const path = require("path");

module.exports = {
  root: true,
  env: {
    browser: true,
    es6: true,
  },
  ignorePatterns: [
    ".eslintrc.js",
    "babel.config.js",
    "postcss.config.js",
    "dist",
    "demo/webpack.config.js",
  ],
  extends: [
    "eslint:recommended",
    "plugin:react/recommended",
    "plugin:@typescript-eslint/recommended",
  ],
  parser: "@typescript-eslint/parser",
  parserOptions: {
    ecmaFeatures: {
      jsx: true,
    },
    ecmaVersion: 12,
    sourceType: "module",
  },
  plugins: ["react", "@typescript-eslint"],
  rules: {},
};
