import { defineConfig } from 'dumi';

// const PREFIX_CLS = 'udesk-gm-ui';

export default defineConfig({
  title: 'GaussMind UI',
  favicon: 'https://avatars.githubusercontent.com/u/12377911?v=4',
  // logo: '/images/gaussMindLogo.png',
  logo: 'https://avatars.githubusercontent.com/u/12377911?v=4',
  outputPath: 'docs-dist',
  // more config: https://d.umijs.org/config
  theme: {
    '@root-entry-name': 'default',
    // '@ant-prefix': PREFIX_CLS,
    // '@primary-color': '#2C7CF6', // 设置主题色
    // '@primary-color': '#2C7CF6', //设置主题色
    '@component-background': '#fff',
  },
  mfsu: {},
  // antd: {
  //   dark: false,
  //   compact: false,
  //   // https://ant.design/components/config-provider-cn/#API
  //   // ConfigProviderProps
  //   config: {
  //     prefixCls: PREFIX_CLS,
  //     direction: 'ltr',
  //   },
  // },
  extraBabelPlugins: [
    'jsx-control-statements',
    [
      'babel-plugin-import',
      {
        libraryName: 'udesk-ui',
        libraryDirectory: 'es',
        style: true,
      },
    ],
  ],
  chainWebpack(memo, { env, webpack, createCSSRule }) {
    if (env === 'production') {

      memo.externals.set('react', 'react');
      memo.externals.set('react-dom', 'react-dom');
      memo.externals.set('udesk-ui', 'udesk-ui');
      // memo.externals.set('udesk-react', 'udesk-react');
    }
    //   memo.plugin('NormalModuleReplacementPlugin').use(webpack.NormalModuleReplacementPlugin, [
    //     /\/style(\/index(\.less)?)?$/,
    //     (opt) => {
    //       if (
    //         opt.context.match(/antd\/(es|lib)\/[\w|-]+?\/style$/) &&
    //         opt.request === '../../style/index.less'
    //       ) {
    //         // 把引用 antd/es/styles/index.less 替换为 udesk-ui 的定制版，去掉了 global.less
    //         opt.request = require.resolve('udesk-ui/es/style/index.less');
    //       }
    //     },
    //   ]);
  },
});
