<!-- @format -->

# umi-fabric

一个包含 prettier，eslint，stylelint 的配置文件合集

A collection of configuration files containing prettier, eslint, stylelint

# Use

in `.eslintrc.js`

```js
module.exports = {
  extends: [require.resolve('@umijs/fabric/dist/eslint')],

  // in antd-design-pro
  globals: {
    ANT_DESIGN_PRO_ONLY_DO_NOT_USE_IN_YOUR_PRODUCTION: true,
    page: true,
  },

  rules: {
    // your rules
  },
};
```

in `.stylelintrc.js`

```js
module.exports = {
  extends: [require.resolve('@umijs/fabric/dist/stylelint')],
  rules: {
    // your rules
  },
};
```

in `.prettierrc.js`

```js
const fabric = require('@umijs/fabric');

module.exports = {
  ...fabric.prettier,
};
```

# Udesk 定制

## 12.5.7 (2021/3/4)

把下列包转移到 `devDependencies` 下，这些包的版本是由 `umi` 内置的 `@umijs/babel-preset-umi` 来管理的，不是在这个包里管理的。这个包应该只控制`eslint`、`prettier`等的版本

1.  `@babel/core`
1.  `@babel/eslint-parser`
1.  `@babel/plugin-proposal-class-properties`
1.  `@babel/plugin-proposal-decorators`
1.  `@babel/preset-env`
1.  `@babel/preset-react`
1.  `@babel/preset-typescript`
