# Udesk公共组件库（Uniapp版）

## 安装

```bash
yarn install
```

## 开发组件

公共组件必须以 `udesk-` 开头，例如 `udesk-list`。

用 HBuilderX 打开项目，在 `uni_modules` 目录上点击右键，选择 `新建uni_modules插件`，会自动创建组件的目录结构。

这种方式创建的组件是遵循 [easycom组件规范](https://uniapp.dcloud.net.cn/component/README?id=easycom%e7%bb%84%e4%bb%b6%e8%a7%84%e8%8c%83)的，符合规范的组件可以在项目中直接使用，无需注册。

## 测试页面

每个组件都要在 `pages` 下创建一个同名页面，里面渲染一个组件，除了可以自己做功能测试以外，还可以让别人作为demo页面来预览这些注塑件。

## 发布

1. 确保测试页面已经添加
2. 在 `CHANGELOG` 中添加本次发版更新内容，分为 `Features` 和 `Bugfix` 两部分。
3. 修改 `package.json` 中的版本号。如果新增组件，增加一个中版本号，如果修复了bug，增加一个小版本号

再执行下面代码发布到npm服务器

```bash
npm publish
```

## 重新发布

可能在发布后，自己内部测试时发现有bug，可以不用再发布个新版本，否则版本会比较乱，可以先把当前版本移除，再重新更新发布。

注意，只能删除当前的版本，不允许删除其它已经存在的版本。

```bash
npm unpublish udesk-uni-ui@x.x.x # 删除当前版本，注意不要删除其它的正式版本号
npm publish # 重新发布
```

另外，在业务项目中要下载更新版的包，不能使用常规的 `yarn install`，请使用下面两种方式：

_方法一_

```bash
yarn add -E udesk-uni-ui # 强制安装最新版本
```

_方法二_

这种方式会重建package依赖关系树，耗时比较就，推荐第一种

```bash
rm yarn.lock
yarn add udesk-uni-ui@x.x.x # 当前版本号
```