# 电话号码组件

用于显示客户的电话号码，传入客户，客服，权限后，将自动判断是否遮盖中间4位

### 示例

```js
<UdeskPhoneNumber number="13312341234"/>

//将会显示为下面内容
133****1234
```

### 显示为一个链接

传入clickable={true}将会显示为一个链接，点击触发onClick事件

```js
<UdeskPhoneNumber number="13312341234" clickable={true}/>

//将会显示为下面内容
<a href="javascipt:" ><i className="icon icon-phone"/> 133****1234</a>
```

### options

name|type|description
----|----|-------
number|string|电话号码
customer|object|号码所属客户,该组件会用到owner_id和owner_group_id两个属性
onClick|function|点击号码触发
clickable|boolean|为true，将会显示为一个链接
currentUser|object|当前客服，该组件会用到id和user_groups两个属性
role_can|object|当前客服权限，该组件会用到ustomer_show_cellphone_all，ustomer_show_cellphone_group，ustomer_show_cellphone_personal这三个属性 


### 与redux store集成

一般currentUser和roleCan都会保存在store，可以直接将这两个属性映射到组件上面

```js
//MyPhoneNumber.js
import UdeskPhoneNumber from 'udesk-phone-number';
import {connect} from 'react-redux';

export default connect(state=>({
    roleCan:state.role_can,
    currentUser:state.currentUser
}))(UdeskPhoneNumber);

//使用，无需再传roleCan和currentUser属性了
import MyPhoneNumber from './MyPhoneNumber';

<MyPhoneNumber customer={customer}/>
```