## 级联字段下拉选择器

### 用法
##### 引入
```bash
yarn add @udesk-webapp/chained-dropdown
```

##### 例子
```jsx harmony
import ChainedDropdown from '@udesk-webapp/chained-dropdown';

const value = [];
const options = [
    {value:'0',title:'北京市', subs:[
        {value:'0',title:'海淀区'},
        {value:'1',title:'朝阳区'}
    ]},
    {value:'1',title:'上海市',subs:[
        {value:'0',title:'黄浦区'},
        {value:'1',title:'徐汇区'},
        {value:'2',title:'长宁区'}
    ]}
];
<ChainedDropdown value={value}
                 prefix='级联下拉：'
                 controlClassName='control'
                 className='chained-dropdown'
                 placeholder='全部'
                 onChange={(value) => setProps({value})}
                 options={options}
                 t={v => v}/>
```

### options

|名称|类型|描述
----|----|----
value|array|控制那些选项被选中，子元素的id用其所有父元素的id和该子元素id逗号分割表示，例如'0,0'
prefix|string|显示在按钮框里前面的文字
controlClassName|string|触发框的class
className|string|整体的class
placeholder|string|如果没有选中项时，默认显示的内容
onChange|function|当多选框变化时触发
options|array|下拉框内容
t|function|多语音方法
