# 下拉选择框
> 一个携带了筛选功能的下拉框组件

## 安装

yarn:

```sh
yarn add @udesk-webapp/single-select
```

npm:

```sh
npm install @udesk-webapp/single-select --save
```

## 例子

```jsx harmony
import * as React from 'react';
import SingleSelect from "@udesk-webapp/single-select";

export default function SingleSelectDemo(){
    return <SingleSelect options={[{id:1,name:'张三'},{id:2,name:'李四'}]}
        getOptionLabel={option=>option.name}
        getOptionValue={option=>option.id}
        value={this.state.value}
        onChange={value=>this.setState({value})}/>
}
``` 

## 参数

name | type | description 
-----|------|---------
options|array|
isSearchable|boolean|是否显示
search|function|自定义内容筛选方法,必须返回一个数组

## Release History

* 1.0.2
    * 取消Control value属性必须是string的限制
* 1.0.1
    * 解决了选择值以后无法自动关闭下拉框的bug
* 1.0.0
    * 实现最基本功能

