## 表格组件

该组件根据列信息，和数据，组成一个表格，支持以下功能
- 列的显示隐藏
- 表格内容格式化，例如日期格式化
- 表头支持多语言

### options

#### columns
列信息，将根据该值生成表头，和数据生成表格内容

type: array&lt;object&gt;

例子：
```js
const columns = [
{"id":"name", "display":true},
{"id":"date", "display":true, "formatter":(v)=>date.format('YYYY-MM-DD')},
{"id":"TextField_5", "display":true, name:"自定义字段"}
]
```

### data
数据，数据的属性名称应该与columns的id一致

type: array&lt;object&gt;

例子：
```js
//columns
const columns = [{"id":"name"},{"id":"age"}];

//data
const data = [{name:"张三",age:"45"},{name:"李四",age:"20"}];
```

### formatter
数据格式化方法

type:function

```js
const formatter={
    date:(v)=>v.format('YYYY-MM-DD'),
    gender:(v)=>{
        if(v==='female'){
            return '女'
        }else{
            return '男'
        }
    }
}
```

### t
获取表头多语言内容的方法，参数是列的id


