# yFiles for HTML (v2.3.0.3)

> [`yFiles for HTML`](http://fe.flyudesk.com/vendor/yfiles/) 是一款非常强大的图表库，可以绘制流程图、甘特图、桑籍图、UML 图等各种专业图表。由于这是一个商业软件，非开源软件，所以官方没有提供 npm 包。我们把 yFiles 类库制作成了本地 npm 包，并且发布在了`Udesk` npm 服务器上。同时我们扩展了新的方法，对 License 进行加密、解密，保证数据安全。

## 文档

### 本地版 (v2.3.0.3)

本地版文档是在本地部署的`v2.3.0.3`版本的文档，由于与当前类库的版本是一致的，所以建议参考本地版的文档，而且访问速度也更快一些。由于 yFiles 是商业软件，不是开源软件，本地类库可能不能与官方版本实时保持同步。

-   [API 文档](http://fe.flyudesk.com/vendor/yfiles/doc/api/index.html)
-   [Demos](http://fe.flyudesk.com/vendor/yfiles/demos-js/)
-   [开发向导](http://fe.flyudesk.com/vendor/yfiles/doc/api/index.html#/dguide/introduction)

### 官方版 (最新版)

这里是官方版文档的链接，直接访问 yFiles 的官方网站。官方版文档会随着 yFiles 新版本的升级而变化，而新增的特性在当前版本下可能无法使用。如果你想查看 yFiles 的最新特性，而不是使用，则建议查看官方网站的文档。

-   [官方首页](https://www.yworks.com/products/yfiles-for-html)
-   [特性](https://www.yworks.com/products/yfiles/features)
-   [API 文档](https://docs.yworks.com/yfileshtml/#/home)
-   [Demos](https://www.yworks.com/products/yfiles/demos)
-   [更多 Demos](https://live.yworks.com/demos/)

## 安装

```bash
# 由于npm版本规则是3位，所以npm包的版本是23.0.3，与yFiles底层库的版本是呼应的
$ yarn install -E yfiles
```

## 获取 License

当前 package 仅包含`yFiles for HTML`的开发类库，并不包含`License授权`，你需要通过[官方渠道](https://www.yworks.com/products/yfiles-for-html/pricing)购买一个合法的 License。

## 使用

yFiles 有两种引用方式：

### 1. 按需引用

1. 前端调用`wl` (`withLicense`) 方法把实例化 `yFiles`类 的代码包裹起来，`wl`方法会自动设置 License，以及执行完成后自动清除。

    在引用 `yFiles` 功能模块的时候，请根据自己的需要 `按需引用` 相应的模块。`yFiles`按照功能划分了多个子模块，可以在 `yfiles/umd` 目录下引用到。关于模块的更多详情，请参阅 [这里](http://yfiles.fe.flyudesk.com/doc/api/index.html#/dguide/yfiles-modules#umd-modules) 。

    ```js
    import 'yfiles/css'; // 引入css
    import { wl } from 'yfiles/lib/utils'; // 引入wl方法，自动初始化License
    import { GraphComponent } from 'yfiles/umd/view-component'; // 引入yFiles的功能模块，注意按需加载

    // 在 wl 的回调函数里返回 yFiles 的class，yFiles一般在构造函数里进行权限校验，而 wl 会自动处理license问题
    const graphComponent = wl(() => new GraphComponent('#graphComponent'));

    // 后面可以正常调用 graphComponent 的各种API和交互
    ```

1. 除了使用 `wl` 方法，也可以调用`ll` (`loadLicense`) 和 `rl` (`removeLicense`)方法，自己控制何时初始化和清除。但强烈建议，在实例化完成后，`尽可能早`的清除，尽量减少在内存中存在的时间。

    ```js
    import 'yfiles/css'; // 引入css
    import { ll, rl } from 'yfiles/lib/utils'; // 引入 ll, rl 方法
    import { GraphComponent } from 'yfiles/umd/view-component'; // 引入yFiles的功能模块，注意按需加载

    ll(); // 手动初始化license
    // 实例化 yFiles的 class，yFiles一般在构造函数里进行权限校验
    const graphComponent = new GraphComponent('#graphComponent');
    rl(); // 手动清除license

    // 后面可以正常调用 graphComponent 的各种API和交互
    ```

### 2. 整个包引入

也可以一次性把整个包都引入。好处就是`省事`，但缺点也很明显，由于`yFiles for HTML`整个包非常大(_~10M_)，所以会极大增加主应用包的大小。所以选择这种方式时，一定要`非常慎重！`

    ```js
    import { wl, GraphComponent } from 'yfiles';

    const graphComponent = wl(() => new GraphComponent('#graphComponent'));
    ```

### 3. 在 index.html 中引入

为了避免 方案2 中会导致bundle增大的问题，可以实现把 yfiles ui库在 index.html 中直接引入，这样就不会参与打包了。这种只适合于在web应用中使用，不适合封装sdk，因为会引入 yfiles 全局变量。

1. 把 `node_modules/yfiles/umd/yfiles-all.js` 拷贝到本项目的 public 目录下
2. 然后在 `index.html` 中添加脚本引用
```html
<script src="path to yfile-all.js" async></script>
```
3. 然后在代码中引入utils和css
```js
import 'yfiles/css'; // 引入css
import { wl } from 'yfiles/lib/utils'; // 引入 wl 方法
    // 在 wl 的回调函数里返回 yFiles 的class，yFiles一般在构造函数里进行权限校验，而 wl 会自动处理license问题
const graphComponent = wl(() => new window.yfiles.view.GraphComponent('#graphComponent'));

// 后面可以正常调用 graphComponent 的各种API和交互
```

更多详细使用方式，请参考 [yFiles 开发者向导](http://fe.flyudesk.com/vendor/yfiles/demos-js/doc/api/index.html#/dguide/introduction)
