<h1 align="center">Udesk UI</h1>

功能描述

## 环境要求

```
"node": ">=8.16.0" // gatsby目前要求至少在10.0以上
"yarn": ">=1.3.2"
```

## 本地开发说明

```
# clone
git clone ssh://git@git.flyudesk.com:9876/udesk/udesk_ui.git

# 初始化安装
yarn initial

# 启动
yarn start

# 打包组件库站点
yarn build

# 清理
yarn clean

# 发布打包
yarn release

# 发布到npm
yarn publish
```

## capability list

-   [✔️] 组件库 Demo 演示站点
-   [✔️] 支持 Demo 在线编辑
-   [✔️] 全面覆盖 ant-design 组件
-   [✔️] 基于 markdown 的文档生成工具
-   [✔️] 组件库打包 支持 es&lib
-   [✔️] 组件库发布到 NPM
-   [-] 编码规范
-   [✔️] 提交 commit 规范
-   [✔️] release note 规范
-   [✔️] 样式按需加载 & 防止全局污染
-   [✔️] 组件国际化

## 参考文档

-   [ant design](https://ant.design/index-cn)
-   [gatsby](https://www.gatsbyjs.cn/)
-   [react-live](https://github.com/FormidableLabs/react-live)

## 如何添加 antd 的新组件

ant-design 的新版本中可能会添加新组件，我们需要将其暴露出来，另外我们自己也会开发、迁移一些组件到组件库，具体步骤类似

-   在目录`udesk_ui/components`下添加组件目录，参考 antd 目录`udesk_ui/node_modules/antd/lib`下组件目录中的`index.d.ts`文件，将其暴露的内容在我们组件中暴露出来，例如：

    Divider 组件：udesk_ui/node_modules/antd/lib/divider/index.d.ts

    ```typescript
    import * as React from 'react';
    export interface DividerProps {
        prefixCls?: string;
        type?: 'horizontal' | 'vertical';
        orientation?: 'left' | 'right' | 'center';
        className?: string;
        children?: React.ReactNode;
        dashed?: boolean;
        style?: React.CSSProperties;
        plain?: boolean;
    }
    declare const Divider: React.FC<DividerProps>;
    export default Divider;
    ```

    Udesk-UI：udesk_ui/components/divider/index.tsx

    ```typescript
    import { Divider } from 'antd';
    export { DividerProps } from 'antd/lib/divider';
    export default Divider;
    ```

-   添加组件说明文档`index.zh-CN.md` `index.en-US.md `与 demo 文档

-   修改 udesk_ui/components/index.ts 文件，添加

    ```typescript
    ...
    export { default as Divider } from './divider';
    ...
    ```

-   更改发版说明文档 udesk_ui/docs/release-note.zh-CN.md

-   更改 udesk-ui/package.json 中的版本号

-   进行组件库的编译打包与发布

    ```shell
    yarn release
    yarn publish
    ```

-   Udesk-UI 站点发版

    登录到站点服务器 101.200.157.23，执行下面命令

    ```shell
    cd /home/webuser/Documents/udesk_ui
    gco master
    gup
    yarn release
    yarn clean
    yarn build
    ```
