# 列控制组件

分左右两个容器，左边容器放置未加载的列，选择一个或者多个，可以移动到右边容器，同理，右边容器里的也可以移动到左边容器。    
左边容器上面提供标签页以及搜索功能    
右边容器提供了排序功能    

## 用法
#### 引入
```bash
yarn add @udesk-webapp/table-column-control
```
或者
```bash
npm install --save @udesk-webapp/table-column-control
```

#### 使用
```jsx harmony
import ColumnControl from '@udesk-webapp/table-column-control';
<ColumnControl onChange={(value) => this.props.onChange(value)}
               t={this.props.t}
               columns={[
                   {id : 'full_name', category : 'label.person'},
                   {id : 'first_name', category : 'label.person'},
                   {id : 'last_name', category : 'label.person'},
                   {id : 'nick_name', category : 'label.person'},
                   {id : 'age', category : 'label.person'},
                   {id : 'email.name', category : 'label.email'},
                   {id : 'email.content', category : 'label.email'}
               ]}
               value={this.props.columns}
               leftTitle='左侧标题'
               rightTitle='右侧标题'
               onReset={() => component.setProps({value : ['full_name', 'first_name', 'email.name']})}
/>
```
## options

|名称|类型|描述|
----|----|----
onChange|function|点击确定按钮时触发
t|function|提供的多语言方法
columns|Object[]|总共有哪些列
value|String[]|被选中列的id数组
leftTitle|String|左边容器的标题
rightTitle|String|右边容器的标题
onReset|function|如何重置为默认选中列
className|String|类
classNameOfSearchInput|String|查询框的类
onOpen|function|
onClose|function|
searchPlaceholder|String|搜索框placeholder
columnButtonClassName|string|列按钮class
columnButtonStyle|string|列按钮样式
CancelButton|ReactNode|自定义取消按钮组件，组件必须有 onClick 属性
ResetButton|ReactNode|自定义重置按钮组件，组件必须有 onClick 属性
ConfirmButton|ReactNode|自定义确定按钮组件，组件必须有 onClick 属性

## columns数组元素的格式

columns数组的元素需要符合规定的格式，格式如下

|名称|类型|是否必须|描述
----|----|-------|----
id|String|是|列的标识，必须是唯一的
category|String|否|放在那个分类下
name|String|否|显示名称，如果不传，该列的名称会调用t(id)获取，t是多语言方法，id是列的标识

## 多语言key列表

|key名称|中文含义|
------|-------
label.search|搜索
label.confirm|确定
label.cancel|取消
label.restoreDefault|重置
label.column|列

## 更新日志
