# udesk_gm_ui

## Getting Started

### **注意：安装依赖必须需要使用 `v16`以上版本的 `node`**

### **注意：安装依赖必须需要使用 `v16`以上版本的 `node`**

### **注意：安装依赖必须需要使用 `v16`以上版本的 `node`**

> 因为使用了 `peerDependencies`减小包体积及 Udesk-ui、react 版本冲突问题，而 7 以下版本的 npm 无法自动安装 `peerDependencies`中的依赖项，会导致项目起不来。

Install dependencies，**install 必须使用 npm install**

```bash
$ npm install
```

Start the dev server,

```bash
$ yarn start
```

Build library via `father-build`,

```bash
$ yarn build
```

## 开发规范

1. 所有组件，包括布局、样式，**必须**使用 styled-component 编写，以防样式污染，并适当向外部暴露 className 以支持外部进行修改。
2. 组件 className**必须**为动态类名拼接，使用统一的 hook `usePrefixCls`获取。
3. 理论上单个 ts、tsx 文件不应超过 150 行（包含复杂样式的 styled-component 除外），单个函数、方法不得超过 50 行。
4. 组件暴露名称与文件夹名称一致(驼峰)
5. style 文件夹下必须要加一个 index.ts 文件

## 代码组织结构

- src
  - xxx-component (组件名称)
    - components (存放 styled-component 以及各种子组件)
    - context (存放 React.createContext)
    - style (统一引入使用到的 udesk-ui 中 原子组件的样式)
    - types (存放组件的各种 interface)
    - index.tsx (组件入口)
    - index.md (demo 入口)
  - utils (公共工具方法存放目录)
    - hooks (公共自定义 hook 存放目录)
    - index.ts (公共工具方法统一导出文件)
  - index.ts (组件库中所有组件的统一导出文件)

## DEMO 编写原则

1. 一个 demo 仅演示一个复杂功能或者不超过 3 个简单功能。
2. 同一 demo 中演示的功能间不可存在优先级关系，必须相互独立、互不影响。
