# @umijs/plugin-antd

> umi 的扩展插件，安装后会自动引入`udesk-ui`库.

## Install

```bash
$ yarn add -D -E umi-plugin-udesk-ui
```

## 升级

```bash
$ npx umi upgrade-preset
# 或者
$ npx umi up
```

## package.json

下面这些 package.json 中的内容是系统保留的，会被系统覆盖，避免手动修改

```json
{
    "scripts": {
        "build": "umi build",
        "clean": "shx rm -f src/**/*.scss.d.ts",
        "postinstall": "umi generate tmp",
        "prettier": "prettier --write '**/*.{js,jsx,tsx,ts,less,md,json}'",
        "serve": "serve ./dist",
        "start": "yarn clean & tcm src -p '**/*.less' -w -s & umi dev",
        "startw": "umi dev & yarn clean & tcm src -p '**/*.less' -w -s",
        "test": "umi-test",
        "test:coverage": "umi-test --coverage"
    },
    "lint-staged": {
        "*.ts?(x)": ["prettier --parser=typescript --write"],
        "*.{js,jsx,less,md,json}": ["prettier --write"]
    },
    "gitHooks": {
        "pre-commit": "lint-staged"
    },
    "prettier": "@udesk/prettier-config"
}
```
