# umi-plugin-upgrade

> 自动升级 umi 插件集，并自动升级项目代码

## Install

```bash
$ yarn add -D -E umi-plugin-upgrade
```

## 升级

```bash
$ npx umi upgrade
# 或者
$ npx umi up
```

## package.json

下面这些 package.json 中的内容是系统保留的，会被系统覆盖，避免手动修改

```json
{
    "resolutions": {
        "@umijs/babel-preset-umi": "13.3.9",
        "@umijs/fabric": "12.5.7",
        "@umijs/plugin-access": "12.3.3",
        "@umijs/plugin-antd": "10.9.1",
        "@umijs/plugin-layout": "10.13.6",
        "@umijs/plugin-request": "12.5.3",
        "@umijs/preset-built-in": "13.3.10",
        "umi": "13.3.10"
    },
    "scripts": {
        "build": "umi build",
        "clean": "shx rm -f src/**/*.scss.d.ts",
        "postinstall": "umi generate tmp",
        "prettier": "prettier --write '**/*.{js,jsx,tsx,ts,less,md,json}'",
        "serve": "serve ./dist",
        "start": "yarn clean & tcm src -p '**/*.less' -w -s & umi dev",
        "startw": "umi dev & yarn clean & tcm src -p '**/*.less' -w -s",
        "test": "umi-test",
        "test:coverage": "umi-test --coverage"
    },
    "lint-staged": {
        "*.ts?(x)": ["prettier --parser=typescript --write"],
        "*.{js,jsx,less,md,json}": ["prettier --write"]
    },
    "gitHooks": {
        "pre-commit": "lint-staged"
    },
    "prettier": "@udesk/prettier-config"
}
```
