import React                     from 'react';
import { configure, mount }      from 'enzyme';
import UdeskColumnControlPopover from '../src';
import Adapter                   from 'enzyme-adapter-react-16';

configure({adapter : new Adapter()});

test('UdeskColumnControlPopover test', () => {
    let wrapper = mount(
        <UdeskColumnControlPopover className="test"
                                   columns={[
                                       {id : 'name', display : true},
                                       {id : 'age', display : true}
                                   ]}
                                   t={(v) => v}
        />
    );

    //expect(wrapper.html()).toBe('');
    expect(wrapper.find('div').text()).toBe('label.column ');

    wrapper.find('button').simulate('click');

    expect(wrapper.find('.open')).toHaveLength(1);

    wrapper.find('button').simulate('click');
    expect(wrapper.find('.open')).toHaveLength(0);
});
