import React                from 'react';
import { configure, mount } from 'enzyme';
import SingleSelect         from '../src';
import Adapter              from 'enzyme-adapter-react-16';

configure({adapter : new Adapter()});

test('Popover test', () => {
    let wrapper = mount(
        <SingleSelect controlClassName='control'
                      controlStyle={{color : '#fff'}}
                      prefix='前缀:'
                      options={['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N']}
                      getOptionLabel={v => v.toLowerCase()}
                      getOptionValue={v => v}
                      onChange={(value) => wrapper.setProps({value})}
                      value={null}
                      placeholder='All'
                      className='custom-style'
                      t={v => v}
        />
    );

    expect(wrapper.find('.select-with-search').prop('className')).toBe('select-with-search custom-style');
    expect(wrapper.find('.control').text()).toBe('前缀: All');
    //expect(wrapper.find('.control').hasClass('control')).toBe(true);
    expect(wrapper.find('.control').prop('style')).toEqual({color : '#fff'});

    wrapper.find('.control').simulate('click');

    expect(wrapper.find('.select-with-search').children().length).toBe(2);

    expect(wrapper.find('.dropdown-menu-left').text()).toBe('abcdefghijklmn');
    expect(wrapper.find('.dropdown-menu-ul').find('li').length).toBe(14);

    expect(wrapper.find('.dropdown-menu-left').find('.dropdown-menu-search').length).toBe(1);
    wrapper.find('.dropdown-menu-left').find('.dropdown-menu-search').find('input')
           .simulate('change', {target : {value : 'c'}});
    expect(wrapper.find('.dropdown-menu-ul').find('li').length).toBe(1);
    wrapper.find('.dropdown-menu-left').find('.dropdown-menu-search').find('input')
           .simulate('change', {target : {value : ''}});

    wrapper.find('.dropdown-menu-ul').find('li').at(1).simulate('click');
    expect(wrapper.prop('value')).toEqual('B');
    expect(wrapper.find('.dropdown-menu-left').length).toBe(0);

    wrapper.find('.control').simulate('click');
    expect(wrapper.find('.dropdown-menu-left').length).toBe(1);
    wrapper.find('.control').simulate('click');
    expect(wrapper.find('.dropdown-menu-left').length).toBe(0);
});


