const { usage } = require('yargs');

const presets = [
    [
        '@babel/preset-env',
        {
            modules: false,
            loose: true,
            useBuiltIns: 'usage',
            corejs: '3',
        },
    ],
    ['@babel/preset-react'],
    [
        '@babel/preset-typescript',
        {
            isTSX: true,
            allExtensions: true,
        },
    ],
];
const plugins = [
    'minify-dead-code-elimination',
    'transform-node-env-inline',
    '@babel/plugin-proposal-class-properties',
    [
        'import',
        {
            libraryName: 'udesk-ui',
            libraryDirectory: 'es',
            style: true, //注意：从v4.15.0开始，值为true，再之前的版本设置为false
        },
    ],
    // babel 编译 scss，目前还不知道怎么搞。可能需要自己开发 plugin
    // [
    //     "css-modules-transform", {
    //     "camelCase": false,
    //     "devMode": false,
    //     "extensions": [".css", ".scss", ".less"], // list extensions to process; defaults to .css
    //     "generateScopedName": "[name]__[local]___[hash:base64:5]", // in case you don't want to use a function
    //     "hashPrefix": "string",
    //     "extractCss": "./dist/stylesheets/combined.css",
    //     "keepImport": true
    // }
    // ]
];

module.exports = {
    presets,
    plugins,
};
