const gitDiffMain = require('../../src/main/git-diff-main');
const { updateOption } = require('../../src/require-options');
const { getPrettierrc } = require('../../src/utils/utils');

function createBuilder(args) {
    const opts = {
        'commit-hash': {
            describe: '提交commit id',
            alias: 'ch',
            type: 'string',
        },
        'no-emit': {
            describe: '仅检测是否存在中文',
            alias: 'ne',
            type: 'boolean',
        },
        log: {
            describe: '是否打印log',
            alias: 'l',
            type: 'boolean',
        },
    };
    args.options(opts);
}

function createHandler(args) {
    updateOption({
        showLog: args.l,
    });
    getPrettierrc();
    gitDiffMain(args.ch, args.ne, args.l);
}

const option = {
    cmd: 'gd',
    desc: '根据git commit tag 生成多语言',
    builder: createBuilder,
    handler: createHandler,
};
module.exports = option;
