const fs = require("fs");
const log = require("npmlog");
const {
    ICON_FILE_PATH,
    getConfigFile,
    reg ,
    pathReg,
    dReg,
    constReg,
} = require("../../utils/icon/index");
/**
 * 为废弃的icon添加对应的替代icon名
 *
 */
const obsoleteReg = /[^ ]+[, ]?\/\/ 废弃，请用新增iconfnt组件代替/g;
const nameReg = /^[a-zA-Z]+/g;
function replaceObsoleteIcon() {
    let config = getConfigFile();

    const iconFilePath = config[ICON_FILE_PATH];
    if (!iconFilePath) {
        log.error(`icon 命令错误：获取${ICON_FILE_PATH}配置失败，请检查！`);
        process.exit(1);
    }
    let iconfontFileData = fs.readFileSync(iconFilePath, "utf-8");
    const matchObsoletes = iconfontFileData.match(obsoleteReg);
    // console.log("matchObsoletes", matchObsoletes);
    if (matchObsoletes && matchObsoletes.length) {
        let svgs = iconfontFileData.match(reg);
        if (!svgs) {
            console.log("svgs", svgs);
            process.exit();
        }
        matchObsoletes.forEach((matchString) => {
            let match = matchString.match(nameReg);
            if (match && match.length) {
                let name = match[0];
                let reg = new RegExp(`const ${name}:[\\w\\W\\n]+?component={([a-zA-Z]+)}`);
                const matchSvg = iconfontFileData.match(reg);
            // console.log(matchSvg)
            if (matchSvg && matchSvg.length) {
                    let svgName = matchSvg[1];
                    // console.log('svgName',svgName)
                    if (svgName) {
                        // 查找指定名字的svg定义代码
                        let svgReg = new RegExp(`const ${svgName}[\w\W]+?<\/svg>`);
                        let svgStr = iconfontFileData.match(svgReg);
                        console.log("svgStr",svgStr)
                        if (svgStr && svgStr.length) {
                            svgStr = svgStr[0];
                            svgs.forEach((svg) => {
                                if (sameSVG(svg, svgStr)) {
                                    let constName = svg.match(/const ([a-zA-Z]+)/);
                                    if (constName && constName.length) {
                                        console.log("constName", constName);
                                        constName = constName[0];
                                        let constIonName = iconfontFileData.match(
                                            new RegExp(
                                                `const ([a-zA-Z]+):.+?component={${constName}}>`,
                                                "gs"
                                            )
                                        );
                                        if (constIonName && constIonName) {
                                            // 查找icon name
                                            constIonName = constIonName[1];
                                            console.log("constIonName", constIonName);
                                            // 替换注释信息
                                            iconfontFileData.replace(
                                                matchString,
                                                matchString.replace("iconfnt", constIonName)
                                            );
                                        }
                                    }
                                }
                            });
                        }
                    } else {
                        log.error("name获取svg name失败");
                    }
                }
            }
        });
        console.log(iconfontFileData);
    }
}

replaceObsoleteIcon();

function sameSVG(svg1, svg2) {
    if (!svg1 || !svg2) {
        return false;
    }
    let svg1Match = svg1.match(pathReg);
    let svg2Match = svg2.match(pathReg);

    if (!svg1Match || !svg2Match) {
        console.error(`SVG path标签没有找到！`, svg1, svg2);
        return;
    }
    if (svg1Match.length != svg2Match.length) {
        return false;
    }
    const svg2MatchDAttrs = svg2Match.map((item) => getDAttr(item));
    return svg1Match.every((svg1Item) => {
        const svg1DAttr = getDAttr(svg1Item);
        return svg2MatchDAttrs.includes(svg1DAttr);
    });
    // let svg1DMatch =
}
