const log = require('npmlog');
const localeFileTran = require('../../src/main/locales-file-tran-main');
const { getPrettierrc } = require('../../src/utils/utils');

function createBuilder(args) {
    const opts = {
        'chinese-path': {
            describe: '中文资源文件路径',
            alias: 'cp',
            type: 'string',
        },
        'output-lang-path': {
            describe: '新语言资源文件路径',
            alias: 'olp',
            type: 'string',
        },
        'target-lang': {
            describe: '目标语言',
            alias: 'tl',
            type: 'string',
        },
        'translate-variable-template': {
            describe: '是否翻译变量模板',
            alias: 'tvt',
            type: 'boolean',
        },
    };
    args.options(opts);
}

function createHandler(args) {
    // console.log('args', args);
    if (!args.cp) {
        log.error('请输入中文资源文件路径！');
        return;
    }
    if (!args.olp) {
        log.error('请输入新语言资源文件路径！');
        return;
    }
    if (!args.tl) {
        log.error('请输入目标语言！');
        return;
    }
    getPrettierrc();
    localeFileTran(args.cp, args.olp, args.tl, args.tvt);
}

const option = {
    cmd: 'lft',
    desc: '以当前中文资源文件为模板生成新的多语言资源',
    builder: createBuilder,
    handler: createHandler,
};
module.exports = option;

// [中文资源文件路径] [新语言资源文件路径] [目标语言]
