const log = require('npmlog');
const localeTran = require('../../src/main/index-main');
const { getPrettierrc } = require('../../src/utils/utils');

function createBuilder(args) {
    const opts = {
        'file-path': {
            describe: '代码文件路径',
            alias: 'fp',
            type: 'string',
        },
    };
    args.options(opts);
}

function createHandler(args) {
    // console.log('args', args);
    if (!args.fp) {
        log.error('请输入代码文件路径！');
        return;
    }
    getPrettierrc();
    localeTran(args.fp);
}

const option = {
    cmd: 'lt',
    desc: '根据配置文件（locales-tran.config.js）提取业务项目多语言',
    builder: createBuilder,
    handler: createHandler,
};
module.exports = option;
