const fs = require("fs");
const path = require("path");
const reg = /const[\w\W]+?<\/svg>/g;
const pathReg = /<path[\w\W]+?(\/>|<\/path>)/g;
const dReg = /(?<=d=")[^"]+/g;
const constReg = /(?<=const )[^ =]+/;
const log = require("npmlog");

module.exports = {
    ICON_FILE_PATH: "icon-file-path",
    USER_COOKIE: "user-cookie",
    getConfigFile,
    reg,
    pathReg,
    dReg,
    constReg,
};

function getConfigFile() {
    const configFilePath = path.resolve(__dirname, "../../config/.icon.config.json");
    const existConfigFile = fs.existsSync(configFilePath);
    if (!existConfigFile) {
        log.error("icon 命令错误：配置文件不存在，请先进行配置或者传入icon-file-path参数！");
        process.exit(1);
    }
    let config;
    const ConfigText = fs.readFileSync(configFilePath, "utf-8");
    try {
        config = JSON.parse(ConfigText) || {};
    } catch (e) {
        log.error("icon 命令错误：配置文件解析失败，请检查！");
        process.exit(1);
    }
    return config;
}
