ace.define("ace/mode/custom_highlight_rules", function(require, exports, module) {
    "use strict";
    var oop = require("../lib/oop");
    var TextHighlightRules = require("./text_highlight_rules").TextHighlightRules;
    var DroolsHighlightRules = function() {
        var keywordMapper = this.createKeywordMapper({
            "keyword": "DATEDIFF|CASCADEPRO|DATESELECT|datediff|cascadepro|dateselect",
            // "string": "[.]"
        }, "identifier");
        this.$rules = {
            "start": [{
                token: keywordMapper,
                regex: "[a-zA-Z_$][a-zA-Z_$]*\\b",
            }, {
                token: "string",
                regex: "\\[([\\s\\S]*?)\\]",
                // regex: "\\[\\s*(.+?)\\s*\\])"
            }],
        };
    };

    oop.inherits(DroolsHighlightRules, TextHighlightRules);
    exports.DroolsHighlightRules = DroolsHighlightRules;
});

ace.define("ace/mode/custom", function(require, exports, module) {
    "use strict";
    var oop = require("../lib/oop");
    var TextMode = require("./text").Mode;
    var DroolsHighlightRules = require("./custom_highlight_rules").DroolsHighlightRules;
    var DroolsMode = function() {
        this.HighlightRules = DroolsHighlightRules;
    };
    oop.inherits(DroolsMode, TextMode);
    (function() {
        this.$id = "ace/mode/custom"
    }).call(DroolsMode.prototype),
        exports.Mode = DroolsMode;
});
