import React, { Component } from 'react';
import ReactDom from 'react-dom';
import ColumnControl from '../src';

let elementRoot = document.createElement('div');
document.body.appendChild(elementRoot);

class Demo extends Component {
    constructor(props) {
        super(props);
        let columns = [
            { id: 'name', name: '名称', category: '基本信息' },
            { id: 'phone', name: '电话', category: '联系方式' },
            { id: 'work_phone', name: '办公室电话', category: '联系方式' },
            { id: 'home_phone', name: '家中电话', category: '联系方式' },
            { id: 'email', name: '邮箱', category: '联系方式' },
            { id: 'address', name: '住址', category: '联系方式' },
            { id: 'qq', name: 'QQ号', category: '联系方式' },
            { id: 'wechat', name: '微信号', category: '联系方式' },
            { id: 'alipay', name: '支付宝号', category: '联系方式' },
            { id: 'weibo', name: '微博号', category: '联系方式' },
            { id: 'facebook', name: 'facebook', category: '联系方式' },
            { id: 'twitter', name: 'twitter', category: '联系方式' },
            { id: 'birthday', name: '生日', category: '基本信息' },
            { id: 'age', name: '年龄', category: '基本信息' },
            { id: 'gender', name: '性别', category: '基本信息' },
            { id: 'signs', name: '星座', category: '基本信息' },
            { id: 'height', name: '身高', category: '基本信息' },
            { id: 'weight', name: '体重', category: '基本信息' },
            { id: 'waist', name: '腰围', category: '基本信息' },
            { id: 'bust', name: '胸围', category: '基本信息' },
            { id: 'feet_size', name: '脚长', category: '基本信息' },
            { id: 'leg_length', name: '腿长', category: '基本信息' },
            { id: 'father', name: '父亲', category: '社会关系' },
            { id: 'mother', name: '母亲', category: '社会关系' },
            { id: 'sister', name: '姐妹', category: '社会关系' },
            { id: 'brother', name: '兄弟', category: '社会关系' },
            { id: 'children', name: '孩子', category: '社会关系' },
            { id: 'leader', name: '上司', category: '社会关系' },
            { id: 'company', name: '公司', category: '社会关系' },
            { id: 'friend', name: '朋友', category: '社会关系' },
        ];
        let defaultValue = [
            'name', 'phone', 'email', 'address',
            'qq',
            'wechat',
            'birthday',
            'age',
            'gender',
            'signs',
            'height',
            'weight',
            'waist',
            'bust',
            'feet_size',
            'leg_length',
            'work_phone',
            'home_phone',
            'father',
            'mother',
            'sister',
            'brother',
            'children',
            'leader',
            'company',
            'friend',
        ];

        this.state = {
            columns,
            defaultValue: defaultValue,
            value: defaultValue
        };
    }

    render() {
        let {
            columns,
            value
        } = this.state;
        return <ColumnControl value={value}
                              leftTitle='可用字段'
                              rightTitle='显示字段'
                              columns={columns}
                              className='demo'
                              t={v => v}
                              onChange={this._onChange}
                              onReset={this._onReset}/>;
    }

    _onChange = (selectedColumnIds) => {
        this.setState({
            value: selectedColumnIds
        });
        console.log('选中了' + selectedColumnIds);
    };

    _onReset = () => {
        let { defaultValue } = this.state;
        this.setState({
            value: [...defaultValue]
        });
    };
}

ReactDom.render(<Demo/>, elementRoot);
