import ReactDom from 'react-dom';
import React, { useRef, useCallback, ElementRef, useState } from 'react';
import Textarea from '../src';
import useLocalStorage from 'react-use/esm/useLocalStorage';
import { props } from './ttt';

function App() {
    const [Props, setprops] = useState(props);
    const ref = useRef<ElementRef<typeof Textarea>>(null);
    const [rightWidth = 400, setRightWidth] = useLocalStorage('stretchable-box-right-panel-width', 400, {
        raw: false,
        serializer: (value) => value + '',
        deserializer: (value: string) => parseInt(value) || 370,
    });
    let zIndex = 4;
    const showTicket = useCallback(() => {
        if (typeof ref?.current?.showTicket === 'function') {
            ref.current.showTicket({
                show: true,
                zIndex: ++zIndex,
            });
        }
    }, []);

    const showVisit = useCallback(() => {
        // if (typeof ref?.current?.showVisit === 'function') {
        //     ref.current.showVisit({
        //         show: true,
        //         zIndex: ++zIndex,
        //     });
        // }
        setprops({
            ...Props,
            chat: {
                ...Props.chat,
                customer: {
                    ...Props.chat.customer,
                    nick_name: '32',
                },
            },
            pluginFilter: [-1, -2],
        });
    }, []);

    const showRecord = useCallback(() => {
        if (typeof ref?.current?.showRecord === 'function') {
            ref?.current?.showRecord({
                show: true,
                zIndex: ++zIndex,
            });
        }
    }, []);
    const onWidthChange = useCallback((aa: number) => {
        setRightWidth(aa);
    }, []);
    const [chat, setChat] = useState({
        ...Props.chat,
        imSubSessionId: Props.chat.id,
        nick_name: Props.chat?.customer?.nick_name,
        title: Props.chat?.customer?.nick_name,
        level: Props.chat?.customer?.level,
        email: Props.chat?.customer?.email,
        lang: Props.chat?.customer?.lang,
        im_sub_session_id: Props.chat.id,
        customer: Props.chat?.customer,
        customer_id: Props.chat?.customer?.id,
        accessInfo: {
            sdkName: Props.chat.sdkName,
        },
    });
    const updateChat = useCallback((item: any) => {
        console.log(item);
        if (item.updateProps) {
            setChat({
                ...chat,
                ...item.updateProps,
            });
        }
    }, []);
    return (
        <div>
            <Textarea
                {...(Props as any)}
                ref={ref}
                chat={chat}
                event={{
                    ...Props.event,
                    onWidthChange,
                    updateChat,
                }}
            />
            <div
                style={{
                    position: 'absolute',
                    left: 0,
                    right: rightWidth + 'px',
                    height: '100%',
                    background: '#fff',
                    display: 'flex',
                    flexDirection: 'column',
                    borderRight: '1px solid #e6e7eb',
                    minWidth: ' 595px',
                }}
            >
                <button onClick={showTicket}>showTicket</button>
                <button onClick={showVisit}>showVisit</button>
                <button onClick={showRecord}>showRecord</button>
            </div>
        </div>
    );
}
ReactDom.render(<App></App>, document.getElementById('root'));
