import { Button, Form, Input, InputNumber, Space, Switch } from 'antd';
import React, { useRef } from 'react';
import { Toast } from "../../../Toast";
import Locales from "../../../locales";
var VariableItem = function VariableItem(_ref) {
  var prefixName = _ref.prefixName,
    deleteBtn = _ref.deleteBtn;
  var inputRef = useRef(null);
  var copyVariable = function copyVariable() {
    navigator.clipboard.writeText("{{".concat(inputRef.current.input.value, "}}")).then(function () {
      Toast({
        message: /* 复制成功 */Locales['current'].appConfig.components.variableItem.index.successfullyCopied,
        type: 'success'
      });
    }).catch(function (error) {
      console.log( /* 复制失败 */Locales['current'].appConfig.components.variableItem.index.copyFailed, error);
    });
  };
  return /*#__PURE__*/React.createElement("div", {
    className: "relative bg-[#EDECF1] p-4 rounded-xl"
  }, /*#__PURE__*/React.createElement(Form.Item, {
    label: /* 标题 */Locales['current'].appConfig.components.variableItem.index.title,
    name: [prefixName, 'name'],
    className: "flex-1",
    rules: [{
      required: true,
      message: /* 请输入标题 */Locales['current'].appConfig.components.variableItem.index.pleaseEnterATitle
    }]
  }, /*#__PURE__*/React.createElement(Input, {
    ref: inputRef,
    addonAfter: /*#__PURE__*/React.createElement(Button, {
      type: "link",
      size: "small",
      onClick: copyVariable
    }, Locales['current'].appConfig.components.variableItem.index.copyVariableName)
  })), /*#__PURE__*/React.createElement(Space, null, /*#__PURE__*/React.createElement(Form.Item, {
    label: /* 必填 */Locales['current'].appConfig.components.variableItem.index.required,
    name: [prefixName, 'required'],
    valuePropName: "checked"
  }, /*#__PURE__*/React.createElement(Switch, null)), /*#__PURE__*/React.createElement(Form.Item, {
    label: /* 字数限制 */Locales['current'].appConfig.components.variableItem.index.wordLimit,
    name: [prefixName, 'wordLimit']
  }, /*#__PURE__*/React.createElement(InputNumber, null))), /*#__PURE__*/React.createElement(Form.Item, {
    label: /* 提示语 */Locales['current'].appConfig.components.variableItem.index.hintLanguage,
    name: [prefixName, 'hint']
  }, /*#__PURE__*/React.createElement(Input.TextArea, {
    autoSize: true
  })), /*#__PURE__*/React.createElement("div", {
    className: "absolute right-4 bottom-4"
  }, deleteBtn));
};
export { VariableItem };