function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import { Spin, PageHeader } from 'antd';
import React from 'react';
import styled from 'styled-components';
import { useRouteContext } from "../LLM/context/route";
import { AppConfigRouteName } from "../LLM/routes/routeMap";
import { request, useGet } from "../utils/fetch";
import { AppGrid } from "../components/AppGrid";
import { AppItem } from "../components/AppItem";
import { getAntClass } from "../utils/core";
import { useSdkOptionsContext } from "../utils/fetch/context";
import Locales from "../locales";
var Div = styled.div.withConfig({
  displayName: "Div",
  componentId: "udesk-llm-fe__sc-xcxlha-0"
})(["", "{width:100%;}"], getAntClass('spin-nested-loading'));
var AppManagement = function AppManagement() {
  var _useRouteContext = useRouteContext(),
    push = _useRouteContext.push,
    pop = _useRouteContext.pop;
  var _useSdkOptionsContext = useSdkOptionsContext(),
    antPrefixCls = _useSdkOptionsContext.antPrefixCls;
  var _useGet = useGet('/applicationManagers'),
    data = _useGet.data,
    mutate = _useGet.mutate,
    isLoading = _useGet.isLoading;
  var goToEditor = function goToEditor(id) {
    push(AppConfigRouteName, {
      id: id
    });
  };
  return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(PageHeader, {
    className: "site-page-header-responsive pt-3 pb-3 hidden md:block bg-white shadow-sm",
    ghost: false,
    onBack: function onBack() {
      return pop();
    },
    title: /* AI 智能助手 */Locales['current'].appManagement.index.aIIntelligentAssistant
  }), /*#__PURE__*/React.createElement(Div, {
    antPrefixCls: antPrefixCls,
    className: "mr-auto ml-auto w-[min(48rem,100%)] md:w-[min(47rem,100%)] lg:w-[min(64rem,100%)] p-7 md:p-0"
  }, /*#__PURE__*/React.createElement("div", {
    className: "flex flex-col items-center"
  }, /*#__PURE__*/React.createElement(Spin, {
    spinning: isLoading
  }, /*#__PURE__*/React.createElement(AppGrid, {
    title: /*#__PURE__*/React.createElement("div", {
      className: "flex justify-between mt-[32px] mb-[14px] w-full"
    }, /*#__PURE__*/React.createElement("div", {
      className: " font-bold flex items-center text-[18px]"
    }, Locales['current'].appManagement.index.application)),
    items: (data === null || data === void 0 ? void 0 : data.data) || [],
    showEmpty: true,
    itemRender: function itemRender(item) {
      return /*#__PURE__*/React.createElement(AppItem, _extends({}, item, {
        key: item.id,
        mode: "edit",
        items: [{
          key: 'editor',
          label: /* 编辑 */Locales['current'].appManagement.index.edit,
          onClick: function onClick(item) {
            goToEditor(item.id);
          }
        }, {
          key: 'delete',
          danger: true,
          label: /* 删除 */Locales['current'].appManagement.index.delete,
          onClick: function onClick(_ref) {
            var id = _ref.id;
            request("/applicationManagers/".concat(id), {
              method: 'delete'
            }).then(function () {
              mutate();
            });
            //
          }
        }]
      }));
    }
  })))));
};

export default AppManagement;