"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _Options = _interopRequireDefault(require("./Options"));

var _isNil = _interopRequireDefault(require("lodash-es/isNil"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = require("@emotion/react");

var CommonDropdown = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(CommonDropdown, _Component);

  function CommonDropdown(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "dropdownMenuRef", /*#__PURE__*/(0, _react.createRef)());
    _this.state = {
      keyword: ''
    };
    return _this;
  }

  var _proto = CommonDropdown.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        getOptionLabel = _this$props.getOptionLabel,
        getOptionValue = _this$props.getOptionValue,
        onChange = _this$props.onChange,
        options = _this$props.options,
        value = _this$props.value,
        _this$props$t = _this$props.t,
        t = _this$props$t === void 0 ? function (v) {
      return v;
    } : _this$props$t,
        isSearchable = _this$props.isSearchable,
        search = _this$props.search;
    var keyword = this.state.keyword;

    if ((0, _isNil["default"])(isSearchable)) {
      isSearchable = options.length > 10;
    }

    if (keyword && typeof search === 'function') {
      options = search(keyword, {
        options: options,
        getOptionLabel: getOptionLabel
      }) || options;
    }

    return (0, _react2.jsx)("div", {
      className: "dropdown-menu-left"
    }, isSearchable && (0, _react2.jsx)(_react.Fragment, null, (0, _react2.jsx)("i", {
      className: "icon icon-search"
    }), (0, _react2.jsx)("div", {
      className: "dropdown-menu-search"
    }, (0, _react2.jsx)("input", {
      placeholder: t('label.search'),
      onChange: function onChange(e) {
        return _this2.setState({
          keyword: e.target.value
        });
      }
    }))), (0, _react2.jsx)("ul", {
      className: "dropdown-menu-ul scrollbar",
      ref: this.dropdownMenuRef
    }, (0, _react2.jsx)(_Options["default"], {
      getOptionLabel: getOptionLabel,
      getOptionValue: getOptionValue,
      options: options,
      value: value,
      onChange: onChange
    })));
  };

  return CommonDropdown;
}(_react.Component);

(0, _defineProperty2["default"])(CommonDropdown, "defaultProps", {
  search: function search(keyword, _ref) {
    var options = _ref.options,
        getOptionLabel = _ref.getOptionLabel;
    return options.filter(function (option) {
      var label = getOptionLabel(option);

      if (typeof label === 'string') {
        return label.toLowerCase().indexOf(keyword.toLowerCase()) > -1;
      }

      return true;
    });
  }
});
CommonDropdown.propTypes = {
  getOptionLabel: _propTypes["default"].func,
  getOptionValue: _propTypes["default"].func,
  value: _propTypes["default"].any,
  onChange: _propTypes["default"].func,
  options: _propTypes["default"].arrayOf(_propTypes["default"].any),
  isSearchable: _propTypes["default"].bool,
  search: _propTypes["default"].func
};
var _default = CommonDropdown;
exports["default"] = _default;