"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _react = _interopRequireWildcard(require("react"));

var _Options = _interopRequireDefault(require("./Options"));

var _forEach = _interopRequireDefault(require("lodash-es/forEach"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var CommonDropdown = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(CommonDropdown, _Component);

  function CommonDropdown(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.dropdownMenuRef = /*#__PURE__*/(0, _react.createRef)();

    _this.filter = function (keyword) {
      if (keyword) {
        (0, _forEach["default"])(_this.dropdownMenuRef.current.children, function (li) {
          if (li.innerText.indexOf(keyword) === -1) {
            li.style.display = 'none';
          } else {
            li.removeAttribute('style');
          }
        });
        return;
      }

      (0, _forEach["default"])(_this.dropdownMenuRef.current.children, function (li) {
        return li.removeAttribute('style');
      });
    };

    return _this;
  }

  var _proto = CommonDropdown.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        getOptionLabel = _this$props.getOptionLabel,
        getOptionValue = _this$props.getOptionValue,
        onChange = _this$props.onChange,
        options = _this$props.options,
        value = _this$props.value,
        _this$props$t = _this$props.t,
        t = _this$props$t === void 0 ? function (v) {
      return v;
    } : _this$props$t;
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "dropdown-menu-left"
    }, options.length > 10 ? /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement("i", {
      className: "icon icon-search"
    }), /*#__PURE__*/_react["default"].createElement("div", {
      className: "dropdown-menu-search"
    }, /*#__PURE__*/_react["default"].createElement("input", {
      placeholder: t('label.searchPlaceholder'),
      onChange: function onChange(e) {
        return _this2.filter(e.target.value);
      }
    }))) : void 0, /*#__PURE__*/_react["default"].createElement("ul", {
      className: "dropdown-menu-ul scrollbar",
      ref: this.dropdownMenuRef
    }, /*#__PURE__*/_react["default"].createElement(_Options["default"], {
      getOptionLabel: getOptionLabel,
      getOptionValue: getOptionValue,
      options: options,
      value: value,
      onChange: onChange
    })));
  };

  return CommonDropdown;
}(_react.Component);

CommonDropdown.propTypes = {
  getOptionLabel: _propTypes["default"].func,
  getOptionValue: _propTypes["default"].func,
  value: _propTypes["default"].arrayOf(_propTypes["default"].any),
  onChange: _propTypes["default"].func,
  options: _propTypes["default"].arrayOf(_propTypes["default"].any)
};
var _default = CommonDropdown;
exports["default"] = _default;