"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _isArray = _interopRequireDefault(require("lodash-es/isArray"));

var _isEmpty = _interopRequireDefault(require("lodash-es/isEmpty"));

var _isNumber = _interopRequireDefault(require("lodash-es/isNumber"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireDefault(require("react"));

var _excluded = ["prefix", "value", "placeholder", "t", "isOpen", "unitLabel", "controlClassName"];

var Control = function Control(_ref) {
  var prefix = _ref.prefix,
      _ref$value = _ref.value,
      value = _ref$value === void 0 ? [] : _ref$value,
      placeholder = _ref.placeholder,
      _ref$t = _ref.t,
      t = _ref$t === void 0 ? function (v) {
    return v;
  } : _ref$t,
      isOpen = _ref.isOpen,
      unitLabel = _ref.unitLabel,
      controlClassName = _ref.controlClassName,
      props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded);
  return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({}, props, {
    className: controlClassName,
    onClick: props.onClick
  }), /*#__PURE__*/_react["default"].createElement("span", null, prefix, " ", (0, _isArray["default"])(value) && !(0, _isEmpty["default"])(value) ? (0, _isNumber["default"])(value[0]) && (0, _isNumber["default"])(value[1]) ? value.join('-') + unitLabel : (0, _isNumber["default"])(value[0]) ? t('label.great_than') + value[0] + unitLabel : (0, _isNumber["default"])(value[1]) ? t('label.less_than') + value[1] + unitLabel : placeholder : placeholder), /*#__PURE__*/_react["default"].createElement("i", {
    className: "icon icon-caret-" + (isOpen ? 'up' : 'down')
  }));
};

Control.propTypes = {
  prefix: _propTypes["default"].string,
  className: _propTypes["default"].string,
  placeholder: _propTypes["default"].string,
  value: _propTypes["default"].arrayOf(_propTypes["default"].number),
  isOpen: _propTypes["default"].bool,
  t: _propTypes["default"].func,
  onClick: _propTypes["default"].func,
  unitLabel: _propTypes["default"].string
};
Control.defaultProps = {
  prefix: '',
  placeholder: '',
  isOpen: false,
  className: 'form-control'
};
var _default = Control;
exports["default"] = _default;