var _excluded = ["extra"];
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { CopyOutlined, DeleteOutlined, MoreOutlined, ReloadOutlined, DislikeOutlined, LikeOutlined } from '@ant-design/icons';
import { Button } from 'antd';
import React, { useCallback } from 'react';
import { PopupBatchedActions } from "../..";
// import { PopupBatchedActionsNew } from 'udesk-llm-fe';
import { fire } from "../../utils/core";
import { Toast } from "../../Toast";
import Locales from "../../locales";
export default /*#__PURE__*/React.memo(function (props) {
  var _props$data = props.data,
    data = _props$data === void 0 ? {} : _props$data,
    onReload = props.onReload,
    onFeedback = props.onFeedback,
    onDelete = props.onDelete,
    getPopupContainer = props.getPopupContainer;
  var _data$extra = data.extra,
    extra = _data$extra === void 0 ? [] : _data$extra,
    otherProps = _objectWithoutProperties(data, _excluded);
  var copyVariable = useCallback(function () {
    navigator.clipboard.writeText(data === null || data === void 0 ? void 0 : data.content).then(function () {
      Toast({
        message: /* 复制成功 */Locales['current'].dialogue.components.batchedActions.successfullyCopied,
        type: 'success'
      });
    }).catch(function (error) {
      console.log( /* 复制失败 */Locales['current'].dialogue.components.batchedActions.copyFailed, error);
    });
  }, [data]);
  return /*#__PURE__*/React.createElement("div", {
    className: "flex flex-col"
  }, /*#__PURE__*/React.createElement(PopupBatchedActions, {
    getPopupContainer: getPopupContainer,
    trigger: 'click',
    menu: [].concat(_toConsumableArray(extra.map(function (item) {
      return fire(item, otherProps);
    }).filter(function (item) {
      return !!item;
    })), _toConsumableArray([{
      label: 'reload',
      onClick: onReload,
      icon: /*#__PURE__*/React.createElement(ReloadOutlined, null)
    }, {
      // label: /* 点赞 */Locales['current'].dialogue.components.batchedActions.copy,
      label: '点赞',
      onClick: copyVariable,
      icon: /*#__PURE__*/React.createElement(LikeOutlined, null)
    }, {
      // label: /* 点踩 */Locales['current'].dialogue.components.batchedActions.copy,
      label: '点踩',
      danger: true,
      feedback: true,
      onClick: onFeedback,
      icon: /*#__PURE__*/React.createElement(DislikeOutlined, null)
    }, navigator.clipboard && {
      label: /* 复制 */Locales['current'].dialogue.components.batchedActions.copy,
      // label: 'CTRL_C',
      onClick: copyVariable,
      icon: /*#__PURE__*/React.createElement(CopyOutlined, null)
    }, onDelete || true ? {
      label: /* 删除 */Locales['current'].dialogue.components.batchedActions.delete + '123',
      confirm: {
        title: /* 删除内容是不可逆的操作，删除后将无法恢复 */Locales['current'].dialogue.components.batchedActions.deletingCo52erDeletion
      },
      danger: true,
      onClick: function onClick() {
        return onDelete === null || onDelete === void 0 ? void 0 : onDelete(otherProps);
      },
      icon: /*#__PURE__*/React.createElement(DeleteOutlined, null)
    } : null].filter(function (item) {
      return !!item;
    })))
  }, /*#__PURE__*/React.createElement(Button, {
    size: "small",
    type: "text",
    icon: /*#__PURE__*/React.createElement(MoreOutlined, null)
  })));
});