function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { DownOutlined, SmileOutlined, MehOutlined } from '@ant-design/icons';
import { Button, Tag, Space, Input } from 'antd';
import React, { useState, useEffect, useMemo } from 'react';
import Locales from "../../locales";
import styled from 'styled-components';
var FeedBackDiv = styled.div.withConfig({
  displayName: "FeedBackDiv",
  componentId: "udesk-llm-fe__sc-19tdbkz-0"
})(["display:flex;justify-content:space-between;min-width:400px;padding:12px;font-size:16px;line-height:24px;font-weight:400;background:rgba(0,0,0,0.06);border-radius:6px;user-select:none;.feedback-another-btn-groups{color:#4007A2;cursor:pointer;}.mgR16{margin-right:16px;}"]);
export default /*#__PURE__*/React.memo(function (props) {
  var feedbackType = props.feedbackType,
    setFeedBackType = props.setFeedBackType,
    isAlreadyFeedback = props.isAlreadyFeedback,
    handleSendFeedback = props.handleSendFeedback;
  var _useState = useState(''),
    _useState2 = _slicedToArray(_useState, 2),
    feedbackMessage = _useState2[0],
    setFeedbackMessage = _useState2[1];
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    feedbackFormVisible = _useState4[0],
    setFeedbackFormVisible = _useState4[1];
  var handleFeedbackBtn = function handleFeedbackBtn() {
    var _content$;
    setFeedbackFormVisible(!feedbackFormVisible);
    var content = document.getElementsByClassName('udesk-coach-components-dialogue-wrap');
    var targetElement = (_content$ = content[0]) === null || _content$ === void 0 || (_content$ = _content$.parentElement) === null || _content$ === void 0 ? void 0 : _content$.parentElement;
    setTimeout(function () {
      targetElement === null || targetElement === void 0 || targetElement.scrollTo({
        top: 99999999,
        behavior: 'smooth'
      });
    }, 500);
  };
  var onSuccess = function onSuccess(params) {
    setFeedbackMessage(Locales['current'].appPage.feedback.thank);
    handleFeedbackBtn();
    setFeedBackType('feedbackSuccess');
    handleSendFeedback(params);
  };
  useEffect(function () {
    if (feedbackType === 'like') {
      setFeedbackMessage(Locales['current'].appPage.feedback.likeMessage);
    } else if (feedbackType === 'dislike') {
      if (isAlreadyFeedback) {
        setFeedbackMessage(Locales['current'].appPage.feedback.thank);
      } else {
        setFeedbackMessage(Locales['current'].appPage.feedback.dislikeMessage);
      }
    } else if (feedbackType === 'feedbackSuccess') {
      setFeedbackMessage(Locales['current'].appPage.feedback.thank);
    } else {
      setFeedbackMessage('');
    }
  }, [feedbackType]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, feedbackMessage ? /*#__PURE__*/React.createElement(FeedBackDiv, null, /*#__PURE__*/React.createElement("div", {
    className: "mgR16"
  }, feedbackType === 'dislike' ? /*#__PURE__*/React.createElement(MehOutlined, null) : /*#__PURE__*/React.createElement(SmileOutlined, null), "\xA0", feedbackMessage), feedbackType === 'dislike' && !isAlreadyFeedback ? /*#__PURE__*/React.createElement("div", {
    onClick: handleFeedbackBtn,
    className: "feedback-another-btn-groups"
  }, Locales['current'].appPage.feedback.feedbackBtn, " \xA0", /*#__PURE__*/React.createElement(DownOutlined, null)) : '') : '', feedbackType === 'dislike' && feedbackFormVisible ? /*#__PURE__*/React.createElement(DislikeFeedback, {
    onSuccess: onSuccess
  }) : '');
});
var DislikeDiv = styled.div.withConfig({
  displayName: "DislikeDiv",
  componentId: "udesk-llm-fe__sc-19tdbkz-1"
})(["padding:12px 0;background:#fff;.dislike-input-box{margin-top:12px;}.dislike-input-box-textarea{border-radius:8px;}"]);
export var tag = /*#__PURE__*/function (tag) {
  tag[tag["WRONG"] = 0] = "WRONG";
  tag[tag["NOT_FOUND"] = 1] = "NOT_FOUND";
  tag[tag["MISSING"] = 2] = "MISSING";
  tag[tag["OTHER"] = 3] = "OTHER";
  return tag;
}({});
function DislikeFeedback(props) {
  var onSuccess = props.onSuccess;
  var TextArea = Input.TextArea;
  var _useState5 = useState(''),
    _useState6 = _slicedToArray(_useState5, 2),
    selectedTags = _useState6[0],
    setSelectedTags = _useState6[1];
  var tagsData = [{
    label: Locales['current'].appPage.feedback.WRONG,
    value: 'WRONG'
  }, {
    label: Locales['current'].appPage.feedback.NOT_FOUND,
    value: 'NOT_FOUND'
  }, {
    label: Locales['current'].appPage.feedback.MISSING,
    value: 'MISSING'
  }, {
    label: Locales['current'].appPage.feedback.OTHER,
    value: 'OTHER'
  }];
  var _useState7 = useState(''),
    _useState8 = _slicedToArray(_useState7, 2),
    value = _useState8[0],
    setValue = _useState8[1];
  var submitBtnDisabled = useMemo(function () {
    if (selectedTags || value) {
      return false;
    } else {
      return true;
    }
  }, [value, selectedTags]);
  var handleChange = function handleChange(tag) {
    console.log(tag);
    if (tag === selectedTags) {
      setSelectedTags('');
    } else {
      setSelectedTags(tag);
    }
  };
  var handleSubmit = function handleSubmit() {
    var params = {
      type: 2,
      // 2:点踩
      content: value,
      tag: selectedTags
    };
    onSuccess(params);
  };
  return /*#__PURE__*/React.createElement(DislikeDiv, null, /*#__PURE__*/React.createElement(Space, {
    size: [0, 8],
    wrap: true
  }, tagsData.map(function (tag) {
    return /*#__PURE__*/React.createElement(Tag, {
      onClick: function onClick() {
        handleChange(tag.value);
      },
      color: selectedTags == tag.value ? 'processing' : 'default',
      style: {
        padding: '8px',
        borderRadius: '4px',
        cursor: 'pointer',
        userSelect: 'none'
      }
    }, tag.label);
  })), /*#__PURE__*/React.createElement("div", {
    className: "dislike-input-box"
  }, /*#__PURE__*/React.createElement(TextArea, {
    className: "dislike-input-box-textarea",
    value: value,
    onChange: function onChange(e) {
      return setValue(e.target.value);
    },
    placeholder: " ",
    autoSize: {
      minRows: 3,
      maxRows: 5
    }
  })), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Button, {
    disabled: submitBtnDisabled,
    type: "primary",
    onClick: handleSubmit,
    style: {
      borderRadius: '6px',
      marginTop: '12px'
    }
  }, Locales['current'].appPage.feedback.submit)));
}