var _excluded = ["align", "closeTextAnimation", "onTextAnimationPlaying", "loading", "onDelete", "onReload", "onFeedback", "onTextRunning", "onDocClick", "sources"];
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { Space, Tag, Avatar, Spin } from 'antd';
import React, { useCallback, useImperativeHandle, useMemo } from 'react';
import styled from 'styled-components';
import { Markdown } from "../..";
// import PopupBatchedActions from './BatchedActions';
import PopupBatchedActions from "./BatchedActionsRobot";
import { SvgDoc } from "../img/doc";
import { FormatDate } from "./UserNode";
import { inspect } from "../../utils/core";
import { SvgRobot } from "../img/robot";
import Locales from "../../locales";
var RobotNodeWrap = styled.div.withConfig({
  displayName: "RobotNodeWrap",
  componentId: "udesk-llm-fe__sc-2pqhhs-0"
})(["display:flex;justify-content:", ";.udesk-coach-user-node-left{flex:1;margin:", ";.border-radius-10{background:#fff;border-radius:10px;padding:16px;}.udesk-coach-user-node-title{color:rgba(0,0,0,0.65);font-size:12px;line-height:12px;margin-bottom:8px;text-align:", ";}.udesk-coach-user-node-content{overflow-x:auto;border-radius:0px 4px 4px 4px;padding:10px 12px;color:rgba(0,0,0,0.85);font-size:14px;line-height:22px;img{max-width:100% !important;}video{max-width:100% !important;}}}.h68{height:68px}"], function (props) {
  return props.align === 'right' ? 'flex-end' : 'flex-start';
}, function (props) {
  return props.align === 'right' ? '0 12px 0 0' : '0 0 0 12px';
}, function (props) {
  return props.align === 'right' ? 'end' : 'start';
});
var DOC_TYPE_ENUMS = {
  KCS_MATERIAL: 9,
  KCS_DOCUMENT: 8,
  KCS_QA: 6,
  KCS_TEMPLATE: 7
};
var formatType = function formatType(type) {
  return Reflect.get(DOC_TYPE_ENUMS, type);
};
export var RobotNode = /*#__PURE__*/React.memo( /*#__PURE__*/React.forwardRef(function (props, ref) {
  var align = props.align,
    closeTextAnimation = props.closeTextAnimation,
    onTextAnimationPlaying = props.onTextAnimationPlaying,
    loading = props.loading,
    onDelete = props.onDelete,
    onReload = props.onReload,
    onFeedback = props.onFeedback,
    onTextRunning = props.onTextRunning,
    onDocClick = props.onDocClick,
    sources = props.sources,
    node = _objectWithoutProperties(props, _excluded);
  useImperativeHandle(ref, function () {
    return {};
  });
  var sourceData = useMemo(function () {
    return sources === null || sources === void 0 ? void 0 : sources.filter(function (item) {
      return !!item.sourceParam.name;
    });
  }, [sources]);
  var activeDoc = useMemo(function () {
    return sources === null || sources === void 0 ? void 0 : sources.find(function (item) {
      return item.checked;
    });
  }, [sources]);
  var _onClick = useCallback(function (item) {
    var url = item.sourceParam.previewUrl;
    if (/(.txt)$/gi.test(item.sourceParam.url)) {
      url = item.sourceParam.url + '?response-content-type=text/html;charset=utf-8';
    }
    onDocClick({
      type: formatType(item.type),
      // 9:文件 6:QA 7:知识模版 8:文档
      itemId: item.sourceParam.id,
      historyId: item.sourceParam.historyId,
      knowledgeBaseId: item.sourceParam.knowledgeBaseId,
      docSegment: item.sourceParam.docSegment,
      templateId: item.sourceParam.templateId,
      url: url
    });
  }, [onDocClick]);
  return /*#__PURE__*/React.createElement(RobotNodeWrap, {
    align: align
  }, align === 'left' ? /*#__PURE__*/React.createElement(Avatar, {
    style: {
      flex: '0 0 40px'
    },
    size: 40,
    icon: /*#__PURE__*/React.createElement(SvgRobot, null)
  }) : null, /*#__PURE__*/React.createElement("div", {
    className: "udesk-coach-user-node-left"
  }, /*#__PURE__*/React.createElement("div", {
    className: "udesk-coach-user-node-title"
  }, /*#__PURE__*/React.createElement(FormatDate, {
    startSecond: props.startSecond
  })), /*#__PURE__*/React.createElement("div", {
    className: "w-[calc(100vw_-_36px_-_4rem)] border-radius-10  md:w-fit"
  }, /*#__PURE__*/React.createElement("div", {
    className: "udesk-coach-user-node-content",
    style: {
      overflowWrap: 'anywhere'
    }
  }, loading ? /*#__PURE__*/React.createElement(Spin, {
    className: "w-full",
    spinning: loading
  }) : /*#__PURE__*/React.createElement(Markdown, {
    onTextRunning: onTextRunning,
    onTextAnimationPlaying: onTextAnimationPlaying,
    closeTextAnimation: closeTextAnimation,
    content: props.content
  }), inspect(activeDoc, function () {
    return /*#__PURE__*/React.createElement("div", {
      style: {
        borderTop: '0.5px solid rgba(0, 0, 0, 0.1)',
        padding: '12px 12px 8px 12px',
        margin: '0 -12px'
      }
    }, /*#__PURE__*/React.createElement("span", {
      onClick: function onClick() {
        return _onClick(activeDoc);
      },
      className: "cursor-pointer text-[#00000073] text-xs hover:text-blue-500"
    }, Locales['current'].dialogue.components.robotNode.documentRetrieval, activeDoc.sourceParam.name));
  }, function () {
    return inspect((sourceData === null || sourceData === void 0 ? void 0 : sourceData.length) > 0, function () {
      return /*#__PURE__*/React.createElement("div", {
        style: {
          borderTop: '0.5px solid rgba(0, 0, 0, 0.1)',
          padding: '12px 12px 8px 12px',
          margin: '0 -12px'
        }
      }, /*#__PURE__*/React.createElement("h4", {
        className: "text-[#00000073] text-xs"
      }, Locales['current'].dialogue.components.robotNode.source), /*#__PURE__*/React.createElement(Space, {
        wrap: true
      }, sourceData === null || sourceData === void 0 ? void 0 : sourceData.map(function (item) {
        return /*#__PURE__*/React.createElement(Tag, {
          key: item.sourceParam.id,
          style: {
            height: 24,
            lineHeight: '24px',
            border: 0,
            cursor: 'pointer',
            background: 'rgba(240, 248, 255, 1)'
          },
          icon: /*#__PURE__*/React.createElement(SvgDoc, {
            style: {
              position: 'relative',
              top: 2,
              marginRight: 3
            }
          }),
          className: "text-slate-600 hover:text-blue-500",
          onClick: function onClick() {
            return _onClick(item);
          },
          color: "blue"
        }, item.sourceParam.name);
      })));
    });
  })), /*#__PURE__*/React.createElement(PopupBatchedActions, {
    data: node,
    onFeedback: onFeedback,
    onDelete: onDelete,
    onReload: onReload
  }))), align === 'right' ? /*#__PURE__*/React.createElement(Avatar, {
    style: {
      flex: '0 0 40px'
    },
    size: 40,
    icon: /*#__PURE__*/React.createElement(SvgRobot, null)
  }) : null);
}));