// @ts-nocheck
import { Empty, Spin } from 'antd';
import React, { useImperativeHandle, useRef } from 'react';
import styled from 'styled-components';
import { DialogueContextProvider } from "./Context";
import { Item } from "./Item";
import { useAudio } from "./hooks/useAudio";
import { useFormattedDialogueSentenceList } from "./hooks/useFormattedDialogueSentenceList";
var Div = styled.div.withConfig({
  displayName: "Div",
  componentId: "udesk-llm-fe__sc-19g3rlm-0"
})(["border-radius:4px;height:100% !important;"]);
function isNotEmptyArray(dialogueSentenceList) {
  return Array.isArray(dialogueSentenceList) && dialogueSentenceList.length > 0;
}
var InternalDialogue = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var divRef = useRef(null);
  var _props$loading = props.loading,
    loading = _props$loading === void 0 ? false : _props$loading,
    dialogueSentenceList = props.dialogueSentenceList,
    onScroll = props.onScroll,
    itemRender = props.itemRender,
    formatItemRenderProps = props.formatItemRenderProps;
  var dialogueSentenceListFormatted = useFormattedDialogueSentenceList(dialogueSentenceList, formatItemRenderProps);
  var audioInstance = useAudio();
  useImperativeHandle(ref, function () {
    return {
      isScrollBottom: function isScrollBottom() {
        var _divRef$current;
        var $content = (_divRef$current = divRef.current) === null || _divRef$current === void 0 || (_divRef$current = _divRef$current.parentElement) === null || _divRef$current === void 0 ? void 0 : _divRef$current.parentElement;
        return (($content === null || $content === void 0 ? void 0 : $content.scrollHeight) || 0) - (($content === null || $content === void 0 ? void 0 : $content.clientHeight) || 0) === (($content === null || $content === void 0 ? void 0 : $content.scrollTop) || 0);
      },
      scrollToBottom: function scrollToBottom() {
        var _divRef$current2;
        var $content = (_divRef$current2 = divRef.current) === null || _divRef$current2 === void 0 || (_divRef$current2 = _divRef$current2.parentElement) === null || _divRef$current2 === void 0 ? void 0 : _divRef$current2.parentElement;
        if ($content) {
          $content === null || $content === void 0 || $content.scrollTo({
            top: 99999999,
            behavior: 'smooth'
          });
        }
      }
    };
  }, []);
  return /*#__PURE__*/React.createElement(DialogueContextProvider, {
    value: {
      dialogueSentenceList: dialogueSentenceList,
      audioInstance: audioInstance
    }
  }, /*#__PURE__*/React.createElement(Spin, {
    onWheel: onScroll,
    wrapperClassName: 'scrollbar scrollbar-thumb scrollbar-track flex-1 overflow-auto',
    spinning: loading
  }, /*#__PURE__*/React.createElement(Div, {
    ref: divRef,
    className: "udesk-coach-components-dialogue-wrap py-5 md:px-5"
  }, isNotEmptyArray(dialogueSentenceListFormatted) ? dialogueSentenceListFormatted === null || dialogueSentenceListFormatted === void 0 ? void 0 : dialogueSentenceListFormatted.map(function (sentence, index) {
    return itemRender(sentence, index);
  }) : /*#__PURE__*/React.createElement(Empty, {
    image: Empty.PRESENTED_IMAGE_SIMPLE
  }))));
});
var Dialogue = InternalDialogue;
Dialogue.Item = Item;
export default Dialogue;