function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
// @ts-nocheck
import editorHtml from 'editorjs-html';
import React, { useEffect, useRef, useState } from 'react';
import "./index.less";
import { customDoc, customHeader, customImage, customTable, customUml, customVideoTool } from "./utils/customs";
import { clearHighlight, highlightTextIndex } from "./utils/dom";
import { getHighlightItemList } from "./utils/highlight";
var CHECK_LIST_STYLE = 'display: inline-block; flex-shrink: 0;position: relative;width: 20px;height: 20px;margin: 5px;margin-left: -7px;margin-right: 7px;border-radius: 50%;border: 1px solid #d0d0d0;background: #fff;cursor: pointer;user-select: none;';
var CHECKED_LIST_STYLE = 'display: inline-block; flex-shrink: 0;position: relative;width: 20px;height: 20px;margin: 5px;margin-left: -7px;margin-right: 7px;border-radius: 50%;border: 1px solid #d0d0d0;background: #fff;cursor: pointer;user-select: none;background: #388ae5;border-color: #388ae5;';
var YES_STYLE = "position: absolute;top: 6px;left: 5px;width: 9px;height: 4px;border: 2px solid #fff;border-top: none;border-right: none;background: transparent;transform: rotate(-45deg);content: '';opacity: 0;";
export function formatEditorHtml(transformHtml) {
  if (!transformHtml || transformHtml === '') {
    return '';
  }
  var htmlObj = transformHtml;
  if (_typeof(htmlObj) !== 'object') {
    try {
      htmlObj = JSON.parse(htmlObj);
    } catch (error) {
      return '';
    }
  }
  if (htmlObj.blocks && !Array.isArray(htmlObj.blocks)) {
    try {
      htmlObj.blocks = JSON.parse(htmlObj.blocks);
    } catch (error) {
      return htmlObj.blocks = [];
    }
  } else {
    htmlObj.blocks = htmlObj.blocks || [];
  }
  var editParser = editorHtml({
    video: customVideoTool,
    table: customTable,
    header: customHeader,
    image: customImage,
    uml: customUml,
    doc: customDoc
  });
  //   let html = editParser.parse(transformHtml || { blocks: [] });
  var html = editParser.parse(htmlObj);
  // 兼容回显图片大小
  // let htmlResp = html.map((item: string) => {
  //   if (item.includes('img') || item.includes('video')) {
  //     item = item.slice(0, 5) + "style='width:100%'" + ' ' + item.slice(5);
  //     return item;
  //   }
  //   return item;
  // });
  //setDataHtml(htmlResp.join(''));
  //处理只读模式下的多选列表的回显
  var convertedHtml = '';
  htmlObj.blocks.forEach(function (block) {
    switch (block.type) {
      case 'checklist':
        convertedHtml += "<ul style='list-style:none'>";
        block.data.items.forEach(function (li) {
          convertedHtml += "<li style=\"display:flex;line-height: 30px;\"><span style='".concat(li.checked ? CHECKED_LIST_STYLE : CHECK_LIST_STYLE, "'><i style='").concat(li.checked ? YES_STYLE : '', "'></i></span>").concat(li.text, "</li>");
        });
        convertedHtml += '</ul>';
        break;
    }
  });
  //setDataHtml(transformHtml.join(''));
  var newHtml = html.map(function (item, index) {
    if (!(typeof item === 'string')) {
      item = convertedHtml;
    }
    var originItem = htmlObj.blocks[index] || {
      data: {
        level: '',
        text: ''
      }
    };
    if (htmlObj.blocks[index].type.includes('header')) {
      item = "<h".concat(originItem.data.level, " id=\"").concat(originItem.id, "\">").concat(originItem.data.text, "</h").concat(originItem.data.level, ">");
    }
    return item;
  });
  return newHtml.join('');
}
var htmlPosition = {
  paddingLeft: '0.4rem',
  paddingRight: '0.4rem',
  background: '#fff',
  width: '100%',
  overflow: 'auto',
  height: 'calc(100% - 45px)'
};
function replacenbsp(text) {
  var reg = new RegExp('&amp;nbsp;', 'g');
  var res = text.replace(reg, '&nbsp;');
  return res;
}
export function formatContent() {
  var content = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var res = content.map(function (item) {
    var _ref = item || {},
      type = _ref.type,
      _ref$data = _ref.data,
      data = _ref$data === void 0 ? {} : _ref$data;
    switch (type) {
      case 'header':
      case 'headerH2':
      case 'headerH3':
      case 'paragraph':
      case 'quote':
        data.text = replacenbsp(data.text);
        break;
      case 'list':
        var _data$items = data.items,
          itemList = _data$items === void 0 ? [] : _data$items;
        itemList.forEach(function (cItem, i) {
          itemList[i] = replacenbsp(cItem);
        });
        break;
      case 'checklist':
        var _data$items2 = data.items,
          items = _data$items2 === void 0 ? [] : _data$items2;
        items.forEach(function (cItem, index) {
          items[index].text = replacenbsp(cItem.text);
        });
        break;
      default:
        break;
    }
    return item;
  });
  return res || [];
}
export default /*#__PURE__*/React.memo(function (props) {
  var search = props.search,
    readHtml = props.readHtml,
    transformHtml = props.transformHtml;
  var _useState = useState(''),
    _useState2 = _slicedToArray(_useState, 2),
    dataHtml = _useState2[0],
    setDataHtml = _useState2[1];
  var divRef = useRef(null);
  useEffect(function () {
    if (transformHtml) {
      var _readHtml = formatEditorHtml({
        blocks: formatContent(JSON.parse(transformHtml || '[]')) || []
      });
      setDataHtml(_readHtml);
    }
  }, [transformHtml]);
  useEffect(function () {
    if (readHtml) {
      setDataHtml(readHtml);
    }
  }, [readHtml]);
  useEffect(function () {
    if (search) {
      var map = getHighlightItemList(divRef.current, search);
      map === null || map === void 0 || map.forEach(function (item, index) {
        highlightTextIndex(divRef.current, item, {
          className: "audio-text-list-item-text-hit-status prev-highlight-".concat(item.index)
        });
        if (index === 1) {
          highlightTextIndex(divRef.current, item, {
            className: "current-highlight-item"
          });
        }
      }, [search]);
    } else {
      clearHighlight(divRef.current);
    }
  }, [dataHtml]);
  return /*#__PURE__*/React.createElement("div", {
    className: "scrollbar scrollbar-thumb scrollbar-track",
    ref: divRef,
    dangerouslySetInnerHTML: {
      __html: dataHtml
    },
    style: htmlPosition
  });
});