// @ts-nocheck
import { stringify } from "./stringify";
export function customVideoTool(block) {
  var _block$data;
  var url = (block === null || block === void 0 || (_block$data = block.data) === null || _block$data === void 0 || (_block$data = _block$data.file) === null || _block$data === void 0 ? void 0 : _block$data.url) || '';
  if (url && url !== '') {
    return "<div style=\"margin: 24px 0\" ><video src=\"".concat(url, "\" width=\"100%\" height=\"auto\" controls> </video></div>");
  }
  return null;
}
export function customTable(block) {
  var _ref = (block === null || block === void 0 ? void 0 : block.data) || {},
    _ref$withHeadings = _ref.withHeadings,
    withHeadings = _ref$withHeadings === void 0 ? false : _ref$withHeadings,
    _ref$content = _ref.content,
    content = _ref$content === void 0 ? [] : _ref$content,
    colgroup = _ref.colgroup;
  var html = "<div class=\"tc-table-wrap\"><table class=\"tc-table  ".concat(withHeadings ? 'tc-table--heading' : '', "\">");
  html += "<colgroup>";
  colgroup === null || colgroup === void 0 || colgroup.forEach(function (col) {
    return html += "<col width=\"".concat(col, "\">");
  });
  html += "</colgroup>";
  content.forEach(function () {
    var row = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var rowHtml = '<tr>';
    row.forEach(function (item) {
      rowHtml += "<td colspan=".concat(item.colspan, " rowspan=").concat(item.rowspan, " >").concat(typeof item === 'string' ? item : stringify(item.content), "</td>");
    });
    rowHtml += '</tr>';
    html += rowHtml;
  });
  html += '</table></div>';
  return html;
}
export function customHeader(block) {
  var id = block.id,
    _block$data2 = block.data,
    _block$data3 = _block$data2 === void 0 ? {} : _block$data2,
    _block$data3$level = _block$data3.level,
    level = _block$data3$level === void 0 ? '' : _block$data3$level,
    _block$data3$text = _block$data3.text,
    text = _block$data3$text === void 0 ? '' : _block$data3$text;
  return "<h".concat(level, " id=\"").concat(id, "\">").concat(text, "</h").concat(level, ">");
}
export function customImage(block) {
  var id = block.id,
    _block$data4 = block.data,
    _block$data5 = _block$data4 === void 0 ? {} : _block$data4,
    _block$data5$file = _block$data5.file,
    _block$data5$file2 = _block$data5$file === void 0 ? {} : _block$data5$file,
    _block$data5$file2$ur = _block$data5$file2.url,
    url = _block$data5$file2$ur === void 0 ? '' : _block$data5$file2$ur,
    _block$data5$file2$wi = _block$data5$file2.width,
    width = _block$data5$file2$wi === void 0 ? '' : _block$data5$file2$wi,
    _block$data5$file2$he = _block$data5$file2.height,
    height = _block$data5$file2$he === void 0 ? '' : _block$data5$file2$he,
    _block$data5$caption = _block$data5.caption,
    caption = _block$data5$caption === void 0 ? '' : _block$data5$caption,
    _block$data5$stretche = _block$data5.stretched,
    stretched = _block$data5$stretche === void 0 ? false : _block$data5$stretche,
    _block$data5$withBack = _block$data5.withBackground,
    withBackground = _block$data5$withBack === void 0 ? false : _block$data5$withBack,
    _block$data5$withBord = _block$data5.withBorder,
    withBorder = _block$data5$withBord === void 0 ? false : _block$data5$withBord;
  return "\n        <div class=\"document-image\" id=\"".concat(id, "\">\n            <div \n                class=\"\n                    document-image-box \n                    ").concat(withBackground ? 'document-image-box--withBackground' : '', "\n                    ").concat(withBorder ? 'document-image-box--withBorder' : '', "\n                    ").concat(stretched ? 'document-image-box--stretched' : '', "\n                \"\n            >\n                <img class=\"document-image-main\" src=\"").concat(url, "\" alt=\"Image\" width=\"").concat(width, "\" height=\"").concat(height, "\" />\n            </div>\n            <div class=\"document-image-caption\">").concat(caption, "</div>\n        </div>\n    ");
}
export function customUml(block) {
  var id = block.id,
    _block$data6 = block.data,
    _block$data7 = _block$data6 === void 0 ? {} : _block$data6,
    _block$data7$url = _block$data7.url,
    url = _block$data7$url === void 0 ? '' : _block$data7$url;
  if (url && url !== '') return "<div class=\"document-image\" >\n            <img class=\"document-image-main\" src=".concat(url, " style=\"width: 100%; max-height: 400px; object-fit: contain; margin-bottom: 16px\"/>\n        </div>");
  return null;
}
export function customDoc(block) {
  var _block$data8 = block.data,
    title = _block$data8.title,
    knowledgeBaseName = _block$data8.knowledgeBaseName;
  if (title) {
    return "\n          <div class='document-block-view'>\n              <span role=\"img\" aria-label=\"file-text\" class=\"anticon anticon-file-text icon icon-FileTextOutlined\">\n                  <svg viewBox=\"64 64 896 896\" focusable=\"false\" data-icon=\"file-text\" width=\"1em\" height=\"1em\" fill=\"currentColor\" aria-hidden=\"true\">\n                      <path d=\"M854.6 288.6L639.4 73.4c-6-6-14.1-9.4-22.6-9.4H192c-17.7 0-32 14.3-32 32v832c0 17.7 14.3 32 32 32h640c17.7 0 32-14.3 32-32V311.3c0-8.5-3.4-16.7-9.4-22.7zM790.2 326H602V137.8L790.2 326zm1.8 562H232V136h302v216a42 42 0 0042 42h216v494zM504 618H320c-4.4 0-8 3.6-8 8v48c0 4.4 3.6 8 8 8h184c4.4 0 8-3.6 8-8v-48c0-4.4-3.6-8-8-8zM312 490v48c0 4.4 3.6 8 8 8h384c4.4 0 8-3.6 8-8v-48c0-4.4-3.6-8-8-8H320c-4.4 0-8 3.6-8 8z\"></path>\n                  </svg>\n              </span>\n              <div>\n                  <span>".concat(title, "</span>\n                  <span>").concat(knowledgeBaseName, "</span>\n              </div>\n          </div>\n      ");
  }
  return null;
}
export function isMobileDevice() {
  try {
    return /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent);
  } catch (e) {
    return false;
  }
}