import { getTextNodesIn } from "./dom";
export var getHighlightItemList = function getHighlightItemList(content, searchHighlightKeywords) {
  var findAll = function findAll(content, target) {
    if (!content) {
      return [];
    }
    var textNodes = getTextNodesIn(content);
    var text = [];
    for (var i = textNodes.length - 1; i >= 0; i--) {
      text.push(textNodes[i].nodeValue);
    }
    var str = text.join('');
    var position = str.indexOf(target);
    var ret = [];
    while (position !== -1) {
      ret.push(position);
      position = str.indexOf(target, position + 1);
    }
    return ret;
  };
  var starts = findAll(content, searchHighlightKeywords);
  if (starts.length === 0) return;
  var createHighlight = function createHighlight(start, index, length) {
    return {
      groupIndex: 0,
      itemIndex: 0,
      highlightType: 1,
      index: index,
      length: length,
      start: start
    };
  };
  return starts.map(function (start, index) {
    return createHighlight(start, index + 1, searchHighlightKeywords.length);
  });
};