import React from 'react';
import { Button, Space } from 'antd';
import { ErrorBoundary } from "react-error-boundary";
import { SvgError } from "./500";
import Locales from "../locales";
function Fallback(props) {
  return /*#__PURE__*/React.createElement("div", {
    className: "w-full text-center flex flex-col relative my-10"
  }, /*#__PURE__*/React.createElement(SvgError, {
    style: {
      height: 302,
      margin: '0 auto'
    }
  }), /*#__PURE__*/React.createElement("div", {
    className: "mt-10 mb-5 text-base text-slate-700"
  }, 'ERROR：', props.error.message), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(Space, null, /*#__PURE__*/React.createElement(Button, {
    onClick: function onClick() {
      return location.replace(location.href);
    },
    type: "primary"
  }, /* 刷新 */Locales['current'].errorBoundaryTest.index.refresh))));
}
export default (function (props) {
  return /*#__PURE__*/React.createElement(ErrorBoundary, {
    FallbackComponent: Fallback
  }, props.children);
});