function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import { AppstoreOutlined, CommentOutlined } from '@ant-design/icons';
import { Empty } from 'antd';
import React, { useMemo } from 'react';
import { SESSION } from "../LLM/components/HistoryTop10";
import { useChatHistoryContext } from "../LLM/context/chatHistory";
import { useRouteContext } from "../LLM/context/route";
import { AppRouteName, SessionRouteName } from "../LLM/routes/routeMap";
import "./index.less";
import Locales from "../locales";
var Item = /*#__PURE__*/React.memo(function (_ref) {
  var id = _ref.id,
    name = _ref.name,
    time = _ref.time,
    type = _ref.type,
    answer = _ref.answer,
    afterClick = _ref.afterClick,
    applicationId = _ref.applicationId;
  var _useRouteContext = useRouteContext(),
    currentRoute = _useRouteContext.currentRoute;
  var _ref2 = currentRoute || {},
    routeName = _ref2.routeName,
    params = _ref2.params;
  var _useChatHistoryContex = useChatHistoryContext(),
    active = _useChatHistoryContex.active,
    setActive = _useChatHistoryContex.setActive;
  var _useRouteContext2 = useRouteContext(),
    push = _useRouteContext2.push;
  var goHistoryDetail = function goHistoryDetail() {
    setActive({
      type: type,
      id: id
    });
    if (type === SESSION) {
      push(SessionRouteName, {
        sessionId: id
      });
    } else {
      push(AppRouteName, {
        applicationId: applicationId
      });
    }
    afterClick === null || afterClick === void 0 || afterClick();
  };
  var isActive = useMemo(function () {
    if ([AppRouteName, SessionRouteName].includes(routeName)) {
      return (active === null || active === void 0 ? void 0 : active.type) === type ? id === (active === null || active === void 0 ? void 0 : active.id) : id === (params === null || params === void 0 ? void 0 : params.sessionId);
    } else {
      setActive(undefined);
    }
  }, [routeName, active === null || active === void 0 ? void 0 : active.type, active === null || active === void 0 ? void 0 : active.id, id]);
  var getTime = function getTime(time) {
    if (!time) return '';
    var datePart = time.substr(5, 5); // '08-29'
    var timePart = time.substr(11, 5); // '09:41'

    // 组合月份、日期和时间部分
    return datePart + ' ' + timePart; // '08-29 09:41'
  };

  return /*#__PURE__*/React.createElement("div", {
    className: "history-item group ".concat(isActive ? 'active' : ''),
    onClick: goHistoryDetail
  }, type === 'application' ? /*#__PURE__*/React.createElement(AppstoreOutlined, {
    className: "!text-[#3b3abe] text-2xl mb-2 opacity-50 group-hover:opacity-100",
    style: {
      marginRight: 2
    }
  }) : /*#__PURE__*/React.createElement(CommentOutlined, {
    className: "!text-[#3b3abe] text-2xl mb-2 opacity-50 group-hover:opacity-100",
    style: {
      marginRight: 2
    }
  }), /*#__PURE__*/React.createElement("div", {
    style: {
      height: '100%',
      justifyContent: 'space-around'
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "mt-0",
    style: {
      alignItems: 'baseline'
    }
  }, /*#__PURE__*/React.createElement("div", {
    title: name,
    style: {
      fontWeight: 'bold',
      fontSize: '14px',
      overflow: 'hidden',
      whiteSpace: 'nowrap',
      textOverflow: 'ellipsis'
    }
  }, name), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("span", {
    className: "text-zinc-400"
  }, getTime(time)), /*#__PURE__*/React.createElement("svg", {
    viewBox: "0 0 24 24",
    xmlns: "http://www.w3.org/2000/svg",
    style: {
      marginTop: '-2px'
    },
    className: "text-zinc-400"
  }, /*#__PURE__*/React.createElement("path", {
    fill: "currentColor",
    d: "M8.38 21.5c.26 0 .51-.1.71-.29l8.5-8.5a.996.996 0 0 0 0-1.41l-8.5-8.5a.996.996 0 1 0-1.41 1.41L15.46 12l-7.79 7.8a.996.996 0 0 0 0 1.41c.2.19.45.29.71.29Z"
  })))), /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("div", null, answer)))));
});
var History = function History(_ref3) {
  var list = _ref3.list,
    afterClick = _ref3.afterClick;
  if (!Array.isArray(list) || !list.length) return /*#__PURE__*/React.createElement(Empty, {
    image: Empty.PRESENTED_IMAGE_SIMPLE,
    description: /* 暂无记录 */Locales['current'].history.index.thereAreCu15sAvailable
  });
  return /*#__PURE__*/React.createElement("div", {
    className: "history-list"
  }, list.map(function (item, index) {
    return /*#__PURE__*/React.createElement(Item, _extends({}, item, {
      key: "".concat(item.type, "-").concat(index),
      afterClick: afterClick
    }));
  }));
};
export default History;