function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
import React, { useCallback } from 'react';
import { Input } from "../Input";
import { useRouteContext } from "../LLM/context/route";
import { AppRouteName, SessionRouteName } from "../LLM/routes/routeMap";
import { useGet } from "../utils/fetch";
import { AppGrid } from "../components/AppGrid";
import { AppItem } from "../components/AppItem";
import Locales from "../locales";
var Home = function Home() {
  var _useRouteContext = useRouteContext(),
    push = _useRouteContext.push;
  var _useGet = useGet('/applicationManagers'),
    data = _useGet.data;
  var _onClick = useCallback(function (data) {
    push(AppRouteName, data);
  }, []);
  var goToCreateChat = function goToCreateChat(text) {
    push(SessionRouteName, {
      defaultSearch: text
    });
  };
  return /*#__PURE__*/React.createElement("div", {
    className: "overflow-y-auto"
  }, /*#__PURE__*/React.createElement("div", {
    className: "container mr-auto ml-auto w-[min(48rem,100%)] md:w-[min(47rem,100%)] lg:w-[min(64rem,100%)] p-7 md:p-0"
  }, /*#__PURE__*/React.createElement("div", {
    className: "flex flex-col items-center"
  }, /*#__PURE__*/React.createElement("div", {
    className: "w-full flex justify-center mt-[20%] pt-[64px] md:pt-0"
  }, /*#__PURE__*/React.createElement(Input, {
    onSend: goToCreateChat
  })), /*#__PURE__*/React.createElement(AppGrid, {
    title: /*#__PURE__*/React.createElement("div", {
      className: "flex justify-between mt-[32px] mb-[14px] w-full"
    }, /*#__PURE__*/React.createElement("div", {
      className: " font-bold flex items-center text-[18px]"
    }, Locales['current'].home.index.application)),
    items: (data === null || data === void 0 ? void 0 : data.data) || [],
    itemRender: function itemRender(item) {
      return /*#__PURE__*/React.createElement("div", {
        onClick: function onClick() {
          return _onClick(item);
        }
      }, /*#__PURE__*/React.createElement(AppItem, _extends({}, item, {
        key: item.id
      })));
    }
  }))));
};
export default Home;