function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { SendOutlined } from '@ant-design/icons';
import { Button } from 'antd';
import React, { useRef, useState } from 'react';
import { Div } from "./components/ui";
import { createClassName, inspect } from "../utils/core";
import { SvgSend } from "./components/send";
import Locales from "../locales";
var Input = function Input(props) {
  var _props$disabled = props.disabled,
    disabled = _props$disabled === void 0 ? false : _props$disabled,
    _props$rows = props.rows,
    rows = _props$rows === void 0 ? 1 : _props$rows,
    _props$multiple = props.multiple,
    multiple = _props$multiple === void 0 ? false : _props$multiple,
    _onChange = props.onChange,
    defaultValue = props.defaultValue,
    onSend = props.onSend;
  var _useState = useState(defaultValue !== null && defaultValue !== void 0 ? defaultValue : ''),
    _useState2 = _slicedToArray(_useState, 2),
    value = _useState2[0],
    setValue = _useState2[1];
  var textarea = useRef(null);
  var _onSend = function _onSend() {
    if (!disabled && value) {
      onSend === null || onSend === void 0 || onSend(value);
      setValue('');
    }
  };
  return /*#__PURE__*/React.createElement(Div, null, /*#__PURE__*/React.createElement("div", {
    className: createClassName({
      'ChatMessageInputContainer': true,
      'multiple': multiple
    }),
    onClick: function onClick() {
      var _textarea$current, _textarea$current$foc;
      return (_textarea$current = textarea.current) === null || _textarea$current === void 0 || (_textarea$current$foc = _textarea$current.focus) === null || _textarea$current$foc === void 0 ? void 0 : _textarea$current$foc.call(_textarea$current);
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "growWrap"
  }, /*#__PURE__*/React.createElement("textarea", {
    ref: textarea,
    value: value,
    onKeyDown: function onKeyDown(event) {
      var hasCtrl = multiple ? event.ctrlKey : !event.ctrlKey;
      if (event.key === 'Enter' && !hasCtrl) {
        event.preventDefault();
        _onSend();
      }
      if (event.key === 'Enter' && hasCtrl) {
        event.preventDefault();
        var _textarea = textarea.current;
        var start = _textarea.selectionStart;
        var end = _textarea.selectionEnd;
        var _value = _textarea.value;
        _textarea.value = _value.substring(0, start) + '\n' + _value.substring(end);
        _textarea.selectionStart = _textarea.selectionEnd = start + 1;
        if (_textarea.scrollHeight > _textarea.clientHeight) {
          _textarea.scrollTop += _textarea.clientHeight;
        }
      }
    },
    onChange: function onChange(e) {
      setValue(e.target.value);
      _onChange === null || _onChange === void 0 || _onChange(e);
    },
    className: "GrowingTextArea",
    rows: rows,
    placeholder: /* 开始对话吧 */Locales['current'].input.index.letsStartTheConversation
  })), /*#__PURE__*/React.createElement(Button, {
    type: "primary",
    shape: multiple ? 'round' : "circle",
    className: "input-send-btn rounded-full",
    disabled: disabled || !value,
    onClick: _onSend
  }, inspect(multiple, /*#__PURE__*/React.createElement(SvgSend, null), /*#__PURE__*/React.createElement(SendOutlined, {
    style: {
      fontSize: '18px',
      marginLeft: '4px',
      marginTop: 2
    }
  })))));
};
export { Input };
export default Input;