function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useCallback, useEffect, useState } from 'react';
import { Input } from "../Input";
import { List, Space } from 'antd';
import { useRouteContext } from "../LLM/context/route";
import { KcsAppRouteName } from "../LLM/routes/routeMap";
import { SvgRobot } from "./img/robot";
import { SvgArticle } from "./img/article";
import { SvgDoc } from "./img/document";
import { SvgQuickAnswer } from "./img/answer";
import { isKcsSdk, request } from "../utils/fetch";
import Locales from "../locales";
import classNames from 'classnames';
var AppGrid = function AppGrid(_ref) {
  var items = _ref.items,
    itemRender = _ref.itemRender;
  return /*#__PURE__*/React.createElement("div", {
    className: classNames({
      "grid md:grid-cols-3 md:mb-0 gap-4 w-full mt-12 apple:mt-4 grid-cols-1": true,
      'hidden': isKcsSdk()
    })
  }, items.map(itemRender));
};
var AppItem = function AppItem(_ref2) {
  var icon = _ref2.icon,
    title = _ref2.title,
    list = _ref2.list,
    _onClick = _ref2.onClick,
    loading = _ref2.loading;
  return /*#__PURE__*/React.createElement("div", {
    className: "bg-white rounded-lg"
  }, /*#__PURE__*/React.createElement(Space, {
    className: "pt-5 pl-5"
  }, icon, /*#__PURE__*/React.createElement("span", {
    className: "font-semibold text-lg"
  }, title)), /*#__PURE__*/React.createElement(List, {
    className: "p-3 pt-1",
    size: "small",
    split: false,
    loading: loading,
    dataSource: list,
    renderItem: function renderItem(item) {
      return /*#__PURE__*/React.createElement(List.Item, {
        className: "cursor-pointer text-[#000000a6] hover:text-[#2c7cf6]"
      }, /*#__PURE__*/React.createElement("div", {
        onClick: function onClick() {
          return _onClick(item);
        },
        className: "truncate cursor-pointer"
      }, /*#__PURE__*/React.createElement("span", {
        className: "inline-block mr-2 mb-1 border-2 border-solid border-[#999999] rounded-sm text-[#000000a6]"
      }), /*#__PURE__*/React.createElement("span", {
        className: "hover:underline underline-offset-4"
      }, item.content)));
    }
  }));
};
var KcsHome = function KcsHome() {
  var _useRouteContext = useRouteContext(),
    push = _useRouteContext.push;
  var _useState = useState([{
      icon: /*#__PURE__*/React.createElement(SvgArticle, null),
      title: /* 热门文章 */Locales['current'].kcsHome.index.popularArticles,
      loading: true,
      list: []
    }, {
      icon: /*#__PURE__*/React.createElement(SvgDoc, null),
      title: /* 查询文档 */Locales['current'].kcsHome.index.consultYourDocumentation,
      loading: true,
      list: []
    }, {
      icon: /*#__PURE__*/React.createElement(SvgQuickAnswer, null),
      title: /* 快速解答 */Locales['current'].kcsHome.index.quickAnswer,
      loading: true,
      list: []
    }]),
    _useState2 = _slicedToArray(_useState, 2),
    data = _useState2[0],
    setData = _useState2[1];
  useEffect(function () {
    request('/llmChat/view', {
      method: 'get'
    }).then(function (resp) {
      setData(function (data) {
        return [_objectSpread(_objectSpread({}, data[0]), {}, {
          loading: false,
          list: resp.data.slice(0, 5).map(function (item) {
            return {
              type: 6,
              // 9:文件 6:QA 7:知识模版 8:文档
              itemId: item.id,
              historyId: item.historyId,
              knowledgeBaseId: item.knowledgeBaseId,
              content: item.name,
              templateId: item.templateId
            };
          })
        }), data[1], data[2]];
      });
    });
    request('/llmChat//materialRepositorys', {
      method: 'get'
    }).then(function (resp) {
      setData(function (data) {
        return [data[0], _objectSpread(_objectSpread({}, data[1]), {}, {
          loading: false,
          list: resp.data.slice(0, 5).map(function (item) {
            var url = item.previewUrl;
            if (/(.txt)$/gi.test(item.encodingUrl)) {
              url = item.encodingUrl + '?response-content-type=text/html;charset=utf-8';
            }
            return {
              type: 9,
              // 9:文件 6:QA 7:知识模版 8:文档
              itemId: item.id,
              content: item.name,
              url: url
            };
          })
        }), data[2]];
      });
    });
    request('/llmChat/knowledgeItems', {
      method: 'get'
    }).then(function (resp) {
      setData(function (data) {
        return [data[0], data[1], _objectSpread(_objectSpread({}, data[2]), {}, {
          loading: false,
          list: resp.data.slice(0, 5).map(function (item) {
            return {
              type: 6,
              // 9:文件 6:QA 7:知识模版 8:文档
              clickType: 'input',
              itemId: item.id,
              content: item.name,
              knowledgeBaseId: item.knowledgeBaseId
            };
          })
        })];
      });
    });
  }, []);
  var onClick = useCallback(function (data) {
    // console.log(data,data.content);
    if (data.clickType && data.clickType === 'input') {
      push(KcsAppRouteName, {
        defaultSearch: data.content
      });
    } else {
      push(KcsAppRouteName, data);
    }
  }, []);
  var goToCreateChat = function goToCreateChat(text) {
    push(KcsAppRouteName, {
      defaultSearch: text
    });
  };
  return /*#__PURE__*/React.createElement("div", {
    className: "overflow-y-auto"
  }, /*#__PURE__*/React.createElement("div", {
    className: "mr-auto ml-auto w-[min(48rem,100%)] md:w-[min(47rem,100%)] lg:w-[min(64rem,100%)] p-7 md:p-0"
  }, /*#__PURE__*/React.createElement("div", {
    className: "flex flex-col items-center"
  }, /*#__PURE__*/React.createElement(SvgRobot, {
    className: "mt-12 apple:mt-1"
  }), /*#__PURE__*/React.createElement("h1", {
    className: "text-3xl"
  }, Locales['current'].kcsHome.index.helloIAmTh19eAssistant), /*#__PURE__*/React.createElement("h3", {
    className: "text-sm opacity-60"
  }, Locales['current'].kcsHome.index.iCanAnswer46meAndAskMe), /*#__PURE__*/React.createElement(AppGrid, {
    items: data || [],
    itemRender: function itemRender(item) {
      return /*#__PURE__*/React.createElement(AppItem, _extends({
        onClick: onClick
      }, item, {
        key: item.id
      }));
    }
  }), /*#__PURE__*/React.createElement("div", {
    style: {
      bottom: '1.5rem'
    },
    className: "absolute w-[min(45rem,100%_-_70px)] md:w-[min(45rem,100%)] lg:w-[min(62rem,100%)]"
  }, /*#__PURE__*/React.createElement(Input, {
    rows: 6,
    multiple: true,
    onSend: goToCreateChat
  })))));
};
export default KcsHome;