function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
import { Tag } from 'antd';
import React, { useMemo } from 'react';
import { inspect } from "../../../utils/core";
import { SAFE_HTML_WHITE_LIST, safeHtml } from "../../../utils/safeHtml";
import UploadAndMaterial from "../FileShowList";
import Locales from "../../../locales";
export function arabia2SimplifiedChinese(num) {
  //字符处理完毕后开始转换，采用前后两部分分别转换
  var part = String(num);
  var newChar = '';
  //小数点前进行转化
  for (var i = part.length - 1; i >= 0; i--) {
    var tmpNewChar = '';
    var perChar = part.charAt(i);
    switch (perChar) {
      case '0':
        tmpNewChar = /* 零 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.zero + tmpNewChar;
        break;
      case '1':
        tmpNewChar = /* 一 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.one + tmpNewChar;
        break;
      case '2':
        tmpNewChar = /* 二 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.two + tmpNewChar;
        break;
      case '3':
        tmpNewChar = /* 三 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.three + tmpNewChar;
        break;
      case '4':
        tmpNewChar = /* 四 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.four + tmpNewChar;
        break;
      case '5':
        tmpNewChar = /* 五 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.five + tmpNewChar;
        break;
      case '6':
        tmpNewChar = /* 六 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.six + tmpNewChar;
        break;
      case '7':
        tmpNewChar = /* 七 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.seven + tmpNewChar;
        break;
      case '8':
        tmpNewChar = /* 八 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.eight + tmpNewChar;
        break;
      case '9':
        tmpNewChar = /* 九 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.nine + tmpNewChar;
        break;
    }
    switch (part.length - i - 1) {
      case 0:
        // tmpNewChar = tmpNewChar;
        break;
      case 1:
        if (perChar !== '0') tmpNewChar = tmpNewChar + /* 十 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.ten;
        break;
      case 2:
        if (perChar !== '0') tmpNewChar = tmpNewChar + /* 百 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.hundred;
        break;
      case 3:
        if (perChar !== '0') tmpNewChar = tmpNewChar + /* 千 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.thousand;
        break;
      case 4:
        tmpNewChar = tmpNewChar + /* 万 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.tenThousand;
        break;
      case 5:
        if (perChar !== '0') tmpNewChar = tmpNewChar + /* 十 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.ten;
        break;
      case 6:
        if (perChar !== '0') tmpNewChar = tmpNewChar + /* 百 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.hundred;
        break;
      case 7:
        if (perChar !== '0') tmpNewChar = tmpNewChar + /* 千 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.thousand;
        break;
      case 8:
        tmpNewChar = tmpNewChar + /* 亿 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.billion;
        break;
      case 9:
        tmpNewChar = tmpNewChar + /* 十 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.ten;
        break;
    }
    newChar = tmpNewChar + newChar;
  }
  //替换所有无用汉字，直到没有此类无用的数字为止
  while (newChar.search( /* 零零 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.zeroZero) !== -1 || newChar.search( /* 零亿 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.zero) !== -1 || newChar.search( /* 亿万 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.billions) !== -1 || newChar.search( /* 零万 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.zero) !== -1) {
    newChar = newChar.replace( /* 零亿 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.zero, /* 亿 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.billion);
    newChar = newChar.replace( /* 亿万 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.billions, /* 亿 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.billion);
    newChar = newChar.replace( /* 零万 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.zero, /* 万 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.tenThousand);
    newChar = newChar.replace( /* 零零 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.zeroZero, /* 零 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.zero);
  }
  //替换以“一十”开头的，为“十”
  if (newChar.indexOf( /* 一十 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.ten) === 0) {
    newChar = newChar.substr(1);
  }
  //替换以“零”结尾的，为“”
  if (newChar.lastIndexOf( /* 零 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.zero) === newChar.length - 1) {
    newChar = newChar.substr(0, newChar.length - 1);
  }
  return newChar;
}
export var DEFAULT_KNOWLEDGE = '0';
export var DefaultTemplateView = /*#__PURE__*/React.memo(function (props) {
  var detailInfo = props.detailInfo;
  var qaAnswersList = useMemo(function () {
    if ((detailInfo === null || detailInfo === void 0 ? void 0 : detailInfo.templateId) === DEFAULT_KNOWLEDGE) {
      var attachments = detailInfo.attachments,
        content = detailInfo.content,
        contentId = detailInfo.contentId,
        contentUuid = detailInfo.contentUuid,
        id = detailInfo.id,
        channelManagements = detailInfo.channelManagements,
        attachmentDownload = detailInfo.attachmentDownload,
        contentAnswerShowFlag = detailInfo.contentAnswerShowFlag,
        contentAnswerList = detailInfo.contentAnswerList;
      var defaultAnswer = {
        attachments: attachments,
        content: content,
        contentId: contentId,
        contentUuid: contentUuid,
        id: id,
        channelManagements: channelManagements,
        attachmentDownload: attachmentDownload,
        contentAnswerShowFlag: contentAnswerShowFlag,
        contentAnswerList: contentAnswerList
      };
      return [defaultAnswer].concat(_toConsumableArray(detailInfo.channelContents || []));
    }
    return [];
  }, [detailInfo]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, qaAnswersList.map(function (answer, index) {
    var _answer$channelManage, _answer$attachments;
    return /*#__PURE__*/React.createElement("div", {
      key: index,
      className: "answer-container"
    }, /*#__PURE__*/React.createElement("div", {
      className: "answer-title"
    }, index === 0 ? /* 默认答案 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.defaultAnswer : /* 答案 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.answer + arabia2SimplifiedChinese(index)), /*#__PURE__*/React.createElement("div", {
      className: "qa-detail-data-content-box  udesk-kcs-react-reset-word",
      dangerouslySetInnerHTML: {
        __html: safeHtml((answer === null || answer === void 0 ? void 0 : answer.content) || '', SAFE_HTML_WHITE_LIST)
      }
    }), inspect((_answer$channelManage = answer.channelManagements) === null || _answer$channelManage === void 0 ? void 0 : _answer$channelManage.length, function () {
      var _answer$channelManage2;
      return /*#__PURE__*/React.createElement("div", {
        className: "qa-detail-data-content-channel"
      }, "".concat( /* 知识生效渠道： */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.knowledgeValidationChannels), answer === null || answer === void 0 || (_answer$channelManage2 = answer.channelManagements) === null || _answer$channelManage2 === void 0 ? void 0 : _answer$channelManage2.map(function (channel, index) {
        return /*#__PURE__*/React.createElement(Tag, {
          key: index,
          color: "processing"
        }, channel.name);
      }));
    }), inspect(answer.contentAnswerShowFlag === 1 && answer.contentAnswerList && answer.contentAnswerList.length > 0, function () {
      return /*#__PURE__*/React.createElement("div", {
        className: "qa-detail-data-content-answer-message"
      }, /*#__PURE__*/React.createElement("div", {
        className: "qa-detail-data-content-answer-message-title"
      }, "".concat( /* 一问多答： */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.oneQuestionMultipleAnswers)), answer.contentAnswerList.map(function (an, anIndex) {
        var _an$channelManagement;
        var answerRuleConfig = an.answerRuleConfig,
          content = an.content,
          _an$contentAnswerMess = an.contentAnswerMessageList,
          contentAnswerMessageList = _an$contentAnswerMess === void 0 ? [] : _an$contentAnswerMess;
        var answerMessages = [{
          content: content
        }].concat(_toConsumableArray(contentAnswerMessageList));
        return /*#__PURE__*/React.createElement("div", {
          key: anIndex,
          className: "qa-detail-data-content-answer-message-item"
        }, /*#__PURE__*/React.createElement("div", {
          className: "qa-detail-data-content-answer-message-item-title"
        }, "".concat( /* 规则 */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.rule), arabia2SimplifiedChinese(anIndex + 1), "\uFF1A ", answerRuleConfig.name), inspect((_an$channelManagement = an.channelManagements) === null || _an$channelManagement === void 0 ? void 0 : _an$channelManagement.length, function () {
          var _an$channelManagement2;
          return /*#__PURE__*/React.createElement("div", {
            className: "qa-detail-data-multiple-answers-content-channel"
          }, "".concat( /* 适用机器人： */Locales['current'].kcsTemplateView.components.defaultTemplateView.index.applicableRobots), an === null || an === void 0 || (_an$channelManagement2 = an.channelManagements) === null || _an$channelManagement2 === void 0 ? void 0 : _an$channelManagement2.map(function (channel, index) {
            return /*#__PURE__*/React.createElement(Tag, {
              key: index,
              color: "processing"
            }, channel.name);
          }));
        }), /*#__PURE__*/React.createElement("div", {
          className: "qa-detail-data-content-answer-message-item-content"
        }, answerMessages.map(function (am, index) {
          return /*#__PURE__*/React.createElement("div", {
            key: index,
            className: "qa-detail-data-content-answer-message-item-content-item",
            dangerouslySetInnerHTML: {
              __html: am.content
            }
          });
        })));
      }));
    }), inspect(answer === null || answer === void 0 || (_answer$attachments = answer.attachments) === null || _answer$attachments === void 0 ? void 0 : _answer$attachments.length, function () {
      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", null, Locales['current'].kcsTemplateView.components.defaultTemplateView.index.attachment), /*#__PURE__*/React.createElement(UploadAndMaterial, {
        value: (answer === null || answer === void 0 ? void 0 : answer.attachments) || [],
        hasDownloadBtn: answer === null || answer === void 0 ? void 0 : answer.attachmentDownload,
        isDownload: answer === null || answer === void 0 ? void 0 : answer.attachmentDownload
      }));
    }));
  }));
});