import React from 'react';
import { DeleteOutlined, PaperClipOutlined } from '@ant-design/icons';
import { request } from "../../../utils/fetch";
import { inspect } from "../../../utils/core";
import "./index.less";
import Locales from "../../../locales";
export function downloadTracking(knowledgeBaseId, knowledgeId) {
  return request("/kcsOperationLogs/".concat(knowledgeBaseId, "/download/").concat(knowledgeId), {
    method: 'get'
  });
}
function UploadAndMaterial(props) {
  var value = props.value,
    handleDel = props.handleDel,
    isDownload = props.isDownload,
    hasDownloadBtn = props.hasDownloadBtn,
    notLogged = props.notLogged;
  var changeNum = function changeNum(num) {
    if (num / 1024 > 1024) {
      return "".concat((num / 1024 / 1024).toFixed(2), "MB");
    } else {
      return "".concat((num / 1024).toFixed(2), "KB");
    }
  };
  var tracking = function tracking(attachment) {
    try {
      if (!notLogged) {
        downloadTracking(attachment.knowledgeBaseId, attachment.id);
      }
    } catch (err) {}
  };

  // console.log(value);
  return /*#__PURE__*/React.createElement("div", {
    className: "udesk-kcs-react-upload-list "
  }, (value || []).map(function (attachment) {
    return /*#__PURE__*/React.createElement("div", {
      className: "udesk-kcs-react-upload-list-item ",
      key: attachment.uid
    }, /*#__PURE__*/React.createElement("div", {
      className: "udesk-kcs-react-upload-list-item-info"
    }, /*#__PURE__*/React.createElement("div", {
      className: "udesk-kcs-react-upload-list-item-info-box"
    }, /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement(PaperClipOutlined, {
      style: {
        color: '#6A737B',
        marginRight: 8
      }
    })), /*#__PURE__*/React.createElement("div", {
      className: "udesk-kcs-react-upload-list-item-info-content"
    }, inspect(!isDownload, function () {
      return /*#__PURE__*/React.createElement("span", {
        className: "udesk-kcs-react-upload-list-item-name udesk-kcs-react-only-ellipsis",
        title: attachment.name
      }, attachment.name);
    }, function () {
      return /*#__PURE__*/React.createElement("a", {
        rel: "noopener noreferrer",
        className: "udesk-kcs-react-upload-list-item-name udesk-kcs-react-only-ellipsis",
        title: attachment.name,
        href: "".concat(attachment.encodingUrl || attachment.url, "?response-content-type=application/octet-stream")
      }, attachment.name);
    }), /*#__PURE__*/React.createElement("span", null, "(".concat(changeNum(attachment.size || 0), ")")))), /*#__PURE__*/React.createElement("div", {
      className: "udesk-kcs-react-upload-list-item-info-action"
    }, inspect(hasDownloadBtn, function () {
      return /*#__PURE__*/React.createElement("a", {
        key: attachment.id,
        className: "file-item",
        download: attachment.name,
        onClick: function onClick() {
          return tracking(attachment);
        },
        href: "".concat(attachment.encodingUrl || attachment.url, "?response-content-type=application/octet-stream")
      }, /* 下载 */Locales['current'].kcsTemplateView.components.fileShowList.index.download);
    }), inspect(typeof handleDel === 'function', function () {
      var _handleDel$bind;
      return /*#__PURE__*/React.createElement(DeleteOutlined, {
        className: "udesk-kcs-react-anticon-close",
        onClick: handleDel === null || handleDel === void 0 || (_handleDel$bind = handleDel.bind) === null || _handleDel$bind === void 0 ? void 0 : _handleDel$bind.call(handleDel, null, attachment)
      });
    }))));
  }));
}
UploadAndMaterial.defaultProps = {
  isDownload: true,
  hasDownloadBtn: false
};
export default UploadAndMaterial;