function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useState, useEffect } from 'react';
import { Row, Col, Tag, Image } from 'antd';
import { inspect } from "../../../utils/core";
import "./index.less";
import Locales from "../../../locales";
export var formFieldTypes = /*#__PURE__*/function (formFieldTypes) {
  formFieldTypes["input"] = "SINGLE_TEXT";
  formFieldTypes["select"] = "DROP_LIST";
  formFieldTypes["date"] = "DATE";
  formFieldTypes["time"] = "TIME";
  formFieldTypes["dateAndTime"] = "DATETIME";
  formFieldTypes["number"] = "NUMERIC";
  formFieldTypes["int"] = "INTEGER";
  formFieldTypes["link"] = "LINK";
  formFieldTypes["cascade"] = "CHAINED_DROP_LIST";
  formFieldTypes["radio"] = "RADIO";
  formFieldTypes["checkbox"] = "CHECKBOX";
  formFieldTypes["textarea"] = "MULTIPLE_TEXT";
  formFieldTypes["richText"] = "RICH_TEXT";
  formFieldTypes["image"] = "IMAGE";
  formFieldTypes["video"] = "VIDEO";
  formFieldTypes["attachment"] = "ATTACHMENT";
  formFieldTypes["multipleSelect"] = "MULTIPLE_SELECT";
  formFieldTypes["treeSelect"] = "TREE_SELECT";
  formFieldTypes["radioSelect"] = "RADIO_SELECT";
  formFieldTypes["tag"] = "TAG";
  return formFieldTypes;
}({});
export var knowledgeTemplateDateTypes = /*#__PURE__*/function (knowledgeTemplateDateTypes) {
  knowledgeTemplateDateTypes["date"] = "date";
  knowledgeTemplateDateTypes["range"] = "range";
  return knowledgeTemplateDateTypes;
}({});
export var tagColor = ['magenta', 'red', 'volcano', 'orange', 'gold', 'lime', 'green', 'cyan', 'blue', 'geekblue', 'purple'];
var NOT_DISPLAY = ['viewPermissionDto', 'managePermissionDto', 'categoryIds'];
function KnowledgeTemplateInfo(props) {
  var styleInfo = props.styleInfo,
    detailInfo = props.detailInfo;
  var _useState = useState([]),
    _useState2 = _slicedToArray(_useState, 2),
    showList = _useState2[0],
    setShowList = _useState2[1];
  var changeNum = function changeNum(num) {
    if (num / 1024 > 1024) {
      return "".concat((num / 1024 / 1024).toFixed(2), "MB");
    } else {
      return "".concat((num / 1024).toFixed(2), "KB");
    }
  };
  var onPreview = function onPreview(item) {
    var curr = item.name && item.name.split('.');
    var type = curr[curr.length - 1];
    if (type === 'jpg' || type === 'jpeg' || type === 'png' || type === 'gif' || type === 'svg' || type === 'bmp' || type === 'ico') {
      window.open(item.url, '_blank');
    } else {
      window.open(item.previewUrl, '_blank');
    }
  };
  useEffect(function () {
    if (styleInfo && detailInfo) {
      var newList = [];
      styleInfo.forEach(function (el) {
        var currExtra = el.extra || '{}';
        if (el.apiName === 'availableTime' && (!detailInfo.startTime || detailInfo.startTime === '')) {
          return;
        }
        if (typeof currExtra === 'string') {
          currExtra = JSON.parse(currExtra);
        }
        el.extra = currExtra;
        if (detailInfo.knowledgeItemTemplateDTOS && detailInfo.knowledgeItemTemplateDTOS.length) {
          detailInfo.knowledgeItemTemplateDTOS.forEach(function (item) {
            if (item.id === el.id) {
              el.value = item.value;
            }
          });
        }
        if (el.apiName === 'name') {
          el.value = detailInfo.name || '';
        } else if (el.apiName === 'tagIds') {
          el.value = detailInfo.tags && detailInfo.tags.map(function (curr) {
            return curr.tagName;
          }) || [];
          el.list = detailInfo.tags;
          el.type = formFieldTypes.tag;
        } else if (detailInfo.startTime && detailInfo.startTime !== '' && el.apiName === 'availableTime') {
          el.value = [detailInfo.startTime, detailInfo.endTime];
        }
        if (!NOT_DISPLAY.includes(el.apiName)) {
          newList.push(el);
        }
      });
      setShowList(newList);
    }
  }, [styleInfo, detailInfo]);
  return /*#__PURE__*/React.createElement("div", {
    className: "udesk-kcs-react-knowledge-template-info-show"
  }, showList.map(function (el) {
    return /*#__PURE__*/React.createElement(Row, {
      key: el.id
    }, /*#__PURE__*/React.createElement(Col, {
      span: 24
    }, /*#__PURE__*/React.createElement("div", {
      className: "knowledge-template-info-tar content-common"
    }, el.name)), /*#__PURE__*/React.createElement(Col, {
      span: 24
    }, /*#__PURE__*/React.createElement("div", {
      className: "knowledge-template-info-content content-common"
    }, inspect(el.type === formFieldTypes.richText, function () {
      return /*#__PURE__*/React.createElement("div", {
        className: "richText-container",
        dangerouslySetInnerHTML: {
          __html: el.value
        }
      });
    }), inspect(el.type === formFieldTypes.link, function () {
      return /*#__PURE__*/React.createElement("a", {
        href: el.value,
        target: "_blank",
        rel: "noreferrer"
      }, el.value);
    }), inspect((el.type === formFieldTypes.video || el.type === formFieldTypes.attachment) && (el.value || []).length > 0, function () {
      var _el$value;
      return /*#__PURE__*/React.createElement("div", {
        className: "data-file-box"
      }, (_el$value = el.value) === null || _el$value === void 0 ? void 0 : _el$value.map(function (item, index) {
        return /*#__PURE__*/React.createElement("div", {
          key: index,
          className: "file-item-box"
        }, /*#__PURE__*/React.createElement("div", {
          className: "file-item-content"
        }, inspect(detailInfo.attachmentDownload, function () {
          return /*#__PURE__*/React.createElement("a", {
            key: index,
            title: item.name,
            className: "file-item",
            download: item.name,
            href: "".concat(item.encodingUrl || item.url, "?response-content-type=application/octet-stream")
          }, item.name);
        }, function () {
          return item.name;
        }), /*#__PURE__*/React.createElement("span", null, "(".concat(changeNum(item.size), ")"))), inspect(detailInfo.attachmentDownload, function () {
          return /*#__PURE__*/React.createElement("a", {
            key: index,
            className: "file-item",
            download: item.name,
            href: "".concat(item.encodingUrl || item.url, "?response-content-type=application/octet-stream")
          }, /* 下载 */Locales['current'].kcsTemplateView.components.templateView.index.download);
        }));
      }));
    }), inspect(el.type === formFieldTypes.image, function () {
      return /*#__PURE__*/React.createElement("div", {
        className: "img-container"
      }, (el.value || []).map(function (curr) {
        return /*#__PURE__*/React.createElement(Image, {
          src: curr.encodingUrl || curr.url,
          key: curr.uid,
          title: curr.name,
          alt: curr.name
        });
      }));
    }), inspect(el.type === formFieldTypes.cascade, function () {
      return (el.value || []).map(function (curr, idx) {
        return /*#__PURE__*/React.createElement("span", {
          key: curr.value
        }, curr, el.value && el.value.length && idx === el.value.length - 1 ? '' : '/');
      });
    }), inspect(el.type === formFieldTypes.date, function () {
      return /*#__PURE__*/React.createElement(React.Fragment, null, inspect(el.extra && el.extra.dateType === knowledgeTemplateDateTypes.range && el.value && el.value.length && el.value.length === 2, function () {
        return /*#__PURE__*/React.createElement("span", null, el.value[0], " - ", el.value[1]);
      }), inspect(el.extra && el.extra.dateType === knowledgeTemplateDateTypes.date, function () {
        return /*#__PURE__*/React.createElement("span", null, el.value);
      }));
    }), inspect(el.type === formFieldTypes.tag, function () {
      var _el$list;
      return el === null || el === void 0 || (_el$list = el.list) === null || _el$list === void 0 ? void 0 : _el$list.map(function (item, i) {
        return /*#__PURE__*/React.createElement(Tag, {
          key: i,
          color: tagColor[i % tagColor.length]
        }, item.tagName);
      });
    }), inspect(![formFieldTypes.richText, formFieldTypes.link, formFieldTypes.video, formFieldTypes.image, formFieldTypes.cascade, formFieldTypes.date, formFieldTypes.tag, formFieldTypes.attachment].includes(el.type), function () {
      return /*#__PURE__*/React.createElement(React.Fragment, null, inspect(Array.isArray(el === null || el === void 0 ? void 0 : el.value), function () {
        var _el$value2;
        return /*#__PURE__*/React.createElement("div", null, el === null || el === void 0 || (_el$value2 = el.value) === null || _el$value2 === void 0 ? void 0 : _el$value2.join(','));
      }, function () {
        return /*#__PURE__*/React.createElement("div", null, el.value);
      }));
    }))));
  }));
}
export default KnowledgeTemplateInfo;