import React, { useMemo } from 'react';
import { useRouteContext } from "../../context/route";
import { routeMap } from "../../routes/routeMap";
import Loading from "../../../Loading";
import { ErrorPage } from "./components/ErrorPage";
var DynamicRouting = function DynamicRouting(_ref) {
  var loadingToken = _ref.loadingToken,
    hasError = _ref.hasError;
  var _useRouteContext = useRouteContext(),
    currentRoute = _useRouteContext.currentRoute;
  var Component = useMemo(function () {
    return routeMap[currentRoute.routeName];
  }, [currentRoute]);
  if (!Component) return null;
  if (hasError) return /*#__PURE__*/React.createElement(ErrorPage, null);
  if (loadingToken) return /*#__PURE__*/React.createElement(Loading, null);
  return /*#__PURE__*/React.createElement(Component, null);
};
export default DynamicRouting;