function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
import React, { useMemo } from 'react';
import History from "../../../History";
import { useChatHistoryContext } from "../../context/chatHistory";
export var SESSION = 'session';
export var APPLICATION = 'application';
var HistoryTop10 = function HistoryTop10(_ref) {
  var close = _ref.close;
  var _useChatHistoryContex = useChatHistoryContext(),
    session = _useChatHistoryContex.session,
    application = _useChatHistoryContex.application;
  var list = useMemo(function () {
    var _session$map, _session$map2, _application$map, _application$map2;
    var _session = (_session$map = session === null || session === void 0 || (_session$map2 = session.map) === null || _session$map2 === void 0 ? void 0 : _session$map2.call(session, function (i) {
      return {
        id: i.id,
        name: i.showTitle,
        time: i.updateTime,
        type: SESSION,
        answer: ''
      };
    })) !== null && _session$map !== void 0 ? _session$map : [];
    var _application = (_application$map = application === null || application === void 0 || (_application$map2 = application.map) === null || _application$map2 === void 0 ? void 0 : _application$map2.call(application, function (i) {
      return {
        id: i.applicationId,
        name: i.applicationName,
        time: i.createTime,
        type: APPLICATION,
        answer: i.answer
      };
    })) !== null && _application$map !== void 0 ? _application$map : [];
    return [].concat(_toConsumableArray(_application), _toConsumableArray(_session));
  }, [session, application]);
  return /*#__PURE__*/React.createElement(History, {
    list: list,
    afterClick: close
  });
};
export default HistoryTop10;