// import { Bars3Icon } from '@heroicons/react/24/outline';
import { MenuOutlined } from '@ant-design/icons';
import { Button } from 'antd';
import classNames from 'classnames';
import React from 'react';
import { useRouteContext } from "../../context/route";
import Locales from "../../../locales";
var Navbar = function Navbar(props) {
  var _useRouteContext = useRouteContext(),
    isHome = _useRouteContext.isHome,
    pop = _useRouteContext.pop;
  return /*#__PURE__*/React.createElement("nav", {
    className: classNames({
      'bg-white text-zinc-500': true,
      // colors
      'flex items-center': true,
      // layout
      'w-full fixed z-10 px-4 shadow-sm h-16': true,
      //positioning & styling
      'md:hidden': true //positioning & styling
    })
  }, /*#__PURE__*/React.createElement("div", {
    className: "font-bold text-lg",
    onClick: function onClick() {
      return pop();
    }
  }, isHome() ? /* LLM问答 */Locales['current'].llm.components.navbar.index.lLMQA : /* LLM问答 */Locales['current'].llm.components.navbar.index.lLMQA), /*#__PURE__*/React.createElement("div", {
    className: "flex-grow"
  }), /*#__PURE__*/React.createElement(Button, {
    type: "text",
    className: "md:hidden",
    onClick: props.onMenuButtonClick
  }, /*#__PURE__*/React.createElement(MenuOutlined, null)));
};
export default Navbar;