import { Button } from 'antd';
import classNames from 'classnames';
import React, { useRef } from 'react';
import styled from 'styled-components';
import { useRouteContext } from "../../context/route";
import { AppConfigRouteName, AppManagementRouteName, HistoryRouteName } from "../../routes/routeMap";
import { inspect } from "../../../utils/core";
import { useSdkOptionsContext } from "../../../utils/fetch/context";
import { isOperator } from "../../../utils/operator";
import { useOnClickOutside } from 'usehooks-ts';
import HistoryTop10 from "../HistoryTop10";
import Locales from "../../../locales";
var HistoryWrap = styled.div.withConfig({
  displayName: "HistoryWrap",
  componentId: "udesk-llm-fe__sc-lpyqgb-0"
})([".history-item{cursor:pointer;&:hover{background-color:#0000000a;}}"]);

// add NavItem prop to component prop

var Sidebar = function Sidebar(_ref) {
  var open = _ref.open,
    setOpen = _ref.setOpen,
    loadingToken = _ref.loadingToken;
  var ref = useRef(null);
  var _useRouteContext = useRouteContext(),
    push = _useRouteContext.push;
  useOnClickOutside(ref, function () {
    setOpen(false);
  });
  var close = function close() {
    return setOpen(false);
  };
  var createApp = function createApp() {
    push(AppConfigRouteName);
    close();
  };
  var gotoAppManagement = function gotoAppManagement() {
    push(AppManagementRouteName);
    close();
  };
  var gotoHistory = function gotoHistory() {
    push(HistoryRouteName);
    close();
  };
  // const gotoClassifysManagement = () => {
  //   push(ClassifysManagementRouteName);
  // };
  var _useSdkOptionsContext = useSdkOptionsContext(),
    wrapHeight = _useSdkOptionsContext.wrapHeight;
  if (loadingToken) return null;
  return /*#__PURE__*/React.createElement("div", {
    className: classNames({
      'flex flex-col justify-between': true,
      // layout
      'bg-indigo-700 text-zinc-50': true,
      // colors
      'bg-[#f7f7f7] border': true,
      // colors
      'md:w-full md:sticky md:top-16 md:z-0 top-0 z-20 fixed': true,
      // positioning
      'md:h-[calc(100vh)] h-full w-[300px]': true,
      // for height and width
      'transition-transform .3s ease-in-out md:-translate-x-0': true,
      //animations
      '-translate-x-full ': !open,
      //hide sidebar to the left when closed
      'shadow-lg': open
    }),
    ref: ref,
    style: Object.assign({
      borderRight: '1px solid #e4e7e7'
    }, wrapHeight ? {
      minHeight: wrapHeight
    } : undefined)
  }, /*#__PURE__*/React.createElement("nav", {
    className: "md:sticky top-0 flex-1 bg-[#f7f7f7] flex-col flex overflow-auto"
  }, /*#__PURE__*/React.createElement("div", {
    className: "flex p-3 bg-white",
    style: {
      borderBottom: '1px solid #e4e7e7'
    }
  }, /*#__PURE__*/React.createElement(Button, {
    onClick: createApp,
    block: true,
    className: classNames({
      'cursor-pointer w-[120px] h-[60px] flex-1 ': true,
      'bg-[#f5f5f5] hover:bg-[#f0f0f0] focus:bg-[#f0f0f0]': true,
      'text-slate-800 hover:text-slate-800 focus:text-slate-800': true,
      'rounded-xl border-none': true
    })
  }, Locales['current'].llm.components.sideBar.index.createANewApplication), inspect(isOperator, function () {
    return /*#__PURE__*/React.createElement(Button, {
      onClick: gotoAppManagement,
      block: true,
      className: classNames({
        'cursor-pointer w-[120px] h-[60px] flex-1 ml-2': true,
        'bg-[#f5f5f5] hover:bg-[#f0f0f0] focus:bg-[#f0f0f0]': true,
        'text-slate-800 hover:text-slate-800 focus:text-slate-800': true,
        'rounded-xl border-none': true
      })
    }, Locales['current'].llm.components.sideBar.index.applicationManagement);
  }, function () {
    return null;
  })), /*#__PURE__*/React.createElement(HistoryWrap, {
    className: "pb-2 flex flex-col gap-2 flex-1 bg-white overflow-auto"
  }, /*#__PURE__*/React.createElement(HistoryTop10, {
    close: close
  }), /*#__PURE__*/React.createElement(Button, {
    onClick: gotoHistory,
    block: true,
    type: "primary",
    className: "opacity-70 hover:opacity-80 rounded-xl border-none py-2",
    size: "large",
    style: {
      fontSize: '12px',
      display: 'flex',
      justifyContent: 'center',
      alignItems: 'center',
      margin: '8px auto 0',
      backgroundColor: '#3b3abe',
      width: 'calc(100% - 32px)'
    }
  }, Locales['current'].llm.components.sideBar.index.viewAllHistory, /*#__PURE__*/React.createElement("svg", {
    viewBox: "0 0 24 24",
    xmlns: "http://www.w3.org/2000/svg",
    style: {
      marginLeft: '2px'
    },
    className: "h-[12px] w-[12px] lin"
  }, /*#__PURE__*/React.createElement("path", {
    fill: "currentColor",
    d: "M8.38 21.5c.26 0 .51-.1.71-.29l8.5-8.5a.996.996 0 0 0 0-1.41l-8.5-8.5a.996.996 0 1 0-1.41 1.41L15.46 12l-7.79 7.8a.996.996 0 0 0 0 1.41c.2.19.45.29.71.29Z"
  }))))));
};
export default Sidebar;