import React from 'react';
interface IRoute {
    currentRoute: IRouteItem | null;
    pop: () => string | undefined;
    push: (routeName: string, params?: {
        [key: string]: any;
    }) => void;
    isHome: () => boolean;
    updateCurrentRoute: (callback: (route: IRouteItem | null, save?: () => void) => void) => void;
}
export interface IRouteItem {
    routeName: string;
    params?: {
        [key: string]: any;
    };
}
type IUseRouteArgs = {
    defaultHomeRouteName?: string;
    onRouteChange?: () => void;
};
type IUseRoute = (args?: IUseRouteArgs) => IRoute;
export declare const useRoute: IUseRoute;
export declare const Context: React.Context<IRoute | undefined>;
export declare const RouteProvider: React.FC<{
    value: IRoute;
    children: any;
}>;
export declare const useRouteContext: () => IRoute;
export {};
