function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import React, { useState } from 'react';
import { HomeRouteName } from "../../routes/routeMap";
import { shallow } from "./utiles";
var HISTORY_KEY = '__udesk_llm_routes';
var Route = /*#__PURE__*/_createClass(function Route() {
  var _this = this;
  _classCallCheck(this, Route);
  _defineProperty(this, "stack", []);
  _defineProperty(this, "getCurrentRoute", function () {
    return _this.stack.length ? _this.stack[_this.stack.length - 1] : null;
  });
  _defineProperty(this, "getRoutesLength", function () {
    return _this.stack.length;
  });
  _defineProperty(this, "pop", function () {
    if (_this.stack.length <= 1) return;
    var res = _this.stack.pop();
    _this.save();
    return res;
  });
  _defineProperty(this, "push", function (route) {
    _this.stack.push(route);
    _this.save();
  });
  _defineProperty(this, "save", function () {
    sessionStorage.setItem(HISTORY_KEY, JSON.stringify(_this.getHistory()));
  });
  _defineProperty(this, "getHistory", function () {
    return _this.stack;
  });
  var lastHistoryString = sessionStorage.getItem(HISTORY_KEY);
  var lastHistory = lastHistoryString ? JSON.parse(lastHistoryString) : null;
  if (lastHistory) {
    this.stack = lastHistory;
  }
});
export var useRoute = function useRoute() {
  var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
    _ref$defaultHomeRoute = _ref.defaultHomeRouteName,
    defaultHomeRouteName = _ref$defaultHomeRoute === void 0 ? HomeRouteName : _ref$defaultHomeRoute,
    onRouteChange = _ref.onRouteChange;
  var _useState = useState(function () {
      var r = new Route();
      if (!r.getCurrentRoute()) {
        r.push({
          routeName: defaultHomeRouteName
        });
      }
      return r;
    }),
    _useState2 = _slicedToArray(_useState, 1),
    route = _useState2[0];
  var _useState3 = useState(route.getCurrentRoute()),
    _useState4 = _slicedToArray(_useState3, 2),
    currentRoute = _useState4[0],
    setCurrentRoute = _useState4[1];
  var _onRouteChange = function _onRouteChange() {
    onRouteChange === null || onRouteChange === void 0 || onRouteChange();
    setCurrentRoute(route.getCurrentRoute());
  };
  var push = function push(routeName, params) {
    var newRouter = {
      routeName: routeName,
      params: params
    };
    var topRouter = route.getCurrentRoute();
    if (newRouter.routeName !== (topRouter === null || topRouter === void 0 ? void 0 : topRouter.routeName) || !shallow(newRouter.params, topRouter === null || topRouter === void 0 ? void 0 : topRouter.params)) {
      route.push(newRouter);
      _onRouteChange();
    }
  };
  var pop = function pop() {
    var res = route.pop();
    _onRouteChange();
    return res === null || res === void 0 ? void 0 : res.routeName;
  };
  var isHome = function isHome() {
    return (currentRoute === null || currentRoute === void 0 ? void 0 : currentRoute.routeName) === defaultHomeRouteName;
  };
  var updateCurrentRoute = function updateCurrentRoute(callback) {
    callback(route.getCurrentRoute(), route.save);
  };
  return {
    currentRoute: currentRoute,
    push: push,
    pop: pop,
    isHome: isHome,
    updateCurrentRoute: updateCurrentRoute
  };
};
export var Context = /*#__PURE__*/React.createContext(undefined);
export var RouteProvider = function RouteProvider(_ref2) {
  var children = _ref2.children,
    value = _ref2.value;
  return /*#__PURE__*/React.createElement(Context.Provider, {
    value: value
  }, children);
};
export var useRouteContext = function useRouteContext() {
  var context = React.useContext(Context);
  if (context === undefined) {
    throw new Error('useRouteContext must be used within a RouteProvider');
  }
  return context;
};