var _excluded = ["inline", "className", "children"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useEffect, useMemo } from 'react';
import ReactMarkdown from 'react-markdown';
import { Prism as SyntaxHighlighter } from 'react-syntax-highlighter';
import rehypeRaw from 'rehype-raw';
import remarkGfm from 'remark-gfm';
import { useAutoDisplay } from "../Text";
var ReactMark = function ReactMark(_ref) {
  var _text$replace;
  var content = _ref.content,
    onTextRunning = _ref.onTextRunning,
    onTextAnimationPlaying = _ref.onTextAnimationPlaying,
    _ref$closeTextAnimati = _ref.closeTextAnimation,
    closeTextAnimation = _ref$closeTextAnimati === void 0 ? false : _ref$closeTextAnimati;
  var _useAutoDisplay = useAutoDisplay(closeTextAnimation, onTextAnimationPlaying),
    text = _useAutoDisplay.text,
    update = _useAutoDisplay.update,
    isRunning = _useAutoDisplay.isRunning;
  useEffect(function () {
    update(content);
  }, [content]);
  useEffect(function () {
    onTextRunning === null || onTextRunning === void 0 || onTextRunning(isRunning);
  }, [isRunning]);
  var components = useMemo(function () {
    return {
      code: function code(_ref2) {
        var inline = _ref2.inline,
          className = _ref2.className,
          children = _ref2.children,
          props = _objectWithoutProperties(_ref2, _excluded);
        var match = /language-(\w+)/.exec(className || '');
        return !inline && match ? /*#__PURE__*/React.createElement(SyntaxHighlighter, _extends({}, props, {
          language: match[1],
          PreTag: "div"
        }), String(children).replace(/\n$/, '')) : /*#__PURE__*/React.createElement("code", _extends({}, props, {
          className: className
        }), children);
      }
    };
  }, []);
  return /*#__PURE__*/React.createElement(ReactMarkdown, {
    remarkPlugins: [remarkGfm],
    rehypePlugins: [rehypeRaw],
    components: components
  }, text === null || text === void 0 || (_text$replace = text.replace(/\\a/gi, '&#7;')) === null || _text$replace === void 0 || (_text$replace = _text$replace.replace(/\\b/gi, '&#8;')) === null || _text$replace === void 0 || (_text$replace = _text$replace.replace(/\\t/gi, '&#9;')) === null || _text$replace === void 0 || (_text$replace = _text$replace.replace(/\\n/gi, '&#10;')) === null || _text$replace === void 0 || (_text$replace = _text$replace.replace(/\\v/gi, '&#11;')) === null || _text$replace === void 0 || (_text$replace = _text$replace.replace(/\\f/gi, '&#12;')) === null || _text$replace === void 0 ? void 0 : _text$replace.replace(/\\r/gi, '&#13;'));
};
export default ReactMark;