function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { Popconfirm as PopconfirmAntd } from 'antd';
import React, { useMemo, useState } from 'react';
import { Dialog } from 'react-vant';
import { useSdkOptionsContext } from "../utils/fetch/context";
import { useScreen } from 'usehooks-ts';
var usePopconfirm = function usePopconfirm() {
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    visible = _useState2[0],
    setVisible = _useState2[1];
  var open = function open() {
    return setVisible(true);
  };
  var close = function close() {
    return setVisible(false);
  };
  return {
    visible: visible,
    open: open,
    close: close
  };
};
var Popconfirm = function Popconfirm(_ref) {
  var _screen$width;
  var children = _ref.children,
    onConfirm = _ref.onConfirm,
    title = _ref.title,
    cancelText = _ref.cancelText,
    okText = _ref.okText;
  var screen = useScreen();
  var _usePopconfirm = usePopconfirm(),
    visible = _usePopconfirm.visible,
    close = _usePopconfirm.close,
    open = _usePopconfirm.open;
  var btn = useMemo(function () {
    return /*#__PURE__*/React.cloneElement(children, {
      onClick: open
    });
  }, [children]);
  var _onConfirm = function _onConfirm() {
    onConfirm === null || onConfirm === void 0 || onConfirm();
    close === null || close === void 0 || close();
  };
  var sdkOptions = useSdkOptionsContext();
  return /*#__PURE__*/React.createElement(React.Fragment, null, ((_screen$width = screen === null || screen === void 0 ? void 0 : screen.width) !== null && _screen$width !== void 0 ? _screen$width : 0) < 768 || !!sdkOptions._container ? /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Dialog, {
    visible: visible,
    showCancelButton: true,
    cancelButtonText: cancelText,
    confirmButtonText: okText,
    onConfirm: _onConfirm,
    onCancel: close,
    teleport: function teleport() {
      return sdkOptions._container || document.body;
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "p-4"
  }, title)), btn) : /*#__PURE__*/React.createElement(PopconfirmAntd, {
    title: title,
    onConfirm: _onConfirm,
    onCancel: close,
    okText: okText,
    cancelText: cancelText,
    okButtonProps: {
      danger: true
    },
    visible: visible
  }, btn));
};
export { Popconfirm };