var _excluded = ["setFeedbackType", "menu", "children", "disabled"];
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { useClick } from '@szhsin/react-menu';
import '@szhsin/react-menu/dist/index.css';
import '@szhsin/react-menu/dist/transitions/slide.css';
import { Space } from 'antd';
import React, { useMemo, useRef, useState } from 'react';
import { Popconfirm } from "../Popconfirm";
import { fire, inspect } from "../utils/core";
import styled from 'styled-components';
var FlexDiv = styled.div.withConfig({
  displayName: "FlexDiv",
  componentId: "udesk-llm-fe__sc-1651maj-0"
})(["display:flex;border-top:1px solid #eee;"]);
var PopupBatchedActions = function PopupBatchedActions(props) {
  var setFeedbackType = props.setFeedbackType,
    _props$menu = props.menu,
    menuProps = _props$menu === void 0 ? [] : _props$menu,
    children = props.children,
    disabled = props.disabled,
    node = _objectWithoutProperties(props, _excluded);
  var ref = useRef(null);
  var _useState = useState(false),
    _useState2 = _slicedToArray(_useState, 2),
    isOpen = _useState2[0],
    setOpen = _useState2[1];
  var anchorProps = useClick(isOpen, setOpen);
  var _useState3 = useState(false),
    _useState4 = _slicedToArray(_useState3, 2),
    dislikeBtn = _useState4[0],
    setDislikeBtn = _useState4[1];
  var _useState5 = useState(false),
    _useState6 = _slicedToArray(_useState5, 2),
    likeBtn = _useState6[0],
    setLikeBtn = _useState6[1];
  var _useState7 = useState(''),
    _useState8 = _slicedToArray(_useState7, 2),
    activeBtn = _useState8[0],
    setActiveBtn = _useState8[1];
  var handleFeedback = function handleFeedback(item) {
    var operateArr = ['like', 'dislike'];
    if (operateArr.includes(item.label)) {
      if (!activeBtn) {
        setActiveBtn(item.label);
      }
    }
    return item.onClick();
  };
  var menu = useMemo(function () {
    return menuProps.map(function (item) {
      var disabled = fire(item.disabled, node);
      return /*#__PURE__*/React.createElement("div", {
        style: {
          padding: '12px'
        }
      }, inspect(!item.danger, function () {
        return /*#__PURE__*/React.createElement(Space, {
          onClick: handleFeedback.bind(null, item),
          style: {
            width: '100%',
            cursor: 'pointer',
            color: item.label === 'like' && activeBtn === 'like' ? '#2687f0' : 'black'
          }
        }, /*#__PURE__*/React.createElement("span", null, item === null || item === void 0 ? void 0 : item.icon));
      }, function () {
        if (item.feedback) {
          return /*#__PURE__*/React.createElement(Space, {
            onClick: handleFeedback.bind(null, item),
            style: {
              width: '100%',
              cursor: 'pointer',
              color: activeBtn === 'dislike' ? '#2687f0' : 'black'
            }
          }, /*#__PURE__*/React.createElement("span", null, item === null || item === void 0 ? void 0 : item.icon));
        } else {
          return /*#__PURE__*/React.createElement(Popconfirm, {
            title: "\u786E\u8BA4\u8981\u5220\u9664\u5417\uFF1F",
            onConfirm: item.onClick,
            okText: "\u5220\u9664",
            cancelText: "\u53D6\u6D88",
            okButtonProps: {
              danger: true
            }
          }, /*#__PURE__*/React.createElement(Space
          // onClick={(e) => e.stopPropagation()}
          , {
            style: {
              color: item.danger ? '#ff4d4f' : 'rgba(0, 0, 0, 0.85)',
              width: '100%',
              cursor: 'pointer'
            }
          }, /*#__PURE__*/React.createElement("span", null, item === null || item === void 0 ? void 0 : item.icon)));
        }
      }));
    });
  }, [menuProps, node]);
  if (!menu.length) {
    return null;
  }
  return /*#__PURE__*/React.createElement(FlexDiv, null, menu);
};
export default PopupBatchedActions;