function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useLayoutEffect, useState } from 'react';
import { createPortal } from 'react-dom';
import { StyleSheetManager } from 'styled-components';
function createLink(href, onload, append) {
  var _link = document.createElement('link');
  _link.rel = 'stylesheet';
  _link.type = 'text/css';
  _link.href = href;
  _link.onload = onload;
  append(_link);
}
function createStyle(innerHTML, append) {
  var _style = document.createElement('style');
  _style.innerHTML = innerHTML;
  append(_style);
}
var STYLE_TAG = 'STYLE';
var LINK_TAG = 'LINK';
var STYLE_TAG_NAMES = [STYLE_TAG, LINK_TAG];
function RenderToIframe(_ref) {
  var _ref$contentDocument, _ref$contentDocument5;
  var children = _ref.children;
  var _useState = useState(),
    _useState2 = _slicedToArray(_useState, 2),
    ref = _useState2[0],
    setRef = _useState2[1];
  var _useState3 = useState(true),
    _useState4 = _slicedToArray(_useState3, 2),
    intial = _useState4[0],
    setIntial = _useState4[1];
  var container = ref === null || ref === void 0 || (_ref$contentDocument = ref.contentDocument) === null || _ref$contentDocument === void 0 ? void 0 : _ref$contentDocument.body;
  useLayoutEffect(function () {
    var _ref$contentDocument2;
    if (container) {
      container.style.overflowX = 'hidden';
      ref.contentWindow.document.getElementsByTagName("html")[0].style.fontSize = '14px';
    }
    var styleOrLinkList = Array.from(document.head.childNodes).filter(function (tag) {
      return STYLE_TAG_NAMES.includes(tag.nodeName);
    }); // 获取父窗口 link 标签对象列表
    var linksLoaded = [];
    var _loop = function _loop() {
      if (styleOrLinkList[i].nodeName === STYLE_TAG) {
        createStyle(styleOrLinkList[i].innerHTML, function (_link) {
          var _ref$contentDocument3;
          return ref === null || ref === void 0 || (_ref$contentDocument3 = ref.contentDocument) === null || _ref$contentDocument3 === void 0 ? void 0 : _ref$contentDocument3.head.appendChild(_link);
        });
      } else if (styleOrLinkList[i].nodeName === LINK_TAG) {
        var resolve = null;
        linksLoaded.push(new Promise(function (res) {
          resolve = res;
        }));
        createLink(styleOrLinkList[i].href, function () {
          return resolve();
        }, function (_link) {
          var _ref$contentDocument4;
          return ref === null || ref === void 0 || (_ref$contentDocument4 = ref.contentDocument) === null || _ref$contentDocument4 === void 0 ? void 0 : _ref$contentDocument4.head.appendChild(_link);
        });
      }
    };
    for (var i = 0; i < styleOrLinkList.length; i++) {
      _loop();
    }
    if (ref !== null && ref !== void 0 && (_ref$contentDocument2 = ref.contentDocument) !== null && _ref$contentDocument2 !== void 0 && _ref$contentDocument2.head) {
      Promise.all(linksLoaded).then(function () {
        setIntial(false);
      });
    }
  }, [ref]);
  return /*#__PURE__*/React.createElement(StyleSheetManager, {
    target: ref === null || ref === void 0 || (_ref$contentDocument5 = ref.contentDocument) === null || _ref$contentDocument5 === void 0 ? void 0 : _ref$contentDocument5.head
  }, /*#__PURE__*/React.createElement("iframe", {
    title: "iframe",
    ref: setRef,
    style: {
      width: '100%',
      height: '100%',
      border: 'none'
    },
    allow: "clipboard-read; clipboard-write"
  }, !intial && container && /*#__PURE__*/createPortal( /*#__PURE__*/React.cloneElement(children, {
    _container: container
  }), container)));
}
export default RenderToIframe;