function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { DownOutlined } from '@ant-design/icons';
import { Combobox, Transition } from '@headlessui/react';
import { Empty } from 'antd';
import React, { Fragment, useRef, useState } from 'react';
import { useSdkOptionsContext } from "../utils/fetch/context";
export default function Select(_ref) {
  var options = _ref.options,
    value = _ref.value,
    _onChange = _ref.onChange;
  var _useSdkOptionsContext = useSdkOptionsContext(),
    antPrefixCls = _useSdkOptionsContext.antPrefixCls;
  var _useState = useState(''),
    _useState2 = _slicedToArray(_useState, 2),
    query = _useState2[0],
    setQuery = _useState2[1];
  var refButton = useRef(null);
  var filteredOptions = query === '' ? options : options.filter(function (option) {
    return option.label.toLowerCase().replace(/\s+/g, '').includes(query.toLowerCase().replace(/\s+/g, ''));
  });
  var selectedValue = options.find(function (o) {
    return Array.isArray(value) ? o.value === value[0] : o.value === value;
  });
  return /*#__PURE__*/React.createElement("div", {
    className: "w-full"
  }, /*#__PURE__*/React.createElement(Combobox, {
    value: selectedValue,
    onChange: function onChange(value) {
      return _onChange === null || _onChange === void 0 ? void 0 : _onChange(value.value);
    }
  }, /*#__PURE__*/React.createElement("div", {
    className: "relative mt-1"
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(antPrefixCls, "-select ").concat(antPrefixCls, "-select-single relative w-full")
  }, /*#__PURE__*/React.createElement("div", {
    className: "".concat(antPrefixCls, "-select-selector")
  }, /*#__PURE__*/React.createElement(Combobox.Input, {
    className: "w-full border-none py-2 pl-0 pr-10 text-sm leading-5 text-gray-900 focus:ring-0",
    displayValue: function displayValue(option) {
      var _selectedValue$label;
      return (_selectedValue$label = selectedValue === null || selectedValue === void 0 ? void 0 : selectedValue.label) !== null && _selectedValue$label !== void 0 ? _selectedValue$label : '';
    },
    onChange: function onChange(event) {
      return setQuery(event.target.value);
    },
    onClick: function onClick() {
      var _refButton$current, _refButton$current$cl;
      return (_refButton$current = refButton.current) === null || _refButton$current === void 0 || (_refButton$current$cl = _refButton$current.click) === null || _refButton$current$cl === void 0 ? void 0 : _refButton$current$cl.call(_refButton$current);
    }
  }), /*#__PURE__*/React.createElement(Combobox.Button, {
    className: "absolute inset-y-0 right-0 flex items-center pr-2 border-0 bg-transparent",
    ref: refButton
  }, /*#__PURE__*/React.createElement(DownOutlined, {
    style: {
      color: 'rgba(0,0,0,0.4)'
    }
  })))), /*#__PURE__*/React.createElement(Transition, {
    as: Fragment,
    leave: "transition ease-in duration-100",
    leaveFrom: "opacity-100",
    leaveTo: "opacity-0",
    afterLeave: function afterLeave() {
      return setQuery('');
    }
  }, /*#__PURE__*/React.createElement(Combobox.Options, {
    className: "absolute z-10 mt-1 max-h-60 w-full overflow-auto rounded-md bg-white py-1 text-base shadow-lg ring-black ring-opacity-5 focus:outline-none sm:text-sm"
  }, filteredOptions.length === 0 && query !== '' ? /*#__PURE__*/React.createElement("div", {
    className: "relative cursor-default select-none py-2 px-4 text-gray-500"
  }, /*#__PURE__*/React.createElement(Empty, {
    image: Empty.PRESENTED_IMAGE_SIMPLE
  })) : filteredOptions.map(function (option) {
    return /*#__PURE__*/React.createElement(Combobox.Option, {
      key: option.value,
      className: function className(_ref2) {
        var selected = _ref2.selected,
          active = _ref2.active;
        return "relative cursor-default select-none py-2 pl-6 pr-4 text-sm ".concat(active ? 'bg-[#f5f5f5]' : 'text-gray-900', " ").concat(selected ? '' : 'gb-white');
      },
      value: option
    }, function (_ref3) {
      var selected = _ref3.selected,
        active = _ref3.active;
      return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("span", {
        className: "block truncate ".concat(selected ? 'font-medium' : 'font-normal')
      }, option.label));
    });
  }))))));
}