"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSelectedCatalog = void 0;
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var rc_virtual_list_1 = tslib_1.__importDefault(require("rc-virtual-list"));
var scope_switch_1 = tslib_1.__importDefault(require("../scope-switch"));
var locale_1 = require("@udesk-webapp/locale");
var utilities_1 = require("../utilities");
var style_module_scss_1 = tslib_1.__importDefault(require("../style.module.scss"));
var utils_1 = require("../utils");
var search_input_1 = tslib_1.__importDefault(require("../search-input"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var catalog_select_1 = tslib_1.__importDefault(require("../catalog-select"));
var TreeNode = udesk_ui_1.TreeSelect.TreeNode;
var ContainerHeight = 650;
var AttachmentInner = function (_a) {
    var data = _a.data, onScrollToBottom = _a.onScrollToBottom;
    var t = (0, locale_1.useTranslation)().t;
    var wrapHeightRef = (0, react_1.useRef)();
    var _b = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext), isWorkbench = _b.isWorkbench, onSend = _b.onSend, previewUrl = _b.previewUrl;
    (0, react_1.useEffect)(function () {
        var _a;
        var wrapDom = (_a = document.getElementsByClassName('repositoryTabsWrap')) === null || _a === void 0 ? void 0 : _a[0];
        if (wrapDom) { // 避免小数 出现外层滚动条
            wrapHeightRef.current = wrapDom.clientHeight ? (wrapDom.clientHeight - 173) : ContainerHeight;
        }
    }, []);
    var onClick = function (data) {
        onSend === null || onSend === void 0 ? void 0 : onSend('attachment', data);
        (0, utilities_1.hit)(data.id, 'KnowledgeAttachment');
    };
    var previewUrlFun = function (data) {
        window.open((0, utils_1.getPreviewUrl)(data.file_url, { previewUrl: previewUrl }));
    };
    var generateContent = function (data) {
        var content = [
            react_1.default.createElement("a", { key: '1', href: data.file_url, rel: 'noopener noreferrer', target: '_blank', className: style_module_scss_1.default['attachment-link'] }, data.file_name),
            react_1.default.createElement("div", { key: '2', className: style_module_scss_1.default.nodeOperations },
                (0, utils_1.canPreviewByFileName)(data.file_name) ? (react_1.default.createElement("div", { className: style_module_scss_1.default.lineBtns },
                    react_1.default.createElement(udesk_ui_1.Button, { type: 'link', size: 'small', className: style_module_scss_1.default['line-btn-item'], onClick: function () { previewUrlFun(data); } }, t('label.preview')),
                    ' ',
                    isWorkbench ? react_1.default.createElement("span", { className: style_module_scss_1.default.line }) : null)) : null,
                isWorkbench ? react_1.default.createElement(udesk_ui_1.Button, { type: 'link', size: 'small', className: style_module_scss_1.default['line-btn-item'], onClick: function () { onClick(data); } }, t('label.send')) : null),
        ];
        if (data.file_type.startsWith('image') || /png|jpg|jpeg|gif/.test(data.file_type)) {
            return (react_1.default.createElement("div", { className: style_module_scss_1.default['repository-item-wrap'] },
                react_1.default.createElement(udesk_ui_1.Popover, { autoAdjustOverflow: false, content: react_1.default.createElement("img", { src: data.file_url, alt: data.file_name, style: { width: '100%' } }), placement: 'leftBottom', overlayStyle: { maxWidth: '300px', maxHeight: '300px' } },
                    react_1.default.createElement("div", { className: "".concat(style_module_scss_1.default['repository-item'], " ").concat(style_module_scss_1.default['attachment-item']) }, content))));
        }
        else {
            return (react_1.default.createElement("div", { className: "".concat(style_module_scss_1.default['repository-item-wrap'], " ").concat(style_module_scss_1.default['repository-item'], " ").concat(style_module_scss_1.default['attachment-item']) }, content));
        }
    };
    var onScroll = function (e) {
        // 滚动到了底部
        if (e.currentTarget.scrollHeight - e.currentTarget.scrollTop === wrapHeightRef.current) {
            onScrollToBottom();
        }
    };
    return (react_1.default.createElement("div", { id: 'knowledgeTreeWrapper', className: (0, classnames_1.default)(style_module_scss_1.default['repository-virtualList-wrapper']) },
        react_1.default.createElement(rc_virtual_list_1.default, { data: data, height: wrapHeightRef.current, itemHeight: 45, itemKey: 'id', onScroll: onScroll }, function (item) { return generateContent(item); })));
};
exports.useSelectedCatalog = (0, utilities_1.createUseSelectedCatalog)();
var Attachment = function (_a) {
    var _b, _c, _d, _e, _f;
    var refreshKnowledge = _a.refreshKnowledge, roleCan = _a.roleCan, onSearch = _a.onSearch, mineChats = _a.mineChats, agentConfig = _a.agentConfig, dialogueTagData = _a.dialogueTagData, stashKey = _a.stashKey, props = tslib_1.__rest(_a, ["refreshKnowledge", "roleCan", "onSearch", "mineChats", "agentConfig", "dialogueTagData", "stashKey"]);
    var query = props.query;
    var chat = (mineChats === null || mineChats === void 0 ? void 0 : mineChats.find(function (chat) { return chat.selected; })) || {};
    var _g = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext), activeScope = _g.activeScope, onScopeChange = _g.onScopeChange;
    var _scope = (0, utilities_1.useSafeScope)(activeScope);
    var _h = (0, exports.useSelectedCatalog)(_scope, stashKey), selectedCatalog = _h[0], setSelectedCatalog = _h[1];
    var tagsIdRef = (0, react_1.useRef)(-1);
    var _j = (0, react_1.useState)(false), tagCatalog = _j[0], setTagCatalog = _j[1];
    var _k = (0, react_1.useState)(1), page = _k[0], setPage = _k[1];
    var _l = (0, react_1.useState)([]), usefulAttachment = _l[0], setUsefulAttachment = _l[1];
    var pagingRef = (0, react_1.useRef)({ current_page: 0, total_pages: 0 });
    var t = (0, locale_1.useTranslation)().t;
    var params = (0, react_1.useMemo)(function () {
        var q = query.trim();
        var catalogId = selectedCatalog;
        if (selectedCatalog === -1 || q) { // 查询是在全部分类中筛选
            catalogId = 'all';
        }
        return {
            catalog_id: catalogId,
            scope: _scope,
            per_page: 20,
            page: page,
            query: q
        };
    }, [page, _scope, query, selectedCatalog]);
    var _m = (0, utilities_1.useRequestData)('attachment', params, refreshKnowledge, roleCan), loading = _m.loading, setLoading = _m.setLoading, catalogs = _m.catalogs, data = _m.data, hasPermission = _m.hasPermission;
    (0, react_1.useEffect)(function () {
        setPage(1);
        setTagCatalog(false);
        setLoading(true);
    }, [_scope]);
    var tagNameArray = (0, react_1.useMemo)(function () {
        var _a, _b, _c, _d;
        if (((_a = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.session_tags_config) === null || _a === void 0 ? void 0 : _a.enable) &&
            (dialogueTagData === null || dialogueTagData === void 0 ? void 0 : dialogueTagData.length) &&
            ((_b = chat.dialogueTag) === null || _b === void 0 ? void 0 : _b.length)) {
            if (((_c = agentConfig.session_tags_config) === null || _c === void 0 ? void 0 : _c.mode_tags) === 'first') {
                return chat.dialogueTag[0].map(function (i) { var _a; return (_a = dialogueTagData === null || dialogueTagData === void 0 ? void 0 : dialogueTagData.find(function (j) { return j.id === i; })) === null || _a === void 0 ? void 0 : _a.name; }).filter(function (i) { return !!i; });
            }
            else if (((_d = agentConfig.session_tags_config) === null || _d === void 0 ? void 0 : _d.mode_tags) === 'new') {
                return chat.dialogueTag[chat.dialogueTag.length - 1].map(function (i) { var _a; return (_a = dialogueTagData === null || dialogueTagData === void 0 ? void 0 : dialogueTagData.find(function (j) { return j.id === i; })) === null || _a === void 0 ? void 0 : _a.name; }).filter(function (i) { return !!i; });
            }
        }
        return [];
    }, [agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.session_tags_config, chat.dialogueTag, dialogueTagData]);
    var tagName = (0, react_1.useMemo)(function () {
        var _a, _b;
        if (((_a = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.session_tags_config) === null || _a === void 0 ? void 0 : _a.enable)
            && ((_b = agentConfig.session_tags_config) === null || _b === void 0 ? void 0 : _b.show_mode) === 'keyword'
            && tagNameArray.length > 0) {
            return tagNameArray.join(' ');
        }
        return '';
    }, [(_b = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.session_tags_config) === null || _b === void 0 ? void 0 : _b.enable, (_c = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.session_tags_config) === null || _c === void 0 ? void 0 : _c.show_mode, tagNameArray]);
    var tagsName = (0, react_1.useCallback)(function (list, tagList, num) {
        list.children.forEach(function (items) {
            var _a, _b;
            if (items.name === tagList[num] && ((_a = items.children) === null || _a === void 0 ? void 0 : _a.length) && tagList[num + 1]) {
                num += 1;
                tagsName(items, tagList, num);
            }
            else if ((items.name === tagList[num] && !((_b = items.children) === null || _b === void 0 ? void 0 : _b.length)) ||
                (items.name === tagList[num] && !tagList[num + 1])) {
                tagsIdRef.current = items.id;
            }
            else if (!tagsIdRef.current) {
                tagsIdRef.current = list.id;
            }
        });
        return tagsIdRef.current;
    }, []);
    var defaultTags = (0, react_1.useCallback)(function () {
        var _a, _b, _c, _d, _e;
        var tagList = [];
        if (((_a = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.session_tags_config) === null || _a === void 0 ? void 0 : _a.enable) &&
            ((_b = agentConfig.session_tags_config) === null || _b === void 0 ? void 0 : _b.show_mode) === 'type' &&
            !tagCatalog &&
            (dialogueTagData === null || dialogueTagData === void 0 ? void 0 : dialogueTagData.length) &&
            ((_c = chat.dialogueTag) === null || _c === void 0 ? void 0 : _c.length)) {
            if (((_d = agentConfig.session_tags_config) === null || _d === void 0 ? void 0 : _d.mode_tags) === 'first') {
                chat.dialogueTag[0].forEach(function (item) {
                    dialogueTagData.forEach(function (items) {
                        if (item === items.id) {
                            tagList.push(items.name);
                        }
                    });
                });
                var num_1 = 0;
                catalogs.forEach(function (item) {
                    var _a;
                    if (item.name === tagList[num_1] && tagList.length > 1 && ((_a = item.children) === null || _a === void 0 ? void 0 : _a.length)) {
                        num_1 += 1;
                        tagsName(item, tagList, num_1);
                    }
                    else if (item.name === tagList[tagList.length - 1]) {
                        tagsIdRef.current = item.id;
                    }
                });
            }
            else if (((_e = agentConfig.session_tags_config) === null || _e === void 0 ? void 0 : _e.mode_tags) === 'new') {
                chat.dialogueTag[chat.dialogueTag.length - 1].forEach(function (item) {
                    dialogueTagData.forEach(function (items) {
                        if (item === items.id) {
                            tagList.push(items.name);
                        }
                    });
                });
                var num_2 = 0;
                catalogs.forEach(function (item) {
                    var _a;
                    if (item.name === tagList[num_2] && tagList.length > 1 && ((_a = item.children) === null || _a === void 0 ? void 0 : _a.length)) {
                        num_2 += 1;
                        tagsName(item, tagList, num_2);
                    }
                    else if (item.name === tagList[tagList.length - 1]) {
                        tagsIdRef.current = item.id;
                    }
                });
            }
            setSelectedCatalog(tagsIdRef.current);
            return tagsIdRef.current;
        }
        else {
            return -1;
        }
    }, [(_d = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.session_tags_config) === null || _d === void 0 ? void 0 : _d.enable, (_e = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.session_tags_config) === null || _e === void 0 ? void 0 : _e.mode_tags, (_f = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.session_tags_config) === null || _f === void 0 ? void 0 : _f.show_mode, catalogs, chat.dialogueTag, dialogueTagData, tagCatalog, tagsName, setSelectedCatalog]);
    (0, react_1.useEffect)(function () {
        defaultTags();
    }, [defaultTags]);
    (0, react_1.useEffect)(function () {
        if (loading)
            return;
        setPage(1);
        setUsefulAttachment([]);
    }, [params.query]);
    (0, react_1.useEffect)(function () {
        setUsefulAttachment([]);
    }, [params.catalog_id, params.scope]);
    (0, react_1.useEffect)(function () {
        var _a;
        if (data === null || data === void 0 ? void 0 : data.knowledge_attachments) {
            var attachments_1 = (_a = data === null || data === void 0 ? void 0 : data.knowledge_attachments) === null || _a === void 0 ? void 0 : _a.map(function (a) { return a.knowledge_attachment; });
            // @ts-ignore
            setUsefulAttachment(function (prevState) { return tslib_1.__spreadArray(tslib_1.__spreadArray([], prevState, true), attachments_1, true); });
            pagingRef.current = data.meta;
        }
    }, [data]);
    var pageChangeCallback = function () {
        var _a;
        if (loading)
            return;
        if (page >= ((_a = pagingRef.current) === null || _a === void 0 ? void 0 : _a.total_pages))
            return;
        setLoading(true);
        setPage(page + 1);
    };
    var changeSelectedCatalogs = (0, react_1.useCallback)(function (value, label, extra) {
        setTagCatalog(true);
        setSelectedCatalog(value);
        setLoading(true);
        setPage(1);
        tagsIdRef.current = -1;
    }, []);
    (0, react_1.useEffect)(function () {
        tagsIdRef.current = -1;
    }, [catalogs]);
    return react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(scope_switch_1.default, { value: _scope, onChange: onScopeChange }),
        react_1.default.createElement(search_input_1.default, { onSearch: onSearch, defaultValue: tagName ? tagName : query }),
        (query && query.trim()) ? null :
            react_1.default.createElement(catalog_select_1.default, { data: catalogs, prependTreeNodes: [react_1.default.createElement(TreeNode, { value: -1, key: '-1', title: t('page.im.km.question.all_catalog') })], value: selectedCatalog, onChange: changeSelectedCatalogs }),
        (function () {
            if (!usefulAttachment) {
                return null;
            }
            if (!hasPermission) {
                return react_1.default.createElement("div", { className: (0, classnames_1.default)(style_module_scss_1.default['no-permission']) }, "\u60A8\u6682\u65E0\u6743\u9650\u67E5\u770B\u6B64\u5185\u5BB9");
            }
            if (!loading && (usefulAttachment && !usefulAttachment.length)) {
                return react_1.default.createElement(udesk_ui_1.Empty, { className: "h-full w-hull flex justify-center items-center flex-col" });
            }
            return (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement(AttachmentInner, tslib_1.__assign({}, props, { data: usefulAttachment, onScrollToBottom: pageChangeCallback })),
                loading ? react_1.default.createElement("div", { className: (0, classnames_1.default)(style_module_scss_1.default['repository-loading']) },
                    react_1.default.createElement(udesk_ui_1.Spin, { className: 'w-full text-center' })) : null));
        })());
};
exports.default = Attachment;
