"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _forEach = _interopRequireDefault(require("lodash-es/forEach"));

var _includes = _interopRequireDefault(require("lodash-es/includes"));

var _isFunction = _interopRequireDefault(require("lodash-es/isFunction"));

var _join = _interopRequireDefault(require("lodash-es/join"));

var _map = _interopRequireDefault(require("lodash-es/map"));

var _split = _interopRequireDefault(require("lodash-es/split"));

var _fontawesomeSvgCore = require("@fortawesome/fontawesome-svg-core");

var _reactFontawesome = require("@fortawesome/react-fontawesome");

var _freeSolidSvgIcons = require("@fortawesome/free-solid-svg-icons");

var _react2 = require("@emotion/react");

_fontawesomeSvgCore.library.add(_freeSolidSvgIcons.faTimesCircle);

var UdeskTimePicker = /*#__PURE__*/function (_React$Component) {
  (0, _inheritsLoose2["default"])(UdeskTimePicker, _React$Component);

  UdeskTimePicker.getDerivedStateFromProps = function getDerivedStateFromProps(props, state) {
    if (props.time !== state.beforeTime) {
      return {
        HH: (0, _split["default"])(props.time, ':', 3)[0] || '',
        mm: (0, _split["default"])(props.time, ':', 3)[1] || '',
        ss: (0, _split["default"])(props.time, ':', 3)[2] || '',
        beforeTime: props.time
      };
    }

    return null;
  };

  function UdeskTimePicker(props) {
    var _this;

    _this = _React$Component.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "state", {
      HH: (0, _split["default"])(_this.props.time, ':', 3)[0] || '',
      mm: (0, _split["default"])(_this.props.time, ':', 3)[1] || '',
      ss: (0, _split["default"])(_this.props.time, ':', 3)[2] || '',
      beforeTime: _this.props.time,
      showPicker: false
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "_ref", /*#__PURE__*/_react["default"].createRef());
    _this._leadingZero = _this._leadingZero.bind((0, _assertThisInitialized2["default"])(_this));
    _this._range = _this._range.bind((0, _assertThisInitialized2["default"])(_this));
    _this._times = _this._times.bind((0, _assertThisInitialized2["default"])(_this));
    _this.onSelectTime = _this.onSelectTime.bind((0, _assertThisInitialized2["default"])(_this));
    _this.showUdeskTimePicker = _this.showUdeskTimePicker.bind((0, _assertThisInitialized2["default"])(_this));
    _this._sendOutSideClick = _this._sendOutSideClick.bind((0, _assertThisInitialized2["default"])(_this));
    return _this;
  }

  var _proto = UdeskTimePicker.prototype;

  _proto.componentDidMount = function componentDidMount() {
    document.addEventListener('mousedown', this._sendOutSideClick);
    var time = this.props.time;
    this.setState({
      time: time
    });
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    document.removeEventListener('mousedown', this._sendOutSideClick);
  };

  _proto._sendOutSideClick = function _sendOutSideClick(e) {
    //eslint-disable-next-line no-console
    if (!contains(this._ref.current, e.target)) {
      this.setState({
        showPicker: false
      });
    }
  };

  _proto._leadingZero = function _leadingZero(num, size) {
    var str = String(num);

    while (str.length < (size || 2)) {
      str = '0' + num;
    }

    return str;
  };

  _proto._range = function _range(start, end) {
    var range = [],
        i;

    for (i = start; i < end; ++i) {
      range.push(this._leadingZero(i));
    }

    return range;
  };

  _proto._times = function _times() {
    var _this2 = this;

    var times = {};
    var format = this.props.format;
    (0, _forEach["default"])((0, _split["default"])(format, ':', 3), function (i) {
      var values = i === 'HH' ? _this2._range(0, 24) : _this2._range(0, 60);
      times[i] = {
        values: values
      };
    });
    return times;
  };

  _proto.onSelectTime = function onSelectTime(unit, value) {
    var _this$setState;

    this.setState((_this$setState = {}, _this$setState[unit] = value, _this$setState));
  };

  _proto.showUdeskTimePicker = function showUdeskTimePicker(e) {
    if (this._doNotOpenPicker) {
      this._doNotOpenPicker = false;
      return;
    }

    this.setState({
      showPicker: true
    });
  };

  _proto._onInputChange = function _onInputChange(timeUnit, value) {
    var _this$setState2;

    this.setState((_this$setState2 = {}, _this$setState2[timeUnit] = value, _this$setState2));
  };

  _proto._fireOnChange = function _fireOnChange() {
    var onChange = this.props.onChange;

    if (!(0, _isFunction["default"])(onChange)) {
      return;
    }

    onChange(this._getFullValue());
  };

  _proto._getFullValue = function _getFullValue() {
    var _this3 = this;

    if (!this.state.HH && !this.state.mm && !this.state.ss) {
      return '';
    }

    var regex = {
      HH: /^[0-1][0-9]|2[0-3]$/,
      mm: /^[0-5][0-9]$/,
      ss: /^[0-5][0-9]$/
    };
    var valueAry = [];
    (0, _forEach["default"])(this.props.format.split(':'), function (timeUnit) {
      var value = _this3.state[timeUnit];

      if (regex[timeUnit].test(value)) {
        //满足条件直接使用
        valueAry.push(value);
      } else if (/^\d$/.test(value)) {
        var _this3$setState;

        //只输入一位数字，前面补零
        valueAry.push('0' + value);

        _this3.setState((_this3$setState = {}, _this3$setState[timeUnit] = '0' + value, _this3$setState));
      } else {
        var _this3$setState2;

        //全不满足设为00
        valueAry.push('00');

        _this3.setState((_this3$setState2 = {}, _this3$setState2[timeUnit] = '00', _this3$setState2));
      }
    });
    return (0, _join["default"])(valueAry, ':');
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps, prevState, snapshot) {
    if (!this.state.showPicker && prevState.showPicker && this._getFullValue() !== this.state.beforeTime) {
      this._fireOnChange();
    }
  };

  _proto.render = function render() {
    var _this4 = this;

    var className = this.props.className;
    var _this$state = this.state,
        showPicker = _this$state.showPicker,
        HH = _this$state.HH,
        mm = _this$state.mm,
        ss = _this$state.ss;
    var onChange = this.props.onChange;

    var times = this._times();

    return (0, _react2.jsx)("div", {
      className: 'udesk-time-picker ' + className,
      ref: this._ref
    }, (0, _react2.jsx)("div", {
      className: "udesk-time-picker-input-box",
      onClick: this.showUdeskTimePicker
    }, (HH || mm || ss) && (0, _map["default"])(times, function (v, i) {
      return (0, _react2.jsx)(_react.Fragment, {
        key: i
      }, (0, _includes["default"])(['mm', 'ss'], i) ? (0, _react2.jsx)("span", null, ":") : void 0, (0, _react2.jsx)("input", {
        type: "text",
        className: "udesk-time-picker-input",
        value: _this4.state[i],
        onChange: function onChange(e) {
          return _this4._onInputChange(i, e.target.value);
        }
      }));
    }), (HH || mm || ss) && (0, _react2.jsx)("span", {
      className: "clear-btn",
      onClick: function onClick() {
        _this4._doNotOpenPicker = true;

        _this4.setState({
          HH: '',
          mm: '',
          ss: ''
        });

        if ((0, _isFunction["default"])(onChange) && !_this4.state.showPicker) {
          onChange('');
        }
      }
    }, (0, _react2.jsx)(_reactFontawesome.FontAwesomeIcon, {
      icon: "times-circle"
    }))), showPicker && (0, _react2.jsx)("div", {
      className: "udesk-time-picker-panel"
    }, (0, _react2.jsx)(UlItems, {
      times: times,
      that: this
    })));
  };

  return UdeskTimePicker;
}(_react["default"].Component);

function UlItems(props) {
  return (0, _map["default"])(props.times, function (time, unit) {
    return (0, _react2.jsx)("div", {
      className: "udesk-time-picker-panel-select",
      key: unit
    }, (0, _react2.jsx)("ul", {
      className: "udesk-time-picker-panel-select-ul"
    }, (0, _react2.jsx)(LiItems, {
      key: unit,
      time: time,
      onClick: function onClick(selectedValue) {
        return props.that.onSelectTime(unit, selectedValue);
      }
    })));
  });
}

function LiItems(props) {
  return props.time.values.map(function (item, index) {
    return (0, _react2.jsx)("li", {
      className: "udesk-time-picker-panel-select-ul-li",
      key: index,
      onClick: function onClick() {
        return props.onClick(item);
      }
    }, item);
  });
}

function contains(root, n) {
  var node = n;

  while (node) {
    if (node === root) {
      return true;
    }

    node = node.parentNode;
  }

  return false;
}

UdeskTimePicker.propTypes = {
  format: _propTypes["default"].oneOf(['HH', 'HH:mm', 'HH:mm:ss']),
  time: function time(props, propName, componentName) {
    if (!/^(([0-1][0-9]|2[0-3])(:[0-5][0-9](:[0-5][0-9])?)?)?$/.test(props[propName])) {
      return new Error('Invalid prop `' + propName + '` supplied to' + ' `' + componentName + '`. Validation failed.');
    }
  },
  onChange: _propTypes["default"].func
};
UdeskTimePicker.defaultProps = {
  time: '',
  format: 'HH:mm',
  onChange: null
};
var _default = UdeskTimePicker;
exports["default"] = _default;