"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.buildTreeNodes = void 0;
var tslib_1 = require("tslib");
var style_module_scss_1 = tslib_1.__importDefault(require("./style.module.scss"));
var udesk_ui_1 = require("udesk-ui");
var react_1 = tslib_1.__importStar(require("react"));
var TreeNode = udesk_ui_1.TreeSelect.TreeNode;
var dropDownStyle = { maxHeight: 400, minWidth: 400, overflow: 'auto' };
var treeStyle = { alignSelf: 'flex-start' };
function buildTreeNodes(catalogs, customCatalogOrder) {
    var sortedCatalogs = catalogs;
    if (customCatalogOrder) {
        sortedCatalogs = catalogs.sort(function (a, b) {
            return customCatalogOrder.findIndex(function (i) { return i.id === a.id; }) -
                customCatalogOrder.findIndex(function (i) { return i.id === b.id; });
        });
    }
    return sortedCatalogs.map(function (i) {
        return (react_1.default.createElement(TreeNode, { value: i.id, key: i.id + '', title: i.name }, buildTreeNodes(i.children || [], i.children)));
    });
}
exports.buildTreeNodes = buildTreeNodes;
var CatalogSelect = function (_a) {
    var data = _a.data, onChange = _a.onChange, value = _a.value, prependTreeNodes = _a.prependTreeNodes;
    var treeNodes = (0, react_1.useMemo)(function () { return buildTreeNodes(data, null); }, [data]);
    return react_1.default.createElement(udesk_ui_1.TreeSelect, { dropdownStyle: dropDownStyle, style: treeStyle, treeDefaultExpandAll: true, bordered: false, value: value, onChange: onChange, 
        // placement={'bottomRight'} // TODO 待antd升级
        className: style_module_scss_1.default['question-select'] },
        prependTreeNodes,
        treeNodes);
};
exports.default = CatalogSelect;
