import { Empty } from 'antd';
import React, { useMemo } from 'react';
import { isNotEmpty } from "../../utils/core";
import { useGet } from "../../utils/fetch";
import Locales from "../../locales";
var AppGrid = function AppGrid(_ref) {
  var items = _ref.items,
    itemRender = _ref.itemRender,
    _ref$showEmpty = _ref.showEmpty,
    showEmpty = _ref$showEmpty === void 0 ? false : _ref$showEmpty;
  var _useGet = useGet('/classifys'),
    data = _useGet.data;
  var classifyMap = useMemo(function () {
    return ((data === null || data === void 0 ? void 0 : data.data) || []).reduce(function (p, c) {
      p.set(c.id, {
        name: c.name,
        apps: items.filter(function (i) {
          var _i$classifies;
          return (_i$classifies = i.classifies) === null || _i$classifies === void 0 ? void 0 : _i$classifies.find(function (classify) {
            return classify.id === c.id;
          });
        })
      });
      return p;
    }, new Map());
  }, [items, data === null || data === void 0 ? void 0 : data.data]);
  var showClassify = useMemo(function () {
    return Array.from(classifyMap.values()).filter(function (i) {
      return showEmpty || i.apps.length > 0;
    });
  }, [classifyMap]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, showClassify.map(function (classify) {
    return /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement("div", {
      className: "flex justify-between mt-[36px] mb-[18px] w-full"
    }, /*#__PURE__*/React.createElement("div", {
      className: " font-bold flex items-center text-[18px]"
    }, classify.name)), isNotEmpty(classify.apps, function () {
      return /*#__PURE__*/React.createElement("div", {
        className: "grid grid-cols-2 gap-4 sm:grid-cols-3 md:grid-cols-3 lg:grid-cols-4 xl:grid-cols-5 w-full "
      }, classify.apps.map(function (item) {
        return itemRender(item);
      }));
    }, function () {
      return /*#__PURE__*/React.createElement(Empty, {
        image: Empty.PRESENTED_IMAGE_SIMPLE,
        description: /* 暂无应用 */Locales['current'].components.appGrid.index.thereAreCu20sAvailable
      });
    }));
  }));
};
export { AppGrid };