function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
var _excluded = ["mode", "items"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import { AppstoreOutlined, EllipsisOutlined } from '@ant-design/icons';
import { Button, Dropdown, Menu } from 'antd';
import classNames from 'classnames';
import React, { useMemo } from 'react';
import { Popconfirm } from "../../Popconfirm";
import { inspect } from "../../utils/core";
import Locales from "../../locales";
var AppItem = function AppItem(props) {
  var _props$mode = props.mode,
    mode = _props$mode === void 0 ? 'view' : _props$mode,
    _props$items = props.items,
    _items = _props$items === void 0 ? [] : _props$items,
    itemProps = _objectWithoutProperties(props, _excluded);
  var isEdit = useMemo(function () {
    return mode === 'edit';
  }, [mode]);
  var items = useMemo(function () {
    return _items.map(function (i) {
      var _i$onClick;
      var _onClick = (_i$onClick = i.onClick) === null || _i$onClick === void 0 ? void 0 : _i$onClick.bind(null, itemProps, i.key);
      return _objectSpread(_objectSpread({}, i), {}, {
        onClick: i.danger ? undefined : _onClick,
        label: i.danger ? /*#__PURE__*/React.createElement(Popconfirm, {
          title: /* 确认要删除吗？ */Locales['current'].components.appItem.index.areYouSureYouWantToDeleteIt,
          onConfirm: _onClick,
          okText: /* 删除 */Locales['current'].components.appItem.index.delete,
          cancelText: /* 取消 */Locales['current'].components.appItem.index.cancel,
          okButtonProps: {
            danger: true
          }
        }, /*#__PURE__*/React.createElement("div", null, i.label)) : i.label
      });
    });
  }, [_items]);
  var menu = useMemo(function () {
    return /*#__PURE__*/React.createElement(Menu, null, items.map(function (item) {
      return /*#__PURE__*/React.createElement(Menu.Item, _extends({}, item, {
        key: item.key
      }), item.label);
    }));
  }, [items]);
  return /*#__PURE__*/React.createElement("div", {
    className: classNames({
      'robot relative bg-white cursor-pointer leading-none overflow-hidden animation transition-all group': true,
      'hover:-translate-y-2 hover:shadow-lg': !isEdit,
      'flex flex-col items-center': true,
      'rounded-[16px] p-[24px] h-[160px] pb-3': true
    })
  }, inspect(isEdit, function () {
    return /*#__PURE__*/React.createElement(Dropdown, {
      overlay: menu,
      getPopupContainer: function getPopupContainer(triggerNode) {
        return triggerNode;
      },
      trigger: ['click']
    }, /*#__PURE__*/React.createElement(Button, {
      type: "link",
      size: "small",
      className: "absolute top-2 right-2"
    }, /*#__PURE__*/React.createElement(EllipsisOutlined, null)));
  }, function () {
    return null;
  }), /*#__PURE__*/React.createElement(AppstoreOutlined, {
    className: "!text-[#3b3abe] text-4xl mb-2 opacity-50 group-hover:opacity-100 mt-[4px]"
  }), /*#__PURE__*/React.createElement("h3", {
    className: "text-[16px] pb-[8px] pt-[16px] font-bold truncate text-center mb-1 w-full ",
    title: props.name
  }, props.name), /*#__PURE__*/React.createElement("div", {
    className: "text-[12px] text-gray text-overflow-l2 leading-tight text-center",
    style: {
      display: '-webkit-box',
      WebkitLineClamp: '2',
      WebkitBoxOrient: 'vertical',
      overflow: 'hidden',
      textOverflow: 'ellipsis'
    },
    title: props.describe
  }, props.describe));
};
export { AppItem };