"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var field_err_explain_1 = __importDefault(require("../field-err-explain"));
var isFunction_1 = __importDefault(require("lodash-es/isFunction"));
var copy_1 = __importDefault(require("../../copy"));
var TextArea = udesk_ui_1.Input.TextArea;
var Area_text = function (props) {
    var _a = props.isFormItem, isFormItem = _a === void 0 ? true : _a, switchFlag = props.switchFlag;
    var _b = (0, react_1.useState)(''), errMsg = _b[0], setErrMsg = _b[1];
    var _c = (0, react_1.useState)(''), value = _c[0], setValue = _c[1];
    (0, react_1.useEffect)(function () {
        setValue(props.value);
    }, [props.value]);
    // 失去焦点 校验是否提示
    var hanleValidateText = (0, react_1.useCallback)(function (e) {
        // 如果传递了自定义的校验规则
        var value = e.target.value;
        // 非form表单形式, 自己提示错误, 自己触发保存
        if (!isFormItem) {
            // 有自定义校验
            if ((0, isFunction_1.default)(props.customValidFn)) {
                props
                    .customValidFn(null, value)
                    .then(function () {
                    // 校验成功,可能触发失焦自动保存,要把方法跑出去
                    props.onValueChangedByBlur && props.onValueChangedByBlur({});
                }, function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                })
                    .catch(function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                });
            }
        }
        else {
            var changeFunction = props[props.trigger];
            if (changeFunction) {
                changeFunction(value);
            }
        }
    }, [isFormItem, props]);
    return (react_1.default.createElement(field_err_explain_1.default, __assign({}, props, { errMsg: errMsg }),
        react_1.default.createElement(copy_1.default, { text: value, switchFlag: switchFlag },
            react_1.default.createElement(TextArea, { rows: props.rowsLine, defaultValue: props.defaultValue, placeholder: props.placeholder, onBlur: hanleValidateText, onChange: function (e) { return setValue(e.target.value); }, value: value, disabled: props.disabled }))));
};
exports.default = Area_text;
