"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var isFunction_1 = __importDefault(require("lodash-es/isFunction"));
var field_err_explain_1 = __importDefault(require("../field-err-explain"));
var moment_1 = __importDefault(require("moment"));
var utils_1 = require("../../../utils");
var copy_1 = __importDefault(require("../../copy"));
function DateTime(props) {
    var _a = props.isFormItem, isFormItem = _a === void 0 ? true : _a, switchFlag = props.switchFlag;
    var _b = (0, react_1.useState)(props.value), value = _b[0], setValue = _b[1];
    var _c = (0, react_1.useState)(''), errMsg = _c[0], setErrMsg = _c[1];
    (0, react_1.useEffect)(function () {
        setValue(props.value || null);
    }, [props.value]);
    // 失去焦点 校验是否提示
    var hanleValidateTime = (0, react_1.useCallback)(function (date) {
        if (!isFormItem) {
            // 有自定义校验
            if ((0, isFunction_1.default)(props.customValidFn)) {
                props
                    .customValidFn(null, date)
                    .then(function () {
                    // 校验成功,可能触发失焦自动保存,要把方法跑出去
                    //props.onValueChangedByBlur && props.onValueChangedByBlur({});
                }, function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                })
                    .catch(function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                });
            }
        }
        else {
            var changeFunction = props[props.trigger];
            if (changeFunction) {
                changeFunction(date ? (0, moment_1.default)(date).format(utils_1.YYYY_MM_DD_HH_MM) : '');
            }
        }
    }, [isFormItem, props]);
    var copyChildren = (0, react_1.useMemo)(function () {
        return (react_1.default.createElement(udesk_ui_1.DatePicker, { format: utils_1.YYYY_MM_DD_HH_MM, value: value ? (0, moment_1.default)(value, utils_1.YYYY_MM_DD_HH_MM) : null, style: { marginBottom: '4px' }, showTime: { format: 'HH:mm' }, onChange: hanleValidateTime, disabled: props.disabled }));
    }, [hanleValidateTime, props.disabled, value]);
    return (react_1.default.createElement(field_err_explain_1.default, __assign({}, props, { errMsg: errMsg }),
        react_1.default.createElement(copy_1.default, { text: value, switchFlag: switchFlag }, copyChildren)));
}
exports.default = DateTime;
