"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var index_module_scss_1 = __importDefault(require("./index.module.scss"));
var udesk_ui_1 = require("udesk-ui");
var icon_1 = require("../../icon/icon");
var icons_1 = require("@ant-design/icons");
var field_err_explain_1 = __importDefault(require("../field-err-explain"));
var isFunction_1 = __importDefault(require("lodash-es/isFunction"));
var copy_1 = __importDefault(require("../../copy"));
var Link = function (props) {
    var switchFlag = props.switchFlag;
    var _a = (0, react_1.useState)(''), errMsg = _a[0], setErrMsg = _a[1];
    // 输入的值
    var _b = (0, react_1.useState)(props.defaultValue || ''), link = _b[0], setLink = _b[1];
    //是否显示跳转按钮
    var _c = (0, react_1.useState)(false), showIcon = _c[0], setShowIcon = _c[1];
    (0, react_1.useEffect)(function () {
        setLink(props.value || '');
        setShowIcon(props.value ? true : false);
    }, [props.value]);
    //   输入值变化时  手动双向绑定  进行检验
    function handleOnchange(e) {
        var value = e.target.value;
        setLink(value);
    }
    // 点击输入框右侧图标  打开输入的链接页面
    var openWindow = (0, react_1.useCallback)(function () {
        window.open(link, '_blank');
    }, [link]);
    // 清空输入框
    var clear = (0, react_1.useCallback)(function () {
        setLink('');
        var changeFunction = props[props.trigger];
        if (changeFunction) {
            changeFunction('');
        }
    }, [props]);
    // 输入框失焦时触发  校验输入的内容
    var check = (0, react_1.useCallback)(function () {
        // 非form表单形式, 自己提示错误, 自己触发保存
        if (!props.isFormItem) {
            // 有自定义校验
            if ((0, isFunction_1.default)(props.customValidFn)) {
                props
                    .customValidFn(null, link)
                    .then(function () {
                    // 校验成功,可能触发失焦自动保存,要把方法跑出去
                    props.onValueChangedByBlur && props.onValueChangedByBlur({});
                }, function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                })
                    .catch(function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                });
            }
        }
        else {
            var changeFunction = props[props.trigger];
            if (changeFunction) {
                changeFunction(link);
            }
        }
    }, [link, props]);
    var handleSuffix = (react_1.default.createElement("div", { className: index_module_scss_1.default['icon-group-wrapper'] },
        react_1.default.createElement("span", { className: index_module_scss_1.default['redict-icon'], onClick: openWindow },
            react_1.default.createElement(icon_1.TiaoZhuan, null)),
        react_1.default.createElement("span", { className: index_module_scss_1.default['clear-icon'], onClick: clear },
            react_1.default.createElement(icons_1.CloseCircleFilled, null))));
    return (react_1.default.createElement(field_err_explain_1.default, __assign({}, props, { errMsg: errMsg }),
        react_1.default.createElement(copy_1.default, { text: link, switchFlag: switchFlag },
            react_1.default.createElement(udesk_ui_1.Input, { placeholder: props.placeholder, value: link, onChange: handleOnchange, onBlur: check, suffix: showIcon ? handleSuffix : '', disabled: props.disabled }))));
};
exports.default = Link;
