"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var index_module_scss_1 = __importDefault(require("./index.module.scss"));
var udesk_ui_1 = require("udesk-ui");
var icons_1 = require("@ant-design/icons");
var isFunction_1 = __importDefault(require("lodash-es/isFunction"));
var field_err_explain_1 = __importDefault(require("../field-err-explain"));
var copy_1 = __importDefault(require("../../copy"));
var TextArea = udesk_ui_1.Input.TextArea;
function Location(props) {
    var _a = (0, react_1.useState)(props.defaultValue || ''), address = _a[0], setAddress = _a[1]; //输入的地址
    var _b = (0, react_1.useState)(false), showIcon = _b[0], setShowIcon = _b[1]; //是否显示右上角地址图标  鼠标经过输入框时显示
    var _c = (0, react_1.useState)(''), errMsg = _c[0], setErrMsg = _c[1];
    (0, react_1.useEffect)(function () {
        setAddress(props.value);
    }, [props.value]);
    // 点击定位图标  打开地图
    function openMap() {
        var url = 'http://apis.map.qq.com/uri/v1/search?keyword=' + (address || '') + '&referer=custom_field';
        window.open(url, '_blank');
    }
    var handleOnBlur = function (e) {
        var _a = props.isFormItem, isFormItem = _a === void 0 ? true : _a;
        // 如果传递了自定义的校验规则
        var value = e.target.value;
        // 非form表单形式, 自己提示错误, 自己触发保存
        if (!isFormItem) {
            // 有自定义校验
            if ((0, isFunction_1.default)(props.customValidFn)) {
                props
                    .customValidFn(null, value)
                    .then(function () {
                    // 校验成功,可能触发失焦自动保存,要把方法跑出去
                    props.onValueChangedByBlur && props.onValueChangedByBlur({});
                }, function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                })
                    .catch(function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                });
            }
        }
        else {
            var changeFunction = props[props.trigger];
            if (changeFunction) {
                changeFunction(value);
            }
        }
    };
    return (react_1.default.createElement(field_err_explain_1.default, __assign({}, props, { errMsg: errMsg }),
        react_1.default.createElement("div", { className: index_module_scss_1.default['textarea-wrapper'], onMouseEnter: function () { return setShowIcon(true); }, onMouseLeave: function () { return setShowIcon(false); } },
            react_1.default.createElement(copy_1.default, { text: address, switchFlag: props.switchFlag },
                react_1.default.createElement(TextArea
                // 占位符
                , { 
                    // 占位符
                    placeholder: props.placeholder, 
                    // 行数
                    rows: props.rowsLine, 
                    // 样式
                    className: index_module_scss_1.default['textarea-style'], 
                    // 最大字数
                    // maxLength={data.input_max}
                    // 输入值
                    value: address, 
                    // 输入变化回调
                    onChange: function (e) { return setAddress(e.target.value); }, onBlur: handleOnBlur, disabled: props.disabled })),
            showIcon ? (react_1.default.createElement("div", { className: index_module_scss_1.default['address-icon'], onClick: openMap },
                react_1.default.createElement(icons_1.EnvironmentOutlined, null))) : (''))));
}
exports.default = Location;
