"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var icon_1 = require("../../icon/icon");
var index_module_scss_1 = __importDefault(require("./index.module.scss"));
var field_err_explain_1 = __importDefault(require("../field-err-explain"));
var isFunction_1 = __importDefault(require("lodash-es/isFunction"));
var lodash_es_1 = require("lodash-es");
function Filed_radio(props) {
    var isFormItem = props.isFormItem, trigger = props.trigger, customValidFn = props.customValidFn;
    var _a = props.options, options = _a === void 0 ? [] : _a, _b = props.arrangement, arrangement = _b === void 0 ? 'continuity' : _b, disabled = props.disabled, _c = props.canCancel, canCancel = _c === void 0 ? true : _c;
    var _d = (0, react_1.useState)(''), errMsg = _d[0], setErrMsg = _d[1];
    //选择的选项值
    var _e = (0, react_1.useState)(), selectValue = _e[0], setSelectValue = _e[1];
    var yStyle = (0, react_1.useMemo)(function () { return ({
        display: 'block',
        height: '30px',
        lineHeight: '30px',
        cursor: disabled ? 'not-allowed' : 'pointer',
        verticalAlign: 'middle',
    }); }, [disabled]);
    var xStyle = (0, react_1.useMemo)(function () { return ({
        display: 'inline-block',
        marginRight: '24px',
        cursor: disabled ? 'not-allowed' : 'pointer',
        verticalAlign: 'middle',
    }); }, [disabled]);
    (0, react_1.useEffect)(function () {
        var _a, _b, _c;
        var value = (0, lodash_es_1.isArray)(props.value) ? props.value[0] : props.value;
        if (!value) {
            try {
                value = (_c = (_b = (_a = props.options) === null || _a === void 0 ? void 0 : _a.filter(function (item) { return item.default; })) === null || _b === void 0 ? void 0 : _b[0]) === null || _c === void 0 ? void 0 : _c.value;
            }
            catch (e) {
                console.log(e);
            }
        }
        setSelectValue(value);
    }, [props.value]);
    var changeFunction = (0, react_1.useMemo)(function () { return props[trigger]; }, [props, trigger]);
    var changeRadio = (0, react_1.useCallback)(function (value) {
        if (disabled)
            return;
        // 如果不支持取消选择  并且点击的是已选择的 不做操作
        if (!canCancel && value === selectValue) {
            return;
        }
        // 如果点击的是已经选择的  取消选择
        var _value = value === selectValue ? '' : value;
        setSelectValue(_value);
        // 非form表单形式, 自己提示错误, 自己触发保存
        if (!isFormItem) {
            // 有自定义校验
            if ((0, isFunction_1.default)(customValidFn)) {
                customValidFn(null, value)
                    .then(function () {
                    // 校验成功,可能触发失焦自动保存,要把方法跑出去
                    // props.onValueChangedByBlur && props.onValueChangedByBlur({});
                }, function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                })
                    .catch(function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                });
            }
        }
        else {
            changeFunction === null || changeFunction === void 0 ? void 0 : changeFunction(_value);
        }
    }, [canCancel, changeFunction, disabled, isFormItem, customValidFn, selectValue]);
    return (react_1.default.createElement(field_err_explain_1.default, __assign({}, props, { errMsg: errMsg }),
        react_1.default.createElement("div", { className: index_module_scss_1.default['radio-select-wrapper'] }, options.map(function (item) {
            return (react_1.default.createElement("span", { key: item.value, style: arrangement === 'wrap' ? yStyle : xStyle, onClick: function () { return changeRadio(item.value); } },
                react_1.default.createElement("div", { style: { display: 'flex', wordBreak: 'break-all' } },
                    disabled ? (react_1.default.createElement(icon_1.DisableRadio, null)) : item.value === selectValue ? (react_1.default.createElement(icon_1.XuanZeDanXuan, { style: { color: '#00B38B', fontSize: '16px' } })) : (react_1.default.createElement(icon_1.DanSuanShiXiao, { style: { color: 'rgba(0, 0, 0, 0.15)', fontSize: '16px' } })),
                    react_1.default.createElement("span", { className: "".concat(index_module_scss_1.default['select-item'], " ").concat(item.color ? index_module_scss_1.default['select-item-hascolor'] : ''), style: {
                            background: item.color ? item.color : '',
                            marginLeft: '8px',
                        } },
                        item.icon ? react_1.default.createElement("img", { alt: "", src: item.icon, className: index_module_scss_1.default['setting-img'] }) : '',
                        react_1.default.createElement("span", { style: { color: disabled ? 'rgba(0, 0, 0, 0.25)' : '' } }, item.title)))));
        }))));
}
exports.default = Filed_radio;
