"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var tree_select_1 = __importDefault(require("udesk-ui/es/tree-select"));
var tag_1 = __importDefault(require("udesk-ui/es/tag"));
var TreeNode = tree_select_1.default.TreeNode;
function renderTreeNode(selectOptions, parentCheckable) {
    if (!selectOptions) {
        return null;
    }
    return selectOptions.map(function (i) {
        var title = i.title;
        if (i.color) {
            title = react_1.default.createElement(tag_1.default, { color: i.color }, i.title);
        }
        return react_1.default.createElement(TreeNode, { value: i.value, title: title, key: i.value, checkable: parentCheckable ? true : (i.node_type === 'leaf') }, renderTreeNode(i.subs, parentCheckable));
    });
}
var tagRender = function (props) {
    var label = props.label, closable = props.closable, onClose = props.onClose;
    return (0, react_1.cloneElement)(label, { closable: closable, onClose: onClose });
};
var TagTree = function (_a) {
    var value = _a.value, onChange = _a.onChange, props = __rest(_a, ["value", "onChange"]);
    var treeNodes = (0, react_1.useMemo)(function () { return renderTreeNode(props.select_options, props.parent_checkable); }, [props.parent_checkable, props.select_options]);
    var ref = (0, react_1.useRef)(null);
    var getPopupContainer = (0, react_1.useCallback)(function () { return ref.current || document.body; }, []);
    var valueAry = (0, react_1.useMemo)(function () {
        if (typeof value === 'string') {
            return value.split(',');
        }
        else if (value) {
            return value;
        }
        else {
            return [];
        }
    }, [value]);
    return (react_1.default.createElement("div", { ref: ref, style: { position: 'relative' } },
        react_1.default.createElement(tree_select_1.default, { showSearch: true, style: { width: '100%' }, value: valueAry, dropdownStyle: { maxHeight: 400, overflow: 'auto' }, placeholder: props.placeholder, allowClear: true, treeCheckable: true, onChange: onChange, getPopupContainer: getPopupContainer, transitionName: '', treeDefaultExpandAll: props.default_expand_all, tagRender: tagRender, disabled: props.disabled }, treeNodes)));
};
exports.default = TagTree;
