"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var drop_down_1 = __importStar(require("../drop-down"));
var udesk_ui_1 = require("udesk-ui");
var apis_1 = __importDefault(require("../../utils/apis"));
var store_hook_1 = require("../../store/store-hook");
var react_i18next_1 = require("react-i18next");
var icon_1 = require("../icon/icon");
var style_module_scss_1 = __importDefault(require("./style.module.scss"));
// const { TreeNode} = Tree;
var Search = udesk_ui_1.Input.Search;
var TreeNode = function (props) {
    return (react_1.default.createElement("span", { key: props.key, title: props.title },
        props.count != null && react_1.default.createElement("b", { className: style_module_scss_1.default["nodeNum"] }, props.count),
        props.title));
};
var AgentGroupSelect = function (props) {
    var t = (0, react_i18next_1.useTranslation)().t;
    var TriggerComponent = props.triggerComponent, _a = props.triggerText, triggerText = _a === void 0 ? t("agent") : _a, _b = props.placeholder, placeholder = _b === void 0 ? "" : _b, _c = props.showNum, showNum = _c === void 0 ? true : _c, _d = props.cacheEnable, cacheEnable = _d === void 0 ? true : _d, _e = props.allColleagueMonitorEnabled, allColleagueMonitorEnabled = _e === void 0 ? true : _e, onChange = props.onChange, onAgentLoad = props.onAgentLoad, _f = props.value, value = _f === void 0 ? [] : _f;
    var _g = (0, react_1.useState)(""), keyWord = _g[0], setKeyword = _g[1];
    var _h = (0, react_1.useState)([]), agents = _h[0], setAgents = _h[1];
    var _j = (0, react_1.useState)(false), dropDownVisible = _j[0], setDropDownVisible = _j[1];
    // let [checkStrictly, setCheckStrictly] = useState<boolean>(false);
    var _k = (0, react_1.useState)([]), checkedNode = _k[0], setCheckedNode = _k[1];
    var currentAgents = (0, store_hook_1.useSelector)(function (state) { return state.agents; });
    var currentUser = (0, store_hook_1.useSelector)(function (state) { return state.currentUser; });
    var groupAgents = (0, react_1.useMemo)(function () {
        return formGroupAgents(agents, currentAgents, currentUser === null || currentUser === void 0 ? void 0 : currentUser.user_groups, allColleagueMonitorEnabled);
    }, [
        agents,
        allColleagueMonitorEnabled,
        currentAgents,
        currentUser === null || currentUser === void 0 ? void 0 : currentUser.user_groups,
    ]);
    var filteredgroupAgents = (0, react_1.useMemo)(function () {
        var filteredAgents = agents.filter(function (agent) {
            var agentName = agent === null || agent === void 0 ? void 0 : agent.name;
            if (agentName) {
                if (keyWord) {
                    return agentName.indexOf(keyWord) !== -1;
                }
                else {
                    return true;
                }
            }
            else {
                return false;
            }
        });
        return formGroupAgents(filteredAgents, currentAgents, currentUser === null || currentUser === void 0 ? void 0 : currentUser.user_groups, allColleagueMonitorEnabled);
    }, [
        keyWord,
        agents,
        currentAgents,
        currentUser === null || currentUser === void 0 ? void 0 : currentUser.user_groups,
        allColleagueMonitorEnabled,
    ]);
    (0, react_1.useEffect)(function () {
        apis_1.default.getMonitorUserList().then(function (resp) {
            if (resp === null || resp === void 0 ? void 0 : resp.agents) {
                var respAgents = resp.agents;
                setAgents(respAgents);
            }
        });
    }, []);
    (0, react_1.useEffect)(function () {
        setCheckedNode(value);
    }, [value]);
    var onSearchChange = (0, react_1.useCallback)(function (e) {
        var value = e.target.value;
        // if (value) {
        //     setCheckStrictly(true);
        // } else {
        //     setCheckStrictly(false);
        // }
        setKeyword(value);
    }, []);
    var onVisibleChange = (0, react_1.useCallback)(function (value) {
        setDropDownVisible(value);
        if (!value) {
            onChange && onChange(checkedNode);
            setKeyword("");
        }
    }, [checkedNode, onChange]);
    var onChecked = (0, react_1.useCallback)(function (value) {
        value = updateParentValue(groupAgents, value);
        setCheckedNode(value);
    }, [groupAgents]);
    return (react_1.default.createElement(drop_down_1.default, { className: style_module_scss_1.default["agent-group-select"], visible: dropDownVisible, onVisibleChange: onVisibleChange },
        react_1.default.createElement(drop_down_1.Trigger, null,
            !!TriggerComponent && react_1.default.createElement(TriggerComponent, null),
            !TriggerComponent && (react_1.default.createElement("span", { className: style_module_scss_1.default["trigger-span"] },
                triggerText,
                showNum && (agents === null || agents === void 0 ? void 0 : agents.length))),
            react_1.default.createElement(icon_1.CareDown, null)),
        react_1.default.createElement(drop_down_1.Menu, { className: style_module_scss_1.default["menu"] },
            react_1.default.createElement(drop_down_1.Menu.Item, null,
                react_1.default.createElement(Search, { value: keyWord, className: style_module_scss_1.default["search"], placeholder: placeholder, onChange: onSearchChange })),
            react_1.default.createElement(drop_down_1.Menu.Item, null,
                react_1.default.createElement("div", { className: style_module_scss_1.default["content"] },
                    filteredgroupAgents.length && (react_1.default.createElement(udesk_ui_1.Tree, { checkable: true, onCheck: onChecked, defaultExpandAll: true, treeData: filteredgroupAgents, checkedKeys: checkedNode })),
                    !filteredgroupAgents.length && (react_1.default.createElement(udesk_ui_1.Empty, { image: udesk_ui_1.Empty.PRESENTED_IMAGE_SIMPLE })))))));
};
exports.default = AgentGroupSelect;
function formGroupAgents(agents, currentAgents, currentUserGroups, allColleagueMonitorEnabled) {
    agents = agents || [];
    return agents.reduce(function (preValue, agent) {
        var currentAgent = currentAgents.find(function (cAgent) { return agent.id == cAgent.id; });
        if (!currentAgent) {
            return preValue;
        }
        else {
            var currentAgentUserGroups_1 = currentAgent.user_groups;
            if (!allColleagueMonitorEnabled) {
                currentAgentUserGroups_1 = currentUserGroups.filter(function (user) {
                    return currentAgentUserGroups_1.some(function (group) {
                        return group.id === user.id;
                    });
                });
            }
            return addGroupAgent(preValue, currentAgentUserGroups_1, agent);
        }
    }, []);
}
function addGroupAgent(groupAgents, groups, agent) {
    if (groups) {
        groups.forEach(function (group) {
            var _a;
            var groupAgent = groupAgents.find(function (ga) { return (ga === null || ga === void 0 ? void 0 : ga.key) == (group === null || group === void 0 ? void 0 : group.id); });
            var newAgent = {
                key: "".concat(group === null || group === void 0 ? void 0 : group.id, "-").concat(agent === null || agent === void 0 ? void 0 : agent.id),
                title: (react_1.default.createElement(TreeNode, { count: agent === null || agent === void 0 ? void 0 : agent.customers_count, key: "".concat(group === null || group === void 0 ? void 0 : group.id, "-").concat(agent === null || agent === void 0 ? void 0 : agent.id), title: agent === null || agent === void 0 ? void 0 : agent.name })),
                customersCount: agent.customers_count,
            };
            if (groupAgent) {
                if (groupAgent.children) {
                    groupAgent.children.push(newAgent);
                }
                else {
                    groupAgent.children = [newAgent];
                }
                //计算总客户数
                var totalCustomerNum = (_a = groupAgent.children) === null || _a === void 0 ? void 0 : _a.reduce(function (total, agent) {
                    return (total += agent.customersCount || 0);
                }, 0);
                groupAgent.title = (react_1.default.createElement(TreeNode, { count: totalCustomerNum, key: groupAgent === null || groupAgent === void 0 ? void 0 : groupAgent.key, title: groupAgent === null || groupAgent === void 0 ? void 0 : groupAgent.name }));
            }
            else {
                groupAgents.push({
                    key: group === null || group === void 0 ? void 0 : group.id,
                    title: (react_1.default.createElement(TreeNode, { count: agent === null || agent === void 0 ? void 0 : agent.customers_count, key: group === null || group === void 0 ? void 0 : group.id, title: group === null || group === void 0 ? void 0 : group.name })),
                    name: group === null || group === void 0 ? void 0 : group.name,
                    children: [newAgent],
                });
            }
        });
    }
    return groupAgents;
}
//如果子节点没有都选中,父节点不选中
function updateParentValue(treeData, value) {
    var result = [];
    result = value.filter(function (_v) {
        if (/^\d+$/.test(_v)) {
            if (treeData) {
                var node = treeData.find(function (data) {
                    return data.key === _v;
                });
                if (node && node.children) {
                    return node.children.every(function (children) {
                        return value.indexOf(children.key) !== -1;
                    });
                }
            }
            else {
                return true;
            }
        }
        else {
            return true;
        }
    });
    return result;
}
