"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var udesk_ui_1 = require("udesk-ui");
var react_1 = tslib_1.__importStar(require("react"));
var locale_1 = require("@udesk-webapp/locale");
var index_module_scss_1 = tslib_1.__importDefault(require("./index.module.scss"));
var utilities_1 = require("../../utilities");
var utils_1 = require("../../utils");
var AttachmentContent = function (props) {
    var item = props.item;
    var _a = item || {}, file_url = _a.file_url, file_name = _a.file_name, file_type = _a.file_type, id = _a.id;
    var t = (0, locale_1.useTranslation)().t;
    var _b = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext), onSend = _b.onSend, previewUrl = _b.previewUrl, isWorkbench = _b.isWorkbench;
    var onClickUseful = (0, react_1.useCallback)(function () {
        onSend === null || onSend === void 0 ? void 0 : onSend('attachment', item);
        (0, utilities_1.hit)(id, 'KnowledgeAttachment');
    }, [item, id, onSend]);
    var previewUrlFun = (0, react_1.useCallback)(function () {
        window.open((0, utils_1.getPreviewUrl)(file_url, { previewUrl: previewUrl }));
    }, [file_url, previewUrl]);
    var content = (0, react_1.useMemo)(function () { return (react_1.default.createElement("div", { className: index_module_scss_1.default['attachment-item'] },
        react_1.default.createElement("a", { key: '1', href: file_url, rel: 'noopener noreferrer', target: '_blank', className: index_module_scss_1.default['attachment-link'] }, file_name),
        react_1.default.createElement("div", { key: '2', className: index_module_scss_1.default['nodeOperations'] },
            (0, utils_1.canPreviewByFileName)(file_name) ? (react_1.default.createElement("div", { className: index_module_scss_1.default['lineBtns'] },
                react_1.default.createElement(udesk_ui_1.Button, { type: 'link', size: 'small', className: index_module_scss_1.default['line-btn-item'], onClick: function () { previewUrlFun(); } }, t('label.preview')),
                ' ',
                isWorkbench ? react_1.default.createElement("span", { className: index_module_scss_1.default['line'] }) : null)) : null,
            isWorkbench ? react_1.default.createElement(udesk_ui_1.Button, { type: 'link', size: 'small', className: index_module_scss_1.default['line-btn-item'], onClick: function () { onClickUseful(); } }, t('label.send')) : null))); }, [file_name, file_url, onClickUseful, previewUrlFun, t]);
    if (file_type.startsWith('image') || /png|jpg|jpeg|gif/.test(file_type)) {
        return (react_1.default.createElement(udesk_ui_1.Popover, { autoAdjustOverflow: false, content: react_1.default.createElement("img", { src: file_url, alt: file_name, style: { width: '100%' } }), placement: 'left', overlayStyle: { maxWidth: '300px', maxHeight: '300px' } }, content));
    }
    return react_1.default.createElement(react_1.default.Fragment, null, content);
};
exports.default = AttachmentContent;
