"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var index_module_less_1 = tslib_1.__importDefault(require("./index.module.less"));
var voice_1 = tslib_1.__importDefault(require("../icon/voice"));
var AudioType = react_1.default.memo(function (_a) {
    var _b;
    var msg = _a.msg;
    // const { src } = props.contentObject.data.content;
    var _c = (0, react_1.useState)(((_b = msg.data) === null || _b === void 0 ? void 0 : _b.duration) || 0), duration = _c[0], setDuration = _c[1];
    var _d = (0, react_1.useState)(false), isPlaying = _d[0], setIsPlaying = _d[1];
    // const audioRef = useRef<any>();
    var audioElement = (0, react_1.useMemo)(function () {
        console.log('audioElement', msg);
        var audio = window.document.createElement('audio');
        audio.src = msg.content || msg.data.content;
        return audio;
    }, [msg]);
    var startPlayAudio = function () {
        audioElement.play();
        setIsPlaying(true);
    };
    (0, react_1.useEffect)(function () {
        var audioObject = {
            loadedmetadata: function (e) {
                console.log('loadedmetadata', e);
                setDuration(function (v) { return v || Math.floor(e.target.duration); });
            },
            ended: function (e) {
                setIsPlaying(false);
            }
        };
        Object.entries(audioObject).forEach(function (_a) {
            var key = _a[0], value = _a[1];
            audioElement.addEventListener(key, value);
        });
        return function () {
            Object.entries(audioObject).forEach(function (_a) {
                var key = _a[0], value = _a[1];
                audioElement.removeEventListener(key, value);
            });
        };
    }, [audioElement]);
    return (react_1.default.createElement("div", { className: index_module_less_1.default['audio-container'], style: { backgroundColor: 'transparent', margin: 0, padding: 0 } },
        react_1.default.createElement("div", { className: index_module_less_1.default['audio-top'], onClick: startPlayAudio },
            react_1.default.createElement("span", { className: index_module_less_1.default['duration-black'] }, "".concat(duration, " \"")),
            isPlaying && react_1.default.createElement("span", { className: index_module_less_1.default['aduio-playing'] }),
            !isPlaying && react_1.default.createElement("span", { className: index_module_less_1.default['r-agent'] },
                " ",
                react_1.default.createElement(voice_1.default, null))),
        msg.loadingText &&
            // 具体样式 没见过  ==================wwd
            react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement("div", { className: index_module_less_1.default['audio-hr'] }),
                react_1.default.createElement("div", { className: index_module_less_1.default['audio-text'] },
                    react_1.default.createElement("div", { className: index_module_less_1.default['loading-img'] }))),
        msg.recognition &&
            // 具体样式 没见过  ==================wwd
            react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement("div", { className: index_module_less_1.default['audio-hr'] }),
                react_1.default.createElement("div", { className: index_module_less_1.default['audio-text'] }, msg.recognition))));
});
exports.default = AudioType;
