"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var index_module_less_1 = tslib_1.__importDefault(require("./index.module.less"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var react_i18next_1 = require("react-i18next");
var ChatRecordType = (0, react_1.memo)(function (_a) {
    var msg = _a.msg, openRecordCb = _a.openRecordCb, chatPlatform = _a.chatPlatform;
    var t = (0, react_i18next_1.useTranslation)().t;
    var typeMap = {
        image: t('img'),
        video: t('video'),
        file: t('label.file'),
        voice: t('voice'),
        emotion: t('expression'),
        chatrecord: t('chatRecord') //聊天记录
    };
    var content = (0, react_1.useMemo)(function () {
        return msg.content && JSON.parse(msg.content);
    }, [msg.content]);
    var initRecordContent = (0, react_1.useMemo)(function () {
        if (!content || !content.item || !content.item.length)
            return null;
        // 展示记录前三条的数据
        return content.item.slice(0, 3).map(function (item, index) {
            return (react_1.default.createElement("div", { key: index, className: (0, classnames_1.default)(index_module_less_1.default['chat-record-item'], index_module_less_1.default['ellipsis']) }, item.type === 'text'
                ? react_1.default.createElement("div", { className: index_module_less_1.default['ellipsis'], dangerouslySetInnerHTML: { __html: item.content } })
                : "[".concat(typeMap[item.type] || item.content, "]")));
        });
    }, [content]);
    var openRecordHandle = (0, react_1.useCallback)(function () {
        openRecordCb(content);
    }, [content]);
    return (react_1.default.createElement("div", { className: index_module_less_1.default['chat-record-wrapper'], onClick: openRecordHandle },
        react_1.default.createElement("h4", { className: (0, classnames_1.default)(index_module_less_1.default['chat-record-wrapper'], index_module_less_1.default['ellipsis']) }, content.title),
        initRecordContent));
});
exports.default = ChatRecordType;
