"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var style_module_scss_1 = __importDefault(require("./style.module.scss"));
var classnames_1 = __importDefault(require("classnames"));
var icon_1 = require("../icon/icon");
var react_i18next_1 = require("react-i18next");
var CheckBoxSelector = function (props) {
    // let newProps = { ...DEFAULT_PROPS, ...props };
    var t = (0, react_i18next_1.useTranslation)().t;
    var _a = props.options, options = _a === void 0 ? [] : _a, _b = props.value, value = _b === void 0 ? [] : _b, _c = props.idFieldName, idFieldName = _c === void 0 ? "id" : _c, _d = props.nameFieldName, nameFieldName = _d === void 0 ? "name" : _d, _e = props.trigger, trigger = _e === void 0 ? ["click"] : _e, _f = props.preText, preText = _f === void 0 ? "" : _f, _g = props.unit, unit = _g === void 0 ? t("unit") : _g, _h = props.className, className = _h === void 0 ? "" : _h, _j = props.AllText, AllText = _j === void 0 ? t("all") : _j, _k = props.searchPlaceholder, searchPlaceholder = _k === void 0 ? "" : _k, onChange = props.onChange, _l = props.showSearch, showSearch = _l === void 0 ? true : _l, getLabel = props.getLabel;
    var _m = (0, react_1.useState)(value), values = _m[0], setValues = _m[1];
    var _o = (0, react_1.useState)(""), keyword = _o[0], setKeyword = _o[1];
    var _p = (0, react_1.useState)(false), visible = _p[0], setVisible = _p[1];
    var _q = (0, react_1.useState)([]), innerOptions = _q[0], setInnerOptions = _q[1];
    var _getLabel = (0, react_1.useCallback)(function (option) {
        if (typeof getLabel === "function") {
            return getLabel(option);
        }
        else {
            return option[nameFieldName];
        }
    }, [getLabel, nameFieldName]);
    (0, react_1.useEffect)(function () {
        setInnerOptions(options);
    }, [options]);
    var onCheckboxChanged = (0, react_1.useCallback)(function (e, option) {
        var checked = e.target.checked;
        var id = option[idFieldName];
        var newValues = [];
        if (checked) {
            // eslint-disable-next-line eqeqeq
            var hasValue = values.some(function (value) { return value == id; });
            if (!hasValue) {
                newValues = __spreadArray(__spreadArray([], values, true), [id], false);
            }
        }
        else {
            newValues = values.filter(function (value) {
                // eslint-disable-next-line eqeqeq
                return value != id;
            });
            newValues = __spreadArray([], newValues, true);
        }
        if (typeof onChange === "function") {
            onChange(newValues);
        }
        setValues(newValues);
    }, [idFieldName, onChange, values]);
    var onKeywordChanged = (0, react_1.useCallback)(function (e) {
        var keyword = e.target.value;
        setKeyword(e.target.value);
        if (options && keyword) {
            var optionResult = options.filter(function (option) {
                var name = option[nameFieldName];
                return name && name.indexOf(keyword) !== -1;
            });
            setInnerOptions(optionResult);
        }
        else {
            setInnerOptions(options);
        }
    }, [nameFieldName, options]);
    var createMenu = (0, react_1.useCallback)(function (options) {
        return (react_1.default.createElement(udesk_ui_1.Menu, { className: style_module_scss_1.default["option-list"] },
            !!showSearch && (react_1.default.createElement(udesk_ui_1.Menu.Item, { key: "-1" },
                react_1.default.createElement("div", { className: style_module_scss_1.default["search"] },
                    react_1.default.createElement(udesk_ui_1.Input.Search, { className: style_module_scss_1.default["search-input"], placeholder: searchPlaceholder, value: keyword, onChange: onKeywordChanged })))),
            react_1.default.createElement(udesk_ui_1.Menu.Item, null,
                react_1.default.createElement(udesk_ui_1.List, { dataSource: options, className: style_module_scss_1.default["list"], size: "small", renderItem: function (option) {
                        var id = option[idFieldName];
                        return (react_1.default.createElement(udesk_ui_1.List.Item, { className: style_module_scss_1.default["list-item"], key: id },
                            react_1.default.createElement(udesk_ui_1.Checkbox, { checked: !!isInValue(values, id), onChange: function (e) {
                                    onCheckboxChanged(e, option);
                                } }, _getLabel(option))));
                    } }))));
    }, [
        idFieldName,
        keyword,
        onCheckboxChanged,
        onKeywordChanged,
        searchPlaceholder,
        showSearch,
        values,
        _getLabel,
    ]);
    var onVisibleChange = (0, react_1.useCallback)(function (value) {
        setVisible(value);
    }, []);
    var selectedName = "";
    if ((values === null || values === void 0 ? void 0 : values.length) === 1) {
        // eslint-disable-next-line eqeqeq
        var selectedOption = options.find(function (option) { return option[idFieldName] == values[0]; });
        selectedName = selectedOption === null || selectedOption === void 0 ? void 0 : selectedOption[nameFieldName];
    }
    return (react_1.default.createElement("div", { className: (0, classnames_1.default)(style_module_scss_1.default["checkbox-selector"], className) },
        react_1.default.createElement(udesk_ui_1.Dropdown, { overlay: createMenu(innerOptions), visible: visible, onVisibleChange: onVisibleChange, trigger: trigger },
            react_1.default.createElement("span", null,
                (values === null || values === void 0 ? void 0 : values.length) > 1 && (react_1.default.createElement(react_1.Fragment, null,
                    preText, values === null || values === void 0 ? void 0 :
                    values.length,
                    unit)),
                (values === null || values === void 0 ? void 0 : values.length) === 1 && (react_1.default.createElement(react_1.Fragment, null,
                    preText,
                    selectedName)),
                !(values === null || values === void 0 ? void 0 : values.length) && (react_1.default.createElement(react_1.Fragment, null,
                    preText,
                    AllText)),
                react_1.default.createElement(icon_1.CareDown, null)))));
};
exports.default = CheckBoxSelector;
function isInValue(values, id) {
    if (!values || id == null) {
        return;
    }
    if (!Array.isArray(values)) {
        values = [values];
    }
    // eslint-disable-next-line eqeqeq
    return values.find(function (value) { return value == id; });
}
