"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var index_module_scss_1 = __importDefault(require("./index.module.scss"));
var react_i18next_1 = require("react-i18next");
var react_copy_to_clipboard_1 = __importDefault(require("react-copy-to-clipboard"));
var CopyComponent = function (props) {
    var t = (0, react_i18next_1.useTranslation)().t;
    // 默认显示在右上角，不能默认显示在容器外面，因为外层容器上设置了overflow:hidden，这样复制按钮就显示不出来了。
    // 而设置overflow:hidden的原因是为了内容过长时，显示省略号...
    var text = props.text, _a = props.left, left = _a === void 0 ? '0px' : _a, _b = props.top, top = _b === void 0 ? '-30px' : _b, _c = props.bottom, bottom = _c === void 0 ? '' : _c, _d = props.switchFlag, switchFlag = _d === void 0 ? false : _d;
    var buttonStyle = {
        position: 'absolute',
        left: left,
        top: top,
        bottom: bottom,
        zIndex: 999,
        visibility: 'hidden',
    };
    var _e = (0, react_1.useState)(buttonStyle), copyStyle = _e[0], setCopyStyle = _e[1];
    var showButton = (0, react_1.useCallback)(function (e) {
        setCopyStyle(__assign(__assign({}, copyStyle), { visibility: text === '' || text === null || text === undefined ? 'hidden' : 'visible' }));
    }, [copyStyle, text]);
    var hideButton = (0, react_1.useCallback)(function (e) {
        setCopyStyle(__assign(__assign({}, copyStyle), { visibility: 'hidden' }));
    }, [copyStyle]);
    var copyText = (0, react_1.useCallback)(function (text, result) {
        if (result) {
            udesk_ui_1.message.info(t('tip.copySuccess'));
        }
        else {
            udesk_ui_1.message.error(t('tip.copySuccess'));
        }
    }, [t]);
    var buttonIcon = (0, react_1.useMemo)(function () {
        return (react_1.default.createElement(udesk_ui_1.Button, { size: 'small', style: copyStyle }, t('label.copy')));
    }, [copyStyle, t]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        switchFlag && (react_1.default.createElement("div", { onMouseEnter: showButton, onMouseLeave: hideButton, className: "".concat(index_module_scss_1.default['copy-container'], " ").concat(props.hidden ? index_module_scss_1.default['hidden'] : '') },
            react_1.default.createElement(react_copy_to_clipboard_1.default, { text: text, onCopy: copyText }, buttonIcon),
            react_1.default.createElement("div", { className: "copy-children" }, props.children))),
        !switchFlag && (react_1.default.createElement("div", { className: "".concat(index_module_scss_1.default['copy-container'], " ").concat(props.hidden ? index_module_scss_1.default['hidden'] : '') }, props.children))));
};
exports.default = CopyComponent;
