"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var style_module_scss_1 = __importDefault(require("./style.module.scss"));
var icons_1 = require("@ant-design/icons/lib/icons");
var udesk_ui_1 = require("udesk-ui");
var field_type_component_1 = __importDefault(require("./field-type-component"));
var isFunction_1 = __importDefault(require("lodash-es/isFunction"));
var CustomFieldItem = function (_a) {
    var fieldItem = _a.fieldItem, isFormItem = _a.isFormItem, _b = _a.switchFlag, switchFlag = _b === void 0 ? false : _b, agents = _a.agents, props = __rest(_a, ["fieldItem", "isFormItem", "switchFlag", "agents"]);
    var fromLabel = function () {
        return (react_1.default.createElement("div", { className: style_module_scss_1.default["item-label"] },
            fieldItem.isRequired && react_1.default.createElement("span", { style: { color: "red" } }, "*"),
            react_1.default.createElement("span", { style: { marginRight: "5px" } },
                fieldItem.label,
                ":"),
            fieldItem.layout !== "horizontal" &&
                fieldItem.tooltipShow &&
                fieldItem.tooltip && (react_1.default.createElement(udesk_ui_1.Tooltip, { title: fieldItem.tooltip },
                react_1.default.createElement(icons_1.QuestionCircleOutlined, null)))));
    };
    return (react_1.default.createElement(react_1.default.Fragment, null, isFormItem ? (react_1.default.createElement(udesk_ui_1.Form.Item, __assign({}, props, { label: fromLabel(), name: fieldItem.field.id, trigger: fieldItem.field.trigger || "onChange", rules: (0, isFunction_1.default)(fieldItem.field.customValidFn)
            ? [
                {
                    validator: fieldItem.field.customValidFn,
                },
            ]
            : undefined }),
        react_1.default.createElement(field_type_component_1.default, __assign({ switchFlag: switchFlag }, fieldItem.field, { isFormItem: isFormItem, notUseDefault: props.notUseDefault, agents: agents })))) : (react_1.default.createElement("div", { className: "".concat(style_module_scss_1.default["field-item"], " ").concat(fieldItem.layout === "horizontal"
            ? style_module_scss_1.default["field-item-horizontal"]
            : "") },
        fromLabel(),
        react_1.default.createElement("div", { className: style_module_scss_1.default["item-content"] },
            react_1.default.createElement(field_type_component_1.default, __assign({ switchFlag: switchFlag }, fieldItem.field, { isFormItem: false, agents: agents })))))));
};
exports.default = CustomFieldItem;
