"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var apis_1 = __importDefault(require("../../utils/apis"));
var index_module_scss_1 = __importDefault(require("./index.module.scss"));
var icon_1 = require("../icon/icon");
var icons_1 = require("@ant-design/icons");
var react_i18next_1 = require("react-i18next");
var useDebounce_1 = __importDefault(require("react-use/esm/useDebounce"));
var DEFAULT_PAGE = 1;
var DEFAULT_PAGE_SIZE = 20;
var DEFAULT_TOTAL_PAGE = 0;
var CustomerAutoComplete = function (props) {
    var t = (0, react_i18next_1.useTranslation)().t;
    var _a = (0, react_1.useState)(false), fetching = _a[0], setFetching = _a[1];
    var _b = (0, react_1.useState)(DEFAULT_PAGE), page = _b[0], setPage = _b[1];
    var _c = (0, react_1.useState)([]), data = _c[0], setData = _c[1]; //搜索到的数据
    var _d = (0, react_1.useState)(""), searchValue = _d[0], setSearchValue = _d[1];
    var _e = (0, react_1.useState)(DEFAULT_TOTAL_PAGE), totalPages = _e[0], setTotalPages = _e[1];
    var selectRef = (0, react_1.useRef)(null);
    var _f = props.showArrow, showArrow = _f === void 0 ? true : _f, _g = props.labelInValue, labelInValue = _g === void 0 ? true : _g, value = props.value, _h = props.placeholder, placeholder = _h === void 0 ? t("components.customerAutoComplete.selectCustomer") : _h, _j = props.filterOption, filterOption = _j === void 0 ? false : _j, _k = props.showSearchModal, showSearchModal = _k === void 0 ? false : _k, onChange = props.onChange;
    var notFoundContent = (0, react_1.useMemo)(function () {
        return fetching && react_1.default.createElement(udesk_ui_1.Spin, { size: "small" });
    }, [fetching]);
    var fetchUser = (0, react_1.useCallback)(function (searchValue, page) {
        setFetching(true);
        apis_1.default
            .postUser({
            params: {
                page: page,
                page_size: DEFAULT_PAGE_SIZE,
                prefix: searchValue,
            },
        })
            .then(function (res) {
            var _a;
            if ((res === null || res === void 0 ? void 0 : res.code) === 1000) {
                setTotalPages((_a = res === null || res === void 0 ? void 0 : res.meta) === null || _a === void 0 ? void 0 : _a.total_pages);
                setPage(res.meta.current_page);
                var orgs_1 = res.organizations;
                setData(function (v) {
                    if (v === void 0) { v = []; }
                    var customers = res.customers.map(function (i) { return (__assign(__assign({}, i), { organizations: i.organizations
                            .map(function (j) { return orgs_1.find(function (l) { return l.id === j; }); })
                            .filter(Boolean) })); });
                    return __spreadArray(__spreadArray([], v, true), customers, true);
                });
            }
            setFetching(false);
        })
            .catch(function () { return setFetching(false); });
    }, []);
    var handleChange = (0, react_1.useCallback)(function (value) {
        onChange && onChange(value);
        setFetching(false);
    }, [onChange]);
    var beforeSearch = (0, react_1.useCallback)(function (searchValue) {
        setSearchValue(searchValue);
        setData([]);
        setPage(DEFAULT_PAGE);
    }, []);
    (0, useDebounce_1.default)(function () {
        fetchUser(searchValue, 1);
    }, 500, [searchValue]);
    //处理滚动事假
    var handleScroll = (0, react_1.useCallback)(function (e) {
        if (e.currentTarget.scrollTop ===
            e.currentTarget.scrollHeight - e.currentTarget.clientHeight) {
            if (page < totalPages) {
                fetchUser(searchValue, page + 1);
            }
        }
    }, [page, totalPages, fetchUser, searchValue]);
    var suffixIcon = (0, react_1.useMemo)(function () {
        return (react_1.default.createElement(react_1.default.Fragment, null,
            showSearchModal && (react_1.default.createElement("div", { className: index_module_scss_1.default["search-icon"] },
                react_1.default.createElement(icon_1.Search, null))),
            !showSearchModal && react_1.default.createElement(icons_1.DownOutlined, null)));
    }, [showSearchModal]);
    return (react_1.default.createElement("div", { style: { display: "flex" } },
        react_1.default.createElement(udesk_ui_1.Select, { showSearch: true, showArrow: showArrow, labelInValue: labelInValue, value: value, placeholder: placeholder, notFoundContent: notFoundContent, filterOption: filterOption, onSearch: beforeSearch, onChange: handleChange, style: { width: "100%", minWidth: 120 }, getPopupContainer: function (triggerNode) { return triggerNode; }, suffixIcon: suffixIcon, onPopupScroll: handleScroll, allowClear: true, dropdownMatchSelectWidth: false, optionLabelProp: "title", ref: selectRef, listItemHeight: 54 }, data.map(function (d) { return (react_1.default.createElement(udesk_ui_1.Select.Option, { title: "".concat(d.nick_name).concat(d.organizations.length ? "\uFF08".concat(d.organizations[0].name, "\uFF09") : ""), key: d.id, value: d.id },
            d.nick_name,
            d.organizations.length ? "\uFF08".concat(d.organizations[0].name, "\uFF09") : null,
            react_1.default.createElement("br", null),
            d.description || "\u00A0")); }))));
};
exports.default = CustomerAutoComplete;
