"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var dompurify_1 = tslib_1.__importDefault(require("dompurify"));
var index_module_less_1 = tslib_1.__importDefault(require("./index.module.less"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var react_i18next_1 = require("react-i18next");
var utils_1 = require("@udesk-webapp/utils");
var utilities_1 = require("../utilities");
var EmailType = (0, react_1.memo)(function (_a) {
    var msg = _a.msg;
    var subject = msg.subject, from = msg.from, to = msg.to, cc = msg.cc, thumbnail = msg.thumbnail, content = msg.content, data = msg.data;
    var t = (0, react_i18next_1.useTranslation)().t;
    var imgRex = /<img.*?\/?>/g;
    var thumbnailFormat = dompurify_1.default.sanitize(thumbnail);
    var contentFormat = dompurify_1.default.sanitize(content);
    var _b = (0, react_1.useState)(false), visible = _b[0], setVisible = _b[1];
    var handleUrl = function (url) {
        return url.replace(/\+/g, '%2B');
    };
    var imgHTML = (0, react_1.useMemo)(function () {
        // 获取缩略文本中第一张图片的HTML
        var matches = thumbnailFormat.match(imgRex);
        return matches && matches.length ? matches[0] : '';
    }, [thumbnailFormat]);
    var text = (0, react_1.useMemo)(function () {
        return thumbnailFormat.replace(imgRex, '').replace(/&nbsp;/gi, ' ');
    }, [thumbnailFormat]);
    var attachments = (0, react_1.useMemo)(function () {
        if (!data.attachments || !data.attachments.length)
            return null;
        return data.attachments.map(function (attach, index) {
            return react_1.default.createElement("div", { className: index_module_less_1.default['attach'], key: index },
                react_1.default.createElement("img", { className: index_module_less_1.default['file-img'], src: (0, utilities_1.getFileType)(".".concat(attach.suffix)) }),
                react_1.default.createElement(udesk_ui_1.Popover, { content: attach.name },
                    react_1.default.createElement("a", { className: index_module_less_1.default['file-name'], href: handleUrl(attach.url), target: '_blank', rel: "noopener noreferrer", download: attach.name }, attach.name)),
                react_1.default.createElement("span", { className: index_module_less_1.default['file-size'] },
                    "(",
                    (0, utils_1.humanFileSize)(attach.size),
                    ")"));
        });
    }, [data.attachments]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: index_module_less_1.default['email-wrapper'] },
            react_1.default.createElement("div", { className: index_module_less_1.default['thumbnail-content'] },
                react_1.default.createElement("div", { className: index_module_less_1.default['info'] },
                    react_1.default.createElement("h4", { className: index_module_less_1.default['ellipsis'] },
                        t('label.subject'),
                        ": ",
                        subject),
                    react_1.default.createElement("div", { className: index_module_less_1.default['ellipsis'] },
                        t('components.email_form.from'),
                        ": ",
                        from),
                    react_1.default.createElement("div", { className: index_module_less_1.default['ellipsis'] },
                        t('components.email_form.to'),
                        ": ",
                        to),
                    react_1.default.createElement("div", { className: index_module_less_1.default['ellipsis'] },
                        t('components.email_form.cc'),
                        ": ",
                        cc),
                    react_1.default.createElement("div", { className: (0, classnames_1.default)(index_module_less_1.default['text'], index_module_less_1.default['ellipsis']) }, text)),
                react_1.default.createElement("div", { className: index_module_less_1.default['image'], dangerouslySetInnerHTML: { __html: imgHTML } })),
            react_1.default.createElement("div", { className: index_module_less_1.default['attach-list'] }, attachments),
            react_1.default.createElement(udesk_ui_1.Button, { className: index_module_less_1.default['detail-btn'], onClick: function () { return setVisible(true); } }, t('emailMethod.emailDetail'))),
        react_1.default.createElement(udesk_ui_1.Modal, { title: t('emailMethod.emailDetail'), visible: visible, width: 1600, footer: null, onCancel: function () { return setVisible(false); }, className: index_module_less_1.default['detail-modal'] },
            react_1.default.createElement("div", { className: (0, classnames_1.default)(index_module_less_1.default['email-wrapper'], index_module_less_1.default['detail']) },
                react_1.default.createElement("h4", null,
                    t('label.subject'),
                    ": ",
                    subject),
                react_1.default.createElement("div", null,
                    t('components.email_form.from'),
                    ": ",
                    from),
                react_1.default.createElement("div", null,
                    t('components.email_form.to'),
                    ": ",
                    to),
                react_1.default.createElement("div", null,
                    t('components.email_form.cc'),
                    ": ",
                    cc),
                react_1.default.createElement("div", { className: index_module_less_1.default['content'], dangerouslySetInnerHTML: { __html: contentFormat } }),
                react_1.default.createElement("div", { className: index_module_less_1.default['attach-list'] }, attachments)))));
});
exports.default = EmailType;
