"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var udesk_ui_1 = require("udesk-ui");
var react_1 = tslib_1.__importStar(require("react"));
var locale_1 = require("@udesk-webapp/locale");
var dompurify_1 = tslib_1.__importDefault(require("dompurify"));
var repository_widget_1 = require("../../utils/repository-widget");
var utilities_1 = require("../../utilities");
var index_module_scss_1 = tslib_1.__importDefault(require("./index.module.scss"));
function replaceWrapAndSpace(str) {
    if (str) {
        str = str.replace(/[\n\r]/g, '<br>').replace(/[\n]/g, '<br>').replace(/[\s]/g, '&nbsp;');
    }
    else {
        str = '';
    }
    return str;
}
var ExpressionContent = function (props) {
    var item = props.item;
    var _a = (item || {}).content, content = _a === void 0 ? '' : _a;
    var safeContent = dompurify_1.default.sanitize(content);
    var t = (0, locale_1.useTranslation)().t;
    var _b = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext), onUse = _b.onUse, isWorkbench = _b.isWorkbench, agent = _b.agent, customer = _b.customer, organizations = _b.organizations, ticket = _b.ticket, ticketCustomFields = _b.ticketCustomFields, customerCustomFields = _b.customerCustomFields, customerFieldAbilities = _b.customerFieldAbilities;
    var onClickUseful = function (item) {
        if (!isWorkbench)
            return;
        if (item) {
            (0, repository_widget_1.replacePlaceholder)(item.content, {
                customer: customer,
                organizations: organizations,
                agent: agent,
                ticket: ticket,
                customerCustomFields: customerCustomFields,
                ticketCustomFields: ticketCustomFields,
                t: t,
                customerFieldAbilities: customerFieldAbilities,
            }).then(function (content) {
                onUse === null || onUse === void 0 ? void 0 : onUse('useful_expression', tslib_1.__assign(tslib_1.__assign({}, item), { content: content }));
            });
            (0, utilities_1.hit)(item.id, 'UsefulExpression');
        }
    };
    return (react_1.default.createElement("div", { className: "".concat(index_module_scss_1.default['expression-item-wrap'], " ").concat(index_module_scss_1.default['highlight']) },
        react_1.default.createElement(udesk_ui_1.Popover, { overlayClassName: index_module_scss_1.default.expressionPopover, placement: 'left', destroyTooltipOnHide: true, content: react_1.default.createElement("div", { className: index_module_scss_1.default['useful-popover-content'], dangerouslySetInnerHTML: { __html: replaceWrapAndSpace(safeContent) } }) },
            react_1.default.createElement("p", { onClick: function () { return onClickUseful(item); }, className: index_module_scss_1.default['expression-item'], dangerouslySetInnerHTML: { __html: safeContent } }))));
};
exports.default = ExpressionContent;
