"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
/* eslint-disable jsx-a11y/anchor-has-content */
var react_1 = tslib_1.__importStar(require("react"));
var utilities_1 = require("../utilities");
var react_i18next_1 = require("react-i18next");
var index_module_less_1 = tslib_1.__importDefault(require("./index.module.less"));
var pdf02_png_1 = tslib_1.__importDefault(require("../images/pdf02.png"));
var word02_png_1 = tslib_1.__importDefault(require("../images/word02.png"));
var excel02_png_1 = tslib_1.__importDefault(require("../images/excel02.png"));
var ppt02_png_1 = tslib_1.__importDefault(require("../images/ppt02.png"));
var txt02_png_1 = tslib_1.__importDefault(require("../images/txt02.png"));
var unknow02_png_1 = tslib_1.__importDefault(require("../images/unknow02.png"));
var stringToHex = (function (str) {
    var hexResult = [];
    for (var i = 0; i < str.length; i++) {
        var hex = str.charCodeAt(i).toString(16);
        hexResult.push(hex);
    }
    return hexResult.join('');
});
var FileType = react_1.default.memo(function (_a) {
    var msg = _a.msg, previewURL = _a.previewURL, allowPreview = _a.allowPreview;
    //多语言配置
    var t = (0, react_i18next_1.useTranslation)().t;
    var canVideoExts = ['mp4', 'mov', 'MOV', 'm4v', 'M4V'];
    var getPreviewUrl = (0, react_1.useCallback)(function (url, encodeUrl) {
        if (!url) {
            return '';
        }
        if (encodeUrl) {
            url = encodeURIComponent(decodeURIComponent(url));
            url = url.replace(/%2F/g, '/');
        }
        var hexUrl;
        try {
            hexUrl = stringToHex(url);
        }
        catch (e) {
            console.error('preview-url-helper', e);
            return url;
        }
        return "".concat(previewURL, "/wopi/files/").concat(hexUrl, "/documents");
    }, [previewURL]);
    var _href = (0, react_1.useMemo)(function () {
        var content = msg.content, href = '', reg2 = /\.((doc)|(docx)|(odt)|(rtf)|(wps)|(ppt)|(pptx)|(odp)|(dp)|(xls)|(xlsx)|(ods)|(csv)|(et)|(pdf))$/g;
        if (content.match(reg2) && allowPreview) {
            href = getPreviewUrl(content, true);
        }
        return href;
    }, [allowPreview, getPreviewUrl, msg.content]);
    var handlerUrl = (0, react_1.useCallback)(function (url) {
        return url.replace(/\+/g, '%2B');
    }, []);
    var _type = (0, react_1.useMemo)(function () {
        var _a;
        var list = (_a = msg === null || msg === void 0 ? void 0 : msg.filename) === null || _a === void 0 ? void 0 : _a.split('.');
        var filenameType = list[list.length - 1];
        var type = '.' + (msg.fileext || filenameType);
        if (/\.(pdf)/.test(type)) {
            type = pdf02_png_1.default;
        }
        else if (/\.(doc|docx|odt)/.test(type)) {
            type = word02_png_1.default;
        }
        else if (/\.(xls|xlsx|csv)/.test(type)) {
            type = excel02_png_1.default;
        }
        else if (/\.(ppt|pptx)/.test(type)) {
            type = ppt02_png_1.default;
        }
        else if (/\.(txt)/.test(type)) {
            type = txt02_png_1.default;
        }
        else {
            type = unknow02_png_1.default;
        }
        return type;
    }, [msg.type]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        canVideoExts.indexOf(msg.fileext) > -1 &&
            react_1.default.createElement("video", { src: (0, utilities_1.update_sdk_url)(msg.content, msg), style: { maxWidth: '100%', maxHeight: '480px' }, controls: true },
                t('page.im.log.videoAddress'),
                "\uFF1A",
                msg.content),
        canVideoExts.indexOf(msg.content.fileext) === -1 &&
            react_1.default.createElement("div", { className: index_module_less_1.default['file-wrapper'] },
                react_1.default.createElement("div", null,
                    react_1.default.createElement("img", { className: index_module_less_1.default['file-img'], src: _type, alt: msg.filename })),
                react_1.default.createElement("div", { className: index_module_less_1.default['file-div'] },
                    react_1.default.createElement("a", { className: index_module_less_1.default['filename'], href: (0, utilities_1.update_sdk_url)(msg.is_receive ? msg.content : handlerUrl(msg.content), msg), target: '_blank', rel: "noopener noreferrer", download: msg.filename }, msg.filename),
                    react_1.default.createElement("div", { className: index_module_less_1.default['filesize'] },
                        react_1.default.createElement("div", { className: index_module_less_1.default['file-size'], style: { marginRight: '6px' } }, msg.filesize),
                        _href && react_1.default.createElement("a", { href: _href, style: { marginRight: '6px' }, target: '_blank', rel: "noopener noreferrer" }, t('page.im.log.preview')),
                        react_1.default.createElement("a", { href: (0, utilities_1.update_sdk_url)(msg.is_receive ? msg.content : handlerUrl(msg.content), msg), target: '_blank', rel: "noopener noreferrer", download: msg.filename }, t('page.im.log.download')))))));
});
exports.default = FileType;
