import React from "react";
declare type ParamsType = {
    query?: string;
    scope?: Scope;
    per_page?: number;
    page?: number;
    current_works?: boolean;
    catalog_id?: number | string;
    knowledge_catalog_id?: number;
};
declare type ResDataType = IExpression[] | IQuestion[] | ILink[] | IAttachment[];
export declare type CatalogDataType = {
    id: number;
    name: string;
    parent_id: number;
    sort: number;
    subitem_count: number;
    children: CatalogDataType[];
};
/**
 *
 * @param knowledgeType
 * @returns 输入框search搜索结果的hooks，提供searchList方法做搜索
 */
export declare const useSearchList: (knowledgeType: RepositoryType) => {
    listLoading: boolean;
    listData: ResDataType;
    pagingRef: React.MutableRefObject<{
        current_page: number;
        total_pages: number;
    }>;
    searchList: (params: ParamsType) => void;
};
/**
 *
 * @param knowledgeType
 * @param scope
 * @returns 知识库分类的树形组件hooks，提供缓存和初始化接口查询，判断一次请求是否超过1000条，是的话默认只请求前面几条并默认打开。
 * 并提供树形懒加载方法
 */
export declare const useCatalogs: (knowledgeType: any, scope: any, stashKey: any, matchTagList: any) => {
    catalogLoading: boolean;
    catalogData: CatalogDataType[];
    catalogList: {};
    loadList: (key: any) => Promise<void>;
    expandedKeys: number[];
    setExpandedKeys: (keys: any) => void;
};
export {};
