"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var utilities_1 = require("../utilities");
var broken_image_png_1 = tslib_1.__importDefault(require("../images/broken-image.png"));
var LinkOutlined_1 = tslib_1.__importDefault(require("@ant-design/icons/LinkOutlined"));
var ReloadOutlined_1 = tslib_1.__importDefault(require("@ant-design/icons/ReloadOutlined"));
var index_module_less_1 = tslib_1.__importDefault(require("./index.module.less"));
var react_i18next_1 = require("react-i18next");
var ImageType = react_1.default.memo(function (_a) {
    var msg = _a.msg, reloadImageTimes = _a.reloadImageTimes;
    var _b = (0, react_1.useState)(false), imgError = _b[0], setImgError = _b[1];
    var reloadTimes = (0, react_1.useRef)(0);
    var t = (0, react_i18next_1.useTranslation)().t;
    var content = (0, react_1.useMemo)(function () {
        if (!msg.__chat_platform || !['weixin_mini', 'qywx', 'wechat', 'weixin_kf'].includes(msg.__chat_platform)) {
            return (msg.content || '').replace(/https:|http:/, '');
        }
        else {
            return msg.content;
        }
    }, [msg.__chat_platform, msg.content]);
    var handlerUrl = (0, react_1.useCallback)(function (url) {
        return url.replace(/\+/g, '%2B');
    }, []);
    var reloadImage = function () {
        setImgError(false);
        if (reloadTimes.current >= 5) {
            reloadImageTimes();
            return;
        }
        reloadTimes.current += 1;
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        (content || msg.origin_url)
            ? ((!imgError)
                ? react_1.default.createElement("img", { className: "image-show", src: (0, utilities_1.update_sdk_url)((0, utilities_1.imageThumbnail)(content ? (msg.is_receive ? content : handlerUrl(content)) : broken_image_png_1.default, msg.file_policy || '', msg.filesize), msg) || msg.origin_url, "data-policy": msg.file_policy, onError: function () {
                        setImgError(true);
                    }, alt: '' })
                : react_1.default.createElement("div", { className: index_module_less_1.default['image-reload'], onClick: reloadImage },
                    react_1.default.createElement(ReloadOutlined_1.default, { className: index_module_less_1.default['image-reload-icon'] }),
                    react_1.default.createElement("span", { className: index_module_less_1.default['image-reload-text'] }, t('page.im.imMessages.reloadImage'))))
            : null,
        (!content && msg.origin_url) &&
            react_1.default.createElement("a", { href: msg.origin_url, target: "_blank", rel: "noopener noreferrer" },
                react_1.default.createElement(LinkOutlined_1.default, null)),
        (function () {
            if (content && imgError) {
                return react_1.default.createElement("a", { href: content, target: "_blank", rel: "noopener noreferrer" },
                    react_1.default.createElement(LinkOutlined_1.default, null));
            }
            return null;
        })()));
});
exports.default = ImageType;
