"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var udesk_ui_1 = require("udesk-ui");
var react_1 = tslib_1.__importStar(require("react"));
var locale_1 = require("@udesk-webapp/locale");
var dompurify_1 = tslib_1.__importDefault(require("dompurify"));
var utilities_1 = require("../../utilities");
var index_module_scss_1 = tslib_1.__importDefault(require("./index.module.scss"));
var LinkContent = function (props) {
    var item = props.item;
    if (!item)
        return null;
    var t = (0, locale_1.useTranslation)().t;
    var id = item.id, name = item.name, mode = item.mode;
    var _a = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext), isWorkbench = _a.isWorkbench, onUse = _a.onUse;
    var safeContent = dompurify_1.default.sanitize(name);
    var onClickUseful = function (item) {
        if (!isWorkbench)
            return;
        if (item) {
            onUse === null || onUse === void 0 ? void 0 : onUse('useful_link', item);
            (0, utilities_1.hit)(item.id, 'UsefulLink');
        }
    };
    return (react_1.default.createElement("div", { className: index_module_scss_1.default['link-item-wrap'], onClick: function () { return onClickUseful(item); } },
        react_1.default.createElement("p", { className: "".concat(index_module_scss_1.default['link-item'], " ").concat(index_module_scss_1.default['highlight']), dangerouslySetInnerHTML: { __html: safeContent } }),
        (mode === 'mini' || mode === 'mini_card') && isWorkbench ? (react_1.default.createElement(udesk_ui_1.Button, { type: 'link', size: 'small' }, t('label.send'))) : null));
    // icon: mode === 'mini' || mode === 'mini_card' ? (<MiniProgram />) : (<LinkOutlined />),
};
exports.default = LinkContent;
