"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var index_module_scss_1 = tslib_1.__importDefault(require("./index.module.scss"));
var useCatalog_1 = require("../hooks/useCatalog");
var udesk_ui_1 = require("udesk-ui");
var locale_1 = require("@udesk-webapp/locale");
var ListTemplate = function (props) {
    var _a;
    var knowledgeType = props.knowledgeType, query = props.query, scope = props.scope, ItemNode = props.itemNode;
    var pageNumberRef = (0, react_1.useRef)(1);
    var _b = (0, useCatalog_1.useSearchList)(knowledgeType), searchList = _b.searchList, listData = _b.listData, listLoading = _b.listLoading, pagingRef = _b.pagingRef;
    var t = (0, locale_1.useTranslation)().t;
    var listParams = (0, react_1.useCallback)(function (page) {
        var p = {
            scope: scope,
            per_page: 20,
            page: page,
            query: query,
        };
        if (knowledgeType === 'attachment') {
            p.catalog_id = 'all';
        }
        else if (knowledgeType === 'question') {
            p.current_works = true;
        }
        return p;
    }, [query, scope, knowledgeType]);
    (0, react_1.useEffect)(function () {
        pageNumberRef.current = 1;
        searchList(listParams(1));
    }, [listParams]);
    var hasMore = pageNumberRef.current < ((_a = pagingRef.current) === null || _a === void 0 ? void 0 : _a.total_pages);
    var loadMore = function () {
        pageNumberRef.current += 1;
        searchList(listParams(pageNumberRef.current));
    };
    var onScroll = function (e) {
        // 滚动到了底部
        var obj = e.currentTarget;
        if (obj.scrollTop === (obj.scrollHeight - obj.offsetHeight)) {
            if (listLoading)
                return;
            if (!hasMore)
                return;
            loadMore();
        }
    };
    var loadMoreBtn = hasMore ? react_1.default.createElement("div", { className: index_module_scss_1.default['flex'] },
        react_1.default.createElement(udesk_ui_1.Button, { className: index_module_scss_1.default['m-auto'], type: 'link', onClick: loadMore }, t('label.load_more'))) : null;
    if (!listLoading && listData && !listData.length) {
        return react_1.default.createElement(udesk_ui_1.Empty, { className: 'h-full w-hull flex justify-center items-center flex-col' });
    }
    return (react_1.default.createElement("div", { onScroll: onScroll, className: index_module_scss_1.default['repository-virtualList-wrapper'] },
        listData.map(function (item, index) {
            return react_1.default.createElement(ItemNode, { item: item, key: index });
        }),
        listLoading ? (react_1.default.createElement("div", { className: index_module_scss_1.default['repository-loading'] },
            react_1.default.createElement(udesk_ui_1.Spin, { className: 'w-full text-center' }))) : loadMoreBtn));
};
exports.default = react_1.default.memo(ListTemplate);
