"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var index_module_less_1 = tslib_1.__importDefault(require("./index.module.less"));
// import Wave1 from '../icon/wave1';
// import Wave2 from '../icon/wave2';
// import Wave3 from '../icon/wave3';
// import Wave4 from '../icon/wave4';
var wave5_1 = tslib_1.__importDefault(require("../icon/wave5"));
var wave6_1 = tslib_1.__importDefault(require("../icon/wave6"));
var wave7_1 = tslib_1.__importDefault(require("../icon/wave7"));
var MessageVideo = react_1.default.memo(function (props) {
    var _a = (0, react_1.useState)(null), playingMsgVoice = _a[0], setPlayingMsgVoice = _a[1];
    // const { src } = props.contentObject.data.content;
    var _b = (0, react_1.useState)(-1), time = _b[0], setTime = _b[1];
    var _c = (0, react_1.useState)(false), isPlaying = _c[0], setIsPlaying = _c[1];
    var msgItem = props.msgItem;
    var audioElement = (0, react_1.useMemo)(function () {
        var _a;
        var audio = window.document.createElement('audio');
        audio.src = (_a = msgItem.data) === null || _a === void 0 ? void 0 : _a.voice_url;
        return audio;
    }, [msgItem]);
    var startPlayAudio = function () {
        if (isPlaying) {
            audioElement.pause();
            setIsPlaying(false);
        }
        else {
            audioElement.play();
            setIsPlaying(true);
        }
    };
    (0, react_1.useEffect)(function () {
        var audioObject = {
            loadedmetadata: function (e) {
                setTime(Math.ceil(e.target.duration));
            },
            timeupdate: function (e) {
                var res = Math.ceil(e.target.currentTime);
                if (res && time !== res) {
                    console.log(res);
                    setTime(Math.ceil(res));
                }
            },
            playing: function (e) {
                if (playingMsgVoice && playingMsgVoice !== e.target) {
                    playingMsgVoice.pause();
                }
                // eslint-disable-next-line react-hooks/exhaustive-deps
                setPlayingMsgVoice(e.target);
            },
            pause: function (e) {
                if (playingMsgVoice === e.target) {
                    // eslint-disable-next-line react-hooks/exhaustive-deps
                    setPlayingMsgVoice(null);
                }
                setIsPlaying(false);
                e.target.currentTime = 0;
                console.log(e.target.duration);
                setTime(Math.ceil(e.target.duration));
            },
            ended: function (e) {
                setIsPlaying(false);
            }
        };
        Object.entries(audioObject).forEach(function (_a) {
            var key = _a[0], value = _a[1];
            audioElement.addEventListener(key, value);
        });
        return function () {
            Object.entries(audioObject).forEach(function (_a) {
                var key = _a[0], value = _a[1];
                audioElement.removeEventListener(key, value);
            });
        };
    }, [audioElement, playingMsgVoice, time]);
    var handleWave = (0, react_1.useCallback)(function () {
        var num = time % 3;
        switch (num) {
            case 0:
                return react_1.default.createElement(wave7_1.default, { className: index_module_less_1.default['wave'] });
            case 1:
                return react_1.default.createElement(wave6_1.default, { className: index_module_less_1.default['wave'] });
            case 2:
                return react_1.default.createElement(wave5_1.default, { className: index_module_less_1.default['wave'] });
            // case 3:
            //     return <Wave3 className={style['wave']}/>;
        }
    }, [time]);
    return (react_1.default.createElement("div", { className: "".concat(index_module_less_1.default['audio-container'], " ").concat('msg-content-wrapper-voice') },
        react_1.default.createElement("div", { className: index_module_less_1.default['audio-top'], onClick: startPlayAudio },
            (function () {
                if (isPlaying) {
                    return handleWave();
                }
                else {
                    return react_1.default.createElement(wave7_1.default, { className: index_module_less_1.default['wave'] });
                }
            })(),
            time > -1 && react_1.default.createElement("span", { className: index_module_less_1.default['duration-white'] }, "".concat(time, " \"")))));
});
exports.default = MessageVideo;
