"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var index_module_less_1 = tslib_1.__importDefault(require("./index.module.less"));
var each_1 = tslib_1.__importDefault(require("lodash-es/each"));
var dompurify_1 = tslib_1.__importDefault(require("dompurify"));
var ProductType = react_1.default.memo(function (_a) {
    var msg = _a.msg;
    var renderParams = (0, react_1.useMemo)(function () {
        var html = [];
        (0, each_1.default)(msg.content.params, function (item) {
            html.push('<span style="');
            item.color && html.push('color: ' + item.color + ';');
            item.size && html.push('font-size: ' + (item.size || 12) + 'px;');
            item.bold && html.push('font-weight: bold;');
            html.push('">' + item.text + '</span>');
            item['break'] && html.push('<br/>');
        });
        return html.join('');
    }, [msg.content.params]);
    return (react_1.default.createElement("div", { className: index_module_less_1.default['im-msg-product'] },
        react_1.default.createElement("div", { className: index_module_less_1.default['media-left'] },
            react_1.default.createElement("img", { src: msg.content.imgUrl, alt: '' })),
        react_1.default.createElement("div", { className: index_module_less_1.default['media-body'] },
            function () {
                if (msg.content.url) {
                    return react_1.default.createElement("a", { href: msg.content.url, target: "_blank", rel: "noopener noreferrer" }, msg.content.name);
                }
                else {
                    return msg.content.name;
                }
            }(),
            react_1.default.createElement("div", { className: index_module_less_1.default['params'], dangerouslySetInnerHTML: { __html: dompurify_1.default.sanitize(renderParams) } }))));
});
exports.default = ProductType;
