"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var LinkOutlined_1 = __importDefault(require("@ant-design/icons/LinkOutlined"));
var es_1 = require("udesk-ui/es");
var scope_switch_1 = __importDefault(require("../scope-switch"));
var react_i18next_1 = require("react-i18next");
var utilities_1 = require("../utilities");
var style_module_scss_1 = __importDefault(require("../style.module.scss"));
var utils_1 = require("../../../utils");
var search_input_1 = __importDefault(require("../search-input"));
var TreeNodeTitle = function (_a) {
    var data = _a.data;
    var t = (0, react_i18next_1.useTranslation)().t;
    var _b = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext), onSend = _b.onSend, previewUrl = _b.previewUrl;
    var onClick = (0, react_1.useCallback)(function () {
        onSend === null || onSend === void 0 ? void 0 : onSend("attachment", data);
        (0, utilities_1.hit)(data.id, "KnowledgeAttachment");
    }, [data, onSend]);
    var content = (0, react_1.useMemo)(function () { return [
        react_1.default.createElement(LinkOutlined_1.default, { key: "0" }),
        react_1.default.createElement("div", { key: "1", style: { flex: "1 1" } },
            react_1.default.createElement("a", { href: data.file_url, rel: "noopener noreferrer", target: "_blank" }, data.file_name)),
        react_1.default.createElement("div", { key: "2", className: style_module_scss_1.default.nodeOperations },
            (0, utils_1.canPreviewByFileName)(data.file_name) ? (react_1.default.createElement(udesk_ui_1.Button, { type: "link", size: "small", target: "_blank", href: (0, utils_1.getPreviewUrl)(data.file_url, { previewUrl: previewUrl }) }, t("label.preview"))) : null,
            react_1.default.createElement(udesk_ui_1.Button, { type: "link", size: "small", onClick: onClick }, t("label.send"))),
    ]; }, [data.file_name, data.file_url, onClick, previewUrl, t]);
    if (data.file_type.startsWith("image") ||
        /png|jpg|jpeg|gif/.test(data.file_type)) {
        return (react_1.default.createElement(udesk_ui_1.Popover, { autoAdjustOverflow: false, content: react_1.default.createElement("img", { src: data.file_url, alt: data.file_name, style: { width: "100%" } }), placement: "left", overlayStyle: { maxWidth: "300px", maxHeight: "300px" } },
            react_1.default.createElement("div", { style: { display: "flex", flex: "1 0", alignItems: "center" } }, content)));
    }
    else {
        return react_1.default.createElement(react_1.default.Fragment, null, content);
    }
};
function buildTreeData(catalogs, catalogMap, t, parentKey) {
    return catalogs.map(function (i) {
        var key = parentKey ? "".concat(parentKey, "-").concat(i.id) : i.id + "";
        return {
            key: key,
            title: i.name,
            selectable: false,
            className: style_module_scss_1.default["treeNode"],
            children: (function () {
                if (i.children) {
                    return buildTreeData(i.children, catalogMap, t, key);
                }
                else {
                    return (catalogMap[i.id] || []).map(function (j) {
                        return {
                            key: "".concat(key, "-content").concat(j.knowledge_attachment.id),
                            className: style_module_scss_1.default["treeNode"],
                            title: react_1.default.createElement(TreeNodeTitle, { data: j.knowledge_attachment }),
                        };
                    });
                }
            })(),
        };
    });
}
var Attachment = function (_a) {
    var _b;
    var query = _a.query, onSearch = _a.onSearch;
    var t = (0, react_i18next_1.useTranslation)().t;
    var _c = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext), expandedKeys = _c.expandedKeys, onExpand = _c.onExpand, activeScope = _c.activeScope, onScopeChange = _c.onScopeChange;
    var _scope = (0, utilities_1.useSafeScope)(activeScope);
    var params = (0, react_1.useMemo)(function () {
        return {
            scope: _scope,
            per_page: 1000,
            catalog_id: "all",
            query: query,
        };
    }, [_scope, query]);
    var _d = (0, utilities_1.useRequestData)("attachment", params), loading = _d.loading, catalogs = _d.catalogs, data = _d.data;
    var catalogMap = (0, utilities_1.useCatalogMap)((_b = data === null || data === void 0 ? void 0 : data.knowledge_attachments) !== null && _b !== void 0 ? _b : []);
    var _expandedKeys = (0, utilities_1.useExpandedKeys)(catalogMap);
    var treeData = (0, react_1.useMemo)(function () {
        if (!data || !data.knowledge_attachments) {
            return [];
        }
        if (query) {
            return data.knowledge_attachments.map(function (_a) {
                var knowledge_attachment = _a.knowledge_attachment;
                return {
                    key: knowledge_attachment.id,
                    className: style_module_scss_1.default["treeNode"],
                    title: react_1.default.createElement(TreeNodeTitle, { data: knowledge_attachment }),
                };
            });
        }
        else {
            return buildTreeData(catalogs, catalogMap, t);
        }
    }, [catalogMap, catalogs, data, query, t]);
    var mainContent = (0, react_1.useMemo)(function () {
        if (loading) {
            return react_1.default.createElement(es_1.Spin, null);
        }
        else if (treeData && treeData.length) {
            return (react_1.default.createElement(udesk_ui_1.Tree, { blockNode: true, selectable: false, expandedKeys: _expandedKeys, onExpand: onExpand, showIcon: true, treeData: treeData }));
        }
        else {
            return (react_1.default.createElement("p", null, t("page.im.km.no_result", { name: "$t(label.useful_link)" })));
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [expandedKeys, loading, onExpand, t, treeData]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(scope_switch_1.default, { value: _scope, onChange: onScopeChange }),
        react_1.default.createElement(search_input_1.default, { onSearch: onSearch, defaultValue: query }),
        mainContent));
};
exports.default = Attachment;
