"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var style_module_scss_1 = __importDefault(require("./style.module.scss"));
var tabs_1 = __importDefault(require("udesk-ui/es/tabs"));
var react_i18next_1 = require("react-i18next");
var km_1 = __importDefault(require("./km"));
var useful_expression_1 = __importDefault(require("./useful_expression"));
var useful_link_1 = __importDefault(require("./useful_link"));
var question_1 = __importDefault(require("./question"));
var attachment_1 = __importDefault(require("./attachment"));
var utilities_1 = require("./utilities");
var spin_1 = __importDefault(require("udesk-ui/es/spin"));
var simple_error_boundary_1 = __importDefault(require("../simple-error-boundary"));
var csApi_1 = require("../../utils/csApi");
var TabPane = tabs_1.default.TabPane;
var tabComponentMap = {
    useful_expression: useful_expression_1.default,
    useful_link: useful_link_1.default,
    question: question_1.default,
    attachment: attachment_1.default,
};
var RepositoryWidget = function (_a) {
    var companyId = _a.companyId, email = _a.email, _b = _a.subdomain, subdomain = _b === void 0 ? "useful_expression" : _b, onSpaceChange = _a.onSpaceChange, onCatalogChange = _a.onCatalogChange, onUse = _a.onUse, allowSendQuestion = _a.allowSendQuestion, showRobotQuestionTab = _a.showRobotQuestionTab, onSend = _a.onSend, kmApiBase = _a.kmApiBase, selectionStateKey = _a.selectionStateKey, showPublicScope = _a.showPublicScope, previewUrl = _a.previewUrl, customer = _a.customer, ticket = _a.ticket, agent = _a.agent, ticketCustomFields = _a.ticketCustomFields, customerCustomFields = _a.customerCustomFields;
    var _c = (0, react_1.useState)(), kmSettings = _c[0], setKmSettings = _c[1];
    var t = (0, react_i18next_1.useTranslation)().t;
    var _d = (0, utilities_1.useTabSetting)(), saveTab = _d.saveTab, tabSetting = _d.tabSetting, loading = _d.loading, saveSpace = _d.saveSpace, saveScope = _d.saveScope, saveCatalog = _d.saveCatalog;
    var _e = (0, utilities_1.useSelectionCache)(selectionStateKey, (0, react_1.useMemo)(function () { return ({
        defaultTab: tabSetting === null || tabSetting === void 0 ? void 0 : tabSetting.activeTab,
        defaultScope: tabSetting === null || tabSetting === void 0 ? void 0 : tabSetting.activeScope,
    }); }, [tabSetting === null || tabSetting === void 0 ? void 0 : tabSetting.activeScope, tabSetting === null || tabSetting === void 0 ? void 0 : tabSetting.activeTab])), activeTab = _e.activeTab, setActiveTab = _e.setActiveTab, query = _e.query, setQuery = _e.setQuery, activeScope = _e.activeScope, setActiveScope = _e.setActiveScope, expandedKeys = _e.expandedKeys, setExpandedKeys = _e.setExpandedKeys;
    (0, react_1.useEffect)(function () {
        (0, csApi_1.csApiGetJSON)("/cs/ts/api/knowledge_manager_settings").then(function (res) { return res.data; }).then(function (res) {
            setKmSettings(res.knowledge_manager_setting);
        });
    }, []);
    var onTabChange = (0, react_1.useCallback)(function (tabKey) {
        saveTab(tabKey);
        setActiveTab(tabKey);
    }, [saveTab, setActiveTab]);
    var tabs = (0, react_1.useMemo)(function () { return ["useful_expression", "useful_link", "question", "attachment"]; }, []);
    var onScopeChange = (0, react_1.useCallback)(function (_scope) {
        saveScope(_scope);
        setActiveScope(_scope);
    }, [saveScope, setActiveScope]);
    var contextValue = (0, react_1.useMemo)(function () { return ({
        allowSendQuestion: allowSendQuestion,
        onUse: onUse,
        showRobotQuestionTab: showRobotQuestionTab,
        onSend: onSend,
        kmApiBase: kmApiBase,
        onExpand: setExpandedKeys,
        expandedKeys: expandedKeys,
        activeScope: activeScope,
        onScopeChange: onScopeChange,
        activeCatalog: tabSetting === null || tabSetting === void 0 ? void 0 : tabSetting.activeCatalog,
        onCatalogChange: saveCatalog,
        activeSpace: tabSetting === null || tabSetting === void 0 ? void 0 : tabSetting.activeSpace,
        onSpaceChange: saveSpace,
        showPublicScope: showPublicScope,
        previewUrl: previewUrl,
        customer: customer,
        ticket: ticket,
        agent: agent,
        ticketCustomFields: ticketCustomFields,
        customerCustomFields: customerCustomFields,
    }); }, [
        activeScope,
        allowSendQuestion,
        expandedKeys,
        kmApiBase,
        setExpandedKeys,
        onScopeChange,
        onSend,
        onUse,
        saveCatalog,
        saveSpace,
        showPublicScope,
        showRobotQuestionTab,
        tabSetting === null || tabSetting === void 0 ? void 0 : tabSetting.activeCatalog,
        tabSetting === null || tabSetting === void 0 ? void 0 : tabSetting.activeSpace,
        previewUrl,
        customer,
        ticket,
        agent,
        ticketCustomFields,
        customerCustomFields,
    ]);
    var ref = (0, react_1.useRef)(null);
    if (loading || !kmSettings) {
        return react_1.default.createElement(spin_1.default, null);
    }
    return (react_1.default.createElement(simple_error_boundary_1.default, null,
        react_1.default.createElement(utilities_1.RepositoryWidgetContext.Provider, { value: contextValue },
            react_1.default.createElement("div", { ref: ref, className: style_module_scss_1.default.container },
                react_1.default.createElement("div", { className: style_module_scss_1.default.kmContent },
                    react_1.default.createElement(tabs_1.default, { activeKey: activeTab, onChange: onTabChange, size: "small", animated: false, tabBarGutter: 0, destroyInactiveTabPane: true },
                        tabs.map(function (i) {
                            var TabComponent = tabComponentMap[i];
                            return (react_1.default.createElement(TabPane, { tab: t("page.im.km.".concat(i, ".title")), key: i },
                                react_1.default.createElement(simple_error_boundary_1.default, null,
                                    react_1.default.createElement(TabComponent, { query: query, onSearch: setQuery }))));
                        }),
                        (kmSettings === null || kmSettings === void 0 ? void 0 : kmSettings.name) && (react_1.default.createElement(TabPane, { tab: kmSettings.name, key: "km" },
                            react_1.default.createElement(simple_error_boundary_1.default, null,
                                react_1.default.createElement(km_1.default, __assign({}, kmSettings, { companyId: companyId, email: email, subdomain: subdomain, query: query, onSearch: setQuery })))))))))));
};
exports.default = RepositoryWidget;
