"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var es_1 = require("udesk-ui/es");
var react_1 = __importStar(require("react"));
var react_i18next_1 = require("react-i18next");
var utilities_1 = require("../../utilities");
var question_list_1 = __importDefault(require("./question-list"));
var TreeNode = es_1.TreeSelect.TreeNode;
function buildTreeNodes(catalogs) {
    return catalogs.map(function (i) {
        return react_1.default.createElement(TreeNode, { value: i.id, key: i.id + '', title: i.name }, buildTreeNodes(i.children || []));
    });
}
var CommonQuestion = function (_a) {
    var scope = _a.scope, query = _a.query;
    var t = (0, react_i18next_1.useTranslation)().t;
    var _b = (0, react_1.useState)(-1), selectedCatalog = _b[0], setSelectedCatalog = _b[1];
    var _c = (0, react_1.useState)(1), page = _c[0], setPage = _c[1];
    var _d = (0, react_1.useState)({ current_page: 0, total_pages: 0 }), paging = _d[0], setPaging = _d[1];
    var _e = (0, react_1.useState)([]), questions = _e[0], setQuestions = _e[1];
    (0, react_1.useEffect)(function () {
        setPage(1);
        setSelectedCatalog(-1);
    }, [scope]);
    var params = (0, react_1.useMemo)(function () { return ({
        knowledge_catalog_id: (selectedCatalog === -1) ? undefined : selectedCatalog,
        scope: scope,
        per_page: 20,
        page: page,
        current_works: true,
        query: query
    }); }, [page, query, scope, selectedCatalog]);
    var _f = (0, utilities_1.useRequestData)("question", params), loading = _f.loading, catalogs = _f.catalogs, data = _f.data;
    var treeNodes = (0, react_1.useMemo)(function () { return buildTreeNodes(catalogs); }, [catalogs]);
    (0, react_1.useEffect)(function () {
        setQuestions([]);
    }, [params.knowledge_catalog_id, params.scope, params.query]);
    (0, react_1.useEffect)(function () {
        if (data === null || data === void 0 ? void 0 : data.questions) {
            setQuestions(function (prevState) { return __spreadArray(__spreadArray([], prevState, true), data.questions, true); });
            setPaging(data.meta);
        }
    }, [data]);
    var nextPage = (0, react_1.useCallback)(function () {
        setPage(function (prevState) {
            if (paging.total_pages >= prevState) {
                return prevState + 1;
            }
            return prevState;
        });
    }, [paging.total_pages]);
    return react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(es_1.TreeSelect, { dropdownStyle: { maxHeight: 400, overflow: 'auto' }, style: { alignSelf: 'flex-start' }, treeDefaultExpandAll: true, bordered: false, value: selectedCatalog, dropdownMatchSelectWidth: false, onChange: setSelectedCatalog },
            react_1.default.createElement(TreeNode, { value: -1, key: '-1', title: t('page.im.km.question.all') }),
            react_1.default.createElement(TreeNode, { value: 0, key: '0', title: t('page.im.km.question.no_catalog') }),
            treeNodes),
        questions.length ?
            react_1.default.createElement(question_list_1.default, { data: questions, loading: loading, onScrollToBottom: nextPage }) :
            react_1.default.createElement("p", null, t('page.im.km.no_result', { name: '$t(label.question)' })));
};
exports.default = CommonQuestion;
