"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_viewer_1 = __importDefault(require("react-viewer"));
var react_1 = __importStar(require("react"));
var style_module_scss_1 = __importDefault(require("../../style.module.scss"));
var button_1 = __importDefault(require("udesk-ui/es/button"));
var react_i18next_1 = require("react-i18next");
var classnames_1 = __importDefault(require("classnames"));
var dompurify_1 = __importDefault(require("dompurify"));
var useEvent_1 = __importDefault(require("react-use/esm/useEvent"));
var udesk_ui_1 = require("udesk-ui");
var hightlight_1 = __importDefault(require("../../hightlight"));
var utilities_1 = require("../../utilities");
var store_hook_1 = require("../../../../store/store-hook");
var DOMPurify = (0, dompurify_1.default)(window);
var QuestionItem = function (_a) {
    var data = _a.data, getImages = _a.getImages;
    var initData = (0, store_hook_1.useSelector)(function (state) { return state.initData; });
    var chat = initData.chat;
    var t = (0, react_i18next_1.useTranslation)().t;
    var _b = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext), allowSendQuestion = _b.allowSendQuestion, onUse = _b.onUse, onSend = _b.onSend;
    var _c = (0, react_1.useState)(false), showExpandButton = _c[0], setShowExpandButton = _c[1];
    var _d = (0, react_1.useState)(true), isExpand = _d[0], setIsExpand = _d[1];
    var contentStyle = (0, react_1.useMemo)(function () {
        if (isExpand) {
            return {};
        }
        else {
            return { height: "22px", overflowY: "hidden" };
        }
    }, [isExpand]);
    var contentRef = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(function () {
        if (contentRef.current) {
            var imageElements = contentRef.current.querySelectorAll("img");
            var images_1 = [];
            imageElements.forEach(function (i) { return images_1.push({ src: i.src }); });
            getImages(images_1);
            if (contentRef.current.clientHeight > 40 || imageElements.length > 0) {
                setShowExpandButton(true);
                setIsExpand(false);
            }
        }
    }, [getImages]);
    var toggleExpand = (0, react_1.useCallback)(function () {
        setIsExpand(!isExpand);
    }, [isExpand]);
    var _onUse = (0, react_1.useCallback)(function () {
        onUse === null || onUse === void 0 ? void 0 : onUse("question", data);
    }, [data, onUse]);
    var onSendClick = (0, react_1.useCallback)(function () {
        var url = window.location.protocol + "//" + window.location.host + "/question/";
        var _data = (0, utilities_1.makeQuestionData)({
            content: data.content,
            content_type: data.content_type,
            title: data.title,
            id: parseInt(data.id),
        }, chat.platform, "", url);
        data.url = _data.url;
        onSend === null || onSend === void 0 ? void 0 : onSend("question", data);
    }, [chat, data, onSend]);
    return (react_1.default.createElement("div", { className: style_module_scss_1.default["question-item"] },
        react_1.default.createElement("div", { className: (0, classnames_1.default)(style_module_scss_1.default["align-justify"]) },
            react_1.default.createElement(hightlight_1.default, { className: style_module_scss_1.default["word-break"], style: { color: "#177BBB" }, content: data.title }),
            react_1.default.createElement("div", { style: { flexShrink: 0 } },
                showExpandButton && (react_1.default.createElement(button_1.default, { type: "link", size: "small", onClick: toggleExpand }, t(isExpand ? "label.collapse" : "label.expand"))),
                allowSendQuestion ? (react_1.default.createElement(button_1.default, { type: "link", size: "small", onClick: onSendClick }, t("label.send"))) : null,
                react_1.default.createElement(button_1.default, { type: "link", size: "small", onClick: _onUse }, t("label.use")))),
        react_1.default.createElement("div", { ref: contentRef, style: contentStyle, className: (0, classnames_1.default)(style_module_scss_1.default.highlight, style_module_scss_1.default["word-break"]), dangerouslySetInnerHTML: {
                __html: DOMPurify.sanitize(data.content_type === "text" ? data.content_text : data.content),
            } })));
};
var QuestionList = function (_a) {
    var data = _a.data, onScrollToBottom = _a.onScrollToBottom, loading = _a.loading;
    var _b = (0, react_1.useState)(false), imageViewerVisible = _b[0], setImageViewerVisible = _b[1];
    var _c = (0, react_1.useState)([]), images = _c[0], setImages = _c[1];
    var _d = (0, react_1.useState)(0), activeIndex = _d[0], setActiveIndex = _d[1];
    var dataWrapperRef = (0, react_1.useRef)(null);
    var onClick = (0, react_1.useCallback)(function (e) {
        if (e.target.tagName === "IMG") {
            setActiveIndex(images.findIndex(function (i) { return i.src === e.target.src; }));
            setImageViewerVisible(true);
        }
    }, [images]);
    (0, useEvent_1.default)("click", onClick, document.getElementById("react-question-common-list"));
    (0, react_1.useEffect)(function () {
        if (dataWrapperRef.current) {
            var scrollHandle_1 = function (e) {
                var element = e.currentTarget;
                if (!element) {
                    return;
                }
                if (element.scrollHeight - element.scrollTop === element.clientHeight) {
                    onScrollToBottom();
                }
            };
            dataWrapperRef.current.addEventListener("scroll", scrollHandle_1);
            return function () { var _a; return (_a = dataWrapperRef === null || dataWrapperRef === void 0 ? void 0 : dataWrapperRef.current) === null || _a === void 0 ? void 0 : _a.removeEventListener("scroll", scrollHandle_1); };
        }
    }, [onScrollToBottom]);
    var getImages = (0, react_1.useCallback)(function (i) { return setImages(function (prevState) { return __spreadArray(__spreadArray([], prevState, true), i, true); }); }, []);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { ref: dataWrapperRef, className: style_module_scss_1.default["question-list"], id: "react-question-common-list" },
            data.map(function (i) { return (react_1.default.createElement(QuestionItem, { data: i, key: i.id, getImages: getImages })); }),
            loading ? react_1.default.createElement(udesk_ui_1.Spin, null) : null),
        react_1.default.createElement(react_viewer_1.default, { activeIndex: activeIndex < 0 ? 0 : activeIndex, visible: imageViewerVisible, onClose: function () { return setImageViewerVisible(false); }, images: images })));
};
exports.default = QuestionList;
