"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var scope_switch_1 = __importDefault(require("../../../components/repository-widget/scope-switch"));
var common_question_1 = __importDefault(require("./common-question"));
var robot_question_1 = __importDefault(require("./robot-question"));
var utilities_1 = require("../utilities");
var utils_1 = require("../../../utils");
var search_input_1 = __importDefault(require("../../../components/repository-widget/search-input"));
var Question = function (_a) {
    var _b;
    var onSearch = _a.onSearch, query = _a.query;
    var _c = (0, react_1.useState)(), settings = _c[0], setSettings = _c[1];
    var _d = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext), activeScope = _d.activeScope, onScopeChange = _d.onScopeChange, showRobotQuestionTab = _d.showRobotQuestionTab;
    (0, react_1.useEffect)(function () {
        (0, utils_1.getJSON)("/knowledge_manager_settings/robot_settings").then(function (settings) {
            setSettings(settings);
        });
    }, []);
    //系统开通了机器人，并且showRobotQuestionTab为 true 时才会显示机器人
    var enableRobot = (0, react_1.useMemo)(function () {
        var _a;
        return showRobotQuestionTab && ((_a = settings === null || settings === void 0 ? void 0 : settings.km_join_udesk_robots) === null || _a === void 0 ? void 0 : _a.is_enabled);
    }, [(_b = settings === null || settings === void 0 ? void 0 : settings.km_join_udesk_robots) === null || _b === void 0 ? void 0 : _b.is_enabled, showRobotQuestionTab]);
    var _onScopeChange = (0, react_1.useCallback)(function (scope) {
        if (!enableRobot && scope === "robot") {
            onScopeChange === null || onScopeChange === void 0 ? void 0 : onScopeChange("public");
        }
        else {
            onScopeChange === null || onScopeChange === void 0 ? void 0 : onScopeChange(scope);
        }
    }, [enableRobot, onScopeChange]);
    var mainContent = (0, react_1.useMemo)(function () {
        if (activeScope === "public" || activeScope === "personal") {
            return react_1.default.createElement(common_question_1.default, { scope: activeScope, query: query });
        }
        else if (enableRobot) {
            return react_1.default.createElement(robot_question_1.default, { searchWord: query, settings: settings });
        }
        else {
            return null;
        }
    }, [activeScope, enableRobot, query, settings]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(scope_switch_1.default, { enableRobot: enableRobot, value: activeScope, onChange: _onScopeChange }),
        react_1.default.createElement(search_input_1.default, { onSearch: onSearch, defaultValue: query }),
        mainContent));
};
exports.default = Question;
