"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var axios_1 = __importDefault(require("axios"));
var tree_select_1 = __importDefault(require("udesk-ui/es/tree-select"));
var utilities_1 = require("../../../repository-widget/utilities");
function buildTreeNodes(nodes, childrenMap) {
    if (!nodes) {
        return [];
    }
    return nodes.map(function (i) {
        return (react_1.default.createElement(tree_select_1.default.TreeNode, { value: i.id, key: i.id + "", title: i.name }, buildTreeNodes(childrenMap[i.id], childrenMap)));
    });
}
var CategorySelect = function (_a) {
    var settings = _a.settings, robotId = _a.robotId, setDefaultValue = _a.setDefaultValue, props = __rest(_a, ["settings", "robotId", "setDefaultValue"]);
    var kmApiBase = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext).kmApiBase;
    var _b = (0, react_1.useState)({}), childrenMap = _b[0], setChildrenMap = _b[1];
    var _c = (0, react_1.useState)([]), rootNodes = _c[0], setRootNodes = _c[1];
    var _d = (0, react_1.useState)([]), treeExpandedKeys = _d[0], setTreeExpandedKeys = _d[1];
    (0, react_1.useEffect)(function () {
        axios_1.default
            .get("".concat(kmApiBase, "/v1/categories"), {
            baseURL: "",
            params: __assign({ robotId: robotId }, settings.auth),
        })
            .then(function (res) {
            var _a;
            var _result = {};
            var _rootNodes = [];
            res.data.data.forEach(function (i) {
                if (i.parentId === 0) {
                    _rootNodes.push(i);
                }
                else {
                    if (!_result[i.parentId]) {
                        _result[i.parentId] = [];
                    }
                    _result[i.parentId].push(i);
                }
            });
            setDefaultValue((_a = _rootNodes[0]) === null || _a === void 0 ? void 0 : _a.id);
            setRootNodes(_rootNodes);
            setChildrenMap(_result);
        });
    }, [robotId, setDefaultValue, settings.auth]);
    var treeNodes = (0, react_1.useMemo)(function () { return buildTreeNodes(rootNodes, childrenMap); }, [
        childrenMap,
        rootNodes,
    ]);
    (0, react_1.useEffect)(function () {
        setTreeExpandedKeys(Object.keys(childrenMap));
    }, [childrenMap]);
    if (!rootNodes.length) {
        return null;
    }
    return (react_1.default.createElement(tree_select_1.default, __assign({ treeExpandedKeys: treeExpandedKeys, onTreeExpand: setTreeExpandedKeys, dropdownMatchSelectWidth: false, treeDefaultExpandAll: true, bordered: false }, props), treeNodes));
};
exports.default = CategorySelect;
