"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var robot_question_item_1 = __importDefault(require("./robot-question-item"));
var axios_1 = __importDefault(require("axios"));
var style_module_scss_1 = __importDefault(require("../style.module.scss"));
var list_1 = __importDefault(require("udesk-ui/es/list"));
var react_infinite_scroller_1 = __importDefault(require("react-infinite-scroller"));
var udesk_ui_1 = require("udesk-ui");
var utilities_1 = require("../../../utilities");
var RobotQuestionList = function (_a) {
    var categoryId = _a.categoryId, robotId = _a.robotId, auth = _a.auth, searchWord = _a.searchWord;
    var _b = (0, react_1.useState)([]), data = _b[0], setData = _b[1];
    var _c = (0, react_1.useState)(1), page = _c[0], setPage = _c[1];
    var _d = (0, react_1.useState)({ pageNum: 1, pageSize: 20, total: 0 }), paging = _d[0], setPaging = _d[1];
    var _e = (0, react_1.useState)(false), loading = _e[0], setLoading = _e[1];
    var kmApiBase = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext).kmApiBase;
    (0, react_1.useEffect)(function () {
        setData([]);
        setPage(1);
    }, [categoryId, robotId, searchWord]);
    (0, react_1.useEffect)(function () {
        setLoading(true);
        axios_1.default
            .post("".concat(kmApiBase, "/v1/questions/search?sign=").concat(auth.sign, "&email=").concat(auth.email, "&timestamp=").concat(auth.timestamp, "&appID=").concat(auth.appID), {
            categoryId: categoryId,
            robotId: robotId,
            pageNum: page,
            pageSize: 20,
            searchWord: searchWord,
        })
            .then(function (res) {
            setPaging(res.data.paging);
            setData(function (prevState) { return __spreadArray(__spreadArray([], prevState, true), res.data.data, true); });
        })
            .finally(function () { return setLoading(false); });
    }, [
        page,
        categoryId,
        robotId,
        auth.sign,
        auth.email,
        auth.timestamp,
        auth.appID,
        searchWord,
    ]);
    var handleInfiniteOnLoad = (0, react_1.useCallback)(function () {
        if (loading) {
            return;
        }
        setPage(function (prevState) { return prevState + 1; });
    }, [loading]);
    return (react_1.default.createElement("div", { className: style_module_scss_1.default["questionList"] },
        react_1.default.createElement(react_infinite_scroller_1.default, { initialLoad: false, pageStart: 0, loadMore: handleInfiniteOnLoad, hasMore: paging.pageNum * paging.pageSize < paging.total, useWindow: false },
            react_1.default.createElement(list_1.default, { dataSource: data, renderItem: function (item) { return react_1.default.createElement(robot_question_item_1.default, { data: item }); } }, loading && (react_1.default.createElement("div", { className: style_module_scss_1.default.loadingContainer },
                react_1.default.createElement(udesk_ui_1.Spin, null)))))));
};
exports.default = RobotQuestionList;
