"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var typography_1 = __importDefault(require("udesk-ui/es/typography"));
var LinkOutlined_1 = __importDefault(require("@ant-design/icons/LinkOutlined"));
var es_1 = require("udesk-ui/es");
var scope_switch_1 = __importDefault(require("../scope-switch"));
var react_i18next_1 = require("react-i18next");
var utilities_1 = require("../utilities");
var style_module_scss_1 = __importDefault(require("../style.module.scss"));
var icon_1 = require("../../icon/icon");
var classnames_1 = __importDefault(require("classnames"));
var dompurify_1 = __importDefault(require("dompurify"));
var FileTextTwoTone_1 = __importDefault(require("@ant-design/icons/FileTextTwoTone"));
var search_input_1 = __importDefault(require("../../repository-widget/search-input"));
var Text = typography_1.default.Text;
function buildTreeData(catalogs, catalogMap, t, parentKey) {
    return catalogs.map(function (i) {
        var key = parentKey ? "".concat(parentKey, "-").concat(i.id) : i.id + "";
        return {
            key: key,
            title: i.name,
            selectable: false,
            className: style_module_scss_1.default["treeNode"],
            children: (function () {
                if (i.children) {
                    return buildTreeData(i.children, catalogMap, t, key);
                }
                else {
                    return (catalogMap[i.id] || []).map(function (j) {
                        return {
                            key: "".concat(key, "-content").concat(j.id),
                            className: style_module_scss_1.default["treeNode"],
                            originData: j,
                            title: (react_1.default.createElement(react_1.default.Fragment, null,
                                react_1.default.createElement(Text, null, j.name),
                                j.mode === "mini" ? (react_1.default.createElement("div", { className: style_module_scss_1.default.nodeOperations },
                                    react_1.default.createElement(udesk_ui_1.Button, { type: "link", size: "small" }, t("label.send")))) : null)),
                            icon: j.mode === "mini" ? react_1.default.createElement(icon_1.MiniProgram, null) : react_1.default.createElement(LinkOutlined_1.default, null),
                        };
                    });
                }
            })(),
        };
    });
}
var UsefulLink = function (_a) {
    var _b;
    var query = _a.query, onSearch = _a.onSearch;
    var _c = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext), onUse = _c.onUse, onExpand = _c.onExpand, expandedKeys = _c.expandedKeys, activeScope = _c.activeScope, onScopeChange = _c.onScopeChange;
    var _scope = (0, utilities_1.useSafeScope)(activeScope);
    var t = (0, react_i18next_1.useTranslation)().t;
    var params = (0, react_1.useMemo)(function () { return ({ scope: _scope, per_page: 1000, query: query }); }, [
        _scope,
        query,
    ]);
    var _d = (0, utilities_1.useRequestData)("useful_link", params), loading = _d.loading, catalogs = _d.catalogs, data = _d.data;
    var catalogMap = (0, utilities_1.useCatalogMap)((_b = data === null || data === void 0 ? void 0 : data.links) !== null && _b !== void 0 ? _b : []);
    var _expandedKeys = (0, utilities_1.useExpandedKeys)(catalogMap);
    var treeData = (0, react_1.useMemo)(function () {
        if (!query) {
            return buildTreeData(catalogs, catalogMap, t);
        }
        else {
            if (!data || !data.links) {
                return [];
            }
            return data.links.map(function (i) { return ({
                key: i.id,
                originData: i,
                className: (0, classnames_1.default)(style_module_scss_1.default.noWrap, style_module_scss_1.default.highlight),
                title: (react_1.default.createElement("span", { dangerouslySetInnerHTML: { __html: dompurify_1.default.sanitize(i.name) } })),
                icon: react_1.default.createElement(FileTextTwoTone_1.default, null),
            }); });
        }
    }, [catalogMap, catalogs, data, query, t]);
    var onClick = (0, react_1.useCallback)(function (e, treeNode) {
        var _a;
        var originData = (_a = treeNode === null || treeNode === void 0 ? void 0 : treeNode.props) === null || _a === void 0 ? void 0 : _a.originData;
        if (originData) {
            onUse === null || onUse === void 0 ? void 0 : onUse("useful_link", originData);
            (0, utilities_1.hit)(originData.id, "UsefulLink");
        }
    }, [onUse]);
    var mainContent = (0, react_1.useMemo)(function () {
        if (loading) {
            return react_1.default.createElement(es_1.Spin, null);
        }
        else if (treeData && treeData.length) {
            return (react_1.default.createElement(udesk_ui_1.Tree, { blockNode: true, showIcon: true, expandedKeys: _expandedKeys, onExpand: onExpand, selectable: false, treeData: treeData, onClick: onClick }));
        }
        else {
            return (react_1.default.createElement("p", null, t("page.im.km.no_result", { name: "$t(label.useful_link)" })));
        }
    }, [expandedKeys, loading, onClick, onExpand, t, treeData]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(scope_switch_1.default, { value: _scope, onChange: onScopeChange }),
        react_1.default.createElement(search_input_1.default, { onSearch: onSearch, defaultValue: query }),
        mainContent));
};
exports.default = UsefulLink;
