"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.useSelectionCache = exports.useExpandedKeys = exports.useSafeScope = exports.useTabSetting = exports.articleToCommonQuestion = exports.robotToCommonQuestion = exports.makeQuestionData = exports.replaceHtmlTag = exports.RepositoryWidgetContext = exports.hit = exports.useCatalogMap = exports.useRequestData = void 0;
var react_1 = __importStar(require("react"));
var utils_1 = require("../../utils");
var csApi_1 = require("../../utils/csApi");
var qs_1 = __importDefault(require("qs"));
var weixin_default_png_1 = __importDefault(require("./weixin_default.png"));
var useDebounce_1 = __importDefault(require("react-use/esm/useDebounce"));
var store_hook_1 = require("../../store/store-hook");
var useRequestData = function (type, params) {
    var refreshKnowledge = (0, store_hook_1.useSelector)(function (state) { return state.initData.modals.refreshKnowledge; });
    var scope = params.scope;
    var _a = (0, react_1.useState)([]), catalogs = _a[0], setCatalogs = _a[1];
    var _b = (0, react_1.useState)(true), loading = _b[0], setLoading = _b[1];
    var _c = (0, react_1.useState)(), data = _c[0], setData = _c[1];
    var dataUrl = (function () {
        switch (type) {
            case "useful_expression":
            case "useful_link":
                return "/cs/ts/api/".concat(type, "s/search");
            case "question":
                return "/cs/ts/api/knowledge_questions/search";
            case "attachment":
                return "/knowledge_attachments";
        }
    })();
    var method = (function () {
        switch (type) {
            case "useful_expression":
            case "useful_link":
            case "question":
                return "post";
            case "attachment":
                return "get";
        }
    })();
    var csRequest = (function () {
        switch (type) {
            case 'useful_expression':
            case 'useful_link':
            case 'question':
                return true;
            case 'attachment':
                return false;
        }
    })();
    var requestOptions = (0, react_1.useMemo)(function () {
        var res = {
            url: dataUrl,
            method: method
        };
        if (method === "post") {
            res.headers = { "content-type": "application/x-www-form-urlencoded" };
            res.data = qs_1.default.stringify(params);
        }
        else {
            res.data = params;
        }
        return res;
    }, [dataUrl, method, params]);
    (0, useDebounce_1.default)(function () {
        setLoading(true);
        Promise.all([
            csRequest ? (0, csApi_1.csApiRequest)(requestOptions) : (0, utils_1.request)(requestOptions),
            (0, csApi_1.csApiGetJSON)("/cs/ts/api/knowledge_catalogs", {
                params: {
                    knowledge_type_name: type,
                    scope: scope,
                    query: params.query,
                }
            }).then(function (res) { return res.data; }).then(function (res) { return res.catalogs; }),
        ])
            .then(function (_a) {
            var data = _a[0], catalogs = _a[1];
            setData(data);
            setCatalogs(catalogs);
        })
            .finally(function () { return setLoading(false); });
    }, 50, [dataUrl, params, scope, type, method, requestOptions, refreshKnowledge]);
    return { loading: loading, catalogs: catalogs, data: data };
};
exports.useRequestData = useRequestData;
var useCatalogMap = function (data) {
    return (0, react_1.useMemo)(function () {
        var _catalogMap = {};
        if (data) {
            data.forEach(function (i) {
                var knowledge_catalog_id;
                if ("knowledge_attachment" in i) {
                    knowledge_catalog_id = i.knowledge_attachment.knowledge_catalog_id;
                }
                else {
                    knowledge_catalog_id = i.knowledge_catalog_id;
                }
                if (!_catalogMap[knowledge_catalog_id]) {
                    _catalogMap[knowledge_catalog_id] = [];
                }
                _catalogMap[knowledge_catalog_id].push(i);
            });
        }
        return _catalogMap;
    }, [data]);
};
exports.useCatalogMap = useCatalogMap;
function hit(id, type) {
    return (0, csApi_1.csApiPostJSON)("/cs/ts/api/knowledges/hit", { id: id + "", type: type });
}
exports.hit = hit;
exports.RepositoryWidgetContext = react_1.default.createContext({
    previewUrl: "",
});
var replaceHtmlTag = function (text) {
    return text.replace(/<(.|\n)*?>/g, "");
};
exports.replaceHtmlTag = replaceHtmlTag;
var makeQuestionData = function (item, platform, content, url) {
    var data;
    var qContent = item.content;
    var content_type = item.content_type;
    if (content_type === "html") {
        var pic_url = weixin_default_png_1.default;
        var pic_title = void 0;
        if (qContent.indexOf("<img") > -1) {
            var reg = /<img[^>]+src=['"]([^'"]+)['"]+/gi;
            var reg2 = /<img[^>]+alt=['"]([^'"]+)['"]+/gi;
            pic_url = (reg.exec(qContent) || [])[1];
            pic_title = reg2.exec(qContent);
            if (pic_title && pic_title[1]) {
                pic_title = pic_title[1];
            }
        }
        data = {
            content: qContent,
            title: item.title,
            desc: (0, exports.replaceHtmlTag)(qContent),
            pic_title: pic_title || "",
            pic_url: pic_url,
            url: item.isRobotQuestion ? item.url : url ? url + item.id : "",
            platform: platform,
            type: "html",
            isRobotQuestion: item.isRobotQuestion || false,
        };
    }
    else {
        var reg_1 = /<[^>]+>/g;
        if (reg_1.test(qContent)) {
            qContent = (0, exports.replaceHtmlTag)(qContent);
        }
        data = {
            content: qContent,
            title: item.title,
            type: "text",
        };
    }
    return data;
};
exports.makeQuestionData = makeQuestionData;
/**
 * 机器人问题转换为普通问题格式
 * @param {RobotQuestion} robotQuestion
 * @return Question
 */
var robotToCommonQuestion = function (robotQuestion) {
    var _a, _b;
    return __assign({ id: robotQuestion.id + "", 
        // title: robotQuestion.content,
        // content: robotQuestion?.answer?.content ?? robotQuestion.content,
        content_text: (_b = (_a = robotQuestion === null || robotQuestion === void 0 ? void 0 : robotQuestion.answer) === null || _a === void 0 ? void 0 : _a.content) !== null && _b !== void 0 ? _b : robotQuestion.content, content_type: "html", updated_at: robotQuestion.updateTime }, (0, exports.makeQuestionData)(__assign(__assign({ content_type: "html" }, robotQuestion), { title: robotQuestion.content, content: robotQuestion.answer
            ? robotQuestion.answer.content
            : robotQuestion.content, url: robotQuestion.wechatUrl, isRobotQuestion: true })));
};
exports.robotToCommonQuestion = robotToCommonQuestion;
var articleToCommonQuestion = function (article) {
    return __assign({ id: article.id + "", 
        // title: article.title,
        // content: article.contentBody,
        content_text: article.contentBody, content_type: "html", updated_at: article.updateTime }, (0, exports.makeQuestionData)(__assign(__assign({ content_type: "html" }, article), { content: article.contentBody })));
};
exports.articleToCommonQuestion = articleToCommonQuestion;
var useTabSetting = function () {
    var _a = (0, react_1.useState)(), tabSetting = _a[0], setTabSetting = _a[1];
    var _b = (0, react_1.useState)(true), loading = _b[0], setLoading = _b[1];
    var url = "/user_profiles/knowledge_tabs";
    var csUrl = '/cs/ts/api/user_profiles/knowledge_tabs';
    var saveTab = (0, react_1.useCallback)(function (key) {
        if (key === "km") {
            setTabSetting(function (prevState) {
                var _a, _b;
                (0, utils_1.post)(url, {
                    "knowledge_tabs[im]": "".concat(key, "_").concat((_a = prevState === null || prevState === void 0 ? void 0 : prevState.activeSpace) !== null && _a !== void 0 ? _a : "", "_").concat((_b = prevState === null || prevState === void 0 ? void 0 : prevState.activeCatalog) !== null && _b !== void 0 ? _b : ""),
                }).then(function () { return null; });
                return {
                    activeSpace: prevState === null || prevState === void 0 ? void 0 : prevState.activeSpace,
                    activeCatalog: prevState === null || prevState === void 0 ? void 0 : prevState.activeCatalog,
                    activeTab: "km",
                };
            });
        }
        else {
            setTabSetting(function (prevState) {
                var _a, _b;
                (0, utils_1.post)(url, {
                    "knowledge_tabs[im]": "".concat(key, "_").concat((_a = prevState === null || prevState === void 0 ? void 0 : prevState.activeScope) !== null && _a !== void 0 ? _a : ""),
                }).then(function () { return null; });
                return __assign(__assign({}, prevState), { activeScope: (_b = prevState === null || prevState === void 0 ? void 0 : prevState.activeScope) !== null && _b !== void 0 ? _b : "public", activeTab: key });
            });
        }
    }, []);
    var saveScope = (0, react_1.useCallback)(function (scope) {
        setTabSetting(function (prevState) {
            var _a, _b;
            (0, utils_1.post)(url, {
                "knowledge_tabs[im]": "".concat((_a = prevState === null || prevState === void 0 ? void 0 : prevState.activeTab) !== null && _a !== void 0 ? _a : "useful_expression", "_").concat(scope),
            }).then(function () { return null; });
            return __assign(__assign({}, prevState), { activeTab: (_b = prevState === null || prevState === void 0 ? void 0 : prevState.activeTab) !== null && _b !== void 0 ? _b : "useful_expression", activeScope: scope });
        });
    }, []);
    var saveSpace = (0, react_1.useCallback)(function (space) {
        setTabSetting(function (prevState) {
            var _a, _b;
            if (typeof space === "string" && space.indexOf(",") === -1) {
                (0, utils_1.post)(url, {
                    "knowledge_tabs[im]": "km_".concat(space, "_").concat((_a = prevState === null || prevState === void 0 ? void 0 : prevState.activeCatalog) !== null && _a !== void 0 ? _a : ""),
                }).then(function () { return null; });
            }
            return __assign(__assign({}, prevState), { activeTab: "km", activeCatalog: (_b = prevState === null || prevState === void 0 ? void 0 : prevState.activeCatalog) !== null && _b !== void 0 ? _b : -1, activeSpace: space + "" });
        });
    }, []);
    var saveCatalog = (0, react_1.useCallback)(function (catalog) {
        setTabSetting(function (prevState) {
            var _a, _b;
            (0, utils_1.post)(url, {
                "knowledge_tabs[im]": "km_".concat((_a = prevState === null || prevState === void 0 ? void 0 : prevState.activeSpace) !== null && _a !== void 0 ? _a : "", "_").concat(catalog),
            }).then(function () { return null; });
            return __assign(__assign({}, prevState), { activeTab: "km", activeSpace: (_b = prevState === null || prevState === void 0 ? void 0 : prevState.activeSpace) !== null && _b !== void 0 ? _b : "", activeCatalog: catalog });
        });
    }, []);
    (0, react_1.useEffect)(function () {
        (0, csApi_1.csApiGetJSON)(csUrl)
            .then(function (res) { return res.data; })
            .then(function (res) {
            var _a;
            if ((_a = res === null || res === void 0 ? void 0 : res.knowledge_tabs) === null || _a === void 0 ? void 0 : _a.im) {
                if (res === null || res === void 0 ? void 0 : res.knowledge_tabs.im.startsWith("km")) {
                    setTabSetting(function (prevState) {
                        return ({
                            activeTab: "km",
                            activeScope: prevState === null || prevState === void 0 ? void 0 : prevState.activeScope,
                            activeSpace: res.knowledge_tabs.im.split("_")[1],
                            activeCatalog: parseInt(res.knowledge_tabs.im.split("_")[2]) || -1,
                        });
                    });
                }
                else {
                    setTabSetting(function (prevState) {
                        var matchResult = res === null || res === void 0 ? void 0 : res.knowledge_tabs.im.match(/^(useful_expression|useful_link|useful|link|question|attachment)_(public|robot|personal)?/);
                        var result = {};
                        if (matchResult && matchResult.length > 1) {
                            var key = matchResult[1];
                            if (key === "useful") {
                                key = "useful_expression";
                            }
                            else if (key === "link") {
                                key = "useful_link";
                            }
                            result.activeTab = key;
                        }
                        if (matchResult && matchResult.length > 2) {
                            result.activeScope = matchResult[2];
                        }
                        return result;
                    });
                }
            }
        })
            .finally(function () { return setLoading(false); });
    }, []);
    return { tabSetting: tabSetting, saveTab: saveTab, loading: loading, saveScope: saveScope, saveSpace: saveSpace, saveCatalog: saveCatalog };
};
exports.useTabSetting = useTabSetting;
/**
 * 除了 question 以外，其他的标签页如果 scope 是 robot，则返回 public
 * @param {Scope} scope
 * @returns {string | "public" | "personal"}
 */
var useSafeScope = function (scope) {
    var showPublicScope = (0, react_1.useContext)(exports.RepositoryWidgetContext).showPublicScope;
    return (0, react_1.useMemo)(function () {
        var result = scope;
        if (!result || result === "robot") {
            result = "public";
        }
        if (!showPublicScope) {
            result = "personal";
        }
        return result;
    }, [scope, showPublicScope]);
};
exports.useSafeScope = useSafeScope;
/**
 * 如果 context 里的 expandedKeys 为 undefined，返回所有的 catalog，即展开所有的节点
 * @param {object} catalogMap
 */
var useExpandedKeys = function (catalogMap) {
    var expandedKeys = (0, react_1.useContext)(exports.RepositoryWidgetContext).expandedKeys;
    return (0, react_1.useMemo)(function () {
        if (!expandedKeys) {
            return Object.keys(catalogMap);
        }
        else {
            return expandedKeys;
        }
    }, [catalogMap, expandedKeys]);
};
exports.useExpandedKeys = useExpandedKeys;
var SELECTION_CACHE = {};
var useSelectionCache = function (key, _a) {
    if (key === void 0) { key = "selection_key"; }
    var defaultTab = _a.defaultTab, defaultScope = _a.defaultScope;
    var keyCache = (0, react_1.useMemo)(function () {
        if (!SELECTION_CACHE[key]) {
            SELECTION_CACHE[key] = {};
        }
        return SELECTION_CACHE[key];
    }, [key]);
    var _b = (0, react_1.useState)("useful_expression"), activeTab = _b[0], setActiveTab = _b[1];
    //默认 tab 更新以后
    (0, react_1.useEffect)(function () {
        if (defaultTab && !keyCache.activeTab) {
            keyCache.activeTab = defaultTab;
            setActiveTab(keyCache.activeTab || "useful_expression");
        }
    }, [defaultTab, keyCache]);
    (0, react_1.useEffect)(function () {
        setActiveTab(keyCache.activeTab || "useful_expression");
        setQuery(keyCache.query || "");
    }, [keyCache]);
    var tabCache = (0, react_1.useMemo)(function () {
        if (!keyCache[activeTab]) {
            keyCache[activeTab] = {
                public: {},
                personal: {},
                robot: {},
            };
        }
        return keyCache[activeTab];
    }, [keyCache, activeTab]);
    var _c = (0, react_1.useState)("public"), activeScope = _c[0], setActiveScope = _c[1];
    (0, react_1.useEffect)(function () {
        if (defaultScope && !tabCache.activeScope) {
            tabCache.activeScope = defaultScope;
            setActiveScope(defaultScope);
        }
    }, [defaultScope, tabCache]);
    (0, react_1.useEffect)(function () {
        setActiveScope(tabCache.activeScope || "public");
    }, [tabCache]);
    var scopeCache = (0, react_1.useMemo)(function () {
        if (!tabCache[activeScope]) {
            tabCache[activeScope] = {};
        }
        return tabCache[activeScope];
    }, [activeScope, tabCache]);
    var _d = (0, react_1.useState)(""), query = _d[0], setQuery = _d[1];
    var _e = (0, react_1.useState)(), expandedKeys = _e[0], setExpandedKeys = _e[1];
    var _f = (0, react_1.useState)(), scrollTop = _f[0], setScrollTop = _f[1];
    (0, react_1.useEffect)(function () {
        setExpandedKeys(scopeCache.expandedKeys);
        setScrollTop(scopeCache.scrollTop);
    }, [scopeCache]);
    return {
        activeTab: activeTab,
        setActiveTab: function (tab) {
            keyCache.activeTab = tab;
            setActiveTab(tab);
        },
        query: query,
        setQuery: function (keyword) {
            keyCache.query = keyword;
            setQuery(keyword);
        },
        activeScope: activeScope,
        setActiveScope: function (scope) {
            tabCache.activeScope = scope;
            setActiveScope(scope);
        },
        expandedKeys: expandedKeys,
        setExpandedKeys: function (keys) {
            scopeCache.expandedKeys = keys;
            setExpandedKeys(keys);
        },
        scrollTop: scrollTop,
        setScrollTop: function (scrollTop) {
            scopeCache.scrollTop = scrollTop;
            setScrollTop(scrollTop);
        },
    };
};
exports.useSelectionCache = useSelectionCache;
