"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var dompurify_1 = tslib_1.__importDefault(require("dompurify"));
var utilities_1 = require("../utilities");
var robot_utils_1 = require("../robot-utils");
var udesk_ui_1 = require("udesk-ui");
var robot_img_1 = tslib_1.__importDefault(require("../icon/robot-img"));
var forEach_1 = tslib_1.__importDefault(require("lodash-es/forEach"));
var react_i18next_1 = require("react-i18next");
var index_module_less_1 = tslib_1.__importDefault(require("./index.module.less"));
var robot_auto_sug_item_1 = tslib_1.__importDefault(require("./robot-auto-sug-item"));
var moment_1 = tslib_1.__importDefault(require("moment"));
var search_1 = tslib_1.__importDefault(require("../icon/search"));
var utilities_2 = require("../utilities");
var RobotAutoSugs = react_1.default.memo(function (_a) {
    var kcsSdk = _a.kcsSdk, id = _a.id, title = _a.title, trans_text = _a.trans_text, langto = _a.langto, titleStyle = _a.titleStyle, im_sub_session_id = _a.im_sub_session_id, date = _a.date, chatPlatform = _a.chatPlatform, onSelectSuggestion = _a.onSelectSuggestion, smart_assistance_enabled = _a.smart_assistance_enabled, robotBaseURL = _a.robotBaseURL, props = tslib_1.__rest(_a, ["kcsSdk", "id", "title", "trans_text", "langto", "titleStyle", "im_sub_session_id", "date", "chatPlatform", "onSelectSuggestion", "smart_assistance_enabled", "robotBaseURL"]);
    var t = (0, react_i18next_1.useTranslation)().t;
    var _b = (0, react_1.useState)(false), enabled = _b[0], setEnabled = _b[1];
    var _c = (0, react_1.useState)(props.open), open = _c[0], setOpen = _c[1];
    var _d = (0, react_1.useState)(false), loadedSugData = _d[0], setLoadedSugData = _d[1];
    var _e = (0, react_1.useState)(props.twemoji), twemoji = _e[0], setTwemoji = _e[1];
    var _f = (0, react_1.useState)([]), sugsData = _f[0], setSugsData = _f[1];
    var _ifEnabled = (0, react_1.useCallback)(function () {
        return (0, robot_utils_1.ifEnabled)('smart_assistance');
    }, []);
    (0, react_1.useEffect)(function () { return setOpen(false); }, [smart_assistance_enabled]);
    (0, react_1.useEffect)(function () { return setOpen(props.open); }, [props.open]);
    var tryNoSearchResultTip = (0, react_1.useCallback)(function (data) {
        if (!data || !data.length) {
            udesk_ui_1.message.error(t('page.im.log.noSearchResult'));
        }
        else {
            setOpen(true);
        }
    }, [t]);
    var loadSugData = (0, react_1.useCallback)(function (clicked) {
        setLoadedSugData(true);
        (0, robot_utils_1.getChannelRobot)(im_sub_session_id).then(function (res) {
            res = res.channel_udesk_robot || {};
            (0, robot_utils_1.getRecommendQuestionList)({
                robotId: res.km_robot_id,
                channelId: res.scene_id,
                queryContent: title,
                imSubSessionId: im_sub_session_id,
                messageId: id,
                messageCreatedAt: (0, moment_1.default)(date).format('YYYY-MM-DD HH:mm:ss')
            }, {
                robotBaseURL: robotBaseURL
            }).then(function (res) {
                var data = res.data || {};
                var sugsData = data.suggestQuestionList || [];
                var solutionResults = data.solutionResults || [];
                // 非流程
                if (!data.flowId) {
                    switch (data.msgType) {
                        case 'rich':
                        case 'text':
                            if (data.hitQuestion) {
                                sugsData.unshift({
                                    id: data.aid,
                                    content: data.hitQuestion,
                                    answer: {
                                        content: data.ansContent
                                    }
                                });
                            }
                            break;
                    }
                }
                solutionResults = (0, forEach_1.default)(solutionResults, function (item) {
                    item.answer = {
                        content: item.content
                    };
                    item.content = item.name;
                    return item;
                });
                sugsData = sugsData.concat(solutionResults);
                setSugsData(sugsData);
                clicked && tryNoSearchResultTip(sugsData);
            });
        });
    }, [date, id, im_sub_session_id, title, tryNoSearchResultTip]);
    var loadData = (0, react_1.useCallback)(function (clicked) {
        _ifEnabled().then(function (res) {
            setOpen(true);
            setEnabled(res.enabled);
            if (clicked) {
                if (res.enabled) {
                    loadSugData(clicked);
                }
            }
            else {
                (0, robot_utils_1.ifEnabled)('smart_assistance_auto_suggestion').then(function (_res) {
                    if (_res.enabled) {
                        loadSugData('');
                    }
                });
            }
        });
    }, [_ifEnabled, loadSugData]);
    (0, react_1.useEffect)(function () {
        if (open) {
            loadData('');
        }
        else {
            _ifEnabled().then(function (res) {
                setEnabled(res.enabled);
            });
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    var handleOpen = (0, react_1.useCallback)(function () {
        if (!loadedSugData) {
            loadData(true);
        }
        else {
            tryNoSearchResultTip(sugsData);
        }
    }, [loadData, loadedSugData, sugsData, tryNoSearchResultTip]);
    var text = (0, react_1.useMemo)(function () {
        return (0, utilities_1.handleText)(chatPlatform, {
            content: title,
            font: titleStyle,
            twemoji: twemoji
        });
    }, [chatPlatform, title, titleStyle]);
    var searchByKcs = (0, react_1.useCallback)(function () {
        kcsSdk === null || kcsSdk === void 0 ? void 0 : kcsSdk.showDrawer();
        kcsSdk === null || kcsSdk === void 0 ? void 0 : kcsSdk.searchKeyword((0, utilities_2.removeHTMLTag)(text));
    }, [kcsSdk, text, utilities_2.removeHTMLTag]);
    return (react_1.default.createElement("div", { className: index_module_less_1.default['robot-msg-wrapper'] },
        kcsSdk ? react_1.default.createElement(search_1.default, { onClick: function () { return searchByKcs(); }, className: index_module_less_1.default['kcs-search'] }) : null,
        react_1.default.createElement("div", { className: index_module_less_1.default['robot-msg'] },
            react_1.default.createElement("span", { className: index_module_less_1.default['robot-img-span'], dangerouslySetInnerHTML: {
                    __html: dompurify_1.default.sanitize(text)
                } }),
            enabled ? react_1.default.createElement(robot_img_1.default, { className: index_module_less_1.default['robot-img'], onClick: handleOpen }) : null),
        (trans_text === null || trans_text === void 0 ? void 0 : trans_text.content) ? react_1.default.createElement("div", { className: index_module_less_1.default['trans_test'] },
            react_1.default.createElement("div", { dangerouslySetInnerHTML: { __html: dompurify_1.default.sanitize(trans_text === null || trans_text === void 0 ? void 0 : trans_text.content) } }),
            react_1.default.createElement("div", { className: index_module_less_1.default['trans_tip'] }, t('page.im.imMessages.AITranslateTitle'))) : null,
        sugsData.length > 0 && open &&
            react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement("hr", null),
                react_1.default.createElement("ul", { style: { marginBottom: 0, textAlign: 'left' } }, sugsData.map(function (item, index) {
                    return react_1.default.createElement(robot_auto_sug_item_1.default, { key: item.id, index: index + 1, data: item, id: id, content: title, onClick: onSelectSuggestion });
                })))));
});
exports.default = RobotAutoSugs;
