"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var utilities_1 = require("../../utilities");
var scope_switch_1 = tslib_1.__importDefault(require("../../scope-switch"));
var search_input_1 = tslib_1.__importDefault(require("../../search-input"));
var tree_template_1 = tslib_1.__importDefault(require("../tree-template"));
var list_template_1 = tslib_1.__importDefault(require("../list-template"));
var TabContent = function (props) {
    var query = props.query, onSearch = props.onSearch, 
    // dialogueTagName,
    dialogueTagMode = props.dialogueTagMode, roleCan = props.roleCan, knowledgeType = props.knowledgeType, stashKey = props.stashKey, dialogueTagNameList = props.dialogueTagNameList, itemNode = props.itemNode;
    var oldQuery = (0, react_1.useRef)("");
    var _a = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext), activeScope = _a.activeScope, onScopeChange = _a.onScopeChange;
    var _scope = (0, utilities_1.useSafeScope)(activeScope);
    var _b = (0, react_1.useState)(""), searchValue = _b[0], setSearchValue = _b[1];
    var hasPermission = (0, react_1.useMemo)(function () {
        if (_scope === "public") {
            return (!!(roleCan === null || roleCan === void 0 ? void 0 : roleCan.knowledge_view_public) && !!(roleCan === null || roleCan === void 0 ? void 0 : roleCan.knowledge_useful_expressions_public));
        }
        else {
            return !!(roleCan === null || roleCan === void 0 ? void 0 : roleCan.knowledge_view) && !!(roleCan === null || roleCan === void 0 ? void 0 : roleCan.knowledge_useful_expressions);
        }
    }, [_scope]);
    (0, react_1.useEffect)(function () {
        var value = (dialogueTagNameList === null || dialogueTagNameList === void 0 ? void 0 : dialogueTagNameList.length) && dialogueTagMode === "keyword"
            ? dialogueTagNameList === null || dialogueTagNameList === void 0 ? void 0 : dialogueTagNameList.join(" ")
            : query;
        if (oldQuery.current !== value) {
            setSearchValue(value);
            oldQuery.current = value;
        }
    }, [dialogueTagMode, dialogueTagNameList, query]);
    var onSearched = (0, react_1.useCallback)(function (keyword) {
        setSearchValue(keyword);
        onSearch === null || onSearch === void 0 ? void 0 : onSearch(keyword);
    }, [onSearch]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(scope_switch_1.default, { value: _scope, onChange: onScopeChange }),
        react_1.default.createElement(search_input_1.default, { onSearch: onSearched, defaultValue: searchValue }),
        !hasPermission ? (react_1.default.createElement(udesk_ui_1.Empty, { className: 'h-full w-hull flex justify-center items-center flex-col', description: '\u60A8\u6682\u65E0\u6743\u9650\u67E5\u770B\u6B64\u5185\u5BB9' })) : searchValue && (searchValue === null || searchValue === void 0 ? void 0 : searchValue.trim()) ? (react_1.default.createElement(list_template_1.default, { knowledgeType: knowledgeType, scope: _scope, query: searchValue, itemNode: itemNode })) : (react_1.default.createElement(tree_template_1.default, tslib_1.__assign({}, props, { stashKey: stashKey, knowledgeType: knowledgeType, scope: _scope, itemNode: itemNode, matchTagList: dialogueTagMode === "type" ? dialogueTagNameList : undefined })))));
};
exports.default = react_1.default.memo(TabContent);
