"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var tree_1 = __importDefault(require("udesk-ui/es/tree"));
var react_1 = __importStar(require("react"));
var immer_1 = __importDefault(require("immer"));
var uniq_1 = __importDefault(require("lodash-es/uniq"));
var node_1 = __importDefault(require("./node"));
var FolderOutlined_1 = __importDefault(require("@ant-design/icons/FolderOutlined"));
var style_module_scss_1 = __importDefault(require("./style.module.scss"));
var utilities_1 = require("./utilities");
var get_1 = __importDefault(require("lodash-es/get"));
var set_1 = __importDefault(require("lodash-es/set"));
function mapSelectOptions(value, _a) {
    var shouldShowNode = _a.shouldShowNode, parentKey = _a.parentKey, nodeChildrenPath = _a.nodeChildrenPath, props = __rest(_a, ["shouldShowNode", "parentKey", "nodeChildrenPath"]);
    return value.filter(shouldShowNode).map(function (i, index) {
        var key = parentKey ? "".concat(parentKey, "-").concat(index) : "".concat(index);
        return {
            key: key,
            title: react_1.default.createElement(node_1.default, __assign({ value: i, nodeKey: key, nodeChildrenPath: nodeChildrenPath }, props)),
            icon: react_1.default.createElement(FolderOutlined_1.default, null),
            blockNode: true,
            className: style_module_scss_1.default.node,
            origin: i,
            children: mapSelectOptions((0, get_1.default)(i, nodeChildrenPath) || [], __assign({ shouldShowNode: shouldShowNode, nodeChildrenPath: nodeChildrenPath, parentKey: key }, props))
        };
    });
}
function TreeEditor(_a) {
    var onChange = _a.onChange, value = _a.value, onSelect = _a.onSelect, _b = _a.shouldShowNode, shouldShowNode = _b === void 0 ? function () { return true; } : _b, _c = _a.nodeChildrenPath, nodeChildrenPath = _c === void 0 ? 'subs' : _c, _d = _a.nodeTitlePath, nodeTitlePath = _d === void 0 ? 'title' : _d, _e = _a.nodeValuePath, nodeValuePath = _e === void 0 ? 'value' : _e, _f = _a.allowSelect, allowSelect = _f === void 0 ? function () { return true; } : _f, createNode = _a.createNode, props = __rest(_a, ["onChange", "value", "onSelect", "shouldShowNode", "nodeChildrenPath", "nodeTitlePath", "nodeValuePath", "allowSelect", "createNode"]);
    var _g = (0, react_1.useState)([]), expandedKeys = _g[0], setExpandedKeys = _g[1];
    var _h = (0, react_1.useState)([]), selectedKeys = _h[0], setSelectedKeys = _h[1];
    var onAddChild = (0, react_1.useCallback)(function (option, parents) {
        if (!onChange || !value) {
            return;
        }
        var nextValue = (0, immer_1.default)(value, function (draft) {
            var parentNode = (0, utilities_1.findTreeNode)(draft, parents, nodeChildrenPath);
            if (!parentNode) {
                return;
            }
            if (!(0, get_1.default)(parentNode, nodeChildrenPath)) {
                (0, set_1.default)(parentNode, nodeChildrenPath, []);
            }
            (0, get_1.default)(parentNode, nodeChildrenPath).push(createNode(parentNode));
        });
        onChange(nextValue || []);
        setExpandedKeys(function (prevState) { return (0, uniq_1.default)(__spreadArray(__spreadArray([], prevState, true), [parents], false)); });
    }, [onChange, value, nodeChildrenPath, createNode]);
    var onClickNode = (0, react_1.useCallback)(function (nodeKey, node) {
        if (allowSelect(node)) {
            setSelectedKeys([nodeKey]);
        }
    }, [allowSelect]);
    var onDeleteNode = (0, react_1.useCallback)(function (nodeKey) {
        if (!onChange || !value) {
            return;
        }
        var nodeKeyLen = nodeKey.split('-');
        var father = nodeKeyLen.length > 1 ? (0, utilities_1.findItemCommon)(value, nodeKeyLen.slice(0, nodeKeyLen.length - 1), true) : value;
        var deleteItem = nodeKeyLen.length > 1 ? father.subs[nodeKeyLen[nodeKeyLen.length - 1]] : father[nodeKey];
        onChange((0, immer_1.default)(value, function (draft) {
            (0, utilities_1.deleteTreeNode)(draft, nodeKey, nodeChildrenPath);
        }) || [], { nodeKey: nodeKey, type: 'delete', deleteItem: deleteItem });
    }, [onChange, value, nodeChildrenPath]);
    var onNodeTitleChange = (0, react_1.useCallback)(function (title, nodeKey) {
        if (!onChange || !value) {
            return;
        }
        var newValue = (0, immer_1.default)(value, function (draft) {
            var node = (0, utilities_1.findTreeNode)(draft, nodeKey, nodeChildrenPath);
            if (node) {
                (0, set_1.default)(node, nodeTitlePath, title);
            }
        });
        onChange(newValue || [], { nodeKey: nodeKey, type: 'change' });
    }, [nodeChildrenPath, nodeTitlePath, onChange, value]);
    var treeData = (0, react_1.useMemo)(function () {
        if (!value) {
            return [];
        }
        return mapSelectOptions(value, __assign({ onAdd: onAddChild, onClick: onClickNode, onChange: onNodeTitleChange, onDelete: onDeleteNode, nodeChildrenPath: nodeChildrenPath, shouldShowNode: shouldShowNode, nodeTitlePath: nodeTitlePath, nodeValuePath: nodeValuePath }, props));
    }, [value, onAddChild, onClickNode, onNodeTitleChange, onDeleteNode, nodeChildrenPath, shouldShowNode, nodeTitlePath, nodeValuePath, props]);
    (0, react_1.useEffect)(function () {
        if (selectedKeys) {
            onSelect(selectedKeys[0]);
        }
    }, [selectedKeys, onSelect]);
    var onDrop = (0, react_1.useCallback)(function (_a) {
        var node = _a.node, dragNode = _a.dragNode;
        if (!onChange || !value) {
            return;
        }
        if (node.dragOver) {
            onChange((0, immer_1.default)(value, function (draft) { return (0, utilities_1.moveTreeNode)(draft, dragNode.key, node.key, nodeChildrenPath); }));
        }
        else if (node.dragOverGapBottom || node.dragOverGapTop) {
            onChange((0, immer_1.default)(value, function (draft) {
                var position = parseInt(node.key.substring(node.key.length - 1));
                if (node.dragOverGapBottom) {
                    position += 1;
                }
                (0, utilities_1.moveTreeNode)(draft, dragNode.key, node.key.substring(0, node.key.lastIndexOf('-')), nodeChildrenPath, position);
            }));
        }
    }, [nodeChildrenPath, onChange, value]);
    return react_1.default.createElement(tree_1.default, { selectable: true, showIcon: true, blockNode: true, treeData: treeData, expandedKeys: expandedKeys, selectedKeys: selectedKeys, draggable: true, onDrop: onDrop, onExpand: function (keys) { return setExpandedKeys(keys); } });
}
exports.default = TreeEditor;
__exportStar(require("./utilities"), exports);
