"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var udesk_ui_1 = require("udesk-ui");
var react_1 = tslib_1.__importStar(require("react"));
var locale_1 = require("@udesk-webapp/locale");
var utilities_1 = require("../../utilities");
var useCatalog_1 = require("../hooks/useCatalog");
var index_module_scss_1 = tslib_1.__importDefault(require("./index.module.scss"));
var TreeTemplate = function (props) {
    var _a;
    var knowledgeType = props.knowledgeType, scope = props.scope, stashKey = props.stashKey, ItemNode = props.itemNode, matchTagList = props.matchTagList;
    var t = (0, locale_1.useTranslation)().t;
    var _b = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext), isWorkbench = _b.isWorkbench, public_knowledge_configs = _b.public_knowledge_configs;
    var _c = (0, useCatalog_1.useCatalogs)(knowledgeType, scope, stashKey, matchTagList), catalogLoading = _c.catalogLoading, catalogData = _c.catalogData, catalogList = _c.catalogList, loadList = _c.loadList, expandedKeys = _c.expandedKeys, setExpandedKeys = _c.setExpandedKeys;
    var onLoadData = function (_a) {
        var key = _a.key, children = _a.children;
        console.log(key, children);
        if (children && children.length) {
            return new Promise(function (resolve) {
                resolve();
            });
        }
        return loadList(key);
    };
    var onExpand = function (expandedKeys, _a) {
        var bool = _a.expanded, node = _a.node;
        setExpandedKeys(expandedKeys);
    };
    var onSelect = function (selectedKeys, e) {
        console.log(selectedKeys, e);
    };
    var onPackUp = function () {
        setExpandedKeys([]);
    };
    var height = ((_a = document.getElementById("knowledgeTreeWrapper")) === null || _a === void 0 ? void 0 : _a.clientHeight) || 600;
    var buildTreeData = (0, react_1.useCallback)(function (catalogs, catalogMap, t, isWorkbench, customCatalogOrder) {
        var sortedCatalogs = catalogs;
        if (customCatalogOrder) {
            sortedCatalogs = catalogs.sort(function (a, b) {
                return customCatalogOrder.findIndex(function (i) { return i.id === a.id; }) -
                    customCatalogOrder.findIndex(function (i) { return i.id === b.id; });
            });
        }
        return sortedCatalogs.map(function (i) {
            return {
                key: i.id,
                title: i.name,
                // className: css['treeNode'],
                children: (function () {
                    if (i.children) {
                        return buildTreeData(i.children, catalogMap, t, isWorkbench, i.children);
                    }
                    else {
                        return (catalogMap[i.id] || []).map(function (j) {
                            return {
                                key: "children_".concat(j.id),
                                isLeaf: true,
                                title: react_1.default.createElement(ItemNode, { item: j }),
                            };
                        });
                    }
                })(),
            };
        });
    }, [ItemNode]);
    var treeData = (0, react_1.useMemo)(function () {
        var _a;
        return buildTreeData(catalogData, catalogList, t, isWorkbench, (_a = public_knowledge_configs === null || public_knowledge_configs === void 0 ? void 0 : public_knowledge_configs.useful_link_catalog) !== null && _a !== void 0 ? _a : null);
    }, [buildTreeData, catalogData, catalogList, isWorkbench, public_knowledge_configs === null || public_knowledge_configs === void 0 ? void 0 : public_knowledge_configs.useful_link_catalog, t]);
    if (catalogLoading) {
        return (react_1.default.createElement(udesk_ui_1.Spin, { className: 'w-full text-center' })
        // <div className={classNames(css['repository-loading'])}>
        // </div>
        );
    }
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(udesk_ui_1.Button, { type: 'link', onClick: onPackUp, size: 'small', style: { textAlign: "left" } }, t("labels.packUp")),
        react_1.default.createElement("div", { id: 'knowledgeTreeWrapper', style: { flex: 1 } },
            react_1.default.createElement(udesk_ui_1.Tree, { className: index_module_scss_1.default["question-select"], loadData: onLoadData, treeData: treeData, blockNode: true, showIcon: true, expandedKeys: expandedKeys, onExpand: onExpand, height: height, onSelect: onSelect, selectable: false }))));
};
exports.default = TreeTemplate;
