"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var react_i18next_1 = require("react-i18next");
var index_1 = require("../../utils/index");
var isEqual_1 = __importDefault(require("lodash-es/isEqual"));
var unionBy_1 = __importDefault(require("lodash-es/unionBy"));
var UploadBox = function (_a) {
    var _b = _a.showUploadList, showUploadList = _b === void 0 ? true : _b, _c = _a.multiple, multiple = _c === void 0 ? true : _c, value = _a.value, _d = _a.accept, accept = _d === void 0 ? "" : _d, _e = _a.headers, headers = _e === void 0 ? {} : _e, props = __rest(_a, ["showUploadList", "multiple", "value", "accept", "headers"]);
    var t = (0, react_i18next_1.useTranslation)().t; //多语言
    var _f = (0, react_1.useState)([]), fileList = _f[0], setFileList = _f[1]; //上传的文件  必须usestate  不然onchange只触发一次
    var onChangeRef = (0, react_1.useRef)(props.onChange);
    (0, react_1.useEffect)(function () {
        if (!value) {
            return;
        }
        setFileList(function (v) {
            var newList = v.concat(value);
            return (0, unionBy_1.default)(newList, "url");
            // const doneFiles = v.filter(i => i.status === 'done');
            // if (isEqual(value, doneFiles) || isEqual(value, v)) {
            //     return v;
            // }
            // const newFiles = differenceBy(value, doneFiles, 'uid');
            // const removedFiles = differenceBy(doneFiles, value, 'uid');
            // if (!newFiles.length && !removedFiles.length) { //既无新增也无删除，则不修改 fileList
            //     return v;
            // }
            // let result = v.filter(i => removedFiles.every(j => j.uid !== i.uid)); //根据 value 删掉 file，此情况出现在 value 里的文件少与 fileList 里的文件
            // result = [...result, ...newFiles]; //根据 value 新增 file，此情况出现在 value 里有新的文件
            // return result;
        });
    }, [value]);
    var _g = (0, react_1.useState)({}), OSSData = _g[0], setOSSData = _g[1]; //鉴权信息
    // 上传之前 获取鉴权信息
    var beforeUpload = (0, react_1.useCallback)(function (file, beforeFileList) {
        // 如果单个文件 大小 超过限制   提示并且 停止上传
        if (props.single && file.size > props.single) {
            udesk_ui_1.message.warning((0, index_1.r)(t("page.im.ticket.warning.exceedsSize"), file.name, props.single / 1024 / 1024 + "M"));
            return Promise.reject();
        }
        // 如果总大小超过限制   提示并停止上传
        var totalSize = 0;
        //计算已上传文件的总大小
        fileList
            .filter(function (item) { return item.status === "done"; })
            .forEach(function (item) { return (totalSize += item.size); });
        if (multiple) {
            // 多选   再加上 beforeFileList的文件总大小
            beforeFileList.forEach(function (item) { return (totalSize += item.size); });
        }
        else {
            // 单选  加上 本次上传文件大小
            totalSize += file.size;
        }
        if (props.total && totalSize > props.total) {
            udesk_ui_1.message.warning((0, index_1.r)(t("page.im.ticket.warning.exceedsTotalSize"), totalSize / 1024 / 1024 + "M", props.total));
            return Promise.reject();
        }
        // 发起请求
        return new Promise(function (resolve, reject) {
            (0, index_1.getJSON)("/file_upload_policy?marking=".concat(props.marking, "&key=").concat(file.name))
                .then(function (res) {
                if (res.code === 1000) {
                    // 存储鉴权信息
                    setOSSData(res);
                    resolve();
                }
                else {
                    reject();
                }
            })
                .catch(function () { return reject(); });
        });
    }, [fileList, multiple, props.marking, props.single, props.total, t]);
    //上传到服务器
    var fetchAttachment = (0, react_1.useCallback)(function (file) {
        var url = "/attachments";
        var params = {
            attachment: {
                qiniu_key: file.url,
                file_file_name: file.name,
                file_content_type: file.type,
                file_file_size: file.size,
                bucket: OSSData.bucket,
                storage_policy: OSSData.storage_policy,
            },
        };
        return (0, index_1.postJSON)(url, params).then(function (res) {
            if (res.code === 1000) {
                return res;
            }
        });
    }, [OSSData.bucket, OSSData.storage_policy]);
    // 上传状态变化触发   status:uploading  error done remove
    var onChange = (0, react_1.useCallback)(function (info) {
        var _a;
        var fileList = info.fileList;
        if (["ali", "huawei_cloud_obs"].includes(OSSData.storage_policy)) {
            fileList.forEach(function (item) {
                if (!props.noAttachment && item.url && !item.url.includes("http"))
                    item.url = OSSData.host + "/" + item.url;
            });
        }
        if (info.file.status === "done") {
            if (props.noAttachment) {
                //需要等到请求结束后才 setFileList
                fetchAttachment(info.file).then(function (res) {
                    if (!res) {
                        return;
                    }
                    setFileList(function (v) {
                        return v.map(function (item) {
                            if (item.url === info.file.url) {
                                item.uid = res.attachment_id;
                                return __assign(__assign({}, item), { uid: res.attachment_id });
                            }
                            return item;
                        });
                    });
                });
                return;
            }
        }
        else if (info.file.status === "error") {
            (_a = props.onError) === null || _a === void 0 ? void 0 : _a.call(props, info.file);
        }
        setFileList((0, unionBy_1.default)(fileList, "url"));
    }, [
        OSSData.host,
        OSSData.storage_policy,
        fetchAttachment,
        props.noAttachment,
        props.onError,
    ]);
    // 在上传之前转换文件
    var transformFile = (0, react_1.useCallback)(function (file) {
        var suffix = file.name.slice(file.name.lastIndexOf("."));
        var filename = Date.now() + suffix;
        file.url = OSSData.dir + filename;
        return file;
    }, [OSSData.dir]);
    // 处理上传接口  阿里/私有部署
    var handleAction = (0, react_1.useCallback)(function () {
        return ["ali", "huawei_cloud_obs"].includes(OSSData.storage_policy)
            ? OSSData.host
            : "".concat(OSSData.host, "/").concat(OSSData.file_path);
    }, [OSSData.file_path, OSSData.host, OSSData.storage_policy]);
    (0, react_1.useEffect)(function () {
        var _a;
        // props?.onChange?.(fileList.filter(i => i.status === 'done'));
        if (!(0, isEqual_1.default)(fileList, value)) {
            (_a = onChangeRef === null || onChangeRef === void 0 ? void 0 : onChangeRef.current) === null || _a === void 0 ? void 0 : _a.call(onChangeRef, fileList.filter(function (i) { return i.status === "done"; }));
        }
    }, [fileList]);
    var handleData = (0, react_1.useCallback)(function (file) {
        if ("ali" === OSSData.storage_policy) {
            return {
                key: file.url,
                OSSAccessKeyId: OSSData.accessid,
                policy: OSSData.policy,
                Signature: OSSData.signature,
            };
        }
        else if ("huawei_cloud_obs" === OSSData.storage_policy) {
            return {
                key: file.url,
                AccessKeyId: OSSData.accessid,
                policy: OSSData.policy,
                Signature: OSSData.signature,
            };
        }
        else {
            var data_1 = {};
            Object.entries(OSSData.fields || {}).forEach(function (_a) {
                var key = _a[0], value = _a[1];
                data_1[key] = value;
            });
            return data_1;
        }
    }, [
        OSSData.accessid,
        OSSData.fields,
        OSSData.policy,
        OSSData.signature,
        OSSData.storage_policy,
    ]);
    return (react_1.default.createElement(udesk_ui_1.Upload, __assign({}, props, { headers: __assign({ "X-Requested-With": null }, headers), accept: accept, name: props.name || "file", withCredentials: true, beforeUpload: beforeUpload, multiple: multiple, fileList: fileList, onChange: onChange, transformFile: transformFile, action: handleAction, showUploadList: showUploadList, data: handleData }), props.children));
};
exports.default = UploadBox;
