"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var index_module_scss_1 = __importDefault(require("./index.module.scss"));
var react_i18next_1 = require("react-i18next");
var icons_1 = require("@ant-design/icons");
var upload_box_1 = __importDefault(require("../upload-box"));
function UploadModal(props) {
    // 上传的图片列表
    var _a = (0, react_1.useState)([]), imageFiles = _a[0], setImageFiles = _a[1];
    var _b = (0, react_1.useState)([]), selectedImages = _b[0], setSelectedImages = _b[1];
    (0, react_1.useEffect)(function () {
        try {
            var imgList = sessionStorage.getItem("imCreateTicketKImg");
            if (imgList) {
                var imgArray_1 = JSON.parse(imgList);
                setImageFiles(function (v) {
                    if (v === void 0) { v = []; }
                    return __spreadArray(__spreadArray([], v, true), imgArray_1.map(function (i, idx) { return ({
                        url: i.src,
                        uid: "".concat(0 - idx),
                        type: "image",
                        size: 0,
                        name: "image-".concat(idx),
                    }); }), true);
                });
            }
        }
        catch (e) {
            console.error(e);
        }
    }, []);
    (0, react_1.useEffect)(function () {
        return function () {
            if (imageFiles) {
                sessionStorage.setItem("imCreateTicketKImg", JSON.stringify(imageFiles.map(function (i) { return ({
                    src: i.url,
                }); })));
            }
        };
    }, [imageFiles]);
    //多语言配置
    var t = (0, react_i18next_1.useTranslation)().t;
    // 点击上传  筛选出被选择的图片   将选择的图片 插入富文本编辑
    function handleOk() {
        // props.addImg(imgList.filter(item => item.isSelect));
        if (selectedImages) {
            props.addImg(selectedImages === null || selectedImages === void 0 ? void 0 : selectedImages.filter(function (i) { return i.url; }).map(function (i) { return ({ src: i.url, isSelect: true }); }));
        }
    }
    // 点击取消 关闭弹窗
    function handleCancel() {
        props.close();
    }
    // 删除图片
    function deleteImg(e, index) {
        e.stopPropagation();
        setImageFiles(function (v) {
            if (!v) {
                return v;
            }
            var result = __spreadArray([], v, true);
            result.splice(index, 1);
            return result;
        });
    }
    // 选择图片  显示右下角对勾
    function selectImg(imageFile) {
        setSelectedImages(function (v) {
            if (v === void 0) { v = []; }
            if (v.includes(imageFile)) {
                return v.filter(function (i) { return i !== imageFile; });
            }
            else {
                return __spreadArray(__spreadArray([], v, true), [imageFile], false);
            }
        });
    }
    var onChange = (0, react_1.useCallback)(function (fileList) {
        setImageFiles(fileList);
        setSelectedImages(fileList);
    }, []);
    // 弹窗页脚
    var footer = (react_1.default.createElement("div", { className: index_module_scss_1.default["modal-btn"] },
        react_1.default.createElement(upload_box_1.default, __assign({ className: index_module_scss_1.default["upload-btn"] }, props, { value: imageFiles, marking: "web.ts.ticket_reply", onChange: onChange, noAttachment: false, showUploadList: false, accept: "image/jpeg,image/jpg,image/png" }),
            react_1.default.createElement(udesk_ui_1.Button, null, t("uploader.uploadImg"))),
        react_1.default.createElement(udesk_ui_1.Button, { key: "back", onClick: handleCancel }, t("cancel")),
        react_1.default.createElement(udesk_ui_1.Button, { key: "submit", type: "primary", onClick: handleOk }, t("uploader.insertImg"))));
    return (react_1.default.createElement("div", null,
        react_1.default.createElement(udesk_ui_1.Modal, { visible: props.show, title: t("uploader.uploadImg"), onOk: handleOk, onCancel: handleCancel, footer: footer, width: 600 },
            react_1.default.createElement("div", { className: index_module_scss_1.default["modal-content"] },
                react_1.default.createElement(udesk_ui_1.Row, { gutter: [16, 24] }, imageFiles === null || imageFiles === void 0 ? void 0 : imageFiles.map(function (item, index) {
                    return (react_1.default.createElement(udesk_ui_1.Col, { span: 8, key: item.url },
                        react_1.default.createElement("div", { className: index_module_scss_1.default["img-wrapper"], onClick: function () { return selectImg(item); } },
                            react_1.default.createElement("img", { src: item.url, alt: item.url }),
                            react_1.default.createElement("div", { className: index_module_scss_1.default["delete-icon"], onClick: function (e) { return deleteImg(e, index); } },
                                react_1.default.createElement(icons_1.CloseCircleFilled, null)),
                            (selectedImages === null || selectedImages === void 0 ? void 0 : selectedImages.includes(item)) && (react_1.default.createElement("div", { className: index_module_scss_1.default["select-icon"] },
                                react_1.default.createElement(icons_1.CheckOutlined, null))))));
                }))))));
}
exports.default = UploadModal;
