"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var index_module_less_1 = tslib_1.__importDefault(require("./index.module.less"));
var pdf02_png_1 = tslib_1.__importDefault(require("../images/pdf02.png"));
var word02_png_1 = tslib_1.__importDefault(require("../images/word02.png"));
var excel02_png_1 = tslib_1.__importDefault(require("../images/excel02.png"));
var ppt02_png_1 = tslib_1.__importDefault(require("../images/ppt02.png"));
var txt02_png_1 = tslib_1.__importDefault(require("../images/txt02.png"));
var unknow02_png_1 = tslib_1.__importDefault(require("../images/unknow02.png"));
var UploadingType = react_1.default.memo(function (_a) {
    var msg = _a.msg;
    var _type = (0, react_1.useMemo)(function () {
        var type = '.' + msg.fileext;
        if (/\.(pdf)/.test(type)) {
            type = pdf02_png_1.default;
        }
        else if (/\.(doc|docx|odt)/.test(type)) {
            type = word02_png_1.default;
        }
        else if (/\.(xls|xlsx|csv)/.test(type)) {
            type = excel02_png_1.default;
        }
        else if (/\.(ppt|pptx)/.test(type)) {
            type = ppt02_png_1.default;
        }
        else if (/\.(txt)/.test(type)) {
            type = txt02_png_1.default;
        }
        else {
            type = unknow02_png_1.default;
        }
        return type;
    }, [msg.type]);
    return (react_1.default.createElement("div", { className: index_module_less_1.default['file-wrapper'] },
        react_1.default.createElement("div", null,
            react_1.default.createElement("img", { className: index_module_less_1.default['file-img'], src: _type, alt: msg.filename })),
        react_1.default.createElement("div", { className: index_module_less_1.default['file-div'] },
            react_1.default.createElement("div", { className: 'msg-content-wrapper-uploading' }, msg.filename),
            react_1.default.createElement(udesk_ui_1.Progress, { percent: msg.percentage, showInfo: false, strokeWidth: 2 }))));
});
exports.default = UploadingType;
