"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var icons_1 = require("@ant-design/icons");
var utilities_1 = require("../utilities");
var react_i18next_1 = require("react-i18next");
var video_module_less_1 = tslib_1.__importDefault(require("./video.module.less"));
var VideoType = react_1.default.memo(function (_a) {
    var msg = _a.msg;
    //多语言配置
    var t = (0, react_i18next_1.useTranslation)().t;
    var downloadVideo = (0, react_1.useCallback)(function (filePath, filename) {
        fetch(filePath)
            .then(function (res) { return res.blob(); })
            .then(function (blob) {
            var a = document.createElement('a');
            document.body.appendChild(a);
            a.style.display = 'none';
            // 使用获取到的blob对象创建的url
            var url = window.URL.createObjectURL(blob);
            a.href = url;
            // 指定下载的文件名
            a.download = filename;
            a.click();
            document.body.removeChild(a);
            // 移除blob对象的url
            window.URL.revokeObjectURL(url);
        });
    }, []);
    return (react_1.default.createElement("div", null,
        react_1.default.createElement("div", { className: video_module_less_1.default['video'] },
            react_1.default.createElement("video", { src: (0, utilities_1.update_sdk_url)(msg.content, msg) || msg.origin_url, style: { maxWidth: '100%' }, controls: true },
                t('page.im.log.videoAddress'),
                "\uFF1A",
                msg.content),
            react_1.default.createElement("div", { className: video_module_less_1.default['video-loading'], style: !msg.whether_transcode ? { display: 'none' } : {} },
                react_1.default.createElement("p", { className: video_module_less_1.default['loading-text'] },
                    react_1.default.createElement("span", null, t('page.im.log.transcoding'))),
                react_1.default.createElement("p", { className: video_module_less_1.default['downloads'], onClick: function () { return downloadVideo(msg.content, msg.filename); } },
                    react_1.default.createElement(icons_1.DownloadOutlined, null),
                    t('page.im.log.DownloadOriginalVideo')))),
        (msg.content === '' && msg.origin_url) && react_1.default.createElement("a", { href: msg.origin_url, target: "_blank", rel: "noopener noreferrer" }, t('page.im.log.videoDownload'))));
});
exports.default = VideoType;
