/**
 * 创建一个 CustomerError 需要定义一个 ErrorCode，
 * 然后需要在 CustomerError 里定义对应的带 static 修饰符的 CustomerError 实例，
 * 在使用的时候就可以直接判断错误类型了，例如 e === CustomerError.CellphoneDuplicated，
 * 如果需要显示默认的报错可以直接使用message属性，例如 CustomerError.CellphoneDuplicated.message
 */
declare enum ErrorCode {
    CUSTOMER_CELLPHONE_DUPLICATED = 0,
    CUSTOMER_EMAIL_DUPLICATED = 1
}
export default class CustomerError extends Error {
    private readonly messageKey;
    get message(): string;
    constructor(type: ErrorCode);
    static CellphoneDuplicated: CustomerError;
    static EmailDuplicated: CustomerError;
}
export {};
