"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var i18next_1 = __importDefault(require("i18next"));
var i18next_browser_languagedetector_1 = __importDefault(require("i18next-browser-languagedetector"));
var react_i18next_1 = require("react-i18next");
var en_us_json_1 = __importDefault(require("./en-us.json"));
var zh_cn_json_1 = __importDefault(require("./zh-cn.json"));
i18next_1.default.use(i18next_browser_languagedetector_1.default)
    .use(react_i18next_1.initReactI18next) // bind react-i18next to the instance
    .init({
    fallbackLng: 'zh',
    debug: process.env.NODE_ENV !== 'production',
    resources: {
        'en': {
            translation: en_us_json_1.default,
        },
        'zh': {
            translation: zh_cn_json_1.default,
        },
    },
    interpolation: {
        escapeValue: false // not needed for react!!
    }
});
exports.default = i18next_1.default;
