"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var includes_1 = __importDefault(require("lodash-es/includes"));
var isArray_1 = __importDefault(require("lodash-es/isArray"));
var udesk_ui_1 = require("udesk-ui");
var CustomFieldsShow = function (props) {
    var customField = props.customField, value = props.value;
    var is_link = customField && customField['content_type'] === 'link';
    var labelStyle = {
        color: 'rgba(0, 0, 0, 0.65)'
    };
    // function getLabel() {
    //     const { customField = {} } = props;
    //     let labelEl = '';
    //     if (customField.agent_permission === 1) {
    //         labelEl += <span className="red">*</span>;
    //     }
    //     return labelEl;
    // }
    function getValue() {
        var customField = props.customField, value = props.value;
        if (!customField)
            return '';
        var type = customField.content_type, options = customField.select_options;
        var reaultValue = '';
        var _value = value;
        var textArr = [];
        var result = [];
        var oArr = [];
        switch (type) {
            case 'droplist':
            case 'radio':
            case 'checkbox':
                if (!(0, isArray_1.default)(value)) {
                    _value = value.split(',');
                }
                (options || []).forEach(function (item) {
                    if ((0, includes_1.default)(_value, item.value + '')) {
                        textArr.push(item.title);
                    }
                });
                reaultValue = textArr.join(',');
                break;
            case 'chained_droplist':
                if (!(0, isArray_1.default)(value)) {
                    _value = value.split(',');
                }
                oArr = options;
                _value.forEach(function (_v) {
                    var ls, oArrObj;
                    if (!oArr || !(oArrObj = oArr.find(function (item) { return item.value === (_v + ''); }) || oArr.find(function (item) { return item.value === parseInt(_v); }))) {
                        return;
                    }
                    ls = oArrObj;
                    result.push(ls['title']);
                    oArr = ls['subs'];
                });
                reaultValue = result.join('/');
                break;
            case 'link':
                reaultValue = "<a href='".concat(_value, "' target=\"_blank\">").concat(_value, "</a>");
                break;
            default:
                reaultValue = _value;
                break;
        }
        return reaultValue;
    }
    return react_1.default.createElement("div", null, (props.customField && props.value) &&
        react_1.default.createElement(udesk_ui_1.Row, null,
            react_1.default.createElement(udesk_ui_1.Col, { span: 6 },
                react_1.default.createElement("label", { style: labelStyle, title: props.title },
                    props.customField.agent_permission === 1 ? react_1.default.createElement("span", { className: "red" }, "*") : '',
                    props.customField.title)),
            react_1.default.createElement(udesk_ui_1.Col, { span: 17, offset: 1 },
                react_1.default.createElement("span", { title: props.title, className: "item-content ".concat(is_link ? 'item-content-link' : '', " word-break") }, is_link ? (react_1.default.createElement("a", { href: value, target: "_blank", rel: "noopener noreferrer" }, value)) : (getValue())))));
};
exports.default = CustomFieldsShow;
