"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable jsx-a11y/anchor-is-valid */
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var react_i18next_1 = require("react-i18next");
var index_module_scss_1 = __importDefault(require("./index.module.scss"));
var ajax_1 = require("../../../utils/ajax");
var csApi_1 = require("../../../utils/csApi");
var index_1 = require("../../../utils/index");
var pick_1 = __importDefault(require("lodash-es/pick"));
var uniq_1 = __importDefault(require("lodash-es/uniq"));
var isEqual_1 = __importDefault(require("lodash-es/isEqual"));
var custom_field_container_1 = __importDefault(require("../../../components/custom-field-container"));
var fields_1 = __importDefault(require("./fields"));
var desc_fields_1 = __importDefault(require("./desc-fields"));
var name_fields_1 = __importDefault(require("./name-fields"));
var store_hook_1 = require("../../../store/store-hook");
var Option = udesk_ui_1.Select.Option;
var CompanyInfoComponent = function (props) {
    var event = props.event, organizationFieldsv2 = props.organizationFieldsv2, sessionKey = props.sessionKey, customerId = props.customerId, organizations = props.organizations, chat = props.chat;
    var t = (0, react_i18next_1.useTranslation)().t;
    var initData = (0, store_hook_1.useSelector)(function (state) { return state.initData; });
    var _a = (0, react_1.useState)([]), origanizationField = _a[0], setOriganizationField = _a[1];
    var _b = (0, react_1.useState)(''), setCopyName = _b[1];
    var _c = (0, react_1.useState)([]), organizationArr = _c[0], setOrganizationArr = _c[1];
    var _d = (0, react_1.useState)(''), companyId = _d[0], setCompanyId = _d[1];
    var _e = (0, react_1.useState)({}), initialValue = _e[0], setInitialValue = _e[1];
    //根据 customer_id请求数据
    var companyForm = udesk_ui_1.Form.useForm()[0];
    // let _organizationFieldsv2: any = [];//用于设置初始化表格
    // let _organizationFieldsv2 = useMemo(() => {
    //     return (organizationFieldsv2 || []).filter((field: any) => {
    //         return field.im_show && field.name && (field.name.indexof('TextField') > -1 || field.name.indexof('SelectField') > -1)
    //     }).map((field: any) => {
    //         return {
    //             ...field,
    //             is_required: field.agent_permission === 1 ? true : false
    //         }
    //     })
    // }, [organizationFieldsv2]);
    var _organizationFields = (0, react_1.useMemo)(function () {
        return (organizationFieldsv2 || [])
            .filter(function (field) {
            if ((0, isEqual_1.default)(initData.page, 'im')) {
                return (field.im_show &&
                    field.name &&
                    (field.name.indexOf('TextField') > -1 || field.name.indexOf('SelectField') > -1));
            }
            else if ((0, isEqual_1.default)(initData.page, 'mpv')) {
                return (field.mpv_show &&
                    field.name &&
                    (field.name.indexOf('TextField') > -1 || field.name.indexOf('SelectField') > -1));
            }
            else {
                return (field.cc_show &&
                    field.name &&
                    (field.name.indexOf('TextField') > -1 || field.name.indexOf('SelectField') > -1));
            }
        })
            .map(function (field) {
            return __assign(__assign({}, field), { is_required: field.agent_permission === 1 ? true : false });
        });
    }, [organizationFieldsv2]);
    (0, react_1.useEffect)(function () {
        //循环公司自定义字段
        var organFields = (0, index_1.formatCustomField)({
            fields: _organizationFields,
            trigger: 'onBlur',
        });
        //自定义字段的formItem
        setOriganizationField(organFields);
    }, [_organizationFields]);
    //根据customerId  session_key monitor _time 请求已经有的公司
    var getOrganizationArr = (0, react_1.useCallback)(function (params) {
        var url = 'im/customer';
        (0, ajax_1.getJSON)(url, params)
            .then(function (res) {
            if (res.code && res.code === 1000) {
                setOrganizationArr(res.organizations);
                changeCompany(res.customer.default_organization_id);
            }
        })
            .catch(function () { });
    }, []);
    (0, react_1.useEffect)(function () {
        //只加载一次  用来赋初始值
        var params = {
            id: customerId,
            session_key: sessionKey,
            monitor: true,
        };
        getOrganizationArr(params);
    }, [customerId, getOrganizationArr, sessionKey]);
    // 点击已选择的公司  进入公司详情
    var goCompany = (0, react_1.useCallback)(function (companyId) {
        // 如果没有选择  不进行操作
        // 判断点击的是否是选择的字的地方  其他地方不触发
        if (companyId) {
            props.event.transitionToRoute &&
                props.event.transitionToRoute({
                    route: 'crm.organization.show',
                    path: companyId,
                });
            return false;
        }
    }, [props.event]);
    //封装form initValue 初始化表格的时候
    //疑问 获取初始值的值  解决  数据是通过接口拿的
    var getValues = (0, react_1.useCallback)(function (_organization) {
        var initValues = (0, index_1.getFieldsDefaultValue)({
            fields: _organizationFields,
            values: _organization.custom_fields || {},
        }) || {};
        initValues = Object.assign({}, initValues, {
            domains: _organization.domains,
            org_email_suffix: _organization.org_email_suffix,
            description: _organization.description,
            name: _organization.name,
        });
        return initValues;
    }, [_organizationFields]);
    var loadData = (0, react_1.useCallback)(function (id) {
        if (!id) {
            return;
        }
        (0, csApi_1.csApiGetJSON)("/cs/ts/api/organizations/".concat(id))
            .then(function (res) { return res.data; })
            .then(function (res) {
            if (res.code === 1000) {
                var formFieldsValue = (0, pick_1.default)(res.organization, 'name', 'domains', 'org_email_suffix', 'description');
                var values = getValues(res.organization);
                setInitialValue(values);
                companyForm.setFieldsValue(values);
                setCopyName(formFieldsValue.name);
            }
        })
            .catch(function (err) {
            udesk_ui_1.message.error(t('page.im.customerInfo.organization.failedToGetData'));
        });
    }, [companyForm, getValues, t]);
    (0, react_1.useEffect)(function () {
        var _a;
        if (organizations && organizations.length > 0) {
            //如果organizations有长度  取默认的第一个值
            var getCompanyId = (_a = organizations[0]) === null || _a === void 0 ? void 0 : _a.id;
            setCompanyId(getCompanyId);
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    (0, react_1.useEffect)(function () {
        if (companyId) {
            loadData(companyId);
        }
    }, [companyId, loadData]);
    var companyChildrenOption = organizationArr &&
        organizationArr.map(function (item, index) {
            return (react_1.default.createElement(Option, { value: item.id, key: item.id }, item.name));
        });
    //设置companyId 根据当前Id 判断是新增还是修改 如果value 是--
    var changeCompany = function (value, option) {
        setCompanyId(value);
        if (value === '') {
            companyForm.setFieldsValue(Object.keys(initialValue).reduce(function (init, curent) {
                init[curent] = '';
                return init;
            }, {}));
        }
    };
    //新建公司之后调用 putcustomers (put 方法) 刷新当前公司的下拉选项
    var putCustomer = (0, react_1.useCallback)(function (customers, id) {
        var url = '/cs/ts/api/customers/' + customerId;
        (0, csApi_1.csApiPutJSON)(url, customers).then(function (res) { return res.data; }).then(function (res) {
            if (res.code && res.code === 1000) {
                setOrganizationArr(res.organizations);
                setCompanyId(id);
                event.updateChat(chat, {
                    organizations: res.organizations,
                    customer: res.customer,
                });
                //调用Ember方法
            }
            else {
                udesk_ui_1.message.error(res.code_message || (res.exceptopn && res.exceptopn.message) || t('tip.error.saveTry'));
            }
        });
    }, [chat, customerId, event, t]);
    function judgeValueChanged(changedValue, initialValue) {
        //只判断当前的修改值
        var key = Object.keys(changedValue)[0];
        return changedValue[key] !== initialValue[key];
    }
    var submitFn = (0, react_1.useCallback)(function (params) {
        var submitFnWay = companyId ? csApi_1.csApiPutJSON : csApi_1.csApiPostJSON;
        // let way = companyId ? 'putJSON' : 'postJSON';
        var url = companyId ? "/cs/ts/api/organizations/".concat(companyId) : '/cs/ts/api/organizations';
        submitFnWay(url, params)
            .then(function (res) { return res.data; })
            .then(function (res) {
            if (res.code === 1000) {
                var values = getValues(res.organization || {});
                companyForm.setFieldsValue(values);
                //将返回的id 设置为select 项
                // setCompanyId(res.organization.id);
                var _organizations = organizationArr.map(function (item, index) {
                    return item.id;
                });
                _organizations = __spreadArray(__spreadArray([], _organizations, true), [res.organization.id], false);
                var params_1 = {};
                params_1.customer = {
                    organizations: (0, uniq_1.default)(_organizations),
                };
                putCustomer(params_1, res.organization.id);
                udesk_ui_1.message.info(t('tip.success.save'));
            }
            else {
                udesk_ui_1.message.error(res.code_message || (res.exceptopn && res.exceptopn.message) || t('tip.error.saveTry'));
            }
        })
            .catch(function () { });
    }, [companyForm, companyId, getValues, organizationArr, putCustomer, t]);
    var onValueChange = function (changedValues, values) {
        var changedKey = Object.keys(changedValues)[0];
        var _isSysField = (0, index_1.isSysField)(changedKey);
        var params = _isSysField
            ? { organization: changedValues }
            : { organization: { custom_fields: changedValues } };
        params.mode = 'quick_edit';
        companyForm
            .validateFields(Object.keys(changedValues))
            .then(function () {
            submitFn(params);
        })
            .catch(function (err) {
            console.log(err);
            var key = Object.keys(changedValues)[0];
            var canSubmit = true;
            err.errorFields.forEach(function (item) {
                if (item.name[0] === key) {
                    canSubmit = false;
                }
            });
            if (canSubmit) {
                submitFn(params);
            }
        });
    };
    return (react_1.default.createElement("div", { className: index_module_scss_1.default['company-info-page'] },
        react_1.default.createElement(udesk_ui_1.Form, { form: companyForm, layout: "vertical", name: "companyInfo", onValuesChange: onValueChange },
            organizationArr.length > 0 && (react_1.default.createElement(udesk_ui_1.Form.Item, null,
                react_1.default.createElement(udesk_ui_1.Row, { align: "middle" },
                    react_1.default.createElement(udesk_ui_1.Col, { span: 12 },
                        react_1.default.createElement(udesk_ui_1.Select, { getPopupContainer: function (triggerNode) { return triggerNode.parentNode; }, value: companyId, onChange: changeCompany },
                            react_1.default.createElement(Option, { value: "" }, " -- "),
                            companyChildrenOption)),
                    react_1.default.createElement(udesk_ui_1.Col, { style: { marginLeft: '15px' } },
                        react_1.default.createElement("a", { onClick: function () { return goCompany(companyId); } },
                            "[",
                            t('page.im.customerInfo.organization.companyDetail'),
                            "]"))))),
            react_1.default.createElement(udesk_ui_1.Form.Item, { label: t('page.im.customerInfo.organization.org_email_suffix'), name: "org_email_suffix", trigger: "onBlur" },
                react_1.default.createElement(fields_1.default, { trigger: 'onBlur' })),
            react_1.default.createElement(udesk_ui_1.Form.Item, { label: t('page.im.customerInfo.organization.domains'), name: "domains", trigger: "onBlur" },
                react_1.default.createElement(fields_1.default, { trigger: 'onBlur' })),
            react_1.default.createElement(udesk_ui_1.Form.Item, { label: t('page.im.customerInfo.organization.name'), name: "name", rules: [
                    {
                        required: true,
                        message: t('page.im.customerInfo.organization.validateFail'),
                    },
                ], trigger: "onBlur" },
                react_1.default.createElement(name_fields_1.default, { trigger: 'onBlur' })),
            react_1.default.createElement(udesk_ui_1.Form.Item, { label: t('page.im.customerInfo.organization.description'), name: "description", trigger: "onBlur" },
                react_1.default.createElement(desc_fields_1.default, { trigger: 'onBlur' })),
            origanizationField.length > 1 && react_1.default.createElement(custom_field_container_1.default, { fields: origanizationField }))));
};
exports.default = CompanyInfoComponent;
