"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var ajax_1 = require("../../../../utils/ajax");
var Option = udesk_ui_1.Select.Option;
var CustomerSelect = function (props) {
    var selectOnChange = props.selectOnChange;
    var _a = (0, react_1.useState)([]), optionsArr = _a[0], setOptionsArr = _a[1];
    var _b = (0, react_1.useState)(props.value || null), value = _b[0], setValue = _b[1];
    var _c = (0, react_1.useState)({
        prefix: "",
        page_size: 20,
        page: 1,
        includes: "can_merge",
    }), searchParams = _c[0], setSearchParams = _c[1];
    (0, react_1.useEffect)(function () {
        setValue(props.value || null);
    }, [props.value]);
    (0, react_1.useEffect)(function () {
        //请求数据
        if (searchParams.prefix) {
            var params = __assign({}, searchParams);
            (0, ajax_1.postJSON)("/customers/contain_search", params).then(function (res) {
                setOptionsArr(function (prev) {
                    return prev.concat(__spreadArray([], res.customers, true));
                });
            });
        }
        else {
            setOptionsArr([]);
            setSearchParams(__assign(__assign({}, searchParams), { page: 1 }));
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [searchParams.prefix, searchParams.page]);
    var handleSearch = (0, react_1.useCallback)(function (value) {
        setSearchParams(__assign(__assign({}, searchParams), { prefix: value }));
    }, [searchParams]);
    // const handleSearch = (value: string) => {
    //     setSearchParams({ ...searchParams, prefix: value })
    // }
    var handleChange = function (value, option) {
        setValue(value);
        selectOnChange && selectOnChange(value, option);
    };
    var handleScroll = (0, react_1.useCallback)(function (e) {
        e.persist();
        var target = e.target;
        if (target.scrollTop + target.offsetHeight === target.scrollHeight) {
            setSearchParams(__assign(__assign({}, searchParams), { page: searchParams.page + 1 }));
        }
    }, [searchParams]);
    // const handScroll = (e: any) => {
    //     e.persist();
    //     const { target } = e;
    //     if (target.scrollTop + target.offsetHeight === target.scrollHeight) {
    //         setSearchParams({ ...searchParams, page: searchParams.page + 1 });
    //     }
    // }
    var optionChildrens = (0, react_1.useMemo)(function () {
        return optionsArr.map(function (item) {
            return (react_1.default.createElement(Option, { value: item.id, key: item.id }, item.nick_name));
        });
    }, [optionsArr]);
    // const optionChildrens = optionsArr.map((item) => {
    //     return (<Option value={item.id} key={item.id}>{item.nick_name}</Option>)
    // })
    var tagRender = function (props) {
        return react_1.default.createElement("span", null, props.label);
    };
    return (react_1.default.createElement(udesk_ui_1.Select, { style: { width: 200 }, showSearch: true, placeholder: "\u8BF7\u9009\u62E9\u5BA2\u6237", value: value, labelInValue: true, defaultActiveFirstOption: true, showArrow: true, filterOption: false, onSearch: handleSearch, onChange: handleChange, onPopupScroll: handleScroll, notFoundContent: null, tagRender: tagRender, size: "small" }, optionChildrens));
};
exports.default = CustomerSelect;
