"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var index_module_scss_1 = __importDefault(require("./index.module.scss"));
var icon_1 = require("../../../../components/icon/icon");
var utils_1 = require("../../../../utils");
var merge_1 = __importDefault(require("./merge"));
var react_i18next_1 = require("react-i18next");
var copy_1 = __importDefault(require("../../../../components/copy"));
var qs_1 = __importDefault(require("qs"));
var store_hook_1 = require("../../../../store/store-hook");
var Email = function (props) {
    var _a;
    var t = (0, react_i18next_1.useTranslation)().t;
    var _b = (0, react_1.useState)(props.value || ""), value = _b[0], setValue = _b[1]; // 初始值
    var _c = (0, react_1.useState)(false), showRepeat = _c[0], setShowRepeat = _c[1]; //  显示合并信息
    var _d = (0, react_1.useState)(false), showMerge = _d[0], setShowMerge = _d[1]; //  显示客户合并Modal
    var _e = (0, react_1.useState)({}), repeatEmail = _e[0], setRepeatEmail = _e[1]; // 缓存合并的数据信息
    var _f = (0, react_1.useState)("客户合并"), title = _f[0], setTitle = _f[1];
    var _g = (0, react_1.useState)(false), reservationed = _g[0], setReservationed = _g[1]; // 是否已经预约
    var initData = (0, store_hook_1.useSelector)(function (state) { return state.initData; });
    var chat = initData.chat;
    // 动态设置value
    (0, react_1.useEffect)(function () {
        setValue(props.value || "");
    }, [props.value]);
    // 动态设置已预约合并信息
    (0, react_1.useEffect)(function () {
        if (props.toCustomer &&
            props.toCustomer.value &&
            props.toCustomer.label &&
            props.toCustomer.reservation_reason === "email") {
            setRepeatEmail(props.toCustomer);
            setReservationed(true);
        }
        else {
            setRepeatEmail({});
            setReservationed(false);
        }
    }, [
        props.toCustomer.value,
        props.toCustomer.label,
        props.toCustomer.reservation_reason,
        props.toCustomer,
    ]);
    // 值变化
    var handleChange = (0, react_1.useCallback)(function (e) {
        setValue(e.target.value);
    }, []);
    // const handleChange = (e: React.FocusEvent<HTMLInputElement>) => {
    //     setValue(e.target.value);
    // }
    // 失去焦点时,先验证是否有重复邮箱,如果有,显示重复提醒,并可以合并, 留言直接合并, 当前会话,预约合并
    var handleBlur = (0, react_1.useCallback)(function (e) {
        var changeFunction = props[props.trigger || "onChange"];
        var _value = e.target.value;
        var customer = props.customer || {};
        var params = {
            customer: {
                id: customer.id,
                email: e.target.value,
            },
        };
        (0, utils_1.getJSON)("/customers/check_duplication?" + qs_1.default.stringify(params), {})
            .then(function (res) {
            if (res.code !== 1000) {
                udesk_ui_1.message.error(t("error.repeatEmailFail"));
            }
            else {
                var dup = res.duplications || {};
                // 有重复邮箱,显示预约合并按钮 ? 如果电话已经预约了 ?
                if (dup.email && dup.email.id) {
                    setShowRepeat(true);
                    setRepeatEmail({
                        label: dup.email.name,
                        value: dup.email.id,
                        key: dup.email.id,
                    });
                }
                else {
                    if (!reservationed) {
                        setShowRepeat(false);
                        setRepeatEmail({});
                    }
                    if (changeFunction) {
                        changeFunction(_value);
                    }
                }
            }
        })
            .catch(function () { });
    }, [props, reservationed, t]);
    // 跳转到客服系统客户详情页
    var transferToCustomer = (0, react_1.useCallback)(function () {
        props.event.transitionToRoute &&
            props.event.transitionToRoute({
                route: "crm.customer.show",
                path: repeatEmail.value,
            });
    }, [props.event, repeatEmail.value]);
    // 显示预约modal
    var showMergeModal = (0, react_1.useCallback)(function () {
        var _a;
        if ((_a = props.selfChat) === null || _a === void 0 ? void 0 : _a.history) {
            setTitle(t("udMerge.mergeCustomer"));
        }
        else {
            setTitle(t("udMerge.appointmentMergeCustomer"));
        }
        setShowMerge(true);
    }, [(_a = props.selfChat) === null || _a === void 0 ? void 0 : _a.history, t]);
    // 取消立即预约
    var cancelReservation = (0, react_1.useCallback)(function () {
        var customerId = props.customer.id;
        var imSubSessionId = props.imSubSessionId;
        (0, utils_1.deleteJSON)("/customer_merge_reservation", {
            from_customer_id: customerId,
            im_sub_session_id: imSubSessionId,
        })
            .then(function (res) {
            // 取消之后,通知父页面, 可以再次预约
            setReservationed(false);
            setShowRepeat(true);
            setRepeatEmail({});
            props.setToCustomer({});
        })
            .catch(function (err) { });
    }, [props]);
    // const cancelReservation = () => {
    //     deleteJSON('/customer_merge_reservation', {
    //         from_customer_id: props.customer.id,
    //         im_sub_session_id: props.imSubSessionId
    //     }).then((res: any) => {
    //         // 取消之后,通知父页面, 可以再次预约
    //         setReservationed(false);
    //         setShowRepeat(true);
    //         setRepeatEmail({})
    //         props.setToCustomer({});
    //     }).catch(err => {
    //     })
    // }
    // 预约回调
    // isSelf: true 表示其他客户合并到了自己身上, false 表示自己合到了其他客户身上,自己有可能被删除
    var handleMerge = (0, react_1.useCallback)(function (isSelf, repeatInfo, needMerge) {
        var chat = props.selfChat || {};
        var history = chat.history || false;
        var setToCustomer = props.setToCustomer;
        var event = props.event;
        setShowRepeat(false);
        setReservationed(true);
        setRepeatEmail(repeatInfo);
        setToCustomer &&
            setToCustomer(__assign(__assign({}, repeatInfo), { reservation_reason: "email" }));
        if (history && needMerge) {
            event &&
                event.updateChat &&
                event.updateChat({
                    chat: props.selfChat,
                    key: "isDeletedCustomer",
                    value: !isSelf,
                });
        }
    }, [props.selfChat, props.event, props.setToCustomer]);
    var createEmailTicket = (0, react_1.useCallback)(function () {
        var event = props.event;
        event && event.createEmailTicket(chat);
    }, [props.event, chat]);
    return (react_1.default.createElement("div", { className: "".concat(index_module_scss_1.default["flex-row"], " ").concat(index_module_scss_1.default["flex-row-item-center"]) },
        react_1.default.createElement("div", { className: index_module_scss_1.default["email-input"] },
            react_1.default.createElement(copy_1.default, { text: value, switchFlag: props.switchFlag },
                react_1.default.createElement(udesk_ui_1.Input, { value: value, onChange: handleChange, onBlur: handleBlur })),
            react_1.default.createElement(icon_1.EmailWordOrder, { title: "新建邮件工单", onClick: createEmailTicket, style: {
                    fontSize: "18px",
                    color: "green",
                    marginLeft: "10px",
                    cursor: "pointer",
                } })),
        showRepeat && (react_1.default.createElement("div", { className: index_module_scss_1.default["repeat-box"] },
            react_1.default.createElement(icon_1.Warning, { className: index_module_scss_1.default["repeat-icon"] }),
            react_1.default.createElement("div", null,
                "\u6B64\u7535\u8BDD\u4E0E\u5DF2\u6709\u5BA2\u6237 \u201C",
                " ",
                react_1.default.createElement("span", { style: { color: "#00B38B" }, onClick: transferToCustomer },
                    repeatEmail.label,
                    " "),
                "\u201D \u91CD\u590D\uFF0C",
                props.selfChat.history ? (react_1.default.createElement(udesk_ui_1.Button, { onClick: showMergeModal, size: "small" }, t("udMerge.merge"))) : (react_1.default.createElement(react_1.default.Fragment, null,
                    t("udMerge.afterMergeConversation"),
                    " ",
                    react_1.default.createElement(udesk_ui_1.Button, { onClick: showMergeModal, size: "small" }, t("udMerge.appointmentMerge"))))))),
        reservationed && (react_1.default.createElement("div", { className: index_module_scss_1.default["repeat-box"] },
            react_1.default.createElement(icon_1.Warning, { className: index_module_scss_1.default["repeat-icon"] }),
            react_1.default.createElement("div", null,
                t("udMerge.hasAppointment"),
                " \u201C",
                react_1.default.createElement("span", { style: { color: "#00B38B" }, onClick: transferToCustomer },
                    repeatEmail.label,
                    " "),
                "\u201D",
                react_1.default.createElement(udesk_ui_1.Button, { onClick: cancelReservation, size: "small" }, t("udMerge.cancelReservation"))))),
        react_1.default.createElement(merge_1.default, { title: title, concatVisible: showMerge, customer: props.customer, repeatCustomer: repeatEmail, imSubSessionId: props.imSubSessionId, cancelCombineCustomer: setShowMerge, mergeFn: handleMerge, companyCategoryConfig: props.companyCategoryConfig, history: props.selfChat.history, reason: "email" })));
};
exports.default = Email;
