"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var field_item_1 = __importDefault(require("../../../../components/custom-field-container/field-item"));
var tag_field_1 = __importDefault(require("../../../ticket/components/tag-field"));
var desc_or_name_1 = __importDefault(require("./desc-or-name"));
var phone_formItem_1 = __importDefault(require("./phone-formItem"));
var email_1 = __importDefault(require("./email"));
var es_1 = require("udesk-ui/es");
var utils_1 = require("../../../../utils");
var org_select_1 = __importDefault(require("./org-select"));
var react_i18next_1 = require("react-i18next");
var CustomerFields = function (_a) {
    var currentUser = _a.currentUser, smsapp = _a.smsapp, customerFields = _a.customerFields, chat = _a.chat, roleCan = _a.roleCan, customer = _a.customer, company = _a.company, organizations = _a.organizations, organizationFields = _a.organizationFields, companyCategoryConfig = _a.companyCategoryConfig, event = _a.event, imSubSessionId = _a.imSubSessionId, switchFlag = _a.switchFlag, _b = _a.isFormItem, isFormItem = _b === void 0 ? true : _b, isAdmin = _a.isAdmin, user = _a.user, agents = _a.agents, props = __rest(_a, ["currentUser", "smsapp", "customerFields", "chat", "roleCan", "customer", "company", "organizations", "organizationFields", "companyCategoryConfig", "event", "imSubSessionId", "switchFlag", "isFormItem", "isAdmin", "user", "agents"]);
    var t = (0, react_i18next_1.useTranslation)().t;
    var _c = (0, react_1.useState)({}), toCustomer = _c[0], setToCustomer = _c[1];
    function isCustomField(item) {
        var type = item.field ? item.field.id || "" : "";
        return type.indexOf("SelectField") > -1 || type.indexOf("TextField") > -1;
    }
    var validatorEmail = (0, react_1.useCallback)(function (rule, values) {
        var emaillReg = /^[a-zA-Z0-9.!#$%&’*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/;
        if (!values || emaillReg.test(values)) {
            return Promise.resolve();
        }
        else {
            return Promise.reject(t("error.emailError"));
        }
    }, [t]);
    (0, react_1.useEffect)(function () {
        if (chat.history) {
            return;
        }
        (0, utils_1.getJSON)("/customer_merge_reservation", {
            from_customer_id: customer.id,
            im_sub_session_id: imSubSessionId,
        })
            .then(function (res) {
            if (res.code === 1000) {
                var to_customer = res.to_customer;
                if (!to_customer) {
                    // 都没有预约, 则都可以显示立即预约按钮
                    setToCustomer({});
                }
                else {
                    setToCustomer({
                        key: to_customer.id,
                        label: to_customer.nick_name,
                        value: to_customer.id,
                        reservation_reason: res.reservation_reason,
                    });
                }
            }
        })
            .catch(function (err) { });
    }, [imSubSessionId, customer.id, chat.history]);
    var customerFieldsMap = (0, react_1.useMemo)(function () {
        return customerFields.map(function (fieldItem) {
            // 自定义字段
            if (isCustomField(fieldItem)) {
                return (react_1.default.createElement(field_item_1.default, { key: fieldItem.field.id, switchFlag: switchFlag, agents: agents, fieldItem: fieldItem, isFormItem: isFormItem }));
            }
            if (fieldItem.name === "tags") {
                return (react_1.default.createElement(es_1.Form.Item, { key: fieldItem.name, label: t("label.tag"), name: "tags", trigger: "onBlur" },
                    react_1.default.createElement(tag_field_1.default, __assign({}, fieldItem))));
            }
            else if (fieldItem.name === "description") {
                return (react_1.default.createElement(es_1.Form.Item, { key: fieldItem.name, label: t("label.description"), name: "description", trigger: "onBlur" },
                    react_1.default.createElement(desc_or_name_1.default, __assign({ switchFlag: switchFlag }, fieldItem))));
            }
            else if (fieldItem.name === "name") {
                return (react_1.default.createElement(es_1.Form.Item, { key: fieldItem.name, label: t("label.name"), name: "nick_name", trigger: "onBlur", rules: [
                        {
                            required: true,
                            message: t("error.nameEmpty"),
                        },
                    ] },
                    react_1.default.createElement(desc_or_name_1.default, __assign({ switchFlag: switchFlag }, fieldItem))));
            }
            else if (fieldItem.name === "cellphone") {
                return (react_1.default.createElement(es_1.Form.Item, { key: fieldItem.name, label: t("label.phone"), name: "cellphones", trigger: "onBlur" },
                    react_1.default.createElement(phone_formItem_1.default, __assign({}, fieldItem, { customer: customer, imSubSessionId: imSubSessionId, event: event, selfChat: {
                            history: chat.history,
                            jid: chat.jid,
                            session_key: chat.session_key,
                            im_sub_session_id: chat.im_sub_session_id,
                        }, toCustomer: toCustomer, companyCategoryConfig: companyCategoryConfig, setToCustomer: function (config) { return setToCustomer(config); }, switchFlag: switchFlag, currentUser: currentUser, smsapp: smsapp, roleCan: roleCan, isAdmin: isAdmin, user: user }))));
            }
            else if (fieldItem.name === "organization") {
                return (react_1.default.createElement(es_1.Form.Item, { key: fieldItem.name, label: t("label.company"), name: "organizations", trigger: "onChange" },
                    react_1.default.createElement(org_select_1.default, __assign({}, fieldItem, { trigger: "onChange", customer: customer, event: event, organizations: organizations, organizationFields: organizationFields, canAdd: company.support_multi_organizations, canCreate: roleCan.add_new_organization, switchFlag: switchFlag }))));
            }
            else if (fieldItem.name === "email") {
                return (react_1.default.createElement(es_1.Form.Item, { key: fieldItem.name, label: t("label.email"), name: "email", trigger: "onBlur", rules: [{ validator: validatorEmail }] },
                    react_1.default.createElement(email_1.default, __assign({}, fieldItem, { customer: customer, imSubSessionId: imSubSessionId, event: event, selfChat: {
                            history: chat.history,
                            jid: chat.jid,
                            session_key: chat.session_key,
                            im_sub_session_id: chat.im_sub_session_id,
                        }, toCustomer: toCustomer, companyCategoryConfig: companyCategoryConfig, setToCustomer: function (config) { return setToCustomer(config); }, switchFlag: switchFlag }))));
            }
            else {
                return "";
            }
        });
    }, [
        chat.history,
        chat.im_sub_session_id,
        chat.jid,
        chat.session_key,
        company.support_multi_organizations,
        companyCategoryConfig,
        currentUser,
        customer,
        customerFields,
        event,
        imSubSessionId,
        isAdmin,
        isFormItem,
        organizationFields,
        organizations,
        roleCan,
        smsapp,
        switchFlag,
        t,
        toCustomer,
        user,
        validatorEmail,
    ]);
    return (react_1.default.createElement(react_1.default.Fragment, null, customerFields.length > 0 && customerFieldsMap));
};
exports.default = CustomerFields;
