"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var react_i18next_1 = require("react-i18next");
var customer_select_1 = __importDefault(require("./customer-select"));
var index_module_scss_1 = __importDefault(require("./index.module.scss"));
var icon_1 = require("../../../../components/icon/icon");
var isEmpty_1 = __importDefault(require("lodash-es/isEmpty"));
var utils_1 = require("../../../../utils");
var csApi_1 = require("../../../../utils/csApi");
var Merge = function (props) {
    var t = (0, react_i18next_1.useTranslation)().t;
    var title = props.title, concatVisible = props.concatVisible, repeatCustomer = props.repeatCustomer, cancelCombineCustomer = props.cancelCombineCustomer, imSubSessionId = props.imSubSessionId, customer = props.customer, reason = props.reason, history = props.history, mergeFn = props.mergeFn;
    var _a = (0, react_1.useState)(false), trun = _a[0], setTrun = _a[1];
    var showError = (0, react_1.useState)(false)[0];
    var _b = (0, react_1.useState)({}), mergeCustomer = _b[0], setMergeCustomer = _b[1];
    (0, react_1.useEffect)(function () {
        setMergeCustomer(repeatCustomer || null);
    }, [repeatCustomer]);
    var handleMerge = (0, react_1.useCallback)(function () {
        if ((0, isEmpty_1.default)(mergeCustomer)) {
            return udesk_ui_1.message.error(t("udMerge.selectTargetCustomer"));
        }
        // 当前客户id
        var currentId = trun ? mergeCustomer.value : customer.id;
        // 目标客户id
        var mergeId = trun ? customer.id : mergeCustomer.value;
        if (currentId === mergeId) {
            return udesk_ui_1.message.error(t("udMerge.sameCustomer"));
        }
        // 历史页面直接合并
        if (history) {
            (0, csApi_1.csApiPostJSON)("/cs/ts/api/customers/".concat(currentId, "/merge"), {
                form_id: mergeId,
            })
                .then(function (res) { return res.data; })
                .then(function (res) {
                if (res.code === 1000) {
                    udesk_ui_1.message.success(t("udMerge.mergeSuccess"));
                    mergeFn && mergeFn(trun, mergeCustomer, true);
                    cancelCombineCustomer(false);
                }
                else {
                    udesk_ui_1.message.error(res.code_message || t("udMerge.mergeFail"));
                }
            })
                .catch(function (e) {
                udesk_ui_1.message.error(t("udMerge.mergeFail"));
            });
        }
        else {
            // 当前聊天页面, 预约合并
            (0, utils_1.postJSON)("/customer_merge_reservation", {
                from_customer_id: currentId,
                to_customer_id: mergeId,
                im_sub_session_id: imSubSessionId,
                reservation_reason: reason,
            })
                .then(function (res) {
                if (res.code === 1000) {
                    udesk_ui_1.message.success(t("udMerge.appointmentMergeSuccess"));
                    mergeFn && mergeFn(false, mergeCustomer, false);
                    cancelCombineCustomer(false);
                }
                else {
                    udesk_ui_1.message.error(res.code_message || t("udMerge.appointmentMergeFail"));
                }
            })
                .catch(function () {
                udesk_ui_1.message.error(t("udMerge.mergeFail"));
            });
        }
    }, [
        cancelCombineCustomer,
        customer.id,
        history,
        imSubSessionId,
        mergeCustomer,
        mergeFn,
        reason,
        t,
        trun,
    ]);
    // const handleMerge = () => {
    //     if (isEmpty(mergeCustomer)) {
    //         return message.error(t('udMerge.selectTargetCustomer'));
    //     }
    //     // 当前客户id
    //     let currentId = trun ? mergeCustomer.value : customer.id
    //     // 目标客户id
    //     let mergeId = trun ? customer.id : mergeCustomer.value
    //     if (currentId === mergeId) {
    //         return message.error(t('udMerge.sameCustomer'));
    //     }
    //     // 历史页面直接合并
    //     if (history) {
    //         postJSON(`/customers/${currentId}/merge`, {
    //             form_id: mergeId
    //         }).then((res: any) => {
    //             if (res.code === 1000) {
    //                 message.success(t('udMerge.mergeSuccess'));
    //                 props.mergeFn && props.mergeFn(trun, mergeCustomer, true);
    //                 cancelCombineCustomer();
    //             } else {
    //                 message.error(res.code_message || t('udMerge.mergeFail'));
    //             }
    //         }).catch((e) => {
    //             message.error(t('udMerge.mergeFail'));
    //         })
    //     } else { // 当前聊天页面, 预约合并
    //         postJSON('/customer_merge_reservation', {
    //             from_customer_id: currentId,
    //             to_customer_id: mergeId,
    //             im_sub_session_id: imSubSessionId,
    //             reservation_reason: reason,
    //         }).then((res: any) => {
    //             if (res.code === 1000) {
    //                 message.success(t('udMerge.appointmentMergeSuccess'));
    //                 props.mergeFn && props.mergeFn(false, mergeCustomer, false);
    //                 cancelCombineCustomer();
    //             } else {
    //                 message.error(res.code_message || t('udMerge.appointmentMergeFail'));
    //             }
    //         }).catch(() => {
    //             message.error(t('udMerge.mergeFail'));
    //         })
    //     }
    // }
    var handleConcatCancel = (0, react_1.useCallback)(function () {
        cancelCombineCustomer(false);
    }, [cancelCombineCustomer]);
    // const handleConcatCancel = () => {
    //     cancelCombineCustomer();
    // }
    //选择目标客户
    var selectCustomer = (0, react_1.useCallback)(function (value) {
        setMergeCustomer(value);
    }, []);
    // const selectCustomer = (value: any, option: OptionsType[number] | OptionsType) => {
    //     setMergeCustomer(value);
    // }
    // 判断是否需要显示不能合并信息
    // !! 测试关注
    // useEffect(() => {
    //     if (!isEmpty(mergeCustomer)) {
    //         if (mergeCustomer.can_merge && customer.can_merge) {
    //             setShowError(false);
    //         } else {
    //             setShowError(true);
    //         }
    //     }
    // }, [mergeCustomer.can_merge, customer.can_merge])
    //交换目标客户和原有客户 更改order
    var changeCustomer = (0, react_1.useCallback)(function () {
        setTrun(function (prev) {
            return !prev;
        });
    }, []);
    // const changeCustomer = () => {
    //     setTrun((prev) => {
    //         return !prev;
    //     });
    // }
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(udesk_ui_1.Modal, { title: title, visible: concatVisible, onOk: handleMerge, okText: t("confirm"), cancelText: t("label.cancel"), onCancel: handleConcatCancel },
            react_1.default.createElement("div", { className: index_module_scss_1.default["phone-concat-modal-content"] },
                react_1.default.createElement("div", null,
                    react_1.default.createElement(udesk_ui_1.Row, null,
                        react_1.default.createElement(udesk_ui_1.Col, { span: 8 }, t("udMerge.currentCustomer")),
                        react_1.default.createElement(udesk_ui_1.Col, { span: 16 }, trun ? (react_1.default.createElement(customer_select_1.default, { value: repeatCustomer, selectOnChange: selectCustomer })) : (react_1.default.createElement("span", null, customer.nick_name)))),
                    react_1.default.createElement("br", null),
                    react_1.default.createElement(udesk_ui_1.Row, null,
                        react_1.default.createElement(udesk_ui_1.Col, { span: 8 }, t("udMerge.targetCustomer")),
                        react_1.default.createElement(udesk_ui_1.Col, { span: 16 }, trun ? (react_1.default.createElement("span", null, customer.nick_name)) : (react_1.default.createElement(customer_select_1.default, { value: repeatCustomer, selectOnChange: selectCustomer }))))),
                react_1.default.createElement("div", null,
                    react_1.default.createElement(icon_1.Change, { style: { marginLeft: "15px", fontSize: "50px" }, onClick: changeCustomer }))),
            react_1.default.createElement("br", null),
            showError ? (react_1.default.createElement("div", null,
                t("udMerge.typeNotMerge"),
                props.companyCategoryConfig &&
                    props.companyCategoryConfig.helpCenterDocumentHide && (
                // eslint-disable-next-line react/jsx-no-target-blank
                react_1.default.createElement("a", { href: "http://udesk.udesk.cn/hc/articles/29296", target: "_blank", style: { textDecoration: "underline" } }, "\u4E86\u89E3\u8BE6\u60C5")))) : (react_1.default.createElement(udesk_ui_1.Row, null,
                react_1.default.createElement(udesk_ui_1.Col, { offset: 2 },
                    react_1.default.createElement("p", null, t("udMerge.afterMergeCustomer")),
                    react_1.default.createElement("p", null, t("udMerge.mergeCustomerHelpOne")),
                    react_1.default.createElement("p", null, t("udMerge.mergeCustomerHelpTwo")),
                    react_1.default.createElement("p", null, t("udMerge.mergeCustomerHelpThree"))))))));
};
exports.default = Merge;
