"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var react_i18next_1 = require("react-i18next");
var csApi_1 = require("../../../../utils/csApi");
var index_module_scss_1 = __importDefault(require("./index.module.scss"));
var icons_1 = require("@ant-design/icons");
var copy_1 = __importDefault(require("../../../../components/copy"));
var create_org_1 = __importDefault(require("../create-org"));
var cloneDeep_1 = __importDefault(require("lodash-es/cloneDeep"));
var includes_1 = __importDefault(require("lodash-es/includes"));
var Option = udesk_ui_1.Select.Option;
var OrgSelect = function (props) {
    var t = (0, react_i18next_1.useTranslation)().t;
    var _a = (0, react_1.useState)(false), showModal = _a[0], setShowModal = _a[1];
    var _b = (0, react_1.useState)([]), optionsArr = _b[0], setOptionsArr = _b[1];
    var _c = (0, react_1.useState)([]), valueList = _c[0], setValueList = _c[1];
    var _d = (0, react_1.useState)(false), fetching = _d[0], setFetching = _d[1]; //无数据时展示
    (0, react_1.useEffect)(function () {
        setValueList(function () {
            if (Array.isArray(props.value) && props.value.length > 0) {
                return props.value.map(function (item) {
                    return {
                        label: item.name || item.label,
                        value: item.id || item.value,
                    };
                });
            }
            else {
                return [
                    {
                        label: "",
                        value: "",
                    },
                ];
            }
        });
    }, [props.value]);
    var getOrg = (0, react_1.useCallback)(function (query) {
        if (query === void 0) { query = ""; }
        setFetching(true);
        (0, csApi_1.csApiPostJSON)("/cs/ts/api/organizations/search", { query: query }).then(function (res) { return res.data; })
            .then(function (res) {
            if (res.code === 1000) {
                setOptionsArr(res.organizations.map(function (item) {
                    return {
                        value: item.id,
                        label: item.name,
                    };
                }));
            }
            else {
                udesk_ui_1.message.error(t("error.requestFailed"));
            }
        })
            .catch(function (err) { })
            .finally(function () {
            setFetching(false);
        });
    }, [t]);
    // 获取焦点时请求下数据
    var handleFocus = (0, react_1.useCallback)(function () {
        getOrg("");
    }, [getOrg]);
    // const handleFocus = () => {
    //     getOrg('');
    // }
    var handleSearch = (0, react_1.useCallback)(function (value) {
        getOrg(value);
    }, [getOrg]);
    // const handleSearch = (value: string) => {
    //     getOrg(value);
    // }
    var handleChange = (0, react_1.useCallback)(function (value, index) {
        var list = (0, cloneDeep_1.default)(valueList);
        //改变当前选择的公司的值
        if (value === undefined) {
            list.splice(index, 1);
        }
        else {
            list = list.map(function (item, idx) {
                if (index === idx) {
                    return {
                        label: value.label,
                        value: value.value,
                    };
                }
                else {
                    return item;
                }
            });
        }
        // list.splice(index, 1, value || {} as AntdSelectOptions)
        // 重新赋值
        if (list && list.length > 0) {
            setValueList(__spreadArray([], list, true));
        }
        else {
            setValueList([
                {
                    label: "",
                    value: "",
                },
            ]);
        }
        setFetching(false);
        var changeFunction = props[props.trigger];
        if (changeFunction) {
            // const _value = list.map(item => item.value).filter(t => t);
            // changeFunction(_value.length ? _value : '');
            changeFunction(list);
        }
    }, [props, valueList]);
    // 添加新的公司
    var addOrg = (0, react_1.useCallback)(function () {
        var canAdd = true;
        //如果有公司还没有选  禁止新加
        valueList.forEach(function (item) {
            if (!item.value) {
                canAdd = false;
                return;
            }
        });
        canAdd &&
            setValueList(__spreadArray([], valueList.concat({ value: "", label: "" }), true));
    }, [valueList]);
    // 删除公司
    var deleteOrg = (0, react_1.useCallback)(function (index) {
        var list = (0, cloneDeep_1.default)(valueList);
        list.splice(index, 1);
        setValueList(list);
        var changeFunction = props[props.trigger];
        if (changeFunction) {
            // const _value = list.map(item => item.value).filter(t => t);
            // changeFunction(_value.length ? _value : '');
            changeFunction(list);
        }
    }, [props, valueList]);
    // const handleOk = (companyInfo: any) => {
    //     setValueList([...valueList.concat(companyInfo as AntdSelectOptions)])
    // }
    var changeOrgValue = (0, react_1.useCallback)(function (info) {
        var list = [];
        if (props.canAdd) {
            list = __spreadArray([], valueList.concat(info), true);
        }
        else {
            list = [info];
        }
        setValueList(list);
        setShowModal(false);
        var changeFunction = props[props.trigger];
        if (changeFunction) {
            // const _value = list.map(item => item.value).filter(t => t);
            // changeFunction(_value.length ? _value : '');
            changeFunction(list);
        }
    }, [props, valueList]);
    // 点击已选择的公司  进入公司详情
    var goCompany = (0, react_1.useCallback)(function (e, item) {
        // 如果没有选择  不进行操作
        // 判断点击的是否是选择的字的地方  其他地方不触发
        if (e.target.className === "#{$prefix}-select-selection-item") {
            if (item.value) {
                props.event.transitionToRoute &&
                    props.event.transitionToRoute({
                        route: "crm.organization.show",
                        path: item.value,
                    });
                return false;
            }
        }
    }, [props.event]);
    return (react_1.default.createElement("div", { className: index_module_scss_1.default["org-selet-container"] },
        valueList.map(function (item, index) {
            return (react_1.default.createElement("div", { key: item.value, className: "".concat(index_module_scss_1.default["org-item"], " ").concat(item.value ? index_module_scss_1.default["link-class"] : "") },
                react_1.default.createElement(copy_1.default, { text: item.label, switchFlag: props.switchFlag, key: item.value },
                    react_1.default.createElement(udesk_ui_1.Select, { key: item.value, 
                        // onClick={(e) => goCompany(e, item)}
                        showSearch: true, allowClear: true, placeholder: "\u8F93\u5165\u5173\u952E\u5B57\u67E5\u8BE2\u516C\u53F8", value: item, labelInValue: true, defaultActiveFirstOption: false, showArrow: true, filterOption: false, onFocus: handleFocus, onSearch: handleSearch, onChange: function (item) { return handleChange(item, index); }, notFoundContent: fetching ? react_1.default.createElement(udesk_ui_1.Spin, { size: "small" }) : "无数据" }, optionsArr.length &&
                        optionsArr.map(function (option) {
                            var listIds = valueList.map(function (_l) { return _l.value || _l; });
                            if (!(0, includes_1.default)(listIds, option.value)) {
                                return (react_1.default.createElement(Option, { key: option.value, value: option.value }, option.label));
                            }
                            else {
                                return "";
                            }
                        }))),
                props.canAdd && (react_1.default.createElement(react_1.default.Fragment, null, !index ? (react_1.default.createElement("div", { onClick: addOrg, className: index_module_scss_1.default["add-org"] },
                    react_1.default.createElement(icons_1.PlusOutlined, null))) : (react_1.default.createElement("div", { onClick: function () { return deleteOrg(index); }, className: index_module_scss_1.default["add-org"] },
                    react_1.default.createElement(icons_1.MinusOutlined, null)))))));
        }),
        props.canCreate && valueList.length < 20 && (react_1.default.createElement("div", { className: index_module_scss_1.default["create-org"], onClick: function () { return setShowModal(true); }, style: { cursor: "pointer", display: "inline-block" } },
            react_1.default.createElement(icons_1.PlusOutlined, null),
            t("page.im.customerInfo.customer.add"))),
        react_1.default.createElement(udesk_ui_1.Modal, { title: t("page.im.customerInfo.customer.add"), visible: showModal, footer: null, forceRender: true, width: 700, 
            // onOk={changeOrgValue}
            onCancel: function () { return setShowModal(false); }, bodyStyle: { padding: "20px 0" } },
            react_1.default.createElement(create_org_1.default, { onSave: changeOrgValue, organizationFields: props.organizationFields, onCancel: function () { return setShowModal(false); } }))));
};
exports.default = OrgSelect;
