"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var copy_1 = __importDefault(require("../../../../components/copy"));
var icon_1 = require("../../../../components/icon/icon");
var index_module_scss_1 = __importDefault(require("./index.module.scss"));
var merge_1 = __importDefault(require("./merge"));
var cloneDeep_1 = __importDefault(require("lodash-es/cloneDeep"));
var ajax_1 = require("../../../../utils/ajax");
var isEqual_1 = __importDefault(require("lodash-es/isEqual"));
var react_i18next_1 = require("react-i18next");
var qs_1 = __importDefault(require("qs"));
var CustomerInfoPhone = function (props) {
    var t = (0, react_i18next_1.useTranslation)().t;
    //先缓存起来
    var _a = (0, react_1.useState)(function () {
        return props.value
            ? props.value.length < 1
                ? [
                    {
                        content: "",
                    },
                ]
                : (0, cloneDeep_1.default)(props.value.map(function (item) {
                    return {
                        id: item.id,
                        content: getPhoneText(item.content),
                    };
                }))
            : [
                {
                    content: "",
                },
            ];
    }), cellphonesArr = _a[0], setCellphonesArr = _a[1];
    var _b = (0, react_1.useState)(false), reservationed = _b[0], setReservationed = _b[1]; // 是否已经预约
    var _c = (0, react_1.useState)({}), hasReservation = _c[0], setHasReservation = _c[1]; // 缓存已预约数据
    var _d = (0, react_1.useState)(false), showMerge = _d[0], setShowMerge = _d[1];
    var _e = (0, react_1.useState)({}), repeatPhone = _e[0], setRepeatPhone = _e[1];
    var _f = (0, react_1.useState)("合并客户"), title = _f[0], setTitle = _f[1];
    var getCellphone = (0, react_1.useCallback)(function (phoneNumber) {
        try {
            if (Array.isArray(phoneNumber)) {
                return phoneNumber.map(function (i) { return hidePhoneNumber(i + ""); });
            }
            else {
                return hidePhoneNumber(phoneNumber + "");
            }
        }
        catch (e) {
            return Array.isArray(phoneNumber) ? [] : "";
        }
    }, []);
    var roleCanShow = (0, react_1.useCallback)(function () {
        var role_can = props.roleCan;
        var isAdmin = props.isAdmin;
        if (isAdmin || role_can.customer_show_cellphone_all) {
            return true;
        }
        if (!props.customer) {
            return false;
        }
        var user = props.user;
        var user_groups = user.user_groups || [];
        var ownerGroupId = props.customer.owner_group_id;
        if (role_can.customer_show_cellphone_group &&
            user_groups.find(function (item) { return item.id === ownerGroupId; })) {
            return true;
        }
        var ownerId = props.customer.owner_id;
        if (role_can.customer_show_cellphone_personal &&
            ownerId &&
            parseInt(ownerId) === parseInt("" + user.id, 10)) {
            return true;
        }
        return false;
    }, [props.isAdmin, props.roleCan, props.user, props.customer]);
    var roleCanEdit = (0, react_1.useCallback)(function () {
        var role_can = props.roleCan;
        var isAdmin = props.isAdmin;
        if (isAdmin || role_can.customer_edit_all) {
            return true;
        }
        if (!props.customer) {
            return false;
        }
        var user = props.user;
        var user_groups = user.user_groups || [];
        var ownerGroupId = props.customer.owner_group_id;
        if (role_can.customer_show_cellphone_group &&
            user_groups.find(function (item) { return item.id === ownerGroupId; })) {
            return true;
        }
        var ownerId = props.customer.owner_id;
        if (role_can.customer_show_cellphone_personal &&
            ownerId &&
            parseInt(ownerId) === parseInt("" + user.id, 10)) {
            return true;
        }
        return false;
    }, [props.isAdmin, props.roleCan, props.user, props.customer]);
    var getPhoneText = (0, react_1.useCallback)(function (text) {
        var isShow = roleCanShow();
        var hidePhone = props.customer.hide_number;
        if (isShow && !hidePhone) {
            return text;
        }
        else {
            return getCellphone(text);
        }
    }, [getCellphone, props.customer.hide_number, roleCanShow]);
    // 监听props.value的变化,显示新的callphone列表
    (0, react_1.useEffect)(function () {
        setCellphonesArr(function () {
            return props.value
                ? props.value.filter(function (item) { return item.content; }).length < 1
                    ? [
                        {
                            content: "",
                        },
                    ]
                    : (0, cloneDeep_1.default)(props.value.map(function (item) {
                        return {
                            id: item.id,
                            content: getPhoneText(item.content),
                            _destroy: item._destroy || false,
                        };
                    }))
                : [
                    {
                        content: "",
                    },
                ];
        });
    }, [props.value]);
    // 动态设置已预约合并信息
    (0, react_1.useEffect)(function () {
        if (props.toCustomer &&
            props.toCustomer.key &&
            props.toCustomer.label &&
            props.toCustomer.reservation_reason === "cellphone") {
            setHasReservation(props.toCustomer);
            setReservationed(true);
        }
        else {
            setHasReservation({});
            setReservationed(false);
        }
    }, [
        props.toCustomer,
        props.toCustomer.key,
        props.toCustomer.label,
        props.toCustomer.reservation_reason,
    ]);
    // 电话数据改变
    var changePhonesAttr = (0, react_1.useCallback)(function (_a) {
        var type = _a.type, value = _a.value, index = _a.index;
        setCellphonesArr(function (prevCellphones) {
            var _prevCellphones = (0, cloneDeep_1.default)(prevCellphones);
            if (type === "add") {
                _prevCellphones.push({
                    content: "",
                });
            }
            else if (type === "del") {
                _prevCellphones.splice(index, 1);
            }
            else if (type === "edit") {
                _prevCellphones.map(function (item, idx) {
                    if (idx === index) {
                        item.content = value;
                    }
                    return item;
                });
            }
            else if (type === "repeatPhone") {
                _prevCellphones.map(function (item, idx) {
                    if (idx === index) {
                        item["repeatPhone"] = value;
                    }
                    return item;
                });
            }
            return _prevCellphones;
        });
    }, []);
    // 增加
    var add = (0, react_1.useCallback)(function () {
        changePhonesAttr({
            type: "add",
        });
    }, [changePhonesAttr]);
    //删除一个
    var del = (0, react_1.useCallback)(function (index, item) {
        var _cellphonesArr = cellphonesArr.map(function (cell, idx) {
            if (index === idx) {
                return Object.assign({}, cell, {
                    _destroy: "1",
                });
            }
            else {
                return cell;
            }
        });
        setCellphonesArr(__spreadArray([], _cellphonesArr, true));
        if (item.content) {
            var changeFunction = props[props.trigger || "onChange"];
            if (changeFunction) {
                changeFunction(_cellphonesArr);
            }
        }
    }, [cellphonesArr, props]);
    // 预约回调
    var handleMerge = (0, react_1.useCallback)(function (isSelf, repeatInfo, needMerge) {
        if (repeatInfo === void 0) { repeatInfo = {}; }
        if (needMerge === void 0) { needMerge = false; }
        setShowMerge(false);
        setReservationed(true);
        setHasReservation(repeatInfo);
        props.setToCustomer(__assign(__assign({}, repeatInfo), { reservation_reason: "cellphone" }));
        if (props.selfChat.history && needMerge) {
            props.event.updateChat &&
                props.event.updateChat({
                    chat: props.selfChat,
                    key: "isDeletedCustomer",
                    value: !isSelf,
                });
        }
    }, [props]);
    // 电话输入框失焦处理
    var handleBlur = (0, react_1.useCallback)(function (e, index) {
        var changeFunction = props[props.trigger || "onChange"];
        var _value = e.target.value;
        // 如果值不变
        if ((0, isEqual_1.default)(props.value, cellphonesArr)) {
            return;
        }
        // 校验号码 是否已经和本客户已有的重复
        var hasNumberFlag = props.value.some(function (item) {
            return item.content === _value;
        });
        if (hasNumberFlag) {
            return udesk_ui_1.message.error("电话信息重复");
        }
        var params = {
            customer: {
                id: props.customer.id,
                cellphone: e.target.value,
            },
        };
        (0, ajax_1.getJSON)("/customers/check_duplication?" + qs_1.default.stringify(params), {})
            .then(function (res) {
            if (res.code !== 1000) {
                udesk_ui_1.message.error("检测重复电话失败");
            }
            else {
                var dup = res.duplications || {};
                // 有重复邮箱,显示预约合并按钮 ? 如果电话已经预约了 ?
                if (dup.cellphone && dup.cellphone.id) {
                    changePhonesAttr({
                        type: "repeatPhone",
                        key: "repeatPhone",
                        value: {
                            label: dup.cellphone.name,
                            value: dup.cellphone.id,
                            key: dup.cellphone.id,
                        },
                        index: index,
                    });
                }
                else {
                    if (changeFunction) {
                        var _cellphonesArr = cellphonesArr.map(function (cell) {
                            return Object.assign({}, __assign({}, cell), !cell.content ? { _destroy: 1 } : {});
                        });
                        changeFunction(_cellphonesArr);
                    }
                }
            }
        })
            .catch(function () { });
    }, [cellphonesArr, changePhonesAttr, props]);
    // 实时输入
    var handleChange = (0, react_1.useCallback)(function (e, index) {
        var _value = e.target.value;
        changePhonesAttr({
            type: "edit",
            value: _value,
            index: index,
        });
    }, [changePhonesAttr]);
    var transferToCustomer = (0, react_1.useCallback)(function (id) {
        props.event.transitionToRoute &&
            props.event.transitionToRoute({
                route: "crm.customer.show",
                path: id,
            });
    }, [props.event]);
    // 显示合并modal
    var showMergeModal = (0, react_1.useCallback)(function (repeatPhone) {
        if (props.selfChat.history) {
            setTitle("客户合并");
        }
        else {
            setTitle("预约客户合并");
        }
        setRepeatPhone(repeatPhone);
        setShowMerge(true);
    }, [props.selfChat.history]);
    // 取消立即预约
    var cancelReservation = (0, react_1.useCallback)(function () {
        (0, ajax_1.deleteJSON)("/customer_merge_reservation", {
            from_customer_id: props.customer.id,
            im_sub_session_id: props.imSubSessionId,
        })
            .then(function (res) {
            // 取消之后,通知父页面, 可以再次预约
            if (res.code === 1000) {
                setReservationed(false);
                setHasReservation({});
                props.setToCustomer({});
            }
            else {
                udesk_ui_1.message.error("取消失败,请重试");
            }
        })
            .catch(function (err) { });
    }, [props]);
    function hidePhoneNumber(phoneNumber) {
        if (!phoneNumber) {
            return "";
        }
        if (phoneNumber.length > 7) {
            return phoneNumber.substr(0, 3) + "****" + phoneNumber.substr(-4, 4);
        }
        else {
            return "****" + phoneNumber.substr(-3, 3);
        }
    }
    var callPhone = (0, react_1.useCallback)(function (phoneNumberObj) {
        props.event.onMakeCall(phoneNumberObj);
    }, [props.event]);
    var sendMessage = (0, react_1.useCallback)(function (phoneNumberObj) {
        props.event.openSms(phoneNumberObj);
    }, [props]);
    return (react_1.default.createElement("div", { className: index_module_scss_1.default["cellphone-list"] },
        cellphonesArr.map(function (item, index) {
            var Operator = index === 0 ? (react_1.default.createElement(icon_1.AddTask, { title: t("label.addPhone"), key: index, onClick: add, style: {
                    fontSize: "18px",
                    marginLeft: "10px",
                    cursor: "pointer",
                } })) : (react_1.default.createElement(icon_1.DelTask, { key: index, onClick: function () { return del(index, item); }, style: {
                    fontSize: "18px",
                    marginLeft: "10px",
                    cursor: "pointer",
                } }));
            return (react_1.default.createElement(react_1.default.Fragment, { key: item.id || index }, !item._destroy && (react_1.default.createElement("div", { className: "".concat(index_module_scss_1.default["flex-row"], " ").concat(index_module_scss_1.default["flex-row-item-center"], " ").concat(index_module_scss_1.default["margin-bottom-15"]) },
                react_1.default.createElement("div", { className: index_module_scss_1.default["cell-item"] },
                    react_1.default.createElement(copy_1.default, { text: item.content || "", switchFlag: props.switchFlag },
                        react_1.default.createElement(udesk_ui_1.Input, { onBlur: function (e) { return handleBlur(e, index); }, onChange: function (e) { return handleChange(e, index); }, value: item.content })),
                    props.currentUser && props.currentUser.isCall && (react_1.default.createElement(icon_1.Phone, { title: t("label.phone"), onClick: function () { return callPhone(item); }, style: {
                            fontSize: "18px",
                            color: "green",
                            marginLeft: "10px",
                            cursor: "pointer",
                        } })),
                    props.smsapp && props.smsapp.is_open && (react_1.default.createElement(icon_1.NewMessage, { title: t("label.message"), onClick: function () { return sendMessage(item); }, style: {
                            fontSize: "18px",
                            color: "blue",
                            marginLeft: "10px",
                            cursor: "pointer",
                        } })),
                    Operator),
                item.repeatPhone && item.repeatPhone.value && (react_1.default.createElement("div", { className: index_module_scss_1.default["repeat-box"] },
                    react_1.default.createElement(icon_1.Warning, { style: {
                            fontSize: "18px",
                            marginRight: "10px",
                            cursor: "pointer",
                        }, className: index_module_scss_1.default["repeat-icon"] }),
                    react_1.default.createElement("div", null,
                        "\u6B64\u7535\u8BDD\u4E0E\u5DF2\u6709\u5BA2\u6237 \u201C",
                        " ",
                        react_1.default.createElement("span", { style: { color: "#00B38B" }, onClick: function () {
                                return transferToCustomer(item.repeatPhone.value);
                            } },
                            item.repeatPhone.label,
                            " "),
                        "\u201D \u91CD\u590D\uFF0C",
                        props.selfChat.history ? (react_1.default.createElement(udesk_ui_1.Button, { onClick: function () { return showMergeModal(item.repeatPhone); }, size: "small" }, "\u5408\u5E76")) : (react_1.default.createElement(react_1.default.Fragment, null, reservationed ? ("对话结束后可合并") : (react_1.default.createElement(react_1.default.Fragment, null,
                            "\u5BF9\u8BDD\u7ED3\u675F\u540E\u53EF\u5408\u5E76, \u6216\u8005",
                            " ",
                            react_1.default.createElement(udesk_ui_1.Button, { onClick: function () { return showMergeModal(item.repeatPhone); }, size: "small" }, "\u9884\u7EA6\u5408\u5E76"))))))))))));
        }),
        reservationed && hasReservation && hasReservation.label && (react_1.default.createElement("div", { className: index_module_scss_1.default["repeat-box"] },
            react_1.default.createElement(icon_1.Warning, { className: index_module_scss_1.default["repeat-icon"] }),
            react_1.default.createElement("div", null,
                "\u5DF2\u9884\u7EA6\u5BF9\u8BDD\u7ED3\u675F\u540E\u5408\u5E76 \u201C",
                react_1.default.createElement("span", { style: { color: "#00B38B" }, onClick: function () { return transferToCustomer(hasReservation.value); } },
                    hasReservation.label,
                    " "),
                "\u201D",
                react_1.default.createElement(udesk_ui_1.Button, { onClick: cancelReservation, size: "small" }, "\u53D6\u6D88\u9884\u7EA6")))),
        react_1.default.createElement(merge_1.default, { title: title, customer: props.customer, concatVisible: showMerge, repeatCustomer: repeatPhone, imSubSessionId: props.imSubSessionId, cancelCombineCustomer: function () { return setShowMerge(false); }, companyCategoryConfig: props.companyCategoryConfig, history: props.selfChat.history, reason: "cellphone", mergeFn: handleMerge })));
};
exports.default = CustomerInfoPhone;
