"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var index_module_scss_1 = __importDefault(require("../index.module.scss"));
var udesk_ui_1 = require("udesk-ui");
var react_i18next_1 = require("react-i18next");
var isEqual_1 = __importDefault(require("lodash-es/isEqual"));
var FieldComponent = __importStar(require("../../ticket/components/index"));
var index_1 = require("../../../utils/index");
var csApi_1 = require("../../../utils/csApi");
var custom_field_container_1 = __importDefault(require("../../../components/custom-field-container"));
var qs_1 = __importDefault(require("qs"));
var store_hook_1 = require("../../../store/store-hook");
function CreateOrg(props) {
    var formRef = (0, react_1.useRef)(null);
    var t = (0, react_i18next_1.useTranslation)().t;
    var organizationFieldsV2 = (0, store_hook_1.useSelector)(function (state) { return state.fields.organizationFieldsv2; });
    var initData = (0, store_hook_1.useSelector)(function (state) { return state.initData; });
    var _organizationFields = (0, react_1.useMemo)(function () {
        return organizationFieldsV2
            .map(function (i) { return (__assign(__assign({}, i), { is_required: i.agent_permission === 1 })); })
            .filter(function (item) {
            if ((0, isEqual_1.default)(initData.page, 'im')) {
                return item.agent_permission && item.im_show;
            }
            else if ((0, isEqual_1.default)(initData.page, 'mpv')) {
                return item.agent_permission && item.mpv_show;
            }
            else {
                return item.agent_permission && item.cc_show;
            }
        });
    }, [organizationFieldsV2]);
    var orgFields = (0, index_1.formatCustomField)({
        fields: _organizationFields,
    });
    // 提交时触发
    var handleSubmit = (0, react_1.useCallback)(function (values) {
        var custom_fields = {};
        var sys_fields = {};
        for (var k in values) {
            if (values[k]) {
                if (k.indexOf('TextField') > -1 || k.indexOf('SelectField') > -1) {
                    custom_fields[k] = values[k];
                }
                else {
                    sys_fields[k] = values[k];
                }
            }
        }
        var params = {
            organization: __assign(__assign({}, sys_fields), { custom_fields: __assign({}, custom_fields) }),
        };
        // 开始提交请求
        (0, csApi_1.csApiPostJSON)('/cs/ts/api/organizations', params, {
            transformRequest: [
                function (data) {
                    return qs_1.default.stringify(data, { arrayFormat: 'brackets' });
                },
            ],
        }).then(function (res) { return res.data; })
            .then(function (res) {
            // 创建成功后将创建的用户更新   给新增工单页面回显用
            if (res.code === 1000) {
                props.onSave({
                    label: res.organization.name,
                    value: res.organization.id,
                });
            }
            else {
                udesk_ui_1.message.error(t('tip.error.saveTry'));
            }
        })
            .catch(function (err) {
            udesk_ui_1.message.error(t('tip.error.saveTry'));
        });
    }, [props, t]);
    // 表单数据改变触发  开发时方便查看  提测注释掉
    var handleChangeValue = (0, react_1.useCallback)(function (changeValue, allValue) {
        // console.log(allValue)
        // setFormData(allValue);
    }, []);
    var handleInitialValue = (0, react_1.useMemo)(function () {
        var initValue = (0, index_1.getFieldsDefaultValue)({
            fields: _organizationFields,
            valuse: {},
        });
        return Object.assign({
            name: '',
            level: '',
            description: '',
            org_email_suffix: '',
            domains: '',
        }, initValue);
    }, [_organizationFields]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: index_module_scss_1.default['ticket-form'] },
            react_1.default.createElement(udesk_ui_1.Form, { ref: formRef, initialValues: handleInitialValue, onFinish: handleSubmit, layout: "vertical", onValuesChange: handleChangeValue },
                react_1.default.createElement(udesk_ui_1.Form.Item, { name: "name", label: t('page.im.customerInfo.organization.name'), required: true, rules: [
                        {
                            required: true,
                            message: t('page.im.customerInfo.organization.validateFail'),
                        },
                    ] },
                    react_1.default.createElement(FieldComponent.text, { trigger: "onChange", isRequired: true, id: "name", type: "text" })),
                react_1.default.createElement(udesk_ui_1.Form.Item, { name: "level", label: t('page.im.customerInfo.customer.level') },
                    react_1.default.createElement(FieldComponent.droplist, { id: "level", type: "droplist", trigger: "onChange", options: [
                            {
                                value: 'normal',
                                title: t('page.im.customerInfo.customer.enum.level.normal'),
                            },
                            {
                                value: 'vip',
                                title: t('page.im.customerInfo.customer.enum.level.vip'),
                            },
                        ] })),
                react_1.default.createElement(udesk_ui_1.Form.Item, { name: "description", label: t('page.im.customerInfo.customer.description') },
                    react_1.default.createElement(FieldComponent.textarea, { trigger: "onChange", placeholder: t('page.im.ticket.descTip'), id: "description", type: "textarea" })),
                react_1.default.createElement(udesk_ui_1.Form.Item, { name: "org_email_suffix", label: t('page.im.customerInfo.organization.org_email_suffix') },
                    react_1.default.createElement(FieldComponent.textHasPoint, { remark: t('page.im.ticket.emailSuffixHelpText') })),
                react_1.default.createElement(udesk_ui_1.Form.Item, { name: "domains", label: t('page.im.customerInfo.organization.domains') },
                    react_1.default.createElement(FieldComponent.textHasPoint, { remark: t('page.im.ticket.helpBlock') })),
                orgFields.length > 1 && (react_1.default.createElement("div", { className: index_module_scss_1.default['org-custom-list'] },
                    react_1.default.createElement(custom_field_container_1.default, { fields: orgFields }))))),
        react_1.default.createElement("div", { style: { textAlign: 'center', marginTop: '15px' } },
            react_1.default.createElement(udesk_ui_1.Button, { style: { marginRight: '10px' }, onClick: props.onCancel }, t('cancel')),
            react_1.default.createElement(udesk_ui_1.Button, { type: "primary", onClick: function () { return formRef.current.submit(); } }, t('confirm')))));
}
exports.default = CreateOrg;
