"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var react_i18next_1 = require("react-i18next");
var index_module_scss_1 = __importDefault(require("../index.module.scss"));
var icon_1 = require("../../../components/icon/icon");
var store_hook_1 = require("../../../store/store-hook");
var store_hook_2 = require("../../../store/store-hook");
var csApi_1 = require("../../../utils/csApi");
var CustomerInfoDetail = function (_a) {
    var _b = _a.customer, customer = _b === void 0 ? {} : _b, company = _a.company, event = _a.event, chat = _a.chat;
    var dispatch = (0, store_hook_1.useDispatch)();
    var t = (0, react_i18next_1.useTranslation)().t;
    var initData = (0, store_hook_2.useSelector)(function (state) { return state.initData; });
    var isCustomerOwnerOn = company.is_customer_owner_on;
    var _c = (0, react_1.useState)(customer.level || 'normal'), level = _c[0], setLevel = _c[1];
    var _d = (0, react_1.useState)(false), block = _d[0], setBlock = _d[1];
    var _e = (0, react_1.useState)(false), modal = _e[0], setModal = _e[1];
    var roleCan = (0, store_hook_2.useSelector)(function (state) { return state.roleCan; });
    (0, react_1.useEffect)(function () {
        setLevel(customer.level || 'normal');
    }, [customer.level]);
    (0, react_1.useEffect)(function () {
        setBlock(customer.is_blocked || false);
    }, [customer.is_blocked]);
    var toggleVip = (0, react_1.useCallback)(function () {
        (0, csApi_1.csApiPutJSON)("/cs/ts/api/customers/".concat(customer.id), {
            customer: {
                level: level === 'vip' ? 'normal' : 'vip',
            },
        }).then(function (res) { return res.data; })
            .then(function (res) {
            if (res.code === 1000) {
                setLevel(level === 'vip' ? 'normal' : 'vip');
                event.updateChatCustomer(res.customer);
                udesk_ui_1.message.info(t('tip.success.save'));
            }
            else {
                udesk_ui_1.message.error(res.code_message || (res.exceptopn && res.exceptopn.message) || t('tip.error.saveTry'));
            }
        })
            .catch(function (err) {
            udesk_ui_1.message.error(t('tip.error.saveTry'));
        });
    }, [customer.id, event, level, t]);
    var goCustomer = (0, react_1.useCallback)(function () {
        event.transitionToRoute &&
            event.transitionToRoute({
                route: 'crm.customer.show',
                path: customer.id,
            });
    }, [customer.id, event]);
    var goBlock = (0, react_1.useCallback)(function () {
        (0, csApi_1.csApiPutJSON)("/cs/ts/api/customers/".concat(customer.id, "/toggle_block"))
            .then(function (res) { return res.data; })
            .then(function (res) {
            if (res.code === 1000) {
                setBlock(function (prev) {
                    if (prev) {
                        udesk_ui_1.message.success(t('page.im.customerInfo.cancel_blocked'));
                    }
                    else {
                        udesk_ui_1.message.success(t('page.im.customerInfo.blocked'));
                    }
                    event.updateChat &&
                        event.updateChat({
                            chat: chat,
                            updateProps: {
                                customer: {
                                    is_blocked: !prev,
                                },
                            },
                        });
                    return !prev;
                });
                setModal(false);
            }
            else {
                udesk_ui_1.message.error(res.code_message || (res.exceptopn && res.exceptopn.message) || t('tip.error.saveTry'));
            }
        })
            .catch(function (err) {
            udesk_ui_1.message.error(t('tip.error.saveTry'));
        });
    }, [chat, customer.id, dispatch, t]);
    return (react_1.default.createElement("div", { className: index_module_scss_1.default['customer-info-header-container'] },
        react_1.default.createElement("div", { className: index_module_scss_1.default['customer-info-header'] },
            react_1.default.createElement("div", { className: index_module_scss_1.default['customer-info-header-left'] },
                react_1.default.createElement("div", { className: index_module_scss_1.default['customer-info-uid'] },
                    "uid: ",
                    customer.uid),
                react_1.default.createElement(udesk_ui_1.Tooltip, { placement: "right", title: level === 'vip'
                        ? t('page.im.customerInfo.customer.enum.level.cancelvip')
                        : t('page.im.customerInfo.customer.enum.level.settingvip') },
                    react_1.default.createElement("div", { onClick: toggleVip, className: level === 'vip' ? index_module_scss_1.default['vip-customer-box'] : index_module_scss_1.default['common-customer-box'] }, level === 'vip' ? 'VIP' : t('page.im.customerInfo.customer.enum.level.normal')))),
            !!roleCan.defriend_customer && (react_1.default.createElement("div", { className: index_module_scss_1.default['customer-info-header-right'] },
                block && (react_1.default.createElement(react_1.default.Fragment, null,
                    react_1.default.createElement(icon_1.ShiftOut, null),
                    react_1.default.createElement("span", { className: index_module_scss_1.default['go-back-list'], onClick: goBlock }, '移出'))),
                !block && (react_1.default.createElement(react_1.default.Fragment, null,
                    react_1.default.createElement(icon_1.BlackList, null),
                    react_1.default.createElement("span", { className: index_module_scss_1.default['go-back-list'], onClick: function () { return setModal(true); } }, t('label.block')))),
                !(initData === null || initData === void 0 ? void 0 : initData.sdk) && (react_1.default.createElement(udesk_ui_1.Button, { size: 'small', onClick: goCustomer }, t('label.detail')))))),
        react_1.default.createElement("div", { className: index_module_scss_1.default['counts-1'] },
            react_1.default.createElement("div", { className: index_module_scss_1.default['count-item'] },
                react_1.default.createElement("span", { className: index_module_scss_1.default['count-item-title'] }, t('label.callRecord')),
                react_1.default.createElement("span", { className: index_module_scss_1.default['count-item-count'] }, customer.calls_count || 0)),
            react_1.default.createElement("div", { className: index_module_scss_1.default['count-item'] },
                react_1.default.createElement("span", { className: index_module_scss_1.default['count-item-title'] }, t('label.imRecord')),
                react_1.default.createElement("span", { className: index_module_scss_1.default['count-item-count'] }, customer.im_sub_sessions_count || 0)),
            react_1.default.createElement("div", { className: index_module_scss_1.default['count-item'] },
                react_1.default.createElement("span", { className: index_module_scss_1.default['count-item-title'] }, t('label.ticket')),
                react_1.default.createElement("span", { className: index_module_scss_1.default['count-item-count'] }, customer.ticket_count || 0)),
            react_1.default.createElement("div", { className: index_module_scss_1.default['count-item'] },
                react_1.default.createElement("span", { className: index_module_scss_1.default['count-item-title'] }, t('label.videoRecord')),
                react_1.default.createElement("span", { className: index_module_scss_1.default['count-item-count'] }, customer.video_records_count || 0)),
            isCustomerOwnerOn && (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement("div", { className: index_module_scss_1.default['count-item'] },
                    react_1.default.createElement("span", { className: index_module_scss_1.default['count-item-title'] }, t('label.owner')),
                    react_1.default.createElement("span", { className: index_module_scss_1.default['count-item-count'] }, customer.owner_name)),
                react_1.default.createElement("div", { className: index_module_scss_1.default['count-item'] },
                    react_1.default.createElement("span", { className: index_module_scss_1.default['count-item-title'] }, t('label.ownerGroup')),
                    react_1.default.createElement("span", { className: index_module_scss_1.default['count-item-count'] }, customer.owner_group_name))))),
        react_1.default.createElement(udesk_ui_1.Modal, { title: "\u786E\u8BA4\u62C9\u9ED1", visible: modal, onOk: goBlock, onCancel: function () { return setModal(false); }, okText: t('confirm'), cancelText: t('cancel') },
            react_1.default.createElement("p", null, "\u786E\u5B9A\u8981\u62C9\u9ED1\u8FD9\u4E2A\u5BA2\u6237\u5417"))));
};
exports.default = CustomerInfoDetail;
