"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var axios_1 = __importDefault(require("axios"));
var field_hook_1 = require("../../../utils/field-hook");
var merge_1 = __importDefault(require("lodash-es/merge"));
var udesk_ui_1 = require("udesk-ui");
var index_1 = require("../../../utils/index");
var csApi_1 = require("../../../utils/csApi");
var form_list_1 = __importDefault(require("./component/form-list"));
var platform_type_1 = __importDefault(require("./component/platform-type"));
var qs_1 = __importDefault(require("qs"));
var customer_form_module_scss_1 = __importDefault(require("./customer-form.module.scss"));
var react_i18next_1 = require("react-i18next");
var isEqual_1 = __importDefault(require("lodash-es/isEqual"));
var cloneDeep_1 = __importDefault(require("lodash-es/cloneDeep"));
var store_hook_1 = require("../../../store/store-hook");
function judgeValueChanged(changedValue, initialValue) {
    var key = Object.keys(changedValue)[0];
    if ((0, isEqual_1.default)(initialValue[key], changedValue[key])) {
        return false;
    }
    return true;
}
function getParam(changedValues) {
    var _a, _b;
    var param = {};
    var cellResult = [];
    for (var changedKey in changedValues) {
        var _isSysField = (0, index_1.isSysField)(changedKey);
        if (_isSysField) {
            switch (changedKey) {
                case 'nick_name':
                case 'email':
                case 'description':
                    (0, merge_1.default)(param, {
                        customer: (_a = {}, _a[changedKey] = changedValues[changedKey], _a),
                    });
                    break;
                case 'cellphones':
                    cellResult = changedValues[changedKey]
                        .filter(function (item) {
                        return item.id || item.content;
                    })
                        .map(function (cell) {
                        if (cell.id) {
                            if (cell.content) {
                                return cell;
                            }
                            else {
                                return Object.assign({}, cell, {
                                    content: cell.content,
                                    id: cell.id,
                                    _destroy: 1,
                                });
                            }
                        }
                        else {
                            return cell;
                        }
                    });
                    (0, merge_1.default)(param, {
                        customer: {
                            cellphones_attributes: cellResult,
                        },
                    });
                    break;
                case 'organizations':
                    (0, merge_1.default)(param, {
                        customer: {
                            organizations: changedValues[changedKey] && changedValues[changedKey].length > 0
                                ? changedValues[changedKey].map(function (item) { return item.value; }).filter(function (t) { return t; })
                                : '',
                        },
                    });
                    break;
                case 'tags':
                    (0, merge_1.default)(param, {
                        tags: changedValues[changedKey].map(function (item) { return item.label; }).join(','),
                    });
                    break;
            }
        }
        else {
            (0, merge_1.default)(param, {
                customer: {
                    custom_fields: (_b = {}, _b[changedKey] = changedValues[changedKey], _b),
                },
            });
        }
    }
    return param;
}
var CustomerInfoForm = function (_a) {
    var currentUser = _a.currentUser, smsapp = _a.smsapp, _b = _a.chat, chat = _b === void 0 ? {} : _b, company = _a.company, roleCan = _a.roleCan, customerFieldsv2 = _a.customerFieldsv2, organizationFields = _a.organizationFields, event = _a.event, companyCategoryConfig = _a.companyCategoryConfig, switchFlag = _a.switchFlag, customerFieldsAuthority = _a.customerFieldsAuthority, fieldHooks = _a.fieldHooks, isAdmin = _a.isAdmin, user = _a.user, agents = _a.agents;
    var form = udesk_ui_1.Form.useForm()[0];
    var _c = (0, react_1.useState)({}), initialValue = _c[0], setInitialValue = _c[1];
    var _d = (0, react_1.useState)(), lastValues = _d[0], setLastValues = _d[1];
    var t = (0, react_i18next_1.useTranslation)().t;
    var initData = (0, store_hook_1.useSelector)(function (state) { return state.initData; });
    var customer = chat.customer, organizations = chat.organizations, imSubSessionId = chat.im_sub_session_id, sessionKey = chat.session_key;
    var _customerFieldsv2 = (0, react_1.useMemo)(function () {
        var customerFieldsv2_bk = (0, cloneDeep_1.default)(customerFieldsv2);
        if (customerFieldsv2_bk) {
            return customerFieldsv2_bk.filter(function (field) {
                if ((0, isEqual_1.default)(initData.page, 'im')) {
                    return field.im_show;
                }
                else if ((0, isEqual_1.default)(initData.page, 'mpv')) {
                    return field.mpv_show;
                }
                else {
                    return field.cc_show;
                }
            });
        }
        else {
            return [];
        }
    }, [customerFieldsv2]);
    var customerFields = (0, react_1.useMemo)(function () {
        return (0, index_1.formatCustomField)({
            fields: _customerFieldsv2,
            trigger: 'onBlur',
            fieldsAuthority: customerFieldsAuthority,
            fieldType: 'customer',
            editType: 'edit',
        });
    }, [_customerFieldsv2, customerFieldsAuthority]);
    var getValues = (0, react_1.useCallback)(function (_customer, organizations) {
        var initValues = (0, index_1.getFieldsDefaultValue)({
            fields: _customerFieldsv2,
            values: _customer.custom_fields || {},
        }) || {};
        var _organizations = (organizations || []).map(function (org) {
            return {
                label: org.name,
                value: org.id,
            };
        });
        initValues = Object.assign({}, initValues, _customer.custom_fields, {
            nick_name: _customer.nick_name,
            cellphones: _customer.cellphones || [{ content: '' }],
            email: _customer.email,
            organizations: _organizations,
            tags: _customer.rich_tags,
            description: _customer.description,
        });
        return initValues;
    }, [_customerFieldsv2]);
    (0, react_1.useEffect)(function () {
        var values = getValues(customer, organizations);
        setInitialValue(values);
        form.setFieldsValue(values);
        setLastValues(values);
    }, [customer, form, getValues, organizations, sessionKey]);
    var availableFieldHooks = (0, react_1.useMemo)(function () {
        if (fieldHooks) {
            return fieldHooks.filter(function (i) { return i.active && i.trigger_type === 'edit' && i.field_owner === 'Customer'; });
        }
        else {
            return [];
        }
    }, [fieldHooks]);
    var submitFn = (0, react_1.useCallback)(function (changedValues) {
        var param = getParam(changedValues);
        return (0, csApi_1.csApiPutJSON)("/cs/ts/api/customers/".concat(customer.id), param, {
            transformRequest: [
                function (data) {
                    return qs_1.default.stringify(data, { arrayFormat: 'brackets' });
                },
            ],
        }).then(function (res) { return res.data; })
            .then(function (res) {
            var _a;
            if (res.code === 1000) {
                var values = getValues(res.customer || {}, res.organizations);
                if (values.cellphones && values.cellphones.length) {
                    values.cellphones = [
                        {
                            content: '',
                        },
                    ];
                }
                setInitialValue(values);
                udesk_ui_1.message.success(t('tip.success.save'));
                var custom_fields = Object.assign(res.customer.custom_fields, (_a = param === null || param === void 0 ? void 0 : param.customer) === null || _a === void 0 ? void 0 : _a.custom_fields);
                res.customer.custom_fields = custom_fields;
                event.updateChat(chat, {
                    organizations: res.organizations,
                    customer: res.customer,
                    nick_name: res.customer.nick_name,
                    rich_tags: res.customer.rich_tags || [],
                });
            }
            else {
                udesk_ui_1.message.error(res.code_message || (res.exceptopn && res.exceptopn.message) || t('tip.error.saveTry'));
            }
        })
            .catch(function (err) {
            console.error(err);
        });
    }, [chat, customer.id, event, getValues, t]);
    var formSubmit = (0, react_1.useCallback)(function (changedValues, values) {
        var changed = judgeValueChanged(changedValues, initialValue);
        if (!changed) {
            return;
        }
        var fieldHook = availableFieldHooks.find(function (i) {
            var triggerField = i.trigger_field;
            triggerField === 'name' && (triggerField = 'nick_name');
            return triggerField && triggerField in changedValues;
        });
        if (fieldHook) {
            return axios_1.default
                .post(fieldHook.url, (0, field_hook_1.buildHookRequestParamsForCustomer)(fieldHook, (0, merge_1.default)({}, customer, values), {
                customerCustomFields: customerFieldsv2,
                otherParams: { im_sub_session_id: imSubSessionId },
            }))
                .then(function (res) {
                if (res.data.error) {
                    udesk_ui_1.message.error(res.data.error);
                }
                if (res.data.code === 1000) {
                    // form.setFieldsValue(res.data.customer);
                    return form
                        .validateFields(Object.keys(res.data.customer))
                        .then(function () {
                        submitFn(res.data.customer).finally(function () { return setLastValues(values); });
                    })
                        .catch(function () {
                        form.setFieldsValue(lastValues);
                    });
                }
                else if (!res.data.error) {
                    udesk_ui_1.message.error('请求数据错误，请重试!');
                    throw new Error('请求数据错误，请重试!');
                }
                else {
                    throw new Error(res.data.error);
                }
            });
        }
        else {
            submitFn(changedValues).finally(function () { return setLastValues(values); });
        }
    }, []);
    var onValueChange = function (changedValues, values) {
        form.validateFields(Object.keys(changedValues))
            .then(function () {
            formSubmit(changedValues, values);
        })
            .catch(function (err) {
            console.log(err);
            var key = Object.keys(changedValues)[0];
            var canSubmit = true;
            err.errorFields.forEach(function (item) {
                if (item.name[0] === key) {
                    canSubmit = false;
                }
            });
            if (canSubmit) {
                formSubmit(changedValues, values);
            }
        });
    };
    return (react_1.default.createElement("div", { className: customer_form_module_scss_1.default['customer-form'], style: { marginTop: '10px' } },
        react_1.default.createElement(udesk_ui_1.Form, { layout: "vertical", name: "customer-info-form", onValuesChange: onValueChange, form: form },
            react_1.default.createElement(platform_type_1.default, { customer: customer }),
            react_1.default.createElement(form_list_1.default, { switchFlag: switchFlag, customerFields: customerFields, organizationFields: organizationFields, company: company, customer: customer, imSubSessionId: imSubSessionId, event: event, chat: chat, companyCategoryConfig: companyCategoryConfig, organizations: organizations, roleCan: roleCan, currentUser: currentUser, smsapp: smsapp, isAdmin: isAdmin, user: user, agents: agents }))));
};
exports.default = CustomerInfoForm;
