"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var form_1 = __importDefault(require("./form"));
var company_info_1 = __importDefault(require("../company-info/company-info"));
var index_module_scss_1 = __importDefault(require("../index.module.scss"));
var isEqual_1 = __importDefault(require("lodash-es/isEqual"));
var csApi_1 = require("../../../utils/csApi");
var store_hook_1 = require("../../../store/store-hook");
var CustomerInfo = function (props) {
    var _a = props.chat, chat = _a === void 0 ? {} : _a, event = props.event, organizationFieldsv2 = props.organizationFieldsv2, organizationFields = props.organizationFields, organizations = props.organizations;
    var customer = chat.customer, imSubSessionId = chat.im_sub_session_id, customerId = chat.customer_id, sessionKey = chat.session_key;
    var initData = (0, store_hook_1.useSelector)(function (state) { return state.initData; });
    //tab切换状态  客户信息 customer 公司信息 org
    var _b = (0, react_1.useState)(''), type = _b[0], setType = _b[1];
    var _c = (0, react_1.useState)(false), showOrg = _c[0], setShowOrg = _c[1];
    /**
  cc_show: false
    code: 1000
    im_priority_display: false
    im_show: true
 */
    (0, react_1.useEffect)(function () {
        var URL = '/cs/ts/api/custom_fields/organization_setting';
        (0, csApi_1.csApiGetJSON)(URL).then(function (res) { return res.data; })
            .then(function (res) { return res.data; })
            .then(function (res) {
            if (res.code === 1000) {
                if ((0, isEqual_1.default)(initData.page, 'im')) {
                    setShowOrg(res.im_show);
                    setType(res.im_show && res.im_priority_display ? 'org' : 'customer');
                }
                else if ((0, isEqual_1.default)(initData.page, 'mpv')) {
                    setShowOrg(res.mpv_show);
                    setType(res.mpv_show && res.im_priority_display ? 'org' : 'customer');
                }
                else {
                    setShowOrg(res.cc_show);
                    setType(res.cc_show && res.im_priority_display ? 'org' : 'customer');
                }
            }
            else {
                setType('customer');
            }
        })
            .catch(function (err) {
            setType('customer');
        });
    }, []);
    return (react_1.default.createElement("div", { className: index_module_scss_1.default['info-page'] }, customer ? (react_1.default.createElement(react_1.default.Fragment, null,
        showOrg && (react_1.default.createElement("div", { className: index_module_scss_1.default['tab-list'] },
            react_1.default.createElement("div", null,
                react_1.default.createElement("span", { className: "".concat(index_module_scss_1.default['tab-item-name'], " ").concat(type === 'customer' ? index_module_scss_1.default['active'] : ''), onClick: function () { return setType('customer'); } }, "\u5BA2\u6237\u4FE1\u606F"),
                react_1.default.createElement("span", { className: index_module_scss_1.default['filter-span-separator'] }, "|")),
            showOrg && (react_1.default.createElement("div", null,
                react_1.default.createElement("span", { className: "".concat(index_module_scss_1.default['tab-item-name'], " ").concat(type === 'org' ? index_module_scss_1.default['active'] : ''), onClick: function () { return setType('org'); } }, "\u516C\u53F8\u4FE1\u606F"))))),
        react_1.default.createElement("div", { className: index_module_scss_1.default['tab-content'] },
            type === 'customer' && react_1.default.createElement(form_1.default, __assign({}, props, { switchFlag: true })),
            type === 'org' && (react_1.default.createElement(company_info_1.default, { event: event, organizationFieldsv2: organizationFieldsv2, organizationFields: organizationFields, sessionKey: sessionKey, customerId: customerId, chat: chat, imSubSessionId: imSubSessionId, organizations: organizations }))))) : null));
};
exports.default = CustomerInfo;
