"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var classnames_1 = __importDefault(require("classnames"));
var react_i18next_1 = require("react-i18next");
var unionBy_1 = __importDefault(require("lodash-es/unionBy"));
var isFunction_1 = __importDefault(require("lodash-es/isFunction"));
var includes_1 = __importDefault(require("lodash-es/includes"));
var utils_1 = require("../utils");
var csApi_1 = require("../utils/csApi");
var component_1 = require("./component");
var tab_setting_modal_1 = __importDefault(require("./parallel/tab-setting-modal/tab-setting-modal"));
var tab_parallel_1 = __importDefault(require("./parallel/tab-parallel"));
var icon_1 = require("../components/icon/icon");
var simple_error_boundary_1 = __importDefault(require("../components/simple-error-boundary"));
var store_hook_1 = require("../store/store-hook");
var index_module_scss_1 = __importDefault(require("./index.module.scss"));
var isEqual_1 = __importDefault(require("lodash-es/isEqual"));
var concat_1 = __importDefault(require("lodash-es/concat"));
var TabPane = udesk_ui_1.Tabs.TabPane;
function getTabKey(tabName, customer_id) {
    return "".concat(tabName, "-").concat(customer_id);
}
var ImPanel = react_1.default.forwardRef(function (_a, ref) {
    var _b;
    var width = _a.width, onWidthChange = _a.onWidthChange, cssMaxWidth = _a.cssMaxWidth, props = __rest(_a, ["width", "onWidthChange", "cssMaxWidth"]);
    var t = (0, react_i18next_1.useTranslation)().t;
    var _c = props.chat, chat = _c === void 0 ? {} : _c, agentConfig = props.agentConfig, currentUser = props.currentUser, noteFields = props.noteFields, event = props.event;
    var _d = (0, react_1.useState)([]), tabPlugins = _d[0], setTabPlugins = _d[1];
    var customer_id = chat.customer_id, _e = chat.plugTab, plugTab = _e === void 0 ? {} : _e;
    var containerRef = (0, react_1.useRef)(null);
    var initData = (0, store_hook_1.useSelector)(function (state) { return state.initData; });
    var agentTabConfig = (0, react_1.useMemo)(function () {
        return (agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.agent_tab_config) || {};
    }, [agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.agent_tab_config]);
    var minWidth = (0, react_1.useMemo)(function () {
        if (agentTabConfig.parallel) {
            return 600;
        }
        else {
            return 400;
        }
    }, [agentTabConfig.parallel]);
    // const tabsWidth = 420;
    var _f = (0, react_1.useState)(), currentTab = _f[0], setCurrentTab = _f[1];
    var _g = (0, react_1.useState)(false), showModal = _g[0], setShowModal = _g[1];
    var _h = (0, react_1.useState)({
        show: false,
        ticketCover: '',
        zIndex: 0,
    }), showTicket = _h[0], setShowTicket = _h[1];
    var _j = (0, react_1.useState)({
        show: false,
        visitCover: '',
        zIndex: 0,
    }), showVisit = _j[0], setShowVisit = _j[1];
    var _k = (0, react_1.useState)({
        show: false,
        recordCover: '',
        zIndex: 0,
    }), showRecord = _k[0], setShowRecord = _k[1];
    var _l = (0, react_1.useState)(), lastCreatedTicket = _l[0], setLastCreatedTicket = _l[1];
    var tabsHash = (0, react_1.useMemo)(function () {
        if (tabPlugins && tabPlugins.length > 0) {
            var _parallel_1 = agentTabConfig.parallel;
            var order_1 = agentTabConfig.order;
            var updatePlugins_1 = [];
            var parallelPlugins_1 = {};
            var list_1 = [];
            if (order_1) {
                if ((0, isEqual_1.default)(initData.page, 'mpv')) {
                    order_1 = (0, concat_1.default)(order_1, ((initData === null || initData === void 0 ? void 0 : initData.pluginFilter) || [])
                        .filter(function (item) { return !order_1.includes("".concat(item)); })
                        .map(function (ite) { return "".concat(ite); }));
                }
                order_1.forEach(function (index) {
                    var plugin = tabPlugins.find(function (plugin) {
                        return plugin.name === index;
                    });
                    if (_parallel_1) {
                        if (_parallel_1 === index) {
                            parallelPlugins_1 = __assign({}, plugin);
                        }
                        else {
                            updatePlugins_1.push(__assign({}, plugin));
                        }
                    }
                    else {
                        updatePlugins_1.push(__assign({}, plugin));
                    }
                    list_1.push(__assign(__assign({}, plugin), { checked: _parallel_1 === index }));
                });
                updatePlugins_1 = (0, unionBy_1.default)(updatePlugins_1, tabPlugins, 'name');
                return {
                    updatePlugins: updatePlugins_1,
                    parallelPlugins: parallelPlugins_1,
                    list: list_1,
                };
            }
            else {
                tabPlugins.forEach(function (plugin) {
                    if (_parallel_1) {
                        if (_parallel_1 === plugin.name) {
                            parallelPlugins_1 = __assign({}, plugin);
                        }
                        else {
                            updatePlugins_1.push(__assign({}, plugin));
                        }
                    }
                    else {
                        updatePlugins_1.push(__assign({}, plugin));
                    }
                    list_1.push(__assign(__assign({}, plugin), { checked: _parallel_1 === plugin.name }));
                });
                return {
                    updatePlugins: updatePlugins_1,
                    parallelPlugins: parallelPlugins_1,
                    list: list_1,
                };
            }
        }
        else {
            return {
                updatePlugins: [],
                parallelPlugins: {},
                list: [],
            };
        }
    }, [tabPlugins, agentTabConfig, initData.pluginFilter]);
    var tabs = (0, react_1.useMemo)(function () { return tabsHash['updatePlugins']; }, [tabsHash]);
    var parallel = (0, react_1.useMemo)(function () { return tabsHash['parallelPlugins']; }, [tabsHash]);
    var settingList = (0, react_1.useMemo)(function () { return tabsHash['list']; }, [tabsHash]);
    var handleChange = (0, react_1.useCallback)(function (activeKey) {
        var plugTab = tabs.find(function (tab) { return getTabKey(tab.name, customer_id) === activeKey; });
        if (plugTab) {
            setCurrentTab(plugTab);
        }
        if ((0, isFunction_1.default)(event.updateChat)) {
            event.updateChat({
                chat: chat,
                updateProps: {
                    plugTab: plugTab,
                },
            });
        }
    }, [chat, customer_id, event, tabs]);
    (0, react_1.useImperativeHandle)(ref, function () { return ({
        showTicket: function (config) {
            var ticketCover = agentTabConfig.ticketCover;
            var _parallel = agentTabConfig.parallel;
            setShowTicket({
                show: config.show,
                ticketCover: _parallel ? ticketCover : 'all',
                zIndex: config.zIndex++,
            });
        },
        showVisit: function (config) {
            var visitCover = agentTabConfig.visitCover;
            var _parallel = agentTabConfig.parallel;
            setShowVisit({
                show: config.show,
                visitCover: _parallel ? visitCover : 'all',
                zIndex: config.zIndex++,
            });
        },
        showRecord: function (config) {
            var recordCover = agentTabConfig.recordCover;
            var _parallel = agentTabConfig.parallel;
            setShowRecord({
                show: config.show,
                recordCover: _parallel ? recordCover : 'all',
                zIndex: config.zIndex++,
            });
        },
        changeImPanelTab: function (id, customerId) {
            handleChange("".concat(id, "-").concat(customerId));
        },
    }); }, [
        agentTabConfig.ticketCover,
        agentTabConfig.parallel,
        agentTabConfig.visitCover,
        agentTabConfig.recordCover,
        handleChange,
    ]);
    // 获取tabs数据
    // useEffect(() => {
    //   const plugins = (initData.tabPlugins || [])
    //     .filter((plugin: any) => plugin.enabled)
    //     .map((i: any) => {
    //       return {
    //         name: i.id + "",
    //         text: i.id < 1 ? t("page.im.tabs.tagName." + i.id) : i.name,
    //         active: i.is_default,
    //         postMsgEnabled: i.post_message_enabled,
    //       };
    //     });
    //   setTabPlugins(plugins);
    // }, [t]);
    (0, react_1.useEffect)(function () {
        (0, csApi_1.csApiGetJSON)("/cs/ts/api/user_defined_plugins?show_page=".concat(initData.page))
            .then(function (res) { return res.data; })
            .then(function (res) {
            if (res === void 0) { res = {}; }
            if (res.code === 1000) {
                var plugins = res.plugins
                    .filter(function (plugin) {
                    return plugin.enabled &&
                        ((0, isEqual_1.default)(initData.page, 'mpv') ? (0, includes_1.default)(initData === null || initData === void 0 ? void 0 : initData.pluginFilter, plugin.id) : true);
                })
                    .map(function (i) {
                    return {
                        name: i.id + '',
                        text: i.id < 1 ? t('page.im.tabs.tagName.' + i.id) : i.name,
                        active: i.is_default,
                        postMsgEnabled: i.post_message_enabled,
                    };
                });
                setTabPlugins(plugins);
            }
        })
            .catch(function (e) {
            console.log(e);
        });
    }, [t, initData.pluginFilter]);
    (0, react_1.useEffect)(function () {
        if ((currentTab === null || currentTab === void 0 ? void 0 : currentTab.text) == '客户信息' && (0, isFunction_1.default)(event.reloadModel)) {
            event.reloadModel();
        }
    }, [currentTab]);
    var tabsWidth = (0, react_1.useMemo)(function () {
        var panelWidth = window.localStorage.getItem('stretchable-box-right-panel-width') || '370';
        var _panelWidth = parseInt(panelWidth, 10);
        if (agentTabConfig.parallel) {
            if (_panelWidth < minWidth) {
                _panelWidth = minWidth;
                window.localStorage.setItem('stretchable-box-right-panel-width', minWidth + '');
            }
        }
        else {
            if (_panelWidth > minWidth) {
                _panelWidth = minWidth;
                window.localStorage.setItem('stretchable-box-right-panel-width', minWidth + '');
            }
        }
        return _panelWidth;
    }, [agentTabConfig.parallel]);
    (0, react_1.useEffect)(function () {
        if (tabs && tabs.length > 0) {
            var activeTab = null;
            var normalTabs = tabs.filter(function (t) { return t.name !== parallel.name; });
            var pluginName_1 = plugTab === null || plugTab === void 0 ? void 0 : plugTab.name;
            // 客户身上的配置
            if (pluginName_1) {
                activeTab = normalTabs.find(function (t) { return t.name === pluginName_1; });
            }
            // 系统配置
            if (activeTab == null) {
                activeTab = normalTabs.find(function (t) { return t.active; });
            }
            // 第一个
            if (activeTab == null) {
                activeTab = normalTabs[0];
            }
            if (activeTab) {
                setCurrentTab(activeTab);
            }
        }
    }, [parallel.name, tabs, tabsWidth, plugTab.name]);
    var getComponent = (0, react_1.useCallback)(function (key) {
        if (key) {
            var plugin = tabPlugins.find(function (p) { return p.name === key; });
            switch (key) {
                case utils_1.IM_CUSTOMER_TAB_NAME:
                    return (react_1.default.createElement(component_1.ImCustomer, { customer: props.customer, currentUser: props.currentUser, event: props.event, organizations: props.organization, chat: props.chat, company: props.company, imSubSessionId: props.imSubSessionId, customerId: props.customerId, companyCategoryConfig: props.companyCategoryConfig, roleCan: props.roleCan, imNewPlatforms: props.imNewPlatforms, organizationFieldsv2: props.organizationFieldsv2, showCount: props.showCount, customerFieldsAuthority: props.customerFieldsAuthority, customerFieldsv2: props.customerFieldsv2, fieldHooks: props.fieldHooks, isAdmin: props.isAdmin, organizationFields: props.organizationFields, sessionKey: props.sessionKey, smsapp: props.smsapp, switchFlag: props.switchFlag, user: props.user, agents: props.agents }));
                case utils_1.IM_NOTE_TAB_NAME:
                    return (react_1.default.createElement(component_1.ImNote, { chat: props.chat, company: props.company, noteTemplates: props.noteTemplates, event: props.event }));
                case utils_1.IM_CONTACT_TAB_NAME:
                    return (react_1.default.createElement(component_1.ImContact, { createdTicket: lastCreatedTicket, chat: props.chat, roleCan: props.roleCan, event: props.event, agents: props.agents }));
                case utils_1.IM_REPOSITORY_TAB_NAME:
                    return (react_1.default.createElement(component_1.ImKnowledge, { event: props.event, roleCan: props.roleCan, chat: props.chat, company: props.company, user: props.user, kmrobot_url: props.kmrobot_url, previewUrl: props.previewUrl }));
                case utils_1.IM_HISTORY_MESSAGE_TAB_NAME:
                    return (react_1.default.createElement(component_1.ImMsgRecord, { chat: props.chat, event: props.event, setShowRecord: props.setShowRecord }));
                case utils_1.IM_RETURN_VISIT_TAB_NAME:
                    return (react_1.default.createElement(component_1.ImVisit, { content: "", showCancel: false, event: event, chat: chat, setShowVisit: setShowVisit }));
                default: {
                    return (react_1.default.createElement(component_1.ImCustomPlugin, { type: (0, isEqual_1.default)(initData.page, 'mpv') ? 'videocall_in' : 'im', currentUser: currentUser, customer: chat.customer, pluginId: plugin === null || plugin === void 0 ? void 0 : plugin.name, postMsgEnabled: plugin === null || plugin === void 0 ? void 0 : plugin.postMsgEnabled, platform: chat.platform, chat: chat, noteFields: noteFields, event: event }));
                }
            }
        }
        else {
            return '';
        }
    }, [
        tabPlugins,
        props.customer,
        props.currentUser,
        props.event,
        props.organization,
        props.chat,
        props.company,
        props.imSubSessionId,
        props.customerId,
        props.companyCategoryConfig,
        props.roleCan,
        props.imNewPlatforms,
        props.organizationFieldsv2,
        props.showCount,
        props.customerFieldsAuthority,
        props.customerFieldsv2,
        props.fieldHooks,
        props.isAdmin,
        props.organizationFields,
        props.sessionKey,
        props.smsapp,
        props.switchFlag,
        props.user,
        props.noteTemplates,
        props.agents,
        props.kmrobot_url,
        props.previewUrl,
        props.setShowRecord,
        lastCreatedTicket,
        event,
        chat,
        currentUser,
        noteFields,
    ]);
    var parallelComponent = (0, react_1.useMemo)(function () { return getComponent(parallel.name); }, [getComponent, parallel.name]);
    var handlerShowTabSettingModel = (0, react_1.useCallback)(function () { return setShowModal(true); }, []);
    var cancelTabs = (0, react_1.useCallback)(function () { return setShowModal(false); }, []);
    var onTicketCreateSuccess = (0, react_1.useCallback)(function (ticket) {
        setLastCreatedTicket(ticket);
    }, []);
    var getShowNewTab = (0, react_1.useCallback)(function (coverType) {
        return (react_1.default.createElement(react_1.default.Fragment, null,
            showTicket.ticketCover === coverType && showTicket.show && (react_1.default.createElement("div", { className: index_module_scss_1.default['new-tab'], style: { zIndex: showTicket.zIndex } },
                react_1.default.createElement(simple_error_boundary_1.default, null,
                    react_1.default.createElement(component_1.ImTicket, __assign({ setShowTicket: setShowTicket, onCreateSuccess: onTicketCreateSuccess }, props))))),
            showVisit.visitCover === coverType && showVisit.show && (react_1.default.createElement("div", { className: index_module_scss_1.default['new-tab'], style: { zIndex: showVisit.zIndex } },
                react_1.default.createElement(simple_error_boundary_1.default, null,
                    react_1.default.createElement(component_1.ImVisit, { content: "", showCancel: false, chat: chat, event: event, setShowVisit: setShowVisit })))),
            showRecord.recordCover === coverType && showRecord.show && (react_1.default.createElement("div", { className: index_module_scss_1.default['new-tab'], style: { zIndex: showRecord.zIndex } },
                react_1.default.createElement(simple_error_boundary_1.default, null,
                    react_1.default.createElement(component_1.ImMsgRecord, __assign({ setShowRecord: setShowRecord }, props)))))));
    }, [
        chat,
        event,
        onTicketCreateSuccess,
        props,
        showRecord.recordCover,
        showRecord.show,
        showRecord.zIndex,
        showTicket.show,
        showTicket.ticketCover,
        showTicket.zIndex,
        showVisit.show,
        showVisit.visitCover,
        showVisit.zIndex,
    ]);
    var handleSwitchParallel = (0, react_1.useCallback)(function () { return console.log('x'); }, []);
    var handleHideParallel = (0, react_1.useCallback)(function () { return console.log('x'); }, []);
    var _m = (0, react_1.useState)(), _width = _m[0], _setWidth = _m[1];
    (0, react_1.useEffect)(function () {
        var _a;
        var startX = 0;
        var isMove = false;
        var maskElement = document.createElement('div');
        var containerWidth = 0;
        maskElement.style.cssText =
            'position:fixed;top:0;left:0;right:0;bottom:0;z-index:99999;background:transparent;cursor:col-resize';
        var fc = {
            mousedown: function (e) {
                var _a, _b;
                startX = e.clientX;
                isMove = true;
                document.body.appendChild(maskElement);
                containerWidth = (_b = (_a = containerRef === null || containerRef === void 0 ? void 0 : containerRef.current) === null || _a === void 0 ? void 0 : _a.offsetWidth) !== null && _b !== void 0 ? _b : 0;
            },
            mousemove: function (e) {
                if (isMove) {
                    _setWidth(containerWidth + (startX - e.clientX));
                    e.preventDefault();
                }
            },
            mouseup: function (e) {
                if (isMove) {
                    isMove = false;
                }
                maskElement.remove();
            },
        };
        (_a = document.getElementById('col-drag-line')) === null || _a === void 0 ? void 0 : _a.addEventListener('mousedown', fc.mousedown);
        document.addEventListener('mousemove', fc.mousemove);
        document.addEventListener('mouseup', fc.mouseup);
        return function () {
            var _a;
            (_a = document.getElementById('col-drag-line')) === null || _a === void 0 ? void 0 : _a.removeEventListener('mousedown', fc.mousedown);
            document.removeEventListener('mousemove', fc.mousemove);
            document.removeEventListener('mouseup', fc.mouseup);
        };
    }, []);
    (0, react_1.useEffect)(function () {
        if (_width) {
            return onWidthChange(Math.max(minWidth, _width));
        }
    }, [_width, minWidth, onWidthChange]);
    var containerStyle = (0, react_1.useMemo)(function () { return ({ width: width + 'px', maxWidth: cssMaxWidth }); }, [cssMaxWidth, width]);
    var tabBarExtraContent = (0, react_1.useMemo)(function () {
        if (!(0, isEqual_1.default)(initData.page, 'mpv')) {
            return (react_1.default.createElement("div", { className: index_module_scss_1.default['tab-extra'], onClick: handlerShowTabSettingModel },
                react_1.default.createElement(icon_1.Setting, null)));
        }
    }, []);
    var tabChildren = (0, react_1.useMemo)(function () {
        return tabs.map(function (tab) {
            var component = getComponent(tab.name);
            return (react_1.default.createElement(TabPane, { tab: tab.text, key: getTabKey(tab.name, customer_id) },
                react_1.default.createElement(simple_error_boundary_1.default, null, component)));
        });
    }, [customer_id, getComponent, tabs]);
    return (react_1.default.createElement("div", { className: index_module_scss_1.default['im-tab-panel'], style: containerStyle, ref: containerRef },
        react_1.default.createElement("div", { className: index_module_scss_1.default['drag-line'], id: "col-drag-line" }),
        react_1.default.createElement("div", { className: (0, classnames_1.default)(index_module_scss_1.default['panel-container'], (_b = {},
                _b[index_module_scss_1.default['has-parallel']] = !!agentTabConfig.parallel,
                _b[index_module_scss_1.default['view-reverse']] = !!agentTabConfig.sortDesc,
                _b)) },
            chat.belong === 'leave' && (react_1.default.createElement("div", { style: { padding: '20px 0 ', width: '100%' } },
                react_1.default.createElement(component_1.ImCustomer, __assign({}, props)))),
            chat.belong !== 'leave' && tabs.length > 0 && (react_1.default.createElement("div", { className: index_module_scss_1.default['panle-main'] },
                react_1.default.createElement(udesk_ui_1.Tabs, { activeKey: getTabKey((currentTab === null || currentTab === void 0 ? void 0 : currentTab.name) || '', customer_id), tabBarGutter: 0, tabBarExtraContent: tabBarExtraContent, onChange: handleChange, className: index_module_scss_1.default.tabs, destroyInactiveTabPane: true, animated: false }, tabChildren),
                react_1.default.createElement(tab_setting_modal_1.default, { tabs: settingList, agentTabConfig: agentTabConfig, showModal: showModal, hideTabSetingModal: cancelTabs, event: event }),
                getShowNewTab('parallelNormal'))),
            !(0, isEqual_1.default)(initData.page, 'mpv') && agentTabConfig.parallel && react_1.default.createElement("div", { className: index_module_scss_1.default['panel-line'] }),
            !(0, isEqual_1.default)(initData.page, 'mpv') && agentTabConfig.parallel && (react_1.default.createElement("div", { className: index_module_scss_1.default['panel-parallel'] },
                react_1.default.createElement(tab_parallel_1.default, __assign({}, parallel, { component: parallelComponent, switchParallel: handleSwitchParallel, hideParallel: handleHideParallel, agentTabConfig: agentTabConfig, event: event })),
                getShowNewTab('parallel'))),
            getShowNewTab('all'))));
});
var ImPanelMemo = react_1.default.memo(ImPanel);
exports.default = ImPanelMemo;
