"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importDefault(require("react"));
var style_module_scss_1 = __importDefault(require("./style.module.scss"));
var icon_1 = require("../../../components/icon/icon");
var csApi_1 = require("../../../utils/csApi");
var isFunction_1 = __importDefault(require("lodash-es/isFunction"));
var udesk_ui_1 = require("udesk-ui");
/**
 * 平行视界
 * @param props
 */
var ParallelTab = function (props) {
    // const udeskImContext: ImContextProps = useContext(UdeskContext);
    // const { event } = udeskImContext;
    var event = props.event;
    var handleSwitchParallel = function () {
        var _data = {
            agent_tab_config: __assign(__assign({}, props.agentTabConfig), { sortDesc: !props.agentTabConfig.sortDesc }),
        };
        (0, csApi_1.csApiPostJSON)("/cs/im/agent/im/agent_config", {
            data: _data,
        }).then(function (res) { return res.data; })
            .then(function () {
            if ((0, isFunction_1.default)(event.updateAgentConfig)) {
                event.updateAgentConfig(__assign(__assign({}, props.agentTabConfig), { sortDesc: !props.agentTabConfig.sortDesc }));
            }
        })
            .catch(function (err) {
            udesk_ui_1.message.error('保存失败,请重试');
        });
    };
    var handleHideParallel = function () {
        var _data = {
            agent_tab_config: __assign(__assign({}, props.agentTabConfig), { parallel: '', sortDesc: false }),
        };
        (0, csApi_1.csApiPostJSON)("/cs/im/agent/im/agent_config", {
            data: _data,
        }).then(function (res) { return res.data; })
            .then(function () {
            if ((0, isFunction_1.default)(event.updateAgentConfig)) {
                event.updateAgentConfig(__assign(__assign({}, props.agentTabConfig), { parallel: '', sortDesc: false }));
            }
        })
            .catch(function () {
            udesk_ui_1.message.error('保存失败,请重试');
        });
    };
    return (react_1.default.createElement("div", { className: style_module_scss_1.default['parallel-container'] },
        react_1.default.createElement("div", { className: style_module_scss_1.default['parallel-header'] },
            react_1.default.createElement("div", { className: style_module_scss_1.default['header-name'] }, props.text),
            react_1.default.createElement("div", { className: style_module_scss_1.default['header-icons'] },
                react_1.default.createElement("span", { onClick: handleSwitchParallel },
                    react_1.default.createElement(icon_1.ZhuanYi, null)),
                react_1.default.createElement("span", { onClick: handleHideParallel },
                    react_1.default.createElement(icon_1.HuiFan, null)))),
        react_1.default.createElement("div", { className: style_module_scss_1.default['parallel-body'] }, props.component)));
};
exports.default = ParallelTab;
