"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DndItem = void 0;
var react_1 = __importDefault(require("react"));
var react_dnd_1 = require("react-dnd");
var udesk_ui_1 = require("udesk-ui");
var icon_1 = require("../../../components/icon/icon");
var icons_1 = require("@ant-design/icons");
var style = {
    padding: "8px 12px",
    borderBottom: "1px solid #fafafa",
};
var handleStyle = {
    display: "inline-block",
    cursor: "move",
};
var DndItem = function (_a) {
    var id = _a.id, text = _a.text, checked = _a.checked, checkedItemToContainer = _a.checkedItemToContainer, moveItemToContainer = _a.moveItemToContainer, findItemToContainer = _a.findItemToContainer, type = _a.type;
    var originalIndex = findItemToContainer(id).index;
    var _b = (0, react_dnd_1.useDrag)({
        item: { type: type, id: id, originalIndex: originalIndex },
        collect: function (monitor) { return ({
            isDragging: monitor.isDragging(),
            opacity: monitor.isDragging() ? 0 : 1,
        }); },
        // end: (dropResult, monitor) => {
        //     const { id: droppedId, originalIndex } = monitor.getItem()
        //     const didDrop = monitor.didDrop()
        //     if (!didDrop) {
        //         moveItemToContainer(droppedId, originalIndex)
        //     }
        // },
    }), opacity = _b[0].opacity, drag = _b[1], preview = _b[2];
    var _c = (0, react_dnd_1.useDrop)({
        accept: type,
        canDrop: function () { return false; },
        hover: function (_a, monitor) {
            var draggedId = _a.id;
            if (draggedId !== id) {
                var overIndex = findItemToContainer(id).index;
                moveItemToContainer(draggedId, overIndex);
            }
        },
    }), drop = _c[1];
    var handleItemChecked = function () {
        checkedItemToContainer(id);
    };
    return (react_1.default.createElement("div", { ref: preview, style: __assign(__assign({}, style), { opacity: opacity }) },
        react_1.default.createElement(udesk_ui_1.Row, null,
            react_1.default.createElement(udesk_ui_1.Col, { span: 4 },
                react_1.default.createElement("span", { ref: function (node) { return drag(drop(node)); }, style: handleStyle },
                    react_1.default.createElement(icons_1.MenuOutlined, null))),
            react_1.default.createElement(udesk_ui_1.Col, { span: 12 }, text),
            react_1.default.createElement(udesk_ui_1.Col, { span: 4 },
                react_1.default.createElement("span", { onClick: handleItemChecked }, checked ? react_1.default.createElement(icon_1.XuanZeDanXuan, null) : react_1.default.createElement(icon_1.DanSuanShiXiao, null))))));
};
exports.DndItem = DndItem;
