"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var csApi_1 = require("../../../utils/csApi");
var react_dnd_1 = require("react-dnd");
var react_dnd_html5_backend_1 = require("react-dnd-html5-backend");
var style_module_scss_1 = __importDefault(require("./style.module.scss"));
var immutability_helper_1 = __importDefault(require("immutability-helper"));
var dnd_container_1 = require("./dnd-container");
var isFunction_1 = __importDefault(require("lodash-es/isFunction"));
var cloneDeep_1 = __importDefault(require("lodash-es/cloneDeep"));
var react_i18next_1 = require("react-i18next");
var store_hook_1 = require("../../../store/store-hook");
var lodash_es_1 = require("lodash-es");
var TabSettingModal = function (_a) {
    var tabs = _a.tabs, _b = _a.agentTabConfig, agentTabConfig = _b === void 0 ? {} : _b, showModal = _a.showModal, hideTabSetingModal = _a.hideTabSetingModal, event = _a.event;
    var t = (0, react_i18next_1.useTranslation)().t;
    var type = 'TabSettingDrap';
    var _c = (0, react_1.useState)(false), loading = _c[0], setLoading = _c[1];
    var _d = (0, react_1.useState)({
        ticketCover: agentTabConfig.ticketCover || 'all',
        visitCover: agentTabConfig.visitCover || 'all',
        recordCover: agentTabConfig.ticketCover || 'all',
    }), cover = _d[0], setCover = _d[1];
    var _e = (0, react_1.useState)(function () {
        return (tabs || [])
            .filter(function (item) { return item.name; })
            .map(function (tab) {
            return {
                id: tab.name,
                key: tab.name,
                text: tab.text,
                checked: tab.checked,
            };
        });
    }), list = _e[0], setList = _e[1];
    var initData = (0, store_hook_1.useSelector)(function (state) { return state.initData; });
    (0, react_1.useEffect)(function () {
        setList(resetList());
    }, [showModal, tabs]);
    var resetList = (0, react_1.useCallback)(function () {
        return (tabs || [])
            .filter(function (item) { return item.name; })
            .map(function (tab) {
            return {
                id: tab.name,
                key: tab.name,
                text: tab.text,
                checked: tab.checked,
            };
        });
    }, [tabs]);
    // 拖拽
    var moveItem = function (id, atIndex) {
        var _a = findItem(id), item = _a.item, index = _a.index;
        setList((0, immutability_helper_1.default)(list, {
            $splice: [
                [index, 1],
                [atIndex, 0, item],
            ],
        }));
    };
    // 查找对应的tab
    var findItem = function (id) {
        var item = list.filter(function (c) { return "".concat(c.id) === id; })[0];
        return {
            item: item,
            index: list.indexOf(item),
        };
    };
    // 选中平行视界
    var checkedItem = function (id) {
        setList(function (prevList) {
            var _prevList = (0, cloneDeep_1.default)(prevList);
            _prevList.map(function (item) {
                if (item.id === id) {
                    item.checked = !item.checked;
                }
                else {
                    item.checked = false;
                }
                return item;
            });
            return _prevList;
            // return produce(prevList, (draft: any) => {
            //     draft.map((item: any) => {
            //         if (item.id === id) {
            //             item.checked = !item.checked
            //         } else {
            //             item.checked = false
            //         }
            //         return item;
            //     })
            // })
        });
    };
    // 保存
    var handleSaveModalSetting = function () {
        setLoading(true);
        var _parallel = (list.find(function (item) { return item.checked; }) || {}).id || '';
        var _order = list.map(function (item) { return item.id; });
        var _data = __assign({ parallel: _parallel, order: _order, sortDesc: agentTabConfig.sortDesc }, cover);
        (0, csApi_1.csApiPostJSON)("/cs/im/agent/im/agent_config", {
            data: {
                agent_tab_config: _data,
            },
        }).then(function (res) { return res.data; })
            .then(function () {
            if ((0, isFunction_1.default)(event.updateAgentConfig)) {
                event.updateAgentConfig(__assign(__assign(__assign({}, agentTabConfig), { parallel: _parallel, order: _order, sortDesc: agentTabConfig.sortDesc }), cover));
            }
        })
            .catch(function (err) {
            udesk_ui_1.message.error('保存失败,请重试');
        })
            .finally(function () {
            setLoading(false);
            hideTabSetingModal();
        });
    };
    // 取消
    var handleCancel = function () {
        var baseList = resetList();
        setList(baseList);
        setCover({
            ticketCover: agentTabConfig.ticketCover,
            visitCover: agentTabConfig.visitCover,
            recordCover: agentTabConfig.recordCover,
        });
        hideTabSetingModal();
    };
    var headerStyle = {
        padding: '8px 12px',
        borderBottom: '1px solid #f0f0f0',
        backgroundColor: '#fafafa',
    };
    var formItemLayout = {
        labelCol: {
            span: 4,
        },
        wrapperCol: {
            span: 20,
        },
    };
    var handleShowType = function (e) {
        var _a = e.target, name = _a.name, value = _a.value;
        // 调用agent_config接口更新数据
        setCover({
            ticketCover: name === 'ticket' ? value : cover.ticketCover,
            visitCover: name === 'visit' ? value : cover.visitCover,
            recordCover: name === 'record' ? value : cover.recordCover,
        });
    };
    return (react_1.default.createElement(udesk_ui_1.Modal, { visible: showModal, title: t('label.preferences'), closable: false, destroyOnClose: true, onOk: handleSaveModalSetting, onCancel: handleCancel, wrapClassName: style_module_scss_1.default['tab-setting-modal'], footer: [
            react_1.default.createElement(udesk_ui_1.Button, { key: "back", onClick: handleCancel }, t('cancel')),
            react_1.default.createElement(udesk_ui_1.Button, { key: "submit", type: "primary", loading: loading, onClick: handleSaveModalSetting }, t('confirm')),
        ] },
        react_1.default.createElement("div", { style: { maxHeight: '350px', overflowY: 'auto' } },
            react_1.default.createElement(react_dnd_1.DndProvider, { backend: react_dnd_html5_backend_1.HTML5Backend },
                react_1.default.createElement("div", { style: headerStyle },
                    react_1.default.createElement(udesk_ui_1.Row, null,
                        react_1.default.createElement(udesk_ui_1.Col, { span: 4 }, t('label.order')),
                        react_1.default.createElement(udesk_ui_1.Col, { span: 12 }, t('label.component')),
                        react_1.default.createElement(udesk_ui_1.Col, { span: 4 }, t('label.parallelHorizon')))),
                react_1.default.createElement(dnd_container_1.DndContainer, { list: list, type: type, moveItem: moveItem, findItem: findItem, checkedItem: checkedItem })),
            react_1.default.createElement("br", { style: { marginBottom: '15px' } }),
            (0, lodash_es_1.isEqual)(initData.page, 'im') && (react_1.default.createElement("div", null,
                react_1.default.createElement(udesk_ui_1.Form, __assign({ name: "validate_other" }, formItemLayout),
                    react_1.default.createElement(udesk_ui_1.Form.Item, { label: t('page.im.ticket.createTicket') },
                        react_1.default.createElement(udesk_ui_1.Radio.Group, { name: "ticket", value: cover.ticketCover, onChange: handleShowType },
                            react_1.default.createElement(udesk_ui_1.Radio, { value: 'all' }, t('label.overallCoverage')),
                            react_1.default.createElement(udesk_ui_1.Radio, { value: 'parallel' }, t('label.coveringParallelHorizon')),
                            react_1.default.createElement(udesk_ui_1.Radio, { value: 'parallelNormal' }, t('label.coverCommonArea')))),
                    react_1.default.createElement(udesk_ui_1.Form.Item, { label: t('page.im.visit.title') },
                        react_1.default.createElement(udesk_ui_1.Radio.Group, { name: "visit", value: cover.visitCover, onChange: handleShowType },
                            react_1.default.createElement(udesk_ui_1.Radio, { value: 'all' }, t('label.overallCoverage')),
                            react_1.default.createElement(udesk_ui_1.Radio, { value: 'parallel' }, t('label.coveringParallelHorizon')),
                            react_1.default.createElement(udesk_ui_1.Radio, { value: 'parallelNormal' }, t('label.coverCommonArea')))),
                    react_1.default.createElement(udesk_ui_1.Form.Item, { label: t('page.im.record.imLogRecords') },
                        react_1.default.createElement(udesk_ui_1.Radio.Group, { name: "record", value: cover.recordCover, onChange: handleShowType },
                            react_1.default.createElement(udesk_ui_1.Radio, { value: 'all' }, t('label.overallCoverage')),
                            react_1.default.createElement(udesk_ui_1.Radio, { value: 'parallel' }, t('label.coveringParallelHorizon')),
                            react_1.default.createElement(udesk_ui_1.Radio, { value: 'parallelNormal' }, t('label.coverCommonArea'))))))))));
};
exports.default = TabSettingModal;
