"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable jsx-control-statements/jsx-use-if-tag */
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var index_1 = require("../../../../utils/index");
var index_module_scss_1 = __importDefault(require("./index.module.scss"));
var search_customer_1 = __importDefault(require("../search-customer"));
var icons_1 = require("@ant-design/icons");
var utilities_1 = require("../../../../im-panel/ticket/utilities");
var Option = udesk_ui_1.Select.Option;
function Customer(props) {
    var _a = (0, react_1.useContext)(utilities_1.TicketContext), changePageType = _a.changePageType, customer = _a.customer;
    var _b = (0, react_1.useState)({}), value = _b[0], setValue = _b[1]; //选择的选项
    var _c = (0, react_1.useState)(false), fetching = _c[0], setFetching = _c[1]; //无数据时展示
    var _d = (0, react_1.useState)([]), data = _d[0], setData = _d[1]; //搜索到的数据
    var _e = (0, react_1.useState)(0), lastFetchId = _e[0], setLastFetchId = _e[1]; //
    var _f = (0, react_1.useState)(false), showSearchMoadl = _f[0], setShowSearchMoadl = _f[1];
    var _g = (0, react_1.useState)(1), page = _g[0], setPage = _g[1];
    var _h = (0, react_1.useState)(""), searchValue = _h[0], setSearchValue = _h[1];
    var _j = (0, react_1.useState)(0), totalPages = _j[0], setTotalPages = _j[1];
    //监听传进来的值变化  有变化就更新value
    (0, react_1.useEffect)(function () {
        if (customer.value) {
            setValue(customer);
            props.onChange && props.onChange(customer);
        }
        else {
            setValue(props.value);
        }
    }, [customer, props, props.value]);
    var beforeSearch = (0, react_1.useCallback)(function (searchValue) {
        setSearchValue(searchValue);
        setData([]);
        setPage(1);
        fetchUser(searchValue);
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    // 搜索用户
    var fetchUser = (0, react_1.useCallback)(function (searchValue) {
        setLastFetchId(function () { return lastFetchId + 1; });
        var fetchId = lastFetchId;
        setFetching(true);
        (0, index_1.postJSON)("/customers/contain_search", {
            page: page,
            page_size: 20,
            prefix: searchValue,
        }).then(function (res) {
            setPage(page + 1);
            setTotalPages(res.meta.total_pages);
            if (fetchId !== lastFetchId) {
                // for fetch callback order
                return;
            }
            var _data = res.customers.map(function (item) {
                return {
                    label: item.nick_name,
                    value: item.id,
                };
            });
            setData(__spreadArray(__spreadArray([], data, true), _data, true));
            setFetching(false);
        });
    }, [lastFetchId, page, data]);
    //
    var handleChange = (0, react_1.useCallback)(function (value) {
        setValue(value);
        setFetching(false);
        props.onChange && props.onChange(value);
    }, [props]);
    // 点击搜索按钮  打开搜索弹窗
    var searchUser = (0, react_1.useCallback)(function () {
        setShowSearchMoadl(true);
    }, []);
    // 关闭搜索弹窗
    var closeSearch = (0, react_1.useCallback)(function () {
        setShowSearchMoadl(false);
    }, []);
    var suffixIcon = (react_1.default.createElement("div", { onClick: searchUser, className: index_module_scss_1.default["search-icon"] },
        react_1.default.createElement(icons_1.SearchOutlined, null)));
    //处理滚动事假
    var handleScroll = (0, react_1.useCallback)(function (e) {
        e.stopPropagation();
        if (e.target.scrollTop ===
            e.target.scrollHeight - e.target.clientHeight) {
            if (page < totalPages) {
                fetchUser(searchValue);
            }
        }
    }, [page, totalPages, fetchUser, searchValue]);
    // 聚焦时  将外部表单取消滚动  防止滚动穿透
    var handleFocus = (0, react_1.useCallback)(function () {
        props.setIsScroll && props.setIsScroll(false);
    }, [props]);
    // 失焦时  将外部滚动复原
    var handleBlur = (0, react_1.useCallback)(function () {
        props.setIsScroll && props.setIsScroll(true);
    }, [props]);
    var selectCustomer = (0, react_1.useCallback)(function (customer) {
        handleChange(customer);
    }, [handleChange]);
    return (react_1.default.createElement("div", { style: { display: "flex" } },
        react_1.default.createElement(udesk_ui_1.Select, { showSearch: true, showArrow: true, labelInValue: true, value: value, placeholder: "", notFoundContent: fetching ? react_1.default.createElement(udesk_ui_1.Spin, { size: "small" }) : null, filterOption: false, onSearch: beforeSearch, onChange: handleChange, style: { width: "100%" }, getPopupContainer: function (triggerNode) { return triggerNode; }, suffixIcon: suffixIcon, onPopupScroll: handleScroll, onFocus: handleFocus, onBlur: handleBlur }, data.map(function (d) { return (react_1.default.createElement(Option, { key: d.value, value: d.value }, d.label)); })),
        react_1.default.createElement("div", { className: index_module_scss_1.default["input-after-icon"], onClick: function () { return changePageType("customer"); } },
            react_1.default.createElement(icons_1.PlusOutlined, null)),
        react_1.default.createElement(search_customer_1.default, { close: closeSearch, show: showSearchMoadl, selectCustomer: selectCustomer, ticketTab: props.ticketTab })));
}
exports.default = Customer;
