"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var index_module_scss_1 = __importDefault(require("./index.module.scss"));
var react_i18next_1 = require("react-i18next");
var field_warning_1 = __importDefault(require("../../../../components/fieldFormItem/components/field_warning"));
var icons_1 = require("@ant-design/icons");
function EmailField(props) {
    //多语言
    var t = (0, react_i18next_1.useTranslation)().t;
    var list = props.value.length ? props.value : [""];
    var _a = (0, react_1.useState)(list), emailList = _a[0], setEmailList = _a[1];
    var _b = (0, react_1.useState)([]), errMessage = _b[0], SetErrMessage = _b[1];
    // 进来第一次生成对应邮箱数量的报错信息
    (0, react_1.useEffect)(function () {
        SetErrMessage(__spreadArray([], new Array(list.length), true));
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    // 新加邮箱时   改变外部form数据
    var addEmail = (0, react_1.useCallback)(function () {
        // props.onChange && props.onChange(emailList.concat('').join(','))
        setEmailList(__spreadArray([], emailList.concat(""), true));
        SetErrMessage(__spreadArray([], errMessage.concat(""), true));
    }, [emailList, errMessage]);
    // 删除   删除邮箱  删除报错信息
    var deleteEmail = (0, react_1.useCallback)(function (index) {
        emailList.splice(index, 1);
        errMessage.splice(index, 1);
        setEmailList(__spreadArray([], emailList, true));
        SetErrMessage(__spreadArray([], errMessage, true));
        // 删除后  更新外部form
        props.onChange && props.onChange(emailList);
    }, [emailList, errMessage, props]);
    // 输入值改变时  改变相对应的数据
    var emailInputChange = (0, react_1.useCallback)(function (e, index) {
        emailList[index] = e.target.value;
        setEmailList(__spreadArray([], emailList, true));
    }, [emailList]);
    // 失焦触发  校验邮箱  更改外部form
    var emailOnBlur = (0, react_1.useCallback)(function (index) {
        var value = emailList[index];
        if (value &&
            !/^[A-Za-z0-9\u4e00-\u9fa5]+@[a-zA-Z0-9_-]+(\.[a-zA-Z0-9_-]+)+$/i.test(value)) {
            errMessage[index] = "邮箱格式不正确";
            SetErrMessage(__spreadArray([], errMessage, true));
        }
        else {
            errMessage[index] = "";
            SetErrMessage(__spreadArray([], errMessage, true));
        }
        props.onChange && props.onChange(emailList);
    }, [emailList, errMessage, props]);
    return (react_1.default.createElement(react_1.default.Fragment, null, emailList.map(function (item, index) {
        return (react_1.default.createElement("div", { key: index, className: index_module_scss_1.default["email-item-wrapper"] },
            react_1.default.createElement("div", { className: index_module_scss_1.default["email-item-box"] },
                react_1.default.createElement(udesk_ui_1.Input, { style: { flex: 1 }, placeholder: props.placeholder, value: item, onChange: function (e) { return emailInputChange(e, index); }, onBlur: function () { return emailOnBlur(index); } }),
                !index ? (react_1.default.createElement("div", { className: index_module_scss_1.default["add-icon"], onClick: addEmail },
                    react_1.default.createElement(icons_1.PlusOutlined, null),
                    react_1.default.createElement("div", null, t("add")))) : (react_1.default.createElement("div", { className: index_module_scss_1.default["add-icon"], onClick: function () { return deleteEmail(index); } },
                    react_1.default.createElement(icons_1.MinusOutlined, null),
                    react_1.default.createElement("div", null, t("delete"))))),
            react_1.default.createElement("div", { style: { marginTop: "5px" } },
                react_1.default.createElement(field_warning_1.default, { warningText: errMessage[index] }))));
    })));
}
exports.default = EmailField;
