"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var index_module_scss_1 = __importDefault(require("./index.module.scss"));
var react_i18next_1 = require("react-i18next");
var icons_1 = require("@ant-design/icons");
var uniqBy_1 = __importDefault(require("lodash-es/uniqBy"));
var utilities_1 = require("../../../../im-panel/ticket/utilities");
function FollowerField(props) {
    //多语言
    var t = (0, react_i18next_1.useTranslation)().t;
    var _a = (0, react_1.useState)([]), value = _a[0], setValue = _a[1]; //选择的选项
    var _b = (0, react_1.useState)(false), starState = _b[0], setStarState = _b[1];
    var agent = (0, react_1.useContext)(utilities_1.TicketContext).agent; //客服组
    // const udeskWebappContext: any = useContext(UdeskContext);//ember传过来的数据
    // const currentUserId = udeskWebappContext.currentUser.id
    var _c = props.currentUser, currentUser = _c === void 0 ? {} : _c, _d = props.admin, admin = _d === void 0 ? {} : _d;
    var currentUserId = currentUser.id;
    (0, react_1.useEffect)(function () {
        setValue(props.value);
    }, [props.value]);
    // 处理选项  从客服组中去除每组中的客服  并且最后加上管理员
    var radio = (0, react_1.useMemo)(function () {
        var list = [];
        agent.forEach(function (item) {
            if (item.children.length) {
                list = __spreadArray(__spreadArray([], list, true), item.children.map(function (item) {
                    return {
                        title: item.label,
                        value: item.value,
                    };
                }), true);
            }
        });
        list = (0, uniqBy_1.default)(list, "value");
        list.push({
            title: admin.nick_name,
            value: admin.id,
        });
        return list;
    }, [admin.id, admin.nick_name, agent]);
    (0, react_1.useEffect)(function () {
        //选项变化时  根据选项中有没有包含当前客服 改变星星状态
        setStarState(value.includes(currentUserId));
    }, [currentUserId, value]);
    // 点击星星事件
    var clickStart = (0, react_1.useCallback)(function () {
        // 当前 starState true  点击事件是为了  删除选择的当前的客服
        // 当前 starState false   点击事件是为了  选择的当前的客服
        if (starState) {
            var index_1 = value.indexOf(currentUserId);
            setValue(function () {
                value.splice(index_1, 1);
                return __spreadArray([], value, true);
            });
            props.onChange && props.onChange(__spreadArray([], value, true));
        }
        else {
            setValue(__spreadArray(__spreadArray([], value, true), [currentUserId], false));
            props.onChange && props.onChange(__spreadArray(__spreadArray([], value, true), [currentUserId], false));
        }
        // 改变选择时会触发上边的useEffect处理星星状态  此处不进行处理
    }, [currentUserId, props, starState, value]);
    // 选项变化时回调
    var handleChange = (0, react_1.useCallback)(function (value) {
        setValue(value);
        props.onChange && props.onChange(value);
    }, [props]);
    //筛选规则
    var handleFilter = (0, react_1.useCallback)(function (inputValue, option) {
        return option.children.includes(inputValue);
    }, []);
    return (react_1.default.createElement("div", { className: index_module_scss_1.default["follower-wrapper"] },
        react_1.default.createElement(udesk_ui_1.Select, { mode: "multiple", showSearch //显示搜索
            : true, showArrow: true, value: value, placeholder: t("page.im.ticket.choiceFollower"), onChange: handleChange, style: { width: "100%" }, filterOption: handleFilter, getPopupContainer: function (triggerNode) { return triggerNode; } }, radio.map(function (d) { return (react_1.default.createElement(udesk_ui_1.Select.Option, { key: d.value, value: d.value }, d.title)); })),
        react_1.default.createElement("div", { className: index_module_scss_1.default["star-icon"], onClick: clickStart, style: { color: starState ? "#FDBD68" : "#333" } },
            react_1.default.createElement(icons_1.StarFilled, null))));
}
exports.default = FollowerField;
