"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var index_1 = require("../../../utils/index");
var Option = udesk_ui_1.Select.Option;
function MerchantField(props) {
    var _a = (0, react_1.useState)({}), value = _a[0], setValue = _a[1]; //选择的选项
    var _b = (0, react_1.useState)(false), fetching = _b[0], setFetching = _b[1]; //无数据时展示
    var _c = (0, react_1.useState)([]), data = _c[0], setData = _c[1]; //搜索到的数据
    var _d = (0, react_1.useState)(0), lastFetchId = _d[0], setLastFetchId = _d[1]; //
    var _e = (0, react_1.useState)(1), page = _e[0], setPage = _e[1];
    var _f = (0, react_1.useState)(""), searchValue = _f[0], setSearchValue = _f[1];
    var _g = (0, react_1.useState)(0), totalPages = _g[0], setTotalPages = _g[1];
    var fetchMerchant = (0, react_1.useCallback)(function (searchValue) {
        setLastFetchId(function () { return lastFetchId + 1; });
        var fetchId = lastFetchId;
        setFetching(true);
        (0, index_1.postJSON)("/mchat_merchants/query_merchants", {
            mchat_name: searchValue,
            page: page,
            per_page: 20,
        }).then(function (res) {
            setPage(page + 1);
            setTotalPages(res.meta.total_pages);
            if (fetchId !== lastFetchId) {
                // for fetch callback order
                return;
            }
            var _data = res.customers.map(function (item) {
                return {
                    label: item.nick_name,
                    value: item.id,
                };
            });
            setData(__spreadArray(__spreadArray([], data, true), _data, true));
            setFetching(false);
        });
    }, [lastFetchId, page, data]);
    var beforeSearch = (0, react_1.useCallback)(function (searchValue) {
        setSearchValue(searchValue);
        setData([]);
        setPage(1);
        fetchMerchant(searchValue);
    }, [fetchMerchant]);
    (0, react_1.useEffect)(function () {
        setValue(props.value);
    }, [props.value]);
    function handleChange(value) {
        setValue(value);
        setFetching(false);
        props.onChange && props.onChange(value);
    }
    //处理滚动事假
    var handleScroll = (0, react_1.useCallback)(function (e) {
        e.stopPropagation();
        if (e.target.scrollTop ===
            e.target.scrollHeight - e.target.clientHeight) {
            if (page < totalPages) {
                fetchMerchant(searchValue);
            }
        }
    }, [page, totalPages, fetchMerchant, searchValue]);
    // 聚焦时  将外部表单取消滚动  防止滚动穿透
    var handleFocus = (0, react_1.useCallback)(function () {
        props.setIsScroll && props.setIsScroll(false);
    }, [props]);
    // 失焦时  将外部滚动复原
    var handleBlur = (0, react_1.useCallback)(function () {
        props.setIsScroll && props.setIsScroll(true);
    }, [props]);
    return (react_1.default.createElement(udesk_ui_1.Select, { showSearch: true, showArrow: true, labelInValue: true, value: value, placeholder: "", notFoundContent: fetching ? react_1.default.createElement(udesk_ui_1.Spin, { size: "small" }) : null, filterOption: false, onSearch: beforeSearch, onChange: handleChange, style: { width: "100%" }, getPopupContainer: function (triggerNode) { return triggerNode; }, onPopupScroll: handleScroll, onFocus: handleFocus, onBlur: handleBlur }, data.map(function (d) { return (react_1.default.createElement(Option, { key: d.value, value: d.value }, d.label)); })));
}
exports.default = MerchantField;
