"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable jsx-control-statements/jsx-use-if-tag */
//搜索公司
var react_1 = __importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var csApi_1 = require("../../../../utils/csApi");
var index_module_scss_1 = __importDefault(require("./index.module.scss"));
var react_i18next_1 = require("react-i18next");
var icons_1 = require("@ant-design/icons");
var utilities_1 = require("../../../../im-panel/ticket/utilities");
var Option = udesk_ui_1.Select.Option;
function SearchOrgField(props) {
    var roleCan = props.roleCan, company = props.company, event = props.event;
    //多语言
    var t = (0, react_i18next_1.useTranslation)().t;
    var ref = (0, react_1.useRef)(null);
    //ember传进来的参数
    var canCreate = roleCan.add_new_organization;
    var canAdd = company.support_multi_organizations;
    var _a = (0, react_1.useContext)(utilities_1.TicketContext), changePageType = _a.changePageType, organization = _a.organization;
    var _b = (0, react_1.useState)(false), fetching = _b[0], setFetching = _b[1]; //无数据时展示
    var _c = (0, react_1.useState)(0), lastFetchId = _c[0], setLastFetchId = _c[1]; //
    var _d = (0, react_1.useState)([]), data = _d[0], setData = _d[1]; //搜索到的数据
    var _e = (0, react_1.useState)([]), valueList = _e[0], setValueList = _e[1];
    var _f = (0, react_1.useState)([]), filterList = _f[0], setFilterList = _f[1];
    (0, react_1.useEffect)(function () {
        var list = [organization];
        setValueList(__spreadArray([], list, true));
        props.onChange && props.onChange(list.map(function (item) { return item.value || ""; }));
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [organization]);
    // 搜索用户
    var fetchUser = (0, react_1.useCallback)(function (searchValue) {
        setLastFetchId(function () { return lastFetchId + 1; });
        var fetchId = lastFetchId;
        setData([]);
        setFetching(true);
        (0, csApi_1.csApiPostJSON)("/cs/ts/api/organizations/search", { query: searchValue }).then(function (res) { return res.data; }).then(function (res) {
            if (fetchId !== lastFetchId) {
                // for fetch callback order
                return;
            }
            // 处理数据格式
            var data = res.organizations.map(function (item) {
                return {
                    value: item.id,
                    label: item.name,
                };
            });
            setData(data);
            setFetching(false);
        });
    }, [lastFetchId]);
    // 选项变化时回调
    function handleChange(value, index) {
        var list = valueList;
        //改变当前选择的公司的值
        list.splice(index, 1, value || {});
        // 重新赋值
        setValueList(__spreadArray([], list, true));
        setFetching(false);
        // 将选择的id数组更新   为了搜索数据之后筛选用
        setFilterList(list.map(function (item) { return item.value; }));
        // 改变外部form值
        props.onChange && props.onChange(list.map(function (item) { return item.value || ""; }));
    }
    // 添加新的公司
    var addOrg = (0, react_1.useCallback)(function () {
        var canAdd = true;
        //如果有公司还没有选  禁止新加
        valueList.forEach(function (item) {
            if (!item.value) {
                canAdd = false;
                return;
            }
        });
        if (!valueList[valueList.length - 1].value) {
            canAdd = false;
            return;
        }
        canAdd && setValueList(__spreadArray([], valueList.concat({}), true));
    }, [valueList]);
    // 删除公司
    var deleteOrg = (0, react_1.useCallback)(function (index) {
        setValueList(function () {
            valueList.splice(index, 1);
            return __spreadArray([], valueList, true);
        });
    }, [valueList]);
    // 点击已选择的公司  进入公司详情
    var gotoCompany = (0, react_1.useCallback)(function (e) {
        // 如果没有选择  不进行操作
        if (!valueList.length || !valueList[0].value)
            return;
        // 判断点击的是否是选择的字的地方  其他地方不触发
        if (e.target.className === "#{$prefix}-select-selection-item") {
            event.transitionToRoute &&
                event.transitionToRoute({
                    route: "crm.organization.show",
                    path: valueList[0].value,
                });
        }
    }, [event, valueList]);
    var getPopupContainer = (0, react_1.useCallback)(function () { return ref.current || document.body; }, []);
    return (react_1.default.createElement("div", { className: index_module_scss_1.default["select-wrapper"], ref: ref },
        react_1.default.createElement("div", { className: index_module_scss_1.default["org-select-wrapper"] }, valueList.map(function (item, index) {
            return (react_1.default.createElement("div", { key: index, className: index_module_scss_1.default["select-itme-wrapper"], id: "select" },
                react_1.default.createElement(udesk_ui_1.Select, { onClick: gotoCompany, showSearch //显示搜索
                    : true, showArrow: true, labelInValue: true, value: valueList[index], placeholder: props.placeholder, notFoundContent: fetching ? react_1.default.createElement(udesk_ui_1.Spin, { size: "small" }) : null, filterOption: false, onSearch: fetchUser, onChange: function (value) { return handleChange(value, index); }, style: { width: "100%" }, getPopupContainer: getPopupContainer, allowClear: true, disabled: index !== valueList.length - 1 }, data.map(function (d) {
                    if (!filterList.includes(d.value))
                        return (react_1.default.createElement(Option, { key: d.value, value: d.value }, d.label));
                    else
                        return react_1.default.createElement(react_1.default.Fragment, null);
                })),
                (function () {
                    if (canAdd) {
                        if (index) {
                            return (react_1.default.createElement("div", { onClick: function () { return deleteOrg(index); }, className: index_module_scss_1.default["add-org"] },
                                react_1.default.createElement(icons_1.MinusOutlined, null)));
                        }
                        else {
                            return (react_1.default.createElement("div", { className: index_module_scss_1.default["add-org"], onClick: addOrg },
                                react_1.default.createElement(icons_1.PlusOutlined, null)));
                        }
                    }
                })()));
        })),
        canCreate && valueList.length < 20 && (react_1.default.createElement("div", { className: index_module_scss_1.default["input-after-icon"], onClick: function () { return changePageType("org"); } },
            react_1.default.createElement(icons_1.PlusOutlined, null),
            t("page.im.ticket.addCompany")))));
}
exports.default = SearchOrgField;
