"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var index_module_scss_1 = __importDefault(require("../index.module.scss"));
var udesk_ui_1 = require("udesk-ui");
var react_i18next_1 = require("react-i18next");
var FieldComponent = __importStar(require("../components/index"));
var index_1 = require("../../../utils/index");
var csApi_1 = require("../../../utils/csApi");
var custom_field_container_1 = __importDefault(require("../../../components/custom-field-container"));
var cloneDeep_1 = __importDefault(require("lodash-es/cloneDeep"));
var utilities_1 = require("../../../im-panel/ticket/utilities");
var langsDict = [
    { id: "", text: "默认语言", lang_code: "" },
    { id: "zh-cn", text: "Chinese/简体中文", lang_code: "zh-cn" },
    { id: "en-us", text: "English", lang_code: "en-us" },
    { id: "bn", text: "Bengali/বাংলা ভাষা", lang_code: "bn" },
    { id: "de", text: "German/Deutsch", lang_code: "de" },
    { id: "es", text: "Spanisch/Español", lang_code: "es" },
    { id: "hi", text: "Hindi/हिन्दी", lang_code: "hi" },
    { id: "id", text: "Indonesian/Bahasa indonesia", lang_code: "id" },
    { id: "it", text: "Italian/italiano", lang_code: "it" },
    { id: "ja", text: "Japanese/日本語", lang_code: "ja" },
    { id: "ko", text: "Korean/한국어", lang_code: "ko" },
    { id: "pt", text: "Portuguese/Português", lang_code: "pt" },
    { id: "ru", text: "Russian/русский", lang_code: "ru" },
    { id: "th", text: "Thai/ไทย", lang_code: "th" },
    { id: "vi", text: "Vietnamese/Người việt nam", lang_code: "vi" },
    { id: "zh-HK", text: "HK Traditional Chinese/香港繁体", lang_code: "zh-HK" },
    { id: "el", text: "Greek/Ελληνική γλώσσα", lang_code: "el" },
    { id: "tr", text: "Turk/Türk dili", lang_code: "tr" },
    { id: "fr", text: "French/Française", lang_code: "fr" },
];
function CreateCustomer(props) {
    var formRef = (0, react_1.useRef)(null);
    //多语言
    var t = (0, react_i18next_1.useTranslation)().t;
    //ember传进来的参数
    var company = props.company, customerFieldsv2 = props.customerFieldsv2, customerFieldsAuthority = props.customerFieldsAuthority, ticketTab = props.ticketTab, roleCan = props.roleCan, agentGroups = props.agentGroups, event = props.event;
    var _customerFieldsv2 = (0, react_1.useMemo)(function () {
        return (0, cloneDeep_1.default)(customerFieldsv2);
    }, [customerFieldsv2]);
    //新建工单用的useContext
    var _a = (0, react_1.useContext)(utilities_1.TicketContext), changePageType = _a.changePageType, changeCustomer = _a.changeCustomer;
    //自定义字段数据 field
    var _b = (0, react_1.useState)([]), customField = _b[0], setCustomField = _b[1];
    //自定义字段的fromData
    var _c = (0, react_1.useState)(), customFormData = _c[0], setCustomFormData = _c[1];
    // 首次进入 处理自定义字段
    (0, react_1.useEffect)(function () {
        //循环用户自定义字段   从中筛选出自定义字段和im显示的子弹 并且处理是否必填  agent_permission=1就是必填的
        var contextCustomerFields = _customerFieldsv2.filter(function (item) {
            return item.agent_permission && item.im_show;
        });
        var customerFields = (0, index_1.formatCustomField)({
            fields: contextCustomerFields,
            trigger: "onBlur",
            fieldsAuthority: customerFieldsAuthority,
            fieldType: "customer",
            editType: "new",
        }); //自定义字段的formItem
        setCustomField(customerFields);
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    // 提交时触发
    var handleSubmit = (0, react_1.useCallback)(function (value) {
        var _a;
        var params = { customer: {} };
        var data = value;
        // 处理cellphones数据格式
        data.cellphones_attributes = data.cellphones
            ? data.cellphones.split(",").map(function (item) {
                return {
                    content: item,
                };
            })
            : [];
        //处理完成后删除cellphones   没有必要传
        delete data.cellphones;
        // 默认值
        data.customerListSelected = false;
        data.merging = false;
        data.default_organization_id = null;
        // 如果选了tags  给params赋值tags
        if ((_a = data === null || data === void 0 ? void 0 : data.tags) === null || _a === void 0 ? void 0 : _a.length) {
            params.tags = data === null || data === void 0 ? void 0 : data.tags.join(",");
        }
        // 删除formdata的tags
        delete data.tags;
        //处理邮箱数据格式
        if (data.email.length > 1) {
            var ohter_emails = data.email;
            //email 是 填的email的第一个值  其他的都是ohter_emails
            data.email = ohter_emails[0];
            var new_email = __spreadArray([null], ohter_emails.slice(1), true);
            params.other_emails = [new_email];
        }
        // 将完整form中的自定义字段拆出来
        var custom_fields = {};
        // 循环完整表单数据
        for (var key in data) {
            // 如果当前循环的数据key在自定义表单中也有  取出来  删除
            if (key in customFormData) {
                custom_fields[key] = data[key];
                delete data[key];
            }
        }
        data.custom_fields = custom_fields;
        //选择的公司和邮箱处理空数据
        data.organizations = data.organizations.filter(function (item) { return item; });
        params.customer = data;
        (0, csApi_1.csApiPostJSON)("/cs/ts/api/customers", params).then(function (res) { return res.data; })
            .then(function (res) {
            var _a;
            // 开始提交请求
            if (res.code === 1000) {
                // 创建成功后将创建的用户更新   给新增工单页面回显用
                changeCustomer({
                    label: res.customer.nick_name,
                    value: res.customer.id,
                });
                //更改页面类型  返回新建工单
                changePageType("ticket");
            }
            else {
                udesk_ui_1.message.error((res === null || res === void 0 ? void 0 : res.code_message) || ((_a = res === null || res === void 0 ? void 0 : res.exception) === null || _a === void 0 ? void 0 : _a.message) || t("saveError"));
                udesk_ui_1.message.error(res.code_message);
            }
        })
            .catch(function (e) {
            e = JSON.parse(e.message);
            udesk_ui_1.message.error(e.data.code_message);
        });
    }, [changeCustomer, changePageType, customFormData, t]);
    var handleInitialValue = (0, react_1.useMemo)(function () {
        var customerFormData = {}; //自定义字段的formData
        //循环用户自定义字段
        _customerFieldsv2
            .filter(function (item) {
            return item.agent_permission && item.im_show;
        })
            .forEach(function (item) {
            customerFormData[item.name] =
                item.name.split("_")[0] === "TextField" ? "" : [];
        });
        setCustomFormData(customerFormData);
        return Object.assign({
            nick_name: "",
            level: "normal",
            email: [],
            description: "",
            organizations: [],
            cellphones: "",
            tags: [],
            lang: "",
            owner_group_id: "",
            owner_id: "",
        }, customerFormData);
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [false]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: index_module_scss_1.default["ticket-form"] },
            react_1.default.createElement(udesk_ui_1.Form, { ref: formRef, initialValues: handleInitialValue, onFinish: handleSubmit, layout: "vertical" },
                react_1.default.createElement(udesk_ui_1.Form.Item, { name: "nick_name", label: t("page.im.ticket.nick_name"), required: true, rules: [
                        {
                            required: true,
                            message: (0, index_1.r)(t("needWrite"), t("page.im.ticket.nick_name")),
                        },
                    ] },
                    react_1.default.createElement(FieldComponent.text, { trigger: "onChange", isRequired: true, id: "nick_name", type: "text" })),
                react_1.default.createElement(udesk_ui_1.Form.Item, { name: "level", label: t("page.im.ticket.level") },
                    react_1.default.createElement(FieldComponent.droplist, { id: "level", type: "droplist", trigger: "onChange", options: [
                            {
                                value: "normal",
                                title: t("page.im.ticket.normal"),
                            },
                            {
                                value: "vip",
                                title: "VIP",
                            },
                        ] })),
                react_1.default.createElement(udesk_ui_1.Form.Item, { name: "email", label: t("page.im.ticket.email"), rules: [
                        {
                            validator: function (rule, value) {
                                var error = 0;
                                value.forEach(function (item) {
                                    if (item &&
                                        !/^[A-Za-z0-9\u4e00-\u9fa5]+@[a-zA-Z0-9_-]+(\.[a-zA-Z0-9_-]+)+$/i.test(item)) {
                                        error++;
                                    }
                                });
                                return error ? Promise.reject("") : Promise.resolve();
                            },
                        },
                    ] },
                    react_1.default.createElement(FieldComponent.email, { placeholder: t("page.im.ticket.email") })),
                react_1.default.createElement(udesk_ui_1.Form.Item, { name: "description", label: t("page.im.ticket.description") },
                    react_1.default.createElement(FieldComponent.textarea, { trigger: "onChange", placeholder: t("page.im.ticket.forCustomerDesc"), id: "description", type: "textarea" })),
                react_1.default.createElement(udesk_ui_1.Form.Item, { name: "organizations", label: t("page.im.ticket.organizations") },
                    react_1.default.createElement(FieldComponent.org, { placeholder: t("page.im.ticket.keywordQueryCompany"), roleCan: roleCan, company: company, event: event })),
                react_1.default.createElement(udesk_ui_1.Form.Item, { name: "cellphones", label: t("page.im.ticket.phone"), rules: [
                        {
                            validator: function (rule, value) {
                                var list = value.split(",");
                                var error = 0, errorText = "";
                                list.forEach(function (item) {
                                    if (!/^1[34578][0-9]{9}$/.test(item) &&
                                        !/^(0[0-9]{2,3}-)([2-9][0-9]{6,7})+(-[0-9]{1,4})?$/) {
                                        error++;
                                        errorText = errorText || "";
                                    }
                                });
                                return error ? Promise.reject(errorText) : Promise.resolve();
                            },
                        },
                    ] },
                    react_1.default.createElement(FieldComponent.cellphone, { placeholder: t("page.im.ticket.phone"), event: event })),
                react_1.default.createElement(udesk_ui_1.Form.Item, { name: "tags", label: t("page.im.ticket.tags") },
                    react_1.default.createElement(FieldComponent.tag, null)),
                company.is_support_lang && (react_1.default.createElement(udesk_ui_1.Form.Item, { name: "lang", label: t("page.im.ticket.lang") },
                    react_1.default.createElement(FieldComponent.selectSearch, { options: langsDict.map(function (item) {
                            return {
                                value: item.id,
                                title: item.text,
                            };
                        }) }))),
                react_1.default.createElement(udesk_ui_1.Form.Item, { name: "owner_group_id", label: t("page.im.ticket.owner_group_name") },
                    react_1.default.createElement(FieldComponent.agentGroups, { agentGroups: agentGroups })),
                react_1.default.createElement(udesk_ui_1.Form.Item, { name: "owner_id", label: t("page.im.ticket.owner_name") },
                    react_1.default.createElement(FieldComponent.agent, null)),
                customField.length > 1 && react_1.default.createElement(custom_field_container_1.default, { fields: customField }))),
        react_1.default.createElement("div", { className: index_module_scss_1.default["bottom-btn-list"] },
            react_1.default.createElement(udesk_ui_1.Button, { style: { marginRight: "10px" }, onClick: function () { return changePageType("ticket"); } }, t("cancel")),
            react_1.default.createElement(udesk_ui_1.Button, { type: "primary", onClick: function () { return formRef.current.submit(); } }, t("submit")))));
}
exports.default = CreateCustomer;
