"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var index_module_scss_1 = __importDefault(require("../index.module.scss"));
var udesk_ui_1 = require("udesk-ui");
var react_i18next_1 = require("react-i18next");
var FieldComponent = __importStar(require("../components/index"));
var index_1 = require("../../../utils/index");
var custom_field_container_1 = __importDefault(require("../../../components/custom-field-container"));
var cloneDeep_1 = __importDefault(require("lodash-es/cloneDeep"));
var utilities_1 = require("../../../im-panel/ticket/utilities");
function CreateOrg(props) {
    var formRef = (0, react_1.useRef)(null);
    //多语言
    var t = (0, react_i18next_1.useTranslation)().t;
    //ember传进来的参数
    // const udeskWebappContext: ImContextProps = useContext(UdeskContext);
    var _a = props.organizationFieldsv2, organizationFieldsv2 = _a === void 0 ? [] : _a;
    //新建工单用的useContext
    var _b = (0, react_1.useContext)(utilities_1.TicketContext), changePageType = _b.changePageType, changeOrganization = _b.changeOrganization;
    //自定义字段数据 field
    var _c = (0, react_1.useState)([]), orgField = _c[0], setOrgField = _c[1];
    ////自定义字段的fromData
    var _d = (0, react_1.useState)(), customData = _d[0], setCustomFormData = _d[1];
    // 首次进入 处理自定义字段
    var _organizationFieldsv2 = (0, react_1.useMemo)(function () {
        return (0, cloneDeep_1.default)(organizationFieldsv2);
    }, [organizationFieldsv2]);
    (0, react_1.useEffect)(function () {
        //循环用户自定义字段   从中筛选出自定义字段和im显示的子弹 并且处理是否必填  agent_permission=1就是必填的
        var contextCustomerFields = _organizationFieldsv2.filter(function (item) {
            item.is_required = item.agent_permission === 1 ? true : false;
            return item.agent_permission && item.im_show;
        });
        var organizationFields = (0, index_1.formatCustomField)({
            fields: contextCustomerFields,
        }); //自定义字段的formItem
        //给form字段重新复制 合并
        setOrgField(organizationFields);
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    // 提交时触发
    var handleSubmit = (0, react_1.useCallback)(function (value) {
        var params = { organization: {} };
        var data = value;
        // 将完整form中的自定义字段拆出来
        var org_fields = {};
        // 循环完整表单数据
        for (var key in data) {
            // 如果当前循环的数据key在自定义表单中也有  取出来  删除
            if (key in customData) {
                org_fields[key] = data[key];
                delete data[key];
            }
        }
        params.organization = Object.assign({
            custom_fields: org_fields,
        }, data);
        // 开始提交请求
        (0, index_1.postJSON)("/organizations", params)
            .then(function (res) {
            var _a;
            if (res.code === 1000) {
                // 创建成功后将创建的用户更新   给新增工单页面回显用
                changeOrganization({
                    label: res.organization.name,
                    value: res.organization.id,
                });
                //更改页面类型  返回新建工单
                changePageType("customer");
            }
            else {
                udesk_ui_1.message.error((res === null || res === void 0 ? void 0 : res.code_message) || ((_a = res === null || res === void 0 ? void 0 : res.exception) === null || _a === void 0 ? void 0 : _a.message) || t("saveError"));
            }
        })
            .catch(function (e) {
            console.log(e);
            udesk_ui_1.message.error(t("saveError"));
        });
    }, [changeOrganization, changePageType, customData, t]);
    // 表单数据改变触发  开发时方便查看  提测注释掉
    var handleChangeValue = (0, react_1.useCallback)(function (changeValue, allValue) {
        // setFormData(allValue);
    }, []);
    var handleInitialValue = (0, react_1.useMemo)(function () {
        var customerFormData = {}; //自定义字段的formData
        //循环用户自定义字段   将处理过后的数据和formField,formData合并
        _organizationFieldsv2
            .filter(function (item) {
            return item.agent_permission && item.im_show;
        })
            .forEach(function (item) {
            customerFormData[item.name] =
                item.name.split("_")[0] === "TextField" ? "" : [];
        });
        setCustomFormData(customerFormData);
        return Object.assign({
            name: "",
            level: "vip",
            description: "",
            org_email_suffix: "",
            domains: "",
        }, customerFormData);
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [false]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: index_module_scss_1.default["ticket-form"] },
            react_1.default.createElement(udesk_ui_1.Form, { ref: formRef, initialValues: handleInitialValue, onFinish: handleSubmit, layout: "vertical", onValuesChange: handleChangeValue },
                react_1.default.createElement(udesk_ui_1.Form.Item, { name: "name", label: t("page.im.ticket.organization_name"), required: true, rules: [{ required: true, message: "\u8BF7\u586B\u5199\u516C\u53F8\u540D\u79F0" }] },
                    react_1.default.createElement(FieldComponent.text, { trigger: "onChange", isRequired: true, id: "name", type: "text" })),
                react_1.default.createElement(udesk_ui_1.Form.Item, { name: "level", label: t("page.im.ticket.level") },
                    react_1.default.createElement(FieldComponent.droplist, { id: "level", type: "droplist", trigger: "onChange", options: [
                            {
                                value: "normal",
                                title: t("page.im.ticket.normal"),
                            },
                            {
                                value: "vip",
                                title: "VIP",
                            },
                        ] })),
                react_1.default.createElement(udesk_ui_1.Form.Item, { name: "description", label: t("page.im.ticket.description") },
                    react_1.default.createElement(FieldComponent.textarea, { trigger: "onChange", placeholder: t("page.im.ticket.descTip"), id: "description", type: "textarea" })),
                react_1.default.createElement(udesk_ui_1.Form.Item, { name: "org_email_suffix", label: t("page.im.ticket.org_email_suffix") },
                    react_1.default.createElement(FieldComponent.textHasPoint, { remark: t("page.im.ticket.emailSuffixHelpText") })),
                react_1.default.createElement(udesk_ui_1.Form.Item, { name: "domains", label: t("page.im.ticket.domains") },
                    react_1.default.createElement(FieldComponent.textHasPoint, { remark: t("page.im.ticket.helpBlock") })),
                orgField.length > 1 && react_1.default.createElement(custom_field_container_1.default, { fields: orgField }))),
        react_1.default.createElement("div", { className: index_module_scss_1.default["bottom-btn-list"] },
            react_1.default.createElement(udesk_ui_1.Button, { style: { marginRight: "10px" }, onClick: function () { return changePageType("customer"); } }, t("cancel")),
            react_1.default.createElement(udesk_ui_1.Button, { type: "primary", onClick: function () { return formRef.current.submit(); } }, t("save")))));
}
exports.default = CreateOrg;
