"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var index_module_scss_1 = __importDefault(require("./index.module.scss"));
var react_i18next_1 = require("react-i18next");
var create_ticket_page_1 = __importDefault(require("./create-ticket-page"));
var create_customer_page_1 = __importDefault(require("./create-customer-page"));
var create_org_page_1 = __importDefault(require("./create-org-page"));
var utils_1 = require("../../utils");
var utilities_1 = require("./utilities");
function CreateTicketIndex(_a) {
    var onCreateSuccess = _a.onCreateSuccess, props = __rest(_a, ["onCreateSuccess"]);
    var _b = (0, react_1.useState)([]), agent = _b[0], setAgent = _b[1];
    (0, react_1.useEffect)(function () {
        (0, utils_1.getJSON)("/user_groups/list_with_agents_status").then(function (res) {
            var options = res.user_groups.map(function (item) {
                return {
                    label: res.ticket_setting_is_open
                        ? "".concat(item.name, "  (").concat(res.ticket_setting_online_title, " ").concat(item.agents_availability_count, "/").concat(item.agents_count, ")")
                        : item.name,
                    value: item.id,
                    agents_availability_count: item.agents_availability_count,
                    agents_count: item.agents_count,
                    children: item.agents.map(function (item) {
                        return {
                            label: res.ticket_setting_is_open
                                ? "".concat(item.nick_name, "  (").concat(item.availability
                                    ? res.ticket_setting_online_title
                                    : res.ticket_setting_offline_title, ")")
                                : item.nick_name,
                            value: item.id,
                            availability: item.availability,
                        };
                    }),
                };
            });
            setAgent(options);
        });
    }, []);
    var t = (0, react_i18next_1.useTranslation)().t;
    var _c = (0, react_1.useState)("ticket"), pageType = _c[0], setPageType = _c[1]; //页面类型  用于切换界面   ticket 新建工单  customer 新建客户 org 新建公司
    var _d = (0, react_1.useState)(""), agentGroup = _d[0], setAgentGroup = _d[1]; //负责组   新增用户中的负责组 组件中改变 负责组选择  改变该值  在 负责人组件中 使用
    var _e = (0, react_1.useState)({}), customer = _e[0], setCustomer = _e[1];
    var _f = (0, react_1.useState)({}), organization = _f[0], setOrganization = _f[1];
    //根据pagetype不一样 改变头部标题
    var header = pageType === "ticket"
        ? t("page.im.ticket.createTicket")
        : pageType === "customer"
            ? t("page.im.ticket.createCustomer")
            : t("page.im.ticket.createOrg");
    var contextContent = (0, react_1.useMemo)(function () {
        return {
            changePageType: function (type) { return setPageType(type); },
            agentGroup: agentGroup,
            changeAgentGroup: function (type) { return setAgentGroup(type); },
            customer: customer,
            changeCustomer: function (object) { return setCustomer(object); },
            organization: organization,
            changeOrganization: function (object) {
                return setOrganization(object);
            },
            agent: agent,
        };
    }, [agent, agentGroup, customer, organization]);
    var content = (0, react_1.useMemo)(function () {
        switch (pageType) {
            case "ticket":
                return (react_1.default.createElement(create_ticket_page_1.default, __assign({ setShowTicket: props.setShowTicket, onSaveSuccess: onCreateSuccess }, props)));
            case "customer":
                return react_1.default.createElement(create_customer_page_1.default, __assign({}, props));
            default:
                return react_1.default.createElement(create_org_page_1.default, __assign({}, props));
        }
    }, [pageType, props]);
    return (react_1.default.createElement("div", { className: index_module_scss_1.default["ticket-wrapper"] },
        react_1.default.createElement("div", { className: index_module_scss_1.default["ticket-header"] }, header),
        react_1.default.createElement(utilities_1.TicketContext.Provider, { value: contextContent }, content)));
}
exports.default = CreateTicketIndex;
