"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var style_module_scss_1 = __importDefault(require("./style.module.scss"));
var udesk_ui_1 = require("udesk-ui");
var icon_1 = require("../../components/icon/icon");
var isFunction_1 = __importDefault(require("lodash-es/isFunction"));
var moment_1 = __importDefault(require("moment"));
var react_i18next_1 = require("react-i18next");
var utils_1 = require("../../utils");
var ImVisit = function (props) {
    var t = (0, react_i18next_1.useTranslation)().t;
    var formRef = udesk_ui_1.Form.useForm()[0];
    var event = props.event, setShowVisit = props.setShowVisit, chat = props.chat;
    var handleSave = (0, react_1.useCallback)(function (allValue) {
        var schedule_time = allValue.schedule_time, remark = allValue.remark;
        if (!schedule_time) {
            udesk_ui_1.message.warn(t("page.im.visit.choiceTime"));
            return;
        }
        if ((0, moment_1.default)(schedule_time).isBefore((0, moment_1.default)())) {
            udesk_ui_1.message.warn(t("page.im.visit.alertTimeTip"));
            return;
        }
        if ((0, isFunction_1.default)(setShowVisit)) {
            setShowVisit({
                show: false,
            });
        }
        event.updateChat &&
            event.updateChat({
                chat: chat,
                key: "newVisit",
                value: {},
            });
        (0, utils_1.postJSON)("alarms", {
            alarm: {
                call_log_id: null,
                callout_task_id: null,
                callout_task_import_method: null,
                callout_task_name: null,
                callout_task_source: null,
                contact_list_id: null,
                contact_method: "im",
                customer_id: chat.customer_id,
                hide_number: false,
                im_sub_session_id: chat.im_sub_session_id,
                overdue: false,
                remark: remark || "",
                result: "unexecuted",
                schedule_time: (0, moment_1.default)(schedule_time).toDate(),
                ticket_id: null,
                user: null,
                user_id: null,
            },
        }).then(function (res) {
            var _a;
            if (res.code === "1000" || res.code === 1000) {
                udesk_ui_1.message.success("保存成功");
            }
            else {
                udesk_ui_1.message.warning((res === null || res === void 0 ? void 0 : res.code_message) ||
                    ((_a = res === null || res === void 0 ? void 0 : res.exception) === null || _a === void 0 ? void 0 : _a.message) ||
                    t("page.im.imMessages.voiceOvertime"));
            }
        });
    }, [chat, event, setShowVisit, t]);
    var handleClose = (0, react_1.useCallback)(function () {
        setShowVisit({
            show: false,
        });
        event.updateChat &&
            event.updateChat({
                chat: chat,
                key: "newRecord",
                value: {},
            });
    }, [chat, event, setShowVisit]);
    var save = (0, react_1.useCallback)(function () {
        formRef.submit();
    }, [formRef]);
    return (react_1.default.createElement("div", { className: style_module_scss_1.default["visit-container"] },
        react_1.default.createElement("div", { className: style_module_scss_1.default["visit-header"] },
            react_1.default.createElement("div", { className: style_module_scss_1.default["header-name"] }, t("page.im.visit.title")),
            react_1.default.createElement("div", { className: style_module_scss_1.default["header-icons"] },
                react_1.default.createElement("span", { onClick: save },
                    react_1.default.createElement(icon_1.DuiHao, null)),
                react_1.default.createElement("span", { onClick: handleClose },
                    react_1.default.createElement(icon_1.CuoHao, null)))),
        react_1.default.createElement("div", { className: style_module_scss_1.default["visit-body"] },
            react_1.default.createElement(udesk_ui_1.Form, { form: formRef, layout: "vertical", onFinish: handleSave, initialValues: {
                    schedule_time: (0, moment_1.default)(),
                } },
                react_1.default.createElement(udesk_ui_1.Form.Item, { label: "\u8BA1\u5212\u65F6\u95F4", name: "schedule_time" },
                    react_1.default.createElement(udesk_ui_1.DatePicker, { format: utils_1.YYYY_MM_DD_HH_MM_SS, showTime: true })),
                react_1.default.createElement(udesk_ui_1.Form.Item, { label: "\u5907\u6CE8", name: "remark" },
                    react_1.default.createElement(udesk_ui_1.Input.TextArea, null)),
                react_1.default.createElement(udesk_ui_1.Form.Item, null,
                    props.showCancel && (react_1.default.createElement(udesk_ui_1.Button, { type: "primary", onClick: handleClose }, t("cancel"))),
                    react_1.default.createElement(udesk_ui_1.Button, { type: "primary", htmlType: "submit", size: "small" }, t("save")))))));
};
exports.default = ImVisit;
