"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = require("react");
var KcsSDKWrapper_1 = tslib_1.__importDefault(require("./KcsSDKWrapper"));
var useKcsSDK = function (props) {
    var buttonsAuthority = props.buttonsAuthority, onButtonClick = props.onButtonClick, onFileButtonClick = props.onFileButtonClick;
    var _a = (0, react_1.useState)(), kcsInstance = _a[0], setKcsInstance = _a[1];
    var getSDKInstance = function () {
        return KcsSDKWrapper_1.default.getInstance({ buttonsAuthority: buttonsAuthority });
    };
    (0, react_1.useEffect)(function () {
        var kcsWrapper = getSDKInstance();
        if (kcsWrapper.kcsInstance) {
            setKcsInstance(function (v) { return v || kcsWrapper.kcsInstance; });
            return;
        }
        var onReady = function (r) { return setKcsInstance(r); };
        kcsWrapper.on("ready", onReady);
        return function () {
            kcsWrapper.off("ready", onReady);
        };
    }, []);
    (0, react_1.useEffect)(function () {
        var kcsWrapper = getSDKInstance();
        var buttonClickListener = function (data, buttonType) { return onButtonClick === null || onButtonClick === void 0 ? void 0 : onButtonClick(data, buttonType); };
        var fileButtonClickListener = function (file, buttonType) {
            return onFileButtonClick === null || onFileButtonClick === void 0 ? void 0 : onFileButtonClick(file, buttonType);
        };
        kcsWrapper.on("buttonClick", buttonClickListener);
        kcsWrapper.on("fileButtonClick", fileButtonClickListener);
        return function () {
            kcsWrapper.off("buttonClick", buttonClickListener);
            kcsWrapper.off("fileButtonClick", fileButtonClickListener);
        };
    }, [onButtonClick, onFileButtonClick]);
    return kcsInstance;
};
exports.default = useKcsSDK;
