"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var react_redux_1 = require("react-redux");
var useLocalStorage_1 = __importDefault(require("react-use/esm/useLocalStorage"));
var store_hook_1 = require("./store/store-hook");
var index_1 = require("./store/index");
var index_2 = require("./utils/index");
var urls_1 = require("./store/urls");
var company_1 = require("./store/company");
var role_can_1 = require("./store/role-can");
var init_data_1 = require("./store/init-data");
var current_user_1 = require("./store/current-user");
var agents_1 = require("./store/agents");
var groups_1 = require("./store/groups");
var fields_1 = require("./store/fields");
var note_templates_1 = require("./store/note-templates");
var platform_1 = require("./store/platform");
var agent_config_1 = require("./store/agent-config");
var im_entry_1 = __importDefault(require("./im-panel/im-entry"));
require("./index.module.scss");
var antd_1 = require("antd");
// const MESSAGES_MIN_WIDTH = 395;
var SessionAssist = react_1.default.forwardRef(function (props, ref) {
    // const imPanelEntryRef = useRef<ElementRef<typeof ImPanel>>(null);
    // const imMessageRef = useRef<ElementRef<"div">>(null);
    // const rightInnerRef = useRef<ElementRef<"div">>(null);
    var dispatch = (0, store_hook_1.useDispatch)();
    var _a = (0, useLocalStorage_1.default)('stretchable-box-right-panel-width', 400, {
        raw: false,
        serializer: function (value) { return value + ''; },
        deserializer: function (value) { return parseInt(value) || 370; },
    }), _b = _a[0], rightWidth = _b === void 0 ? 400 : _b, setRightWidth = _a[1];
    var initData = (0, react_1.useMemo)(function () {
        console.log('初始化开始');
        index_2.staticData.changeRobotUrl(props.kmrobot_url);
        index_2.staticData.changePreviewUrl(props.previewUrl);
        var _props = (0, index_2.formatProps)(props);
        dispatch((0, company_1.setCompany)(_props.company));
        dispatch((0, role_can_1.setRoleCan)(_props.roleCan));
        dispatch((0, current_user_1.setCurrentUser)(_props.user));
        dispatch((0, agents_1.setAgents)(_props.agents));
        dispatch((0, groups_1.setGroups)(_props.agentGroups));
        dispatch((0, init_data_1.setInitData)(_props)); //props所有数据
        dispatch((0, urls_1.setRUrls)({
            apiHost: _props.apiHost,
            vistor_server: _props.vistor_server,
        }));
        dispatch((0, fields_1.setFields)({
            customerFields: _props.customerFields,
            customerFieldsv2: _props.customerFieldsv2,
            organizationFields: _props.organizationFields,
            organizationFieldsv2: _props.organizationFieldsv2,
            noteFields: _props.noteFields,
        }));
        dispatch((0, note_templates_1.setNoteTemplateConfig)({
            noteTemplates: _props.noteTemplates || [],
            imAgentNoteTemplatesSort: _props.imAgentNoteTemplatesSort || [],
        }));
        dispatch((0, platform_1.setPlatform)(_props.platforms));
        dispatch((0, agent_config_1.getAgentConfig)());
        return;
    }, []);
    (0, react_1.useEffect)(function () {
        var _props = (0, index_2.formatProps)(props);
        dispatch((0, init_data_1.setInitData)(_props));
    }, [props]);
    var onRightWidthChange = (0, react_1.useCallback)(function (changedWidth) {
        // const messageWidth = imMessageRef?.current?.getWidth?.();
        // if (
        //   messageWidth &&
        //   messageWidth < MESSAGES_MIN_WIDTH &&
        //   changedWidth > rightWidth
        // ) {
        //   const rightInnerWidth = rightInnerRef.current!.offsetWidth;
        //   return setRightWidth(rightInnerWidth - MESSAGES_MIN_WIDTH);
        // } else {
        props.event.onWidthChange(changedWidth);
        return setRightWidth(changedWidth);
        // }
    }, [rightWidth, setRightWidth]);
    return (react_1.default.createElement(im_entry_1.default, { ref: ref, width: rightWidth, cssMaxWidth: "calc(100% - ".concat(props.tabsWidth, "px)"), onWidthChange: onRightWidthChange }));
});
var Index = react_1.default.forwardRef(function (props, ref) {
    return (react_1.default.createElement(antd_1.ConfigProvider, { prefixCls: 'udesk-avs-web-prefix' },
        react_1.default.createElement(react_redux_1.Provider, { context: store_hook_1.UdeskContext, store: index_1.store },
            react_1.default.createElement(SessionAssist, __assign({}, props, { ref: ref })))));
});
Index.displayName = 'Index';
exports.default = Index;
