"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.components = exports["default"] = void 0;

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _CommonDropdown = _interopRequireDefault(require("./CommonDropdown"));

var _Control = _interopRequireDefault(require("./Control"));

var _react2 = require("@emotion/react");

var SingleSelect = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(SingleSelect, _Component);

  function SingleSelect(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "_ref", /*#__PURE__*/(0, _react.createRef)());
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "_onChange", function (value, option) {
      _this.setState({
        isOpen: false
      });

      _this.props.onChange(value, option);
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "toggleDropdown", function () {
      _this.setState({
        isOpen: !_this.state.isOpen
      });
    });
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "handleClickOutside", function (event) {
      if (_this._ref.current && !_this._ref.current.contains(event.target)) {
        _this.setState({
          isOpen: false
        });
      }
    });
    _this.state = {
      isOpen: false,
      options: []
    };
    return _this;
  }

  var _proto = SingleSelect.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        controlClassName = _this$props.controlClassName,
        controlStyle = _this$props.controlStyle,
        _this$props$prefix = _this$props.prefix,
        prefix = _this$props$prefix === void 0 ? '' : _this$props$prefix,
        _this$props$options = _this$props.options,
        options = _this$props$options === void 0 ? [] : _this$props$options,
        _this$props$getOption = _this$props.getOptionLabel,
        getOptionLabel = _this$props$getOption === void 0 ? function (v) {
      return JSON.stringify(v);
    } : _this$props$getOption,
        _this$props$getOption2 = _this$props.getOptionValue,
        getOptionValue = _this$props$getOption2 === void 0 ? function (v) {
      return v;
    } : _this$props$getOption2,
        onChange = _this$props.onChange,
        value = _this$props.value,
        _this$props$placehold = _this$props.placeholder,
        placeholder = _this$props$placehold === void 0 ? '全部' : _this$props$placehold,
        _this$props$t = _this$props.t,
        t = _this$props$t === void 0 ? function (v) {
      return v;
    } : _this$props$t,
        loadOptions = _this$props.loadOptions,
        components = _this$props.components,
        _this$props$className = _this$props.className,
        className = _this$props$className === void 0 ? '' : _this$props$className;
    return (0, _react2.jsx)("div", {
      className: 'select-with-search ' + className,
      ref: this._ref
    }, (0, _react2.jsx)("div", {
      className: 'align-justify ' + controlClassName,
      style: controlStyle,
      onClick: this.toggleDropdown
    }, (0, _react2.jsx)(components.Control, {
      value: value,
      options: options,
      prefix: prefix,
      getOptionLabel: getOptionLabel,
      getOptionValue: getOptionValue,
      placeholder: placeholder,
      isOpen: this.state.isOpen,
      t: t
    })), this.state.isOpen ? !loadOptions ? (0, _react2.jsx)(_CommonDropdown["default"], {
      value: value,
      onChange: this._onChange,
      getOptionValue: getOptionValue,
      getOptionLabel: getOptionLabel,
      t: t,
      options: options
    }) : void 0 : void 0);
  };

  _proto.componentDidMount = function componentDidMount() {
    document.addEventListener('mousedown', this.handleClickOutside);
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    document.removeEventListener('mousedown', this.handleClickOutside);
  };

  return SingleSelect;
}(_react.Component);

SingleSelect.propTypes = {
  controlClassName: _propTypes["default"].string,
  controlStyle: _propTypes["default"].object,
  prefix: _propTypes["default"].string,
  value: _propTypes["default"].any,
  options: _propTypes["default"].arrayOf(_propTypes["default"].any),
  loadOptions: _propTypes["default"].func,
  getOptionLabel: _propTypes["default"].func,
  getOptionValue: _propTypes["default"].func,
  onChange: _propTypes["default"].func,
  placeholder: _propTypes["default"].string,
  className: _propTypes["default"].string,
  components: _propTypes["default"].object
};
var defaultComponents = {
  Control: _Control["default"]
};
SingleSelect.defaultProps = {
  components: defaultComponents,
  controlClassName: 'form-control',
  className: ''
};
var _default = SingleSelect;
exports["default"] = _default;
var components = defaultComponents;
exports.components = components;