"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = require("@emotion/react");

var Popover = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(Popover, _Component);

  function Popover(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "_ref", /*#__PURE__*/_react["default"].createRef());
    (0, _defineProperty2["default"])((0, _assertThisInitialized2["default"])(_this), "_doNotClosePopover", false);
    _this.state = {
      isOpen: false
    };
    return _this;
  }

  var _proto = Popover.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        components = _this$props.components,
        style = _this$props.style,
        className = _this$props.className,
        props = (0, _objectWithoutPropertiesLoose2["default"])(_this$props, ["components", "style", "className"]);

    if (!components.Control) {
      components.Control = DefaultControl;
    }

    if (!components.PopContent) {
      components.PopContent = DefaultPopContent;
    }

    return (0, _react2.jsx)("div", {
      style: style,
      className: className,
      ref: this._ref
    }, (0, _react2.jsx)(components.Control, (0, _extends2["default"])({}, props, {
      isOpen: this.state.isOpen,
      onClick: function onClick() {
        return _this2.toggleOpen();
      }
    })), this.state.isOpen && (0, _react2.jsx)(components.PopContent, (0, _extends2["default"])({}, props, {
      isOpen: this.state.isOpen,
      closePopContent: function closePopContent() {
        return _this2.setState({
          isOpen: false
        });
      }
    })));
  };

  _proto.componentDidMount = function componentDidMount() {
    var _this3 = this;

    this._ref.current.addEventListener('click', function () {
      _this3._doNotClosePopover = true;
    });

    document.body.addEventListener('click', this._bodyEvent = function () {
      if (_this3._doNotClosePopover) {
        _this3._doNotClosePopover = false;
        return;
      }

      _this3.setState({
        isOpen: false
      });
    });
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    document.body.removeEventListener('click', this._bodyEvent);
  };

  _proto.toggleOpen = function toggleOpen() {
    this.setState({
      isOpen: !this.state.isOpen
    });
  };

  return Popover;
}(_react.Component);

Popover.propTypes = {
  components: _propTypes["default"].object
};

var DefaultControl = function DefaultControl(props) {
  return (0, _react2.jsx)("button", (0, _extends2["default"])({
    type: "button"
  }, props), "Default Control");
};

var DefaultPopContent = function DefaultPopContent(props) {
  return (0, _react2.jsx)("div", props, "Default Pop Content");
};

Popover.defaultProps = {
  components: {
    Control: DefaultControl,
    PopContent: DefaultPopContent
  }
};
var _default = Popover;
exports["default"] = _default;