"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.axiosInstance = void 0;
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var react_i18next_1 = require("react-i18next");
var udesk_ui_1 = require("udesk-ui");
var moment_1 = tslib_1.__importDefault(require("moment"));
var IconComponent = tslib_1.__importStar(require("./icon"));
var icon_1 = require("./icon");
var dompurify_1 = tslib_1.__importDefault(require("dompurify"));
var MessageComponent = tslib_1.__importStar(require("./components"));
var message_video_1 = tslib_1.__importDefault(require("./components/message-video"));
var knowledge_graph_1 = tslib_1.__importDefault(require("./knowledge-graph"));
var style_module_less_1 = tslib_1.__importDefault(require("./style.module.less"));
var icons_1 = require("@ant-design/icons");
var menu_1 = tslib_1.__importDefault(require("./menu"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var ImLog = function (_a) {
    var _b;
    var msg = _a.msg, onReEdit = _a.onReEdit, allowAddToCustomerInfo = _a.allowAddToCustomerInfo, allowAddToRobotKM = _a.allowAddToRobotKM, allowAddToKM = _a.allowAddToKM, allowRecall = _a.allowRecall, onSelectEmail = _a.onSelectEmail, onSelectTel = _a.onSelectTel, onRecall = _a.onRecall, onHide = _a.onHide, onRef = _a.onRef, onCheck = _a.onCheck, onUnHide = _a.onUnHide, allowVoiceToText = _a.allowVoiceToText, allowSearchImRecord = _a.allowSearchImRecord, onAddToKM = _a.onAddToKM, onSelectText = _a.onSelectText, onVoiceToText = _a.onVoiceToText, onAddToRobotKM = _a.onAddToRobotKM, allowUnHide = _a.allowUnHide, allowReedit = _a.allowReedit, msgdisplayStatus = _a.msgdisplayStatus, hideEnable = _a.hideEnable, refEnable = _a.refEnable, onReSend = _a.onReSend, agent = _a.agent, chat = _a.chat, web_message_display_status = _a.web_message_display_status, enabledSmartAssistance = _a.enabledSmartAssistance, realTimeTranslation = _a.realTimeTranslation, onSelectSuggestion = _a.onSelectSuggestion, robotBaseURL = _a.robotBaseURL, currentUser = _a.currentUser, kcsSdk = _a.kcsSdk, msgColor = _a.msgColor, msgRecvColor = _a.msgRecvColor, area = _a.area, wechatSuffix = _a.wechatSuffix, showCheckbox = _a.showCheckbox, isChecked = _a.isChecked, imLogCheckCb = _a.imLogCheckCb, openRecordCb = _a.openRecordCb, reloadImageTimes = _a.reloadImageTimes;
    //多语言
    var t = (0, react_i18next_1.useTranslation)().t;
    allowUnHide = allowUnHide === false ? false : true;
    // const { agents, chat, user, company, roleCan, currentTab,event} = udeskWebappContext
    // const chat = chatContext.chat;
    //是否是消息
    var isInfo = (0, react_1.useMemo)(function () {
        var contentType = msg.type;
        //处理isInfo
        var ifAction = function () {
            var type = contentType || 'message';
            var eventTypes = [
                'info_transfer',
                'transfer_send',
                'transfer_accept',
                'transfer_deny',
                'transfer_timeout',
                'ask_transfer_send',
                'ask_transfer_accept',
                'ask_transfer_deny',
                'ask_transfer_timeout',
                'video_call_invitation',
                'video_call_invitation_accept',
                'video_call_invitation_deny',
                'video_call_invitation_cancel',
                'video_call_invitation_hangup',
                'video_call_invitation_busy',
                'offline_reassign',
                'leave_message_assign',
                'assign_queue',
                'voice_call_invitation',
                'voice_call_invitation_accept',
                'voice_call_invitation_deny',
                'voice_call_invitation_cancel',
                'voice_call_invitation_hangup',
                'voice_call_invitation_busy',
                'info_offline_transfer'
            ];
            return msg.show_type === 'action' || eventTypes.includes(type);
        };
        var types = [
            'info',
            'info_transfer',
            'pre',
            'survey',
            'close',
            'info_appoint',
            'active_guest',
            'form',
            'form_received',
            'lock',
            'start_session',
            'vcall',
            'invitation',
            'customer_close',
            'agent_open_session',
            'suspend_expire',
            'info_offline_transfer',
            'jump_action'
        ];
        return (!types.includes(contentType) && !ifAction());
    }, [msg]);
    var eventText = (0, react_1.useMemo)(function () {
        var _a, _b;
        var event_text = msg.event_text || ((_a = msg.content) === null || _a === void 0 ? void 0 : _a.event_text);
        if (msg.timeout_freq == 1) {
            event_text = t('page.im.record.tip.noAnswer');
        }
        else if (msg.timeout_freq == 2) {
            event_text = t('page.im.record.tip.customerOvertime');
        }
        var name = (agent === null || agent === void 0 ? void 0 : agent.aliase) || (agent === null || agent === void 0 ? void 0 : agent.nick_name) || '';
        if (msg.timeout_auto_msg) {
            event_text = t('page.im.record.tip.agentOvertime', { agentName: name });
        }
        if (msg.msg_close) {
            if (msg.inviter && msg.inviter.jid) {
                name = msg.agent_nick_name || name; // 三方会话使用消息中的坐席名称
            }
            event_text = t('page.im.record.tip.agentCloseChat', { agentName: name });
        }
        if (msg.customer_close) {
            event_text = t('page.im.record.tip.customerCloseChat');
        }
        //is_active_guest:根据后台存储的消息类型为active_guest的属性
        //active_guest：xmpp收到的第一条消息的额外属性
        if (!isInfo) {
            event_text = msg.content || msg.data.content;
        }
        if (msg.type === 'jump_action') {
            event_text = msg.event_text || ((_b = msg.content) === null || _b === void 0 ? void 0 : _b.event_text);
        }
        if (msg.type === 'info_transfer') {
            event_text = msg.content || msg.data.content || t('page.im.record.tip.chatTransfer');
        }
        if (msg.type === 'suspend_expire') {
            event_text = msg.content || msg.data.content || t('page.im.record.tip.suspendExpire');
        }
        if (msg.type === 'offline_reassign' || msg.type === 'leave_message_assign' || msg.type === 'assign_queue') {
            event_text = msg.content || msg.data.content;
        }
        if (msg.type === 'info_offline_transfer') {
            event_text = msg.content || msg.data.content || t('page.im.record.tip.offlineChatTransfer', { agentName: name });
        }
        return event_text || '';
    }, [msg.event_text,
        msg.content,
        msg.timeout_freq,
        msg.timeout_auto_msg,
        msg.msg_close,
        msg.customer_close,
        msg.type,
        msg.data.content, agent === null || agent === void 0 ? void 0 : agent.aliase, agent === null || agent === void 0 ? void 0 : agent.nick_name, isInfo,
        t]);
    var timeText = (0, react_1.useMemo)(function () {
        if (eventText) {
            return (0, moment_1.default)(new Date(msg.created_at)).format('YY/MM/DD HH:mm:ss');
        }
        return '';
    }, [eventText, msg.created_at]);
    var handleMsgPre = (0, react_1.useCallback)(function () {
        var contentType = msg.type;
        var res = [];
        if (contentType === 'pre') {
            res.push(react_1.default.createElement("div", { key: 'pre' + msg.id, className: style_module_less_1.default['msg-content'], style: { opacity: 0, filter: 'opacity(0)', display: 'flex' } },
                react_1.default.createElement("div", { dangerouslySetInnerHTML: { __html: msg.content } }),
                react_1.default.createElement("div", null, "__"),
                react_1.default.createElement(icon_1.Pencil, null)));
        }
        else {
            if (msg.send_status !== 'rollback') {
                if (timeText) {
                    res.push(react_1.default.createElement("div", { key: 'time-text' + msg.id, className: style_module_less_1.default['time-bar'] }, dompurify_1.default.sanitize(timeText)));
                }
                if (eventText) {
                    res.push(react_1.default.createElement("div", { key: 'event-text' + msg.id, className: "".concat(style_module_less_1.default['event-bar'], " ").concat((contentType === 'transfer' || contentType === 'info_transfer' || contentType === 'info_offline_transfer') ? style_module_less_1.default['red'] : '') }, dompurify_1.default.sanitize(eventText)));
                }
            }
        }
        return res;
    }, [msg.type, msg.id, msg.content, msg.send_status, timeText, eventText]);
    var msgType = (0, react_1.useMemo)(function () {
        var _a, _b, _c;
        var contentType = msg.type;
        try {
            if ((msg === null || msg === void 0 ? void 0 : msg.content_raw) && ((_c = (_b = (_a = JSON.parse(msg.content_raw)) === null || _a === void 0 ? void 0 : _a.robotAnswer) === null || _b === void 0 ? void 0 : _b[0]) === null || _c === void 0 ? void 0 : _c.msgType) === 'db_answer') {
                contentType = 'echarts';
            }
        }
        catch (e) {
            //do nothing
        }
        return contentType;
    }, [msg.type, msg.content_raw]);
    //加载当前对应的消息类型
    var handleMessageComponent = (0, react_1.useCallback)(function () {
        var Component = MessageComponent[msgType];
        return Component ? react_1.default.createElement(Component, { msg: msg, trans_text: msg.translation, chatPlatform: chat.platform, smart_assistance_enabled: enabledSmartAssistance, real_time_translation: realTimeTranslation, onSelectSuggestion: onSelectSuggestion, robotBaseURL: robotBaseURL, kcsSdk: kcsSdk, area: area, openRecordCb: openRecordCb, reloadImageTimes: reloadImageTimes }) : null;
    }, [kcsSdk, chat.platform, enabledSmartAssistance, msg, msgType, onSelectSuggestion, realTimeTranslation]);
    var reEdit = (0, react_1.useCallback)(function () { return onReEdit === null || onReEdit === void 0 ? void 0 : onReEdit(msg.content, msg); }, [msg.content, msg, onReEdit]);
    var handleStatusIcon = (0, react_1.useCallback)(function () {
        var status = ('status_' + msg.send_status);
        var StatusComponent = IconComponent[status];
        return StatusComponent ? react_1.default.createElement(StatusComponent, { style: { fontSize: '16px' } }) : '';
    }, [msg.send_status]);
    var getMsgHeader = (0, react_1.useMemo)(function () {
        var _a, _b, _c;
        // 处理日期  如果发消息时日是当天  只显示时间，不显示日期
        var time;
        if ((0, moment_1.default)(msg.created_at).format('YYYY/MM/DD') === (0, moment_1.default)().format('YYYY/MM/DD')) {
            time = (0, moment_1.default)(msg.created_at).format('HH:mm:ss');
        }
        else {
            time = (0, moment_1.default)(msg.created_at).format('MM-DD HH:mm:ss');
        }
        if (msg.is_receive) {
            if (wechatSuffix || ((_a = msg.data) === null || _a === void 0 ? void 0 : _a.senderType)) {
                return (react_1.default.createElement(react_1.default.Fragment, null,
                    msg.sender_name || ((_b = msg.data) === null || _b === void 0 ? void 0 : _b.from),
                    react_1.default.createElement("span", { className: style_module_less_1.default['customer-wx-icon'] }, ((_c = msg.data) === null || _c === void 0 ? void 0 : _c.senderType) === 1 ? '@' + (msg.data.corpName || "企微") : '@微信'),
                    "\u00A0\u00A0",
                    time));
            }
            return msg.sender_name + ' ' + time;
        }
        else {
            return time + ' ' + msg.sender_name;
        }
    }, [msg.created_at, msg.is_receive, msg.sender_name, wechatSuffix]);
    var send_status_msg = (0, react_1.useMemo)(function () {
        if (msg.send_status === 'fail' && msg.respone) {
            return msg.respone;
        }
        else {
            var effectiveStatus = ['off_sending', 'arrive', 'off_arrive', 'fail', 'rollback'];
            if (msg.send_status && effectiveStatus.includes(msg.send_status)) {
                return t('page.im.log.' + msg.send_status);
            }
        }
        return '';
    }, [msg, t]);
    var _c = (0, react_1.useState)(''), selection = _c[0], setSelection = _c[1];
    var onMenuMouseUp = (0, react_1.useCallback)(function () {
        var _a, _b;
        var type = msg.type;
        if (window.getSelection && ['message', 'info', 'rich'].includes(type)) {
            var _selection = (_b = (_a = window.getSelection()) === null || _a === void 0 ? void 0 : _a.toString().replace(/^\s|\s$/g, '').substring(0, 20)) !== null && _b !== void 0 ? _b : '';
            setSelection(_selection);
        }
    }, [msg.type]);
    var popoverChildren = (0, react_1.useMemo)(function () {
        return react_1.default.createElement("div", { className: style_module_less_1.default['child-wrapper'], onMouseUp: onMenuMouseUp },
            react_1.default.createElement("div", { style: msg.is_receive && msgRecvColor ? msgRecvColor : msgColor || {}, className: "".concat(style_module_less_1.default['msg-content'], " ").concat(msg.log_type === 'internal' ? style_module_less_1.default['msg-internal'] : '') }, (allowUnHide && msg.message_display_status === 'hide' && !msgdisplayStatus) ? react_1.default.createElement("span", null,
                "\u3010",
                t('label.theMsgIsHidden'),
                "\u3011") : handleMessageComponent()),
            msgType === 'email' &&
                react_1.default.createElement("div", { className: (0, classnames_1.default)(style_module_less_1.default['email-send'], msg.is_receive ? style_module_less_1.default['left'] : '') }, t('emailMethod.sendFromEmail')));
    }, [handleMessageComponent, msg.log_type, msg.translation, onMenuMouseUp, msgdisplayStatus]);
    var knowledgeId = (0, react_1.useMemo)(function () {
        var _a, _b, _c;
        var content_raw = msg.content_raw;
        if (!content_raw) {
            return null;
        }
        try {
            var contentRawJson = JSON.parse(content_raw);
            return (_c = (_b = (_a = contentRawJson === null || contentRawJson === void 0 ? void 0 : contentRawJson.robotAnswer) === null || _a === void 0 ? void 0 : _a[0]) === null || _b === void 0 ? void 0 : _b.knowledgeResponse) === null || _c === void 0 ? void 0 : _c.knowledgeId;
        }
        catch (e) {
            return null;
        }
    }, [msg.content_raw]);
    // 选中聊天记录事件回调
    var imLogCheckChange = (0, react_1.useCallback)(function (e) {
        e.stopPropagation();
        if (!showCheckbox || !imLogCheckCb)
            return;
        imLogCheckCb(+msg.id, !isChecked);
    }, [imLogCheckCb, isChecked, showCheckbox]);
    var wrapperRef = (0, react_1.useRef)(null);
    return (react_1.default.createElement("div", { id: "im-log-".concat(msg.id), "data-message-id": msg.msg_id, className: (0, classnames_1.default)(showCheckbox ? style_module_less_1.default['pointer'] : '', (isChecked && showCheckbox) ? style_module_less_1.default['checked'] : ''), ref: wrapperRef, onClick: imLogCheckChange },
        react_1.default.createElement("div", { className: (0, classnames_1.default)(style_module_less_1.default['msg-item'], style_module_less_1.default['msg-' + msgType], msg.is_receive ? style_module_less_1.default['msg-recv'] : '', (chat.belong === 'mine' && msg.sensitive) ? style_module_less_1.default['msg-sensitive'] : '', showCheckbox ? style_module_less_1.default['pdl-16'] : '') },
            handleMsgPre(),
            isInfo &&
                react_1.default.createElement(react_1.default.Fragment, null,
                    showCheckbox &&
                        react_1.default.createElement(udesk_ui_1.Checkbox, { className: style_module_less_1.default['im-log-checkbox'], checked: isChecked }),
                    react_1.default.createElement("div", { className: style_module_less_1.default['customerName'] }, getMsgHeader),
                    ((_b = msg === null || msg === void 0 ? void 0 : msg.data) === null || _b === void 0 ? void 0 : _b.voice_url) && react_1.default.createElement(message_video_1.default, { msgItem: msg }),
                    react_1.default.createElement("div", { className: "".concat(style_module_less_1.default['msg-content-wrapper'], " ").concat(style_module_less_1.default['msg-content-wrapper-' + msgType], " ").concat('msg-content-wrapper-' + msgType, " ").concat(showCheckbox ? style_module_less_1.default['msg-content-wrapper-check'] : '') },
                        allowReedit ?
                            react_1.default.createElement("a", { onClick: reEdit, className: style_module_less_1.default['re-edit-box'] }, t('page.im.log.reEdit')) : null,
                        msg.message_display_status === 'hide' ? react_1.default.createElement("span", { className: "".concat(style_module_less_1.default['eye-invisible'], " ").concat(kcsSdk && (msg.message_display_status === 'hide') && msgdisplayStatus ? style_module_less_1.default['eye-invisible-kcs'] : '') },
                            react_1.default.createElement(icons_1.EyeInvisibleOutlined, null)) : null,
                        function () {
                            if (!msg.is_receive && msg.type !== 'email') {
                                if (msg.send_status && ((msg.is_wechat_fail && msg.send_status === 'fail'))) {
                                    return (react_1.default.createElement("a", { onClick: onReSend, className: "".concat(style_module_less_1.default['send-status-box'], " ").concat(style_module_less_1.default['wechat-msg'], " ").concat(style_module_less_1.default[msg.send_status]) },
                                        react_1.default.createElement(icon_1.Resend, null),
                                        react_1.default.createElement("span", { className: style_module_less_1.default['send-status-box-text'] }, send_status_msg)));
                                }
                                if (!web_message_display_status || msg.send_status === 'fail' || msg.send_status === 'off_sending' || (chat.platform !== 'web' && chat.platform !== 'api') || chat.belong === 'colleague' || msg.send_status === 'rollback') {
                                    return (react_1.default.createElement("a", { onClick: onReSend, className: "".concat(style_module_less_1.default['send-status-box'], " ").concat(msg.send_status ? style_module_less_1.default[msg.send_status] : '') }, msg.send_status === 'fail' ?
                                        react_1.default.createElement(icon_1.Resend, null) :
                                        react_1.default.createElement(react_1.default.Fragment, null,
                                            handleStatusIcon(),
                                            react_1.default.createElement("span", { className: style_module_less_1.default['send-status-box-text'] }, send_status_msg))));
                                }
                            }
                        }(),
                        !msg.is_receive && web_message_display_status && msg.send_status !== 'fail' && (chat.platform === 'web' || chat.platform === 'api') && chat.belong !== 'colleague' && msg.type !== 'email' &&
                            react_1.default.createElement("span", { className: "".concat(style_module_less_1.default['send-status-box'], " ").concat(style_module_less_1.default['read-status'], " ").concat((!msg.read_status || (msg.send_status === 'off_sending')) ? "".concat(style_module_less_1.default['unread'], " unread") : "".concat(style_module_less_1.default['read'], " read")) }, (!msg.read_status || (msg.send_status === 'off_sending')) ? react_1.default.createElement(icon_1.Unread, null) : react_1.default.createElement(icon_1.Read, null)),
                        function () {
                            if (!msg.is_receive || msg.send_status !== 'rollback')
                                return null;
                            return (react_1.default.createElement("span", { className: "".concat(style_module_less_1.default['send-status-box'], " ").concat(style_module_less_1.default['rollback']), style: { margin: kcsSdk ? '1px 0 0 26px' : '1px 0 0 6px' } },
                                handleStatusIcon(),
                                react_1.default.createElement("span", { className: style_module_less_1.default['send-status-box-text'] }, t('page.im.log.rollback'))));
                        }(),
                        react_1.default.createElement(menu_1.default, { allowAddToKM: allowAddToKM, msgdisplayStatus: msgdisplayStatus, hideEnable: hideEnable, refEnable: refEnable, msg: msg, chatPlatform: chat.platform, currentUser: currentUser, allowRecall: allowRecall, allowAddToCustomerInfo: allowAddToCustomerInfo, allowAddToRobotKM: allowAddToRobotKM, allowSearchImRecord: allowSearchImRecord, allowVoiceToText: allowVoiceToText, allowUnHide: allowUnHide, onAddToRobotKM: onAddToRobotKM, onVoiceToText: onVoiceToText, onSelectText: onSelectText, onAddToKM: onAddToKM, onHide: onHide, onRef: onRef, onCheck: onCheck, onUnHide: onUnHide, onRecall: onRecall, onSelectEmail: onSelectEmail, onSelectTel: onSelectTel, selection: selection }, popoverChildren)),
                    knowledgeId &&
                        react_1.default.createElement("div", { className: style_module_less_1.default['flex-end'] },
                            react_1.default.createElement(knowledge_graph_1.default, { knowledgeId: knowledgeId }))),
            msg.send_status === 'rollback' && timeText &&
                react_1.default.createElement("div", { className: style_module_less_1.default['time-bar'] }, dompurify_1.default.sanitize(timeText)),
            msg.send_status === 'rollback' && eventText &&
                react_1.default.createElement("div", { className: style_module_less_1.default['event-bar'] }, dompurify_1.default.sanitize(eventText)))));
};
exports.default = ImLog;
var ajax_1 = require("./ajax");
Object.defineProperty(exports, "axiosInstance", { enumerable: true, get: function () { return ajax_1.axiosInstance; } });
