"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _popover = _interopRequireDefault(require("@udesk-webapp/popover"));

var _excluded = ["onChange", "t"],
    _excluded2 = ["value", "prefix", "controlClassName", "controlStyle", "placeholder", "isOpen", "popContentStyle", "isBlank", "allowBlank", "isNotBlank", "allowNotBlank"],
    _excluded3 = ["closePopContent"],
    _excluded4 = ["onChange", "allowBlank", "allowNotBlank", "t"];

var TextDropdown = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(TextDropdown, _Component);

  function TextDropdown(props) {
    return _Component.call(this, props) || this;
  }

  var _proto = TextDropdown.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        _onChange = _this$props.onChange,
        t = _this$props.t,
        props = (0, _objectWithoutPropertiesLoose2["default"])(_this$props, _excluded);
    return /*#__PURE__*/_react["default"].createElement(_popover["default"], (0, _extends2["default"])({}, props, {
      components: {
        Control: function Control(_ref) {
          var value = _ref.value,
              prefix = _ref.prefix,
              controlClassName = _ref.controlClassName,
              controlStyle = _ref.controlStyle,
              placeholder = _ref.placeholder,
              isOpen = _ref.isOpen,
              popContentStyle = _ref.popContentStyle,
              isBlank = _ref.isBlank,
              allowBlank = _ref.allowBlank,
              isNotBlank = _ref.isNotBlank,
              allowNotBlank = _ref.allowNotBlank,
              props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded2);
          var title = value || placeholder;

          if (allowBlank && isBlank && allowNotBlank && isNotBlank) {
            title = placeholder;
          }

          if (allowBlank && isBlank && !isNotBlank) {
            title = t('filter.operator.blank');
          }

          if (allowNotBlank && isNotBlank && !isBlank) {
            title = t('filter.operator.present');
          }

          return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
            className: controlClassName,
            style: controlStyle
          }, props), /*#__PURE__*/_react["default"].createElement("span", null, prefix, " " + title), /*#__PURE__*/_react["default"].createElement("i", {
            className: "icon icon-caret-" + (isOpen ? 'up' : 'down')
          }));
        },
        PopContent: function PopContent(_ref2) {
          var closePopContent = _ref2.closePopContent,
              props = (0, _objectWithoutPropertiesLoose2["default"])(_ref2, _excluded3);
          return /*#__PURE__*/_react["default"].createElement(_PopContent, (0, _extends2["default"])({}, props, {
            t: t,
            onChange: function onChange(v, isBlank, isNotBlank) {
              _onChange(v, isBlank, isNotBlank);

              closePopContent();
            }
          }));
        }
      }
    }));
  };

  return TextDropdown;
}(_react.Component);

var _PopContent = /*#__PURE__*/function (_Component2) {
  (0, _inheritsLoose2["default"])(_PopContent, _Component2);

  function _PopContent() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component2.call.apply(_Component2, [this].concat(args)) || this;
    _this._ref = /*#__PURE__*/(0, _react.createRef)();
    _this.state = {
      value: _this.props.value,
      isBlank: _this.props.isBlank,
      isNotBlank: _this.props.isNotBlank,
      changeFromState: false
    };

    _this.onInputKeyDown = function (e) {
      if (e.key === 'Enter') {
        _this.props.onChange(e.target.value);
      }
    };

    return _this;
  }

  _PopContent.getDerivedStateFromProps = function getDerivedStateFromProps(props, state) {
    if (state.changeFromState) {
      return {
        value: state.value,
        isBlank: state.isBlank,
        isNotBlank: state.isNotBlank,
        changeFromState: false
      };
    } else if (props.value !== state.value || props.isBlank !== state.isBlank || props.isNotBlank !== state.isNotBlank) {
      return {
        value: props.value,
        isBlank: props.isBlank,
        isNotBlank: props.isNotBlank,
        changeFromState: false
      };
    }

    return null;
  };

  var _proto2 = _PopContent.prototype;

  _proto2.render = function render() {
    var _this2 = this;

    var _this$props2 = this.props,
        onChange = _this$props2.onChange,
        allowBlank = _this$props2.allowBlank,
        allowNotBlank = _this$props2.allowNotBlank,
        t = _this$props2.t,
        props = (0, _objectWithoutPropertiesLoose2["default"])(_this$props2, _excluded4);
    var _this$state = this.state,
        isBlank = _this$state.isBlank,
        isNotBlank = _this$state.isNotBlank,
        value = _this$state.value;
    return /*#__PURE__*/_react["default"].createElement("div", {
      style: props.popContentStyle
    }, /*#__PURE__*/_react["default"].createElement("div", {
      className: "form-group"
    }, /*#__PURE__*/_react["default"].createElement("input", {
      className: "form-control",
      value: value,
      ref: this._ref,
      onKeyDown: this.onInputKeyDown,
      disabled: allowBlank && isBlank || allowNotBlank && isNotBlank ? true : false,
      onChange: function onChange(e) {
        // if (allowBlank) {
        //     this.setState({ value: e.target.value, isBlank: !!isBlank, changeFromState: true });
        // } else {
        //     this.setState({ value: e.target.value, changeFromState: true });
        // }
        if (allowBlank && allowNotBlank) {
          _this2.setState({
            value: e.target.value,
            isBlank: !!isBlank,
            isNotBlank: !!isNotBlank,
            changeFromState: true
          });
        } else if (allowBlank && !allowNotBlank) {
          _this2.setState({
            value: e.target.value,
            isBlank: !!isBlank,
            changeFromState: true
          });
        } else if (allowNotBlank && !allowBlank) {
          _this2.setState({
            value: e.target.value,
            isNotBlank: !!isNotBlank,
            changeFromState: true
          });
        } else {
          _this2.setState({
            value: e.target.value,
            changeFromState: true
          });
        }
      }
    })), allowBlank ? /*#__PURE__*/_react["default"].createElement("div", {
      className: "checkbox"
    }, /*#__PURE__*/_react["default"].createElement("label", null, /*#__PURE__*/_react["default"].createElement("input", {
      type: "checkbox",
      checked: isBlank,
      onChange: function onChange(e) {
        return _this2.setState({
          isBlank: e.target.checked,
          changeFromState: true
        });
      }
    }), " ", t('filter.operator.blank'))) : void 0, allowNotBlank ? /*#__PURE__*/_react["default"].createElement("div", {
      className: "checkbox"
    }, /*#__PURE__*/_react["default"].createElement("label", null, /*#__PURE__*/_react["default"].createElement("input", {
      type: "checkbox",
      checked: isNotBlank,
      onChange: function onChange(e) {
        return _this2.setState({
          isNotBlank: e.target.checked,
          changeFromState: true
        });
      }
    }), t('filter.operator.present'))) : void 0, /*#__PURE__*/_react["default"].createElement("button", {
      type: "button",
      onClick: function onClick() {
        return onChange(value, isBlank, isNotBlank);
      },
      className: "btn btn-default"
    }, t('label.confirm')), /*#__PURE__*/_react["default"].createElement("button", {
      type: "button",
      className: "btn btn-link",
      onClick: function onClick() {
        // if (allowBlank) {
        //     this.setState({ 
        //         value: '', 
        //         isBlank: false, 
        //         changeFromState: true 
        //     });
        //     onChange('', false);
        // } else {
        //     this.setState({ value: '', changeFromState: true });
        //     onChange('');
        // }
        if (allowBlank && allowNotBlank) {
          _this2.setState({
            value: '',
            isBlank: false,
            isNotBlank: false,
            changeFromState: true
          });

          onChange('', false, false);
          return;
        }

        if (allowBlank) {
          _this2.setState({
            value: '',
            isBlank: false,
            changeFromState: true
          });

          onChange('', false);
          return;
        }

        if (allowNotBlank) {
          _this2.setState({
            value: '',
            isNotBlank: false,
            changeFromState: true
          });

          onChange('', undefined, false);
          return;
        }

        _this2.setState({
          value: '',
          changeFromState: true
        });

        onChange('');
      }
    }, t('label.clear')));
  };

  _proto2.componentDidMount = function componentDidMount() {
    this._ref.current.focus();
  };

  return _PopContent;
}(_react.Component);

_PopContent.propTypes = {
  value: _propTypes["default"].string,
  onChange: _propTypes["default"].func
};
TextDropdown.propTypes = {
  t: _propTypes["default"].func,
  controlClassName: _propTypes["default"].string,
  onChange: _propTypes["default"].func,
  value: _propTypes["default"].string,

  /**
   * 是否显示“为空“选框
   */
  allowBlank: _propTypes["default"].bool,

  /**
   * “为空“选框的选中状态
   */
  isBlank: _propTypes["default"].bool,
  allowNotBlank: _propTypes["default"].bool,
  //是否显示“不为空“选框
  isNotBlank: _propTypes["default"].bool //"不为空"选框的选中状态

};
TextDropdown.defaultProps = {
  className: 'select-with-search',
  controlClassName: 'align-justify form-control',
  value: '',
  popContentStyle: {
    padding: '15px',
    minWidth: '200px'
  }
};
var _default = TextDropdown;
exports["default"] = _default;
