"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _utils = require("@udesk-webapp/utils");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var Index = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(Index, _Component);

  function Index(props) {
    return _Component.call(this, props) || this;
  }

  var _proto = Index.prototype;

  _proto.shouldMask = function shouldMask() {
    var _this$props = this.props,
        isMask = _this$props.isMask,
        customer = _this$props.customer,
        roleCan = _this$props.roleCan,
        currentUser = _this$props.currentUser;

    if (typeof isMask === 'boolean') {
      return isMask;
    }

    try {
      if (typeof isMask === 'function') {
        return isMask();
      }
    } catch (e) {
      console.error(e);
    }

    return !(0, _utils.canShowCustomerPhoneNumber)(currentUser, customer, roleCan);
  };

  _proto.render = function render() {
    var _this$props2 = this.props,
        phoneIcon = _this$props2.phoneIcon,
        smsIcon = _this$props2.smsIcon,
        number = _this$props2.number,
        onPhoneClick = _this$props2.onPhoneClick,
        onSmsClick = _this$props2.onSmsClick;
    var finalNumber = this.shouldMask() ? (0, _utils.maskPhoneNumber)(number) : number;

    if (phoneIcon && smsIcon) {
      return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, /*#__PURE__*/_react["default"].createElement("a", {
        href: "javascript:",
        onClick: function onClick(e) {
          return onPhoneClick(finalNumber, number, e);
        }
      }, finalNumber, /*#__PURE__*/_react["default"].createElement("i", {
        className: "icon icon-phone"
      })), /*#__PURE__*/_react["default"].createElement("i", {
        className: "icon icon-comment",
        onClick: function onClick(e) {
          return onSmsClick(finalNumber, number, e);
        }
      }));
    } else if (phoneIcon) {
      return /*#__PURE__*/_react["default"].createElement("a", {
        href: "javascript:",
        onClick: function onClick(e) {
          return onPhoneClick(finalNumber, number, e);
        }
      }, finalNumber, " ", /*#__PURE__*/_react["default"].createElement("i", {
        className: "icon icon-phone"
      }));
    } else if (smsIcon) {
      return /*#__PURE__*/_react["default"].createElement("a", {
        href: "javascript:",
        onClick: function onClick(e) {
          return onSmsClick(finalNumber, number, e);
        }
      }, finalNumber, " ", /*#__PURE__*/_react["default"].createElement("i", {
        className: "icon icon-comment"
      }));
    } else {
      return /*#__PURE__*/_react["default"].createElement(_react.Fragment, null, finalNumber);
    }
  };

  return Index;
}(_react.Component); //@formatter:off


Index.propTypes = {
  /**
   * 要显示的电话号码
   */
  number: _propTypes["default"].string,

  /**
   * 电话号码所属客户
   */
  customer: _propTypes["default"].shape({
    owner_id: _propTypes["default"].number,
    owner_group_id: _propTypes["default"].number
  }),
  phoneIcon: _propTypes["default"].bool,
  smsIcon: _propTypes["default"].bool,
  onPhoneClick: _propTypes["default"].func,
  onSmsClick: _propTypes["default"].func,
  currentUser: _propTypes["default"].shape({
    id: _propTypes["default"].number,
    user_groups: _propTypes["default"].arrayOf(_propTypes["default"].shape({
      id: _propTypes["default"].number
    }))
  }),
  roleCan: _propTypes["default"].shape({
    customer_show_cellphone_all: _propTypes["default"].bool,
    customer_show_cellphone_group: _propTypes["default"].bool,
    customer_show_cellphone_personal: _propTypes["default"].bool
  }),
  isMask: _propTypes["default"].oneOfType([_propTypes["default"].bool, _propTypes["default"].func])
}; //@formatter:on

var _default = Index;
exports["default"] = _default;