"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react2 = require("@emotion/react");

var DateRangePicker = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(DateRangePicker, _Component);

  function DateRangePicker(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.dateRangePicker = null;
    return _this;
  }

  var _proto = DateRangePicker.prototype;

  _proto.attachPickerEvents = function attachPickerEvents() {
    var self = this;
    this.dateRangePicker.off('apply.daterangepicker').on('apply.daterangepicker', function (ev, picker) {
      var applyAction = self.props.applyAction;
      var start = picker.startDate;
      var end = picker.endDate;

      if (applyAction != null) {
        if (typeof applyAction === 'function') {
          applyAction(start.toDate(), end.toDate());
        }
      }
    });
    this.dateRangePicker.off('cancel.daterangepicker').on('cancel.daterangepicker', function (ev, picker) {
      var _self$props = self.props,
          applyAction = _self$props.applyAction,
          enableClear = _self$props.enableClear;

      if (applyAction != null && enableClear) {
        if (typeof applyAction === 'function') {
          applyAction(null, null);
        }
      }
    });
    var _this$props = this.props,
        onShowCalendar = _this$props.onShowCalendar,
        onHideCalendar = _this$props.onHideCalendar,
        onShow = _this$props.onShow,
        onHide = _this$props.onHide;

    if ('function' === typeof onShowCalendar) {
      this.dateRangePicker.off('showCalendar.daterangepicker').on('showCalendar.daterangepicker', onShowCalendar);
    }

    if ('function' === typeof onHideCalendar) {
      this.dateRangePicker.off('hideCalendar.daterangepicker').on('hideCalendar.daterangepicker', onHideCalendar);
    }

    if ('function' === typeof onShow) {
      this.dateRangePicker.off('show.daterangepicker').on('show.daterangepicker', onShow);
    }

    if ('function' === typeof onHide) {
      this.dateRangePicker.off('hide.daterangepicker').on('hide.daterangepicker', onHide);
    }
  };

  _proto.clearValue = function clearValue() {
    var applyAction = this.props.applyAction;

    if (typeof applyAction === 'function') {
      applyAction(null, null);
    }
  };

  _proto.setDatePickerData = function setDatePickerData(props) {
    var start = props.start,
        end = props.end;
    this.dateRangePicker.data('daterangepicker').setStartDate(start);
    this.dateRangePicker.data('daterangepicker').setEndDate(end);
  };

  _proto.componentDidMount = function componentDidMount() {
    this.initDateRangePicker();
  };

  _proto.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
    this.setDatePickerData(nextProps);
    return true;
  };

  _proto.componentDidUpdate = function componentDidUpdate(prevProps, prevState) {
    if (prevProps.singleDatePicker !== this.props.singleDatePicker || prevProps.timePicker !== this.props.timePicker) {
      this.removeDateRangePicker();
      this.initDateRangePicker();
    }
  };

  _proto.initDateRangePicker = function initDateRangePicker() {
    var _this2 = this;

    this.dateRangePicker = $(this.dateRangePickerElement);
    this.dateRangePicker.on('click', '.icon-close-circle', function (e) {
      e.stopPropagation();

      _this2.clearValue();
    });
    this.dateRangePicker.daterangepicker(this.getOptions(), this.handleCallback);
    this.attachPickerEvents();
    this.setDatePickerData(this.props);

    if (typeof this.props.onCreated === 'function') {
      this.props.onCreated();
    }
  };

  _proto.removeDateRangePicker = function removeDateRangePicker() {
    var dateRangePicker = this.dateRangePicker.data('daterangepicker');

    if (dateRangePicker != null) {
      this.dateRangePicker.off('apply.daterangepicker');
      this.dateRangePicker.off('cancel.daterangepicker');
      this.dateRangePicker.off('showCalendar.daterangepicker');
      this.dateRangePicker.off('hideCalendar.daterangepicker');
      this.dateRangePicker.off('show.daterangepicker');
      this.dateRangePicker.off('hide.daterangepicker');

      if (typeof dateRangePicker.remove === 'function') {
        dateRangePicker.remove();
      }
    }

    this.dateRangePicker.off();
    this.dateRangePicker = null;
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.removeDateRangePicker();
    this.dateRangePickerElement = null;
  };

  _proto.getOptions = function getOptions() {
    var _this$props2 = this.props,
        start = _this$props2.start,
        end = _this$props2.end,
        serverFormat = _this$props2.serverFormat,
        minDate = _this$props2.minDate,
        maxDate = _this$props2.maxDate,
        alwaysShowCalendars = _this$props2.alwaysShowCalendars,
        autoUpdateInput = _this$props2.autoUpdateInput,
        autoApply = _this$props2.autoApply,
        applyLabel = _this$props2.applyLabel,
        cancelLabel = _this$props2.cancelLabel,
        customRangeLabel = _this$props2.customRangeLabel,
        fromLabel = _this$props2.fromLabel,
        toLabel = _this$props2.toLabel,
        format = _this$props2.format,
        firstDay = _this$props2.firstDay,
        daysOfWeek = _this$props2.daysOfWeek,
        monthNames = _this$props2.monthNames,
        timePicker = _this$props2.timePicker,
        buttonClasses = _this$props2.buttonClasses,
        applyClass = _this$props2.applyClass,
        cancelClass = _this$props2.cancelClass,
        separator = _this$props2.separator,
        singleDatePicker = _this$props2.singleDatePicker,
        drops = _this$props2.drops,
        opens = _this$props2.opens,
        timePicker24Hour = _this$props2.timePicker24Hour,
        timePickerSeconds = _this$props2.timePickerSeconds,
        timePickerIncrement = _this$props2.timePickerIncrement,
        showWeekNumbers = _this$props2.showWeekNumbers,
        showDropdowns = _this$props2.showDropdowns,
        linkedCalendars = _this$props2.linkedCalendars,
        dateLimit = _this$props2.dateLimit,
        parentEl = _this$props2.parentEl,
        enableClear = _this$props2.enableClear,
        _this$props2$t = _this$props2.t,
        t = _this$props2$t === void 0 ? function (resId) {
      return resId;
    } : _this$props2$t;

    if (!daysOfWeek || daysOfWeek.length < 1) {
      daysOfWeek = [t('date_range_picker.days_of_week.sun'), t('date_range_picker.days_of_week.mon'), t('date_range_picker.days_of_week.tu'), t('date_range_picker.days_of_week.we'), t('date_range_picker.days_of_week.th'), t('date_range_picker.days_of_week.fr'), t('date_range_picker.days_of_week.sa')];
    }

    if (!monthNames || monthNames.length < 1) {
      monthNames = [t('date_range_picker.month_names.jan'), t('date_range_picker.month_names.feb'), t('date_range_picker.month_names.mar'), t('date_range_picker.month_names.apr'), t('date_range_picker.month_names.may'), t('date_range_picker.month_names.jun'), t('date_range_picker.month_names.jul'), t('date_range_picker.month_names.aug'), t('date_range_picker.month_names.sep'), t('date_range_picker.month_names.oct'), t('date_range_picker.month_names.nov'), t('date_range_picker.month_names.dec')];
    }

    var options = {
      alwaysShowCalendars: alwaysShowCalendars,
      autoUpdateInput: autoUpdateInput,
      autoApply: autoApply,
      locale: {
        applyLabel: applyLabel || t('date_range_picker.apply_label'),
        cancelLabel: cancelLabel || (enableClear ? t('date_range_picker.empty_label') : t('date_range_picker.cancel_label')),
        customRangeLabel: customRangeLabel || t('date_range_picker.custom_range_label'),
        fromLabel: fromLabel || t('date_range_picker.from_label'),
        toLabel: toLabel || t('date_range_picker.to_label'),
        format: format,
        firstDay: firstDay,
        daysOfWeek: daysOfWeek,
        monthNames: monthNames
      },
      startDate: start,
      endDate: end,
      minDate: minDate,
      maxDate: maxDate,
      timePicker: timePicker,
      buttonClasses: buttonClasses,
      applyClass: applyClass,
      cancelClass: cancelClass,
      separator: separator,
      singleDatePicker: singleDatePicker,
      drops: drops,
      opens: opens,
      timePicker24Hour: timePicker24Hour,
      timePickerSeconds: timePickerSeconds,
      timePickerIncrement: timePickerIncrement,
      showWeekNumbers: showWeekNumbers,
      showDropdowns: showDropdowns,
      linkedCalendars: linkedCalendars,
      dateLimit: dateLimit,
      parentEl: parentEl
    };

    if (!singleDatePicker) {
      var ranges = this.props.ranges;

      if (ranges === null) {
        var _ranges;

        ranges = (_ranges = {}, _ranges[t('date_range_picker.ranges.today')] = [moment().startOf('day'), moment().endOf('day')], _ranges[t('date_range_picker.ranges.yesterday')] = [moment().subtract(1, 'days').startOf('day'), moment().subtract(1, 'days').endOf('day')], _ranges[t('date_range_picker.ranges.recently_seven_day')] = [moment().subtract(6, 'days').startOf('day'), moment().endOf('day')], _ranges[t('date_range_picker.ranges.recently_thirty_day')] = [moment().subtract(29, 'days').startOf('day'), moment().endOf('day')], _ranges[t('date_range_picker.ranges.this_month')] = [moment().startOf('month').startOf('day'), moment().endOf('month').endOf('day')], _ranges[t('date_range_picker.ranges.last_month')] = [moment().subtract(1, 'month').startOf('month').startOf('day'), moment().subtract(1, 'month').endOf('month').endOf('day')], _ranges[t('date_range_picker.ranges.this_year')] = [moment().startOf('year').startOf('day'), moment().endOf('year').endOf('day')], _ranges[t('date_range_picker.ranges.last_year')] = [moment().subtract(1, 'year').startOf('year').startOf('day'), moment().subtract(1, 'year').endOf('year').endOf('day')], _ranges[t('date_range_picker.ranges.recently_year')] = [moment().subtract(1, 'year'), moment()], _ranges);
      }

      options.ranges = ranges;
    }

    options = Object.assign({}, options);
    return options;
  };

  _proto.render = function render() {
    var _this3 = this;

    var _this$props3 = this.props,
        className = _this$props3.className,
        format = _this$props3.format,
        start = _this$props3.start,
        end = _this$props3.end,
        separator = _this$props3.separator,
        singleDatePicker = _this$props3.singleDatePicker,
        calendarIcon = _this$props3.calendarIcon,
        enableClear = _this$props3.enableClear;
    var momentStartDate;
    var momentEndDate;
    var startDate = '';
    var endDate = '';

    if (start) {
      if (typeof start === 'string') {
        momentStartDate = moment(start, format);
      } else {
        momentStartDate = moment(start);
      }

      startDate = momentStartDate.isValid() ? momentStartDate.format(format) : undefined;
    }

    if (end) {
      if (typeof end === 'string') {
        momentEndDate = moment(end, format);
      } else {
        momentEndDate = moment(end);
      }

      endDate = momentEndDate.isValid() ? momentEndDate.format(format) : undefined;
    }

    var rangeText = '';

    if (singleDatePicker) {
      if (startDate) {
        rangeText = startDate;
      }
    } else {
      if (startDate || endDate) {
        rangeText = [startDate, endDate].join(separator);
      }
    }

    return (0, _react2.jsx)("div", {
      ref: function ref(dateRangePickerElement) {
        return _this3.dateRangePickerElement = dateRangePickerElement;
      },
      className: 'date-range-picker flex-layout ' + className
    }, (0, _react2.jsx)("span", {
      className: "flex-1"
    }, rangeText), enableClear && rangeText && (0, _react2.jsx)("i", {
      className: "icon icon-close-circle",
      style: {
        marginLeft: '5px',
        cursor: 'pointer'
      }
    }), calendarIcon && (0, _react2.jsx)("i", {
      className: "icon icon-calendar",
      style: {
        marginLeft: '5px'
      }
    }));
  };

  return DateRangePicker;
}(_react.Component);

DateRangePicker.propTypes = {
  t: _propTypes["default"].func,
  calendarIcon: _propTypes["default"].bool,
  start: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].instanceOf(Date)]),
  end: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].instanceOf(Date)]),
  onShowCalendar: _propTypes["default"].func,
  onHideCalendar: _propTypes["default"].func,
  onShow: _propTypes["default"].func,
  onHide: _propTypes["default"].func
};
DateRangePicker.defaultProps = {
  start: undefined,
  end: undefined,
  className: 'form-control input-sm',
  minDate: undefined,
  maxDate: undefined,
  timePicker: false,
  timePicker24Hour: true,
  timePickerSeconds: false,
  timePickerIncrement: 1,
  showWeekNumbers: false,
  showDropdowns: false,
  linkedCalendars: false,
  datelimit: false,
  parentEl: 'body',
  format: 'YYYY-MM-DD',
  serverFormat: 'YYYY-MM-DD',
  separator: ' - ',
  singleDatePicker: false,
  placeholder: null,
  buttonClasses: ['btn', 'btn-sm'],
  applyClass: 'btn-success',
  cancelClass: 'btn-default',
  drops: 'down',
  opens: 'right',
  daysOfWeek: [],
  monthNames: [],
  removeDropdownOnDestroy: false,
  cancelLabel: '',
  applyLabel: '',
  customRangeLabel: '',
  fromLabel: '',
  toLabel: '',
  autoUpdateInput: false,
  autoApply: false,
  alwaysShowCalendars: false,
  firstDay: 0,
  ranges: null,
  applyAction: null,
  languageCode: 'zh-cn',
  enableClear: false,
  onCreated: undefined
};
var _default = DateRangePicker;
exports["default"] = _default;