"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _filter = _interopRequireDefault(require("lodash-es/filter"));

var _find = _interopRequireDefault(require("lodash-es/find"));

var _forEach = _interopRequireDefault(require("lodash-es/forEach"));

var _includes = _interopRequireDefault(require("lodash-es/includes"));

var _isArray = _interopRequireDefault(require("lodash-es/isArray"));

var _isEmpty = _interopRequireDefault(require("lodash-es/isEmpty"));

var _map = _interopRequireDefault(require("lodash-es/map"));

var _some = _interopRequireDefault(require("lodash-es/some"));

var _startsWith = _interopRequireDefault(require("lodash-es/startsWith"));

var _uniq = _interopRequireDefault(require("lodash-es/uniq"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _popover = _interopRequireDefault(require("@udesk-webapp/popover"));

var _IndeterminateCheckbox = _interopRequireDefault(require("./IndeterminateCheckbox"));

var _excluded = ["t", "value"],
    _excluded2 = ["prefix", "value", "controlClassName", "isOpen", "placeholder", "popContentStyle", "options"],
    _excluded3 = ["options"],
    _excluded4 = ["content", "style"];

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var ChainedSelect = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(ChainedSelect, _Component);

  function ChainedSelect(props) {
    var _this;

    _this = _Component.call(this, props) || this;

    _this.onChildNodeChange = function (childOptionValue, isChecked, checkedIds, uncheckedIds, originChangedNodeId) {
      var _this$props = _this.props,
          _this$props$value = _this$props.value,
          value = _this$props$value === void 0 ? [] : _this$props$value,
          onChange = _this$props.onChange;
      var finalValue = [].concat(value, checkedIds).filter(function (i) {
        return !(0, _includes["default"])(uncheckedIds, i);
      }).filter(function (i) {
        return i === originChangedNodeId || !(0, _startsWith["default"])(i, originChangedNodeId + ',');
      }); //过滤掉当前节点的所有子节点

      finalValue = (0, _uniq["default"])(finalValue);
      onChange(finalValue);
    };

    _this.saveScrollTop = function (e) {
      _this._scrollTop = e.target.scrollTop;
    };

    _this.state = {
      openedNode: []
    };
    _this._openedNode = [];
    _this._scrollTop = 0;
    return _this;
  }

  var _proto = ChainedSelect.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props2 = this.props,
        t = _this$props2.t,
        _this$props2$value = _this$props2.value,
        value = _this$props2$value === void 0 ? [] : _this$props2$value,
        props = (0, _objectWithoutPropertiesLoose2["default"])(_this$props2, _excluded);
    return /*#__PURE__*/_react["default"].createElement(_popover["default"], (0, _extends2["default"])({}, props, {
      value: value,
      components: {
        Control: function Control(_ref) {
          var prefix = _ref.prefix,
              _ref$value = _ref.value,
              value = _ref$value === void 0 ? [] : _ref$value,
              controlClassName = _ref.controlClassName,
              isOpen = _ref.isOpen,
              placeholder = _ref.placeholder,
              popContentStyle = _ref.popContentStyle,
              options = _ref.options,
              props = (0, _objectWithoutPropertiesLoose2["default"])(_ref, _excluded2);
          return /*#__PURE__*/_react["default"].createElement("div", (0, _extends2["default"])({
            className: controlClassName
          }, props), /*#__PURE__*/_react["default"].createElement("span", null, prefix, " ", (0, _isArray["default"])(value) && !(0, _isEmpty["default"])(value) ? t('label.selected') : placeholder), /*#__PURE__*/_react["default"].createElement("i", {
            className: "icon icon-caret-" + (isOpen ? 'up' : 'down')
          }));
        },
        PopContent: function PopContent(_ref2) {
          var options = _ref2.options,
              props = (0, _objectWithoutPropertiesLoose2["default"])(_ref2, _excluded3);
          return /*#__PURE__*/_react["default"].createElement(NodeList, (0, _extends2["default"])({
            content: (0, _map["default"])(options, function (option) {
              return {
                id: option.value,
                title: option.title,
                subs: option.subs,
                checked: (0, _includes["default"])(value, option.value)
              };
            })
          }, props, {
            openedNode: _this2._openedNode,
            onNodeOpen: function onNodeOpen(node) {
              return _this2._openedNode.push(node);
            },
            onNodeClose: function onNodeClose(node) {
              return _this2._openedNode = (0, _filter["default"])(_this2._openedNode, function (i) {
                return i !== node;
              });
            },
            style: {
              'minWidth': '100%',
              whiteSpace: 'nowrap',
              padding: '5px 10px 0',
              maxHeight: '330px',
              overflow: 'auto'
            },
            value: value,
            onChildNodeChange: _this2.onChildNodeChange,
            onScroll: _this2.saveScrollTop,
            scrollTop: _this2._scrollTop
          }));
        }
      }
    }));
  };

  return ChainedSelect;
}(_react.Component);

var Node = /*#__PURE__*/function (_Component2) {
  (0, _inheritsLoose2["default"])(Node, _Component2);

  function Node(props) {
    var _this3;

    _this3 = _Component2.call(this, props) || this;

    _this3.onChildNodeChange = function (childId, isChecked, checkedIds, uncheckedIds, originChangedNodeId) {
      var subs = _this3.state.subs;
      var id = _this3.props.id;
      (0, _find["default"])(subs, {
        id: childId
      }).checked = isChecked;
      var checkedSubs = [];
      var uncheckedSubs = [];
      (0, _forEach["default"])(subs, function (i) {
        if (i.checked) {
          checkedSubs.push(i.id);
        } else {
          uncheckedSubs.push(i.id);
        }
      });

      if (uncheckedSubs.length === 0) {
        //如果子节点全部选中，则选中当前节点，并删除所有子节点
        _this3.props.onChildNodeChange(id, true, [].concat(checkedIds, [id]), [].concat(uncheckedIds, checkedSubs), originChangedNodeId);
      } else if (checkedSubs.length === 0) {
        //如果子节点全部未选中，则删除当前节点
        _this3.props.onChildNodeChange(id, false, [].concat(checkedIds), [].concat(uncheckedIds, [id]), originChangedNodeId);
      } else {
        _this3.props.onChildNodeChange(id, false, [].concat(checkedIds, checkedSubs), [].concat(uncheckedIds, [id], uncheckedSubs), originChangedNodeId);
      }
    };

    var _id = props.id,
        value = props.value,
        checked = props.checked;
    _this3.state = {
      isOpen: (0, _includes["default"])(props.openedNode, _id),
      subs: (0, _map["default"])(props.subs, function (child) {
        var childId = _id + ',' + child.value;
        return {
          id: childId,
          title: child.title,
          checked: checked || (0, _includes["default"])(value, childId),
          subs: child.subs
        };
      })
    };
    return _this3;
  }

  var _proto2 = Node.prototype;

  _proto2.render = function render() {
    var _this4 = this;

    var _this$props3 = this.props,
        checked = _this$props3.checked,
        title = _this$props3.title,
        id = _this$props3.id,
        content = _this$props3.content,
        onChange = _this$props3.onChange,
        value = _this$props3.value,
        onNodeOpen = _this$props3.onNodeOpen,
        onNodeClose = _this$props3.onNodeClose,
        openedNode = _this$props3.openedNode,
        onChildNodeChange = _this$props3.onChildNodeChange;
    var _this$state = this.state,
        isOpen = _this$state.isOpen,
        subs = _this$state.subs;
    var nodeStyle = {};

    if ((0, _isEmpty["default"])(subs)) {
      nodeStyle.paddingLeft = '13px';
    }

    return /*#__PURE__*/_react["default"].createElement("div", null, /*#__PURE__*/_react["default"].createElement("div", {
      style: nodeStyle
    }, function () {
      if (!(0, _isEmpty["default"])(subs)) {
        return /*#__PURE__*/_react["default"].createElement("i", {
          className: "icon icon-caret-" + (isOpen ? 'down' : 'right'),
          onClick: function onClick() {
            return _this4.toggleOpen();
          }
        });
      }
    }(), /*#__PURE__*/_react["default"].createElement("label", null, /*#__PURE__*/_react["default"].createElement(_IndeterminateCheckbox["default"], {
      className: "mgr-5",
      indeterminate: (0, _some["default"])(value, function (i) {
        return (0, _startsWith["default"])(i, id + ',') && i !== id;
      }),
      checked: checked,
      type: "checkbox",
      value: id,
      onChange: function onChange(e) {
        onChildNodeChange(id, e.target.checked, e.target.checked ? [id] : [], e.target.checked ? [] : [id], id);
      }
    }), title)), function () {
      if (isOpen && !(0, _isEmpty["default"])(subs)) {
        return /*#__PURE__*/_react["default"].createElement("div", {
          style: {
            paddingLeft: '13px'
          }
        }, /*#__PURE__*/_react["default"].createElement(NodeList, {
          content: subs,
          parentOptionValue: id,
          value: value,
          onChange: onChange,
          onNodeOpen: onNodeOpen,
          onNodeClose: onNodeClose,
          openedNode: openedNode,
          parentNodeContent: content,
          onChildNodeChange: _this4.onChildNodeChange
        }));
      }
    }());
  };

  _proto2.toggleOpen = function toggleOpen() {
    var isOpen = !this.state.isOpen;
    this.setState({
      isOpen: isOpen
    });

    if (isOpen) {
      this.props.onNodeOpen(this.props.id);
    } else {
      this.props.onNodeClose(this.props.id);
    }
  };

  return Node;
}(_react.Component);

var NodeList = /*#__PURE__*/function (_Component3) {
  (0, _inheritsLoose2["default"])(NodeList, _Component3);

  function NodeList(props) {
    var _this5;

    _this5 = _Component3.call(this, props) || this;
    _this5._ref = /*#__PURE__*/(0, _react.createRef)();
    return _this5;
  }

  var _proto3 = NodeList.prototype;

  _proto3.render = function render() {
    var _this$props4 = this.props,
        content = _this$props4.content,
        style = _this$props4.style,
        props = (0, _objectWithoutPropertiesLoose2["default"])(_this$props4, _excluded4);

    if ((0, _isArray["default"])(content) && !(0, _isEmpty["default"])(content)) {
      return /*#__PURE__*/_react["default"].createElement("div", {
        style: style,
        ref: this._ref
      }, (0, _map["default"])(content, function (item) {
        return /*#__PURE__*/_react["default"].createElement(Node, (0, _extends2["default"])({
          key: item.id
        }, item, props));
      }));
    }
  };

  _proto3.componentDidMount = function componentDidMount() {
    var _this6 = this;

    var element = this._ref.current;

    if (this.props.scrollTop) {
      element.scrollTop = this.props.scrollTop;
    }

    if (this.props.onScroll) {
      element.addEventListener('scroll', function (e) {
        _this6.props.onScroll(e);
      });
    }
  };

  return NodeList;
}(_react.Component);

ChainedSelect.propTypes = {
  id: _propTypes["default"].any,
  value: _propTypes["default"].any,
  checked: _propTypes["default"].any,
  openedNode: _propTypes["default"].any,
  subs: _propTypes["default"].any,
  title: _propTypes["default"].any,
  content: _propTypes["default"].any,
  onChange: _propTypes["default"].any,
  onNodeOpen: _propTypes["default"].any,
  onNodeClose: _propTypes["default"].any,
  onChildNodeChange: _propTypes["default"].any,
  popContentStyle: _propTypes["default"].object
};
Node.propTypes = {
  id: _propTypes["default"].string,
  value: _propTypes["default"].array,
  checked: _propTypes["default"].bool,
  openedNode: _propTypes["default"].array,
  subs: _propTypes["default"].array,
  title: _propTypes["default"].string,
  content: _propTypes["default"].string,
  onChange: _propTypes["default"].func,
  onNodeOpen: _propTypes["default"].func,
  onNodeClose: _propTypes["default"].func,
  onChildNodeChange: _propTypes["default"].func
};
Node.defaultProps = {};
ChainedSelect.defaultProps = {
  className: 'select-with-search',
  controlClassName: 'align-justify form-control'
};
var _default = ChainedSelect;
exports["default"] = _default;