"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var axios_1 = tslib_1.__importDefault(require("axios"));
var style_module_scss_1 = tslib_1.__importDefault(require("./style.module.scss"));
var react_infinite_scroller_1 = tslib_1.__importDefault(require("react-infinite-scroller"));
var list_1 = tslib_1.__importDefault(require("udesk-ui/es/list"));
var udesk_ui_1 = require("udesk-ui");
var article_item_1 = tslib_1.__importDefault(require("./article-item"));
var utilities_1 = require("../utilities");
var km_util_1 = require("./km-util");
var message_1 = tslib_1.__importDefault(require("udesk-ui/es/message"));
var ArticleList = function (_a) {
    var companyId = _a.companyId, subdomain = _a.subdomain, email = _a.email, limitSpaceIds = _a.limitSpaceIds, enablePrivate = _a.enablePrivate, passport = _a.passport, spaceId = _a.spaceId, catalogId = _a.catalogId, query = _a.query, props = tslib_1.__rest(_a, ["companyId", "subdomain", "email", "limitSpaceIds", "enablePrivate", "passport", "spaceId", "catalogId", "query"]);
    var _b = (0, react_1.useState)([]), data = _b[0], setData = _b[1];
    var _c = (0, react_1.useState)(1), page = _c[0], setPage = _c[1];
    var _d = (0, react_1.useState)({ pageNum: 1, pageSize: 20, total: 0 }), paging = _d[0], setPaging = _d[1];
    var _e = (0, react_1.useState)(false), loading = _e[0], setLoading = _e[1];
    var kmApiBase = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext).kmApiBase;
    var safeSpaceId = (0, km_util_1.useSafeSpaceId)(spaceId);
    (0, react_1.useEffect)(function () {
        if (!passport || !spaceId) {
            return;
        }
        var params = {
            companyId: companyId,
            subdomain: subdomain,
            email: email,
            limitSpaceIds: limitSpaceIds,
            enablePrivate: enablePrivate,
            passport: passport,
            pageNum: page,
            query: query,
        };
        if (query) {
            params.spaceIds = spaceId;
            axios_1.default.post("".concat(kmApiBase, "/spaces"), params).then(function (res) {
                if (res.data.code !== 200) {
                    message_1.default.error(res.data.message);
                    return;
                }
                setData(res.data.data);
                setPaging(res.data.paging);
            });
        }
        else {
            params.spaceId = safeSpaceId;
            if (catalogId !== -1) {
                params.catalogId = catalogId;
            }
            axios_1.default.get("".concat(kmApiBase, "/articles/list"), { params: params }).then(function (res) {
                if (res.data.code === 200) {
                    setData(res.data.data);
                    setPaging(res.data.paging);
                }
                else {
                    message_1.default.error(res.data.message);
                }
            });
        }
    }, [
        catalogId,
        passport,
        spaceId,
        companyId,
        subdomain,
        email,
        limitSpaceIds,
        enablePrivate,
        page,
        query,
        kmApiBase,
        safeSpaceId,
    ]);
    var handleInfiniteOnLoad = (0, react_1.useCallback)(function () {
        if (loading) {
            return;
        }
        setLoading(true);
        setPage(function (prevState) { return prevState + 1; });
    }, [loading]);
    return (react_1.default.createElement("div", { className: style_module_scss_1.default['articleList'] },
        react_1.default.createElement(react_infinite_scroller_1.default, { initialLoad: false, pageStart: 0, loadMore: handleInfiniteOnLoad, hasMore: paging.pageNum * paging.pageSize < paging.total, useWindow: false },
            react_1.default.createElement(list_1.default, { dataSource: data, size: 'small', renderItem: function (item) { return (react_1.default.createElement(article_item_1.default, { data: item, companyId: companyId, email: email, enablePrivate: enablePrivate, limitSpaceIds: limitSpaceIds, passport: passport, subdomain: subdomain })); } }, loading && react_1.default.createElement(udesk_ui_1.Spin, { className: "w-full text-center mt-30" })))));
};
exports.default = ArticleList;
