"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var axios_1 = tslib_1.__importDefault(require("axios"));
var tree_select_1 = tslib_1.__importDefault(require("udesk-ui/es/tree-select"));
var locale_1 = require("@udesk-webapp/locale");
var km_util_1 = require("./km-util");
var utilities_1 = require("../utilities");
function buildTreeNodes(nodes, childrenMap) {
    if (!nodes) {
        return [];
    }
    return nodes.map(function (i) {
        return (react_1.default.createElement(tree_select_1.default.TreeNode, { value: i.id, key: i.id + '', title: i.name }, buildTreeNodes(childrenMap[i.id], childrenMap)));
    });
}
var CatalogSelect = function (_a) {
    var setDefaultValue = _a.setDefaultValue, companyId = _a.companyId, spaceId = _a.spaceId, subdomain = _a.subdomain, email = _a.email, limitSpaceIds = _a.limitSpaceIds, enablePrivate = _a.enablePrivate, passport = _a.passport, props = tslib_1.__rest(_a, ["setDefaultValue", "companyId", "spaceId", "subdomain", "email", "limitSpaceIds", "enablePrivate", "passport"]);
    var kmApiBase = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext).kmApiBase;
    var _b = (0, react_1.useState)({}), childrenMap = _b[0], setChildrenMap = _b[1];
    var _c = (0, react_1.useState)([]), rootNodes = _c[0], setRootNodes = _c[1];
    var _d = (0, react_1.useState)([]), treeExpandedKeys = _d[0], setTreeExpandedKeys = _d[1];
    var t = (0, locale_1.useTranslation)().t;
    var safeSpaceId = (0, km_util_1.useSafeSpaceId)(spaceId);
    (0, react_1.useEffect)(function () {
        axios_1.default
            .get("".concat(kmApiBase, "/spaces/").concat(safeSpaceId, "/catalogs"), {
            params: {
                companyId: companyId,
                subdomain: subdomain,
                email: email,
                limitSpaceIds: limitSpaceIds,
                enablePrivate: enablePrivate,
                passport: passport,
            },
        })
            .then(function (res) {
            var _a, _b;
            var _result = {};
            var _topNodes = [];
            (_b = (_a = res.data) === null || _a === void 0 ? void 0 : _a.data) === null || _b === void 0 ? void 0 : _b.forEach(function (i) {
                if (i.parentId === 0) {
                    _topNodes.push(i);
                }
                else {
                    if (!_result[i.parentId]) {
                        _result[i.parentId] = [];
                    }
                    _result[i.parentId].push(i);
                }
            });
            var _topNode = _topNodes[0];
            if (!_topNode) {
                return;
            }
            setRootNodes(tslib_1.__spreadArray([
                {
                    id: -1,
                    name: t('page.im.km.km.all_article'),
                    parentId: _topNode.id,
                }
            ], _result[_topNode.id], true));
            setDefaultValue === null || setDefaultValue === void 0 ? void 0 : setDefaultValue(-1);
            setChildrenMap(_result);
        });
    }, [
        companyId,
        email,
        enablePrivate,
        limitSpaceIds,
        passport,
        setDefaultValue,
        safeSpaceId,
        subdomain,
        t,
        kmApiBase,
    ]);
    var treeNodes = (0, react_1.useMemo)(function () { return buildTreeNodes(rootNodes, childrenMap); }, [
        childrenMap,
        rootNodes,
    ]);
    (0, react_1.useEffect)(function () {
        setTreeExpandedKeys(Object.keys(childrenMap));
    }, [childrenMap]);
    if (!rootNodes.length) {
        return null;
    }
    return (react_1.default.createElement(tree_select_1.default, tslib_1.__assign({ treeExpandedKeys: treeExpandedKeys, onTreeExpand: setTreeExpandedKeys, dropdownMatchSelectWidth: false, bordered: false }, props), treeNodes));
};
exports.default = CatalogSelect;
