"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var utils_1 = require("../utils");
var spin_1 = tslib_1.__importDefault(require("udesk-ui/es/spin"));
var space_1 = tslib_1.__importDefault(require("udesk-ui/es/space"));
var udesk_ui_1 = require("udesk-ui");
var axios_1 = tslib_1.__importDefault(require("axios"));
var catalog_select_1 = tslib_1.__importDefault(require("./catalog-select"));
var style_module_scss_1 = tslib_1.__importDefault(require("./style.module.scss"));
var article_list_1 = tslib_1.__importDefault(require("./article-list"));
// import { ISpace, KmSetting } from '../types';
var utilities_1 = require("../utilities");
var locale_1 = require("@udesk-webapp/locale");
var search_input_1 = tslib_1.__importDefault(require("../search-input"));
var Option = udesk_ui_1.Select.Option;
var Km = function (_a) {
    var _b;
    var private_space = _a.private_space, sync = _a.sync, companyId = _a.companyId, subdomain = _a.subdomain, email = _a.email, query = _a.query, onSearch = _a.onSearch;
    var _c = (0, react_1.useState)(''), token = _c[0], setToken = _c[1];
    var _d = (0, react_1.useState)(), spacesResponse = _d[0], setSpacesResponse = _d[1];
    var _e = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext), activeCatalog = _e.activeCatalog, onCatalogChange = _e.onCatalogChange, activeSpace = _e.activeSpace, onSpaceChange = _e.onSpaceChange, kmApiBase = _e.kmApiBase;
    var t = (0, locale_1.useTranslation)().t;
    var publicParams = (0, react_1.useMemo)(function () { return ({
        companyId: companyId,
        subdomain: subdomain,
        email: email,
        limitSpaceIds: private_space.join(','),
        enablePrivate: sync,
        passport: token,
    }); }, [companyId, email, private_space, subdomain, sync, token]);
    (0, react_1.useEffect)(function () {
        (0, utils_1.getJSON)("/knowledge_manager_settings/token?scope=token&_=".concat(new Date().getTime())).then(function (res) {
            setToken(res.token);
        });
    }, []);
    var getSpaces = (0, react_1.useCallback)(function () {
        if (!publicParams.passport) {
            return Promise.reject();
        }
        return axios_1.default
            .get("".concat(kmApiBase, "/spaces"), {
            params: tslib_1.__assign(tslib_1.__assign({}, publicParams), { pageSize: 100 }),
        })
            .then(function (res) {
            if (res.data.code === 200) {
                return res;
            }
            udesk_ui_1.message.error(res.data.message);
            return null;
        })
            .catch(function (err) {
            var _a, _b;
            udesk_ui_1.message.error(((_b = (_a = err === null || err === void 0 ? void 0 : err.response) === null || _a === void 0 ? void 0 : _a.data) === null || _b === void 0 ? void 0 : _b.message) || '请求失败');
            return null;
        });
    }, [kmApiBase, publicParams]);
    (0, react_1.useEffect)(function () {
        getSpaces().then(function (res) {
            var _a;
            if (((_a = res === null || res === void 0 ? void 0 : res.data) === null || _a === void 0 ? void 0 : _a.code) === 200) {
                setSpacesResponse(res === null || res === void 0 ? void 0 : res.data);
            }
        });
    }, [getSpaces]);
    var allSpaces = (0, react_1.useMemo)(function () { return spacesResponse && spacesResponse.data.map(function (i) { return i.id; }).join(','); }, [spacesResponse]);
    (0, react_1.useEffect)(function () {
        var _a;
        if (query) {
            onSpaceChange === null || onSpaceChange === void 0 ? void 0 : onSpaceChange(allSpaces);
        }
        else {
            if ((_a = spacesResponse === null || spacesResponse === void 0 ? void 0 : spacesResponse.data) === null || _a === void 0 ? void 0 : _a.length) {
                onSpaceChange === null || onSpaceChange === void 0 ? void 0 : onSpaceChange(spacesResponse.data[0].id);
            }
        }
    }, [allSpaces, onSpaceChange, query, spacesResponse === null || spacesResponse === void 0 ? void 0 : spacesResponse.data]);
    var safeSpace = (0, react_1.useMemo)(function () {
        if (!query &&
            activeSpace &&
            typeof activeSpace === 'string' &&
            activeSpace.indexOf(',') > -1) {
            return activeSpace.substring(0, activeSpace.indexOf(','));
        }
        return activeSpace;
    }, [activeSpace, query]);
    if (!token) {
        return react_1.default.createElement(spin_1.default, { className: "w-full text-center mt-30" });
    }
    if (!((_b = spacesResponse === null || spacesResponse === void 0 ? void 0 : spacesResponse.data) === null || _b === void 0 ? void 0 : _b.length)) {
        return react_1.default.createElement(udesk_ui_1.Empty, { className: "h-full w-hull flex justify-center items-center flex-col" });
    }
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(search_input_1.default, { className: 'mt-12', onSearch: onSearch, defaultValue: query }),
        react_1.default.createElement(space_1.default, { className: style_module_scss_1.default.spaceCatalogSelectWrapper },
            react_1.default.createElement("span", null,
                t('label.space'),
                ":"),
            react_1.default.createElement(udesk_ui_1.Select, { value: safeSpace, onChange: onSpaceChange, bordered: false, dropdownMatchSelectWidth: false },
                query ? (react_1.default.createElement(Option, { value: allSpaces }, t('page.im.km.km.all_space'))) : null,
                spacesResponse.data.map(function (i) { return (react_1.default.createElement(Option, { key: i.id, value: i.id + '' }, i.name)); })),
            safeSpace && !query ? (react_1.default.createElement(catalog_select_1.default, tslib_1.__assign({}, publicParams, { spaceId: safeSpace, value: activeCatalog, onChange: onCatalogChange, setDefaultValue: onCatalogChange }))) : null),
        safeSpace && activeCatalog ? (react_1.default.createElement(article_list_1.default, tslib_1.__assign({}, publicParams, { spaceId: safeSpace, catalogId: activeCatalog, query: query }))) : null));
};
exports.default = Km;
