import AddToCustomerMenuItem from './add-to-customer-menu-item';
import SearchImRecordMenuItem from './search-im-record-menu-item';
import VoiceToTextMenuItem from './voice-to-text-menu-item';
import AddMessageToKmRobotMenuItem from './add-message-to-km-robot-menu-item';
import RecallMenuItem from './recall-menu-item';
import HideItem from './hide-item';
import RefItem from './ref-item';
import CheckItem from './check-item';
import UnHideItem from './un-hide-item';
import AddToKnowledgeMenuItem from './add-to-knowledge-menu-item';
import React, { ComponentProps } from 'react';
declare type Props = {
    currentUser?: {
        aliase?: string;
        nick_name?: string;
        id?: number;
    };
    allowAddToCustomerInfo: boolean;
    allowSearchImRecord: boolean;
    allowVoiceToText: boolean;
    allowAddToRobotKM: boolean;
    allowUnHide: boolean;
    allowAddToKM: boolean;
    msgdisplayStatus?: boolean;
    hideEnable?: boolean;
    refEnable?: boolean;
    allowRecall: boolean;
    chatPlatform: IPlatform;
    onSelectTel?: ComponentProps<typeof AddToCustomerMenuItem>['onSelectTel'];
    onSelectEmail?: ComponentProps<typeof AddToCustomerMenuItem>['onSelectEmail'];
    onRecall?: ComponentProps<typeof RecallMenuItem>['onClick'];
    onHide?: ComponentProps<typeof HideItem>['onClick'];
    onRef?: ComponentProps<typeof RefItem>['onClick'];
    onCheck?: ComponentProps<typeof CheckItem>['onClick'];
    onUnHide?: ComponentProps<typeof UnHideItem>['onClick'];
    onAddToKM?: ComponentProps<typeof AddToKnowledgeMenuItem>['onClick'];
    onSelectText?: ComponentProps<typeof SearchImRecordMenuItem>['onClick'];
    onVoiceToText?: ComponentProps<typeof VoiceToTextMenuItem>['onClick'];
    onAddToRobotKM?: ComponentProps<typeof AddMessageToKmRobotMenuItem>['onClick'];
    selection?: string;
    msg: Pick<IMessage, 'content' | 'platform' | 'is_receive' | 'recognition' | 'type' | 'msg_id' | 'data' | 'auto' | 'agent_id' | 'filename' | 'filesize' | 'filetype' | 'randomFileName' | 'send_status' | 'created_at' | 'sender' | 'message_display_status' | 'status'>;
};
declare const Menu: React.FC<Props>;
export default Menu;
