"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var add_to_customer_menu_item_1 = tslib_1.__importDefault(require("./add-to-customer-menu-item"));
var search_im_record_menu_item_1 = tslib_1.__importDefault(require("./search-im-record-menu-item"));
var voice_to_text_menu_item_1 = tslib_1.__importDefault(require("./voice-to-text-menu-item"));
var add_message_to_km_robot_menu_item_1 = tslib_1.__importDefault(require("./add-message-to-km-robot-menu-item"));
var recall_menu_item_1 = tslib_1.__importDefault(require("./recall-menu-item"));
var hide_item_1 = tslib_1.__importDefault(require("./hide-item"));
var ref_item_1 = tslib_1.__importDefault(require("./ref-item"));
var check_item_1 = tslib_1.__importDefault(require("./check-item"));
var un_hide_item_1 = tslib_1.__importDefault(require("./un-hide-item"));
var add_to_knowledge_menu_item_1 = tslib_1.__importDefault(require("./add-to-knowledge-menu-item"));
var style_module_less_1 = tslib_1.__importDefault(require("./style.module.less"));
var react_1 = tslib_1.__importStar(require("react"));
var lodash_es_1 = require("lodash-es");
var popover_1 = tslib_1.__importDefault(require("udesk-ui/es/popover"));
var telReg = /\b(((\+\d\d)?1\d{10})|((0\d{2,3}-?)\d{7,8}))\b/g;
var emailReg = /((\w)+(\.\w+)*@(\w)+((\.\w+)+))/g;
var getPopupContainer = function (triggerNode) { return triggerNode || document.body; };
var Menu = function (_a) {
    var allowAddToCustomerInfo = _a.allowAddToCustomerInfo, allowSearchImRecord = _a.allowSearchImRecord, allowVoiceToText = _a.allowVoiceToText, allowAddToRobotKM = _a.allowAddToRobotKM, allowUnHide = _a.allowUnHide, allowAddToKM = _a.allowAddToKM, msgdisplayStatus = _a.msgdisplayStatus, hideEnable = _a.hideEnable, refEnable = _a.refEnable, allowRecall = _a.allowRecall, msg = _a.msg, chatPlatform = _a.chatPlatform, onSelectEmail = _a.onSelectEmail, onSelectTel = _a.onSelectTel, onRecall = _a.onRecall, onHide = _a.onHide, onRef = _a.onRef, onCheck = _a.onCheck, onUnHide = _a.onUnHide, onAddToKM = _a.onAddToKM, onSelectText = _a.onSelectText, onVoiceToText = _a.onVoiceToText, onAddToRobotKM = _a.onAddToRobotKM, selection = _a.selection, currentUser = _a.currentUser, children = _a.children;
    var _b = (0, react_1.useState)(false), isAddToCustomerMenuItemExpand = _b[0], setAddToCustomerMenuItemExpand = _b[1];
    var tels = (0, react_1.useMemo)(function () { return (0, lodash_es_1.uniq)(JSON.stringify(msg.content).match(telReg)); }, [msg.content]);
    var emails = (0, react_1.useMemo)(function () { return (0, lodash_es_1.uniq)(JSON.stringify(msg.content).match(emailReg)); }, [msg.content]);
    var type = (0, react_1.useMemo)(function () { return msg.type; }, [msg.type]);
    var isText = (0, react_1.useMemo)(function () { return type === 'message' || type === 'info' || false; }, [type]);
    var isRich = (0, react_1.useMemo)(function () { return type === 'rich' || false; }, [type]);
    var isImage = (0, react_1.useMemo)(function () { return type === 'image' || false; }, [type]);
    var isFile = (0, react_1.useMemo)(function () { return type === 'file' || false; }, [type]);
    var isAudio = (0, react_1.useMemo)(function () { return type === 'audio'; }, [type]);
    var isVideo = (0, react_1.useMemo)(function () { return type === 'video'; }, [type]);
    var enabledAddToCustomerInfo = (0, react_1.useMemo)(function () { return allowAddToCustomerInfo && (tels.length + emails.length) > 0; }, [allowAddToCustomerInfo, emails.length, tels.length]);
    var enabledSearchImRecord = (0, react_1.useMemo)(function () { return allowSearchImRecord && !!selection; }, [allowSearchImRecord, selection]);
    var enabledVoiceToText = (0, react_1.useMemo)(function () { return allowVoiceToText &&
        ['ios', 'android'].includes(msg.platform || '') &&
        msg.type === 'audio' &&
        msg.is_receive &&
        !msg.recognition; }, [allowVoiceToText, msg.is_receive, msg.platform, msg.recognition, msg.type]);
    var enabledAddToRobotKM = (0, react_1.useMemo)(function () { return allowAddToRobotKM && !msg.is_receive && ['message', 'rich'].includes(msg.type); }, [allowAddToRobotKM, msg.is_receive, msg.type]);
    var enabledAddToKM = (0, react_1.useMemo)(function () { return allowAddToKM &&
        (isText || isRich || isImage || isFile) &&
        !msg.is_receive &&
        !msg.auto &&
        msg.agent_id !== 'robot'; }, [allowAddToKM, isFile, isImage, isRich, isText, msg.agent_id, msg.auto, msg.is_receive]);
    var enabledHide = (0, react_1.useMemo)(function () { return hideEnable && (isText || isRich); }, [isRich, isText, hideEnable]);
    var rpaSupportType = (0, react_1.useMemo)(function () { return isText || isImage || isFile || isAudio || isVideo; }, [isText, isImage, isFile, isAudio, isVideo]);
    // 文本类型或机器人消息，非系统消息非撤回消息
    var enabledRef = (0, react_1.useMemo)(function () {
        return refEnable &&
            !msg.auto &&
            msg.status !== 'system' &&
            msg.send_status !== 'rollback' &&
            ((chatPlatform === 'web' && isText) ||
                ((chatPlatform === 'single_rpa' || chatPlatform === 'group_rpa') && rpaSupportType));
    }, [isText, refEnable, msg.auto, chatPlatform, rpaSupportType]);
    var getMenuItems = (0, react_1.useCallback)(function () {
        var checkEnableRecall = function () {
            var _a;
            /*
                allowRecall: 允许撤回（im-log组件传入参数）
                msg.type === 'uploading' 正在图片或文件正在上传
                msg.send_status === 'rollback' 已经撤回的消息
                msg.is_receive 为true是客户发送的消息
                msg.status === 'system' 系统消息，例如“欢迎语”
                msg.auto 为true是自动消息，例如客服超时回复提醒
            */
            if (!allowRecall || msg.type === 'uploading' || msg.send_status === 'rollback' || msg.is_receive || msg.status === 'system' || msg.auto) {
                return false;
            }
            var now = new Date().getTime();
            var created_at = new Date(msg.created_at).getTime();
            return !((_a = msg.content) === null || _a === void 0 ? void 0 : _a.auto) && msg.sender !== 'customer' && (now - created_at < 2000 * 60) && ((currentUser === null || currentUser === void 0 ? void 0 : currentUser.id) === msg.agent_id);
        };
        return [
            (msg.message_display_status !== 'hide' && enabledAddToCustomerInfo ? react_1.default.createElement(add_to_customer_menu_item_1.default, { tels: tels, emails: emails, isExpand: isAddToCustomerMenuItemExpand, onSelectEmail: onSelectEmail, onSelectTel: onSelectTel, key: 'add-to-customer-menu-item' }) : null),
            (msg.message_display_status !== 'hide' && enabledSearchImRecord ?
                react_1.default.createElement(search_im_record_menu_item_1.default, { keyword: selection || '', onClick: onSelectText, key: 'search-im-record-menu-item' }) : null),
            (msg.message_display_status !== 'hide' && enabledVoiceToText ? react_1.default.createElement(voice_to_text_menu_item_1.default, { onClick: onVoiceToText, msg: {
                    msg_id: msg.msg_id,
                    data: msg.data
                }, key: 'voice-to-text' }) : null),
            (msg.message_display_status !== 'hide' && enabledAddToRobotKM ?
                react_1.default.createElement(add_message_to_km_robot_menu_item_1.default, { onClick: onAddToRobotKM, key: 'add-message-to-km-robot-menu-item', msg: { data: msg.data, type: msg.type } }) : null),
            (msg.message_display_status !== 'hide' && checkEnableRecall() ?
                react_1.default.createElement(recall_menu_item_1.default, { onClick: onRecall, key: 'recall-menu-item' }) : null),
            (allowUnHide && enabledHide && msg.message_display_status !== 'hide' ? react_1.default.createElement(hide_item_1.default, { onClick: onHide, key: 'hide-item' }) : null),
            (allowUnHide && enabledRef && msg.message_display_status !== 'hide' ? react_1.default.createElement(ref_item_1.default, { onClick: onRef, key: 'ref-item' }) : null),
            (allowUnHide && msg.message_display_status === 'hide' && !msgdisplayStatus ? react_1.default.createElement(check_item_1.default, { onClick: onCheck, key: 'check-item' }) : null),
            (allowUnHide && msg.message_display_status === 'hide' ? react_1.default.createElement(un_hide_item_1.default, { onClick: onUnHide, key: 'un-hide-item' }) : null),
            (msg.message_display_status !== 'hide' && enabledAddToKM ?
                react_1.default.createElement(add_to_knowledge_menu_item_1.default, { content: msg.data.content, onClick: onAddToKM, key: 'add-to-knowledge-menu-item', msg: {
                        type: msg.type,
                        data: msg.data,
                        is_receive: msg.is_receive,
                        filename: msg.filename,
                        filesize: msg.filesize,
                        filetype: msg.filetype,
                        randomFileName: msg.randomFileName
                    } }) : null)
        ].filter(function (i) { return i; });
    }, [emails, enabledAddToCustomerInfo, enabledAddToKM, enabledAddToRobotKM, enabledSearchImRecord, enabledVoiceToText,
        isAddToCustomerMenuItemExpand, msg.data, msg.filename, msg.filesize, msg.filetype, msg.is_receive, msg.msg_id,
        msg.randomFileName, msg.type, onAddToKM, onAddToRobotKM, onRecall, onHide, onRef, onCheck, onUnHide, onSelectEmail,
        onSelectTel, onSelectText, onVoiceToText, selection, tels]);
    var onMouseEnter = (0, react_1.useCallback)(function () { return setAddToCustomerMenuItemExpand(true); }, []);
    var _c = (0, react_1.useState)(false), visible = _c[0], setVisible = _c[1];
    var onVisibleChange = (0, react_1.useCallback)(function (v) { return setVisible(v && getMenuItems().length > 0); }, [getMenuItems]);
    return react_1.default.createElement(popover_1.default, { onVisibleChange: onVisibleChange, visible: visible, content: function () {
            return react_1.default.createElement("div", { onMouseEnter: onMouseEnter, className: style_module_less_1.default['menus'] }, getMenuItems());
        }, getPopupContainer: getPopupContainer, overlayClassName: style_module_less_1.default['im-log'], destroyTooltipOnHide: true, placement: msg.sender === 'customer' ? 'bottomLeft' : 'bottomRight' }, children);
};
exports.default = Menu;
