"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_viewer_1 = tslib_1.__importDefault(require("react-viewer"));
var react_1 = tslib_1.__importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var style_module_scss_1 = tslib_1.__importDefault(require("../../style.module.scss"));
var icons_1 = require("@ant-design/icons");
var locale_1 = require("@udesk-webapp/locale");
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var dompurify_1 = tslib_1.__importDefault(require("dompurify"));
var useEvent_1 = tslib_1.__importDefault(require("react-use/esm/useEvent"));
var hightlight_1 = tslib_1.__importDefault(require("../../hightlight"));
var utilities_1 = require("../../utilities");
var utils_1 = require("../../utils");
// import { IQuestion } from '../../types';
// import { selectedChatSelector } from '@Src/store/selectors'; // 需要传进来
// import EditQuestionModal from '../edit-question-answer';
// import { useSelector } from 'react-redux';
// import { ArrowRightSOutlined, ArrowDownSOutlined } from '@udesk/icons';
var DOMPurify = (0, dompurify_1.default)(window);
DOMPurify.setConfig({ ADD_ATTR: ['target'] });
DOMPurify.addHook('afterSanitizeAttributes', function (node) {
    if ('target' in node) {
        node.setAttribute('rel', 'noopener noreferrer');
    }
});
var QuestionItem = function (_a) {
    var _b, _c;
    var _d;
    var data = _a.data, agentConfig = _a.agentConfig, getImages = _a.getImages, host = _a.host, chat = _a.chat;
    // const chat = useSelector(selectedChatSelector) || ({} as IMineChat); // 需要传进来
    var t = (0, locale_1.useTranslation)().t;
    // const agentConfig = useSelector((state: RootState) => state.im.config); // 需要传进来
    var _e = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext), allowSendQuestion = _e.allowSendQuestion, allowRelateQuestion = _e.allowRelateQuestion, onUse = _e.onUse, onSend = _e.onSend, onRelate = _e.onRelate, isWorkbench = _e.isWorkbench, showQuestionModal = _e.showQuestionModal, activeScope = _e.activeScope, previewUrl = _e.previewUrl;
    var _f = (0, react_1.useState)(false), showExpandButton = _f[0], setShowExpandButton = _f[1];
    var _g = (0, react_1.useState)(true), isExpand = _g[0], setIsExpand = _g[1];
    // const [showAddModal, setShowAddModal] = useState<boolean>(false);
    var contentRef = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(function () {
        if (contentRef.current) {
            var imageElements = contentRef.current.querySelectorAll('img');
            var images_1 = [];
            imageElements.forEach(function (i) { return images_1.push({ src: i.src }); });
            getImages(images_1);
            if (contentRef.current.clientHeight > 40 || imageElements.length > 0) {
                setShowExpandButton(true);
                setIsExpand(false);
            }
        }
    }, [getImages]);
    var toggleExpand = (0, react_1.useCallback)(function () {
        setIsExpand(!isExpand);
    }, [isExpand]);
    var _onUse = (0, react_1.useCallback)(function () {
        var _a;
        (0, utilities_1.hit)(data.id, 'KnowledgeQuestion');
        if ((_a = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.knowledge_config) === null || _a === void 0 ? void 0 : _a.question_use_edit) {
            // setShowAddModal(true);
            showQuestionModal === null || showQuestionModal === void 0 ? void 0 : showQuestionModal(data, true);
        }
        else {
            onUse === null || onUse === void 0 ? void 0 : onUse('question', data);
        }
    }, [data, onUse, showQuestionModal, (_d = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.knowledge_config) === null || _d === void 0 ? void 0 : _d.question_use_edit]);
    var onSendClick = (0, react_1.useCallback)(function () {
        (0, utilities_1.hit)(data.id, 'KnowledgeQuestion');
        var url = "https://".concat(host || window.location.host, "/question/");
        var _data = (0, utilities_1.makeQuestionData)({
            content: data.content,
            content_type: data.content_type,
            title: data.title,
            id: parseInt(data.id),
        }, chat.platform, '', url);
        onSend === null || onSend === void 0 ? void 0 : onSend('question', tslib_1.__assign(tslib_1.__assign({}, data), { url: _data.url, desc: _data.desc }));
    }, [chat, data, onSend]);
    var onRelateClick = (0, react_1.useCallback)(function () {
        onRelate === null || onRelate === void 0 ? void 0 : onRelate({
            id: data.id,
            title: data.title,
            desc: data.desc,
        });
    }, [onRelate, data]);
    var previewUrlFun = (0, react_1.useCallback)(function (url) {
        window.open((0, utils_1.getPreviewUrl)(url, { previewUrl: previewUrl }));
    }, [previewUrl]);
    var AttachmentContent = (0, react_1.useMemo)(function () {
        var attachment = data.attachment;
        if (!attachment || (typeof attachment !== 'object'))
            return null;
        var _a = attachment || {}, url = _a.url, file_name = _a.file_name, content_type = _a.content_type;
        if (!url)
            return null;
        var canPreview = (0, utils_1.canPreviewByFileName)(file_name);
        var nodeItem = [
            react_1.default.createElement("div", { className: style_module_scss_1.default['attachment-left'], style: { maxWidth: canPreview ? undefined : 'calc(100% - 10px)' } },
                react_1.default.createElement(icons_1.LinkOutlined, { key: '0' }),
                "\u00A0\u00A0",
                react_1.default.createElement("a", { href: url, title: file_name, target: '_blank', rel: "noreferrer noopener" }, file_name)),
            canPreview ? (react_1.default.createElement(udesk_ui_1.Button, { type: 'link', size: 'small', onClick: function () { return previewUrlFun(url); } }, t('label.preview'))) : null
        ];
        if (content_type.startsWith('image') || /png|jpg|jpeg|gif/.test(content_type)) {
            return (react_1.default.createElement(udesk_ui_1.Popover, { autoAdjustOverflow: false, content: react_1.default.createElement("img", { src: url, alt: file_name, style: { width: '100%' } }), placement: 'left', overlayStyle: { maxWidth: '300px', maxHeight: '300px' } },
                react_1.default.createElement("div", { className: style_module_scss_1.default['attachment-wrap'] }, nodeItem)));
        }
        else {
            return react_1.default.createElement("div", { className: style_module_scss_1.default['attachment-wrap'] }, nodeItem);
        }
    }, [data, previewUrlFun]);
    return (react_1.default.createElement("div", { className: style_module_scss_1.default['question-item'] },
        react_1.default.createElement("div", { className: style_module_scss_1.default['question-item-title'] },
            react_1.default.createElement("div", { className: (0, classnames_1.default)(style_module_scss_1.default['align-justify']) },
                react_1.default.createElement(hightlight_1.default, { className: style_module_scss_1.default['word-break'], content: data.title })),
            react_1.default.createElement("div", { style: { overflow: 'hidden' } },
                react_1.default.createElement("div", { className: (0, classnames_1.default)(style_module_scss_1.default['btns']) },
                    allowSendQuestion && isWorkbench ? (react_1.default.createElement(react_1.default.Fragment, null,
                        react_1.default.createElement(udesk_ui_1.Button, { type: 'link', className: style_module_scss_1.default['question-item-btn'], size: 'small', onClick: onSendClick }, t('label.send')),
                        react_1.default.createElement("span", { className: style_module_scss_1.default['line'] }))) : null,
                    isWorkbench ? react_1.default.createElement(udesk_ui_1.Button, { type: 'link', className: style_module_scss_1.default['question-item-btn'], size: 'small', onClick: _onUse }, t('label.use')) : null,
                    allowRelateQuestion && activeScope === 'public' ? (react_1.default.createElement(react_1.default.Fragment, null,
                        isWorkbench ? react_1.default.createElement("span", { className: style_module_scss_1.default['line'] }) : null,
                        react_1.default.createElement(udesk_ui_1.Button, { type: 'link', className: style_module_scss_1.default['question-item-btn'], size: 'small', onClick: onRelateClick }, t('label.relate')))) : null,
                    showExpandButton && (react_1.default.createElement(react_1.default.Fragment, null,
                        isWorkbench ? react_1.default.createElement("span", { className: style_module_scss_1.default['line'] }) : null,
                        react_1.default.createElement(udesk_ui_1.Button, { type: 'link', className: style_module_scss_1.default['question-item-btn'], size: 'small', onClick: toggleExpand },
                            t(isExpand ? 'label.collapse' : 'label.expand'),
                            isExpand ? (react_1.default.createElement(icons_1.DownOutlined, { className: style_module_scss_1.default['arrow-svg'] })) : (react_1.default.createElement(icons_1.RightOutlined, { className: style_module_scss_1.default['arrow-svg'] })))))))),
        react_1.default.createElement("div", { ref: contentRef, className: (0, classnames_1.default)(style_module_scss_1.default.highlight, style_module_scss_1.default['word-break'], (_b = {}, _b[style_module_scss_1.default.expand] = isExpand, _b), (_c = {}, _c[style_module_scss_1.default['un-expand']] = !isExpand, _c)), dangerouslySetInnerHTML: {
                __html: DOMPurify.sanitize(data.content_type === 'text' ? data.content_text : data.content),
            } }),
        AttachmentContent));
};
var QuestionList = function (_a) {
    var data = _a.data, onScrollToBottom = _a.onScrollToBottom, host = _a.host, agentConfig = _a.agentConfig, chat = _a.chat;
    var _b = (0, react_1.useState)(false), imageViewerVisible = _b[0], setImageViewerVisible = _b[1];
    var _c = (0, react_1.useState)([]), images = _c[0], setImages = _c[1];
    var _d = (0, react_1.useState)(0), activeIndex = _d[0], setActiveIndex = _d[1];
    var dataWrapperRef = (0, react_1.useRef)(null);
    var onClick = (0, react_1.useCallback)(function (e) {
        if (e.target.tagName === 'IMG') {
            setActiveIndex(images.findIndex(function (i) { return i.src === e.target.src; }));
            setImageViewerVisible(true);
        }
    }, [images]);
    (0, useEvent_1.default)('click', onClick, document.getElementById('react-question-common-list'));
    (0, react_1.useEffect)(function () {
        if (dataWrapperRef.current) {
            var scrollHandle_1 = function (e) {
                var element = e.currentTarget;
                if (!element) {
                    return;
                }
                // 因为屏幕的DPI问题，会导致部分电脑scrollTop为小数，无法加载新的
                if (element.scrollHeight - element.scrollTop <= element.clientHeight + 1) {
                    onScrollToBottom();
                }
            };
            dataWrapperRef.current.addEventListener('scroll', scrollHandle_1);
            return function () { var _a; return (_a = dataWrapperRef === null || dataWrapperRef === void 0 ? void 0 : dataWrapperRef.current) === null || _a === void 0 ? void 0 : _a.removeEventListener('scroll', scrollHandle_1); };
        }
    }, [onScrollToBottom]);
    var getImages = (0, react_1.useCallback)(function (i) { return setImages(function (prevState) { return tslib_1.__spreadArray(tslib_1.__spreadArray([], prevState, true), i, true); }); }, []);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { ref: dataWrapperRef, className: "".concat(style_module_scss_1.default['question-list'], " scrollbar"), id: 'react-question-common-list' }, data.map(function (i) { return (react_1.default.createElement(QuestionItem, { data: i, key: i.id, host: host, getImages: getImages, agentConfig: agentConfig, chat: chat })); })),
        react_1.default.createElement(react_viewer_1.default, { activeIndex: activeIndex < 0 ? 0 : activeIndex, visible: imageViewerVisible, onClose: function () { return setImageViewerVisible(false); }, images: images })));
};
exports.default = QuestionList;
