"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var scope_switch_1 = tslib_1.__importDefault(require("../scope-switch"));
var index_1 = tslib_1.__importDefault(require("./common-question/index"));
var robot_question_1 = tslib_1.__importDefault(require("./robot-question"));
var utilities_1 = require("../utilities");
var search_input_1 = tslib_1.__importDefault(require("../search-input"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var style_module_scss_1 = tslib_1.__importDefault(require("../style.module.scss"));
var Question = function (_a) {
    var _b;
    var onSearch = _a.onSearch, query = _a.query, refreshKnowledge = _a.refreshKnowledge, roleCan = _a.roleCan, agentConfig = _a.agentConfig, dialogueTagData = _a.dialogueTagData, mineChats = _a.mineChats, stashKey = _a.stashKey, dialogueTagNameList = _a.dialogueTagNameList, dialogueTagMode = _a.dialogueTagMode;
    var _c = (0, react_1.useState)(), settings = _c[0], setSettings = _c[1];
    var _d = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext), activeScope = _d.activeScope, onScopeChange = _d.onScopeChange, showRobotQuestionTab = _d.showRobotQuestionTab, host = _d.host;
    var _e = (0, react_1.useState)(query), searchValue = _e[0], setSearchValue = _e[1];
    var oldQuery = (0, react_1.useRef)("");
    // const agentConfig = useSelector((state: RootState) => state.im.config); // 需要传进来
    // const dialogueTagData = useSelector<RootState, TagItem[]>( // 需要传进来
    //     (state) => state.im.config.dialogueTag.tag
    // );
    // const mineChats = useSelector<RootState, IMineChat[]>((state) => state.mineChats); // 需要传进来
    var chat = (mineChats === null || mineChats === void 0 ? void 0 : mineChats.find(function (chat) { return chat.selected; })) || {};
    var tagName = (0, react_1.useMemo)(function () {
        var _a, _b, _c, _d, _e;
        var tagList = [];
        if (((_a = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.session_tags_config) === null || _a === void 0 ? void 0 : _a.enable) &&
            ((_b = agentConfig.session_tags_config) === null || _b === void 0 ? void 0 : _b.show_mode) === 'keyword' &&
            ((_c = chat.dialogueTag) === null || _c === void 0 ? void 0 : _c.length)) {
            if (((_d = agentConfig.session_tags_config) === null || _d === void 0 ? void 0 : _d.mode_tags) === 'first') {
                chat.dialogueTag[0].forEach(function (item) {
                    dialogueTagData === null || dialogueTagData === void 0 ? void 0 : dialogueTagData.forEach(function (items) {
                        if (item === items.id) {
                            tagList.push(items.name);
                        }
                    });
                }); //9/10/11/12/1/2
            }
            else if (((_e = agentConfig.session_tags_config) === null || _e === void 0 ? void 0 : _e.mode_tags) === 'new') {
                chat.dialogueTag[chat.dialogueTag.length - 1].forEach(function (item) {
                    dialogueTagData === null || dialogueTagData === void 0 ? void 0 : dialogueTagData.forEach(function (items) {
                        if (item === items.id) {
                            tagList.push(items.name);
                        }
                    });
                });
            }
            return tagList.join(' ');
        }
        else {
            return false;
        }
    }, [agentConfig, chat, dialogueTagData]);
    (0, react_1.useEffect)(function () {
        (0, utilities_1.fetchKnowledgeManagerRobotSettings)().then(function (settings) {
            setSettings(settings);
        });
    }, []);
    (0, react_1.useEffect)(function () {
        var value = (dialogueTagNameList === null || dialogueTagNameList === void 0 ? void 0 : dialogueTagNameList.length) && dialogueTagMode === "keyword"
            ? dialogueTagNameList === null || dialogueTagNameList === void 0 ? void 0 : dialogueTagNameList.join(" ")
            : query;
        if (oldQuery.current !== value) {
            setSearchValue(value);
            oldQuery.current = value;
        }
    }, [dialogueTagMode, dialogueTagNameList, query]);
    var onSearched = (0, react_1.useCallback)(function (keyword) {
        setSearchValue(keyword);
        onSearch === null || onSearch === void 0 ? void 0 : onSearch(keyword);
    }, [onSearch]);
    //系统开通了机器人，并且showRobotQuestionTab为 true 时才会显示机器人
    var enableRobot = (0, react_1.useMemo)(function () {
        var _a;
        return showRobotQuestionTab && ((_a = settings === null || settings === void 0 ? void 0 : settings.km_join_udesk_robots) === null || _a === void 0 ? void 0 : _a.is_enabled);
    }, [(_b = settings === null || settings === void 0 ? void 0 : settings.km_join_udesk_robots) === null || _b === void 0 ? void 0 : _b.is_enabled, showRobotQuestionTab]);
    var _onScopeChange = (0, react_1.useCallback)(function (scope) {
        if (!enableRobot && scope === 'robot') {
            onScopeChange === null || onScopeChange === void 0 ? void 0 : onScopeChange('public');
        }
        else {
            onScopeChange === null || onScopeChange === void 0 ? void 0 : onScopeChange(scope);
        }
    }, [enableRobot, onScopeChange]);
    var mainContent = (0, react_1.useMemo)(function () {
        if (activeScope === 'public' || activeScope === 'personal') {
            return (react_1.default.createElement(index_1.default, { scope: activeScope, query: searchValue, host: host, refreshKnowledge: refreshKnowledge, roleCan: roleCan, agentConfig: agentConfig, dialogueTagData: dialogueTagData, mineChats: mineChats, stashKey: stashKey }));
        }
        else if (enableRobot) {
            return (react_1.default.createElement(robot_question_1.default, { searchWord: searchValue, settings: settings, agentConfig: agentConfig }));
        }
        else {
            return null;
        }
    }, [activeScope, enableRobot, searchValue, settings, roleCan, refreshKnowledge]);
    var hasPermission = (0, react_1.useMemo)(function () {
        if (activeScope === 'public') {
            return !!(roleCan === null || roleCan === void 0 ? void 0 : roleCan.knowledge_view_public) && !!(roleCan === null || roleCan === void 0 ? void 0 : roleCan.knowledge_questions_public);
        }
        else {
            return !!(roleCan === null || roleCan === void 0 ? void 0 : roleCan.knowledge_view) && !!(roleCan === null || roleCan === void 0 ? void 0 : roleCan.knowledge_questions);
        }
    }, [activeScope, roleCan]);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(scope_switch_1.default, { enableRobot: enableRobot, value: activeScope, onChange: _onScopeChange }),
        hasPermission ? (react_1.default.createElement(react_1.default.Fragment, null,
            react_1.default.createElement(search_input_1.default, { onSearch: onSearched, defaultValue: tagName ? tagName : searchValue }),
            mainContent)) : (react_1.default.createElement("div", { className: (0, classnames_1.default)(style_module_scss_1.default['no-permission']) }, "\u60A8\u6682\u65E0\u6743\u9650\u67E5\u770B\u6B64\u5185\u5BB9"))));
};
exports.default = Question;
