"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
// import axios from 'axios';
var tree_select_1 = tslib_1.__importDefault(require("udesk-ui/es/tree-select"));
var utilities_1 = require("../../utilities");
var index_1 = require("../../utils/index");
function buildTreeNodes(nodes, childrenMap) {
    if (!nodes) {
        return [];
    }
    return nodes.map(function (i) {
        return (react_1.default.createElement(tree_select_1.default.TreeNode, { value: i.id, key: i.id + '', title: i.name }, buildTreeNodes(childrenMap[i.id], childrenMap)));
    });
}
var CategorySelect = function (_a) {
    var settings = _a.settings, robotId = _a.robotId, setDefaultValue = _a.setDefaultValue, props = tslib_1.__rest(_a, ["settings", "robotId", "setDefaultValue"]);
    var kmApiBase = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext).kmApiBase;
    var _b = (0, react_1.useState)({}), childrenMap = _b[0], setChildrenMap = _b[1];
    var _c = (0, react_1.useState)([]), rootNodes = _c[0], setRootNodes = _c[1];
    var _d = (0, react_1.useState)([]), treeExpandedKeys = _d[0], setTreeExpandedKeys = _d[1];
    (0, react_1.useEffect)(function () {
        (0, index_1.getCategoryList)({ robotId: robotId, kmApiBase: kmApiBase }).then(function (res) {
            var _a;
            var _result = {};
            var _rootNodes = [];
            res.data.forEach(function (i) {
                if (i.parentId === 0) {
                    _rootNodes.push(i);
                }
                else {
                    if (!_result[i.parentId]) {
                        _result[i.parentId] = [];
                    }
                    _result[i.parentId].push(i);
                }
            });
            setDefaultValue((_a = _rootNodes[0]) === null || _a === void 0 ? void 0 : _a.id);
            setRootNodes(_rootNodes);
            setChildrenMap(_result);
        });
    }, [robotId, setDefaultValue, settings.auth]);
    var treeNodes = (0, react_1.useMemo)(function () { return buildTreeNodes(rootNodes, childrenMap); }, [
        childrenMap,
        rootNodes,
    ]);
    (0, react_1.useEffect)(function () {
        setTreeExpandedKeys(Object.keys(childrenMap));
    }, [childrenMap]);
    if (!rootNodes.length) {
        return null;
    }
    return (react_1.default.createElement(tree_select_1.default, tslib_1.__assign({ treeExpandedKeys: treeExpandedKeys, onTreeExpand: setTreeExpandedKeys, dropdownMatchSelectWidth: false, treeDefaultExpandAll: true, bordered: false }, props), treeNodes));
};
exports.default = CategorySelect;
