"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var robot_select_1 = tslib_1.__importDefault(require("./robot-select"));
var udesk_ui_1 = require("udesk-ui");
var category_select_1 = tslib_1.__importDefault(require("./category-select"));
var space_1 = tslib_1.__importDefault(require("udesk-ui/es/space"));
var robot_question_list_1 = tslib_1.__importDefault(require("./robot-question-list"));
var style_module_scss_1 = tslib_1.__importDefault(require("./style.module.scss"));
var RobotQuestionComp = function (_a) {
    var searchWord = _a.searchWord, settings = _a.settings, agentConfig = _a.agentConfig;
    var _b = (0, react_1.useState)(), selectedRobotId = _b[0], setSelectedRobotId = _b[1];
    var _c = (0, react_1.useState)(), selectedCategoryId = _c[0], setSelectedCategoryId = _c[1];
    var selectFirstRobot = (0, react_1.useCallback)(function (robots) {
        setSelectedRobotId(function (prevState) {
            if (!prevState) {
                return robots[0].km_robot_id;
            }
            return prevState;
        });
    }, []);
    if (!settings) {
        return react_1.default.createElement(udesk_ui_1.Spin, null);
    }
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(space_1.default, { className: style_module_scss_1.default.conditionWrapper },
            react_1.default.createElement(robot_select_1.default, { settings: settings, value: selectedRobotId, onChange: setSelectedRobotId, onDataLoaded: selectFirstRobot }),
            selectedRobotId && (react_1.default.createElement(category_select_1.default, { settings: settings, value: selectedCategoryId, onChange: setSelectedCategoryId, setDefaultValue: setSelectedCategoryId, robotId: selectedRobotId }))),
        selectedRobotId && selectedCategoryId && (react_1.default.createElement(robot_question_list_1.default, { robotId: selectedRobotId, categoryId: selectedCategoryId, searchWord: searchWord, agentConfig: agentConfig }))));
};
exports.default = RobotQuestionComp;
