"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var robot_question_item_1 = tslib_1.__importDefault(require("./robot-question-item"));
var axios_1 = tslib_1.__importDefault(require("axios"));
var style_module_scss_1 = tslib_1.__importDefault(require("../style.module.scss"));
var list_1 = tslib_1.__importDefault(require("udesk-ui/es/list"));
var react_infinite_scroller_1 = tslib_1.__importDefault(require("react-infinite-scroller"));
var udesk_ui_1 = require("udesk-ui");
var utilities_1 = require("../../../utilities");
var RobotQuestionList = function (_a) {
    var categoryId = _a.categoryId, robotId = _a.robotId, searchWord = _a.searchWord, agentConfig = _a.agentConfig;
    var _b = (0, react_1.useState)(null), auth = _b[0], setAuth = _b[1];
    var _c = (0, react_1.useState)([]), data = _c[0], setData = _c[1];
    var _d = (0, react_1.useState)(1), page = _d[0], setPage = _d[1];
    var _e = (0, react_1.useState)({ pageNum: 1, pageSize: 20, total: 0 }), paging = _e[0], setPaging = _e[1];
    var _f = (0, react_1.useState)(false), loading = _f[0], setLoading = _f[1];
    var kmApiBase = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext).kmApiBase;
    (0, react_1.useEffect)(function () {
        (0, utilities_1.fetchKnowledgeManagerRobotSettings)().then(function (settings) {
            setAuth(settings.auth);
        });
    }, []);
    (0, react_1.useEffect)(function () {
        setData([]);
        setPage(1);
    }, [categoryId, robotId, searchWord]);
    (0, react_1.useEffect)(function () {
        if (!auth)
            return;
        setLoading(true);
        axios_1.default
            .post("".concat(kmApiBase, "/v1/questions/search?sign=").concat(auth.sign, "&email=").concat(auth.email, "&timestamp=").concat(auth.timestamp, "&appID=").concat(auth.appID), {
            categoryId: categoryId,
            robotId: robotId,
            pageNum: page,
            pageSize: 20,
            searchWord: searchWord,
        })
            .then(function (res) {
            setPaging(res.data.paging);
            setData(function (prevState) { return tslib_1.__spreadArray(tslib_1.__spreadArray([], prevState, true), res.data.data, true); });
        })
            .finally(function () { return setLoading(false); });
    }, [page, categoryId, robotId, auth === null || auth === void 0 ? void 0 : auth.sign, auth === null || auth === void 0 ? void 0 : auth.email, auth === null || auth === void 0 ? void 0 : auth.timestamp, auth === null || auth === void 0 ? void 0 : auth.appID, searchWord]);
    var handleInfiniteOnLoad = (0, react_1.useCallback)(function () {
        if (loading) {
            return;
        }
        setPage(function (prevState) { return prevState + 1; });
    }, [loading]);
    return (react_1.default.createElement("div", { className: style_module_scss_1.default['questionList'] },
        react_1.default.createElement(react_infinite_scroller_1.default, { initialLoad: false, pageStart: 0, loadMore: handleInfiniteOnLoad, hasMore: paging.pageNum * paging.pageSize < paging.total, useWindow: false },
            data.length ? react_1.default.createElement(list_1.default, { dataSource: data, renderItem: function (item) { return react_1.default.createElement(robot_question_item_1.default, { data: item }); } }) : loading ? null : react_1.default.createElement(udesk_ui_1.Empty, { className: style_module_scss_1.default['nodata'] }),
            loading && react_1.default.createElement(udesk_ui_1.Spin, { className: "w-full text-center mt-30" }))));
};
exports.default = RobotQuestionList;
