"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var locale_1 = require("@udesk-webapp/locale");
var FileTextTwoTone_1 = tslib_1.__importDefault(require("@ant-design/icons/FileTextTwoTone"));
var dompurify_1 = tslib_1.__importDefault(require("dompurify"));
var utilities_1 = require("../../../utilities");
var style_module_scss_1 = tslib_1.__importDefault(require("../style.module.scss"));
var RobotQuestionItem = function (_a) {
    var _b, _c, _d;
    var data = _a.data, agentConfig = _a.agentConfig;
    var t = (0, locale_1.useTranslation)().t;
    var _e = (0, react_1.useContext)(utilities_1.RepositoryWidgetContext), onUse = _e.onUse, allowSendQuestion = _e.allowSendQuestion, onSend = _e.onSend, showQuestionModal = _e.showQuestionModal;
    var onUseClick = (0, react_1.useCallback)(function () {
        var _a;
        if ((_a = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.knowledge_config) === null || _a === void 0 ? void 0 : _a.question_use_edit) {
            var robotAnswer = (0, utilities_1.robotToCommonQuestion)(data);
            showQuestionModal === null || showQuestionModal === void 0 ? void 0 : showQuestionModal(robotAnswer, true);
        }
        else {
            onUse === null || onUse === void 0 ? void 0 : onUse('question', (0, utilities_1.robotToCommonQuestion)(data));
        }
    }, [data, onUse, showQuestionModal, (_b = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.knowledge_config) === null || _b === void 0 ? void 0 : _b.question_use_edit]);
    var onSendClick = (0, react_1.useCallback)(function () {
        onSend === null || onSend === void 0 ? void 0 : onSend('question', (0, utilities_1.robotToCommonQuestion)(data));
    }, [data, onSend]);
    return (react_1.default.createElement(udesk_ui_1.Popover, { content: react_1.default.createElement("div", { dangerouslySetInnerHTML: {
                __html: dompurify_1.default.sanitize((_d = (_c = data.answer) === null || _c === void 0 ? void 0 : _c.content) !== null && _d !== void 0 ? _d : ''),
            } }), overlayStyle: { maxWidth: '300px' }, overlayClassName: style_module_scss_1.default.robotQuestionItemPopover, placement: 'left' },
        react_1.default.createElement(udesk_ui_1.List.Item, { className: style_module_scss_1.default['align-justify'] },
            react_1.default.createElement("div", { className: style_module_scss_1.default['file-title'] },
                react_1.default.createElement(FileTextTwoTone_1.default, { className: style_module_scss_1.default['file-icon'] }),
                data.content),
            react_1.default.createElement("div", { className: style_module_scss_1.default['nowrap'] },
                allowSendQuestion ? (react_1.default.createElement(react_1.default.Fragment, null,
                    react_1.default.createElement(udesk_ui_1.Button, { size: 'small', type: 'link', onClick: onSendClick }, t('label.send')),
                    react_1.default.createElement("span", { className: style_module_scss_1.default['line'] }))) : null,
                react_1.default.createElement(udesk_ui_1.Button, { size: 'small', type: 'link', onClick: onUseClick }, t('label.use'))))));
};
exports.default = RobotQuestionItem;
