"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var select_1 = tslib_1.__importDefault(require("udesk-ui/es/select"));
var csApi_1 = require("../../utils/csApi");
var RobotSelect = function (_a) {
    var _b;
    var settings = _a.settings, onDataLoaded = _a.onDataLoaded, props = tslib_1.__rest(_a, ["settings", "onDataLoaded"]);
    var _c = (0, react_1.useState)([]), robotList = _c[0], setRobotList = _c[1];
    (0, react_1.useEffect)(function () {
        (0, csApi_1.csApiGetJSON)('/cs/im/agent/udesk_robots').then(function (res) { return res.data; }).then(function (list) {
            var _a, _b;
            var visibleIds = (_a = settings === null || settings === void 0 ? void 0 : settings.km_join_udesk_robots) === null || _a === void 0 ? void 0 : _a.robot_ids;
            if (visibleIds) {
                var robots = (_b = list === null || list === void 0 ? void 0 : list.udesk_robots.filter(function (i) {
                    return visibleIds.includes(i.km_robot_id);
                })) !== null && _b !== void 0 ? _b : [];
                onDataLoaded(robots);
                setRobotList(robots);
            }
        });
    }, [onDataLoaded, (_b = settings === null || settings === void 0 ? void 0 : settings.km_join_udesk_robots) === null || _b === void 0 ? void 0 : _b.robot_ids]);
    if (!robotList.length) {
        return null;
    }
    return (react_1.default.createElement(select_1.default, tslib_1.__assign({ bordered: false }, props), robotList.map(function (i, idx) {
        return (react_1.default.createElement(select_1.default.Option, { value: i.km_robot_id, key: i.km_robot_id }, i.name));
    })));
};
exports.default = RobotSelect;
