"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var repository_widget_1 = tslib_1.__importDefault(require("./repository-widget"));
var icon_1 = require("@udesk-webapp/icon");
var style_module_scss_1 = tslib_1.__importDefault(require("./style.module.scss"));
var REPOSITORY_WIDTH = 480;
;
var RepositoryWidgetDrawer = function (_a) {
    var _b = _a.top, top = _b === void 0 ? '116px' : _b, // fixed布局top值
    iconTop = _a.iconTop, // fixed布局top值
    persistenceKey = _a.persistenceKey, restProps = tslib_1.__rest(_a, ["top", "iconTop", "persistenceKey"]);
    var _c = (0, react_1.useState)(false), open = _c[0], setOpen = _c[1];
    var _d = (0, react_1.useState)(0), resizeWidth = _d[0], setResizeWidth = _d[1];
    var handleRef = (0, react_1.useRef)(null);
    var rightPanelRef = (0, react_1.useRef)(null);
    var resizeWidthRef = (0, react_1.useRef)(0);
    var iconTopStyle = (0, react_1.useMemo)(function () {
        if (iconTop) {
            return {
                top: iconTop
            };
        }
        return {};
    }, [iconTop]);
    var OpenBar = (0, react_1.useMemo)(function () {
        return (react_1.default.createElement("div", { className: style_module_scss_1.default['repository-open-bar-wrap'], onClick: function () { return setOpen(true); }, style: iconTopStyle },
            react_1.default.createElement(icon_1.BookIcon, null),
            react_1.default.createElement("br", null),
            react_1.default.createElement(icon_1.AngleLeftIcon, null)));
    }, []);
    var CloseBar = (0, react_1.useMemo)(function () {
        return (react_1.default.createElement("div", { className: style_module_scss_1.default['repository-close-bar-wrap'], style: iconTopStyle, onClick: function () { return setOpen(false); } },
            react_1.default.createElement(icon_1.BookIcon, null),
            react_1.default.createElement("br", null),
            react_1.default.createElement(icon_1.AngleRightIcon, null)));
    }, [iconTopStyle]);
    var Repository = (0, react_1.useMemo)(function () {
        if (!open)
            return null;
        return (react_1.default.createElement(react_1.default.Fragment, null,
            CloseBar,
            react_1.default.createElement(repository_widget_1.default, tslib_1.__assign({}, restProps))));
    }, [
        restProps.companyId,
        restProps.email,
        restProps.kmApiBase,
        restProps.previewUrl,
        restProps.roleCan,
        restProps.subdomain,
        restProps.agent,
        restProps.customer,
        restProps.ticket,
        restProps.customerCustomFields,
        restProps.tabs,
        restProps.organizations,
        restProps.customerFieldAbilities,
        restProps.onUse,
        restProps.onSend,
        restProps.onRelate,
        restProps.categoryValue,
        CloseBar,
        open
    ]);
    (0, react_1.useEffect)(function () {
        if (open) { // 读缓存宽度
            if (persistenceKey) {
                var localCacheParams = localStorage.getItem(persistenceKey);
                var n = localCacheParams ? parseInt(localCacheParams) : 0;
                n = n || REPOSITORY_WIDTH;
                setResizeWidth(n);
                resizeWidthRef.current = n;
            }
            else {
                resizeWidthRef.current = REPOSITORY_WIDTH;
                setResizeWidth(REPOSITORY_WIDTH);
            }
        }
        else {
            setResizeWidth(0);
        }
    }, [open]);
    (0, react_1.useEffect)(function () {
        if (!open)
            return;
        var startX = 0;
        var isMove = false;
        var startRightPanelWidth = 0;
        var maxWidth = document.body.clientWidth * 0.8;
        var maskElement = document.createElement('div');
        maskElement.style.cssText =
            'position:fixed;top:0;left:0;right:0;bottom:0;z-index:99999;background:transparent;cursor:col-resize';
        var handleRefCurrent = handleRef.current;
        var mousemove = function (e) {
            if (isMove) {
                var rightWidth = void 0;
                var newRightWidth = startRightPanelWidth + (startX - e.clientX);
                if (newRightWidth >= startRightPanelWidth) {
                    rightWidth = Math.min(newRightWidth, maxWidth);
                }
                else {
                    rightWidth = Math.max(newRightWidth, REPOSITORY_WIDTH);
                }
                if (rightPanelRef === null || rightPanelRef === void 0 ? void 0 : rightPanelRef.current)
                    rightPanelRef.current.style.width = rightWidth + 'px';
                resizeWidthRef.current = rightWidth;
                e.preventDefault();
            }
        };
        var mouseup = function (e) {
            if (isMove) {
                isMove = false;
            }
            persistenceKey && localStorage.setItem(persistenceKey, "".concat(resizeWidthRef.current));
            _destroy();
        };
        var _destroy = function () {
            document.removeEventListener('mouseup', mouseup);
            document.removeEventListener('mousemove', mousemove);
            maskElement.remove();
        };
        var mousedown = function (e) {
            var _a, _b;
            startX = e.clientX;
            isMove = true;
            document.body.appendChild(maskElement);
            startRightPanelWidth = (_b = (_a = rightPanelRef === null || rightPanelRef === void 0 ? void 0 : rightPanelRef.current) === null || _a === void 0 ? void 0 : _a.offsetWidth) !== null && _b !== void 0 ? _b : 0;
            document.addEventListener('mousemove', mousemove);
            document.addEventListener('mouseup', mouseup);
        };
        handleRefCurrent === null || handleRefCurrent === void 0 ? void 0 : handleRefCurrent.addEventListener('mousedown', mousedown);
        return function () {
            handleRefCurrent === null || handleRefCurrent === void 0 ? void 0 : handleRefCurrent.removeEventListener('mousedown', mousedown);
            _destroy();
        };
    }, [open]);
    return (react_1.default.createElement("div", { style: { width: resizeWidth + 'px', top: top }, className: style_module_scss_1.default['repository-widget-drawer-wrap'], ref: rightPanelRef }, !open ? OpenBar : (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement("div", { className: style_module_scss_1.default['resizable-handler'], ref: handleRef }),
        Repository))));
};
exports.default = RepositoryWidgetDrawer;
