"use strict";
var _a, _b, _c;
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var style_module_scss_1 = tslib_1.__importDefault(require("./style.module.scss"));
var tabs_1 = tslib_1.__importDefault(require("udesk-ui/es/tabs"));
var locale_1 = require("@udesk-webapp/locale");
var km_1 = tslib_1.__importDefault(require("./km"));
var question_1 = tslib_1.__importDefault(require("./question"));
var tab_content_1 = tslib_1.__importDefault(require("./components/tab-content"));
var expression_1 = tslib_1.__importDefault(require("./components/expression"));
var link_1 = tslib_1.__importDefault(require("./components/link"));
var attachment_1 = tslib_1.__importDefault(require("./components/attachment"));
var utilities_1 = require("./utilities");
var spin_1 = tslib_1.__importDefault(require("udesk-ui/es/spin"));
var simple_error_boundary_1 = tslib_1.__importDefault(require("./simple-error-boundary"));
var csApi_1 = require("./utils/csApi");
var TabPane = tabs_1.default.TabPane;
var tabComponentMap = (_a = {},
    _a[utilities_1.IM_REPOSITORY_EXPRESSION] = tab_content_1.default,
    _a[utilities_1.IM_REPOSITORY_LINK] = tab_content_1.default,
    _a[utilities_1.IM_REPOSITORY_ATTACHMENT] = tab_content_1.default,
    _a[utilities_1.IM_REPOSITORY_QUESTION] = question_1.default,
    _a);
var tabItemComponentMap = (_b = {},
    _b[utilities_1.IM_REPOSITORY_EXPRESSION] = expression_1.default,
    _b[utilities_1.IM_REPOSITORY_LINK] = link_1.default,
    _b[utilities_1.IM_REPOSITORY_ATTACHMENT] = attachment_1.default,
    _b[utilities_1.IM_REPOSITORY_QUESTION] = null,
    _b);
var tabNameMap = (_c = {},
    _c[utilities_1.IM_REPOSITORY_EXPRESSION] = 'useful_expression',
    _c[utilities_1.IM_REPOSITORY_LINK] = 'useful_link',
    _c[utilities_1.IM_REPOSITORY_QUESTION] = 'question',
    _c[utilities_1.IM_REPOSITORY_ATTACHMENT] = 'attachment',
    _c);
var RepositoryWidget = function (props) {
    var companyId = props.companyId, email = props.email, _a = props.subdomain, subdomain = _a === void 0 ? 'useful_expression' : _a, 
    // onSpaceChange,
    // onCatalogChange,
    onUse = props.onUse, allowSendQuestion = props.allowSendQuestion, showRobotQuestionTab = props.showRobotQuestionTab, onSend = props.onSend, onRelate = props.onRelate, kmApiBase = props.kmApiBase, selectionStateKey = props.selectionStateKey, roleCan = props.roleCan, previewUrl = props.previewUrl, customer = props.customer, ticket = props.ticket, agent = props.agent, ticketCustomFields = props.ticketCustomFields, customerCustomFields = props.customerCustomFields, _b = props.tabs, tabs = _b === void 0 ? [] : _b, public_knowledge_configs = props.public_knowledge_configs, organizations = props.organizations, agentConfig = props.agentConfig, dialogueTagData = props.dialogueTagData, mineChats = props.mineChats, refreshKnowledge = props.refreshKnowledge, 
    //    selectedChat,
    customerFieldAbilities = props.customerFieldAbilities, showQuestionModal = props.showQuestionModal, isWorkbench = props.isWorkbench, host = props.host, allowRelateQuestion = props.allowRelateQuestion, // 是否允许关联问题库
    categoryValue = props.categoryValue;
    var _c = (0, react_1.useState)(), kmSettings = _c[0], setKmSettings = _c[1];
    var t = (0, locale_1.useTranslation)().t;
    var _d = (0, utilities_1.useTabSetting)(), saveTab = _d.saveTab, tabSetting = _d.tabSetting, loading = _d.loading, saveSpace = _d.saveSpace, saveScope = _d.saveScope, saveCatalog = _d.saveCatalog;
    var _e = (0, utilities_1.useSelectionCache)(selectionStateKey, (0, react_1.useMemo)(function () { return ({
        defaultTab: tabSetting === null || tabSetting === void 0 ? void 0 : tabSetting.activeTab,
        defaultScope: tabSetting === null || tabSetting === void 0 ? void 0 : tabSetting.activeScope
    }); }, [tabSetting === null || tabSetting === void 0 ? void 0 : tabSetting.activeScope, tabSetting === null || tabSetting === void 0 ? void 0 : tabSetting.activeTab])), activeTab = _e.activeTab, setActiveTab = _e.setActiveTab, query = _e.query, setQuery = _e.setQuery, activeScope = _e.activeScope, setActiveScope = _e.setActiveScope;
    (0, react_1.useEffect)(function () {
        (0, csApi_1.csApiGetJSON)('/cs/ts/api/knowledge_manager_settings').then(function (res) { return res.data; }).then(function (res) {
            setKmSettings(res.knowledge_manager_setting);
        });
        // 从外部传进来的 自定义知识库
    }, []);
    var onTabChange = (0, react_1.useCallback)(function (tabKey) {
        saveTab(tabKey);
        setActiveTab(tabKey);
    }, [saveTab, setActiveTab]);
    var onScopeChange = (0, react_1.useCallback)(function (_scope) {
        saveScope(_scope);
        setActiveScope(_scope);
    }, [saveScope, setActiveScope]);
    var chat = (mineChats === null || mineChats === void 0 ? void 0 : mineChats.find(function (chat) { return chat.selected; })) || {};
    var tagNameArray = (0, react_1.useMemo)(function () {
        var _a, _b, _c, _d;
        if (((_a = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.session_tags_config) === null || _a === void 0 ? void 0 : _a.enable) &&
            (dialogueTagData === null || dialogueTagData === void 0 ? void 0 : dialogueTagData.length) &&
            ((_b = chat.dialogueTag) === null || _b === void 0 ? void 0 : _b.length)) {
            if (((_c = agentConfig.session_tags_config) === null || _c === void 0 ? void 0 : _c.mode_tags) === 'first') {
                return chat.dialogueTag[0].map(function (i) { var _a; return (_a = dialogueTagData === null || dialogueTagData === void 0 ? void 0 : dialogueTagData.find(function (j) { return j.id === i; })) === null || _a === void 0 ? void 0 : _a.name; }).filter(function (i) { return !!i; });
            }
            else if (((_d = agentConfig.session_tags_config) === null || _d === void 0 ? void 0 : _d.mode_tags) === 'new') {
                return chat.dialogueTag[chat.dialogueTag.length - 1].map(function (i) { var _a; return (_a = dialogueTagData === null || dialogueTagData === void 0 ? void 0 : dialogueTagData.find(function (j) { return j.id === i; })) === null || _a === void 0 ? void 0 : _a.name; }).filter(function (i) { return !!i; });
            }
        }
        return [];
    }, [agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.session_tags_config, chat.dialogueTag, dialogueTagData]);
    // const tagName = useMemo(() => {
    //     if (agentConfig?.session_tags_config?.enable
    //         && agentConfig.session_tags_config?.show_mode === 'keyword'
    //         && tagNameArray.length > 0) {
    //         return tagNameArray.join(' ');
    //     }
    //     return '';
    // }, [agentConfig?.session_tags_config?.enable, agentConfig?.session_tags_config?.show_mode, tagNameArray]);
    // const tagsList = useMemo(() => {
    //     if (agentConfig?.session_tags_config?.enable
    //         && agentConfig.session_tags_config?.show_mode === 'type'
    //         && tagNameArray.length > 0) {
    //         return tagNameArray;
    //     }
    //     return [];
    // }, [agentConfig?.session_tags_config?.enable, agentConfig?.session_tags_config?.show_mode, tagNameArray]);
    var contextValue = (0, react_1.useMemo)(function () { return ({
        allowSendQuestion: allowSendQuestion,
        onUse: onUse,
        showRobotQuestionTab: showRobotQuestionTab,
        onSend: onSend,
        onRelate: onRelate,
        kmApiBase: kmApiBase,
        activeScope: activeScope,
        onScopeChange: onScopeChange,
        activeCatalog: tabSetting === null || tabSetting === void 0 ? void 0 : tabSetting.activeCatalog,
        onCatalogChange: saveCatalog,
        activeSpace: tabSetting === null || tabSetting === void 0 ? void 0 : tabSetting.activeSpace,
        onSpaceChange: saveSpace,
        roleCan: roleCan,
        previewUrl: previewUrl,
        customer: customer,
        ticket: ticket,
        agent: agent,
        ticketCustomFields: ticketCustomFields,
        customerCustomFields: customerCustomFields,
        public_knowledge_configs: public_knowledge_configs,
        organizations: organizations,
        refreshKnowledge: refreshKnowledge,
        customerFieldAbilities: customerFieldAbilities,
        showQuestionModal: showQuestionModal,
        isWorkbench: isWorkbench,
        host: host,
        allowRelateQuestion: allowRelateQuestion,
        categoryValue: categoryValue
    }); }, [
        activeScope,
        allowSendQuestion,
        kmApiBase,
        onScopeChange,
        onSend,
        onRelate,
        onUse,
        saveCatalog,
        saveSpace,
        roleCan,
        showRobotQuestionTab,
        tabSetting === null || tabSetting === void 0 ? void 0 : tabSetting.activeCatalog,
        tabSetting === null || tabSetting === void 0 ? void 0 : tabSetting.activeSpace,
        previewUrl,
        customer,
        ticket,
        agent,
        ticketCustomFields,
        customerCustomFields,
        public_knowledge_configs,
        organizations,
        refreshKnowledge,
        customerFieldAbilities,
        showQuestionModal,
        isWorkbench,
        host,
        allowRelateQuestion,
        categoryValue
    ]);
    var ref = (0, react_1.useRef)(null);
    if (loading || !kmSettings) {
        return react_1.default.createElement(spin_1.default, { className: "mt-30" });
    }
    return react_1.default.createElement(simple_error_boundary_1.default, { t: t },
        react_1.default.createElement(utilities_1.RepositoryWidgetContext.Provider, { value: contextValue },
            react_1.default.createElement("div", { ref: ref, className: style_module_scss_1.default.container },
                react_1.default.createElement("div", { className: style_module_scss_1.default.kmContent },
                    react_1.default.createElement(tabs_1.default, { activeKey: activeTab, onChange: onTabChange, size: 'small', animated: false, type: 'card', destroyInactiveTabPane: true, className: "".concat(style_module_scss_1.default.tabsWrap, " repositoryTabsWrap") }, tabs.filter(function (i) { return i.is_displayed; }).map(function (i) {
                        var _a;
                        if (i.order_id === utilities_1.IM_REPOSITORY_ROBOT_KM) {
                            return (kmSettings === null || kmSettings === void 0 ? void 0 : kmSettings.name) ? react_1.default.createElement(TabPane, { tab: kmSettings.name, key: 'km' },
                                react_1.default.createElement(simple_error_boundary_1.default, { t: t },
                                    react_1.default.createElement(km_1.default, tslib_1.__assign({}, kmSettings, { companyId: companyId, email: email, subdomain: subdomain, query: query, onSearch: setQuery })))) : null;
                        }
                        var TabComponent = tabComponentMap[i.order_id];
                        return (react_1.default.createElement(TabPane, { tab: i.name, key: tabNameMap[i.order_id] },
                            react_1.default.createElement(simple_error_boundary_1.default, { t: t },
                                react_1.default.createElement(TabComponent, { query: query, onSearch: setQuery, refreshKnowledge: refreshKnowledge, roleCan: roleCan, customerFieldAbilities: customerFieldAbilities, stashKey: selectionStateKey, knowledgeType: tabNameMap[i.order_id], itemNode: tabItemComponentMap[i.order_id], 
                                    // dialogueTagName={tagName}
                                    dialogueTagNameList: tagNameArray, dialogueTagMode: (_a = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.session_tags_config) === null || _a === void 0 ? void 0 : _a.show_mode, dialogueTagData: dialogueTagData }))));
                    }))))));
};
exports.default = RepositoryWidget;
