"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var SearchOutlined_1 = tslib_1.__importDefault(require("@ant-design/icons/SearchOutlined"));
var useDebounce_1 = tslib_1.__importDefault(require("react-use/esm/useDebounce"));
var style_module_scss_1 = tslib_1.__importDefault(require("./style.module.scss"));
var locale_1 = require("@udesk-webapp/locale");
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var SearchInput = function (_a) {
    var onSearch = _a.onSearch, defaultValue = _a.defaultValue, className = _a.className;
    var _b = (0, react_1.useState)(''), keyword = _b[0], setKeyword = _b[1];
    var onChange = (0, react_1.useCallback)(function (e) { return setKeyword(e.target.value); }, []);
    var t = (0, locale_1.useTranslation)().t;
    (0, react_1.useEffect)(function () {
        setKeyword(defaultValue || '');
    }, [defaultValue]);
    (0, useDebounce_1.default)(function () {
        onSearch(keyword);
    }, 500, [onSearch, keyword]);
    var suffix = (0, react_1.useMemo)(function () {
        if (keyword) {
            return null;
        }
        else {
            return react_1.default.createElement(SearchOutlined_1.default, null);
        }
    }, [keyword]);
    return react_1.default.createElement(udesk_ui_1.Input, { value: keyword, onChange: onChange, suffix: suffix, allowClear: true, placeholder: t('label.input_keyword'), className: (0, classnames_1.default)(className, style_module_scss_1.default['mgb-7']) });
};
exports.default = SearchInput;
