"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var SimpleErrorBoundary = /** @class */ (function (_super) {
    tslib_1.__extends(SimpleErrorBoundary, _super);
    function SimpleErrorBoundary(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            hasError: false
        };
        return _this;
    }
    SimpleErrorBoundary.getDerivedStateFromError = function (error) {
        // 更新 state 使下一次渲染能够显示降级后的 UI
        return { hasError: true };
    };
    SimpleErrorBoundary.prototype.componentDidCatch = function (error, errorInfo) {
        var _a;
        if (process.env.NODE_ENV !== 'development') {
            (_a = window.Sentry) === null || _a === void 0 ? void 0 : _a.captureException(error);
        }
        console.error('error', error);
    };
    SimpleErrorBoundary.prototype.render = function () {
        var t = this.props.t;
        if (this.state.hasError) {
            return react_1.default.createElement(react_1.default.Fragment, null, this.props.type === 'message' ? t('msgError') : t('simpleError'));
        }
        return this.props.children;
    };
    return SimpleErrorBoundary;
}(react_1.Component));
exports.default = (SimpleErrorBoundary);
