"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _react = _interopRequireWildcard(require("react"));

var _th = _interopRequireDefault(require("./th"));

var _throttle = _interopRequireDefault(require("lodash-es/throttle"));

function getScrollParent(node) {
  var isElement = node instanceof HTMLElement;
  var overflowX = isElement && window.getComputedStyle(node).overflowX;
  var isScrollable = overflowX !== 'visible' && overflowX !== 'hidden';

  if (!node) {
    return null;
  } else if (isScrollable && node.scrollWidth >= node.clientWidth) {
    return node;
  }

  return getScrollParent(node.parentNode) || document.body;
}

var Thead = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(Thead, _Component);

  function Thead() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;
    _this._ref = /*#__PURE__*/_react["default"].createRef();
    _this._thWrapper = /*#__PURE__*/_react["default"].createRef();
    _this._thWrapperWidth = 0;
    _this._draggingTh = null;
    _this._draggingThLeft = 0;
    _this._draggingThRect = {};
    _this._nextTh = null;
    _this._nextThRect = {};
    _this._prevTh = null;
    _this._prevThRect = {};
    _this._sortingTh = null;
    _this._dragTargetTh = null;
    _this._dragTargetColumn = null;
    _this._beforeMouseClientX = 0;
    _this._scrollBox = null;
    _this._scrollBoxRect = {};
    _this._isMouseDown = false;

    _this._onDndMouseDown = function (e, dragTargetColumn) {
      if (!_this._thWrapper.current) {
        return;
      }

      _this._isMouseDown = true; // 记录正在拖拽的元素
      // 记录当前鼠标位置

      _this._beforeMouseClientX = e.clientX;
      _this._dragTargetTh = e.currentTarget;
      _this._dragTargetColumn = dragTargetColumn;
      console.log('_onDndMouseDown');
    };

    _this._mouseMove = function (e) {
      if (!_this._isMouseDown) {
        return;
      }

      var offset = e.clientX - _this._beforeMouseClientX;
      console.log('_mouseMove', offset); //点击时可能会抖动 水平拖拽超过1认为是拖拽

      if (Math.abs(offset) <= 1) {
        return;
      }

      _this._createDraggingTh();

      _this._draggingThLeft += offset;
      _this._draggingThRect.left += offset;

      _this._updateDraggingThPosition(_this._draggingThRect.left);

      _this._beforeMouseClientX = e.clientX;

      _this._scroll(offset);

      _this._moveTh();
    };

    _this._mouseUp = function () {
      console.log('_mouseUp');
      _this._isMouseDown = false;

      if (!_this._dragTargetTh) {
        return;
      }

      var onColumnPlaceChange = _this.props.onColumnPlaceChange;
      console.log('this._dragTargetColumn', _this._dragTargetColumn, _this._dragTargetColumn && typeof onColumnPlaceChange === 'function');

      if (_this._dragTargetColumn && typeof onColumnPlaceChange === 'function' && (_this._prevTh || _this._nextTh)) {
        var sortingThIndex = parseInt(_this._dragTargetTh.dataset.columnIndex, 10);
        var newIndex = sortingThIndex;
        console.log('sortingThIndex', sortingThIndex, newIndex);

        if (!_this._prevTh) {
          newIndex = 0;
        } else if (!_this._nextTh) {
          newIndex = _this.props.columns.length - 1;
        } else {
          var prevThIndex = parseInt(_this._prevTh.dataset.columnIndex, 10); //$FlowFixMe

          var nextThIndex = parseInt(_this._nextTh.dataset.columnIndex, 10);

          if (sortingThIndex < prevThIndex) {
            newIndex = prevThIndex;
          } else if (sortingThIndex > nextThIndex) {
            newIndex = nextThIndex;
          }
        }

        console.log('newIndex', sortingThIndex, newIndex);

        if (sortingThIndex !== newIndex) {
          //$FlowFixMe
          onColumnPlaceChange(_this._dragTargetColumn, sortingThIndex, newIndex);
        }
      }

      if (_this._draggingTh) {
        _this._draggingTh.remove();
      }

      if (_this._dragTargetTh) {
        //$FlowFixMe
        _this._dragTargetTh.className = _this._dragTargetTh.className.replace(/ ?drag-target-element/g, '');
      }

      if (_this._ref.current) {
        //$FlowFixMe
        _this._ref.current.className = _this._ref.current.className.replace(/ ?dragging/g, '');
      }

      _this._draggingTh = null;
      _this._draggingThRect = {};
      _this._draggingThLeft = 0;
      _this._nextTh = null;
      _this._nextThRect = {};
      _this._prevTh = null;
      _this._prevThRect = {};
      _this._scrollBox = null;
      _this._scrollBoxRect = {};
      _this._dragTargetTh = null; //销毁后不会触发click事件

      _this._dragTargetColumn = null;
    };

    _this._throttleMouseMove = (0, _throttle["default"])(_this._mouseMove, 50);
    return _this;
  }

  var _proto = Thead.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        checkbox = _this$props.checkbox,
        checkboxChecked = _this$props.checkboxChecked,
        onCheckboxChange = _this$props.onCheckboxChange,
        columns = _this$props.columns,
        dnd = _this$props.dnd,
        sortingColumns = _this$props.sortingColumns,
        _onSort = _this$props.onSort,
        t = _this$props.t;
    return /*#__PURE__*/_react["default"].createElement("thead", {
      ref: this._ref
    }, /*#__PURE__*/_react["default"].createElement("tr", {
      ref: this._thWrapper
    }, checkbox && /*#__PURE__*/_react["default"].createElement("th", null, /*#__PURE__*/_react["default"].createElement("input", {
      type: "checkbox",
      checked: checkboxChecked,
      onChange: onCheckboxChange
    })), columns.map(function (i, idx) {
      return /*#__PURE__*/_react["default"].createElement(_th["default"], {
        key: i.id,
        dnd: dnd,
        columnIndex: idx,
        sortable: i.sortable,
        sortDirection: sortingColumns && sortingColumns[i.id],
        onSort: function onSort(direction) {
          if (typeof _onSort === 'function') {
            console.log('onSort');
            return _onSort(i, direction, idx);
          }
        },
        onDndMouseDown: function onDndMouseDown(e) {
          return _this2._onDndMouseDown(e, i);
        }
      }, i.name || t(i.id));
    })));
  } //计算排序节点的前一个和后一个节点，随着排序节点位置的变化，其前后节点也随之改变
  ;

  _proto._resetDraggingThSiblings = function _resetDraggingThSiblings() {
    console.log('_resetDraggingThSiblings', this._dragTargetTh);

    if (this._dragTargetTh && this._dragTargetTh.previousElementSibling && this._dragTargetTh.previousElementSibling.hasAttribute('data-column-index')) {
      this._prevTh = this._dragTargetTh.previousElementSibling;
    } else {
      this._prevTh = null;
    }

    this._prevThRect = this._prevTh ? this._prevTh.getBoundingClientRect() : {};

    if (this._dragTargetTh && this._dragTargetTh.nextElementSibling && this._dragTargetTh.nextElementSibling.hasAttribute('data-column-index')) {
      this._nextTh = this._dragTargetTh.nextElementSibling;
    } else {
      this._nextTh = null;
    }

    this._nextThRect = this._nextTh ? this._nextTh.getBoundingClientRect() : {};
  };

  _proto._createDraggingTh = function _createDraggingTh() {
    if (this._draggingTh || !this._dragTargetTh) {
      return;
    }

    var thWrapperLeft = this._thWrapper.current.getBoundingClientRect().left;

    var dragTargetThRect = this._dragTargetTh.getBoundingClientRect();

    var _this$_draggingThRect = this._draggingThRect = {
      left: dragTargetThRect.left,
      width: dragTargetThRect.width,
      height: dragTargetThRect.height
    },
        draggingThLeft = _this$_draggingThRect.left,
        height = _this$_draggingThRect.height,
        width = _this$_draggingThRect.width; // 记录前一个和后一个节点


    this._resetDraggingThSiblings();
    /**
     * 复制当前准备拖动的元素，
     * 并将复制后的元素的外观位置和被复制元素保持一致
     */


    var draggingThClone = this._draggingTh = this._dragTargetTh.cloneNode(true);

    draggingThClone.className += ' dragging-element';
    this._draggingThLeft = draggingThLeft - thWrapperLeft;

    this._updateDraggingThPosition(draggingThLeft);

    draggingThClone.style.width = width + 'px';
    draggingThClone.style.height = height + 'px';
    draggingThClone.style.top = dragTargetThRect.top + 'px'; // 原始元素被一层白色div遮罩

    this._dragTargetTh.className += ' drag-target-element'; // 给当前thead加一个dragging的类

    if (this._ref.current) {
      this._ref.current.className += ' dragging';
    } // 将复制的元素加入到tr里


    if (this._thWrapper.current) {
      this._thWrapperWidth = this._thWrapper.current.offsetWidth;

      this._thWrapper.current.appendChild(this._draggingTh);
    } // 获取最近的滚动容器


    this._scrollBox = getScrollParent(this._ref.current);

    if (this._scrollBox) {
      this._scrollBoxRect = this._scrollBox.getBoundingClientRect();
    }
  };

  _proto._updateDraggingThPosition = function _updateDraggingThPosition(newPosition) {
    if (this._draggingTh) {
      this._draggingTh.style.left = newPosition + "px";
    }
  };

  _proto._scroll = function _scroll(offset) {
    if (offset > 0 && this._draggingThRect.left > this._scrollBoxRect.left + this._scrollBoxRect.width - 200 || offset < 0 && this._draggingThRect.left < this._scrollBoxRect.left + 200) {
      var scrollWidth = offset > 0 ? offset + 10 : offset - 10;
      this._draggingThLeft += scrollWidth;

      if (this._scrollBox) {
        this._scrollBox.scrollLeft += scrollWidth;
      }

      if (this._nextTh) {
        this._nextThRect = this._nextTh.getBoundingClientRect();
      }

      if (this._prevTh) {
        this._prevThRect = this._prevTh.getBoundingClientRect();
      }
    }
  };

  _proto._moveTh = function _moveTh() {
    if (this._thWrapper.current && this._nextTh && this._draggingThRect.left > this._nextThRect.left + this._nextThRect.width / 2) {
      this._thWrapper.current.insertBefore(this._dragTargetTh, this._nextTh.nextElementSibling);

      this._resetDraggingThSiblings();
    } else if (this._thWrapper.current && this._draggingThRect.left < this._prevThRect.left + this._prevThRect.width / 2) {
      this._thWrapper.current.insertBefore(this._dragTargetTh, this._prevTh);

      this._resetDraggingThSiblings();
    }
  };

  _proto.componentDidMount = function componentDidMount() {
    var dnd = this.props.dnd;

    if (dnd) {
      document.addEventListener('mouseup', this._mouseUp);
      document.addEventListener('mousemove', (0, _throttle["default"])(this._throttleMouseMove)); //document.addEventListener('mousemove', this._mouseMove);
    }
  };

  _proto.componentWillMount = function componentWillMount() {
    document.removeEventListener('mouseup', this._mouseUp);
    document.removeEventListener('mousemove', this._throttleMouseMove);
  };

  return Thead;
}(_react.Component);

Thead.defaultProps = {
  t: function t(key) {
    return key;
  }
};
var _default = Thead;
exports["default"] = _default;