"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFileType = exports.loadScript = exports.loadStyle = exports.getStanardFileSizeSuffixes = exports.removeHTMLTag = exports.handleText = exports.replaceWordEmotions = exports.replaceWechatEmotions = exports.replaceEmotions = exports.escapeXSS = exports.getTencentMap = exports.imageThumbnail = exports.update_sdk_url = exports.useAddToCustomerMenuItem = void 0;
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var lodash_es_1 = require("lodash-es");
var PlusOutlined_1 = tslib_1.__importDefault(require("@ant-design/icons/PlusOutlined"));
var react_i18next_1 = require("react-i18next");
var dompurify_1 = tslib_1.__importDefault(require("dompurify"));
var emojiData_1 = tslib_1.__importDefault(require("./emojiData"));
var lodash_1 = require("lodash");
var pdf02_png_1 = tslib_1.__importDefault(require("./images/pdf02.png"));
var word02_png_1 = tslib_1.__importDefault(require("./images/word02.png"));
var excel02_png_1 = tslib_1.__importDefault(require("./images/excel02.png"));
var ppt02_png_1 = tslib_1.__importDefault(require("./images/ppt02.png"));
var txt02_png_1 = tslib_1.__importDefault(require("./images/txt02.png"));
var unknow02_png_1 = tslib_1.__importDefault(require("./images/unknow02.png"));
var telReg = /\b(((\+\d\d)?1\d{10})|((0\d{2,3}-?)\d{7,8}))\b/g;
var emailReg = /((\w)+(\.\w+)*@(\w)+((\.\w+)+))/g;
var useAddToCustomerMenuItem = function (allowAddToCustomerInfo, content) {
    var t = (0, react_i18next_1.useTranslation)().t;
    var tels = (0, react_1.useMemo)(function () { return (0, lodash_es_1.uniq)(JSON.stringify(content).match(telReg)); }, [content]);
    var emails = (0, react_1.useMemo)(function () { return (0, lodash_es_1.uniq)(JSON.stringify(content).match(emailReg)); }, [content]);
    var addToCustomerInfoMenu = (0, react_1.useMemo)(function () {
        if (allowAddToCustomerInfo && (tels.length + emails.length) > 1) {
            return react_1.default.createElement("div", { title: t('page.im.log.addToCustomerInfo') },
                tels.map(function (i) { return react_1.default.createElement("div", { key: i },
                    react_1.default.createElement(PlusOutlined_1.default, null),
                    i); }),
                emails.map(function (i) { return react_1.default.createElement("div", { key: i },
                    react_1.default.createElement(PlusOutlined_1.default, null),
                    i); }));
        }
        else if (allowAddToCustomerInfo && (tels.length + emails.length) === 1) {
            var contact = tels[0] || emails[0];
            return react_1.default.createElement("div", null, t('page.im.log.addToCustomerInfo'));
        }
        return null;
    }, [allowAddToCustomerInfo, emails, t, tels]);
    return [addToCustomerInfoMenu];
};
exports.useAddToCustomerMenuItem = useAddToCustomerMenuItem;
function update_sdk_url(url, obj) {
    obj = obj || {};
    var is_receive = obj.is_receive, platform = obj.platform;
    var result = url;
    return result;
}
exports.update_sdk_url = update_sdk_url;
function getUrlBacket(url) {
    if (!url)
        return;
    var qiniuReg = /qn-im\.udesk\.cn|qn-public\.udesk\.cn|qn-private\.udesk\.cn/i;
    var qiniuRegNew = /qbox\.me/i;
    var aliReg = /aliyuncs\.com/i;
    var aliRegNew = /kefutoutiao\.com/i;
    var minioReg = /47\.94\.16\.154:9000/i; // 暂定,本地化需修改这个值
    if (qiniuReg.test(url) || qiniuRegNew.test(url)) {
        return 'qiniu';
    }
    else if (aliReg.test(url) || aliRegNew.test(url)) {
        return 'ali';
    }
    else if (minioReg.test(url)) {
        return 'minio';
    }
    else {
        return null;
    }
}
function imageThumbnail(url, policy, fileSize) {
    if (policy === void 0) { policy = ''; }
    if (!url) {
        return '';
    }
    if (!policy) {
        policy = getUrlBacket(url);
    }
    if (policy === 'qiniu') {
        url = (url.split('?')[0] + '?imageMogr2/auto-orient/thumbnail/300x300>');
    }
    else if (policy === 'ali') {
        if (url.indexOf('Signature') === -1 || Number.parseInt(fileSize) >= 50) {
            /* gif图片不加后缀(图片添加旋转纠正参数后不动了)    大于20M图片不加后缀(加后缀IM工作台无法显示) */
            if (/\.gif$/.test(url)) {
                url = url.split('?')[0];
            }
            else {
                url = url.split('?')[0] + '?x-oss-process=image/auto-orient,0/resize,l_300';
            }
        }
        // eslint-disable-next-line no-empty
    }
    else if (policy === 'minio') {
    }
    return url;
}
exports.imageThumbnail = imageThumbnail;
function getTencentMap(params) {
    var imgUrl = 'http://apis.map.qq.com/ws/staticmap/v2/', mapUrl = 'http://apis.map.qq.com/uri/v1/marker', key = 'NFFBZ-QGA3P-66OD5-LDYQH-GHTEV-CWBUV';
    try {
        var locationData = params.split(';') || ['0', '0', '', ''];
        var local = locationData[0] + ',' + locationData[1];
        var zoom = locationData[2] || 16;
        var localName = locationData[3] || '位置';
        // '&labels=anchor:3|offset:0_-50|bgcolor:yellow|' + localName + '|' + local +
        return {
            img_src: imgUrl + '?key=' + key + '&size=200*150&center=' + local + '&zoom=' + zoom + '&markers=' + local,
            map_src: mapUrl + '?marker=coord:' + local + ';title:位置信息;addr:' + localName
        };
    }
    catch (e) {
        return {};
    }
}
exports.getTencentMap = getTencentMap;
function escapeXSS(str, canHtml) {
    str = str + '';
    if (str) {
        if ((str.search('/:') === -1) && !canHtml) {
            str = str.replace(/</g, '&lt;').replace(/>/g, '&gt;');
        }
        return str.replace(/\n/g, '<br>').replace(/%26/g, '&').replace(/%25/g, '%'); //%26为api类型特殊用途;
    }
    return '';
}
exports.escapeXSS = escapeXSS;
function replaceEmotions(text) {
    return (text + '').replace(/\[[e|E]moji([^\].]+)\]/g, '<span class="emoji emoji$1"></span>');
}
exports.replaceEmotions = replaceEmotions;
function replaceWechatEmotions(text, twemoji) {
    if (twemoji === void 0) { twemoji = false; }
    var emojiArr = emojiData_1.default.getWechatData();
    text = (text + '').replace(/&gt;/g, '>').replace(/&lt;/g, '<').replace(/&#39;/g, '\'').replace(/\/::$/, '/:: ').replace(/&amp;/g, '&');
    (0, lodash_1.each)(emojiArr, function (item) {
        var reg = new RegExp(item.regcode, 'g');
        if (twemoji) {
            text = text.replace(reg, '<span class="wechat-emoji twemoji">' + item.twemoji + '</span>');
        }
        else {
            if (text.includes('richText')) {
                text = text.replace(reg, '<span class=\\"wechat-emoji ' + item.clz + '\\"></span>');
            }
            else {
                text = text.replace(reg, '<span class="wechat-emoji ' + item.clz + '"></span>');
            }
        }
    });
    return text;
}
exports.replaceWechatEmotions = replaceWechatEmotions;
function replaceWordEmotions(text, platform) {
    var isWechatEmoji = platform === 'wechat' || platform === 'api' || platform === 'weixin_mini' || platform === 'qywx' || platform === 'web' || platform === 'weixin_kf';
    var emojiArr = isWechatEmoji ? emojiData_1.default.getWechatData() : emojiData_1.default.getSdkData();
    if (platform === 'line') {
        emojiArr = emojiData_1.default.getWebData();
    }
    else if (platform === 'qywx') {
        emojiArr = emojiData_1.default.getQywxData();
    }
    else if (platform === 'weixin_kf') {
        emojiArr = emojiData_1.default.getWeixin_kfData();
    }
    (0, lodash_1.each)(emojiArr, function (item) {
        var reg = new RegExp(item.regtext, 'g');
        text = text.replace(reg, "<span class=\"".concat(isWechatEmoji ? 'wechat-' : '', "emoji ") + item.clz + '"></span>');
    });
    return text;
}
exports.replaceWordEmotions = replaceWordEmotions;
//富文本样式
function handleText(chatPlatform, msg) {
    //处理content
    var telReg = /\b(((\+\d\d)?1\d{10})|((0\d{2,3}-?)\d{7,8}))\b/g;
    var emailReg = /((\w)+(\.\w+)*@(\w)+((\.\w+)+))/g;
    var content = escapeXSS(msg.content, false);
    var reg = /((http|https):\/\/([\w-]+\.)+[\w-:]+(\/[\w-./?;%+&=#：]*)?)/;
    var isLink = reg.test(content);
    var twemoji = msg.twemoji;
    content = (content + '').replace(/((http|https):\/\/([\w-]+\.)+[\w-:]+(\/[\w-./?;%+&=#：:]*)?)/g, '<a href="$1" target="_blank">$1</a>');
    if (content.search('/:') > -1) {
        content = replaceWechatEmotions(content, twemoji);
    }
    else if ((content || '').indexOf('[') > -1 && (content || '').indexOf('[emoji') < 0) {
        content = replaceWordEmotions(content, chatPlatform);
    }
    else {
        content = replaceEmotions(content);
    }
    if (!isLink) {
        content = content.replace(telReg, '<a>$1</a>').replace(emailReg, '<a>$1</a>');
    }
    // 如果是链接  不进行xss处理  否则target会被过滤掉
    if (isLink) {
        return "<div style=".concat(msg.font || '', ">").concat(content, "</div>");
    }
    else {
        return "<div style=".concat(msg.font || '', ">").concat(dompurify_1.default.sanitize(content), "</div>");
    }
}
exports.handleText = handleText;
function removeHTMLTag(str) {
    if (!str) {
        return '';
    }
    str = str.replace(/<\/?[^>]*>/g, ''); //去除HTML tag
    // str = str.replace(/[ | ]*\n/g, '\n'); //去除行尾空白
    //str = str.replace(/\n[\s| | ]*\r/g,'\n'); //去除多余空行
    str = str.replace(/&nbsp;/ig, ' '); //去掉&nbsp;
    return str;
}
exports.removeHTMLTag = removeHTMLTag;
function getStanardFileSizeSuffixes(sizeStr) {
    if (!sizeStr) {
        return '';
    }
    if (typeof sizeStr === 'number') {
        sizeStr = sizeStr + 'B';
    }
    var reg = /[a-zA-Z]{1,2}/i;
    var suffixes = {
        B: 'B',
        K: 'KB',
        M: 'MB',
        G: 'GB',
        T: 'TB',
        KB: 'KB',
        MB: 'MB',
        GB: 'GB',
        TB: 'TB'
    };
    var newStr = sizeStr.replace(reg, function (match) {
        return suffixes[match.toUpperCase()] || match.toUpperCase();
    });
    return newStr;
}
exports.getStanardFileSizeSuffixes = getStanardFileSizeSuffixes;
exports.loadStyle = (0, lodash_1.memoize)(function (href) {
    if (!href) {
        return;
    }
    var head = document.head;
    var link = document.createElement("link");
    link.type = 'text/css';
    link.rel = 'stylesheet';
    link.href = href;
    head.appendChild(link);
});
exports.loadScript = (0, lodash_1.memoize)(function (src) {
    return new Promise(function (resolve, reject) {
        if (!src) {
            reject(new Error('src is required'));
            return;
        }
        var script = document.createElement('script');
        script.src = src;
        script.async = true;
        script.addEventListener('load', function () {
            resolve(script);
        });
        script.addEventListener('error', function (error) {
            var _a;
            script.remove();
            reject(error);
            (_a = exports.loadStyle === null || exports.loadStyle === void 0 ? void 0 : exports.loadStyle.cache) === null || _a === void 0 ? void 0 : _a.delete(src);
        });
        document.body.appendChild(script);
    });
});
var getFileType = function (type) {
    if (typeof type !== 'string')
        return unknow02_png_1.default;
    if (/\.(pdf)/.test(type)) {
        type = pdf02_png_1.default;
    }
    else if (/\.(doc|docx|odt)/.test(type)) {
        type = word02_png_1.default;
    }
    else if (/\.(xls|xlsx|csv)/.test(type)) {
        type = excel02_png_1.default;
    }
    else if (/\.(ppt|pptx)/.test(type)) {
        type = ppt02_png_1.default;
    }
    else if (/\.(txt)/.test(type)) {
        type = txt02_png_1.default;
    }
    else {
        type = unknow02_png_1.default;
    }
    return type;
};
exports.getFileType = getFileType;
