"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadScript = exports.loadStyle = void 0;
var lodash_1 = require("lodash");
exports.loadStyle = (0, lodash_1.memoize)(function (href) {
    if (!href) {
        return;
    }
    var head = document.head;
    var link = document.createElement('link');
    link.type = 'text/css';
    link.rel = 'stylesheet';
    link.href = href;
    head.appendChild(link);
});
exports.loadScript = (0, lodash_1.memoize)(function (src) {
    return new Promise(function (resolve, reject) {
        if (!src) {
            reject(new Error('src is required'));
            return;
        }
        var script = document.createElement('script');
        script.src = src;
        script.async = true;
        script.addEventListener('load', function () {
            resolve(script);
        });
        script.addEventListener('error', function (error) {
            script.remove();
            reject(error);
            exports.loadStyle.cache.delete(src);
        });
        document.body.appendChild(script);
    });
});
