import { AxiosRequestConfig, Method } from 'axios';
export declare const axiosInstance: import("axios").AxiosInstance;
interface AxiosOption extends AxiosRequestConfig {
    /**
     * 不添加任何自定义header，如果跨域调用外部系统（比如排班后台）接口，额外的自定义header会导致跨域失败，
     * 因为这些header没有在跨域白名单里
     *
     * @type {boolean}
     * @memberof AxiosOption
     */
    noCustomHeader?: boolean;
}
export declare function request(options: Omit<AxiosOption, 'url' | 'method'> & {
    url: string;
    method: Method;
}): Promise<any>;
export declare function getJSON<T = any>(url: string, params?: any, options?: AxiosOption): Promise<T>;
export declare function postJSON(url: string, params?: any, options?: AxiosOption): Promise<any>;
export declare function post(url: string, params?: any, options?: AxiosOption): Promise<any>;
export declare function putJSON(url: string, params?: any, options?: AxiosOption): Promise<any>;
export declare function deleteJSON(url: string, params?: any, options?: AxiosOption): Promise<any>;
export declare function getCsrfToken(): any;
export {};
