"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCsrfToken = exports.deleteJSON = exports.putJSON = exports.post = exports.postJSON = exports.getJSON = exports.request = exports.axiosInstance = void 0;
var tslib_1 = require("tslib");
var axios_1 = tslib_1.__importDefault(require("axios"));
var js_cookie_1 = tslib_1.__importDefault(require("js-cookie"));
var merge_1 = tslib_1.__importDefault(require("lodash-es/merge"));
var utils_1 = require("@udesk-webapp/utils");
// axios.defaults.baseURL = 'http://reocar.b3.tryudesk.com/spa1';
// axios.defaults.baseURL = 'http://reocar.ud.com/spa1';
exports.axiosInstance = axios_1.default.create({
    baseURL: '/spa1'
});
function ajaxBefore(url, method, params, options) {
    var headers = {};
    if (!(options === null || options === void 0 ? void 0 : options.noCustomHeader)) {
        // 是否开启了CXRFTOKEN
        var _isSameOrigin = (0, utils_1.isSameOrigin)(url);
        var csrfToken = getCsrfToken();
        if (_isSameOrigin && csrfToken) {
            headers['X-CSRF-Token'] = csrfToken;
        }
        //如果启用了灰度，则读取 cookie 里的 tid 和 ifc，并把值加到 header 里
        var tid = js_cookie_1.default.get('tid');
        var ifc = js_cookie_1.default.get('ifc');
        if (tid) {
            headers['X-Udesk-Tid'] = tid;
        }
        if (ifc) {
            headers['X-Udesk-Ifc'] = ifc;
        }
    }
    var setHeaderOptions = (0, merge_1.default)({ headers: headers }, tslib_1.__assign({}, options));
    var requestPptions = tslib_1.__assign({ url: url, method: method, data: params }, setHeaderOptions);
    if (method.toUpperCase() === "GET") {
        requestPptions.params = params;
    }
    return exports.axiosInstance.request(requestPptions).then(function (res) {
        var _a;
        var code = (_a = res === null || res === void 0 ? void 0 : res.data) === null || _a === void 0 ? void 0 : _a.code;
        if (code === 1000 || code === '1000') {
            return res.data;
        }
        else {
            if (res.status >= 200 && res.status < 300) {
                return res.data;
            }
            else {
                return Promise.reject(res.data);
            }
        }
    });
}
function request(options) {
    var url = options.url, method = options.method, data = options.data, _options = tslib_1.__rest(options, ["url", "method", "data"]);
    return ajaxBefore(url, method, data, _options);
}
exports.request = request;
function getJSON(url, params, options) {
    var _url = url;
    // if (!isEmpty(params)) {
    //     _url += ('?' + Qs.stringify(params))
    // }
    return ajaxBefore(_url, 'GET', params, options);
}
exports.getJSON = getJSON;
function postJSON(url, params, options) {
    return ajaxBefore(url, 'post', params, options);
}
exports.postJSON = postJSON;
function post(url, params, options) {
    var searchParams = new URLSearchParams();
    for (var i in params) {
        if (Object.prototype.hasOwnProperty.call(params, i) && params[i] !== undefined) {
            searchParams.append(i, params[i]);
        }
    }
    return ajaxBefore(url, 'post', searchParams, options);
}
exports.post = post;
function putJSON(url, params, options) {
    return ajaxBefore(url, 'put', params, options);
}
exports.putJSON = putJSON;
function deleteJSON(url, params, options) {
    return ajaxBefore(url, 'delete', params, options);
}
exports.deleteJSON = deleteJSON;
function getCsrfToken() {
    var UDD = window.UDD || {};
    var user = UDD.user || {};
    if (user.csrf_token) {
        return user.csrf_token;
    }
}
exports.getCsrfToken = getCsrfToken;
