"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.putJson = exports.postJson = exports.csApiGetJson = exports.getJson = void 0;
var utils_1 = require("../../utils");
var udesk_ui_1 = require("udesk-ui");
var i18n_1 = __importDefault(require("../../i18n"));
var csApi_1 = require("../csApi");
/**
 *
 * @param response
 * @param {object} options
 * @param {boolean} options.noCode - 界面上是否显示报错，true 为不显示
 */
function success(response, options) {
    var _a, _b, _c;
    (_a = options === null || options === void 0 ? void 0 : options.success) === null || _a === void 0 ? void 0 : _a.call(options, response);
    // eslint-disable-next-line eqeqeq
    if (!(options === null || options === void 0 ? void 0 : options.noCode) && (response === null || response === void 0 ? void 0 : response.code) != 1000) {
        if ((response === null || response === void 0 ? void 0 : response.code_message) ||
            ((_b = response === null || response === void 0 ? void 0 : response.exception) === null || _b === void 0 ? void 0 : _b.message) ||
            i18n_1.default.t("tip.error.requestError")) {
            console.log(response, options);
            udesk_ui_1.message.error((response === null || response === void 0 ? void 0 : response.code_message) ||
                ((_c = response === null || response === void 0 ? void 0 : response.exception) === null || _c === void 0 ? void 0 : _c.message) ||
                i18n_1.default.t("tip.error.requestError"));
        }
    }
    return response;
}
function getJson(url, options) {
    return (0, utils_1.getJSON)(url, options === null || options === void 0 ? void 0 : options.params, options === null || options === void 0 ? void 0 : options.options)
        .then(function (response) {
        return success(response, options);
    }, function (reason) {
        var _a;
        (_a = options === null || options === void 0 ? void 0 : options.fail) === null || _a === void 0 ? void 0 : _a.call(options, reason);
        !(options === null || options === void 0 ? void 0 : options.noCode) &&
            udesk_ui_1.message.error((options === null || options === void 0 ? void 0 : options.errMsg) || i18n_1.default.t("tip.error.requestError"));
    })
        .finally(function () {
        var _a;
        var argus = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            argus[_i] = arguments[_i];
        }
        (_a = options === null || options === void 0 ? void 0 : options.finally) === null || _a === void 0 ? void 0 : _a.call.apply(_a, __spreadArray([options], argus, false));
    })
        .catch(function (e) {
        console.error(e);
    });
}
exports.getJson = getJson;
function csApiGetJson(url, options) {
    return (0, csApi_1.csApiGetJSON)(url, __assign({ params: options === null || options === void 0 ? void 0 : options.params }, options === null || options === void 0 ? void 0 : options.options)).then(function (res) { return res.data; }).then(function (response) {
        return success(response, options);
    }, function (reason) {
        var _a;
        (_a = options === null || options === void 0 ? void 0 : options.fail) === null || _a === void 0 ? void 0 : _a.call(options, reason);
        !(options === null || options === void 0 ? void 0 : options.noCode) && udesk_ui_1.message.error((options === null || options === void 0 ? void 0 : options.errMsg) || i18n_1.default.t('tip.error.requestError'));
    }).finally(function () {
        var _a;
        (_a = options === null || options === void 0 ? void 0 : options.finally) === null || _a === void 0 ? void 0 : _a.call(options);
    }).catch(function (e) {
        console.error(e);
    });
}
exports.csApiGetJson = csApiGetJson;
function postJson(url, options) {
    return (0, utils_1.postJSON)(url, options === null || options === void 0 ? void 0 : options.params, options === null || options === void 0 ? void 0 : options.options)
        .then(function (response) {
        return success(response, options);
    }, function (reason) {
        var _a;
        (_a = options === null || options === void 0 ? void 0 : options.fail) === null || _a === void 0 ? void 0 : _a.call(options, reason);
        udesk_ui_1.message.error((options === null || options === void 0 ? void 0 : options.errMsg) || i18n_1.default.t("tip.error.requestError"));
    })
        .finally(function () {
        var _a;
        var argus = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            argus[_i] = arguments[_i];
        }
        (_a = options === null || options === void 0 ? void 0 : options.finally) === null || _a === void 0 ? void 0 : _a.call.apply(_a, __spreadArray([options], argus, false));
    })
        .catch(function (e) {
        console.error(e);
    });
}
exports.postJson = postJson;
function putJson(url, options) {
    return (0, utils_1.putJSON)(url, options === null || options === void 0 ? void 0 : options.params, options === null || options === void 0 ? void 0 : options.options)
        .then(function (response) {
        return success(response, options);
    }, function (reason) {
        var _a;
        (_a = options === null || options === void 0 ? void 0 : options.fail) === null || _a === void 0 ? void 0 : _a.call(options, reason);
        udesk_ui_1.message.error((options === null || options === void 0 ? void 0 : options.errMsg) || i18n_1.default.t("tip.error.requestError"));
    })
        .finally(function () {
        var _a;
        var argus = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            argus[_i] = arguments[_i];
        }
        (_a = options === null || options === void 0 ? void 0 : options.finally) === null || _a === void 0 ? void 0 : _a.call.apply(_a, __spreadArray([options], argus, false));
    })
        .catch(function (e) {
        console.error(e);
    });
}
exports.putJson = putJson;
