function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
/* eslint-disable */
// @ts-nocheck
var id = 1;
export var getId = function getId() {
  return id++;
};
export function fire(event) {
  if (typeof event === 'function') {
    for (var _len = arguments.length, args = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }
    return event.apply(this, args);
  }
  return event;
}
export function inspect(handle, success, fail) {
  success = success === undefined ? true : success;
  fail = fail === undefined ? false : fail;
  handle = fire.call(this, handle);
  return fire.call(this, handle ? success : fail);
}
export function array2tree(list, filter, id, pId, children, parent) {
  var i = 0,
    l = list.length;
  if (!list || l === 0) {
    return [];
  }
  var tree = [],
    tmp = {};
  if (typeof filter === 'string') {
    parent = children;
    children = pId;
    pId = id;
    id = filter;
    filter = !1;
  }
  id = id || 'id';
  pId = pId || 'parentId';
  children = children || 'children';
  if (filter) {
    for (i = 0; i < l; i++) {
      if (filter(list[i])) {
        tmp[list[i][id]] = list[i];
      }
    }
  } else {
    for (i = 0; i < l; i++) {
      tmp[list[i][id]] = list[i];
    }
  }
  for (i = 0; i < l; i++) {
    if (tmp[list[i][id]]) {
      if (tmp[list[i][pId]]) {
        (tmp[list[i][pId]][children] = (parent ? list[i][parent] = tmp[list[i][pId]] : tmp[list[i][pId]])[children] || []).push(list[i]);
      } else {
        tree.push(list[i]);
      }
    }
  }
  return parent ? {
    list: tree,
    cache: tmp
  } : tree;
}

/**
 * 递归遍历列表及其子孙列表
 * @param list
 * @param callback
 * @param recursive 获取子孙列表的函数，如果函数存在则代表递归
 */
export function posterity(list, callback, recursive) {
  var result = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : [];
  var index = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 0;
  if (Array.isArray(list)) {
    list.forEach(function (node, indexOfList) {
      result.push({
        index: index++,
        data: node,
        result: fire(callback, node, indexOfList, list)
      });
      if (recursive) {
        posterity(recursive(node, indexOfList, list), callback, recursive, result, index);
      }
    });
  }
  return result;
}
export function createClassName() {
  for (var _len2 = arguments.length, names = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    names[_key2] = arguments[_key2];
  }
  if (names) {
    return names.filter(function (item) {
      return isFunction(item) || isString(item) || isPlainObject(item);
    }).map(function (item) {
      var data = fire(item);
      if (isPlainObject(data)) {
        data = Reflect.ownKeys(data).filter(function (key) {
          return !!Reflect.get(data, key);
        }).join(' ');
      }
      return data;
    }).join(' ');
  }
  return '';
}
export function getPropByPath(dataSource) {
  var path = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var strict = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var temp = dataSource;
  path = path.replace(/\[(\w+)\]/g, '.$1');
  path = path.replace(/^\./, '');
  path = path.replaceAll(/\w*\.\./g, '');
  var keyArr = path.split('.');
  var index = 0;
  for (var length = keyArr.length; index < length - 1; ++index) {
    if (!temp && !strict) break;
    var key = keyArr[index];
    if (key in temp) {
      temp = temp[key];
    } else {
      if (strict) {
        throw new Error('please transfer a valid prop path to form item!');
      }
      break;
    }
  }
  return {
    data: temp,
    key: isEmpty(path, function () {
      return path;
    }, function () {
      return keyArr[index];
    }),
    value: isEmpty(path, function () {
      return temp;
    }, function () {
      return temp ? temp[keyArr[index]] : null;
    })
  };
}
export function setPropValue(dataSource, path, value) {
  var strict = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
  var _getPropByPath = getPropByPath(dataSource, path, strict),
    data = _getPropByPath.data,
    key = _getPropByPath.key,
    oldValue = _getPropByPath.value;
  if (data) {
    Reflect.set(data, key, value);
  } else {
    value = oldValue;
  }
  return {
    data: data,
    key: key,
    value: value
  };
}
export function getType(value) {
  return {}.toString.call(value).replace(/\[object (.+)\]/i, '$1').toLowerCase();
}
export function isBoolean(value, successHandle, errorHandle) {
  return inspect(getType(value) === 'boolean', successHandle, errorHandle);
}
export function isFunction(value, successHandle, errorHandle) {
  return inspect(getType(value) === 'function', successHandle, errorHandle);
}
export function isString(value, successHandle, errorHandle) {
  return inspect(getType(value) === 'string', successHandle, errorHandle);
}
export function isNumber(value, successHandle, errorHandle) {
  return inspect(getType(value) === 'number' && !isNaN(value), successHandle, errorHandle);
}
export function isSet(value, successHandle, errorHandle) {
  return inspect(getType(value) === 'set', successHandle, errorHandle);
}
export function isMap(value, successHandle, errorHandle) {
  return inspect(getType(value) === 'map', successHandle, errorHandle);
}
export function isArray(value, successHandle, errorHandle) {
  return inspect(getType(value) === 'array', successHandle, errorHandle);
}
export function isPlainObject(value, successHandle, errorHandle) {
  return inspect(getType(value) === 'object', successHandle, errorHandle);
}
export function isNull(value, successHandle, errorHandle) {
  return inspect(value === null, successHandle, errorHandle);
}
export function isUndefined(value, successHandle, errorHandle) {
  return inspect(value === undefined, successHandle, errorHandle);
}
export function isDefined(value, successHandle, errorHandle) {
  return inspect(!isNull(value) && !isUndefined(value), successHandle, errorHandle);
}
export function isEmpty(value, successHandle, errorHandle) {
  return inspect(isDefined(value, function () {
    if (isString(value) || isArray(value)) {
      return value.length === 0;
    }
    if (isSet(value) || isMap(value)) {
      return value.size === 0;
    }
    if (isPlainObject(value)) {
      return Reflect.ownKeys(value).length === 0;
    }
    if (isNaN(value)) {
      return true;
    }
    return false;
  }, true), successHandle, errorHandle);
}
export function isNotEmpty(value, successHandle, errorHandle) {
  return isEmpty(value, errorHandle || false, successHandle || true);
}
function formatNumberForLength(value, length) {
  var valueLength = value.toString().length;
  if (valueLength <= length) {
    return [].concat(_toConsumableArray(new Array(length - valueLength).fill('0')), [value]).join('');
  }
  return value.toString();
}
export function getLocaleDateTimeString() {
  var dateTime = new Date();
  var fullYear = formatNumberForLength(dateTime.getFullYear(), 4);
  var month = formatNumberForLength(dateTime.getMonth() + 1, 2);
  var day = formatNumberForLength(dateTime.getDate(), 2);
  var hours = formatNumberForLength(dateTime.getHours(), 2);
  var minutes = formatNumberForLength(dateTime.getMinutes(), 2);
  var seconds = formatNumberForLength(dateTime.getSeconds(), 2);
  return "".concat(fullYear, "-").concat(month, "-").concat(day, " ").concat(hours, ":").concat(minutes, ":").concat(seconds);
}
export function getAntClass(name) {
  return function (props) {
    return ".".concat(props.antPrefixCls, "-").concat(name);
  };
}