"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.csApiDeleteJSON = exports.csApiPutJSON = exports.csApiPostJSON = exports.csApiGetJSON = exports.csApiRequest = exports.csApiInstance = void 0;
var tslib_1 = require("tslib");
var utils_1 = require("@udesk-webapp/utils");
var ajax_1 = require("./ajax");
var merge_1 = tslib_1.__importDefault(require("lodash-es/merge"));
var csApiAxiosInstance = (0, utils_1.createAxiosInstance)();
csApiAxiosInstance.interceptors.request.use(function (config) {
    var _isSameOrigin = config.url ? (0, utils_1.isSameOrigin)(config.url) : false;
    var headers = {};
    var csrfToken = (0, ajax_1.getCsrfToken)();
    if (_isSameOrigin && csrfToken) {
        headers['X-CSRF-Token'] = csrfToken;
    }
    return (0, merge_1.default)({ headers: headers }, config);
});
exports.csApiInstance = csApiAxiosInstance;
var utils_2 = require("@udesk-webapp/utils");
Object.defineProperty(exports, "csApiRequest", { enumerable: true, get: function () { return utils_2.csApiRequest; } });
Object.defineProperty(exports, "csApiGetJSON", { enumerable: true, get: function () { return utils_2.csApiGetJSON; } });
Object.defineProperty(exports, "csApiPostJSON", { enumerable: true, get: function () { return utils_2.csApiPostJSON; } });
Object.defineProperty(exports, "csApiPutJSON", { enumerable: true, get: function () { return utils_2.csApiPutJSON; } });
Object.defineProperty(exports, "csApiDeleteJSON", { enumerable: true, get: function () { return utils_2.csApiDeleteJSON; } });
