"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.saveCustomer = exports.roleCanCustomerPhone = void 0;
var csApi_1 = require("../utils/csApi");
/**
 * 是否有权限查看编辑客户电话
 * @param customer 必须，客户对象
 * @param customer.owner_group_id - 客户所属客服组
 * @param customer.owner_id - 客户所属客服
 * @param {object} options
 * @return {boolean}
 */
function roleCanCustomerPhone(customer, options) {
    if (!customer) {
        return false;
    }
    var agent = options.agent, role_can = options.role_can;
    if (agent.role === "admin" || role_can.customer_show_cellphone_all) {
        return true;
    }
    var user_groups = agent.user_groups || [];
    var ownerGroupId = customer.owner_group_id;
    if (role_can.customer_show_cellphone_group &&
        user_groups.some(function (i) { return i.id === ownerGroupId; })) {
        return true;
    }
    var ownerId = customer.owner_id;
    return !!(role_can.customer_show_cellphone_personal &&
        ownerId &&
        "".concat(ownerId) === "".concat(agent.id));
}
exports.roleCanCustomerPhone = roleCanCustomerPhone;
function saveCustomer(customer, options) {
    var _a;
    return __awaiter(this, void 0, void 0, function () {
        var role_can, company, agent, resp;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    role_can = options.role_can, company = options.company, agent = options.agent;
                    if (!role_can.set_customer_level) {
                        delete customer.level;
                    }
                    if (!company.is_support_lang) {
                        delete customer.lang;
                    }
                    if (!roleCanCustomerPhone(customer, { role_can: role_can, agent: agent })) {
                        delete customer.cellphones;
                        delete customer.cellphones_attributes;
                    }
                    return [4 /*yield*/, (0, csApi_1.csApiPutJSON)("/cs/ts/api/customers/" + customer.id, {
                            customer: customer,
                            tags: customer.tags,
                        }).then(function (res) { return res.data; })];
                case 1:
                    resp = _b.sent();
                    if ((resp === null || resp === void 0 ? void 0 : resp.code) === 1000) {
                        resp.customer.organizations = resp.organizations;
                        return [2 /*return*/, resp.customer];
                    }
                    throw new Error((_a = resp.exception) === null || _a === void 0 ? void 0 : _a.message);
            }
        });
    });
}
exports.saveCustomer = saveCustomer;
