type IMethod = 'get' | 'post' | 'put' | 'delete';
type IParams = {
    [key: string]: any;
};
export declare const isKcs: (props?: any) => any;
export declare const isKcsSdk: (props?: any) => any;
/**
 * 从是否有domain参数判断是否需要token，在kcs web嵌入的问一问是直接使用cookie鉴权的，所以没有token
 * kcs sdk 也不需要
 */
export declare const isTokenRequired: () => boolean;
export declare const getUrl: (url: string) => string;
export declare const useGet: (url: string | null, params?: IParams) => import("swr/_internal").SWRResponse<import("axios").AxiosResponse<any, any>, any, {
    revalidateOnFocus: false;
    onErrorRetry: (error: any, key: string, config: Readonly<import("swr/_internal").PublicConfiguration<import("axios").AxiosResponse<any, any>, any, (arg: string) => import("swr/_internal").FetcherResponse<import("axios").AxiosResponse<any, any>>>>, revalidate: import("swr/_internal").Revalidator, { retryCount }: Required<import("swr/_internal").RevalidatorOptions>) => void;
}>;
export declare const usePost: (url: string | null, data?: any, params?: IParams) => import("swr/_internal").SWRResponse<import("axios").AxiosResponse<any, any>, any, {
    revalidateOnFocus: false;
    onErrorRetry: (error: any, key: string, config: Readonly<import("swr/_internal").PublicConfiguration<import("axios").AxiosResponse<any, any>, any, (arg: string) => import("swr/_internal").FetcherResponse<import("axios").AxiosResponse<any, any>>>>, revalidate: import("swr/_internal").Revalidator, { retryCount }: Required<import("swr/_internal").RevalidatorOptions>) => void;
}>;
export declare const useDelete: (url: string | null, data?: any, params?: IParams) => import("swr/_internal").SWRResponse<import("axios").AxiosResponse<any, any>, any, {
    revalidateOnFocus: false;
    onErrorRetry: (error: any, key: string, config: Readonly<import("swr/_internal").PublicConfiguration<import("axios").AxiosResponse<any, any>, any, (arg: string) => import("swr/_internal").FetcherResponse<import("axios").AxiosResponse<any, any>>>>, revalidate: import("swr/_internal").Revalidator, { retryCount }: Required<import("swr/_internal").RevalidatorOptions>) => void;
}>;
export declare const usePut: (url: string | null, data?: any, params?: IParams) => import("swr/_internal").SWRResponse<import("axios").AxiosResponse<any, any>, any, {
    revalidateOnFocus: false;
    onErrorRetry: (error: any, key: string, config: Readonly<import("swr/_internal").PublicConfiguration<import("axios").AxiosResponse<any, any>, any, (arg: string) => import("swr/_internal").FetcherResponse<import("axios").AxiosResponse<any, any>>>>, revalidate: import("swr/_internal").Revalidator, { retryCount }: Required<import("swr/_internal").RevalidatorOptions>) => void;
}>;
export declare const useStream: () => (url: string, method: IMethod, data?: any, config?: any) => void | Promise<void>;
export declare const useTokenInit: (params: any, data: any) => import("swr/_internal").SWRResponse<string | {
    data: {
        token: string;
    };
}, any, {
    shouldRetryOnError: false;
}>;
export declare const request: (url: string, { method, params, data, headers, }: {
    method: IMethod;
    params?: IParams | undefined;
    data?: any;
    headers?: any;
}) => Promise<import("axios").AxiosResponse<any, any>>;
export {};
