"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.convertFieldHookResponse = exports.buildHookRequestParamsForCustomer = exports.executeImFieldHook = exports.isSelectFieldByFieldName = void 0;
var pick_1 = __importDefault(require("lodash-es/pick"));
var get_1 = __importDefault(require("lodash-es/get"));
var merge_1 = __importDefault(require("lodash-es/merge"));
var axios_1 = __importDefault(require("axios"));
var difference_1 = __importDefault(require("lodash-es/difference"));
var differenceWith_1 = __importDefault(require("lodash-es/differenceWith"));
var isArray_1 = __importDefault(require("lodash-es/isArray"));
var customer_utils_1 = require("./customer-utils");
var udesk_ui_1 = require("udesk-ui");
function isSelectFieldByFieldName(fieldName) {
    return /^SelectField_\d+$/.test(fieldName);
}
exports.isSelectFieldByFieldName = isSelectFieldByFieldName;
//防止同样的客户推送多次
var pushingCustomersId = [];
function executeImFieldHook(fieldHook, chat, customer, options) {
    return __awaiter(this, void 0, void 0, function () {
        var otherParams, hookRes, e_1, changedCustomerData;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (pushingCustomersId.includes(customer.id)) {
                        return [2 /*return*/];
                    }
                    pushingCustomersId.push(customer.id);
                    otherParams = {
                        im_sub_session_id: chat.im_sub_session_id,
                        customer_id: chat.customer_id,
                    };
                    if (chat.platform === "web") {
                        otherParams.web_token = customer.web_token;
                    }
                    else if (chat.platform === "wechat") {
                        otherParams.weixins = (customer.weixins || []).map(function (i) { return i.openid; });
                    }
                    else if (chat.platform === "weibo") {
                        otherParams.weibos = (customer.weibos || []).map(function (i) { return i.openid; });
                    }
                    else if (["android", "ios"].includes(chat.platform)) {
                        otherParams.sdk_token = customer.sdk_token;
                    }
                    else if (chat.platform === "weixin_mini") {
                        otherParams.weixin_minis = (customer.weixin_minis || []).map(function (i) { return i.openid; });
                    }
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, postData(fieldHook.url, buildHookRequestParamsForCustomer(fieldHook, customer, __assign(__assign({}, options), { otherParams: otherParams })))];
                case 2:
                    hookRes = _a.sent();
                    pushingCustomersId = pushingCustomersId.filter(function (i) { return i !== customer.id; });
                    return [3 /*break*/, 4];
                case 3:
                    e_1 = _a.sent();
                    pushingCustomersId = pushingCustomersId.filter(function (i) { return i !== customer.id; });
                    throw e_1;
                case 4:
                    if (hookRes.error) {
                        udesk_ui_1.message.error(hookRes.error);
                    }
                    if (!hookRes.customer) {
                        return [2 /*return*/];
                    }
                    ignoreDuplicateEmail(hookRes, customer);
                    ignoreDuplicatePhone(hookRes, customer);
                    changedCustomerData = convertFieldHookResponse(hookRes.customer);
                    if (!changedCustomerData) {
                        return [2 /*return*/];
                    }
                    changedCustomerData.id = customer.id;
                    return [2 /*return*/, (0, customer_utils_1.saveCustomer)(changedCustomerData, {
                            agent: options.agent,
                            role_can: options.role_can,
                            company: options.company,
                        })];
            }
        });
    });
}
exports.executeImFieldHook = executeImFieldHook;
function postData(url, params) {
    return __awaiter(this, void 0, void 0, function () {
        var resp;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, axios_1.default.post(url, params)];
                case 1:
                    resp = _a.sent();
                    if (resp.data.code === 1000) {
                        return [2 /*return*/, resp.data];
                    }
                    else {
                        throw new Error("请求数据错误，请重试!");
                    }
                    return [2 /*return*/];
            }
        });
    });
}
/**
 * 创建请求field hook的参数
 * @param {object}  fieldHook
 * @param {string}  fieldHook.url - field hook的url
 * @param {array}   fieldHook.target_fields - 要传给field hook的字段
 * @param {key}     fieldHook.key - 用于field hook验证
 * @param {object}  targetObject - 客户或者工单
 * @param {object}  otherParams - 其他的参数，呼叫中心弹屏时是电话号码，im进线是微信号、微博号等等
 * @param {string}  otherParams.phoneNumber - 电话号码，field hook的type是cc时有效
 * @param {string}  otherParams.web_token
 * @param {string}  otherParams.weixin_openid
 * @param {string}  otherParams.weibo_openid
 * @param {string}  otherParams.sdk_token
 * @param {string}  otherParams.im_sub_session_id
 * @return {object}
 */
function buildHookRequestParamsForCustomer(fieldHook, targetObject, options) {
    var _a;
    var customerCustomFields = options.customerCustomFields, _b = options.otherParams, otherParams = _b === void 0 ? {} : _b;
    var data = fieldHook.target_fields.reduce(function (preVal, i) {
        if (i === "cellphone") {
            if ("cellphones" in targetObject) {
                preVal[i] = targetObject["cellphones"];
            }
            else if ("cellphones_attributes" in targetObject) {
                preVal[i] = targetObject["cellphones_attributes"];
            }
            if (Array.isArray(preVal[i])) {
                preVal[i] = preVal[i].map(function (i) {
                    return (0, pick_1.default)(i, "id", "content", "_destroy");
                });
            }
        }
        else if (i === "organization_id") {
            //为兼容老数据，字段推送时依然会推organization_id
            preVal[i] = (0, get_1.default)(targetObject, "organizations[0].id");
            if (Array.isArray(targetObject.organizations)) {
                preVal["organizations"] = targetObject.organizations.map(function (item) {
                    if ("object" === typeof item) {
                        return item.id + "";
                    }
                    else {
                        return item + "";
                    }
                });
            }
        }
        else if (i === "unionids") {
            preVal[i] = (targetObject.weixins || []).map(function (i) { return i.openid; });
        }
        else if (i === "userids") {
            preVal[i] = (targetObject.qywxes || []).map(function (i) { return i.qywx_userid; });
        }
        else if (isSelectFieldByFieldName(i) && targetObject.custom_fields) {
            var value = targetObject.custom_fields[i];
            if (!Array.isArray(value) && typeof value !== "string") {
                return preVal;
            }
            if (typeof value === "string") {
                value = value.split(",");
            }
            var customField = customerCustomFields.find(function (j) { return j.name === i; });
            if (!customField) {
                return preVal;
            }
            var fieldType = customField.content_type;
            var options_1 = customField.select_options;
            var getOption_1 = function (valueItem, opts) {
                if ("object" === typeof valueItem) {
                    return opts.find(function (i) { return i.value === valueItem.value + ""; });
                }
                else {
                    return opts.find(function (i) { return i.value === valueItem; });
                }
            };
            preVal[i] = [];
            if (fieldType === "chained_droplist") {
                value.reduce(function (preOpts, v) {
                    var selectedOption = getOption_1(v, preOpts);
                    if (!selectedOption) {
                        return preOpts;
                    }
                    preVal[i].push({
                        value: selectedOption.value,
                        text: selectedOption.title,
                    });
                    return selectedOption.subs;
                }, options_1);
            }
            else {
                value.forEach(function (v) {
                    var option = getOption_1(v, options_1);
                    if (option) {
                        preVal[i].push({ value: option.value, text: option.title });
                    }
                });
            }
        }
        else {
            preVal[i] =
                targetObject[i] ||
                    (targetObject.custom_fields && targetObject.custom_fields[i]);
        }
        return preVal;
    }, {});
    return (0, merge_1.default)((_a = {}, _a[fieldHook.field_owner.toLowerCase()] = data, _a), otherParams);
}
exports.buildHookRequestParamsForCustomer = buildHookRequestParamsForCustomer;
// export function buildHookRequestParams(fieldHook: IFieldHook, targetObject: Customer | Ticket, otherParams = {}, options: { customerCustomFields: any, ticketCustomFields: any }) {
//     let data = fieldHook.target_fields.reduce<{ [key: string]: any }>((preVal, i) => {
//         if (i === 'cellphone') {
//             if ('cellphones' in targetObject) {
//                 preVal[i] = targetObject['cellphones'];
//             } else if ('cellphones_attributes' in targetObject) {
//                 preVal[i] = targetObject['cellphones_attributes'];
//             }
//             if (Array.isArray(preVal[i])) {
//                 preVal[i] = preVal[i].map((i: Customer['cellphones']) => pick(i, 'id', 'content', '_destroy'));
//             }
//         } else if (i === 'customer' && ('customer' in targetObject)) {
//             let customerData: { [key: string]: any } = pick(targetObject[i], 'open_api_token', 'weixin_openid', 'weibo_openid', 'web_token', 'sdk_token', 'email', 'cellphones');
//             if ('weixins' in targetObject[i]) {
//                 let weixins = targetObject[i].weixins;
//                 if (Array.isArray(weixins) && weixins.length > 0) {
//                     customerData.weixin_openid = weixins[0].openid;
//                 }
//             }
//
//             customerData.cellphone = customerData.cellphones;
//             delete customerData.cellphones;
//
//             preVal[i] = customerData;
//         } else if (i === 'organization_id') {
//             //为兼容老数据，字段推送时依然会推organization_id
//             preVal[i] = Ember.get(targetObject, 'organizations.firstObject.id');
//             if (Ember.isArray(Ember.get(targetObject, 'organizations'))) {
//                 preVal['organizations'] = Ember.get(targetObject, 'organizations').map(item => {
//                     if (['instance', 'object'].contains(Ember.typeOf(item))) {
//                         return Ember.get(item, 'id') + '';
//                     } else {
//                         return item + '';
//                     }
//                 });
//             }
//         } else if (isSelectFieldByFieldName(i) && targetObject.custom_fields) {
//             let value = targetObject.custom_fields[i];
//             if (!Ember.isArray(value) && (typeof value !== 'string')) {
//                 return preVal;
//             }
//             if (typeof value === 'string') {
//                 value = value.split(',');
//             }
//             let customField = customerCustomFields.findBy('name', i) || ticketCustomFields.findBy('name', i);
//             let fieldType = Ember.get(customField, 'content_type');
//             let options = Ember.get(customField, 'select_options');
//             let getOption = function (valueItem, opts) {
//                 if (['object', 'instance'].contains(typeof valueItem)) {
//                     return opts.findBy('value', Ember.get(valueItem, 'value') + '');
//                 } else {
//                     return opts.findBy('value', valueItem);
//                 }
//             };
//
//             preVal[i] = [];
//             if (fieldType === CONTENT_TYPE_CHAINED_DROPLIST) {
//                 value.reduce((preOpts, v) => {
//                     let selectedOption = getOption(v, preOpts);
//                     if (!selectedOption) {
//                         return preOpts;
//                     }
//                     preVal[i].push({
//                         value: Ember.get(selectedOption, 'value'),
//                         text: Ember.get(selectedOption, 'title')
//                     });
//                     return Ember.get(selectedOption, 'subs');
//                 }, options);
//             } else {
//                 value.forEach(v => {
//                     let option = getOption(v, options);
//                     if (option) {
//                         preVal[i].push({value: Ember.get(option, 'value'), text: Ember.get(option, 'title')});
//                     }
//                 });
//             }
//         } else {
//             preVal[i] = targetObject[i] || (targetObject.custom_fields && targetObject.custom_fields[i]);
//         }
//
//         return preVal;
//     }, {});
//
//     if (Ember.get(targetObject, 'field_num') && fieldHook.field_owner.toLowerCase() === 'ticket') {
//         data['field_num'] = Ember.get(targetObject, 'field_num');
//     }
//     return Ember.merge({[fieldHook.field_owner.toLowerCase()]: data}, otherParams);
// }
/**
 * 忽略返回数据里已重复的电话号码
 * @param {object} fieldHookResp - 字段推送返回的数据
 * @param {object} customer - 客户
 * @return {object} - 删除了重复项的field hook response
 */
function ignoreDuplicatePhone(fieldHookResp, customer) {
    var _a;
    var respCustomer = fieldHookResp.customer;
    if (!respCustomer) {
        return fieldHookResp;
    }
    var originalPhones = customer.cellphones || customer.cellphones_attributes;
    respCustomer.cellphones_attributes = (0, difference_1.default)(respCustomer.cellphones_attributes || [], (_a = originalPhones === null || originalPhones === void 0 ? void 0 : originalPhones.map(function (i) { return (i === null || i === void 0 ? void 0 : i.content) || i; })) !== null && _a !== void 0 ? _a : []);
    return fieldHookResp;
}
/**
 * 忽略返回数据里已重复的邮箱
 * @param {object} fieldHookResp - 字段推送返回的数据
 * @param {object} customer - 客户
 * @return {object} - 删除了重复项的field hook response
 */
function ignoreDuplicateEmail(fieldHookResp, customer) {
    var respCustomer = fieldHookResp.customer;
    if (!respCustomer) {
        return fieldHookResp;
    }
    var originalEmail = customer.email || "";
    if (originalEmail === respCustomer.email) {
        delete respCustomer.email;
    }
    respCustomer.other_emails = (0, differenceWith_1.default)(respCustomer.other_emails || [], customer.other_emails || [], function (a, b) { return a === b[1]; });
    return fieldHookResp;
}
/**
 * field hook返回的数据无法直接传到后端修改,需要做一步转换
 * 1、如果没有custom_fields字段，则加一个空的custom_fields字段
 * 2、把cellphones_attributes的元素用content包装一下
 * 3、把自定义字段全部移动到custom_fields属性里
 * @param {object} changedData - field hook返回的客户参数
 */
function convertFieldHookResponse(changedData) {
    var res = {};
    for (var attr in changedData) {
        var val = changedData[attr];
        if (attr === "cellphones_attributes" && (0, isArray_1.default)(val)) {
            res[attr] = val.map(function (i) { return ({ content: i }); });
        }
        else if (attr === "other_emails" && (0, isArray_1.default)(val)) {
            res[attr] = val.map(function (i) { return [null, i]; });
        }
        else if (/^[a-zA-Z]+Field_\d+$/.test(attr)) {
            if (!res.custom_fields) {
                res.custom_fields = {};
            }
            res.custom_fields[attr] = val;
        }
        else {
            res[attr] = val;
        }
    }
    return res;
}
exports.convertFieldHookResponse = convertFieldHookResponse;
