"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChatUtils = void 0;
var store_1 = require("../store");
//TODO 工具类所有方法尽可能做成纯函数
exports.ChatUtils = {
    /**
     * 获取业务记录模板是否含有必填字段
     * @param agent_note_template_id 会话设置过的业务记录模板,可能为空
     * return boolean
     */
    getNoteHasReqField: function (agent_note_template_id) {
        var noteTemplateConfig = store_1.store.getState().noteTemplateConfig || {};
        var initData = store_1.store.getState().initData || {};
        var note_category = {
            im: "im",
            mpv: "video",
            call: "call",
        };
        var noteTemplates = noteTemplateConfig.noteTemplates || [];
        var imAgentNoteTemplatesSort = noteTemplateConfig.imAgentNoteTemplatesSort || [];
        var imNoteFields = [];
        var imNoteKey = note_category[initData.page]; //"im";
        if (agent_note_template_id) {
            imNoteFields =
                (noteTemplates.find(function (note) { return (note === null || note === void 0 ? void 0 : note.id) === agent_note_template_id; }) || {}).fields || [];
        }
        else {
            if (imAgentNoteTemplatesSort && imAgentNoteTemplatesSort.length > 0) {
                imNoteFields =
                    (noteTemplates.find(function (note) { return note.id === imAgentNoteTemplatesSort[0]; }) || {}).fields || [];
            }
            else {
                imNoteFields =
                    (noteTemplates.find(function (note) { return note.category === imNoteKey; }) || {}).fields || [];
            }
        }
        return imNoteFields.some(function (field) { return field.is_required; });
    },
};
