"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.timeDurationFormat = exports.getEndDate = exports.getStartDate = exports.dateFormat = exports.formatNowDay = void 0;
var global_const_1 = require("./global-const");
var moment_1 = __importDefault(require("moment"));
function formatNowDay(date, format, alwaysTime) {
    if (format === void 0) { format = global_const_1.DATETIME_FORMAT_BIAS; }
    if (!date) {
        return '';
    }
    if (!(0, moment_1.default)(date).isSame((0, moment_1.default)(), 'day') && !alwaysTime) {
        return (0, moment_1.default)(date).format(global_const_1.SHORT_DATE_FORMAT);
    }
    return (0, moment_1.default)(date).format(format);
}
exports.formatNowDay = formatNowDay;
function dateFormat(date, format) {
    if (format === void 0) { format = global_const_1.DATETIME_FORMAT; }
    return (0, moment_1.default)(date).format(format);
}
exports.dateFormat = dateFormat;
function getStartDate(day) {
    if (day === void 0) { day = 6; }
    return (0, moment_1.default)().subtract(day, 'days').format(global_const_1.YYYY_MM_DD);
}
exports.getStartDate = getStartDate;
function getEndDate() {
    return (0, moment_1.default)().endOf('day').format(global_const_1.YYYY_MM_DD);
}
exports.getEndDate = getEndDate;
function timeDurationFormat(time) {
    var duration = moment_1.default.duration(time, 'seconds');
    var hours = duration.hours() || 0;
    var minutes = duration.minutes() || 0;
    var seconds = duration.seconds() || 0;
    if (hours < 10) {
        hours = '0' + hours;
    }
    if (minutes < 10) {
        minutes = '0' + minutes;
    }
    if (seconds < 10) {
        seconds = '0' + seconds;
    }
    return hours + ':' + minutes + ':' + seconds;
}
exports.timeDurationFormat = timeDurationFormat;
