import Compressor from 'compressorjs';
import { RcFile } from 'udesk-ui/es/upload';
export declare function getId(): number;
export declare function r(template: string, ...args: any): string;
export declare function getFileTypeByContentType(contentType: string): "TextField" | "SelectField";
export declare function isSysField(type: string): boolean;
export declare function mapCascader(options: any): any;
export declare function handleCascaderHideOption(option: any): any;
/**
 * @description 将级联字段隐藏的选项删除，需要返显的场景，动态添加已选择的隐藏选项
 * @param options
 * @returns
 */
export declare function createCacaderOptions(options: any): any[];
/**
 * @param {string} fieldType  那种字段?   customer | ticket
 * @param {string} editType   什么操作?   edit | new | show
 * @param {object} fieldsAuthority    字段全选hash表
 */
export declare function formatCustomField({ fields, fieldsAuthority, trigger, fieldType, editType, }: any): IFieldItem[];
export declare function getFieldsDefaultValue({ fields, values }: any): any;
export declare function formatProps(props: any): any;
export declare function stringToHex(str: string): string;
export declare function getPreviewUrl(url: string, options: {
    needEncode?: boolean;
    previewUrl: string;
}): string;
/**
 * 通过文件名判断是否可以预览
 * @param {string} fileName
 * @returns {boolean}
 */
export declare function canPreviewByFileName(fileName: string): boolean;
export declare function createMedia(type: string, cfg: any): {
    el: any;
    play(): void;
    pause(): void;
    replay(): void;
    destroy(): void;
} | undefined;
export declare function createAudio(cfg: any): {
    el: any;
    play(): void;
    pause(): void;
    replay(): void;
    destroy(): void;
} | undefined;
export declare function replaceLinks(text: any): string;
export declare function removeStorage(name: string, type?: 'session' | 'local'): void;
export declare function getStorage(name: string, type?: string, json?: boolean): any;
export declare function setStorage(name: string, val: any, type?: 'session' | 'local', json?: boolean): void;
export declare function getByteByStr(val: string): number;
export declare function compareStr(val1: string, val2: string, flag: string): boolean;
export declare function humanizeDuration(seconds: number): string;
export declare function randomString(wordCount: number): string;
export declare function udeskId(): string;
export declare function guid(prefix?: any, suffix?: any): string;
export declare function css2obj(css?: string): {
    [key: string]: string;
};
export declare function checkFileIsImage(imageFile: File): Promise<unknown>;
export declare function compressImage(imageFile: File | RcFile, { success, error, ...options }: Compressor.Options): Promise<RcFile>;
/**
 + *@method 获取对象对应key的value值
 + */
export declare const getAssociativeObjValue: <T, K extends keyof T>(obj: T, key: K) => T[K];
/**
 * 相当于当前页面的心跳，告诉后端我打开了客服系统
 */
export declare const syncSysStatus: (current_page?: string) => void;
