import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import React, { Component, createRef, Fragment } from 'react';
import Options from './Options';
import forEach from 'lodash-es/forEach';
import PropTypes from 'prop-types';

var CommonDropdown = /*#__PURE__*/function (_Component) {
  _inheritsLoose(CommonDropdown, _Component);

  function CommonDropdown(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.dropdownMenuRef = /*#__PURE__*/createRef();

    _this.filter = function (keyword) {
      if (keyword) {
        forEach(_this.dropdownMenuRef.current.children, function (li) {
          if (li.innerText.indexOf(keyword) === -1) {
            li.style.display = 'none';
          } else {
            li.removeAttribute('style');
          }
        });
        return;
      }

      forEach(_this.dropdownMenuRef.current.children, function (li) {
        return li.removeAttribute('style');
      });
    };

    return _this;
  }

  var _proto = CommonDropdown.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        getOptionLabel = _this$props.getOptionLabel,
        getOptionValue = _this$props.getOptionValue,
        onChange = _this$props.onChange,
        options = _this$props.options,
        value = _this$props.value,
        _this$props$t = _this$props.t,
        t = _this$props$t === void 0 ? function (v) {
      return v;
    } : _this$props$t;
    return /*#__PURE__*/React.createElement("div", {
      className: "dropdown-menu-left"
    }, options.length > 10 ? /*#__PURE__*/React.createElement(Fragment, null, /*#__PURE__*/React.createElement("i", {
      className: "icon icon-search"
    }), /*#__PURE__*/React.createElement("div", {
      className: "dropdown-menu-search"
    }, /*#__PURE__*/React.createElement("input", {
      placeholder: t('label.searchPlaceholder'),
      onChange: function onChange(e) {
        return _this2.filter(e.target.value);
      }
    }))) : void 0, /*#__PURE__*/React.createElement("ul", {
      className: "dropdown-menu-ul scrollbar",
      ref: this.dropdownMenuRef
    }, /*#__PURE__*/React.createElement(Options, {
      getOptionLabel: getOptionLabel,
      getOptionValue: getOptionValue,
      options: options,
      value: value,
      onChange: onChange
    })));
  };

  return CommonDropdown;
}(Component);

CommonDropdown.propTypes = {
  getOptionLabel: PropTypes.func,
  getOptionValue: PropTypes.func,
  value: PropTypes.arrayOf(PropTypes.any),
  onChange: PropTypes.func,
  options: PropTypes.arrayOf(PropTypes.any)
};
export default CommonDropdown;