import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React, { Component, createRef, Fragment } from 'react';
import Options from './Options';
import isNil from 'lodash-es/isNil';
import PropTypes from 'prop-types';
import { jsx as ___EmotionJSX } from "@emotion/react";

var CommonDropdown = /*#__PURE__*/function (_Component) {
  _inheritsLoose(CommonDropdown, _Component);

  function CommonDropdown(props) {
    var _this;

    _this = _Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "dropdownMenuRef", /*#__PURE__*/createRef());

    _this.state = {
      keyword: ''
    };
    return _this;
  }

  var _proto = CommonDropdown.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var _this$props = this.props,
        getOptionLabel = _this$props.getOptionLabel,
        getOptionValue = _this$props.getOptionValue,
        onChange = _this$props.onChange,
        options = _this$props.options,
        value = _this$props.value,
        _this$props$t = _this$props.t,
        t = _this$props$t === void 0 ? function (v) {
      return v;
    } : _this$props$t,
        isSearchable = _this$props.isSearchable,
        search = _this$props.search;
    var keyword = this.state.keyword;

    if (isNil(isSearchable)) {
      isSearchable = options.length > 10;
    }

    if (keyword && typeof search === 'function') {
      options = search(keyword, {
        options: options,
        getOptionLabel: getOptionLabel
      }) || options;
    }

    return ___EmotionJSX("div", {
      className: "dropdown-menu-left"
    }, isSearchable && ___EmotionJSX(Fragment, null, ___EmotionJSX("i", {
      className: "icon icon-search"
    }), ___EmotionJSX("div", {
      className: "dropdown-menu-search"
    }, ___EmotionJSX("input", {
      placeholder: t('label.search'),
      onChange: function onChange(e) {
        return _this2.setState({
          keyword: e.target.value
        });
      }
    }))), ___EmotionJSX("ul", {
      className: "dropdown-menu-ul scrollbar",
      ref: this.dropdownMenuRef
    }, ___EmotionJSX(Options, {
      getOptionLabel: getOptionLabel,
      getOptionValue: getOptionValue,
      options: options,
      value: value,
      onChange: onChange
    })));
  };

  return CommonDropdown;
}(Component);

_defineProperty(CommonDropdown, "defaultProps", {
  search: function search(keyword, _ref) {
    var options = _ref.options,
        getOptionLabel = _ref.getOptionLabel;
    return options.filter(function (option) {
      var label = getOptionLabel(option);

      if (typeof label === 'string') {
        return label.toLowerCase().indexOf(keyword.toLowerCase()) > -1;
      }

      return true;
    });
  }
});

CommonDropdown.propTypes = {
  getOptionLabel: PropTypes.func,
  getOptionValue: PropTypes.func,
  value: PropTypes.any,
  onChange: PropTypes.func,
  options: PropTypes.arrayOf(PropTypes.any),
  isSearchable: PropTypes.bool,
  search: PropTypes.func
};
export default CommonDropdown;