import { __awaiter, __extends, __generator } from "tslib";
import { loadScript, loadStyle } from "./utils";
import EventEmitter from "eventemitter3";
import { csApiGetJSON } from "@udesk-webapp/utils";
var REACT_APP_WFE_SDK_JS_PATH = "/wfe-apps/js/kcsSpaceSdk/sdk.es6.js";
var REACT_APP_WFE_SDK_CSS_PATH = "/wfe-apps/css/kcsSpaceSdk/sdk.es6.css";
var KcsSDKWrapper = /** @class */ (function (_super) {
    __extends(KcsSDKWrapper, _super);
    function KcsSDKWrapper(options) {
        var _this = _super.call(this) || this;
        _this.onButtonClick = function (data, buttonType) {
            _this.emit("buttonClick", data, buttonType);
        };
        _this.onFileButtonClick = function (data, buttonType) {
            _this.emit("fileButtonClick", data, buttonType);
        };
        _this._opts = {
            csToken: "",
            domain: "",
            staticDomain: "",
            onButtonClick: _this.onButtonClick,
            onFileButtonClick: _this.onFileButtonClick,
        };
        _this.options = options;
        _this.load().then(function (r) {
            _this.emit("ready", r);
        });
        _this.on("ready", function (r) {
            _this._kcsInstance = r;
        });
        return _this;
    }
    Object.defineProperty(KcsSDKWrapper.prototype, "kcsInstance", {
        get: function () {
            return this._kcsInstance;
        },
        enumerable: false,
        configurable: true
    });
    KcsSDKWrapper.getInstance = function (options) {
        if (!KcsSDKWrapper._instance) {
            KcsSDKWrapper._instance = new KcsSDKWrapper(options);
        }
        return KcsSDKWrapper._instance;
    };
    KcsSDKWrapper.prototype.load = function () {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var data, sdkHost;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, csApiGetJSON("/cs/im/agent/kcs_sdk").then(function (r) { return r.data; })];
                    case 1:
                        data = _b.sent();
                        this._opts.csToken = data.data.token;
                        this._opts.domain = data.data.domain;
                        this._opts.staticDomain = data.data.url;
                        sdkHost = (_a = this._opts) === null || _a === void 0 ? void 0 : _a.staticDomain;
                        if (process.env.NODE_ENV === "development") {
                            //因为km那边测试环境只有s-km1能部署前端，但后端不一定是s-km1，所以如果是开发环境，就用 s-km1，如果某天 km 那边的前端能随便部署了，这里的判断可以删掉
                            sdkHost = "https://s-km5.udesk.cn";
                        }
                        loadStyle("".concat(sdkHost).concat(REACT_APP_WFE_SDK_CSS_PATH));
                        return [4 /*yield*/, loadScript("".concat(sdkHost).concat(REACT_APP_WFE_SDK_JS_PATH))];
                    case 2:
                        _b.sent();
                        if (window.UdeskKcsSDK) {
                            return [2 /*return*/, new UdeskKcsSDK({ props: Object.assign(this._opts, this.options) })];
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    return KcsSDKWrapper;
}(EventEmitter));
export default KcsSDKWrapper;
