import { __assign, __rest } from "tslib";
import Cookies from 'js-cookie';
import axios from 'axios';
import merge from 'lodash-es/merge';
// axios.defaults.baseURL = 'http://reocar.b3.tryudesk.com/spa1';
// axios.defaults.baseURL = 'http://reocar.ud.com/spa1';
export var axiosInstance = axios.create({
    baseURL: '/spa1'
});
function ajaxBefore(url, method, params, options) {
    var headers = {};
    // 是否开启了CXRFTOKEN
    var _isSameOrigin = isSameOrigin(url);
    var csrfToken = getCsrfToken();
    if (_isSameOrigin && csrfToken) {
        headers['X-CSRF-Token'] = csrfToken;
    }
    //如果启用了灰度，则读取 cookie 里的 tid 和 ifc，并把值加到 header 里
    var tid = Cookies.get('tid');
    var ifc = Cookies.get('ifc');
    if (tid) {
        headers['X-Udesk-Tid'] = tid;
    }
    if (ifc) {
        headers['X-Udesk-Ifc'] = ifc;
    }
    var setHeaderOptions = merge({ headers: headers }, __assign({}, options));
    var requestPptions = __assign({ url: url, method: method, data: params }, setHeaderOptions);
    if (method.toUpperCase() === 'GET') {
        requestPptions.params = params;
    }
    return axiosInstance.request(requestPptions).then(function (res) {
        var _a;
        var code = (_a = res === null || res === void 0 ? void 0 : res.data) === null || _a === void 0 ? void 0 : _a.code;
        if (code === 1000 || code === '1000') {
            return res.data;
        }
        else {
            if (res.status >= 200 && res.status < 300) {
                return res.data;
            }
            else {
                return Promise.reject(res.data);
            }
        }
    });
}
export function request(options) {
    var url = options.url, method = options.method, data = options.data, _options = __rest(options, ["url", "method", "data"]);
    return ajaxBefore(url, method, data, _options);
}
export function getJSON(url, params, options) {
    var _url = url;
    // if (!isEmpty(params)) {
    //     _url += ('?' + Qs.stringify(params))
    // }
    return ajaxBefore(_url, 'GET', params, options);
}
export function postJSON(url, params, options) {
    return ajaxBefore(url, 'post', params, options);
}
export function post(url, params, options) {
    var searchParams = new URLSearchParams();
    for (var i in params) {
        if (Object.prototype.hasOwnProperty.call(params, i) && params[i] !== undefined) {
            searchParams.append(i, params[i]);
        }
    }
    return ajaxBefore(url, 'post', searchParams, options);
}
export function putJSON(url, params, options) {
    return ajaxBefore(url, 'put', params, options);
}
export function deleteJSON(url, params, options) {
    return ajaxBefore(url, 'delete', params, options);
}
function isSameOrigin(url) {
    var loc = window.location;
    var a = document.createElement('a');
    a.href = url;
    return a.hostname === loc.hostname &&
        a.port === loc.port &&
        a.protocol === loc.protocol;
}
function getCsrfToken() {
    var UDD = window.UDD || {};
    var user = UDD.user || {};
    if (user.csrf_token) {
        return user.csrf_token;
    }
}
