import { __assign, __rest } from "tslib";
import React, { useMemo, useState } from 'react';
import { Table } from 'udesk-ui';
import i18n from '@udesk-webapp/locale';
// import { useIntl } from 'umi';
import { 
// @ts-ignore
systemField, getCustomFieldValue, sensitiveField, removeHtmlErrorAttr, replaceScriptCode, RemoveHtmlTag, xssByWhitelist, xssByEmailWhitelist, } from '@udesk-webapp/utils';
var associatedTicketForm = function (props) {
    var lists = props.lists, columns = props.columns, scroll = props.scroll, onRow = props.onRow, rowSelection = props.rowSelection, onChange = props.onChange, customizeLists = props.customizeLists, selectionType = props.selectionType, pagination = props.pagination, _a = props.isSensitiveField, isSensitiveField = _a === void 0 ? true : _a, ticketSystemFields = props.ticketSystemFields, agents = props.agents, agentsWithAdmin = props.agentsWithAdmin;
    var _b = useState([]), ticketsLists = _b[0], setticketsLists = _b[1];
    // 这里用来区分系统字段类型，未来应该有个动态的数据来源
    var CUSTOMER_SYSTEM_IDS = {
        customer_name: i18n.t('utils.ticket.customer'),
        customer_cellphone: i18n.t('components.ticketFilterTable.associatedTicketForm.customerCellphone'),
        customer_telephone: i18n.t('components.ticketFilterTable.associatedTicketForm.customerTelephone'),
        customer_replied_at: i18n.t('components.ticketFilterTable.associatedTicketForm.customerRepliedAt'),
        customer_email: i18n.t('components.ticketFilterTable.associatedTicketForm.customerEmail'),
        customer_rich_tags: i18n.t('components.ticketFilterTable.associatedTicketForm.customerRichTags'),
        customer_description: i18n.t('components.ticketFilterTable.associatedTicketForm.customerDescription'),
        customer_owner_name: i18n.t('components.ticketFilterTable.associatedTicketForm.customerOwnerName'),
        customer_owner_group_name: i18n.t('components.ticketFilterTable.associatedTicketForm.customerOwnerGroupName'),
        customer_level: i18n.t('components.ticketFilterTable.associatedTicketForm.customerLevel'),
        customer_is_blocked: i18n.t('components.ticketFilterTable.associatedTicketForm.customerIsBlocked'),
        customer_lang: i18n.t('components.ticketFilterTable.associatedTicketForm.customerLang'),
    };
    var ORGANIZATION_SYSTEM_IDS = {
        organization: i18n.t('utils.ticket..organization'),
        organizationDomains: i18n.t('components.ticketFilterTable.associatedTicketForm.organizationDomain'),
        organizationOrgEmailSuffix: i18n.t('components.ticketFilterTable.associatedTicketForm.organizationOrgEmailSuffix'),
        organizationDescription: i18n.t('components.ticketFilterTable.associatedTicketForm.organizationDescription'),
    };
    function getFieldName(id, ticketSystemFields) {
        if (CUSTOMER_SYSTEM_IDS[id]) {
            return CUSTOMER_SYSTEM_IDS[id];
        }
        else if (ORGANIZATION_SYSTEM_IDS[id]) {
            return ORGANIZATION_SYSTEM_IDS[id];
        }
        return systemField ? systemField(id, ticketSystemFields) : '';
    }
    // const [columnsLists, setcolumnsLists] = useState<Array<columnsTypes>>([]);
    // 系统模板
    // text 类型较多
    var systemRender = function (itemColumns, record, text, index) {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k;
        // TODO:看下是否需要undefined类型定义
        var pStr = text;
        var id = itemColumns.id;
        // if (COLUMNS_MAP[id]) {
        // } else {
        // }
        switch (id) {
            case 'status':
                // 案例状态
                switch (text) {
                    case '开启':
                        pStr = (React.createElement("span", { dangerouslySetInnerHTML: {
                                __html: "<span class=\"table-pop-open\">".concat(i18n.t('components.ticketFilterTable.associatedTicketForm.statusOpen'), "</span>"),
                            } }));
                        break;
                    case '解决中':
                        pStr = (React.createElement("span", { dangerouslySetInnerHTML: {
                                __html: "<span class=\"table-pop-solving\">".concat(i18n.t('components.ticketFilterTable.associatedTicketForm.statusSolving'), "</span>"),
                            } }));
                        break;
                    case '已解决':
                        // pStr = '<i class="icon icon-arrow-up text-info"></i>';
                        pStr = (React.createElement("span", { dangerouslySetInnerHTML: {
                                __html: "<span class=\"table-pop-resolved\">".concat(i18n.t('components.ticketFilterTable.associatedTicketForm.statusResolved'), "</span>"),
                            } }));
                        break;
                    case '已关闭':
                        pStr = (React.createElement("span", { dangerouslySetInnerHTML: {
                                __html: "<span class=\"table-pop-closed\">".concat(i18n.t('components.ticketFilterTable.associatedTicketForm.statusClosed'), "</span>"),
                            } }));
                        break;
                }
                break;
            case 'priority':
                // 紧急度
                switch (text) {
                    case '高':
                        pStr = (React.createElement("span", { dangerouslySetInnerHTML: {
                                __html: "<i class=\"icon icon-arrow-up text-danger\"></i>".concat(i18n.t('components.ticketFilterTable.associatedTicketForm.priorityHigh')),
                            } }));
                        break;
                    case '低':
                        pStr = (React.createElement("span", { dangerouslySetInnerHTML: {
                                __html: "<i class=\"icon icon-arrow-down text-info\"></i>".concat(i18n.t('components.ticketFilterTable.associatedTicketForm.priorityLow')),
                            } }));
                        break;
                    case '标准':
                        // pStr = '<i class="icon icon-arrow-up text-info"></i>';
                        pStr = (React.createElement("span", { dangerouslySetInnerHTML: {
                                __html: "<i class=\"icon icon-arrow-up text-info\"></i>".concat(i18n.t('components.ticketFilterTable.associatedTicketForm.priorityNormal')),
                            } }));
                        break;
                    case '紧急':
                        pStr = (React.createElement("span", { dangerouslySetInnerHTML: {
                                __html: "<i class=\"icon icon-emergent text-danger\"></i>".concat(i18n.t('components.ticketFilterTable.associatedTicketForm.priorityUrgent')),
                            } }));
                        break;
                }
                break;
            // 客户姓名脱敏
            case 'customer_name':
                if (record.customer_name) {
                    var customerName = record.customer_name;
                    var params = {
                        name: 'name',
                    };
                    if (isSensitiveField) {
                        return (pStr = sensitiveField(params)(customerName)) || '';
                    }
                    else {
                        return (pStr = customerName);
                    }
                }
                break;
            // 客户邮箱脱敏
            case 'customer_email':
                if (record.customer_email) {
                    var customerEmail = record.customer_email;
                    var params = {
                        name: 'email',
                    };
                    if (isSensitiveField) {
                        return (pStr = sensitiveField(params)(customerEmail)) || '';
                    }
                    else {
                        return (pStr = customerEmail);
                    }
                }
                break;
            // 描述
            case 'content':
                if (record.content) {
                    var attachments = record.attachments || [];
                    var platform = record.platform_name;
                    var result = '';
                    var value = record.content;
                    if (platform === 'email') {
                        value = removeHtmlErrorAttr(value);
                        result = attachments.length
                            ? "\uD83D\uDCCE ".concat(xssByEmailWhitelist(value))
                            : xssByEmailWhitelist(value);
                        result = RemoveHtmlTag(replaceScriptCode(result));
                    }
                    else {
                        result = attachments.length
                            ? "\uD83D\uDCCE ".concat(xssByWhitelist(value))
                            : xssByWhitelist(value);
                        result = RemoveHtmlTag(replaceScriptCode(result));
                    }
                    pStr = (React.createElement("div", { dangerouslySetInnerHTML: {
                            __html: result,
                        } }));
                }
                break;
            // 创建时间
            case 'solving_at':
            case 'resolved_at':
            case 'replied_at':
            case 'updated_at':
            case 'customer_replied_at':
            case 'closed_at':
            case 'created_at':
                if (record[id]) {
                    var d = new Date(record[id]);
                    pStr =
                        d.getFullYear() +
                            '-' +
                            (d.getMonth() + 1) +
                            '-' +
                            d.getDate() +
                            ' ' +
                            d.getHours() +
                            ':' +
                            d.getMinutes() +
                            ':' +
                            d.getSeconds();
                }
                else {
                    pStr = '';
                }
                break;
            case 'customer_is_blocked':
                pStr =
                    text === true
                        ? i18n.t('components.ticketFilterTable.associatedTicketForm.yes')
                        : i18n.t('components.ticketFilterTable.associatedTicketForm.no');
                break;
            case 'customer_rich_tags':
                pStr = Array.isArray(text) ? text.map(function (v) { return v.name; }).join(',') : text;
            // 公司相关
            case 'organization':
                pStr = (text === null || text === void 0 ? void 0 : text.name) || '';
                break;
            case 'organizationDomains':
                pStr = (_b = (_a = record === null || record === void 0 ? void 0 : record.organization) === null || _a === void 0 ? void 0 : _a.domains) !== null && _b !== void 0 ? _b : '';
                break;
            case 'organizationOrgEmailSuffix':
                pStr = (_d = (_c = record === null || record === void 0 ? void 0 : record.organization) === null || _c === void 0 ? void 0 : _c.org_email_suffix) !== null && _d !== void 0 ? _d : '';
                break;
            case 'organizationDescription':
                pStr = (_f = (_e = record === null || record === void 0 ? void 0 : record.organization) === null || _e === void 0 ? void 0 : _e.description) !== null && _f !== void 0 ? _f : '';
                break;
            case 'template_name':
                pStr = (_h = (_g = record === null || record === void 0 ? void 0 : record.template) === null || _g === void 0 ? void 0 : _g.template_name) !== null && _h !== void 0 ? _h : '';
                break;
            case 'updator_id':
                if (record === null || record === void 0 ? void 0 : record.updator_id) {
                    var updator = agentsWithAdmin === null || agentsWithAdmin === void 0 ? void 0 : agentsWithAdmin.find(function (agent) { return (agent === null || agent === void 0 ? void 0 : agent.id) == parseInt(record === null || record === void 0 ? void 0 : record.updator_id, 10); });
                    pStr = updator ? updator === null || updator === void 0 ? void 0 : updator.nick_name : '';
                }
                else {
                    pStr = '';
                }
                break;
            case 'followers':
                return (_k = (_j = record === null || record === void 0 ? void 0 : record.followers) === null || _j === void 0 ? void 0 : _j.map(function (follower) { return follower === null || follower === void 0 ? void 0 : follower.nick_name; }).filter(Boolean).join(',')) !== null && _k !== void 0 ? _k : '';
                break;
            default:
                pStr = text;
                break;
        }
        return pStr;
    };
    // 自定义模板
    var customizeRender = function (text, record, index, customize) {
        var _a;
        // record列表数据
        // 合并所有自定义字段的值，公司/客户/工单
        var customFieldsValue = Object.assign([], record.custom_fields, record.customer_custom_fields, (_a = record === null || record === void 0 ? void 0 : record.organization) === null || _a === void 0 ? void 0 : _a.custom_fields);
        var renderList = getCustomFieldValue(customize, customFieldsValue === null || customFieldsValue === void 0 ? void 0 : customFieldsValue[customize.name], agents);
        return renderList;
    };
    useMemo(function () {
        // TODO： 列表数据,否则checkbox有问题，这里需要深入研究下是否一定需要这个key
        lists.forEach(function (item) {
            // @ts-ignore
            item.key = item.id;
        });
        setticketsLists(lists.map(function (item) { return item; }));
    }, [lists]);
    var columnsLists = useMemo(function () {
        //表头数据
        var columnsLists = [];
        columns.forEach(function (itemColumns) {
            if (itemColumns === void 0) { itemColumns = {}; }
            var id = itemColumns.id, fieldMode = itemColumns.fieldMode, otherColumnAttributes = __rest(itemColumns, ["id", "fieldMode"]);
            if (fieldMode == 'system') {
                if (id) {
                    columnsLists.push(__assign({ title: getFieldName(id, ticketSystemFields), dataIndex: id, key: id, width: itemColumns.width || '150px', sorter: itemColumns.sorter, ellipsis: itemColumns.ellipsis, render: function (text, record, index) {
                            return systemRender(itemColumns, record, text, index);
                        } }, otherColumnAttributes));
                }
                // let columnsConfig = COLUMNS_MAP.find((column) => column.id == id);
                // if (columnsConfig) {
                //     columnsLists.push({
                //         title: systemField ? systemField(columnsConfig.id, ticketSystemFields) : '',
                //         dataIndex: columnsConfig.id,
                //         key: columnsConfig.id,
                //         width: itemColumns.width || '150px',
                //         sorter: itemColumns.sorter,
                //         ellipsis: itemColumns.ellipsis,
                //         render: (text: string, record: ITicket, index: number) =>
                //             systemRender(text, record, index, columnsConfig.id),
                //         ...otherColumnAttributes,
                //     });
                // } else {
                //     columnsLists.push({
                //         title: systemField ? systemField(id, ticketSystemFields) : '',
                //         dataIndex: id,
                //         key: id,
                //         width: itemColumns.width || '150px',
                //         sorter: itemColumns.sorter,
                //         ellipsis: itemColumns.ellipsis,
                //         render: (text: string, record: ITicket, index: number) =>
                //             systemRender(text, record, index, id),
                //         ...otherColumnAttributes,
                //     });
                // }
            }
            else if (fieldMode == 'customTemplate') {
                columnsLists.push(itemColumns);
            }
            else {
                customizeLists.forEach(function (item_map) {
                    if (item_map.name == id) {
                        columnsLists.push(__assign({ title: item_map.title, dataIndex: item_map.id, key: item_map.id, width: itemColumns.width || '150px', sorter: itemColumns.sorter, ellipsis: itemColumns.ellipsis, render: function (text, record, index) {
                                return customizeRender(text, record, index, item_map);
                            } }, otherColumnAttributes));
                    }
                });
            }
        });
        return columnsLists;
    }, [columns, customizeLists]);
    return (React.createElement(React.Fragment, null,
        React.createElement("div", null,
            React.createElement(Table
            // TODO:类型重新定义
            // @ts-ignore
            , { 
                // TODO:类型重新定义
                // @ts-ignore
                columns: columnsLists, dataSource: ticketsLists, scrollToFirstRowOnChange: true, scroll: scroll, rowSelection: __assign({ 
                    //表格行切换
                    type: selectionType || 'checkbox' }, rowSelection), onRow: onRow, 
                // TODO:类型重新定义
                // @ts-ignore
                onChange: onChange, pagination: pagination }))));
};
export default associatedTicketForm;
