import _AutoComplete from "antd/es/auto-complete";

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }

function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

// prettier-ignore
import React, { useRef, useImperativeHandle, useState, useContext, useEffect, useMemo } from 'react';
// import { OptionData, OptionGroupData } from 'rc-select/lib/interface';
import message from "../message";
import Spin from "../spin";
import { LoadingOutlined } from '@ant-design/icons';
import debounce from 'lodash-es/debounce';
import { copyFromAntd } from "../_utils/core";
import { isAbortedError } from "../_utils/request";
import { UdeskContext } from "../config-provider";
import { libraryName } from "../_utils/vars";
export * from 'antd/es/auto-complete'; //#endregion
//#region defaultProps

/** UdeskAutoComplete的默认值 */

var defaultProps = {
  outputMode: 'value',
  allowEmpty: true,
  searchHttpMethod: 'GET',
  queryParamName: 'keyword',
  search: undefined,
  // search: 'https://www.google.com/test',
  // async search(query, { pageNum, pageSize, total, abortSignal }) {
  //     console.log(query, pageNum, pageSize);
  //     return new Promise((resolve, reject) => {
  //         setTimeout(() => {
  //             let options: TOption[] = [];
  //             for (let i = total + 1; i <= pageSize + total; i++) {
  //                 let value = Math.round(Date.now() * Math.random());
  //                 options.push({
  //                     label: `${query}_${i}`,
  //                     value: value.toString(),
  //                 });
  //             }
  //             resolve(options);
  //         }, 500);
  //     });
  // },
  emptySearchOnFocus: true,
  searchDebounce: 500,
  getResponseData: function getResponseData(resp) {
    return (resp === null || resp === void 0 ? void 0 : resp.data) || resp;
  },
  resolveLabel: undefined,
  valueField: 'value',
  labelField: 'label',
  childOptionsField: 'options',
  labelPreferred: true,
  pageNumParamName: 'pageNum',
  pageSizeParamName: 'pageSize',
  pageSize: 50,
  infiniteScrolling: true,
  scrollToEndOffset: 160,
  infiniteScrollingMaxNum: 2000
}; //#endregion

/** 默认页码，默认为1 */

var DefaultPage = 1;
/** UdeskAutoComplete组件，对 AutoComplete 组件的扩展，在与其保持兼容的同时，扩展了一些新的特性 */

var UdeskAutoComplete = function UdeskAutoComplete(props, ref) {
  // 获取全局context对象，可以获取很多全局信息，包括intl国际化对象
  var udeskContext = useContext(UdeskContext); // 构造AutoCompleteProps，兼容字段可以直接拷贝过来。其余的不兼容字段，在下面进行重写。

  var autoCompleteProps = useMemo(function () {
    var newOptions = {}; // 仅拷贝AutoComplete声明的props，排除我们扩展的字段，否则AutoComplete警告有些字段不识别

    Object.keys(props).forEach(function (k) {
      if (!Object.prototype.hasOwnProperty.call(defaultProps, k)) {
        newOptions[k] = props[k];
      }
    });
    return newOptions;
  }, [props]); // prettier-ignore

  var propValue = props.value,
      defaultValue = props.defaultValue,
      valueField = props.valueField,
      labelField = props.labelField,
      outputMode = props.outputMode,
      childOptionsField = props.childOptionsField,
      labelPreferred = props.labelPreferred,
      pageNumParamName = props.pageNumParamName,
      pageSizeParamName = props.pageSizeParamName,
      resolveLabel = props.resolveLabel,
      getResponseData = props.getResponseData;
  var value = propValue || defaultValue; // 重新初始化 value 属性，并监听变化

  var _useState = useState(),
      _useState2 = _slicedToArray(_useState, 2),
      currentText = _useState2[0],
      setCurrentText = _useState2[1];

  var _useState3 = useState(value),
      _useState4 = _slicedToArray(_useState3, 2),
      currentValue = _useState4[0],
      setCurrentValue = _useState4[1];

  var _useState5 = useState(value),
      _useState6 = _slicedToArray(_useState5, 2),
      previousValidValue = _useState6[0],
      setPreviousValidValue = _useState6[1];

  var _useState7 = useState(currentText),
      _useState8 = _slicedToArray(_useState7, 2),
      previousValidLabel = _useState8[0],
      setPreviousValidLabel = _useState8[1]; // prettier-ignore


  useEffect(function () {
    // 只监听propValue的变化，改变text
    var label = getLabelFromValue({
      value: propValue || defaultValue,
      labelField: labelField,
      valueField: valueField,
      outputMode: outputMode,
      labelPreferred: labelPreferred,
      resolveLabel: resolveLabel,
      udeskContext: udeskContext
    });
    setCurrentText(label);
    setPreviousValidValue(propValue);
    setPreviousValidLabel(label); // eslint-disable-next-line react-hooks/exhaustive-deps
  }, [propValue, labelField, outputMode, resolveLabel, udeskContext, valueField, labelPreferred]); // 把传入的 options 转化成 {label, value} 这样标准的数据结构，
  // 传入的 options 可能是自定义对象，类似 {labelField, valueField}，当然也支持使用标准结构

  var options = props.options,
      dataSource = props.dataSource; // prettier-ignore

  var _useState9 = useState([]),
      _useState10 = _slicedToArray(_useState9, 2),
      autoCompleteOptions = _useState10[0],
      setAutoCompleteOptions = _useState10[1]; // 监听 options 和 dataSource 的变化，重新计算 autoCompleteOptions
  // prettier-ignore


  useEffect(function () {
    setAutoCompleteOptions(getAutoCompleteOptions({
      options: options,
      dataSource: dataSource,
      valueField: valueField,
      labelField: labelField,
      childOptionsField: childOptionsField
    }));
  }, [options, dataSource, valueField, labelField, childOptionsField]); // 把 options 展开成一维数组，主要是用来根据 label 查找对象，因为AC底层只支持字符串格式
  // 有可能包含option groups。

  var _useState11 = useState([]),
      _useState12 = _slicedToArray(_useState11, 2),
      optionList = _useState12[0],
      setOptionList = _useState12[1]; // 监听options和dataSource的变化，如果发生变化就重新计算options


  useEffect(function () {
    setOptionList(getOriginalOptionList({
      options: options
    }));
  }, [options, dataSource, valueField, labelField, childOptionsField]); // 用 value 异步解析 label，再进行回显。value有可能是个数字，不能直接回显给用户。
  // 在异步拉取期间，显示一个loading动画，提示用户当前组件暂时不可用

  var _useState13 = useState(false),
      _useState14 = _slicedToArray(_useState13, 2),
      isResolvingLabel = _useState14[0],
      setIsResolvingLabel = _useState14[1]; // 记录动态解析的对象，在一些场景下还要加回去的，比如每次重新search后


  var _useState15 = useState(),
      _useState16 = _slicedToArray(_useState15, 2),
      resolvedOption = _useState16[0],
      setResolvedOption = _useState16[1]; // prettier-ignore


  useEffect(function () {
    if (shouldResolveLabel({
      outputMode: outputMode,
      resolveLabel: resolveLabel,
      currentText: currentText,
      currentValue: currentValue,
      resolvedOption: resolvedOption,
      isResolvingLabel: isResolvingLabel
    })) {
      resolveLabelByValue({
        currentText: currentText,
        currentValue: currentValue,
        valueField: valueField,
        labelField: labelField,
        outputMode: outputMode,
        resolvedOption: resolvedOption,
        isResolvingLabel: isResolvingLabel,
        resolveLabel: resolveLabel,
        getResponseData: getResponseData,
        setCurrentText: setCurrentText,
        setCurrentValue: setCurrentValue,
        udeskContext: udeskContext,
        setIsResolvingLabel: setIsResolvingLabel,
        setResolvedOption: setResolvedOption,
        setPreviousValidValue: setPreviousValidValue,
        setPreviousValidLabel: setPreviousValidLabel
      });
    }
  }, [currentText, currentValue, getResponseData, isResolvingLabel, labelField, outputMode, resolveLabel, resolvedOption, udeskContext, valueField]);
  /* 重写AutoComplete与Select不兼容的几个事件 */
  // 重写onselect事件。AutoComplete只支持字符串的value，但我们需要把值包装成对象，方便业务项目使用

  var onSelect = props.onSelect;
  var autoCompleteOnSelect = useMemo(function () {
    // prettier-ignore
    return getOnSelectHandler({
      optionList: optionList,
      valueField: valueField,
      labelField: labelField,
      outputMode: outputMode,
      onSelect: onSelect
    });
  }, [optionList, valueField, labelField, outputMode, onSelect]); // 重写onDeselect事件。AutoComplete不会触发这个事件，但也实现了内部逻辑，以防未来antd支持此事件

  var onDeselect = props.onDeselect;
  var autoCompleteOnDeselect = useMemo(function () {
    // prettier-ignore
    return getOnDeselectHandler({
      optionList: optionList,
      valueField: valueField,
      labelField: labelField,
      outputMode: outputMode,
      onDeselect: onDeselect
    });
  }, [optionList, valueField, labelField, outputMode, onDeselect]); // 重写onChange事件，如果有匹配到的Option，返回Option，否则返回value字符串

  var onChange = props.onChange;
  var autoCompleteOnChange = useMemo(function () {
    // prettier-ignore
    return getOnChangeHandler({
      optionList: optionList,
      valueField: valueField,
      labelField: labelField,
      outputMode: outputMode,
      onChange: onChange,
      setCurrentText: setCurrentText,
      setCurrentValue: setCurrentValue,
      setPreviousValidLabel: setPreviousValidLabel,
      setPreviousValidValue: setPreviousValidValue
    });
  }, [optionList, valueField, labelField, outputMode, onChange]);
  /* 重写 onSearch 事件，如果没有传 options 数据源的话，会自动进行搜索。 */
  // prettier-ignore

  var onSearch = props.onSearch,
      search = props.search,
      searchDebounce = props.searchDebounce,
      pageSize = props.pageSize,
      searchHttpMethod = props.searchHttpMethod,
      queryParamName = props.queryParamName,
      emptySearchOnFocus = props.emptySearchOnFocus,
      infiniteScrolling = props.infiniteScrolling;

  var _useState17 = useState(),
      _useState18 = _slicedToArray(_useState17, 2),
      abortController = _useState18[0],
      setAbortController = _useState18[1];

  var _useState19 = useState(),
      _useState20 = _slicedToArray(_useState19, 2),
      loadingPage = _useState20[0],
      setLoadingPage = _useState20[1];

  var _useState21 = useState(),
      _useState22 = _slicedToArray(_useState21, 2),
      currentPage = _useState22[0],
      setCurrentPage = _useState22[1];

  var _useState23 = useState(false),
      _useState24 = _slicedToArray(_useState23, 2),
      noMoreData = _useState24[0],
      setNoMoreData = _useState24[1];

  var _useState25 = useState(0),
      _useState26 = _slicedToArray(_useState25, 2),
      total = _useState26[0],
      setTotal = _useState26[1];

  var _useState27 = useState(false),
      _useState28 = _slicedToArray(_useState27, 2),
      isAutoFocusSearch = _useState28[0],
      setIsAutoFocusSearch = _useState28[1]; // prettier-ignore


  var autoCompleteOnSearch = useMemo(function () {
    return getOnSearchHandler({
      options: options,
      dataSource: dataSource,
      search: search,
      getResponseData: getResponseData,
      searchDebounce: searchDebounce,
      abortController: abortController,
      setAbortController: setAbortController,
      loadingPage: loadingPage,
      pageSize: pageSize,
      searchHttpMethod: searchHttpMethod,
      queryParamName: queryParamName,
      labelField: labelField,
      valueField: valueField,
      childOptionsField: childOptionsField,
      pageNumParamName: pageNumParamName,
      pageSizeParamName: pageSizeParamName,
      udeskContext: udeskContext,
      emptySearchOnFocus: emptySearchOnFocus,
      setCurrentText: setCurrentText,
      setCurrentPage: setCurrentPage,
      setLoadingPage: setLoadingPage,
      setNoMoreData: setNoMoreData,
      setTotal: setTotal,
      setOptionList: setOptionList,
      setAutoCompleteOptions: setAutoCompleteOptions,
      setIsAutoFocusSearch: setIsAutoFocusSearch,
      onSearch: onSearch
    });
  }, [options, dataSource, onSearch, search, searchDebounce, getResponseData, emptySearchOnFocus, abortController, loadingPage, pageSize, searchHttpMethod, queryParamName, labelField, valueField, pageNumParamName, pageSizeParamName, childOptionsField, udeskContext]);
  /* 绑定 OnPopupScroll 事件，实现无限滚动加载 */

  var onPopupScroll = props.onPopupScroll,
      scrollToEndOffset = props.scrollToEndOffset,
      listItemHeight = props.listItemHeight,
      infiniteScrollingMaxNum = props.infiniteScrollingMaxNum; // prettier-ignore

  var autoCompleteOnPopupScroll = useMemo(function () {
    // 搜索补全下拉项
    return getOnPopupScrollHandler({
      options: options,
      dataSource: dataSource,
      search: search,
      getResponseData: getResponseData,
      currentText: currentText,
      loadingPage: loadingPage,
      currentPage: currentPage,
      noMoreData: noMoreData,
      total: total,
      scrollToEndOffset: scrollToEndOffset,
      listItemHeight: listItemHeight,
      abortController: abortController,
      setAbortController: setAbortController,
      autoCompleteOptions: autoCompleteOptions,
      optionList: optionList,
      infiniteScrollingMaxNum: infiniteScrollingMaxNum,
      pageSize: pageSize,
      searchHttpMethod: searchHttpMethod,
      queryParamName: queryParamName,
      labelField: labelField,
      valueField: valueField,
      childOptionsField: childOptionsField,
      pageNumParamName: pageNumParamName,
      pageSizeParamName: pageSizeParamName,
      udeskContext: udeskContext,
      isAutoFocusSearch: isAutoFocusSearch,
      setCurrentPage: setCurrentPage,
      setLoadingPage: setLoadingPage,
      setNoMoreData: setNoMoreData,
      setTotal: setTotal,
      setOptionList: setOptionList,
      setAutoCompleteOptions: setAutoCompleteOptions,
      onPopupScroll: onPopupScroll,
      infiniteScrolling: infiniteScrolling
    });
  }, [options, dataSource, search, getResponseData, currentText, currentPage, total, noMoreData, scrollToEndOffset, listItemHeight, abortController, autoCompleteOptions, optionList, loadingPage, pageSize, infiniteScrollingMaxNum, searchHttpMethod, queryParamName, labelField, valueField, childOptionsField, pageNumParamName, pageSizeParamName, udeskContext, isAutoFocusSearch, onPopupScroll, infiniteScrolling]); // 重写onChange事件，如果有匹配到的Option，返回Option，否则返回value字符串

  var onFocus = props.onFocus; // prettier-ignore

  var autoCompleteOnFocus = useMemo(function () {
    return getOnFocusHandler({
      currentText: currentText,
      options: options,
      dataSource: dataSource,
      search: search,
      getResponseData: getResponseData,
      abortController: abortController,
      total: total,
      setAbortController: setAbortController,
      loadingPage: loadingPage,
      pageSize: pageSize,
      searchHttpMethod: searchHttpMethod,
      queryParamName: queryParamName,
      labelField: labelField,
      valueField: valueField,
      childOptionsField: childOptionsField,
      pageNumParamName: pageNumParamName,
      pageSizeParamName: pageSizeParamName,
      udeskContext: udeskContext,
      emptySearchOnFocus: emptySearchOnFocus,
      setCurrentPage: setCurrentPage,
      setLoadingPage: setLoadingPage,
      setNoMoreData: setNoMoreData,
      setTotal: setTotal,
      setOptionList: setOptionList,
      setAutoCompleteOptions: setAutoCompleteOptions,
      setIsAutoFocusSearch: setIsAutoFocusSearch,
      onFocus: onFocus
    });
  }, [currentText, options, dataSource, search, getResponseData, abortController, total, loadingPage, pageSize, searchHttpMethod, queryParamName, labelField, valueField, childOptionsField, pageNumParamName, pageSizeParamName, udeskContext, emptySearchOnFocus, onFocus]); // 重写onChange事件，如果有匹配到的Option，返回Option，否则返回value字符串

  var allowEmpty = props.allowEmpty,
      onBlur = props.onBlur; // prettier-ignore

  var autoCompleteOnBlur = useMemo(function () {
    return getOnBlurHandler({
      currentText: currentText,
      currentValue: currentValue,
      previousValidLabel: previousValidLabel,
      previousValidValue: previousValidValue,
      allowEmpty: allowEmpty,
      outputMode: outputMode,
      emptySearchOnFocus: emptySearchOnFocus,
      onChange: onChange,
      setCurrentText: setCurrentText,
      setPreviousValidValue: setPreviousValidValue,
      setPreviousValidLabel: setPreviousValidLabel,
      setAutoCompleteOptions: setAutoCompleteOptions,
      setCurrentPage: setCurrentPage,
      setTotal: setTotal,
      setIsAutoFocusSearch: setIsAutoFocusSearch,
      onBlur: onBlur
    });
  }, [currentText, currentValue, previousValidLabel, previousValidValue, allowEmpty, outputMode, emptySearchOnFocus, onChange, onBlur]); // 指定forwardRef的对象，仅输出api对象，隐藏组件实例的细节

  var autoCompleteRef = useRef(null);
  useImperativeHandle(ref, function () {
    var _autoCompleteRef$curr, _autoCompleteRef$curr2;

    // 组件内部控制暴露给外界的API，而不是默认暴露整个组件实例
    return {
      focus: ((_autoCompleteRef$curr = autoCompleteRef.current) === null || _autoCompleteRef$curr === void 0 ? void 0 : _autoCompleteRef$curr.focus) || function () {},
      blur: ((_autoCompleteRef$curr2 = autoCompleteRef.current) === null || _autoCompleteRef$curr2 === void 0 ? void 0 : _autoCompleteRef$curr2.blur) || function () {}
    };
  }); // 渲染 antd 的 AutoComplete组件

  var antIcon = /*#__PURE__*/React.createElement(LoadingOutlined, {
    style: {
      fontSize: 24
    },
    spin: true
  });
  return /*#__PURE__*/React.createElement(Spin, {
    indicator: antIcon,
    spinning: isResolvingLabel
  }, /*#__PURE__*/React.createElement(_AutoComplete, _objectSpread(_objectSpread({}, autoCompleteProps), {}, {
    value: currentText,
    options: autoCompleteOptions,
    onSelect: autoCompleteOnSelect,
    onDeselect: autoCompleteOnDeselect,
    onChange: autoCompleteOnChange,
    onSearch: autoCompleteOnSearch,
    onPopupScroll: autoCompleteOnPopupScroll,
    onFocus: autoCompleteOnFocus,
    onBlur: autoCompleteOnBlur,
    ref: autoCompleteRef
  })));
};

UdeskAutoComplete.displayName = 'UdeskAutoComplete'; // 真正用来导出的组件
// @ts-expect-error

var ExportAutoComplete = /*#__PURE__*/React.forwardRef(UdeskAutoComplete); // 拷贝源类型上的静态字段

copyFromAntd(ExportAutoComplete, _AutoComplete);
ExportAutoComplete.AntdAutoComplete = _AutoComplete; // 重新扩展 defaultProps

ExportAutoComplete.defaultProps = _objectSpread(_objectSpread({}, _AutoComplete.defaultProps), defaultProps);
export * from "../_utils/type"; // 扩展静态字段，添加上除了 AutoComplete 自身类型以外的静态字段

export default ExportAutoComplete; //#endregion
//#region 模块的一些内部函数，折叠起来容易维护

/** 根据组件的value获取对应的label，传递给AutoComplete，它只接受字符串。
 * 如果outputMode是对象模式，可以提取label，但如果outputMode是value模式的话，需要异步请求label
 */

function getLabelFromValue(_ref) {
  var value = _ref.value,
      labelField = _ref.labelField,
      valueField = _ref.valueField,
      outputMode = _ref.outputMode,
      labelPreferred = _ref.labelPreferred,
      resolveLabel = _ref.resolveLabel,
      udeskContext = _ref.udeskContext;

  if (value == null) {
    return undefined;
  }

  if (value === '') {
    return '';
  }

  switch (outputMode) {
    case 'labelInValue':
      if (_typeof(value) === 'object') {
        if (labelPreferred) {
          var _value;

          return (_value = value[labelField || defaultProps.labelField]) === null || _value === void 0 ? void 0 : _value.toString();
        } else {
          var _value2;

          return (_value2 = value[valueField || defaultProps.valueField]) === null || _value2 === void 0 ? void 0 : _value2.toString();
        }
      } else {
        throw new Error("".concat(libraryName, "/AutoComplete\u8F93\u5165\u503C\u7684\u683C\u5F0F\u9519\u8BEF\u3002\u671F\u5F85\u4E00\u4E2A {label, value} \u5BF9\u8C61\uFF0C") + "\u7ED3\u679C\u4E3A ".concat(JSON.stringify(value), "\u3002") + "\u5982\u679C\u8981\u4F7F\u7528\u5B57\u7B26\u4E32\u7C7B\u578B\u7684\u8BDD\uFF0C\u8BF7\u628A outputMode \u8BBE\u7F6E\u4E3A value\u3002");
      }

    case 'string':
      return value;

    case 'value':
    default:
      if (_typeof(value) === 'object') {
        var _value3;

        // 这其实是一种不正常的情况，需要value但给了一个对象，也可以做个兼容
        return (_value3 = value[labelField || defaultProps.labelField]) === null || _value3 === void 0 ? void 0 : _value3.toString();
      } else {
        // 如果提供了 resolveLabel 方法，则会在 fetchLabelByValue 方法中异步拉取 label 再回显。
        if (resolveLabel == null) {
          // 但如果没有提供 resolveLabel 方法，则只能用 `value` 来回显。但这可能不是用户想要的，
          // 因为 value 可能只是一个数字。很可能是忘了设置 resolveLabel 属性方法。
          // 所以在开发模式下打印一个错误。
          if (udeskContext.debugMode) {
            console.error("AutoComplete \u7EC4\u4EF6\u4F20\u5165\u7684\u503C\u4E3A ".concat(value, "\uFF0C") + "\u4F46\u6CA1\u6709\u63D0\u4F9B resolveLabel \u65B9\u6CD5\u5C5E\u6027\u6765\u62C9\u53D6 label \u6765\u56DE\u663E\uFF0C\u6240\u4EE5\u81EA\u52A8\u964D\u7EA7\u4F7F\u7528 value \u8FDB\u884C\u56DE\u663E\u3002\n" + "\u5982\u679C\u53EA\u662F\u6807\u51C6\u7684\u5B57\u7B26\u4E32\u4F7F\u7528\u573A\u666F\uFF0C\u4E0D\u9700\u8981 {value, label} \u7ED3\u6784\u7684\u8BDD\uFF0C\u8BF7\u628A outputMode \u8BBE\u7F6E\u4E3A string\u3002");
          }
        }

        return value;
      }

  }
}
/** 判断是否需要解析 value 值对应的 label */


function shouldResolveLabel(_ref2) {
  var outputMode = _ref2.outputMode,
      resolveLabel = _ref2.resolveLabel,
      currentText = _ref2.currentText,
      currentValue = _ref2.currentValue,
      resolvedOption = _ref2.resolvedOption,
      isResolvingLabel = _ref2.isResolvingLabel;

  /* 只有满足以下条件才需要异步拉取label
   1. 给组件设置了值（如果没设置值，是不需要回显的）
   2. outputMode 是 value （对象和字符串模式都不需要异步拉取，都已经具备了label，可以直接回显）
   3. value 类型不是对象 (如果是对象，则可以直接提取label)
   4. currentText为空（表示只有value而没有text），或者currentText与currentValue相等（一般是value被重新赋值，此时虽然有currentText，但其实不能直接回显，而是需要先resolve）
   4. 提供了 resolveLabel 方法 （这个是前提吧 -_-||）
   5. 已经resolve完成了，并且 label 相同（说明 value 已经解析过了，不要重复解析）
   6. isResolvingLabel == false （resolve的过程可能是异步的，如果已经在解析了，就不要重复解析了）
  */
  var isResolved = resolvedOption && resolvedOption.label === currentText;
  return currentValue && outputMode === 'value' && _typeof(currentValue) !== 'object' && (!currentText || currentValue === currentText) && resolveLabel && !isResolved && !isResolvingLabel;
}
/** 根据 value 的值动态解析对应的 label 值 */


function resolveLabelByValue(_ref3) {
  var currentText = _ref3.currentText,
      currentValue = _ref3.currentValue,
      valueField = _ref3.valueField,
      labelField = _ref3.labelField,
      outputMode = _ref3.outputMode,
      resolvedOption = _ref3.resolvedOption,
      isResolvingLabel = _ref3.isResolvingLabel,
      resolveLabel = _ref3.resolveLabel,
      getResponseData = _ref3.getResponseData,
      setCurrentText = _ref3.setCurrentText,
      setCurrentValue = _ref3.setCurrentValue,
      udeskContext = _ref3.udeskContext,
      setIsResolvingLabel = _ref3.setIsResolvingLabel,
      setResolvedOption = _ref3.setResolvedOption,
      setPreviousValidValue = _ref3.setPreviousValidValue,
      setPreviousValidLabel = _ref3.setPreviousValidLabel;

  // 只有设置了值的情况下，并且 outputMode 是 value，
  // 以及 value 类型不是 { label, value } 这样对象的情况下，才可能需要异步拉取 label
  if (shouldResolveLabel({
    outputMode: outputMode,
    resolveLabel: resolveLabel,
    currentText: currentText,
    currentValue: currentValue,
    resolvedOption: resolvedOption,
    isResolvingLabel: isResolvingLabel
  })) {
    var value = currentText; // 由于shouldFetchLabel已经判断了value必须存在，所以这里不为空
    // 调用 resolveLabel 方法把 value 翻译为 label，再重新传给 AutoComplete 重新回显

    var label = resolveLabel(value);

    if (label instanceof Promise) {
      // 是异步返回的，需要等待完成后重新设置 value  重新回显
      setIsResolvingLabel(true);
      label.then(function (resp) {
        setIsResolvingLabel(false);
        var remoteLabel = '';

        if (typeof resp === 'string') {
          remoteLabel = resp;
        } else {
          remoteLabel = (getResponseData || defaultProps.getResponseData)(resp);

          if (typeof remoteLabel !== 'string') {
            throw new Error("".concat(libraryName, "/AutoComplete \u7684 resolveLabel \u65B9\u6CD5\u5C5E\u6027\u8FD4\u56DE\u4E86\u9519\u8BEF\u7684\u5F02\u6B65\u6570\u636E\uFF0C") + "\u65E0\u6CD5\u4ECE\u6570\u636E\u4E2D\u63D0\u53D6 label \u503C\u3002\u8BF7\u4F7F\u7528 getResponseData \u65B9\u6CD5\u624B\u52A8\u4ECE response \u4E2D\u63D0\u53D6 label\uFF0C" + "\u8FD4\u56DE\u503C\u5FC5\u987B\u662F\u5B57\u7B26\u4E32\u3002");
          }
        }

        innerSetResolvedValue({
          label: remoteLabel,
          value: value,
          valueField: valueField,
          labelField: labelField,
          setCurrentText: setCurrentText,
          setCurrentValue: setCurrentValue,
          setResolvedOption: setResolvedOption,
          setPreviousValidValue: setPreviousValidValue,
          setPreviousValidLabel: setPreviousValidLabel
        });
      })["catch"](function (reason) {
        setIsResolvingLabel(false);
        var errorMsg = udeskContext.intl.formatMessage({
          id: 'AutoComplete.fetchLabelError'
        }, {
          value: value
        });
        window.console.error(reason);
        innerSetResolvedValue({
          label: errorMsg,
          value: value,
          valueField: valueField,
          labelField: labelField,
          setCurrentText: setCurrentText,
          setCurrentValue: setCurrentValue,
          setResolvedOption: setResolvedOption,
          setPreviousValidValue: setPreviousValidValue,
          setPreviousValidLabel: setPreviousValidLabel
        });
      });
    } else {
      // 同步返回了 label，直接回显
      innerSetResolvedValue({
        label: label,
        value: value,
        valueField: valueField,
        labelField: labelField,
        setCurrentText: setCurrentText,
        setCurrentValue: setCurrentValue,
        setResolvedOption: setResolvedOption,
        setPreviousValidValue: setPreviousValidValue,
        setPreviousValidLabel: setPreviousValidLabel
      });
    }
  }
}
/** 直接设置解析后的结果，回显 label，以及保存解析结果对象 */


function innerSetResolvedValue(_ref4) {
  var label = _ref4.label,
      value = _ref4.value,
      valueField = _ref4.valueField,
      labelField = _ref4.labelField,
      setCurrentText = _ref4.setCurrentText,
      setCurrentValue = _ref4.setCurrentValue,
      setResolvedOption = _ref4.setResolvedOption,
      setPreviousValidValue = _ref4.setPreviousValidValue,
      setPreviousValidLabel = _ref4.setPreviousValidLabel;

  /*  该把 label 作为 value 传递给 AutoComplete，让它进行回显。
   */
  var userOption = _defineProperty(_defineProperty({}, labelField || defaultProps.labelField, label), valueField || defaultProps.valueField, value); // 把新option添加到数据源中去


  setResolvedOption(userOption);
  setCurrentText(label);
  setCurrentValue(value);
  setPreviousValidValue(value);
  setPreviousValidLabel(label);
}
/** 把props.options(可能是自定义对象)或dataSource转化成AutoComplete标准的options */


function getAutoCompleteOptions(_ref5) {
  var options = _ref5.options,
      dataSource = _ref5.dataSource,
      valueField = _ref5.valueField,
      labelField = _ref5.labelField,
      childOptionsField = _ref5.childOptionsField;
  var optionGroups = options !== null && options !== void 0 ? options : [];

  if (dataSource && !options) {
    // 如果仅适用dataSource，则转化成options的数据结构，后面只使用options
    optionGroups = dataSource.map(function (v) {
      // 字符串变成对象，value和label相同
      if (typeof v === 'string') {
        return _defineProperty(_defineProperty({}, labelField || defaultProps.labelField, v), valueField || defaultProps.valueField, v);
      } else {
        return v;
      }
    });
  }

  return convertUserDataToOptions({
    data: optionGroups,
    labelField: labelField,
    valueField: valueField,
    childOptionsField: childOptionsField
  });
}
/** 把options转换成一维数组，届时根据AutoComplete输出的字符串value，遍历获取option对象  */


function getOriginalOptionList(_ref7) {
  var inputOptions = _ref7.options;
  var optionList = [];

  if (inputOptions) {
    inputOptions.forEach(function (item) {
      if (item.options) {
        optionList.push.apply(optionList, _toConsumableArray(getOriginalOptionList({
          options: item.options
        })));
      } else {
        optionList.push(item);
      }
    });
  }

  return optionList;
}
/** 用value匹配optionList中的label，有匹配则返回，同时转换成业务系统想要的数据结构，
 * 否则返回undefined */


function matchOption(_ref8) {
  var value = _ref8.value,
      optionList = _ref8.optionList,
      valueField = _ref8.valueField,
      labelField = _ref8.labelField;
  // eslint-disable-next-line eqeqeq
  var exactMatched = optionList === null || optionList === void 0 ? void 0 : optionList.find(function (o) {
    return o[labelField || defaultProps.labelField] == value;
  });

  if (!exactMatched) {
    exactMatched = optionList === null || optionList === void 0 ? void 0 : optionList.find(function (o) {
      var _o;

      return (// eslint-disable-next-line eqeqeq
        ((_o = o[labelField || defaultProps.labelField]) === null || _o === void 0 ? void 0 : _o.toString().toUpperCase()) == (value === null || value === void 0 ? void 0 : value.toUpperCase())
      );
    });
  }

  return exactMatched;
}
/* 把选中的Option对象转化成输出的值，根据 outputMode 的配置，可能输出value或者对象格式 */


function convertOptionToValue(_ref9) {
  var _item;

  var item = _ref9.item,
      outputMode = _ref9.outputMode,
      valueField = _ref9.valueField,
      labelField = _ref9.labelField;

  if (item) {
    switch (outputMode) {
      case 'labelInValue':
        return item;

      case 'string':
        return (_item = item[labelField || defaultProps.labelField]) === null || _item === void 0 ? void 0 : _item.toString();

      case 'value':
      default:
        return item[valueField || defaultProps.valueField] || item[labelField || defaultProps.labelField];
    }
  }

  return undefined;
}
/** 生成AutoComplete onSelect 事件回调函数 */


function getOnSelectHandler(_ref10) {
  var optionList = _ref10.optionList,
      valueField = _ref10.valueField,
      labelField = _ref10.labelField,
      outputMode = _ref10.outputMode,
      onSelect = _ref10.onSelect;
  return function (value, option) {
    var item = matchOption({
      value: value,
      optionList: optionList,
      labelField: labelField,
      valueField: valueField
    });

    if (item) {
      var outputValue = convertOptionToValue({
        item: item,
        outputMode: outputMode,
        labelField: labelField,
        valueField: valueField
      });

      if (onSelect) {
        onSelect(outputValue, option);
      }
    }
  };
}
/** 生成AutoComplete onDeselect 事件回调函数 */


function getOnDeselectHandler(_ref11) {
  var optionList = _ref11.optionList,
      valueField = _ref11.valueField,
      labelField = _ref11.labelField,
      outputMode = _ref11.outputMode,
      onDeselect = _ref11.onDeselect;
  return function (value, option) {
    var item = matchOption({
      value: value,
      optionList: optionList,
      labelField: labelField,
      valueField: valueField
    });

    if (item) {
      var outputValue = convertOptionToValue({
        item: item,
        outputMode: outputMode,
        labelField: labelField,
        valueField: valueField
      });

      if (onDeselect) {
        onDeselect(outputValue, option);
      }
    }
  };
}
/** 生成AutoComplete onChange 事件回调函数 */


function getOnChangeHandler(_ref12) {
  var optionList = _ref12.optionList,
      valueField = _ref12.valueField,
      labelField = _ref12.labelField,
      outputMode = _ref12.outputMode,
      onChange = _ref12.onChange,
      setCurrentText = _ref12.setCurrentText,
      setCurrentValue = _ref12.setCurrentValue,
      setPreviousValidLabel = _ref12.setPreviousValidLabel,
      setPreviousValidValue = _ref12.setPreviousValidValue;
  return function (value, option) {
    setCurrentText(value);
    var outputValue = undefined;

    if (outputMode === 'string') {
      // 如果是字符串模式，则文本原样输出
      outputValue = value;
    } else {
      var matchedOption = matchOption({
        value: value,
        optionList: optionList,
        labelField: labelField,
        valueField: valueField
      });

      if (matchedOption) {
        if (outputMode === 'labelInValue') {
          // 对象模式
          outputValue = matchedOption;
        } else {
          // value模式
          outputValue = convertOptionToValue({
            item: matchedOption,
            outputMode: outputMode,
            labelField: labelField,
            valueField: valueField
          });
        }
      } else {
        outputValue = undefined;
      }
    }

    setCurrentValue(outputValue);

    if (outputValue != null) {
      // 如果是有效的值，则保存在 setPreviousValidLabel 和 setPreviousValidValue 上，
      // 这样的话，如果下次没有匹配到值，再恢复成这两个值，不让 onChange 返回空
      setPreviousValidLabel(value);
      setPreviousValidValue(outputValue);
    }

    if (onChange) {
      onChange(outputValue, option);
    }
  };
}
/** 生成AutoComplete onFocus 事件回调函数 */


function getOnFocusHandler(_ref13) {
  var currentText = _ref13.currentText,
      options = _ref13.options,
      dataSource = _ref13.dataSource,
      search = _ref13.search,
      abortController = _ref13.abortController,
      loadingPage = _ref13.loadingPage,
      total = _ref13.total,
      pageSize = _ref13.pageSize,
      searchHttpMethod = _ref13.searchHttpMethod,
      queryParamName = _ref13.queryParamName,
      labelField = _ref13.labelField,
      valueField = _ref13.valueField,
      childOptionsField = _ref13.childOptionsField,
      pageNumParamName = _ref13.pageNumParamName,
      pageSizeParamName = _ref13.pageSizeParamName,
      udeskContext = _ref13.udeskContext,
      emptySearchOnFocus = _ref13.emptySearchOnFocus,
      setCurrentPage = _ref13.setCurrentPage,
      setLoadingPage = _ref13.setLoadingPage,
      setNoMoreData = _ref13.setNoMoreData,
      setTotal = _ref13.setTotal,
      setOptionList = _ref13.setOptionList,
      setAutoCompleteOptions = _ref13.setAutoCompleteOptions,
      setIsAutoFocusSearch = _ref13.setIsAutoFocusSearch,
      setAbortController = _ref13.setAbortController,
      getResponseData = _ref13.getResponseData,
      onFocus = _ref13.onFocus;
  return function (e) {
    if (options == null && dataSource == null) {
      if (emptySearchOnFocus) {
        setIsAutoFocusSearch(true);
      }

      doSearch({
        value: emptySearchOnFocus ? '' : currentText || '',
        page: DefaultPage,
        search: search,
        getResponseData: getResponseData,
        abortController: abortController,
        autoCompleteOptions: [],
        optionList: [],
        loadingPage: loadingPage,
        total: total,
        pageSize: pageSize,
        searchHttpMethod: searchHttpMethod,
        queryParamName: queryParamName,
        labelField: labelField,
        valueField: valueField,
        childOptionsField: childOptionsField,
        pageNumParamName: pageNumParamName,
        pageSizeParamName: pageSizeParamName,
        udeskContext: udeskContext,
        setCurrentPage: setCurrentPage,
        setLoadingPage: setLoadingPage,
        setNoMoreData: setNoMoreData,
        setTotal: setTotal,
        setAbortController: setAbortController,
        setOptionList: setOptionList,
        setAutoCompleteOptions: setAutoCompleteOptions
      });
    }

    if (onFocus) {
      onFocus(e);
    }
  };
}
/** 生成AutoComplete onBlur 事件回调函数 */


function getOnBlurHandler(_ref14) {
  var currentText = _ref14.currentText,
      currentValue = _ref14.currentValue,
      previousValidValue = _ref14.previousValidValue,
      previousValidLabel = _ref14.previousValidLabel,
      allowEmpty = _ref14.allowEmpty,
      outputMode = _ref14.outputMode,
      emptySearchOnFocus = _ref14.emptySearchOnFocus,
      onChange = _ref14.onChange,
      setCurrentText = _ref14.setCurrentText,
      setPreviousValidLabel = _ref14.setPreviousValidLabel,
      setPreviousValidValue = _ref14.setPreviousValidValue,
      setAutoCompleteOptions = _ref14.setAutoCompleteOptions,
      setCurrentPage = _ref14.setCurrentPage,
      setTotal = _ref14.setTotal,
      setIsAutoFocusSearch = _ref14.setIsAutoFocusSearch,
      onBlur = _ref14.onBlur;
  return function (e) {
    if (currentValue == null && outputMode !== 'string') {
      if (currentText) {
        if (previousValidValue) {
          // 如果没有匹配到值，则恢复成上次的有效值
          setCurrentText(previousValidLabel);
        } else {
          // 如果上次也没有值，则内容清空
          setCurrentText('');
        }

        if (onChange) {
          onChange(previousValidValue, undefined);
        }
      } else {
        if (allowEmpty) {
          // 如果允许为空，除了出发 onChange 事件，还需要把
          // 两个previous 清空，否则再次 focus+blur，还是会被恢复成上次的值
          setPreviousValidLabel('');
          setPreviousValidValue(undefined);

          if (onChange) {
            onChange(undefined, undefined);
          }
        } else {
          if (previousValidValue) {
            // 如果没有匹配到值，则恢复成上次的有效值
            setCurrentText(previousValidLabel);
          } else {
            // 如果上次也没有值，则内容清空
            setCurrentText('');
          }

          if (onChange) {
            onChange(previousValidValue, undefined);
          }
        }
      }
    } // 清空传给AutoComplete的options，每次获取焦点时都自动搜索


    setAutoCompleteOptions([]);
    setCurrentPage(DefaultPage);
    setTotal(0);

    if (emptySearchOnFocus) {
      setIsAutoFocusSearch(false);
    }

    if (onBlur) {
      onBlur(e);
    }
  };
}
/** 生成AutoComplete onSearch 事件回调函数 */


function getOnSearchHandler(_ref15) {
  var options = _ref15.options,
      dataSource = _ref15.dataSource,
      loadingPage = _ref15.loadingPage,
      search = _ref15.search,
      searchDebounce = _ref15.searchDebounce,
      abortController = _ref15.abortController,
      pageSize = _ref15.pageSize,
      searchHttpMethod = _ref15.searchHttpMethod,
      queryParamName = _ref15.queryParamName,
      labelField = _ref15.labelField,
      valueField = _ref15.valueField,
      childOptionsField = _ref15.childOptionsField,
      pageNumParamName = _ref15.pageNumParamName,
      pageSizeParamName = _ref15.pageSizeParamName,
      udeskContext = _ref15.udeskContext,
      emptySearchOnFocus = _ref15.emptySearchOnFocus,
      setCurrentText = _ref15.setCurrentText,
      setCurrentPage = _ref15.setCurrentPage,
      setLoadingPage = _ref15.setLoadingPage,
      setNoMoreData = _ref15.setNoMoreData,
      setTotal = _ref15.setTotal,
      setAutoCompleteOptions = _ref15.setAutoCompleteOptions,
      setIsAutoFocusSearch = _ref15.setIsAutoFocusSearch,
      setOptionList = _ref15.setOptionList,
      setAbortController = _ref15.setAbortController,
      getResponseData = _ref15.getResponseData,
      onSearch = _ref15.onSearch;
  // 搜索补全下拉项
  var debouncedSearch = debounce(function (value) {
    doSearch({
      value: value,
      page: DefaultPage,
      total: 0,
      search: search,
      getResponseData: getResponseData,
      abortController: abortController,
      autoCompleteOptions: [],
      optionList: [],
      loadingPage: loadingPage,
      pageSize: pageSize,
      searchHttpMethod: searchHttpMethod,
      queryParamName: queryParamName,
      labelField: labelField,
      valueField: valueField,
      childOptionsField: childOptionsField,
      pageNumParamName: pageNumParamName,
      pageSizeParamName: pageSizeParamName,
      udeskContext: udeskContext,
      setCurrentPage: setCurrentPage,
      setLoadingPage: setLoadingPage,
      setNoMoreData: setNoMoreData,
      setTotal: setTotal,
      setAbortController: setAbortController,
      setOptionList: setOptionList,
      setAutoCompleteOptions: setAutoCompleteOptions
    });
  }, searchDebounce || defaultProps.searchDebounce);
  return function (value) {
    if (options == null && dataSource == null) {
      setCurrentText(value);

      if (emptySearchOnFocus) {
        setIsAutoFocusSearch(false);
      } // 搜索补全下拉项


      debouncedSearch(value);
    }

    if (onSearch) {
      onSearch(value);
    }
  };
}
/** 生成AutoComplete OnPopupScroll 事件回调函数 */


function getOnPopupScrollHandler(_ref16) {
  var options = _ref16.options,
      dataSource = _ref16.dataSource,
      autoCompleteOptions = _ref16.autoCompleteOptions,
      optionList = _ref16.optionList,
      noMoreData = _ref16.noMoreData,
      total = _ref16.total,
      search = _ref16.search,
      currentText = _ref16.currentText,
      loadingPage = _ref16.loadingPage,
      currentPage = _ref16.currentPage,
      scrollToEndOffset = _ref16.scrollToEndOffset,
      listItemHeight = _ref16.listItemHeight,
      abortController = _ref16.abortController,
      pageSize = _ref16.pageSize,
      infiniteScrollingMaxNum = _ref16.infiniteScrollingMaxNum,
      searchHttpMethod = _ref16.searchHttpMethod,
      queryParamName = _ref16.queryParamName,
      labelField = _ref16.labelField,
      valueField = _ref16.valueField,
      childOptionsField = _ref16.childOptionsField,
      pageNumParamName = _ref16.pageNumParamName,
      pageSizeParamName = _ref16.pageSizeParamName,
      udeskContext = _ref16.udeskContext,
      isAutoFocusSearch = _ref16.isAutoFocusSearch,
      setCurrentPage = _ref16.setCurrentPage,
      setLoadingPage = _ref16.setLoadingPage,
      setNoMoreData = _ref16.setNoMoreData,
      setTotal = _ref16.setTotal,
      setOptionList = _ref16.setOptionList,
      setAutoCompleteOptions = _ref16.setAutoCompleteOptions,
      setAbortController = _ref16.setAbortController,
      getResponseData = _ref16.getResponseData,
      onPopupScroll = _ref16.onPopupScroll,
      infiniteScrolling = _ref16.infiniteScrolling;
  return function (e) {
    if (onPopupScroll) {
      onPopupScroll(e);
    } // 只有没有设置 options 的情况下才需要滚动加载，如果设置了 options，则不需要自动补全的，
    // 当然也不需要滚动加载。


    if (options == null && dataSource == null && infiniteScrolling) {
      e.persist();
      var target = e.target;

      if (target instanceof HTMLDivElement) {
        // 计算默认offset，如果设置的话，默认为5个item的高度，或者160px。
        var offset = 0;

        if (scrollToEndOffset) {
          offset = scrollToEndOffset;
        } else if (listItemHeight) {
          offset = listItemHeight * 5;
        } else {
          offset = defaultProps.scrollToEndOffset;
        } // 距离底部 <= offset时，就可以发请求了


        var scrollToEnd = target.scrollHeight - target.scrollTop - target.offsetHeight <= offset;
        var maxNum = infiniteScrollingMaxNum !== null && infiniteScrollingMaxNum !== void 0 ? infiniteScrollingMaxNum : defaultProps.infiniteScrollingMaxNum;

        if (scrollToEnd && loadingPage == null && total < maxNum && !noMoreData) {
          var _pageSize;

          pageSize = (_pageSize = pageSize) !== null && _pageSize !== void 0 ? _pageSize : defaultProps.pageSize;

          if (maxNum - total < pageSize) {
            pageSize = maxNum - total;
          }

          doSearch({
            value: isAutoFocusSearch ? '' : currentText || '',
            page: (currentPage !== null && currentPage !== void 0 ? currentPage : DefaultPage) + 1,
            total: total,
            search: search,
            getResponseData: getResponseData,
            abortController: abortController,
            autoCompleteOptions: autoCompleteOptions,
            optionList: optionList,
            loadingPage: loadingPage,
            pageSize: pageSize,
            searchHttpMethod: searchHttpMethod,
            queryParamName: queryParamName,
            labelField: labelField,
            valueField: valueField,
            childOptionsField: childOptionsField,
            pageNumParamName: pageNumParamName,
            pageSizeParamName: pageSizeParamName,
            udeskContext: udeskContext,
            setCurrentPage: setCurrentPage,
            setLoadingPage: setLoadingPage,
            setNoMoreData: setNoMoreData,
            setTotal: setTotal,
            setAbortController: setAbortController,
            setOptionList: setOptionList,
            setAutoCompleteOptions: setAutoCompleteOptions
          });
        }
      }
    }
  };
}
/** 发起搜索请求 */


function doSearch(_ref17) {
  var value = _ref17.value,
      page = _ref17.page,
      search = _ref17.search,
      loadingPage = _ref17.loadingPage,
      total = _ref17.total,
      abortController = _ref17.abortController,
      autoCompleteOptions = _ref17.autoCompleteOptions,
      optionList = _ref17.optionList,
      pageSize = _ref17.pageSize,
      searchHttpMethod = _ref17.searchHttpMethod,
      queryParamName = _ref17.queryParamName,
      labelField = _ref17.labelField,
      valueField = _ref17.valueField,
      childOptionsField = _ref17.childOptionsField,
      pageNumParamName = _ref17.pageNumParamName,
      pageSizeParamName = _ref17.pageSizeParamName,
      udeskContext = _ref17.udeskContext,
      setCurrentPage = _ref17.setCurrentPage,
      setLoadingPage = _ref17.setLoadingPage,
      setNoMoreData = _ref17.setNoMoreData,
      setTotal = _ref17.setTotal,
      setAbortController = _ref17.setAbortController,
      setOptionList = _ref17.setOptionList,
      setAutoCompleteOptions = _ref17.setAutoCompleteOptions,
      getResponseData = _ref17.getResponseData;

  if (loadingPage && abortController) {
    // 先abort掉前面未完成的请求
    abortController.abort();
    setAbortController(undefined);
  }

  var searchData = [];
  var searchPromise = undefined;
  var loadingText = udeskContext.intl.formatMessage({
    id: 'AutoComplete.loading'
  });
  var controller = new AbortController();
  var incompatibleError = "".concat(libraryName, "/AutoComplete\u7EC4\u4EF6search\u8BF7\u6C42\u8FD4\u56DE\u4E86\u9519\u8BEF\u7684\u6570\u636E\u7ED3\u6784\uFF0C\u671F\u671B\u662F\u4E00\u4E2A\u5BF9\u8C61\u6570\u7EC4\u3002\n") + '如果必须是异构数据的话，可以传入 `getResponseData` 属性来转换成对象数组。';

  if (typeof search === 'function') {
    // 如果定义了search方法，则优先使用search方法
    var searchResult = search(value, {
      pageNum: page,
      pageSize: pageSize || defaultProps.pageSize,
      total: total,
      abortSignal: controller.signal
    });

    if (searchResult instanceof Promise) {
      // 如果返回值是Promise，表示发送了异步请求
      searchPromise = searchResult;
    } else {
      setLoadingPage(undefined); // 如果返回值不是Promise，则表示同步返回了数据

      if (Array.isArray(searchResult)) {
        searchData = searchResult;
      } else {
        searchData = (getResponseData || defaultProps.getResponseData)(searchResult || {});

        if (!Array.isArray(searchData)) {
          throw new Error(incompatibleError);
        }
      }
    }
  } else if (typeof search === 'string') {
    var searchUrl = search; // 否则自己发送异步请求，注意GET请求时使用 param 参数，其他类型的请求使用 data 参数

    var httpMethod = searchHttpMethod || defaultProps.searchHttpMethod;
    searchPromise = udeskContext.request(searchUrl, _defineProperty(_defineProperty({
      method: httpMethod
    }, httpMethod === 'GET' ? 'params' : 'data', _defineProperty(_defineProperty(_defineProperty({}, queryParamName || defaultProps.queryParamName, value), pageNumParamName || defaultProps.pageNumParamName, page), pageSizeParamName || defaultProps.pageSizeParamName, pageSize || defaultProps.pageSize)), "signal", controller.signal));
  } else {
    if (udeskContext.debugMode) {
      console.error("".concat(libraryName, "/AutoComplete \u7EC4\u4EF6\u65E0\u6CD5\u81EA\u52A8\u8865\u5168\u4E0B\u62C9\u9879\u3002\u8BF7\u4F7F\u7528 search \u5C5E\u6027\uFF0C\u8BBE\u7F6E\u4E3A\u4E00\u4E2A url \u6216\u8005\u4E00\u4E2A\u65B9\u6CD5\uFF0C\u6765\u542F\u7528\u81EA\u52A8\u8865\u5168\u529F\u80FD"));
    }
  } // 收到数据后的回调（同步及异步），重新生成options数据


  var onReceiveData = function onReceiveData(data) {
    // 记录分页状态
    setCurrentPage(page); // 如果是重新搜索，重置total

    if (page === DefaultPage) {
      total = data.length;
      setTotal(total);
      setNoMoreData(false);
    } else {
      if (data.length === 0) {
        setNoMoreData(true);
      }

      total += data.length;
      setTotal(total);
    } // 转化为AutoComplete 的options


    var newDataSource = _toConsumableArray(data);

    var newAutoCompleteOptions = convertUserDataToOptions({
      data: newDataSource,
      labelField: labelField,
      valueField: valueField,
      childOptionsField: childOptionsField
    });
    var newOptionList = getOriginalOptionList({
      options: newDataSource
    });

    if (page === DefaultPage) {
      // 如果是重新搜索，则完全使用新数据覆盖
      setAutoCompleteOptions(newAutoCompleteOptions);
      setOptionList(newOptionList);
    } else {
      // 否则附加在当前数据后面
      setAutoCompleteOptions([].concat(_toConsumableArray(autoCompleteOptions.filter(function (o) {
        return o.value !== loadingText;
      })), _toConsumableArray(newAutoCompleteOptions)));
      setOptionList([].concat(_toConsumableArray(optionList !== null && optionList !== void 0 ? optionList : []), _toConsumableArray(newOptionList)));
    }
  }; // 如果发送了异步请求，则等待Promise的回调。


  if (searchPromise) {
    // 保存当前分页，在滚动加载时进行判断，避免反复重复加载一页
    setLoadingPage(page);
    setAbortController(controller); // 添加一个加载中的选项

    if (autoCompleteOptions.some(function (o) {
      return o.value !== loadingText;
    })) {
      setAutoCompleteOptions([].concat(_toConsumableArray(autoCompleteOptions.filter(function (o) {
        return o.value !== loadingText;
      })), [{
        label: loadingText,
        value: loadingText
      }]));
    } // 处理 searchPromise


    searchPromise.then(function (resp) {
      // 清除加载中的状态
      setLoadingPage(undefined);
      var data = [];

      if (Array.isArray(resp)) {
        data = resp;
      } else {
        data = (getResponseData || defaultProps.getResponseData)(resp || {});

        if (!Array.isArray(data)) {
          throw new Error(incompatibleError);
        }
      }

      onReceiveData(data);
    })["catch"](function (reason) {
      // 如果是abort请求，则默默失败，什么也不做
      if (isAbortedError(reason)) {
        return;
      } // 清除搜索中的标记


      setLoadingPage(undefined); // 消除加载中的选项

      if (autoCompleteOptions.some(function (o) {
        return o.value === loadingText;
      })) {
        setAutoCompleteOptions(autoCompleteOptions.filter(function (o) {
          return o.value !== loadingText;
        }));
      }

      if (reason && !reason.hideErrorMessage) {
        message.error(udeskContext.intl.formatMessage({
          id: 'AutoComplete.searchError'
        }));
        console.error(reason);
      }
    });
  } else {
    onReceiveData(searchData);
  }
}
/** 把search请求中返回的自定义数据源转换成AutoComplete能识别的Options，
 * 如果存在OptionGroup的话，支持深度转化。
 * 返回的自定义数据源推荐是标准的{ value, label }数据结构，但如果不一致的话，
 * 可以使用 valueField与labelField 指定的字段名。
 *
 * 此方法的作用就是把自定义字段名转换成{ value, label }
 */


function convertUserDataToOptions(_ref19) {
  var data = _ref19.data,
      labelField = _ref19.labelField,
      valueField = _ref19.valueField,
      childOptionsField = _ref19.childOptionsField;
  var options = [];
  data.forEach(function (item, index) {
    var option = {};
    var childOptions = item[childOptionsField || defaultProps.childOptionsField];

    if (childOptions) {
      option.options = convertUserDataToOptions({
        data: childOptions,
        labelField: labelField,
        valueField: valueField,
        childOptionsField: childOptionsField
      });
    } else {
      option = convertSingleOption({
        item: item,
        labelField: labelField,
        valueField: valueField
      });
    }

    options.push(option);
  });
  return options;
}
/** 把search请求中返回的自定义数据源转换成AutoComplete能识别的Options。
 * 返回的自定义数据源推荐是标准的{ value, label }数据结构，但如果不一致的话，
 * 可以使用 valueField与labelField 指定的字段名。
 *
 * 此方法的作用就是把自定义字段名转换成{ value, label }
 */


function convertSingleOption(_ref20) {
  var item = _ref20.item,
      labelField = _ref20.labelField,
      valueField = _ref20.valueField;
  var label = item[labelField || defaultProps.labelField];
  var value = item[valueField || defaultProps.valueField];

  if (value == null || label == null) {
    throw new Error("".concat(libraryName, "/AutoComplete\u641C\u7D22\u8FD4\u56DE\u7684\u6570\u636E\u7ED3\u6784\u4E0D\u6B63\u786E\uFF01\u671F\u671B\u6709value\u548Clabel\u5B57\u6BB5\uFF0C\u7ED3\u679C\u4E3A: ").concat(JSON.stringify(item)));
  } // 前面的 value 只是用来验证一下，但传给 AC 的还是 label，
  // 因为 AC 不支持 value。


  return _objectSpread(_objectSpread({}, item), {}, {
    key: value,
    label: label,
    value: label
  });
} //#endregion
//# sourceMappingURL=index.js.map
