import React, { ComponentProps } from 'react';
import { Cascader } from 'udesk-ui';
import CopyComponent from '@udesk-webapp/copy-content';
declare type OptionType = {
    value: string;
    label: string;
    is_hide?: boolean | undefined;
    children?: OptionType[] | undefined;
};
declare type PropsInterface = Omit<ComponentProps<typeof Cascader>, 'value'> & Pick<ComponentProps<typeof CopyComponent>, 'switchFlag'> & {
    options: OptionType[];
    optionsMeta?: OptionType[];
    value: string | string[];
    switchFlag?: boolean;
    fullSelect?: boolean;
    onChange: (value: string) => void;
};
/**
 * 级联组件
 * @param props
 */
declare const NewCascader: React.FC<PropsInterface>;
export default NewCascader;
