import css from './style.module.scss';
import { TreeSelect } from 'udesk-ui';
import React, { useMemo } from 'react';
var TreeNode = TreeSelect.TreeNode;
var dropDownStyle = { maxHeight: 400, minWidth: 400, overflow: 'auto' };
var treeStyle = { alignSelf: 'flex-start' };
export function buildTreeNodes(catalogs, customCatalogOrder) {
    var sortedCatalogs = catalogs;
    if (customCatalogOrder) {
        sortedCatalogs = catalogs.sort(function (a, b) {
            return customCatalogOrder.findIndex(function (i) { return i.id === a.id; }) -
                customCatalogOrder.findIndex(function (i) { return i.id === b.id; });
        });
    }
    return sortedCatalogs.map(function (i) {
        return (React.createElement(TreeNode, { value: i.id, key: i.id + '', title: i.name }, buildTreeNodes(i.children || [], i.children)));
    });
}
var CatalogSelect = function (_a) {
    var data = _a.data, onChange = _a.onChange, value = _a.value, prependTreeNodes = _a.prependTreeNodes;
    var treeNodes = useMemo(function () { return buildTreeNodes(data, null); }, [data]);
    return React.createElement(TreeSelect, { dropdownStyle: dropDownStyle, style: treeStyle, treeDefaultExpandAll: true, bordered: false, value: value, onChange: onChange, 
        // placement={'bottomRight'} // TODO 待antd升级
        className: css['question-select'] },
        prependTreeNodes,
        treeNodes);
};
export default CatalogSelect;
