import React from 'react';
import type { FormProps, FormInstance, FormFieldConfig } from 'udesk-ui/es/form-builder/types/form';
import './style/index';
interface FilterField extends FormFieldConfig {
    isDefault?: boolean;
}
export interface CommonFilterProps {
    fields: FilterField[];
    onSearch?: (value: any, options?: any) => void;
    initialValues?: FormProps['initialValues'];
    shouldTriggerSearchOnReset?: boolean;
    prefixCls?: string;
    customComponents?: FormProps['customComponents'];
    open?: boolean;
    onOpenPropsChange?: (open: boolean) => void;
}
export interface CommonFilterInstance {
    closeFilter: () => void;
    openFilter: () => void;
    formInstance: FormInstance;
}
declare const _default: React.MemoExoticComponent<React.ForwardRefExoticComponent<CommonFilterProps & React.RefAttributes<CommonFilterInstance>>>;
export default _default;
