import type { ReactNode } from 'react';
import type { PageHeaderProps } from 'udesk-ui/es/page-header/index';
export interface NavigationTabItem {
    path: string;
    text: string;
    hidden?: boolean;
    pathName?: string;
}
export interface CommonPageProps extends PageHeaderProps {
    pageBodyClassName: string;
    prefixCls?: string;
    className?: string;
    ghostPage?: boolean;
    padding?: number;
    footBar?: ReactNode;
    navigationTabs?: NavigationTabItem[];
    onNavigationTabsChange?: (tab: NavigationTabItem) => void;
    currentNavigationPath?: string;
    loading?: boolean;
}
export interface PageHeaderFooterProps {
    antdFooter?: PageHeaderProps['footer'];
    navigationTabs?: NavigationTabItem[];
    onChange?: (tab: NavigationTabItem) => void;
    currentNavigationPath?: CommonPageProps['currentNavigationPath'];
}
