var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useCallback, useEffect, useState } from 'react';
import { Input } from 'udesk-ui';
import FieldErrAndExplain from '../field-err-explain';
import isFunction from 'lodash-es/isFunction';
import CopyComponent from '../../copy';
var TextArea = Input.TextArea;
var Area_text = function (props) {
    var _a = props.isFormItem, isFormItem = _a === void 0 ? true : _a, switchFlag = props.switchFlag;
    var _b = useState(''), errMsg = _b[0], setErrMsg = _b[1];
    var _c = useState(''), value = _c[0], setValue = _c[1];
    useEffect(function () {
        setValue(props.value);
    }, [props.value]);
    // 失去焦点 校验是否提示
    var hanleValidateText = useCallback(function (e) {
        // 如果传递了自定义的校验规则
        var value = e.target.value;
        // 非form表单形式, 自己提示错误, 自己触发保存
        if (!isFormItem) {
            // 有自定义校验
            if (isFunction(props.customValidFn)) {
                props
                    .customValidFn(null, value)
                    .then(function () {
                    // 校验成功,可能触发失焦自动保存,要把方法跑出去
                    props.onValueChangedByBlur && props.onValueChangedByBlur({});
                }, function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                })
                    .catch(function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                });
            }
        }
        else {
            var changeFunction = props[props.trigger];
            if (changeFunction) {
                changeFunction(value);
            }
        }
    }, [isFormItem, props]);
    return (React.createElement(FieldErrAndExplain, __assign({}, props, { errMsg: errMsg }),
        React.createElement(CopyComponent, { text: value, switchFlag: switchFlag },
            React.createElement(TextArea, { rows: props.rowsLine, defaultValue: props.defaultValue, placeholder: props.placeholder, onBlur: hanleValidateText, onChange: function (e) { return setValue(e.target.value); }, value: value, disabled: props.disabled }))));
};
export default Area_text;
