var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useCallback, useEffect, useMemo, useState } from 'react';
import { Select } from 'udesk-ui';
import CopyComponent from '../../../copy';
var Option = Select.Option;
/**
 * 级联组件
 * @param props
 * @param props.value    选中的值
 * @param props.options  option数据
 */
var OldCascader = function (_a) {
    var _options = _a.options, props = __rest(_a, ["options"]);
    var _b = useState([]), optionsAry = _b[0], setOptionsAry = _b[1];
    var _c = useState([]), valueList = _c[0], setValueList = _c[1];
    var options = useMemo(function () {
        return addBlank2Options(_options);
    }, [_options]);
    useEffect(function () {
        var _values = [];
        if (!Array.isArray(props.value)) {
            _values = props.value ? props.value.split(',') : [];
        }
        else {
            _values = props.value;
        }
        setValueList(_values);
    }, [props.value]);
    useEffect(function () {
        var _values = [];
        if (!Array.isArray(valueList)) {
            _values = valueList ? valueList.split(',') : [];
        }
        else {
            _values = valueList;
        }
        var list = _values.reduce(function (prev, current, index) {
            var opts;
            if (!index) {
                opts = options;
            }
            else {
                opts = (prev[index - 1] || {}).children || [];
            }
            var keyOption = opts.find(function (option) {
                return current === option.value;
            });
            keyOption &&
                prev.push({
                    value: keyOption.label,
                    options: opts,
                    children: keyOption.children || keyOption.subs || [],
                });
            return prev;
        }, []);
        if (list && list.length > 0) {
            var last = list[list.length - 1];
            if (last.children && last.children.length) {
                list.push({
                    options: last.children,
                });
            }
        }
        else {
            list.push({ options: options });
        }
        setOptionsAry(list);
    }, [options, valueList]);
    var handleChange = useCallback(function (item, index, _value, option) {
        var valueAry = [];
        if (index === 0) {
            valueAry.push(_value);
        }
        else {
            for (var i = 0; i < index; i++) {
                valueAry.push(valueList[i]);
            }
            valueAry.push(_value);
        }
        setValueList(valueAry);
        props.onChange && props.onChange(valueAry);
    }, [props, valueList]);
    var optionsElement = useMemo(function () {
        return optionsAry.map(function (item, index) {
            return (React.createElement("div", { style: { marginBottom: '6px' }, key: index },
                React.createElement(CopyComponent, { text: item.value, switchFlag: props.switchFlag },
                    React.createElement(Select, { onChange: function (value, options) { return handleChange(item, index, value, options); }, value: item.value, placeholder: '请选择', disabled: props.disabled }, item.options.map(function (option) {
                        return (React.createElement(Option, { key: option.value, value: option.value }, option.label));
                    })))));
        });
    }, [handleChange, optionsAry, props.disabled, props.switchFlag]);
    return React.createElement("div", null, optionsElement);
};
function addBlank2Options(options) {
    options.unshift({
        label: '请选择',
        value: '',
        children: [],
    });
    options.forEach(function (item) {
        var _a;
        if ((_a = item === null || item === void 0 ? void 0 : item.children) === null || _a === void 0 ? void 0 : _a.length) {
            addBlank2Options(item === null || item === void 0 ? void 0 : item.children);
        }
    });
    return options;
}
export default OldCascader;
