//多选框组件
import React, { useCallback, useEffect, useMemo, useRef, useState } from 'react';
import { Checkbox } from 'udesk-ui';
import cssObj from './index.module.scss';
var CheckboxGroup = Checkbox.Group;
function Filed_checkbox(props) {
    var onChange = props.onChange, _a = props.options, options = _a === void 0 ? [] : _a, _b = props.sort_type, sort_type = _b === void 0 ? 'x' : _b;
    //选择的选项值
    var _c = useState([]), checkedList = _c[0], setCheckedList = _c[1];
    // 换行排列样式
    var yStyle = useRef({
        display: 'block',
        height: '30px',
        lineHeight: '30px',
        marginLeft: '0'
    });
    // 连续排列样式
    var xStyle = useRef({
        display: 'inline-block'
    });
    // 监听道选项改变 处理数据   取出其中默认选项  复制给Radio.Group的value  主要是外部新建字段  改变默认选项时触发  改变展示效果
    useEffect(function () {
        if (props.value) {
            //value  类型 是[] 或 string
            if (typeof (props.value) === 'string') {
                // 将value转数组  存值
                setCheckedList(props.value.split(','));
            }
            else {
                setCheckedList(props.value);
            }
        }
        else {
            setCheckedList(options.filter(function (item) { return item.default; }).map(function (item) { return item.value; }));
        }
    }, [props.value]);
    // useEffect(() => {
    //     setCheckedList(props.value)
    // }, [props.value])
    // 选择改变时触发
    var checkOnChange = useCallback(function (checkedList) {
        setCheckedList(checkedList);
        if (onChange)
            onChange(checkedList.join(','));
    }, [onChange]);
    var checkGroupChildren = useMemo(function () {
        return (React.createElement(CheckboxGroup, { value: checkedList, onChange: checkOnChange, disabled: props.disabled }, options.map(function (item) {
            return (React.createElement(Checkbox, { key: item.value, value: item.value, style: sort_type === 'y' ? yStyle.current : xStyle.current },
                React.createElement("span", { className: "".concat(cssObj['select-item'], " ").concat(item.color ? cssObj['select-item-hascolor'] : ''), style: {
                        background: item.color ? item.color : ''
                    } },
                    item.icon ?
                        React.createElement("img", { alt: '', src: item.icon, className: cssObj['setting-img'] }) : '',
                    item.title)));
        })));
    }, [checkOnChange, checkedList, options, props.disabled, sort_type]);
    return (React.createElement("div", { className: cssObj['select-wrapper'] }, checkGroupChildren));
}
export default Filed_checkbox;
