var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useCallback, useEffect, useState, useMemo } from 'react';
import { DatePicker } from 'udesk-ui';
import isFunction from 'lodash-es/isFunction';
import FieldErrAndExplain from '../field-err-explain';
import moment from 'moment';
import { YYYY_MM_DD } from '../../../utils';
import CopyComponent from '../../copy';
var Date = function (props) {
    var _a = props.isFormItem, isFormItem = _a === void 0 ? true : _a, switchFlag = props.switchFlag;
    var _b = useState(props.value), value = _b[0], setValue = _b[1];
    var _c = useState(''), errMsg = _c[0], setErrMsg = _c[1];
    useEffect(function () {
        setValue(props.value || null);
    }, [props.value]);
    // 失去焦点 校验是否提示
    var hanleValidateTime = useCallback(function (date, dateString) {
        setValue(date);
        if (!isFormItem) {
            // 有自定义校验
            if (isFunction(props.customValidFn)) {
                props
                    .customValidFn(null, date)
                    .then(function () {
                    // 校验成功,可能触发失焦自动保存,要把方法跑出去
                    //props.onValueChangedByBlur && props.onValueChangedByBlur({});
                }, function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                })
                    .catch(function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                });
            }
        }
        else {
            var changeFunction = props[props.trigger];
            if (changeFunction) {
                changeFunction(date ? moment(date).format(YYYY_MM_DD) : '');
            }
        }
    }, [isFormItem, props]);
    var handleOpenChange = useCallback(function () {
        var changeFunction = props[props.trigger];
        if (!value && changeFunction) {
            changeFunction(moment().format(YYYY_MM_DD));
        }
    }, [props, value]);
    var copyText = useMemo(function () {
        if (moment(value).isValid()) {
            return moment(value).format(YYYY_MM_DD);
        }
        else {
            return value;
        }
    }, [value]);
    return (React.createElement(FieldErrAndExplain, __assign({}, props, { errMsg: errMsg }),
        React.createElement(CopyComponent, { text: copyText, switchFlag: switchFlag },
            React.createElement(DatePicker, { value: value ? moment(value, YYYY_MM_DD) : null, getPopupContainer: function (triggerNode) { return triggerNode; }, style: { marginBottom: '4px' }, onChange: hanleValidateTime, disabled: props.disabled, onOpenChange: handleOpenChange }))));
};
export default Date;
