var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useCallback, useEffect, useState } from 'react';
import cssObj from './index.module.scss';
import { Input } from 'udesk-ui';
import { TiaoZhuan } from '../../icon/icon';
import { CloseCircleFilled } from '@ant-design/icons';
import FieldErrAndExplain from '../field-err-explain';
import isFunction from 'lodash-es/isFunction';
import CopyComponent from '../../copy';
var Link = function (props) {
    var switchFlag = props.switchFlag;
    var _a = useState(''), errMsg = _a[0], setErrMsg = _a[1];
    // 输入的值
    var _b = useState(props.defaultValue || ''), link = _b[0], setLink = _b[1];
    //是否显示跳转按钮
    var _c = useState(false), showIcon = _c[0], setShowIcon = _c[1];
    useEffect(function () {
        setLink(props.value || '');
        setShowIcon(props.value ? true : false);
    }, [props.value]);
    //   输入值变化时  手动双向绑定  进行检验
    function handleOnchange(e) {
        var value = e.target.value;
        setLink(value);
    }
    // 点击输入框右侧图标  打开输入的链接页面
    var openWindow = useCallback(function () {
        window.open(link, '_blank');
    }, [link]);
    // 清空输入框
    var clear = useCallback(function () {
        setLink('');
        var changeFunction = props[props.trigger];
        if (changeFunction) {
            changeFunction('');
        }
    }, [props]);
    // 输入框失焦时触发  校验输入的内容
    var check = useCallback(function () {
        // 非form表单形式, 自己提示错误, 自己触发保存
        if (!props.isFormItem) {
            // 有自定义校验
            if (isFunction(props.customValidFn)) {
                props
                    .customValidFn(null, link)
                    .then(function () {
                    // 校验成功,可能触发失焦自动保存,要把方法跑出去
                    props.onValueChangedByBlur && props.onValueChangedByBlur({});
                }, function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                })
                    .catch(function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                });
            }
        }
        else {
            var changeFunction = props[props.trigger];
            if (changeFunction) {
                changeFunction(link);
            }
        }
    }, [link, props]);
    var handleSuffix = (React.createElement("div", { className: cssObj['icon-group-wrapper'] },
        React.createElement("span", { className: cssObj['redict-icon'], onClick: openWindow },
            React.createElement(TiaoZhuan, null)),
        React.createElement("span", { className: cssObj['clear-icon'], onClick: clear },
            React.createElement(CloseCircleFilled, null))));
    return (React.createElement(FieldErrAndExplain, __assign({}, props, { errMsg: errMsg }),
        React.createElement(CopyComponent, { text: link, switchFlag: switchFlag },
            React.createElement(Input, { placeholder: props.placeholder, value: link, onChange: handleOnchange, onBlur: check, suffix: showIcon ? handleSuffix : '', disabled: props.disabled }))));
};
export default Link;
