var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useEffect, useState } from 'react';
import cssObj from './index.module.scss';
import { Input } from 'udesk-ui';
import { EnvironmentOutlined } from '@ant-design/icons';
import isFunction from 'lodash-es/isFunction';
import FieldErrAndExplain from '../field-err-explain';
import CopyComponent from '../../copy';
var TextArea = Input.TextArea;
function Location(props) {
    var _a = useState(props.defaultValue || ''), address = _a[0], setAddress = _a[1]; //输入的地址
    var _b = useState(false), showIcon = _b[0], setShowIcon = _b[1]; //是否显示右上角地址图标  鼠标经过输入框时显示
    var _c = useState(''), errMsg = _c[0], setErrMsg = _c[1];
    useEffect(function () {
        setAddress(props.value);
    }, [props.value]);
    // 点击定位图标  打开地图
    function openMap() {
        var url = 'http://apis.map.qq.com/uri/v1/search?keyword=' + (address || '') + '&referer=custom_field';
        window.open(url, '_blank');
    }
    var handleOnBlur = function (e) {
        var _a = props.isFormItem, isFormItem = _a === void 0 ? true : _a;
        // 如果传递了自定义的校验规则
        var value = e.target.value;
        // 非form表单形式, 自己提示错误, 自己触发保存
        if (!isFormItem) {
            // 有自定义校验
            if (isFunction(props.customValidFn)) {
                props
                    .customValidFn(null, value)
                    .then(function () {
                    // 校验成功,可能触发失焦自动保存,要把方法跑出去
                    props.onValueChangedByBlur && props.onValueChangedByBlur({});
                }, function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                })
                    .catch(function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                });
            }
        }
        else {
            var changeFunction = props[props.trigger];
            if (changeFunction) {
                changeFunction(value);
            }
        }
    };
    return (React.createElement(FieldErrAndExplain, __assign({}, props, { errMsg: errMsg }),
        React.createElement("div", { className: cssObj['textarea-wrapper'], onMouseEnter: function () { return setShowIcon(true); }, onMouseLeave: function () { return setShowIcon(false); } },
            React.createElement(CopyComponent, { text: address, switchFlag: props.switchFlag },
                React.createElement(TextArea
                // 占位符
                , { 
                    // 占位符
                    placeholder: props.placeholder, 
                    // 行数
                    rows: props.rowsLine, 
                    // 样式
                    className: cssObj['textarea-style'], 
                    // 最大字数
                    // maxLength={data.input_max}
                    // 输入值
                    value: address, 
                    // 输入变化回调
                    onChange: function (e) { return setAddress(e.target.value); }, onBlur: handleOnBlur, disabled: props.disabled })),
            showIcon ? (React.createElement("div", { className: cssObj['address-icon'], onClick: openMap },
                React.createElement(EnvironmentOutlined, null))) : (''))));
}
export default Location;
