var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useCallback, useEffect, useState } from 'react';
import isFunction from 'lodash-es/isFunction';
import { Input } from 'udesk-ui';
import FieldErrAndExplain from '../field-err-explain';
import CopyComponent from '../../copy';
var Number = function (props) {
    var _a = props.isFormItem, isFormItem = _a === void 0 ? true : _a, switchFlag = props.switchFlag;
    var _b = useState(props.value), value = _b[0], setValue = _b[1];
    var _c = useState(''), errMsg = _c[0], setErrMsg = _c[1];
    useEffect(function () {
        setValue(props.value || '');
    }, [props.value]);
    // 失去焦点 校验是否提示
    var handleBlur = useCallback(function (e) {
        // 如果传递了自定义的校验规则
        var value = e.target.value;
        // 非form表单形式, 自己提示错误, 自己触发保存
        if (!isFormItem) {
            // 有自定义校验
            if (isFunction(props.customValidFn)) {
                props
                    .customValidFn(null, value)
                    .then(function () {
                    // 校验成功,可能触发失焦自动保存,要把方法跑出去
                    props.onValueChangedByBlur && props.onValueChangedByBlur({});
                }, function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                })
                    .catch(function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                });
            }
        }
        else {
            var changeFunction = props[props.trigger];
            if (changeFunction) {
                changeFunction(value);
            }
        }
    }, [isFormItem, props]);
    var changeValue = useCallback(function (e) {
        var value = e.target.value;
        var reg = /^-?\d*$/;
        if (reg.test(value)) {
            setValue(value);
        }
    }, []);
    return (React.createElement(FieldErrAndExplain, __assign({}, props, { errMsg: errMsg }),
        React.createElement(CopyComponent, { text: value, switchFlag: switchFlag },
            React.createElement(Input, { value: value, placeholder: props.placeholder, onBlur: handleBlur, onChange: changeValue, style: { marginBottom: '4px' }, addonBefore: props.addonSetting &&
                    props.addonSetting.addonBefore.checked &&
                    props.addonSetting.addonBefore.content, addonAfter: props.addonSetting &&
                    props.addonSetting.addonAfter.checked &&
                    props.addonSetting.addonAfter.content, prefix: props.addonSetting && props.addonSetting.prefix.checked && props.addonSetting.prefix.content, suffix: props.addonSetting && props.addonSetting.suffix.checked && props.addonSetting.suffix.content, disabled: props.disabled }))));
};
export default Number;
