var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useCallback, useEffect, useMemo, useState } from 'react';
import { DanSuanShiXiao, DisableRadio, XuanZeDanXuan } from '../../icon/icon';
import cssObj from './index.module.scss';
import FieldErrAndExplain from '../field-err-explain';
import isFunction from 'lodash-es/isFunction';
import { isArray } from 'lodash-es';
function Filed_radio(props) {
    var isFormItem = props.isFormItem, trigger = props.trigger, customValidFn = props.customValidFn;
    var _a = props.options, options = _a === void 0 ? [] : _a, _b = props.arrangement, arrangement = _b === void 0 ? 'continuity' : _b, disabled = props.disabled, _c = props.canCancel, canCancel = _c === void 0 ? true : _c;
    var _d = useState(''), errMsg = _d[0], setErrMsg = _d[1];
    //选择的选项值
    var _e = useState(), selectValue = _e[0], setSelectValue = _e[1];
    var yStyle = useMemo(function () { return ({
        display: 'block',
        height: '30px',
        lineHeight: '30px',
        cursor: disabled ? 'not-allowed' : 'pointer',
        verticalAlign: 'middle',
    }); }, [disabled]);
    var xStyle = useMemo(function () { return ({
        display: 'inline-block',
        marginRight: '24px',
        cursor: disabled ? 'not-allowed' : 'pointer',
        verticalAlign: 'middle',
    }); }, [disabled]);
    useEffect(function () {
        var _a, _b, _c;
        var value = isArray(props.value) ? props.value[0] : props.value;
        if (!value) {
            try {
                value = (_c = (_b = (_a = props.options) === null || _a === void 0 ? void 0 : _a.filter(function (item) { return item.default; })) === null || _b === void 0 ? void 0 : _b[0]) === null || _c === void 0 ? void 0 : _c.value;
            }
            catch (e) {
                console.log(e);
            }
        }
        setSelectValue(value);
    }, [props.value]);
    var changeFunction = useMemo(function () { return props[trigger]; }, [props, trigger]);
    var changeRadio = useCallback(function (value) {
        if (disabled)
            return;
        // 如果不支持取消选择  并且点击的是已选择的 不做操作
        if (!canCancel && value === selectValue) {
            return;
        }
        // 如果点击的是已经选择的  取消选择
        var _value = value === selectValue ? '' : value;
        setSelectValue(_value);
        // 非form表单形式, 自己提示错误, 自己触发保存
        if (!isFormItem) {
            // 有自定义校验
            if (isFunction(customValidFn)) {
                customValidFn(null, value)
                    .then(function () {
                    // 校验成功,可能触发失焦自动保存,要把方法跑出去
                    // props.onValueChangedByBlur && props.onValueChangedByBlur({});
                }, function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                })
                    .catch(function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                });
            }
        }
        else {
            changeFunction === null || changeFunction === void 0 ? void 0 : changeFunction(_value);
        }
    }, [canCancel, changeFunction, disabled, isFormItem, customValidFn, selectValue]);
    return (React.createElement(FieldErrAndExplain, __assign({}, props, { errMsg: errMsg }),
        React.createElement("div", { className: cssObj['radio-select-wrapper'] }, options.map(function (item) {
            return (React.createElement("span", { key: item.value, style: arrangement === 'wrap' ? yStyle : xStyle, onClick: function () { return changeRadio(item.value); } },
                React.createElement("div", { style: { display: 'flex', wordBreak: 'break-all' } },
                    disabled ? (React.createElement(DisableRadio, null)) : item.value === selectValue ? (React.createElement(XuanZeDanXuan, { style: { color: '#00B38B', fontSize: '16px' } })) : (React.createElement(DanSuanShiXiao, { style: { color: 'rgba(0, 0, 0, 0.15)', fontSize: '16px' } })),
                    React.createElement("span", { className: "".concat(cssObj['select-item'], " ").concat(item.color ? cssObj['select-item-hascolor'] : ''), style: {
                            background: item.color ? item.color : '',
                            marginLeft: '8px',
                        } },
                        item.icon ? React.createElement("img", { alt: "", src: item.icon, className: cssObj['setting-img'] }) : '',
                        React.createElement("span", { style: { color: disabled ? 'rgba(0, 0, 0, 0.25)' : '' } }, item.title)))));
        }))));
}
export default Filed_radio;
