import React, { useCallback, useEffect, useState } from 'react';
import { Select } from 'udesk-ui';
import cssObj from './index.module.scss';
import CopyComponent from '../../copy';
var Option = Select.Option;
function Filed_droplistRadio(props) {
    var _a = props.switchFlag, switchFlag = _a === void 0 ? false : _a;
    var onChange = props.onChange, _b = props.options, options = _b === void 0 ? [] : _b;
    //选择的选项值
    var _c = useState(''), selectValue = _c[0], setSelectValue = _c[1];
    var _d = useState(''), copyText = _d[0], setCopyText = _d[1];
    useEffect(function () {
        var value = Array.isArray(selectValue) ? selectValue.join(',') : selectValue;
        options.forEach(function (item) {
            if (item.value === value) {
                setCopyText(item.title);
            }
        });
    }, [options, selectValue]);
    // 监听道选项改变 处理数据   取出其中默认选项  复制给Radio.Group的value  主要是外部新建字段  改变默认选项时触发  改变展示效果
    useEffect(function () {
        // 如果有值传进来 优先使用传进来的值  否则从选项中找道默认选项
        if (props.value) {
            setSelectValue(props.value);
        }
        else {
            //如果禁止使用默认值，直接不进行默认值处理
            if (props.notUseDefault)
                return;
            options.forEach(function (item) {
                if (item.default)
                    setSelectValue(item.value);
            });
        }
    }, [options, props.notUseDefault, props.value]);
    var selectOnChange = useCallback(function (e) {
        setSelectValue(e);
        if (onChange)
            onChange(e);
    }, [onChange]);
    return (React.createElement(CopyComponent, { text: copyText, switchFlag: switchFlag },
        React.createElement(Select, { value: selectValue, onChange: selectOnChange, style: { width: '100%' }, getPopupContainer: function (triggerNode) { return triggerNode; }, disabled: props.disabled, showSearch: options.length > 8, filterOption: function (input, option) { return option.label.toLowerCase().includes(input.toLowerCase()); }, allowClear: true }, options.map(function (item) {
            return (React.createElement(Option, { key: item.value, value: item.value, label: item.title },
                React.createElement("span", { className: "".concat(cssObj['select-item'], " ").concat(item.color ? cssObj['select-item-hascolor'] : ''), style: {
                        background: item.color ? item.color : '',
                    } },
                    item.icon ? React.createElement("img", { alt: "", src: item.icon, className: cssObj['setting-img'] }) : '',
                    item.title)));
        }))));
}
export default Filed_droplistRadio;
