import { Button, Popover } from 'udesk-ui';
import React, { useContext, useMemo, useCallback } from 'react';
import { useTranslation } from '@udesk-webapp/locale';
import css from './index.module.scss';
import { hit, RepositoryWidgetContext } from '../../utilities';
import { canPreviewByFileName, getPreviewUrl } from '../../utils';
var AttachmentContent = function (props) {
    var item = props.item;
    var _a = item || {}, file_url = _a.file_url, file_name = _a.file_name, file_type = _a.file_type, id = _a.id;
    var t = useTranslation().t;
    var _b = useContext(RepositoryWidgetContext), onSend = _b.onSend, previewUrl = _b.previewUrl, isWorkbench = _b.isWorkbench;
    var onClickUseful = useCallback(function () {
        onSend === null || onSend === void 0 ? void 0 : onSend('attachment', item);
        hit(id, 'KnowledgeAttachment');
    }, [item, id, onSend]);
    var previewUrlFun = useCallback(function () {
        window.open(getPreviewUrl(file_url, { previewUrl: previewUrl }));
    }, [file_url, previewUrl]);
    var content = useMemo(function () { return (React.createElement("div", { className: css['attachment-item'] },
        React.createElement("a", { key: '1', href: file_url, rel: 'noopener noreferrer', target: '_blank', className: css['attachment-link'] }, file_name),
        React.createElement("div", { key: '2', className: css['nodeOperations'] },
            canPreviewByFileName(file_name) ? (React.createElement("div", { className: css['lineBtns'] },
                React.createElement(Button, { type: 'link', size: 'small', className: css['line-btn-item'], onClick: function () { previewUrlFun(); } }, t('label.preview')),
                ' ',
                isWorkbench ? React.createElement("span", { className: css['line'] }) : null)) : null,
            isWorkbench ? React.createElement(Button, { type: 'link', size: 'small', className: css['line-btn-item'], onClick: function () { onClickUseful(); } }, t('label.send')) : null))); }, [file_name, file_url, onClickUseful, previewUrlFun, t]);
    if (file_type.startsWith('image') || /png|jpg|jpeg|gif/.test(file_type)) {
        return (React.createElement(Popover, { autoAdjustOverflow: false, content: React.createElement("img", { src: file_url, alt: file_name, style: { width: '100%' } }), placement: 'left', overlayStyle: { maxWidth: '300px', maxHeight: '300px' } }, content));
    }
    return React.createElement(React.Fragment, null, content);
};
export default AttachmentContent;
