import React, { useEffect, useMemo, useState } from 'react';
import style from './index.module.less';
import Voice from '../icon/voice';
var AudioType = React.memo(function (_a) {
    var _b;
    var msg = _a.msg;
    // const { src } = props.contentObject.data.content;
    var _c = useState(((_b = msg.data) === null || _b === void 0 ? void 0 : _b.duration) || 0), duration = _c[0], setDuration = _c[1];
    var _d = useState(false), isPlaying = _d[0], setIsPlaying = _d[1];
    // const audioRef = useRef<any>();
    var audioElement = useMemo(function () {
        console.log('audioElement', msg);
        var audio = window.document.createElement('audio');
        audio.src = msg.content || msg.data.content;
        return audio;
    }, [msg]);
    var startPlayAudio = function () {
        audioElement.play();
        setIsPlaying(true);
    };
    useEffect(function () {
        var audioObject = {
            loadedmetadata: function (e) {
                console.log('loadedmetadata', e);
                setDuration(function (v) { return v || Math.floor(e.target.duration); });
            },
            ended: function (e) {
                setIsPlaying(false);
            }
        };
        Object.entries(audioObject).forEach(function (_a) {
            var key = _a[0], value = _a[1];
            audioElement.addEventListener(key, value);
        });
        return function () {
            Object.entries(audioObject).forEach(function (_a) {
                var key = _a[0], value = _a[1];
                audioElement.removeEventListener(key, value);
            });
        };
    }, [audioElement]);
    return (React.createElement("div", { className: style['audio-container'], style: { backgroundColor: 'transparent', margin: 0, padding: 0 } },
        React.createElement("div", { className: style['audio-top'], onClick: startPlayAudio },
            React.createElement("span", { className: style['duration-black'] }, "".concat(duration, " \"")),
            isPlaying && React.createElement("span", { className: style['aduio-playing'] }),
            !isPlaying && React.createElement("span", { className: style['r-agent'] },
                " ",
                React.createElement(Voice, null))),
        msg.loadingText &&
            // 具体样式 没见过  ==================wwd
            React.createElement(React.Fragment, null,
                React.createElement("div", { className: style['audio-hr'] }),
                React.createElement("div", { className: style['audio-text'] },
                    React.createElement("div", { className: style['loading-img'] }))),
        msg.recognition &&
            // 具体样式 没见过  ==================wwd
            React.createElement(React.Fragment, null,
                React.createElement("div", { className: style['audio-hr'] }),
                React.createElement("div", { className: style['audio-text'] }, msg.recognition))));
});
export default AudioType;
