import React, { memo, useMemo, useCallback } from 'react';
import style from './index.module.less';
import classNames from "classnames";
import { useTranslation } from 'react-i18next';
var ChatRecordType = memo(function (_a) {
    var msg = _a.msg, openRecordCb = _a.openRecordCb, chatPlatform = _a.chatPlatform;
    var t = useTranslation().t;
    var typeMap = {
        image: t('img'),
        video: t('video'),
        file: t('label.file'),
        voice: t('voice'),
        emotion: t('expression'),
        chatrecord: t('chatRecord') //聊天记录
    };
    var content = useMemo(function () {
        return msg.content && JSON.parse(msg.content);
    }, [msg.content]);
    var initRecordContent = useMemo(function () {
        if (!content || !content.item || !content.item.length)
            return null;
        // 展示记录前三条的数据
        return content.item.slice(0, 3).map(function (item, index) {
            return (React.createElement("div", { key: index, className: classNames(style['chat-record-item'], style['ellipsis']) }, item.type === 'text'
                ? React.createElement("div", { className: style['ellipsis'], dangerouslySetInnerHTML: { __html: item.content } })
                : "[".concat(typeMap[item.type] || item.content, "]")));
        });
    }, [content]);
    var openRecordHandle = useCallback(function () {
        openRecordCb(content);
    }, [content]);
    return (React.createElement("div", { className: style['chat-record-wrapper'], onClick: openRecordHandle },
        React.createElement("h4", { className: classNames(style['chat-record-wrapper'], style['ellipsis']) }, content.title),
        initRecordContent));
});
export default ChatRecordType;
