var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { Fragment, useCallback, useEffect, useState } from "react";
import { Checkbox, Dropdown, Input, List, Menu } from "udesk-ui";
import style from "./style.module.scss";
import ClassNames from "classnames";
import { CareDown } from "../icon/icon";
import { useTranslation } from "react-i18next";
var CheckBoxSelector = function (props) {
    // let newProps = { ...DEFAULT_PROPS, ...props };
    var t = useTranslation().t;
    var _a = props.options, options = _a === void 0 ? [] : _a, _b = props.value, value = _b === void 0 ? [] : _b, _c = props.idFieldName, idFieldName = _c === void 0 ? "id" : _c, _d = props.nameFieldName, nameFieldName = _d === void 0 ? "name" : _d, _e = props.trigger, trigger = _e === void 0 ? ["click"] : _e, _f = props.preText, preText = _f === void 0 ? "" : _f, _g = props.unit, unit = _g === void 0 ? t("unit") : _g, _h = props.className, className = _h === void 0 ? "" : _h, _j = props.AllText, AllText = _j === void 0 ? t("all") : _j, _k = props.searchPlaceholder, searchPlaceholder = _k === void 0 ? "" : _k, onChange = props.onChange, _l = props.showSearch, showSearch = _l === void 0 ? true : _l, getLabel = props.getLabel;
    var _m = useState(value), values = _m[0], setValues = _m[1];
    var _o = useState(""), keyword = _o[0], setKeyword = _o[1];
    var _p = useState(false), visible = _p[0], setVisible = _p[1];
    var _q = useState([]), innerOptions = _q[0], setInnerOptions = _q[1];
    var _getLabel = useCallback(function (option) {
        if (typeof getLabel === "function") {
            return getLabel(option);
        }
        else {
            return option[nameFieldName];
        }
    }, [getLabel, nameFieldName]);
    useEffect(function () {
        setInnerOptions(options);
    }, [options]);
    var onCheckboxChanged = useCallback(function (e, option) {
        var checked = e.target.checked;
        var id = option[idFieldName];
        var newValues = [];
        if (checked) {
            // eslint-disable-next-line eqeqeq
            var hasValue = values.some(function (value) { return value == id; });
            if (!hasValue) {
                newValues = __spreadArray(__spreadArray([], values, true), [id], false);
            }
        }
        else {
            newValues = values.filter(function (value) {
                // eslint-disable-next-line eqeqeq
                return value != id;
            });
            newValues = __spreadArray([], newValues, true);
        }
        if (typeof onChange === "function") {
            onChange(newValues);
        }
        setValues(newValues);
    }, [idFieldName, onChange, values]);
    var onKeywordChanged = useCallback(function (e) {
        var keyword = e.target.value;
        setKeyword(e.target.value);
        if (options && keyword) {
            var optionResult = options.filter(function (option) {
                var name = option[nameFieldName];
                return name && name.indexOf(keyword) !== -1;
            });
            setInnerOptions(optionResult);
        }
        else {
            setInnerOptions(options);
        }
    }, [nameFieldName, options]);
    var createMenu = useCallback(function (options) {
        return (React.createElement(Menu, { className: style["option-list"] },
            !!showSearch && (React.createElement(Menu.Item, { key: "-1" },
                React.createElement("div", { className: style["search"] },
                    React.createElement(Input.Search, { className: style["search-input"], placeholder: searchPlaceholder, value: keyword, onChange: onKeywordChanged })))),
            React.createElement(Menu.Item, null,
                React.createElement(List, { dataSource: options, className: style["list"], size: "small", renderItem: function (option) {
                        var id = option[idFieldName];
                        return (React.createElement(List.Item, { className: style["list-item"], key: id },
                            React.createElement(Checkbox, { checked: !!isInValue(values, id), onChange: function (e) {
                                    onCheckboxChanged(e, option);
                                } }, _getLabel(option))));
                    } }))));
    }, [
        idFieldName,
        keyword,
        onCheckboxChanged,
        onKeywordChanged,
        searchPlaceholder,
        showSearch,
        values,
        _getLabel,
    ]);
    var onVisibleChange = useCallback(function (value) {
        setVisible(value);
    }, []);
    var selectedName = "";
    if ((values === null || values === void 0 ? void 0 : values.length) === 1) {
        // eslint-disable-next-line eqeqeq
        var selectedOption = options.find(function (option) { return option[idFieldName] == values[0]; });
        selectedName = selectedOption === null || selectedOption === void 0 ? void 0 : selectedOption[nameFieldName];
    }
    return (React.createElement("div", { className: ClassNames(style["checkbox-selector"], className) },
        React.createElement(Dropdown, { overlay: createMenu(innerOptions), visible: visible, onVisibleChange: onVisibleChange, trigger: trigger },
            React.createElement("span", null,
                (values === null || values === void 0 ? void 0 : values.length) > 1 && (React.createElement(Fragment, null,
                    preText, values === null || values === void 0 ? void 0 :
                    values.length,
                    unit)),
                (values === null || values === void 0 ? void 0 : values.length) === 1 && (React.createElement(Fragment, null,
                    preText,
                    selectedName)),
                !(values === null || values === void 0 ? void 0 : values.length) && (React.createElement(Fragment, null,
                    preText,
                    AllText)),
                React.createElement(CareDown, null)))));
};
export default CheckBoxSelector;
function isInValue(values, id) {
    if (!values || id == null) {
        return;
    }
    if (!Array.isArray(values)) {
        values = [values];
    }
    // eslint-disable-next-line eqeqeq
    return values.find(function (value) { return value == id; });
}
