var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useCallback, useMemo, useState } from 'react';
import { Button, message } from 'udesk-ui';
import style from './index.module.scss';
import { useTranslation } from 'react-i18next';
import CopyToClipboard from 'react-copy-to-clipboard';
var CopyComponent = function (props) {
    var t = useTranslation().t;
    // 默认显示在右上角，不能默认显示在容器外面，因为外层容器上设置了overflow:hidden，这样复制按钮就显示不出来了。
    // 而设置overflow:hidden的原因是为了内容过长时，显示省略号...
    var text = props.text, _a = props.left, left = _a === void 0 ? '0px' : _a, _b = props.top, top = _b === void 0 ? '-30px' : _b, _c = props.bottom, bottom = _c === void 0 ? '' : _c, _d = props.switchFlag, switchFlag = _d === void 0 ? false : _d;
    var buttonStyle = {
        position: 'absolute',
        left: left,
        top: top,
        bottom: bottom,
        zIndex: 999,
        visibility: 'hidden',
    };
    var _e = useState(buttonStyle), copyStyle = _e[0], setCopyStyle = _e[1];
    var showButton = useCallback(function (e) {
        setCopyStyle(__assign(__assign({}, copyStyle), { visibility: text === '' || text === null || text === undefined ? 'hidden' : 'visible' }));
    }, [copyStyle, text]);
    var hideButton = useCallback(function (e) {
        setCopyStyle(__assign(__assign({}, copyStyle), { visibility: 'hidden' }));
    }, [copyStyle]);
    var copyText = useCallback(function (text, result) {
        if (result) {
            message.info(t('tip.copySuccess'));
        }
        else {
            message.error(t('tip.copySuccess'));
        }
    }, [t]);
    var buttonIcon = useMemo(function () {
        return (React.createElement(Button, { size: 'small', style: copyStyle }, t('label.copy')));
    }, [copyStyle, t]);
    return (React.createElement(React.Fragment, null,
        switchFlag && (React.createElement("div", { onMouseEnter: showButton, onMouseLeave: hideButton, className: "".concat(style['copy-container'], " ").concat(props.hidden ? style['hidden'] : '') },
            React.createElement(CopyToClipboard, { text: text, onCopy: copyText }, buttonIcon),
            React.createElement("div", { className: "copy-children" }, props.children))),
        !switchFlag && (React.createElement("div", { className: "".concat(style['copy-container'], " ").concat(props.hidden ? style['hidden'] : '') }, props.children))));
};
export default CopyComponent;
