var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { useCallback, useMemo, useRef, useState } from "react";
import { Select, Spin } from "udesk-ui";
import apis from "../../utils/apis";
import style from "./index.module.scss";
import { Search } from "../icon/icon";
import { DownOutlined } from "@ant-design/icons";
import { useTranslation } from "react-i18next";
import useDebounce from "react-use/esm/useDebounce";
var DEFAULT_PAGE = 1;
var DEFAULT_PAGE_SIZE = 20;
var DEFAULT_TOTAL_PAGE = 0;
var CustomerAutoComplete = function (props) {
    var t = useTranslation().t;
    var _a = useState(false), fetching = _a[0], setFetching = _a[1];
    var _b = useState(DEFAULT_PAGE), page = _b[0], setPage = _b[1];
    var _c = useState([]), data = _c[0], setData = _c[1]; //搜索到的数据
    var _d = useState(""), searchValue = _d[0], setSearchValue = _d[1];
    var _e = useState(DEFAULT_TOTAL_PAGE), totalPages = _e[0], setTotalPages = _e[1];
    var selectRef = useRef(null);
    var _f = props.showArrow, showArrow = _f === void 0 ? true : _f, _g = props.labelInValue, labelInValue = _g === void 0 ? true : _g, value = props.value, _h = props.placeholder, placeholder = _h === void 0 ? t("components.customerAutoComplete.selectCustomer") : _h, _j = props.filterOption, filterOption = _j === void 0 ? false : _j, _k = props.showSearchModal, showSearchModal = _k === void 0 ? false : _k, onChange = props.onChange;
    var notFoundContent = useMemo(function () {
        return fetching && React.createElement(Spin, { size: "small" });
    }, [fetching]);
    var fetchUser = useCallback(function (searchValue, page) {
        setFetching(true);
        apis
            .postUser({
            params: {
                page: page,
                page_size: DEFAULT_PAGE_SIZE,
                prefix: searchValue,
            },
        })
            .then(function (res) {
            var _a;
            if ((res === null || res === void 0 ? void 0 : res.code) === 1000) {
                setTotalPages((_a = res === null || res === void 0 ? void 0 : res.meta) === null || _a === void 0 ? void 0 : _a.total_pages);
                setPage(res.meta.current_page);
                var orgs_1 = res.organizations;
                setData(function (v) {
                    if (v === void 0) { v = []; }
                    var customers = res.customers.map(function (i) { return (__assign(__assign({}, i), { organizations: i.organizations
                            .map(function (j) { return orgs_1.find(function (l) { return l.id === j; }); })
                            .filter(Boolean) })); });
                    return __spreadArray(__spreadArray([], v, true), customers, true);
                });
            }
            setFetching(false);
        })
            .catch(function () { return setFetching(false); });
    }, []);
    var handleChange = useCallback(function (value) {
        onChange && onChange(value);
        setFetching(false);
    }, [onChange]);
    var beforeSearch = useCallback(function (searchValue) {
        setSearchValue(searchValue);
        setData([]);
        setPage(DEFAULT_PAGE);
    }, []);
    useDebounce(function () {
        fetchUser(searchValue, 1);
    }, 500, [searchValue]);
    //处理滚动事假
    var handleScroll = useCallback(function (e) {
        if (e.currentTarget.scrollTop ===
            e.currentTarget.scrollHeight - e.currentTarget.clientHeight) {
            if (page < totalPages) {
                fetchUser(searchValue, page + 1);
            }
        }
    }, [page, totalPages, fetchUser, searchValue]);
    var suffixIcon = useMemo(function () {
        return (React.createElement(React.Fragment, null,
            showSearchModal && (React.createElement("div", { className: style["search-icon"] },
                React.createElement(Search, null))),
            !showSearchModal && React.createElement(DownOutlined, null)));
    }, [showSearchModal]);
    return (React.createElement("div", { style: { display: "flex" } },
        React.createElement(Select, { showSearch: true, showArrow: showArrow, labelInValue: labelInValue, value: value, placeholder: placeholder, notFoundContent: notFoundContent, filterOption: filterOption, onSearch: beforeSearch, onChange: handleChange, style: { width: "100%", minWidth: 120 }, getPopupContainer: function (triggerNode) { return triggerNode; }, suffixIcon: suffixIcon, onPopupScroll: handleScroll, allowClear: true, dropdownMatchSelectWidth: false, optionLabelProp: "title", ref: selectRef, listItemHeight: 54 }, data.map(function (d) { return (React.createElement(Select.Option, { title: "".concat(d.nick_name).concat(d.organizations.length ? "\uFF08".concat(d.organizations[0].name, "\uFF09") : ""), key: d.id, value: d.id },
            d.nick_name,
            d.organizations.length ? "\uFF08".concat(d.organizations[0].name, "\uFF09") : null,
            React.createElement("br", null),
            d.description || "\u00A0")); }))));
};
export default CustomerAutoComplete;
