import React, { useState, useCallback } from "react";
import { Button } from "udesk-ui";
import style from "./index.module.scss";
import DropDown, { Menu, Trigger } from "../drop-down";
import CustomerAutoComplete from "../customer-auto-complete";
import { useTranslation } from "react-i18next";
import { CareDown } from "../icon/icon";
var CustomerDropDown = function (props) {
    var onConfirm = props.onConfirm;
    var t = useTranslation().t;
    var _a = useState(false), visible = _a[0], setVisible = _a[1];
    var _b = useState(), selectCustomer = _b[0], setSelectCustomer = _b[1];
    var onChange = useCallback(function (value) {
        setSelectCustomer(value);
    }, []);
    var onConfirmed = useCallback(function () {
        onConfirm && onConfirm(selectCustomer);
        setVisible(false);
    }, [onConfirm, selectCustomer]);
    var onCancel = useCallback(function () {
        setVisible(false);
    }, []);
    var onVisibleChange = useCallback(function (value) {
        setVisible(value);
    }, []);
    return (React.createElement(DropDown, { className: style["customer-drop-down"], visible: visible, onVisibleChange: onVisibleChange },
        React.createElement(Trigger, null,
            t("components.customerDropDown.customer"),
            React.createElement(CareDown, null)),
        React.createElement(Menu, { className: style["menu"] },
            React.createElement(Menu.Item, null,
                React.createElement("div", { className: style["customer-select"] },
                    React.createElement(CustomerAutoComplete, { value: selectCustomer, onChange: onChange })),
                React.createElement("div", { className: style["buttons"] },
                    React.createElement(Button, { onClick: onConfirmed, type: "primary", size: "small" }, t("confirm")),
                    React.createElement(Button, { onClick: onCancel, size: "small" }, t("cancel")))))));
};
export default CustomerDropDown;
