import React, { useCallback, useEffect, useRef } from 'react';
import { loadScript } from '../utilities';
var DatumCard = function (_a) {
    var msg = _a.msg, area = _a.area;
    var renderDom = useRef(null);
    var loadKmSdk = useCallback(function () {
        var url = 'https://static-ud.udesk.cn';
        if (area) {
            if ((area === null || area === void 0 ? void 0 : area.indexOf('s')) > -1) {
                url = 'https://static-ud.' + area + '.udesk.cn';
            }
            else {
                url = 'https://static-ud.' + area + '.tryudesk.com';
            }
        }
        loadScript(url + '/lib/km-chat-sdk/manifest-loader.min.js').then(function () {
            var _a;
            var _window = window;
            var wfManifest = new _window.ManifestLoader("".concat((_a = msg === null || msg === void 0 ? void 0 : msg.content) === null || _a === void 0 ? void 0 : _a.kmhost, "/km-chat-sdk/manifest.json"));
            wfManifest.assets().then(function (res) {
                var _a, _b, _c;
                console.log('wfManifestRes===', res);
                var SdkClass;
                if (Array.isArray(res)) {
                    SdkClass = res.find(function (item) { return item.isEntry; }).SdkClass;
                    if (!SdkClass) {
                        loadKmSdk();
                        return;
                    }
                }
                try {
                    var customFormInstance = new SdkClass({
                        componentProps: {
                            type: 'DATABASE_COMPARISON',
                            readonly: true,
                            sessionId: (_a = msg === null || msg === void 0 ? void 0 : msg.content) === null || _a === void 0 ? void 0 : _a.sessionId,
                            kmhost: (_b = msg === null || msg === void 0 ? void 0 : msg.content) === null || _b === void 0 ? void 0 : _b.kmhost,
                            robotId: (_c = msg === null || msg === void 0 ? void 0 : msg.content) === null || _c === void 0 ? void 0 : _c.robotId,
                            cardContent: msg === null || msg === void 0 ? void 0 : msg.content
                        },
                        componentName: 'sdkEntry'
                    });
                    customFormInstance.renderTo(renderDom.current);
                }
                catch (err) { // not existed
                }
            });
        });
    }, [msg === null || msg === void 0 ? void 0 : msg.content]);
    useEffect(function () {
        loadKmSdk();
    }, []);
    return (React.createElement("div", { ref: renderDom }));
};
export default DatumCard;
