import { __assign } from "tslib";
import { Popover } from 'udesk-ui';
import React, { useContext } from 'react';
import { useTranslation } from '@udesk-webapp/locale';
import DOMPurify from 'dompurify';
import { replacePlaceholder } from '../../utils/repository-widget';
import { hit, RepositoryWidgetContext } from '../../utilities';
import css from './index.module.scss';
function replaceWrapAndSpace(str) {
    if (str) {
        str = str.replace(/[\n\r]/g, '<br>').replace(/[\n]/g, '<br>').replace(/[\s]/g, '&nbsp;');
    }
    else {
        str = '';
    }
    return str;
}
var ExpressionContent = function (props) {
    var item = props.item;
    var _a = (item || {}).content, content = _a === void 0 ? '' : _a;
    var safeContent = DOMPurify.sanitize(content);
    var t = useTranslation().t;
    var _b = useContext(RepositoryWidgetContext), onUse = _b.onUse, isWorkbench = _b.isWorkbench, agent = _b.agent, customer = _b.customer, organizations = _b.organizations, ticket = _b.ticket, ticketCustomFields = _b.ticketCustomFields, customerCustomFields = _b.customerCustomFields, customerFieldAbilities = _b.customerFieldAbilities;
    var onClickUseful = function (item) {
        if (!isWorkbench)
            return;
        if (item) {
            replacePlaceholder(item.content, {
                customer: customer,
                organizations: organizations,
                agent: agent,
                ticket: ticket,
                customerCustomFields: customerCustomFields,
                ticketCustomFields: ticketCustomFields,
                t: t,
                customerFieldAbilities: customerFieldAbilities,
            }).then(function (content) {
                onUse === null || onUse === void 0 ? void 0 : onUse('useful_expression', __assign(__assign({}, item), { content: content }));
            });
            hit(item.id, 'UsefulExpression');
        }
    };
    return (React.createElement("div", { className: "".concat(css['expression-item-wrap'], " ").concat(css['highlight']) },
        React.createElement(Popover, { overlayClassName: css.expressionPopover, placement: 'left', destroyTooltipOnHide: true, content: React.createElement("div", { className: css['useful-popover-content'], dangerouslySetInnerHTML: { __html: replaceWrapAndSpace(safeContent) } }) },
            React.createElement("p", { onClick: function () { return onClickUseful(item); }, className: css['expression-item'], dangerouslySetInnerHTML: { __html: safeContent } }))));
};
export default ExpressionContent;
