import React, { useCallback, useMemo, useRef, useState } from 'react';
import { imageThumbnail, update_sdk_url } from '../utilities';
import BrokenImage from '../images/broken-image.png';
import LinkOutlined from '@ant-design/icons/LinkOutlined';
import ReloadOutlined from '@ant-design/icons/ReloadOutlined';
import style from './index.module.less';
import { useTranslation } from 'react-i18next';
var ImageType = React.memo(function (_a) {
    var msg = _a.msg, reloadImageTimes = _a.reloadImageTimes;
    var _b = useState(false), imgError = _b[0], setImgError = _b[1];
    var reloadTimes = useRef(0);
    var t = useTranslation().t;
    var content = useMemo(function () {
        if (!msg.__chat_platform || !['weixin_mini', 'qywx', 'wechat', 'weixin_kf'].includes(msg.__chat_platform)) {
            return (msg.content || '').replace(/https:|http:/, '');
        }
        else {
            return msg.content;
        }
    }, [msg.__chat_platform, msg.content]);
    var handlerUrl = useCallback(function (url) {
        return url.replace(/\+/g, '%2B');
    }, []);
    var reloadImage = function () {
        setImgError(false);
        if (reloadTimes.current >= 5) {
            reloadImageTimes();
            return;
        }
        reloadTimes.current += 1;
    };
    return (React.createElement(React.Fragment, null,
        (content || msg.origin_url)
            ? ((!imgError)
                ? React.createElement("img", { className: "image-show", src: update_sdk_url(imageThumbnail(content ? (msg.is_receive ? content : handlerUrl(content)) : BrokenImage, msg.file_policy || '', msg.filesize), msg) || msg.origin_url, "data-policy": msg.file_policy, onError: function () {
                        setImgError(true);
                    }, alt: '' })
                : React.createElement("div", { className: style['image-reload'], onClick: reloadImage },
                    React.createElement(ReloadOutlined, { className: style['image-reload-icon'] }),
                    React.createElement("span", { className: style['image-reload-text'] }, t('page.im.imMessages.reloadImage'))))
            : null,
        (!content && msg.origin_url) &&
            React.createElement("a", { href: msg.origin_url, target: "_blank", rel: "noopener noreferrer" },
                React.createElement(LinkOutlined, null)),
        (function () {
            if (content && imgError) {
                return React.createElement("a", { href: content, target: "_blank", rel: "noopener noreferrer" },
                    React.createElement(LinkOutlined, null));
            }
            return null;
        })()));
});
export default ImageType;
