import { Button } from 'udesk-ui';
import React, { useContext } from 'react';
import { useTranslation } from '@udesk-webapp/locale';
import DOMPurify from 'dompurify';
import { hit, RepositoryWidgetContext } from '../../utilities';
import css from './index.module.scss';
var LinkContent = function (props) {
    var item = props.item;
    if (!item)
        return null;
    var t = useTranslation().t;
    var id = item.id, name = item.name, mode = item.mode;
    var _a = useContext(RepositoryWidgetContext), isWorkbench = _a.isWorkbench, onUse = _a.onUse;
    var safeContent = DOMPurify.sanitize(name);
    var onClickUseful = function (item) {
        if (!isWorkbench)
            return;
        if (item) {
            onUse === null || onUse === void 0 ? void 0 : onUse('useful_link', item);
            hit(item.id, 'UsefulLink');
        }
    };
    return (React.createElement("div", { className: css['link-item-wrap'], onClick: function () { return onClickUseful(item); } },
        React.createElement("p", { className: "".concat(css['link-item'], " ").concat(css['highlight']), dangerouslySetInnerHTML: { __html: safeContent } }),
        (mode === 'mini' || mode === 'mini_card') && isWorkbench ? (React.createElement(Button, { type: 'link', size: 'small' }, t('label.send'))) : null));
    // icon: mode === 'mini' || mode === 'mini_card' ? (<MiniProgram />) : (<LinkOutlined />),
};
export default LinkContent;
