import React, { useCallback, useEffect, useMemo, useState } from 'react';
import style from './index.module.less';
// import Wave1 from '../icon/wave1';
// import Wave2 from '../icon/wave2';
// import Wave3 from '../icon/wave3';
// import Wave4 from '../icon/wave4';
import Wave5 from '../icon/wave5';
import Wave6 from '../icon/wave6';
import Wave7 from '../icon/wave7';
var MessageVideo = React.memo(function (props) {
    var _a = useState(null), playingMsgVoice = _a[0], setPlayingMsgVoice = _a[1];
    // const { src } = props.contentObject.data.content;
    var _b = useState(-1), time = _b[0], setTime = _b[1];
    var _c = useState(false), isPlaying = _c[0], setIsPlaying = _c[1];
    var msgItem = props.msgItem;
    var audioElement = useMemo(function () {
        var _a;
        var audio = window.document.createElement('audio');
        audio.src = (_a = msgItem.data) === null || _a === void 0 ? void 0 : _a.voice_url;
        return audio;
    }, [msgItem]);
    var startPlayAudio = function () {
        if (isPlaying) {
            audioElement.pause();
            setIsPlaying(false);
        }
        else {
            audioElement.play();
            setIsPlaying(true);
        }
    };
    useEffect(function () {
        var audioObject = {
            loadedmetadata: function (e) {
                setTime(Math.ceil(e.target.duration));
            },
            timeupdate: function (e) {
                var res = Math.ceil(e.target.currentTime);
                if (res && time !== res) {
                    console.log(res);
                    setTime(Math.ceil(res));
                }
            },
            playing: function (e) {
                if (playingMsgVoice && playingMsgVoice !== e.target) {
                    playingMsgVoice.pause();
                }
                // eslint-disable-next-line react-hooks/exhaustive-deps
                setPlayingMsgVoice(e.target);
            },
            pause: function (e) {
                if (playingMsgVoice === e.target) {
                    // eslint-disable-next-line react-hooks/exhaustive-deps
                    setPlayingMsgVoice(null);
                }
                setIsPlaying(false);
                e.target.currentTime = 0;
                console.log(e.target.duration);
                setTime(Math.ceil(e.target.duration));
            },
            ended: function (e) {
                setIsPlaying(false);
            }
        };
        Object.entries(audioObject).forEach(function (_a) {
            var key = _a[0], value = _a[1];
            audioElement.addEventListener(key, value);
        });
        return function () {
            Object.entries(audioObject).forEach(function (_a) {
                var key = _a[0], value = _a[1];
                audioElement.removeEventListener(key, value);
            });
        };
    }, [audioElement, playingMsgVoice, time]);
    var handleWave = useCallback(function () {
        var num = time % 3;
        switch (num) {
            case 0:
                return React.createElement(Wave7, { className: style['wave'] });
            case 1:
                return React.createElement(Wave6, { className: style['wave'] });
            case 2:
                return React.createElement(Wave5, { className: style['wave'] });
            // case 3:
            //     return <Wave3 className={style['wave']}/>;
        }
    }, [time]);
    return (React.createElement("div", { className: "".concat(style['audio-container'], " ").concat('msg-content-wrapper-voice') },
        React.createElement("div", { className: style['audio-top'], onClick: startPlayAudio },
            (function () {
                if (isPlaying) {
                    return handleWave();
                }
                else {
                    return React.createElement(Wave7, { className: style['wave'] });
                }
            })(),
            time > -1 && React.createElement("span", { className: style['duration-white'] }, "".concat(time, " \"")))));
});
export default MessageVideo;
