import React, { useMemo } from 'react';
import style from './index.module.less';
import each from 'lodash-es/each';
import DOMPurify from 'dompurify';
var ProductType = React.memo(function (_a) {
    var msg = _a.msg;
    var renderParams = useMemo(function () {
        var html = [];
        each(msg.content.params, function (item) {
            html.push('<span style="');
            item.color && html.push('color: ' + item.color + ';');
            item.size && html.push('font-size: ' + (item.size || 12) + 'px;');
            item.bold && html.push('font-weight: bold;');
            html.push('">' + item.text + '</span>');
            item['break'] && html.push('<br/>');
        });
        return html.join('');
    }, [msg.content.params]);
    return (React.createElement("div", { className: style['im-msg-product'] },
        React.createElement("div", { className: style['media-left'] },
            React.createElement("img", { src: msg.content.imgUrl, alt: '' })),
        React.createElement("div", { className: style['media-body'] },
            function () {
                if (msg.content.url) {
                    return React.createElement("a", { href: msg.content.url, target: "_blank", rel: "noopener noreferrer" }, msg.content.name);
                }
                else {
                    return msg.content.name;
                }
            }(),
            React.createElement("div", { className: style['params'], dangerouslySetInnerHTML: { __html: DOMPurify.sanitize(renderParams) } }))));
});
export default ProductType;
