var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { useContext, useEffect, useMemo, useState, } from "react";
import axios from "axios";
import TreeSelect from "udesk-ui/es/tree-select";
import { useTranslation } from "react-i18next";
import { useSafeSpaceId } from "./km-util";
import { RepositoryWidgetContext } from "../utilities";
function buildTreeNodes(nodes, childrenMap) {
    if (!nodes) {
        return [];
    }
    return nodes.map(function (i) {
        return (React.createElement(TreeSelect.TreeNode, { value: i.id, key: i.id + "", title: i.name }, buildTreeNodes(childrenMap[i.id], childrenMap)));
    });
}
var CatalogSelect = function (_a) {
    var setDefaultValue = _a.setDefaultValue, companyId = _a.companyId, spaceId = _a.spaceId, subdomain = _a.subdomain, email = _a.email, limitSpaceIds = _a.limitSpaceIds, enablePrivate = _a.enablePrivate, passport = _a.passport, props = __rest(_a, ["setDefaultValue", "companyId", "spaceId", "subdomain", "email", "limitSpaceIds", "enablePrivate", "passport"]);
    var kmApiBase = useContext(RepositoryWidgetContext).kmApiBase;
    var _b = useState({}), childrenMap = _b[0], setChildrenMap = _b[1];
    var _c = useState([]), rootNodes = _c[0], setRootNodes = _c[1];
    var _d = useState([]), treeExpandedKeys = _d[0], setTreeExpandedKeys = _d[1];
    var t = useTranslation().t;
    var safeSpaceId = useSafeSpaceId(spaceId);
    useEffect(function () {
        axios
            .get("".concat(kmApiBase, "/spaces/").concat(safeSpaceId, "/catalogs"), {
            baseURL: "",
            params: {
                companyId: companyId,
                subdomain: subdomain,
                email: email,
                limitSpaceIds: limitSpaceIds,
                enablePrivate: enablePrivate,
                passport: passport,
            },
        })
            .then(function (res) {
            var _a, _b;
            var _result = {};
            var _topNodes = [];
            (_b = (_a = res.data) === null || _a === void 0 ? void 0 : _a.data) === null || _b === void 0 ? void 0 : _b.forEach(function (i) {
                if (i.parentId === 0) {
                    _topNodes.push(i);
                }
                else {
                    if (!_result[i.parentId]) {
                        _result[i.parentId] = [];
                    }
                    _result[i.parentId].push(i);
                }
            });
            var _topNode = _topNodes[0];
            if (!_topNode) {
                return;
            }
            setRootNodes(__spreadArray([
                {
                    id: -1,
                    name: t("page.im.km.km.all_article"),
                    parentId: _topNode.id,
                }
            ], _result[_topNode.id], true));
            setDefaultValue === null || setDefaultValue === void 0 ? void 0 : setDefaultValue(-1);
            setChildrenMap(_result);
        });
    }, [
        companyId,
        email,
        enablePrivate,
        limitSpaceIds,
        passport,
        setDefaultValue,
        safeSpaceId,
        subdomain,
        t,
        kmApiBase,
    ]);
    var treeNodes = useMemo(function () { return buildTreeNodes(rootNodes, childrenMap); }, [
        childrenMap,
        rootNodes,
    ]);
    useEffect(function () {
        setTreeExpandedKeys(Object.keys(childrenMap));
    }, [childrenMap]);
    if (!rootNodes.length) {
        return null;
    }
    return (React.createElement(TreeSelect, __assign({ treeExpandedKeys: treeExpandedKeys, onTreeExpand: setTreeExpandedKeys, dropdownMatchSelectWidth: false, bordered: false }, props), treeNodes));
};
export default CatalogSelect;
