var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { TreeSelect } from "udesk-ui/es";
import React, { useCallback, useEffect, useMemo, useState } from "react";
import { useTranslation } from "react-i18next";
import { useRequestData } from "../../utilities";
import QuestionList from "./question-list";
var TreeNode = TreeSelect.TreeNode;
function buildTreeNodes(catalogs) {
    return catalogs.map(function (i) {
        return React.createElement(TreeNode, { value: i.id, key: i.id + '', title: i.name }, buildTreeNodes(i.children || []));
    });
}
var CommonQuestion = function (_a) {
    var scope = _a.scope, query = _a.query;
    var t = useTranslation().t;
    var _b = useState(-1), selectedCatalog = _b[0], setSelectedCatalog = _b[1];
    var _c = useState(1), page = _c[0], setPage = _c[1];
    var _d = useState({ current_page: 0, total_pages: 0 }), paging = _d[0], setPaging = _d[1];
    var _e = useState([]), questions = _e[0], setQuestions = _e[1];
    useEffect(function () {
        setPage(1);
        setSelectedCatalog(-1);
    }, [scope]);
    var params = useMemo(function () { return ({
        knowledge_catalog_id: (selectedCatalog === -1) ? undefined : selectedCatalog,
        scope: scope,
        per_page: 20,
        page: page,
        current_works: true,
        query: query
    }); }, [page, query, scope, selectedCatalog]);
    var _f = useRequestData("question", params), loading = _f.loading, catalogs = _f.catalogs, data = _f.data;
    var treeNodes = useMemo(function () { return buildTreeNodes(catalogs); }, [catalogs]);
    useEffect(function () {
        setQuestions([]);
    }, [params.knowledge_catalog_id, params.scope, params.query]);
    useEffect(function () {
        if (data === null || data === void 0 ? void 0 : data.questions) {
            setQuestions(function (prevState) { return __spreadArray(__spreadArray([], prevState, true), data.questions, true); });
            setPaging(data.meta);
        }
    }, [data]);
    var nextPage = useCallback(function () {
        setPage(function (prevState) {
            if (paging.total_pages >= prevState) {
                return prevState + 1;
            }
            return prevState;
        });
    }, [paging.total_pages]);
    return React.createElement(React.Fragment, null,
        React.createElement(TreeSelect, { dropdownStyle: { maxHeight: 400, overflow: 'auto' }, style: { alignSelf: 'flex-start' }, treeDefaultExpandAll: true, bordered: false, value: selectedCatalog, dropdownMatchSelectWidth: false, onChange: setSelectedCatalog },
            React.createElement(TreeNode, { value: -1, key: '-1', title: t('page.im.km.question.all') }),
            React.createElement(TreeNode, { value: 0, key: '0', title: t('page.im.km.question.no_catalog') }),
            treeNodes),
        questions.length ?
            React.createElement(QuestionList, { data: questions, loading: loading, onScrollToBottom: nextPage }) :
            React.createElement("p", null, t('page.im.km.no_result', { name: '$t(label.question)' })));
};
export default CommonQuestion;
