import React, { useCallback, useContext, useEffect, useMemo, useState, } from "react";
import ScopeSwitch from "../../../components/repository-widget/scope-switch";
import CommonQuestion from "./common-question";
import RobotQuestionComp from "./robot-question";
import { RepositoryWidgetContext } from "../utilities";
import { getJSON } from "../../../utils";
import SearchInput from "../../../components/repository-widget/search-input";
var Question = function (_a) {
    var _b;
    var onSearch = _a.onSearch, query = _a.query;
    var _c = useState(), settings = _c[0], setSettings = _c[1];
    var _d = useContext(RepositoryWidgetContext), activeScope = _d.activeScope, onScopeChange = _d.onScopeChange, showRobotQuestionTab = _d.showRobotQuestionTab;
    useEffect(function () {
        getJSON("/knowledge_manager_settings/robot_settings").then(function (settings) {
            setSettings(settings);
        });
    }, []);
    //系统开通了机器人，并且showRobotQuestionTab为 true 时才会显示机器人
    var enableRobot = useMemo(function () {
        var _a;
        return showRobotQuestionTab && ((_a = settings === null || settings === void 0 ? void 0 : settings.km_join_udesk_robots) === null || _a === void 0 ? void 0 : _a.is_enabled);
    }, [(_b = settings === null || settings === void 0 ? void 0 : settings.km_join_udesk_robots) === null || _b === void 0 ? void 0 : _b.is_enabled, showRobotQuestionTab]);
    var _onScopeChange = useCallback(function (scope) {
        if (!enableRobot && scope === "robot") {
            onScopeChange === null || onScopeChange === void 0 ? void 0 : onScopeChange("public");
        }
        else {
            onScopeChange === null || onScopeChange === void 0 ? void 0 : onScopeChange(scope);
        }
    }, [enableRobot, onScopeChange]);
    var mainContent = useMemo(function () {
        if (activeScope === "public" || activeScope === "personal") {
            return React.createElement(CommonQuestion, { scope: activeScope, query: query });
        }
        else if (enableRobot) {
            return React.createElement(RobotQuestionComp, { searchWord: query, settings: settings });
        }
        else {
            return null;
        }
    }, [activeScope, enableRobot, query, settings]);
    return (React.createElement(React.Fragment, null,
        React.createElement(ScopeSwitch, { enableRobot: enableRobot, value: activeScope, onChange: _onScopeChange }),
        React.createElement(SearchInput, { onSearch: onSearch, defaultValue: query }),
        mainContent));
};
export default Question;
