var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useContext, useEffect, useMemo, useState, } from "react";
import axios from "axios";
import TreeSelect from "udesk-ui/es/tree-select";
import { RepositoryWidgetContext } from "../../../repository-widget/utilities";
function buildTreeNodes(nodes, childrenMap) {
    if (!nodes) {
        return [];
    }
    return nodes.map(function (i) {
        return (React.createElement(TreeSelect.TreeNode, { value: i.id, key: i.id + "", title: i.name }, buildTreeNodes(childrenMap[i.id], childrenMap)));
    });
}
var CategorySelect = function (_a) {
    var settings = _a.settings, robotId = _a.robotId, setDefaultValue = _a.setDefaultValue, props = __rest(_a, ["settings", "robotId", "setDefaultValue"]);
    var kmApiBase = useContext(RepositoryWidgetContext).kmApiBase;
    var _b = useState({}), childrenMap = _b[0], setChildrenMap = _b[1];
    var _c = useState([]), rootNodes = _c[0], setRootNodes = _c[1];
    var _d = useState([]), treeExpandedKeys = _d[0], setTreeExpandedKeys = _d[1];
    useEffect(function () {
        axios
            .get("".concat(kmApiBase, "/v1/categories"), {
            baseURL: "",
            params: __assign({ robotId: robotId }, settings.auth),
        })
            .then(function (res) {
            var _a;
            var _result = {};
            var _rootNodes = [];
            res.data.data.forEach(function (i) {
                if (i.parentId === 0) {
                    _rootNodes.push(i);
                }
                else {
                    if (!_result[i.parentId]) {
                        _result[i.parentId] = [];
                    }
                    _result[i.parentId].push(i);
                }
            });
            setDefaultValue((_a = _rootNodes[0]) === null || _a === void 0 ? void 0 : _a.id);
            setRootNodes(_rootNodes);
            setChildrenMap(_result);
        });
    }, [robotId, setDefaultValue, settings.auth]);
    var treeNodes = useMemo(function () { return buildTreeNodes(rootNodes, childrenMap); }, [
        childrenMap,
        rootNodes,
    ]);
    useEffect(function () {
        setTreeExpandedKeys(Object.keys(childrenMap));
    }, [childrenMap]);
    if (!rootNodes.length) {
        return null;
    }
    return (React.createElement(TreeSelect, __assign({ treeExpandedKeys: treeExpandedKeys, onTreeExpand: setTreeExpandedKeys, dropdownMatchSelectWidth: false, treeDefaultExpandAll: true, bordered: false }, props), treeNodes));
};
export default CategorySelect;
