var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { useCallback, useContext, useEffect, useState } from "react";
import RobotQuestionItem from "./robot-question-item";
import axios from "axios";
import css from "../style.module.scss";
import List from "udesk-ui/es/list";
import InfiniteScroll from "react-infinite-scroller";
import { Spin } from "udesk-ui";
import { RepositoryWidgetContext } from "../../../utilities";
var RobotQuestionList = function (_a) {
    var categoryId = _a.categoryId, robotId = _a.robotId, auth = _a.auth, searchWord = _a.searchWord;
    var _b = useState([]), data = _b[0], setData = _b[1];
    var _c = useState(1), page = _c[0], setPage = _c[1];
    var _d = useState({ pageNum: 1, pageSize: 20, total: 0 }), paging = _d[0], setPaging = _d[1];
    var _e = useState(false), loading = _e[0], setLoading = _e[1];
    var kmApiBase = useContext(RepositoryWidgetContext).kmApiBase;
    useEffect(function () {
        setData([]);
        setPage(1);
    }, [categoryId, robotId, searchWord]);
    useEffect(function () {
        setLoading(true);
        axios
            .post("".concat(kmApiBase, "/v1/questions/search?sign=").concat(auth.sign, "&email=").concat(auth.email, "&timestamp=").concat(auth.timestamp, "&appID=").concat(auth.appID), {
            categoryId: categoryId,
            robotId: robotId,
            pageNum: page,
            pageSize: 20,
            searchWord: searchWord,
        })
            .then(function (res) {
            setPaging(res.data.paging);
            setData(function (prevState) { return __spreadArray(__spreadArray([], prevState, true), res.data.data, true); });
        })
            .finally(function () { return setLoading(false); });
    }, [
        page,
        categoryId,
        robotId,
        auth.sign,
        auth.email,
        auth.timestamp,
        auth.appID,
        searchWord,
    ]);
    var handleInfiniteOnLoad = useCallback(function () {
        if (loading) {
            return;
        }
        setPage(function (prevState) { return prevState + 1; });
    }, [loading]);
    return (React.createElement("div", { className: css["questionList"] },
        React.createElement(InfiniteScroll, { initialLoad: false, pageStart: 0, loadMore: handleInfiniteOnLoad, hasMore: paging.pageNum * paging.pageSize < paging.total, useWindow: false },
            React.createElement(List, { dataSource: data, renderItem: function (item) { return React.createElement(RobotQuestionItem, { data: item }); } }, loading && (React.createElement("div", { className: css.loadingContainer },
                React.createElement(Spin, null)))))));
};
export default RobotQuestionList;
