import React, { useCallback, useContext } from "react";
import { Button, List, Popover } from "udesk-ui";
import { useTranslation } from "react-i18next";
import FileTextTwoTone from "@ant-design/icons/FileTextTwoTone";
import DOMPurify from "dompurify";
import { RepositoryWidgetContext, robotToCommonQuestion, } from "../../../utilities";
import css from "../style.module.scss";
var RobotQuestionItem = function (_a) {
    var _b, _c;
    var data = _a.data;
    var t = useTranslation().t;
    var _d = useContext(RepositoryWidgetContext), onUse = _d.onUse, allowSendQuestion = _d.allowSendQuestion, onSend = _d.onSend;
    var onUseClick = useCallback(function () {
        onUse === null || onUse === void 0 ? void 0 : onUse("question", robotToCommonQuestion(data));
    }, [data, onUse]);
    var onSendClick = useCallback(function () {
        onSend === null || onSend === void 0 ? void 0 : onSend("question", robotToCommonQuestion(data));
    }, [data, onSend]);
    return (React.createElement(Popover, { content: React.createElement("div", { dangerouslySetInnerHTML: {
                __html: DOMPurify.sanitize((_c = (_b = data.answer) === null || _b === void 0 ? void 0 : _b.content) !== null && _c !== void 0 ? _c : ""),
            } }), overlayStyle: { maxWidth: "300px" }, overlayClassName: css.robotQuestionItemPopover, placement: "left" },
        React.createElement(List.Item, { className: css["align-justify"] },
            React.createElement("div", null,
                React.createElement(FileTextTwoTone, null),
                data.content),
            React.createElement("div", { className: css["nowrap"] },
                allowSendQuestion ? (React.createElement(Button, { size: "small", type: "link", onClick: onSendClick }, t("label.send"))) : null,
                React.createElement(Button, { size: "small", type: "link", onClick: onUseClick }, t("label.use"))))));
};
export default RobotQuestionItem;
