var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useEffect, useState } from "react";
import Select from "udesk-ui/es/select";
import { csApiGetJSON } from "../../../../utils/csApi";
var RobotSelect = function (_a) {
    var _b;
    var settings = _a.settings, onDataLoaded = _a.onDataLoaded, props = __rest(_a, ["settings", "onDataLoaded"]);
    var _c = useState([]), robotList = _c[0], setRobotList = _c[1];
    useEffect(function () {
        csApiGetJSON('/cs/im/agent/udesk_robots').then(function (res) { return res.data; }).then(function (list) {
            var _a, _b;
            var visibleIds = (_a = settings === null || settings === void 0 ? void 0 : settings.km_join_udesk_robots) === null || _a === void 0 ? void 0 : _a.robot_ids;
            if (visibleIds) {
                var robots = (_b = list === null || list === void 0 ? void 0 : list.udesk_robots.filter(function (i) {
                    return visibleIds.includes(i.km_robot_id);
                })) !== null && _b !== void 0 ? _b : [];
                onDataLoaded(robots);
                setRobotList(robots);
            }
        });
    }, [onDataLoaded, (_b = settings === null || settings === void 0 ? void 0 : settings.km_join_udesk_robots) === null || _b === void 0 ? void 0 : _b.robot_ids]);
    if (!robotList.length) {
        return null;
    }
    return (React.createElement(Select, __assign({ bordered: false }, props), robotList.map(function (i, idx) {
        return (React.createElement(Select.Option, { value: i.km_robot_id, key: i.km_robot_id }, i.name));
    })));
};
export default RobotSelect;
