var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useCallback, useContext, useMemo } from "react";
import { Popover, Tree } from "udesk-ui";
import FileTextTwoTone from "@ant-design/icons/FileTextTwoTone";
import { Spin } from "udesk-ui/es";
import ScopeSwitch from "../../../components/repository-widget/scope-switch";
import { useTranslation } from "react-i18next";
import { hit, RepositoryWidgetContext, useCatalogMap, useExpandedKeys, useRequestData, useSafeScope, } from "../../../components/repository-widget/utilities";
import DOMPurify from "dompurify";
import css from "../style.module.scss";
import classNames from "classnames";
import SearchInput from "../../../components/repository-widget/search-input";
import { customFieldValueToText } from "../../../utils/custom-field";
import moment from "moment";
import { YYYY_MM_DD_HH_MM_SS } from "../../../utils";
function replacePlaceholder(content, _a) {
    var _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x;
    var customer = _a.customer, agent = _a.agent, ticket = _a.ticket, customerCustomFields = _a.customerCustomFields, ticketCustomFields = _a.ticketCustomFields, t = _a.t;
    content = content.replace("{{agent.name}}", (_b = agent === null || agent === void 0 ? void 0 : agent.nick_name) !== null && _b !== void 0 ? _b : ""); // 当前客服姓名
    content = content.replace("{{agent.nick_name}}", (_c = agent === null || agent === void 0 ? void 0 : agent.aliase) !== null && _c !== void 0 ? _c : ""); // 当前客服昵称
    content = content.replace("{{ticket.field_num}}", (_d = ticket === null || ticket === void 0 ? void 0 : ticket.field_num) !== null && _d !== void 0 ? _d : ""); // 工单编号
    content = content.replace("{{ticket.id}}", "".concat((_e = ticket === null || ticket === void 0 ? void 0 : ticket.id) !== null && _e !== void 0 ? _e : "")); // 工单id
    content = content.replace("{{ticket.user}}", (_f = ticket === null || ticket === void 0 ? void 0 : ticket.customer_name) !== null && _f !== void 0 ? _f : ""); // 客户
    content = content.replace("{{ticket.created_at}}", (ticket === null || ticket === void 0 ? void 0 : ticket.created_at)
        ? moment(ticket.created_at).format(YYYY_MM_DD_HH_MM_SS)
        : ""); // 创建时间
    content = content.replace("{{ticket.subject}}", (_g = ticket === null || ticket === void 0 ? void 0 : ticket.subject) !== null && _g !== void 0 ? _g : ""); // 主题
    content = content.replace("{{ticket.content}}", (_h = ticket === null || ticket === void 0 ? void 0 : ticket.content) !== null && _h !== void 0 ? _h : ""); // 描述
    content = content.replace("{{ticket.priority}}", (_j = ticket === null || ticket === void 0 ? void 0 : ticket.priority) !== null && _j !== void 0 ? _j : ""); // 优先级
    content = content.replace("{{ticket.status}}", (_k = ticket === null || ticket === void 0 ? void 0 : ticket.status) !== null && _k !== void 0 ? _k : ""); // 状态
    content = content.replace("{{ticket.platform}}", (ticket === null || ticket === void 0 ? void 0 : ticket.platform_name) ? t(ticket.platform_name) : ""); // 渠道
    content = content.replace("{{ticket.tags}}", (ticket === null || ticket === void 0 ? void 0 : ticket.all_tags)
        ? ticket.all_tags
        : (ticket === null || ticket === void 0 ? void 0 : ticket.tags)
            ? ticket.tags.map(function (i) { return i.name; }).join(",")
            : ""); // 标签
    content = content.replace("{{ticket.assignee}}", (_l = ticket === null || ticket === void 0 ? void 0 : ticket.assignee_name) !== null && _l !== void 0 ? _l : ""); // 受理客服
    content = content.replace("{{ticket.user_group}}", (_m = ticket === null || ticket === void 0 ? void 0 : ticket.agent_group_name) !== null && _m !== void 0 ? _m : ""); // 受理客服组
    content = content.replace("{{ticket.followers}}", (ticket === null || ticket === void 0 ? void 0 : ticket.followers) ? ticket.followers.map(function (i) { return i.nick_name; }).join(",") : ""); // 工单关注人
    content = content.replace("{{ticket.web_url}}", (_o = ticket === null || ticket === void 0 ? void 0 : ticket.web_url) !== null && _o !== void 0 ? _o : ""); // 工单链接
    content = content.replace("{{ticket.solved_deadline}}", (_p = ticket === null || ticket === void 0 ? void 0 : ticket.solved_deadline) !== null && _p !== void 0 ? _p : ""); // 到期时间
    content = content.replace("{{ticket.replier}}", (_q = ticket === null || ticket === void 0 ? void 0 : ticket.replied_by) !== null && _q !== void 0 ? _q : ""); // 最后回复人
    content = content.replace("{{ticket.replied_at}}", (ticket === null || ticket === void 0 ? void 0 : ticket.replied_at)
        ? moment(ticket === null || ticket === void 0 ? void 0 : ticket.replied_at).format(YYYY_MM_DD_HH_MM_SS)
        : ""); // 最后回复时间
    content = content.replace("{{ticket.latest_comment_formatted}}", ""); // TODO 最新回复
    content = content.replace("{{ticket.customer_replied_at}}", (_r = ticket === null || ticket === void 0 ? void 0 : ticket.customer_replied_at) !== null && _r !== void 0 ? _r : ""); // 客户最后回复时间
    content = content.replace("{{ticket.latest_public_comment_at}}", ""); // TODO 最新公开回复时间
    content = content.replace("{{ticket.latest_internal_comment}}", ""); // TODO 最新内部备注
    content = content.replace("{{ticket.latest_public_comment_formatted}}", ""); //TODO 最新公开回复
    content = content.replace("{{ticket.agent_replied_at}}", (_s = ticket === null || ticket === void 0 ? void 0 : ticket.agent_replied_at) !== null && _s !== void 0 ? _s : ""); // 客服最后回复时间
    content = content.replace("{{customer.nick_name}}", (_t = customer === null || customer === void 0 ? void 0 : customer.nick_name) !== null && _t !== void 0 ? _t : ""); // 姓名
    content = content.replace("{{customer.email}}", (_u = customer === null || customer === void 0 ? void 0 : customer.email) !== null && _u !== void 0 ? _u : ""); // 邮箱
    content = content.replace("{{customer.cellphone}}", (customer === null || customer === void 0 ? void 0 : customer.cellphones)
        ? customer.cellphones.map(function (i) { return i.content; }).join(",")
        : ""); // 手机号
    content = content.replace("{{customer.description}}", (_v = customer === null || customer === void 0 ? void 0 : customer.description) !== null && _v !== void 0 ? _v : ""); // 描述
    content = content.replace("{{customer.owner}}", (_w = customer === null || customer === void 0 ? void 0 : customer.owner_name) !== null && _w !== void 0 ? _w : ""); // 负责人
    content = content.replace("{{customer.owner_group}}", (_x = customer === null || customer === void 0 ? void 0 : customer.owner_group_name) !== null && _x !== void 0 ? _x : ""); // 负责组
    content = content.replace("{{customer.organization}}", (customer === null || customer === void 0 ? void 0 : customer.organizations)
        ? customer.organizations.map(function (i) { return i.name; }).join(",")
        : ""); // 公司
    ticketCustomFields === null || ticketCustomFields === void 0 ? void 0 : ticketCustomFields.forEach(function (i) {
        var _a;
        content = content.replace("{{ticket.".concat(i.name, "}}"), customFieldValueToText(i, (_a = ticket === null || ticket === void 0 ? void 0 : ticket.custom_fields) === null || _a === void 0 ? void 0 : _a[i.name]) + "");
    });
    customerCustomFields === null || customerCustomFields === void 0 ? void 0 : customerCustomFields.forEach(function (i) {
        var _a;
        content = content.replace("{{customer.".concat(i.name, "}}"), customFieldValueToText(i, (_a = customer === null || customer === void 0 ? void 0 : customer.custom_fields) === null || _a === void 0 ? void 0 : _a[i.name]) + "");
    });
    return content;
}
function buildTreeData(catalogs, catalogMap, parentKey) {
    return catalogs.map(function (i) {
        var key = parentKey ? "".concat(parentKey, "-").concat(i.id) : i.id + "";
        return {
            key: key,
            title: i.name,
            selectable: false,
            children: (function () {
                if (i.children) {
                    return buildTreeData(i.children, catalogMap, key);
                }
                else {
                    return (catalogMap[i.id] || []).map(function (j) {
                        return {
                            key: "".concat(key, "-content").concat(j.id),
                            className: classNames(css.noWrap, css.flexNode),
                            originData: j,
                            title: (React.createElement(Popover, { overlayClassName: css.expressionPopover, placement: "left", content: React.createElement("pre", null, j.content) },
                                React.createElement("div", null, j.content))),
                            icon: React.createElement(FileTextTwoTone, null),
                        };
                    });
                }
            })(),
        };
    });
}
var UsefulExpression = function (_a) {
    var _b;
    var onSearch = _a.onSearch, query = _a.query;
    var _c = useContext(RepositoryWidgetContext), onUse = _c.onUse, onExpand = _c.onExpand, agent = _c.agent, customer = _c.customer, ticket = _c.ticket, ticketCustomFields = _c.ticketCustomFields, customerCustomFields = _c.customerCustomFields, activeScope = _c.activeScope, onScopeChange = _c.onScopeChange;
    var _scope = useSafeScope(activeScope);
    var t = useTranslation().t;
    var params = useMemo(function () { return ({ scope: _scope, per_page: 1000, query: query }); }, [
        _scope,
        query,
    ]);
    var _d = useRequestData("useful_expression", params), loading = _d.loading, catalogs = _d.catalogs, data = _d.data;
    var catalogMap = useCatalogMap((_b = data === null || data === void 0 ? void 0 : data.expressions) !== null && _b !== void 0 ? _b : []);
    var _expandedKeys = useExpandedKeys(catalogMap);
    var treeData = useMemo(function () {
        if (!query) {
            return buildTreeData(catalogs, catalogMap);
        }
        else {
            if (!data || !data.expressions) {
                return [];
            }
            return data.expressions.map(function (i) {
                var safeContent = DOMPurify.sanitize(i.content);
                return {
                    key: i.id,
                    originData: i,
                    className: classNames(css.noWrap, css.highlight, css.flexNode),
                    title: (React.createElement(Popover, { overlayClassName: css.expressionPopover, placement: "left", content: React.createElement("pre", { dangerouslySetInnerHTML: { __html: safeContent } }) },
                        React.createElement("div", { dangerouslySetInnerHTML: { __html: safeContent } }))),
                    icon: React.createElement(FileTextTwoTone, null),
                };
            });
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [data, catalogMap, catalogs]);
    var onClick = useCallback(function (e, treeNode) {
        var _a;
        var originData = (_a = treeNode === null || treeNode === void 0 ? void 0 : treeNode.props) === null || _a === void 0 ? void 0 : _a.originData;
        if (originData) {
            onUse === null || onUse === void 0 ? void 0 : onUse("useful_expression", __assign(__assign({}, originData), { content: replacePlaceholder(originData.content, {
                    customer: customer,
                    agent: agent,
                    ticket: ticket,
                    customerCustomFields: customerCustomFields,
                    ticketCustomFields: ticketCustomFields,
                    t: t,
                }) }));
            hit(originData.id, "UsefulExpression");
        }
    }, [
        agent,
        customer,
        customerCustomFields,
        onUse,
        t,
        ticket,
        ticketCustomFields,
    ]);
    var mainContent = useMemo(function () {
        if (loading) {
            return React.createElement(Spin, null);
        }
        else if (treeData && treeData.length) {
            return (React.createElement(Tree, { blockNode: true, showIcon: true, expandedKeys: _expandedKeys, onExpand: onExpand, selectable: false, treeData: treeData, onClick: onClick }));
        }
        else {
            return (React.createElement("p", null, t("page.im.km.no_result", { name: "$t(label.useful_expression)" })));
        }
    }, [_expandedKeys, loading, onClick, onExpand, t, treeData]);
    return (React.createElement(React.Fragment, null,
        React.createElement(ScopeSwitch, { value: _scope, onChange: onScopeChange }),
        React.createElement(SearchInput, { onSearch: onSearch, defaultValue: query }),
        mainContent));
};
export default UsefulExpression;
