var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import React, { Component } from "react";
import i18n from "../../i18n";
var SimpleErrorBoundary = /** @class */ (function (_super) {
    __extends(SimpleErrorBoundary, _super);
    function SimpleErrorBoundary(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            hasError: false,
        };
        return _this;
    }
    SimpleErrorBoundary.getDerivedStateFromError = function (error) {
        // 更新 state 使下一次渲染能够显示降级后的 UI
        return { hasError: true };
    };
    SimpleErrorBoundary.prototype.componentDidCatch = function (error, errorInfo) {
        console.error("error", error);
    };
    SimpleErrorBoundary.prototype.render = function () {
        if (this.state.hasError) {
            return (React.createElement(React.Fragment, null, this.props.type === "message"
                ? i18n.t("msgError")
                : i18n.t("simpleError")));
        }
        return this.props.children;
    };
    return SimpleErrorBoundary;
}(Component));
export default SimpleErrorBoundary;
