import React, { useCallback, useState } from 'react';
import style from './index.module.less';
import { useTranslation } from 'react-i18next';
import { Modal } from 'udesk-ui';
var buttonTypes = {
    link: 'link',
    phone: 'phone'
};
function StructType(props) {
    var msgItem = props.msg;
    var t = useTranslation().t;
    var _a = useState(false), showModal = _a[0], setShowModal = _a[1];
    var _b = useState(''), showPhone = _b[0], setShowPhone = _b[1];
    var item = typeof (msgItem.content) === 'string' ? JSON.parse(msgItem.content) : msgItem.content;
    if (item.data) {
        item = item.data.content;
    }
    var showTel = useCallback(function (phone) {
        setShowModal(true);
        setShowPhone(phone);
    }, []);
    return (React.createElement("div", { className: style['im-struct'] },
        React.createElement("ul", { className: style['list-group'] },
            item.img_url &&
                React.createElement("li", { className: style['list-group-item'] },
                    React.createElement("img", { alt: "", src: item.img_url, className: style['list-group-item-img'] })),
            (item.title || item.description) &&
                React.createElement("li", { className: "".concat(style['list-group-item'], " ").concat(style['text-left']) },
                    item.title && React.createElement("label", null, item.title),
                    item.description && React.createElement("p", { className: style['text-muted'] }, item.description)),
            item.buttons && item.buttons.map(function (item) {
                if (item) {
                    if (item.type === buttonTypes.link) {
                        return (React.createElement("li", { className: style['list-group-item'] },
                            React.createElement("a", { href: item.value, target: "_blank", rel: "noopener noreferrer" }, item.text)));
                    }
                    else if (item.type === buttonTypes.phone) {
                        return (React.createElement("li", { className: style['list-group-item'] },
                            React.createElement("a", { href: "tel:".concat(item.value), onClick: function () { return showTel(item.value); } }, item.text)));
                    }
                }
                return null;
            })),
        React.createElement(Modal, { title: t('page.im.record.callNum'), visible: showModal, onOk: function () { return setShowModal(false); }, onCancel: function () { return setShowModal(false); } },
            React.createElement("p", null,
                t('page.im.record.pleaseCall'),
                ":",
                showPhone))));
}
export default StructType;
