import { __assign } from "tslib";
import React, { useCallback, useContext, useEffect, useMemo, useState, useRef } from "react";
import { Empty } from "udesk-ui";
import { RepositoryWidgetContext, useSafeScope } from "../../utilities";
import ScopeSwitch from "../../scope-switch";
import SearchInput from "../../search-input";
import CatalogTree from "../tree-template";
import ListComponent from "../list-template";
var TabContent = function (props) {
    var query = props.query, onSearch = props.onSearch, 
    // dialogueTagName,
    dialogueTagMode = props.dialogueTagMode, roleCan = props.roleCan, knowledgeType = props.knowledgeType, stashKey = props.stashKey, dialogueTagNameList = props.dialogueTagNameList, itemNode = props.itemNode;
    var oldQuery = useRef("");
    var _a = useContext(RepositoryWidgetContext), activeScope = _a.activeScope, onScopeChange = _a.onScopeChange;
    var _scope = useSafeScope(activeScope);
    var _b = useState(""), searchValue = _b[0], setSearchValue = _b[1];
    var hasPermission = useMemo(function () {
        if (_scope === "public") {
            return (!!(roleCan === null || roleCan === void 0 ? void 0 : roleCan.knowledge_view_public) && !!(roleCan === null || roleCan === void 0 ? void 0 : roleCan.knowledge_useful_expressions_public));
        }
        else {
            return !!(roleCan === null || roleCan === void 0 ? void 0 : roleCan.knowledge_view) && !!(roleCan === null || roleCan === void 0 ? void 0 : roleCan.knowledge_useful_expressions);
        }
    }, [_scope]);
    useEffect(function () {
        var value = (dialogueTagNameList === null || dialogueTagNameList === void 0 ? void 0 : dialogueTagNameList.length) && dialogueTagMode === "keyword"
            ? dialogueTagNameList === null || dialogueTagNameList === void 0 ? void 0 : dialogueTagNameList.join(" ")
            : query;
        if (oldQuery.current !== value) {
            setSearchValue(value);
            oldQuery.current = value;
        }
    }, [dialogueTagMode, dialogueTagNameList, query]);
    var onSearched = useCallback(function (keyword) {
        setSearchValue(keyword);
        onSearch === null || onSearch === void 0 ? void 0 : onSearch(keyword);
    }, [onSearch]);
    return (React.createElement(React.Fragment, null,
        React.createElement(ScopeSwitch, { value: _scope, onChange: onScopeChange }),
        React.createElement(SearchInput, { onSearch: onSearched, defaultValue: searchValue }),
        !hasPermission ? (React.createElement(Empty, { className: 'h-full w-hull flex justify-center items-center flex-col', description: '\u60A8\u6682\u65E0\u6743\u9650\u67E5\u770B\u6B64\u5185\u5BB9' })) : searchValue && (searchValue === null || searchValue === void 0 ? void 0 : searchValue.trim()) ? (React.createElement(ListComponent, { knowledgeType: knowledgeType, scope: _scope, query: searchValue, itemNode: itemNode })) : (React.createElement(CatalogTree, __assign({}, props, { stashKey: stashKey, knowledgeType: knowledgeType, scope: _scope, itemNode: itemNode, matchTagList: dialogueTagMode === "type" ? dialogueTagNameList : undefined })))));
};
export default React.memo(TabContent);
