import React, { useMemo } from 'react';
import DOMPurify from 'dompurify';
import css from './index.module.less';
var TaskButton = function (_a) {
    var msg = _a.msg;
    var parsedContent = useMemo(function () {
        try {
            return JSON.parse(msg.content);
        }
        catch (_a) {
            return JSON.parse(JSON.stringify(msg.content));
        }
    }, [msg.content]);
    var buttons = useMemo(function () {
        return parsedContent.buttons.map(function (i) {
            return React.createElement("div", { className: css['task-button-rich'], dangerouslySetInnerHTML: { __html: DOMPurify.sanitize(i.customStyle) } });
        });
    }, [parsedContent.buttons]);
    return React.createElement(React.Fragment, null,
        React.createElement("div", { className: css['task-button-rich-title'], dangerouslySetInnerHTML: { __html: DOMPurify.sanitize(parsedContent.richText) } }),
        buttons);
};
export default TaskButton;
