import React, { useState, } from 'react';
import { Input, Row, Tooltip } from 'udesk-ui';
import { QuestionCircleOutlined } from '@ant-design/icons';
var CustomizeTextComponent = function (props) {
    // eslint-disable-next-line react/prop-types
    var formData = props.formData;
    var _a = useState(''), errMessage = _a[0], setErrMessage = _a[1];
    var _b = useState(false), errMsgShowFlag = _b[0], setErrMsgShowFlag = _b[1];
    // 失去焦点 校验是否提示
    var hanleValidateText = function (e) {
        //校验是否是必填项
        var textValue = e.target.value;
        if (formData.isRequired) {
            if (textValue === '') {
                setErrMessage(function () { return '必填项必须输入值'; });
                setErrMsgShowFlag(function () { return true; });
                return;
            }
            else {
                setErrMessage(function () { return ''; });
                setErrMsgShowFlag(function () { return false; });
            }
        }
        //检验是否是纯文本
        //校验长度
        if (textValue.length > formData.input_max) {
            setErrMessage(function () { return '超过做大长度限制'; });
            setErrMsgShowFlag(function () { return true; });
            return;
        }
        else {
            setErrMessage(function () { return ''; });
            setErrMsgShowFlag(function () { return false; });
        }
        //校验自定义的正则表达式
        if (formData.input_regex) {
            // eslint-disable-next-line no-eval
            if (eval(formData.input_regex).test(textValue)) {
                setErrMessage(function () { return ''; });
                setErrMsgShowFlag(function () { return false; });
            }
            else {
                setErrMessage(function () { return '不符合校验规则'; });
                setErrMsgShowFlag(function () { return true; });
                return;
            }
        }
    };
    return (React.createElement("div", { className: 'box-shadow-bg' },
        React.createElement(Row, null,
            formData.isRequired && React.createElement("span", { style: { color: 'red' } }, "*"),
            React.createElement("span", null, formData.name),
            (formData.help_tip_content && formData.help_tip_content.length > 0) && (formData.help_tip_target && formData.help_tip_target.length > 0) &&
                React.createElement(Tooltip, { title: formData.help_tip_content },
                    React.createElement(QuestionCircleOutlined, null))),
        React.createElement(Row, null,
            React.createElement(Input, { defaultValue: formData.input_default, placeholder: formData.input_tip, onBlur: hanleValidateText })),
        React.createElement(Row, null, errMsgShowFlag && React.createElement("span", null, errMessage))));
};
export default CustomizeTextComponent;
