import React from "react";
declare type Props<T> = {
    onChange?: (treeData: T[], objectData?: {
        nodeKey: string;
        type: string;
        deleteItem?: any;
    }) => void;
    value?: T[];
    onSelect: (nodeKey: string) => void;
    shouldShowNode?: (node: T) => boolean;
    allowSelect?: (node: T) => boolean;
    createNode: (parentNode: T) => T;
} & Pick<NodeProps<T>, 'allowAddChild' | 'allowEditTitle' | 'allowRemoveNode' | 'nodeChildrenPath' | 'nodeTitlePath' | 'nodeValuePath'>;
declare function TreeEditor<T extends object>({ onChange, value, onSelect, shouldShowNode, nodeChildrenPath, nodeTitlePath, nodeValuePath, allowSelect, createNode, ...props }: Props<T>): ReturnType<React.FC>;
export default TreeEditor;
export * from './utilities';
