import React, { useCallback, useEffect, useMemo, useRef, useState } from "react";
import { Button } from "udesk-ui";
import PlusCircleOutlined from "@ant-design/icons/PlusCircleOutlined";
import EditOutlined from "@ant-design/icons/EditOutlined";
import MinusCircleOutlined from "@ant-design/icons/MinusCircleOutlined";
import { Input } from "udesk-ui";
import get from 'lodash-es/get';
function Node(_a) {
    var value = _a.value, onAdd = _a.onAdd, nodeKey = _a.nodeKey, onClick = _a.onClick, onChange = _a.onChange, onDelete = _a.onDelete, nodeTitlePath = _a.nodeTitlePath, _b = _a.allowAddChild, allowAddChild = _b === void 0 ? function () { return true; } : _b, _c = _a.allowEditTitle, allowEditTitle = _c === void 0 ? function () { return true; } : _c, _d = _a.allowRemoveNode, allowRemoveNode = _d === void 0 ? function () { return true; } : _d;
    var _e = useState(!get(value, nodeTitlePath)), editing = _e[0], setEditing = _e[1];
    var inputRef = useRef(null);
    var _f = useState(get(value, nodeTitlePath)), title = _f[0], setTitle = _f[1];
    useEffect(function () {
        var _a;
        if (inputRef.current && editing) {
            (_a = inputRef.current) === null || _a === void 0 ? void 0 : _a.focus();
        }
    }, [editing]);
    var onFinishEdit = useCallback(function () {
        onChange(title, nodeKey);
        setEditing(false);
    }, [onChange, title, nodeKey]);
    var _onClick = useCallback(function () { return onClick(nodeKey, value); }, [nodeKey, value, onClick]);
    var enableAddChild = useMemo(function () { return allowAddChild(value); }, [allowAddChild, value]);
    var enableEditTitle = useMemo(function () { return allowEditTitle(value); }, [allowEditTitle, value]);
    var enableRemoveNode = useMemo(function () { return allowRemoveNode(value); }, [allowRemoveNode, value]);
    return React.createElement(React.Fragment, null,
        editing ? React.createElement(Input, { ref: inputRef, value: title, size: 'small', onBlur: onFinishEdit, onPressEnter: onFinishEdit, onChange: function (e) { return setTitle(e.target.value); } }) :
            React.createElement("div", { onClick: _onClick }, get(value, nodeTitlePath)),
        React.createElement("div", null,
            enableAddChild ? React.createElement(Button, { size: 'small', type: 'link', icon: React.createElement(PlusCircleOutlined, null), onClick: function () { return onAdd(value, nodeKey); } }) : null,
            enableEditTitle ? React.createElement(Button, { size: 'small', type: 'link', icon: React.createElement(EditOutlined, null), onClick: function () { return setEditing(function (prevState) { return !prevState; }); } }) : null,
            enableRemoveNode ? React.createElement(Button, { size: 'small', type: 'link', danger: true, icon: React.createElement(MinusCircleOutlined, null), onClick: function () { return onDelete(nodeKey); } }) : null));
}
export default Node;
