declare type Options = {
    nodeChildrenPath: ObjectPropertyPath;
    nodeValuePath: ObjectPropertyPath;
};
export declare function forEachTree<T>(treeData: T[] | undefined, callback: (node: T) => void, options: Pick<Options, 'nodeChildrenPath'>): void;
export declare function findTreeNode<T>(treeData: T[], nodeKey: string, nodeChildrenPath: ObjectPropertyPath): T | undefined;
/**
 * 移动树里的两个节点，会修改源数据
 * @param {Option[]} tree
 * @param {string} nodeKey
 * @param {string} targetNodeKey - 如果为空，则移动到 tree 里的 position 位置
 * @param nodeChildrenPath
 * @param {number} position
 */
export declare function moveTreeNode<T extends object>(tree: T[], nodeKey: string, targetNodeKey: string, nodeChildrenPath: ObjectPropertyPath, position?: number): void;
export declare function deleteTreeNode<T>(tree: T[], nodeKey: string, nodeChildrenPath: ObjectPropertyPath): any;
export declare function findItemCommon<T>(value: T[], nodeKey: string[], isFather?: boolean): any;
export {};
