import { Button, Spin, Tree } from "udesk-ui";
import React, { useCallback, useContext, useMemo } from "react";
import { useTranslation } from "@udesk-webapp/locale";
import { RepositoryWidgetContext } from "../../utilities";
import { useCatalogs } from "../hooks/useCatalog";
import css from "./index.module.scss";
var TreeTemplate = function (props) {
    var _a;
    var knowledgeType = props.knowledgeType, scope = props.scope, stashKey = props.stashKey, ItemNode = props.itemNode, matchTagList = props.matchTagList;
    var t = useTranslation().t;
    var _b = useContext(RepositoryWidgetContext), isWorkbench = _b.isWorkbench, public_knowledge_configs = _b.public_knowledge_configs;
    var _c = useCatalogs(knowledgeType, scope, stashKey, matchTagList), catalogLoading = _c.catalogLoading, catalogData = _c.catalogData, catalogList = _c.catalogList, loadList = _c.loadList, expandedKeys = _c.expandedKeys, setExpandedKeys = _c.setExpandedKeys;
    var onLoadData = function (_a) {
        var key = _a.key, children = _a.children;
        console.log(key, children);
        if (children && children.length) {
            return new Promise(function (resolve) {
                resolve();
            });
        }
        return loadList(key);
    };
    var onExpand = function (expandedKeys, _a) {
        var bool = _a.expanded, node = _a.node;
        setExpandedKeys(expandedKeys);
    };
    var onSelect = function (selectedKeys, e) {
        console.log(selectedKeys, e);
    };
    var onPackUp = function () {
        setExpandedKeys([]);
    };
    var height = ((_a = document.getElementById("knowledgeTreeWrapper")) === null || _a === void 0 ? void 0 : _a.clientHeight) || 600;
    var buildTreeData = useCallback(function (catalogs, catalogMap, t, isWorkbench, customCatalogOrder) {
        var sortedCatalogs = catalogs;
        if (customCatalogOrder) {
            sortedCatalogs = catalogs.sort(function (a, b) {
                return customCatalogOrder.findIndex(function (i) { return i.id === a.id; }) -
                    customCatalogOrder.findIndex(function (i) { return i.id === b.id; });
            });
        }
        return sortedCatalogs.map(function (i) {
            return {
                key: i.id,
                title: i.name,
                // className: css['treeNode'],
                children: (function () {
                    if (i.children) {
                        return buildTreeData(i.children, catalogMap, t, isWorkbench, i.children);
                    }
                    else {
                        return (catalogMap[i.id] || []).map(function (j) {
                            return {
                                key: "children_".concat(j.id),
                                isLeaf: true,
                                title: React.createElement(ItemNode, { item: j }),
                            };
                        });
                    }
                })(),
            };
        });
    }, [ItemNode]);
    var treeData = useMemo(function () {
        var _a;
        return buildTreeData(catalogData, catalogList, t, isWorkbench, (_a = public_knowledge_configs === null || public_knowledge_configs === void 0 ? void 0 : public_knowledge_configs.useful_link_catalog) !== null && _a !== void 0 ? _a : null);
    }, [buildTreeData, catalogData, catalogList, isWorkbench, public_knowledge_configs === null || public_knowledge_configs === void 0 ? void 0 : public_knowledge_configs.useful_link_catalog, t]);
    if (catalogLoading) {
        return (React.createElement(Spin, { className: 'w-full text-center' })
        // <div className={classNames(css['repository-loading'])}>
        // </div>
        );
    }
    return (React.createElement(React.Fragment, null,
        React.createElement(Button, { type: 'link', onClick: onPackUp, size: 'small', style: { textAlign: "left" } }, t("labels.packUp")),
        React.createElement("div", { id: 'knowledgeTreeWrapper', style: { flex: 1 } },
            React.createElement(Tree, { className: css["question-select"], loadData: onLoadData, treeData: treeData, blockNode: true, showIcon: true, expandedKeys: expandedKeys, onExpand: onExpand, height: height, onSelect: onSelect, selectable: false }))));
};
export default TreeTemplate;
