import React, { useMemo } from 'react';
import style from './index.module.less';
import { Input } from 'udesk-ui';
var TextArea = Input.TextArea;
var UnsatisfiedType = React.memo(function (_a) {
    var msg = _a.msg;
    var content = useMemo(function () {
        var reasonList = JSON.parse(msg.data.unsatisfied_tags_result.tags).filter(function (item) { return item.enable; });
        if (!reasonList.length)
            return;
        var _content = [];
        for (var i = 0; i < reasonList.length; i++) {
            var item = reasonList[i];
            var active = ('' + item.id) === ('' + msg.data.unsatisfied_tags_result.tag_id);
            _content.push(React.createElement("div", { className: "".concat(style['no-reason-item'], " ").concat(active ? style['active'] : '') }, item.content));
        }
        return _content;
    }, [msg]);
    return (React.createElement("div", { className: style['unsatisfied-wrapper'] },
        React.createElement("div", { className: style['no-reason-title'] }, "\u610F\u89C1\u53CD\u9988"),
        content,
        msg.data.unsatisfied_tags_result.reason ?
            React.createElement(TextArea, { className: style['text-area'], value: msg.data.unsatisfied_tags_result.reason, disabled: true }) : null,
        React.createElement("div", { className: style['sub-btn'] }, "\u5DF2\u6536\u5230\u60A8\u7684\u53CD\u9988\uFF01")));
});
export default UnsatisfiedType;
