var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { useCallback, useEffect, useState } from "react";
import { Button, Col, Modal, Row } from "udesk-ui";
import style from "./index.module.scss";
import { useTranslation } from "react-i18next";
import { CheckOutlined, CloseCircleFilled } from "@ant-design/icons";
import UploadBox from "../upload-box";
function UploadModal(props) {
    // 上传的图片列表
    var _a = useState([]), imageFiles = _a[0], setImageFiles = _a[1];
    var _b = useState([]), selectedImages = _b[0], setSelectedImages = _b[1];
    useEffect(function () {
        try {
            var imgList = sessionStorage.getItem("imCreateTicketKImg");
            if (imgList) {
                var imgArray_1 = JSON.parse(imgList);
                setImageFiles(function (v) {
                    if (v === void 0) { v = []; }
                    return __spreadArray(__spreadArray([], v, true), imgArray_1.map(function (i, idx) { return ({
                        url: i.src,
                        uid: "".concat(0 - idx),
                        type: "image",
                        size: 0,
                        name: "image-".concat(idx),
                    }); }), true);
                });
            }
        }
        catch (e) {
            console.error(e);
        }
    }, []);
    useEffect(function () {
        return function () {
            if (imageFiles) {
                sessionStorage.setItem("imCreateTicketKImg", JSON.stringify(imageFiles.map(function (i) { return ({
                    src: i.url,
                }); })));
            }
        };
    }, [imageFiles]);
    //多语言配置
    var t = useTranslation().t;
    // 点击上传  筛选出被选择的图片   将选择的图片 插入富文本编辑
    function handleOk() {
        // props.addImg(imgList.filter(item => item.isSelect));
        if (selectedImages) {
            props.addImg(selectedImages === null || selectedImages === void 0 ? void 0 : selectedImages.filter(function (i) { return i.url; }).map(function (i) { return ({ src: i.url, isSelect: true }); }));
        }
    }
    // 点击取消 关闭弹窗
    function handleCancel() {
        props.close();
    }
    // 删除图片
    function deleteImg(e, index) {
        e.stopPropagation();
        setImageFiles(function (v) {
            if (!v) {
                return v;
            }
            var result = __spreadArray([], v, true);
            result.splice(index, 1);
            return result;
        });
    }
    // 选择图片  显示右下角对勾
    function selectImg(imageFile) {
        setSelectedImages(function (v) {
            if (v === void 0) { v = []; }
            if (v.includes(imageFile)) {
                return v.filter(function (i) { return i !== imageFile; });
            }
            else {
                return __spreadArray(__spreadArray([], v, true), [imageFile], false);
            }
        });
    }
    var onChange = useCallback(function (fileList) {
        setImageFiles(fileList);
        setSelectedImages(fileList);
    }, []);
    // 弹窗页脚
    var footer = (React.createElement("div", { className: style["modal-btn"] },
        React.createElement(UploadBox, __assign({ className: style["upload-btn"] }, props, { value: imageFiles, marking: "web.ts.ticket_reply", onChange: onChange, noAttachment: false, showUploadList: false, accept: "image/jpeg,image/jpg,image/png" }),
            React.createElement(Button, null, t("uploader.uploadImg"))),
        React.createElement(Button, { key: "back", onClick: handleCancel }, t("cancel")),
        React.createElement(Button, { key: "submit", type: "primary", onClick: handleOk }, t("uploader.insertImg"))));
    return (React.createElement("div", null,
        React.createElement(Modal, { visible: props.show, title: t("uploader.uploadImg"), onOk: handleOk, onCancel: handleCancel, footer: footer, width: 600 },
            React.createElement("div", { className: style["modal-content"] },
                React.createElement(Row, { gutter: [16, 24] }, imageFiles === null || imageFiles === void 0 ? void 0 : imageFiles.map(function (item, index) {
                    return (React.createElement(Col, { span: 8, key: item.url },
                        React.createElement("div", { className: style["img-wrapper"], onClick: function () { return selectImg(item); } },
                            React.createElement("img", { src: item.url, alt: item.url }),
                            React.createElement("div", { className: style["delete-icon"], onClick: function (e) { return deleteImg(e, index); } },
                                React.createElement(CloseCircleFilled, null)),
                            (selectedImages === null || selectedImages === void 0 ? void 0 : selectedImages.includes(item)) && (React.createElement("div", { className: style["select-icon"] },
                                React.createElement(CheckOutlined, null))))));
                }))))));
}
export default UploadModal;
