import React, { useMemo } from 'react';
import { Progress } from 'udesk-ui';
import style from './index.module.less';
import pdf from '../images/pdf02.png';
import word from '../images/word02.png';
import excel from '../images/excel02.png';
import ppt from '../images/ppt02.png';
import txt from '../images/txt02.png';
import unknow from '../images/unknow02.png';
var UploadingType = React.memo(function (_a) {
    var msg = _a.msg;
    var _type = useMemo(function () {
        var type = '.' + msg.fileext;
        if (/\.(pdf)/.test(type)) {
            type = pdf;
        }
        else if (/\.(doc|docx|odt)/.test(type)) {
            type = word;
        }
        else if (/\.(xls|xlsx|csv)/.test(type)) {
            type = excel;
        }
        else if (/\.(ppt|pptx)/.test(type)) {
            type = ppt;
        }
        else if (/\.(txt)/.test(type)) {
            type = txt;
        }
        else {
            type = unknow;
        }
        return type;
    }, [msg.type]);
    return (React.createElement("div", { className: style['file-wrapper'] },
        React.createElement("div", null,
            React.createElement("img", { className: style['file-img'], src: _type, alt: msg.filename })),
        React.createElement("div", { className: style['file-div'] },
            React.createElement("div", { className: 'msg-content-wrapper-uploading' }, msg.filename),
            React.createElement(Progress, { percent: msg.percentage, showInfo: false, strokeWidth: 2 }))));
});
export default UploadingType;
