import React, { useCallback } from 'react';
import { DownloadOutlined } from '@ant-design/icons';
import { update_sdk_url } from '../utilities';
import { useTranslation } from 'react-i18next';
import css from './video.module.less';
var VideoType = React.memo(function (_a) {
    var msg = _a.msg;
    //多语言配置
    var t = useTranslation().t;
    var downloadVideo = useCallback(function (filePath, filename) {
        fetch(filePath)
            .then(function (res) { return res.blob(); })
            .then(function (blob) {
            var a = document.createElement('a');
            document.body.appendChild(a);
            a.style.display = 'none';
            // 使用获取到的blob对象创建的url
            var url = window.URL.createObjectURL(blob);
            a.href = url;
            // 指定下载的文件名
            a.download = filename;
            a.click();
            document.body.removeChild(a);
            // 移除blob对象的url
            window.URL.revokeObjectURL(url);
        });
    }, []);
    return (React.createElement("div", null,
        React.createElement("div", { className: css['video'] },
            React.createElement("video", { src: update_sdk_url(msg.content, msg) || msg.origin_url, style: { maxWidth: '100%' }, controls: true },
                t('page.im.log.videoAddress'),
                "\uFF1A",
                msg.content),
            React.createElement("div", { className: css['video-loading'], style: !msg.whether_transcode ? { display: 'none' } : {} },
                React.createElement("p", { className: css['loading-text'] },
                    React.createElement("span", null, t('page.im.log.transcoding'))),
                React.createElement("p", { className: css['downloads'], onClick: function () { return downloadVideo(msg.content, msg.filename); } },
                    React.createElement(DownloadOutlined, null),
                    t('page.im.log.DownloadOriginalVideo')))),
        (msg.content === '' && msg.origin_url) && React.createElement("a", { href: msg.origin_url, target: "_blank", rel: "noopener noreferrer" }, t('page.im.log.videoDownload'))));
});
export default VideoType;
