import _ConfigProvider from "antd/es/config-provider";
var _excluded = ["prefixCls"];

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }

function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState } from 'react';
import { createIntl } from 'react-intl';
import { prefixCls as defaultPrefixCls } from "../_utils/vars";
import moment from 'moment';
import { extend } from 'umi-request';
import { copyFromAntd } from "../_utils/core";
import { isAbortedError } from "../_utils/request";
import zhCN from "../locale-udesk/zh_CN";
import enUS from "../locale-udesk/en_US";
import jaJP from "../locale-udesk/ja_JP"; // 不用引入moment英文，因为英文是内置语言

import 'moment/locale/zh-cn'; // 简体中文

import 'moment/locale/zh-tw'; // 繁体中文（台湾）

import 'moment/locale/zh-hk'; // 繁体中文（香港）

import 'moment/locale/ja'; // 日语

export * from 'antd/es/config-provider';
export * from 'antd/es/config-provider/SizeContext'; // 设置antd ConfigProvider的默认值

var antdConfigProviderDefaults = {};
/**
 *  @type ReadonlyContext 的默认值
 */

var defaultContext = {
  debugMode: undefined,
  intl: undefined,
  request: undefined // 只为了声明，起到占位符的作用，具体的值在运行时会初始化

}; // 所有的属性都需要声明默认值，即使是undefined。
// 在运行时会根据KeyList过滤UdeskContextProps的字段

/**
 *  UdeskConfigProvider组件的默认值
 */

var defaultProps = {
  request: undefined,
  requestOptions: {
    requestType: 'json',
    responseType: 'json',
    headers: {
      'Content-Type': 'application/json'
    } // credentials: 'include',

  },
  requestInterceptors: [function (url, options) {
    var defaultErrorHandler = options.errorHandler;

    options.errorHandler = function (error) {
      if (isAbortedError(error) && !error.info) {
        var errorInfo = {
          // 增加一个标识，请求是否被abort了？这个在业务系统里会用到
          isAborted: true,
          message: error.message || 'Request was aborted',
          errorMessage: error.message || 'Request was aborted',
          errorCode: 0,
          data: undefined,
          ok: false,
          success: false
        }; // eslint-disable-next-line no-param-reassign

        error.info = errorInfo;
      }

      if (defaultErrorHandler) {
        defaultErrorHandler(error);
      }

      throw error;
    };

    return {
      url: url,
      options: options
    };
  }],
  responseInterceptors: [],
  requestMiddlewares: []
};
/** 默认语言 */

var defaultLocaleName = 'en-US'; //#endregion

var UdeskContext = /*#__PURE__*/React.createContext(defaultContext);
UdeskContext.displayName = 'UdeskContext';

var UdeskConfigProvider = function UdeskConfigProvider(props) {
  var _props$locale, _props$locale2;

  // 抽取 UdeskContextProps 和 ConfigProviderProps，
  // 确保传给antd组件的都是支持的属性，antd会在组件内部校验提示不识别的属性
  var udeskProps = {},
      antdProps = {};
  Object.keys(props).forEach(function (k) {
    if (Object.prototype.hasOwnProperty.call(defaultProps, k)) {
      udeskProps[k] = props[k];
    } else {
      antdProps[k] = props[k];
    }
  });
  /** 构造 UdeskContext */

  var request = udeskProps.request,
      requestOptions = udeskProps.requestOptions,
      requestInterceptors = udeskProps.requestInterceptors,
      responseInterceptors = udeskProps.responseInterceptors,
      requestMiddlewares = udeskProps.requestMiddlewares;
  var locale = antdProps.locale;

  var _useState = useState(function () {
    var _locale$locale;

    var contextValue = _objectSpread({}, defaultContext); // 创建只读字段


    contextValue.debugMode = process.env.NODE_ENV === 'development'; // 根据传入的语言，加载相应的内部资源文件

    var localeObj = {};
    var localeName = (locale === null || locale === void 0 ? void 0 : (_locale$locale = locale.locale) === null || _locale$locale === void 0 ? void 0 : _locale$locale.toLowerCase()) || defaultLocaleName;

    switch (localeName) {
      case 'cn':
      case 'zh-cn':
        localeObj = zhCN;
        break;

      case 'ja':
      case 'ja-jp':
        localeObj = jaJP;
        break;

      case 'en':
      case 'en-us':
      default:
        localeObj = enUS;
        break;
    }

    contextValue.intl = createIntl({
      locale: localeName,
      messages: expandLocales(localeObj)
    }); // 如果传入了 request 对象，则使用传入的。如果没有传入，则内部创建一个

    if (request) {
      contextValue.request = request;
    } else {
      // 组织 requestOptions
      var options = _objectSpread(_objectSpread({}, defaultProps.requestOptions), requestOptions); // 手动拷贝复杂类型的对象
      // 合并方法


      ['errorHandler', 'paramsSerializer', 'validateCache'].forEach(function (k) {
        var defaultMethod = defaultProps.requestOptions[k];
        var method = requestOptions && requestOptions[k];

        if (method || defaultMethod) {
          options[k] = function () {
            var result;

            for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
              args[_key] = arguments[_key];
            }

            if (defaultMethod) {
              result = defaultMethod.apply(defaultProps.requestOptions, args);
            }

            if (method) {
              result = method.call.apply(method, [requestOptions].concat(args, [result]));
            }

            return result;
          };
        }
      }); // 合并对象

      ['headers', 'data', 'params'].forEach(function (k) {
        options[k] = _objectSpread(_objectSpread({}, defaultProps.requestOptions[k]), requestOptions && requestOptions[k]);
      }); // 构建默认request对象

      var newRequest = extend(options); // 注册 request 拦截器

      [].concat(_toConsumableArray(requestInterceptors !== null && requestInterceptors !== void 0 ? requestInterceptors : []), _toConsumableArray(defaultProps.requestInterceptors)).forEach(function (interceptor) {
        newRequest.interceptors.request.use(interceptor, {
          global: false,
          core: false,
          defaultInstance: false
        });
      }); // 注册 response 拦截器

      [].concat(_toConsumableArray(responseInterceptors !== null && responseInterceptors !== void 0 ? responseInterceptors : []), _toConsumableArray(defaultProps.responseInterceptors)).forEach(function (interceptor) {
        newRequest.interceptors.response.use(interceptor, {
          global: false,
          core: false,
          defaultInstance: false
        });
      }); // 注册中间件

      [].concat(_toConsumableArray(requestMiddlewares !== null && requestMiddlewares !== void 0 ? requestMiddlewares : []), _toConsumableArray(defaultProps.requestMiddlewares)).forEach(function (middleware) {
        newRequest.use(middleware, {
          global: false,
          core: false,
          defaultInstance: false
        });
      });
      contextValue.request = newRequest;
    }

    return contextValue;
  }),
      _useState2 = _slicedToArray(_useState, 1),
      context = _useState2[0]; // 默认prefixCls


  var _antdProps$prefixCls = antdProps.prefixCls,
      prefixCls = _antdProps$prefixCls === void 0 ? defaultPrefixCls : _antdProps$prefixCls,
      restProps = _objectWithoutProperties(antdProps, _excluded); // 设置message、notification、Modal的class前缀。


  _ConfigProvider.config({
    prefixCls: prefixCls // 4.13.0+
    // iconPrefixCls: 'anticon', // 4.17.0+

  }); // moment 默认支持：英文、简体中文、繁体中文（台湾）、繁体中文（香港）、日文


  switch ((_props$locale = props.locale) === null || _props$locale === void 0 ? void 0 : _props$locale.locale) {
    case 'en':
    case 'en-gb':
    case undefined:
      moment.locale('en');
      break;

    default:
      moment.locale((_props$locale2 = props.locale) === null || _props$locale2 === void 0 ? void 0 : _props$locale2.locale);
      break;
  }

  return /*#__PURE__*/React.createElement(_ConfigProvider, _objectSpread(_objectSpread({
    prefixCls: prefixCls
  }, antdConfigProviderDefaults), restProps), /*#__PURE__*/React.createElement(UdeskContext.Provider, {
    value: context
  }, props.children));
}; // 设置displayName, 可以在DevTool中显示出节点名称


UdeskConfigProvider.displayName = 'UdeskConfigProvider'; // 拷贝源类型上的静态字段

UdeskConfigProvider = copyFromAntd(UdeskConfigProvider, _ConfigProvider); // 重新扩展 defaultProps

UdeskConfigProvider.defaultProps = _objectSpread(_objectSpread({}, _ConfigProvider.defaultProps), defaultProps);
export { UdeskContext };
export * from "../_utils/type"; // 扩展静态字段，添加上除了 ConfigProvider 自身类型以外的静态字段

export default UdeskConfigProvider; //#region 内部私有方法

/** 把locales对象展开成一维结构 */

function expandLocales(inputLocaleObj) {
  var parentKey = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';
  var outputMap = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  if (inputLocaleObj) {
    Object.keys(inputLocaleObj).forEach(function (k) {
      var value = inputLocaleObj[k];
      var localeKey = parentKey ? "".concat(parentKey, ".").concat(k) : k;

      if (value == null) {
        outputMap[localeKey] = '';
      } else if (_typeof(value) === 'object') {
        expandLocales(value, k, outputMap);
      } else {
        outputMap[localeKey] = value.toString();
      }
    });
  }

  return outputMap;
} //#endregion
//# sourceMappingURL=index.js.map
