import { jsx } from '@emotion/react';
import { ChangeEvent, Component, ComponentType } from 'react';
import { Column, ColumnIdType, ValueType } from "./types";
declare type Props = {
    columns: Column[];
    value?: ValueType;
    setoDefaultValue?: ValueType;
    onChange?: (value: ValueType) => void;
    onCancel?: () => void;
    leftTitle?: string | null;
    rightTitle?: string | null;
    className?: string;
    t: (string: any) => string;
    classNameOfSearchInput?: string;
    onReset?: () => void;
    allowReset?: boolean;
    allowSort?: boolean;
    allowAutoSelectNext?: boolean;
    allowSetoDefault?: boolean;
    CancelButton: ComponentType<{
        onClick: () => void;
        t: (string: any) => string;
    }>;
    ResetButton: ComponentType<{
        onClick: () => void;
        t: (string: any) => string;
    }>;
    ConfirmButton: ComponentType<{
        onClick: () => void;
        t: (string: any) => string;
    }>;
};
declare type State = {
    activeCategory: string;
    leftSelectedColumnIds: ColumnIdType[];
    rightSelectedColumnIds: ColumnIdType[];
    keyword: string;
    originValue: ValueType;
    value: ValueType;
};
declare class Control extends Component<Props, State> {
    state: State;
    static getDerivedStateFromProps(props: Props, state: State): null | State;
    _getCategories(): string[];
    _getLeftColumns(): Column[];
    _getRightColumns(): Column[];
    _getLastValue(values: any): string;
    _getNextId(type?: string): ValueType;
    _moveToRight: () => void;
    _moveToLeft: () => void;
    _up: () => void;
    _down: () => void;
    _updateKeyword: (e: ChangeEvent<HTMLInputElement>) => void;
    _onConfirmClick: () => void;
    _onCancelClick: () => void;
    _onSetoDefaultClick: () => void;
    _onResetClick: () => void;
    _onDropEnd: (list: any) => void;
    _onDndItemClick: (item: any) => void;
    render(): jsx.JSX.Element;
    static defaultProps: {
        allowReset: boolean;
        allowSort: boolean;
        allowAutoSelectNext: boolean;
        allowSetoDefault: boolean;
    };
}
export default Control;
