import { __extends } from "tslib";
import React from 'react';
import PropTypes from 'prop-types';
import ClassNames from 'classnames';
import { Input } from 'udesk-ui';
var AntdInputComponent = /** @class */ (function (_super) {
    __extends(AntdInputComponent, _super);
    function AntdInputComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleTextInputChanged = function (e) {
            var onChanged = _this.props.onChanged;
            var internalValue = e.target.value;
            onChanged(internalValue);
        };
        return _this;
    }
    AntdInputComponent.prototype.render = function () {
        var _a = this.props, disabled = _a.disabled, attributes = _a.attributes, value = _a.value;
        var classNames = attributes.classNames, placeholder = attributes.placeholder, maxLength = attributes.maxLength, _b = attributes.allowClear, allowClear = _b === void 0 ? true : _b, _c = attributes.type, type = _c === void 0 ? 'text' : _c;
        return (React.createElement(Input, { type: type, style: { width: '300px' }, className: ClassNames(classNames, 'udesk-custom-filter-antd-text-input'), placeholder: placeholder, maxLength: maxLength, allowClear: allowClear, disabled: disabled, value: value, onChange: this.handleTextInputChanged }));
    };
    return AntdInputComponent;
}(React.Component));
export default AntdInputComponent;
/**
 * @description 组件可能接收的prop
 * @namespace
 * @property {object} attributes - 配置valueSetting时传入，常用
 * @property {string} attributes.classNames - 自定义组件css类名
 * @property {string} attributes.placeholder - 自定义组件placeholder
 * @property {string} attributes.maxLength - 校验value长度，未实现 todo
 * @property {function} onChanged - value改变唯一触发事件，其他入onFocus之类可能需要在valueSetting时配置，而且是跟自定义过滤器同一上下文
 * @property {string} value - 字段value，该组件位text input,value只需考虑string,复杂选择组件需object
 *
 * @property {object} operator - condition上下文相关
 * @property {object} field - condition上下文相关
 * @property {string} name - 校验相关，错误信息提示字段名
 * @property {boolean} isValid - 校验相关 具体待补充 todo
 * @property {array} errors - 校验相关，错误信息
 * @property {object} runtimeAttributes - 运行时传入valueInput组件的属性,从custom-filter组件传入conditionValueComponentAttrs
 *
 */
AntdInputComponent.defaultProps = {
    value: null,
    onChanged: null,
    attributes: {},
    disabled: false,
    operator: {},
    field: {},
    name: null,
    isValid: true,
    errors: [],
    runtimeAttributes: {},
};
AntdInputComponent.propTypes = {
    value: PropTypes.string,
    onChanged: PropTypes.func,
    attributes: PropTypes.object,
    disabled: PropTypes.bool,
    operator: PropTypes.object,
    field: PropTypes.object,
    name: PropTypes.string,
    isValid: PropTypes.bool,
    errors: PropTypes.array,
    runtimeAttributes: PropTypes.object,
};
