import { __extends } from "tslib";
import React from 'react';
import PropTypes from 'prop-types';
import { Radio } from 'udesk-ui';
/**
 * todo: 这个组件未来会合并到udesk-ui中去，需要替换成udesk-ui中的组件
 *
 */
/**
 * @description 客服系统常见单选选项
 * {
 *      title: '选项一',
 *      value: '1'
 * }
 */
var AntdRadioComponent = /** @class */ (function (_super) {
    __extends(AntdRadioComponent, _super);
    function AntdRadioComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleRadioChange = function (e) {
            var onChanged = _this.props.onChanged;
            var internalValue = e.target.value;
            onChanged(internalValue);
        };
        return _this;
    }
    AntdRadioComponent.prototype.render = function () {
        var _a = this.props, disabled = _a.disabled, attributes = _a.attributes, dataSource = _a.dataSource, value = _a.value, dataSourceValueField = _a.dataSourceValueField, dataSourceNameField = _a.dataSourceNameField, defaultValueField = _a.defaultValueField, defaultNameField = _a.defaultNameField;
        var buttonStyle = attributes.buttonStyle, size = attributes.size;
        var valueField = defaultValueField;
        var nameField = defaultNameField;
        if (attributes[dataSourceValueField]) {
            valueField = attributes[dataSourceValueField];
        }
        if (attributes[dataSourceNameField]) {
            nameField = attributes[dataSourceNameField];
        }
        if (!Array.isArray(dataSource)) {
            dataSource = [];
        }
        var optionsRender = dataSource.map(function (option) {
            return (React.createElement(Radio, { value: option[valueField], key: option[valueField], title: option[nameField] }, option[nameField]));
        });
        return (React.createElement(Radio.Group, { onChange: this.handleRadioChange, value: value, disabled: disabled, size: size, buttonStyle: buttonStyle }, optionsRender));
    };
    return AntdRadioComponent;
}(React.Component));
export default AntdRadioComponent;
/**
 * @description 组件可能接收的prop
 * @namespace
 * @property {object} attributes - 配置fields(优先级更高)和valueSetting时传入，常用
 * @property {string} attributes.classNames - 自定义组件css类名
 * @property {string} attributes.placeholder - 自定义组件placeholder
 * @property {string} attributes.dropdownClassName - 自定义下拉菜单的 className 属性
 * @property {boolean} attributes.allowClear - 单选支持清除
 * @property {function} onChanged - value改变唯一触发事件，其他入onFocus之类可能需要在valueSetting时配置，而且是跟自定义过滤器同一上下文
 * @property {string} value - 字段value，该组件位text input,value只需考虑string,复杂选择组件需object
 *
 * @property {object} operator - condition上下文相关
 * @property {object} field - condition上下文相关
 * @property {string} name - 校验相关，错误信息提示字段名
 * @property {boolean} isValid - 校验相关 具体待补充 todo
 * @property {array} errors - 校验相关，错误信息
 * @property {object} runtimeAttributes - 运行时传入valueInput组件的属性,从custom-filter组件传入conditionValueComponentAttrs
 *
 */
AntdRadioComponent.defaultProps = Object.assign({
    value: null,
    onChanged: null,
    attributes: {},
    dataSource: [],
    disabled: false,
    operator: {},
    field: {},
    name: null,
    isValid: true,
    errors: [],
    runtimeAttributes: {},
}, {
    dataSourceValueField: 'valueField',
    dataSourceNameField: 'nameField',
    dataSourceSearchField: 'searchField',
    defaultValueField: 'id',
    defaultNameField: 'text',
    defaultSearchField: 'text',
    defaultOutputValueMode: 'value', //'value'|'object'
});
AntdRadioComponent.propTypes = {
    value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    onChanged: PropTypes.func,
    attributes: PropTypes.object,
    dataSource: PropTypes.array,
    disabled: PropTypes.bool,
    operator: PropTypes.object,
    field: PropTypes.object,
    name: PropTypes.string,
    isValid: PropTypes.bool,
    errors: PropTypes.array,
    runtimeAttributes: PropTypes.object,
    dataSourceValueField: PropTypes.string,
    dataSourceNameField: PropTypes.string,
    dataSourceSearchField: PropTypes.string,
    defaultValueField: PropTypes.string,
    defaultNameField: PropTypes.string,
    defaultSearchField: PropTypes.string,
    defaultOutputValueMode: PropTypes.string,
};
