export declare const getEditorJsTools: (methodObj: any) => {
    header: {
        class: any;
        config: {
            placeholder: string;
            levels: number[];
            defaultLevel: number;
        };
        inlineToolbar: string[];
    };
    embed: {
        class: any;
        inlineToolbar: boolean;
    };
    list: {
        class: any;
        inlineToolbar: boolean;
        selected: boolean;
    };
    checklist: {
        class: any;
        inlineToolbar: boolean;
    };
    paragraph: {
        class: any;
        inlineToolbar: boolean;
    };
    quote: {
        class: any;
        inlineToolbar: boolean;
        config: {
            quotePlaceholder: string;
            captionPlaceholder: string;
        };
    };
    linkTool: {
        class: any;
        inlineToolbar: boolean;
        config: {
            endpoint: string;
            headers: string;
        };
    };
    delimiter: any;
};
export declare const EDITOR_JS_TOOLS: {
    header: {
        class: any;
        config: {
            placeholder: string;
            levels: number[];
            defaultLevel: number;
        };
        inlineToolbar: string[];
    };
    embed: {
        class: any;
        inlineToolbar: boolean;
    };
    list: {
        class: any;
        inlineToolbar: boolean;
        selected: boolean;
    };
    checklist: {
        class: any;
        inlineToolbar: boolean;
    };
    paragraph: {
        class: any;
        inlineToolbar: boolean;
    };
    quote: {
        class: any;
        inlineToolbar: boolean;
        config: {
            quotePlaceholder: string;
            captionPlaceholder: string;
        };
    };
    linkTool: {
        class: any;
        inlineToolbar: boolean;
        config: {
            endpoint: string;
            headers: string;
        };
    };
    image: {
        class: any;
        config: {
            endpoints: {
                byFile: string;
                byUrl: string;
            };
            uploader: {
                /**
                 * Upload file to the server and return an uploaded image data
                 * @param {File} file - file selected from the device or pasted by drag-n-drop
                 * @return {Promise.<{success, file: {url}}>}
                 */
                uploadByFile(file: any): {
                    success: number;
                    file: {
                        url: string;
                    };
                };
                /**
                 * Send URL-string to the server. Backend should load image by this URL and return an uploaded image data
                 * @param {string} url - pasted image URL
                 * @return {Promise.<{success, file: {url}}>}
                 */
                uploadByUrl(url: string): {
                    success: number;
                    file: {
                        url: string;
                    };
                };
            };
            actions: {
                name: string;
                icon: string;
                title: string;
                action: (names: any) => boolean;
            }[];
        };
    };
    video: {
        class: any;
        config: {
            /**
             * Custom uploader
             *
             */
            endpoints: {
                byFile: string;
                byUrl: string;
            };
            player: {
                pip: boolean;
                controls: boolean;
                light: boolean;
                playing: boolean;
            };
            uploader: {
                /**
                 * Upload file to the server and return an uploaded video data
                 * @param {File} file - file selected from the device or pasted by drag-n-drop
                 * @return {Promise.<{success, file: {url}}>}
                 */
                uploadByFile(file: any): {
                    success: number;
                    file: {
                        url: string;
                    };
                };
                /**
                 * Send URL-string to the server. Backend should load video by this URL and return an uploaded video data
                 * @param {string} url - pasted video URL
                 * @return {Promise.<{success, file: {url}}>}
                 */
                uploadByUrl(url: any): {
                    success: number;
                    file: {
                        url: string;
                    };
                };
            };
        };
    };
    delimiter: any;
};
