import { __assign } from "tslib";
import each from 'lodash-es/each';
function getEmojiPositions() {
    var arr = [];
    for (var i = 1; i <= 28; i++) {
        arr.push('-' + (i - 1) * 30 + 'px 0px');
    }
    for (var i = 1; i <= 28; i++) {
        arr.push('-' + (i - 1) * 30 + 'px -30px');
    }
    return arr;
}
var getWechatData = function () {
    var arr = [
        { text: '微笑', index: 0, code: '/::)', regcode: '/::\\)', regtext: '\\[微笑\\]', twemoji: '😀' },
        { text: '伤心', index: 1, code: '/::~', regcode: '/::~', regtext: '\\[伤心\\]', twemoji: '😐' },
        { text: '美女', index: 2, code: '/::B', regcode: '/::B', regtext: '\\[美女\\]', twemoji: '😍' },
        { text: '发呆', index: 3, code: '/::|', regcode: '/::\\|', regtext: '\\[发呆\\]', twemoji: '😳' },
        { text: '墨镜', index: 4, code: '/:8-)', regcode: '/:8\\-\\)', regtext: '\\[墨镜\\]', twemoji: '😎' },
        { text: '哭泣', index: 5, code: '/::<', regcode: '/::<', regtext: '\\[哭泣\\]', twemoji: '😭' },
        { text: '羞', index: 6, code: '/::$', regcode: '/::\\$', regtext: '\\[羞\\]', twemoji: '😊' },
        { text: '哑', index: 7, code: '/::X', regcode: '/::X', regtext: '\\[哑\\]', twemoji: '🤐' },
        { text: '睡', index: 8, code: '/::Z', regcode: '/::Z', regtext: '\\[睡\\]', twemoji: '😴' },
        { text: '大哭', index: 9, code: '/::\'(', regcode: '/::\'\\(', regtext: '\\[大哭\\]', twemoji: '😂' },
        { text: '尴尬', index: 10, code: '/::-|', regcode: '/::\\-\\|', regtext: '\\[尴尬\\]', twemoji: '🙃' },
        { text: '怒', index: 11, code: '/::@', regcode: '/::@', regtext: '\\[怒\\]', twemoji: '😡' },
        { text: '调皮', index: 12, code: '/::P', regcode: '/::P', regtext: '\\[调皮\\]', twemoji: '😜' },
        { text: '笑', index: 13, code: '/::D', regcode: '/::D', regtext: '\\[笑\\]', twemoji: '😃' },
        { text: '惊讶', index: 14, code: '/::O', regcode: '/::O', regtext: '\\[惊讶\\]', twemoji: '😯' },
        { text: '难过', index: 15, code: '/::(', regcode: '/::\\(', regtext: '\\[难过\\]', twemoji: '😢' },
        { text: '酷', index: 16, code: '/:: ', regcode: '/:: ', regtext: '\\[酷\\]', twemoji: '🆒' },
        { text: '囧', index: 17, code: '/:--b', regcode: '/:--b', regtext: '\\[囧\\]', twemoji: '😌' },
        { text: '抓狂', index: 18, code: '/::Q', regcode: '/::Q', regtext: '\\[抓狂\\]', twemoji: '😱' },
        { text: '吐', index: 19, code: '/::T', regcode: '/::T', regtext: '\\[吐\\]', twemoji: '🥴' },
        { text: '偷笑', index: 20, code: '/:,@P', regcode: '/:,@P', regtext: '\\[偷笑\\]', twemoji: '🤭' },
        { text: '快乐', index: 21, code: '/:,@-D', regcode: '/:,@\\-D', regtext: '\\[快乐\\]', twemoji: '🤗' },
        { text: '白眼', index: 22, code: '/::d', regcode: '/::d', regtext: '\\[白眼\\]', twemoji: '🙄' },
        { text: '撇嘴', index: 23, code: '/:,@o', regcode: '/:,@o', regtext: '\\[撇嘴\\]', twemoji: '😒' },
        { text: '饿', index: 24, code: '/::g', regcode: '/::g', regtext: '\\[饿\\]', twemoji: '😑' },
        { text: '困', index: 25, code: '/:|-)', regcode: '/:\\|\\-\\)', regtext: '\\[困\\]', twemoji: '🥱' },
        { text: '惊吓', index: 26, code: '/::!', regcode: '/::!', regtext: '\\[惊吓\\]', twemoji: '😲' },
        { text: '流汗', index: 27, code: '/::L', regcode: '/::L', regtext: '\\[流汗\\]', twemoji: '🥵' },
        { text: '大笑', index: 28, code: '/::>', regcode: '/::>', regtext: '\\[大笑\\]', twemoji: '😆' },
        { text: '抽烟', index: 29, code: '/::,@', regcode: '/::,@', regtext: '\\[抽烟\\]', twemoji: '🤓' },
        { text: '奋斗', index: 30, code: '/:,@f', regcode: '/:,@f', regtext: '\\[奋斗\\]', twemoji: '👨‍🚒' },
        { text: '咒骂', index: 31, code: '/::-S', regcode: '/::\\-S', regtext: '\\[咒骂\\]', twemoji: '🤬' },
        { text: '疑问', index: 32, code: '/:?', regcode: '/:\\?', regtext: '\\[疑问\\]', twemoji: '🤷' },
        { text: '秘密', index: 33, code: '/:,@x', regcode: '/:,@x', regtext: '\\[秘密\\]', twemoji: '🧐' },
        { text: '晕', index: 34, code: '/:,@@', regcode: '/:,@@', regtext: '\\[晕\\]', twemoji: '😇' },
        { text: '发疯', index: 35, code: '/::8', regcode: '/::8', regtext: '\\[发疯\\]', twemoji: '👿' },
        { text: '衰', index: 36, code: '/:,@!', regcode: '/:,@!', regtext: '\\[衰\\]', twemoji: '👻' },
        { text: '骷髅', index: 37, code: '/:!!!', regcode: '/:!!!', regtext: '\\[骷髅\\]', twemoji: '💀' },
        { text: '敲打', index: 38, code: '/:xx', regcode: '/:xx', regtext: '\\[敲打\\]', twemoji: '🔨' },
        { text: '再见', index: 39, code: '/:bye', regcode: '/:bye', regtext: '\\[再见\\]', twemoji: '🤚' },
        { text: '汗', index: 40, code: '/:wipe', regcode: '/:wipe', regtext: '\\[汗\\]', twemoji: '😓' },
        { text: '抠鼻', index: 41, code: '/:dig', regcode: '/:dig', regtext: '\\[抠鼻\\]', twemoji: '😿' },
        { text: '鼓掌', index: 42, code: '/:handclap', regcode: '/:handclap', regtext: '\\[鼓掌\\]', twemoji: '👏' },
        { text: '糗', index: 43, code: '/:&-(', regcode: '/:&\\-\\(', regtext: '\\[糗\\]', twemoji: '🤡' },
        { text: '坏笑', index: 44, code: '/:B-)', regcode: '/:B\\-\\)', regtext: '\\[坏笑\\]', twemoji: '😉' },
        { text: '左哼哼', index: 45, code: '/:<@', regcode: '/:<@', regtext: '\\[左哼哼\\]', twemoji: '😚' },
        { text: '右哼哼', index: 46, code: '/:@>', regcode: '/:@>', regtext: '\\[右哼哼\\]', twemoji: '😙' },
        { text: '哈欠', index: 47, code: '/::-O', regcode: '/::\\-O', regtext: '\\[哈欠\\]', twemoji: '😴' },
        { text: '鄙视', index: 48, code: '/:>-|', regcode: '/:>\\-\\|', regtext: '\\[鄙视\\]', twemoji: '🖕' },
        { text: '委屈', index: 49, code: '/:P-(', regcode: '/:P\\-\\(', regtext: '\\[委屈\\]', twemoji: '🙁' },
        { text: '难过', index: 50, code: '/::\'|', regcode: '/::\'\\|', regtext: '\\[难过\\]', twemoji: '💔' },
        { text: '奸笑', index: 51, code: '/:X-)', regcode: '/:X\\-\\)', regtext: '\\[奸笑\\]', twemoji: '😏' },
        { text: '亲亲', index: 52, code: '/::*', regcode: '/::\\*', regtext: '\\[亲亲\\]', twemoji: '😘' },
        { text: '吓', index: 53, code: '/:@x', regcode: '/:@x', regtext: '\\[吓\\]', twemoji: '😫' },
        { text: '可怜', index: 54, code: '/:8*', regcode: '/:8\\*', regtext: '\\[可怜\\]', twemoji: '🤥' },
        { text: '菜刀', index: 55, code: '/:pd', regcode: '/:pd', regtext: '\\[菜刀\\]', twemoji: '🔪' },
        { text: '西瓜', index: 56, code: '/:<W>', regcode: '/:<W>', regtext: '\\[西瓜\\]', twemoji: '🍉' },
        { text: '啤酒', index: 57, code: '/:beer', regcode: '/:beer', regtext: '\\[啤酒\\]', twemoji: '🍺' },
        { text: '篮球', index: 58, code: '/:basketb', regcode: '/:basketb', regtext: '\\[篮球\\]', twemoji: '🏀' },
        { text: '乒乓', index: 59, code: '/:oo', regcode: '/:oo', regtext: '\\[乒乓\\]', twemoji: '🏓' },
        { text: '咖啡', index: 60, code: '/:coffee', regcode: '/:coffee', regtext: '\\[咖啡\\]', twemoji: '☕' },
        { text: '饭', index: 61, code: '/:eat', regcode: '/:eat', regtext: '\\[饭\\]', twemoji: '🥘' },
        { text: '猪头', index: 62, code: '/:pig', regcode: '/:pig', regtext: '\\[猪头\\]', twemoji: '🐷' },
        { text: '鲜花', index: 63, code: '/:rose', regcode: '/:rose', regtext: '\\[鲜花\\]', twemoji: '🌹' },
        { text: '枯萎', index: 64, code: '/:fade', regcode: '/:fade', regtext: '\\[枯萎\\]', twemoji: '🥀' },
        { text: '红唇', index: 65, code: '/:showlove', regcode: '/:showlove', regtext: '\\[红唇\\]', twemoji: '👄' },
        { text: '爱心', index: 66, code: '/:heart', regcode: '/:heart', regtext: '\\[爱心\\]', twemoji: '❤️' },
        { text: '心碎', index: 67, code: '/:break', regcode: '/:break', regtext: '\\[心碎\\]', twemoji: '💔' },
        { text: '蛋糕', index: 68, code: '/:cake', regcode: '/:cake', regtext: '\\[蛋糕\\]', twemoji: '🍰' },
        { text: '闪电', index: 69, code: '/:li', regcode: '/:li', regtext: '\\[闪电\\]', twemoji: '⚡' },
        { text: '炸弹', index: 70, code: '/:bome', regcode: '/:bome', regtext: '\\[炸弹\\]', twemoji: '💣' },
        { text: '刀', index: 71, code: '/:kn', regcode: '/:kn', regtext: '\\[刀\\]', twemoji: '🗡️' },
        { text: '足球', index: 72, code: '/:footb', regcode: '/:footb', regtext: '\\[足球\\]', twemoji: '⚽' },
        { text: '瓢虫', index: 73, code: '/:ladybug', regcode: '/:ladybug', regtext: '\\[瓢虫\\]', twemoji: '🐞' },
        { text: '便便', index: 74, code: '/:shit', regcode: '/:shit', regtext: '\\[便便\\]', twemoji: '💩' },
        { text: '晚安', index: 75, code: '/:moon', regcode: '/:moon', regtext: '\\[晚安\\]', twemoji: '🌛' },
        { text: '太阳', index: 76, code: '/:sun', regcode: '/:sun', regtext: '\\[太阳\\]', twemoji: '🌞' },
        { text: '礼物', index: 77, code: '/:gift', regcode: '/:gift', regtext: '\\[礼物\\]', twemoji: '🎁' },
        { text: '抱抱', index: 78, code: '/:hug', regcode: '/:hug', regtext: '\\[抱抱\\]', twemoji: '💞' },
        { text: '赞', index: 79, code: '/:strong', regcode: '/:strong', regtext: '\\[赞\\]', twemoji: '👍' },
        { text: '差劲', index: 80, code: '/:weak', regcode: '/:weak', regtext: '\\[差劲\\]', twemoji: '👎' },
        { text: '握手', index: 81, code: '/:share', regcode: '/:share', regtext: '\\[握手\\]', twemoji: '🤝' },
        { text: 'yeah', index: 82, code: '/:v', regcode: '/:v', regtext: '\\[yeah\\]', twemoji: '✌️' },
        { text: '抱拳', index: 83, code: '/:@)', regcode: '/:@\\)', regtext: '\\[抱拳\\]', twemoji: '🙏' },
        { text: '勾引', index: 84, code: '/:jj', regcode: '/:jj', regtext: '\\[勾引\\]', twemoji: '💗' },
        { text: '力量', index: 85, code: '/:@@', regcode: '/:@@', regtext: '\\[力量\\]', twemoji: '👊' },
        { text: '坏', index: 86, code: '/:bad', regcode: '/:bad', regtext: '\\[坏\\]', twemoji: '👇' },
        { text: '爱你', index: 87, code: '/:lvu', regcode: '/:lvu', regtext: '\\[爱你\\]', twemoji: '💕' },
        { text: 'NO', index: 88, code: '/:no', regcode: '/:no', regtext: '\\[NO\\]', twemoji: '🙅‍♂️' },
        { text: 'OK', index: 89, code: '/:ok', regcode: '/:ok', regtext: '\\[OK\\]', twemoji: '👌' },
        { text: '爱', index: 90, code: '/:love', regcode: '/:love', regtext: '\\[爱\\]', twemoji: '🥰' },
        { text: '亲吻', index: 91, code: '/:<L>', regcode: '/:<L>', regtext: '\\[亲吻\\]', twemoji: '👩‍❤️‍💋‍👨' },
        { text: '跳舞', index: 92, code: '/:jump', regcode: '/:jump', regtext: '\\[跳舞\\]', twemoji: '💃' },
        { text: '害怕', index: 93, code: '/:shake', regcode: '/:shake', regtext: '\\[害怕\\]', twemoji: '😱' },
        { text: '尖叫', index: 94, code: '/:<O>', regcode: '/:<O>', regtext: '\\[尖叫\\]', twemoji: '🙀' },
        { text: '圈', index: 95, code: '/:circle', regcode: '/:circle', regtext: '\\[圈\\]', twemoji: '👯‍♂️' },
        { text: '拜', index: 96, code: '/:kotow', regcode: '/:kotow', regtext: '\\[拜\\]', twemoji: '🕺' },
        { text: '回头', index: 97, code: '/:turn', regcode: '/:turn', regtext: '\\[回头\\]', twemoji: '😼' },
        { text: '跳', index: 98, code: '/:skip', regcode: '/:skip', regtext: '\\[跳\\]', twemoji: '🤸' },
        { text: '挥手', index: 99, code: '/:oY', regcode: '/:o\\Y', regtext: '\\[挥手\\]', twemoji: '🙉' },
        { text: '激动', index: 100, code: '/:#-0', regcode: '/:#\\-0', regtext: '\\[激动\\]', twemoji: '🤪' },
        // {text: "街舞", clz: "wechat-emoji101", code: "[街舞]", regcode: "[街舞]" },
        // {text: '街舞', index: 101, code: '/:hiphot', regcode: '/:hiphot', regtext: '\\[街舞\\]' },
        { text: '吻', index: 102, code: '/:kiss', regcode: '/:kiss', regtext: '\\[吻\\]', twemoji: '😚' },
        // {text: '旋转', index: 103, code: '/:<&', regcode: '/:<&', regtext: '\\[旋转\\]' },
        { text: '太极', index: 104, code: '/:&>', regcode: '/:&>', regtext: '\\[太极\\]', twemoji: '👩‍🎤' },
        { text: '笑脸', index: 105, code: '[Happy]', regcode: '\\[Happy\\]', regtext: '\\[Happy\\]', twemoji: '👩‍🎤' },
        { text: '脸红', index: 106, code: '[Flushed]', regcode: '\\[Flushed\\]', regtext: '\\[Flushed\\]', twemoji: '👩‍🎤' },
        { text: '生病', index: 107, code: '[Sick]', regcode: '\\[Sick\\]', regtext: '\\[Sick\\]', twemoji: '👩‍🎤' },
        { text: '破涕为笑', index: 108, code: '[Lol]', regcode: '\\[Lol\\]', regtext: '\\[Lol\\]', twemoji: '👩‍🎤' },
        { text: '恐惧', index: 109, code: '[Terror]', regcode: '\\[Terror\\]', regtext: '\\[Terror\\]', twemoji: '👩‍🎤' },
        { text: '失望', index: 110, code: '[LetDown]', regcode: '\\[LetDown\\]', regtext: '\\[LetDown\\]', twemoji: '👩‍🎤' },
        { text: '无语', index: 111, code: '[Duh]', regcode: '\\[Duh\\]', regtext: '\\[Duh\\]', twemoji: '👩‍🎤' },
        { text: '嘿哈', index: 112, code: '[Hey]', regcode: '\\[Hey\\]', regtext: '\\[Hey\\]', twemoji: '👩‍🎤' },
        { text: '捂脸', index: 113, code: '[Facepalm]', regcode: '\\[Facepalm\\]', regtext: '\\[Facepalm\\]', twemoji: '👩‍🎤' },
        { text: '奸笑', index: 114, code: '[Smirk]', regcode: '\\[Smirk\\]', regtext: '\\[Smirk\\]', twemoji: '👩‍🎤' },
        { text: '机智', index: 115, code: '[Smart]', regcode: '\\[Smart\\]', regtext: '\\[Smart\\]', twemoji: '👩‍🎤' },
        { text: '皱眉', index: 116, code: '[Concerned]', regcode: '\\[Concerned\\]', regtext: '\\[Concerned\\]', twemoji: '👩‍🎤' },
        { text: '耶', index: 117, code: '[Yeah!]', regcode: '\\[Yeah!\\]', regtext: '\\[Yeah!\\]', twemoji: '👩‍🎤' },
        { text: '吃瓜', index: 118, code: '[Onlooker]', regcode: '\\[Onlooker\\]', regtext: '\\[Onlooker\\]', twemoji: '👩‍🎤' },
        { text: '加油', index: 119, code: '[GoForIt]', regcode: '\\[GoForIt\\]', regtext: '\\[GoForIt\\]', twemoji: '👩‍🎤' },
        { text: '汗', index: 120, code: '[Sweats]', regcode: '\\[Sweats\\]', regtext: '\\[Sweats\\]', twemoji: '👩‍🎤' },
        { text: '天啊', index: 121, code: '[OMG]', regcode: '\\[OMG\\]', regtext: '\\[OMG\\]', twemoji: '👩‍🎤' },
        { text: 'Emm', index: 122, code: '[Emm]', regcode: '\\[Emm\\]', regtext: '\\[Emm\\]', twemoji: '👩‍🎤' },
        { text: '社会社会', index: 123, code: '[Respect]', regcode: '\\[Respect\\]', regtext: '\\[Respect\\]', twemoji: '👩‍🎤' },
        { text: '旺柴', index: 124, code: '[Doge]', regcode: '\\[Doge\\]', regtext: '\\[Doge\\]', twemoji: '👩‍🎤' },
        { text: '好的', index: 125, code: '[NoProb]', regcode: '\\[NoProb\\]', regtext: '\\[NoProb\\]', twemoji: '👩‍🎤' },
        { text: '打脸', index: 126, code: '[MyBad]', regcode: '\\[MyBad\\]', regtext: '\\[MyBad\\]', twemoji: '👩‍🎤' },
        { text: '哇', index: 127, code: '[Wow]', regcode: '\\[Wow\\]', regtext: '\\[Wow\\]', twemoji: '👩‍🎤' },
        { text: '翻白眼', index: 128, code: '[Boring]', regcode: '\\[Boring\\]', regtext: '\\[Boring\\]', twemoji: '👩‍🎤' },
        { text: '666', index: 129, code: '[Awesome]', regcode: '\\[Awesome\\]', regtext: '\\[Awesome\\]', twemoji: '👩‍🎤' },
        { text: '让我看看', index: 130, code: '[LetMeSee]', regcode: '\\[LetMeSee\\]', regtext: '\\[LetMeSee\\]', twemoji: '👩‍🎤' },
        { text: '叹气', index: 131, code: '[Sigh]', regcode: '\\[Sigh\\]', regtext: '\\[Sigh\\]', twemoji: '👩‍🎤' },
        { text: '苦涩', index: 132, code: '[Hurt]', regcode: '\\[Hurt\\]', regtext: '\\[Hurt\\]', twemoji: '👩‍🎤' },
        { text: '裂开', index: 133, code: '[Broken]', regcode: '\\[Broken\\]', regtext: '\\[Broken\\]', twemoji: '👩‍🎤' },
        { text: '庆祝', index: 134, code: '[Party]', regcode: '\\[Party\\]', regtext: '\\[Party\\]', twemoji: '👩‍🎤' },
        { text: '红包', index: 135, code: '[Packet]', regcode: '\\[Packet\\]', regtext: '\\[Packet\\]', twemoji: '👩‍🎤' },
        { text: '发', index: 136, code: '[Rich]', regcode: '\\[Rich\\]', regtext: '\\[Rich\\]', twemoji: '👩‍🎤' },
        { text: '福', index: 137, code: '[Blessing]', regcode: '\\[Blessing\\]', regtext: '\\[Blessing\\]', twemoji: '👩‍🎤' },
        { text: '烟花', index: 138, code: '[Fireworks]', regcode: '\\[Fireworks\\]', regtext: '\\[Fireworks\\]', twemoji: '👩‍🎤' },
        { text: '爆竹', index: 139, code: '[爆竹]', regcode: '\\[爆竹\\]', regtext: '\\[爆竹\\]', twemoji: '👩‍🎤' },
        { text: '合十', index: 140, code: '[Worship]', regcode: '\\[Worship\\]', regtext: '\\[Worship\\]', twemoji: '👩‍🎤' },
    ];
    each(arr, function (item) {
        var idx = item.index;
        item.clz = 'wechat-emoji' + idx;
        item.position = '-' + (idx % 15) * 29 + 'px -' + Math.floor(idx / 15) * 29 + 'px';
    });
    return arr;
};
var qywxEmojiData = [
    { text: '微笑', index: 0, regtext: '\\[微笑\\]' },
    { text: '撇嘴', index: 1, regtext: '\\[撇嘴\\]' },
    { text: '色', index: 2, regtext: '\\[色\\]' },
    { text: '发呆', index: 3, regtext: '\\[发呆\\]' },
    { text: '得意', index: 4, regtext: '\\[得意\\]' },
    { text: '流泪', index: 5, regtext: '\\[流泪\\]' },
    { text: '害羞', index: 6, regtext: '\\[害羞\\]' },
    { text: '闭嘴', index: 7, regtext: '\\[闭嘴\\]' },
    { text: '睡', index: 8, regtext: '\\[睡\\]' },
    { text: '大哭', index: 9, regtext: '\\[大哭\\]' },
    { text: '尴尬', index: 10, regtext: '\\[尴尬\\]' },
    { text: '发怒', index: 11, regtext: '\\[发怒\\]' },
    { text: '调皮', index: 12, regtext: '\\[调皮\\]' },
    { text: '呲牙', index: 13, regtext: '\\[呲牙\\]' },
    { text: '惊讶', index: 14, regtext: '\\[惊讶\\]' },
    { text: '难过', index: 15, regtext: '\\[难过\\]' },
    { text: '酷', index: 16, regtext: '\\[酷\\]' },
    { text: '囧', index: 17, regtext: '\\[囧\\]' },
    { text: '抓狂', index: 18, regtext: '\\[抓狂\\]' },
    { text: '吐', index: 19, regtext: '\\[吐\\]' },
    { text: '偷笑', index: 20, regtext: '\\[偷笑\\]' },
    { text: '可爱', index: 21, regtext: '\\[可爱\\]' },
    { text: '白眼', index: 22, regtext: '\\[白眼\\]' },
    { text: '傲慢', index: 23, regtext: '\\[傲慢\\]' },
    { text: '困', index: 25, regtext: '\\[困\\]' },
    { text: '惊恐', index: 26, regtext: '\\[惊恐\\]' },
    { text: '憨笑', index: 28, regtext: '\\[憨笑\\]' },
    { text: '大兵', index: 29, regtext: '\\[大兵\\]' },
    { text: '咒骂', index: 31, regtext: '\\[咒骂\\]' },
    { text: '疑问', index: 32, regtext: '\\[疑问\\]' },
    { text: '嘘', index: 33, regtext: '\\[嘘\\]' },
    { text: '晕', index: 34, regtext: '\\[晕\\]' },
    { text: '衰', index: 36, regtext: '\\[衰\\]' },
    { text: '骷髅', index: 37, regtext: '\\[骷髅\\]' },
    { text: '敲打', index: 38, regtext: '\\[敲打\\]' },
    { text: '再见', index: 39, regtext: '\\[再见\\]' },
    { text: '擦汗', index: 40, regtext: '\\[擦汗\\]' },
    { text: '抠鼻', index: 41, regtext: '\\[抠鼻\\]' },
    { text: '鼓掌', index: 42, regtext: '\\[鼓掌\\]' },
    { text: '坏笑', index: 44, regtext: '\\[坏笑\\]' },
    { text: '右哼哼', index: 46, regtext: '\\[右哼哼\\]' },
    { text: '鄙视', index: 48, regtext: '\\[鄙视\\]' },
    { text: '委屈', index: 49, regtext: '\\[委屈\\]' },
    { text: '快哭了', index: 50, regtext: '\\[快哭了\\]' },
    { text: '阴险', index: 51, regtext: '\\[阴险\\]' },
    { text: '亲亲', index: 52, regtext: '\\[亲亲\\]' },
    { text: '可怜', index: 54, regtext: '\\[可怜\\]' },
    { text: '笑脸', index: 105, regtext: '\\[笑脸\\]' },
    { text: '脸红', index: 106, regtext: '\\[脸红\\]' },
    { text: '生病', index: 107, regtext: '\\[生病\\]' },
    { text: '破涕为笑', index: 108, regtext: '\\[破涕为笑\\]' },
    { text: '恐惧', index: 109, regtext: '\\[恐惧\\]' },
    { text: '失望', index: 110, regtext: '\\[失望\\]' },
    { text: '无语', index: 111, regtext: '\\[无语\\]' },
    { text: '嘿哈', index: 112, regtext: '\\[嘿哈\\]' },
    { text: '捂脸', index: 113, regtext: '\\[捂脸\\]' },
    { text: '奸笑', index: 114, regtext: '\\[奸笑\\]' },
    { text: '机智', index: 115, regtext: '\\[机智\\]' },
    { text: '皱眉', index: 116, regtext: '\\[皱眉\\]' },
    { text: '耶', index: 117, regtext: '\\[耶\\]' },
    { text: '吃瓜', index: 118, regtext: '\\[吃瓜\\]' },
    { text: '加油', index: 119, regtext: '\\[加油\\]' },
    { text: '汗', index: 120, regtext: '\\[汗\\]' },
    { text: '天啊', index: 121, regtext: '\\[天啊\\]' },
    { text: 'Emm', index: 122, regtext: '\\[Emm\\]' },
    { text: '社会社会', index: 123, regtext: '\\[社会社会\\]' },
    { text: '旺柴', index: 124, regtext: '\\[旺柴\\]' },
    { text: '好的', index: 125, regtext: '\\[好的\\]' },
    { text: '打脸', index: 126, regtext: '\\[打脸\\]' },
    { text: '哇', index: 127, regtext: '\\[哇\\]' },
    { text: '翻白眼', index: 128, regtext: '\\[翻白眼\\]' },
    { text: '666', index: 129, regtext: '\\[666\\]' },
    { text: '让我看看', index: 130, regtext: '\\[让我看看\\]' },
    { text: '叹气', index: 131, regtext: '\\[叹气\\]' },
    { text: '苦涩', index: 132, regtext: '\\[苦涩\\]' },
    { text: '裂开', index: 133, regtext: '\\[裂开\\]' },
    { text: '嘴唇', index: 65, regtext: '\\[嘴唇\\]' },
    { text: '爱心', index: 66, regtext: '\\[爱心\\]' },
    { text: '心碎', index: 67, regtext: '\\[心碎\\]' },
    { text: '拥抱', index: 78, regtext: '\\[拥抱\\]' },
    { text: '强', index: 79, regtext: '\\[强\\]' },
    { text: '弱', index: 80, regtext: '\\[弱\\]' },
    { text: '握手', index: 81, regtext: '\\[握手\\]' },
    { text: '胜利', index: 82, regtext: '\\[胜利\\]' },
    { text: '抱拳', index: 83, regtext: '\\[抱拳\\]' },
    { text: '勾引', index: 84, regtext: '\\[勾引\\]' },
    { text: '拳头', index: 85, regtext: '\\[拳头\\]' },
    { text: 'OK', index: 89, regtext: '\\[OK\\]' },
    { text: '合十', index: 140, regtext: '\\[合十\\]' },
    { text: '啤酒', index: 57, regtext: '\\[啤酒\\]' },
    { text: '咖啡', index: 60, regtext: '\\[咖啡\\]' },
    { text: '蛋糕', index: 68, regtext: '\\[蛋糕\\]' },
    { text: '玫瑰', index: 63, regtext: '\\[玫瑰\\]' },
    { text: '凋谢', index: 64, regtext: '\\[凋谢\\]' },
    { text: '菜刀', index: 55, regtext: '\\[菜刀\\]' },
    { text: '炸弹', index: 70, regtext: '\\[炸弹\\]' },
    { text: '便便', index: 74, regtext: '\\[便便\\]' },
    { text: '月亮', index: 75, regtext: '\\[月亮\\]' },
    { text: '太阳', index: 76, regtext: '\\[太阳\\]' },
    { text: '庆祝', index: 134, regtext: '\\[庆祝\\]' },
    { text: '礼物', index: 77, regtext: '\\[礼物\\]' },
    { text: '红包', index: 135, regtext: '\\[红包\\]' },
    { text: '发', index: 136, regtext: '\\[發\\]' },
    { text: '福', index: 137, regtext: '\\[福\\]' },
    { text: '烟花', index: 138, regtext: '\\[烟花\\]' },
    { text: '爆竹', index: 139, regtext: '\\[爆竹\\]' },
    { text: '猪头', index: 62, regtext: '\\[猪头\\]' },
    { text: '跳跳', index: 92, regtext: '\\[跳跳\\]' },
    { text: '发抖', index: 93, regtext: '\\[发抖\\]' },
    { text: '转圈', index: 95, regtext: '\\[转圈\\]' },
];
var getQywxData = function () {
    var qywxEmojiDataArr = qywxEmojiData.map(function (item) {
        var idx = item.index;
        item.clz = 'wechat-emoji' + idx;
        item.position = '-' + (idx % 15) * 29 + 'px -' + Math.floor(idx / 15) * 29 + 'px';
        return item;
    });
    return qywxEmojiDataArr;
};
var getWeixin_kfData = function () {
    var WeixinKf = [
        { text: '冷汗', index: 17, regtext: '\\[冷汗\\]' },
        { text: '愉快', index: 21, regtext: '\\[愉快\\]' },
        { text: '悠闲', index: 29, regtext: '\\[悠闲\\]' }, // 悠闲
    ];
    var WeixinKfDataArr = qywxEmojiData.map(function (item) {
        var idx = item.index;
        item.clz = 'wechat-emoji' + idx;
        item.position = '-' + (idx % 15) * 29 + 'px -' + Math.floor(idx / 15) * 29 + 'px';
        var res = WeixinKf.find(function (i) { return i.index === idx; });
        if (res) {
            return __assign(__assign({}, item), res);
        }
        return item;
    });
    return WeixinKfDataArr;
};
var getSdkData = function () {
    var i = 1, items = [];
    var sdkEmojiText = ['笑脸', '开心', '微笑', '赞扬', '眨眼', '美女', '飞吻', '亲亲', '囧', '满意', '呲牙', '调皮', '吐舌', '无语', '酷', '流汗', '失望', '低落', '吐', '焦虑', '担心', '震惊', '坚韧', '流泪', '哭', '破涕为笑', '晕', '恐惧'];
    while (i < 29) {
        var code = 'emoji0' + (i < 10 ? '0' : '') + i + '';
        items.push({
            clz: code,
            code: '[' + code + ']',
            position: getEmojiPositions()[i - 1],
            text: sdkEmojiText[i - 1],
            regtext: '\\[' + sdkEmojiText[i - 1] + '\\]'
        });
        i++;
    }
    return items;
};
var getWebData = function () {
    var i = 29, items = [];
    var webEmojiText = ['笑脸', '开心', '美女', '眨眼', '囧', '呲牙', '亲亲', '酷', '睡觉', '难过', '破涕为笑', '哭', '吐舌', '怒', '恐惧', '得意', '生病', '赞', '鼓掌', 'OK', '加油', '拜托', '太阳', '咖啡', '红心', '花', '冰激凌', '叹号'];
    while (i < 57) {
        var code = 'emoji0' + i + '';
        items.push({
            clz: code,
            code: '[' + code + ']',
            position: getEmojiPositions()[i - 1],
            text: webEmojiText[i - 29],
            regtext: '\\[' + webEmojiText[i - 29] + '\\]'
        });
        i++;
    }
    return items;
};
export default {
    getWechatData: getWechatData,
    getSdkData: getSdkData,
    getWebData: getWebData,
    getQywxData: getQywxData,
    getWeixin_kfData: getWeixin_kfData
};
