var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import i18n from "../i18n";
/**
 * 创建一个 CustomerError 需要定义一个 ErrorCode，
 * 然后需要在 CustomerError 里定义对应的带 static 修饰符的 CustomerError 实例，
 * 在使用的时候就可以直接判断错误类型了，例如 e === CustomerError.CellphoneDuplicated，
 * 如果需要显示默认的报错可以直接使用message属性，例如 CustomerError.CellphoneDuplicated.message
 */
var ErrorCode;
(function (ErrorCode) {
    ErrorCode[ErrorCode["CUSTOMER_CELLPHONE_DUPLICATED"] = 0] = "CUSTOMER_CELLPHONE_DUPLICATED";
    ErrorCode[ErrorCode["CUSTOMER_EMAIL_DUPLICATED"] = 1] = "CUSTOMER_EMAIL_DUPLICATED";
})(ErrorCode || (ErrorCode = {}));
var CustomerError = /** @class */ (function (_super) {
    __extends(CustomerError, _super);
    function CustomerError(type) {
        var _this = _super.call(this) || this;
        _this.messageKey = "tip.error.customer_error.".concat(type);
        return _this;
    }
    Object.defineProperty(CustomerError.prototype, "message", {
        get: function () {
            return i18n.t(this.messageKey);
        },
        enumerable: false,
        configurable: true
    });
    CustomerError.CellphoneDuplicated = new CustomerError(ErrorCode.CUSTOMER_CELLPHONE_DUPLICATED);
    CustomerError.EmailDuplicated = new CustomerError(ErrorCode.CUSTOMER_EMAIL_DUPLICATED);
    return CustomerError;
}(Error));
export default CustomerError;
