import React from 'react';
import { ButtonProps } from 'udesk-ui/es/button';
import { ModalFuncProps } from 'udesk-ui/es/modal';
import { DropDownProps } from 'udesk-ui/es/dropdown';
export interface ActionMenuItem {
    label: string;
    type: string;
    disabled?: boolean | ((item: any) => boolean);
    confirm?: Omit<ModalFuncProps, 'onOk'>;
}
export interface ExportButtonProps extends Omit<ButtonProps, 'onClick'> {
    exportDataCount?: number;
    onClick: (type?: string | React.MouseEvent<HTMLElement, MouseEvent>, e?: React.MouseEvent<HTMLElement, MouseEvent>) => Promise<any>;
    noSecondConfirmation?: boolean;
    goToDownloadCenter?: () => void;
    confirm?: Omit<ModalFuncProps, 'onOk'>;
    dropdown?: ActionMenuItem[];
    getPopupContainer?: DropDownProps['getPopupContainer'];
}
declare const ExportButton: React.FC<ExportButtonProps>;
export default ExportButton;
