function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["prefixCls", "className", "children", "exportDataCount", "goToDownloadCenter", "confirm", "dropdown", "onClick", "noSecondConfirmation", "getPopupContainer"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useCallback, useMemo } from 'react';
import { Button, notification, message, Modal } from 'udesk-ui';
import classNames from 'classnames';
import { usePrefixCls } from '../utils';
import { useLocaleReceiver } from '../locale-provider/LocaleReceiver';
import { ArrowDownSOutlined, ExportOutlined } from '@udesk/icons';
import BatchedActions from '../batched-actions';
var confirm = Modal.confirm;
var ExportButton = function ExportButton(props) {
  var customizePrefixCls = props.prefixCls,
    className = props.className,
    children = props.children,
    exportDataCount = props.exportDataCount,
    goToDownloadCenter = props.goToDownloadCenter,
    confirmProps = props.confirm,
    dropdown = props.dropdown,
    onClick = props.onClick,
    _props$noSecondConfir = props.noSecondConfirmation,
    noSecondConfirmation = _props$noSecondConfir === void 0 ? false : _props$noSecondConfir,
    getPopupContainer = props.getPopupContainer,
    rest = _objectWithoutProperties(props, _excluded);
  var _useLocaleReceiver = useLocaleReceiver('ExportButton'),
    _useLocaleReceiver2 = _slicedToArray(_useLocaleReceiver, 1),
    contextLocale = _useLocaleReceiver2[0];
  var _usePrefixCls = usePrefixCls('export-button', customizePrefixCls),
    _usePrefixCls2 = _slicedToArray(_usePrefixCls, 2),
    buttonPrefixCls = _usePrefixCls2[0],
    prefixCls = _usePrefixCls2[1];
  var classes = classNames(buttonPrefixCls, className);
  var isExportAll = function isExportAll() {
    return typeof exportDataCount !== 'number';
  };
  var onOk = useCallback(function (type) {
    var _props$onClick, _props$onClick$call;
    return (_props$onClick = props.onClick) === null || _props$onClick === void 0 ? void 0 : (_props$onClick$call = _props$onClick.call(props, type)) === null || _props$onClick$call === void 0 ? void 0 : _props$onClick$call.then(function () {
      notification.success({
        key: 'exportNotification',
        message: contextLocale.lang.successfully,
        getContainer: getPopupContainer,
        description: /*#__PURE__*/React.createElement("div", null, contextLocale.lang.pleaseJumpTo, /*#__PURE__*/React.createElement(Button, {
          prefixCls: "".concat(prefixCls, "-btn"),
          type: "link",
          size: "small",
          onClick: goToDownloadCenter
        }, contextLocale.lang.uploadAndDownloadCenter), contextLocale.lang.check)
      });
    });
  }, [props.onClick, goToDownloadCenter, getPopupContainer]);
  var defaultConfirmProps = useMemo(function () {
    return _objectSpread(_objectSpread({
      title: isExportAll() ? contextLocale.lang.exportAll : "".concat(contextLocale.lang.total, " ").concat(exportDataCount || 0, " ").concat(contextLocale.lang.confirm),
      // icon: <ExclamationCircleOutlined />,
      maskClosable: true,
      okText: contextLocale.lang.export
    }, confirmProps), {}, {
      onOk: onOk
    });
  }, [exportDataCount, confirmProps, prefixCls, onOk]);
  var showConfirm = function showConfirm() {
    if (exportDataCount === 0) {
      message.error(contextLocale.lang.error);
      return;
    }
    confirm(defaultConfirmProps);
  };
  var exportDropdown = useMemo(function () {
    var res = dropdown === null || dropdown === void 0 ? void 0 : dropdown.map(function (item) {
      return _objectSpread(_objectSpread({}, item), {}, {
        confirm: noSecondConfirmation ? undefined : _objectSpread(_objectSpread({}, defaultConfirmProps), item.confirm),
        onClick: onOk.bind(null, item.type)
      });
    });
    return res;
  }, [dropdown, defaultConfirmProps, onOk, noSecondConfirmation]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, dropdown ? /*#__PURE__*/React.createElement(BatchedActions, {
    menu: exportDropdown,
    getPopupContainer: getPopupContainer
  }, /*#__PURE__*/React.createElement(Button, _objectSpread(_objectSpread({
    className: classes
  }, rest), {}, {
    // onClick={showConfirm}
    icon: /*#__PURE__*/React.createElement(ExportOutlined, {
      style: {
        marginRight: 4
      }
    })
  }), children || contextLocale.lang.export, /*#__PURE__*/React.createElement(ArrowDownSOutlined, {
    style: {
      marginLeft: 4
    }
  }))) : /*#__PURE__*/React.createElement(Button, _objectSpread(_objectSpread({
    className: classes,
    icon: /*#__PURE__*/React.createElement(ExportOutlined, {
      style: {
        marginRight: 4
      }
    })
  }, rest), {}, {
    onClick: noSecondConfirmation ? props.onClick : showConfirm
  }), children || contextLocale.lang.export));
};
export default ExportButton;