import { __assign, __rest } from "tslib";
import React, { useMemo } from 'react';
import FieldItemComponents from './field-mapping';
var FieldTypeComponent = function (props) {
    var type = props.type, agents = props.agents, transProps = __rest(props, ["type", "agents"]);
    var Component = useMemo(function () { return FieldItemComponents[type]; }, [type]);
    if (Component && type) {
        if (type === 'staff') {
            return (React.createElement(Component, __assign({}, transProps, { agents: agents })));
        }
        else if (type === 'datetime') {
            var is_standard = (props || {}).is_standard;
            return (React.createElement(Component, __assign({}, transProps, { needTransfer: is_standard })));
        }
        else if (type === 'file') {
            var _a = props || {}, file_suffix = _a.file_suffix, file_size_limit = _a.file_size_limit, file_field_size_limit = _a.file_field_size_limit, file_count_limit = _a.file_count_limit;
            return (React.createElement(Component, __assign({}, transProps, { marking: 'web.custom_field.file', singleLimit: file_size_limit, totalLimit: file_field_size_limit, uploadProps: { accept: file_suffix, maxCount: file_count_limit } })));
        }
        return (React.createElement(Component, __assign({}, props)));
    }
    else {
        return null;
    }
};
export default FieldTypeComponent;
