import React, { ComponentProps } from 'react';
import { Cascader } from 'udesk-ui';
import './index.module.scss';
import { CopyProps } from '../copy';
export declare type OptionType = {
    value?: string | number;
    label?: string;
    is_hide?: boolean | undefined;
    children?: OptionType[] | undefined;
};
declare type PropsInterface = Omit<ComponentProps<typeof Cascader>, 'value'> & {
    options: OptionType[];
    value: string | string[] | number[];
    fieldNames: {
        label?: string;
        value?: string;
        children?: string;
        is_hide?: string;
    };
    readOnly?: boolean;
    disabled?: boolean;
    fullSelect?: boolean;
    classNames?: string;
    id?: string;
    copyProps?: CopyProps;
    onValueBlur?: (id: string, value: any) => void;
    onChange?: (value: string | any[]) => void;
};
/**
 * 快速级联组件
 */
declare const FormCascader: React.FC<PropsInterface>;
export default FormCascader;
