import { __assign, __rest } from "tslib";
import React, { useEffect, useMemo, useState } from 'react';
import { Checkbox, Tag } from 'udesk-ui';
import { isArray, xor } from 'lodash-es';
import CopyText from '../copy';
import { useTranslation } from '@udesk-webapp/locale';
import { markOptionUsedByValue } from '../../utils/format';
// 自定义字段 多选/单选
// FIXME: 因为单选有不选的情况，暂无法处理，所以利用多选替代单选模式 isRadio
// TODO: 单选时需要替换方块为原点，这个后续支持下
// TODO: 多选的全选模式暂时没有启用，这个可以提给产品，看有无需求
var FormCheckbox = function (props) {
    var onChange = props.onChange, options = props.options, value = props.value, copyProps = props.copyProps, isCheckAll = props.isCheckAll, readOnly = props.readOnly, _a = props.isRadio, isRadio = _a === void 0 ? false : _a, _b = props.labelInValue, labelInValue = _b === void 0 ? true : _b, restProps = __rest(props, ["onChange", "options", "value", "copyProps", "isCheckAll", "readOnly", "isRadio", "labelInValue"]);
    var t = useTranslation().t;
    var getValueArray = function (_value) {
        if (!isArray(_value)) {
            if (typeof _value === 'string') {
                return _value.split(',');
            }
            else {
                return _value ? [_value] : [];
            }
        }
        else {
            return _value || [];
        }
    };
    var getCanCheckValues = function (_options) {
        if (_options && _options.length) {
            var s = _options.filter(function (o) { return !o.is_hide; }) || [];
            return s.map(function (item) { return (item === null || item === void 0 ? void 0 : item.value) || ''; });
            // TODO: 全选是否处理禁用
            // const canCheckValues: string[] = [];
            // _options.forEach(item => {
            //     !item?.disabled && canCheckValues.push(item?.value || '');
            // });
            // return canCheckValues;
        }
        return [];
    };
    var _c = useState(getValueArray(value)), checkedList = _c[0], setCheckedList = _c[1];
    var _d = useState(getCanCheckValues(options)), canCheckValues = _d[0], setCanCheckValues = _d[1];
    var _e = useState(true), indeterminate = _e[0], setIndeterminate = _e[1];
    var _f = useState(false), checkAll = _f[0], setCheckAll = _f[1];
    var initValuesRef = React.useRef(value);
    useEffect(function () {
        setCheckedList(getValueArray(value));
    }, [value]);
    useEffect(function () {
        setCanCheckValues(getCanCheckValues(options));
    }, [options]);
    // 更新选项列表 - 不显示隐藏项则直接
    var showOptions = useMemo(function () {
        var _checkedList = [];
        var markedOptions = markOptionUsedByValue(options, initValuesRef.current) || [];
        if (!isArray(value)) {
            if (typeof value === 'string') {
                _checkedList = value.split(',');
            }
            else {
                _checkedList = value ? [value] : [];
            }
        }
        else if ((value === null || value === void 0 ? void 0 : value.length) > 0 && typeof value[0] === 'object') {
            _checkedList = value.map(function (item) { return (item === null || item === void 0 ? void 0 : item.value) || ''; });
        }
        else {
            _checkedList = value || [];
        }
        var showOptions = [];
        markedOptions.forEach(function (item) {
            if (item) {
                var isSelected = _checkedList != null && _checkedList.includes(item.value);
                if (!item.is_hide || isSelected || item.isUsed) {
                    item.disabled = (item.is_hide && !isSelected);
                    showOptions.push(item);
                }
            }
        });
        return showOptions;
    }, [options, value]);
    var formatValue = useMemo(function () {
        return checkedList.map(function (v) {
            if (typeof v === 'string') {
                return v;
            }
            return v.value;
        });
    }, [checkedList]);
    if (readOnly) {
        var checkedRender_1 = [];
        var showValueText_1 = '';
        options.forEach(function (item) {
            var index = checkedList.indexOf(item.value);
            if (index !== -1) {
                showValueText_1 = "".concat(showValueText_1, ",").concat(item.label || '');
                checkedRender_1.push(React.createElement(Tag, { style: { marginRight: 3 }, key: index }, item.label));
            }
        });
        return (React.createElement(CopyText, __assign({}, copyProps, { text: showValueText_1 }),
            React.createElement(React.Fragment, null, checkedRender_1)));
    }
    var onValueChange = function (list) {
        var s = options.filter(function (o) { return !o.disabled; }) || [];
        var changeList = list;
        if (isRadio && list.length > 1) {
            changeList = xor(list, formatValue) || [];
        }
        var changeValues = s.filter(function (o) { return changeList.includes(o.value); });
        setCheckedList(changeValues);
        if (isCheckAll && !isRadio) {
            setIndeterminate(!!list.length && list.length < s.length);
            setCheckAll(list.length === s.length);
        }
        var values = changeValues;
        // 需要支持两种形式的value
        if (!labelInValue) {
            values = changeList;
        }
        var onValueBlur = props.onValueBlur, _a = props.id, id = _a === void 0 ? '' : _a;
        if (isRadio) {
            onChange === null || onChange === void 0 ? void 0 : onChange(values && values[0] ? values[0] : '');
            onValueBlur === null || onValueBlur === void 0 ? void 0 : onValueBlur(id, values && values[0] ? values[0] : '');
        }
        else {
            onChange === null || onChange === void 0 ? void 0 : onChange(values);
            onValueBlur === null || onValueBlur === void 0 ? void 0 : onValueBlur(id, values);
        }
    };
    var onCheckAllChange = function (e) {
        // TODO: 全选是否处理禁用？ []需要处理
        setCheckedList(e.target.checked ? canCheckValues : []);
        setIndeterminate(false);
        setCheckAll(e.target.checked);
    };
    return (React.createElement(React.Fragment, null,
        isCheckAll && !isRadio ? (React.createElement(Checkbox, { indeterminate: indeterminate, onChange: onCheckAllChange, checked: checkAll }, t('labels.allSelect'))) : null,
        React.createElement(Checkbox.Group, __assign({}, restProps, { className: "form-checkbox-group", value: formatValue, options: showOptions, onChange: onValueChange }), showOptions && showOptions.length
            ? showOptions.map(function (item, index) {
                return (React.createElement(Checkbox, { key: index, value: item === null || item === void 0 ? void 0 : item.value, disabled: item === null || item === void 0 ? void 0 : item.disabled }, item === null || item === void 0 ? void 0 : item.label));
            })
            : null)));
};
FormCheckbox.defaultProps = {
    value: [],
    isRadio: false,
};
export default FormCheckbox;
