import { __assign } from "tslib";
// @ts-nocheck
import React, { useState, useEffect, useRef, useImperativeHandle, useMemo } from 'react';
import RichEditor from '@udesk-webapp/rich-editor';
import './index.module.scss';
import CopyText from '../../copy';
import ContentView from '../content-view';
var ContentEditComponent = React.forwardRef(function (props, ref) {
    var disabled = props.disabled, value = props.value, onChange = props.onChange, onEditorPostRender = props.onEditorPostRender, _a = props.backgroundColor, backgroundColor = _a === void 0 ? '' : _a, _b = props.showUploadImg, showUploadImg = _b === void 0 ? true : _b, copyProps = props.copyProps, readOnly = props.readOnly, translate = props.translate, _c = props.statusbar, statusbar = _c === void 0 ? true : _c;
    var _d = useState(value || ''), content = _d[0], setContent = _d[1];
    var richEditorRef = useRef(null);
    useEffect(function () {
        setContent(value || '');
    }, [value]);
    var onEditorChange = function (content) {
        setContent(content);
        onChange === null || onChange === void 0 ? void 0 : onChange(content);
    };
    // 保留子组件插入文本的能力
    useImperativeHandle(ref, function () { return ({
        insertContent: function (content) {
            if (!(richEditorRef === null || richEditorRef === void 0 ? void 0 : richEditorRef.current)) {
                return;
            }
            var insertContent = (richEditorRef === null || richEditorRef === void 0 ? void 0 : richEditorRef.current).insertContent;
            insertContent === null || insertContent === void 0 ? void 0 : insertContent(content);
        },
    }); });
    var copyText = useMemo(function () {
        return content.replace(new RegExp('<[^>]+>', 'gi'), '');
    }, [content]);
    return (readOnly ?
        React.createElement(ContentView, __assign({}, props, { copyProps: copyProps, content: content }))
        :
            React.createElement(CopyText, __assign({}, copyProps, { text: copyText }),
                React.createElement("div", { className: "contentEdit-wrap" },
                    React.createElement("div", { className: "contentEdit-content" },
                        React.createElement(RichEditor, { marking: "web.ts.create_ticket", autoresize_min_height: 130, autoresize_max_height: 200, statusbar: statusbar, paste_data_images: true, readonly: disabled, value: content, showImg: showUploadImg, 
                            // defaultValue={''}
                            backgroundColor: backgroundColor, onChange: onEditorChange, postRender: onEditorPostRender, translate: translate, ref: richEditorRef })))));
});
export default ContentEditComponent;
