import { __assign } from "tslib";
// @ts-nocheck
import React, { useCallback, useState } from 'react';
import { Button, message } from 'udesk-ui';
import CopyToClipboard from 'react-copy-to-clipboard';
import './index.module.scss';
import { useTranslation } from '@udesk-webapp/locale';
export var PositionEnum;
(function (PositionEnum) {
    PositionEnum["Top"] = "top";
    PositionEnum["Left"] = "left";
    PositionEnum["Right"] = "right";
    PositionEnum["Bottom"] = "bottom";
    PositionEnum["TopLeft"] = "topLeft";
    PositionEnum["TopRight"] = "topRight";
    PositionEnum["BottomLeft"] = "bottomLeft";
    PositionEnum["BottomRight"] = "bottomRight";
    PositionEnum["LeftTop"] = "leftTop";
    PositionEnum["LeftBottom"] = "leftBottom";
    PositionEnum["RightTop"] = "rightTop";
    PositionEnum["RightBottom"] = "rightBottom";
})(PositionEnum || (PositionEnum = {}));
var CopyText = function (props) {
    // 默认显示在右上角，不能默认显示在容器外面，因为外层容器上设置了overflow:hidden，这样复制按钮就显示不出来了。
    // 而设置overflow:hidden的原因是为了内容过长时，显示省略号...
    var icon = props.icon, text = props.text, _a = props.left, left = _a === void 0 ? '' : _a, _b = props.right, right = _b === void 0 ? '' : _b, _c = props.top, top = _c === void 0 ? '' : _c, _d = props.bottom, bottom = _d === void 0 ? '' : _d, _e = props.switchFlag, switchFlag = _e === void 0 ? true : _e, _f = props.btnSize, btnSize = _f === void 0 ? 'small' : _f, _g = props.type, type = _g === void 0 ? 'default' : _g, _h = props.buttonText, buttonText = _h === void 0 ? '' : _h, _j = props.placement, placement = _j === void 0 ? PositionEnum.TopRight : _j, className = props.className, style = props.style;
    var formatMessage = useTranslation().t; // 多语言
    var buttonStyle = {
        left: left,
        right: right,
        top: top,
        bottom: bottom,
    };
    var _k = useState(buttonStyle), copyStyle = _k[0], setCopyStyle = _k[1];
    var showButton = useCallback(function () {
        setCopyStyle(__assign(__assign({}, copyStyle), { visibility: text === '' || text === null || text === undefined ? 'hidden' : 'visible' }));
    }, [copyStyle, text]);
    var hideButton = useCallback(function () {
        setCopyStyle(__assign(__assign({}, copyStyle), { visibility: 'hidden' }));
    }, [copyStyle]);
    var copyText = function (_text, result) {
        if (result) {
            message.info(formatMessage('tips.success.copy'));
        }
        else {
            message.error(formatMessage('tips.fail.copy'));
        }
    };
    var handleClick = useCallback(function (event) {
        event.stopPropagation();
    }, []);
    return switchFlag ? (React.createElement("div", { onMouseEnter: showButton, onMouseLeave: hideButton, className: className ? "".concat(className, " copy-container") : 'copy-container', style: style },
        React.createElement(CopyToClipboard, { text: text, onCopy: copyText },
            React.createElement(Button, { className: "copy-button copy-position-".concat(placement), size: btnSize, style: copyStyle, onClick: handleClick, type: type, icon: icon }, buttonText || formatMessage('labels.copy'))),
        props.children)) : (React.createElement(React.Fragment, null, props.children));
};
export default CopyText;
