import { __assign } from "tslib";
// @ts-nocheck
import React, { useMemo } from 'react';
import { Input, InputNumber } from 'udesk-ui';
import './index.module.scss';
import CopyText from '../copy';
import { useTranslation } from '@udesk-webapp/locale';
// 自定义字段 范围值（大于、小于）
var FormRange = function (props) {
    var _a = props.id, id = _a === void 0 ? '' : _a, value = props.value, _b = props.suffix, suffix = _b === void 0 ? '' : _b, copyProps = props.copyProps, onChange = props.onChange, onValueBlur = props.onValueBlur;
    var t = useTranslation().t;
    var _c = useMemo(function () {
        if (value && value.length) {
            return [value[0] || '', value[1] || ''];
        }
        return ['', ''];
    }, [value]), startNumber = _c[0], endNumber = _c[1];
    var onValueChange = function (type, v) {
        var changeValue = [startNumber, endNumber];
        changeValue[type === 'min' ? 0 : 1] = v;
        onChange === null || onChange === void 0 ? void 0 : onChange(changeValue);
    };
    var onInputBlur = function (type) {
        var changeValue = [startNumber, endNumber];
        if (startNumber && endNumber && parseInt(startNumber) > parseInt(endNumber)) {
            changeValue[type === 'min' ? 0 : 1] = '';
            onChange === null || onChange === void 0 ? void 0 : onChange(changeValue);
        }
        onValueBlur === null || onValueBlur === void 0 ? void 0 : onValueBlur(id, [startNumber, endNumber]);
    };
    return (React.createElement(CopyText, __assign({}, copyProps, { text: "".concat(startNumber, ",").concat(endNumber) }),
        React.createElement("div", { className: "form-range-group-wrapper" },
            React.createElement(Input.Group, { compact: true },
                React.createElement(InputNumber, { controls: false, min: '0', onBlur: function () { return onInputBlur('min'); }, onChange: function (e) { return onValueChange('min', e); }, placeholder: t('labels.minValue'), precision: 0, stringMode: true, style: { width: "calc(".concat(suffix ? '40%' : '50%', " - 15px)"), textAlign: 'center' }, value: startNumber }),
                React.createElement(Input, { className: "form-range-input-split", style: {
                        width: 30,
                        pointerEvents: 'none',
                    }, placeholder: "~", disabled: true }),
                React.createElement(InputNumber, { controls: false, addonAfter: suffix, className: "form-range-input-right", min: '0', onBlur: function () { return onInputBlur('max'); }, onChange: function (e) { return onValueChange('max', e); }, placeholder: t('labels.maxValue'), precision: 0, stringMode: true, style: { width: "calc(".concat(suffix ? '60%' : '50%', " - 15px)"), textAlign: 'center' }, value: endNumber })))));
};
export default FormRange;
