import { __assign, __rest } from "tslib";
// @ts-nocheck
import React, { useMemo } from 'react';
import { DatePicker } from 'udesk-ui';
import moment from 'moment';
import CopyText from '../copy';
import enUS from 'antd/es/date-picker/locale/en_US';
import zhCN from 'antd/es/date-picker/locale/zh_CN';
import { useTranslation } from '@udesk-webapp/locale';
import { time2Locale, time2Service } from '@udesk-webapp/utils';
var RangePicker = DatePicker.RangePicker;
var YYYY_MM_DD = 'YYYY-MM-DD';
var YYYY_MM_DD_HH_MM = 'YYYY-MM-DD HH:mm';
var YYYY_MM_DD_HH_MM_SS = 'YYYY-MM-DD HH:mm:ss';
// 日期类 注意格式和多语言
var FormRangePicker = function (props) {
    var onChange = props.onChange, value = props.value, _a = props.language, language = _a === void 0 ? 'zh-CN' : _a, _b = props.showTime, showTime = _b === void 0 ? false : _b, copyProps = props.copyProps, format = props.format, ranges = props.ranges, needTransfer = props.needTransfer, restProps = __rest(props, ["onChange", "value", "language", "showTime", "copyProps", "format", "ranges", "needTransfer"]);
    var formatMessage = useTranslation().t; // 多语言
    var dateFormat = format || (showTime ? YYYY_MM_DD_HH_MM_SS : YYYY_MM_DD);
    var normalRanges = useMemo(function () {
        var _a;
        return ranges ? ranges : (_a = {},
            _a[formatMessage('components.ranges.today')] = [moment().startOf('day'),
                moment().endOf('day')],
            _a[formatMessage('components.ranges.yesterday')] = [moment().subtract(1, 'days').startOf('day'),
                moment().subtract(1, 'days').endOf('day')],
            _a[formatMessage('components.ranges.recently_seven_day')] = [moment().subtract(6, 'days').startOf('day'),
                moment().endOf('day')],
            _a[formatMessage('components.ranges.recently_thirty_day')] = [moment().subtract(29, 'days').startOf('day'),
                moment().endOf('day')],
            _a[formatMessage('components.ranges.this_month')] = [moment().startOf('month').startOf('day'),
                moment().endOf('month').endOf('day')],
            _a[formatMessage('components.ranges.last_month')] = [moment().subtract(1, 'month')
                    .startOf('month')
                    .startOf('day'),
                moment().subtract(1, 'month').endOf('month')
                    .endOf('day')],
            _a[formatMessage('components.ranges.this_year')] = [moment().startOf('year').startOf('day'),
                moment().endOf('year').endOf('day')],
            _a[formatMessage('components.ranges.last_year')] = [moment().subtract(1, 'year').startOf('year')
                    .startOf('day'),
                moment().subtract(1, 'year').endOf('year')
                    .endOf('day')],
            _a[formatMessage('components.ranges.recently_year')] = [moment().subtract(1, 'year'), moment()],
            _a);
    }, [ranges]);
    var _c = useMemo(function () {
        if (value && value.length && showTime && needTransfer) {
            // 服务器时间转本地时间
            // @ts-ignore
            return [time2Locale(value[0], dateFormat) || '', time2Locale(value[1], dateFormat) || ''];
        }
        if (value && value.length) {
            return [value[0] || '', value[1] || ''];
        }
        return ['', ''];
    }, [value, showTime, needTransfer, dateFormat]), startTime = _c[0], endTime = _c[1];
    var handleOnchange = function (dates, dateStrings) {
        if (dateStrings && dateStrings.length && showTime && needTransfer) {
            // 服务器时间转本地时间
            onChange === null || onChange === void 0 ? void 0 : onChange([time2Service(dateStrings[0], dateFormat) || '', time2Service(dateStrings[1], dateFormat) || '']);
        }
        else {
            onChange === null || onChange === void 0 ? void 0 : onChange(dateStrings);
        }
    };
    return (React.createElement(CopyText, __assign({}, copyProps, { text: "".concat(startTime, ",").concat(endTime) }),
        React.createElement(RangePicker, __assign({ style: { width: '100%' }, getPopupContainer: function (triggerNode) { return triggerNode; } }, restProps, { ranges: normalRanges, showTime: showTime, format: dateFormat, locale: language === 'zh-CN' ? zhCN : enUS, onChange: handleOnchange, value: startTime === "" || endTime === "" ? null :
                [moment(startTime, dateFormat), moment(endTime, dateFormat)], onBlur: function () {
                var onValueBlur = props.onValueBlur, _a = props.id, id = _a === void 0 ? '' : _a;
                if (showTime && needTransfer) {
                    // 服务器时间转本地时间
                    // @ts-ignore
                    return [time2Service(startTime, dateFormat) || '', time2Service(endTime, dateFormat) || ''];
                }
                else {
                    onValueBlur === null || onValueBlur === void 0 ? void 0 : onValueBlur(id, [startTime, endTime]);
                }
            } }))));
};
export default FormRangePicker;
