import { __assign, __rest, __spreadArray } from "tslib";
// @ts-nocheck
import React, { useMemo, useState } from 'react';
import { Button, Divider, Input, Space } from 'udesk-ui';
import FormSelect from '../select';
import { useTranslation } from '@udesk-webapp/locale';
// 默认labelInValue为false， 兼容text字段
var FormSelectWithInput = function (props) {
    var options = props.options, _a = props.labelInValue, labelInValue = _a === void 0 ? false : _a, restProps = __rest(props, ["options", "labelInValue"]);
    var formatMessage = useTranslation().t; // 多语言
    var _b = useState([]), addOptions = _b[0], setAddOptions = _b[1];
    var _c = useState(''), addItem = _c[0], setAddItem = _c[1];
    var _d = useState(false), open = _d[0], setOpen = _d[1];
    var newOptions = useMemo(function () {
        return __spreadArray(__spreadArray([], options, true), addOptions, true);
    }, [options, addOptions]);
    var addSelectItem = function (e) {
        var _a;
        e.preventDefault();
        if (addItem) {
            var isHas = addOptions.find(function (e) { return e.value === addItem; });
            if (!isHas) {
                setAddOptions(__spreadArray(__spreadArray([], addOptions, true), [{ value: addItem, label: addItem, key: "addItem_".concat(addOptions.length + 1) }], false));
            }
            setAddItem('');
            (_a = props === null || props === void 0 ? void 0 : props.onChange) === null || _a === void 0 ? void 0 : _a.call(props, labelInValue ? { value: addItem, label: addItem } : addItem);
        }
        setOpen(false);
    };
    var onAddChange = function (event) {
        setAddItem(event.target.value);
    };
    return (React.createElement(FormSelect, __assign({ labelInValue: labelInValue, getPopupContainer: function (triggerNode) { return triggerNode; } }, restProps, { options: newOptions, open: open, onDropdownVisibleChange: function (visible) { return setOpen(visible); }, dropdownRender: function (menu) { return (React.createElement(React.Fragment, null,
            React.createElement(Space, { style: { padding: '0 8px 4px' } },
                React.createElement(Input, { placeholder: formatMessage('labels.pleaseInput') || '请输入', value: addItem, onChange: onAddChange }),
                React.createElement(Button, { type: "text", onClick: addSelectItem }, formatMessage('labels.confirm') || '确定')),
            React.createElement(Divider, { style: { margin: '8px 0' } }),
            menu)); } })));
};
export default FormSelectWithInput;
