import React, { ComponentProps } from 'react';
import { Select } from 'udesk-ui';
import { CopyProps } from '../copy';
declare type OptionType = {
    value?: string | number;
    label?: string;
    is_hide?: boolean | undefined;
    isUsed?: boolean;
};
declare type Props = Omit<ComponentProps<typeof Select>, 'onChange' | 'onBlur'> & {
    onChange?: (value: ComponentProps<typeof Select>['value']) => void;
    onValueBlur?: (id: string, value: any) => void;
    id?: string;
    showSearch?: boolean;
    allowClear?: boolean;
    readOnly?: boolean;
    options: OptionType[];
    value?: string | (string | number)[] | OptionType[];
    fieldNames?: {
        label?: string;
        value?: string;
        is_hide?: string;
    };
    mode?: undefined | 'multiple' | 'tags';
    style?: any;
    placeholder?: string;
    labelInValue?: boolean;
    checkAll?: boolean;
    copyProps?: CopyProps;
    classNames?: string;
};
/**
 * 自定义字段 单选/多选
 * 默认labelInValue
 */
declare const FormSelect: React.FC<Props>;
export default FormSelect;
