import { __assign, __rest } from "tslib";
import React, { useEffect, useState, useRef, useCallback } from 'react';
import { Input } from 'udesk-ui';
import CopyText from '../copy';
import { sensitiveField } from '@udesk-webapp/utils';
// 自定义字段 文本/或者通用性质的带icon点击事件/或者纯文本的系统字段（主题等）
var FormText = function (props) {
    var _a = props.allowClear, allowClear = _a === void 0 ? true : _a, _b = props.autoToggleSensitiveValue, autoToggleSensitiveValue = _b === void 0 ? false : _b, value = props.value, copyProps = props.copyProps, addonAfterRender = props.addonAfterRender, sensitiveMarkPlaceholder = props.sensitive_mark_placeholder, sensitiveMarkPosition = props.sensitive_mark_position, sensitiveMarkSize = props.sensitive_mark_size, sensitiveMode = props.sensitive_mode, _c = props.addonAfterClick, addonAfterClick = _c === void 0 ? function () { } : _c, onFocus = props.onFocus, restProps = __rest(props, ["allowClear", "autoToggleSensitiveValue", "value", "copyProps", "addonAfterRender", "sensitive_mark_placeholder", "sensitive_mark_position", "sensitive_mark_size", "sensitive_mode", "addonAfterClick", "onFocus"]);
    // 设置展示值
    var _d = useState(value), showValue = _d[0], setShowValue = _d[1];
    // 判断是否获取焦点
    var _e = useState(false), focusing = _e[0], setFocusing = _e[1];
    // const focusRef=useRef(false);
    // 内部值
    var localeValueRef = useRef(value);
    useEffect(function () {
        localeValueRef.current = value;
        setShowValue(value);
        // 自动转换脱敏状态
        if (autoToggleSensitiveValue && !focusing) {
            var sensitiveValue = sensitiveField({
                sensitive_mark_placeholder: sensitiveMarkPlaceholder,
                sensitive_mark_position: sensitiveMarkPosition,
                sensitive_mark_size: sensitiveMarkSize,
                sensitive_mode: sensitiveMode, // 脱敏模式，0不脱敏，1全脱敏，2部分脱敏
            })(value);
            setShowValue(sensitiveValue);
        }
    }, [value, autoToggleSensitiveValue, sensitiveMarkPlaceholder, sensitiveMarkPosition, sensitiveMarkSize, sensitiveMode, focusing]);
    var onValueChange = function (e) {
        var _a;
        var targetValue = e.target.value;
        setShowValue(targetValue);
        (_a = props === null || props === void 0 ? void 0 : props.onChange) === null || _a === void 0 ? void 0 : _a.call(props, targetValue);
    };
    var focus = useCallback(function () {
        setFocusing(true);
        setShowValue(value);
        onFocus === null || onFocus === void 0 ? void 0 : onFocus(value);
    }, [onFocus, value]);
    return (React.createElement(CopyText, __assign({}, copyProps, { text: showValue }),
        React.createElement(Input, __assign({ addonAfter: !!addonAfterRender ? (React.createElement("span", { onClick: function () { return addonAfterClick === null || addonAfterClick === void 0 ? void 0 : addonAfterClick(localeValueRef.current); } }, addonAfterRender)) : null }, restProps, { allowClear: allowClear, value: showValue, onChange: function (data) { return onValueChange(data); }, onBlur: function (e) {
                // const targetValue = e.target.value;
                var onValueBlur = props.onValueBlur, _a = props.id, id = _a === void 0 ? '' : _a;
                setFocusing(false);
                onValueBlur === null || onValueBlur === void 0 ? void 0 : onValueBlur(id, value);
            }, onFocus: focus }))));
};
export default FormText;
