import { __assign, __rest } from "tslib";
import React, { useCallback, useEffect, useRef, useState } from 'react';
import { TimePicker } from 'udesk-ui';
import dayjs from 'dayjs';
import 'dayjs/locale/zh-cn';
import enUS from 'antd/es/date-picker/locale/en_US';
import zhCN from 'antd/es/date-picker/locale/zh_CN';
import CopyText from '../copy';
import ReactDOM from 'react-dom';
import { time2Locale, time2Service } from '@udesk-webapp/utils';
var TIME_FORMAT = 'HH:mm';
var TIME_FORMAT_S = 'HH:mm:ss';
// 时间类 注意格式和多语言
var FormTimePicker = function (props) {
    var onChange = props.onChange, onValueBlur = props.onValueBlur, id = props.id, value = props.value, _a = props.format, format = _a === void 0 ? TIME_FORMAT_S : _a, _b = props.language, language = _b === void 0 ? 'zh-CN' : _b, copyProps = props.copyProps, _c = props.blurToSave, blurToSave = _c === void 0 ? true : _c, _d = props.needTransfer, needTransfer = _d === void 0 ? false : _d, restProps = __rest(props, ["onChange", "onValueBlur", "id", "value", "format", "language", "copyProps", "blurToSave", "needTransfer"]);
    var _e = useState(value || null), dateValue = _e[0], setDateValue = _e[1];
    var dateRef = useRef(null);
    var isDateChange = useRef(false); // 解决配置了失焦保存时，点击此刻无效的问题。
    useEffect(function () {
        if (value && needTransfer) {
            // 服务器时间转本地时间
            // @ts-ignore
            setDateValue(time2Locale(value, format, true));
        }
        else {
            setDateValue(value || null);
        }
    }, [value, needTransfer, format]);
    var handleOnchange = useCallback(function (date, dateString) {
        // const newString = date?.format(format) || dateString;
        setDateValue(dateString);
        if (dateString && needTransfer) {
            // 本地时间转服务器时间
            // @ts-ignore
            onChange === null || onChange === void 0 ? void 0 : onChange(time2Service(dateString, format, true));
        }
        else {
            onChange === null || onChange === void 0 ? void 0 : onChange(dateString);
        }
        // 清除触发失去焦点
        if (!dateString && id) {
            onValueBlur === null || onValueBlur === void 0 ? void 0 : onValueBlur(id, '');
        }
        // 值为空时不变更，可能是删除按钮，不会触发OpenChange
        isDateChange.current = !!dateString;
    }, [id, onChange, onValueBlur, needTransfer, format]);
    var handleOnOpenChange = useCallback(function (open) {
        var _a;
        if (!open && dateRef.current) {
            var dateDom = ReactDOM.findDOMNode(dateRef.current);
            var dateInputDom = dateDom ? (_a = dateDom === null || dateDom === void 0 ? void 0 : dateDom.getElementsByTagName('input')) === null || _a === void 0 ? void 0 : _a[0] : null;
            var inputValue = (dateInputDom === null || dateInputDom === void 0 ? void 0 : dateInputDom.value) || "";
            // 验证input元素中value有值，判断是否与当前值相等,且是个有效时间
            // dayjs校验或者正则
            if (inputValue && dateValue !== inputValue && !isDateChange.current && dayjs(inputValue, TIME_FORMAT_S).isValid()) {
                setDateValue(inputValue);
                if (needTransfer) {
                    // @ts-ignore
                    onChange === null || onChange === void 0 ? void 0 : onChange(time2Service(inputValue, format, true));
                }
                else {
                    onChange === null || onChange === void 0 ? void 0 : onChange(inputValue);
                }
            }
            isDateChange.current = false;
        }
    }, [dateValue, onChange, needTransfer, format]);
    return (React.createElement(CopyText, __assign({}, copyProps, { text: dateValue }),
        React.createElement(TimePicker, __assign({ getPopupContainer: function (triggerNode) { return triggerNode; }, ref: dateRef, style: { width: '100%' } }, restProps, { onChange: handleOnchange, 
            // 这里兼容失焦保存
            onOpenChange: blurToSave ? handleOnOpenChange : undefined, 
            // @ts-ignore
            value: dateValue ? dayjs(dateValue, TIME_FORMAT_S) : null, format: format, locale: language === 'zh-CN' ? zhCN : enUS, onBlur: function () {
                var onValueBlur = props.onValueBlur, _a = props.id, id = _a === void 0 ? '' : _a;
                if (dateValue && needTransfer) {
                    // @ts-ignore
                    onValueBlur === null || onValueBlur === void 0 ? void 0 : onValueBlur(id, time2Service(dateValue, format, true));
                }
                else {
                    onValueBlur === null || onValueBlur === void 0 ? void 0 : onValueBlur(id, dateValue);
                }
            }, 
            // WARN:下面这个antd看着没有这个api,在onchange先实现
            onClear: function () {
                // 这里模拟Blur事件用于字段推送
                var onValueBlur = props.onValueBlur, _a = props.id, id = _a === void 0 ? '' : _a;
                onValueBlur === null || onValueBlur === void 0 ? void 0 : onValueBlur(id, '');
            } }))));
};
export default FormTimePicker;
