import { __assign, __rest } from "tslib";
import React, { useMemo, useState } from 'react';
import { TreeSelect } from 'udesk-ui';
import { cloneDeep } from 'lodash-es';
var SHOW_PARENT = TreeSelect.SHOW_PARENT, SHOW_CHILD = TreeSelect.SHOW_CHILD;
var getData = function (data, val) {
    var arr = data;
    arr.map(function (i) {
        i.value = val + ',' + i.value;
        if (i.children) {
            getData(i.children, i.value);
        }
    });
    return arr;
};
// 树形结构 多选
var FormTreeSelect = function (props) {
    var valueProps = props.value, onChange = props.onChange, treeData = props.treeData, strategy = props.strategy, _a = props.maxTagCount, maxTagCount = _a === void 0 ? 1 : _a, _b = props.labelInValue, labelInValue = _b === void 0 ? true : _b, formatTreeDataValue = props.formatTreeDataValue, readOnly = props.readOnly, _c = props.treeCheckable, treeCheckable = _c === void 0 ? true : _c, _d = props.treeNodeFilterProp, treeNodeFilterProp = _d === void 0 ? 'title' : _d, restProps = __rest(props, ["value", "onChange", "treeData", "strategy", "maxTagCount", "labelInValue", "formatTreeDataValue", "readOnly", "treeCheckable", "treeNodeFilterProp"]);
    var _e = useState(valueProps || undefined), curValue = _e[0], setCurValue = _e[1];
    var onValueChange = function (newValue) {
        setCurValue(newValue);
        onChange === null || onChange === void 0 ? void 0 : onChange(newValue);
    };
    var newTreeData = useMemo(function () {
        if (formatTreeDataValue) {
            var arr = cloneDeep(treeData);
            arr.map(function (item) {
                if (item === null || item === void 0 ? void 0 : item.children) {
                    item.children = getData(item === null || item === void 0 ? void 0 : item.children, item.value);
                }
            });
            return arr;
        }
        return treeData;
    }, [formatTreeDataValue, treeData]);
    if (readOnly) {
        return null;
    }
    return (React.createElement(TreeSelect, __assign({ getPopupContainer: function (triggerNode) { return triggerNode; } }, restProps, { maxTagCount: maxTagCount, treeData: newTreeData, labelInValue: labelInValue, value: curValue, onChange: onValueChange, treeCheckable: treeCheckable, treeNodeFilterProp: treeNodeFilterProp, showCheckedStrategy: strategy === 'parent' ? SHOW_PARENT : SHOW_CHILD, style: {
            width: '100%',
        } })));
};
export default FormTreeSelect;
