function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }

var _excluded = ["form", "children", "fields", "customComponents", "footerRender", "labelCol", "wrapperCol", "btnsCol", "onValuesChange", "isLazy"];

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }

function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import React, { useEffect,
/* forwardRef, */
useImperativeHandle, useMemo, useContext } from 'react';
import Form from "../form";
import Button from "../button";
import Space from "../space";
import { ConfigContext } from "../config-provider"; // import { FormInstance as AFormInstance } from '../form';
// import { getDefaultFormConfigMap } from './component-map';

import useFormContext from "./useFormContext";
import Field from "./field";
var Item = Form.Item;
var defaultLayout = {
  labelCol: {
    xs: {
      span: 24
    },
    sm: {
      span: 7
    }
  },
  wrapperCol: {
    xs: {
      span: 24
    },
    sm: {
      span: 10
    }
  }
};
var defaultTailLayout = {
  xs: {
    span: 24,
    offset: 0
  },
  sm: {
    span: 10,
    offset: 7
  }
}; //factory.tsx

function creatFormBuilder(getFieldComponent) {
  var FormBuilder = function FormBuilder(props, ref) {
    var userForm = props.form,
        children = props.children,
        fields = props.fields,
        _props$customComponen = props.customComponents,
        customComponents = _props$customComponen === void 0 ? {} : _props$customComponen,
        _props$footerRender = props.footerRender,
        footerRender = _props$footerRender === void 0 ? function () {
      return null;
    } : _props$footerRender,
        labelCol = props.labelCol,
        wrapperCol = props.wrapperCol,
        _props$btnsCol = props.btnsCol,
        btnsCol = _props$btnsCol === void 0 ? defaultTailLayout : _props$btnsCol,
        propsOnValuesChange = props.onValuesChange,
        _props$isLazy = props.isLazy,
        isLazy = _props$isLazy === void 0 ? true : _props$isLazy,
        rest = _objectWithoutProperties(props, _excluded);

    var layout = rest.layout;
    var ctx = useContext(ConfigContext);
    var getPrefixCls = ctx.getPrefixCls;

    var _useFormContext = useFormContext(userForm),
        _useFormContext2 = _slicedToArray(_useFormContext, 1),
        form = _useFormContext2[0];

    var _form$getInternalHook = form.getInternalHooks(),
        getAFormInstance = _form$getInternalHook.getAFormInstance;

    useImperativeHandle(ref, function () {
      return form.getFormInstance();
    }); // const defaultConfigMap = getDefaultFormConfigMap(isLazy);
    // const mixedConfigMap = useMemo(() => {
    //     return { ...defaultConfigMap, ...customComponents };
    // }, [customComponents]);

    var formCol = useMemo(function () {
      if (layout !== 'inline' && (!labelCol || !wrapperCol)) {
        return defaultLayout;
      }

      return {
        labelCol: labelCol,
        wrapperCol: wrapperCol
      };
    }, [labelCol, wrapperCol, layout]);
    var formBtnsCol = useMemo(function () {
      return btnsCol === false ? {
        offset: undefined,
        span: undefined
      } : btnsCol;
    }, [btnsCol]);

    var onValuesChange = function onValuesChange(changedValues, allValues) {
      //
      form.computedEffecties();
      propsOnValuesChange && propsOnValuesChange(changedValues, allValues);
    };

    useEffect(function () {
      form.setFields(fields);
      form.computedEffecties(true);
    }, [fields, form]);
    return /*#__PURE__*/React.createElement("div", {
      className: getPrefixCls('form-builder-container')
    }, /*#__PURE__*/React.createElement(React.Suspense, {
      fallback: /*#__PURE__*/React.createElement("div", null, "loading...")
    }, /*#__PURE__*/React.createElement(Form, _objectSpread(_objectSpread({
      form: getAFormInstance(),
      onValuesChange: onValuesChange
    }, formCol), rest), Array.isArray(fields) && fields.map(function (field) {
      return /*#__PURE__*/React.createElement(Field, {
        field: field,
        // mixedConfigMap={mixedConfigMap}
        getFieldComponent: getFieldComponent.bind(null, customComponents),
        formStore: form,
        formName: rest.name
      });
    }), React.Children.map(children, function (item) {
      return item;
    }), typeof footerRender === 'function' && /*#__PURE__*/React.createElement(Item, {
      wrapperCol: formBtnsCol
    }, /*#__PURE__*/React.createElement(Space, null, footerRender() || /*#__PURE__*/React.createElement(React.Fragment, null, /*#__PURE__*/React.createElement(Button, {
      type: "primary",
      htmlType: "submit"
    }, "\u4FDD\u5B58"), /*#__PURE__*/React.createElement(Button, {
      onClick: function onClick() {
        form.resetFields();
      }
    }, "\u53D6\u6D88")))))));
  };

  return FormBuilder;
} //lazy.js
// const FormBuilder = creatFormBuilder((key:string)=>{
//     switch(key){
//         case "input":
//             return import("../input").then(mod=> mod.default.TextArea);
//         default:
//     }
// });
// const InternalForm = forwardRef<FormInstance, FormProps>(FormBuilder as any) as (
//     props: React.PropsWithChildren<FormProps> & { ref?: React.Ref<FormInstance> }
// ) => React.ReactElement;
// type InternalFormType = typeof InternalForm;
// interface RefFormType extends InternalFormType {
//     useForm: typeof useFormContext;
//     Item: typeof Form.Item;
// }
// const RefForm: RefFormType = InternalForm as RefFormType;
// RefForm.useForm = useFormContext;
// RefForm.Item = Item;


export default creatFormBuilder; // const A:React.FC = () => {
//     return <div>111</div>
// }
// const configMap = {A: A}
// const [form1] = useFormContext();
// const config: FormProps<typeof configMap> = {
//     form: form1,
//     fields: [
//         {
//             name: '1',
//             label: '1',
//             type: 'A',
//         }
//     ]
// }
//# sourceMappingURL=form-builder.js.map
