import { FormInstance as AFormInstance, FormProps as AntdFormProps, Rule, FormItemProps as AntdFormItemProps } from '../../form';
import defaultFormConfigMap from '../default-component-maps/component-map';
import React from 'react';
export interface onFinishValues {
    [key: string]: any;
}
export interface FormProps<M extends {
    [key: string]: React.FC | React.ClassicComponent | React.ReactNode;
} = any> extends Omit<AntdFormProps, 'children' | 'fields' | 'form'> {
    fields: FormFieldConfig<M>[];
    initialValues?: {
        [key: string]: any;
    };
    form?: AFormInstance;
    customComponents?: M;
    footerRender?: false | (() => React.ReactNode);
    onFinish?: (values: onFinishValues) => void;
    btnsCol?: {
        offset?: any;
        span?: any;
    } | false;
    isLazy?: boolean;
}
export interface FormFieldConfig<M = {}> extends AntdFormItemProps {
    type: keyof typeof defaultFormConfigMap | keyof M;
    props?: any;
    forceDisabled?: boolean;
    forceHidden?: boolean;
    addonBefore?: React.ReactNode;
    addonAfter?: React.ReactNode;
    rules?: Rule[];
    effect?: {
        visible?: {
            [key: string]: FormFieldConfig['name'][];
        };
        value?: {
            [key: string]: {
                name: FormFieldConfig['name'][];
                output: any;
            }[];
        };
        disable?: {
            [key: string]: FormFieldConfig['name'][];
        };
    };
}
export interface FormInstance extends AFormInstance {
    getInternalHooks: () => {
        getAFormInstance: () => AFormInstance;
    };
    computedEffecties: (skipComputeValues?: boolean) => void;
    getVisibleFieldsMap: () => Map<AntdFormItemProps['name'], boolean>;
    getDisableFieldsMap: () => Map<AntdFormItemProps['name'], boolean>;
    registerField: (name: any, field: any) => void;
    getFieldVisible: (name: AntdFormItemProps['name']) => boolean | undefined;
    getFieldDisable: (name: AntdFormItemProps['name']) => boolean | undefined;
    setFields: (fields: any) => void;
    getFormInstance: () => FormInstance | AFormInstance;
}
