import { __assign } from "tslib";
import i18n from 'i18next';
import LanguageDetector from 'i18next-browser-languagedetector';
import { useTranslation as _useTranslation, withTranslation } from 'react-i18next';
import enUs from './en-US.json';
import zhCn from './zh-CN.json';
import arEg from './ar-EG.json';
import jaJp from './ja-JP.json';
import ruRu from './ru-RU.json';
import viVn from './vi-VN.json';
import thTh from './th-TH.json';
import trTR from './tr-TR.json';
import ptPT from './pt-PT.json';
import fr from './fr.json';
import esES from './es-ES.json';
import de from './de.json';
import zhTW from './zh-TW.json';
import zhHK from './zh-HK.json';
import id from './id-ID.json';
import elGR from './el-GR.json';
import itIT from './it-IT.json';
import koKR from './ko-KR.json';
import ms from './ms.json';
var newInstance = i18n.createInstance();
newInstance.use(LanguageDetector).init({
    fallbackLng: 'zh',
    debug: process.env.NODE_ENV !== 'production',
    resources: {
        en: {
            translation: enUs,
        },
        zh: {
            translation: zhCn,
        },
        // WARN:上面两个配置是为了兼容历史配置，下面为新配置
        'en-US': {
            translation: enUs,
        },
        'zh-CN': {
            translation: zhCn,
        },
        'zh-TW': {
            translation: zhTW,
        },
        'zh-HK': {
            translation: zhHK,
        },
        'ar-EG': {
            translation: arEg,
        },
        ar: {
            translation: arEg,
        },
        'ja-JP': {
            translation: jaJp,
        },
        ja: {
            translation: jaJp,
        },
        'ru-RU': {
            translation: ruRu,
        },
        ru: {
            translation: ruRu,
        },
        'vi-VN': {
            translation: viVn,
        },
        vi: {
            translation: viVn,
        },
        'th-TH': {
            translation: thTh,
        },
        'th': {
            translation: thTh,
        },
        'tr-TR': {
            translation: trTR,
        },
        'tr': {
            translation: trTR,
        },
        'pt-PT': {
            translation: ptPT,
        },
        'pt': {
            translation: ptPT,
        },
        fr: {
            translation: fr,
        },
        'es-ES': {
            translation: esES,
        },
        'es': {
            translation: esES,
        },
        de: {
            translation: de,
        },
        'id-ID': {
            translation: id,
        },
        'id': {
            translation: id,
        },
        'el-GR': {
            translation: elGR,
        },
        'el': {
            translation: elGR,
        },
        'it-IT': {
            translation: itIT,
        },
        'it': {
            translation: itIT,
        },
        'ko-KR': {
            translation: koKR
        },
        'ko': {
            translation: koKR
        },
        ms: {
            translation: ms,
        },
    },
    interpolation: {
        escapeValue: false, // not needed for react!!
    },
});
export default newInstance;
export var useTranslation = function (ns, options) {
    return _useTranslation(ns, __assign({ i18n: newInstance }, options));
};
export { withTranslation };
