import { __assign } from "tslib";
import i18n from 'i18next';
import LanguageDetector from 'i18next-browser-languagedetector';
import { initReactI18next, useTranslation as _useTranslation, withTranslation } from 'react-i18next';
import enUs from './en';
import zhCn from './zh';
import ja from './ja-JP';
import ar from './ar-EG';
import ru from './ru-RU';
import th from './th-TH';
import tr from './tr-TR';
import vi from './vi-VN';
import fr from './fr';
import es from './es-ES';
import pt from './pt-PT';
import zhHK from './zh-HK';
import zhTW from './zh-TW';
import de from './de';
import id from './id-ID';
import elGR from './el-GR';
import itIT from './it-IT';
import koKR from './ko-KR';
import ms from './ms';
var newI18n = i18n.createInstance();
newI18n.use(LanguageDetector)
    .use(initReactI18next) // bind react-i18next to the instance
    .init({
    fallbackLng: 'zh',
    resources: {
        'en-US': {
            translation: enUs,
        },
        'zh-CN': {
            translation: zhCn,
        },
        'zh-HK': {
            translation: zhHK,
        },
        'zh-TW': {
            translation: zhTW,
        },
        'ja-JP': {
            translation: ja,
        },
        'ar-EG': {
            translation: ar,
        },
        'ru-RU': {
            translation: ru,
        },
        'th-TH': {
            translation: th,
        },
        'tr-TR': {
            translation: tr,
        },
        'vi-VN': {
            translation: vi,
        },
        'fr': {
            translation: fr,
        },
        'pt-PT': {
            translation: pt,
        },
        'es-ES': {
            translation: es,
        },
        'de': {
            translation: de,
        },
        'id-ID': {
            translation: id,
        },
        'el-GR': {
            translation: elGR,
        },
        'it-IT': {
            translation: itIT,
        },
        'ko-KR': {
            translation: koKR
        },
        ms: {
            translation: ms,
        }
    },
    interpolation: {
        escapeValue: false // not needed for react!!
    }
});
export default newI18n;
export var useTranslation = function (ns, options) {
    return _useTranslation(ns, __assign({ i18n: newI18n }, options));
};
export { withTranslation };
