import React from 'react';
import 'loaders.css/src/animations/ball-beat.scss';
declare type PluginTypes = 'call_in' | 'call_out' | 'im' | 'customer_detail' | 'videocall_in';
declare type Props = {
    type: PluginTypes;
    currentUser: IUser;
    /**
     * 所属客户，必传。如果customer在父组件中是异步获取的，确保在外层组件判断customer。只有customer有值时渲染本组件。
     *
     * @type {Customer}
     */
    customer?: Customer;
    pluginId?: string;
    pluginHeight?: number;
    link?: string;
    platform?: string;
    postMsgEnabled?: boolean;
    params?: any;
    /**
     *  仅在im模块中使用
     */
    chat?: IChat;
    /**
     *  仅在im模块中使用
     *
     * @type {Field[]}
     */
    customerFields?: Field[];
    /**
     *  仅在im模块中使用
     *
     * @type {Field[]}
     */
    noteFields?: Field[];
    ticket?: any;
    event: any;
    onRequestLinkError?: (response: any) => void;
    onRequestLinkReady?: (src: string) => void;
    onSrcEncoded?: (src: string) => void;
};
declare const IMCustomPlugin: React.FC<Props>;
export default IMCustomPlugin;
