var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useCallback, useEffect, useState } from 'react';
import { message } from 'udesk-ui';
import classNames from 'classnames';
import { useTranslation } from 'react-i18next';
import { MaximizeIcon } from '../../components/icon/icon';
import { getJSON } from '../../utils';
import { useSelector } from '../../store/store-hook';
import isEqual from 'lodash-es/isEqual';
import 'loaders.css/src/animations/ball-beat.scss';
import style from './index.module.scss';
var IMCustomPlugin = function (props) {
    var _a, _b;
    var t = useTranslation().t;
    var initData = useSelector(function (state) { return state.initData; });
    var iframeRef = useState(React.createRef())[0];
    var _c = useState(), iframeEl = _c[0], setIframeEl = _c[1];
    var _d = useState(false), isDestroyed = _d[0], setIsDestroyed = _d[1];
    var _e = useState(''), error = _e[0], setError = _e[1];
    useEffect(function () {
        var iframeDom = iframeRef.current;
        setIframeEl(iframeDom);
        return function cleanup() {
            setIsDestroyed(true);
        };
    }, [iframeRef]);
    var pluginHeight = useState(getPluginHeight(props.type, props.pluginHeight))[0];
    var _f = useState(), requestLink = _f[0], setRequestLink = _f[1];
    var _g = useState(), src = _g[0], setSrc = _g[1];
    // 拼接src
    useEffect(function () {
        var _a, _b, _c;
        var url = requestLink;
        if (!url) {
            setSrc('');
            return;
        }
        var customer = props.customer;
        var platform = props.platform;
        if (!customer) {
            setSrc('');
            return;
        }
        url += (url.indexOf('?') > -1 ? '&' : '?') + 'agent_email=' + props.currentUser.email;
        url += '&agent_phone_number=' + (props.currentUser.cellphone || '');
        var type = props.type;
        var ticket_id = (_a = props.ticket) === null || _a === void 0 ? void 0 : _a.id;
        var params = props.params;
        if (isEqual(initData.page, 'mpv') && ((_b = props.chat) === null || _b === void 0 ? void 0 : _b.roomId)) {
            url += '&call_id=' + ((_c = props.chat) === null || _c === void 0 ? void 0 : _c.roomId);
        }
        if (type) {
            url += '&type=' + type;
        }
        if (platform) {
            url += '&platform=' + platform;
        }
        if (ticket_id) {
            url += '&ticket_id=' + ticket_id;
        }
        var urlObj = getCustomerPlatformId(props);
        url += urlObj.url;
        if (props.params) {
            for (var i in params) {
                url += '&' + i + '=' + params[i];
            }
        }
        var encodeUrl = encodeURI(url);
        if (props.onSrcEncoded) {
            props.onSrcEncoded(encodeUrl);
        }
        setSrc(encodeUrl);
    }, [props.currentUser.cellphone, props.currentUser.email, props, props.customer, props.ticket, requestLink]);
    // 生成并缓存iframe load事件
    var iframeLoadEvent = useCallback(function (e) {
        var _a, _b, _c;
        console.log('iframe初始化完成');
        if (props.type === 'im' && props.postMsgEnabled) {
            if (isDestroyed) {
                return;
            }
            var customer = props.customer;
            if (!customer) {
                return;
            }
            var customerCustomFieldsValue_1 = customer.custom_fields || {};
            var chat = props.chat;
            // 访问信息
            var accessInfo_1 = (chat === null || chat === void 0 ? void 0 : chat.accessInfo) || {};
            // 客户信息
            var cellphones = ((_a = customer.cellphones) === null || _a === void 0 ? void 0 : _a.map(function (phone) { return phone.content; })) || [];
            var organizations = ((_b = chat === null || chat === void 0 ? void 0 : chat.organizations) === null || _b === void 0 ? void 0 : _b.map(function (org) { return org.name; })) || [];
            var sysFields = {
                email: customer.email || '',
                cellphones: cellphones || [],
                nick_name: customer.nick_name || '',
                organizations: organizations || [],
                description: customer.description || '',
                tags: customer.tags || '',
            };
            var customerIdObj = getCustomerPlatformId(props);
            var customerCustomFields_1 = [];
            (_c = props.customerFields) === null || _c === void 0 ? void 0 : _c.forEach(function (item) {
                var _a;
                customerCustomFields_1.push((_a = {},
                    _a[item.name] = customerCustomFieldsValue_1[item.name] || '',
                    _a.title = item.title || item.name || '',
                    _a.content_type = item.content_type || '',
                    _a));
            });
            var customerInfo_1 = __assign(__assign({}, customerIdObj.idObj), { sysFields: sysFields, customFields: customerCustomFields_1 });
            // 业务记录
            var noteInfo_1 = {};
            var noteFields_1 = [];
            loadNote(chat, isDestroyed, setError).then(function (data) {
                var _a;
                var noteCustomFields = data.custom_fields;
                var subject = data.content || '';
                noteInfo_1.subject = subject;
                (_a = props.noteFields) === null || _a === void 0 ? void 0 : _a.forEach(function (item) {
                    var _a;
                    noteFields_1.push((_a = {},
                        _a[item.name] = noteCustomFields[item.name] || '',
                        _a.title = item.title,
                        _a.content_type = item.content_type,
                        _a));
                });
                noteInfo_1.noteFields = noteFields_1;
                // 获取工号
                loadAgentWorkId(props, isDestroyed, setError).then(function (agent) {
                    var _a, _b;
                    if (agent === void 0) { agent = {}; }
                    // 客服信息
                    var agentInfo = {
                        name: props.currentUser.nick_name,
                        aliase: props.currentUser.aliase || '',
                        id: props.currentUser.id,
                        work_id: agent.work_id || '',
                        email: props.currentUser.email || '',
                        cellphone: props.currentUser.cellphone || '',
                    };
                    // 拼数据
                    var postData = {
                        agentInfo: agentInfo,
                        accessInfo: accessInfo_1,
                        customerInfo: customerInfo_1,
                        noteInfo: noteInfo_1,
                    };
                    // 发送postMessage
                    (_b = (_a = iframeRef.current) === null || _a === void 0 ? void 0 : _a.contentWindow) === null || _b === void 0 ? void 0 : _b.postMessage(JSON.stringify(postData, function (k, v) {
                        if (v === null) {
                            return '';
                        }
                        else {
                            return v;
                        }
                    }), new URL(src).origin);
                });
            });
        }
    }, [iframeRef, isDestroyed, props, src]);
    // 监听参数变化，重新获取requestLink
    useEffect(function () {
        var _a, _b, _c, _d;
        if (((_a = props.customer) === null || _a === void 0 ? void 0 : _a.id) || ((_b = props.ticket) === null || _b === void 0 ? void 0 : _b.id)) {
            var customerId = (_c = props.customer) === null || _c === void 0 ? void 0 : _c.id;
            var ticketId = (_d = props.ticket) === null || _d === void 0 ? void 0 : _d.id;
            var pluginId = props.pluginId;
            // 重置src
            setRequestLink('');
            getJSON(props.link, {
                customer_id: customerId,
                ticket_id: ticketId,
                id: pluginId,
            })
                .then(function (res) {
                setError('');
                if (!res || !res.url) {
                    if (props.onRequestLinkError) {
                        props.onRequestLinkError(res);
                    }
                    return;
                }
                if (isDestroyed) {
                    return;
                }
                setRequestLink(res.url);
                if (props.onRequestLinkReady) {
                    props.onRequestLinkReady(src);
                }
            })
                .catch(function (reason) {
                setError(reason.code_message);
            });
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [props.pluginId, (_a = props.customer) === null || _a === void 0 ? void 0 : _a.id, (_b = props.ticket) === null || _b === void 0 ? void 0 : _b.id]);
    useEffect(function () {
        var chat = props.chat;
        var sendTime = '';
        var handleMsg = function (e) {
            var data = {};
            try {
                data = JSON.parse(e.data);
            }
            catch (ex) {
                console.log(ex);
            }
            var type = data.type, method = data.method, content = data.content;
            if (method !== 'sendMsg')
                return;
            if (chat.customer_driving_close) {
                return message.warning('会话已经被客户关闭,不能继续发送消息,请关闭会话后操作!');
            }
            if (sendTime && +new Date() - (sendTime || 0) < 1000) {
                sendTime = new Date().getTime();
                message.warning('请不要太快发送消息');
            }
            else {
                sendTime = new Date().getTime();
                props.event.sendMsg &&
                    props.event.sendMsg({
                        msg: {
                            type: data.type === 'text' ? 'message' : data.type,
                            data: {
                                content: data.content,
                            },
                            content: data.content,
                        },
                        chat: props.chat,
                    });
            }
        };
        window.addEventListener('message', handleMsg);
        return function () {
            window.removeEventListener('message', handleMsg);
        };
    }, []);
    return (React.createElement("div", { className: style['udesk-component-custom-plugin'] },
        React.createElement("a", { href: src, className: "open-link", target: "_blank", rel: "noopener noreferrer", title: t('page.im.assist.openInNewWindow') },
            React.createElement(MaximizeIcon, null)),
        error && React.createElement("div", { className: style.error }, error),
        src && (React.createElement("iframe", { className: classNames(style['plugin-iframe']), style: { height: pluginHeight }, src: src, title: " ", ref: iframeRef, onLoad: iframeLoadEvent }))));
};
IMCustomPlugin.defaultProps = {
    pluginHeight: 380,
    link: '/user_defined_plugins/request_link',
};
function loadNote(chat, isDestroyed, setError) {
    return new Promise(function (resolve) {
        var noteCustomFields = chat.note_custom_field;
        if (noteCustomFields) {
            resolve(noteCustomFields);
        }
        else {
            getJSON('notes/detail', {
                type: 'im',
                ref_id: chat.im_sub_session_id,
            })
                .then(function (res) {
                setError('');
                if (isDestroyed) {
                    return;
                }
                resolve(res.data);
            })
                .catch(function (reason) {
                setError(reason.code_message);
            });
        }
    });
}
function loadAgentWorkId(props, isDestroyed, setError) {
    var id = props.currentUser.id;
    return new Promise(function (resolve) {
        getJSON('agents/' + id)
            .then(function (res) {
            setError('');
            if (isDestroyed) {
                return;
            }
            resolve(res.agent);
        })
            .catch(function (reason) {
            setError(reason.code_message);
        });
    });
}
function getCustomerPlatformId(props) {
    var customer = props.customer;
    var weixin_openid = customer.weixin_openid, weixins = customer.weixins, unionid = customer.unionid, weibo_openid = customer.weibo_openid, weibos = customer.weibos, open_api_token = customer.open_api_token, customer_id = customer.id, weixin_minis = customer.weixin_minis, sdk_token = customer.sdk_token, web_token = customer.web_token, customer_token = customer.customer_token;
    var weixin_mini_openid;
    weixin_openid = (weixins && weixins.length > 0 && weixins[0].openid) || weixin_openid;
    unionid = (weixins && weixins.length > 0 && weixins[0].unionid) || unionid;
    weibo_openid = (weibos && weibos.length > 0 && weibos[0].openid) || weibo_openid;
    unionid = (weixins && weixins.length > 0 && weixins[0].unionid) || unionid;
    weixin_mini_openid = weixin_minis && weixin_minis.length > 0 && weixin_minis[0].openid;
    var url = '';
    var idObj = {};
    if (weixin_openid) {
        url += '&weixin_openid=' + weixin_openid;
        unionid && (url += '&unionid=' + unionid);
        idObj.weixin_open_id = weixin_openid;
    }
    if (weibo_openid) {
        url += '&weibo_openid=' + weibo_openid;
        idObj.weibo_id = weibo_openid;
    }
    if (open_api_token) {
        url += '&open_api_token=' + open_api_token;
        idObj.open_api_token = open_api_token;
    }
    if (customer_id) {
        url += '&customer_id=' + customer_id;
        idObj.id = customer_id;
    }
    if (weixin_mini_openid) {
        url += '&weixin_mini_openid=' + weixin_mini_openid;
        idObj.weixin_mini_openid = weixin_mini_openid;
    }
    if (sdk_token) {
        idObj.sdk_token = sdk_token;
    }
    if (web_token) {
        idObj.web_token = web_token;
    }
    if (customer_token) {
        idObj.customer_token = customer_token;
    }
    return {
        url: url,
        idObj: idObj,
    };
}
function getPluginHeight(type, pluginHeight) {
    if (pluginHeight < 150) {
        pluginHeight = 150;
    }
    else if (pluginHeight > 600) {
        pluginHeight = 600;
    }
    if (type === 'customer_detail' || type === 'im' || type === 'call_out' || type === 'call_in') {
        return '100%';
    }
    else {
        return "".concat(pluginHeight, "px");
    }
}
export default IMCustomPlugin;
