import React, { useCallback } from 'react';
import moment from 'moment';
import { dateFormat } from '../../utils';
import { useTranslation } from 'react-i18next';
import style from './style.module.scss';
import { Col, Row } from 'udesk-ui';
import { useSelector } from '../../store/store-hook';
var CcConversation = function (props) {
    var _a;
    var t = useTranslation().t;
    var initData = useSelector(function (state) { return state.initData; });
    var roleCan = useSelector(function (state) { return state.roleCan; });
    var feed = props.feed;
    var sdk = initData === null || initData === void 0 ? void 0 : initData.sdk;
    var showDetail = useCallback(function (item) {
        var _a;
        (_a = initData === null || initData === void 0 ? void 0 : initData.event) === null || _a === void 0 ? void 0 : _a.showDetail(item);
    }, [(_a = initData === null || initData === void 0 ? void 0 : initData.event) === null || _a === void 0 ? void 0 : _a.showDetail]);
    function formatDuration(time) {
        var duration = moment.duration(time, 'seconds');
        var minutes = duration.asMinutes();
        var seconds = duration.seconds();
        if (minutes >= 1) {
            return parseInt(minutes) + t('minute') + seconds + t('second');
        }
        else {
            return seconds + t('second');
        }
    }
    return (React.createElement(React.Fragment, null,
        React.createElement("div", { className: style['top-title'] },
            React.createElement("span", { className: style['bar-left'] }),
            React.createElement("span", { className: style['type-text'] }, t('call')),
            React.createElement("span", { className: style['data-text'] }, dateFormat(feed.created_at)),
            // eslint-disable-next-line jsx-a11y/anchor-is-valid
            !sdk && feed.type == 'CcConversation' && roleCan.im_customer_contact && (React.createElement("a", { className: style['detail-text'], onClick: function () { return showDetail(feed); } }, t('detail')))),
        React.createElement("div", { className: style['im-main-content'] },
            React.createElement(Row, null,
                React.createElement(Col, { span: 6 },
                    React.createElement("label", null,
                        t('page.im.imContact.type'),
                        ":")),
                React.createElement(Col, { span: 17, offset: 1 },
                    React.createElement("span", { title: feed.source }, feed.call_type))),
            React.createElement(Row, null,
                React.createElement(Col, { span: 6 },
                    React.createElement("label", null,
                        t('page.im.imContact.assigneeAgent'),
                        ":")),
                React.createElement(Col, { span: 17, offset: 1 },
                    React.createElement("span", { title: feed.agent.name }, feed.agent.name))),
            React.createElement(Row, null,
                React.createElement(Col, { span: 6 },
                    React.createElement("label", null,
                        t('page.im.imContact.callResult'),
                        ":")),
                React.createElement(Col, { span: 17, offset: 1 },
                    React.createElement("span", { title: feed.result }, feed.result))),
            React.createElement(Row, null,
                React.createElement(Col, { span: 6 },
                    React.createElement("label", null,
                        t('page.im.imContact.callDuration'),
                        ":")),
                React.createElement(Col, { span: 17, offset: 1 },
                    React.createElement("span", null, formatDuration(feed.talking_seconds)))))));
};
export default CcConversation;
