import React from 'react';
import includes from 'lodash-es/includes';
import isArray from 'lodash-es/isArray';
import { Col, Row } from 'udesk-ui';
var CustomFieldsShow = function (props) {
    var customField = props.customField, value = props.value;
    var is_link = customField && customField['content_type'] === 'link';
    var labelStyle = {
        color: 'rgba(0, 0, 0, 0.65)'
    };
    // function getLabel() {
    //     const { customField = {} } = props;
    //     let labelEl = '';
    //     if (customField.agent_permission === 1) {
    //         labelEl += <span className="red">*</span>;
    //     }
    //     return labelEl;
    // }
    function getValue() {
        var customField = props.customField, value = props.value;
        if (!customField)
            return '';
        var type = customField.content_type, options = customField.select_options;
        var reaultValue = '';
        var _value = value;
        var textArr = [];
        var result = [];
        var oArr = [];
        switch (type) {
            case 'droplist':
            case 'radio':
            case 'checkbox':
                if (!isArray(value)) {
                    _value = value.split(',');
                }
                (options || []).forEach(function (item) {
                    if (includes(_value, item.value + '')) {
                        textArr.push(item.title);
                    }
                });
                reaultValue = textArr.join(',');
                break;
            case 'chained_droplist':
                if (!isArray(value)) {
                    _value = value.split(',');
                }
                oArr = options;
                _value.forEach(function (_v) {
                    var ls, oArrObj;
                    if (!oArr || !(oArrObj = oArr.find(function (item) { return item.value === (_v + ''); }) || oArr.find(function (item) { return item.value === parseInt(_v); }))) {
                        return;
                    }
                    ls = oArrObj;
                    result.push(ls['title']);
                    oArr = ls['subs'];
                });
                reaultValue = result.join('/');
                break;
            case 'link':
                reaultValue = "<a href='".concat(_value, "' target=\"_blank\">").concat(_value, "</a>");
                break;
            default:
                reaultValue = _value;
                break;
        }
        return reaultValue;
    }
    return React.createElement("div", null, (props.customField && props.value) &&
        React.createElement(Row, null,
            React.createElement(Col, { span: 6 },
                React.createElement("label", { style: labelStyle, title: props.title },
                    props.customField.agent_permission === 1 ? React.createElement("span", { className: "red" }, "*") : '',
                    props.customField.title)),
            React.createElement(Col, { span: 17, offset: 1 },
                React.createElement("span", { title: props.title, className: "item-content ".concat(is_link ? 'item-content-link' : '', " word-break") }, is_link ? (React.createElement("a", { href: value, target: "_blank", rel: "noopener noreferrer" }, value)) : (getValue())))));
};
export default CustomFieldsShow;
