import React, { useCallback } from "react";
import { dateFormat } from "../../utils";
import CustomFieldsShow from "./custom-fields";
import { useTranslation } from "react-i18next";
import style from "./style.module.scss";
import { Col, Row } from "udesk-ui";
import { useSelector } from "../../store/store-hook";
var ImSubSession = function (props) {
    var _a;
    var t = useTranslation().t;
    var initData = useSelector(function (state) { return state.initData; });
    var roleCan = useSelector(function (state) { return state.roleCan; });
    var imNoteFields = initData.noteFields || [];
    var feed = props.feed;
    var sdk = initData === null || initData === void 0 ? void 0 : initData.sdk;
    var showDetail = useCallback(function (item) {
        var _a;
        (_a = initData === null || initData === void 0 ? void 0 : initData.event) === null || _a === void 0 ? void 0 : _a.showDetail(item);
    }, [(_a = initData === null || initData === void 0 ? void 0 : initData.event) === null || _a === void 0 ? void 0 : _a.showDetail]);
    return (React.createElement(React.Fragment, null,
        React.createElement("div", { className: style["top-title"] },
            React.createElement("span", { className: style["bar-left"] }),
            React.createElement("span", { className: style["type-text"] }, t("im")),
            React.createElement("span", { className: style["data-text"] }, dateFormat(feed.created_at)),
            // eslint-disable-next-line jsx-a11y/anchor-is-valid
            !sdk && roleCan.im_customer_contact && (React.createElement("a", { className: style["detail-text"], onClick: function () { return showDetail(feed); } }, t("detail")))),
        React.createElement("div", { className: style["im-main-content"] },
            React.createElement(Row, null,
                React.createElement(Col, { span: 6 },
                    React.createElement("label", { style: { color: "rgba(0, 0, 0, 0.45)" } },
                        t("agentAccepted"),
                        ":")),
                React.createElement(Col, { span: 17, offset: 1 },
                    React.createElement("span", null, feed.agent.nick_name))),
            feed.custom_fields
                ? imNoteFields.map(function (field) {
                    return (React.createElement(CustomFieldsShow, { key: field.name, customField: field, customer: "", value: feed.custom_fields[field.name], imShow: true }));
                })
                : null)));
};
export default ImSubSession;
