var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { useCallback, useEffect, useMemo, useRef, useState } from 'react';
import { getJSON } from '../../utils';
import ImSubSession from './imSubSession';
import Ticket from './ticket';
import CcConversation from './ccConversation';
import style from './style.module.scss';
import { useTranslation } from 'react-i18next';
import { message, Select, Timeline } from 'udesk-ui';
import Loader from 'react-loaders';
import 'loaders.css/src/animations/ball-beat.scss';
import cloneDeep from 'lodash-es/cloneDeep';
import pick from 'lodash-es/pick';
import useDebounce from 'react-use/esm/useDebounce';
import { TICKET_STATUS } from '../../common/enums/ticket';
var Option = Select.Option;
var ImContact = function (_a) {
    var createdTicket = _a.createdTicket, props = __rest(_a, ["createdTicket"]);
    var roleCan = props.roleCan, chat = props.chat, _b = props.agents, agents = _b === void 0 ? [] : _b, event = props.event;
    var customerId = chat.customer_id;
    var t = useTranslation().t;
    var _agents = agents.map(function (agent) {
        return {
            id: agent.id + '',
            nick_name: agent.nick_name,
        };
    });
    var allAgents = [{ id: 'all', nick_name: t('page.im.imContact.allAgent') }].concat(_agents);
    var _c = useState(1), page = _c[0], setPage = _c[1];
    var _d = useState({}), setMeta = _d[1];
    var _e = useState(chat.contact_agent_id || 'all'), imContactAgentId = _e[0], setImContactAgentId = _e[1];
    var _f = useState([]), feeds = _f[0], setFeeds = _f[1];
    var _g = useState(true), loading = _g[0], setLoading = _g[1];
    var _h = useState(true), loaded = _h[0], setLoaded = _h[1];
    var _j = useState('all'), selectFilterKey = _j[0], setSelectFilterKey = _j[1];
    var _k = useState(false), loadMore = _k[0], setLoadMore = _k[1];
    var _l = useState(false), hasMore = _l[0], setHasMore = _l[1];
    var _m = useState({
        All: 0,
        Ticket: 0,
        UnsolveTicket: 0,
        CcConversation: 0,
        ImSubSession: 0,
        Video: 0,
    }), allCount = _m[0], setAllCount = _m[1];
    var scrollRef = useRef(null);
    useEffect(function () {
        if (createdTicket) {
            setFeeds(function (v) { return __spreadArray([
                __assign(__assign({}, pick(createdTicket, [
                    'id',
                    'priority_id',
                    'priority',
                    'status_id',
                    'status',
                    'subject',
                    'content',
                    'created_at',
                ])), { type: 'Ticket', agent: pick(createdTicket, [
                        'assignee_id',
                        'assignee_name',
                        'agent_group_id',
                        'agent_group_name',
                    ]) })
            ], v, true); });
            setAllCount(function (v) {
                var isCreatedTicketResolved = createdTicket.status_id === TICKET_STATUS.CLOSED;
                return __assign(__assign({}, v), { Ticket: v.Ticket + 1, UnsolveTicket: isCreatedTicketResolved ? v.UnsolveTicket : v.UnsolveTicket + 1 });
            });
        }
    }, [createdTicket]);
    var params = useMemo(function () {
        return {
            agent_id: imContactAgentId === 'all' ? '' : imContactAgentId,
            feed_type: selectFilterKey === 'all' ? '' : selectFilterKey,
            page: page,
            customer_id: customerId,
        };
    }, [customerId, imContactAgentId, page, selectFilterKey]);
    useEffect(function () {
        var customer_id = params.customer_id;
        var agent_id = params.agent_id;
        if (!customer_id)
            return;
        var sizeParams = {
            customer_id: customer_id,
        };
        if (agent_id) {
            sizeParams.agent_id = agent_id;
        }
        getJSON('/im/customer_feeds_size', sizeParams)
            .then(function (res) {
            if (res && res.code === 1000) {
                setAllCount({
                    All: res.All,
                    Ticket: res.Ticket,
                    UnsolveTicket: res.UnsolveTicket,
                    CcConversation: res.CcConversation,
                    ImSubSession: res.ImSubSession,
                    Video: res.VideoRecord || 0,
                });
            }
        })
            .catch(function (err) {
            console.log(err);
        });
    }, [params.agent_id, params.customer_id]);
    useDebounce(function () {
        if (!params.customer_id)
            return;
        var _params = cloneDeep(params);
        if (!_params.agent_id) {
            delete _params.agent_id;
        }
        if (!_params.customer_id) {
            delete _params.customer_id;
        }
        var _isAdd = _params.page > 1;
        getJSON('/im/customer_feeds', _params)
            .then(function (res) {
            if (res === void 0) { res = {}; }
            if (res.code === 1000) {
                res.feeds.forEach(function (item) { return (item.type = item.type ? item.type : _params.feed_type); });
                setMeta(__assign({}, res.meta));
                if (_isAdd) {
                    setFeeds(function (prevFeeds) {
                        return __spreadArray(__spreadArray([], prevFeeds, true), res.feeds, true);
                    });
                }
                else {
                    setFeeds(res.feeds);
                }
                setLoading(false);
                setLoaded(true);
                setLoadMore(false);
                setHasMore(res.meta.total_pages > res.meta.current_page);
            }
        })
            .catch(function () {
            message.error('加载失败');
        });
    }, 500, [params]);
    var handleChangeAgent = useCallback(function (value) {
        if (value !== imContactAgentId) {
            if (scrollRef.current) {
                scrollRef.current.scrollTop = 0;
            }
            setLoading(true);
            setFeeds([]);
            setPage(1);
            setImContactAgentId(value);
            event === null || event === void 0 ? void 0 : event.updateChat({
                chat: chat,
                key: 'contact_agent_id',
                value: value,
            });
        }
    }, [chat, imContactAgentId, event === null || event === void 0 ? void 0 : event.updateChat]);
    var handleSwitchType = useCallback(function (type) {
        if (type !== selectFilterKey) {
            if (scrollRef.current) {
                scrollRef.current.scrollTop = 0;
            }
            setLoading(true);
            setFeeds([]);
            setPage(1);
            setSelectFilterKey(type);
        }
    }, [selectFilterKey]);
    var showTotal = useCallback(function (type) {
        var text = '';
        switch (type) {
            case 'All':
                text = (allCount.All || 0) + '';
                break;
            case 'ImSubSession':
                text = allCount.ImSubSession + '';
                break;
            case 'CcConversation':
                text = allCount.CcConversation + '';
                break;
            case 'Video':
                text = allCount.Video + '';
                break;
            case 'Ticket':
                text = allCount.UnsolveTicket + '/' + allCount.Ticket + '';
                break;
        }
        return "(".concat(text, ")");
    }, [
        allCount.All,
        allCount.CcConversation,
        allCount.ImSubSession,
        allCount.Ticket,
        allCount.UnsolveTicket,
        allCount.Video,
    ]);
    var handleScroll = useCallback(function () {
        if (scrollRef.current && hasMore) {
            var $El = scrollRef.current;
            var allHeight = $El.scrollHeight;
            var scrollTop = $El.scrollTop;
            var contentHeight = $El.clientHeight || $El.offsetHeight;
            // 滚动到底部时, 且没有在加载数据时
            if (scrollTop + contentHeight + 50 >= allHeight && loaded) {
                // 判断是否有更多页
                setLoadMore(true);
                setLoaded(false);
                setPage(function (prevPage) {
                    return prevPage + 1;
                });
            }
        }
    }, [hasMore, loaded]);
    return (React.createElement("div", { className: "".concat(style['im-contact'], " ").concat(roleCan.only_show_self_customer_feed ? style.noSearch : '') },
        roleCan.only_show_self_customer_feed ? null : (React.createElement("div", { className: style.searchDiv },
            React.createElement("label", null, t('agent')),
            React.createElement("div", { className: style.searchMenu },
                React.createElement(Select, { showSearch: true, size: 'small', style: { width: 120 }, placeholder: '\u8BF7\u9009\u62E9', value: imContactAgentId, optionFilterProp: 'children', onChange: handleChangeAgent, dropdownClassName: style['drop-box'], maxTagCount: 10, filterOption: function (input, option) {
                        return option.children.toLowerCase().indexOf(input.toLowerCase()) >= 0;
                    } }, allAgents.map(function (agent) {
                    return (React.createElement(Option, { value: agent.id, key: agent.id }, agent.nick_name));
                }))))),
        React.createElement("div", { className: style['feed-filter-box'] },
            React.createElement("div", null,
                React.createElement("span", { className: "".concat(style['filter-span-text'], " ").concat(selectFilterKey === 'all' ? style['active'] : ''), onClick: function () { return handleSwitchType('all'); } },
                    t('label.all'),
                    showTotal('All')),
                React.createElement("span", { className: style['filter-span-separator'] }, "|")),
            React.createElement("div", null,
                React.createElement("span", { className: "".concat(style['filter-span-text'], " ").concat(selectFilterKey === 'Ticket' ? style['active'] : ''), onClick: function () { return handleSwitchType('Ticket'); } },
                    t('ticket'),
                    showTotal('Ticket')),
                React.createElement("span", { className: style['filter-span-separator'] }, "|")),
            React.createElement("div", null,
                React.createElement("span", { className: "".concat(style['filter-span-text'], " ").concat(selectFilterKey === 'CcConversation' ? style['active'] : ''), onClick: function () { return handleSwitchType('CcConversation'); } },
                    t('call'),
                    showTotal('CcConversation')),
                React.createElement("span", { className: style['filter-span-separator'] }, "|")),
            React.createElement("div", null,
                React.createElement("span", { className: "".concat(style['filter-span-text'], " ").concat(selectFilterKey === 'ImSubSession' ? style['active'] : ''), onClick: function () { return handleSwitchType('ImSubSession'); } },
                    t('im'),
                    showTotal('ImSubSession')),
                React.createElement("span", { className: style['filter-span-separator'] }, "|")),
            React.createElement("div", null,
                React.createElement("span", { className: "".concat(style['filter-span-text'], " ").concat(selectFilterKey === 'Video' ? style['active'] : ''), onClick: function () { return handleSwitchType('Video'); } },
                    "\u89C6\u9891",
                    showTotal('Video')),
                React.createElement("span", { className: style['filter-span-separator'] }, "|"))),
        loading ? (React.createElement("div", { className: style.pl20 },
            React.createElement(Loader, { type: 'ball-beat', active: true }))) : (React.createElement("div", { className: "".concat(style['scroll-contact'], " scrollbar"), ref: scrollRef, onScroll: handleScroll },
            feeds.length > 0 ? (React.createElement(Timeline, null, feeds.map(function (item, index) {
                var Element;
                switch (item.type) {
                    case 'ImSubSession':
                        Element = ImSubSession;
                        break;
                    case 'Ticket':
                        Element = Ticket;
                        break;
                    case 'CcConversation':
                        Element = CcConversation;
                        break;
                    case 'Video':
                        Element = CcConversation;
                        break;
                    default:
                        Element = CcConversation;
                }
                return (React.createElement(Timeline.Item, { dot: React.createElement("span", { className: style['timeline-dot'] }), key: item.id, className: "".concat(style['contact-timeline']) },
                    React.createElement("div", { className: "".concat(style['contact-record'], " ").concat(style['contact-' + item.type]), key: item.index }, Element && (React.createElement(Element, __assign({ feed: item }, props, { key: item.id }))))));
            }))) : (React.createElement("div", null, t('page.im.imContact.noFeed'))),
            loadMore && React.createElement("div", { className: style['text-center'] }, "loading...")))));
};
export default ImContact;
