import React, { useCallback } from "react";
import { dateFormat } from "../../utils";
import { useTranslation } from "react-i18next";
import style from "./style.module.scss";
import { Col, Row } from "udesk-ui";
import DOMPurify from "dompurify";
import { ArrowDown, ArrowUp, Emergent } from "../../components/icon/icon";
import { TICKET_STATUS } from "../../common/enums/ticket";
import { useSelector } from "../../store/store-hook";
var Ticket = function (props) {
    var _a;
    var t = useTranslation().t;
    var initData = useSelector(function (state) { return state.initData; });
    var roleCan = useSelector(function (state) { return state.roleCan; });
    var feed = props.feed;
    var sdk = initData === null || initData === void 0 ? void 0 : initData.sdk;
    var showDetail = useCallback(function (item) {
        var _a;
        (_a = initData === null || initData === void 0 ? void 0 : initData.event) === null || _a === void 0 ? void 0 : _a.showDetail(item);
    }, [(_a = initData === null || initData === void 0 ? void 0 : initData.event) === null || _a === void 0 ? void 0 : _a.showDetail]);
    return (React.createElement(React.Fragment, null,
        React.createElement("div", { className: style["top-title"] },
            React.createElement("span", { className: style["bar-left"] }),
            React.createElement("span", { className: style["type-text"] }, t("ticket")),
            React.createElement("span", { className: style["data-text"] }, dateFormat(feed.created_at)),
            // eslint-disable-next-line jsx-a11y/anchor-is-valid
            !sdk && roleCan.im_customer_contact && (React.createElement("a", { className: style["detail-text"], onClick: function () { return showDetail(feed); } }, t("detail")))),
        React.createElement("div", { className: style["im-main-content"] },
            React.createElement(Row, null,
                React.createElement(Col, { span: 6 },
                    React.createElement("label", { style: { color: "rgba(0, 0, 0, 0.45)" } },
                        t("page.im.imContact.subject"),
                        ":")),
                React.createElement(Col, { span: 17, offset: 1 },
                    React.createElement("span", { title: feed.subject }, feed.subject))),
            React.createElement(Row, null,
                React.createElement(Col, { span: 6 },
                    React.createElement("label", { style: { color: "rgba(0, 0, 0, 0.45)" } },
                        t("page.im.imContact.desc"),
                        ":")),
                React.createElement(Col, { span: 17, offset: 1 },
                    React.createElement("span", { title: DOMPurify.sanitize(feed.content), className: "ellipsis-two-line" },
                        React.createElement("span", { dangerouslySetInnerHTML: {
                                __html: DOMPurify.sanitize(feed.content),
                            } })))),
            React.createElement(Row, null,
                React.createElement(Col, { span: 6 },
                    React.createElement("label", { style: { color: "rgba(0, 0, 0, 0.45)" } },
                        t("page.im.imContact.status"),
                        ":")),
                React.createElement(Col, { span: 17, offset: 1 },
                    feed.status_id === TICKET_STATUS.OPEN && (React.createElement("span", { className: style["table-pop-open"] }, feed.status)),
                    feed.status_id === TICKET_STATUS.RESOLVED && (React.createElement("span", { className: style["table-pop-resolved"] }, feed.status)),
                    feed.status_id === TICKET_STATUS.CLOSED && (React.createElement("span", { className: style["table-pop-closed"] }, feed.status)),
                    feed.status_id === TICKET_STATUS.SOLVING && (React.createElement("span", { className: style["table-pop-solving"] }, feed.status)))),
            React.createElement(Row, null,
                React.createElement(Col, { span: 6 },
                    React.createElement("label", { style: { color: "rgba(0, 0, 0, 0.45)" } },
                        t("page.im.imContact.priority"),
                        ":")),
                React.createElement(Col, { span: 17, offset: 1 },
                    feed.priority_id === 1 && (React.createElement("span", { className: style["text-error"] },
                        React.createElement(Emergent, null),
                        feed.priority)),
                    feed.priority_id === 2 && (React.createElement("span", { className: style["text-danger"] },
                        React.createElement(ArrowUp, null),
                        feed.priority)),
                    feed.priority_id === 3 && (React.createElement("span", { className: style["text-info"] },
                        React.createElement(ArrowUp, null),
                        feed.priority)),
                    feed.priority_id === 4 && (React.createElement("span", { className: style["text-info"] },
                        React.createElement(ArrowDown, null),
                        feed.priority)))),
            React.createElement(Row, null,
                React.createElement(Col, { span: 6 },
                    React.createElement("label", { style: { color: "rgba(0, 0, 0, 0.45)" } },
                        t("page.im.imContact.assigneeName"),
                        ":")),
                React.createElement(Col, { span: 17, offset: 1 },
                    React.createElement("span", null,
                        feed.agent.agent_group_name
                            ? feed.agent.agent_group_name + " / "
                            : "",
                        feed.agent.assignee_name))))));
};
export default Ticket;
