/* eslint-disable react/prop-types */
import React, { useState } from 'react';
import { Col, Collapse, Row } from 'udesk-ui';
import { useTranslation } from 'react-i18next';
import includes from 'lodash-es/includes';
import isEqual from 'lodash-es/isEqual';
import style from './index.module.scss';
import UpOutlined from '@ant-design/icons/UpOutlined';
import DownOutlined from '@ant-design/icons/DownOutlined';
import { useSelector } from '../../store/store-hook';
var Panel = Collapse.Panel;
var AccessInfo = function (_a) {
    var accessInfo = _a.accessInfo, imNewPlatforms = _a.imNewPlatforms;
    var PLATFORM_ARR = ['wechat', 'weibo', 'ios', 'android', 'weixin_mini', 'web'];
    var initData = useSelector(function (state) { return state.initData; });
    var t = useTranslation().t;
    var _b = useState('open'), key = _b[0], setKey = _b[1];
    var handleChange = function (key) {
        setKey(key);
    };
    return (React.createElement("div", { className: style['visit-info'] },
        React.createElement(Collapse, { bordered: false, activeKey: key, expandIconPosition: "right", onChange: handleChange, expandIcon: function (_a) {
                var isActive = _a.isActive;
                return (isActive ? React.createElement(UpOutlined, null) : React.createElement(DownOutlined, null));
            } },
            React.createElement(Panel, { showArrow: true, header: React.createElement("h3", { className: style['visit-info-title'] }, t('page.im.customerInfo.device.title')), key: 'open' },
                isEqual(initData.page, 'im') && accessInfo && (React.createElement("div", { className: style['info-list'] },
                    accessInfo.session_code && (React.createElement(Row, null,
                        React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.DialogueID')),
                        React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.session_code))),
                    accessInfo.menu_names && includes(PLATFORM_ARR, accessInfo.platform) && (React.createElement(Row, null,
                        React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.menu')),
                        React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.menu_names))),
                    (accessInfo.platform === 'web' || accessInfo.platform === 'mchat') && (React.createElement(React.Fragment, null,
                        accessInfo.accessUrl && (React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.curUrl')),
                            React.createElement(Col, { className: style['info-content'], span: 16 },
                                React.createElement("a", { href: accessInfo.cur_url, rel: "noopener noreferrer", target: '_blank', title: accessInfo.cur_url },
                                    React.createElement("span", null, accessInfo.cur_url_desc),
                                    accessInfo.cur_url_show)))),
                        accessInfo.accessUrl && (React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.preUrl')),
                            React.createElement(Col, { className: style['info-content'], span: 16 },
                                React.createElement("a", { href: accessInfo.accessUrl, rel: "noopener noreferrer", target: '_blank', title: accessInfo.accessUrl },
                                    React.createElement("span", null, accessInfo.accessUrl_desc),
                                    accessInfo.accessUrl_show)))),
                        accessInfo.src && (React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.searchType')),
                            React.createElement(Col, { className: style['info-content'], span: 16 },
                                React.createElement("a", { href: accessInfo.src_url, rel: "noopener noreferrer", target: '_blank', title: accessInfo.src_url },
                                    React.createElement("span", null, accessInfo.src),
                                    accessInfo.src_url_show)))),
                        accessInfo.web_plugin_name && (React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.web_plugin')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.web_plugin_name))),
                        accessInfo.keyword && (React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('label.keyword')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.keyword))),
                        accessInfo.sysInfo && (React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.os')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.sysInfo))),
                        accessInfo.bowserInfo && (React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.browser')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.bowserInfo))),
                        accessInfo.channel && (React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.customChannel')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.channel))),
                        accessInfo.ip && (React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.IP')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.ip))),
                        accessInfo.session_key && (React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, "session_key"),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.session_key))))),
                    (accessInfo.platform === 'mchat' ||
                        accessInfo.platform === 'weibo' ||
                        accessInfo.platform === 'wechat' ||
                        accessInfo.platform === 'weixin_mini' ||
                        accessInfo.platform === 'qywx') &&
                        accessInfo.src && (React.createElement(Row, null,
                        React.createElement(Col, { className: style['info-title'] }, t('label.source')),
                        React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.src))),
                    (accessInfo.platform === 'android' || accessInfo.platform === 'ios') && (React.createElement(React.Fragment, null,
                        React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.phoneModal')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.phoneModal)),
                        React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.phoneVersion')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.phoneVersion)),
                        React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('label.source')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.src)),
                        React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.netWorkStatus')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.netWorkStatus)),
                        React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.carrier')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.carrier)),
                        React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.scaleScreen')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.scaleScreen)),
                        accessInfo.channel && (React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.customChannel')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.channel))))),
                    accessInfo.platform === 'mchat' && (React.createElement(React.Fragment, null,
                        // 设备型号
                        accessInfo.phoneModal && (React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.phoneModal')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.phoneModal))),
                        // 系统版本号
                        accessInfo.phoneVersion && (React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.phoneVersion')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.phoneVersion))),
                        // 来源
                        accessInfo.src && (React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('label.source')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.src))),
                        // 网络状态
                        accessInfo.networkStatus && (React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.networkStatus')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.networkStatus))),
                        // 运营商
                        accessInfo.carrier && (React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.carrier')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.carrier))),
                        // 分辨率
                        accessInfo.scaleScreen && (React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.scaleScreen')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.scaleScreen))),
                        //自定义渠道信息
                        accessInfo.channel && (React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.customChannel')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.channel))))),
                    accessInfo.platform === 'api' && (React.createElement(React.Fragment, null,
                        React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('label.source')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.src)),
                        accessInfo.channel && (React.createElement(Row, null,
                            React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.customChannel')),
                            React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.channel))))),
                    imNewPlatforms &&
                        imNewPlatforms.filter(function (item) {
                            return item.platform === 'channel_name';
                        }).length > 0 && (React.createElement(Row, null,
                        React.createElement(Col, { className: style['info-title'] }, t('label.source')),
                        React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.src))),
                    accessInfo.day_sub_session_count && (React.createElement(Row, null,
                        React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.chatTimes')),
                        React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.day_sub_session_count))),
                    accessInfo.queue_name && (React.createElement(Row, { style: { minHeight: '20px' } },
                        React.createElement(Col, { className: style['info-title'] }, t('page.im.customerInfo.device.queueList')),
                        React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo.queue_name))))),
                isEqual(initData.page, 'mpv') && accessInfo && (React.createElement("div", { className: style['info-list'] }, accessInfo.sdkName && (React.createElement(Row, null,
                    React.createElement(Col, { className: style['info-title'] }, accessInfo === null || accessInfo === void 0 ? void 0 : accessInfo.sdkType),
                    React.createElement(Col, { className: style['info-content'], span: 16 }, accessInfo === null || accessInfo === void 0 ? void 0 : accessInfo.sdkName)))))))));
};
export default AccessInfo;
