var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
/* eslint-disable jsx-a11y/anchor-is-valid */
import React, { useCallback, useEffect, useMemo, useState } from 'react';
import { Col, Form, message, Row, Select } from 'udesk-ui';
import { useTranslation } from 'react-i18next';
import style from './index.module.scss';
import { getJSON } from '../../../utils/ajax';
import { csApiGetJSON, csApiPutJSON, csApiPostJSON } from '../../../utils/csApi';
import { formatCustomField, getFieldsDefaultValue, isSysField } from '../../../utils/index';
import pick from 'lodash-es/pick';
import uniq from 'lodash-es/uniq';
import isEqual from 'lodash-es/isEqual';
import CustomField from '../../../components/custom-field-container';
import Field from './fields';
import DescField from './desc-fields';
import NameField from './name-fields';
import { useSelector } from '../../../store/store-hook';
var Option = Select.Option;
var CompanyInfoComponent = function (props) {
    var event = props.event, organizationFieldsv2 = props.organizationFieldsv2, sessionKey = props.sessionKey, customerId = props.customerId, organizations = props.organizations, chat = props.chat;
    var t = useTranslation().t;
    var initData = useSelector(function (state) { return state.initData; });
    var _a = useState([]), origanizationField = _a[0], setOriganizationField = _a[1];
    var _b = useState(''), setCopyName = _b[1];
    var _c = useState([]), organizationArr = _c[0], setOrganizationArr = _c[1];
    var _d = useState(''), companyId = _d[0], setCompanyId = _d[1];
    var _e = useState({}), initialValue = _e[0], setInitialValue = _e[1];
    //根据 customer_id请求数据
    var companyForm = Form.useForm()[0];
    // let _organizationFieldsv2: any = [];//用于设置初始化表格
    // let _organizationFieldsv2 = useMemo(() => {
    //     return (organizationFieldsv2 || []).filter((field: any) => {
    //         return field.im_show && field.name && (field.name.indexof('TextField') > -1 || field.name.indexof('SelectField') > -1)
    //     }).map((field: any) => {
    //         return {
    //             ...field,
    //             is_required: field.agent_permission === 1 ? true : false
    //         }
    //     })
    // }, [organizationFieldsv2]);
    var _organizationFields = useMemo(function () {
        return (organizationFieldsv2 || [])
            .filter(function (field) {
            if (isEqual(initData.page, 'im')) {
                return (field.im_show &&
                    field.name &&
                    (field.name.indexOf('TextField') > -1 || field.name.indexOf('SelectField') > -1));
            }
            else if (isEqual(initData.page, 'mpv')) {
                return (field.mpv_show &&
                    field.name &&
                    (field.name.indexOf('TextField') > -1 || field.name.indexOf('SelectField') > -1));
            }
            else {
                return (field.cc_show &&
                    field.name &&
                    (field.name.indexOf('TextField') > -1 || field.name.indexOf('SelectField') > -1));
            }
        })
            .map(function (field) {
            return __assign(__assign({}, field), { is_required: field.agent_permission === 1 ? true : false });
        });
    }, [organizationFieldsv2]);
    useEffect(function () {
        //循环公司自定义字段
        var organFields = formatCustomField({
            fields: _organizationFields,
            trigger: 'onBlur',
        });
        //自定义字段的formItem
        setOriganizationField(organFields);
    }, [_organizationFields]);
    //根据customerId  session_key monitor _time 请求已经有的公司
    var getOrganizationArr = useCallback(function (params) {
        var url = 'im/customer';
        getJSON(url, params)
            .then(function (res) {
            if (res.code && res.code === 1000) {
                setOrganizationArr(res.organizations);
                changeCompany(res.customer.default_organization_id);
            }
        })
            .catch(function () { });
    }, []);
    useEffect(function () {
        //只加载一次  用来赋初始值
        var params = {
            id: customerId,
            session_key: sessionKey,
            monitor: true,
        };
        getOrganizationArr(params);
    }, [customerId, getOrganizationArr, sessionKey]);
    // 点击已选择的公司  进入公司详情
    var goCompany = useCallback(function (companyId) {
        // 如果没有选择  不进行操作
        // 判断点击的是否是选择的字的地方  其他地方不触发
        if (companyId) {
            props.event.transitionToRoute &&
                props.event.transitionToRoute({
                    route: 'crm.organization.show',
                    path: companyId,
                });
            return false;
        }
    }, [props.event]);
    //封装form initValue 初始化表格的时候
    //疑问 获取初始值的值  解决  数据是通过接口拿的
    var getValues = useCallback(function (_organization) {
        var initValues = getFieldsDefaultValue({
            fields: _organizationFields,
            values: _organization.custom_fields || {},
        }) || {};
        initValues = Object.assign({}, initValues, {
            domains: _organization.domains,
            org_email_suffix: _organization.org_email_suffix,
            description: _organization.description,
            name: _organization.name,
        });
        return initValues;
    }, [_organizationFields]);
    var loadData = useCallback(function (id) {
        if (!id) {
            return;
        }
        csApiGetJSON("/cs/ts/api/organizations/".concat(id))
            .then(function (res) { return res.data; })
            .then(function (res) {
            if (res.code === 1000) {
                var formFieldsValue = pick(res.organization, 'name', 'domains', 'org_email_suffix', 'description');
                var values = getValues(res.organization);
                setInitialValue(values);
                companyForm.setFieldsValue(values);
                setCopyName(formFieldsValue.name);
            }
        })
            .catch(function (err) {
            message.error(t('page.im.customerInfo.organization.failedToGetData'));
        });
    }, [companyForm, getValues, t]);
    useEffect(function () {
        var _a;
        if (organizations && organizations.length > 0) {
            //如果organizations有长度  取默认的第一个值
            var getCompanyId = (_a = organizations[0]) === null || _a === void 0 ? void 0 : _a.id;
            setCompanyId(getCompanyId);
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    useEffect(function () {
        if (companyId) {
            loadData(companyId);
        }
    }, [companyId, loadData]);
    var companyChildrenOption = organizationArr &&
        organizationArr.map(function (item, index) {
            return (React.createElement(Option, { value: item.id, key: item.id }, item.name));
        });
    //设置companyId 根据当前Id 判断是新增还是修改 如果value 是--
    var changeCompany = function (value, option) {
        setCompanyId(value);
        if (value === '') {
            companyForm.setFieldsValue(Object.keys(initialValue).reduce(function (init, curent) {
                init[curent] = '';
                return init;
            }, {}));
        }
    };
    //新建公司之后调用 putcustomers (put 方法) 刷新当前公司的下拉选项
    var putCustomer = useCallback(function (customers, id) {
        var url = '/cs/ts/api/customers/' + customerId;
        csApiPutJSON(url, customers).then(function (res) { return res.data; }).then(function (res) {
            if (res.code && res.code === 1000) {
                setOrganizationArr(res.organizations);
                setCompanyId(id);
                event.updateChat(chat, {
                    organizations: res.organizations,
                    customer: res.customer,
                });
                //调用Ember方法
            }
            else {
                message.error(res.code_message || (res.exceptopn && res.exceptopn.message) || t('tip.error.saveTry'));
            }
        });
    }, [chat, customerId, event, t]);
    function judgeValueChanged(changedValue, initialValue) {
        //只判断当前的修改值
        var key = Object.keys(changedValue)[0];
        return changedValue[key] !== initialValue[key];
    }
    var submitFn = useCallback(function (params) {
        var submitFnWay = companyId ? csApiPutJSON : csApiPostJSON;
        // let way = companyId ? 'putJSON' : 'postJSON';
        var url = companyId ? "/cs/ts/api/organizations/".concat(companyId) : '/cs/ts/api/organizations';
        submitFnWay(url, params)
            .then(function (res) { return res.data; })
            .then(function (res) {
            if (res.code === 1000) {
                var values = getValues(res.organization || {});
                companyForm.setFieldsValue(values);
                //将返回的id 设置为select 项
                // setCompanyId(res.organization.id);
                var _organizations = organizationArr.map(function (item, index) {
                    return item.id;
                });
                _organizations = __spreadArray(__spreadArray([], _organizations, true), [res.organization.id], false);
                var params_1 = {};
                params_1.customer = {
                    organizations: uniq(_organizations),
                };
                putCustomer(params_1, res.organization.id);
                message.info(t('tip.success.save'));
            }
            else {
                message.error(res.code_message || (res.exceptopn && res.exceptopn.message) || t('tip.error.saveTry'));
            }
        })
            .catch(function () { });
    }, [companyForm, companyId, getValues, organizationArr, putCustomer, t]);
    var onValueChange = function (changedValues, values) {
        var changedKey = Object.keys(changedValues)[0];
        var _isSysField = isSysField(changedKey);
        var params = _isSysField
            ? { organization: changedValues }
            : { organization: { custom_fields: changedValues } };
        params.mode = 'quick_edit';
        companyForm
            .validateFields(Object.keys(changedValues))
            .then(function () {
            submitFn(params);
        })
            .catch(function (err) {
            console.log(err);
            var key = Object.keys(changedValues)[0];
            var canSubmit = true;
            err.errorFields.forEach(function (item) {
                if (item.name[0] === key) {
                    canSubmit = false;
                }
            });
            if (canSubmit) {
                submitFn(params);
            }
        });
    };
    return (React.createElement("div", { className: style['company-info-page'] },
        React.createElement(Form, { form: companyForm, layout: "vertical", name: "companyInfo", onValuesChange: onValueChange },
            organizationArr.length > 0 && (React.createElement(Form.Item, null,
                React.createElement(Row, { align: "middle" },
                    React.createElement(Col, { span: 12 },
                        React.createElement(Select, { getPopupContainer: function (triggerNode) { return triggerNode.parentNode; }, value: companyId, onChange: changeCompany },
                            React.createElement(Option, { value: "" }, " -- "),
                            companyChildrenOption)),
                    React.createElement(Col, { style: { marginLeft: '15px' } },
                        React.createElement("a", { onClick: function () { return goCompany(companyId); } },
                            "[",
                            t('page.im.customerInfo.organization.companyDetail'),
                            "]"))))),
            React.createElement(Form.Item, { label: t('page.im.customerInfo.organization.org_email_suffix'), name: "org_email_suffix", trigger: "onBlur" },
                React.createElement(Field, { trigger: 'onBlur' })),
            React.createElement(Form.Item, { label: t('page.im.customerInfo.organization.domains'), name: "domains", trigger: "onBlur" },
                React.createElement(Field, { trigger: 'onBlur' })),
            React.createElement(Form.Item, { label: t('page.im.customerInfo.organization.name'), name: "name", rules: [
                    {
                        required: true,
                        message: t('page.im.customerInfo.organization.validateFail'),
                    },
                ], trigger: "onBlur" },
                React.createElement(NameField, { trigger: 'onBlur' })),
            React.createElement(Form.Item, { label: t('page.im.customerInfo.organization.description'), name: "description", trigger: "onBlur" },
                React.createElement(DescField, { trigger: 'onBlur' })),
            origanizationField.length > 1 && React.createElement(CustomField, { fields: origanizationField }))));
};
export default CompanyInfoComponent;
