var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useCallback, useEffect, useState } from "react";
import { Button, Input, message } from "udesk-ui";
import style from "./index.module.scss";
import { EmailWordOrder, Warning } from "../../../../components/icon/icon";
import { deleteJSON, getJSON } from "../../../../utils";
import Merge from "./merge";
import { useTranslation } from "react-i18next";
import CopyComponent from "../../../../components/copy";
import Qs from "qs";
import { useSelector } from "../../../../store/store-hook";
var Email = function (props) {
    var _a;
    var t = useTranslation().t;
    var _b = useState(props.value || ""), value = _b[0], setValue = _b[1]; // 初始值
    var _c = useState(false), showRepeat = _c[0], setShowRepeat = _c[1]; //  显示合并信息
    var _d = useState(false), showMerge = _d[0], setShowMerge = _d[1]; //  显示客户合并Modal
    var _e = useState({}), repeatEmail = _e[0], setRepeatEmail = _e[1]; // 缓存合并的数据信息
    var _f = useState("客户合并"), title = _f[0], setTitle = _f[1];
    var _g = useState(false), reservationed = _g[0], setReservationed = _g[1]; // 是否已经预约
    var initData = useSelector(function (state) { return state.initData; });
    var chat = initData.chat;
    // 动态设置value
    useEffect(function () {
        setValue(props.value || "");
    }, [props.value]);
    // 动态设置已预约合并信息
    useEffect(function () {
        if (props.toCustomer &&
            props.toCustomer.value &&
            props.toCustomer.label &&
            props.toCustomer.reservation_reason === "email") {
            setRepeatEmail(props.toCustomer);
            setReservationed(true);
        }
        else {
            setRepeatEmail({});
            setReservationed(false);
        }
    }, [
        props.toCustomer.value,
        props.toCustomer.label,
        props.toCustomer.reservation_reason,
        props.toCustomer,
    ]);
    // 值变化
    var handleChange = useCallback(function (e) {
        setValue(e.target.value);
    }, []);
    // const handleChange = (e: React.FocusEvent<HTMLInputElement>) => {
    //     setValue(e.target.value);
    // }
    // 失去焦点时,先验证是否有重复邮箱,如果有,显示重复提醒,并可以合并, 留言直接合并, 当前会话,预约合并
    var handleBlur = useCallback(function (e) {
        var changeFunction = props[props.trigger || "onChange"];
        var _value = e.target.value;
        var customer = props.customer || {};
        var params = {
            customer: {
                id: customer.id,
                email: e.target.value,
            },
        };
        getJSON("/customers/check_duplication?" + Qs.stringify(params), {})
            .then(function (res) {
            if (res.code !== 1000) {
                message.error(t("error.repeatEmailFail"));
            }
            else {
                var dup = res.duplications || {};
                // 有重复邮箱,显示预约合并按钮 ? 如果电话已经预约了 ?
                if (dup.email && dup.email.id) {
                    setShowRepeat(true);
                    setRepeatEmail({
                        label: dup.email.name,
                        value: dup.email.id,
                        key: dup.email.id,
                    });
                }
                else {
                    if (!reservationed) {
                        setShowRepeat(false);
                        setRepeatEmail({});
                    }
                    if (changeFunction) {
                        changeFunction(_value);
                    }
                }
            }
        })
            .catch(function () { });
    }, [props, reservationed, t]);
    // 跳转到客服系统客户详情页
    var transferToCustomer = useCallback(function () {
        props.event.transitionToRoute &&
            props.event.transitionToRoute({
                route: "crm.customer.show",
                path: repeatEmail.value,
            });
    }, [props.event, repeatEmail.value]);
    // 显示预约modal
    var showMergeModal = useCallback(function () {
        var _a;
        if ((_a = props.selfChat) === null || _a === void 0 ? void 0 : _a.history) {
            setTitle(t("udMerge.mergeCustomer"));
        }
        else {
            setTitle(t("udMerge.appointmentMergeCustomer"));
        }
        setShowMerge(true);
    }, [(_a = props.selfChat) === null || _a === void 0 ? void 0 : _a.history, t]);
    // 取消立即预约
    var cancelReservation = useCallback(function () {
        var customerId = props.customer.id;
        var imSubSessionId = props.imSubSessionId;
        deleteJSON("/customer_merge_reservation", {
            from_customer_id: customerId,
            im_sub_session_id: imSubSessionId,
        })
            .then(function (res) {
            // 取消之后,通知父页面, 可以再次预约
            setReservationed(false);
            setShowRepeat(true);
            setRepeatEmail({});
            props.setToCustomer({});
        })
            .catch(function (err) { });
    }, [props]);
    // const cancelReservation = () => {
    //     deleteJSON('/customer_merge_reservation', {
    //         from_customer_id: props.customer.id,
    //         im_sub_session_id: props.imSubSessionId
    //     }).then((res: any) => {
    //         // 取消之后,通知父页面, 可以再次预约
    //         setReservationed(false);
    //         setShowRepeat(true);
    //         setRepeatEmail({})
    //         props.setToCustomer({});
    //     }).catch(err => {
    //     })
    // }
    // 预约回调
    // isSelf: true 表示其他客户合并到了自己身上, false 表示自己合到了其他客户身上,自己有可能被删除
    var handleMerge = useCallback(function (isSelf, repeatInfo, needMerge) {
        var chat = props.selfChat || {};
        var history = chat.history || false;
        var setToCustomer = props.setToCustomer;
        var event = props.event;
        setShowRepeat(false);
        setReservationed(true);
        setRepeatEmail(repeatInfo);
        setToCustomer &&
            setToCustomer(__assign(__assign({}, repeatInfo), { reservation_reason: "email" }));
        if (history && needMerge) {
            event &&
                event.updateChat &&
                event.updateChat({
                    chat: props.selfChat,
                    key: "isDeletedCustomer",
                    value: !isSelf,
                });
        }
    }, [props.selfChat, props.event, props.setToCustomer]);
    var createEmailTicket = useCallback(function () {
        var event = props.event;
        event && event.createEmailTicket(chat);
    }, [props.event, chat]);
    return (React.createElement("div", { className: "".concat(style["flex-row"], " ").concat(style["flex-row-item-center"]) },
        React.createElement("div", { className: style["email-input"] },
            React.createElement(CopyComponent, { text: value, switchFlag: props.switchFlag },
                React.createElement(Input, { value: value, onChange: handleChange, onBlur: handleBlur })),
            React.createElement(EmailWordOrder, { title: "新建邮件工单", onClick: createEmailTicket, style: {
                    fontSize: "18px",
                    color: "green",
                    marginLeft: "10px",
                    cursor: "pointer",
                } })),
        showRepeat && (React.createElement("div", { className: style["repeat-box"] },
            React.createElement(Warning, { className: style["repeat-icon"] }),
            React.createElement("div", null,
                "\u6B64\u7535\u8BDD\u4E0E\u5DF2\u6709\u5BA2\u6237 \u201C",
                " ",
                React.createElement("span", { style: { color: "#00B38B" }, onClick: transferToCustomer },
                    repeatEmail.label,
                    " "),
                "\u201D \u91CD\u590D\uFF0C",
                props.selfChat.history ? (React.createElement(Button, { onClick: showMergeModal, size: "small" }, t("udMerge.merge"))) : (React.createElement(React.Fragment, null,
                    t("udMerge.afterMergeConversation"),
                    " ",
                    React.createElement(Button, { onClick: showMergeModal, size: "small" }, t("udMerge.appointmentMerge"))))))),
        reservationed && (React.createElement("div", { className: style["repeat-box"] },
            React.createElement(Warning, { className: style["repeat-icon"] }),
            React.createElement("div", null,
                t("udMerge.hasAppointment"),
                " \u201C",
                React.createElement("span", { style: { color: "#00B38B" }, onClick: transferToCustomer },
                    repeatEmail.label,
                    " "),
                "\u201D",
                React.createElement(Button, { onClick: cancelReservation, size: "small" }, t("udMerge.cancelReservation"))))),
        React.createElement(Merge, { title: title, concatVisible: showMerge, customer: props.customer, repeatCustomer: repeatEmail, imSubSessionId: props.imSubSessionId, cancelCombineCustomer: setShowMerge, mergeFn: handleMerge, companyCategoryConfig: props.companyCategoryConfig, history: props.selfChat.history, reason: "email" })));
};
export default Email;
