var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useEffect, useState, useMemo, useCallback } from "react";
import CustomFieldItem from "../../../../components/custom-field-container/field-item";
import TagField from "../../../ticket/components/tag-field";
import DescOrName from "./desc-or-name";
import CustomerInfoPhone from "./phone-formItem";
import Email from "./email";
import { Form } from "udesk-ui/es";
import { getJSON } from "../../../../utils";
import OrgSelect from "./org-select";
import { useTranslation } from "react-i18next";
var CustomerFields = function (_a) {
    var currentUser = _a.currentUser, smsapp = _a.smsapp, customerFields = _a.customerFields, chat = _a.chat, roleCan = _a.roleCan, customer = _a.customer, company = _a.company, organizations = _a.organizations, organizationFields = _a.organizationFields, companyCategoryConfig = _a.companyCategoryConfig, event = _a.event, imSubSessionId = _a.imSubSessionId, switchFlag = _a.switchFlag, _b = _a.isFormItem, isFormItem = _b === void 0 ? true : _b, isAdmin = _a.isAdmin, user = _a.user, agents = _a.agents, props = __rest(_a, ["currentUser", "smsapp", "customerFields", "chat", "roleCan", "customer", "company", "organizations", "organizationFields", "companyCategoryConfig", "event", "imSubSessionId", "switchFlag", "isFormItem", "isAdmin", "user", "agents"]);
    var t = useTranslation().t;
    var _c = useState({}), toCustomer = _c[0], setToCustomer = _c[1];
    function isCustomField(item) {
        var type = item.field ? item.field.id || "" : "";
        return type.indexOf("SelectField") > -1 || type.indexOf("TextField") > -1;
    }
    var validatorEmail = useCallback(function (rule, values) {
        var emaillReg = /^[a-zA-Z0-9.!#$%&’*+/=?^_`{|}~-]+@[a-zA-Z0-9-]+(?:\.[a-zA-Z0-9-]+)*$/;
        if (!values || emaillReg.test(values)) {
            return Promise.resolve();
        }
        else {
            return Promise.reject(t("error.emailError"));
        }
    }, [t]);
    useEffect(function () {
        if (chat.history) {
            return;
        }
        getJSON("/customer_merge_reservation", {
            from_customer_id: customer.id,
            im_sub_session_id: imSubSessionId,
        })
            .then(function (res) {
            if (res.code === 1000) {
                var to_customer = res.to_customer;
                if (!to_customer) {
                    // 都没有预约, 则都可以显示立即预约按钮
                    setToCustomer({});
                }
                else {
                    setToCustomer({
                        key: to_customer.id,
                        label: to_customer.nick_name,
                        value: to_customer.id,
                        reservation_reason: res.reservation_reason,
                    });
                }
            }
        })
            .catch(function (err) { });
    }, [imSubSessionId, customer.id, chat.history]);
    var customerFieldsMap = useMemo(function () {
        return customerFields.map(function (fieldItem) {
            // 自定义字段
            if (isCustomField(fieldItem)) {
                return (React.createElement(CustomFieldItem, { key: fieldItem.field.id, switchFlag: switchFlag, agents: agents, fieldItem: fieldItem, isFormItem: isFormItem }));
            }
            if (fieldItem.name === "tags") {
                return (React.createElement(Form.Item, { key: fieldItem.name, label: t("label.tag"), name: "tags", trigger: "onBlur" },
                    React.createElement(TagField, __assign({}, fieldItem))));
            }
            else if (fieldItem.name === "description") {
                return (React.createElement(Form.Item, { key: fieldItem.name, label: t("label.description"), name: "description", trigger: "onBlur" },
                    React.createElement(DescOrName, __assign({ switchFlag: switchFlag }, fieldItem))));
            }
            else if (fieldItem.name === "name") {
                return (React.createElement(Form.Item, { key: fieldItem.name, label: t("label.name"), name: "nick_name", trigger: "onBlur", rules: [
                        {
                            required: true,
                            message: t("error.nameEmpty"),
                        },
                    ] },
                    React.createElement(DescOrName, __assign({ switchFlag: switchFlag }, fieldItem))));
            }
            else if (fieldItem.name === "cellphone") {
                return (React.createElement(Form.Item, { key: fieldItem.name, label: t("label.phone"), name: "cellphones", trigger: "onBlur" },
                    React.createElement(CustomerInfoPhone, __assign({}, fieldItem, { customer: customer, imSubSessionId: imSubSessionId, event: event, selfChat: {
                            history: chat.history,
                            jid: chat.jid,
                            session_key: chat.session_key,
                            im_sub_session_id: chat.im_sub_session_id,
                        }, toCustomer: toCustomer, companyCategoryConfig: companyCategoryConfig, setToCustomer: function (config) { return setToCustomer(config); }, switchFlag: switchFlag, currentUser: currentUser, smsapp: smsapp, roleCan: roleCan, isAdmin: isAdmin, user: user }))));
            }
            else if (fieldItem.name === "organization") {
                return (React.createElement(Form.Item, { key: fieldItem.name, label: t("label.company"), name: "organizations", trigger: "onChange" },
                    React.createElement(OrgSelect, __assign({}, fieldItem, { trigger: "onChange", customer: customer, event: event, organizations: organizations, organizationFields: organizationFields, canAdd: company.support_multi_organizations, canCreate: roleCan.add_new_organization, switchFlag: switchFlag }))));
            }
            else if (fieldItem.name === "email") {
                return (React.createElement(Form.Item, { key: fieldItem.name, label: t("label.email"), name: "email", trigger: "onBlur", rules: [{ validator: validatorEmail }] },
                    React.createElement(Email, __assign({}, fieldItem, { customer: customer, imSubSessionId: imSubSessionId, event: event, selfChat: {
                            history: chat.history,
                            jid: chat.jid,
                            session_key: chat.session_key,
                            im_sub_session_id: chat.im_sub_session_id,
                        }, toCustomer: toCustomer, companyCategoryConfig: companyCategoryConfig, setToCustomer: function (config) { return setToCustomer(config); }, switchFlag: switchFlag }))));
            }
            else {
                return "";
            }
        });
    }, [
        chat.history,
        chat.im_sub_session_id,
        chat.jid,
        chat.session_key,
        company.support_multi_organizations,
        companyCategoryConfig,
        currentUser,
        customer,
        customerFields,
        event,
        imSubSessionId,
        isAdmin,
        isFormItem,
        organizationFields,
        organizations,
        roleCan,
        smsapp,
        switchFlag,
        t,
        toCustomer,
        user,
        validatorEmail,
    ]);
    return (React.createElement(React.Fragment, null, customerFields.length > 0 && customerFieldsMap));
};
export default CustomerFields;
