var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { useCallback, useEffect, useState } from "react";
import { message, Modal, Select, Spin } from "udesk-ui";
import { useTranslation } from "react-i18next";
import { csApiPostJSON } from "../../../../utils/csApi";
import style from "./index.module.scss";
import { MinusOutlined, PlusOutlined } from "@ant-design/icons";
import CopyComponent from "../../../../components/copy";
import CreateOrg from "../create-org";
import cloneDeep from "lodash-es/cloneDeep";
import includes from "lodash-es/includes";
var Option = Select.Option;
var OrgSelect = function (props) {
    var t = useTranslation().t;
    var _a = useState(false), showModal = _a[0], setShowModal = _a[1];
    var _b = useState([]), optionsArr = _b[0], setOptionsArr = _b[1];
    var _c = useState([]), valueList = _c[0], setValueList = _c[1];
    var _d = useState(false), fetching = _d[0], setFetching = _d[1]; //无数据时展示
    useEffect(function () {
        setValueList(function () {
            if (Array.isArray(props.value) && props.value.length > 0) {
                return props.value.map(function (item) {
                    return {
                        label: item.name || item.label,
                        value: item.id || item.value,
                    };
                });
            }
            else {
                return [
                    {
                        label: "",
                        value: "",
                    },
                ];
            }
        });
    }, [props.value]);
    var getOrg = useCallback(function (query) {
        if (query === void 0) { query = ""; }
        setFetching(true);
        csApiPostJSON("/cs/ts/api/organizations/search", { query: query }).then(function (res) { return res.data; })
            .then(function (res) {
            if (res.code === 1000) {
                setOptionsArr(res.organizations.map(function (item) {
                    return {
                        value: item.id,
                        label: item.name,
                    };
                }));
            }
            else {
                message.error(t("error.requestFailed"));
            }
        })
            .catch(function (err) { })
            .finally(function () {
            setFetching(false);
        });
    }, [t]);
    // 获取焦点时请求下数据
    var handleFocus = useCallback(function () {
        getOrg("");
    }, [getOrg]);
    // const handleFocus = () => {
    //     getOrg('');
    // }
    var handleSearch = useCallback(function (value) {
        getOrg(value);
    }, [getOrg]);
    // const handleSearch = (value: string) => {
    //     getOrg(value);
    // }
    var handleChange = useCallback(function (value, index) {
        var list = cloneDeep(valueList);
        //改变当前选择的公司的值
        if (value === undefined) {
            list.splice(index, 1);
        }
        else {
            list = list.map(function (item, idx) {
                if (index === idx) {
                    return {
                        label: value.label,
                        value: value.value,
                    };
                }
                else {
                    return item;
                }
            });
        }
        // list.splice(index, 1, value || {} as AntdSelectOptions)
        // 重新赋值
        if (list && list.length > 0) {
            setValueList(__spreadArray([], list, true));
        }
        else {
            setValueList([
                {
                    label: "",
                    value: "",
                },
            ]);
        }
        setFetching(false);
        var changeFunction = props[props.trigger];
        if (changeFunction) {
            // const _value = list.map(item => item.value).filter(t => t);
            // changeFunction(_value.length ? _value : '');
            changeFunction(list);
        }
    }, [props, valueList]);
    // 添加新的公司
    var addOrg = useCallback(function () {
        var canAdd = true;
        //如果有公司还没有选  禁止新加
        valueList.forEach(function (item) {
            if (!item.value) {
                canAdd = false;
                return;
            }
        });
        canAdd &&
            setValueList(__spreadArray([], valueList.concat({ value: "", label: "" }), true));
    }, [valueList]);
    // 删除公司
    var deleteOrg = useCallback(function (index) {
        var list = cloneDeep(valueList);
        list.splice(index, 1);
        setValueList(list);
        var changeFunction = props[props.trigger];
        if (changeFunction) {
            // const _value = list.map(item => item.value).filter(t => t);
            // changeFunction(_value.length ? _value : '');
            changeFunction(list);
        }
    }, [props, valueList]);
    // const handleOk = (companyInfo: any) => {
    //     setValueList([...valueList.concat(companyInfo as AntdSelectOptions)])
    // }
    var changeOrgValue = useCallback(function (info) {
        var list = [];
        if (props.canAdd) {
            list = __spreadArray([], valueList.concat(info), true);
        }
        else {
            list = [info];
        }
        setValueList(list);
        setShowModal(false);
        var changeFunction = props[props.trigger];
        if (changeFunction) {
            // const _value = list.map(item => item.value).filter(t => t);
            // changeFunction(_value.length ? _value : '');
            changeFunction(list);
        }
    }, [props, valueList]);
    // 点击已选择的公司  进入公司详情
    var goCompany = useCallback(function (e, item) {
        // 如果没有选择  不进行操作
        // 判断点击的是否是选择的字的地方  其他地方不触发
        if (e.target.className === "#{$prefix}-select-selection-item") {
            if (item.value) {
                props.event.transitionToRoute &&
                    props.event.transitionToRoute({
                        route: "crm.organization.show",
                        path: item.value,
                    });
                return false;
            }
        }
    }, [props.event]);
    return (React.createElement("div", { className: style["org-selet-container"] },
        valueList.map(function (item, index) {
            return (React.createElement("div", { key: item.value, className: "".concat(style["org-item"], " ").concat(item.value ? style["link-class"] : "") },
                React.createElement(CopyComponent, { text: item.label, switchFlag: props.switchFlag, key: item.value },
                    React.createElement(Select, { key: item.value, 
                        // onClick={(e) => goCompany(e, item)}
                        showSearch: true, allowClear: true, placeholder: "\u8F93\u5165\u5173\u952E\u5B57\u67E5\u8BE2\u516C\u53F8", value: item, labelInValue: true, defaultActiveFirstOption: false, showArrow: true, filterOption: false, onFocus: handleFocus, onSearch: handleSearch, onChange: function (item) { return handleChange(item, index); }, notFoundContent: fetching ? React.createElement(Spin, { size: "small" }) : "无数据" }, optionsArr.length &&
                        optionsArr.map(function (option) {
                            var listIds = valueList.map(function (_l) { return _l.value || _l; });
                            if (!includes(listIds, option.value)) {
                                return (React.createElement(Option, { key: option.value, value: option.value }, option.label));
                            }
                            else {
                                return "";
                            }
                        }))),
                props.canAdd && (React.createElement(React.Fragment, null, !index ? (React.createElement("div", { onClick: addOrg, className: style["add-org"] },
                    React.createElement(PlusOutlined, null))) : (React.createElement("div", { onClick: function () { return deleteOrg(index); }, className: style["add-org"] },
                    React.createElement(MinusOutlined, null)))))));
        }),
        props.canCreate && valueList.length < 20 && (React.createElement("div", { className: style["create-org"], onClick: function () { return setShowModal(true); }, style: { cursor: "pointer", display: "inline-block" } },
            React.createElement(PlusOutlined, null),
            t("page.im.customerInfo.customer.add"))),
        React.createElement(Modal, { title: t("page.im.customerInfo.customer.add"), visible: showModal, footer: null, forceRender: true, width: 700, 
            // onOk={changeOrgValue}
            onCancel: function () { return setShowModal(false); }, bodyStyle: { padding: "20px 0" } },
            React.createElement(CreateOrg, { onSave: changeOrgValue, organizationFields: props.organizationFields, onCancel: function () { return setShowModal(false); } }))));
};
export default OrgSelect;
