import React, { useCallback, useEffect, useState } from 'react';
import { Button, message, Modal, Tooltip } from 'udesk-ui';
import { useTranslation } from 'react-i18next';
import style from '../index.module.scss';
import { BlackList, ShiftOut } from '../../../components/icon/icon';
import { useDispatch } from '../../../store/store-hook';
import { useSelector } from '../../../store/store-hook';
import { csApiPutJSON } from "../../../utils/csApi";
var CustomerInfoDetail = function (_a) {
    var _b = _a.customer, customer = _b === void 0 ? {} : _b, company = _a.company, event = _a.event, chat = _a.chat;
    var dispatch = useDispatch();
    var t = useTranslation().t;
    var initData = useSelector(function (state) { return state.initData; });
    var isCustomerOwnerOn = company.is_customer_owner_on;
    var _c = useState(customer.level || 'normal'), level = _c[0], setLevel = _c[1];
    var _d = useState(false), block = _d[0], setBlock = _d[1];
    var _e = useState(false), modal = _e[0], setModal = _e[1];
    var roleCan = useSelector(function (state) { return state.roleCan; });
    useEffect(function () {
        setLevel(customer.level || 'normal');
    }, [customer.level]);
    useEffect(function () {
        setBlock(customer.is_blocked || false);
    }, [customer.is_blocked]);
    var toggleVip = useCallback(function () {
        csApiPutJSON("/cs/ts/api/customers/".concat(customer.id), {
            customer: {
                level: level === 'vip' ? 'normal' : 'vip',
            },
        }).then(function (res) { return res.data; })
            .then(function (res) {
            if (res.code === 1000) {
                setLevel(level === 'vip' ? 'normal' : 'vip');
                event.updateChatCustomer(res.customer);
                message.info(t('tip.success.save'));
            }
            else {
                message.error(res.code_message || (res.exceptopn && res.exceptopn.message) || t('tip.error.saveTry'));
            }
        })
            .catch(function (err) {
            message.error(t('tip.error.saveTry'));
        });
    }, [customer.id, event, level, t]);
    var goCustomer = useCallback(function () {
        event.transitionToRoute &&
            event.transitionToRoute({
                route: 'crm.customer.show',
                path: customer.id,
            });
    }, [customer.id, event]);
    var goBlock = useCallback(function () {
        csApiPutJSON("/cs/ts/api/customers/".concat(customer.id, "/toggle_block"))
            .then(function (res) { return res.data; })
            .then(function (res) {
            if (res.code === 1000) {
                setBlock(function (prev) {
                    if (prev) {
                        message.success(t('page.im.customerInfo.cancel_blocked'));
                    }
                    else {
                        message.success(t('page.im.customerInfo.blocked'));
                    }
                    event.updateChat &&
                        event.updateChat({
                            chat: chat,
                            updateProps: {
                                customer: {
                                    is_blocked: !prev,
                                },
                            },
                        });
                    return !prev;
                });
                setModal(false);
            }
            else {
                message.error(res.code_message || (res.exceptopn && res.exceptopn.message) || t('tip.error.saveTry'));
            }
        })
            .catch(function (err) {
            message.error(t('tip.error.saveTry'));
        });
    }, [chat, customer.id, dispatch, t]);
    return (React.createElement("div", { className: style['customer-info-header-container'] },
        React.createElement("div", { className: style['customer-info-header'] },
            React.createElement("div", { className: style['customer-info-header-left'] },
                React.createElement("div", { className: style['customer-info-uid'] },
                    "uid: ",
                    customer.uid),
                React.createElement(Tooltip, { placement: "right", title: level === 'vip'
                        ? t('page.im.customerInfo.customer.enum.level.cancelvip')
                        : t('page.im.customerInfo.customer.enum.level.settingvip') },
                    React.createElement("div", { onClick: toggleVip, className: level === 'vip' ? style['vip-customer-box'] : style['common-customer-box'] }, level === 'vip' ? 'VIP' : t('page.im.customerInfo.customer.enum.level.normal')))),
            !!roleCan.defriend_customer && (React.createElement("div", { className: style['customer-info-header-right'] },
                block && (React.createElement(React.Fragment, null,
                    React.createElement(ShiftOut, null),
                    React.createElement("span", { className: style['go-back-list'], onClick: goBlock }, '移出'))),
                !block && (React.createElement(React.Fragment, null,
                    React.createElement(BlackList, null),
                    React.createElement("span", { className: style['go-back-list'], onClick: function () { return setModal(true); } }, t('label.block')))),
                !(initData === null || initData === void 0 ? void 0 : initData.sdk) && (React.createElement(Button, { size: 'small', onClick: goCustomer }, t('label.detail')))))),
        React.createElement("div", { className: style['counts-1'] },
            React.createElement("div", { className: style['count-item'] },
                React.createElement("span", { className: style['count-item-title'] }, t('label.callRecord')),
                React.createElement("span", { className: style['count-item-count'] }, customer.calls_count || 0)),
            React.createElement("div", { className: style['count-item'] },
                React.createElement("span", { className: style['count-item-title'] }, t('label.imRecord')),
                React.createElement("span", { className: style['count-item-count'] }, customer.im_sub_sessions_count || 0)),
            React.createElement("div", { className: style['count-item'] },
                React.createElement("span", { className: style['count-item-title'] }, t('label.ticket')),
                React.createElement("span", { className: style['count-item-count'] }, customer.ticket_count || 0)),
            React.createElement("div", { className: style['count-item'] },
                React.createElement("span", { className: style['count-item-title'] }, t('label.videoRecord')),
                React.createElement("span", { className: style['count-item-count'] }, customer.video_records_count || 0)),
            isCustomerOwnerOn && (React.createElement(React.Fragment, null,
                React.createElement("div", { className: style['count-item'] },
                    React.createElement("span", { className: style['count-item-title'] }, t('label.owner')),
                    React.createElement("span", { className: style['count-item-count'] }, customer.owner_name)),
                React.createElement("div", { className: style['count-item'] },
                    React.createElement("span", { className: style['count-item-title'] }, t('label.ownerGroup')),
                    React.createElement("span", { className: style['count-item-count'] }, customer.owner_group_name))))),
        React.createElement(Modal, { title: "\u786E\u8BA4\u62C9\u9ED1", visible: modal, onOk: goBlock, onCancel: function () { return setModal(false); }, okText: t('confirm'), cancelText: t('cancel') },
            React.createElement("p", null, "\u786E\u5B9A\u8981\u62C9\u9ED1\u8FD9\u4E2A\u5BA2\u6237\u5417"))));
};
export default CustomerInfoDetail;
