var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useEffect, useState } from 'react';
import CustomerInfoForm from './form';
import CompanyInfoComponent from '../company-info/company-info';
import style from '../index.module.scss';
import isEqual from 'lodash-es/isEqual';
import { csApiGetJSON } from '../../../utils/csApi';
import { useSelector } from '../../../store/store-hook';
var CustomerInfo = function (props) {
    var _a = props.chat, chat = _a === void 0 ? {} : _a, event = props.event, organizationFieldsv2 = props.organizationFieldsv2, organizationFields = props.organizationFields, organizations = props.organizations;
    var customer = chat.customer, imSubSessionId = chat.im_sub_session_id, customerId = chat.customer_id, sessionKey = chat.session_key;
    var initData = useSelector(function (state) { return state.initData; });
    //tab切换状态  客户信息 customer 公司信息 org
    var _b = useState(''), type = _b[0], setType = _b[1];
    var _c = useState(false), showOrg = _c[0], setShowOrg = _c[1];
    /**
  cc_show: false
    code: 1000
    im_priority_display: false
    im_show: true
 */
    useEffect(function () {
        var URL = '/cs/ts/api/custom_fields/organization_setting';
        csApiGetJSON(URL).then(function (res) { return res.data; })
            .then(function (res) { return res.data; })
            .then(function (res) {
            if (res.code === 1000) {
                if (isEqual(initData.page, 'im')) {
                    setShowOrg(res.im_show);
                    setType(res.im_show && res.im_priority_display ? 'org' : 'customer');
                }
                else if (isEqual(initData.page, 'mpv')) {
                    setShowOrg(res.mpv_show);
                    setType(res.mpv_show && res.im_priority_display ? 'org' : 'customer');
                }
                else {
                    setShowOrg(res.cc_show);
                    setType(res.cc_show && res.im_priority_display ? 'org' : 'customer');
                }
            }
            else {
                setType('customer');
            }
        })
            .catch(function (err) {
            setType('customer');
        });
    }, []);
    return (React.createElement("div", { className: style['info-page'] }, customer ? (React.createElement(React.Fragment, null,
        showOrg && (React.createElement("div", { className: style['tab-list'] },
            React.createElement("div", null,
                React.createElement("span", { className: "".concat(style['tab-item-name'], " ").concat(type === 'customer' ? style['active'] : ''), onClick: function () { return setType('customer'); } }, "\u5BA2\u6237\u4FE1\u606F"),
                React.createElement("span", { className: style['filter-span-separator'] }, "|")),
            showOrg && (React.createElement("div", null,
                React.createElement("span", { className: "".concat(style['tab-item-name'], " ").concat(type === 'org' ? style['active'] : ''), onClick: function () { return setType('org'); } }, "\u516C\u53F8\u4FE1\u606F"))))),
        React.createElement("div", { className: style['tab-content'] },
            type === 'customer' && React.createElement(CustomerInfoForm, __assign({}, props, { switchFlag: true })),
            type === 'org' && (React.createElement(CompanyInfoComponent, { event: event, organizationFieldsv2: organizationFieldsv2, organizationFields: organizationFields, sessionKey: sessionKey, customerId: customerId, chat: chat, imSubSessionId: imSubSessionId, organizations: organizations }))))) : null));
};
export default CustomerInfo;
