var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useImperativeHandle, useMemo, useRef } from "react";
import { useSelector, useDispatch } from "../store/store-hook";
import { updateAgentConfig } from "../store/agent-config";
import Index from "./index";
var ImPanelEntry = React.forwardRef(function (_a, ref) {
    var width = _a.width, onWidthChange = _a.onWidthChange, cssMaxWidth = _a.cssMaxWidth, props = __rest(_a, ["width", "onWidthChange", "cssMaxWidth"]);
    var agentConfig = useSelector(function (state) { return state.agentConfig || {}; });
    var currentUser = useSelector(function (state) { return state.currentUser; });
    var fields = useSelector(function (state) { return state.fields; });
    var roleCan = useSelector(function (state) { return state.roleCan; });
    var company = useSelector(function (state) { return state.company; });
    var initData = useSelector(function (state) { return state.initData; });
    var noteTemplates = useSelector(function (state) { return state.noteTemplateConfig.noteTemplates; });
    var dispatch = useDispatch();
    var smsapp = initData.smsapp, agents = initData.agents, page = initData.page, agentGroups = initData.agentGroups, ticketTab = initData.ticketTab, ticketTemplates = initData.ticketTemplates, ticketFieldsAbilities = initData.ticketFieldsAbilities, kmrobot_url = initData.kmrobot_url, previewUrl = initData.previewUrl, imNewPlatforms = initData.imNewPlatforms, companyCategoryConfig = initData.companyCategoryConfig, customerFieldsAuthority = initData.customerFieldsAuthority, user = initData.user, admin = initData.admin, isAdmin = initData.isAdmin, fieldHooks = initData.fieldHooks, event = initData.event, chat = initData.chat;
    var _event = useMemo(function () {
        return {
            updateChat: function (chat, updateProps) {
                event.updateChat({
                    chat: chat,
                    updateProps: updateProps,
                });
            },
            transitionToRoute: function (pathConfig) {
                event.transitionToRoute(pathConfig);
            },
            createReturnVisit: function () {
                // TODO 创建回访计划
                console.log("TODO 创建回访计划");
            },
            updateAgentConfig: function (data) {
                dispatch(updateAgentConfig({
                    agent_tab_config: data,
                }));
            },
            updateChatCustomer: function (customer) {
                event.updateChatCustomer(customer);
            },
            onMakeCall: function (phoneNumberObj) {
                event.onMakeCall(phoneNumberObj);
            },
            openSms: function (phoneNumberObj) {
                event.openSms(phoneNumberObj);
            },
            createEmailTicket: function (chat) {
                event.createEmailTicket(chat);
            },
            onUse: function (type, data) {
                event.onKnowledgeUseClick(type, data);
            },
            onSend: function (type, data) {
                event.onKnowledgeSendClick(type, data);
            },
            reloadModel: function () {
                event.reloadModel();
            },
        };
    }, [dispatch, event, chat === null || chat === void 0 ? void 0 : chat.platform]);
    var imPanelRef = useRef();
    // 父组件调用的方法
    useImperativeHandle(ref, function () { return ({
        showTicket: function (config) {
            var _a;
            // 调用子组件的方法
            if (typeof ((_a = imPanelRef.current) === null || _a === void 0 ? void 0 : _a.showTicket) === "function") {
                imPanelRef.current.showTicket(config);
            }
        },
        showVisit: function (config) {
            var _a;
            // 调用子组件的方法
            if (typeof ((_a = imPanelRef.current) === null || _a === void 0 ? void 0 : _a.showVisit) === "function") {
                imPanelRef.current.showVisit(config);
            }
        },
        showRecord: function (config) {
            var _a;
            // 调用子组件的方法
            if (typeof ((_a = imPanelRef.current) === null || _a === void 0 ? void 0 : _a.showRecord) === "function") {
                imPanelRef.current.showRecord(config);
            }
        },
        changeImPanelTab: function (id, customerId) {
            var _a;
            // 调用子组件的方法
            if (typeof ((_a = imPanelRef.current) === null || _a === void 0 ? void 0 : _a.changeImPanelTab) === "function") {
                imPanelRef.current.changeImPanelTab(id, customerId);
            }
        },
    }); });
    return (React.createElement(Index, { customerFieldsv2: fields.customerFieldsv2, organizationFieldsv2: fields.organizationFieldsv2, organizationFields: fields.organizationFields, noteFields: fields.noteFields, currentUser: currentUser, roleCan: roleCan, company: company, agentConfig: agentConfig, noteTemplates: noteTemplates, 
        //
        page: page, chat: chat, ticketTemplates: ticketTemplates, smsapp: smsapp, imNewPlatforms: imNewPlatforms, companyCategoryConfig: companyCategoryConfig, event: _event, customerFieldsAuthority: customerFieldsAuthority, user: user, isAdmin: isAdmin, fieldHooks: fieldHooks, agents: agents, kmrobot_url: kmrobot_url, previewUrl: previewUrl, ticketFieldsAbilities: ticketFieldsAbilities, ticketTab: ticketTab, agentGroups: agentGroups, admin: admin, ref: imPanelRef, width: width, onWidthChange: onWidthChange, cssMaxWidth: cssMaxWidth }));
});
ImPanelEntry.displayName = "ImPanelEntry";
export default ImPanelEntry;
