/* eslint-disable jsx-a11y/anchor-is-valid */
import React, { useCallback, useEffect, useState, Fragment } from "react";
import { Form, message, Select } from "udesk-ui";
import { useTranslation } from "react-i18next";
import * as FieldComponent from "../../components/_fields";
import style from "./index.module.scss";
import { formatCustomField, getFieldsDefaultValue, getJSON, postJSON, } from "../../utils/index";
import CustomField from "../../components/custom-field-container";
import { useDispatch } from "../../store/store-hook";
import { ChatUtils } from "../../utils/im-utils";
import { useSelector } from "../../store/store-hook";
import { isEqual } from "lodash-es";
var note_category = {
    im: "im",
    mpv: "video",
    call: "call",
};
var Option = Select.Option;
var ImNote = function (props) {
    var _a, _b, _c, _d, _e, _f;
    var dispatch = useDispatch();
    var initData = useSelector(function (state) { return state.initData; });
    var businessRender = (_b = (_a = initData === null || initData === void 0 ? void 0 : initData.template) === null || _a === void 0 ? void 0 : _a.business) === null || _b === void 0 ? void 0 : _b.render;
    var oldBusinessTemplate = (_d = (_c = initData === null || initData === void 0 ? void 0 : initData.template) === null || _c === void 0 ? void 0 : _c.business) === null || _d === void 0 ? void 0 : _d.oldBusinessTemplate;
    var formRef = Form.useForm()[0];
    // 多语言
    var t = useTranslation().t;
    //ember传进来的参数
    // const udeskWebappContext: ImContextProps = useContext(UdeskContext);
    var chat = props.chat, noteTemplates = props.noteTemplates, company = props.company, event = props.event;
    var _g = useState(true), setIsSubjectEnable = _g[1]; //是否显示主题
    var _h = useState(""), templateId = _h[0], setTemplateId = _h[1]; //当前选择的模板id
    var _j = useState(), initFormData = _j[0], setInitFormData = _j[1];
    //主题字段是否必填
    var _k = useState(false), setIsSubjectRequired = _k[1];
    // 自定义字段
    var _l = useState([]), customField = _l[0], setCustomField = _l[1];
    //此业务记录是否处于已完成状态
    var _m = useState(true), noteComplete = _m[0], setNoteComplete = _m[1];
    var _o = useState(0), id = _o[0], setId = _o[1];
    //处理工单模板选项数据
    var _noteTemplates = noteTemplates
        .filter(function (item) { return item.category === note_category[initData.page]; }) //
        .map(function (item) {
        return {
            value: item.id,
            label: item.name,
        };
    });
    // 公司选项
    var organizations = (_f = (_e = chat === null || chat === void 0 ? void 0 : chat.organizations) === null || _e === void 0 ? void 0 : _e.map(function (item) {
        return {
            value: item.id,
            title: item.name,
        };
    })) !== null && _f !== void 0 ? _f : [];
    var _p = useState(true), allDone = _p[0], setAllDone = _p[1];
    var handleAllReqHasValue = useCallback(function (data, customField) {
        var isRequestFields = customField.filter(function (field) {
            return field.isRequired;
        });
        var allDone = isRequestFields.every(function (item, index) {
            return data[item.field.id];
        });
        setAllDone(allDone);
        event.updateChat &&
            event.updateChat({
                chat: chat,
                updateProps: {
                    note_complete: allDone,
                },
            });
    }, [chat, dispatch]);
    //根据模板id获取详情
    var getTemplateById = useCallback(function (id) {
        getJSON("/notes/detail", {
            type: initData.page,
            ref_id: chat.im_sub_session_id,
            template_id: id,
        }).then(function (res) {
            setId(res.data.id);
            if (id) {
                event.updateChat &&
                    event.updateChat({
                        chat: chat,
                        updateProps: {
                            agent_note_template_id: parseInt(id),
                            noteHasReqField: ChatUtils.getNoteHasReqField(parseInt(id)),
                        },
                    });
            }
            setTemplateId(res.data.agent_note_template.id);
            if (!isEqual(initData.page, "mpv")) {
                setNoteComplete(res.data.im_sub_session.note_complete);
            }
            //控制是否显示 主题 字段
            setIsSubjectEnable(res.data.agent_note_template.is_subject_enable);
            setIsSubjectRequired(res.data.agent_note_template.is_subject_required);
            // 处理自定义字段
            var customField = formatCustomField({
                fields: res.data.agent_note_template.fields,
                trigger: "onBlur",
            });
            var customerFormData = {}; //自定义字段的formData
            //循环用户自定义字段
            customField.forEach(function (item) {
                customerFormData[item.field.id] =
                    item.field.id.split("_")[0] === "TextField" ? "" : [];
            });
            //将已经有数据的自定义字段和初始化完成的自定义字段合并
            customerFormData = Object.assign(getFieldsDefaultValue(customField), res.data.custom_fields);
            // 将基础的表单数据和自定义表单数据合并
            var formData = Object.assign({
                content: res.data.content || "",
                organization_id: res.data.organization_id,
            }, customerFormData);
            setInitFormData(formData);
            // 表单重置初始值
            formRef.setFieldsValue(formData);
            if (res.data.agent_note_template.is_subject_enable) {
                customField.unshift({
                    field: {
                        disabled: false,
                        id: "content",
                        isRequired: res.data.agent_note_template.is_subject_required,
                        trigger: "onBlur",
                        type: "text",
                        customValidFn: function (rule, value) {
                            var validTexts = [];
                            if (res.data.agent_note_template.is_subject_required &&
                                !value) {
                                validTexts.push("该字段为必填项");
                            }
                            if (validTexts.length > 0) {
                                var errMsg = validTexts.join(",");
                                return Promise.reject(errMsg);
                            }
                            else {
                                return Promise.resolve();
                            }
                        },
                    },
                    isRequired: res.data.agent_note_template.is_subject_required,
                    label: "主题",
                });
            }
            //存储自定义字段  循环用
            setCustomField(customField);
            handleAllReqHasValue(formData, customField);
        });
    }, [chat, dispatch, formRef, handleAllReqHasValue]);
    useEffect(function () {
        getTemplateById("");
    }, [getTemplateById]);
    var changeTemplate = useCallback(function (value) {
        getTemplateById(value);
    }, [getTemplateById]);
    var submit = useCallback(function (data) {
        postJSON("/notes", Object.assign({
            type: initData.page,
            ref_id: chat.im_sub_session_id,
            template_id: templateId,
        }, data))
            .then(function (res) {
            var _a;
            //当前表单的值
            var values = formRef.getFieldsValue();
            //报错信息
            if (res.code !== 1000 && res.code !== "1000") {
                message.error((res === null || res === void 0 ? void 0 : res.code_message) || ((_a = res === null || res === void 0 ? void 0 : res.exception) === null || _a === void 0 ? void 0 : _a.message) || t("saveError"));
                var key = Object.keys(data.custom_fields)[0];
                values[key] = initFormData[key];
                formRef.setFieldsValue(values);
                return;
            }
            message.success("保存成功");
            // 如果当前业务记录不是完成状态  判断必填项是否完成  如果都填完  就请求一个完成记录的接口
            handleAllReqHasValue(values, customField);
            if (!noteComplete) {
                //是否必填都填写的 标识
                var allReqHasValue_1 = true;
                //从自定义字段中筛选出必填项
                var imReqFields = customField.filter(function (field) {
                    return field.isRequired;
                });
                //如果没有必填项 也认为没有填全
                if (imReqFields.length === 0) {
                    allReqHasValue_1 = false;
                }
                //查看必填项是否有值
                imReqFields.forEach(function (item) {
                    if (!values[item.field.id]) {
                        allReqHasValue_1 = false;
                    }
                });
                if (allReqHasValue_1) {
                    postJSON("/im/note_complete", {
                        complete: true,
                        im_sub_session_id: chat.im_sub_session_id,
                    }).then(function (res) {
                        setNoteComplete(true);
                    });
                }
            }
            //将已经有数据的自定义字段和初始化完成的自定义字段合并
            var customerFormData = Object.assign(getFieldsDefaultValue(customField), res.data.custom_fields);
            // 将基础的表单数据和自定义表单数据合并
            var formData = Object.assign({
                content: res.data.content,
                organization_id: res.data.organization_id,
            }, customerFormData);
            setInitFormData(formData);
            // 表单重置初始值
            formRef.setFieldsValue(formData);
        })
            .catch(function (e) {
            console.log(e);
        });
    }, [
        chat,
        templateId,
        formRef,
        handleAllReqHasValue,
        customField,
        noteComplete,
        t,
        initFormData,
    ]);
    var valueChange = useCallback(function (value) {
        // 获取改变的字段的key值
        var key = Object.keys(value)[0];
        if (key.split("_")[0] === "SelectField" && Array.isArray(value[key])) {
            value[key] = value[key].join(",");
        }
        if (!value[key])
            value[key] = "";
        //判断改变的字段是自定义字段还是系统字段
        var params = {};
        if (key === "content" || key === "organization_id") {
            params = value;
        }
        else {
            params = {
                custom_fields: value,
            };
        }
        // 触发form表单的校验  检查校验错误信息中是否包含本次修改数据   如果不存在  提交本条数据
        formRef
            .validateFields(Object.keys(value))
            .then(function (res) {
            submit(params);
        })
            .catch(function (e) {
            var canSubmit = true;
            e.errorFields.forEach(function (item) {
                if (item.name[0] === key) {
                    canSubmit = false;
                }
            });
            if (canSubmit) {
                submit(params);
            }
        });
    }, [initFormData, formRef, submit]);
    return (React.createElement(Fragment, null, !oldBusinessTemplate ? (React.createElement("div", { className: style["note-wrapper"] },
        !allDone && React.createElement("div", { className: style["tip"] }, t("page.im.note.tip")),
        _noteTemplates.length ? (React.createElement(Select, { showArrow: true, onChange: changeTemplate, getPopupContainer: function (triggerNode) { return triggerNode; }, defaultValue: _noteTemplates[0].value, bordered: false, value: templateId, className: style["select-wrapper"], dropdownMatchSelectWidth: false }, _noteTemplates.map(function (d) { return (React.createElement(Option, { key: d.value, value: d.value }, d.label)); }))) : (React.createElement("a", { className: style["select-name"] }, _noteTemplates[0].label)),
        React.createElement(Form, { form: formRef, initialValues: {
                content: "",
                organization_id: "",
            }, onValuesChange: function (changedValues, allValues) {
                return valueChange(changedValues);
            }, layout: "vertical" },
            organizations.length > 1 && company.support_multi_organizations && (React.createElement(Form.Item, { name: "organization_id", label: t("page.im.ticket.organizations") },
                React.createElement(FieldComponent.droplist, { id: "level", type: "droplist", trigger: "onChange", options: organizations }))),
            customField.length > 0 && (React.createElement(CustomField, { fields: customField, switchFlag: true, notUseDefault: !!id }))))) : businessRender && businessRender()));
};
export default ImNote;
