var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React from 'react';
import style from './style.module.scss';
import { HuiFan, ZhuanYi } from '../../../components/icon/icon';
import { csApiPostJSON } from '../../../utils/csApi';
import isFunction from 'lodash-es/isFunction';
import { message } from 'udesk-ui';
/**
 * 平行视界
 * @param props
 */
var ParallelTab = function (props) {
    // const udeskImContext: ImContextProps = useContext(UdeskContext);
    // const { event } = udeskImContext;
    var event = props.event;
    var handleSwitchParallel = function () {
        var _data = {
            agent_tab_config: __assign(__assign({}, props.agentTabConfig), { sortDesc: !props.agentTabConfig.sortDesc }),
        };
        csApiPostJSON("/cs/im/agent/im/agent_config", {
            data: _data,
        }).then(function (res) { return res.data; })
            .then(function () {
            if (isFunction(event.updateAgentConfig)) {
                event.updateAgentConfig(__assign(__assign({}, props.agentTabConfig), { sortDesc: !props.agentTabConfig.sortDesc }));
            }
        })
            .catch(function (err) {
            message.error('保存失败,请重试');
        });
    };
    var handleHideParallel = function () {
        var _data = {
            agent_tab_config: __assign(__assign({}, props.agentTabConfig), { parallel: '', sortDesc: false }),
        };
        csApiPostJSON("/cs/im/agent/im/agent_config", {
            data: _data,
        }).then(function (res) { return res.data; })
            .then(function () {
            if (isFunction(event.updateAgentConfig)) {
                event.updateAgentConfig(__assign(__assign({}, props.agentTabConfig), { parallel: '', sortDesc: false }));
            }
        })
            .catch(function () {
            message.error('保存失败,请重试');
        });
    };
    return (React.createElement("div", { className: style['parallel-container'] },
        React.createElement("div", { className: style['parallel-header'] },
            React.createElement("div", { className: style['header-name'] }, props.text),
            React.createElement("div", { className: style['header-icons'] },
                React.createElement("span", { onClick: handleSwitchParallel },
                    React.createElement(ZhuanYi, null)),
                React.createElement("span", { onClick: handleHideParallel },
                    React.createElement(HuiFan, null)))),
        React.createElement("div", { className: style['parallel-body'] }, props.component)));
};
export default ParallelTab;
