import React, { useEffect, useMemo, useState } from "react";
import style from "./index.module.scss";
import { Horn } from "../../../components/icon/icon";
var AudioType = function (props) {
    // const { src } = props.contentObject.data.content;
    var _a = useState(0), duration = _a[0], setDuration = _a[1];
    var _b = useState(false), isPlaying = _b[0], setIsPlaying = _b[1];
    var msgItem = props.msgItem;
    var contentObject = typeof msgItem.content === "string"
        ? JSON.parse(msgItem.content)
        : msgItem.content;
    // const audioRef = useRef<any>();
    var audioElement = useMemo(function () {
        var audio = window.document.createElement("audio");
        audio.src = contentObject.data.content;
        return audio;
    }, [contentObject.data]);
    var startPlayAudio = function () {
        audioElement.play();
        setIsPlaying(true);
    };
    var endPlayAudio = function () {
        setIsPlaying(false);
    };
    useEffect(function () {
        audioElement.addEventListener("loaded", function (e) {
            setDuration(e.duration === 0 ? 1 : e.duration);
        });
        return function () {
            audioElement.removeEventListener("loaded", function (e) { });
        };
    }, [audioElement]);
    useEffect(function () {
        audioElement.addEventListener("ended", endPlayAudio);
        audioElement.removeEventListener("ended", function (e) { });
    }, [audioElement, isPlaying]);
    return (React.createElement("div", { className: style["audio-container"] },
        React.createElement("div", { className: style["audio-top"], onClick: startPlayAudio },
            React.createElement("span", null,
                React.createElement("b", { className: style["duration"] }, "".concat(duration, " \""))),
            isPlaying && React.createElement("span", { className: style["aduio-playing"] }),
            !isPlaying && (React.createElement("span", { className: style["r-agent"] },
                " ",
                React.createElement(Horn, null)))),
        contentObject.data.recognition && (React.createElement(React.Fragment, null,
            React.createElement("div", { className: style["audio-hr"] }),
            React.createElement("div", { className: style["audio-text"] }, contentObject.data.recognition)))));
};
export default AudioType;
