var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { useCallback, useEffect, useRef, useState } from "react";
import moment from "moment";
import { Button, DatePicker, Input, message, Spin } from "udesk-ui";
import * as speicalTypeItem from "./components";
import style from "./index.module.scss";
import { imLogIsEvent, imLogIsMessage, postJSON, r, } from "../../utils/index";
import { useTranslation } from "react-i18next";
import { CheckCircle } from "../../components/icon/icon";
import { CuoHao } from "../../components/icon/icon";
import { useDateRanges } from "../../utils/util";
import { csApiGetJSON } from "../../utils/csApi";
var RangePicker = DatePicker.RangePicker;
var ImMsgRecord = function (props) {
    //多语言配置
    var t = useTranslation().t;
    //ember传进来的参数
    // const udeskWebappContext: any = useContext(UdeskContext)
    var chat = props.chat, event = props.event;
    // const [udeskWebappContext, setUdeskWebappContext] = useState<any>(useContext(UdeskContext))
    var _a = useState([]), msgList = _a[0], setMsgList = _a[1]; //消息列表 非查询
    var _b = useState([]), searchMsgList = _b[0], setSearchMsgList = _b[1]; //消息列表 查询的结果
    var _c = useState([]), nearbyMsgList = _c[0], setNearbyMsgList = _c[1];
    // const [tabType, setType] = useState<string>('all')//tab切换状态  'all' 'flie' 'pic'
    var _d = useState(""), lastId = _d[0], setLastId = _d[1]; //上一个对话的id
    var _e = useState(""), nextId = _e[0], setNextId = _e[1]; //下一个对话的id
    var _f = useState(false), topSpinning = _f[0], setTopSpinning = _f[1]; //头部loading加载状态是否显示
    var _g = useState(false), bottomSpinning = _g[0], setBottomSpinning = _g[1]; //底部loading加载状态是否显示
    var _h = useState("all"), searchType = _h[0], SetSearchType = _h[1]; //是否点击的查询   点击了以后 显示查询结果   否则显示全部
    var _j = useState(""), searchValue = _j[0], setSearchValue = _j[1]; //输入的搜索关键词
    var _k = useState(moment().subtract(3, "month")), startDate = _k[0], setStartDate = _k[1]; //查询的开始时间
    var _l = useState(moment()), endDate = _l[0], setEndDate = _l[1]; //查询的结束始时间
    var msgRef = useRef(null);
    var _m = useState(), currentLog = _m[0], setCurrentLog = _m[1]; //翻页时的当前的最前的一条数据  用来请求数据回来 记忆滚动用
    var _o = useState(1), searchPage = _o[0], setSearchPage = _o[1]; //当前请求的页数  搜索聊天记录用
    var _p = useState(0), totalPage = _p[0], setTotalPage = _p[1]; //搜索数据的总页数
    var _q = useState(0), totalCount = _q[0], setTotalCount = _q[1]; //搜索数据的总条数
    var _r = useState(""), searchLastId = _r[0], setSearchLastId = _r[1];
    var _s = useState(""), searchNextId = _s[0], setSearchNextId = _s[1];
    // 进入第一次  搜索当前回话的消息记录
    useEffect(function () {
        initData(chat.im_sub_session_id + "", msgList, -1).then(function (res) {
            setLastId(res === null || res === void 0 ? void 0 : res.lastId);
            setNextId(res === null || res === void 0 ? void 0 : res.nextId);
            setMsgList((res === null || res === void 0 ? void 0 : res.msgList) || []);
        });
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    var _scrollToImLog = useCallback(function (offset) {
        var _a;
        if (offset === void 0) { offset = 0; }
        // 获取滚动元素
        var results = document.getElementById("result");
        //获取当前最新元素所在位置
        var imLogTop = currentLog
            ? (_a = document.getElementById("data-im-log-".concat(currentLog.id))) === null || _a === void 0 ? void 0 : _a.offsetTop
            : 0;
        if (!imLogTop) {
            return;
        }
        // 外层元素滚动到 之前滚动的高度+新加进来的会话列表的高度+偏移量
        results.scrollTop = results.scrollTop + imLogTop + offset;
    }, [currentLog]);
    //每次请求以后把请求前的第一或者最新的第一条复制以后  自动滚到该位置
    useEffect(function () {
        if (!currentLog)
            return;
        _scrollToImLog(-46);
    }, [_scrollToImLog, currentLog]);
    // 通过sessionId获取消息列表
    var getMsgList = useCallback(function (id) {
        return new Promise(function (resolve, reject) {
            csApiGetJSON('/cs/im/agent/im/im_logs/agent_logs', {
                params: {
                    im_session_id: id,
                    customer_id: chat.customer_id,
                    session_key: chat.session_key,
                }
            }).then(function (res) { return res.data; }).then(function (res) {
                if (res.code === 1000 || res.code === "1000") {
                    resolve({
                        msgList: res.im_logs,
                        nextId: res.next_im_session_id,
                        lastId: res.last_im_session_id,
                    });
                }
                else {
                    reject(res);
                }
            });
        });
    }, [chat.customer_id, chat.session_key]);
    //初始化请求数据
    //nextId 初始化都传-1  只将请求后的第一次的res.nextId复制给nextId  因为是向上查询  nextId只会是第一次的nextId
    var initData = useCallback(function (id, newMsgList, nextId) {
        return getMsgList(id)
            .then(function (res) {
            // 将之前请求数据  与 此次请求数据合并
            var _newMsgList = __spreadArray(__spreadArray([], res.msgList, true), newMsgList, true);
            //因为是向上查询  所以下一个的sessionId取第一次的值  一旦nextId有值 便不再重新赋值
            var currentNextId = nextId === -1 ? res.nextId : nextId;
            // 如果 聊天记录条数小于20  并且  还有上一条对话    继续请求 上一次对话  知道聊天记录多余20条
            if (_newMsgList.length < 20 && res.lastId) {
                return initData(res.lastId, _newMsgList, currentNextId);
            }
            else {
                return {
                    msgList: _newMsgList,
                    lastId: res.lastId.toString(),
                    nextId: nextId.toString(),
                };
            }
        })
            .catch(function (e) {
            message.error(e.code_message ||
                (e.exceptopn && e.exceptopn.message) ||
                t("page.im.record.requestError"));
            return {};
        });
    }, [getMsgList, t]);
    var isBottom = false, isTop = false;
    //监听的滚动事件
    //如果是搜索事件  搜索只有触底翻页   即searchType是search时
    //查询全部和查询前后文是同一个接口 只是在处理返回数据会有区别  即searchType是all和nearby
    var handleMsgScroll = useCallback(function (e) {
        var ref = e.target;
        var _lastId = searchType === "nearby" ? searchLastId : lastId;
        var _nextId = searchType === "nearby" ? searchNextId : nextId;
        // 滚动到顶部加载前一个session
        if (ref.scrollTop < 1 && _lastId && !isTop && !isBottom) {
            // 如果是搜索时的吸顶 不进行操作
            if (searchType === "search")
                return;
            setTopSpinning(true);
            // eslint-disable-next-line react-hooks/exhaustive-deps
            isTop = true;
            getMsgList(_lastId)
                .then(function (res) {
                setTopSpinning(false);
                searchType === "nearby"
                    ? setSearchLastId(res.lastId)
                    : setLastId(res.lastId);
                //根据全部 还是上下文  处理不一样的数据
                if (searchType === "all") {
                    setMsgList(__spreadArray(__spreadArray([], res.msgList, true), msgList, true));
                    setCurrentLog(msgList[0]);
                }
                else if (searchType === "nearby") {
                    setNearbyMsgList(__spreadArray(__spreadArray([], res.msgList, true), nearbyMsgList, true));
                    setCurrentLog(nearbyMsgList[0]);
                }
                isTop = false;
            })
                .catch(function (e) {
                setTopSpinning(false);
                isTop = false;
            });
            return;
        }
        //滚动到底部加载下一个session
        if (ref.scrollTop === ref.scrollHeight - ref.clientHeight &&
            !isTop &&
            !isBottom) {
            //搜索有触底
            if (searchType === "search") {
                if (searchPage < totalPage + 1) {
                    setBottomSpinning(true);
                    // eslint-disable-next-line react-hooks/exhaustive-deps
                    isBottom = true;
                    searchRecord(searchMsgList, searchPage);
                }
            }
            else {
                if (_nextId && _nextId !== "-1") {
                    setBottomSpinning(true);
                    isBottom = true;
                    getMsgList(_nextId)
                        .then(function (res) {
                        setBottomSpinning(false);
                        if (searchType === "all") {
                            setMsgList(__spreadArray(__spreadArray([], res.msgList, true), msgList, true));
                        }
                        else if (searchType === "nearby") {
                            setNearbyMsgList(__spreadArray(__spreadArray([], res.msgList, true), nearbyMsgList, true));
                        }
                        searchType === "nearby"
                            ? setSearchNextId(res.lastId)
                            : setNextId(res.lastId);
                        isBottom = false;
                    })
                        .catch(function (e) {
                        setBottomSpinning(false);
                        isBottom = false;
                    });
                }
            }
            return;
        }
    }, [
        nextId,
        lastId,
        msgList,
        searchType,
        nearbyMsgList,
        totalPage,
        searchPage,
        searchLastId,
        searchNextId,
    ]);
    //改变事件范围选择
    var rangePickerChange = useCallback(function (dates, dateStrings) {
        setStartDate(dates[0]);
        setEndDate(dates[1]);
    }, []);
    // 输入框改变
    var inputChange = useCallback(function (e) {
        setSearchValue(e.target.value.trim());
    }, []);
    // 切换tab
    // const changeTab = useCallback((type: string) => {
    //     setType(type)
    // }, [])
    // 根据时间和关键字查询聊天记录
    var searchRecord = useCallback(function (list, page) {
        if (!searchValue) {
            message.warning("输入关键字查询");
            return;
        }
        postJSON("/im/im_logs/search", {
            customer_id: chat.customer_id,
            session_key: chat.session_key,
            page_size: 50,
            keyword: searchValue,
            page: page,
            start_date: startDate.format("YYYY-MM-DD"),
            end_date: endDate.format("YYYY-MM-DD"),
        }).then(function (res) {
            var _a, _b;
            if (res.code === 1000 || res.code === "1000") {
                // eslint-disable-next-line react-hooks/exhaustive-deps
                isBottom = false;
                setBottomSpinning(false);
                setTotalCount((_a = res === null || res === void 0 ? void 0 : res.meta) === null || _a === void 0 ? void 0 : _a.total_count);
                setTotalPage((_b = res === null || res === void 0 ? void 0 : res.meta) === null || _b === void 0 ? void 0 : _b.total_pages);
                setSearchPage(page + 1);
                setSearchMsgList(__spreadArray(__spreadArray([], list, true), res.im_logs.map(function (item) { return _matchedResultToImLog(item); }), true));
            }
            else {
                message.error(res.code_message ||
                    (res.exceptopn && res.exceptopn.message) ||
                    t("page.im.record.requestError"));
            }
        });
        SetSearchType("search");
    }, [
        searchValue,
        chat.customer_id,
        chat.session_key,
        startDate,
        endDate,
        searchPage,
    ]);
    //点击了搜索  先将分页  数据置空
    var beforeSearchRecord = useCallback(function () {
        setSearchMsgList([]);
        setSearchPage(1);
        searchRecord([], 1);
    }, [searchRecord]);
    //查询结果中搜索上下文
    var searchNearbyById = useCallback(function (sessionId, id) {
        initData(sessionId, [], -1).then(function (res) {
            var _a;
            setSearchLastId(res.lastId);
            setSearchNextId(res.nextId);
            SetSearchType("nearby");
            setNearbyMsgList(res.msgList);
            //滚动到查询的信息的位置
            (_a = document.getElementById("data-im-log-".concat(id))) === null || _a === void 0 ? void 0 : _a.scrollIntoView();
        });
    }, [initData]);
    // 处理是事件时的具体显示
    var handleEvent = useCallback(function (item) {
        var contentObj = JSON.parse(item.content);
        if (contentObj.data.timeout_freq === 1) {
            return t("page.im.record.tip.noAnswer");
        }
        else if (contentObj.data.timeout_freq === 2) {
            return t("page.im.record.tip.customerOvertime");
        }
        else if (contentObj.data.timeout_auto_msg) {
            return r(t("page.im.record.tip.agentOvertime"), item.agent_nick_name);
        }
        else if (contentObj.data.msg_close) {
            return r(t("page.im.record.tip.agentCloseChat"), item.agent_nick_name);
        }
        else if (contentObj.type === "transfer") {
            return contentObj.data.content || t("page.im.record.tip.chatTransfer");
        }
        else {
            return typeof contentObj.data.content === "string"
                ? contentObj.data.content
                : "";
        }
    }, [t]);
    //搜索得到的数据和用sessionid查的数据格式不一样   将搜索得到的数据处理成一样的格式
    var _matchedResultToImLog = useCallback(function (matchedResult) {
        return {
            id: matchedResult.id,
            im_session_id: matchedResult.im_session_id,
            agent_id: matchedResult.agent.id,
            customer_id: matchedResult.customer.id,
            im_sub_session_id: matchedResult.im_sub_session_id,
            sender: matchedResult.sender,
            user_nick_name: matchedResult.sender === "customer"
                ? matchedResult.customer.nick_name
                : matchedResult.agent.nick_name,
            content: matchedResult.content,
            agent_nick_name: matchedResult.agent.nick_name,
            created_at: matchedResult.created_at,
        };
    }, []);
    //关闭当前消息记录
    var closeRecord = useCallback(function () {
        props.setShowRecord({
            show: false,
        });
        event.updateChat &&
            event.updateChat({
                chat: chat,
                updateProps: {
                    newRecord: {},
                },
            });
    }, [props, chat, event]);
    //根据消息类型渲染不同的消息组件
    var recordList = useCallback(function (item) {
        var type = JSON.parse(item.content).type;
        var SpeicalTypeItem = speicalTypeItem[type];
        return SpeicalTypeItem ? React.createElement(SpeicalTypeItem, { msgItem: item }) : null;
    }, []);
    // 消息记录的头部名称和时间
    var recordHeader = useCallback(function (item) {
        return (React.createElement("div", { className: "".concat(style["time-wrapper"], " ").concat(style["sender-is-".concat(item.sender)]) },
            React.createElement("div", { className: style["name"] }, item.user_nick_name),
            React.createElement("div", null, moment(item.created_at).format("YYYY/MM/DD hh:mm:ss")),
            searchType === "search" && (React.createElement("div", { className: style["search-nearby"], onClick: function () { return searchNearbyById(item.im_session_id, item.id); } }, t("page.im.record.searchNearby")))));
    }, [searchNearbyById, searchType, t]);
    var ranges = useDateRanges();
    return (React.createElement(React.Fragment, null,
        React.createElement("div", { className: style["record-wrapper"] },
            React.createElement("div", { className: style["header-wrapper"] },
                React.createElement("div", { className: style["header-title"] }, t("page.im.record.imLogRecords")),
                React.createElement(CuoHao, { className: style["header-icons"], onClick: closeRecord })),
            React.createElement("div", { className: style["picker-and-search"], id: "timer" },
                React.createElement(RangePicker, { defaultValue: [startDate, endDate], ranges: ranges, onChange: rangePickerChange, allowClear: false, className: style["range-picker"] }),
                React.createElement(Input, { className: style["input"], onChange: inputChange, onPressEnter: beforeSearchRecord }),
                React.createElement(Button, { className: style["btn"], type: "primary", onClick: beforeSearchRecord }, t("confirm"))),
            searchType !== "all" && (React.createElement("div", { className: style["search-result"] },
                searchType === "search" && (React.createElement("div", { dangerouslySetInnerHTML: {
                        __html: r(t("page.im.record.searchRes"), "<span>".concat(totalCount, "</span>")),
                    } })),
                React.createElement("div", { className: style["back-btn"], onClick: function () {
                        return SetSearchType(searchType === "nearby" ? "search" : "all");
                    } }, t("back")))),
            React.createElement("div", { className: style["msg-wrapper"], ref: msgRef, onScroll: handleMsgScroll, id: "result" },
                React.createElement("div", null,
                    React.createElement("div", { hidden: !topSpinning, className: style["spin-wrapper"] },
                        React.createElement(Spin, null)),
                    (searchType === "all"
                        ? msgList
                        : searchType === "search"
                            ? searchMsgList
                            : nearbyMsgList).map(function (item) {
                        return (
                        // {/* 内容 ===================start */}
                        React.createElement("div", { className: style["message-content"], key: item.id },
                            imLogIsEvent(item) && (React.createElement("div", { className: style["msg-item"], id: "data-im-log-".concat(item.id) },
                                React.createElement("div", null,
                                    recordHeader(item),
                                    React.createElement("div", { className: style["is-event"] },
                                        React.createElement("span", null, handleEvent(item)))))),
                            imLogIsMessage(item) && (React.createElement("div", { className: style["msg-item"], id: "data-im-log-".concat(item.id) },
                                React.createElement("div", null,
                                    recordHeader(item),
                                    React.createElement("div", { className: style["is-message"] },
                                        item.send_status === "rollback" && (React.createElement("div", { className: style["send-status"] },
                                            React.createElement("span", null,
                                                React.createElement(CheckCircle, null),
                                                " ",
                                                t("page.im.record.tip.withdrawed")))),
                                        item.send_status === "off_sending" && (React.createElement("div", { className: style["send-status"] },
                                            React.createElement("img", { src: "images/im/off-send.png", alt: "" }))),
                                        recordList(item)))))));
                    }),
                    React.createElement("div", { hidden: !bottomSpinning, className: style["spin-wrapper"] },
                        React.createElement(Spin, null)))))));
};
export default ImMsgRecord;
