//搜索公司
import React, { useCallback, useContext, useEffect, useState } from "react";
import { Select } from "udesk-ui";
import { csApiGetJSON } from "../../../../utils/csApi";
import { TicketContext } from "../../../../im-panel/ticket/utilities";
var Option = Select.Option;
function AgentUserField(props) {
    var agentGroup = useContext(TicketContext).agentGroup;
    var _a = useState(), value = _a[0], setValue = _a[1]; //选择的选项
    var _b = useState([]), data = _b[0], setData = _b[1];
    useEffect(function () {
        //负责组只要改变  负责人就置空  重新选择
        setValue({ value: "", label: "" });
        if (!agentGroup) {
            // 如果选负责组是空选项   负责人数据置空
            setData([]);
        }
        else {
            // 请求负责人数据
            csApiGetJSON("/cs/ts/api/user_groups/" + agentGroup).then(function (res) { return res.data; }).then(function (res) {
                var list = res.user_group.users.map(function (item) {
                    return {
                        value: item.id,
                        label: item.nick_name,
                    };
                });
                // 前边加空选项
                list.unshift({
                    value: "",
                    label: "--",
                });
                setData(list);
            });
        }
    }, [agentGroup]);
    // 选项变化时回调
    var handleChange = useCallback(function (value) {
        setValue(value);
        props.onChange && props.onChange(value ? value.value : "");
    }, [props]);
    //筛选规则
    var handleFilter = useCallback(function (inputValue, option) {
        if (option.children.includes(inputValue))
            return true;
        else
            return false;
    }, []);
    return (React.createElement(React.Fragment, null,
        React.createElement(Select, { showSearch //显示搜索
            : true, showArrow: true, labelInValue: true, value: value, placeholder: props.placeholder, onChange: handleChange, style: { width: "100%" }, filterOption: handleFilter, getPopupContainer: function (triggerNode) { return triggerNode; } }, data.map(function (d) { return (React.createElement(Option, { key: d.value, value: d.value }, d.label)); }))));
}
export default AgentUserField;
