var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
/* eslint-disable jsx-a11y/anchor-is-valid */
import React, { useCallback, useEffect, useState } from "react";
import { Input, message } from "udesk-ui";
import style from "./index.module.scss";
import FieldWarning from "../../../../components/fieldFormItem/components/field_warning";
import { getJSON } from "../../../../utils/index";
import { useTranslation } from "react-i18next";
import { MinusOutlined, PlusOutlined } from "@ant-design/icons";
function CellphoneField(props) {
    var event = props.event;
    //多语言
    var t = useTranslation().t;
    var list = typeof props.value === "string" ? props.value.split(",") : [];
    var _a = useState(list), emailList = _a[0], setEmailList = _a[1];
    var _b = useState([]), errMessage = _b[0], SetErrMessage = _b[1];
    var _c = useState([]), repeat = _c[0], SetRepeat = _c[1];
    //手机正则
    var mobilePtn = /^1[34578][0-9]{9}$/;
    //座机正则
    var landlinePtn = /^(0[0-9]{2,3}-)([2-9][0-9]{6,7})+(-[0-9]{1,4})?$/;
    // 进来第一次生成对应邮箱数量的报错信息
    useEffect(function () {
        SetErrMessage(__spreadArray([], new Array(list.length), true));
        SetRepeat(__spreadArray([], new Array(list.length), true));
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    // 新加邮箱时   改变外部form数据
    var addEmail = useCallback(function () {
        // props.onChange && props.onChange(emailList.concat('').join(','))
        setEmailList(__spreadArray([], emailList.concat(""), true));
        SetErrMessage(__spreadArray([], errMessage.concat(""), true));
        SetRepeat(__spreadArray([], repeat.concat({}), true));
    }, [emailList, errMessage, repeat]);
    // 删除   删除邮箱  删除报错信息
    var deleteEmail = useCallback(function (index) {
        emailList.splice(index, 1);
        errMessage.splice(index, 1);
        setEmailList(__spreadArray([], emailList, true));
        SetErrMessage(__spreadArray([], errMessage, true));
        // 删除后  更新外部form
        props.onChange && props.onChange(emailList.join(","));
    }, [emailList, errMessage, props]);
    // 输入值改变时  改变相对应的数据
    var emailInputChange = useCallback(function (e, index) {
        emailList[index] = e.target.value;
        setEmailList(__spreadArray([], emailList, true));
    }, [emailList]);
    // 失焦触发  校验邮箱  更改外部form
    var emailOnBlur = useCallback(function (index) {
        var value = emailList[index];
        // 查看是否重复输入同一手机号
        var valueNum = 0;
        emailList.forEach(function (item) {
            if (item === value)
                valueNum++;
        });
        // 如果有重复的数据  提示重复  并且将该值置空
        if (valueNum > 1) {
            message.warning("电话信息重复，请检查");
            emailList[index] = "";
            setEmailList(__spreadArray([], emailList, true));
            return;
        }
        //校验电话号码格式
        if (value && !mobilePtn.test(value) && !landlinePtn.test(value)) {
            errMessage[index] = "号码格式不正确";
            SetErrMessage(__spreadArray([], errMessage, true));
            return;
        }
        else {
            errMessage[index] = "";
            SetErrMessage(__spreadArray([], errMessage, true));
        }
        //查询是否有重复数据
        getJSON("/customers/check_duplication?customer%5Bcellphone%5D=" + value).then(function (res) {
            if (res.duplications.cellphone) {
                repeat[index] = {
                    id: res.duplications.cellphone.id,
                    name: res.duplications.cellphone.name,
                };
                SetRepeat(__spreadArray([], repeat, true));
                // 有重复   将填写的置空
                emailList[index] = "";
                setEmailList(__spreadArray([], emailList, true));
            }
            else {
                repeat[index] = {};
                SetRepeat(__spreadArray([], repeat, true));
            }
        });
    }, [emailList, errMessage, landlinePtn, mobilePtn, repeat]);
    useEffect(function () {
        props.onChange && props.onChange(emailList.join(","));
    }, [emailList, props]);
    //点击重复信息时   跳转
    var clickRepeatWarning = useCallback(function (id) {
        event.transitionToRoute &&
            event.transitionToRoute({
                route: "crm.customer.show",
                path: id,
            });
    }, [event]);
    return (React.createElement(React.Fragment, null, emailList.map(function (item, index) {
        return (React.createElement("div", { key: index, className: style["email-item-wrapper"] },
            React.createElement("div", { className: style["email-item-box"] },
                React.createElement(Input, { style: { flex: 1 }, placeholder: props.placeholder, value: item, onChange: function (e) { return emailInputChange(e, index); }, onBlur: function () { return emailOnBlur(index); } }),
                (function () {
                    if (index) {
                        return (React.createElement("div", { className: style["add-icon"], onClick: function () { return deleteEmail(index); } },
                            React.createElement(MinusOutlined, null),
                            React.createElement("div", null, t("delete"))));
                    }
                    else {
                        return (React.createElement("div", { className: style["add-icon"], onClick: addEmail },
                            React.createElement(PlusOutlined, null),
                            React.createElement("div", null, t("add"))));
                    }
                })()),
            errMessage[index] && (React.createElement("div", { style: { marginTop: "5px" } },
                React.createElement(FieldWarning, { warningText: errMessage[index] }))),
            repeat.length > 0 && repeat[index] && repeat[index].id && (React.createElement("div", { style: { marginTop: "5px" } },
                React.createElement("div", { className: style["repeat-warning"] },
                    React.createElement("div", { className: style["warning-img"] }),
                    React.createElement("div", null,
                        "\u6B64\u7535\u8BDD\u4E0E\u5DF2\u6709\u5BA2\u6237",
                        React.createElement("a", { onClick: function () { return clickRepeatWarning(repeat[index].id); } }, repeat[index].name),
                        "\u91CD\u590D"))))));
    })));
}
export default CellphoneField;
