var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
/* eslint-disable jsx-control-statements/jsx-use-if-tag */
import React, { useCallback, useContext, useEffect, useState } from "react";
import { Select, Spin } from "udesk-ui";
import { postJSON } from "../../../../utils/index";
import style from "./index.module.scss";
import SearchCustomer from "../search-customer";
import { PlusOutlined, SearchOutlined } from "@ant-design/icons";
import { TicketContext } from "../../../../im-panel/ticket/utilities";
var Option = Select.Option;
function Customer(props) {
    var _a = useContext(TicketContext), changePageType = _a.changePageType, customer = _a.customer;
    var _b = useState({}), value = _b[0], setValue = _b[1]; //选择的选项
    var _c = useState(false), fetching = _c[0], setFetching = _c[1]; //无数据时展示
    var _d = useState([]), data = _d[0], setData = _d[1]; //搜索到的数据
    var _e = useState(0), lastFetchId = _e[0], setLastFetchId = _e[1]; //
    var _f = useState(false), showSearchMoadl = _f[0], setShowSearchMoadl = _f[1];
    var _g = useState(1), page = _g[0], setPage = _g[1];
    var _h = useState(""), searchValue = _h[0], setSearchValue = _h[1];
    var _j = useState(0), totalPages = _j[0], setTotalPages = _j[1];
    //监听传进来的值变化  有变化就更新value
    useEffect(function () {
        if (customer.value) {
            setValue(customer);
            props.onChange && props.onChange(customer);
        }
        else {
            setValue(props.value);
        }
    }, [customer, props, props.value]);
    var beforeSearch = useCallback(function (searchValue) {
        setSearchValue(searchValue);
        setData([]);
        setPage(1);
        fetchUser(searchValue);
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    // 搜索用户
    var fetchUser = useCallback(function (searchValue) {
        setLastFetchId(function () { return lastFetchId + 1; });
        var fetchId = lastFetchId;
        setFetching(true);
        postJSON("/customers/contain_search", {
            page: page,
            page_size: 20,
            prefix: searchValue,
        }).then(function (res) {
            setPage(page + 1);
            setTotalPages(res.meta.total_pages);
            if (fetchId !== lastFetchId) {
                // for fetch callback order
                return;
            }
            var _data = res.customers.map(function (item) {
                return {
                    label: item.nick_name,
                    value: item.id,
                };
            });
            setData(__spreadArray(__spreadArray([], data, true), _data, true));
            setFetching(false);
        });
    }, [lastFetchId, page, data]);
    //
    var handleChange = useCallback(function (value) {
        setValue(value);
        setFetching(false);
        props.onChange && props.onChange(value);
    }, [props]);
    // 点击搜索按钮  打开搜索弹窗
    var searchUser = useCallback(function () {
        setShowSearchMoadl(true);
    }, []);
    // 关闭搜索弹窗
    var closeSearch = useCallback(function () {
        setShowSearchMoadl(false);
    }, []);
    var suffixIcon = (React.createElement("div", { onClick: searchUser, className: style["search-icon"] },
        React.createElement(SearchOutlined, null)));
    //处理滚动事假
    var handleScroll = useCallback(function (e) {
        e.stopPropagation();
        if (e.target.scrollTop ===
            e.target.scrollHeight - e.target.clientHeight) {
            if (page < totalPages) {
                fetchUser(searchValue);
            }
        }
    }, [page, totalPages, fetchUser, searchValue]);
    // 聚焦时  将外部表单取消滚动  防止滚动穿透
    var handleFocus = useCallback(function () {
        props.setIsScroll && props.setIsScroll(false);
    }, [props]);
    // 失焦时  将外部滚动复原
    var handleBlur = useCallback(function () {
        props.setIsScroll && props.setIsScroll(true);
    }, [props]);
    var selectCustomer = useCallback(function (customer) {
        handleChange(customer);
    }, [handleChange]);
    return (React.createElement("div", { style: { display: "flex" } },
        React.createElement(Select, { showSearch: true, showArrow: true, labelInValue: true, value: value, placeholder: "", notFoundContent: fetching ? React.createElement(Spin, { size: "small" }) : null, filterOption: false, onSearch: beforeSearch, onChange: handleChange, style: { width: "100%" }, getPopupContainer: function (triggerNode) { return triggerNode; }, suffixIcon: suffixIcon, onPopupScroll: handleScroll, onFocus: handleFocus, onBlur: handleBlur }, data.map(function (d) { return (React.createElement(Option, { key: d.value, value: d.value }, d.label)); })),
        React.createElement("div", { className: style["input-after-icon"], onClick: function () { return changePageType("customer"); } },
            React.createElement(PlusOutlined, null)),
        React.createElement(SearchCustomer, { close: closeSearch, show: showSearchMoadl, selectCustomer: selectCustomer, ticketTab: props.ticketTab })));
}
export default Customer;
