var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { useCallback, useEffect, useState } from "react";
import { Input } from "udesk-ui";
import style from "./index.module.scss";
import { useTranslation } from "react-i18next";
import FieldWarning from "../../../../components/fieldFormItem/components/field_warning";
import { MinusOutlined, PlusOutlined } from "@ant-design/icons";
function EmailField(props) {
    //多语言
    var t = useTranslation().t;
    var list = props.value.length ? props.value : [""];
    var _a = useState(list), emailList = _a[0], setEmailList = _a[1];
    var _b = useState([]), errMessage = _b[0], SetErrMessage = _b[1];
    // 进来第一次生成对应邮箱数量的报错信息
    useEffect(function () {
        SetErrMessage(__spreadArray([], new Array(list.length), true));
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    // 新加邮箱时   改变外部form数据
    var addEmail = useCallback(function () {
        // props.onChange && props.onChange(emailList.concat('').join(','))
        setEmailList(__spreadArray([], emailList.concat(""), true));
        SetErrMessage(__spreadArray([], errMessage.concat(""), true));
    }, [emailList, errMessage]);
    // 删除   删除邮箱  删除报错信息
    var deleteEmail = useCallback(function (index) {
        emailList.splice(index, 1);
        errMessage.splice(index, 1);
        setEmailList(__spreadArray([], emailList, true));
        SetErrMessage(__spreadArray([], errMessage, true));
        // 删除后  更新外部form
        props.onChange && props.onChange(emailList);
    }, [emailList, errMessage, props]);
    // 输入值改变时  改变相对应的数据
    var emailInputChange = useCallback(function (e, index) {
        emailList[index] = e.target.value;
        setEmailList(__spreadArray([], emailList, true));
    }, [emailList]);
    // 失焦触发  校验邮箱  更改外部form
    var emailOnBlur = useCallback(function (index) {
        var value = emailList[index];
        if (value &&
            !/^[A-Za-z0-9\u4e00-\u9fa5]+@[a-zA-Z0-9_-]+(\.[a-zA-Z0-9_-]+)+$/i.test(value)) {
            errMessage[index] = "邮箱格式不正确";
            SetErrMessage(__spreadArray([], errMessage, true));
        }
        else {
            errMessage[index] = "";
            SetErrMessage(__spreadArray([], errMessage, true));
        }
        props.onChange && props.onChange(emailList);
    }, [emailList, errMessage, props]);
    return (React.createElement(React.Fragment, null, emailList.map(function (item, index) {
        return (React.createElement("div", { key: index, className: style["email-item-wrapper"] },
            React.createElement("div", { className: style["email-item-box"] },
                React.createElement(Input, { style: { flex: 1 }, placeholder: props.placeholder, value: item, onChange: function (e) { return emailInputChange(e, index); }, onBlur: function () { return emailOnBlur(index); } }),
                !index ? (React.createElement("div", { className: style["add-icon"], onClick: addEmail },
                    React.createElement(PlusOutlined, null),
                    React.createElement("div", null, t("add")))) : (React.createElement("div", { className: style["add-icon"], onClick: function () { return deleteEmail(index); } },
                    React.createElement(MinusOutlined, null),
                    React.createElement("div", null, t("delete"))))),
            React.createElement("div", { style: { marginTop: "5px" } },
                React.createElement(FieldWarning, { warningText: errMessage[index] }))));
    })));
}
export default EmailField;
