var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { useState, useCallback, useContext, useEffect, useMemo, } from "react";
import { Select } from "udesk-ui";
import style from "./index.module.scss";
import { useTranslation } from "react-i18next";
import { StarFilled } from "@ant-design/icons";
import uniqBy from "lodash-es/uniqBy";
import { TicketContext } from "../../../../im-panel/ticket/utilities";
function FollowerField(props) {
    //多语言
    var t = useTranslation().t;
    var _a = useState([]), value = _a[0], setValue = _a[1]; //选择的选项
    var _b = useState(false), starState = _b[0], setStarState = _b[1];
    var agent = useContext(TicketContext).agent; //客服组
    // const udeskWebappContext: any = useContext(UdeskContext);//ember传过来的数据
    // const currentUserId = udeskWebappContext.currentUser.id
    var _c = props.currentUser, currentUser = _c === void 0 ? {} : _c, _d = props.admin, admin = _d === void 0 ? {} : _d;
    var currentUserId = currentUser.id;
    useEffect(function () {
        setValue(props.value);
    }, [props.value]);
    // 处理选项  从客服组中去除每组中的客服  并且最后加上管理员
    var radio = useMemo(function () {
        var list = [];
        agent.forEach(function (item) {
            if (item.children.length) {
                list = __spreadArray(__spreadArray([], list, true), item.children.map(function (item) {
                    return {
                        title: item.label,
                        value: item.value,
                    };
                }), true);
            }
        });
        list = uniqBy(list, "value");
        list.push({
            title: admin.nick_name,
            value: admin.id,
        });
        return list;
    }, [admin.id, admin.nick_name, agent]);
    useEffect(function () {
        //选项变化时  根据选项中有没有包含当前客服 改变星星状态
        setStarState(value.includes(currentUserId));
    }, [currentUserId, value]);
    // 点击星星事件
    var clickStart = useCallback(function () {
        // 当前 starState true  点击事件是为了  删除选择的当前的客服
        // 当前 starState false   点击事件是为了  选择的当前的客服
        if (starState) {
            var index_1 = value.indexOf(currentUserId);
            setValue(function () {
                value.splice(index_1, 1);
                return __spreadArray([], value, true);
            });
            props.onChange && props.onChange(__spreadArray([], value, true));
        }
        else {
            setValue(__spreadArray(__spreadArray([], value, true), [currentUserId], false));
            props.onChange && props.onChange(__spreadArray(__spreadArray([], value, true), [currentUserId], false));
        }
        // 改变选择时会触发上边的useEffect处理星星状态  此处不进行处理
    }, [currentUserId, props, starState, value]);
    // 选项变化时回调
    var handleChange = useCallback(function (value) {
        setValue(value);
        props.onChange && props.onChange(value);
    }, [props]);
    //筛选规则
    var handleFilter = useCallback(function (inputValue, option) {
        return option.children.includes(inputValue);
    }, []);
    return (React.createElement("div", { className: style["follower-wrapper"] },
        React.createElement(Select, { mode: "multiple", showSearch //显示搜索
            : true, showArrow: true, value: value, placeholder: t("page.im.ticket.choiceFollower"), onChange: handleChange, style: { width: "100%" }, filterOption: handleFilter, getPopupContainer: function (triggerNode) { return triggerNode; } }, radio.map(function (d) { return (React.createElement(Select.Option, { key: d.value, value: d.value }, d.title)); })),
        React.createElement("div", { className: style["star-icon"], onClick: clickStart, style: { color: starState ? "#FDBD68" : "#333" } },
            React.createElement(StarFilled, null))));
}
export default FollowerField;
