var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import React, { useCallback, useEffect, useState } from "react";
import { Select, Spin } from "udesk-ui";
import { postJSON } from "../../../utils/index";
var Option = Select.Option;
function MerchantField(props) {
    var _a = useState({}), value = _a[0], setValue = _a[1]; //选择的选项
    var _b = useState(false), fetching = _b[0], setFetching = _b[1]; //无数据时展示
    var _c = useState([]), data = _c[0], setData = _c[1]; //搜索到的数据
    var _d = useState(0), lastFetchId = _d[0], setLastFetchId = _d[1]; //
    var _e = useState(1), page = _e[0], setPage = _e[1];
    var _f = useState(""), searchValue = _f[0], setSearchValue = _f[1];
    var _g = useState(0), totalPages = _g[0], setTotalPages = _g[1];
    var fetchMerchant = useCallback(function (searchValue) {
        setLastFetchId(function () { return lastFetchId + 1; });
        var fetchId = lastFetchId;
        setFetching(true);
        postJSON("/mchat_merchants/query_merchants", {
            mchat_name: searchValue,
            page: page,
            per_page: 20,
        }).then(function (res) {
            setPage(page + 1);
            setTotalPages(res.meta.total_pages);
            if (fetchId !== lastFetchId) {
                // for fetch callback order
                return;
            }
            var _data = res.customers.map(function (item) {
                return {
                    label: item.nick_name,
                    value: item.id,
                };
            });
            setData(__spreadArray(__spreadArray([], data, true), _data, true));
            setFetching(false);
        });
    }, [lastFetchId, page, data]);
    var beforeSearch = useCallback(function (searchValue) {
        setSearchValue(searchValue);
        setData([]);
        setPage(1);
        fetchMerchant(searchValue);
    }, [fetchMerchant]);
    useEffect(function () {
        setValue(props.value);
    }, [props.value]);
    function handleChange(value) {
        setValue(value);
        setFetching(false);
        props.onChange && props.onChange(value);
    }
    //处理滚动事假
    var handleScroll = useCallback(function (e) {
        e.stopPropagation();
        if (e.target.scrollTop ===
            e.target.scrollHeight - e.target.clientHeight) {
            if (page < totalPages) {
                fetchMerchant(searchValue);
            }
        }
    }, [page, totalPages, fetchMerchant, searchValue]);
    // 聚焦时  将外部表单取消滚动  防止滚动穿透
    var handleFocus = useCallback(function () {
        props.setIsScroll && props.setIsScroll(false);
    }, [props]);
    // 失焦时  将外部滚动复原
    var handleBlur = useCallback(function () {
        props.setIsScroll && props.setIsScroll(true);
    }, [props]);
    return (React.createElement(Select, { showSearch: true, showArrow: true, labelInValue: true, value: value, placeholder: "", notFoundContent: fetching ? React.createElement(Spin, { size: "small" }) : null, filterOption: false, onSearch: beforeSearch, onChange: handleChange, style: { width: "100%" }, getPopupContainer: function (triggerNode) { return triggerNode; }, onPopupScroll: handleScroll, onFocus: handleFocus, onBlur: handleBlur }, data.map(function (d) { return (React.createElement(Option, { key: d.value, value: d.value }, d.label)); })));
}
export default MerchantField;
