import React, { useCallback, useContext, useEffect, useState } from "react";
import { Cascader } from "udesk-ui";
import style from "./index.module.scss";
import { TicketContext } from "../../../../im-panel/ticket/utilities";
function RecevierField(props) {
    var onChange = props.onChange;
    var _a = useState(), value = _a[0], setValue = _a[1];
    var _b = useState([]), options = _b[0], setOptions = _b[1];
    var agent = useContext(TicketContext).agent;
    var cascaderOnChange = useCallback(function (value, selectedOptions) {
        setValue(value);
        onChange && onChange(value);
    }, [onChange]);
    var filter = useCallback(function (inputValue, path) {
        return path.some(function (option) {
            return option.label.toLowerCase().indexOf(inputValue.toLowerCase()) > -1;
        });
    }, []);
    useEffect(function () {
        setOptions(agent);
    }, [agent]);
    useEffect(function () {
        setValue(props.value);
    }, [props.value]);
    return (React.createElement("div", { className: style["cascader-wrapper"] },
        React.createElement(Cascader, { value: value, options: options, onChange: cascaderOnChange, placeholder: "", changeOnSelect: true, showSearch: { filter: filter } })));
}
export default RecevierField;
