var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
/* eslint-disable jsx-control-statements/jsx-use-if-tag */
//搜索公司
import React, { useCallback, useContext, useEffect, useRef, useState, } from "react";
import { Select, Spin } from "udesk-ui";
import { csApiPostJSON } from "../../../../utils/csApi";
import style from "./index.module.scss";
import { useTranslation } from "react-i18next";
import { MinusOutlined, PlusOutlined } from "@ant-design/icons";
import { TicketContext } from "../../../../im-panel/ticket/utilities";
var Option = Select.Option;
function SearchOrgField(props) {
    var roleCan = props.roleCan, company = props.company, event = props.event;
    //多语言
    var t = useTranslation().t;
    var ref = useRef(null);
    //ember传进来的参数
    var canCreate = roleCan.add_new_organization;
    var canAdd = company.support_multi_organizations;
    var _a = useContext(TicketContext), changePageType = _a.changePageType, organization = _a.organization;
    var _b = useState(false), fetching = _b[0], setFetching = _b[1]; //无数据时展示
    var _c = useState(0), lastFetchId = _c[0], setLastFetchId = _c[1]; //
    var _d = useState([]), data = _d[0], setData = _d[1]; //搜索到的数据
    var _e = useState([]), valueList = _e[0], setValueList = _e[1];
    var _f = useState([]), filterList = _f[0], setFilterList = _f[1];
    useEffect(function () {
        var list = [organization];
        setValueList(__spreadArray([], list, true));
        props.onChange && props.onChange(list.map(function (item) { return item.value || ""; }));
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [organization]);
    // 搜索用户
    var fetchUser = useCallback(function (searchValue) {
        setLastFetchId(function () { return lastFetchId + 1; });
        var fetchId = lastFetchId;
        setData([]);
        setFetching(true);
        csApiPostJSON("/cs/ts/api/organizations/search", { query: searchValue }).then(function (res) { return res.data; }).then(function (res) {
            if (fetchId !== lastFetchId) {
                // for fetch callback order
                return;
            }
            // 处理数据格式
            var data = res.organizations.map(function (item) {
                return {
                    value: item.id,
                    label: item.name,
                };
            });
            setData(data);
            setFetching(false);
        });
    }, [lastFetchId]);
    // 选项变化时回调
    function handleChange(value, index) {
        var list = valueList;
        //改变当前选择的公司的值
        list.splice(index, 1, value || {});
        // 重新赋值
        setValueList(__spreadArray([], list, true));
        setFetching(false);
        // 将选择的id数组更新   为了搜索数据之后筛选用
        setFilterList(list.map(function (item) { return item.value; }));
        // 改变外部form值
        props.onChange && props.onChange(list.map(function (item) { return item.value || ""; }));
    }
    // 添加新的公司
    var addOrg = useCallback(function () {
        var canAdd = true;
        //如果有公司还没有选  禁止新加
        valueList.forEach(function (item) {
            if (!item.value) {
                canAdd = false;
                return;
            }
        });
        if (!valueList[valueList.length - 1].value) {
            canAdd = false;
            return;
        }
        canAdd && setValueList(__spreadArray([], valueList.concat({}), true));
    }, [valueList]);
    // 删除公司
    var deleteOrg = useCallback(function (index) {
        setValueList(function () {
            valueList.splice(index, 1);
            return __spreadArray([], valueList, true);
        });
    }, [valueList]);
    // 点击已选择的公司  进入公司详情
    var gotoCompany = useCallback(function (e) {
        // 如果没有选择  不进行操作
        if (!valueList.length || !valueList[0].value)
            return;
        // 判断点击的是否是选择的字的地方  其他地方不触发
        if (e.target.className === "#{$prefix}-select-selection-item") {
            event.transitionToRoute &&
                event.transitionToRoute({
                    route: "crm.organization.show",
                    path: valueList[0].value,
                });
        }
    }, [event, valueList]);
    var getPopupContainer = useCallback(function () { return ref.current || document.body; }, []);
    return (React.createElement("div", { className: style["select-wrapper"], ref: ref },
        React.createElement("div", { className: style["org-select-wrapper"] }, valueList.map(function (item, index) {
            return (React.createElement("div", { key: index, className: style["select-itme-wrapper"], id: "select" },
                React.createElement(Select, { onClick: gotoCompany, showSearch //显示搜索
                    : true, showArrow: true, labelInValue: true, value: valueList[index], placeholder: props.placeholder, notFoundContent: fetching ? React.createElement(Spin, { size: "small" }) : null, filterOption: false, onSearch: fetchUser, onChange: function (value) { return handleChange(value, index); }, style: { width: "100%" }, getPopupContainer: getPopupContainer, allowClear: true, disabled: index !== valueList.length - 1 }, data.map(function (d) {
                    if (!filterList.includes(d.value))
                        return (React.createElement(Option, { key: d.value, value: d.value }, d.label));
                    else
                        return React.createElement(React.Fragment, null);
                })),
                (function () {
                    if (canAdd) {
                        if (index) {
                            return (React.createElement("div", { onClick: function () { return deleteOrg(index); }, className: style["add-org"] },
                                React.createElement(MinusOutlined, null)));
                        }
                        else {
                            return (React.createElement("div", { className: style["add-org"], onClick: addOrg },
                                React.createElement(PlusOutlined, null)));
                        }
                    }
                })()));
        })),
        canCreate && valueList.length < 20 && (React.createElement("div", { className: style["input-after-icon"], onClick: function () { return changePageType("org"); } },
            React.createElement(PlusOutlined, null),
            t("page.im.ticket.addCompany")))));
}
export default SearchOrgField;
