//搜索公司
import React, { useCallback, useEffect, useState } from 'react';
import { Select } from 'udesk-ui';
var Option = Select.Option;
function LanguageField(props) {
    var list = props.options || [];
    var _a = useState(props.value), value = _a[0], setValue = _a[1]; //选择的选项
    var data = (function () {
        return list.map(function (item) {
            return {
                value: item.value,
                label: item.title,
            };
        });
    })(); //搜索到的数据
    useEffect(function () {
        setValue(props.value);
    }, [props.value]);
    // 选项变化时回调
    var handleChange = useCallback(function (value) {
        setValue(value);
        props.onChange && props.onChange(value);
    }, [props]);
    //筛选规则
    var handleFilter = useCallback(function (inputValue, option) {
        return option.children.includes(inputValue);
    }, []);
    return (React.createElement(React.Fragment, null,
        React.createElement(Select, { showSearch //显示搜索
            : true, showArrow: true, value: value, placeholder: props.placeholder, onChange: handleChange, style: { width: '100%' }, filterOption: handleFilter, getPopupContainer: function (triggerNode) { return triggerNode; } }, data.map(function (d) { return (React.createElement(Option, { key: d.value, value: d.value }, d.label)); }))));
}
export default LanguageField;
