//标签选择  可分词
//由于需要回显  初始化时没有数据源  只用id取不到显示内容  所以原数据返回 存储 回填
//返回数据格式为 [{value:1,label:'xxxx'},...]
//如只需id 在外部提交时单独处理
import React, { useCallback, useEffect, useState } from "react";
import { Select, Spin, Tag } from "udesk-ui";
import { getJSON } from "../../../../utils/index";
var Option = Select.Option;
function TagField(props) {
    var _a = props.trigger, trigger = _a === void 0 ? "onChange" : _a;
    var _b = useState([]), value = _b[0], setValue = _b[1]; //选择的选项
    var _c = useState(false), fetching = _c[0], setFetching = _c[1]; //无数据时展示
    var _d = useState(0), lastFetchId = _d[0], setLastFetchId = _d[1]; //
    var _e = useState([]), data = _e[0], setData = _e[1]; //搜索到的数据
    var _f = useState(false), hasFocus = _f[0], setHasFocus = _f[1];
    useEffect(function () {
        fetchUser();
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    useEffect(function () {
        setValue(function () {
            if (Array.isArray(props.value) && props.value.length > 0) {
                return props.value.map(function (item) {
                    return {
                        value: (item.value || item.id),
                        label: item.label || item.name,
                        color: item.color,
                    };
                });
            }
            else {
                return [];
            }
        });
    }, [props.value]);
    // 搜索用户
    var fetchUser = useCallback(function (searchValue) {
        if (searchValue === void 0) { searchValue = ""; }
        setLastFetchId(function () { return lastFetchId + 1; });
        var fetchId = lastFetchId;
        setData([]);
        setFetching(true);
        getJSON("/tags?query=" + searchValue).then(function (res) {
            if (fetchId !== lastFetchId) {
                // for fetch callback order
                return;
            }
            var data = (res.tags || []).map(function (item) {
                return {
                    value: item.id,
                    label: item.name,
                    color: item.color,
                };
            });
            setData(data);
            setFetching(false);
        });
    }, [lastFetchId]);
    var reSelect = useCallback(function () {
        getJSON("/tags?query=").then(function (res) {
            var data = (res.tags || []).map(function (item) {
                return {
                    label: item.name,
                    value: item.id,
                    color: item.color,
                };
            });
            setData(data);
        });
    }, []);
    var selectOnFocus = useCallback(function () {
        setHasFocus(true);
        getJSON("/tags?query=").then(function (res) {
            var data = (res.tags || []).map(function (item) {
                return {
                    label: item.name,
                    value: item.id,
                    color: item.color,
                };
            });
            setData(data);
        });
    }, []);
    // 选项变化时回调
    var handleChange = useCallback(function (value) {
        if (value.length && !value[0].color)
            value[0].color = "1";
        setValue(value);
        setFetching(false);
        if (trigger === "onChange") {
            props.onChange && props.onChange(value);
        }
        if (!hasFocus) {
            if (trigger === "onBlur") {
                props.onBlur && props.onBlur(value);
            }
        }
        // selectOnFocus()
        reSelect();
    }, [hasFocus, props, reSelect, trigger]);
    var handleOnBlur = useCallback(function () {
        setHasFocus(false);
        if (value.length && !value[0].color)
            value[0].color = "1";
        if (trigger === "onBlur") {
            props.onBlur && props.onBlur(value);
        }
    }, [props, trigger, value]);
    var handleColor = useCallback(function (value) {
        var colorType = "1";
        //查询数据源中是否有选择的数据  如果有   颜色用数据源中此数据的颜色
        for (var key in data) {
            if (data[key].value === value) {
                colorType = data[key].color;
            }
        }
        switch (colorType) {
            case "1":
                return "green";
            case "2":
                return "lime";
            case "3":
                return "blue";
            case "4":
                return "geekblue";
            case "5":
                return "magenta";
            case "6":
                return "purple";
            case "7":
                return "red";
            case "8":
                return "orange";
            case "9":
                return "gold";
            case "10":
                return "#999999";
        }
    }, [data]);
    var tagRender = useCallback(function (props) {
        var label = props.label, value = props.value, closable = props.closable, onClose = props.onClose;
        var color = handleColor(value);
        return (React.createElement(Tag, { color: color, closable: closable, onClose: onClose, style: { marginRight: 3 } }, label));
    }, [handleColor]);
    return (React.createElement("div", null,
        React.createElement(Select, { mode: "tags", showSearch //显示搜索
            : true, showArrow: true, labelInValue: true, value: value, placeholder: props.placeholder, notFoundContent: fetching ? React.createElement(Spin, { size: "small" }) : null, filterOption: false, onSearch: fetchUser, onChange: handleChange, style: { width: "100%" }, getPopupContainer: function (triggerNode) { return triggerNode; }, allowClear: true, onFocus: selectOnFocus, onBlur: handleOnBlur, tagRender: tagRender, tokenSeparators: [","] }, data.map(function (_a) {
            var value = _a.value, label = _a.label;
            return (React.createElement(Option, { key: value, value: value }, label));
        }))));
}
export default TagField;
