import React, { useCallback, useContext, useEffect, useMemo, useRef, useState, } from "react";
import style from "../index.module.scss";
import { Button, Form, message } from "udesk-ui";
import { useTranslation } from "react-i18next";
import * as FieldComponent from "../components/index";
import { formatCustomField, postJSON } from "../../../utils/index";
import CustomField from "../../../components/custom-field-container";
import cloneDeep from "lodash-es/cloneDeep";
import { TicketContext } from "../../../im-panel/ticket/utilities";
function CreateOrg(props) {
    var formRef = useRef(null);
    //多语言
    var t = useTranslation().t;
    //ember传进来的参数
    // const udeskWebappContext: ImContextProps = useContext(UdeskContext);
    var _a = props.organizationFieldsv2, organizationFieldsv2 = _a === void 0 ? [] : _a;
    //新建工单用的useContext
    var _b = useContext(TicketContext), changePageType = _b.changePageType, changeOrganization = _b.changeOrganization;
    //自定义字段数据 field
    var _c = useState([]), orgField = _c[0], setOrgField = _c[1];
    ////自定义字段的fromData
    var _d = useState(), customData = _d[0], setCustomFormData = _d[1];
    // 首次进入 处理自定义字段
    var _organizationFieldsv2 = useMemo(function () {
        return cloneDeep(organizationFieldsv2);
    }, [organizationFieldsv2]);
    useEffect(function () {
        //循环用户自定义字段   从中筛选出自定义字段和im显示的子弹 并且处理是否必填  agent_permission=1就是必填的
        var contextCustomerFields = _organizationFieldsv2.filter(function (item) {
            item.is_required = item.agent_permission === 1 ? true : false;
            return item.agent_permission && item.im_show;
        });
        var organizationFields = formatCustomField({
            fields: contextCustomerFields,
        }); //自定义字段的formItem
        //给form字段重新复制 合并
        setOrgField(organizationFields);
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    // 提交时触发
    var handleSubmit = useCallback(function (value) {
        var params = { organization: {} };
        var data = value;
        // 将完整form中的自定义字段拆出来
        var org_fields = {};
        // 循环完整表单数据
        for (var key in data) {
            // 如果当前循环的数据key在自定义表单中也有  取出来  删除
            if (key in customData) {
                org_fields[key] = data[key];
                delete data[key];
            }
        }
        params.organization = Object.assign({
            custom_fields: org_fields,
        }, data);
        // 开始提交请求
        postJSON("/organizations", params)
            .then(function (res) {
            var _a;
            if (res.code === 1000) {
                // 创建成功后将创建的用户更新   给新增工单页面回显用
                changeOrganization({
                    label: res.organization.name,
                    value: res.organization.id,
                });
                //更改页面类型  返回新建工单
                changePageType("customer");
            }
            else {
                message.error((res === null || res === void 0 ? void 0 : res.code_message) || ((_a = res === null || res === void 0 ? void 0 : res.exception) === null || _a === void 0 ? void 0 : _a.message) || t("saveError"));
            }
        })
            .catch(function (e) {
            console.log(e);
            message.error(t("saveError"));
        });
    }, [changeOrganization, changePageType, customData, t]);
    // 表单数据改变触发  开发时方便查看  提测注释掉
    var handleChangeValue = useCallback(function (changeValue, allValue) {
        // setFormData(allValue);
    }, []);
    var handleInitialValue = useMemo(function () {
        var customerFormData = {}; //自定义字段的formData
        //循环用户自定义字段   将处理过后的数据和formField,formData合并
        _organizationFieldsv2
            .filter(function (item) {
            return item.agent_permission && item.im_show;
        })
            .forEach(function (item) {
            customerFormData[item.name] =
                item.name.split("_")[0] === "TextField" ? "" : [];
        });
        setCustomFormData(customerFormData);
        return Object.assign({
            name: "",
            level: "vip",
            description: "",
            org_email_suffix: "",
            domains: "",
        }, customerFormData);
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [false]);
    return (React.createElement(React.Fragment, null,
        React.createElement("div", { className: style["ticket-form"] },
            React.createElement(Form, { ref: formRef, initialValues: handleInitialValue, onFinish: handleSubmit, layout: "vertical", onValuesChange: handleChangeValue },
                React.createElement(Form.Item, { name: "name", label: t("page.im.ticket.organization_name"), required: true, rules: [{ required: true, message: "\u8BF7\u586B\u5199\u516C\u53F8\u540D\u79F0" }] },
                    React.createElement(FieldComponent.text, { trigger: "onChange", isRequired: true, id: "name", type: "text" })),
                React.createElement(Form.Item, { name: "level", label: t("page.im.ticket.level") },
                    React.createElement(FieldComponent.droplist, { id: "level", type: "droplist", trigger: "onChange", options: [
                            {
                                value: "normal",
                                title: t("page.im.ticket.normal"),
                            },
                            {
                                value: "vip",
                                title: "VIP",
                            },
                        ] })),
                React.createElement(Form.Item, { name: "description", label: t("page.im.ticket.description") },
                    React.createElement(FieldComponent.textarea, { trigger: "onChange", placeholder: t("page.im.ticket.descTip"), id: "description", type: "textarea" })),
                React.createElement(Form.Item, { name: "org_email_suffix", label: t("page.im.ticket.org_email_suffix") },
                    React.createElement(FieldComponent.textHasPoint, { remark: t("page.im.ticket.emailSuffixHelpText") })),
                React.createElement(Form.Item, { name: "domains", label: t("page.im.ticket.domains") },
                    React.createElement(FieldComponent.textHasPoint, { remark: t("page.im.ticket.helpBlock") })),
                orgField.length > 1 && React.createElement(CustomField, { fields: orgField }))),
        React.createElement("div", { className: style["bottom-btn-list"] },
            React.createElement(Button, { style: { marginRight: "10px" }, onClick: function () { return changePageType("customer"); } }, t("cancel")),
            React.createElement(Button, { type: "primary", onClick: function () { return formRef.current.submit(); } }, t("save")))));
}
export default CreateOrg;
