var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import React, { useEffect, useMemo, useState } from "react";
import style from "./index.module.scss";
import { useTranslation } from "react-i18next";
import CreateTicket from "./create-ticket-page";
import CreateCustomer from "./create-customer-page";
import CreateOrg from "./create-org-page";
import { getJSON } from "../../utils";
import { TicketContext } from "./utilities";
function CreateTicketIndex(_a) {
    var onCreateSuccess = _a.onCreateSuccess, props = __rest(_a, ["onCreateSuccess"]);
    var _b = useState([]), agent = _b[0], setAgent = _b[1];
    useEffect(function () {
        getJSON("/user_groups/list_with_agents_status").then(function (res) {
            var options = res.user_groups.map(function (item) {
                return {
                    label: res.ticket_setting_is_open
                        ? "".concat(item.name, "  (").concat(res.ticket_setting_online_title, " ").concat(item.agents_availability_count, "/").concat(item.agents_count, ")")
                        : item.name,
                    value: item.id,
                    agents_availability_count: item.agents_availability_count,
                    agents_count: item.agents_count,
                    children: item.agents.map(function (item) {
                        return {
                            label: res.ticket_setting_is_open
                                ? "".concat(item.nick_name, "  (").concat(item.availability
                                    ? res.ticket_setting_online_title
                                    : res.ticket_setting_offline_title, ")")
                                : item.nick_name,
                            value: item.id,
                            availability: item.availability,
                        };
                    }),
                };
            });
            setAgent(options);
        });
    }, []);
    var t = useTranslation().t;
    var _c = useState("ticket"), pageType = _c[0], setPageType = _c[1]; //页面类型  用于切换界面   ticket 新建工单  customer 新建客户 org 新建公司
    var _d = useState(""), agentGroup = _d[0], setAgentGroup = _d[1]; //负责组   新增用户中的负责组 组件中改变 负责组选择  改变该值  在 负责人组件中 使用
    var _e = useState({}), customer = _e[0], setCustomer = _e[1];
    var _f = useState({}), organization = _f[0], setOrganization = _f[1];
    //根据pagetype不一样 改变头部标题
    var header = pageType === "ticket"
        ? t("page.im.ticket.createTicket")
        : pageType === "customer"
            ? t("page.im.ticket.createCustomer")
            : t("page.im.ticket.createOrg");
    var contextContent = useMemo(function () {
        return {
            changePageType: function (type) { return setPageType(type); },
            agentGroup: agentGroup,
            changeAgentGroup: function (type) { return setAgentGroup(type); },
            customer: customer,
            changeCustomer: function (object) { return setCustomer(object); },
            organization: organization,
            changeOrganization: function (object) {
                return setOrganization(object);
            },
            agent: agent,
        };
    }, [agent, agentGroup, customer, organization]);
    var content = useMemo(function () {
        switch (pageType) {
            case "ticket":
                return (React.createElement(CreateTicket, __assign({ setShowTicket: props.setShowTicket, onSaveSuccess: onCreateSuccess }, props)));
            case "customer":
                return React.createElement(CreateCustomer, __assign({}, props));
            default:
                return React.createElement(CreateOrg, __assign({}, props));
        }
    }, [pageType, props]);
    return (React.createElement("div", { className: style["ticket-wrapper"] },
        React.createElement("div", { className: style["ticket-header"] }, header),
        React.createElement(TicketContext.Provider, { value: contextContent }, content)));
}
export default CreateTicketIndex;
