function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useState, useImperativeHandle } from 'react';
import { Divider, Radio } from "../index";
import Cropper from 'react-cropper';
var defaultClipperItem = {
  key: 'custom',
  title: '自定义',
  initialAspectRatio: 1,
  description: '自定义裁剪预览'
};
var defaultStyle = {
  width: '100%'
};
var ImageClipper = /*#__PURE__*/React.forwardRef(function (props, ref) {
  var _props$clipperTitle = props.clipperTitle,
      clipperTitle = _props$clipperTitle === void 0 ? '裁剪区域' : _props$clipperTitle,
      _props$previewTitle = props.previewTitle,
      previewTitle = _props$previewTitle === void 0 ? '预览区域' : _props$previewTitle,
      _props$dragMode = props.dragMode,
      dragMode = _props$dragMode === void 0 ? 'move' : _props$dragMode,
      _props$guides = props.guides,
      guides = _props$guides === void 0 ? false : _props$guides,
      _props$clipperStyle = props.clipperStyle,
      clipperStyle = _props$clipperStyle === void 0 ? {} : _props$clipperStyle,
      _props$viewMode = props.viewMode,
      viewMode = _props$viewMode === void 0 ? 1 : _props$viewMode,
      _props$zoomable = props.zoomable,
      zoomable = _props$zoomable === void 0 ? true : _props$zoomable,
      _props$rotatable = props.rotatable,
      rotatable = _props$rotatable === void 0 ? true : _props$rotatable,
      _props$responsive = props.responsive,
      responsive = _props$responsive === void 0 ? true : _props$responsive,
      _props$checkCrossOrig = props.checkCrossOrigin,
      checkCrossOrigin = _props$checkCrossOrig === void 0 ? true : _props$checkCrossOrig,
      clipperItems = props.clipperItems,
      imageSrc = props.imageSrc,
      _props$maxImageHeight = props.maxImageHeight,
      maxImageHeight = _props$maxImageHeight === void 0 ? 500 : _props$maxImageHeight,
      crop = props.crop,
      cropend = props.cropend;
  var cropRefs = React.useRef({});
  var thisRef = React.useRef(null);
  var standardClipperItems = [];

  if (clipperItems) {
    standardClipperItems = standardClipperItems.concat(clipperItems);
  } else {
    standardClipperItems = [defaultClipperItem];
  }

  var _useState = useState(standardClipperItems[0]),
      _useState2 = _slicedToArray(_useState, 2),
      currentClipperItem = _useState2[0],
      setCurrentClipperItem = _useState2[1];

  var onAspectRatioChange = function onAspectRatioChange(e) {
    setCurrentClipperItem(e.target.value);
  };

  var onReady = function onReady(e, item) {
    if (maxImageHeight && !clipperStyle.height) {
      for (var _i = 0, _Object$keys = Object.keys(cropRefs.current); _i < _Object$keys.length; _i++) {
        var key = _Object$keys[_i];
        cropRefs.current[key].img.parentElement.style.height = maxImageHeight + 'px';
      }

      window.dispatchEvent(new Event('resize'));
    }

    onCropend(e, item);
  };

  var onCropend = function onCropend(e, item) {
    if (cropend) {
      cropend(e, item, e.currentTarget.cropper.getCroppedCanvas().toDataURL());
    }
  };

  var onCrop = function onCrop(e, item) {
    if (crop) {
      crop(e, item);
    }
  };

  useImperativeHandle(ref, function () {
    return {
      getClipperImage: function getClipperImage() {
        return standardClipperItems.map(function (item) {
          return {
            key: item.key,
            image: cropRefs.current[item.key].getCroppedCanvas().toDataURL()
          };
        });
      }
    };
  });
  return /*#__PURE__*/React.createElement("div", {
    className: "image-clipper",
    ref: thisRef
  }, /*#__PURE__*/React.createElement("div", {
    className: "clipper-zone"
  }, /*#__PURE__*/React.createElement("h3", null, clipperTitle), /*#__PURE__*/React.createElement("div", {
    className: "content"
  }, standardClipperItems.map(function (item) {
    return /*#__PURE__*/React.createElement("div", {
      key: item.key,
      className: "clipper",
      // 要在隐藏时还能获取到clipper的高度
      style: {
        visibility: currentClipperItem.key === item.key ? 'visible' : 'hidden',
        position: currentClipperItem.key === item.key ? 'relative' : 'absolute'
      }
    }, /*#__PURE__*/React.createElement(Cropper, {
      ref: function ref(el) {
        cropRefs.current[item.key] = el;
      },
      src: imageSrc,
      style: _extends({}, defaultStyle, clipperStyle),
      initialAspectRatio: item.initialAspectRatio,
      aspectRatio: item.aspectRatio,
      guides: guides,
      viewMode: viewMode,
      zoomable: zoomable,
      rotatable: rotatable,
      checkCrossOrigin: checkCrossOrigin,
      preview: ".img-preview-".concat(item.key),
      dragMode: dragMode,
      crop: function crop(e) {
        return onCrop(e, item);
      },
      responsive: responsive,
      restore: false,
      cropend: function cropend(e) {
        return onCropend(e, item);
      },
      ready: function ready(e) {
        return onReady(e, item);
      }
    }));
  })), /*#__PURE__*/React.createElement("div", {
    className: "aspect-ratio-bar"
  }, /*#__PURE__*/React.createElement(Radio.Group, {
    onChange: onAspectRatioChange,
    defaultValue: currentClipperItem
  }, standardClipperItems.length > 1 && standardClipperItems.map(function (item) {
    return /*#__PURE__*/React.createElement(Radio.Button, {
      key: item.key,
      value: item
    }, item.aspectRatioTitle);
  })))), /*#__PURE__*/React.createElement(Divider, {
    type: "vertical",
    className: "divider"
  }), /*#__PURE__*/React.createElement("div", {
    className: "preview-zone"
  }, /*#__PURE__*/React.createElement("h3", null, previewTitle), /*#__PURE__*/React.createElement("div", {
    className: "content"
  }, standardClipperItems.map(function (item) {
    return /*#__PURE__*/React.createElement("div", {
      key: item.key,
      className: "preview-clipper-item"
    }, /*#__PURE__*/React.createElement("div", {
      className: "img-preview-".concat(item.key),
      style: {
        width: '200px',
        height: "".concat(200 / (item.aspectRatio || 1), "px"),
        minWidth: '200px',
        minHeight: "".concat(200 / (item.aspectRatio || 1), "px")
      }
    }), /*#__PURE__*/React.createElement("div", {
      className: "clipper-item-content"
    }, /*#__PURE__*/React.createElement("h4", {
      className: "title"
    }, item.title, item.aspectRatioTitle && " (".concat(item.aspectRatioTitle, ")")), /*#__PURE__*/React.createElement("div", {
      className: "description"
    }, item.description)));
  }))));
});
export default ImageClipper;
//# sourceMappingURL=index.js.map
