import React from 'react';
import { TreeSelectProps } from "antd/es/tree-select";
import "antd/es/tree-select/style/index.less";
import "antd/es/select/style/index.less";
import 'antd/es/tag/style/index.less';
import 'antd/es/empty/style/index.less';
interface SelectOptions {
    value: string;
    title: string;
    default?: boolean;
    subs?: SelectOptions[];
    node_type?: 'branch' | 'leaf';
    icon_url?: string;
    color?: string;
}
declare type ObjectPropertyPath = string | string[];
declare type Options = {
    nodeChildrenPath: ObjectPropertyPath;
    nodeValuePath: ObjectPropertyPath;
};
declare type Field = {
    select_options?: SelectOptions[];
    parent_checkable?: boolean;
    input_tip?: string;
    default_expand_all?: boolean;
};
declare type FieldProps = {
    value?: string | string[];
    onChange?: (value: string | string[]) => void;
    formData: Field;
    warningText?: string;
    disabled?: boolean | (() => boolean);
    changeErrMessage: (value: string) => void;
    size?: 'small' | 'middle' | 'large';
    prefixCls?: TreeSelectProps<any>['prefixCls'];
};
export declare function forEachTree<T>(treeData: T[] | undefined, callback: (node: T) => void, options: Pick<Options, 'nodeChildrenPath'>): void;
declare const TagTree: React.FC<FieldProps>;
export default TagTree;
