import React from 'react';
import { ColumnProps } from 'udesk-ui/es/table';
import { CustomField, ITicket, IAgent, FIlterCondition as ConditionInterface } from '@udesk-webapp/utils';
import TicketTable from './associated-ticket-form';
import TicketFilter, { FilterInterface } from './ticket-filters/index';
import TicketFilterCondition, { DataSourcesInterface } from './ticket-filters/ticket-filter-condition';
export { TicketFilter, TicketFilterCondition, TicketTable };
export * from './ticket-filters';
interface MetaInterface {
    total_records?: number;
    current_page?: number;
}
interface ResultInterface {
    meta: MetaInterface;
    tickets: ITicket[];
}
export interface onRowTypes {
    (record: ITicket): {
        onClick?: () => void;
        onDoubleClick?: () => void;
        onContextMenu?: () => void;
        onMouseEnter?: () => void;
        onMouseLeave?: () => void;
    };
}
export interface listsParamsAllConditionsTypes {
    field_name?: string;
    operation?: string;
    value?: string;
}
export interface listsParamsTypes {
    all_conditions?: Array<listsParamsAllConditionsTypes>;
    any_conditions?: Array<string>;
    column?: string;
    filter_id?: string;
    group_name?: string;
    order?: string;
    page: number;
    page_size: number;
    query?: string;
    sort_by?: Array<Array<string>>;
}
interface TicketColumnInterface {
    fieldMode?: string;
}
export interface TicketDetailTypes {
    isInitDatas?: boolean;
    disabledLists?: Array<number>;
    onRow?: onRowTypes;
    onRowSelectionChange?: Function;
    dataSources?: DataSourcesInterface;
    filterLists?: FilterInterface[];
    ticketCustomFields?: any;
    ticketSystemFields?: any;
    selectedRowKeys?: number[];
    useCustomFieldRequset?: boolean;
    useTicketListRequset?: boolean;
    agents: IAgent[];
    agentsWithAdmin: IAgent[];
    allConditions: ConditionInterface[];
    anyConditions: ConditionInterface[];
    filterMaxNumber?: number;
    filterText?: string;
    filterField?: string;
    hideFilter?: boolean;
    showCondition?: boolean;
    customFields?: CustomField[];
    columns?: (TicketColumnInterface & ColumnProps<ITicket>)[];
    scrollConfig: {
        scrollToFirstRowOnChange: boolean;
        x: string | number;
        y: string | number;
    };
    getTicketsList?: (params: listsParamsTypes) => Promise<ResultInterface>;
    filters: FilterInterface[];
    getFilters: () => Promise<FilterInterface[]>;
    filterClassName?: string;
    removalIconClass?: string;
    addIconClass?: string;
    addIconText?: string;
}
declare const TicketDetail: React.ForwardRefExoticComponent<TicketDetailTypes & React.RefAttributes<unknown>>;
export default TicketDetail;
