import React, { ComponentProps } from 'react';
import { Select } from 'udesk-ui';
import './index.module.scss';
declare type AgentType = {
    label: string;
    value: number;
};
declare type GroupAgentType = {
    label: string;
    value: number;
    children?: AgentType[];
};
declare type PropsInterface = Omit<ComponentProps<typeof Select>, 'filterOption' | 'onChange' | 'value' | 'mode' | 'options' | 'defaultValue' | 'disabled' | 'placeholder'> & {
    value?: number[];
    defaultValue?: number[];
    disabled?: boolean;
    readOnly?: boolean;
    placeholder?: string;
    onChange?: (value: number[], options: object[]) => void;
    currentUser: {
        [key: string]: any;
    };
    admin: {
        [key: string]: any;
    };
    startClassName?: string;
    groupAgentsWithStatus?: GroupAgentType[];
    dropdownMatchSelectWidth?: boolean;
};
declare const FollowerField: React.FC<PropsInterface>;
export default FollowerField;
