/** @jsx jsx */
import { jsx } from '@emotion/react';
import { Component, ComponentProps, CSSProperties } from 'react';
import Control from './control';
import './control.css';
export declare type RenderFunction = () => React.ReactNode;
declare type Props = {
    className: string;
    columnButtonClassName: string;
    columnButtonStyle: CSSProperties;
    buttonComponent?: RenderFunction;
    onClose: () => void;
    onOpen: () => void;
} & Pick<ComponentProps<typeof Control>, 'columns' | 't' | 'classNameOfSearchInput' | 'setoDefaultValue' | 'value' | 'leftTitle' | 'rightTitle' | 'onChange' | 'onReset' | 'allowReset' | 'allowSort' | 'allowAutoSelectNext' | 'allowSetoDefault' | 'CancelButton' | 'ResetButton' | 'ConfirmButton'>;
interface State {
    isOpen: boolean;
}
declare class ColumnControlPopover extends Component<Props, State> {
    private _ref;
    private _doNotClosePopover;
    constructor(props: any);
    render(): jsx.JSX.Element;
    private _bodyEvent;
    componentDidMount(): void;
    componentWillUnmount(): void;
    _close(): void;
    _open(): void;
    _toggle(): void;
    _onChange: (value: any) => void;
    _onReset: () => void;
    _onCancel: () => void;
    static defaultProps: {
        allowSort: boolean;
        allowReset: boolean;
        columnButtonClassName: string;
        CancelButton: ({ onClick, t }: {
            onClick: any;
            t: any;
        }) => jsx.JSX.Element;
        ResetButton: ({ onClick, t }: {
            onClick: any;
            t: any;
        }) => jsx.JSX.Element;
        ConfirmButton: ({ onClick, t }: {
            onClick: any;
            t: any;
        }) => jsx.JSX.Element;
    };
}
export default ColumnControlPopover;
export declare const getRenderPropValue: (propValue?: React.ReactNode | RenderFunction) => React.ReactNode;
