import React, { ComponentProps } from 'react';
import { Input } from 'udesk-ui';
import FieldErrAndExplain from '@udesk-webapp/custom-field-error-explain';
import CopyComponent from '@udesk-webapp/copy-content';
import { useValid } from '@udesk-webapp/custom-field-input-base';
declare type Props = {
    onBlur?: (value: ComponentProps<typeof Input>['value']) => void;
    onFocus?: (value: ComponentProps<typeof Input>['value']) => void;
    authority?: string;
    autoToggleSensitiveValue?: boolean;
    sensitive_mark_placeholder?: string;
    sensitive_mark_position?: number;
    sensitive_mark_size?: number;
    sensitive_mode?: 0 | 1 | 2;
} & Partial<Omit<ComponentProps<typeof FieldErrAndExplain>, 'errMsg'>> & Omit<ComponentProps<typeof Input>, 'onBlur'> & Pick<ComponentProps<typeof CopyComponent>, 'switchFlag'> & Partial<Pick<Parameters<typeof useValid>[0], 'customValidPromise'>> & {
    trigger?: 'onChange' | 'onBlur';
};
declare const Text: React.FC<Props>;
export default Text;
