import React, { ComponentProps } from 'react';
import * as MessageComponent from './components';
import AddToCustomerMenuItem from './add-to-customer-menu-item';
import SearchImRecordMenuItem from './search-im-record-menu-item';
import VoiceToTextMenuItem from './voice-to-text-menu-item';
import AddMessageToKmRobotMenuItem from './add-message-to-km-robot-menu-item';
import RecallMenuItem from './recall-menu-item';
import HideItem from './hide-item';
import RefItem from './ref-item';
import CheckItem from './check-item';
import UnHideItem from './un-hide-item';
import AddToKnowledgeMenuItem from './add-to-knowledge-menu-item';
declare type Props = {
    area?: string;
    kcsSdk?: any;
    robotBaseURL?: string;
    onReEdit: (content: string, msg?: Object) => void;
    onReSend?: () => void;
    allowAddToCustomerInfo: boolean;
    allowAddToRobotKM: boolean;
    allowAddToKM: boolean;
    hideEnable?: boolean;
    refEnable?: boolean;
    allowRecall: boolean;
    allowReedit: boolean;
    msgdisplayStatus?: boolean;
    allowVoiceToText: boolean;
    allowSearchImRecord: boolean;
    allowUnHide?: boolean;
    onSelectTel?: ComponentProps<typeof AddToCustomerMenuItem>['onSelectTel'];
    onSelectEmail?: ComponentProps<typeof AddToCustomerMenuItem>['onSelectEmail'];
    onRecall?: ComponentProps<typeof RecallMenuItem>['onClick'];
    onHide?: ComponentProps<typeof HideItem>['onClick'];
    onRef?: ComponentProps<typeof RefItem>['onClick'];
    onCheck?: ComponentProps<typeof CheckItem>['onClick'];
    onUnHide?: ComponentProps<typeof UnHideItem>['onClick'];
    onAddToKM?: ComponentProps<typeof AddToKnowledgeMenuItem>['onClick'];
    onSelectText?: ComponentProps<typeof SearchImRecordMenuItem>['onClick'];
    onVoiceToText?: ComponentProps<typeof VoiceToTextMenuItem>['onClick'];
    onAddToRobotKM?: ComponentProps<typeof AddMessageToKmRobotMenuItem>['onClick'];
    agent?: {
        aliase?: string;
        nick_name?: string;
    };
    currentUser?: {
        aliase?: string;
        nick_name?: string;
    };
    chat: {
        platform: IPlatform;
        belong: string;
        history?: boolean;
    };
    web_message_display_status: boolean;
    enabledSmartAssistance: boolean;
    realTimeTranslation?: {
        translate_to?: string;
        enabled?: boolean;
    };
    msgColor?: Object;
    msgRecvColor?: Object;
    wechatSuffix?: boolean;
    showCheckbox?: boolean;
    isChecked?: boolean;
    imLogCheckCb?: (id: number, checked: boolean) => void;
    openRecordCb?: (content: IContent) => void;
    reloadImageTimes?: () => void;
    msg: {
        show_type: string;
        event_text: string;
        content: any;
        customer_close: boolean;
        respone: any;
        translation: any;
        is_wechat_fail: boolean;
    } & Pick<IMessage, 'timeout_freq' | 'type' | 'agent_id' | 'timeout_auto_msg' | 'msg_close' | 'data' | 'id' | 'send_status' | 'created_at' | 'rollback_at' | 'im_sub_session_id' | 'updated_at' | 'content_raw' | 'is_receive' | 'sender_name' | 'log_type' | 'read_status' | 'sender' | 'platform' | 'recognition' | 'auto' | 'filename' | 'filesize' | 'filetype' | 'randomFileName' | 'msg_id' | 'date' | 'sensitive' | 'message_display_status' | 'agent_nick_name' | 'inviter'>;
} & Partial<Pick<ComponentProps<typeof MessageComponent['message']>, 'onSelectSuggestion'>>;
declare const ImLog: React.FC<Props>;
export default ImLog;
export { axiosInstance } from './ajax';
