import React from 'react';
import './index.module.scss';
import type { FormLayout } from 'antd/lib/form/Form';
import type { ModalFormProps, ProFormLayoutType } from '@ant-design/pro-form';
export type { ProFormLayoutType };
export declare type ModalPropsType = Pick<ModalFormProps, 'modalProps'>;
export declare type ValueType = {
    [key: string]: {
        render: (text: any, props: any) => any;
        renderFormItem: (text: any, props: any) => any;
    };
};
interface PropsInterface {
    columns: any[];
    valueTypes?: ValueType;
    layoutType?: ProFormLayoutType;
    formLayout?: FormLayout;
    formRef?: React.RefObject<any>;
    hiddenResetButton?: boolean;
    hiddenSubmitButton?: boolean;
    modalProps?: ModalPropsType;
    submitBtnText?: string;
    cancelBtnText?: string;
    title?: string;
    loading?: boolean;
    visible?: boolean;
    isModalScroll?: boolean;
    submitBtnType?: 'save';
    zIndex?: number;
    maskClosable?: boolean;
    destroyOnClose?: boolean;
    language?: string;
    onFinish?: (values: any) => void;
    afterSubmitter?: (props: any) => React.ReactNode | null;
    beforeSubmitter?: (props: any) => React.ReactNode | null;
    onCancel?: () => void;
    onValuesChange?: (id: string, changeValues: any) => void;
    onValuesBlur?: (id: string, changeValues: any) => void;
    submitterRender?: (props: any) => React.ReactNode | string | null;
    collapseRender?: (props: any) => React.ReactNode | string | null;
}
declare const CustomForm: React.FC<PropsInterface>;
export default CustomForm;
