import { __assign, __rest } from "tslib";
import React, { useCallback, useEffect, useState } from 'react';
import { Input } from 'udesk-ui';
import FieldErrAndExplain from '@udesk-webapp/custom-field-error-explain';
import CopyComponent from '@udesk-webapp/copy-content';
import { useValid } from '@udesk-webapp/custom-field-input-base';
var TextArea = Input.TextArea;
var AreaText = function (_a) {
    var isFormItem = _a.isFormItem, switchFlag = _a.switchFlag, customValidPromise = _a.customValidPromise, explainShow = _a.explainShow, explain = _a.explain, v = _a.value, onBlur = _a.onBlur, onChange = _a.onChange, rowsLine = _a.rowsLine, props = __rest(_a, ["isFormItem", "switchFlag", "customValidPromise", "explainShow", "explain", "value", "onBlur", "onChange", "rowsLine"]);
    var _b = useState(''), errMsg = _b[0], setErrMsg = _b[1];
    var _c = useState(v || ''), value = _c[0], setValue = _c[1];
    var handleValid = useValid({
        customValidPromise: customValidPromise,
        onSuccess: function () {
            var changeFunction = onBlur;
            if (typeof changeFunction === 'function') {
                changeFunction(value);
            }
        },
        onError: function (error) {
            var err = error && error.message;
            setErrMsg(err);
        },
    });
    useEffect(function () {
        setValue(v);
    }, [v]);
    var handleOnchange = useCallback(function (e) {
        // 解决ember传值过来时,由于异步渲染引起的光标抖动问题,后面可以考虑下其他解决方案
        // 或者传入数据处由react处理后可以考虑去除此代码,以保证数据流向清晰
        setValue(e.target.value);
        if (typeof onChange === 'function') {
            onChange(e.target.value);
        }
    }, [onChange]);
    var handleValidValue = useCallback(function (e) {
        var value = e.target.value;
        handleValid({
            value: value,
            changeFunction: onBlur,
            isFormItem: isFormItem
        });
    }, [isFormItem, onBlur]);
    return React.createElement(FieldErrAndExplain, { isFormItem: isFormItem, explainShow: explainShow, explain: explain, errMsg: errMsg },
        React.createElement(CopyComponent, { text: value, switchFlag: switchFlag },
            React.createElement(TextArea, __assign({ rows: rowsLine, onBlur: handleValidValue, onChange: handleOnchange, value: value }, props))));
};
AreaText.defaultProps = {
    isFormItem: true
};
export default AreaText;
