import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import React, { Component, createRef } from 'react';
import PropTypes from 'prop-types';
import CommonDropdown from './CommonDropdown';
import Control from './Control';

var MultiSelect = /*#__PURE__*/function (_Component) {
  _inheritsLoose(MultiSelect, _Component);

  function MultiSelect(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this._ref = /*#__PURE__*/createRef();

    _this.toggleDropdown = function () {
      _this.setState({
        isOpen: !_this.state.isOpen
      });
    };

    _this.handleClickOutside = function (event) {
      if (_this._ref.current && !_this._ref.current.contains(event.target)) {
        _this.setState({
          isOpen: false
        });
      }
    };

    _this.state = {
      isOpen: false,
      options: []
    };
    return _this;
  }

  var _proto = MultiSelect.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        controlClassName = _this$props.controlClassName,
        controlStyle = _this$props.controlStyle,
        _this$props$prefix = _this$props.prefix,
        prefix = _this$props$prefix === void 0 ? '' : _this$props$prefix,
        _this$props$options = _this$props.options,
        options = _this$props$options === void 0 ? [] : _this$props$options,
        _this$props$getOption = _this$props.getOptionLabel,
        getOptionLabel = _this$props$getOption === void 0 ? function (v) {
      return JSON.stringify(v);
    } : _this$props$getOption,
        _this$props$getOption2 = _this$props.getOptionValue,
        getOptionValue = _this$props$getOption2 === void 0 ? function (v) {
      return v;
    } : _this$props$getOption2,
        onChange = _this$props.onChange,
        value = _this$props.value,
        _this$props$placehold = _this$props.placeholder,
        placeholder = _this$props$placehold === void 0 ? '全部' : _this$props$placehold,
        _this$props$t = _this$props.t,
        t = _this$props$t === void 0 ? function (v) {
      return v;
    } : _this$props$t,
        loadOptions = _this$props.loadOptions,
        components = _this$props.components,
        showAllOption = _this$props.showAllOption;
    return /*#__PURE__*/React.createElement("div", {
      className: "select-with-search",
      ref: this._ref
    }, /*#__PURE__*/React.createElement("div", {
      className: 'align-justify ' + controlClassName,
      style: controlStyle,
      onClick: this.toggleDropdown
    }, /*#__PURE__*/React.createElement(components.Control, {
      value: value,
      options: options,
      prefix: prefix,
      getOptionLabel: getOptionLabel,
      getOptionValue: getOptionValue,
      showAllOption: showAllOption,
      placeholder: placeholder,
      isOpen: this.state.isOpen,
      t: t
    })), this.state.isOpen ? !loadOptions ? /*#__PURE__*/React.createElement(CommonDropdown, {
      value: value,
      onChange: onChange,
      getOptionValue: getOptionValue,
      getOptionLabel: getOptionLabel,
      t: t,
      showAllOption: showAllOption,
      options: options
    }) : void 0 : void 0);
  };

  _proto.componentDidMount = function componentDidMount() {
    document.addEventListener('mousedown', this.handleClickOutside);
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    document.removeEventListener('mousedown', this.handleClickOutside);
  };

  return MultiSelect;
}(Component);

MultiSelect.propTypes = {
  controlClassName: PropTypes.string,
  controlStyle: PropTypes.object,
  prefix: PropTypes.string,
  value: PropTypes.arrayOf(PropTypes.any),
  options: PropTypes.arrayOf(PropTypes.any),
  loadOptions: PropTypes.func,
  getOptionLabel: PropTypes.func,
  getOptionValue: PropTypes.func,
  onChange: PropTypes.func,
  placeholder: PropTypes.string,
  components: PropTypes.object
};
var defaultComponents = {
  Control: Control
};
MultiSelect.defaultProps = {
  components: defaultComponents,
  controlClassName: 'form-control'
};
export default MultiSelect;
export var components = defaultComponents;