function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import React, { Component } from 'react';
import { Manager, Popper, Reference } from 'react-popper';
import ColumnControl from '@udesk-webapp/column-control';
import PropTypes from 'prop-types';
import assign from 'lodash-es/assign';

var ColumnControlPopover = /*#__PURE__*/function (_Component) {
  _inheritsLoose(ColumnControlPopover, _Component);

  function ColumnControlPopover(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {
      isOpen: false
    };
    _this._ref = /*#__PURE__*/React.createRef();
    _this._doNotClosePopover = false;
    return _this;
  }

  var _proto = ColumnControlPopover.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var managerClassNames = ['dropdown'];

    if (this.state.isOpen) {
      managerClassNames.push('open');
    }

    var _this$props = this.props,
        columns = _this$props.columns,
        _this$props$cols = _this$props.cols,
        cols = _this$props$cols === void 0 ? 1 : _this$props$cols,
        t = _this$props.t,
        onChange = _this$props.onChange,
        _this$props$className = _this$props.className,
        className = _this$props$className === void 0 ? '' : _this$props$className,
        showSearch = _this$props.showSearch,
        classNameOfSearchInput = _this$props.classNameOfSearchInput,
        classNameOfSearchInputWrapper = _this$props.classNameOfSearchInputWrapper,
        classNameOfSearchInputIcon = _this$props.classNameOfSearchInputIcon,
        classNameOfRecoverDefaultWrapper = _this$props.classNameOfRecoverDefaultWrapper,
        classNameOfColumnsWrapper = _this$props.classNameOfColumnsWrapper,
        showRecoverDefault = _this$props.showRecoverDefault,
        onRecoverDefaultClick = _this$props.onRecoverDefaultClick,
        styleOfColumnsWrapper = _this$props.styleOfColumnsWrapper,
        searchPlaceholder = _this$props.searchPlaceholder;
    return /*#__PURE__*/React.createElement("div", {
      className: managerClassNames.join(' ') + ' ' + className,
      ref: this._ref
    }, /*#__PURE__*/React.createElement(Manager, null, /*#__PURE__*/React.createElement(Reference, null, function (_ref) {
      var ref = _ref.ref;
      return (
        /*#__PURE__*/
        //@formatter:off
        React.createElement("button", {
          type: "button",
          className: "btn btn-default",
          ref: ref,
          onClick: function onClick() {
            return _this2._toggle();
          }
        }, t('label.column'), " ", /*#__PURE__*/React.createElement("i", {
          className: "icon icon-caret-down"
        })) //@formatter:on

      );
    }), this.state.isOpen && /*#__PURE__*/React.createElement(Popper, {
      placement: "bottom-end"
    }, function (_ref2) {
      var ref = _ref2.ref,
          style = _ref2.style,
          placement = _ref2.placement;
      return /*#__PURE__*/React.createElement("div", {
        ref: ref,
        style: assign({
          zIndex: 1000000
        }, style),
        "data-placement": placement
      }, /*#__PURE__*/React.createElement(ColumnControl, {
        style: {
          backgroundColor: '#fff',
          border: '1px solid #e1e1e1',
          width: cols * 165 + 20
        },
        columns: columns,
        cols: cols,
        onChange: onChange,
        t: t,
        showSearch: showSearch,
        classNameOfSearchInput: classNameOfSearchInput,
        classNameOfSearchInputWrapper: classNameOfSearchInputWrapper,
        classNameOfSearchInputIcon: classNameOfSearchInputIcon,
        classNameOfRecoverDefaultWrapper: classNameOfRecoverDefaultWrapper,
        classNameOfColumnsWrapper: classNameOfColumnsWrapper,
        showRecoverDefault: showRecoverDefault,
        onRecoverDefaultClick: onRecoverDefaultClick,
        styleOfColumnsWrapper: styleOfColumnsWrapper,
        searchPlaceholder: searchPlaceholder
      }));
    })));
  };

  _proto.componentDidMount = function componentDidMount() {
    var _this3 = this;

    this._ref.current.addEventListener('click', function () {
      _this3._doNotClosePopover = true;
    });

    document.addEventListener('click', this._bodyEvent = function () {
      if (_this3._doNotClosePopover) {
        _this3._doNotClosePopover = false;
        return;
      }

      _this3._close();
    });
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    document.removeEventListener('click', this._bodyEvent);
  };

  _proto._close = function _close() {
    if (this.state.isOpen) {
      var onClose = this.props.onClose;
      onClose && onClose();
      this.setState({
        isOpen: false
      });
    }
  };

  _proto._open = function _open() {
    var onOpen = this.props.onOpen;
    onOpen && onOpen();
    this.setState({
      isOpen: true
    });
  };

  _proto._toggle = function _toggle() {
    if (this.state.isOpen) {
      this._close();
    } else {
      this._open();
    }
  };

  return ColumnControlPopover;
}(Component);

ColumnControlPopover.propTypes = {
  columns: PropTypes.array,
  cols: PropTypes.number,
  onChange: PropTypes.func,
  className: PropTypes.string,
  t: PropTypes.func,
  showSearch: PropTypes.bool,
  classNameOfSearchInput: PropTypes.string,
  classNameOfSearchInputWrapper: PropTypes.string,
  classNameOfSearchInputIcon: PropTypes.string,
  classNameOfRecoverDefaultWrapper: PropTypes.string,
  classNameOfColumnsWrapper: PropTypes.string,
  showRecoverDefault: PropTypes.bool,
  onRecoverDefaultClick: PropTypes.func,
  styleOfColumnsWrapper: PropTypes.object,
  onOpen: PropTypes.func,
  onClose: PropTypes.func,
  searchPlaceholder: PropTypes.string
};
export default ColumnControlPopover;