function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import React, { Component } from 'react';
import filter from 'lodash-es/filter';
import forEach from 'lodash-es/forEach';
import isEmpty from 'lodash-es/isEmpty';
import map from 'lodash-es/map';
import PropTypes from 'prop-types';
var labelStyle = {
  display: 'inline-block',
  padding: '0 15px',
  width: '165px',
  whiteSpace: 'nowrap',
  textOverflow: 'ellipsis',
  overflow: 'hidden'
};
/**
 * @property {array<object>} columns - 将要显示的内容
 * @property {number} cols - 内容显示为几列
 */

var ColumnControl = /*#__PURE__*/function (_Component) {
  _inheritsLoose(ColumnControl, _Component);

  function ColumnControl(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {
      keyword: ''
    };
    return _this;
  }
  /**
   * 恢复默认
   * @returns {null|*}
   */


  var _proto = ColumnControl.prototype;

  _proto.renderRecoverDefault = function renderRecoverDefault() {
    var _this$props = this.props,
        showRecoverDefault = _this$props.showRecoverDefault,
        classNameOfRecoverDefaultWrapper = _this$props.classNameOfRecoverDefaultWrapper,
        styleOfRecoverDefaultWrapper = _this$props.styleOfRecoverDefaultWrapper,
        onRecoverDefaultClick = _this$props.onRecoverDefaultClick,
        t = _this$props.t;

    if (showRecoverDefault) {
      return /*#__PURE__*/React.createElement("div", {
        className: classNameOfRecoverDefaultWrapper,
        style: styleOfRecoverDefaultWrapper
      }, /*#__PURE__*/React.createElement("a", {
        href: "javascript:",
        className: "link",
        onClick: onRecoverDefaultClick
      }, t('label.recover_default')));
    }

    return null;
  };

  /**
   * 搜索框
   * @returns {null|*}
   */
  _proto.renderSearch = function renderSearch() {
    var _this2 = this;

    var keyword = this.state.keyword;
    var _this$props2 = this.props,
        showSearch = _this$props2.showSearch,
        classNameOfSearchInputWrapper = _this$props2.classNameOfSearchInputWrapper,
        styleOfSearchInputWrapper = _this$props2.styleOfSearchInputWrapper,
        classNameOfSearchInput = _this$props2.classNameOfSearchInput,
        styleOfSearchInput = _this$props2.styleOfSearchInput,
        searchPlaceholder = _this$props2.searchPlaceholder,
        classNameOfSearchInputIcon = _this$props2.classNameOfSearchInputIcon,
        styleOfSearchInputIcon = _this$props2.styleOfSearchInputIcon;

    if (showSearch) {
      return /*#__PURE__*/React.createElement("div", {
        className: classNameOfSearchInputWrapper,
        style: styleOfSearchInputWrapper
      }, /*#__PURE__*/React.createElement("input", {
        className: classNameOfSearchInput,
        style: styleOfSearchInput,
        value: keyword,
        onChange: function onChange(e) {
          return _this2.setState({
            keyword: e.target.value
          });
        },
        placeholder: searchPlaceholder
      }), /*#__PURE__*/React.createElement("span", {
        className: classNameOfSearchInputIcon,
        style: styleOfSearchInputIcon
      }));
    }

    return null;
  };

  _proto.render = function render() {
    var _this3 = this;

    var categories = this.determineCategories();
    var _this$props3 = this.props,
        columns = _this$props3.columns,
        _this$props3$cols = _this$props3.cols,
        cols = _this$props3$cols === void 0 ? 1 : _this$props3$cols,
        style = _this$props3.style,
        className = _this$props3.className,
        _this$props3$t = _this$props3.t,
        t = _this$props3$t === void 0 ? function (v) {
      return v;
    } : _this$props3$t,
        classNameOfColumnsWrapper = _this$props3.classNameOfColumnsWrapper,
        styleOfColumnsWrapper = _this$props3.styleOfColumnsWrapper;

    if (!style) {
      style = {};
    }

    if (!style.boxSizing) {
      style.boxSizing = 'content-box';
    }

    if (!style.width) {
      style.width = cols * 165 + "px";
    }

    return /*#__PURE__*/React.createElement("div", {
      style: style,
      className: className
    }, this.renderSearch(), this.renderRecoverDefault(), /*#__PURE__*/React.createElement("div", {
      className: classNameOfColumnsWrapper,
      style: styleOfColumnsWrapper
    }, isEmpty(categories) ? this.renderColumns(columns, cols) : map(categories, function (category) {
      return /*#__PURE__*/React.createElement("div", {
        key: category
      }, /*#__PURE__*/React.createElement("h5", null, t(category)), _this3.renderColumns(filter(columns, ['category', category]), cols));
    })));
  }
  /**
   * @param {array} columns
   * @param {number} cols
   */
  ;

  _proto.renderColumns = function renderColumns(columns, cols) {
    var _this4 = this;

    var _this$props$t = this.props.t,
        t = _this$props$t === void 0 ? function (v) {
      return v;
    } : _this$props$t;
    var keyword = this.state.keyword;
    return /*#__PURE__*/React.createElement("div", null, map(columns, function (item) {
      var title;

      if (!item.name) {
        title = t(item.id);
      } else if (typeof item.name === 'string') {
        title = item.name;
      }

      if (keyword && title.indexOf(keyword) === -1) {
        return null;
      }

      return /*#__PURE__*/React.createElement("label", {
        key: item.id,
        style: labelStyle,
        title: title
      }, /*#__PURE__*/React.createElement("input", {
        type: "checkbox",
        checked: item.display,
        style: {
          marginRight: '5px'
        },
        onChange: function onChange(e) {
          return _this4._onChange(item, e);
        }
      }), item.name || t(item.id));
    }));
  };

  _proto.determineCategories = function determineCategories() {
    var categories = [];
    forEach(this.props.columns, function (item) {
      if (item.category && categories.indexOf(item.category) === -1) {
        categories.push(item.category);
      }
    });
    return categories;
  };

  _proto._onChange = function _onChange(column, e) {
    this.props.onChange(column, e.target.checked);
  };

  return ColumnControl;
}(Component); //@formatter:off


export { ColumnControl as default };
ColumnControl.propTypes = {
  /**
   * 哪些列将受到控制
   * category属性请使用国际化key值
   * @example
   * [
   *  {id:'name', display:true, category:'label.person'},
   *  {id:'age',  display:true, category:'label.person'}
   * ]
   */
  columns: PropTypes.arrayOf(PropTypes.shape({
    id: PropTypes.string.isRequired,
    display: PropTypes.bool,
    category: PropTypes.string,
    name: PropTypes.oneOfType([PropTypes.string, PropTypes.node])
  })).isRequired,
  //显示为几列
  cols: PropTypes.number,
  style: PropTypes.object,
  className: PropTypes.string,
  onChange: PropTypes.func,
  t: PropTypes.func,
  showSearch: PropTypes.bool,
  classNameOfSearchInput: PropTypes.string,
  classNameOfSearchInputWrapper: PropTypes.string,
  classNameOfSearchInputIcon: PropTypes.string,
  classNameOfRecoverDefaultWrapper: PropTypes.string,
  classNameOfColumnsWrapper: PropTypes.string,
  showRecoverDefault: PropTypes.bool,
  onRecoverDefaultClick: PropTypes.func,
  styleOfSearchInput: PropTypes.object,
  styleOfSearchInputWrapper: PropTypes.object,
  styleOfSearchInputIcon: PropTypes.object,
  styleOfRecoverDefaultWrapper: PropTypes.object,
  styleOfColumnsWrapper: PropTypes.object,
  searchPlaceholder: PropTypes.string
}; //@formatter:on

ColumnControl.defaultProps = {
  classNameOfSearchInput: 'form-control input-sm',
  classNameOfSearchInputWrapper: 'form-group has-feedback',
  classNameOfSearchInputIcon: 'icon icon-search form-control-feedback text-muted',
  classNameOfRecoverDefaultWrapper: 'recover-default-wrapper',
  classNameOfColumnsWrapper: 'columns-wrapper',
  className: '',
  styleOfSearchInput: {},
  styleOfSearchInputWrapper: {},
  styleOfSearchInputIcon: {},
  styleOfRecoverDefaultWrapper: {
    padding: '0 15px 10px'
  },
  styleOfColumnsWrapper: {
    height: '270px',
    overflowY: 'auto'
  },
  searchPlaceholder: null
};