import { __assign, __rest } from "tslib";
import React, { useCallback, useEffect, useState, useMemo } from 'react';
import { Input } from 'udesk-ui';
import FieldErrAndExplain from '@udesk-webapp/custom-field-error-explain';
import CopyComponent from '@udesk-webapp/copy-content';
import { useValid } from '@udesk-webapp/custom-field-input-base';
import { sensitiveField } from '@udesk-webapp/utils';
var Text = function (_a) {
    var isFormItem = _a.isFormItem, switchFlag = _a.switchFlag, explainShow = _a.explainShow, explain = _a.explain, v = _a.value, authority = _a.authority, autoToggleSensitiveValue = _a.autoToggleSensitiveValue, sensitiveMarkPlaceholder = _a.sensitive_mark_placeholder, sensitiveMarkPosition = _a.sensitive_mark_position, sensitiveMarkSize = _a.sensitive_mark_size, sensitiveMode = _a.sensitive_mode, customValidPromise = _a.customValidPromise, onBlur = _a.onBlur, onFocus = _a.onFocus, onChange = _a.onChange, props = __rest(_a, ["isFormItem", "switchFlag", "explainShow", "explain", "value", "authority", "autoToggleSensitiveValue", "sensitive_mark_placeholder", "sensitive_mark_position", "sensitive_mark_size", "sensitive_mode", "customValidPromise", "onBlur", "onFocus", "onChange"]);
    var _b = useState(''), errMsg = _b[0], setErrMsg = _b[1];
    var _c = useState(v || ''), value = _c[0], setValue = _c[1];
    // // 设置展示值
    // const [showValue, setShowValue] = useState(value);
    // 判断是否获取焦点
    var _d = useState(false), focusing = _d[0], setFocusing = _d[1];
    var handleValid = useValid({
        customValidPromise: customValidPromise,
        onSuccess: function () {
            var changeFunction = onBlur;
            if (typeof changeFunction === 'function') {
                changeFunction(value || '');
            }
        },
        onError: function (error) {
            var err = error && error.message;
            setErrMsg(err);
        },
    });
    var showValue = useMemo(function () {
        if (autoToggleSensitiveValue) {
            var sensitiveValue = sensitiveField({
                sensitive_mark_placeholder: sensitiveMarkPlaceholder,
                sensitive_mark_position: sensitiveMarkPosition,
                sensitive_mark_size: sensitiveMarkSize,
                sensitive_mode: sensitiveMode, // 脱敏模式，0不脱敏，1全脱敏，2部分脱敏
            })(value);
            if (!focusing) {
                return sensitiveValue;
            }
            else {
                return value;
            }
        }
        else {
            return authority === 'sensitive' ? sensitiveField(props)(value) : value;
        }
    }, [authority, autoToggleSensitiveValue, focusing, props, sensitiveMarkPlaceholder, sensitiveMarkPosition, sensitiveMarkSize, sensitiveMode, value]);
    useEffect(function () {
        setValue(v || '');
    }, [v]);
    var handleOnchange = useCallback(function (e) {
        // 解决ember传值过来时,由于异步渲染引起的光标抖动问题,后面可以考虑下其他解决方案
        // 或者传入数据处由react处理后可以考虑去除此代码,以保证数据流向清晰
        setValue(e.target.value);
        if (typeof onChange === 'function') {
            onChange(e.target.value);
        }
    }, [onChange]);
    var handleValidValue = useCallback(function (e) {
        setFocusing(false);
        var value = e.target.value;
        handleValid({
            value: value,
            changeFunction: onBlur,
            isFormItem: isFormItem
        });
    }, [handleValid, isFormItem, onBlur]);
    var focus = useCallback(function () {
        setFocusing(true);
        onFocus === null || onFocus === void 0 ? void 0 : onFocus(value);
    }, [onFocus, value]);
    return (React.createElement(FieldErrAndExplain, { isFormItem: isFormItem, explainShow: explainShow, explain: explain, errMsg: errMsg },
        React.createElement(CopyComponent, { text: showValue, switchFlag: switchFlag },
            React.createElement(Input, __assign({ value: showValue, onBlur: handleValidValue, onChange: handleOnchange }, props, { onFocus: focus })))));
};
Text.defaultProps = {
    isFormItem: true
};
export default Text;
