import { useEffect, useState } from "react";
import KcsSDKWrapper from "./KcsSDKWrapper";
var useKcsSDK = function (props) {
    var buttonsAuthority = props.buttonsAuthority, onButtonClick = props.onButtonClick, onFileButtonClick = props.onFileButtonClick;
    var _a = useState(), kcsInstance = _a[0], setKcsInstance = _a[1];
    var getSDKInstance = function () {
        return KcsSDKWrapper.getInstance({ buttonsAuthority: buttonsAuthority });
    };
    useEffect(function () {
        var kcsWrapper = getSDKInstance();
        if (kcsWrapper.kcsInstance) {
            setKcsInstance(function (v) { return v || kcsWrapper.kcsInstance; });
            return;
        }
        var onReady = function (r) { return setKcsInstance(r); };
        kcsWrapper.on("ready", onReady);
        return function () {
            kcsWrapper.off("ready", onReady);
        };
    }, []);
    useEffect(function () {
        var kcsWrapper = getSDKInstance();
        var buttonClickListener = function (data, buttonType) { return onButtonClick === null || onButtonClick === void 0 ? void 0 : onButtonClick(data, buttonType); };
        var fileButtonClickListener = function (file, buttonType) {
            return onFileButtonClick === null || onFileButtonClick === void 0 ? void 0 : onFileButtonClick(file, buttonType);
        };
        kcsWrapper.on("buttonClick", buttonClickListener);
        kcsWrapper.on("fileButtonClick", fileButtonClickListener);
        return function () {
            kcsWrapper.off("buttonClick", buttonClickListener);
            kcsWrapper.off("fileButtonClick", fileButtonClickListener);
        };
    }, [onButtonClick, onFileButtonClick]);
    return kcsInstance;
};
export default useKcsSDK;
