import { __assign } from "tslib";
import React, { useCallback, useContext, useEffect, useMemo, useRef, useState } from 'react';
import { Button, Form, message } from 'udesk-ui';
import { useTranslation } from '@udesk-webapp/locale';
import { ajax, formatCustomField, replaceTemplateVar, PATH_BASE } from "@udesk-webapp/utils";
import CustomField from '@udesk-webapp/custom-field-container';
import cloneDeep from 'lodash-es/cloneDeep';
import { TicketContext } from "@udesk-webapp/ticket-signature/es/utilities";
// 用各种独立包替代
// import * as FieldComponent from '../components/index'
import Text from '@udesk-webapp/custom-field-text';
import Droplist from '@udesk-webapp/custom-field-radio-droplist';
import Textarea from '@udesk-webapp/custom-field-text-area';
import Email from '@udesk-webapp/ticket-system-field-email';
import SearchOrg from "@udesk-webapp/ticket-system-field-search-org";
import Cellphone from "@udesk-webapp/ticket-system-field-cellphone";
import Tag from "@udesk-webapp/ticket-system-field-tag";
import SelectSearch from "@udesk-webapp/ticket-system-field-select-search";
import AgentGroups from "@udesk-webapp/ticket-system-field-agent-groups";
import AgentUser from "@udesk-webapp/ticket-system-field-agent-user";
import ClassNames from 'classnames';
import style from './index.module.scss';
function CreateCustomer(props) {
    var formRef = useRef(null);
    // 多语言
    var t = useTranslation().t;
    var company = props.company, customerFieldsv2 = props.customerFieldsv2, customerFieldsAuthority = props.customerFieldsAuthority, ticketTab = props.ticketTab, roleCan = props.roleCan, agentGroups = props.agentGroups, event = props.event, agents = props.agents, _a = props.customerTextConfig, customerTextConfig = _a === void 0 ? {} : _a, onChange = props.onChange;
    var customerFieldsv2Clone = useMemo(function () { return cloneDeep(customerFieldsv2); }, [customerFieldsv2]);
    // 新建工单用的useContext
    var _b = useContext(TicketContext), changePageType = _b.changePageType, changeCustomer = _b.changeCustomer;
    // 自定义字段数据 field
    var _c = useState([]), customField = _c[0], setCustomField = _c[1];
    // 自定义字段的fromData
    var _d = useState(), customFormData = _d[0], setCustomFormData = _d[1];
    // 首次进入 处理自定义字段
    useEffect(function () {
        // 循环用户自定义字段   从中筛选出自定义字段和im显示的子弹 并且处理是否必填  agent_permission=1就是必填的
        var contextCustomerFields = customerFieldsv2Clone.filter(function (item) { return item.agent_permission && item.im_show; });
        var customerFields = formatCustomField({
            fields: contextCustomerFields,
            trigger: 'onBlur',
            fieldsAuthority: customerFieldsAuthority,
            fieldType: 'customer',
            editType: 'new',
            showLabel: true
        }); // 自定义字段的formItem
        setCustomField(customerFields);
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    // 提交时触发
    var handleSubmit = useCallback(function (value) {
        var _a;
        var params = { customer: {} };
        var data = value;
        // 处理cellphones数据格式
        data.cellphones_attributes = data.cellphones ? data.cellphones.split(',').map(function (item) { return ({
            content: item
        }); }) : [];
        // 处理完成后删除cellphones   没有必要传
        delete data.cellphones;
        // 默认值
        data.customerListSelected = false;
        data.merging = false;
        data.default_organization_id = null;
        // 如果选了tags  给params赋值tags
        if ((_a = data === null || data === void 0 ? void 0 : data.tags) === null || _a === void 0 ? void 0 : _a.length) {
            params.tags = data.tags.map(function (item) { return item.label; }).join(',');
        }
        // 删除formdata的tags
        delete data.tags;
        // 处理邮箱数据格式
        if (data.email.length > 1) {
            var otherEmails = data.email;
            // email 是 填的email的第一个值  其他的都是otherEmails
            data.email = otherEmails && otherEmails[0];
            // ...报错,改为此种形式
            var defaultEmail = [null];
            var newEmail = defaultEmail.concat(otherEmails.slice(1));
            params.other_emails = [newEmail];
        }
        else {
            data.email = data.email[0] || '';
        }
        // 将完整form中的自定义字段拆出来
        var customFields = {};
        // 循环完整表单数据
        Object.keys(data).forEach(function (key) {
            // 如果当前循环的数据key在自定义表单中也有  取出来  删除
            if (key in customFormData) {
                customFields[key] = data[key];
                delete data[key];
            }
        });
        // for (const key in Object.keys(data)) {
        //     // 如果当前循环的数据key在自定义表单中也有  取出来  删除
        //     if (key in customFormData) {
        //         customFields[key] = data[key]
        //         delete data[key]
        //     }
        // }
        data.custom_fields = customFields;
        // 选择的公司和邮箱处理空数据
        data.organizations = data.organizations.filter(function (item) { return item; });
        params.customer = data;
        ajax().postJSON("".concat(PATH_BASE, "/customers"), params).then(function (res) {
            var _a;
            // 开始提交请求
            if (res.code === 1000) {
                // 创建成功后将创建的用户更新   给新增工单页面回显用
                changeCustomer({
                    label: res.customer.nick_name,
                    value: res.customer.id,
                });
                // TODO: 预留传递字段，取消上面的useContext changeCustomer
                onChange === null || onChange === void 0 ? void 0 : onChange({
                    label: res.customer.nick_name,
                    value: res.customer.id,
                    organization: res.organizations,
                });
                // 更改页面类型  返回新建工单
                changePageType('ticket');
            }
            else {
                message.error((res === null || res === void 0 ? void 0 : res.code_message) || ((_a = res === null || res === void 0 ? void 0 : res.exception) === null || _a === void 0 ? void 0 : _a.message) || t('saveError'));
            }
        }).catch(function (e) {
            var parseMsg = JSON.parse(e.message);
            message.error(parseMsg.data.code_message);
        });
    }, [changeCustomer, changePageType, customFormData, t]);
    var handleInitialValue = useMemo(function () {
        var customerFormData = {}; // 自定义字段的formData
        // 循环用户自定义字段
        customerFieldsv2Clone.filter(function (item) { return item.agent_permission && item.im_show; }).forEach(function (item) {
            var _a;
            if (/^TextField_\d+$/.test(item.name)) {
                customerFormData[item.name] = '';
            }
            else if (/^SelectField_\d+$/.test(item.name)) {
                var defaults = ((_a = item === null || item === void 0 ? void 0 : item.select_options) === null || _a === void 0 ? void 0 : _a.filter(function (j) { return j.default; })) || [];
                if (defaults) {
                    customerFormData[item.name] = defaults.map(function (j) { return j.value; });
                }
                else {
                    customerFormData[item.name] = [];
                }
            }
        });
        setCustomFormData(customerFormData);
        return __assign({ nick_name: '', level: 'normal', email: [], description: '', organizations: [], cellphones: '', tags: [], lang: '', owner_group_id: '', owner_id: '' }, customerFormData);
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    return (React.createElement(React.Fragment, null,
        React.createElement("div", { className: ClassNames(style['ticket-form'], 'public-component-create-customer-ticket-form') },
            React.createElement(Form, { ref: formRef, initialValues: handleInitialValue, onFinish: handleSubmit, layout: 'vertical' },
                React.createElement(Form.Item, { name: 'nick_name', label: customerTextConfig.nick_name || t('page.im.ticket.nick_name'), required: true, rules: [{ required: true, message: replaceTemplateVar(t('needWrite'), t('page.im.ticket.nick_name')) }] },
                    React.createElement(Text, { trigger: 'onChange', id: 'nick_name', type: "text" })),
                React.createElement(Form.Item, { name: 'level', label: t('page.im.ticket.level') },
                    React.createElement(Droplist, { id: 'level', options: [{
                                value: 'normal',
                                title: t('page.im.ticket.normal')
                            }, {
                                value: 'vip',
                                title: 'VIP'
                            }] })),
                React.createElement(Form.Item, { name: 'email', label: t('page.im.ticket.email') },
                    React.createElement(Email, { placeholder: t('page.im.ticket.email') })),
                React.createElement(Form.Item, { name: 'description', label: t('page.im.ticket.description') },
                    React.createElement(Textarea, { trigger: 'onChange', placeholder: t('page.im.ticket.forCustomerDesc'), id: 'description' })),
                React.createElement(Form.Item, { name: 'organizations', label: t('page.im.ticket.organizations') },
                    React.createElement(SearchOrg, { placeholder: t('page.im.ticket.keywordQueryCompany'), roleCan: roleCan, company: company, event: event })),
                React.createElement(Form.Item, { name: 'cellphones', label: customerTextConfig.phone || t('page.im.ticket.phone') },
                    React.createElement(Cellphone, { placeholder: t('page.im.ticket.phone'), event: event, goToCustomer: props.goToCustomer })),
                React.createElement(Form.Item, { name: 'tags', label: customerTextConfig.tags || t('page.im.ticket.tags') },
                    React.createElement(Tag, null)),
                company.is_support_lang &&
                    React.createElement(Form.Item, { name: 'lang', label: t('page.im.ticket.lang') },
                        React.createElement(SelectSearch, { options: ticketTab.langs_dict.map(function (item) { return ({
                                value: item.id,
                                title: item.text
                            }); }) })),
                React.createElement(Form.Item, { name: 'owner_group_id', label: t('page.im.ticket.owner_group_name') },
                    React.createElement(AgentGroups, { agentGroups: agentGroups })),
                React.createElement(Form.Item, { name: 'owner_id', label: t('page.im.ticket.owner_name') },
                    React.createElement(AgentUser, null)),
                customField.length > 1 && React.createElement(CustomField, { fields: customField, agents: agents }))),
        React.createElement("div", { className: style['bottom-btn-list'] },
            React.createElement(Button, { style: { marginRight: '10px' }, onClick: function () { return changePageType('ticket'); } }, t('cancel')),
            React.createElement(Button, { type: "primary", onClick: function () { return formRef.current.submit(); } }, t('submit')))));
}
export default CreateCustomer;
