var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useCallback, useEffect, 
// useRef,
useMemo, } from 'react';
import { Provider } from 'react-redux';
import useLocalStorage from 'react-use/esm/useLocalStorage';
import { UdeskContext, useDispatch } from './store/store-hook';
import { store } from './store/index';
import { formatProps, staticData } from './utils/index';
import { setRUrls } from './store/urls';
import { setCompany } from './store/company';
import { setRoleCan } from './store/role-can';
import { setInitData } from './store/init-data';
import { setCurrentUser } from './store/current-user';
import { setAgents } from './store/agents';
import { setGroups } from './store/groups';
import { setFields } from './store/fields';
import { setNoteTemplateConfig } from './store/note-templates';
import { setPlatform } from './store/platform';
import { getAgentConfig } from './store/agent-config';
import ImPanel from './im-panel/im-entry';
import './index.module.scss';
import { ConfigProvider } from 'antd';
// const MESSAGES_MIN_WIDTH = 395;
var SessionAssist = React.forwardRef(function (props, ref) {
    // const imPanelEntryRef = useRef<ElementRef<typeof ImPanel>>(null);
    // const imMessageRef = useRef<ElementRef<"div">>(null);
    // const rightInnerRef = useRef<ElementRef<"div">>(null);
    var dispatch = useDispatch();
    var _a = useLocalStorage('stretchable-box-right-panel-width', 400, {
        raw: false,
        serializer: function (value) { return value + ''; },
        deserializer: function (value) { return parseInt(value) || 370; },
    }), _b = _a[0], rightWidth = _b === void 0 ? 400 : _b, setRightWidth = _a[1];
    var initData = useMemo(function () {
        console.log('初始化开始');
        staticData.changeRobotUrl(props.kmrobot_url);
        staticData.changePreviewUrl(props.previewUrl);
        var _props = formatProps(props);
        dispatch(setCompany(_props.company));
        dispatch(setRoleCan(_props.roleCan));
        dispatch(setCurrentUser(_props.user));
        dispatch(setAgents(_props.agents));
        dispatch(setGroups(_props.agentGroups));
        dispatch(setInitData(_props)); //props所有数据
        dispatch(setRUrls({
            apiHost: _props.apiHost,
            vistor_server: _props.vistor_server,
        }));
        dispatch(setFields({
            customerFields: _props.customerFields,
            customerFieldsv2: _props.customerFieldsv2,
            organizationFields: _props.organizationFields,
            organizationFieldsv2: _props.organizationFieldsv2,
            noteFields: _props.noteFields,
        }));
        dispatch(setNoteTemplateConfig({
            noteTemplates: _props.noteTemplates || [],
            imAgentNoteTemplatesSort: _props.imAgentNoteTemplatesSort || [],
        }));
        dispatch(setPlatform(_props.platforms));
        dispatch(getAgentConfig());
        return;
    }, []);
    useEffect(function () {
        var _props = formatProps(props);
        dispatch(setInitData(_props));
    }, [props]);
    var onRightWidthChange = useCallback(function (changedWidth) {
        // const messageWidth = imMessageRef?.current?.getWidth?.();
        // if (
        //   messageWidth &&
        //   messageWidth < MESSAGES_MIN_WIDTH &&
        //   changedWidth > rightWidth
        // ) {
        //   const rightInnerWidth = rightInnerRef.current!.offsetWidth;
        //   return setRightWidth(rightInnerWidth - MESSAGES_MIN_WIDTH);
        // } else {
        props.event.onWidthChange(changedWidth);
        return setRightWidth(changedWidth);
        // }
    }, [rightWidth, setRightWidth]);
    return (React.createElement(ImPanel, { ref: ref, width: rightWidth, cssMaxWidth: "calc(100% - ".concat(props.tabsWidth, "px)"), onWidthChange: onRightWidthChange }));
});
var Index = React.forwardRef(function (props, ref) {
    return (React.createElement(ConfigProvider, { prefixCls: 'udesk-avs-web-prefix' },
        React.createElement(Provider, { context: UdeskContext, store: store },
            React.createElement(SessionAssist, __assign({}, props, { ref: ref })))));
});
Index.displayName = 'Index';
export default Index;
