import _assertThisInitialized from "@babel/runtime/helpers/assertThisInitialized";
import _inheritsLoose from "@babel/runtime/helpers/inheritsLoose";
import _defineProperty from "@babel/runtime/helpers/defineProperty";
import React, { Component, createRef } from 'react';
import PropTypes from 'prop-types';
import CommonDropdown from './CommonDropdown';
import Control from './Control';
import { jsx as ___EmotionJSX } from "@emotion/react";

var SingleSelect = /*#__PURE__*/function (_Component) {
  _inheritsLoose(SingleSelect, _Component);

  function SingleSelect(props) {
    var _this;

    _this = _Component.call(this, props) || this;

    _defineProperty(_assertThisInitialized(_this), "_ref", /*#__PURE__*/createRef());

    _defineProperty(_assertThisInitialized(_this), "_onChange", function (value, option) {
      _this.setState({
        isOpen: false
      });

      _this.props.onChange(value, option);
    });

    _defineProperty(_assertThisInitialized(_this), "toggleDropdown", function () {
      _this.setState({
        isOpen: !_this.state.isOpen
      });
    });

    _defineProperty(_assertThisInitialized(_this), "handleClickOutside", function (event) {
      if (_this._ref.current && !_this._ref.current.contains(event.target)) {
        _this.setState({
          isOpen: false
        });
      }
    });

    _this.state = {
      isOpen: false,
      options: []
    };
    return _this;
  }

  var _proto = SingleSelect.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        controlClassName = _this$props.controlClassName,
        controlStyle = _this$props.controlStyle,
        _this$props$prefix = _this$props.prefix,
        prefix = _this$props$prefix === void 0 ? '' : _this$props$prefix,
        _this$props$options = _this$props.options,
        options = _this$props$options === void 0 ? [] : _this$props$options,
        _this$props$getOption = _this$props.getOptionLabel,
        getOptionLabel = _this$props$getOption === void 0 ? function (v) {
      return JSON.stringify(v);
    } : _this$props$getOption,
        _this$props$getOption2 = _this$props.getOptionValue,
        getOptionValue = _this$props$getOption2 === void 0 ? function (v) {
      return v;
    } : _this$props$getOption2,
        onChange = _this$props.onChange,
        value = _this$props.value,
        _this$props$placehold = _this$props.placeholder,
        placeholder = _this$props$placehold === void 0 ? '全部' : _this$props$placehold,
        _this$props$t = _this$props.t,
        t = _this$props$t === void 0 ? function (v) {
      return v;
    } : _this$props$t,
        loadOptions = _this$props.loadOptions,
        components = _this$props.components,
        _this$props$className = _this$props.className,
        className = _this$props$className === void 0 ? '' : _this$props$className;
    return ___EmotionJSX("div", {
      className: 'select-with-search ' + className,
      ref: this._ref
    }, ___EmotionJSX("div", {
      className: 'align-justify ' + controlClassName,
      style: controlStyle,
      onClick: this.toggleDropdown
    }, ___EmotionJSX(components.Control, {
      value: value,
      options: options,
      prefix: prefix,
      getOptionLabel: getOptionLabel,
      getOptionValue: getOptionValue,
      placeholder: placeholder,
      isOpen: this.state.isOpen,
      t: t
    })), this.state.isOpen ? !loadOptions ? ___EmotionJSX(CommonDropdown, {
      value: value,
      onChange: this._onChange,
      getOptionValue: getOptionValue,
      getOptionLabel: getOptionLabel,
      t: t,
      options: options
    }) : void 0 : void 0);
  };

  _proto.componentDidMount = function componentDidMount() {
    document.addEventListener('mousedown', this.handleClickOutside);
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    document.removeEventListener('mousedown', this.handleClickOutside);
  };

  return SingleSelect;
}(Component);

SingleSelect.propTypes = {
  controlClassName: PropTypes.string,
  controlStyle: PropTypes.object,
  prefix: PropTypes.string,
  value: PropTypes.any,
  options: PropTypes.arrayOf(PropTypes.any),
  loadOptions: PropTypes.func,
  getOptionLabel: PropTypes.func,
  getOptionValue: PropTypes.func,
  onChange: PropTypes.func,
  placeholder: PropTypes.string,
  className: PropTypes.string,
  components: PropTypes.object
};
var defaultComponents = {
  Control: Control
};
SingleSelect.defaultProps = {
  components: defaultComponents,
  controlClassName: 'form-control',
  className: ''
};
export default SingleSelect;
export var components = defaultComponents;