import { __assign, __rest } from "tslib";
import React, { useCallback, useContext, useState } from 'react';
import { Select } from 'udesk-ui';
import { TicketContext } from '@udesk-webapp/ticket-signature/es/utilities';
var Option = Select.Option;
var AgentGroupsField = function (_a) {
    var agentGroups = _a.agentGroups, onChange = _a.onChange, propValue = _a.value, props = __rest(_a, ["agentGroups", "onChange", "value"]);
    var changeAgentGroup = useContext(TicketContext).changeAgentGroup;
    // const udeskWebappContext: any = useContext(UdeskContext);//ember传进来的参数
    var langList = agentGroups;
    var _b = useState({
        value: '',
        label: '--'
    }), value = _b[0], setValue = _b[1]; // 选择的选项
    // 处理客服组数据   转完格式以后在前边加上空选项
    var data = (function () {
        var list = langList.map(function (item) { return ({
            value: item.id,
            label: item.name,
        }); });
        // 前边加空选项
        list.unshift({
            value: '',
            label: '--'
        });
        return list;
    })(); // 搜索到的数据
    // 选项变化时回调
    var handleChange = useCallback(function (changedValue) {
        setValue(changedValue);
        changeAgentGroup(changedValue ? changedValue.value : '');
        if (typeof onChange === 'function') {
            onChange(changedValue ? changedValue.value : '');
        }
    }, [changeAgentGroup, onChange]);
    // 筛选规则
    var handleFilter = useCallback(function (inputValue, option) {
        if (option.children.includes(inputValue))
            return true;
        return false;
    }, []);
    return (React.createElement(Select, __assign({ value: value, onChange: handleChange, filterOption: handleFilter }, props), data.map(function (d) { return (React.createElement(Option, { key: d.value, value: d.value }, d.label)); })));
};
AgentGroupsField.defaultProps = {
    showSearch: true,
    showArrow: true,
    labelInValue: true,
    style: { width: '100%' },
    getPopupContainer: function (triggerNode) { return triggerNode; }
};
export default AgentGroupsField;
