import { __assign, __rest } from "tslib";
import React, { useCallback, useEffect, useMemo, useState } from 'react';
import { DanSuanShiXiao, DisableRadio, XuanZeDanXuan } from '@udesk-webapp/icon';
import FieldErrAndExplain from '@udesk-webapp/custom-field-error-explain';
import cssObj from './index.module.scss';
import classNames from 'classnames';
var FiledRadio = function (_a) {
    var _b;
    var isFormItem = _a.isFormItem, trigger = _a.trigger, customValidFn = _a.customValidFn, notUseDefault = _a.notUseDefault, arrangement = _a.arrangement, options = _a.options, disabled = _a.disabled, canCancel = _a.canCancel, value = _a.value, explainShow = _a.explainShow, explain = _a.explain, className = _a.className, onBlur = _a.onBlur, onChange = _a.onChange, hiddenLabelPath = _a.hiddenLabelPath, props = __rest(_a, ["isFormItem", "trigger", "customValidFn", "notUseDefault", "arrangement", "options", "disabled", "canCancel", "value", "explainShow", "explain", "className", "onBlur", "onChange", "hiddenLabelPath"]);
    var _c = useState(''), errMsg = _c[0], setErrMsg = _c[1];
    // 选择的选项值
    var _d = useState(), selectValue = _d[0], setSelectValue = _d[1];
    var yStyle = useMemo(function () { return ({
        display: 'block',
        height: '30px',
        lineHeight: '30px',
        cursor: disabled ? 'not-allowed' : 'pointer',
        verticalAlign: 'middle'
    }); }, [disabled]);
    var xStyle = useMemo(function () { return ({
        display: 'inline-block',
        marginRight: '24px',
        cursor: disabled ? 'not-allowed' : 'pointer',
        verticalAlign: 'middle'
    }); }, [disabled]);
    var validValue = useMemo(function () {
        return Array.isArray(value) ? value[0] : value;
    }, [value]);
    var showOptions = useMemo(function () {
        if (!options) {
            return [];
        }
        return options.filter(function (option) {
            if (!option) {
                return false;
            }
            var isHide = hiddenLabelPath && option[hiddenLabelPath];
            var isSelected = validValue != null && validValue == option.value;
            return !isHide || isSelected;
        });
    }, [hiddenLabelPath, options, validValue]);
    useEffect(function () {
        var _a, _b;
        var v = Array.isArray(value) ? value[0] : value;
        if (!v && !notUseDefault) {
            try {
                v = (_b = (_a = options === null || options === void 0 ? void 0 : options.filter(function (item) { return item.default; })) === null || _a === void 0 ? void 0 : _a[0]) === null || _b === void 0 ? void 0 : _b.value;
            }
            catch (e) {
                // eslint-disable-next-line no-console
                console.error(e);
            }
        }
        setSelectValue(v);
    }, [value]);
    var changeFunction = useMemo(function () {
        if (trigger === 'onChange') {
            return onChange;
        }
        else if (trigger === 'onBlur') {
            return onBlur;
        }
    }, [onBlur, onChange, trigger]);
    var changeRadio = useCallback(function (value) {
        if (disabled)
            return;
        // 如果不支持取消选择  并且点击的是已选择的 不做操作
        if (!canCancel && value === selectValue) {
            return;
        }
        // 如果点击的是已经选择的  取消选择
        var targetValue = value === selectValue ? '' : value;
        setSelectValue(targetValue);
        // 非form表单形式, 自己提示错误, 自己触发保存
        if (!isFormItem) {
            // 有自定义校验
            if (typeof customValidFn === 'function') {
                customValidFn(null, value).then(function () {
                    // 校验成功,可能触发失焦自动保存,要把方法跑出去
                    // props.onValueChangedByBlur && props.onValueChangedByBlur({});
                    changeFunction === null || changeFunction === void 0 ? void 0 : changeFunction(targetValue);
                }, function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                }).catch(function (err) {
                    // 校验失败,提示错误信息
                    setErrMsg(err);
                });
            }
            else {
                changeFunction === null || changeFunction === void 0 ? void 0 : changeFunction(targetValue);
            }
        }
        else {
            changeFunction === null || changeFunction === void 0 ? void 0 : changeFunction(targetValue);
        }
    }, [canCancel, changeFunction, disabled, isFormItem, customValidFn, selectValue]);
    function getContent(item) {
        var content;
        if (item.value === selectValue) {
            content = React.createElement(XuanZeDanXuan, { style: { color: '#00B38B', fontSize: '16px' } });
        }
        else if (disabled) {
            content = React.createElement(DisableRadio, null);
        }
        else {
            content = React.createElement(DanSuanShiXiao, { className: cssObj['weixuanze-icon'] });
        }
        return content;
    }
    return (React.createElement(FieldErrAndExplain, { explainShow: explainShow, explain: explain, isFormItem: isFormItem, errMsg: errMsg },
        React.createElement("div", __assign({ className: classNames(cssObj['radio-select-wrapper'], className) }, props), (_b = showOptions === null || showOptions === void 0 ? void 0 : showOptions.map(function (item) { return (React.createElement("span", { key: item.value, style: arrangement === 'wrap' ? yStyle : xStyle, onClick: function () { return changeRadio(item.value); } },
            React.createElement("div", { style: { display: 'flex', wordBreak: 'break-all' } },
                getContent(item),
                React.createElement("span", { className: "".concat(cssObj['select-item'], " ").concat(item.color ? cssObj['select-item-hascolor'] : ''), style: {
                        background: item.color ? item.color : '',
                        marginLeft: '8px'
                    } },
                    item.icon ? React.createElement("img", { alt: '', src: item.icon, className: cssObj['setting-img'] }) : '',
                    React.createElement("span", { style: { color: disabled ? 'rgba(0, 0, 0, 0.25)' : '' } }, item.title))))); })) !== null && _b !== void 0 ? _b : null)));
};
FiledRadio.defaultProps = {
    notUseDefault: true,
    arrangement: 'continuity',
    canCancel: true,
    hiddenLabelPath: 'is_hide'
};
export default FiledRadio;
