import { __assign } from "tslib";
import React, { useCallback, useState, useMemo } from 'react';
// eslint-disable-next-line no-restricted-imports
import { Button, message } from 'udesk-ui';
import CopyToClipboard from 'react-copy-to-clipboard';
import ClassNames from 'classnames';
import { useTranslation } from '@udesk-webapp/locale';
// TODO支持多语言
// import { useTranslation } from "react-i18next";
import style from './index.module.scss';
var CopyComponent = function (props) {
    var t = useTranslation().t;
    // 默认显示在右上角，不能默认显示在容器外面，因为外层容器上设置了overflow:hidden，这样复制按钮就显示不出来了。
    // 而设置overflow:hidden的原因是为了内容过长时，显示省略号...
    var text = props.text, left = props.left, _a = props.right, right = _a === void 0 ? '0px' : _a, _b = props.top, top = _b === void 0 ? '-30px' : _b, _c = props.bottom, bottom = _c === void 0 ? '' : _c, _d = props.switchFlag, switchFlag = _d === void 0 ? false : _d, _e = props.btnSize, btnSize = _e === void 0 ? 'small' : _e, _f = props.type, type = _f === void 0 ? 'default' : _f;
    var buttonStyle = {
        position: 'absolute',
        left: left,
        right: right,
        top: top,
        bottom: bottom,
        zIndex: 999,
        visibility: 'hidden',
    };
    var _g = useState(buttonStyle), copyStyle = _g[0], setCopyStyle = _g[1];
    var showButton = useCallback(function () {
        setCopyStyle(__assign(__assign({}, copyStyle), { visibility: (text === '' || text === null || text === undefined) ? 'hidden' : 'visible' }));
    }, [copyStyle, text]);
    var hideButton = useCallback(function () {
        setCopyStyle(__assign(__assign({}, copyStyle), { visibility: 'hidden' }));
    }, [copyStyle]);
    var copyText = useCallback(function (_text, result) {
        if (result) {
            message.info(t('tips.success.copy'));
        }
        else {
            message.info(t('tips.fail.copy'));
        }
    }, []);
    var handleClick = useCallback(function (event) {
        event.stopPropagation();
    }, []);
    var buttonIcon = useMemo(function () { return (React.createElement(Button, { className: ClassNames('copy-button'), size: btnSize, style: copyStyle, onClick: handleClick, type: type }, t("labels.copy"))); }, [btnSize, copyStyle, handleClick, type]);
    return (React.createElement(React.Fragment, null,
        switchFlag &&
            React.createElement("div", { onMouseEnter: showButton, onMouseLeave: hideButton, className: "copy-container ".concat(style['copy-container'], " ").concat(props.noHidden ? style['no-hidden'] : '') },
                React.createElement(CopyToClipboard, { text: text, onCopy: copyText }, buttonIcon),
                React.createElement("div", { className: 'copy-children' }, props.children)),
        !switchFlag &&
            React.createElement("div", { className: "copy-container ".concat(style['copy-container'], " ").concat(props.noHidden ? style['no-hidden'] : '') }, props.children)));
};
export default CopyComponent;
