import { __assign, __rest } from "tslib";
import React, { useCallback, useState, useEffect } from 'react';
import QuestionCircleOutlined from '@ant-design/icons/QuestionCircleOutlined';
import Tooltip from 'udesk-ui/es/tooltip';
import Form from 'udesk-ui/es/form';
import ClassNames from 'classnames';
import GetFieldComponet from './field-type-component';
import FieldItemComponents from './field-mapping';
import fieldStyle from './index.module.scss';
// TODO 提成enums
var valueChangeFieldTypes = ['link', 'location', 'number', 'numeric', 'textarea', 'text'];
var CustomFieldItem = function (_a) {
    var fieldItem = _a.fieldItem, isFormItem = _a.isFormItem, agents = _a.agents, _b = _a.switchFlag, switchFlag = _b === void 0 ? false : _b, labelCol = _a.labelCol, wrapperCol = _a.wrapperCol, onValueChange = _a.onValueChange, props = __rest(_a, ["fieldItem", "isFormItem", "agents", "switchFlag", "labelCol", "wrapperCol", "onValueChange"]);
    var showLabel = fieldItem.showLabel, itemLabelCol = fieldItem.labelCol, itemWrapperCol = fieldItem.wrapperCol, _c = fieldItem.mode, mode = _c === void 0 ? 'edit' : _c, itemClassName = fieldItem.itemClassName;
    var _d = useState(fieldItem.value), oldValue = _d[0], setOldValue = _d[1]; // 存储历史数据,用来判断onblur时值是否变化
    var fromLabel = function () { return (showLabel ?
        (React.createElement("div", { className: ClassNames('item-label', fieldStyle['item-label']) },
            fieldItem.isRequired && React.createElement("span", { style: { color: 'red' } }, "*"),
            React.createElement("span", { style: { marginRight: '5px' } },
                fieldItem.label,
                fieldItem.colon ? ':' : '',
                React.createElement("span", { className: "sub-title", dangerouslySetInnerHTML: { __html: fieldItem.subTitle || '' } })),
            fieldItem.layout !== 'horizontal' && fieldItem.tooltipShow && fieldItem.tooltip && (React.createElement(Tooltip, { title: fieldItem.tooltip },
                React.createElement(QuestionCircleOutlined, null))))) : ''); };
    useEffect(function () {
        setOldValue(fieldItem.value);
    }, [fieldItem.value]);
    var onValueChanged = useCallback(function (value, field) {
        if (props && typeof onValueChange === 'function') {
            onValueChange(value, fieldItem);
        }
    }, [onValueChange]);
    var onChange = useCallback(function (value) {
        if (props && typeof props.onChange === 'function') {
            props.onChange(value, fieldItem);
        }
        if (!valueChangeFieldTypes.includes(fieldItem.type)) {
            onValueChanged(value, fieldItem);
        }
    }, [fieldItem]);
    var onBlur = useCallback(function (value) {
        if (props && typeof props.onBlur === 'function') {
            props.onBlur(value, fieldItem);
        }
        if (valueChangeFieldTypes.includes(fieldItem.type)) {
            if (value !== oldValue) {
                setOldValue(value);
                onValueChanged(value, fieldItem);
            }
        }
    }, [fieldItem, oldValue]);
    return (React.createElement(React.Fragment, null, FieldItemComponents[fieldItem.type] ?
        isFormItem ? (React.createElement(Form.Item, __assign({}, props, { className: itemClassName, label: fromLabel(), labelCol: itemLabelCol || labelCol, wrapperCol: itemWrapperCol || wrapperCol, name: fieldItem.id, colon: false, trigger: fieldItem.trigger || 'onChange', rules: typeof fieldItem.customValidFn === 'function' ? [
                {
                    validator: fieldItem.customValidFn
                }
            ] : undefined }), React.createElement(GetFieldComponet, __assign({ onChange: onChange, onBlur: onBlur, switchFlag: switchFlag, agents: agents }, fieldItem, { isFormItem: isFormItem, notUseDefault: props.notUseDefault, mode: mode })))) : (React.createElement("div", { className: "".concat(itemClassName, " ").concat(fieldItem.layout === 'horizontal' ? fieldStyle['field-item-horizontal'] : fieldStyle['field-item']) },
            fromLabel(),
            React.createElement("div", { className: fieldStyle['item-content'] }, React.createElement(GetFieldComponet, __assign({ onChange: onChange, onBlur: onBlur, switchFlag: switchFlag, agents: agents }, fieldItem, { isFormItem: false, mode: mode })))))
        : null));
};
export default CustomFieldItem;
export { GetFieldComponet };
export var fieldComponentMapping = FieldItemComponents;
