import _Space from "antd/es/space";
import _Input from "antd/es/input";
var _excluded = ["showCount", "maxCount", "onResize"],
    _excluded2 = ["showCount", "maxCount"];

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }

function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }

import React, { forwardRef, useState, useContext, useEffect } from 'react';
import ConfigProvider from "../config-provider";
import { copyFromAntd } from "../_utils/core";
import classNames from 'classnames';
import { lessVariables } from "../_utils/less-variables";

var CurrentCount = function CurrentCount(_ref) {
  var maxCount = _ref.maxCount,
      valueLength = _ref.valueLength,
      showCount = _ref.showCount,
      width = _ref.width;
  var ctx = useContext(ConfigProvider.ConfigContext);
  var getPrefixCls = ctx.getPrefixCls;
  var valueLengthOver = typeof maxCount === 'number' && valueLength > maxCount;
  return /*#__PURE__*/React.createElement(React.Fragment, null, showCount && /*#__PURE__*/React.createElement("div", {
    className: classNames(getPrefixCls('input-value-count'), _defineProperty({}, getPrefixCls('input-value-count-over'), valueLengthOver)),
    style: width ? {
      width: width - parseInt(lessVariables['@padding-xss'], 10) - parseInt(lessVariables['@scroll-bar-width'], 10)
    } : undefined
  }, "".concat(valueLength).concat(Boolean(maxCount) ? '/' + maxCount : '')));
};

var TextArea = /*#__PURE__*/forwardRef(function (props, ref) {
  var ctx = useContext(ConfigProvider.ConfigContext);
  var getPrefixCls = ctx.getPrefixCls;

  var _props$showCount = props.showCount,
      showCount = _props$showCount === void 0 ? false : _props$showCount,
      maxCount = props.maxCount,
      propsOnResize = props.onResize,
      restProps = _objectWithoutProperties(props, _excluded);

  var propsOnChange = restProps.onChange;

  var _useState = useState(0),
      _useState2 = _slicedToArray(_useState, 2),
      valueLength = _useState2[0],
      setValueLength = _useState2[1];

  var _useState3 = useState(undefined),
      _useState4 = _slicedToArray(_useState3, 2),
      width = _useState4[0],
      setWidth = _useState4[1];

  var onChange = function onChange(e) {
    setValueLength(e.target.value.length);
    propsOnChange === null || propsOnChange === void 0 ? void 0 : propsOnChange(e);
  };

  if (!showCount) {
    return /*#__PURE__*/React.createElement(_Input.TextArea, _objectSpread(_objectSpread({}, restProps), {}, {
      ref: ref
    }));
  }

  var onResize = function onResize(_ref2) {
    var width = _ref2.width,
        height = _ref2.height;
    setWidth(width);
    propsOnResize === null || propsOnResize === void 0 ? void 0 : propsOnResize({
      width: width,
      height: height
    });
  };

  useEffect(function () {
    setValueLength(function () {
      if (typeof props.value === 'string') {
        return props.value.length;
      } else {
        return 0;
      }
    });
  }, [props.value]);
  return /*#__PURE__*/React.createElement("div", {
    className: classNames(getPrefixCls('input-textarea'), getPrefixCls('input-textarea-show-count'))
  }, /*#__PURE__*/React.createElement(_Input.TextArea, _objectSpread(_objectSpread({}, restProps), {}, {
    onResize: onResize,
    showCount: false,
    onChange: onChange,
    ref: ref
  })), showCount && /*#__PURE__*/React.createElement(CurrentCount, {
    showCount: showCount,
    valueLength: valueLength,
    maxCount: maxCount,
    width: width
  }));
});
var UInput = /*#__PURE__*/forwardRef(function (props, ref) {
  var _props$showCount2 = props.showCount,
      showCount = _props$showCount2 === void 0 ? false : _props$showCount2,
      maxCount = props.maxCount,
      restProps = _objectWithoutProperties(props, _excluded2);

  var suffix = restProps.suffix,
      propsOnChange = restProps.onChange;

  var _useState5 = useState(0),
      _useState6 = _slicedToArray(_useState5, 2),
      valueLength = _useState6[0],
      setValueLength = _useState6[1];

  var onChange = function onChange(e) {
    setValueLength(e.target.value.length);
    propsOnChange === null || propsOnChange === void 0 ? void 0 : propsOnChange(e);
  };

  if (!showCount) {
    return /*#__PURE__*/React.createElement(_Input, _objectSpread(_objectSpread({}, restProps), {}, {
      ref: ref
    }));
  }

  useEffect(function () {
    setValueLength(function () {
      if (typeof props.value === 'string') {
        return props.value.length;
      } else {
        return 0;
      }
    });
  }, [props.value]);
  return /*#__PURE__*/React.createElement(_Input, _objectSpread(_objectSpread({}, restProps), {}, {
    onChange: onChange,
    suffix: /*#__PURE__*/React.createElement(_Space, null, /*#__PURE__*/React.createElement(CurrentCount, {
      showCount: showCount,
      valueLength: valueLength,
      maxCount: maxCount
    }), suffix),
    ref: ref
  }));
});
var ExportInput = UInput; //拷贝静态属性

copyFromAntd(ExportInput, _Input); //重写TextArea组件映射

ExportInput.TextArea = TextArea;
export default ExportInput;
//# sourceMappingURL=index.js.map
