function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
var _excluded = ["prefixCls", "className", "extraButton", "dataSource", "value", "renderItem", "onChange", "itemDisable"];
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }
function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }
function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React, { useState, useEffect, useImperativeHandle } from 'react';
import { List } from 'udesk-ui';
import classNames from 'classnames';
import { usePrefixCls } from '../utils';
import ListHeader from './components/list-header';
import ListItem from './components/list-item';
import './style/index';
var ListCheckbox = function ListCheckbox(props, ref) {
  var customizePrefixCls = props.prefixCls,
    _props$className = props.className,
    className = _props$className === void 0 ? '' : _props$className,
    _props$extraButton = props.extraButton,
    extraButton = _props$extraButton === void 0 ? [] : _props$extraButton,
    _props$dataSource = props.dataSource,
    dataSource = _props$dataSource === void 0 ? [] : _props$dataSource,
    value = props.value,
    _renderItem = props.renderItem,
    onChange = props.onChange,
    itemDisable = props.itemDisable,
    listRest = _objectWithoutProperties(props, _excluded);
  var _useState = useState([]),
    _useState2 = _slicedToArray(_useState, 2),
    checkedList = _useState2[0],
    setCheckedList = _useState2[1];
  var _usePrefixCls = usePrefixCls('list-checkbox', customizePrefixCls || ''),
    _usePrefixCls2 = _slicedToArray(_usePrefixCls, 1),
    listCheckboxPrefixCls = _usePrefixCls2[0];
  var classes = classNames(listCheckboxPrefixCls, className);
  useImperativeHandle(ref, function () {
    return {
      resetSelect: handleCancelSelect
    };
  }, []);
  var handleCheckAllChange = function handleCheckAllChange(e) {
    var currCheckedList = _toConsumableArray(checkedList);
    if (e.target.checked) {
      var currCheckedIds = currCheckedList.map(function (el) {
        return el.id;
      });
      dataSource.forEach(function (el) {
        if (!currCheckedIds.includes(el.id)) {
          if (typeof itemDisable === 'function') {
            !(itemDisable === null || itemDisable === void 0 ? void 0 : itemDisable(el)) && currCheckedList.push(_objectSpread({}, el));
          } else {
            currCheckedList.push(_objectSpread({}, el));
          }
        }
      });
    } else {
      var currCheckedListIds = dataSource.map(function (el) {
        return el.id;
      });
      currCheckedList = currCheckedList.filter(function (el) {
        if (!currCheckedListIds.includes(el.id)) {
          return el;
        }
        return false;
      });
    }
    setCheckedList(currCheckedList);
    onChange === null || onChange === void 0 ? void 0 : onChange(currCheckedList);
  };
  var handleSingleCheck = function handleSingleCheck(item) {
    var _currCheckedList;
    var currCheckedList = _toConsumableArray(checkedList);
    if ((_currCheckedList = currCheckedList) === null || _currCheckedList === void 0 ? void 0 : _currCheckedList.some(function (el) {
      return el.id === item.id;
    })) {
      currCheckedList = currCheckedList.filter(function (el) {
        return el.id !== item.id;
      });
    } else {
      currCheckedList.push(_objectSpread({}, item));
    }
    setCheckedList(currCheckedList);
    onChange === null || onChange === void 0 ? void 0 : onChange(currCheckedList);
  };
  var handleCancelSelect = function handleCancelSelect() {
    setCheckedList([]);
    onChange === null || onChange === void 0 ? void 0 : onChange([]);
  };
  useEffect(function () {
    if (Array.isArray(value) && value.length) {
      setCheckedList(value);
    }
  }, [value]);
  return /*#__PURE__*/React.createElement(List, _objectSpread(_objectSpread({
    className: classes,
    dataSource: dataSource
  }, listRest), {}, {
    header: /*#__PURE__*/React.createElement(ListHeader, {
      extraButton: extraButton,
      dataSource: dataSource,
      checkedList: checkedList,
      handleCheckAllChange: handleCheckAllChange,
      handleCancelSelect: handleCancelSelect,
      itemDisable: itemDisable
    }),
    renderItem: function renderItem(item, index) {
      return /*#__PURE__*/React.createElement(ListItem, {
        item: item,
        checkedList: checkedList,
        handleSingleCheck: handleSingleCheck,
        itemDisable: itemDisable,
        key: item.key
      }, _renderItem === null || _renderItem === void 0 ? void 0 : _renderItem(item, index));
    }
  }));
};
var FancyListCheckbox = /*#__PURE__*/React.forwardRef(ListCheckbox);
export default FancyListCheckbox;