function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }

function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useMemo, useRef, useEffect, useState } from 'react';
import { ManifestLoader as Loader } from '@udesk/sdk/lib/manifest-loader';
import Skeleton from "../skeleton";
/**
 * 组件形式SDK的加载器,其中manifestUrl必传
 * autoRender默认值为true,当改属性设置为false时,需要使用者
 * 在onLoad回调中处理manifest加载器返回的AssetResult
 *
 * @param {*} props
 */

var ManifestLoader = function ManifestLoader(props) {
  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      sdkloading = _useState2[0],
      setSdkLoading = _useState2[1];

  var containerRef = useRef(null);
  var sdkInstanceRef = useRef(null);
  var manifestLoaderInstanceRef = useRef(null);
  var sdkLoaderUnmounted = useRef(false);
  var manifestUrl = props.manifestUrl,
      loadingComponent = props.loadingComponent,
      _props$componentProps = props.componentProps,
      componentProps = _props$componentProps === void 0 ? {} : _props$componentProps,
      componentName = props.componentName,
      showLoading = props.showLoading,
      autoRender = props.autoRender,
      container = props.container,
      _props$options = props.options,
      options = _props$options === void 0 ? {} : _props$options,
      errorCallback = props.errorCallback,
      onLoad = props.onLoad,
      onCreate = props.onCreate,
      onDestroy = props.onDestroy; // 取到所有的依赖KEY

  var propKeys = useMemo(function () {
    return Reflect.ownKeys(componentProps);
  }, [componentProps]);
  var propDeps = useMemo(function () {
    return propKeys.map(function (prop) {
      return componentProps[prop];
    });
  }, [propKeys, componentProps]);
  useEffect(function () {
    if (!manifestUrl) {
      throw new TypeError('manifest-loader manifestUrl can not be empty!');
    }

    setSdkLoading(true);
    var manifestLoaderInstance = new Loader(manifestUrl, {});
    manifestLoaderInstanceRef.current = manifestLoaderInstance;

    if (!manifestLoaderInstance) {
      setSdkLoading(false);
      throw new TypeError('Failed to instantiate Loader!');
    }

    var sdkInstance;
    manifestLoaderInstance === null || manifestLoaderInstance === void 0 ? void 0 : manifestLoaderInstance.assets().then(function () {
      var assets = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

      if (sdkLoaderUnmounted.current) {
        return;
      }

      var entry = assets.find(function (a) {
        return a.isEntry;
      });
      setSdkLoading(false);

      if (typeof onLoad === 'function') {
        onLoad(assets);
      }

      if (!autoRender) {
        return;
      }

      var SdkClass = (entry === null || entry === void 0 ? void 0 : entry.ComponentSdkClass) || (entry === null || entry === void 0 ? void 0 : entry.SdkClass);

      if (SdkClass) {
        var sdkContainer = containerRef.current;

        var mergeOptions = _objectSpread(_objectSpread({
          componentName: componentName,
          isComponentSdk: true
        }, options), componentProps);

        sdkInstanceRef.current = sdkInstance = new SdkClass(mergeOptions);

        if (typeof onCreate === 'function') {
          onCreate(sdkInstance);
        }

        if (container) {
          if (typeof container === 'string') {
            sdkContainer = document.getElementById(container);
          } else {
            sdkContainer = container;
          }
        }

        sdkInstance.renderTo(sdkContainer).then(function () {
          if (sdkContainer) {
            sdkContainer.style.display = 'block';
          }
        });
      }
    })["catch"](function (error) {
      errorCallback && errorCallback(error);
    });
    return function () {
      var _manifestLoaderInstan;

      if (typeof onDestroy === 'function') {
        onDestroy(sdkInstanceRef === null || sdkInstanceRef === void 0 ? void 0 : sdkInstanceRef.current);
      }

      if (autoRender) {
        var _sdkInstanceRef$curre;

        sdkInstanceRef === null || sdkInstanceRef === void 0 ? void 0 : (_sdkInstanceRef$curre = sdkInstanceRef.current) === null || _sdkInstanceRef$curre === void 0 ? void 0 : _sdkInstanceRef$curre.destroy();
      }

      if (manifestLoaderInstanceRef !== null && manifestLoaderInstanceRef !== void 0 && (_manifestLoaderInstan = manifestLoaderInstanceRef.current) !== null && _manifestLoaderInstan !== void 0 && _manifestLoaderInstan.destroy) {
        var _manifestLoaderInstan2;

        manifestLoaderInstanceRef === null || manifestLoaderInstanceRef === void 0 ? void 0 : (_manifestLoaderInstan2 = manifestLoaderInstanceRef.current) === null || _manifestLoaderInstan2 === void 0 ? void 0 : _manifestLoaderInstan2.destroy();
      }

      sdkLoaderUnmounted.current = true;
    };
  }, []); // 监听SDK的属性变化,触发update

  useEffect(function () {
    if (sdkInstanceRef !== null && sdkInstanceRef !== void 0 && sdkInstanceRef.current) {
      var _sdkInstanceRef$curre2;

      (_sdkInstanceRef$curre2 = sdkInstanceRef.current) === null || _sdkInstanceRef$curre2 === void 0 ? void 0 : _sdkInstanceRef$curre2.update(componentProps);
    }
  }, [].concat(_toConsumableArray(propDeps), [componentProps]));
  var getLoadingComponent = useMemo(function () {
    if (loadingComponent) {
      return loadingComponent;
    } else {
      return /*#__PURE__*/React.createElement(Skeleton, null);
    }
  }, [loadingComponent]);
  return sdkloading && showLoading ? /*#__PURE__*/React.createElement(React.Fragment, null, getLoadingComponent) : /*#__PURE__*/React.createElement("div", {
    ref: containerRef,
    className: "sdk-content",
    style: {
      display: 'none'
    }
  });
};

ManifestLoader.defaultProps = {
  options: {},
  showLoading: true,
  autoRender: true
};
export default ManifestLoader;
//# sourceMappingURL=component-manifest-loader.js.map
