function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useRef, useEffect, useState, useMemo } from 'react';
import { ManifestLoader as Loader } from '@udesk/sdk/lib/manifest-loader';
import Skeleton from "../skeleton";
/**
 * 路由SDK的manifest加载器,
 * manifestUrl为必传项
 * autoRender默认值为true,当改属性设置为false时,需要使用者
 * 在onLoad回调中处理manifest加载器返回的AssetResult
 *
 * @param {*} props
 */

var ManifestLoader = function ManifestLoader(props) {
  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      sdkloading = _useState2[0],
      setSdkLoading = _useState2[1];

  var containerRef = useRef(null);
  var sdkInstanceRef = useRef(null);
  var manifestUrl = props.manifestUrl,
      loadingComponent = props.loadingComponent,
      options = props.options,
      showLoading = props.showLoading,
      autoRender = props.autoRender,
      container = props.container,
      errorCallback = props.errorCallback,
      onLoad = props.onLoad,
      onCreate = props.onCreate,
      onDestroy = props.onDestroy;
  useEffect(function () {
    if (!manifestUrl) {
      throw new TypeError('manifest-loader manifestUrl can not be empty!');
    }

    setSdkLoading(true);
    var manifestLoaderInstance = new Loader(manifestUrl, {});

    if (!manifestLoaderInstance) {
      setSdkLoading(false);
      throw new TypeError('Failed to instantiate Loader!');
    }

    var sdkInstance;
    manifestLoaderInstance === null || manifestLoaderInstance === void 0 ? void 0 : manifestLoaderInstance.assets().then(function () {
      var assets = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var entry = assets.find(function (a) {
        return a.isEntry;
      });
      setSdkLoading(false);

      if (typeof onLoad === 'function') {
        onLoad(assets);
      }

      if (!autoRender) {
        return;
      }

      if (entry !== null && entry !== void 0 && entry.SdkClass) {
        var sdkContainer = containerRef.current;
        sdkInstanceRef.current = sdkInstance = new entry.SdkClass(options);

        if (typeof onCreate === 'function') {
          onCreate(sdkInstance);
        }

        if (container) {
          if (typeof container === 'string') {
            sdkContainer = document.getElementById(container);
          } else {
            sdkContainer = container;
          }
        }

        sdkInstance.renderTo(sdkContainer).then(function () {
          if (sdkContainer) {
            sdkContainer.style.display = 'block';
          }
        });
      }
    })["catch"](function (error) {
      errorCallback && errorCallback(error);
    });
    return function () {
      if (typeof onDestroy === 'function') {
        onDestroy(sdkInstanceRef === null || sdkInstanceRef === void 0 ? void 0 : sdkInstanceRef.current);
      }

      if (autoRender) {
        var _sdkInstanceRef$curre;

        sdkInstanceRef === null || sdkInstanceRef === void 0 ? void 0 : (_sdkInstanceRef$curre = sdkInstanceRef.current) === null || _sdkInstanceRef$curre === void 0 ? void 0 : _sdkInstanceRef$curre.destroy();
      }
    };
  }, []);
  var getLoadingComponent = useMemo(function () {
    if (loadingComponent) {
      return loadingComponent;
    } else {
      return /*#__PURE__*/React.createElement(Skeleton, null);
    }
  }, [loadingComponent]);
  return sdkloading && showLoading ? /*#__PURE__*/React.createElement(React.Fragment, null, getLoadingComponent) : /*#__PURE__*/React.createElement("div", {
    ref: containerRef,
    className: "sdk-content",
    style: {
      display: 'none'
    }
  }, ' ');
};

ManifestLoader.defaultProps = {
  options: {},
  showLoading: true,
  autoRender: true
};
export default ManifestLoader;
//# sourceMappingURL=route-manifest-loader.js.map
