import React from 'react';
import type { TableProps as AntTableProps } from 'udesk-ui/lib/table';
import { UseRowSelectionOptionsType } from './utils/hooks/useRowSelection';
import './style/index';
interface RowSelectionEnhance<T> extends UseRowSelectionOptionsType<T> {
    type?: 'checkbox' | 'radio';
}
export interface TableProps<T extends object = any> extends AntTableProps<T> {
    cacheId?: string;
    autoSize?: boolean;
    rowSelectionEnhance?: RowSelectionEnhance<T>;
    onTableScroll?: () => void;
}
export interface TableInstance {
    clearScrollPosition: () => void;
    scrollTo: (x: number, y: number) => void;
    resetToEmpty: () => void;
}
declare const _default: React.MemoExoticComponent<React.ForwardRefExoticComponent<TableProps<any> & React.RefAttributes<TableInstance>>>;
export default _default;
