var _excluded = ["scroll", "columns", "cacheId", "prefixCls", "autoSize", "rowSelectionEnhance", "onTableScroll"];
var _templateObject;
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
function _taggedTemplateLiteral(strings, raw) { if (!raw) { raw = strings.slice(0); } return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }
import React, { useRef, forwardRef, useImperativeHandle, useMemo } from 'react';
import { Table } from 'udesk-ui';
import styled from 'styled-components';
import { usePrefixCls } from '../utils';
import { useMemoScrollPosition, useScroll as useTableScrollProps, useRowSelection, useColumnsFormat } from './utils';
import './style/index';
var TableWrap = styled.div(_templateObject || (_templateObject = _taggedTemplateLiteral(["\n  width: 100%;\n  height: 100%;\n  ", " {\n    height: 100%;\n  }\n  ", "\n"])), function (props) {
  return ".".concat(props.prefixCls, "-table-wrapper");
}, function (props) {
  return props.columnsEllipsis.map(function (column) {
    return ".gm-ui-table-col-max-width-".concat(column.key, " {\n     max-width: ").concat(column.width, "px;\n  }");
  });
});
var MemoTable = /*#__PURE__*/forwardRef(function (props, ref) {
  var _rowSelectionEnhance$, _rowSelectionEnhance$2;
  var propsScroll = props.scroll,
    propsColumns = props.columns,
    _props$cacheId = props.cacheId,
    cacheId = _props$cacheId === void 0 ? '' : _props$cacheId,
    customizePrefixCls = props.prefixCls,
    autoSize = props.autoSize,
    rowSelectionEnhance = props.rowSelectionEnhance,
    onTableScroll = props.onTableScroll,
    antdProps = _objectWithoutProperties(props, _excluded);
  //   const [columns, setColumns] = useState<TableProps['columns']>([]);
  var _usePrefixCls = usePrefixCls('table-body', customizePrefixCls),
    _usePrefixCls2 = _slicedToArray(_usePrefixCls, 2),
    tableBodyPrefixCls = _usePrefixCls2[0],
    prefixCls = _usePrefixCls2[1];
  var _usePrefixCls3 = usePrefixCls('memo-table', customizePrefixCls),
    _usePrefixCls4 = _slicedToArray(_usePrefixCls3, 1),
    tableWrapPrefixCls = _usePrefixCls4[0];
  var wrapRef = useRef(null);
  var scroll = useTableScrollProps({
    wrapRef: wrapRef,
    propsScroll: propsScroll,
    prefixCls: prefixCls,
    dataSource: antdProps.dataSource
  }, [propsScroll]);
  var _useMemoScrollPositio = useMemoScrollPosition({
      cacheId: cacheId,
      tableBodyPrefixCls: tableBodyPrefixCls,
      wrapRef: wrapRef,
      dataSource: antdProps.dataSource,
      columns: propsColumns
    }),
    tryToSavePrevScrollPosition = _useMemoScrollPositio.tryToSavePrevScrollPosition,
    tryToResetPrevScrollPosition = _useMemoScrollPositio.tryToResetPrevScrollPosition,
    storage = _useMemoScrollPositio.storage;
  var _useRowSelection = useRowSelection(_typeof(rowSelectionEnhance) === 'object' ? (_rowSelectionEnhance$ = rowSelectionEnhance === null || rowSelectionEnhance === void 0 ? void 0 : rowSelectionEnhance.type) !== null && _rowSelectionEnhance$ !== void 0 ? _rowSelectionEnhance$ : 'checkbox' : undefined, rowSelectionEnhance),
    rowSelection = _useRowSelection.rowSelection,
    rowSelectionInstance = _useRowSelection.instance;
  var columns = useColumnsFormat(propsColumns);
  useImperativeHandle(ref, function () {
    return {
      clearScrollPosition: function clearScrollPosition() {
        return storage.delete();
      },
      scrollTo: tryToResetPrevScrollPosition,
      resetToEmpty: rowSelectionInstance.resetToEmpty
    };
  });
  var columnsEllipsis = useMemo(function () {
    var _columns$filter;
    return (_columns$filter = columns === null || columns === void 0 ? void 0 : columns.filter(function (i) {
      return i.ellipsis;
    })) !== null && _columns$filter !== void 0 ? _columns$filter : [];
  }, [columns]);
  return /*#__PURE__*/React.createElement(TableWrap, {
    columnsEllipsis: columnsEllipsis,
    onScrollCapture: function onScrollCapture() {
      onTableScroll && requestAnimationFrame(onTableScroll);
      requestAnimationFrame(tryToSavePrevScrollPosition);
    },
    className: tableWrapPrefixCls,
    ref: wrapRef,
    prefixCls: prefixCls
  }, /*#__PURE__*/React.createElement(Table, _objectSpread(_objectSpread({
    rowSelection: rowSelection
  }, antdProps), {}, {
    scroll: autoSize ? scroll : propsScroll,
    columns: columns,
    rowKey: (_rowSelectionEnhance$2 = rowSelectionEnhance === null || rowSelectionEnhance === void 0 ? void 0 : rowSelectionEnhance.rowKeysFieldName) !== null && _rowSelectionEnhance$2 !== void 0 ? _rowSelectionEnhance$2 : 'id'
  })));
});
MemoTable.defaultProps = {
  autoSize: true,
  cacheId: ''
};
export default /*#__PURE__*/React.memo(MemoTable);