import { TableRowSelection } from 'udesk-ui/lib/table';
type RowSelectionType = 'checkbox' | 'radio' | undefined;
export interface UseRowSelectionOptionsType<T> extends Omit<TableRowSelection<T>, 'onChange' | 'onSelect' | 'onSelectMultiple' | 'onSelectAll' | 'onSelectInvert' | 'onSelectNone' | 'preserveSelectedRowKeys' | 'type' | 'selectedRowKeys' | 'defaultSelectedRowKeys'> {
    defaultSelectedRowKeys?: string[] | number[];
    selectedRowKeys?: string[] | number[];
    rowKeysFieldName?: string;
    onSelectedRowKeysChange?: (keys: string[], items: any[]) => void;
}
interface UseRowSelectionReturnType<T> {
    rowSelection: TableRowSelection<T> | undefined;
    instance: {
        resetToEmpty: () => void;
    };
}
declare const useRowSelection: <T>(rowSelectionType: RowSelectionType, options?: UseRowSelectionOptionsType<T> | undefined) => UseRowSelectionReturnType<T>;
export default useRowSelection;
