import React, { useCallback, useContext } from 'react';
import { Button, Radio, Breadcrumb, Checkbox, Divider, Spin } from "../index";
import ConfigProvider from "../config-provider";

var MulitlevelPicker = function MulitlevelPicker(_ref) {
  var title = _ref.title,
      dataKey = _ref.dataKey,
      displayKey = _ref.displayKey,
      childrenKey = _ref.childrenKey,
      dataSource = _ref.dataSource,
      initialValue = _ref.initialValue,
      _ref$value = _ref.value,
      value = _ref$value === void 0 ? [] : _ref$value,
      _ref$showSelectAll = _ref.showSelectAll,
      showSelectAll = _ref$showSelectAll === void 0 ? true : _ref$showSelectAll,
      _ref$multiple = _ref.multiple,
      multiple = _ref$multiple === void 0 ? false : _ref$multiple,
      loadData = _ref.loadData,
      onLevelChange = _ref.onLevelChange,
      dataSimpleMode = _ref.dataSimpleMode;
  var onValueChange = useCallback(function () {}, []);
  var onClickNextLevet = useCallback(function () {}, []);

  var _useContext = useContext(ConfigProvider.ConfigContext),
      getPrefixCls = _useContext.getPrefixCls;

  return /*#__PURE__*/React.createElement("div", {
    className: getPrefixCls("mulitlevel-picker-wrapper")
  }, /*#__PURE__*/React.createElement("div", {
    className: "mulitlevel-picker-source-wrapper"
  }, /*#__PURE__*/React.createElement("h3", {
    className: "multilevel-picker-source-header"
  }, title), /*#__PURE__*/React.createElement("div", {
    className: "multilevel-picker-source-breadcrumb"
  }, /*#__PURE__*/React.createElement(Breadcrumb, null)), /*#__PURE__*/React.createElement(Spin, {
    spinning: false
  }, /*#__PURE__*/React.createElement("div", {
    className: "multilevel-picker-source-content"
  }, showSelectAll && /*#__PURE__*/React.createElement("div", {
    className: "multilevel-picker-check-all"
  }, multiple && /*#__PURE__*/React.createElement(Checkbox // indeterminate={
  //     selectedAll
  //         ? false
  //         : currentDisplayList.find((item) => item.checked)
  //         ? true
  //         : false
  // }
  // onChange={onCheckAllChange}
  // checked={selectedAll}
  , null, "\u5168\u9009")), dataSource && dataSource.map(function (item) {
    return /*#__PURE__*/React.createElement("div", {
      key: "".concat(item[dataKey]),
      className: "multilevel-picker-source-node"
    }, multiple ? /*#__PURE__*/React.createElement(Checkbox, {
      value: item,
      checked: value.some(function (itemSelectedValue) {
        return itemSelectedValue[dataKey] === item[dataKey];
      }),
      onChange: onValueChange
    }, item[displayKey]) : /*#__PURE__*/React.createElement(Radio, {
      value: item,
      checked: value.some(function (itemSelectedValue) {
        return itemSelectedValue[dataKey] === item[dataKey];
      }),
      onChange: onValueChange
    }, item[displayKey]), item['showLevel'] && /*#__PURE__*/React.createElement("div", {
      className: "check-box-btn"
    }, /*#__PURE__*/React.createElement(Divider, {
      type: "vertical"
    }), /*#__PURE__*/React.createElement(Button, {
      type: "link",
      onClick: onClickNextLevet.bind(item)
    }, "\u4E0B\u7EA7")));
  })))));
};

export default MulitlevelPicker;
//# sourceMappingURL=index.js.map
