import _Tooltip from "antd/es/tooltip";
import _Menu from "antd/es/menu";
import _Dropdown from "antd/es/dropdown";
import React from 'react';
import { ColumnHeightOutlined } from '@ant-design/icons';
import Container from "../../container";
import { useIntl } from "../intlContext";

var DensityIcon = function DensityIcon(_, ref) {
  var counter = Container.useContainer();
  var intl = useIntl();
  return /*#__PURE__*/React.createElement(_Dropdown, {
    overlay: /*#__PURE__*/React.createElement(_Menu, {
      selectedKeys: [counter.tableSize],
      onClick: function onClick(_ref) {
        var key = _ref.key;

        if (counter.setTableSize) {
          counter.setTableSize(key);
        }
      },
      style: {
        width: 80
      }
    }, /*#__PURE__*/React.createElement(_Menu.Item, {
      key: "large"
    }, intl.getMessage('tableToolBar.densityLarger', '默认')), /*#__PURE__*/React.createElement(_Menu.Item, {
      key: "middle"
    }, intl.getMessage('tableToolBar.densityMiddle', '中等')), /*#__PURE__*/React.createElement(_Menu.Item, {
      key: "small"
    }, intl.getMessage('tableToolBar.densitySmall', '紧凑'))),
    trigger: ['click']
  }, /*#__PURE__*/React.createElement(_Tooltip, {
    ref: ref,
    title: intl.getMessage('tableToolBar.density', '表格密度')
  }, /*#__PURE__*/React.createElement(ColumnHeightOutlined, null)));
};

export default /*#__PURE__*/React.forwardRef(DensityIcon);
//# sourceMappingURL=DensityIcon.js.map
