import React from 'react';
import type { UseFetchDataAction, RequestData } from '../../useFetchData';
import './index.less';
export interface OptionConfig<T> {
    density: boolean;
    fullScreen: OptionsType<T>;
    reload: OptionsType<T>;
    setting: boolean;
}
export declare type OptionsType<T = unknown> = ((e: React.MouseEvent<HTMLSpanElement>, action: UseFetchDataAction<RequestData<T>>) => void) | boolean;
export interface ToolBarProps<T = unknown> {
    headerTitle?: React.ReactNode;
    toolBarRender?: (action: UseFetchDataAction<RequestData<T>>, rows: {
        selectedRowKeys?: (string | number)[];
        selectedRows?: T[];
    }) => React.ReactNode[];
    action: UseFetchDataAction<RequestData<T>>;
    options?: OptionConfig<T> | false;
    selectedRowKeys?: (string | number)[];
    selectedRows?: T[];
    className?: string;
}
declare const WarpToolBar: <T, U = {}>(props: ToolBarProps<T>) => JSX.Element;
export default WarpToolBar;
