import { __spreadArray } from "tslib";
import { TreeSelect, Spin, Empty } from 'udesk-ui';
import React, { useCallback, useContext, useEffect, useMemo, useState, useRef } from 'react';
import { useTranslation } from '@udesk-webapp/locale';
import { createUseSelectedCatalog, RepositoryWidgetContext, useRequestData } from '../../utilities';
import QuestionList from './question-list';
import CatalogSelect from '../../catalog-select';
// import { ICatalog, IQuestion, Scope } from '../../types';
// import { useSelector } from 'react-redux';
// import { RootState } from '@Src/store/root-reducer';
var TreeNode = TreeSelect.TreeNode;
export var useSelectedCatalog = createUseSelectedCatalog();
var CommonQuestion = function (_a) {
    var _b, _c, _d;
    var scope = _a.scope, query = _a.query, host = _a.host, refreshKnowledge = _a.refreshKnowledge, roleCan = _a.roleCan, agentConfig = _a.agentConfig, dialogueTagData = _a.dialogueTagData, mineChats = _a.mineChats, stashKey = _a.stashKey;
    var t = useTranslation().t;
    // const agentConfig = useSelector((state: RootState) => state.im.config); // 需要传进来
    // const mineChats = useSelector<RootState, IMineChat[]>((state) => state.mineChats); // 需要传进来
    // const dialogueTagData = useSelector<RootState, TagItem[]>(
    //     (state) => state.im.config.dialogueTag.tag
    // ); // 需要传进来
    var _e = useSelectedCatalog(scope, stashKey), selectedCatalog = _e[0], setSelectedCatalog = _e[1];
    var selectedPublicCatalogChangedRef = useRef(false);
    var tagsIdRef = useRef(-1);
    var _f = useState(false), tagCatalog = _f[0], setTagCatalog = _f[1];
    var _g = useState(1), page = _g[0], setPage = _g[1];
    var _h = useState({ current_page: 0, total_pages: 0 }), paging = _h[0], setPaging = _h[1];
    var _j = useState([]), questions = _j[0], setQuestions = _j[1];
    var categoryValue = useContext(RepositoryWidgetContext).categoryValue;
    var chat = (mineChats === null || mineChats === void 0 ? void 0 : mineChats.find(function (chat) { return chat.selected; })) || {};
    useEffect(function () {
        setPage(1);
        setTagCatalog(false);
    }, [scope]);
    var params = useMemo(function () { return ({
        knowledge_catalog_id: selectedCatalog === -1 ? undefined : selectedCatalog,
        scope: scope,
        per_page: 20,
        page: page,
        current_works: true,
        query: query,
    }); }, [page, query, scope, selectedCatalog]);
    var _k = useRequestData('question', params, refreshKnowledge, roleCan), loading = _k.loading, catalogs = _k.catalogs, data = _k.data, setLoading = _k.setLoading;
    var tagsName = useCallback(function (list, tagList, num) {
        // let tagsId: number | undefined;
        list.children.forEach(function (items) {
            var _a, _b;
            if (items.name === tagList[num] && ((_a = items.children) === null || _a === void 0 ? void 0 : _a.length) && tagList[num + 1]) {
                num += 1;
                tagsName(items, tagList, num);
            }
            else if ((items.name === tagList[num] && !((_b = items.children) === null || _b === void 0 ? void 0 : _b.length)) ||
                (items.name === tagList[num] && !tagList[num + 1])) {
                // tagsId = items.id;
                tagsIdRef.current = items.id;
            }
            else if (!tagsIdRef.current) {
                // tagsId = list.id;
                tagsIdRef.current = list.id;
            }
        });
        return tagsIdRef.current;
    }, []);
    var defaultTags = useCallback(function () {
        var _a, _b, _c, _d, _e;
        var tagList = [];
        // let tagsId: (number | any) = -1;
        if (((_a = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.session_tags_config) === null || _a === void 0 ? void 0 : _a.enable) &&
            ((_b = agentConfig.session_tags_config) === null || _b === void 0 ? void 0 : _b.show_mode) === 'type' &&
            !tagCatalog &&
            (dialogueTagData === null || dialogueTagData === void 0 ? void 0 : dialogueTagData.length) &&
            ((_c = chat.dialogueTag) === null || _c === void 0 ? void 0 : _c.length)) {
            if (((_d = agentConfig.session_tags_config) === null || _d === void 0 ? void 0 : _d.mode_tags) === 'first') {
                chat.dialogueTag[0].forEach(function (item) {
                    dialogueTagData.forEach(function (items) {
                        if (item === items.id) {
                            tagList.push(items.name);
                        }
                    });
                });
                var num_1 = 0;
                catalogs.forEach(function (item) {
                    var _a;
                    if (item.name === tagList[num_1] && tagList.length > 1 && ((_a = item.children) === null || _a === void 0 ? void 0 : _a.length)) {
                        num_1 += 1;
                        // tagsId = tagsName(item, tagList, num);
                        tagsName(item, tagList, num_1);
                    }
                    else if (item.name === tagList[tagList.length - 1]) {
                        // tagsId = item.id;
                        tagsIdRef.current = item.id;
                    }
                });
            }
            else if (((_e = agentConfig.session_tags_config) === null || _e === void 0 ? void 0 : _e.mode_tags) === 'new') {
                chat.dialogueTag[chat.dialogueTag.length - 1].forEach(function (item) {
                    dialogueTagData.forEach(function (items) {
                        if (item === items.id) {
                            tagList.push(items.name);
                        }
                    });
                });
                var num_2 = 0;
                catalogs.forEach(function (item) {
                    var _a;
                    if (item.name === tagList[num_2] && tagList.length > 1 && ((_a = item.children) === null || _a === void 0 ? void 0 : _a.length)) {
                        num_2 += 1;
                        // tagsId = tagsName(item, tagList, num, tagsId);
                        tagsName(item, tagList, num_2);
                    }
                    else if (item.name === tagList[tagList.length - 1]) {
                        // tagsId = item.id;
                        tagsIdRef.current = item.id;
                    }
                });
            }
            setSelectedCatalog(tagsIdRef.current);
            return tagsIdRef.current;
        }
        else {
            return -1;
        }
    }, [(_b = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.session_tags_config) === null || _b === void 0 ? void 0 : _b.enable, (_c = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.session_tags_config) === null || _c === void 0 ? void 0 : _c.mode_tags, (_d = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.session_tags_config) === null || _d === void 0 ? void 0 : _d.show_mode, catalogs, chat.dialogueTag, dialogueTagData, tagCatalog, tagsName, setSelectedCatalog]);
    useEffect(function () {
        defaultTags();
    }, [defaultTags]);
    useEffect(function () {
        setQuestions([]);
    }, [params.knowledge_catalog_id, params.scope, params.query]);
    useEffect(function () {
        if (data === null || data === void 0 ? void 0 : data.questions) {
            // @ts-ignore
            setQuestions(function (prevState) { return __spreadArray(__spreadArray([], prevState, true), data.questions, true); });
            setPaging(data.meta);
        }
    }, [data]);
    var nextPage = function () {
        if (loading)
            return;
        if (paging.total_pages > page) {
            setPage(page + 1);
            setLoading(true);
        }
    };
    var setSelectedCatalogs = useCallback(function (value, label, extra) {
        setTagCatalog(true);
        setSelectedCatalog(value);
        setPage(1);
        tagsIdRef.current = -1;
        if (scope === 'public') {
            selectedPublicCatalogChangedRef.current = true;
        }
    }, [scope, setSelectedCatalog]);
    useEffect(function () {
        if (categoryValue && scope === 'public') {
            setTagCatalog(true);
            setPage(1);
        }
    }, [categoryValue]);
    useEffect(function () {
        tagsIdRef.current = -1;
    }, [catalogs]);
    return (React.createElement(React.Fragment, null,
        React.createElement(CatalogSelect, { data: catalogs, prependTreeNodes: [
                React.createElement(TreeNode, { value: -1, key: '-1', title: t('page.im.km.question.all') }),
                React.createElement(TreeNode, { value: 0, key: '0', title: t('page.im.km.question.no_catalog') }),
            ], value: selectedCatalog, onChange: setSelectedCatalogs }),
        questions.length ?
            React.createElement(React.Fragment, null,
                React.createElement(QuestionList, { data: questions, onScrollToBottom: nextPage, agentConfig: agentConfig, chat: chat, host: host }),
                loading ? React.createElement(Spin, { className: "w-full text-center mt-30" }) : null)
            :
                React.createElement(Empty, { className: "h-full w-hull flex justify-center items-center flex-col" })));
};
export default CommonQuestion;
