import { __assign, __rest } from "tslib";
import React, { useEffect, useMemo, useState, useContext } from 'react';
// import axios from 'axios';
import TreeSelect from 'udesk-ui/es/tree-select';
import { RepositoryWidgetContext } from '../../utilities';
import { getCategoryList } from '../../utils/index';
function buildTreeNodes(nodes, childrenMap) {
    if (!nodes) {
        return [];
    }
    return nodes.map(function (i) {
        return (React.createElement(TreeSelect.TreeNode, { value: i.id, key: i.id + '', title: i.name }, buildTreeNodes(childrenMap[i.id], childrenMap)));
    });
}
var CategorySelect = function (_a) {
    var settings = _a.settings, robotId = _a.robotId, setDefaultValue = _a.setDefaultValue, props = __rest(_a, ["settings", "robotId", "setDefaultValue"]);
    var kmApiBase = useContext(RepositoryWidgetContext).kmApiBase;
    var _b = useState({}), childrenMap = _b[0], setChildrenMap = _b[1];
    var _c = useState([]), rootNodes = _c[0], setRootNodes = _c[1];
    var _d = useState([]), treeExpandedKeys = _d[0], setTreeExpandedKeys = _d[1];
    useEffect(function () {
        getCategoryList({ robotId: robotId, kmApiBase: kmApiBase }).then(function (res) {
            var _a;
            var _result = {};
            var _rootNodes = [];
            res.data.forEach(function (i) {
                if (i.parentId === 0) {
                    _rootNodes.push(i);
                }
                else {
                    if (!_result[i.parentId]) {
                        _result[i.parentId] = [];
                    }
                    _result[i.parentId].push(i);
                }
            });
            setDefaultValue((_a = _rootNodes[0]) === null || _a === void 0 ? void 0 : _a.id);
            setRootNodes(_rootNodes);
            setChildrenMap(_result);
        });
    }, [robotId, setDefaultValue, settings.auth]);
    var treeNodes = useMemo(function () { return buildTreeNodes(rootNodes, childrenMap); }, [
        childrenMap,
        rootNodes,
    ]);
    useEffect(function () {
        setTreeExpandedKeys(Object.keys(childrenMap));
    }, [childrenMap]);
    if (!rootNodes.length) {
        return null;
    }
    return (React.createElement(TreeSelect, __assign({ treeExpandedKeys: treeExpandedKeys, onTreeExpand: setTreeExpandedKeys, dropdownMatchSelectWidth: false, treeDefaultExpandAll: true, bordered: false }, props), treeNodes));
};
export default CategorySelect;
