import React, { useCallback, useState } from 'react';
import RobotSelect from './robot-select';
import { Spin } from 'udesk-ui';
import CategorySelect from './category-select';
import Space from 'udesk-ui/es/space';
import RobotQuestionList from './robot-question-list';
import css from './style.module.scss';
var RobotQuestionComp = function (_a) {
    var searchWord = _a.searchWord, settings = _a.settings, agentConfig = _a.agentConfig;
    var _b = useState(), selectedRobotId = _b[0], setSelectedRobotId = _b[1];
    var _c = useState(), selectedCategoryId = _c[0], setSelectedCategoryId = _c[1];
    var selectFirstRobot = useCallback(function (robots) {
        setSelectedRobotId(function (prevState) {
            if (!prevState) {
                return robots[0].km_robot_id;
            }
            return prevState;
        });
    }, []);
    if (!settings) {
        return React.createElement(Spin, null);
    }
    return (React.createElement(React.Fragment, null,
        React.createElement(Space, { className: css.conditionWrapper },
            React.createElement(RobotSelect, { settings: settings, value: selectedRobotId, onChange: setSelectedRobotId, onDataLoaded: selectFirstRobot }),
            selectedRobotId && (React.createElement(CategorySelect, { settings: settings, value: selectedCategoryId, onChange: setSelectedCategoryId, setDefaultValue: setSelectedCategoryId, robotId: selectedRobotId }))),
        selectedRobotId && selectedCategoryId && (React.createElement(RobotQuestionList, { robotId: selectedRobotId, categoryId: selectedCategoryId, searchWord: searchWord, agentConfig: agentConfig }))));
};
export default RobotQuestionComp;
