import { __spreadArray } from "tslib";
import React, { useCallback, useContext, useEffect, useState } from 'react';
import RobotQuestionItem from './robot-question-item';
import axios from 'axios';
import css from '../style.module.scss';
import List from 'udesk-ui/es/list';
import InfiniteScroll from 'react-infinite-scroller';
import { Empty, Spin } from 'udesk-ui';
import { RepositoryWidgetContext, fetchKnowledgeManagerRobotSettings } from '../../../utilities';
var RobotQuestionList = function (_a) {
    var categoryId = _a.categoryId, robotId = _a.robotId, searchWord = _a.searchWord, agentConfig = _a.agentConfig;
    var _b = useState(null), auth = _b[0], setAuth = _b[1];
    var _c = useState([]), data = _c[0], setData = _c[1];
    var _d = useState(1), page = _d[0], setPage = _d[1];
    var _e = useState({ pageNum: 1, pageSize: 20, total: 0 }), paging = _e[0], setPaging = _e[1];
    var _f = useState(false), loading = _f[0], setLoading = _f[1];
    var kmApiBase = useContext(RepositoryWidgetContext).kmApiBase;
    useEffect(function () {
        fetchKnowledgeManagerRobotSettings().then(function (settings) {
            setAuth(settings.auth);
        });
    }, []);
    useEffect(function () {
        setData([]);
        setPage(1);
    }, [categoryId, robotId, searchWord]);
    useEffect(function () {
        if (!auth)
            return;
        setLoading(true);
        axios
            .post("".concat(kmApiBase, "/v1/questions/search?sign=").concat(auth.sign, "&email=").concat(auth.email, "&timestamp=").concat(auth.timestamp, "&appID=").concat(auth.appID), {
            categoryId: categoryId,
            robotId: robotId,
            pageNum: page,
            pageSize: 20,
            searchWord: searchWord,
        })
            .then(function (res) {
            setPaging(res.data.paging);
            setData(function (prevState) { return __spreadArray(__spreadArray([], prevState, true), res.data.data, true); });
        })
            .finally(function () { return setLoading(false); });
    }, [page, categoryId, robotId, auth === null || auth === void 0 ? void 0 : auth.sign, auth === null || auth === void 0 ? void 0 : auth.email, auth === null || auth === void 0 ? void 0 : auth.timestamp, auth === null || auth === void 0 ? void 0 : auth.appID, searchWord]);
    var handleInfiniteOnLoad = useCallback(function () {
        if (loading) {
            return;
        }
        setPage(function (prevState) { return prevState + 1; });
    }, [loading]);
    return (React.createElement("div", { className: css['questionList'] },
        React.createElement(InfiniteScroll, { initialLoad: false, pageStart: 0, loadMore: handleInfiniteOnLoad, hasMore: paging.pageNum * paging.pageSize < paging.total, useWindow: false },
            data.length ? React.createElement(List, { dataSource: data, renderItem: function (item) { return React.createElement(RobotQuestionItem, { data: item }); } }) : loading ? null : React.createElement(Empty, { className: css['nodata'] }),
            loading && React.createElement(Spin, { className: "w-full text-center mt-30" }))));
};
export default RobotQuestionList;
