import React, { useCallback, useContext } from 'react';
import { Button, List, Popover } from 'udesk-ui';
import { useTranslation } from '@udesk-webapp/locale';
import FileTextTwoTone from '@ant-design/icons/FileTextTwoTone';
import DOMPurify from 'dompurify';
import { RepositoryWidgetContext, robotToCommonQuestion } from '../../../utilities';
import css from '../style.module.scss';
var RobotQuestionItem = function (_a) {
    var _b, _c, _d;
    var data = _a.data, agentConfig = _a.agentConfig;
    var t = useTranslation().t;
    var _e = useContext(RepositoryWidgetContext), onUse = _e.onUse, allowSendQuestion = _e.allowSendQuestion, onSend = _e.onSend, showQuestionModal = _e.showQuestionModal;
    var onUseClick = useCallback(function () {
        var _a;
        if ((_a = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.knowledge_config) === null || _a === void 0 ? void 0 : _a.question_use_edit) {
            var robotAnswer = robotToCommonQuestion(data);
            showQuestionModal === null || showQuestionModal === void 0 ? void 0 : showQuestionModal(robotAnswer, true);
        }
        else {
            onUse === null || onUse === void 0 ? void 0 : onUse('question', robotToCommonQuestion(data));
        }
    }, [data, onUse, showQuestionModal, (_b = agentConfig === null || agentConfig === void 0 ? void 0 : agentConfig.knowledge_config) === null || _b === void 0 ? void 0 : _b.question_use_edit]);
    var onSendClick = useCallback(function () {
        onSend === null || onSend === void 0 ? void 0 : onSend('question', robotToCommonQuestion(data));
    }, [data, onSend]);
    return (React.createElement(Popover, { content: React.createElement("div", { dangerouslySetInnerHTML: {
                __html: DOMPurify.sanitize((_d = (_c = data.answer) === null || _c === void 0 ? void 0 : _c.content) !== null && _d !== void 0 ? _d : ''),
            } }), overlayStyle: { maxWidth: '300px' }, overlayClassName: css.robotQuestionItemPopover, placement: 'left' },
        React.createElement(List.Item, { className: css['align-justify'] },
            React.createElement("div", { className: css['file-title'] },
                React.createElement(FileTextTwoTone, { className: css['file-icon'] }),
                data.content),
            React.createElement("div", { className: css['nowrap'] },
                allowSendQuestion ? (React.createElement(React.Fragment, null,
                    React.createElement(Button, { size: 'small', type: 'link', onClick: onSendClick }, t('label.send')),
                    React.createElement("span", { className: css['line'] }))) : null,
                React.createElement(Button, { size: 'small', type: 'link', onClick: onUseClick }, t('label.use'))))));
};
export default RobotQuestionItem;
