import { __assign, __rest } from "tslib";
import React, { useEffect, useState } from 'react';
import Select from 'udesk-ui/es/select';
import { csApiGetJSON } from '../../utils/csApi';
var RobotSelect = function (_a) {
    var _b;
    var settings = _a.settings, onDataLoaded = _a.onDataLoaded, props = __rest(_a, ["settings", "onDataLoaded"]);
    var _c = useState([]), robotList = _c[0], setRobotList = _c[1];
    useEffect(function () {
        csApiGetJSON('/cs/im/agent/udesk_robots').then(function (res) { return res.data; }).then(function (list) {
            var _a, _b;
            var visibleIds = (_a = settings === null || settings === void 0 ? void 0 : settings.km_join_udesk_robots) === null || _a === void 0 ? void 0 : _a.robot_ids;
            if (visibleIds) {
                var robots = (_b = list === null || list === void 0 ? void 0 : list.udesk_robots.filter(function (i) {
                    return visibleIds.includes(i.km_robot_id);
                })) !== null && _b !== void 0 ? _b : [];
                onDataLoaded(robots);
                setRobotList(robots);
            }
        });
    }, [onDataLoaded, (_b = settings === null || settings === void 0 ? void 0 : settings.km_join_udesk_robots) === null || _b === void 0 ? void 0 : _b.robot_ids]);
    if (!robotList.length) {
        return null;
    }
    return (React.createElement(Select, __assign({ bordered: false }, props), robotList.map(function (i, idx) {
        return (React.createElement(Select.Option, { value: i.km_robot_id, key: i.km_robot_id }, i.name));
    })));
};
export default RobotSelect;
