import React, { ContextType } from 'react';
import { RepositoryWidgetContext, IM_REPOSITORY_ROBOT_KM } from './utilities';
import { Ability } from './common';
export interface Props {
    companyId: number;
    email: string;
    subdomain: string;
    onSpaceChange?: (space: number) => void;
    onCatalogChange?: (catalog: number) => void;
    expandKeys?: string[];
    scrollTop?: number;
    onUse?: ContextType<typeof RepositoryWidgetContext>['onUse'];
    onSend?: ContextType<typeof RepositoryWidgetContext>['onSend'];
    onRelate?: Function;
    allowSendQuestion?: boolean;
    showRobotQuestionTab?: boolean;
    kmApiBase: string;
    selectionStateKey?: string;
    roleCan: IRoleCan;
    previewUrl: string;
    customer?: Customer;
    ticket?: ITicket;
    agent?: IAgent;
    ticketCustomFields?: CustomField[];
    customerCustomFields?: CustomField[];
    tabs?: {
        order_id: typeof IM_REPOSITORY_ROBOT_KM | keyof typeof tabComponentMap;
        name: string;
        is_default?: boolean;
        is_displayed: boolean;
    }[];
    public_knowledge_configs?: ContextType<typeof RepositoryWidgetContext>['public_knowledge_configs'];
    organizations?: Pick<Organization, 'name'>[];
    agentConfig?: ImConfig;
    dialogueTagData?: TagItem[];
    mineChats?: IMineChat[];
    refreshKnowledge?: number;
    customerFieldAbilities?: {
        [key: string]: {
            new: Ability;
            edit: Ability;
            show: Ability;
        };
    };
    showQuestionModal?: (data: any, status: boolean) => void;
    isWorkbench: boolean;
    host: string;
    allowRelateQuestion?: boolean;
    categoryValue?: number;
}
declare const tabComponentMap: {
    [x: string]: any;
};
declare const RepositoryWidget: React.FC<Props>;
export default RepositoryWidget;
