/// <reference types="lodash" />
/**
 * 获取机器人配置
 */
export declare const getConfig: (() => any) & import("lodash").MemoizedFunction;
/**
 * 设置机器人配置
 */
export declare function setConfig(key: string, value: any): any;
/**
 * 通过类型，判断配置开关
 * @param {string} type -
 */
export declare function ifEnabled(type: string): any;
/**
 * 获取机器人列表
 * @param {Array} [cfg.visibleIds] - 需要显示机器人ids
 */
export declare function getList(cfg?: {
    [key: string]: any;
}, cache?: boolean): any;
/**
 * 获取机器人分类列表
 * @param {number} cfg.robotId - 机器人id
 */
export declare function getCategoryList(cfg?: {
    [key: string]: any;
    robotBaseURL: string;
}, cache?: boolean): any;
/**
 * 获取机器人问题列表
 * @param {number} cfg.robotId - 机器人id
 * @param {number[]} cfg.channelIdList - 场景id列表
 * @param {number} [cfg.categoryId] - 分类id
 * @param {string} [cfg.searchWord] - 关键字
 * @param {number} cfg.[pageNum=1]
 * @param {number} cfg.[pageSize=20]
 */
export declare function getQuestionList(cfg: {
    [key: string]: any;
    robotBaseURL: string;
}): any;
/**
 * 获取机器人推荐问题列表
 * @param {number} cfg.robotId - 机器人id
 * @param {number} cfg.channelId - 场景id
 * @param {string} cfg.queryContent - 关键字
 */
export declare function getRecommendQuestionList(cfg: any, cacheCfg?: {
    [key: string]: any;
    robotBaseURL: string;
}): any;
/**
 * 把im工作台消息存进对应的km机器人知识库
 * @param {number} [robotId] - 机器人id
 * @param {number} [categoryId] 分类id 默认 未分类
 * @param {string} [content] - 问题标题
 * @param {string} [type] [问题类型] 默认选1
 * @param {Object} [answer] - 答案
 * @param {stirng} [answer.content]  答案内容
 * @param {number} [answer.type] 答案类型  1: text   2: rich
 * @param {number[]} channelIdList - 场景id列表
 * @param {number} [suggestType] - 推荐类型 默认1
 */
export declare function saveQuestionToKm(cfg: any, cacheCfg?: {
    [key: string]: any;
    robotBaseURL: string;
}): any;
/**
 * 获取会话渠道robot配置，渠道：网页插件/微信/sdk/小程序
 * @returns
 * @param {number} id
 * @param {string} name
 * @param {number} km_robot_id
 * @param {number} scene_id
 */
export declare function getChannelRobot(im_sub_session_id: number): any;
