function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
// @ts-ignore
import Udesk from 'udesk-react/src/udesk';
import { inputTypes, getFieldOperators } from '../../../constant';
var exportObj = {
  validateString: validateString,
  validateInputTypes: validateInputTypes,
  validateOperators: validateOperators,
  validateObject: validateObject,
  validateFunction: validateFunction,
  validateFunctionNullable: validateFunctionNullable
};
export default exportObj;
function validateString(value) {
  if (typeof value !== 'string') {
    return 'value must be string';
  }
  return true;
}
function validateInputTypes(value) {
  return validateEnum(value, inputTypes, 'inputTypes');
}
function validateOperators(locale, value) {
  return validateEnumArray(value, getFieldOperators(locale), 'fieldOperators');
}
function validateObject(value) {
  if (value != null && _typeof(value) !== 'object') {
    return 'value must be POJO';
  }
  return true;
}
function validateFunction(value) {
  if (typeof value !== 'function') {
    return 'value must be function';
  }
  return true;
}
function validateFunctionNullable(value) {
  if (value != null && typeof value !== 'function') {
    return 'value must be function';
  }
  return true;
}
function validateEnum(value, enumType, enumTypeName) {
  if (!(value instanceof Udesk.enums.EnumItemClass) && enumType[value] == null && enumType.get(value) == null) {
    return "value (".concat(value, ") must be enum type (").concat(enumTypeName, ")");
  }
  return true;
}
function validateEnumArray(value, enumType, enumTypeName) {
  if (!(value instanceof Array)) {
    return 'value must be array';
  }
  var _iterator = _createForOfIteratorHelper(value),
    _step;
  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var item = _step.value;
      var result = validateEnum(item, enumType, enumTypeName);
      if (result !== true) {
        return result;
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }
  return true;
}