// @ts-ignore
import Udesk from 'udesk-react/src/udesk';
export var inputTypes = new Udesk.enums.EnumClass([{
  id: 'text',
  key: 'text'
}, {
  id: 'number',
  key: 'number'
}, {
  id: 'doubleText',
  key: 'doubleText'
}, {
  id: 'textArea',
  key: 'textArea'
}, {
  id: 'dropDown',
  key: 'dropDown'
}, {
  id: 'datePicker',
  key: 'datePicker'
}, {
  id: 'time',
  key: 'time'
}, {
  id: 'dateTimePicker',
  key: 'dateTimePicker'
}, {
  id: 'dateRange',
  key: 'dateRange'
}, {
  id: 'integerNumber',
  key: 'integerNumber'
}, {
  id: 'floatNumber',
  key: 'floatNumber'
}, {
  id: 'autoComplete',
  key: 'autoComplete'
}, {
  id: 'noValue',
  key: 'noValue'
}, {
  id: 'autoCompleteInput',
  key: 'autoCompleteInput'
}, {
  id: 'emotionCategoryDropDown',
  key: 'emotionCategoryDropDown'
}]);
export var getFieldOperators = function getFieldOperators(locale) {
  var lang = locale.lang;
  var fieldOperators = new Udesk.enums.EnumClass([/*jshint camelcase:false*/
  {
    id: 'exist',
    name: function name() {
      return lang.customFilters.fieldOperators.exist;
    },
    key: 'exist'
  }, {
    id: 'not_exist',
    name: function name() {
      return lang.customFilters.fieldOperators.not_exist;
    },
    key: 'not_exist'
  }, {
    id: 'is',
    name: function name() {
      return lang.customFilters.fieldOperators.is;
    },
    key: 'is'
  }, {
    id: 'not',
    name: function name() {
      return lang.customFilters.fieldOperators.not;
    },
    key: 'not'
  }, {
    id: 'is',
    name: function name() {
      return lang.customFilters.fieldOperators.equal;
    },
    key: 'equal'
  }, {
    id: 'is_express',
    name: function name() {
      return lang.customFilters.fieldOperators.isExpress;
    },
    key: 'isExpress'
  }, {
    id: 'not',
    name: function name() {
      return lang.customFilters.fieldOperators.notEqual;
    },
    key: 'notEqual'
  }, {
    id: 'any_equal',
    name: function name() {
      return lang.customFilters.fieldOperators.any_equal;
    },
    key: 'any_equal'
  }, {
    id: 'any_not_equal',
    name: function name() {
      return lang.customFilters.fieldOperators.any_not_equal;
    },
    key: 'any_not_equal'
  }, {
    id: 'any_match',
    name: function name() {
      return lang.customFilters.fieldOperators.any_equal;
    },
    key: 'any_match'
  }, {
    id: 'none_match',
    name: function name() {
      return lang.customFilters.fieldOperators.any_not_equal;
    },
    key: 'none_match'
  }, {
    id: 'contains',
    name: function name() {
      return lang.customFilters.fieldOperators.contains;
    },
    key: 'contains'
  }, {
    id: 'not_contains',
    name: function name() {
      return lang.customFilters.fieldOperators.notContains;
    },
    key: 'not_contains'
  }, {
    id: 'contains_any',
    name: function name() {
      return lang.customFilters.fieldOperators.containsAny;
    },
    key: 'contains_any'
  }, {
    id: 'not_contains_any',
    name: function name() {
      return lang.customFilters.fieldOperators.notContainsAny;
    },
    key: 'not_contains_any'
  }, {
    id: 'included_any',
    name: function name() {
      return lang.customFilters.fieldOperators.containsAny;
    },
    key: 'included_any'
  }, {
    id: 'excluded_any',
    name: function name() {
      return lang.customFilters.fieldOperators.notContainsAny;
    },
    key: 'excluded_any'
  }, {
    id: 'contains_all',
    name: function name() {
      return lang.customFilters.fieldOperators.containsAll;
    },
    key: 'contains_all'
  }, {
    id: 'not_contains_all',
    name: function name() {
      return lang.customFilters.fieldOperators.notContainsAll;
    },
    key: 'not_contains_all'
  }, {
    id: 'included_all',
    name: function name() {
      return lang.customFilters.fieldOperators.containsAll;
    },
    key: 'included_all'
  }, {
    id: 'excluded_all',
    name: function name() {
      return lang.customFilters.fieldOperators.notContainsAll;
    },
    key: 'excluded_all'
  }, {
    id: 'is_null',
    name: function name() {
      return lang.customFilters.fieldOperators.isNull;
    },
    key: 'is_null'
  }, {
    id: 'is_not_null',
    name: function name() {
      return lang.customFilters.fieldOperators.isNotNull;
    },
    key: 'is_not_null'
  }, {
    id: 'greater_than',
    name: function name() {
      return lang.customFilters.fieldOperators.greaterThan;
    },
    key: 'greater_than'
  }, {
    id: 'greater_than_eq',
    name: function name() {
      return lang.customFilters.fieldOperators.greaterThanEq;
    },
    key: 'greater_than_eq'
  }, {
    id: 'less_than',
    name: function name() {
      return lang.customFilters.fieldOperators.lessThan;
    },
    key: 'less_than'
  }, {
    id: 'less_than_eq',
    name: function name() {
      return lang.customFilters.fieldOperators.lessThanEq;
    },
    key: 'less_than_eq'
  }, {
    id: 'between',
    name: function name() {
      return lang.customFilters.fieldOperators.between;
    },
    key: 'between'
  }, {
    id: 'not_between',
    name: function name() {
      return lang.customFilters.fieldOperators.notBetween;
    },
    key: 'not_between'
  }, {
    id: 'relative',
    name: function name() {
      return lang.customFilters.fieldOperators.relative;
    },
    key: 'relative'
  }, {
    id: 'set',
    name: function name() {
      return lang.customFilters.fieldOperators.set;
    },
    key: 'set'
  }, {
    id: 'customBelong',
    name: function name() {
      return lang.customFilters.fieldOperators.customBelong;
    },
    key: 'customBelong'
  }, {
    id: 'customNotBelong',
    name: function name() {
      return lang.customFilters.fieldOperators.customNotBelong;
    },
    key: 'customNotBelong'
  }, {
    id: 'belongs',
    name: function name() {
      return lang.customFilters.fieldOperators.belongs;
    },
    key: 'belongs'
  }, {
    id: 'not_belongs',
    name: function name() {
      return lang.customFilters.fieldOperators.notBelongs;
    },
    key: 'notBelongs'
  }, {
    id: 'custom_belong',
    name: function name() {
      return lang.customFilters.fieldOperators.belongs;
    },
    key: 'custom_belong'
  }, {
    id: 'custom_not_belong',
    name: function name() {
      return lang.customFilters.fieldOperators.notBelongs;
    },
    key: 'custom_not_belong'
  }, {
    id: 'today',
    name: function name() {
      return lang.customFilters.fieldOperators.today;
    },
    key: 'today'
  }, {
    id: 'yesterday',
    name: function name() {
      return lang.customFilters.fieldOperators.yesterday;
    },
    key: 'yesterday'
  }, {
    id: 'tomorrow',
    name: function name() {
      return lang.customFilters.fieldOperators.tomorrow;
    },
    key: 'tomorrow'
  }, {
    id: 'next_seven_day',
    name: function name() {
      return lang.customFilters.fieldOperators.next_seven_day;
    },
    key: 'next_seven_day'
  }, {
    id: 'last_seven_day',
    name: function name() {
      return lang.customFilters.fieldOperators.last_seven_day;
    },
    key: 'last_seven_day'
  }, {
    id: 'this_week',
    name: function name() {
      return lang.customFilters.fieldOperators.this_week;
    },
    key: 'this_week'
  }, {
    id: 'next_week',
    name: function name() {
      return lang.customFilters.fieldOperators.next_week;
    },
    key: 'next_week'
  }, {
    id: 'last_week',
    name: function name() {
      return lang.customFilters.fieldOperators.last_week;
    },
    key: 'last_week'
  }, {
    id: 'this_month',
    name: function name() {
      return lang.customFilters.fieldOperators.this_month;
    },
    key: 'this_month'
  }, {
    id: 'next_month',
    name: function name() {
      return lang.customFilters.fieldOperators.next_month;
    },
    key: 'next_month'
  }, {
    id: 'last_month',
    name: function name() {
      return lang.customFilters.fieldOperators.last_month;
    },
    key: 'last_month'
  }, {
    id: 'this_year',
    name: function name() {
      return lang.customFilters.fieldOperators.this_year;
    },
    key: 'this_year'
  }, {
    id: 'next_year',
    name: function name() {
      return lang.customFilters.fieldOperators.next_year;
    },
    key: 'next_year'
  }, {
    id: 'last_year',
    name: function name() {
      return lang.customFilters.fieldOperators.last_year;
    },
    key: 'last_year'
  }, {
    id: 'exact_match',
    name: function name() {
      return lang.customFilters.fieldOperators.exact_match;
    },
    key: 'exact_match'
  }, {
    id: 'add_value',
    name: function name() {
      return lang.customFilters.fieldOperators.add_value;
    },
    key: 'add_value'
  }, {
    id: 'remove_value',
    name: function name() {
      return lang.customFilters.fieldOperators.remove_value;
    },
    key: 'remove_value'
  }, {
    id: 'set_null',
    name: function name() {
      return lang.customFilters.fieldOperators.set_null;
    },
    key: 'set_null'
  }, {
    id: 'is_any',
    name: function name() {
      return lang.customFilters.fieldOperators.is_any;
    },
    key: 'is_any'
  }, {
    id: 'not_any',
    name: function name() {
      return lang.customFilters.fieldOperators.not_any;
    },
    key: 'not_any'
  }, {
    id: 'containsSensitive',
    name: function name() {
      return lang.customFilters.fieldOperators.containsSensitive;
    },
    key: 'containsSensitive'
  }, {
    id: 'contain_any',
    name: function name() {
      return lang.customFilters.fieldOperators.contain_any;
    },
    key: 'contain_any'
  }, {
    id: 'not_contain_any',
    name: function name() {
      return lang.customFilters.fieldOperators.not_contain_any;
    },
    key: 'not_contain_any'
  }, {
    id: 'contain_all',
    name: function name() {
      return lang.customFilters.fieldOperators.contain_all;
    },
    key: 'contain_all'
  }, {
    id: 'not_contain_all',
    name: function name() {
      return lang.customFilters.fieldOperators.not_contain_all;
    },
    key: 'not_contain_all'
  }, {
    id: 'belong',
    name: function name() {
      return lang.customFilters.fieldOperators.belong;
    },
    key: 'belong'
  }, {
    id: 'not_belong',
    name: function name() {
      return lang.customFilters.fieldOperators.not_belong;
    },
    key: 'not_belong'
  }]);
  return fieldOperators;
};
export var getConfigRuleTypes = function getConfigRuleTypes(locale) {
  var lang = locale.lang;
  var configRuleTypes = new Udesk.enums.EnumClass([{
    id: 'platform',
    key: 'platform',
    name: function name() {
      return lang.configRuleTypes.platform;
    }
  }, {
    id: 'src',
    key: 'src',
    name: function name() {
      return lang.configRuleTypes.src;
    }
  }, {
    id: 'srcUrl',
    key: 'srcUrl',
    name: function name() {
      return lang.configRuleTypes.srcUrl;
    }
  }, {
    id: 'webPluginName',
    key: 'webPluginName',
    name: function name() {
      return lang.configRuleTypes.webPluginName;
    }
  }, {
    id: 'loginUrl',
    key: 'loginUrl',
    name: function name() {
      return lang.configRuleTypes.loginUrl;
    }
  }, {
    id: 'sessionUrl',
    key: 'sessionUrl',
    name: function name() {
      return lang.configRuleTypes.sessionUrl;
    }
  }, {
    id: 'dialogueDesc',
    key: 'dialogueDesc',
    name: function name() {
      return lang.configRuleTypes.dialogueDesc;
    }
  }, {
    id: 'tags',
    key: 'tags',
    name: function name() {
      return lang.configRuleTypes.tags;
    }
  }, {
    id: 'currentTime',
    key: 'currentTime',
    name: function name() {
      return lang.configRuleTypes.currentTime;
    }
  }, {
    id: 'orderReply',
    key: 'orderReply',
    name: function name() {
      return lang.configRuleTypes.orderReply;
    }
  }, {
    id: 'keyword',
    key: 'keyword',
    name: function name() {
      return lang.configRuleTypes.keyword;
    }
  }, {
    id: 'emotionCategory',
    key: 'emotionCategory',
    name: function name() {
      return lang.configRuleTypes.emotionCategory;
    }
  }, {
    id: 'queryContent',
    key: 'queryContent',
    name: function name() {
      return lang.configRuleTypes.queryContent;
    }
  }]);
  return configRuleTypes;
};
export var getManyAnswerEmotionCategory = function getManyAnswerEmotionCategory(locale) {
  var lang = locale.lang;
  var manyAnswerEmotionCategory = new Udesk.enums.EnumClass([{
    id: 'OPTIMISTIC',
    key: 'positive',
    name: function name() {
      return lang.emotionCategory.positive;
    }
  }, {
    id: 'NEUTRAL',
    key: 'neutral',
    name: function name() {
      return lang.emotionCategory.neutral;
    }
  }, {
    id: 'PESSIMISTIC',
    key: 'negative',
    name: function name() {
      return lang.emotionCategory.negative;
    }
  }]);
  return manyAnswerEmotionCategory;
};
export var getJudgmentLogicTypes = function getJudgmentLogicTypes(locale) {
  var lang = locale.lang;
  var judgmentLogicTypes = new Udesk.enums.EnumClass([{
    id: 1,
    key: 'meetAll',
    name: function name() {
      return lang.judgmentLogicTypes.meetAll;
    }
  }, {
    id: 2,
    key: 'meetAny',
    name: function name() {
      return lang.judgmentLogicTypes.meetAny;
    }
  }, {
    id: 3,
    key: 'custom',
    name: function name() {
      return lang.judgmentLogicTypes.custom;
    }
  }]);
  return judgmentLogicTypes;
};
export var getManyAnswerChannelTypes = function getManyAnswerChannelTypes(locale) {
  var lang = locale.lang;
  var manyAnswerChannelTypes = new Udesk.enums.EnumClass([{
    id: 'testWindow',
    key: 'testWindow',
    name: function name() {
      return lang.channelTypes.testWindow;
    }
  }, {
    id: 'web',
    key: 'web',
    name: function name() {
      return lang.channelTypes.web;
    }
  }, {
    id: 'wechat,微信',
    key: 'WEChat',
    name: function name() {
      return lang.channelTypes.WEChat;
    }
  }, {
    id: 'android',
    key: 'android',
    name: function name() {
      return lang.channelTypes.android;
    }
  }, {
    id: 'ios',
    key: 'ios',
    name: function name() {
      return lang.channelTypes.ios;
    }
  }, {
    id: 'weibo',
    key: 'weibo',
    name: function name() {
      return lang.channelTypes.weibo;
    }
  }, {
    id: 'api',
    key: 'api',
    name: function name() {
      return lang.channelTypes.api;
    }
  }, {
    id: 'mchat',
    key: 'mchat',
    name: function name() {
      return lang.channelTypes.mchat;
    }
  }, {
    id: 'weixin_mini',
    key: 'WeChatSmallProgram',
    name: function name() {
      return lang.channelTypes.WeChatSmallProgram;
    }
  }, {
    id: 'qywx',
    key: 'enterpriseWechat',
    name: function name() {
      return lang.channelTypes.enterpriseWechat;
    }
  }, {
    id: 'baidu',
    key: 'baidu',
    name: function name() {
      return lang.channelTypes.baidu;
    }
  }, {
    id: 'facebook',
    key: 'facebook',
    name: function name() {
      return lang.channelTypes.facebook;
    }
  }, {
    id: 'line',
    key: 'line',
    name: function name() {
      return lang.channelTypes.line;
    }
  }, {
    id: 'whats_app',
    key: 'whatsApp',
    name: function name() {
      return lang.channelTypes.whatsApp;
    }
  }, {
    id: 'twitter',
    key: 'twitter',
    name: function name() {
      return lang.channelTypes.twitter;
    }
  }, {
    id: 'tiktok',
    key: 'tiktok',
    name: function name() {
      return lang.channelTypes.tiktok;
    }
  }, {
    id: 'weixin_kf',
    key: 'weChatService',
    name: function name() {
      return lang.channelTypes.weChatService;
    }
  }, {
    id: 'meituan_waimai',
    key: 'meituan',
    name: function name() {
      return lang.channelTypes.meituan;
    }
  }, {
    id: 'eleme_waimai',
    key: 'eleme',
    name: function name() {
      return lang.channelTypes.eleme;
    }
  }]);
  return manyAnswerChannelTypes;
};
var exportObj = {
  inputTypes: inputTypes,
  getFieldOperators: getFieldOperators,
  getManyAnswerEmotionCategory: getManyAnswerEmotionCategory,
  getJudgmentLogicTypes: getJudgmentLogicTypes,
  getManyAnswerChannelTypes: getManyAnswerChannelTypes
};
export default exportObj;