function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import React, { useState, useEffect, useImperativeHandle } from 'react';
import classNames from 'classnames';
import { usePrefixCls } from '../utils';
import { Form, Input, Radio, Popover, Icon } from 'udesk-ui';
import PopContent from './components/pop-content';
import { getJudgmentLogicTypes, getConfigRuleTypes, getFieldOperators, getManyAnswerChannelTypes } from './constant';
import { useLocaleReceiver } from '../locale-provider/LocaleReceiver';
import CustomLogicInput from './components/custom-logic-input';
import CustomLogicFilter from './components/custom-logic-filter';
// import { If } from 'tsx-control-statements/components';
import { validateValues, formatData, formatToComponentData } from './utils';
import './style/index';
var formLayout = {
  labelCol: {
    span: 4
  },
  wrapperCol: {
    span: 16
  }
};
var tailLayout = {
  wrapperCol: {
    offset: 4,
    span: 16
  }
};
var defauleFormKeys = {
  nameKey: 'name',
  tagValueListsKey: 'tagValueLists',
  judgmentLogicKey: 'judgmentLogic',
  tagKey: 'tag'
};
var RulesConfig = function RulesConfig(props, ref) {
  var customizePrefixCls = props.prefixCls,
    _props$className = props.className,
    className = _props$className === void 0 ? '' : _props$className,
    _props$value = props.value,
    value = _props$value === void 0 ? {} : _props$value,
    onChange = props.onChange,
    _props$formKeys = props.formKeys,
    formKeys = _props$formKeys === void 0 ? defauleFormKeys : _props$formKeys,
    onFinish = props.onFinish;
  var _useLocaleReceiver = useLocaleReceiver('RulesConfig'),
    _useLocaleReceiver2 = _slicedToArray(_useLocaleReceiver, 1),
    contextLocale = _useLocaleReceiver2[0];
  var _Form$useForm = Form.useForm(),
    _Form$useForm2 = _slicedToArray(_Form$useForm, 1),
    form = _Form$useForm2[0];
  var judgmentLogicTypes = getJudgmentLogicTypes(contextLocale);
  var configRuleTypes = getConfigRuleTypes(contextLocale);
  var fieldOperators = getFieldOperators(contextLocale);
  var manyAnswerChannelTypes = getManyAnswerChannelTypes(contextLocale);
  var _useState = useState(judgmentLogicTypes.meetAll.id),
    _useState2 = _slicedToArray(_useState, 2),
    judgmentLogic = _useState2[0],
    setJudgmentLogic = _useState2[1];
  var _usePrefixCls = usePrefixCls('rules-config', customizePrefixCls || ''),
    _usePrefixCls2 = _slicedToArray(_usePrefixCls, 1),
    rulesConfigPrefixCls = _usePrefixCls2[0];
  var classes = classNames(rulesConfigPrefixCls, className);
  var MANY_ANSWER_EXTRA_LIST = [configRuleTypes.emotionCategory.id];
  useImperativeHandle(ref, function () {
    return {
      reset: handleReset,
      submit: handleSubmit
    };
  }, []);
  var handleSubmit = function handleSubmit() {
    form === null || form === void 0 ? void 0 : form.submit();
  };
  var handleFinish = function handleFinish(values) {
    var _value$formKeys$tagVa;
    var val = _objectSpread(_objectSpread({}, values), {}, _defineProperty({}, formKeys.tagValueListsKey, formatToComponentData((value === null || value === void 0 ? void 0 : (_value$formKeys$tagVa = value[formKeys.tagValueListsKey]) === null || _value$formKeys$tagVa === void 0 ? void 0 : _value$formKeys$tagVa.map(function (el) {
      return _objectSpread({}, el);
    })) || [], configRuleTypes, manyAnswerChannelTypes)));
    var flag = validateValues(val, configRuleTypes, fieldOperators, judgmentLogicTypes, contextLocale);
    if (flag) {
      onFinish === null || onFinish === void 0 ? void 0 : onFinish(formatData(val, formKeys.tagValueListsKey, judgmentLogicTypes, configRuleTypes));
    }
  };
  var handleReset = function handleReset() {
    var _form$setFieldsValue;
    setJudgmentLogic(judgmentLogicTypes.meetAll.id);
    form === null || form === void 0 ? void 0 : form.setFieldsValue((_form$setFieldsValue = {}, _defineProperty(_form$setFieldsValue, formKeys.nameKey, ''), _defineProperty(_form$setFieldsValue, formKeys.tagValueListsKey, {
      field: configRuleTypes.platform.id,
      operator: fieldOperators.is.id,
      value: null
    }), _defineProperty(_form$setFieldsValue, formKeys.judgmentLogicKey, judgmentLogicTypes.meetAll.id), _defineProperty(_form$setFieldsValue, formKeys.tagKey, ''), _form$setFieldsValue));
  };
  var onJudgmentLogicChange = function onJudgmentLogicChange(e) {
    var value = e.target.value;
    setJudgmentLogic(value);
  };
  var handleValuesChange = function handleValuesChange(changedValues, allValues) {
    onChange === null || onChange === void 0 ? void 0 : onChange(_objectSpread(_objectSpread({}, value), allValues));
  };
  var handleLogicChange = function handleLogicChange(val) {
    value[formKeys.tagValueListsKey] = val;
    onChange === null || onChange === void 0 ? void 0 : onChange(_objectSpread(_objectSpread({}, value), {}, _defineProperty({}, formKeys.tagValueListsKey, val)));
  };
  useEffect(function () {
    var _form$setFieldsValue2;
    setJudgmentLogic((value === null || value === void 0 ? void 0 : value[formKeys.judgmentLogicKey]) || judgmentLogicTypes.meetAll.id);
    form === null || form === void 0 ? void 0 : form.setFieldsValue((_form$setFieldsValue2 = {}, _defineProperty(_form$setFieldsValue2, formKeys.nameKey, (value === null || value === void 0 ? void 0 : value[formKeys.nameKey]) || ''), _defineProperty(_form$setFieldsValue2, formKeys.judgmentLogicKey, (value === null || value === void 0 ? void 0 : value[formKeys.judgmentLogicKey]) || judgmentLogicTypes.meetAll.id), _defineProperty(_form$setFieldsValue2, formKeys.tagKey, (value === null || value === void 0 ? void 0 : value[formKeys.tagKey]) || ''), _form$setFieldsValue2));
  }, [value]);
  return /*#__PURE__*/React.createElement("div", {
    className: classes
  }, /*#__PURE__*/React.createElement(Form, _objectSpread(_objectSpread({}, formLayout), {}, {
    form: form,
    onValuesChange: handleValuesChange,
    onFinish: handleFinish
  }), /*#__PURE__*/React.createElement(Form.Item, {
    label: contextLocale.lang.name,
    name: formKeys.nameKey,
    rules: [{
      required: true,
      message: contextLocale.lang.inputRuleName
    }]
  }, /*#__PURE__*/React.createElement(Input, {
    placeholder: contextLocale.lang.inputRuleName
  })), /*#__PURE__*/React.createElement(Form.Item, _objectSpread({}, tailLayout), /*#__PURE__*/React.createElement(CustomLogicFilter, {
    value: formatToComponentData((value === null || value === void 0 ? void 0 : value[formKeys.tagValueListsKey]) || [], configRuleTypes, manyAnswerChannelTypes),
    onChange: handleLogicChange,
    blackList: [],
    extraList: MANY_ANSWER_EXTRA_LIST
  })), /*#__PURE__*/React.createElement(Form.Item, {
    label: contextLocale.lang.judgmentLogic,
    rules: [{
      required: true,
      message: contextLocale.lang.inputRuleName
    }]
  }, /*#__PURE__*/React.createElement(Form.Item, {
    name: formKeys.judgmentLogicKey,
    noStyle: true
  }, /*#__PURE__*/React.createElement(Radio.Group, {
    onChange: onJudgmentLogicChange
  }, judgmentLogicTypes.map(function (item) {
    return /*#__PURE__*/React.createElement(Radio.Button, {
      value: item.id
    }, item.name);
  }))), /*#__PURE__*/React.createElement(If, {
    condition: judgmentLogic === judgmentLogicTypes.custom.id
  }, judgmentLogic === judgmentLogicTypes.custom.id && /*#__PURE__*/React.createElement(Popover, {
    content: /*#__PURE__*/React.createElement(PopContent, null)
  }, /*#__PURE__*/React.createElement(Icon, {
    type: "QuestionCircleOutlined",
    antdIcon: true,
    style: {
      marginLeft: '12px'
    }
  })))), /*#__PURE__*/React.createElement(If, {
    condition: judgmentLogic === judgmentLogicTypes.custom.id
  }, judgmentLogic === judgmentLogicTypes.custom.id && /*#__PURE__*/React.createElement(Form.Item, _objectSpread(_objectSpread({}, tailLayout), {}, {
    name: formKeys.tagKey,
    rules: [{
      required: true,
      message: contextLocale.lang.inputJudgmentLogicCustom
    }]
  }), /*#__PURE__*/React.createElement(CustomLogicInput, null)))));
};
var FancyListCheckbox = /*#__PURE__*/React.forwardRef(RulesConfig);
export default FancyListCheckbox;