var locale = {
  lang: {
    pleaseInput: 'Please enter',
    pleaseInputCustomLogic: 'Please enter custom logic',
    pleaseSelect: 'Please select',
    field: 'options',
    operator: 'operator',
    value: 'value',
    judgmentLogicTypes: {
      meetAll: 'Meet all conditions',
      meetAny: 'Meet any conditions',
      custom: 'Custom logic'
    },
    customFilters: {
      fieldOperators: {
        exist: 'exist',
        not_exist: 'does not exist',
        equal: 'equal to',
        notEqual: 'Not equal to',
        is: 'equal to',
        not: 'Not equal to',
        contains: 'contains',
        notContains: 'does not contain',
        containsAny: 'contains any',
        notContainsAny: 'Does not contain any',
        containsAll: 'contains all',
        notContainsAll: 'Does not contain all',
        isNull: 'null',
        isNotNull: 'Not null',
        greaterThan: 'greater than',
        greaterThanEq: 'greater than or equal to',
        lessThan: 'less than',
        lessThanEq: 'less than or equal to',
        between: 'between',
        notBetween: 'Not between',
        relative: 'equal to',
        set: 'set to',
        belongs: 'belongs to',
        notBelongs: 'Not Belongs',
        customBelong: 'belongs to',
        customNotBelong: 'Not Belong',
        today: 'today',
        yesterday: 'yesterday',
        tomorrow: 'tomorrow',
        next_seven_day: 'The next seven days',
        last_seven_day: 'Last seven days',
        this_week: 'this week',
        next_week: 'next week',
        last_week: 'last week',
        this_month: 'this month',
        next_month: 'Next month',
        last_month: 'Last month',
        this_year: 'this year',
        next_year: 'next year',
        last_year: 'last year',
        exact_match: 'exact match',
        add_value: 'Add value',
        remove_value: 'Remove value',
        set_null: 'null',
        is_any: 'contains any',
        not_any: 'Does not contain any',
        containsSensitive: 'Contains sensitive words',
        isExpress: 'equal to expression',
        any_equal: 'any equal',
        any_not_equal: 'Any is not equal to',
        contain_any: 'contains any',
        not_contain_any: 'Does not contain any',
        contain_all: 'contain all',
        not_contain_all: 'Not all',
        belong: 'belong to',
        not_belong: 'Does not belong'
      }
    },
    configRuleTypes: {
      platform: 'session channel',
      src: 'session source',
      srcUrl: 'Source URL',
      webPluginName: 'Source Plugin',
      loginUrl: 'Visit the landing page',
      sessionUrl: 'Dialog initiation page',
      dialogueDesc: 'dialogue description',
      tags: 'Customer tags',
      currentTime: 'Current time',
      orderReply: 'Order reply',
      keyword: 'Search keywords',
      emotionCategory: 'emotion category',
      queryContent: 'Message vocabulary '
    },
    emotionCategory: {
      positive: 'positive',
      neutral: 'neutral',
      negative: 'negative'
    },
    questionContent: 'Message vocabulary',
    judgmentLogic: 'judgment logic',
    inputJudgmentLogicCustom: 'Please enter custom logic',
    name: 'name',
    inputRuleName: 'Please enter a rule name',
    channelTypes: {
      testWindow: 'Test window',
      web: 'Web',
      WEChat: 'Wechat',
      android: 'Android',
      ios: 'ios',
      weibo: 'Weibo',
      api: 'Api',
      mchat: 'Multi-merchant',
      WeChatSmallProgram: 'WeChat applet',
      enterpriseWechat: 'Enterprise WeChat',
      baidu: 'Baidu BCP',
      facebook: 'facebook',
      line: 'LINE (Korean chat app)',
      whatsApp: 'WhatsApp',
      twitter: 'Twitter',
      tiktok: 'Tiktok',
      weChatService: 'WeChat customer service',
      meituan: 'Meituan',
      eleme: 'eleme'
    },
    judgeLogic: {
      judgeStrategyInfo: 'Please edit the condition combination according to the following rules:',
      validStrategyFormat: '(1 and 2) or (3 and 4)',
      invalidStrategyInfoOne: '1. Add spaces between characters',
      invalidStrategyFormatOne: '1and2or3and4',
      invalidStrategyInfoTwo: '2. Code not allowed',
      invalidStrategyFormatTwo: '1 and 2 and 3 and 4 and 5',
      invalidStrategyInfoThree: '3. Parentheses are in pairs',
      invalidStrategyFormatThree: '(1 and 2 or 3 and 4'
    },
    validate: {
      inputName: 'Please enter a name',
      lengthError8: 'The length cannot exceed 8',
      rulesConfigcanNotBeEmpty: 'Rule configuration cannot be empty',
      inputCustomName: 'Please enter custom logic',
      customTagDataError: 'Please fill in the custom logic according to the rules!'
    }
  }
};
export default locale;