function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
import { message } from 'udesk-ui';
var TagValueMaxLength = 8;
export var validateValues = function validateValues(values, configRuleTypes, fieldOperators, judgmentLogicTypes, contextLocale) {
  var _values$tagValueLists;
  if (!values.name || !values.name.trim()) {
    message.error(contextLocale.lang.validate.inputName);
    return false;
  }
  var tagValueLengthError = false;
  var isExistNullTagValue;
  if (Array.isArray(values.tagValueLists) && (values === null || values === void 0 ? void 0 : (_values$tagValueLists = values.tagValueLists) === null || _values$tagValueLists === void 0 ? void 0 : _values$tagValueLists.length)) {
    if (values.tagValueLists.length > TagValueMaxLength) {
      tagValueLengthError = true;
    }
    for (var index = 0; index < (values === null || values === void 0 ? void 0 : (_values$tagValueLists2 = values.tagValueLists) === null || _values$tagValueLists2 === void 0 ? void 0 : _values$tagValueLists2.length); index++) {
      var _values$tagValueLists2;
      var tagValueItem = values.tagValueLists[index];
      var field = tagValueItem.field;
      var operator = tagValueItem.operator;
      var value = tagValueItem.value;
      if (field === '' || field == null) {
        isExistNullTagValue = true;
        break;
      } else {
        if (field == configRuleTypes.platform.id) {
          if (!Array.isArray(value) || !value.length) {
            isExistNullTagValue = true;
            break;
          }
        } else if (field == configRuleTypes.dialogueDesc.id && (operator == fieldOperators.exist.id || operator == fieldOperators.not_exist.id)) {
          continue;
        } else if (field == configRuleTypes.tags.id && (operator == fieldOperators.exist.id || operator == fieldOperators.not_exist.id)) {
          continue;
        } else if (field == configRuleTypes.queryContent.id && (operator == fieldOperators.containsSensitive.id || operator == fieldOperators.contains.id)) {
          continue;
        } else if (field == configRuleTypes.orderReply.id) {
          continue;
        } else {
          if (value === '' || value == null) {
            isExistNullTagValue = true;
            break;
          }
        }
      }
    }
  }
  if (tagValueLengthError) {
    message.error(contextLocale.lang.validate.lengthError8);
    return;
  }
  if (isExistNullTagValue) {
    message.error(contextLocale.lang.validate.rulesConfigcanNotBeEmpty);
    return;
  }
  if (values.judgmentLogic === judgmentLogicTypes.custom.id && (!values.tag || !values.tag.trim())) {
    message.error(contextLocale.lang.validate.inputCustomName);
    return;
  }
  values.name = values.name.trim();
  if (values.judgmentLogic === judgmentLogicTypes.custom.id) {
    values.tag = values.tag.trim();
  }
  var reg = /^[() andor\d]*$/;
  if (values.tag && !reg.test(values.tag)) {
    message.error(contextLocale.lang.validate.customTagDataError);
    return;
  }
  return true;
};
// 从km复制来
export var formatData = function formatData(values, tagValueListsKey, judgmentLogicTypes, configRuleTypes) {
  if (values.judgmentLogic == judgmentLogicTypes.meetAll.id) {
    values.tag = getLogicText(' and ', values === null || values === void 0 ? void 0 : values[tagValueListsKey]);
  } else if (values.judgmentLogic == judgmentLogicTypes.meetAny.id) {
    values.tag = getLogicText(' or ', values === null || values === void 0 ? void 0 : values[tagValueListsKey]);
  }
  // 格式化数据后返回
  Array.isArray(values === null || values === void 0 ? void 0 : values[tagValueListsKey]) && (values === null || values === void 0 ? void 0 : values[tagValueListsKey].forEach(function (item) {
    if (item.field == configRuleTypes.platform.id) {
      var _item$value;
      var formatValue = item === null || item === void 0 ? void 0 : (_item$value = item.value) === null || _item$value === void 0 ? void 0 : _item$value.join(',');
      item.value = formatValue;
    } else if (item.field == configRuleTypes.currentTime.id) {
      // 无需处理
    } else if (item.field == configRuleTypes.orderReply.id) {
      item.operator = 'is';
      item.value = 'true';
    } else if (item.value) {
      var _formatValue = item.value.replace(/，/g, ',');
      item.value = _formatValue;
    }
  }));
  return values;
};
var getLogicText = function getLogicText(separator, tagValueLists) {
  if (Array.isArray(tagValueLists)) {
    var resultList = [];
    var tagValueLength = tagValueLists.length;
    for (var index = 1; index <= tagValueLength; index++) {
      resultList.push(index);
    }
    return '(' + resultList.join(separator) + ')';
  }
};
// 从km复制来
export var formatToComponentData = function formatToComponentData(tagValueLists, configRuleTypes, manyAnswerChannelTypes) {
  var _tagValueLists;
  // 处理tagValueLists字段，封装到过滤器组件中会有bug，暂时只能放到这里处理好数据给封装的过滤器组件
  // 格式化数据后传递
  tagValueLists = (_tagValueLists = tagValueLists) === null || _tagValueLists === void 0 ? void 0 : _tagValueLists.map(function (item) {
    var tagItem = _objectSpread({}, item);
    if (tagItem.field == configRuleTypes.platform.id && typeof tagItem.value === 'string') {
      var formatValue = tagItem.value;
      var weChatValue = manyAnswerChannelTypes.WEChat.id; // "wechat,微信" 特殊处理一下
      if (formatValue.includes(weChatValue)) {
        formatValue = formatValue.replace(weChatValue, '#####'); // "#####" 临时占位用
      }

      var formatValueList = formatValue.split(',');
      var findIndex = formatValueList.findIndex(function (val) {
        return val === '#####';
      });
      if (findIndex > -1) {
        formatValueList[findIndex] = weChatValue;
      }
      tagItem.value = formatValueList;
    }
    return tagItem;
  });
  return tagValueLists;
};