import React, { useCallback, useEffect, useMemo, useState } from 'react';
import { Input } from 'udesk-ui';
import SearchOutlined from '@ant-design/icons/SearchOutlined';
import useDebounce from 'react-use/esm/useDebounce';
import css from './style.module.scss';
import { useTranslation } from '@udesk-webapp/locale';
import classnames from 'classnames';
var SearchInput = function (_a) {
    var onSearch = _a.onSearch, defaultValue = _a.defaultValue, className = _a.className;
    var _b = useState(''), keyword = _b[0], setKeyword = _b[1];
    var onChange = useCallback(function (e) { return setKeyword(e.target.value); }, []);
    var t = useTranslation().t;
    useEffect(function () {
        setKeyword(defaultValue || '');
    }, [defaultValue]);
    useDebounce(function () {
        onSearch(keyword);
    }, 500, [onSearch, keyword]);
    var suffix = useMemo(function () {
        if (keyword) {
            return null;
        }
        else {
            return React.createElement(SearchOutlined, null);
        }
    }, [keyword]);
    return React.createElement(Input, { value: keyword, onChange: onChange, suffix: suffix, allowClear: true, placeholder: t('label.input_keyword'), className: classnames(className, css['mgb-7']) });
};
export default SearchInput;
