import { __extends } from "tslib";
import React, { Component } from 'react';
var SimpleErrorBoundary = /** @class */ (function (_super) {
    __extends(SimpleErrorBoundary, _super);
    function SimpleErrorBoundary(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            hasError: false
        };
        return _this;
    }
    SimpleErrorBoundary.getDerivedStateFromError = function (error) {
        // 更新 state 使下一次渲染能够显示降级后的 UI
        return { hasError: true };
    };
    SimpleErrorBoundary.prototype.componentDidCatch = function (error, errorInfo) {
        var _a;
        if (process.env.NODE_ENV !== 'development') {
            (_a = window.Sentry) === null || _a === void 0 ? void 0 : _a.captureException(error);
        }
        console.error('error', error);
    };
    SimpleErrorBoundary.prototype.render = function () {
        var t = this.props.t;
        if (this.state.hasError) {
            return React.createElement(React.Fragment, null, this.props.type === 'message' ? t('msgError') : t('simpleError'));
        }
        return this.props.children;
    };
    return SimpleErrorBoundary;
}(Component));
export default (SimpleErrorBoundary);
