var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import { createSlice } from '@reduxjs/toolkit';
import merge from 'lodash-es/merge';
var _a = createSlice({
    name: 'visitor',
    initialState: [],
    reducers: {
        addVisitor: function (state, action) {
            var chat = action.payload;
            var index = state.findIndex(function (item) { return item.key === chat.key; });
            if (index !== -1) {
                return __spreadArray(__spreadArray([chat], state.slice(0, index), true), state.slice(index + 1), true);
            }
            else {
                return __spreadArray([chat], state, true);
            }
        },
        deleteVisitor: function (state, action) {
            var customer = action.payload;
            var index = state.findIndex(function (item) { return item.key === customer.key; });
            if (index !== -1) {
                return __spreadArray(__spreadArray([], state.slice(0, index), true), state.slice(index + 1), true);
            }
            else {
                return state;
            }
        },
        updateVisitor: function (state, action) {
            var customer = action.payload;
            var index = state.findIndex(function (item) { return item.key === customer.key; });
            if (index !== -1) {
                merge(state[index], customer);
                return __spreadArray([], state, true);
            }
            else {
                return state;
            }
        }
    }
}), actions = _a.actions, reducer = _a.reducer;
export var addVisitor = actions.addVisitor, deleteVisitor = actions.deleteVisitor, updateVisitor = actions.updateVisitor;
export default reducer;
