import { AntdInput, AntdTimePicker, AntdRangeTimePicker, AntdDatePicker, AntdRangeDatePicker, AntdCascader } from '@udesk-webapp/custom-filter';
declare function getComponentsConfigTable(): ({
    inputType: string;
    operators: string[];
    component: typeof AntdInput;
    attributes: {
        classNames: string;
        picker?: undefined;
        format?: undefined;
        placeholder?: undefined;
        showTime?: undefined;
        fieldNames?: undefined;
        nameField?: undefined;
        valueField?: undefined;
    };
} | {
    inputType: string;
    operators: string[];
    component: any;
    attributes: {
        classNames?: undefined;
        picker?: undefined;
        format?: undefined;
        placeholder?: undefined;
        showTime?: undefined;
        fieldNames?: undefined;
        nameField?: undefined;
        valueField?: undefined;
    };
} | {
    inputType: string;
    operators: string[];
    component: typeof AntdDatePicker;
    attributes: {
        picker: string;
        format: string;
        classNames?: undefined;
        placeholder?: undefined;
        showTime?: undefined;
        fieldNames?: undefined;
        nameField?: undefined;
        valueField?: undefined;
    };
} | {
    inputType: string;
    operators: string[];
    component: typeof AntdRangeDatePicker;
    attributes: {
        placeholder: string[];
        picker: string;
        format: string;
        classNames?: undefined;
        showTime?: undefined;
        fieldNames?: undefined;
        nameField?: undefined;
        valueField?: undefined;
    };
} | {
    inputType: string;
    operators: string[];
    component: typeof AntdTimePicker;
    attributes: {
        format: string;
        classNames?: undefined;
        picker?: undefined;
        placeholder?: undefined;
        showTime?: undefined;
        fieldNames?: undefined;
        nameField?: undefined;
        valueField?: undefined;
    };
} | {
    inputType: string;
    operators: string[];
    component: typeof AntdRangeTimePicker;
    attributes: {
        format: string;
        classNames?: undefined;
        picker?: undefined;
        placeholder?: undefined;
        showTime?: undefined;
        fieldNames?: undefined;
        nameField?: undefined;
        valueField?: undefined;
    };
} | {
    inputType: string;
    operators: string[];
    component: typeof AntdDatePicker;
    attributes: {
        picker: string;
        format: string;
        showTime: {
            format: string;
        };
        classNames?: undefined;
        placeholder?: undefined;
        fieldNames?: undefined;
        nameField?: undefined;
        valueField?: undefined;
    };
} | {
    inputType: string;
    operators: string[];
    component: typeof AntdRangeDatePicker;
    attributes: {
        placeholder: string[];
        picker: string;
        format: string;
        showTime: {
            format: string;
        };
        classNames?: undefined;
        fieldNames?: undefined;
        nameField?: undefined;
        valueField?: undefined;
    };
} | {
    inputType: string;
    operators: string[];
    component: typeof AntdCascader;
    attributes: {
        fieldNames: {
            label: string;
            value: string;
            children: string;
        };
        classNames?: undefined;
        picker?: undefined;
        format?: undefined;
        placeholder?: undefined;
        showTime?: undefined;
        nameField?: undefined;
        valueField?: undefined;
    };
} | {
    inputType: string;
    operators: string[];
    component: any;
    attributes: {
        nameField: string;
        valueField: string;
        placeholder: string;
        classNames?: undefined;
        picker?: undefined;
        format?: undefined;
        showTime?: undefined;
        fieldNames?: undefined;
    };
})[];
export default getComponentsConfigTable;
