import { TreeMenuProps, TreeNode } from '../types';
/**
 * 用于格式化扁平数据到 treeData 数据类型
 *
 * @param {TreeNode[]} [data=[]] 后端接口返回的扁平化数据
 * @param {(string | number | null)} treeRootParentId 根节点的parentId的值，看接口返回的具体值
 * @param {string} [parentIdPropsName='pid'] 表示节点的parentId的字段名
 * @param {string} [idPropsName='id'] 表示节点的id的字段名
 * @return {*}  {TreeMenuProps['treeData']} TreeMenu组件能接收的treeData值
 */
export default function formatTreeDataFromArrayToTree(data: TreeNode[] | undefined, treeRootParentId: string | number | null, parentIdPropsName?: string, idPropsName?: string): TreeMenuProps['treeData'];
