declare type IdType = string | number;
declare type customFields = {
    [key: string]: any;
};
/**
 * 工单签名目前只关注下面具名字段
 */
interface baseSignatureTicket {
    subject: string;
    content: string;
    status_id: IdType;
    priority_id: IdType;
    tags: string;
    assignee_id: IdType;
    follower_ids: IdType[];
    template_id: IdType;
    customer_id: IdType;
    organization_id: IdType;
    custom_fields: customFields;
    [key: string]: any;
}
export declare type SignatureTicket = Partial<baseSignatureTicket>;
/**
 * im 创建工单所传ticket参数
 */
export declare type SubmitImTicketParams = {
    ticket: {
        im_sub_session_id?: number;
        subject: string;
        content: string;
        customer_id: number;
        agent_group_id: number;
        assignee_id: number;
        status_id: string;
        priority_id: string;
        platform_name: string;
        attachment_ids: number[];
        template_id: number;
        follower_ids: number[];
        custom_fields: {
            [key: string]: any;
        };
    };
    tags: string;
};
export declare type ExamineType = 'create' | 'update' | undefined;
export declare type ModeType = 'needSignature' | 'verifySignatureAndSaveTicket' | undefined;
export interface SignatureConfigParams {
    mode?: ModeType;
    ticket_id?: IdType;
    examine_type?: ExamineType;
    ticket: SignatureTicket;
}
interface BaseTicketSignatureConfigResponse {
    id: IdType;
    name: string;
    category_content: string | string[];
    category_enabled: boolean;
    category_required: boolean;
    description_enabled: boolean;
    description_required: boolean;
    signature_require_user_email: boolean;
}
export declare type TicketSignatureConfigResponse = Partial<BaseTicketSignatureConfigResponse>;
export interface VerifySignature {
    ticket_signature_user?: {
        email?: string;
        password: string;
    };
    ticket_signature_record?: {
        category_names?: string;
        description?: string;
        ticket_signature_id: number;
    };
}
export declare type VerifySignatureAndSaveTicket = VerifySignature & SubmitImTicketParams;
export {};
