import { __assign, __rest, __spreadArray } from "tslib";
import React, { useCallback, useState, useMemo, useRef } from 'react';
import { Button, Col, Modal, Row } from 'udesk-ui';
import { useTranslation } from 'react-i18next';
import UploadBox from '@udesk-webapp/upload-box';
import css from './index.module.less';
import CheckOutlined from '@ant-design/icons/CheckOutlined';
import CloseCircleFilled from '@ant-design/icons/CloseCircleFilled';
function UploadModal(_a) {
    var marking = _a.marking, props = __rest(_a, ["marking"]);
    var uploadRef = useRef();
    // 上传的图片列表
    var _b = useState([]), imageFiles = _b[0], setImageFiles = _b[1];
    var _c = useState([]), selectedImages = _c[0], setSelectedImages = _c[1];
    //多语言配置
    var t = useTranslation().t;
    // 点击插入  筛选出被选择的图片   将选择的图片 插入富文本编辑
    function handleOk() {
        // props.addImg(imgList.filter(item => item.isSelect));
        if (selectedImages) {
            props.addImg(selectedImages === null || selectedImages === void 0 ? void 0 : selectedImages.filter(function (i) { return i.url; }).map(function (i) { return ({ src: i.url, isSelect: true }); }));
            // 插入后清空
            uploadRef.current.deleteAll();
            setSelectedImages([]);
            setImageFiles([]);
        }
    }
    // 点击取消 关闭弹窗
    function handleCancel() {
        props.close();
    }
    // 删除图片
    function deleteImg(e, index) {
        e.stopPropagation();
        var delItem = imageFiles[index];
        setImageFiles(function (v) {
            if (!v) {
                return v;
            }
            var result = __spreadArray([], v, true);
            result.splice(index, 1);
            return result;
        });
        //同时删除antdUpload中的数据，
        imageFiles && uploadRef.current.deleteItem(delItem);
        // 删除select
        setSelectedImages(function (v) {
            if (v === void 0) { v = []; }
            if (v.includes(delItem)) {
                return v.filter(function (i) { return i !== delItem; });
            }
            else {
                return v;
            }
        });
    }
    // 选择图片  显示右下角对勾
    function selectImg(imageFile) {
        setSelectedImages(function (v) {
            if (v === void 0) { v = []; }
            if (v.includes(imageFile)) {
                return v.filter(function (i) { return i !== imageFile; });
            }
            else {
                return __spreadArray(__spreadArray([], v, true), [imageFile], false);
            }
        });
    }
    var onChange = useCallback(function (fileList) {
        setImageFiles(fileList);
        setSelectedImages(fileList);
    }, []);
    // 弹窗页脚
    var footer = useMemo(function () {
        return (React.createElement("div", { className: css['modal-btn'] },
            React.createElement(UploadBox, __assign({ className: css['upload-btn'] }, props, { value: imageFiles, marking: marking || 'web.ts.ticket_reply', onChange: onChange, noAttachment: false, showUploadList: false, accept: 'image/jpeg,image/jpg,image/png', ref: uploadRef }),
                React.createElement(Button, null, t('uploader.uploadImg'))),
            React.createElement(Button, { key: 'back', onClick: handleCancel }, t('cancel')),
            React.createElement(Button, { key: 'submit', type: 'primary', onClick: handleOk }, t('uploader.insertImg'))));
    }, [imageFiles, selectedImages]);
    return (React.createElement("div", null,
        React.createElement(Modal, { visible: props.show, title: t('uploader.uploadImg'), onOk: handleOk, onCancel: handleCancel, footer: footer, width: 600, zIndex: 9999 },
            React.createElement("div", { className: css['modal-content'] },
                React.createElement(Row, { gutter: [16, 24] }, imageFiles === null || imageFiles === void 0 ? void 0 : imageFiles.map(function (item, index) {
                    return (React.createElement(Col, { span: 8, key: item.url },
                        React.createElement("div", { className: css['img-wrapper'], onClick: function () { return selectImg(item); } },
                            React.createElement("img", { src: item.url, alt: item.url }),
                            React.createElement("div", { className: css['delete-icon'], onClick: function (e) { return deleteImg(e, index); } },
                                React.createElement(CloseCircleFilled, null)),
                            (selectedImages === null || selectedImages === void 0 ? void 0 : selectedImages.includes(item)) && (React.createElement("div", { className: css['select-icon'] },
                                React.createElement(CheckOutlined, null))))));
                }))))));
}
export default UploadModal;
