import { useRequest } from "@umijs/hooks";
export default function useValid(options) {
    var onSuccess = options.onSuccess, onError = options.onError, _a = options.customValidPromise, customValidPromise = _a === void 0 ? Promise.resolve() : _a;
    var run = useRequest(customValidPromise, {
        manual: true,
        onSuccess: function (result) {
            if (typeof onSuccess === 'function') {
                onSuccess(result);
            }
        },
        onError: function (error) {
            if (typeof onError === 'function') {
                onError(error);
            }
        }
    }).run;
    function handleValid(options) {
        var value = options.value, isFormItem = options.isFormItem, changeFunction = options.changeFunction;
        if (isFormItem || typeof customValidPromise !== 'function') {
            //如果是表单模式或者不需要校验,直接触发onBlur
            if (typeof changeFunction === 'function') {
                changeFunction(value);
            }
        }
        else if (typeof customValidPromise === 'function') {
            run(value);
        }
    }
    return handleValid;
}
