import { memoize } from 'lodash';
export var loadStyle = memoize(function (href) {
    if (!href) {
        return;
    }
    var head = document.head;
    var link = document.createElement('link');
    link.type = 'text/css';
    link.rel = 'stylesheet';
    link.href = href;
    head.appendChild(link);
});
export var loadScript = memoize(function (src) {
    return new Promise(function (resolve, reject) {
        if (!src) {
            reject(new Error('src is required'));
            return;
        }
        var script = document.createElement('script');
        script.src = src;
        script.async = true;
        script.addEventListener('load', function () {
            resolve(script);
        });
        script.addEventListener('error', function (error) {
            script.remove();
            reject(error);
            loadStyle.cache.delete(src);
        });
        document.body.appendChild(script);
    });
});
