var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
import axios from 'axios';
import Cookies from 'js-cookie';
import merge from 'lodash-es/merge';
import { store } from "../store";
import { isSameOrigin } from '@udesk-webapp/utils';
// axios.defaults.baseURL = 'http://reocar.b3.tryudesk.com/spa1';
// axios.defaults.baseURL = 'http://reocar.ud.com/spa1';
axios.defaults.baseURL = '/spa1';
function ajaxBefore(url, method, params, options) {
    var _a, _b, _c, _d;
    var headers = {};
    // 是否开启了CXRFTOKEN
    var _isSameOrigin = isSameOrigin(url);
    var csrfToken = getCsrfToken();
    console.log('store', store.getState().initData);
    if (_isSameOrigin && csrfToken) {
        headers['X-CSRF-Token'] = csrfToken;
    }
    // 是否使用了SDK
    if (_isSameOrigin && csrfToken) {
        headers['X-CSRF-Token'] = csrfToken;
    }
    //如果启用了灰度，则读取 cookie 里的 tid 和 ifc，并把值加到 header 里
    var tid = Cookies.get('tid');
    var ifc = Cookies.get('ifc');
    var token = (_a = store.getState().initData) === null || _a === void 0 ? void 0 : _a.token;
    var credentials = (_b = store.getState().initData) === null || _b === void 0 ? void 0 : _b.credentials;
    var sdk = (_c = store.getState().initData) === null || _c === void 0 ? void 0 : _c.sdk;
    if (tid) {
        headers['X-Udesk-Tid'] = tid;
    }
    if (ifc) {
        headers['X-Udesk-Ifc'] = ifc;
    }
    if (sdk && token) {
        headers['Authorization'] = "Bearer ".concat(token);
        axios.defaults.baseURL = (_d = store.getState().initData) === null || _d === void 0 ? void 0 : _d.spa1Path;
    }
    if (!credentials) {
        axios.defaults.withCredentials = false;
    }
    var setHeaderOptions = merge({ headers: headers }, __assign({}, options));
    var requestPptions = __assign({ url: url, method: method, data: params }, setHeaderOptions);
    if (method.toUpperCase() === 'GET') {
        requestPptions.params = params;
    }
    return axios(requestPptions).then(function (res) {
        var _a;
        var code = (_a = res === null || res === void 0 ? void 0 : res.data) === null || _a === void 0 ? void 0 : _a.code;
        if (code === 1000 || code === '1000') {
            return res.data;
        }
        else {
            if (res.status >= 200 && res.status < 300) {
                return res.data;
            }
            else {
                return Promise.reject(res.data);
            }
        }
    });
}
export function request(options) {
    var url = options.url, method = options.method, data = options.data, _options = __rest(options, ["url", "method", "data"]);
    return ajaxBefore(url, method, data, _options);
}
export function getJSON(url, params, options) {
    var _url = url;
    // if (!isEmpty(params)) {
    //     _url += ('?' + Qs.stringify(params))
    // }
    return ajaxBefore(_url, 'GET', params, options);
}
export function postJSON(url, params, options) {
    return ajaxBefore(url, 'post', params, options);
}
export function post(url, params, options) {
    var searchParams = new URLSearchParams();
    for (var i in params) {
        if (Object.prototype.hasOwnProperty.call(params, i) && params[i] !== undefined) {
            searchParams.append(i, params[i]);
        }
    }
    return ajaxBefore(url, 'post', searchParams, options);
}
export function putJSON(url, params, options) {
    return ajaxBefore(url, 'put', params, options);
}
export function deleteJSON(url, params, options) {
    return ajaxBefore(url, 'delete', params, options);
}
export function getCsrfToken() {
    var UDD = window.UDD || {};
    var user = UDD.user || {};
    if (user.csrf_token) {
        return user.csrf_token;
    }
}
