interface ISuccessCallback {
    (resp: any): void;
}
export interface ICustomerOptions {
    url?: string;
    errMsg?: string;
    params?: ObjectWithIndex;
    options?: ObjectWithIndex;
    success?: ISuccessCallback;
}
declare function postUser(options?: ICustomerOptions): Promise<any>;
declare function getMonitorUserList(): Promise<any>;
/**
 * 检查电话号和邮箱是否已经被使用
 * @param {number} customerId - 客户 id
 * @param {string} cellphone - 被检验的电话号码
 * @param {string} email - 被检验的邮箱
 */
export declare function checkDuplicate(customerId: number, { cellphone, email }: {
    cellphone?: string;
    email?: string;
}): Promise<{
    code: number;
    duplications: Record<"cellphone" | "email", {
        name: string;
        id: number;
    }>;
}>;
/**
 * 修改客户
 * @param customer
 */
export declare function putCustomer(customer: {
    id: Customer["id"];
} & Partial<Customer>): Promise<any>;
declare const _default: {
    postUser: typeof postUser;
    getMonitorUserList: typeof getMonitorUserList;
};
export default _default;
