var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import apis from "../../common/config/apis";
import { csApiGetJson, postJson } from "./common";
import { getJSON, } from "../../utils";
import { csApiPutJSON } from "../../utils/csApi";
import qs from "qs";
function postUser(options) {
    return postJson((options === null || options === void 0 ? void 0 : options.url) || apis.postUser, options || {});
}
function getMonitorUserList() {
    return csApiGetJson(apis.getMonitorUserList);
}
/**
 * 检查电话号和邮箱是否已经被使用
 * @param {number} customerId - 客户 id
 * @param {string} cellphone - 被检验的电话号码
 * @param {string} email - 被检验的邮箱
 */
export function checkDuplicate(customerId, _a) {
    var _b;
    var cellphone = _a.cellphone, email = _a.email;
    return __awaiter(this, void 0, void 0, function () {
        var resp, url, params;
        return __generator(this, function (_c) {
            switch (_c.label) {
                case 0:
                    if (!customerId) {
                        throw new Error("customerId is required");
                    }
                    if (!cellphone && !email) {
                        throw new Error("cellphone or email is required");
                    }
                    url = "/customers/check_duplication";
                    if (cellphone) {
                        params = { customer: { id: customerId, cellphone: cellphone } };
                    }
                    else if (email) {
                        params = { customer: { id: customerId, email: email } };
                    }
                    return [4 /*yield*/, getJSON(url, params, {
                            paramsSerializer: function (params) {
                                return qs.stringify(params, { arrayFormat: "brackets" });
                            },
                        })];
                case 1:
                    resp = _c.sent();
                    if (resp.code !== 1000) {
                        throw new Error((_b = resp === null || resp === void 0 ? void 0 : resp.exception) === null || _b === void 0 ? void 0 : _b.message);
                    }
                    return [2 /*return*/, resp];
            }
        });
    });
}
/**
 * 修改客户
 * @param customer
 */
export function putCustomer(customer) {
    var _a;
    return __awaiter(this, void 0, void 0, function () {
        var resp;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    if (!customer.id) {
                        throw new Error("customer.id is required");
                    }
                    return [4 /*yield*/, csApiPutJSON("/cs/ts/api/customers/".concat(customer.id), { customer: customer }).then(function (res) { return res.data; })];
                case 1:
                    resp = _b.sent();
                    if (resp.code === 1000) {
                        return [2 /*return*/, resp];
                    }
                    throw new Error((_a = resp === null || resp === void 0 ? void 0 : resp.exception) === null || _a === void 0 ? void 0 : _a.message);
            }
        });
    });
}
export default {
    postUser: postUser,
    getMonitorUserList: getMonitorUserList,
};
