import { csApiAxiosInstance, isSameOrigin } from '@udesk-webapp/utils';
import { getCsrfToken } from "./ajax";
import merge from 'lodash-es/merge';
csApiAxiosInstance.interceptors.request.use(function (config) {
    var _isSameOrigin = config.url ? isSameOrigin(config.url) : false;
    var headers = {};
    var csrfToken = getCsrfToken();
    if (_isSameOrigin && csrfToken) {
        headers['X-CSRF-Token'] = csrfToken;
    }
    return merge({ headers: headers }, config);
});
export { csApiRequest, csApiGetJSON, csApiPostJSON, csApiPutJSON, csApiDeleteJSON, } from '@udesk-webapp/utils';
