/**
 * 将自定字段的值转换为文字，例如多选字段'1,2'转换为'选项1,选项2'
 * @param {CustomField} field - 自定义字段
 * @param {string|string[]} value - 值
 */
export declare function customFieldValueToText(field: CustomField, value?: string | string[]): string | number | undefined;
/**
 * 计算字段脱敏后的结果
 * @example
 * sensitiveField({
 *     sensitive_mark_placeholder: '*',
 *     sensitive_mark_position: 3,
 *     sensitive_mark_size: 4,
 *     sensitive_mode: 2
 * })('18811112222');
 * // 结果：188****2222
 */
export declare const sensitiveField: ({ name, sensitive_mark_placeholder, sensitive_mark_position, sensitive_mark_size, sensitive_mode, }: {
    name?: string | undefined;
    sensitive_mark_placeholder?: string | undefined;
    sensitive_mark_position?: number | undefined;
    sensitive_mark_size?: number | undefined;
    sensitive_mode?: 0 | 1 | 2 | undefined;
}) => (v?: string) => string | undefined;
