var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import EventEmitter from "eventemitter3";
var Eventable = /** @class */ (function () {
    function Eventable() {
        this.eventEmitter = new EventEmitter();
    }
    Eventable.prototype.on = function (event, fn, context) {
        this.eventEmitter.on(event, fn, context !== null && context !== void 0 ? context : this);
    };
    Eventable.prototype.once = function (event, fn, context) {
        this.eventEmitter.once(event, fn, context !== null && context !== void 0 ? context : this);
    };
    Eventable.prototype.off = function (event, fn, context, once) {
        this.eventEmitter.off(event, fn, context !== null && context !== void 0 ? context : this, once);
    };
    Eventable.prototype.removeAllListeners = function (event) {
        this.eventEmitter.removeAllListeners(event);
    };
    Eventable.prototype.fire = function (event) {
        var _a;
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        (_a = this.eventEmitter).emit.apply(_a, __spreadArray([event], args, false));
    };
    return Eventable;
}());
export { Eventable };
