function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t.return && (u = t.return(), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useState } from 'react';
export default function useStorage(cacheId) {
  var cacheMode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'session';
  var _useState = useState(new StorageManager(cacheMode, cacheId)),
    _useState2 = _slicedToArray(_useState, 1),
    storage = _useState2[0];
  return storage;
}
export var StorageManager = /*#__PURE__*/function () {
  function StorageManager(cacheMode, cacheId) {
    _classCallCheck(this, StorageManager);
    this.cacheMode = void 0;
    this.cacheId = void 0;
    this.storage = void 0;
    this.cacheMode = cacheMode;
    this.cacheId = cacheId;
    this.storage = sessionStorage;
    if (cacheMode === 'local') {
      this.storage = localStorage;
    }
  }
  _createClass(StorageManager, [{
    key: "save",
    value: function save(value) {
      if (!this.cacheId) return;
      try {
        this.storage.setItem(this.cacheId, JSON.stringify(value));
      } catch (e) {
        console.log('save failed :: ', e);
      }
    }
  }, {
    key: "read",
    value: function read() {
      if (!this.cacheId) return;
      try {
        var value = this.storage.getItem(this.cacheId);
        return value ? JSON.parse(value) : value;
      } catch (e) {
        console.log('read failed :: ', e);
      }
    }
  }, {
    key: "delete",
    value: function _delete() {
      if (!this.cacheId) return;
      try {
        this.storage.removeItem(this.cacheId);
      } catch (e) {
        console.log('delete failed :: ', e);
      }
    }
  }]);
  return StorageManager;
}();