function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }
function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }
function _iterableToArrayLimit(arr, i) { var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"]; if (null != _i) { var _s, _e, _x, _r, _arr = [], _n = !0, _d = !1; try { if (_x = (_i = _i.call(arr)).next, 0 === i) { if (Object(_i) !== _i) return; _n = !1; } else for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) { ; } } catch (err) { _d = !0, _e = err; } finally { try { if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) return; } finally { if (_d) throw _e; } } return _arr; } }
function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }
import { useState } from 'react';
export default function useStorage(cacheId) {
  var cacheMode = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'session';
  var _useState = useState(new StorageManager(cacheMode, cacheId)),
    _useState2 = _slicedToArray(_useState, 1),
    storage = _useState2[0];
  return storage;
}
export var StorageManager = /*#__PURE__*/function () {
  function StorageManager(cacheMode, cacheId) {
    _classCallCheck(this, StorageManager);
    this.cacheMode = void 0;
    this.cacheId = void 0;
    this.storage = void 0;
    this.cacheMode = cacheMode;
    this.cacheId = cacheId;
    this.storage = sessionStorage;
    if (cacheMode === 'local') {
      this.storage = localStorage;
    }
  }
  _createClass(StorageManager, [{
    key: "save",
    value: function save(value) {
      if (!this.cacheId) return;
      try {
        this.storage.setItem(this.cacheId, JSON.stringify(value));
      } catch (e) {
        console.log('save failed :: ', e);
      }
    }
  }, {
    key: "read",
    value: function read() {
      if (!this.cacheId) return;
      try {
        var value = this.storage.getItem(this.cacheId);
        return value ? JSON.parse(value) : value;
      } catch (e) {
        console.log('read failed :: ', e);
      }
    }
  }, {
    key: "delete",
    value: function _delete() {
      if (!this.cacheId) return;
      try {
        this.storage.removeItem(this.cacheId);
      } catch (e) {
        console.log('delete failed :: ', e);
      }
    }
  }]);
  return StorageManager;
}();