import { __awaiter, __generator } from "tslib";
import moment from 'moment';
import { YYYY_MM_DD_HH_MM_SS, YYYY_MM_DD } from './global-const';
import { customFieldValueToText, sensitiveField } from './custom-field';
// import { RootState } from '@Src/store/root-reducer'; // 传进来
import { Ability } from '../common';
import { getJSON } from './index';
// customerFieldAbilities替换传进来的数据
export function replacePlaceholder(content, _a) {
    var _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y, _z, _0, _1, _2, _3, _4, _5, _6, _7, _8, _9, _10, _11, _12, _13, _14, _15, _16, _17;
    var customer = _a.customer, organizations = _a.organizations, agent = _a.agent, ticket = _a.ticket, customerCustomFields = _a.customerCustomFields, ticketCustomFields = _a.ticketCustomFields, t = _a.t, customerFieldAbilities = _a.customerFieldAbilities;
    return __awaiter(this, void 0, void 0, function () {
        var ticketReplies, repliesCustomers, repliesAgents, repliesInternal, repliesExternal;
        return __generator(this, function (_18) {
            switch (_18.label) {
                case 0:
                    ticketReplies = [];
                    if (!(hasRepliesContent(content) && (ticket === null || ticket === void 0 ? void 0 : ticket.id))) return [3 /*break*/, 2];
                    return [4 /*yield*/, getTicketReplies(ticket.id)];
                case 1:
                    ticketReplies = _18.sent();
                    _18.label = 2;
                case 2:
                    repliesCustomers = getRepliesWithType(ticketReplies, 'customer');
                    repliesAgents = getRepliesWithType(ticketReplies, 'agent');
                    repliesInternal = getNotesRepliesWithType(ticketReplies, 'internal');
                    repliesExternal = getNotesRepliesWithType(ticketReplies, 'external');
                    content = content.replace('{{agent.name}}', (_b = agent === null || agent === void 0 ? void 0 : agent.nick_name) !== null && _b !== void 0 ? _b : ''); // 当前客服姓名
                    content = content.replace('{{agent.nick_name}}', (_c = agent === null || agent === void 0 ? void 0 : agent.aliase) !== null && _c !== void 0 ? _c : ''); // 当前客服昵称
                    content = content.replace('{{ticket.field_num}}', (_d = ticket === null || ticket === void 0 ? void 0 : ticket.field_num) !== null && _d !== void 0 ? _d : ''); // 工单编号
                    content = content.replace('{{ticket.id}}', "".concat((_e = ticket === null || ticket === void 0 ? void 0 : ticket.id) !== null && _e !== void 0 ? _e : '')); // 工单id
                    content = content.replace('{{ticket.user}}', (_f = ticket === null || ticket === void 0 ? void 0 : ticket.customer_name) !== null && _f !== void 0 ? _f : ''); // 客户
                    content = content.replace('{{ticket.created_at}}', (ticket === null || ticket === void 0 ? void 0 : ticket.created_at) ? moment(ticket.created_at).format(YYYY_MM_DD_HH_MM_SS) : ''); // 创建时间
                    content = content.replace('{{ticket.subject}}', (_g = ticket === null || ticket === void 0 ? void 0 : ticket.subject) !== null && _g !== void 0 ? _g : ''); // 主题
                    content = content.replace('{{ticket.content}}', (_h = ticket === null || ticket === void 0 ? void 0 : ticket.content) !== null && _h !== void 0 ? _h : ''); // 描述
                    content = content.replace('{{ticket.priority}}', (_j = ticket === null || ticket === void 0 ? void 0 : ticket.priority) !== null && _j !== void 0 ? _j : ''); // 优先级
                    content = content.replace('{{ticket.status}}', (_k = ticket === null || ticket === void 0 ? void 0 : ticket.status) !== null && _k !== void 0 ? _k : ''); // 状态
                    content = content.replace('{{ticket.platform}}', (ticket === null || ticket === void 0 ? void 0 : ticket.platform_name) ? t(ticket.platform_name) : ''); // 渠道
                    content = content.replace('{{ticket.tags}}', (ticket === null || ticket === void 0 ? void 0 : ticket.all_tags)
                        ? ticket.all_tags
                        : (ticket === null || ticket === void 0 ? void 0 : ticket.tags)
                            ? ticket.tags.map(function (i) { return i.name; }).join(',')
                            : ''); // 标签
                    content = content.replace('{{ticket.assignee}}', (_l = ticket === null || ticket === void 0 ? void 0 : ticket.assignee_name) !== null && _l !== void 0 ? _l : ''); // 受理客服
                    content = content.replace('{{ticket.user_group}}', (_m = ticket === null || ticket === void 0 ? void 0 : ticket.agent_group_name) !== null && _m !== void 0 ? _m : ''); // 受理客服组
                    content = content.replace('{{ticket.followers}}', (ticket === null || ticket === void 0 ? void 0 : ticket.followers) ? ticket.followers.map(function (i) { return i.nick_name; }).join(',') : ''); // 工单关注人
                    content = content.replace('{{ticket.web_url}}', (_o = ticket === null || ticket === void 0 ? void 0 : ticket.web_url) !== null && _o !== void 0 ? _o : ''); // 工单链接
                    content = content.replace('{{ticket.solved_deadline}}', (ticket === null || ticket === void 0 ? void 0 : ticket.solved_deadline) ? moment(ticket.solved_deadline).format(YYYY_MM_DD) : ''); // 到期时间
                    content = content.replace('{{ticket.replier}}', (_s = (_r = (_q = (_p = ticketReplies[0]) === null || _p === void 0 ? void 0 : _p.data) === null || _q === void 0 ? void 0 : _q.author) === null || _r === void 0 ? void 0 : _r.nick_name) !== null && _s !== void 0 ? _s : ''); // 最后回复人
                    content = content.replace('{{ticket.replied_at}}', ((_u = (_t = ticketReplies[0]) === null || _t === void 0 ? void 0 : _t.data) === null || _u === void 0 ? void 0 : _u.created_at) ? moment(ticketReplies[0].data.created_at).format(YYYY_MM_DD_HH_MM_SS) : ''); // 最后回复时间
                    content = content.replace('{{ticket.latest_comment_formatted}}', (_x = (_w = (_v = ticketReplies[0]) === null || _v === void 0 ? void 0 : _v.data) === null || _w === void 0 ? void 0 : _w.content) !== null && _x !== void 0 ? _x : ''); // 最新回复
                    content = content.replace('{{ticket.customer_replied_at}}', ((_z = (_y = repliesCustomers[0]) === null || _y === void 0 ? void 0 : _y.data) === null || _z === void 0 ? void 0 : _z.created_at) ? moment(repliesCustomers[0].data.created_at).format(YYYY_MM_DD_HH_MM_SS) : ''); // 客户最后回复时间
                    content = content.replace('{{ticket.latest_public_comment_at}}', ((_1 = (_0 = repliesExternal[0]) === null || _0 === void 0 ? void 0 : _0.data) === null || _1 === void 0 ? void 0 : _1.created_at) ? moment(repliesExternal[0].data.created_at).format(YYYY_MM_DD_HH_MM_SS) : ''); // 最新公开回复时间
                    content = content.replace('{{ticket.latest_internal_comment}}', (_4 = (_3 = (_2 = repliesInternal[0]) === null || _2 === void 0 ? void 0 : _2.data) === null || _3 === void 0 ? void 0 : _3.content) !== null && _4 !== void 0 ? _4 : ''); // 最新内部备注
                    content = content.replace('{{ticket.latest_public_comment_formatted}}', (_7 = (_6 = (_5 = repliesExternal[0]) === null || _5 === void 0 ? void 0 : _5.data) === null || _6 === void 0 ? void 0 : _6.content) !== null && _7 !== void 0 ? _7 : ''); // 最新公开回复
                    content = content.replace('{{ticket.agent_replied_at}}', ((_9 = (_8 = repliesAgents[0]) === null || _8 === void 0 ? void 0 : _8.data) === null || _9 === void 0 ? void 0 : _9.created_at) ? moment(repliesAgents[0].data.created_at).format(YYYY_MM_DD_HH_MM_SS) : ''); // 客服最后回复时间
                    content = content.replace('{{customer.nick_name}}', (((_10 = customerFieldAbilities === null || customerFieldAbilities === void 0 ? void 0 : customerFieldAbilities['nick_name']) === null || _10 === void 0 ? void 0 : _10['show']) === Ability.sensitive
                        ? sensitiveField((_11 = customerCustomFields === null || customerCustomFields === void 0 ? void 0 : customerCustomFields.find(function (i) { return i.name === 'name'; })) !== null && _11 !== void 0 ? _11 : {})(customer === null || customer === void 0 ? void 0 : customer.nick_name)
                        : customer === null || customer === void 0 ? void 0 : customer.nick_name) || ''); // 姓名
                    content = content.replace('{{customer.email}}', (((_12 = customerFieldAbilities === null || customerFieldAbilities === void 0 ? void 0 : customerFieldAbilities['email']) === null || _12 === void 0 ? void 0 : _12['show']) === Ability.sensitive
                        ? sensitiveField((_13 = customerCustomFields === null || customerCustomFields === void 0 ? void 0 : customerCustomFields.find(function (i) { return i.name === 'email'; })) !== null && _13 !== void 0 ? _13 : {})(customer === null || customer === void 0 ? void 0 : customer.email)
                        : customer === null || customer === void 0 ? void 0 : customer.email) || ''); // 邮箱
                    content = content.replace('{{customer.cellphone}}', ((_14 = customer === null || customer === void 0 ? void 0 : customer.cellphones) === null || _14 === void 0 ? void 0 : _14.map(function (i) {
                        var _a, _b;
                        return ((_a = customerFieldAbilities === null || customerFieldAbilities === void 0 ? void 0 : customerFieldAbilities['cellphone']) === null || _a === void 0 ? void 0 : _a['show']) === Ability.sensitive
                            ? sensitiveField((_b = customerCustomFields === null || customerCustomFields === void 0 ? void 0 : customerCustomFields.find(function (i) { return i.name === 'cellphone'; })) !== null && _b !== void 0 ? _b : {})(i.content)
                            : i.content;
                    }).join(',')) || ''); // 手机号
                    content = content.replace('{{customer.description}}', (_15 = customer === null || customer === void 0 ? void 0 : customer.description) !== null && _15 !== void 0 ? _15 : ''); // 描述
                    content = content.replace('{{customer.owner}}', (_16 = customer === null || customer === void 0 ? void 0 : customer.owner_name) !== null && _16 !== void 0 ? _16 : ''); // 负责人
                    content = content.replace('{{customer.owner_group}}', (_17 = customer === null || customer === void 0 ? void 0 : customer.owner_group_name) !== null && _17 !== void 0 ? _17 : ''); // 负责组
                    content = content.replace('{{customer.organization}}', organizations ? organizations === null || organizations === void 0 ? void 0 : organizations.map(function (i) { return i.name; }).join(',') : (customer === null || customer === void 0 ? void 0 : customer.organizations) ? customer.organizations.map(function (i) { return i.name; }).join(',') : ''); // 公司
                    ticketCustomFields === null || ticketCustomFields === void 0 ? void 0 : ticketCustomFields.forEach(function (i) {
                        var _a;
                        content = content.replace("{{ticket.".concat(i.name, "}}"), customFieldValueToText(i, (_a = ticket === null || ticket === void 0 ? void 0 : ticket.custom_fields) === null || _a === void 0 ? void 0 : _a[i.name]) + '');
                    });
                    customerCustomFields === null || customerCustomFields === void 0 ? void 0 : customerCustomFields.forEach(function (i) {
                        var _a;
                        content = content.replace("{{customer.".concat(i.name, "}}"), customFieldValueToText(i, (_a = customer === null || customer === void 0 ? void 0 : customer.custom_fields) === null || _a === void 0 ? void 0 : _a[i.name]) + '');
                    });
                    return [2 /*return*/, content];
            }
        });
    });
}
/**
 * @description: 获取工单回复记录
 * @param {*} id
 * @return {*} promise
 */
function getTicketReplies(id) {
    var _this = this;
    return new Promise(function (resolve) { return __awaiter(_this, void 0, void 0, function () {
        var _a, code, items;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0: return [4 /*yield*/, getJSON("/ts/api/tickets/".concat(id, "/replies"), '', {
                        baseURL: '/cs'
                    })];
                case 1:
                    _a = _b.sent(), code = _a.code, items = _a.items;
                    resolve(code === 1000 ? items : []);
                    return [2 /*return*/];
            }
        });
    }); });
}
/**
 * @description: 常用语是否包含回复相关的内容   有需要获取最新的回复记录
 * @param {*} content
 * @return {*} boolean
 */
function hasRepliesContent(content) {
    var reg = /ticket\.replier|ticket\.replied_at|ticket\.latest_comment_formatted|ticket\.customer_replied_at|ticket\.latest_public_comment_at|ticket\.latest_internal_comment|ticket\.latest_public_comment_formatted|ticket\.agent_replied_at/;
    return reg.test(content);
}
/**
 * @description: 获取特定类型(agent|customer)的回复
 * @param {*} Replies: RepliesItemType[]
 * @param {*} type:string
 * @return {*} RepliesItemType[]
 */
function getRepliesWithType(replies, type) {
    if (replies.length) {
        return replies.filter(function (item) {
            var _a, _b;
            return ((_b = (_a = item.data) === null || _a === void 0 ? void 0 : _a.author) === null || _b === void 0 ? void 0 : _b.user_type) === type;
        }) || [];
    }
    return [];
}
/**
 * @description: 获取特定类型（内部备注|外部备注）的回复
 * @param {*} Replies: RepliesItemType[]
 * @param {*} type:string
 * @return {*} RepliesItemType[]
 */
function getNotesRepliesWithType(replies, type) {
    if (replies.length) {
        return replies.filter(function (item) {
            var _a;
            return item.type === 'reply' && ((_a = item.data) === null || _a === void 0 ? void 0 : _a.function_type) === type;
        }) || [];
    }
    return [];
}
