import { DATETIME_FORMAT, DATETIME_FORMAT_BIAS, SHORT_DATE_FORMAT, YYYY_MM_DD } from './global-const';
import moment from 'moment';
export function formatNowDay(date, format, alwaysTime) {
    if (format === void 0) { format = DATETIME_FORMAT_BIAS; }
    if (!date) {
        return '';
    }
    if (!moment(date).isSame(moment(), 'day') && !alwaysTime) {
        return moment(date).format(SHORT_DATE_FORMAT);
    }
    return moment(date).format(format);
}
export function dateFormat(date, format) {
    if (format === void 0) { format = DATETIME_FORMAT; }
    return moment(date).format(format);
}
export function getStartDate(day) {
    if (day === void 0) { day = 6; }
    return moment().subtract(day, 'days').format(YYYY_MM_DD);
}
export function getEndDate() {
    return moment().endOf('day').format(YYYY_MM_DD);
}
export function timeDurationFormat(time) {
    var duration = moment.duration(time, 'seconds');
    var hours = duration.hours() || 0;
    var minutes = duration.minutes() || 0;
    var seconds = duration.seconds() || 0;
    if (hours < 10) {
        hours = '0' + hours;
    }
    if (minutes < 10) {
        minutes = '0' + minutes;
    }
    if (seconds < 10) {
        seconds = '0' + seconds;
    }
    return hours + ':' + minutes + ':' + seconds;
}
