module.exports = {
    "plugins": [
        '@babel',
        'jsx-control-statements'
    ],
    "extends": [
        "react-app", "plugin:jsx-control-statements/recommended"
    ],
    ignorePatterns: ['es', 'lib', 'dist', 'stories.tsx', '*.stories.tsx'],
    overrides: [{
        files: ['**/*.js?(x)'],
        parser: '@babel/eslint-parser'
    }],
    rules: {
        eqeqeq: ['error', 'smart'],
        'no-dupe-keys': 'error',
        'quotes': ['error', 'single'],
        'semi': ['off'],
        'linebreak-style': ['error', 'unix'],
        'array-callback-return': 'error',
        'no-unused-expressions': ['off'],
        'import/no-cycle': ['error'],
        'import/no-extraneous-dependencies': ['error'],
        'jsx-a11y/scope': ['off'],
        'jsx-a11y/role-supports-aria-props': ['off'],
        'jsx-a11y/role-has-required-aria-props': ['off'],
        'jsx-a11y/no-redundant-roles': ['off'],
        'jsx-a11y/no-distracting-elements': ['error'],
        'jsx-a11y/img-redundant-alt': ['off'],
        'flowtype/use-flow-type': ['off'],
        'flowtype/require-valid-file-annotation': ['off'],
        'flowtype/define-flow-type': ['off'],
        "@babel/new-cap": "off",
        "@babel/no-invalid-this": "error",
        "@babel/object-curly-spacing": "off", // 花括号内部空格检查
        "@babel/semi": "error",
        '@babel/no-unused-expressions': ['error', {
            allowShortCircuit: true,
            allowTernary: true,
            allowTaggedTemplates: true
        }],

        "jsx-control-statements/jsx-choose-not-empty": 0,
        "jsx-control-statements/jsx-for-require-each": 0,
        "jsx-control-statements/jsx-for-require-of": 0,
        "jsx-control-statements/jsx-if-require-condition": 0,
        "jsx-control-statements/jsx-otherwise-once-last": 0,
        "jsx-control-statements/jsx-use-if-tag": 0,
        "jsx-control-statements/jsx-when-require-condition": 0,
        "jsx-control-statements/jsx-jcs-no-undef": 0,
        "no-plusplus": ['error', {"allowForLoopAfterthoughts": true}],
        "no-restricted-imports": ["error", "udesk-ui/es", "udesk-ui/lib", "@ant-design/icons/lib/icons"]
    }
};
