const fs = require("fs");
const path = require("path");

module.exports = (api) => {
    const exportsFile = "entry-code.ts";
    const localExportsFile = "entry-code.local.ts";

    let entryCodePath = exportsFile;
    if (
        api?.env === "development" &&
        fs.existsSync(path.resolve(api.paths.absSrcPath, localExportsFile))
    ) {
        entryCodePath = localExportsFile;
    }
    api.addTmpGenerateWatcherPaths(() => [path.resolve(api.paths.absSrcPath, entryCodePath)]);
    api.addEntryCode(() => {
        return fs.readFileSync(path.resolve(api.paths.absSrcPath, entryCodePath), {
            encoding: "utf-8",
        });
    });
};
