module.exports = function(api) {
    api.onBuildComplete(({err, stats}) => {
        if (!stats) {
            return;
        }
        let outPath = '';
        switch(api.pkg.name){
            case 'udesk-webapp-react':
                outPath = '/webapp';
                break;
            case 'udesk-webapp-cc':
                outPath = '/cc';
                break;
        }
        if (!outPath) {
            return;
        }
        let result = `\n//请将以下代码复制到 webapp 项目的 config/sdk.js 中的 ${api.pkg.name} 部分\n`;

        const statsJson = stats.toJson({
            modules: false,
            chunkGroups: false,
            chunks: false,
            chunkOrigins: false,
            entrypoints: false
        });

        const assetsByChunkName = statsJson.assetsByChunkName;
        for (const chunkName in assetsByChunkName) {
            let chunkAssets = assetsByChunkName[chunkName];
            if (Array.isArray(chunkAssets)) {
                chunkAssets = chunkAssets.filter(i => i.endsWith('.js') || i.endsWith('.css'));
            } else {
                chunkAssets = [chunkAssets];
            }
            chunkAssets.forEach(i => {
                let dir = i.substring(0, i.lastIndexOf('/'));
                let ext = i.substring(i.lastIndexOf('.'));
                result += `\n'${outPath}${dir ? ('/' + dir) : ''}/${chunkName}${ext}':'${outPath}/${i}',`;
            });
        }
        result += '\n\n';

        api.logger.info(result);
    });
}
