/// <reference types="react" />
import { ITicket, IAgent } from '@udesk-webapp/utils';
interface columnsTypes {
    title?: string;
    id?: string;
    dataIndex?: string;
    fieldMode?: string;
    key?: string;
    width?: string;
    sorter?: boolean;
    render?: Function;
    ellipsis?: string;
}
interface customizeListsTypes {
    name: string;
    title: string;
    id: string;
}
interface onRowTypes {
    (record: ITicket): {
        onClick: () => {};
        onDoubleClick: () => {};
        onContextMenu: () => {};
        onMouseEnter: () => {};
        onMouseLeave: () => {};
    };
}
interface AssociatedTicketFormTypes {
    lists: Array<ITicket>;
    columns: Array<columnsTypes>;
    customizeLists: Array<customizeListsTypes>;
    scroll: Object;
    onRow: onRowTypes;
    rowSelection: Object;
    onChange: Function;
    selectionType: 'checkbox' | 'radio';
    pagination: object;
    isSensitiveField: boolean;
    ticketSystemFields: any;
    agents: IAgent[];
    agentsWithAdmin: IAgent[];
}
declare const associatedTicketForm: (props: AssociatedTicketFormTypes) => JSX.Element;
export default associatedTicketForm;
