const { 
    switchFolder,
    checkoutToBranch
} = require("udesk-web-toolkits/lib/build/index");
const fs = require('fs');
const path = require('path');
const LINKED_PACKAGE_PREFIX = "link:";

function checkoutToMasterBranch() { 
    let linkedPackages = [];
    let projectName = null;
    let projectFolderPath = fs.realpathSync(process.cwd());
    let packageFile = path.join(fs.realpathSync(process.cwd()), "package.json");
    if (fs.existsSync(packageFile)) {
        let projectPackage = require(packageFile);
        projectName = packageFile.name;
        let dependKeys = Object.keys(projectPackage.dependencies).concat(Object.keys(projectPackage.devDependencies));
        for (let i = 0; i < dependKeys.length; i++) {
            let key = dependKeys[i];
            let value = projectPackage.dependencies[key] || projectPackage.devDependencies[key];
            if (typeof value === "string" && value.startsWith(LINKED_PACKAGE_PREFIX)) {
                linkedPackages.push({
                    key: key,
                    path: path.join(fs.realpathSync(process.cwd()), value.slice(LINKED_PACKAGE_PREFIX.length))
                });
            }
        }
    }
    if (linkedPackages.length > 0) {
        for (let i = 0; i < linkedPackages.length; i++) {
            const linkedPackage = linkedPackages[i];
            if (linkedPackage.path != null && linkedPackage.path !== "") {
                switchFolder(linkedPackage.path);
                checkoutToBranch("master", linkedPackage.key);
            }
        }
    }
    switchFolder(projectFolderPath);
    checkoutToBranch("master", projectName || "");
}

module.exports = {
    checkoutToMasterBranch
};