import { __assign, __rest } from "tslib";
import React, { useCallback, useEffect, useState } from 'react';
import { Cascader } from 'udesk-ui';
import CopyComponent from '@udesk-webapp/copy-content';
import { createCascadeOptionsByValue, getOptionByValue } from '../util';
/**
 * 级联组件
 * @param props
 */
var NewCascader = React.memo(function (props) {
    var switchFlag = props.switchFlag, options = props.options, optionsMeta = props.optionsMeta, onChange = props.onChange, valueProps = props.value, fullSelect = props.fullSelect, restProps = __rest(props, ["switchFlag", "options", "optionsMeta", "onChange", "value", "fullSelect"]);
    var _a = useState(), value = _a[0], setValue = _a[1];
    var _b = useState(options), currentOptions = _b[0], setCurrentOptions = _b[1];
    useEffect(function () {
        if ((valueProps && typeof valueProps === 'string') || (Array.isArray(valueProps) && valueProps.length)) {
            var valueOption = getOptionByValue(valueProps, options);
        }
        if (Array.isArray(optionsMeta) && optionsMeta.length) {
            setCurrentOptions(createCascadeOptionsByValue(valueProps, optionsMeta));
        }
    }, [options, optionsMeta, valueProps]);
    useEffect(function () {
        setValue(function () {
            if (valueProps && typeof valueProps === 'string') {
                return valueProps.split(',');
            }
            return valueProps;
        });
    }, [valueProps]);
    var handleChange = useCallback(function (_value, _option) {
        var newValue = _value || [];
        setValue(newValue);
        onChange === null || onChange === void 0 ? void 0 : onChange(newValue.length ? newValue : '');
    }, [onChange]);
    var formatValue = useCallback(function (value) {
        var data = (value || []).reduce(function (initValues, currentValue, index) {
            var _options;
            if (!index) {
                _options = currentOptions;
            }
            else {
                _options = (initValues[index - 1] || {}).options || [];
            }
            var keyOption = _options.find(function (option) {
                return currentValue === option.value;
            }) || {};
            initValues.push({
                key: keyOption.label,
                options: keyOption.children || keyOption.subs || []
            });
            return initValues;
        }, []).filter(function (_t) { return _t.key; }).map(function (item) { return item.key; }).join('/');
        return data;
    }, [currentOptions]);
    var filter = useCallback(function (inputValue, path) {
        return path.some(function (option) { return option.label.toLowerCase().indexOf(inputValue.toLowerCase()) > -1; });
    }, []);
    return (
    // copy 应当移到外层使用不应该在此
    React.createElement(CopyComponent, { text: formatValue(value), switchFlag: switchFlag },
        React.createElement(Cascader, __assign({}, restProps, { value: value, options: currentOptions, onChange: handleChange, showSearch: { filter: filter } }))));
});
NewCascader.defaultProps = {
    disabled: false,
    fullSelect: false,
    changeOnSelect: true,
    placeholder: '',
    value: [],
    options: [],
    onChange: function () { },
};
export default NewCascader;
