"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Collector = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const react_easy_state_1 = require("@risingstack/react-easy-state");
const global_1 = tslib_1.__importDefault(require("./global"));
// TODO: 支持同步 value 以外的状态, setValue 完全交给外部来做，内部只实例化空间
exports.Collector = (0, react_easy_state_1.view)(({ id, model, defaultValue, onValueChange, render, children }) => {
    (0, react_1.useEffect)(() => {
        const storePath = `currentPage.${id}`;
        if (id) {
            global_1.default.setStoreValue(storePath, {
                value: defaultValue,
            });
        }
        return () => {
            if (id) {
                global_1.default.clearStoreValue(storePath);
            }
        };
    }, [id]);
    const valuePath = model || ['currentPage', id, 'value'].join('.');
    const value = global_1.default.getStoreValue(valuePath);
    const componentOrFunction = render || children;
    return renderProps(componentOrFunction, {
        value,
        setValue: (nextValue) => {
            global_1.default.setStoreValue(valuePath, nextValue);
            onValueChange === null || onValueChange === void 0 ? void 0 : onValueChange(nextValue);
        },
        ref: (instance) => {
            global_1.default.refs[id] = instance;
        },
    });
});
const renderProps = (ComponentOrFunction, props) => {
    if (ComponentOrFunction.propTypes || ComponentOrFunction.prototype.render) {
        return react_1.default.createElement(ComponentOrFunction, Object.assign({}, props));
    }
    return ComponentOrFunction(Object.assign(Object.assign({}, (ComponentOrFunction.defaultProps || {})), props));
};
