import React from 'react';
type ActionOptionType = {
    label?: string;
    value?: string;
    [key: string]: any;
};
interface ActionSelectProps {
    /**
     * 是否支持输入
     */
    showInput?: boolean;
    /**
     * 输入框默认值
     */
    defaultInputValue?: string;
    /**
     * 输入文本时的回调
     */
    onInputChange?: (value: string) => void;
    /**
     * 提示文本
     */
    text?: string;
    /**
     * 选择菜单时的回调
     */
    onSelect?: (key: string) => void;
    /**
     * 选择的菜单列表
     */
    options?: ActionOptionType[];
}
export declare function ActionSelect({ showInput, defaultInputValue, text, options, onSelect, onInputChange, }: ActionSelectProps): React.JSX.Element;
export {};
