"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActionSelect = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const coral_system_1 = require("coral-system");
const antd_1 = require("antd");
const icons_1 = require("@ant-design/icons");
const actionInputStyle = (0, coral_system_1.css) `
  overflow: auto;
  font-family: Consolas, 'Liberation Mono', Menlo, Courier, monospace;
  cursor: pointer;
  user-select: none;

  display: flex;
  align-items: center;

  .action-input-text {
    flex: 1;
    overflow: hidden;
    text-overflow: ellipsis;
    white-space: nowrap;
    color: var(--tango-colors-text3);

    &:hover {
      color: var(--tango-colors-text2);
    }
  }

  .anticon-down {
    color: var(--tango-colors-text-placeholder);
  }

  &::-webkit-scrollbar {
    display: none;
  }
`;
const inputStyle = { width: 'calc(100% - 82px)' };
function ActionSelect({ showInput = false, defaultInputValue, text, options = [], onSelect, onInputChange, }) {
    const menu = (react_1.default.createElement(antd_1.Menu, { onClick: ({ key }) => onSelect(key) }, options.map((item) => (react_1.default.createElement(antd_1.Menu.Item, { key: item.value },
        react_1.default.createElement(coral_system_1.Box, { display: "flex", alignItems: "center", minWidth: 200, columnGap: "m" },
            react_1.default.createElement(coral_system_1.Box, { flex: "1" }, item.label),
            react_1.default.createElement(coral_system_1.Text, { fontSize: "12px", color: "text.note" }, item.value)))))));
    if (showInput) {
        return (react_1.default.createElement(antd_1.Input.Group, { compact: true },
            react_1.default.createElement(antd_1.Input, { placeholder: "\u8BF7\u8F93\u5165\u6587\u672C", defaultValue: defaultInputValue, style: inputStyle, onBlur: (e) => {
                    onInputChange && onInputChange(e.target.value);
                }, allowClear: true }),
            react_1.default.createElement(antd_1.Dropdown, { overlay: menu },
                react_1.default.createElement(antd_1.Button, { icon: react_1.default.createElement(icons_1.PlusSquareOutlined, null) }, "\u9884\u8BBE"))));
    }
    return (react_1.default.createElement(antd_1.Dropdown, { overlay: menu, trigger: ['click'] },
        react_1.default.createElement(coral_system_1.Box, { border: "solid", borderColor: "line.normal", borderRadius: "s", height: "32px", lineHeight: "32px", px: "m", mb: "m", css: actionInputStyle },
            react_1.default.createElement(coral_system_1.Box, { className: "action-input-text", color: "text.body" }, text),
            react_1.default.createElement(icons_1.DownOutlined, null))));
}
exports.ActionSelect = ActionSelect;
