"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Action = void 0;
const tslib_1 = require("tslib");
const antd_1 = require("antd");
const react_1 = tslib_1.__importDefault(require("react"));
const coral_system_1 = require("coral-system");
const classnames_1 = tslib_1.__importDefault(require("classnames"));
const actionStyle = (0, coral_system_1.css) `
  display: inline-flex;
  align-items: center;
  justify-content: center;
  width: 32px;
  height: 32px;
  outline: none;
  border: 0;
  border-radius: var(--tango-radii-s);
  color: var(--tango-colors-text2);
  background-color: transparent;

  &:hover {
    background-color: var(--tango-colors-fill2);
  }

  &.small {
    width: 24px;
    height: 24px;
  }

  &.outline {
    background-color: var(--tango-colors-fill1);
  }

  &.outline:hover {
    background-color: var(--tango-colors-fill3);
  }

  &.disabled {
    pointer-events: none;
    color: var(--tango-colors-text4);
  }
`;
function Action(_a) {
    var { icon, tooltip, href, size, shape, disabled, className, children } = _a, rest = tslib_1.__rest(_a, ["icon", "tooltip", "href", "size", "shape", "disabled", "className", "children"]);
    const classNames = (0, classnames_1.default)({
        'tango-action': true,
        'link-action': !!href,
        small: size === 'small',
        outline: shape === 'outline',
        disabled,
    }, className);
    let ret;
    if (href) {
        ret = (react_1.default.createElement(coral_system_1.Link, Object.assign({ className: classNames, css: actionStyle, href: href, isExternal: true }, rest), icon !== null && icon !== void 0 ? icon : children));
    }
    else {
        ret = (react_1.default.createElement(coral_system_1.Button, Object.assign({ type: "button", className: classNames, css: actionStyle }, rest), icon !== null && icon !== void 0 ? icon : children));
    }
    if (tooltip) {
        return react_1.default.createElement(antd_1.Tooltip, { title: tooltip }, ret);
    }
    return ret;
}
exports.Action = Action;
