"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MultiEditor = exports.SingleMonacoEditor = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const react_monaco_editor_lite_1 = require("react-monaco-editor-lite");
const coral_system_1 = require("coral-system");
function SingleMonacoEditor(props) {
    const { language, options: optionsProp = {}, height = '100%', width = '100%', hasBorder = false } = props, rest = tslib_1.__rest(props, ["language", "options", "height", "width", "hasBorder"]);
    const options = Object.assign({ language }, optionsProp);
    const boxProps = hasBorder
        ? {
            border: 'solid',
            borderColor: 'line.normal',
            borderRadius: 's',
        }
        : {};
    return (react_1.default.createElement(coral_system_1.Box, Object.assign({ width: width, height: height }, boxProps),
        react_1.default.createElement(react_monaco_editor_lite_1.SingleEditor, Object.assign({ options: options }, rest))));
}
exports.SingleMonacoEditor = SingleMonacoEditor;
var react_monaco_editor_lite_2 = require("react-monaco-editor-lite");
Object.defineProperty(exports, "MultiEditor", { enumerable: true, get: function () { return react_monaco_editor_lite_2.MultiEditor; } });
