import type { ListenerFunction, SandpackMessage, UnsubscribeFunction } from '../types';
export declare class IFrameProtocol {
    readonly channelId: number;
    channelListeners: Record<number, ListenerFunction>;
    private channelListenersCount;
    private iframe;
    private origin;
    private globalListeners;
    private globalListenersCount;
    constructor(iframe: HTMLIFrameElement, origin: string);
    cleanup(): void;
    register(): void;
    dispatch(message: SandpackMessage): void;
    globalListen(listener: ListenerFunction): UnsubscribeFunction;
    channelListen(listener: ListenerFunction): UnsubscribeFunction;
    private eventListener;
}
