import React from 'react';
import Manager from './manager';
import { IFiles, CodeSandboxState, CodeSandboxProps, UnsubscribeFunction } from '../types';
export declare class CodeSandbox extends React.Component<CodeSandboxProps, CodeSandboxState> {
    static defaultProps: {
        template: string;
        skipEval: boolean;
        eventHandlers: {};
        externalResources: string[];
    };
    manager?: Manager;
    unsubscribeChannelListener: UnsubscribeFunction;
    iframe: HTMLIFrameElement;
    constructor(props: CodeSandboxProps);
    componentDidUpdate(props: CodeSandboxProps): void;
    componentWillUnmount(): void;
    updateRoute: (route: string) => void;
    handleMessage: (m: any) => void;
    getOptions: () => {
        bundlerURL: string;
        fileResolver: {
            isFile: (path: string) => Promise<boolean>;
            readFile: (path: string) => Promise<string>;
        };
        skipEval: boolean;
        externalResources: string[];
    };
    setupFrame: (el: HTMLIFrameElement) => void;
    updateFiles: (files: IFiles) => void;
    render(): React.JSX.Element;
}
