import React from 'react';
import { HTMLCoralProps } from 'coral-system';
export interface CollapsePanelProps extends Omit<HTMLCoralProps<'div'>, 'title'> {
    /**
     * 标题
     */
    title?: React.ReactNode;
    /**
     * 标题附加内容
     */
    extra?: React.ReactNode;
    /**
     * 是否固定在顶部
     */
    stickyHeader?: boolean;
    /**
     * 默认是否收起
     */
    defaultCollapsed?: boolean;
    /**
     * 受控的折叠状态
     */
    collapsed?: boolean;
    /**
     * 折叠状态变化时的回调
     */
    onCollapse?: (collapse: boolean) => void;
    /**
     * 是否显示底部边框线
     */
    showBottomBorder?: boolean;
    headerProps?: HTMLCoralProps<'div'>;
    bodyProps?: HTMLCoralProps<'div'>;
}
export declare function CollapsePanel(props: CollapsePanelProps): React.JSX.Element;
