"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DragBox = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const coral_system_1 = require("coral-system");
const DragBox = (_a) => {
    var { children, index, onMove } = _a, rest = tslib_1.__rest(_a, ["children", "index", "onMove"]);
    const handleStartDrag = (ev) => {
        ev.dataTransfer.setData('text', `${index}`);
    };
    const handleEndDrag = (ev) => {
        ev.dataTransfer.dropEffect = 'move';
    };
    const handleDrop = (ev) => {
        const idx = ev.dataTransfer.getData('text');
        onMove === null || onMove === void 0 ? void 0 : onMove(+idx, index);
    };
    const handleDragOver = (ev) => {
        // 阻止默认行为，触发 onDrop
        ev.preventDefault();
        // TODO: 优化动画交互
    };
    return (react_1.default.createElement(coral_system_1.Box, Object.assign({}, rest, { draggable: true, onDragStart: handleStartDrag, onDragEnd: handleEndDrag, onDragOver: handleDragOver, onDrop: handleDrop }), children));
};
exports.DragBox = DragBox;
