"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VariableTreeModal = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const antd_1 = require("antd");
const coral_system_1 = require("coral-system");
const tango_helpers_1 = require("@music163/tango-helpers");
const variable_tree_1 = require("./variable-tree");
function VariableTreeModal(_a) {
    var { trigger, title, modalProps, onSelect = tango_helpers_1.noop } = _a, rest = tslib_1.__rest(_a, ["trigger", "title", "modalProps", "onSelect"]);
    const [node, setNode] = (0, react_1.useState)();
    const [visible, { on, off }] = (0, tango_helpers_1.useBoolean)(false);
    return (react_1.default.createElement(coral_system_1.Box, null,
        react_1.default.cloneElement(trigger, { onClick: on }),
        react_1.default.createElement(antd_1.Modal, Object.assign({ title: title, open: visible, onCancel: off, okButtonProps: {
                disabled: !node,
            }, onOk: () => {
                if (node) {
                    onSelect(node);
                    off();
                }
            }, width: "60%" }, modalProps),
            react_1.default.createElement(variable_tree_1.VariableTree, Object.assign({ height: 400, onSelect: setNode }, rest)))));
}
exports.VariableTreeModal = VariableTreeModal;
