"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AddStoreForm = exports.AddStoreVariableForm = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const antd_1 = require("antd");
const tango_core_1 = require("@music163/tango-core");
const tango_ui_1 = require("@music163/tango-ui");
function AddStoreVariableForm({ parentNode, onCancel, onSubmit, }) {
    return (react_1.default.createElement(antd_1.Form, { layout: "vertical", autoComplete: "off", validateTrigger: "onBlur", onFinish: (values) => {
            if (onSubmit && parentNode) {
                const [type, storeName] = parentNode.key.split('.');
                onSubmit(storeName, values);
            }
        } },
        react_1.default.createElement(antd_1.Form.Item, { label: "\u6240\u5C5E\u6A21\u578B" },
            react_1.default.createElement(antd_1.Input, { value: parentNode === null || parentNode === void 0 ? void 0 : parentNode.key, disabled: true })),
        react_1.default.createElement(antd_1.Form.Item, { label: "\u53D8\u91CF\u540D", name: "name", rules: [
                { required: true },
                { pattern: /^\w+$/, message: '非法的变量标识符' },
                {
                    validator(_, value) {
                        const found = parentNode.children.find((item) => item.title === value);
                        return found
                            ? Promise.reject(new Error('和已有变量名冲突，请换一个名字！'))
                            : Promise.resolve();
                    },
                },
            ] },
            react_1.default.createElement(antd_1.Input, { placeholder: "\u8BF7\u8F93\u5165\u53D8\u91CF\u540D" })),
        react_1.default.createElement(antd_1.Form.Item, { label: "\u521D\u503C", name: "initialValue", rules: [
                { required: true },
                {
                    validator(_, value) {
                        return value && (0, tango_core_1.isValidExpressionCode)(value)
                            ? Promise.resolve()
                            : Promise.reject(new Error('代码存在语法错误，请输入合法的代码片段！'));
                    },
                },
            ] },
            react_1.default.createElement(tango_ui_1.InputCode, { shape: "inset", placeholder: "\u8BF7\u8F93\u5165\u521D\u503C" })),
        react_1.default.createElement(antd_1.Form.Item, null,
            react_1.default.createElement(antd_1.Space, null,
                react_1.default.createElement(antd_1.Button, { onClick: onCancel }, "\u53D6\u6D88"),
                react_1.default.createElement(antd_1.Button, { type: "primary", htmlType: "submit" }, "\u4FDD\u5B58")))));
}
exports.AddStoreVariableForm = AddStoreVariableForm;
function AddStoreForm({ storeNames = [], onCancel, onSubmit }) {
    return (react_1.default.createElement(tango_ui_1.Panel, { title: "\u6DFB\u52A0\u6A21\u578B", subTitle: "\u6A21\u578B\u53EF\u4EE5\u7528\u6765\u7EC4\u7EC7\u4E00\u7EC4\u53D8\u91CF", bodyProps: { p: 'l' } },
        react_1.default.createElement(antd_1.Form, { autoComplete: "off", colon: false, onFinish: (values) => {
                onSubmit && onSubmit(values);
            } },
            react_1.default.createElement(antd_1.Form.Item, { label: "\u6A21\u578B\u540D\u79F0", name: "name", rules: [
                    { required: true },
                    { pattern: /^[a-z]\w+$/, message: '非法的变量标识符' },
                    {
                        validator(_, value) {
                            const found = storeNames.includes(value);
                            return found
                                ? Promise.reject(new Error('已存在该模型名，请换一个！'))
                                : Promise.resolve();
                        },
                    },
                ] },
                react_1.default.createElement(antd_1.Input, { placeholder: "\u8BF7\u8F93\u5165\u6A21\u578B\u540D\u79F0" })),
            react_1.default.createElement(antd_1.Form.Item, { label: " " },
                react_1.default.createElement(antd_1.Space, null,
                    react_1.default.createElement(antd_1.Button, { onClick: onCancel }, "\u53D6\u6D88"),
                    react_1.default.createElement(antd_1.Button, { type: "primary", htmlType: "submit" }, "\u4FDD\u5B58"))))));
}
exports.AddStoreForm = AddStoreForm;
