"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ServicePreview = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const coral_system_1 = require("coral-system");
const antd_1 = require("antd");
const icons_1 = require("@ant-design/icons");
const tango_ui_1 = require("@music163/tango-ui");
const tango_helpers_1 = require("@music163/tango-helpers");
const tango_core_1 = require("@music163/tango-core");
function ServicePreview({ appContext, functionKey }) {
    const [payload, setPayload] = (0, react_1.useState)({});
    const [result, setResult] = (0, react_1.useState)();
    const [error, setError] = (0, react_1.useState)('');
    return (react_1.default.createElement(coral_system_1.Box, null,
        react_1.default.createElement(tango_ui_1.Panel, { title: "\u8BF7\u6C42\u53C2\u6570", bodyProps: { px: 'l' } },
            react_1.default.createElement(tango_ui_1.InputCode, { placeholder: '添加请求参数，对象格式，如 { key: value }', editable: true, showLineNumbers: true, onChange: (value) => {
                    const obj = (0, tango_core_1.code2value)(value); // 转为 object 对象
                    setPayload(obj);
                } }),
            react_1.default.createElement(antd_1.Button, { block: true, type: "primary", style: { margin: '8px 0' }, disabled: !appContext, onClick: () => {
                    if (!appContext) {
                        setError('执行上下文未准备好，请关闭面板重试');
                        return;
                    }
                    try {
                        const fn = (0, tango_helpers_1.getValue)(appContext, functionKey);
                        fn(payload).then((data) => {
                            setError('');
                            setResult(data);
                        });
                    }
                    catch (err) {
                        setError('接口调用失败，请检查参数是否正确');
                        tango_helpers_1.logger.error(err);
                    }
                }, icon: react_1.default.createElement(icons_1.PlayCircleOutlined, null) }, "\u9884\u89C8")),
        react_1.default.createElement(tango_ui_1.Panel, { title: "\u8BF7\u6C42\u54CD\u5E94", bodyProps: { px: 'l' } }, error || (result ? react_1.default.createElement(ResponseDataPreview, { data: result }) : '点击预览按钮测试接口返回值'))));
}
exports.ServicePreview = ServicePreview;
function ResponseDataPreview({ data }) {
    let ret;
    if (!(0, tango_helpers_1.isNil)(data)) {
        switch (typeof data) {
            case 'object':
                ret = react_1.default.createElement(tango_ui_1.JsonView, { src: data });
                break;
            default:
                ret = String(data);
                break;
        }
    }
    const initialRet = react_1.default.createElement(antd_1.Empty, { image: antd_1.Empty.PRESENTED_IMAGE_SIMPLE });
    return (react_1.default.createElement(coral_system_1.Box, { className: "ResponseDataPreview", overflow: "auto", height: "auto", minHeight: 260, marginTop: 10 }, ret || initialRet));
}
