"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NodeCommonDetail = exports.ValueDefine = exports.ValueDetail = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const tango_helpers_1 = require("@music163/tango-helpers");
const antd_1 = require("antd");
const coral_system_1 = require("coral-system");
const tango_ui_1 = require("@music163/tango-ui");
const tango_core_1 = require("@music163/tango-core");
const previewOptions = [
    { label: '运行时', value: 'runtime' },
    { label: '定义', value: 'define' },
];
function ValueDetail({ defaultMode = 'runtime', children }) {
    const [mode, setMode] = (0, react_1.useState)(defaultMode);
    return (react_1.default.createElement(tango_ui_1.Panel, { title: "\u53D8\u91CF\u8BE6\u60C5", shape: "solid", extra: react_1.default.createElement(antd_1.Radio.Group, { optionType: "button", buttonStyle: "solid", size: "small", value: mode, onChange: (e) => {
                setMode(e.target.value);
            }, options: previewOptions }) }, children(mode)));
}
exports.ValueDetail = ValueDetail;
/**
 * 变量值定义面板
 */
function ValueDefine({ data, onSave = tango_helpers_1.noop }) {
    const [value, setValue] = (0, react_1.useState)(data.raw);
    const [error, setError] = (0, react_1.useState)('');
    const [editable, { on, off }] = (0, tango_helpers_1.useBoolean)();
    if ((0, tango_helpers_1.isNil)(data.raw)) {
        return react_1.default.createElement(antd_1.Empty, { image: antd_1.Empty.PRESENTED_IMAGE_SIMPLE, description: "\u7F3A\u5931\u5B9A\u4E49\u6570\u636E" });
    }
    return (react_1.default.createElement(coral_system_1.Box, null,
        react_1.default.createElement(tango_ui_1.InputCode, { shape: "inset", value: value, onChange: (nextValue) => setValue(nextValue), readOnly: !editable, onBlur: () => {
                if (!value) {
                    setError('输入内容不可为空！');
                }
                else if (value && !(0, tango_core_1.isValidExpressionCode)(`foo = ${value}`)) {
                    // 这里先保证输入是一个合法的表达式
                    setError('代码格式错误，请检查代码语法！');
                }
                else {
                    setError('');
                }
            } }),
        react_1.default.createElement(coral_system_1.Box, { color: "red", my: "m" }, error),
        react_1.default.createElement(coral_system_1.Box, { mt: "l" }, editable ? (react_1.default.createElement(antd_1.Space, null,
            react_1.default.createElement(antd_1.Button, { onClick: () => {
                    off();
                    setError('');
                } }, "\u53D6\u6D88"),
            react_1.default.createElement(antd_1.Button, { type: "primary", onClick: () => {
                    if (error) {
                        return;
                    }
                    onSave(data.key, value);
                    off();
                } }, "\u4FDD\u5B58"))) : (react_1.default.createElement(antd_1.Button, { onClick: on }, "\u7F16\u8F91")))));
}
exports.ValueDefine = ValueDefine;
function NodeCommonDetail({ data }) {
    if (!(data === null || data === void 0 ? void 0 : data.help)) {
        return react_1.default.createElement("div", null);
    }
    return react_1.default.createElement(antd_1.Alert, { type: "info", message: `使用说明：${data.help}`, closable: true });
}
exports.NodeCommonDetail = NodeCommonDetail;
