"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ValuePreview = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const tango_helpers_1 = require("@music163/tango-helpers");
const tango_ui_1 = require("@music163/tango-ui");
const antd_1 = require("antd");
function ValuePreview({ value, onCopy }) {
    if ((0, tango_helpers_1.isNil)(value)) {
        return react_1.default.createElement(antd_1.Empty, { image: antd_1.Empty.PRESENTED_IMAGE_SIMPLE, description: "\u6682\u65F6\u6CA1\u6709\u53EF\u9884\u89C8\u7684\u6570\u636E" });
    }
    if ((0, tango_helpers_1.isFunction)(value)) {
        return react_1.default.createElement(antd_1.Empty, { image: antd_1.Empty.PRESENTED_IMAGE_SIMPLE, description: "\u6682\u4E0D\u652F\u6301\u9884\u89C8\u51FD\u6570" });
    }
    if (typeof value === 'object') {
        return react_1.default.createElement(tango_ui_1.JsonView, { src: value, enableCopy: true, onCopy: onCopy });
    }
    return (react_1.default.createElement(tango_ui_1.InputCode, { shape: "inset", value: (0, tango_helpers_1.isString)(value) ? `"${value}"` : String(value), editable: false }));
}
exports.ValuePreview = ValuePreview;
