/// <reference types="react" />
import type { Engine } from '@music163/tango-core';
import { IVariableTreeNode } from '@music163/tango-helpers';
export interface ITangoEngineContext {
    /**
     * 低代码引擎
     */
    engine: Engine;
    /**
     * 自定义配置数据
     */
    config?: {
        customActionVariables?: IVariableTreeNode[];
        customExpressionVariables?: IVariableTreeNode[];
    };
}
declare const TangoEngineProvider: import("react").Provider<ITangoEngineContext>;
export { TangoEngineProvider };
export declare const useWorkspace: () => import("@music163/tango-core").IWorkspace;
export declare const useDesigner: () => import("@music163/tango-core").Designer;
export declare const useWorkspaceData: () => {
    modelVariables: {
        key: string;
        title: string;
        children: IVariableTreeNode[];
    }[];
    actionVariables: IVariableTreeNode[];
    storeVariables: IVariableTreeNode[];
    serviceVariables: IVariableTreeNode[];
    expressionVariables: IVariableTreeNode[];
    routeOptions: {
        label: string;
        value: any;
    }[];
};
