"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.CopyClipboard = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
function CopyClipboard({ onCopy, text, children }) {
    const [copied, setCopied] = (0, react_1.useState)(false);
    const timeoutRef = (0, react_1.useRef)();
    (0, react_1.useEffect)(() => {
        return () => {
            if (timeoutRef.current) {
                clearTimeout(timeoutRef.current);
            }
        };
    }, []);
    const onClick = () => {
        if (timeoutRef.current) {
            clearTimeout(timeoutRef.current);
        }
        navigator.clipboard.writeText(text);
        setCopied(true);
        onCopy === null || onCopy === void 0 ? void 0 : onCopy();
        timeoutRef.current = setTimeout(() => {
            setCopied(false);
        }, 1000);
    };
    if (typeof children === 'function') {
        return react_1.default.cloneElement(children({ copied, onClick }), {
            onClick,
        });
    }
}
exports.CopyClipboard = CopyClipboard;
