"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createServices = exports.createService = void 0;
const tslib_1 = require("tslib");
const request_1 = tslib_1.__importDefault(require("./request"));
const global_config_1 = tslib_1.__importDefault(require("./global-config"));
function createService(_a) {
    var { onSuccess, onError } = _a, baseConfig = tslib_1.__rest(_a, ["onSuccess", "onError"]);
    return (payload, config) => tslib_1.__awaiter(this, void 0, void 0, function* () {
        var _b;
        const _c = Object.assign(Object.assign({}, config), baseConfig), { method = 'get', url } = _c, restConfig = tslib_1.__rest(_c, ["method", "url"]);
        try {
            const fn = fixMethod(method);
            const data = yield request_1.default[fn](url, payload, restConfig);
            onSuccess === null || onSuccess === void 0 ? void 0 : onSuccess(data);
            return data;
        }
        catch (err) {
            (_b = global_config_1.default.message) === null || _b === void 0 ? void 0 : _b.error(err.message);
            onError === null || onError === void 0 ? void 0 : onError(err);
        }
    });
}
exports.createService = createService;
function createServices(configs, baseConfig) {
    return Object.keys(configs).reduce((acc, key) => {
        acc[key] = createService(Object.assign(Object.assign({}, configs[key]), baseConfig));
        return acc;
    }, {});
}
exports.createServices = createServices;
const methodMap = {
    postformdata: 'postFormData',
    postformurlencoded: 'postFormUrlencoded',
};
function fixMethod(method) {
    method = method.toLowerCase();
    return methodMap[method] || method;
}
