"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.defineStore = void 0;
const tslib_1 = require("tslib");
const react_easy_state_1 = require("@risingstack/react-easy-state");
const global_1 = tslib_1.__importDefault(require("./global"));
// export const globalStore = store({});
/**
 * 创建 Store 实例
 * @param object 定义的状态熟悉和方法
 * @param namespace 命名空间，暂时废弃，不推荐使用
 * @returns
 */
function defineStore(object, namespace) {
    // if (namespace) {
    //   globalStore[namespace] = object;
    //   return globalStore[namespace];
    //   // return bind(globalStore[namespace]);
    // }
    const ret = bind((0, react_easy_state_1.store)(object));
    global_1.default.registerStore(namespace, ret);
    return ret;
}
exports.defineStore = defineStore;
function bind(object) {
    Object.keys(object).forEach((key) => {
        if (typeof object[key] === 'function') {
            object[key] = object[key].bind(object);
        }
    });
    return object;
}
