"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Designer = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const coral_system_1 = require("coral-system");
const antd_1 = require("antd");
const tango_context_1 = require("@music163/tango-context");
const zh_CN_1 = tslib_1.__importDefault(require("antd/lib/locale/zh_CN"));
const context_1 = require("./context");
const default_1 = tslib_1.__importDefault(require("./themes/default"));
/**
 * 设计器状态和设置容器
 * @param props
 * @returns
 */
function Designer(props) {
    const { engine, config, theme: themeProp, sandboxQuery, remoteServices = {}, children } = props;
    const theme = (0, react_1.useMemo)(() => (0, coral_system_1.extendTheme)(themeProp, default_1.default), [themeProp]);
    return (react_1.default.createElement(coral_system_1.SystemProvider, { theme: theme, prefix: "--tango" },
        react_1.default.createElement(antd_1.ConfigProvider, { locale: zh_CN_1.default },
            react_1.default.createElement(tango_context_1.TangoEngineProvider, { value: { engine, config } },
                react_1.default.createElement(context_1.DesignerProvider, { value: { sandboxQuery, remoteServices } }, children)))));
}
exports.Designer = Designer;
