"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Hotkey = void 0;
/**
 * 快捷键
 */
class Hotkey {
    constructor(hotkeys) {
        this.hotkeyMap = {};
        Object.keys(hotkeys).forEach((hotkey) => {
            const keys = hotkey.split(',');
            keys.forEach((key) => {
                if (key) {
                    key = fixKey(key);
                    this.hotkeyMap[key] = hotkeys[hotkey];
                }
            });
        });
    }
    run(hotkey) {
        const callback = this.hotkeyMap[hotkey];
        callback === null || callback === void 0 ? void 0 : callback();
    }
}
exports.Hotkey = Hotkey;
function fixKey(key) {
    if (key === 'esc') {
        return 'escape';
    }
    return key.replaceAll('command', 'meta');
}
