"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ErrorBoundary = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const coral_system_1 = require("coral-system");
const tango_helpers_1 = require("@music163/tango-helpers");
class ErrorBoundary extends react_1.default.Component {
    static getDerivedStateFromError(error) {
        // Update state so the next render will show the fallback UI.
        tango_helpers_1.logger.error(error);
        return { hasError: true };
    }
    constructor(props) {
        super(props);
        this.state = { hasError: false };
    }
    componentDidCatch(error, errorInfo) {
        // You can also log the error to an error reporting service
        tango_helpers_1.logger.error(error, errorInfo);
    }
    render() {
        if (this.state.hasError) {
            // You can render any custom fallback UI
            return (react_1.default.createElement(coral_system_1.Box, { as: "h1", color: "red" }, "Something went wrong."));
        }
        return this.props.children;
    }
}
exports.ErrorBoundary = ErrorBoundary;
