"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createEngine = void 0;
const models_1 = require("./models");
/**
 * Designer 实例化工厂函数
 * @param options
 * @returns
 */
function createEngine({ workspace, defaultSimulatorMode = 'desktop', defaultActiveSidebarPanel = '', }) {
    const engine = new models_1.Engine({
        workspace,
        designer: new models_1.Designer({
            workspace,
            simulator: defaultSimulatorMode,
            activeSidebarPanel: defaultActiveSidebarPanel,
        }),
    });
    return engine;
}
exports.createEngine = createEngine;
