"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Directory = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const file_1 = require("./file");
const module_list_1 = require("./module-list");
class Directory extends react_1.default.Component {
    constructor() {
        super(...arguments);
        this.state = {
            open: true,
        };
        this.toggleOpen = () => {
            this.setState((state) => ({ open: !state.open }));
        };
    }
    render() {
        const { prefixedPath, files, selectFile, activePath, depth } = this.props;
        return (react_1.default.createElement("div", { key: prefixedPath },
            react_1.default.createElement(file_1.File, { depth: depth, isDirOpen: this.state.open, onClick: this.toggleOpen, path: prefixedPath + '/' }),
            this.state.open ? (react_1.default.createElement(module_list_1.ModuleList, { activePath: activePath, depth: depth, files: files, prefixedPath: prefixedPath, selectFile: selectFile })) : null));
    }
}
exports.Directory = Directory;
