"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.File = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const coral_system_1 = require("coral-system");
const icons_1 = require("@ant-design/icons");
const fileItemStyle = (0, coral_system_1.css) `
  user-select: none;
  transition: all 0.15s ease-in-out;

  > .anticon {
    margin-right: 4px;
  }

  &:hover {
    background-color: var(--tango-colors-gray-10);
  }

  &[data-active='true'] {
    background-color: var(--tango-colors-gray-30);
  }
`;
class File extends react_1.default.PureComponent {
    constructor() {
        super(...arguments);
        this.selectFile = () => {
            if (this.props.selectFile) {
                this.props.selectFile(this.props.path);
            }
        };
    }
    render() {
        const fileName = this.props.path.split('/').filter(Boolean).pop();
        return (react_1.default.createElement(coral_system_1.Box, { as: "li", "data-active": this.props.active, onClick: this.props.selectFile ? this.selectFile : this.props.onClick, display: "flex", alignItems: "center", height: "28px", py: "4px", pr: "12px", pl: 16 * this.props.depth, css: fileItemStyle },
            this.props.selectFile ? react_1.default.createElement(icons_1.FileOutlined, null) : react_1.default.createElement(DirectoryIcon, { isOpen: this.props.isDirOpen }),
            fileName));
    }
}
exports.File = File;
function DirectoryIcon({ isOpen }) {
    return isOpen ? react_1.default.createElement(icons_1.FolderOpenOutlined, null) : react_1.default.createElement(icons_1.FolderOutlined, null);
}
