"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModuleList = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const directory_1 = require("./directory");
const file_1 = require("./file");
class ModuleList extends react_1.default.PureComponent {
    render() {
        const { depth = 0, activePath, selectFile, prefixedPath, files } = this.props;
        const fileListWithoutPrefix = files
            .filter((file) => file.startsWith(prefixedPath))
            .map((file) => file.substring(prefixedPath.length));
        const directoriesToShow = new Set(fileListWithoutPrefix
            .filter((file) => file.includes('/'))
            .map((file) => `${prefixedPath}${file.split('/')[0]}/`));
        const filesToShow = fileListWithoutPrefix
            .filter((file) => !file.includes('/'))
            .map((file) => ({ path: `${prefixedPath}${file}` }));
        return (react_1.default.createElement("div", null,
            Array.from(directoriesToShow).map((dir) => (react_1.default.createElement(directory_1.Directory, { key: dir, activePath: activePath, depth: depth + 1, files: files, prefixedPath: dir, selectFile: selectFile }))),
            filesToShow.map((file) => (react_1.default.createElement(file_1.File, { key: file.path, active: activePath === file.path, depth: depth + 1, path: file.path, selectFile: this.props.selectFile })))));
    }
}
exports.ModuleList = ModuleList;
