"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SettingFormObject = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const coral_system_1 = require("coral-system");
const mobx_react_lite_1 = require("mobx-react-lite");
const form_item_1 = require("./form-item");
const context_1 = require("./context");
const form_ui_1 = require("./form-ui");
const helpers_1 = require("./helpers");
const defaultGetVisible = () => true;
/**
 * 为该组件下的 SettingFormItem 添加一个数据字段前缀
 */
exports.SettingFormObject = (0, mobx_react_lite_1.observer)(({ title, tip, docs, name, defaultValue, getVisible = defaultGetVisible, props = [], }) => {
    var _a;
    const parent = (0, context_1.useFormModel)();
    const visible = getVisible(parent);
    const subModel = parent.getSubModel(name);
    return (react_1.default.createElement(context_1.FormModelProvider, { value: subModel },
        react_1.default.createElement(coral_system_1.Box, { className: "FormObject", display: visible ? 'block' : 'none' },
            react_1.default.createElement(form_ui_1.FormControlGroup, { label: title, note: name, tip: tip, docs: docs, checked: (_a = !!subModel.values) !== null && _a !== void 0 ? _a : !!defaultValue, onCheck: (checked) => {
                    const nextValue = checked ? {} : undefined;
                    parent.setValue(name, nextValue);
                    parent.onChange(name, nextValue); // 非 Field 发起， 主动调一次
                } }, props.map((prop) => {
                if ((0, helpers_1.isValidNestProps)(prop.props)) {
                    return react_1.default.createElement(exports.SettingFormObject, Object.assign({ key: prop.name }, prop));
                }
                return react_1.default.createElement(form_item_1.SettingFormItem, Object.assign({ key: prop.name }, prop));
            })))));
});
