import React from 'react';
import { HTMLCoralProps } from 'coral-system';
export interface FormControlProps extends Omit<FormLabelProps, 'type'> {
    visible: boolean;
    extra?: React.ReactNode;
    footer?: React.ReactNode;
    error?: string;
    children?: React.ReactNode;
}
export declare function FormControl({ visible, label, note, tip, docs, extra, deprecated, footer, error, children, ...rest }: FormControlProps): React.JSX.Element;
export interface FormControlGroupProps extends FormLabelProps {
    error?: string;
    extra?: React.ReactNode;
    children?: React.ReactNode;
    /**
     * 勾选变化时的回调
     */
    onCheck?: (checked: boolean) => void;
    /**
     * 是否勾选
     */
    checked?: boolean;
}
export declare function FormControlGroup({ label, note, tip, docs, error, extra, children, onCheck, checked, }: FormControlGroupProps): React.JSX.Element;
interface FormLabelProps extends HTMLCoralProps<'div'> {
    /**
     * 标签
     */
    label?: string;
    /**
     * 备注
     */
    note?: string;
    /**
     * 冒泡信息
     */
    tip?: string;
    /**
     * 文档地址
     */
    docs?: string;
    /**
     * 是否显示废弃标记
     */
    deprecated?: boolean | string;
}
interface FieldSetProps {
    title?: React.ReactNode;
    extra?: React.ReactNode;
    children?: React.ReactNode;
}
export declare function FieldSet({ title, extra, children }: FieldSetProps): React.JSX.Element;
interface FormHeaderProps {
    title?: React.ReactNode;
    subTitle?: React.ReactNode;
    extra?: React.ReactNode;
}
export declare function FormHeader({ title, extra, subTitle }: FormHeaderProps): React.JSX.Element;
export {};
