"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const MESSAGE = Symbol('message');
const message = {
    error(msg) {
        console.error('[error] %s', msg);
    },
    warn(msg) {
        console.warn('[warn] %s', msg);
    },
    success(msg) {
        console.log('[success] %s', msg);
    },
};
class GlobalConfig {
    constructor() {
        this[MESSAGE] = message;
    }
    get message() {
        return this[MESSAGE];
    }
    set message(messageInstance) {
        if (messageInstance &&
            messageInstance.error &&
            messageInstance.warn &&
            messageInstance.success) {
            this[MESSAGE] = message;
        }
        else {
            console.error('invalid message, should have error, warn, success method');
        }
    }
}
exports.default = new GlobalConfig();
