"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getWorkspace = void 0;
const tslib_1 = require("tslib");
const react_easy_state_1 = require("@risingstack/react-easy-state");
const i18next_1 = tslib_1.__importDefault(require("i18next"));
const globalTango = {
    config: {},
    services: {},
    stores: {
        currentPage: (0, react_easy_state_1.store)({}),
    },
    refs: {},
    // i18next,
    t: (...args) => {
        const __workspace__ = getWorkspace();
        if (__workspace__) {
            console.log('===> i18next.language:: ', camelCase(i18next_1.default.language));
            console.log('===> window.__workspace__.i18nJsons:: ', __workspace__.i18nJsons);
            return __workspace__.i18nJsons[camelCase(i18next_1.default.language)].getValue(...args);
        }
        else {
            return i18next_1.default.t(...args);
        }
    },
    i18n: i18next_1.default,
    getStore(name) {
        return globalTango.stores[name];
    },
    getStoreValue(path) {
        if (!path) {
            return;
        }
        const keys = path.split('.');
        let value = globalTango.stores;
        for (let i = 0; i < keys.length; i++) {
            if (value) {
                value = value[keys[i]];
            }
            else {
                break;
            }
        }
        return value;
    },
    setStoreValue(path, value) {
        const keys = path.split('.');
        const storeName = keys[0];
        const subStore = globalTango.stores[storeName];
        if (!subStore) {
            globalTango.stores[storeName] = {};
        }
        let context = globalTango.stores[storeName];
        for (let i = 1; i < keys.length - 1; i++) {
            context = context[keys[i]] || {};
        }
        context[keys[keys.length - 1]] = value;
    },
    clearStoreValue(path) {
        globalTango.setStoreValue(path, undefined);
    },
    registerStore(name, storeInstance) {
        if (!globalTango.getStore(name)) {
            globalTango.stores[name] = storeInstance;
        }
    },
    registerServices(services, namespace) {
        if (namespace) {
            globalTango.services[namespace] = services;
        }
        else {
            globalTango.services = Object.assign(Object.assign({}, globalTango.services), services);
        }
    },
};
exports.default = globalTango;
function camelCase(str) {
    return str.replace(/\W+(.)/g, (match, chr) => {
        return chr.toUpperCase();
    });
}
function getWorkspace() {
    var _a;
    return window.__workspace__ || ((_a = window.parent) === null || _a === void 0 ? void 0 : _a.__workspace__);
}
exports.getWorkspace = getWorkspace;
