"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isInTangoDesignMode = exports.isServiceVariablePath = exports.isStoreVariablePath = exports.isNil = exports.isPromise = exports.isPlainObject = exports.isObject = exports.isBoolean = exports.isNumber = exports.isFunction = exports.isString = exports.assert = void 0;
/**
 * condition 为 false 的时候打印 msg
 * @param condition
 * @param msg
 */
function assert(condition, msg) {
    console.assert(condition, msg);
}
exports.assert = assert;
function isString(str) {
    return typeof str === 'string';
}
exports.isString = isString;
function isFunction(fn) {
    return typeof fn === 'function';
}
exports.isFunction = isFunction;
function isNumber(num) {
    return typeof num === 'number';
}
exports.isNumber = isNumber;
function isBoolean(obj) {
    return typeof obj === 'boolean';
}
exports.isBoolean = isBoolean;
function isObject(obj) {
    return typeof obj === 'object' && !Array.isArray(obj) && obj !== null;
}
exports.isObject = isObject;
function isPlainObject(obj) {
    return Object.prototype.toString.call(obj) === '[object Object]';
}
exports.isPlainObject = isPlainObject;
function isPromise(obj) {
    return obj && obj.then && isFunction(obj.then);
}
exports.isPromise = isPromise;
/**
 * 判断值是否是 null 或 undefined
 * @param val
 * @returns true if val is null or undefined
 */
function isNil(val) {
    return val == null;
}
exports.isNil = isNil;
/**
 * 是否是状态变量的 path
 * @param key
 * @returns
 */
function isStoreVariablePath(key) {
    return key === 'pageStore' || /^stores\.[a-zA-Z0-9]+\.\w+$/.test(key);
}
exports.isStoreVariablePath = isStoreVariablePath;
/**
 * 是否是服务变量的 path
 * @param key
 * @returns
 */
function isServiceVariablePath(key) {
    return /^services\.[a-zA-Z0-9]+/.test(key);
}
exports.isServiceVariablePath = isServiceVariablePath;
/**
 * 是否在 Tango 设计模式
 */
function isInTangoDesignMode() {
    return !!window.__TANGO_DESIGNER__;
}
exports.isInTangoDesignMode = isInTangoDesignMode;
