/**
 * ast to code
 */
import { GeneratorOptions } from '@babel/generator';
import * as t from '@babel/types';
/**
 * 将 t.File 生成为代码
 * @param ast
 * @param options
 * @returns
 */
export declare function ast2code(ast: t.Node, options?: GeneratorOptions): string;
/**
 * 将表达式生成为块级代码
 * @param node
 * @returns
 */
export declare function expression2code(node: t.Expression): string;
/**
 * 将 的 jsxAttributeName 或 objectPropertyKey 转换为 js value
 * @param node jsxAttributeName or objectPropertyKey
 * @returns simple js value
 */
export declare function keyNode2value(node: t.Node): string | number;
/**
 * 将 t.Node 生成为字符串代码
 * @param node
 * @returns
 */
export declare function node2code(node: t.Node): string;
/**
 * 将 t.Node 生成为 js 值
 * @param node ast node
 * @param isWrapCode 是否包裹代码，例如 code -> {{code}}
 * @returns a plain javascript value
 */
export declare function node2value(node: t.Node, isWrapCode?: boolean): any;
/**
 * jsx prop value 节点转为 js value
 */
export declare function jsxAttributeValueNode2value(node: t.Node): any;
