/**
 * js value 转为代码字符串
 * @example 1 => 1
 * @example hello => "hello"
 * @example { foo: bar } => {{ foo: bar }}
 * @example [1,2,3] => {[1,2,3]}
 *
 * @param val js value
 * @returns 表达式代码
 */
export declare function value2code(val: any): string;
export declare const value2expressionCode: typeof value2code;
/**
 * 代码字符串转为具体的 js value
 * @example `() => {}` 返回 undefined
 *
 * @param rawCode 代码字符串
 * @returns 返回解析后的 js value，包括：string, number, boolean, simpleObject, simpleArray
 */
export declare function code2value(rawCode: string): any;
