import { Selector } from 'cash-dom';
import { MousePoint, ISelectedItemData } from '@music163/tango-helpers';
export declare function buildQueryBySlotId(id: string): string;
export declare function getElement(selector: Selector): HTMLElement & Element & Node;
export declare const DRAG_GHOST_ID = "dragGhost";
export declare const getDragGhostElement: () => HTMLElement & Element & Node;
export declare function setElementStyle(selector: Selector, style: any): string;
/**
 * 获取元素的外框数据
 * @param element
 * @returns
 */
export declare function getElementBoundingData(element: HTMLElement, relativeContainer?: HTMLElement): {
    width: number;
    height: number;
    top: number;
    left: number;
};
export declare function getRelativePoint(point: MousePoint, relativeContainer?: HTMLElement): MousePoint;
/**
 * 获取元素的 css display 值
 * @param element
 * @returns
 */
export declare function getElementCSSDisplay(element: HTMLElement): string;
/**
 * 获取元素的数据
 * @param element
 * @returns
 */
export declare function getElementData(element: HTMLElement, relativeContainer?: HTMLElement): ISelectedItemData;
/**
 * 给定点的位置到某个元素外框的距离
 * @param point
 * @param rect
 * @returns
 */
export declare function distanceToRect(point: any, rect: any): number;
