"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.callAll = exports.runIfFn = exports.noop = void 0;
const assert_1 = require("./assert");
function noop(...args) { }
exports.noop = noop;
function runIfFn(valueOrFn, ...args) {
    return (0, assert_1.isFunction)(valueOrFn) ? valueOrFn(...args) : valueOrFn;
}
exports.runIfFn = runIfFn;
function callAll(...fns) {
    return function mergedFn(...args) {
        fns.forEach((fn) => {
            if ((0, assert_1.isFunction)(fn)) {
                fn === null || fn === void 0 ? void 0 : fn(...args);
            }
        });
    };
}
exports.callAll = callAll;
