type IdGeneratorOptionsType = {
    prefix?: string;
};
/**
 * ID 生成器
 */
export declare class IdGenerator {
    /**
     * ID 前缀
     */
    private readonly prefix;
    /**
     * 记录组件 ID 记录
     */
    private map;
    constructor(options?: IdGeneratorOptionsType);
    /**
     * 更新组件记录
     * @param component
     */
    setItem(component: string, id?: string): void;
    /**
     * 获取组件 ID
     * @param component 组件名, 如 Button, DatePicker
     * @param codeId 用户自定义的 ID
     * @returns
     */
    generateId(component: string, codeId?: string): {
        id: string;
        fullId: string;
    };
}
export {};
