export declare const logger: {
    group(title: string, body: string): void;
    log(msg: string): void;
    warn(msg: string): void;
    error(...args: any): void;
};
/**
 * 如果条件为 false 则打印警告日志
 * @example warning(truthyValue, 'This should not log a warning');
 * @example warning(falsyValue, 'This should log a warning');
 * @see https://github.com/alexreardon/tiny-warning
 *
 * @param condition 打印警告日志的条件
 * @param message 警告日志
 */
export declare function warning(condition: boolean, message: string): void;
/**
 * 如果条件为 false 则抛出错误
 * @see https://github.com/alexreardon/tiny-invariant
 * @param condition 条件
 * @param message 错误消息
 */
export declare function invariant(condition: boolean, message: string | (() => string)): void;
