"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.deepCloneNode = void 0;
const tango_helpers_1 = require("@music163/tango-helpers");
// { id: 1, component, props: { id: 1 }, children: [ { id: 2, component } ] }
function deepCloneNode(obj, component) {
    function deepCloneObject() {
        const target = {};
        for (const key in obj) {
            if (Object.hasOwn(obj, key)) {
                target[key] = deepCloneNode(obj[key], component);
            }
        }
        return target;
    }
    function deepCloneElementNode() {
        const target = deepCloneObject();
        let name = component || target.component;
        if (target.id) {
            const dnd = (0, tango_helpers_1.parseDndId)(target.id);
            name = dnd.component || name;
        }
        target.id = (0, tango_helpers_1.uuid)(`${name}:`);
        return target;
    }
    if (!obj || typeof obj !== 'object') {
        return obj;
    }
    if (Array.isArray(obj)) {
        return obj.map((item) => deepCloneNode(item, component));
    }
    if (!obj.component) {
        return deepCloneObject();
    }
    return deepCloneElementNode();
}
exports.deepCloneNode = deepCloneNode;
