import React from 'react';
interface IWithDndOptions<T> {
    /**
     * 组件名
     */
    name: string;
    /**
     * 是否注入 draggable 属性，默认为 true
     */
    draggable?: boolean;
    /**
     * 是否使用 DndWrapper 包装一层，推进容器类组件关闭此属性，其他类组件均开启
     */
    hasWrapper?: boolean;
    /**
     * DndWrapper 的自定义样式
     */
    wrapperStyle?: React.CSSProperties;
    /**
     * 组件的展示方式，仅在 hasWrapper 开启时有效
     */
    display?: DndBoxProps['display'];
    /**
     * 被包裹的组件是否为函数组件
     * @deprecated
     */
    isFunctionComponent?: boolean;
    /**
     * 覆盖的属性集
     */
    overrideProps?: T;
    /**
     * 自定义容器底部渲染，仅在 hasWrapper 开启时有效
     */
    renderFooter?: (props: T) => React.ReactNode;
}
interface DraggableComponentProps {
    /**
     * 组件 ID
     */
    tid?: string;
}
export declare function withDnd(options: IWithDndOptions<any>): <P>(BaseComponent: React.ComponentType<P>) => React.ForwardRefExoticComponent<React.PropsWithoutRef<P & DraggableComponentProps> & React.RefAttributes<unknown>>;
interface DndBoxProps extends React.ComponentPropsWithoutRef<'div'> {
    name?: string;
    display?: 'block' | 'inline-block' | 'inline';
}
export {};
