"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.withDnd = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const hoist_non_react_statics_1 = tslib_1.__importDefault(require("hoist-non-react-statics"));
const helpers_1 = require("../helpers");
const renderEmpty = () => null;
function withDnd(options) {
    return function hoc(BaseComponent) {
        var _a, _b;
        const isFC = (0, helpers_1.isFunctionComponent)(BaseComponent);
        const displayName = options.name || (0, helpers_1.getDisplayName)(BaseComponent);
        const draggable = (_a = options.draggable) !== null && _a !== void 0 ? _a : true;
        const hasWrapper = (_b = options.hasWrapper) !== null && _b !== void 0 ? _b : true;
        const display = options.display || 'block';
        const override = options.overrideProps || {};
        const renderFooter = options.renderFooter || renderEmpty;
        const Component = (0, react_1.forwardRef)((props, refProp) => {
            const dndProps = {
                [helpers_1.SLOT.id]: props.tid, // id 作为唯一标记
                [helpers_1.SLOT.dnd]: props[helpers_1.SLOT.dnd], // dnd 作为追踪标记
                draggable: draggable ? true : undefined,
            };
            const propsCopy = Object.assign({}, props);
            delete propsCopy[helpers_1.SLOT.dnd];
            delete propsCopy.tid;
            const ref = isFC ? undefined : refProp;
            if (!hasWrapper) {
                return react_1.default.createElement(BaseComponent, Object.assign({ ref: ref }, dndProps, override, propsCopy));
            }
            return (react_1.default.createElement(DndBox, Object.assign({ name: displayName, display: display, style: options.wrapperStyle }, dndProps),
                react_1.default.createElement(BaseComponent, Object.assign({ ref: ref }, override, propsCopy)),
                renderFooter(props)));
        });
        (0, hoist_non_react_statics_1.default)(Component, BaseComponent);
        Component.displayName = (0, helpers_1.wrapDisplayName)(displayName, 'withDnd');
        return Component;
    };
}
exports.withDnd = withDnd;
function DndBox(_a) {
    var { name, display, children, style: styleProp } = _a, rest = tslib_1.__rest(_a, ["name", "display", "children", "style"]);
    const style = Object.assign({ display, minHeight: 4 }, styleProp);
    return (react_1.default.createElement("div", Object.assign({ className: `${name}-designer tango-dndBox`, style: style }, rest), children));
}
