"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useBoolean = void 0;
const react_1 = require("react");
function useBoolean(initialState = false) {
    const [value, setValue] = (0, react_1.useState)(initialState);
    const on = (0, react_1.useCallback)(() => {
        setValue(true);
    }, []);
    const off = (0, react_1.useCallback)(() => {
        setValue(false);
    }, []);
    const toggle = (0, react_1.useCallback)(() => {
        setValue((prev) => !prev);
    }, []);
    return [value, { on, off, toggle }];
}
exports.useBoolean = useBoolean;
