"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.useCallbackRef = void 0;
const react_1 = require("react");
/**
 * @param callback
 * @param deps
 * @returns
 */
function useCallbackRef(callback, deps = []) {
    const callbackRef = (0, react_1.useRef)(callback);
    (0, react_1.useEffect)(() => {
        callbackRef.current = callback;
    });
    // eslint-disable-next-line react-hooks/exhaustive-deps
    return (0, react_1.useCallback)(((...args) => { var _a; return (_a = callbackRef.current) === null || _a === void 0 ? void 0 : _a.call(callbackRef, ...args); }), deps);
}
exports.useCallbackRef = useCallbackRef;
