"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const i18next_1 = tslib_1.__importDefault(require("i18next"));
const i18next_browser_languagedetector_1 = tslib_1.__importDefault(require("i18next-browser-languagedetector"));
const i18next_http_backend_1 = tslib_1.__importDefault(require("i18next-http-backend"));
const global_1 = require("./global");
const __workspace__ = (0, global_1.getWorkspace)();
const options = {
    order: ['cookie', 'localStorage', 'sessionStorage', 'navigator', 'htmlTag', 'path', 'subdomain'],
    lookupLocalStorage: 'lng',
};
if (!__workspace__) {
    i18next_1.default
        // i18next-http-backend
        // loads translations from your server
        // https://github.com/i18next/i18next-http-backend
        .use(i18next_http_backend_1.default);
}
// detect user language
// learn more: https://github.com/i18next/i18next-browser-languageDetector
i18next_1.default
    .use(i18next_browser_languagedetector_1.default)
    // init i18next
    // for all options read: https://www.i18next.com/overview/configuration-options
    .init({
    debug: true,
    fallbackLng: 'zh-CN',
    detection: options,
    interpolation: {
        escapeValue: false, // not needed for react as it escapes by default
    },
    backend: {
        overrideMimeType: true,
        crossDomain: true,
    },
});
exports.default = i18next_1.default;
