"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.IconFont = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const icons_1 = tslib_1.__importDefault(require("@ant-design/icons"));
/**
 * 只能在 Designer 里面用，其他地方用不了，依赖 iconfont 脚本提前载入
 */
function IconFont(props) {
    const { type, children } = props, restProps = tslib_1.__rest(props, ["type", "children"]);
    // children > type
    let content = null;
    if (props.type) {
        content = react_1.default.createElement("use", { xlinkHref: `#${type}` });
    }
    if (children) {
        content = children;
    }
    return react_1.default.createElement(icons_1.default, Object.assign({}, restProps), content);
}
exports.IconFont = IconFont;
IconFont.displayName = 'IconFont';
