import React from 'react';
import { ReactCodeMirrorProps } from '@uiw/react-codemirror';
export interface InputCodeProps extends ReactCodeMirrorProps {
    /**
     * 外观
     * - solid 带边框，完整模式
     * - inset 嵌入式场景，轻量模式
     */
    shape?: 'solid' | 'inset';
    /**
     * 是否展示行号
     */
    showLineNumbers?: boolean;
    /**
     * 是否展示代码折叠箭头
     */
    showFoldGutter?: boolean;
    /**
     * 后缀元素
     */
    suffix?: React.ReactNode;
    /**
     * 状态
     */
    status?: string;
    /**
     * 补全上下文对象
     */
    autoCompleteContext?: any;
    /**
     * 自定义补全的选项列表
     */
    autoCompleteOptions?: string[];
    /**
     * 启用 ESLint
     */
    enableESLint?: boolean;
}
export declare function InputCode({ shape, suffix, status, autoCompleteContext, autoCompleteOptions, showLineNumbers, showFoldGutter, enableESLint, ...rest }: InputCodeProps): React.JSX.Element;
