"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.InputList = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const coral_system_1 = require("coral-system");
const antd_1 = require("antd");
const icons_1 = require("@ant-design/icons");
function InputList({ value = [], onChange }) {
    const [isAdding, setIsAdding] = (0, react_1.useState)(false);
    return (react_1.default.createElement(coral_system_1.Box, null,
        !value.length && !isAdding && react_1.default.createElement(coral_system_1.Box, { color: "text.note" }, "\u7A7A"),
        react_1.default.createElement(coral_system_1.Box, { display: "flex", flexDirection: "column", gap: "m" },
            value.map((item, index) => (react_1.default.createElement(InputListItem, { key: index, value: item, onBlur: (newItem) => {
                    if (newItem === item)
                        return;
                    const newValue = [...value];
                    newValue[index] = newItem;
                    onChange === null || onChange === void 0 ? void 0 : onChange(newValue);
                }, onRemove: () => {
                    const newValue = [...value];
                    newValue.splice(index, 1);
                    onChange === null || onChange === void 0 ? void 0 : onChange(newValue);
                } }))),
            isAdding && (react_1.default.createElement(InputListItem, { onBlur: (val) => {
                    if (!val)
                        return;
                    onChange === null || onChange === void 0 ? void 0 : onChange(value.concat([val]));
                    setIsAdding(false);
                }, onRemove: () => {
                    setIsAdding(false);
                } }))),
        react_1.default.createElement(coral_system_1.Box, { mt: "m" },
            react_1.default.createElement(antd_1.Button, { icon: react_1.default.createElement(icons_1.PlusOutlined, null), onClick: () => setIsAdding(true) }, "\u65B0\u589E"))));
}
exports.InputList = InputList;
function InputListItem({ value: valueProp, onChange, onBlur, onRemove, }) {
    const [value, setValue] = (0, react_1.useState)(valueProp);
    return (react_1.default.createElement(coral_system_1.Box, { display: "flex", gap: "m" },
        react_1.default.createElement(antd_1.Input, { placeholder: "\u8BF7\u8F93\u5165", value: value, onChange: (e) => {
                setValue(e.target.value);
                onChange === null || onChange === void 0 ? void 0 : onChange(e.target.value);
            }, onBlur: () => onBlur === null || onBlur === void 0 ? void 0 : onBlur(value) }),
        react_1.default.createElement(antd_1.Tooltip, { title: "\u5220\u9664" },
            react_1.default.createElement(antd_1.Button, { type: "text", icon: react_1.default.createElement(icons_1.DeleteOutlined, null), onClick: onRemove }))));
}
