"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsonView = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const react_json_view_1 = tslib_1.__importDefault(require("react-json-view"));
function JsonView(_a) {
    var { enableCopy, onCopy } = _a, rest = tslib_1.__rest(_a, ["enableCopy", "onCopy"]);
    return (react_1.default.createElement(react_json_view_1.default, Object.assign({ name: false, iconStyle: "square", quotesOnKeys: false, displayDataTypes: false, enableClipboard: enableCopy
            ? (data) => {
                const valuePath = getJsonValuePath(data.namespace);
                const ret = onCopy === null || onCopy === void 0 ? void 0 : onCopy(valuePath, data);
                navigator.clipboard.writeText(ret || valuePath);
            }
            : false }, rest)));
}
exports.JsonView = JsonView;
const numPattern = /^\d+$/;
function getJsonValuePath(namespace) {
    if (!Array.isArray(namespace)) {
        return;
    }
    if (namespace[0] === false) {
        namespace = namespace.slice(1);
    }
    return [...namespace].reduce((prev, cur) => {
        if (numPattern.test(cur)) {
            prev = `${prev}[${cur}]`;
        }
        else {
            prev = prev ? [prev, cur].join('?.') : cur;
        }
        return prev;
    }, '');
}
