import React from 'react';
type MenuItemType = {
    /**
     * 标识符
     */
    key: string;
    /**
     * 文案
     */
    label: string;
    /**
     * 附加文案
     */
    note?: string;
    /**
     * 是否可编辑
     */
    editable?: boolean;
    /**
     * 是否可删除
     */
    deletable?: boolean;
    /**
     * 删除时的确认消息
     */
    deletableConfirm?: string;
};
export interface MenuProps {
    items?: MenuItemType[];
    activeKey?: string;
    onItemClick?: (activeKey: string) => void;
    onEdit?: (activeKey: string) => void;
    onDelete?: (activeKey: string) => void;
}
export declare function Menu({ items, activeKey, onItemClick, onEdit, onDelete, }: MenuProps): React.JSX.Element;
export {};
