"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TangoComponentsEntryModule = void 0;
const tslib_1 = require("tslib");
const path_1 = tslib_1.__importDefault(require("path"));
const mobx_1 = require("mobx");
const module_1 = require("./module");
const helpers_1 = require("../helpers");
/**
 * 本地组件目录的入口文件，例如 '/components/index.js' 或 `/blocks/index.js`
 */
class TangoComponentsEntryModule extends module_1.TangoModule {
    constructor(workspace, props) {
        super(workspace, props, false);
        this.update(props.code, false, false);
        (0, mobx_1.makeObservable)(this, {
            _code: mobx_1.observable,
            _cleanCode: mobx_1.observable,
            exportList: mobx_1.observable,
            code: mobx_1.computed,
            cleanCode: mobx_1.computed,
            update: mobx_1.action,
        });
    }
    _analysisAst() {
        const baseDir = path_1.default.dirname(this.filename);
        const { exportMap } = (0, helpers_1.traverseComponentsEntryFile)(this.ast, baseDir);
        this.exportList = exportMap;
        Object.keys(this.exportList).forEach((key) => {
            this.workspace.componentPrototypes.set(key, {
                name: key,
                exportType: 'namedExport',
                package: baseDir,
                type: 'element',
            });
        });
    }
}
exports.TangoComponentsEntryModule = TangoComponentsEntryModule;
