import { ISelectedItemData } from '@music163/tango-helpers';
import { DropTarget } from './drop-target';
import { IWorkspace } from './interfaces';
/**
 * 拖拽来源类，被拖拽的物体
 */
export declare class DragSource {
    /**
     * 是否处于拖拽状态
     */
    isDragging: boolean;
    /**
     * 选中的目标元素数据
     */
    data: ISelectedItemData;
    /**
     * 放置目标
     */
    dropTarget: DropTarget;
    private readonly workspace;
    get node(): import("./interfaces").IViewNode;
    /**
     * 获取对应的 prototype
     */
    get prototype(): import("@music163/tango-helpers").IComponentPrototype;
    get id(): string;
    get name(): string;
    get bounding(): import("@music163/tango-helpers").ElementBoundingType;
    constructor(workspace: IWorkspace);
    /**
     * 更新选中数据
     * @param props
     */
    set(data: ISelectedItemData): void;
    /**
     * 重置
     */
    clear(): void;
    /**
     * 获取对应的 node
     * @deprecated
     */
    getNode(): import("./interfaces").IViewNode;
}
