import { ISelectedItemData } from '@music163/tango-helpers';
import { IWorkspace } from './interfaces';
export declare enum DropMethod {
    ReplaceNode = "replaceNode",// 替换节点
    InsertBefore = "insertBefore",// 插入节点，放置在前面
    InsertAfter = "insertAfter",// 插入节点，放置在后面
    InsertChild = "insertChild",// 插入子节点，放置在最后
    InsertFirstChild = "insertFirstChild"
}
/**
 * 放置目标类
 */
export declare class DropTarget {
    /**
     * 插入方法
     */
    method: DropMethod;
    /**
     * 放置的目标元素数据
     */
    data: ISelectedItemData;
    private readonly workspace;
    get node(): import("./interfaces").IViewNode;
    /**
     * 获取对应的 prototype
     */
    get prototype(): import("@music163/tango-helpers").IComponentPrototype;
    get id(): string;
    get bounding(): import("@music163/tango-helpers").ElementBoundingType;
    get display(): string;
    constructor(workspace: IWorkspace);
    set(data: ISelectedItemData, method: DropMethod): void;
    /**
     * 重置
     */
    clear(): void;
    /**
     * 获取对应的 node
     * @deprecated
     */
    getNode(): import("./interfaces").IViewNode;
}
