"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DropTarget = exports.DropMethod = void 0;
const mobx_1 = require("mobx");
var DropMethod;
(function (DropMethod) {
    DropMethod["ReplaceNode"] = "replaceNode";
    DropMethod["InsertBefore"] = "insertBefore";
    DropMethod["InsertAfter"] = "insertAfter";
    DropMethod["InsertChild"] = "insertChild";
    DropMethod["InsertFirstChild"] = "insertFirstChild";
})(DropMethod || (exports.DropMethod = DropMethod = {}));
/**
 * 放置目标类
 */
class DropTarget {
    get node() {
        return this.workspace.getNode(this.data.id, this.data.filename);
    }
    /**
     * 获取对应的 prototype
     */
    get prototype() {
        var _a, _b;
        return ((_a = this.data) === null || _a === void 0 ? void 0 : _a.name) ? this.workspace.getPrototype((_b = this.data) === null || _b === void 0 ? void 0 : _b.name) : null;
    }
    get id() {
        var _a;
        return (_a = this.data) === null || _a === void 0 ? void 0 : _a.id;
    }
    get bounding() {
        var _a;
        return (_a = this.data) === null || _a === void 0 ? void 0 : _a.bounding;
    }
    get display() {
        var _a;
        return (_a = this.data) === null || _a === void 0 ? void 0 : _a.display;
    }
    constructor(workspace) {
        this.workspace = workspace;
        this.method = DropMethod.InsertAfter;
        this.data = null;
        (0, mobx_1.makeObservable)(this, {
            method: mobx_1.observable,
            data: mobx_1.observable,
            set: mobx_1.action,
            clear: mobx_1.action,
            node: mobx_1.computed,
        });
    }
    set(data, method) {
        this.data = data;
        this.method = method;
    }
    /**
     * 重置
     */
    clear() {
        this.data = null;
    }
    /**
     * 获取对应的 node
     * @deprecated
     */
    getNode() {
        return this.node;
    }
}
exports.DropTarget = DropTarget;
