"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TangoNode = void 0;
const helpers_1 = require("../helpers");
/**
 * 视图节点类
 */
class TangoNode {
    get loc() {
        var _a;
        return (_a = this.rawNode) === null || _a === void 0 ? void 0 : _a.loc;
    }
    constructor(props) {
        this.file = props.file;
        this.id = props.id;
        this.component = props.component;
        this.rawNode = props.rawNode;
        this.props = (0, helpers_1.getJSXElementAttributes)((0, helpers_1.cloneJSXElement)(props.rawNode));
    }
    /**
     * 返回克隆后的 ast 节点
     * @param overrideProps 额外设置给克隆节点的属性
     * @returns
     */
    cloneRawNode(overrideProps) {
        return (0, helpers_1.cloneJSXElement)(this.rawNode, overrideProps);
    }
    /**
     * 清空节点的指向，交给 GC 去回收
     */
    destroy() {
        this.file = null;
    }
}
exports.TangoNode = TangoNode;
