import { IRouteData, IFileConfig } from '../types';
import { IWorkspace } from './interfaces';
import { TangoModule } from './module';
/**
 * 路由配置模块
 */
export declare class TangoRouteModule extends TangoModule {
    _routes: IRouteData[];
    get routes(): IRouteData[];
    constructor(workspace: IWorkspace, props: IFileConfig);
    /**
     * 根据路由地址获取 route 对象
     */
    getRouteByRoutePath(route: string): IRouteData;
    /**
     * 添加一条新路由
     * @param name
     */
    addRoute(routePath: string, importFilePath: string): this;
    /**
     * 更新页面路由
     * @param oldRoutePath
     * @param newRoutePath
     * @returns
     */
    updateRoute(oldRoutePath: string, newRoutePath: string): this;
    /**
     * 删除一条路由
     * @param route 路由地址
     */
    removeRoute(route: string): this;
    _analysisAst(): void;
}
