import { Dict } from '@music163/tango-helpers';
import { IFileConfig } from '../types';
import { IWorkspace } from './interfaces';
import { TangoModule } from './module';
/**
 * 数据服务模块
 */
export declare class TangoServiceModule extends TangoModule {
    /**
     * 服务函数的模块名，默认为 index
     */
    name: string;
    /**
     * 原始注册的服务函数
     * @example { get: {}, list: {} }
     */
    _serviceFunctions: Dict;
    /**
     * 原始的基础配置
     */
    _baseConfig: Dict;
    get serviceFunctions(): Dict;
    get baseConfig(): Dict;
    constructor(workspace: IWorkspace, props: IFileConfig);
    _analysisAst(): void;
    addServiceFunction(name: string, config: object): this;
    /**
     * 批量添加服务函数
     * @param configs { [name: string]: object }
     * @returns
     */
    addServiceFunctions(configs: Dict<object>): this;
    updateServiceFunction(name: string, payload: object): this;
    deleteServiceFunction(serviceFunctionName: string): this;
    /**
     * 更新服务的基础配置
     */
    updateBaseConfig(data: object): this;
}
