"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Panel = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const classnames_1 = tslib_1.__importDefault(require("classnames"));
const coral_system_1 = require("coral-system");
const tango_helpers_1 = require("@music163/tango-helpers");
const headerStyle = (0, coral_system_1.css) `
  user-select: none;
  display: flex;
  justify-content: space-between;
  align-items: center;
`;
function Panel(_a) {
    var { shape = 'light', title, subTitle: subTitleProp, extra, headerProps: headerPropsProp, bodyProps: bodyPropsProp, children, className } = _a, rest = tslib_1.__rest(_a, ["shape", "title", "subTitle", "extra", "headerProps", "bodyProps", "children", "className"]);
    const systemProps = (0, react_1.useMemo)(() => {
        let rootProps;
        let headerProps;
        let bodyProps;
        if (shape === 'solid') {
            rootProps = {
                border: 'solid',
                borderColor: 'line.normal',
            };
            headerProps = {
                borderBottom: 'solid',
                borderBottomColor: 'line.normal',
                p: 'm',
                lineHeight: '24px',
            };
            bodyProps = {
                p: 'm',
            };
        }
        return {
            rootProps,
            headerProps: (0, tango_helpers_1.merge)(headerProps, headerPropsProp),
            bodyProps: (0, tango_helpers_1.merge)(bodyProps, bodyPropsProp),
        };
    }, [shape, headerPropsProp, bodyPropsProp]);
    const subTitle = typeof subTitleProp === 'string' && subTitleProp ? (react_1.default.createElement(coral_system_1.Text, { ml: "m", fontSize: "note" }, subTitleProp)) : (subTitleProp);
    const showHeader = !!(title || subTitle || extra);
    return (react_1.default.createElement(coral_system_1.Box, Object.assign({ display: "flex", flexDirection: "column", overflow: "auto", bg: "white" }, systemProps.rootProps, { className: (0, classnames_1.default)('Panel', className) }, rest),
        showHeader && (react_1.default.createElement(coral_system_1.Box, Object.assign({ flex: "0", px: "m", py: "s" }, systemProps.headerProps, { css: headerStyle, className: "PanelHeader" }),
            react_1.default.createElement(coral_system_1.Box, null,
                react_1.default.createElement(coral_system_1.Text, { color: "text.title", fontWeight: "500" }, title),
                subTitle && react_1.default.createElement(coral_system_1.Text, { ml: "s" }, subTitle)),
            extra)),
        react_1.default.createElement(coral_system_1.Box, Object.assign({ flex: "1", overflowY: "auto" }, systemProps.bodyProps, { className: "PanelBody" }), children)));
}
exports.Panel = Panel;
