import type { AxiosInstance, AxiosRequestConfig } from 'axios';
export interface RequestConfig extends AxiosRequestConfig {
    /**
     * 响应格式化函数
     * @param data 响应数据
     * @returns 返回格式化后的数据
     */
    formatter?: (data: any) => any;
    /**
     * 路径变量，例如 `/users/:id`，其中 id 为路径变量
     */
    pathVariables?: Record<string, any>;
}
export interface RequestInstance extends AxiosInstance {
    get: (url: string, params?: object, config?: RequestConfig) => Promise<any>;
    postFormData: (url: string, data?: object, config?: RequestConfig) => Promise<any>;
    postFormUrlencoded: (url: string, data?: object, config?: RequestConfig) => Promise<any>;
}
declare const _default: RequestInstance;
export default _default;
