"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Search = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const coral_system_1 = require("coral-system");
const antd_1 = require("antd");
const icons_1 = require("@ant-design/icons");
function Search(_a) {
    var { placeholder = '请输入关键词', onChange, width, escapeValue = true, style: styleProp = {} } = _a, rest = tslib_1.__rest(_a, ["placeholder", "onChange", "width", "escapeValue", "style"]);
    const style = Object.assign({ width }, styleProp);
    return (react_1.default.createElement(antd_1.Input, Object.assign({ placeholder: placeholder, onChange: (e) => {
            let next = e.target.value;
            if (escapeValue) {
                next = next.replaceAll('\\', '\\\\');
            }
            onChange === null || onChange === void 0 ? void 0 : onChange(next);
        }, suffix: react_1.default.createElement(coral_system_1.Text, { color: "text.placeholder" },
            react_1.default.createElement(icons_1.SearchOutlined, null)), allowClear: true, style: style }, rest)));
}
exports.Search = Search;
