"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SelectList = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const coral_system_1 = require("coral-system");
const antd_1 = require("antd");
const icons_1 = require("@ant-design/icons");
function SelectList({ value = [], onChange, options = [], isUniqueValue = false, }) {
    const [isAdding, setIsAdding] = (0, react_1.useState)(false);
    if (isUniqueValue) {
        options = options.filter((option) => value.indexOf(option.value) < 0);
    }
    return (react_1.default.createElement(coral_system_1.Box, null,
        !value.length && !isAdding && react_1.default.createElement(coral_system_1.Box, { color: "text.note" }, "\u7A7A"),
        react_1.default.createElement(coral_system_1.Box, { display: "flex", flexDirection: "column", gap: "m" },
            value.map((item, index) => (react_1.default.createElement(SelectListItem, { key: index, options: options, value: item, onChange: (newItem) => {
                    if (newItem === item)
                        return;
                    const newValue = [...value];
                    newValue[index] = newItem;
                    onChange === null || onChange === void 0 ? void 0 : onChange(newValue);
                }, onRemove: () => {
                    const newValue = [...value];
                    newValue.splice(index, 1);
                    onChange === null || onChange === void 0 ? void 0 : onChange(newValue);
                } }))),
            isAdding && (react_1.default.createElement(SelectListItem, { options: options, onChange: (val) => {
                    if (!val)
                        return;
                    onChange === null || onChange === void 0 ? void 0 : onChange(value.concat([val]));
                    setIsAdding(false);
                }, onRemove: () => {
                    setIsAdding(false);
                } }))),
        react_1.default.createElement(coral_system_1.Box, { mt: "m" },
            react_1.default.createElement(antd_1.Button, { icon: react_1.default.createElement(icons_1.PlusOutlined, null), onClick: () => setIsAdding(true) }, "\u65B0\u589E"))));
}
exports.SelectList = SelectList;
const selectStyle = {
    flex: 1,
};
function SelectListItem({ value, onChange, onRemove, options, }) {
    return (react_1.default.createElement(coral_system_1.Box, { display: "flex", gap: "m" },
        react_1.default.createElement(antd_1.Select, { placeholder: "\u8BF7\u9009\u62E9", options: options, value: value, onChange: (val) => {
                onChange === null || onChange === void 0 ? void 0 : onChange(val);
            }, style: selectStyle }),
        react_1.default.createElement(antd_1.Tooltip, { title: "\u5220\u9664" },
            react_1.default.createElement(antd_1.Button, { type: "text", icon: react_1.default.createElement(icons_1.DeleteOutlined, null), onClick: onRemove }))));
}
