"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActionListSetter = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const antd_1 = require("antd");
const list_setter_1 = require("./list-setter");
const defaultNewOptionValue = {
    key: '1',
    label: '按钮',
};
const shapes = [
    { label: '普通按钮', value: 'button' },
    { label: '文本按钮', value: 'text' },
];
const buttonTypes = [
    { label: '主要', value: 'primary' },
    { label: '次要', value: 'secondary' },
    { label: '普通', value: 'normal' },
];
const types = [
    { label: '普通动作', value: 'action' },
    { label: '确认提示', value: 'confirm' },
];
const optionFormFields = [
    { label: 'key', name: 'key', required: true },
    { label: '文本', name: 'label', required: true },
    { label: '外观', name: 'shape', component: react_1.default.createElement(antd_1.Select, { placeholder: "\u8BF7\u9009\u62E9", options: shapes }) },
    {
        label: '按钮类型',
        name: 'buttonType',
        component: react_1.default.createElement(antd_1.Select, { placeholder: "\u8BF7\u9009\u62E9", options: buttonTypes }),
    },
    { label: '类型', name: 'actionType', component: react_1.default.createElement(antd_1.Select, { placeholder: "\u8BF7\u9009\u62E9", options: types }) },
    { label: '确认气泡内容', name: 'confirmContent' },
];
const getKey = (item) => item.key;
const renderItem = (item) => item.label;
/**
 * 列表项设置器
 */
function ActionListSetter(props) {
    return (react_1.default.createElement(list_setter_1.ListSetter, Object.assign({ getListItemKey: getKey, renderItem: renderItem, listItemFormFields: optionFormFields, newItemDefaultValues: defaultNewOptionValue }, props)));
}
exports.ActionListSetter = ActionListSetter;
