"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ColumnSetter = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const antd_1 = require("antd");
const coral_system_1 = require("coral-system");
const icons_1 = require("@ant-design/icons");
const list_setter_1 = require("./list-setter");
const defaultNewOptionValue = {
    // key: 'c1',
    // dataIndex: 'option',
    title: 'Column',
    // width: '200px',
};
const optionFormFields = [
    { label: 'key', name: 'key', required: true },
    { label: 'dataIndex', name: 'dataIndex', required: true },
    { label: '列标题', name: 'title', required: true },
    { label: '列宽', name: 'width' },
    { label: '锁列', name: 'fixed', valuePropName: 'checked', component: react_1.default.createElement(antd_1.Switch, null) },
];
const renderSetterItem = (item) => {
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(icons_1.FieldStringOutlined, null),
        react_1.default.createElement(coral_system_1.Box, { display: "inline-block", ml: "m" }, item.title)));
};
/**
 * 表格列设置器
 */
function ColumnSetter(props) {
    return (react_1.default.createElement(list_setter_1.ListSetter, Object.assign({ getListItemKey: (item) => item.key || item.dataIndex, addBtnText: "\u6DFB\u52A0\u65B0\u5217", listItemFormFields: optionFormFields, newItemDefaultValues: defaultNewOptionValue, renderItem: renderSetterItem }, props)));
}
exports.ColumnSetter = ColumnSetter;
