"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TimeRangeSetter = exports.TimeSetter = exports.DateRangeSetter = exports.DateSetter = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const moment_1 = tslib_1.__importDefault(require("moment"));
const antd_1 = require("antd");
function toMoment(value, format) {
    let ret;
    if (moment_1.default.isMoment(value)) {
        ret = value;
    }
    else if (typeof value === 'string' && format) {
        ret = (0, moment_1.default)(value, format);
    }
    else {
        ret = (0, moment_1.default)();
    }
    if (ret && ret.isValid()) {
        return ret;
    }
    return;
}
const style = {
    width: '100%',
};
function DateSetter(_a) {
    var { value, onChange, format = 'YYYY-MM-DD' } = _a, rest = tslib_1.__rest(_a, ["value", "onChange", "format"]);
    return (react_1.default.createElement(antd_1.DatePicker, Object.assign({}, rest, { format: format, style: style, value: value ? toMoment(value, format) : undefined, onChange: (val, str) => {
            onChange && onChange(str);
        } })));
}
exports.DateSetter = DateSetter;
function toMoments(value, format) {
    if (Array.isArray(value)) {
        return value.map((item) => toMoment(item, format));
    }
    return [];
}
function DateRangeSetter(_a) {
    var { value, onChange, format = 'YYYY-MM-DD' } = _a, rest = tslib_1.__rest(_a, ["value", "onChange", "format"]);
    return (react_1.default.createElement(antd_1.DatePicker.RangePicker, Object.assign({}, rest, { style: style, format: format, value: toMoments(value, format), onChange: (val, str) => {
            onChange && onChange(str);
        } })));
}
exports.DateRangeSetter = DateRangeSetter;
function TimeSetter(_a) {
    var { value, onChange, format = 'HH:mm:ss' } = _a, rest = tslib_1.__rest(_a, ["value", "onChange", "format"]);
    return (react_1.default.createElement(antd_1.TimePicker, Object.assign({}, rest, { format: format, style: style, value: toMoment(value, format), onChange: (val, str) => {
            onChange && onChange(str);
        } })));
}
exports.TimeSetter = TimeSetter;
function TimeRangeSetter(_a) {
    var { value, onChange, format = 'HH:mm:ss' } = _a, rest = tslib_1.__rest(_a, ["value", "onChange", "format"]);
    return (react_1.default.createElement(antd_1.TimePicker.RangePicker, Object.assign({}, rest, { style: style, format: format, value: toMoments(value, format), onChange: (val, str) => {
            onChange && onChange(str);
        } })));
}
exports.TimeRangeSetter = TimeRangeSetter;
