"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.registerBuiltinSetters = exports.BUILT_IN_SETTERS = void 0;
const tango_setting_form_1 = require("@music163/tango-setting-form");
const action_list_setter_1 = require("./action-list-setter");
const column_setter_1 = require("./column-setter");
const css_setter_1 = require("./css-setter");
const date_setter_1 = require("./date-setter");
const enum_setter_1 = require("./enum-setter");
const event_setter_1 = require("./event-setter");
const expression_setter_1 = require("./expression-setter");
const json_setter_1 = require("./json-setter");
const jsx_setter_1 = require("./jsx-setter");
const list_setter_1 = require("./list-setter");
const model_setter_1 = require("./model-setter");
const option_setter_1 = require("./option-setter");
const picker_setter_1 = require("./picker-setter");
const render_setter_1 = require("./render-setter");
const router_setter_1 = require("./router-setter");
const style_setter_1 = require("./style-setter");
const choice_setter_1 = require("./choice-setter");
exports.BUILT_IN_SETTERS = [
    {
        name: 'codeSetter',
        alias: ['expSetter', 'expressionSetter'],
        component: expression_setter_1.ExpressionSetter,
        type: 'code',
    },
    {
        name: 'radioGroupSetter',
        alias: ['choiceSetter'],
        component: choice_setter_1.ChoiceSetter,
    },
    {
        name: 'actionListSetter',
        component: action_list_setter_1.ActionListSetter,
    },
    {
        name: 'tableColumnsSetter',
        alias: ['columnSetter'], // 兼容
        component: column_setter_1.ColumnSetter,
    },
    {
        name: 'cssSetter',
        component: css_setter_1.CssSetter,
    },
    {
        name: 'dateSetter',
        component: date_setter_1.DateSetter,
    },
    {
        name: 'dateRangeSetter',
        component: date_setter_1.DateRangeSetter,
    },
    {
        name: 'timeSetter',
        component: date_setter_1.DateRangeSetter,
    },
    {
        name: 'timeRangeSetter',
        component: date_setter_1.TimeRangeSetter,
    },
    {
        name: 'enumSetter',
        component: enum_setter_1.EnumSetter,
    },
    {
        name: 'eventSetter',
        alias: ['actionSetter', 'functionSetter', 'callbackSetter'],
        component: event_setter_1.EventSetter,
    },
    {
        name: 'jsonSetter',
        component: json_setter_1.JSONSetter,
        type: 'code',
    },
    {
        name: 'jsxSetter',
        component: jsx_setter_1.JsxSetter,
        type: 'code',
    },
    {
        name: 'listSetter',
        component: list_setter_1.ListSetter,
    },
    {
        name: 'modelSetter',
        component: model_setter_1.ModelSetter,
    },
    {
        name: 'optionSetter',
        component: option_setter_1.OptionSetter,
    },
    {
        name: 'selectSetter',
        alias: ['pickerSetter'],
        component: picker_setter_1.PickerSetter,
    },
    {
        name: 'renderPropsSetter',
        component: render_setter_1.RenderSetter,
        type: 'code',
    },
    {
        name: 'tableCellSetter',
        component: render_setter_1.TableCellSetter,
        type: 'code',
    },
    {
        name: 'tableExpandableSetter',
        component: render_setter_1.TableExpandableSetter,
        type: 'code',
    },
    {
        name: 'routerSetter',
        component: router_setter_1.RouterSetter,
    },
    {
        name: 'displaySetter',
        component: style_setter_1.DisplaySetter,
    },
    { name: 'flexDirectionSetter', component: style_setter_1.FlexDirectionSetter },
    {
        name: 'flexGapSetter',
        component: style_setter_1.FlexGapSetter,
    },
    {
        name: 'flexJustifyContentSetter',
        component: style_setter_1.FlexJustifyContentSetter,
    },
    {
        name: 'flexAlignItemsSetter',
        component: style_setter_1.FlexAlignItemsSetter,
    },
    {
        name: 'spacingSetter',
        component: style_setter_1.SpacingSetter,
    },
    {
        name: 'colorSetter',
        component: style_setter_1.ColorSetter,
    },
    { name: 'bgSetter', component: style_setter_1.BgSetter },
    { name: 'borderSetter', component: style_setter_1.BorderSetter },
];
function registerBuiltinSetters() {
    exports.BUILT_IN_SETTERS.forEach(tango_setting_form_1.register);
}
exports.registerBuiltinSetters = registerBuiltinSetters;
