"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JSONSetter = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const coral_system_1 = require("coral-system");
const tango_ui_1 = require("@music163/tango-ui");
/**
 * JSON Setter
 */
function JSONSetter({ value: valueProp, onChange }) {
    const [value, setValue] = (0, react_1.useState)(valueProp || '');
    return (react_1.default.createElement(coral_system_1.Box, { height: "120px", border: "solid", borderColor: "line.normal", borderRadius: "s" },
        react_1.default.createElement(tango_ui_1.SingleMonacoEditor, { defaultValue: value, onChange: (newValue) => {
                setValue(newValue);
            }, onBlur: (newValue) => {
                if (newValue !== value) {
                    onChange(newValue);
                }
            }, language: "json", options: {
                lineNumbers: 'off',
                minimap: {
                    enabled: false,
                },
            } })));
}
exports.JSONSetter = JSONSetter;
