"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JsxSetter = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const tango_ui_1 = require("@music163/tango-ui");
const coral_system_1 = require("coral-system");
const options = [
    { label: '取消自定义', value: '' },
    { label: '自定义区域', value: 'Box' },
    { label: '文本', value: 'Text' },
    { label: '占位区域', value: 'Placeholder' },
    { label: '按钮组', value: 'ButtonGroup' },
];
const defaultGetTemplate = (key) => {
    let ret;
    switch (key) {
        case 'Box':
            ret = ['<Box></Box>', ['Box']];
            break;
        case 'Text':
            ret = ['<Text>示例文本</Text>', ['Text']];
            break;
        case 'Placeholder':
            ret = ['<Placeholder text="拖拽到此进行替换" />', ['Placeholder']];
            break;
        case 'ButtonGroup':
            ret = [
                '<ButtonGroup><Button>按钮1</Button><Button>按钮2</Button></ButtonGroup>',
                ['ButtonGroup', 'Button'],
            ];
            break;
        default:
            break;
    }
    return ret;
};
/**
 * 自定义结点渲染器，适用于值类型为 ReactNode 的属性
 */
function JsxSetter(props) {
    const { showInput, getTemplate = defaultGetTemplate, value, onChange } = props;
    const [inputValue, setInputValue] = (0, react_1.useState)(value);
    (0, react_1.useEffect)(() => {
        setInputValue(value);
    }, [value]);
    return (react_1.default.createElement(coral_system_1.Box, null,
        react_1.default.createElement(tango_ui_1.ActionSelect, { showInput: showInput, defaultInputValue: value, options: options, text: "\u8BBE\u7F6E\u6B64\u533A\u57DF\u4E3A", onInputChange: onChange, onSelect: (key) => {
                const [tpl, deps] = getTemplate(key);
                if (tpl) {
                    onChange(tpl, { relatedImports: deps });
                }
                else {
                    onChange(undefined);
                }
            } }),
        value && (react_1.default.createElement(tango_ui_1.InputCode, { value: value, onChange: (val) => setInputValue(val), onBlur: () => {
                onChange(inputValue);
            } }))));
}
exports.JsxSetter = JsxSetter;
