"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.OptionSetter = void 0;
const tslib_1 = require("tslib");
const tango_helpers_1 = require("@music163/tango-helpers");
const react_1 = tslib_1.__importDefault(require("react"));
const list_setter_1 = require("./list-setter");
const optionFormFields = [
    { label: '文案', name: 'label', required: true },
    { label: '值', name: 'value', required: true },
];
const getKey = (item) => item.value;
const renderItem = (item) => item.label;
/**
 * 列表项设置器
 */
function OptionSetter(props) {
    return (react_1.default.createElement(list_setter_1.ListSetter, Object.assign({ getListItemKey: getKey, renderItem: renderItem, listItemFormFields: optionFormFields, getNewItemDefaultValues: () => {
            const randomStr = (0, tango_helpers_1.uuid)('_', 4);
            return {
                label: `选项${randomStr}`,
                value: randomStr,
            };
        } }, props)));
}
exports.OptionSetter = OptionSetter;
