"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RouterSetter = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const coral_system_1 = require("coral-system");
const antd_1 = require("antd");
const tango_helpers_1 = require("@music163/tango-helpers");
const tango_context_1 = require("@music163/tango-context");
const picker_setter_1 = require("./picker-setter");
function RouterSetter(props) {
    const [type, setType] = (0, react_1.useState)(() => {
        return (0, tango_helpers_1.isValidUrl)(props.value) ? 'input' : 'select';
    });
    const [input, setInput] = (0, react_1.useState)(props.value);
    const { routeOptions } = (0, tango_context_1.useWorkspaceData)();
    const displayType = props.type || 'both';
    (0, react_1.useEffect)(() => {
        displayType === 'router' ? setType('select') : setType('input');
    }, [displayType]);
    return (react_1.default.createElement(coral_system_1.Box, null,
        react_1.default.createElement(coral_system_1.Box, { mb: "m" }, ['both', 'router'].includes(displayType) && (react_1.default.createElement(antd_1.Radio.Group, { value: type, optionType: "button", buttonStyle: "solid", onChange: (e) => setType(e.target.value) },
            react_1.default.createElement(antd_1.Radio, { value: "select" }, "\u9009\u62E9\u8DEF\u7531"),
            react_1.default.createElement(antd_1.Radio, { value: "input" }, "\u81EA\u5B9A\u4E49\u8F93\u5165")))),
        type === 'select' && (react_1.default.createElement(picker_setter_1.PickerSetter, Object.assign({ placeholder: "\u8BF7\u9009\u62E9\u672C\u5730\u8DEF\u7531", options: routeOptions }, props))),
        type === 'input' && (react_1.default.createElement(antd_1.Input, Object.assign({ placeholder: `请输入任意${{ link: '链接', router: '路由', both: '' }[displayType]}地址` }, props, { value: input, onChange: (e) => setInput(e.target.value), onBlur: () => props === null || props === void 0 ? void 0 : props.onChange(input) })))));
}
exports.RouterSetter = RouterSetter;
