"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DataSourcePanel = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const coral_system_1 = require("coral-system");
const tango_ui_1 = require("@music163/tango-ui");
const interface_config_1 = tslib_1.__importDefault(require("./interface-config"));
const proxy_config_1 = tslib_1.__importDefault(require("./proxy-config"));
function DataSourcePanel(props) {
    return (react_1.default.createElement(coral_system_1.Box, { className: "DataSourceView", height: "100%", overflowY: "auto" },
        react_1.default.createElement(tango_ui_1.Tabs, { size: "small", isTabBarSticky: true, 
            // 切换 tab 时销毁其他 tab，以解决添加数据源后，接口服务函数内的应用不会更新的问题
            destroyInactiveTabPane: true, items: [
                {
                    key: 'interface',
                    label: '服务函数',
                    children: react_1.default.createElement(interface_config_1.default, Object.assign({}, props)),
                },
                {
                    key: 'proxy',
                    label: '代理',
                    children: react_1.default.createElement(proxy_config_1.default, null),
                },
            ] })));
}
exports.DataSourcePanel = DataSourcePanel;
