"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.shapeServiceValues = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const tango_context_1 = require("@music163/tango-context");
const coral_system_1 = require("coral-system");
const components_1 = require("../../components");
const context_1 = require("../../context");
// 移除掉不必要的属性
function shapeServiceValues(val) {
    const shapeValues = Object.assign({}, val);
    delete shapeValues.type;
    return shapeValues;
}
exports.shapeServiceValues = shapeServiceValues;
const DataSourceView = (0, tango_context_1.observer)(() => {
    const sandbox = (0, context_1.useSandboxQuery)();
    const workspace = (0, tango_context_1.useWorkspace)();
    const { serviceVariables } = (0, tango_context_1.useWorkspaceData)();
    const serviceModules = Object.keys(workspace.serviceModules).map((key) => ({
        label: key === 'index' ? '默认模块' : key,
        value: key,
    }));
    return (react_1.default.createElement(coral_system_1.Box, { className: "ServiceFunctionList", p: "m" },
        react_1.default.createElement(components_1.VariableTree, { dataSource: serviceVariables, appContext: sandbox === null || sandbox === void 0 ? void 0 : sandbox.window['tango'], serviceModules: serviceModules, onRemoveService: (variableKey) => {
                workspace.removeServiceFunction(variableKey);
            }, onAddService: (data) => {
                const _a = shapeServiceValues(data), { name, moduleName } = _a, payload = tslib_1.__rest(_a, ["name", "moduleName"]);
                workspace.addServiceFunction(name, payload, moduleName);
            }, onUpdateService: (data) => {
                const _a = shapeServiceValues(data), { name, moduleName } = _a, payload = tslib_1.__rest(_a, ["name", "moduleName"]);
                workspace.updateServiceFunction(name, payload, moduleName);
            }, getServiceData: (serviceKey) => {
                const data = workspace.getServiceFunction(serviceKey);
                return Object.assign({ name: data.name, moduleName: data.moduleName, method: 'get' }, data.config);
            } })));
});
exports.default = DataSourceView;
