"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.proxyManageFormStyle = exports.proxyRuleStyle = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const tango_context_1 = require("@music163/tango-context");
const tango_ui_1 = require("@music163/tango-ui");
const coral_system_1 = require("coral-system");
const antd_1 = require("antd");
const icons_1 = require("@ant-design/icons");
exports.default = (0, tango_context_1.observer)(() => {
    var _a;
    const workspace = (0, tango_context_1.useWorkspace)();
    return (react_1.default.createElement(tango_ui_1.ConfigGroup, { title: "\u4EE3\u7406\u8BBE\u7F6E" },
        react_1.default.createElement(tango_ui_1.ConfigItem, { title: "proxy", description: "\u8FD9\u91CC\u53EF\u4EE5\u914D\u7F6E\u63A5\u53E3\u8F6C\u53D1\u7684\u4EE3\u7406\u89C4\u5219", layoutDirection: "column" },
            react_1.default.createElement(ProxyManage, { initialValues: (_a = workspace.tangoConfigJson) === null || _a === void 0 ? void 0 : _a.getValue('proxy'), onSave: (value) => {
                    var _a;
                    (_a = workspace.tangoConfigJson) === null || _a === void 0 ? void 0 : _a.setValue('proxy', value).update();
                    antd_1.message.success('proxy 规则更新成功！');
                } }))));
});
exports.proxyRuleStyle = (0, coral_system_1.css) `
  position: relative;
  border: 1px dashed #f0f0f0;
  padding-top: 24px;
  border-radius: 4px;
  margin-bottom: 8px;

  &:hover {
    border-color: var(--tango-colors-brand);
  }

  > .RuleRemoveBtn {
    position: absolute;
    top: 0;
    right: 0;
  }

  .RuleHeaderItem {
    margin-bottom: 10px;
  }
`;
exports.proxyManageFormStyle = {
    labelCol: {
        span: 6,
    },
    wrapperCol: {
        span: 16,
    },
    autoComplete: 'off',
    colon: false,
};
function ProxyManage({ initialValues: initialValuesProp = {}, onSave, }) {
    const initialValues = (0, react_1.useMemo)(() => {
        const proxy = Object.keys(initialValuesProp).reduce((prev, cur) => {
            prev.push(Object.assign({ path: cur }, initialValuesProp[cur]));
            return prev;
        }, []);
        return {
            proxy,
        };
    }, [initialValuesProp]);
    return (react_1.default.createElement(antd_1.Form, Object.assign({}, exports.proxyManageFormStyle, { initialValues: initialValues, onFinish: (values) => {
            const proxy = values.proxy.reduce((prev, _a) => {
                var { path } = _a, rest = tslib_1.__rest(_a, ["path"]);
                prev[path] = rest;
                return prev;
            }, {});
            onSave === null || onSave === void 0 ? void 0 : onSave(proxy);
        } }),
        react_1.default.createElement(antd_1.Form.List, { name: "proxy" }, (fields, { add, remove }) => {
            return (react_1.default.createElement(react_1.default.Fragment, null,
                fields.map((field) => (react_1.default.createElement(coral_system_1.Box, { key: field.key, css: exports.proxyRuleStyle },
                    react_1.default.createElement(antd_1.Button, { className: "RuleRemoveBtn", type: "link", icon: react_1.default.createElement(icons_1.CloseOutlined, null), onClick: () => remove(field.name) }),
                    react_1.default.createElement(antd_1.Form.Item, Object.assign({}, field, { key: "path", label: "path", name: [field.name, 'path'], rules: [{ required: true }] }),
                        react_1.default.createElement(antd_1.Input, null)),
                    react_1.default.createElement(antd_1.Form.Item, Object.assign({}, field, { key: "target", label: "target", name: [field.name, 'target'], rules: [{ required: true }] }),
                        react_1.default.createElement(antd_1.Input, null)),
                    react_1.default.createElement(antd_1.Form.Item, Object.assign({}, field, { key: "changeOrigin", label: "changeOrigin", name: [field.name, 'changeOrigin'], valuePropName: "checked" }),
                        react_1.default.createElement(antd_1.Switch, null)),
                    react_1.default.createElement(antd_1.Form.Item, { label: "\u8BF7\u6C42\u5934" },
                        react_1.default.createElement(antd_1.Form.List, { name: [field.name, 'headers'] }, (headerFields, { add: headerAdd, remove: headerRemove }) => {
                            return (react_1.default.createElement(react_1.default.Fragment, null,
                                headerFields.map((headerField) => (react_1.default.createElement(antd_1.Form.Item, { className: "RuleHeaderItem", key: headerField.key },
                                    react_1.default.createElement(coral_system_1.Box, { gap: "8px", display: "flex" },
                                        react_1.default.createElement(antd_1.Form.Item, Object.assign({}, headerField, { noStyle: true, key: "name", label: "name", name: [headerField.name, 'name'], rules: [{ required: true }] }),
                                            react_1.default.createElement(antd_1.Input, { placeholder: "Key" })),
                                        react_1.default.createElement(antd_1.Form.Item, Object.assign({}, headerField, { noStyle: true, key: "value", label: "value", name: [headerField.name, 'value'], rules: [{ required: true }] }),
                                            react_1.default.createElement(antd_1.Input, { placeholder: "Value" })),
                                        react_1.default.createElement(antd_1.Button, { type: "link", icon: react_1.default.createElement(icons_1.CloseCircleOutlined, null), onClick: () => headerRemove(headerField.name) }))))),
                                react_1.default.createElement("a", { onClick: () => headerAdd() }, "\u6DFB\u52A0\u8BF7\u6C42\u5934")));
                        }))))),
                react_1.default.createElement(coral_system_1.Box, { mt: "m", mb: "l" },
                    react_1.default.createElement(antd_1.Button, { block: true, type: "dashed", onClick: () => add() }, "\u6DFB\u52A0\u89C4\u5219"))));
        }),
        react_1.default.createElement(antd_1.Form.Item, null,
            react_1.default.createElement(antd_1.Button, { type: "primary", htmlType: "submit" }, "\u4FDD\u5B58"))));
}
