"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.HistoryPanel = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const classnames_1 = tslib_1.__importDefault(require("classnames"));
const coral_system_1 = require("coral-system");
const date_fns_1 = require("date-fns");
const tango_context_1 = require("@music163/tango-context");
exports.HistoryPanel = (0, tango_context_1.observer)(() => {
    const { history } = (0, tango_context_1.useWorkspace)();
    return (react_1.default.createElement(coral_system_1.Box, { as: "ul", p: "0", m: "0" }, history.list.map((item, index) => (react_1.default.createElement(HistoryItem, { key: item.time, data: item, className: (0, classnames_1.default)({ active: history.index === index }) })))));
});
const itemStyle = (0, coral_system_1.css) `
  line-height: 2.5;
  cursor: pointer;
  user-select: none;

  &:hover {
    background-color: var(--tango-colors-gray-10);
  }

  &.active {
    color: var(--tango-colors-brand);
  }
`;
function HistoryItem(_a) {
    var { data } = _a, rest = tslib_1.__rest(_a, ["data"]);
    const { time, message } = data;
    const formatTime = (0, react_1.useMemo)(() => {
        return (0, date_fns_1.format)(time, 'yyyy/MM/dd HH:mm:mm');
    }, [time]);
    return (react_1.default.createElement(coral_system_1.Box, Object.assign({ as: "li", display: "flex", justifyContent: "space-between", px: "m", css: itemStyle }, rest),
        react_1.default.createElement(coral_system_1.Box, null, message),
        react_1.default.createElement(coral_system_1.Box, null, formatTime)));
}
