"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.StateTree = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const tango_context_1 = require("@music163/tango-context");
const tango_helpers_1 = require("@music163/tango-helpers");
const tango_ui_1 = require("@music163/tango-ui");
const icons_1 = require("@ant-design/icons");
const context_1 = require("../../context");
function processTango(obj = {}, index = 0) {
    const ret = {};
    Object.keys(obj).forEach((key) => {
        const val = obj[key];
        if (index > 2) {
            ret[key] = val;
        }
        else if ((0, tango_helpers_1.isFunction)(val)) {
            ret[key] = '[Function]';
        }
        else if ((0, tango_helpers_1.isObject)(val)) {
            ret[key] = processTango(val, index + 1);
        }
        else {
            ret[key] = val;
        }
    });
    return ret;
}
exports.StateTree = (0, tango_context_1.observer)(() => {
    const sandboxQuery = (0, context_1.useSandboxQuery)();
    const [, forceUpdate] = (0, react_1.useReducer)((x) => x + 1, 0);
    const tangoContext = (0, tango_helpers_1.pick)(sandboxQuery.window['tango'] || {}, [
        'stores',
        'pageStore',
        'services',
        'config',
    ]);
    const callback = () => {
        forceUpdate();
    };
    (0, react_1.useEffect)(() => {
        // FIXME: 优化这段代码，应该监听 tangoContext 的变化，来刷新
        const settingForm = document.querySelector('.SettingPanel');
        const ob = new MutationObserver(callback);
        if (settingForm) {
            ob.observe(settingForm, {
                attributes: true,
                childList: true,
                subtree: true,
            });
        }
        return () => {
            ob.disconnect();
        };
    }, []);
    return (react_1.default.createElement(tango_ui_1.CollapsePanel, { title: "\u9875\u9762\u72B6\u6001", stickyHeader: true, maxHeight: "90%", overflowY: "auto", extra: react_1.default.createElement(tango_ui_1.IconButton, { tooltip: "\u540C\u6B65\u72B6\u6001", size: "small", icon: react_1.default.createElement(icons_1.ReloadOutlined, null), onClick: (e) => {
                e.stopPropagation();
                forceUpdate();
            } }) },
        react_1.default.createElement(tango_ui_1.JsonView, { src: processTango(tangoContext), collapsed: 1, name: "tango", displayObjectSize: false, indentWidth: 2, enableCopy: true })));
});
