"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.VariablePanel = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const antd_1 = require("antd");
const icons_1 = require("@ant-design/icons");
const tango_helpers_1 = require("@music163/tango-helpers");
const tango_ui_1 = require("@music163/tango-ui");
const tango_context_1 = require("@music163/tango-context");
const components_1 = require("../components");
const helpers_1 = require("../helpers");
const add_store_1 = require("../components/variable-tree/add-store");
exports.VariablePanel = (0, tango_context_1.observer)(({ newStoreTemplate = helpers_1.CODE_TEMPLATES.newStoreTemplate }) => {
    const [isAdd, { on, off }] = (0, tango_helpers_1.useBoolean)();
    const workspace = (0, tango_context_1.useWorkspace)();
    const { storeVariables } = (0, tango_context_1.useWorkspaceData)();
    const storeNames = storeVariables.map((item) => item.title);
    return (react_1.default.createElement(tango_ui_1.Panel, { className: "ModelView", height: "100%", title: "\u89C6\u56FE\u6A21\u578B\u4E0E\u53D8\u91CF\u7BA1\u7406", extra: react_1.default.createElement(antd_1.Button, { size: "small", type: "primary", icon: react_1.default.createElement(icons_1.FileAddOutlined, null), onClick: on }, "\u65B0\u5EFA\u6A21\u578B"), bodyProps: { p: 'm' } }, isAdd ? (react_1.default.createElement(add_store_1.AddStoreForm, { storeNames: storeNames, onCancel: off, onSubmit: (values) => {
            workspace.addStoreFile(values.name, newStoreTemplate);
            off();
        } })) : (react_1.default.createElement(components_1.VariableTree, { defaultValueDetailMode: "define", dataSource: storeVariables, onAddStoreVariable: (storeName, data) => {
            workspace.addStoreState(storeName, data.name, data.initialValue);
        }, onRemoveStoreVariable: (variableKey) => {
            workspace.removeStoreVariable(variableKey);
        }, onUpdateStoreVariable: (variableKey, code) => {
            workspace.updateStoreVariable(variableKey, code);
        } }))));
});
