"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.BottomBar = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const coral_system_1 = require("coral-system");
const antd_1 = require("antd");
const tango_context_1 = require("@music163/tango-context");
const itemWrapperStyle = (0, coral_system_1.css) `
  user-select: none;

  &:hover {
    color: var(--tango-colors-brand);
  }
`;
const ItemWrapper = (props) => {
    return react_1.default.createElement(coral_system_1.Box, Object.assign({ display: "inline-block", css: itemWrapperStyle }, props));
};
exports.BottomBar = (0, tango_context_1.observer)(() => {
    var _a, _b;
    const workspace = (0, tango_context_1.useWorkspace)();
    const designer = (0, tango_context_1.useDesigner)();
    if (workspace.selectSource.size !== 1) {
        return null;
    }
    const parents = ((_b = (_a = workspace.selectSource) === null || _a === void 0 ? void 0 : _a.first) === null || _b === void 0 ? void 0 : _b.parents) || [];
    const reversedParents = [...parents].reverse();
    const length = parents.length;
    return (react_1.default.createElement(coral_system_1.Box, { className: "BottomBar", display: designer.isPreview ? 'none' : 'block', flex: "0", px: "l", bg: "background.normal", borderTop: "solid", borderTopColor: "line.normal" },
        react_1.default.createElement(antd_1.Breadcrumb, null,
            reversedParents.map((parent, index) => (react_1.default.createElement(antd_1.Breadcrumb.Item, { key: parent.id, onClick: () => {
                    workspace.selectSource.select(Object.assign(Object.assign({}, parent), { parents: parents.slice(length - index) }));
                } },
                react_1.default.createElement(ItemWrapper, null, parent.name)))),
            react_1.default.createElement(antd_1.Breadcrumb.Item, { key: workspace.selectSource.first.id },
                react_1.default.createElement(ItemWrapper, null, workspace.selectSource.first.name)))));
});
