"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Ghost = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const styled_components_1 = tslib_1.__importDefault(require("styled-components"));
const tango_context_1 = require("@music163/tango-context");
const helpers_1 = require("../helpers");
const GhostWrapper = styled_components_1.default.div `
  display: inline-block;
  position: absolute;
  top: -50%;
  left: -50%;
  z-index: -1;
  background-color: rgba(30, 167, 253, 0.5);
  color: #fff;
  font-size: 12px;
  line-height: 2;
  padding: 0 12px;
  pointer-events: none;
  white-space: nowrap;
`;
exports.Ghost = (0, tango_context_1.observer)(() => {
    const workspace = (0, tango_context_1.useWorkspace)();
    const text = workspace.dragSource.name || '';
    return react_1.default.createElement(GhostWrapper, { id: helpers_1.DRAG_GHOST_ID }, text);
});
