"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Viewport = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const classnames_1 = tslib_1.__importDefault(require("classnames"));
const coral_system_1 = require("coral-system");
const tango_context_1 = require("@music163/tango-context");
const ghost_1 = require("./ghost");
const context_1 = require("../context");
const selection_1 = require("./selection");
const insertion_1 = require("./insertion");
const mask_1 = require("./mask");
function Viewport(_a) {
    var { selectionTools, children, className } = _a, rest = tslib_1.__rest(_a, ["selectionTools", "children", "className"]);
    return (react_1.default.createElement(coral_system_1.Box, Object.assign({ position: "relative", height: "100%", className: (0, classnames_1.default)('Viewport', className) }, rest),
        react_1.default.createElement(ViewportBody, null, children),
        react_1.default.createElement("div", { className: "AuxTools" },
            react_1.default.createElement(selection_1.SelectionTools, { actions: selectionTools }),
            react_1.default.createElement(insertion_1.InsertionPrompt, null),
            react_1.default.createElement(mask_1.DraggingMask, null)),
        react_1.default.createElement(ghost_1.Ghost, null)));
}
exports.Viewport = Viewport;
function ViewportBody(_a) {
    var { children } = _a, rest = tslib_1.__rest(_a, ["children"]);
    const mainRef = (0, react_1.useRef)();
    const workspace = (0, tango_context_1.useWorkspace)();
    const designer = (0, tango_context_1.useDesigner)();
    const sandboxQuery = (0, context_1.useSandboxQuery)();
    (0, react_1.useEffect)(() => {
        const resizeObserver = new ResizeObserver((entries) => {
            if (mainRef.current) {
                designer.setViewport({
                    width: mainRef.current.offsetWidth,
                    height: mainRef.current.offsetHeight,
                });
            }
            if (entries.length && workspace.selectSource.isSelected) {
                const items = workspace.selectSource.selected.map((item) => {
                    const element = sandboxQuery.getElementBySlotId(item.id);
                    if (element) {
                        const bounding = sandboxQuery.getElementBounding(element);
                        item.bounding = bounding;
                        item.element = element;
                    }
                    return item;
                });
                workspace.selectSource.select(items);
            }
        });
        resizeObserver.observe(mainRef.current);
    }, []);
    return (react_1.default.createElement(coral_system_1.Box, Object.assign({ ref: mainRef, position: "relative", height: "100%", className: "ViewportBody" }, rest), children));
}
