"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tabs = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const styled_components_1 = tslib_1.__importDefault(require("styled-components"));
const classnames_1 = tslib_1.__importDefault(require("classnames"));
const antd_1 = require("antd");
const StyledTabs = (0, styled_components_1.default)(antd_1.Tabs) `
  .ant-tabs-nav {
    padding-left: 12px;
    padding-right: 12px;
    margin: 0;
  }

  &.sticky .ant-tabs-nav {
    position: sticky;
    top: ${(props) => props.$stickyOffset};
    z-index: 2;
    background: #fff;
  }

  &.ant-tabs-centered .ant-tabs-nav {
    margin: 0;
  }
`;
function Tabs(_a) {
    var { centered, isTabBarSticky = false, tabBarStickyOffset = 0, className } = _a, rest = tslib_1.__rest(_a, ["centered", "isTabBarSticky", "tabBarStickyOffset", "className"]);
    const classNames = (0, classnames_1.default)(className, { sticky: isTabBarSticky });
    return (react_1.default.createElement(StyledTabs, Object.assign({ size: "small", tabBarGutter: 24, centered: centered, className: classNames, "$stickyOffset": tabBarStickyOffset }, rest)));
}
exports.Tabs = Tabs;
Tabs.TabPane = antd_1.Tabs.TabPane;
