import React from 'react';
export interface TagSelectProps {
    /**
     * 默认值
     */
    defaultValue?: string[];
    /**
     * 受控值
     */
    value?: string[];
    /**
     * 值变化时的回调
     */
    onChange?: (value: string[]) => void;
    /**
     * 选项列表
     */
    options?: Array<{
        label: string;
        value: string;
        disabled?: boolean;
    }>;
    /**
     * 选择模式，单选或多选
     */
    mode?: 'single' | 'multiple';
    className?: string;
    style?: React.CSSProperties;
}
export declare function TagSelect({ value: valueProp, defaultValue, onChange, options, mode, ...rest }: TagSelectProps): React.JSX.Element;
