"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TagSelect = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const coral_system_1 = require("coral-system");
const antd_1 = require("antd");
const tango_helpers_1 = require("@music163/tango-helpers");
function TagSelect(_a) {
    var { value: valueProp, defaultValue = [], onChange, options, mode = 'multiple' } = _a, rest = tslib_1.__rest(_a, ["value", "defaultValue", "onChange", "options", "mode"]);
    const [value, setValue] = (0, tango_helpers_1.useControllableState)({
        value: valueProp,
        defaultValue,
        onChange,
    });
    if (mode === 'single' && value.length > 1) {
        (0, tango_helpers_1.warning)(false, '单选模式下 value 只能有一个值！');
    }
    return (react_1.default.createElement(coral_system_1.Box, Object.assign({ className: "TangoTagSelect" }, rest), options.map((option) => (react_1.default.createElement(antd_1.Tag.CheckableTag, { className: option.disabled ? 'disabled' : undefined, key: option.value, checked: value.includes(option.value), onChange: (checked) => {
            if (mode === 'multiple') {
                if (checked) {
                    setValue([...value, option.value]);
                }
                else {
                    setValue(value.filter((item) => item !== option.value));
                }
            }
            else {
                checked ? setValue([option.value]) : setValue([]);
            }
        } }, option.label)))));
}
exports.TagSelect = TagSelect;
