"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModeSwitchTool = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importStar(require("react"));
const coral_system_1 = require("coral-system");
const antd_1 = require("antd");
const tango_ui_1 = require("@music163/tango-ui");
const tango_context_1 = require("@music163/tango-context");
const icons_1 = require("@ant-design/icons");
exports.ModeSwitchTool = (0, tango_context_1.observer)(() => {
    const workspace = (0, tango_context_1.useWorkspace)();
    const designer = (0, tango_context_1.useDesigner)();
    const activeFileCheck = (0, react_1.useCallback)(() => {
        if (workspace.activeFile !== workspace.activeViewFile) {
            antd_1.Modal.confirm({
                title: '当前打开的文件与视图不匹配，是否切换到当前视图对应的文件？',
                onOk: () => {
                    workspace.setActiveFile(workspace.activeViewFile);
                },
            });
        }
    }, [workspace]);
    return (react_1.default.createElement(coral_system_1.Group, { attached: true },
        react_1.default.createElement(tango_ui_1.ToggleButton, { shape: "ghost", selected: designer.activeView === 'design', onClick: () => {
                designer.setActiveView('design');
            }, tooltip: "\u8BBE\u8BA1\u89C6\u56FE" },
            react_1.default.createElement(icons_1.BorderOutlined, null)),
        react_1.default.createElement(tango_ui_1.ToggleButton, { shape: "ghost", selected: designer.activeView === 'code', onClick: () => {
                designer.setActiveView('code'); // 切换到源码视图
                designer.setActiveSidebarPanel(''); // 关闭左侧面板
                activeFileCheck();
            }, tooltip: "\u6E90\u7801\u89C6\u56FE" },
            react_1.default.createElement(tango_ui_1.CodeOutlined, null)),
        react_1.default.createElement(tango_ui_1.ToggleButton, { shape: "ghost", selected: designer.activeView === 'dual', onClick: () => {
                designer.setActiveView('dual'); // 切换到双屏视图
                designer.setActiveSidebarPanel(''); // 关闭左侧面板
                activeFileCheck();
            }, tooltip: "\u53CC\u5C4F\u89C6\u56FE" },
            react_1.default.createElement(tango_ui_1.DualOutlined, null))));
});
