"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PreviewTool = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const tango_ui_1 = require("@music163/tango-ui");
const icons_1 = require("@ant-design/icons");
const tango_context_1 = require("@music163/tango-context");
exports.PreviewTool = (0, tango_context_1.observer)(() => {
    const designer = (0, tango_context_1.useDesigner)();
    return (react_1.default.createElement(tango_ui_1.ToggleButton, { shape: "ghost", selected: designer.isPreview, onClick: () => {
            const nextIsPreview = !designer.isPreview;
            designer.toggleIsPreview(nextIsPreview);
            if (nextIsPreview && designer.activeView === 'code') {
                designer.setActiveView('design');
            }
        }, tooltip: "\u9884\u89C8" },
        react_1.default.createElement(icons_1.EyeOutlined, null)));
});
