"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getWidget = exports.registerWidget = void 0;
const tango_helpers_1 = require("@music163/tango-helpers");
const toolbar_1 = require("./toolbar");
const sidebar_1 = require("./sidebar");
const selection_menu_1 = require("./selection-menu");
const widgets = {};
function registerWidget(key, component) {
    if (!/^(toolbar|sidebar|selectionMenu)\.[a-zA-z]+$/.test(key)) {
        throw new Error(`Invalid widget key(${key}), should start with toolbar, sidebar, or selection-menu`);
    }
    (0, tango_helpers_1.setValue)(widgets, key, component);
}
exports.registerWidget = registerWidget;
function getWidget(key) {
    if (!key) {
        return;
    }
    return (0, tango_helpers_1.getValue)(widgets, key);
}
exports.getWidget = getWidget;
registerWidget('toolbar.modeSwitch', toolbar_1.ModeSwitchTool);
registerWidget('toolbar.preview', toolbar_1.PreviewTool);
registerWidget('toolbar.history', toolbar_1.HistoryTool);
registerWidget('toolbar.routeSwitch', toolbar_1.RouteSwitchTool);
registerWidget('toolbar.togglePanel', toolbar_1.TogglePanelTool);
registerWidget('sidebar.components', sidebar_1.ComponentsPanel);
registerWidget('sidebar.outline', sidebar_1.OutlinePanel);
registerWidget('sidebar.dependency', sidebar_1.DependencyPanel);
registerWidget('sidebar.variables', sidebar_1.VariablePanel);
registerWidget('sidebar.dataSource', sidebar_1.DataSourcePanel);
registerWidget('selectionMenu.copyNode', selection_menu_1.CopyNodeAction);
registerWidget('selectionMenu.deleteNode', selection_menu_1.DeleteNodeAction);
registerWidget('selectionMenu.viewSource', selection_menu_1.ViewSourceAction);
