"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.WorkspaceView = void 0;
const tslib_1 = require("tslib");
const react_1 = tslib_1.__importDefault(require("react"));
const coral_system_1 = require("coral-system");
const tango_context_1 = require("@music163/tango-context");
exports.WorkspaceView = (0, tango_context_1.observer)((props) => {
    const { mode = 'design', children } = props;
    const designer = (0, tango_context_1.useDesigner)();
    const display = mode !== designer.activeView ? 'none' : 'block';
    // 云音乐移动端模式小屏幕适配，可能会溢出屏幕
    const overflow = designer.simulator.name === 'phone' ? 'auto' : designer.isPreview ? 'auto' : 'hidden';
    return (react_1.default.createElement(coral_system_1.Box, { className: `ViewPanel ${mode}`, display: designer.activeView === 'dual' ? 'block' : display, flex: "1", overflow: overflow, position: "relative" }, children));
});
