const fs = require('fs');
const fsExtra = require('fs-extra');
const paths = require('../config/paths');

module.exports = copyTargetSource;

function copyTargetSource(sourcePath, targetPath, { copyCallback = undefined, isExistGitignore = false } = {}) {
    if (!sourcePath || !targetPath) {
        console.log(
            `sourcePath and targetPath is required in copy-folder file.`
        );
        return;
    }
    if (isExistGitignore) {
        let addGitignore = "/public/static/vendor";
        let gitignorePath = paths.gitignorePath;
        let gitignoreContent = fs.readFileSync(gitignorePath, 'utf8').split('\n');
        let isExist = gitignoreContent.some(i => i === addGitignore);
        if (!isExist) {
            gitignoreContent.push(addGitignore);
            fs.writeFileSync(gitignorePath, gitignoreContent.join('\n'), 'utf8');
        }
    }
    // let stat = fs.statSync(sourcePath);
    // let isDirectory = stat.isDirectory();
    // if (!fs.existsSync(targetPath)) {
    //     if (isDirectory) {
    //         fs.mkdirSync(targetPath);
    //     }
    // }

    if (typeof copyCallback !== "function") {
        copyCallback = function () {
            return true;
        };
    }

    fsExtra.copySync(sourcePath, targetPath, {
        dereference: true,
        filter: file => copyCallback(file),
    });
}