import { __extends } from "tslib";
import React from 'react';
import PropTypes from 'prop-types';
import isNaN from 'lodash-es/isNaN';
import { Input } from 'udesk-ui';
var Group = Input.Group;
var AntdRangeInputNumberComponent = /** @class */ (function (_super) {
    __extends(AntdRangeInputNumberComponent, _super);
    function AntdRangeInputNumberComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleFirstInputChanged = function (e) {
            var _a = _this.props, onChanged = _a.onChanged, value = _a.value, attributes = _a.attributes;
            var precision = attributes.precision, type = attributes.type, _b = attributes.stringValue, stringValue = _b === void 0 ? false : _b;
            var firstValue = e.target.value;
            if (type === 'number' &&
                typeof precision === 'number' &&
                !isNaN(Number.parseFloat(firstValue))) {
                firstValue = Number.parseFloat(firstValue).toFixed(precision);
            }
            var internalValue = [];
            if (Array.isArray(value)) {
                internalValue = value;
            }
            if (stringValue && typeof value === 'string') {
                internalValue = value.split(',') || [];
            }
            var first = internalValue[0], second = internalValue[1];
            first = firstValue;
            var result = stringValue ? [first, second].toString() : [first, second];
            onChanged(result);
        };
        _this.handleSecondInputChanged = function (e) {
            var _a = _this.props, onChanged = _a.onChanged, value = _a.value, attributes = _a.attributes;
            var precision = attributes.precision, type = attributes.type, _b = attributes.stringValue, stringValue = _b === void 0 ? false : _b;
            var secondValue = e.target.value;
            if (type === 'number' &&
                typeof precision === 'number' &&
                !isNaN(Number.parseFloat(secondValue))) {
                secondValue = Number.parseFloat(secondValue).toFixed(precision);
            }
            var internalValue = [];
            if (Array.isArray(value)) {
                internalValue = value;
            }
            if (stringValue && typeof value === 'string') {
                internalValue = value.split(',') || [];
            }
            var first = internalValue[0], second = internalValue[1];
            second = secondValue;
            var result = stringValue ? [first, second].toString() : [first, second];
            onChanged(result);
        };
        return _this;
    }
    AntdRangeInputNumberComponent.prototype.render = function () {
        var _a = this.props, disabled = _a.disabled, value = _a.value, attributes = _a.attributes;
        var _b = attributes.type, type = _b === void 0 ? 'number' : _b, _c = attributes.stringValue, stringValue = _c === void 0 ? false : _c;
        var displayValue = [];
        if (Array.isArray(value)) {
            displayValue = value;
        }
        if (stringValue && typeof value === 'string') {
            displayValue = value.split(',') || [];
        }
        var first = displayValue[0], second = displayValue[1];
        return (React.createElement(Group, { compact: true, style: { width: '300px' } },
            React.createElement(Input, { style: { width: 130, textAlign: 'center' }, disabled: disabled, type: type, value: first, onChange: this.handleFirstInputChanged }),
            React.createElement(Input, { style: {
                    width: 41,
                    borderLeft: 0,
                    pointerEvents: 'none',
                    backgroundColor: '#fff',
                }, placeholder: "~", disabled: true }),
            React.createElement(Input, { style: { width: 130, textAlign: 'center', borderLeft: 0 }, disabled: disabled, type: type, value: second, onChange: this.handleSecondInputChanged })));
    };
    return AntdRangeInputNumberComponent;
}(React.Component));
export default AntdRangeInputNumberComponent;
/**
 * @description 组件可能接收的prop
 * @namespace
 * @property {object} attributes - 配置valueSetting时传入，常用
 * @property {string} attributes.classNames - 自定义组件css类名
 * @property {string} attributes.placeholder - 自定义组件placeholder
 * @property {string} attributes.maxLength - 校验value长度，未实现 todo
 * @property {function} onChanged - value改变唯一触发事件，其他入onFocus之类可能需要在valueSetting时配置，而且是跟自定义过滤器同一上下文
 * @property {string} value - 字段value，该组件位text input,value只需考虑string,复杂选择组件需object
 *
 * @property {object} operator - condition上下文相关
 * @property {object} field - condition上下文相关
 * @property {string} name - 校验相关，错误信息提示字段名
 * @property {boolean} isValid - 校验相关 具体待补充 todo
 * @property {array} errors - 校验相关，错误信息
 * @property {object} runtimeAttributes - 运行时传入valueInput组件的属性,从custom-filter组件传入conditionValueComponentAttrs
 *
 */
AntdRangeInputNumberComponent.defaultProps = {
    value: [],
    onChanged: null,
    attributes: {},
    disabled: false,
    operator: {},
    field: {},
    name: null,
    isValid: true,
    errors: [],
    runtimeAttributes: {},
};
AntdRangeInputNumberComponent.propTypes = {
    value: PropTypes.array,
    onChanged: PropTypes.func,
    disabled: PropTypes.bool,
    attributes: PropTypes.shape({
        type: PropTypes.oneOf(['text', 'number']).isRequired,
        precision: PropTypes.number,
        stringValue: PropTypes.bool
    }),
    operator: PropTypes.object,
    field: PropTypes.object,
    name: PropTypes.string,
    isValid: PropTypes.bool,
    errors: PropTypes.array,
    runtimeAttributes: PropTypes.object
};
