import { __assign, __extends } from "tslib";
import React from 'react';
import ClassNames from 'classnames';
import AntdSelectComponent from './antd-select';
import { isEqual } from 'lodash-es';
/**
 * @description 客服系统常见下拉选项
 * {
 *      title: '选项一',
 *      value: '1'
 * }
 */
var AntdMultipleSelectComponent = /** @class */ (function (_super) {
    __extends(AntdMultipleSelectComponent, _super);
    function AntdMultipleSelectComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.handleSelectChange = function (value) {
            var _a = _this.props, onChanged = _a.onChanged, _b = _a.attributes, attributes = _b === void 0 ? {} : _b;
            var _c = attributes.stringValue, stringValue = _c === void 0 ? false : _c;
            var internalValue = value;
            if (stringValue && Array.isArray(internalValue)) {
                internalValue = internalValue.join(',');
            }
            if (typeof onChanged === 'function') {
                onChanged(internalValue);
            }
        };
        _this.state = {
            dataSourceProps: props.dataSource,
        };
        return _this;
    }
    AntdMultipleSelectComponent.getDerivedStateFromProps = function (nextProps, prevState) {
        var dataSource = nextProps.dataSource, _a = nextProps.attributes, attributes = _a === void 0 ? {} : _a;
        var valueField = attributes.valueField, stringValue = attributes.stringValue;
        var newDataSource = dataSource;
        if (stringValue) {
            newDataSource = dataSource.map(function (item) {
                var _a;
                var _b;
                return (__assign(__assign({}, item), (_a = {}, _a[valueField] = (_b = item[valueField]) === null || _b === void 0 ? void 0 : _b.toString(), _a)));
            });
        }
        // if (newDataSource !== prevState.dataSourceProps) {
        if (!isEqual(newDataSource, prevState.dataSourceProps)) {
            return {
                dataSourceProps: newDataSource,
            };
        }
        else {
            return {};
        }
    };
    AntdMultipleSelectComponent.prototype.render = function () {
        // stringValue 是否传入传出数据为逗号分割字符串形式
        var _a = this.props, classNames = _a.classNames, dropdownClassName = _a.dropdownClassName, value = _a.value, _b = _a.attributes, attributes = _b === void 0 ? {} : _b;
        var _c = attributes.stringValue, stringValue = _c === void 0 ? false : _c;
        var validValue = value ? value : [];
        if (stringValue && typeof validValue === 'string') {
            validValue = value.split(',');
        }
        // value = value ? value : [];
        return (React.createElement(AntdSelectComponent, __assign({}, this.props, { dataSource: this.state.dataSourceProps, value: validValue, onMultipleChange: this.handleSelectChange, mode: 'multiple', className: ClassNames(classNames, 'udesk-custom-filter-antd-multiple-select'), dropdownClassName: ClassNames(dropdownClassName, 'udesk-custom-filter-antd-multiple-select-dropdown') })));
    };
    return AntdMultipleSelectComponent;
}(React.Component));
export default AntdMultipleSelectComponent;
