import { __extends } from "tslib";
import React from 'react';
import PropTypes from 'prop-types';
import ClassNames from 'classnames';
import { InputNumber } from 'udesk-ui';
import isString from 'lodash-es/isString';
var AntdInputNumberComponent = /** @class */ (function (_super) {
    __extends(AntdInputNumberComponent, _super);
    function AntdInputNumberComponent() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleTextInputChanged = function (value) {
            var onChanged = _this.props.onChanged;
            // 转为字符串
            if (typeof value === 'number') {
                value = String(value);
            }
            var internalValue = value;
            onChanged(internalValue);
        };
        return _this;
    }
    AntdInputNumberComponent.prototype.render = function () {
        var _a = this.props, disabled = _a.disabled, attributes = _a.attributes, value = _a.value;
        var classNames = attributes.classNames, precision = attributes.precision;
        return (React.createElement(InputNumber, { style: { width: '300px' }, className: ClassNames(classNames, 'udesk-custom-filter-antd-text-input'), disabled: disabled, value: isString(value) ? parseFloat(value) : value, precision: precision, onChange: this.handleTextInputChanged }));
    };
    return AntdInputNumberComponent;
}(React.Component));
export default AntdInputNumberComponent;
/**
 * @description 组件可能接收的prop
 * @namespace
 * @property {object} attributes - 配置valueSetting时传入，常用
 * @property {string} attributes.classNames - 自定义组件css类名
 * @property {string} attributes.placeholder - 自定义组件placeholder
 * @property {string} attributes.maxLength - 校验value长度，未实现 todo
 * @property {function} onChanged - value改变唯一触发事件，其他入onFocus之类可能需要在valueSetting时配置，而且是跟自定义过滤器同一上下文
 * @property {string} value - 字段value，该组件位text input,value只需考虑string,复杂选择组件需object
 *
 * @property {object} operator - condition上下文相关
 * @property {object} field - condition上下文相关
 * @property {string} name - 校验相关，错误信息提示字段名
 * @property {boolean} isValid - 校验相关 具体待补充 todo
 * @property {array} errors - 校验相关，错误信息
 * @property {object} runtimeAttributes - 运行时传入valueInput组件的属性,从custom-filter组件传入conditionValueComponentAttrs
 *
 */
AntdInputNumberComponent.defaultProps = {
    value: null,
    onChanged: null,
    attributes: {},
    disabled: false,
    operator: {},
    field: {},
    name: null,
    isValid: true,
    errors: [],
    runtimeAttributes: {},
};
AntdInputNumberComponent.propTypes = {
    value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    onChanged: PropTypes.func,
    attributes: PropTypes.object,
    disabled: PropTypes.bool,
    operator: PropTypes.object,
    field: PropTypes.object,
    name: PropTypes.string,
    isValid: PropTypes.bool,
    errors: PropTypes.array,
    runtimeAttributes: PropTypes.object,
};
