import { __extends, __spreadArray } from "tslib";
import React from 'react';
import PropTypes from 'prop-types';
import ClassNames from 'classnames';
import { Select, Spin } from 'udesk-ui';
import i18n from '@udesk-webapp/locale';
// import { dropDownOptionDefaultPropsName } from '@/utils/custom-filter/dataSourceDefaultPropsName';
var Option = Select.Option, OptGroup = Select.OptGroup;
import { debounce } from 'lodash-es';
// TODO: 后面重构成hooks
/**
 * @description 客服系统常见下拉选项
 * {
 *      title: '选项一',
 *      value: '1'
 * }
 */
// 迁移之前这个是放在了ts_react utils里面，看情况是否需要提到public utils
export var dropDownOptionDefaultPropsName = {
    dataSourceValueField: 'valueField',
    dataSourceNameField: 'nameField',
    dataSourceSearchField: 'searchField',
    defaultValueField: 'id',
    defaultNameField: 'text',
    defaultSearchField: 'text',
    defaultOutputValueMode: 'value', //'value'|'object'
};
var AntdSelectComponent = /** @class */ (function (_super) {
    __extends(AntdSelectComponent, _super);
    function AntdSelectComponent(props) {
        var _this = _super.call(this, props) || this;
        _this.handleSelectChange = function (value) {
            var _a = _this.props, onChanged = _a.onChanged, onMultipleChange = _a.onMultipleChange;
            var internalValue = value;
            if (typeof onMultipleChange === 'function') {
                return onMultipleChange(internalValue);
            }
            if (typeof onChanged === 'function') {
                onChanged(internalValue);
            }
        };
        _this.onSearched = function (value) {
            var onSearch = (_this.props.attributes || {}).onSearch;
            if (onSearch) {
                _this.setState({
                    fetching: true,
                    dataSource: [],
                });
                var id_1 = (_this.props.field || {}).id;
                var search = function (value) {
                    var _a;
                    (_a = onSearch(value, id_1)) === null || _a === void 0 ? void 0 : _a.then(function (resp) {
                        _this.setState({
                            dataSource: (resp === null || resp === void 0 ? void 0 : resp.data) || [],
                            params: (resp === null || resp === void 0 ? void 0 : resp.params) || {},
                            fetching: false,
                        });
                        _this.catchEmptySearchOption = (resp === null || resp === void 0 ? void 0 : resp.data) || [];
                    }, function (reason) {
                        return _this.setState({
                            fetching: false,
                        });
                    });
                };
                search(value);
                // debounce(search, debounceTimer)(value);
            }
        };
        _this.selectOnFocus = function () {
            var onSearch = (_this.props.attributes || {}).onSearch;
            if (_this.catchEmptySearchOption && onSearch) {
                if (_this.catchEmptySearchOption.length === 0) {
                    _this.onSearched('');
                }
                else {
                    _this.setState({
                        dataSource: _this.catchEmptySearchOption,
                        fetching: false,
                    });
                }
            }
        };
        _this.onPopupScroll = function (event) {
            var _a;
            var _b = _this.props.attributes, attributes = _b === void 0 ? {} : _b;
            var onPopupScroll = attributes.onPopupScroll;
            if (typeof onPopupScroll === 'function') {
                (_a = onPopupScroll(event, _this.state.params)) === null || _a === void 0 ? void 0 : _a.then(function (resp) {
                    var dataSource = _this.state.dataSource;
                    _this.setState({
                        dataSource: __spreadArray(__spreadArray([], dataSource, true), resp === null || resp === void 0 ? void 0 : resp.data, true) || [],
                        params: (resp === null || resp === void 0 ? void 0 : resp.params) || {},
                        fetching: false,
                    });
                }, function (reason) {
                    return _this.setState({
                        fetching: false,
                    });
                });
            }
        };
        _this.state = {
            dataSource: props.dataSource,
            dataSourceProps: props.dataSource,
            params: {},
            fetching: false,
        };
        _this.catchEmptySearchOption = [];
        return _this;
    }
    AntdSelectComponent.getDerivedStateFromProps = function (nextProps, prevState) {
        var dataSource = nextProps.dataSource;
        if (dataSource !== prevState.dataSourceProps) {
            return {
                dataSourceProps: dataSource,
                dataSource: dataSource,
            };
        }
        else {
            return {};
        }
    };
    AntdSelectComponent.prototype.render = function () {
        var _a = this.props, disabled = _a.disabled, _b = _a.attributes, attributes = _b === void 0 ? {} : _b, 
        // dataSource,
        value = _a.value, dataSourceValueField = _a.dataSourceValueField, dataSourceNameField = _a.dataSourceNameField, defaultValueField = _a.defaultValueField, defaultNameField = _a.defaultNameField, mode = _a.mode;
        var dataSource = this.state.dataSource;
        var filterOptionAction = function (input, option) {
            var _a, _b;
            return (_b = (_a = option === null || option === void 0 ? void 0 : option[optionFilterProp]) === null || _a === void 0 ? void 0 : _a.toLowerCase()) === null || _b === void 0 ? void 0 : _b.includes(input === null || input === void 0 ? void 0 : input.toLowerCase());
        };
        var classNames = attributes.classNames, dropdownClassName = attributes.dropdownClassName, placeholder = attributes.placeholder, _c = attributes.allowClear, allowClear = _c === void 0 ? true : _c, isGroup = attributes.isGroup, // 是否分组
        valueField = attributes.valueField, // 外部指定option的value用这个属性，下面如此
        nameField = attributes.nameField, groupValueField = attributes.groupValueField, groupNameField = attributes.groupNameField, groupDataField = attributes.groupDataField, onSearch = attributes.onSearch, _d = attributes.showSearch, showSearch = _d === void 0 ? true : _d, _e = attributes.optionFilterProp, optionFilterProp = _e === void 0 ? 'children' : _e, _f = attributes.filterOption, filterOption = _f === void 0 ? filterOptionAction : _f, _g = attributes.labelInValue, labelInValue = _g === void 0 ? false : _g, _h = attributes.width, width = _h === void 0 ? '300px' : _h, // 这个默认值有点奇怪，因为以前是这样设置的，暂时保留，如果确定影响范围建议去掉此默认值，或者设置更为合理的默认值
        defaultValue = attributes.defaultValue;
        var innerValueField = defaultValueField || valueField;
        var innerNameField = defaultNameField || nameField;
        var optionsRender = null; // 渲染模板
        if (attributes[dataSourceValueField]) {
            innerValueField = attributes[dataSourceValueField];
        }
        if (attributes[dataSourceNameField]) {
            innerNameField = attributes[dataSourceNameField];
        }
        if (!(Array.isArray(dataSource))) {
            dataSource = [];
        }
        // 未分组统一模板
        var singleDataSource = function (dataSourceArr) {
            return dataSourceArr.map(function (option, index) {
                return (React.createElement(Option, { value: option[innerValueField], key: option[innerValueField] || index, title: option[innerNameField], searchto: option[innerNameField], disabled: option.disabled }, option[innerNameField]));
            });
        };
        if (isGroup) {
            // 分组模板
            optionsRender = dataSource.map(function (option) {
                return (React.createElement(OptGroup, { label: option[groupNameField] }, singleDataSource(option[groupDataField])));
            });
        }
        else {
            optionsRender = singleDataSource(dataSource);
        }
        var style = {};
        if (width) {
            style.width = width;
        }
        return (React.createElement(Select, { defaultValue: defaultValue, mode: mode, style: style, className: ClassNames(classNames, 'udesk-custom-filter-antd-select'), dropdownClassName: ClassNames(dropdownClassName, 'udesk-custom-filter-antd-select-dropdown'), getPopupContainer: function (triggerNode) { return triggerNode.parentElement; }, placeholder: placeholder, disabled: disabled, allowClear: allowClear, labelInValue: labelInValue, filterOption: onSearch ? false : filterOption, value: value, showSearch: showSearch, notFoundContent: this.state.fetching ? (React.createElement(Spin, { size: 'small' })) : (showSearch ? null : i18n.t('components.customFilterInput.antdSelect.noData')), optionFilterProp: optionFilterProp, onPopupScroll: this.onPopupScroll, onChange: this.handleSelectChange, onFocus: this.selectOnFocus, onSearch: showSearch && debounce(this.onSearched, 500) }, optionsRender));
    };
    return AntdSelectComponent;
}(React.Component));
export default AntdSelectComponent;
/**
 * @description 组件可能接收的prop
 * @namespace
 * @property {object} attributes - 配置fields(优先级更高)和valueSetting时传入，常用
 * @property {string} attributes.classNames - 自定义组件css类名
 * @property {string} attributes.placeholder - 自定义组件placeholder
 * @property {string} attributes.dropdownClassName - 自定义下拉菜单的 className 属性
 * @property {boolean} attributes.allowClear - 单选支持清除
 * @property {function} onChanged - value改变唯一触发事件，其他入onFocus之类可能需要在valueSetting时配置，而且是跟自定义过滤器同一上下文
 * @property {string} value - 字段value，该组件位text input,value只需考虑string,复杂选择组件需object
 *
 * @property {object} operator - condition上下文相关
 * @property {object} field - condition上下文相关
 * @property {string} name - 校验相关，错误信息提示字段名
 * @property {boolean} isValid - 校验相关 具体待补充 todo
 * @property {array} errors - 校验相关，错误信息
 * @property {object} runtimeAttributes - 运行时传入valueInput组件的属性,从custom-filter组件传入conditionValueComponentAttrs
 *
 */
AntdSelectComponent.defaultProps = Object.assign({
    value: null,
    onChanged: null,
    attributes: {},
    dataSource: [],
    disabled: false,
    operator: {},
    field: {},
    name: null,
    isValid: true,
    errors: [],
    runtimeAttributes: {},
}, dropDownOptionDefaultPropsName);
AntdSelectComponent.propTypes = {
    value: PropTypes.oneOfType([PropTypes.string, PropTypes.number]),
    onChanged: PropTypes.func,
    attributes: PropTypes.object,
    dataSource: PropTypes.array,
    disabled: PropTypes.bool,
    isValid: PropTypes.bool,
    operator: PropTypes.object,
    field: PropTypes.object,
    name: PropTypes.string,
    errors: PropTypes.array,
    runtimeAttributes: PropTypes.object,
    dataSourceValueField: PropTypes.string,
    dataSourceNameField: PropTypes.string,
    dataSourceSearchField: PropTypes.string,
    defaultValueField: PropTypes.string,
    defaultNameField: PropTypes.string,
    defaultSearchField: PropTypes.string,
    defaultOutputValueMode: PropTypes.string,
};
