import { __assign, __awaiter, __generator, __rest } from "tslib";
import React, { useEffect, useState, useMemo } from 'react';
import { memoize } from "lodash-es";
import { Select } from 'udesk-ui';
import { ajax } from '@udesk-webapp/utils';
import styles from '../index.module.scss';
// 缓存数据，避免父组件设计不合理，导致组件反复加载请求数据
var getTicketStatus = memoize(function () { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        return [2 /*return*/, ajax().getJSON('/cs/ts/api/ticket_status')];
    });
}); });
// 工单状态过滤组件，可以满足已禁用选项展示，但不可选
var AntdTicketStatus = function (props) {
    var value = props.value, _a = props.disabled, disabled = _a === void 0 ? false : _a, onChanged = props.onChanged, _b = props.attributes, attributes = _b === void 0 ? {} : _b;
    var _c = useState([]), ticketStatus = _c[0], setTicketStatus = _c[1];
    var _d = attributes.fieldNames, fieldNames = _d === void 0 ? { label: 'name', value: 'key' } : _d, mode = attributes.mode, _e = attributes.width, width = _e === void 0 ? '300px' : _e, _f = attributes.allowClear, allowClear = _f === void 0 ? true : _f, stringValue = attributes.stringValue, restProps = __rest(attributes, ["fieldNames", "mode", "width", "allowClear", "stringValue"]);
    useEffect(function () {
        getTicketStatus().then(function (res) {
            if (res.code === 1000) {
                var result = res.data || [];
                var status_1 = result.map(function (item) {
                    return {
                        key: item.en_name,
                        name: item.name,
                        id: item.status_id,
                        color: item.color,
                        enable: item.enable // 是否可用
                    };
                });
                setTicketStatus(status_1);
            }
        });
    }, []);
    var showOptions = useMemo(function () {
        if (stringValue) {
            return ticketStatus.map(function (item) {
                var _a;
                var _b;
                return (__assign(__assign({}, item), (_a = {}, _a[fieldNames.value] = (_b = item[fieldNames.value]) === null || _b === void 0 ? void 0 : _b.toString(), _a)));
            });
        }
        return ticketStatus;
    }, [ticketStatus, stringValue, fieldNames.value]);
    var innerValue = useMemo(function () {
        if (mode === 'multiple') {
            if (!stringValue) {
                return value ? value : [];
            }
            else {
                return value ? value.split(',') : [];
            }
        }
        if (stringValue) {
            return (value || '').toString();
        }
        return value;
    }, [value, mode, stringValue]);
    var onValueChanged = function (value) {
        var internalValue = value;
        if (stringValue && Array.isArray(internalValue)) {
            internalValue = internalValue.join(',');
        }
        onChanged && onChanged(internalValue);
    };
    return (React.createElement("div", { className: styles['ticket-status-container'] },
        React.createElement(Select, __assign({ style: { width: width }, getPopupContainer: function (triggerNode) { return triggerNode.parentElement; } }, restProps, { disabled: disabled, 
            // 工单状态不会很多，将虚拟滚动关闭，下面的选项隐藏会导致虚拟滚动高度计算不准，下拉框底部空白
            dropdownMatchSelectWidth: false, labelInValue: false, allowClear: allowClear, mode: mode, value: innerValue, onChange: onValueChanged }), showOptions.map(function (item) { return (React.createElement(Select.Option, { key: item.id, value: item[fieldNames.value], className: item.enable === false ? styles['hidden'] : '' }, item.name)); }))));
};
export default React.memo(AntdTicketStatus);
