import React, { useCallback, useMemo } from 'react';
import { Input } from 'udesk-ui';
// type PropsType = {
//     value: string;
//     attributes: {
//         [key: string]: any;
//     };
//     onChanged: (time: string) => void;
// };
var AntdTimeInput = function (props) {
    var value = props.value, onChanged = props.onChanged, _a = props.attributes, attributes = _a === void 0 ? {} : _a;
    var type = attributes.type, _b = attributes.separation, separation = _b === void 0 ? ':' : _b;
    var innerValue = useMemo(function () {
        var time = Number(value);
        if (typeof time === 'number') {
            var hour = Math.floor(time / 3600);
            var minute = Math.floor((time - hour * 3600) / 60);
            var scend = time - hour * 3600 - minute * 60;
            return [hour, minute, scend];
        }
        else {
            return [0, 0, 0];
        }
    }, [value]);
    var onChange = function (hour, nimuite, second) {
        if (typeof onChanged === 'function') {
            onChanged(hour * 3600 + nimuite * 60 + second);
        }
    };
    var onHourChange = useCallback(function (event) {
        var time = Math.floor(event.target.value);
        if (typeof time !== 'number') {
            time = 0;
        }
        onChange(time, innerValue === null || innerValue === void 0 ? void 0 : innerValue[1], innerValue === null || innerValue === void 0 ? void 0 : innerValue[2]);
    }, [innerValue]);
    var onMinuteChange = useCallback(function (event) {
        var time = Math.floor(event.target.value);
        if (typeof time !== 'number') {
            time = 0;
        }
        onChange(innerValue === null || innerValue === void 0 ? void 0 : innerValue[0], time, innerValue === null || innerValue === void 0 ? void 0 : innerValue[2]);
    }, [innerValue]);
    var onSecondChange = useCallback(function (event) {
        var time = Math.floor(event.target.value);
        if (typeof time !== 'number') {
            time = 0;
        }
        onChange(innerValue === null || innerValue === void 0 ? void 0 : innerValue[0], innerValue === null || innerValue === void 0 ? void 0 : innerValue[1], time);
    }, [innerValue]);
    return (React.createElement("div", { className: '' },
        React.createElement(Input, { value: innerValue === null || innerValue === void 0 ? void 0 : innerValue[0], style: { width: '80px' }, type: type, onChange: onHourChange, addonAfter: separation }),
        React.createElement(Input, { value: innerValue === null || innerValue === void 0 ? void 0 : innerValue[1], style: { width: '80px', borderLeft: 0 }, type: type, onChange: onMinuteChange, addonAfter: separation }),
        React.createElement(Input, { value: innerValue === null || innerValue === void 0 ? void 0 : innerValue[2], style: { width: '50px', borderLeft: 0 }, type: type, onChange: onSecondChange })));
};
export default AntdTimeInput;
