import React, { useEffect } from 'react';
import { view } from '@risingstack/react-easy-state';
import globalTango from './global';
// TODO: 支持同步 value 以外的状态, setValue 完全交给外部来做，内部只实例化空间
export const Collector = view(({ id, model, defaultValue, onValueChange, render, children }) => {
    useEffect(() => {
        const storePath = `currentPage.${id}`;
        if (id) {
            globalTango.setStoreValue(storePath, {
                value: defaultValue,
            });
        }
        return () => {
            if (id) {
                globalTango.clearStoreValue(storePath);
            }
        };
    }, [id]);
    const valuePath = model || ['currentPage', id, 'value'].join('.');
    const value = globalTango.getStoreValue(valuePath);
    const componentOrFunction = render || children;
    return renderProps(componentOrFunction, {
        value,
        setValue: (nextValue) => {
            globalTango.setStoreValue(valuePath, nextValue);
            onValueChange === null || onValueChange === void 0 ? void 0 : onValueChange(nextValue);
        },
        ref: (instance) => {
            globalTango.refs[id] = instance;
        },
    });
});
const renderProps = (ComponentOrFunction, props) => {
    if (ComponentOrFunction.propTypes || ComponentOrFunction.prototype.render) {
        return React.createElement(ComponentOrFunction, Object.assign({}, props));
    }
    return ComponentOrFunction(Object.assign(Object.assign({}, (ComponentOrFunction.defaultProps || {})), props));
};
