import React from 'react';
import { HTMLCoralProps } from 'coral-system';
export interface ActionProps extends HTMLCoralProps<any> {
    /**
     * 图标
     */
    icon?: React.ReactNode;
    /**
     * 提示文本
     */
    tooltip?: string;
    /**
     * 超链接
     */
    href?: string;
    /**
     * 尺寸
     */
    size?: 'small';
    /**
     * 外观：outline-有边框
     */
    shape?: 'outline';
    /**
     * 是否禁用
     */
    disabled?: boolean;
    /**
     * 自定义样式
     */
    className?: string;
    children?: React.ReactNode;
    onClick?: React.MouseEventHandler;
}
export declare function Action({ icon, tooltip, href, size, shape, disabled, className, children, ...rest }: ActionProps): React.JSX.Element;
