import { __rest } from "tslib";
import React from 'react';
import { SingleEditor } from 'react-monaco-editor-lite';
import { Box } from 'coral-system';
export function SingleMonacoEditor(props) {
    const { language, options: optionsProp = {}, height = '100%', width = '100%', hasBorder = false } = props, rest = __rest(props, ["language", "options", "height", "width", "hasBorder"]);
    const options = Object.assign({ language }, optionsProp);
    const boxProps = hasBorder
        ? {
            border: 'solid',
            borderColor: 'line.normal',
            borderRadius: 's',
        }
        : {};
    return (React.createElement(Box, Object.assign({ width: width, height: height }, boxProps),
        React.createElement(SingleEditor, Object.assign({ options: options }, rest))));
}
export { MultiEditor } from 'react-monaco-editor-lite';
