import { __rest } from "tslib";
import React from 'react';
import { Box } from 'coral-system';
export const DragBox = (_a) => {
    var { children, index, onMove } = _a, rest = __rest(_a, ["children", "index", "onMove"]);
    const handleStartDrag = (ev) => {
        ev.dataTransfer.setData('text', `${index}`);
    };
    const handleEndDrag = (ev) => {
        ev.dataTransfer.dropEffect = 'move';
    };
    const handleDrop = (ev) => {
        const idx = ev.dataTransfer.getData('text');
        onMove === null || onMove === void 0 ? void 0 : onMove(+idx, index);
    };
    const handleDragOver = (ev) => {
        // 阻止默认行为，触发 onDrop
        ev.preventDefault();
        // TODO: 优化动画交互
    };
    return (React.createElement(Box, Object.assign({}, rest, { draggable: true, onDragStart: handleStartDrag, onDragEnd: handleEndDrag, onDragOver: handleDragOver, onDrop: handleDrop }), children));
};
