import React from 'react';
import styled from 'styled-components';
import classnames from 'classnames';
const Text = styled.div `
  background-color: #8fa0f0;
  color: white;
  padding: 2px 4px;
`;
const List = styled.ul `
  list-style: none;
  padding: 0;
  background-color: white;
  border: 1px solid #d9d9d9;
  margin: 0 4px;
  position: absolute;
  width: calc(100% - 8px);
  max-width: 300px;

  > li {
    .group-title {
      color: #666;
      margin: 8px 0 4px;
      padding: 0 4px;
    }

    .action-item {
      line-height: 22px;
      padding: 0 4px;
      user-select: none;

      &:hover {
        cursor: pointer;
      }

      &.active {
        background-color: #8fa0f0;
        color: white;
      }
    }
  }
`;
let timer;
export const Menu = (props) => {
    const { text = '输入 {} 进入指令选择界面', showDefaultText = true, items = [], value, onClick, onUpdate, top, } = props;
    const handleClick = (ev, item) => {
        ev.stopPropagation();
        (item === null || item === void 0 ? void 0 : item.key.indexOf('.')) > -1 && onUpdate(item === null || item === void 0 ? void 0 : item.key);
        timer && clearTimeout(timer);
        timer = setTimeout(() => {
            onClick === null || onClick === void 0 ? void 0 : onClick(item === null || item === void 0 ? void 0 : item.key);
        }, 0);
    };
    const renderItems = () => {
        return items.map((item, idx) => {
            const { label, title, key } = item;
            const newClass = classnames('action-item', { active: value === key });
            return (React.createElement("li", { key: idx },
                title && React.createElement("div", { className: "group-title" }, title),
                React.createElement("div", { className: newClass, onClick: (ev) => handleClick(ev, item) }, label)));
        });
    };
    const children = showDefaultText ? React.createElement(Text, null, text) : renderItems();
    return React.createElement(List, { style: { top } }, children);
};
