import { __rest } from "tslib";
import React, { useState } from 'react';
import { Modal } from 'antd';
import { Box } from 'coral-system';
import { noop, useBoolean } from '@music163/tango-helpers';
import { VariableTree } from './variable-tree';
export function VariableTreeModal(_a) {
    var { trigger, title, modalProps, onSelect = noop } = _a, rest = __rest(_a, ["trigger", "title", "modalProps", "onSelect"]);
    const [node, setNode] = useState();
    const [visible, { on, off }] = useBoolean(false);
    return (React.createElement(Box, null,
        React.cloneElement(trigger, { onClick: on }),
        React.createElement(Modal, Object.assign({ title: title, open: visible, onCancel: off, okButtonProps: {
                disabled: !node,
            }, onOk: () => {
                if (node) {
                    onSelect(node);
                    off();
                }
            }, width: "60%" }, modalProps),
            React.createElement(VariableTree, Object.assign({ height: 400, onSelect: setNode }, rest)))));
}
