import React from 'react';
import { isFunction, isNil, isString } from '@music163/tango-helpers';
import { InputCode, JsonView } from '@music163/tango-ui';
import { Empty } from 'antd';
export function ValuePreview({ value, onCopy }) {
    if (isNil(value)) {
        return React.createElement(Empty, { image: Empty.PRESENTED_IMAGE_SIMPLE, description: "\u6682\u65F6\u6CA1\u6709\u53EF\u9884\u89C8\u7684\u6570\u636E" });
    }
    if (isFunction(value)) {
        return React.createElement(Empty, { image: Empty.PRESENTED_IMAGE_SIMPLE, description: "\u6682\u4E0D\u652F\u6301\u9884\u89C8\u51FD\u6570" });
    }
    if (typeof value === 'object') {
        return React.createElement(JsonView, { src: value, enableCopy: true, onCopy: onCopy });
    }
    return (React.createElement(InputCode, { shape: "inset", value: isString(value) ? `"${value}"` : String(value), editable: false }));
}
