import React, { useEffect, useRef, useState } from 'react';
export function CopyClipboard({ onCopy, text, children }) {
    const [copied, setCopied] = useState(false);
    const timeoutRef = useRef();
    useEffect(() => {
        return () => {
            if (timeoutRef.current) {
                clearTimeout(timeoutRef.current);
            }
        };
    }, []);
    const onClick = () => {
        if (timeoutRef.current) {
            clearTimeout(timeoutRef.current);
        }
        navigator.clipboard.writeText(text);
        setCopied(true);
        onCopy === null || onCopy === void 0 ? void 0 : onCopy();
        timeoutRef.current = setTimeout(() => {
            setCopied(false);
        }, 1000);
    };
    if (typeof children === 'function') {
        return React.cloneElement(children({ copied, onClick }), {
            onClick,
        });
    }
}
