import { __awaiter, __rest } from "tslib";
import request from './request';
import globalConfig from './global-config';
export function createService(_a) {
    var { onSuccess, onError } = _a, baseConfig = __rest(_a, ["onSuccess", "onError"]);
    return (payload, config) => __awaiter(this, void 0, void 0, function* () {
        var _b;
        const _c = Object.assign(Object.assign({}, config), baseConfig), { method = 'get', url } = _c, restConfig = __rest(_c, ["method", "url"]);
        try {
            const fn = fixMethod(method);
            const data = yield request[fn](url, payload, restConfig);
            onSuccess === null || onSuccess === void 0 ? void 0 : onSuccess(data);
            return data;
        }
        catch (err) {
            (_b = globalConfig.message) === null || _b === void 0 ? void 0 : _b.error(err.message);
            onError === null || onError === void 0 ? void 0 : onError(err);
        }
    });
}
export function createServices(configs, baseConfig) {
    return Object.keys(configs).reduce((acc, key) => {
        acc[key] = createService(Object.assign(Object.assign({}, configs[key]), baseConfig));
        return acc;
    }, {});
}
const methodMap = {
    postformdata: 'postFormData',
    postformurlencoded: 'postFormUrlencoded',
};
function fixMethod(method) {
    method = method.toLowerCase();
    return methodMap[method] || method;
}
