import React, { useMemo } from 'react';
import { SystemProvider, extendTheme } from 'coral-system';
import { ConfigProvider } from 'antd';
import { TangoEngineProvider } from '@music163/tango-context';
import zhCN from 'antd/lib/locale/zh_CN';
import { DesignerProvider } from './context';
import defaultTheme from './themes/default';
/**
 * 设计器状态和设置容器
 * @param props
 * @returns
 */
export function Designer(props) {
    const { engine, config, theme: themeProp, sandboxQuery, remoteServices = {}, children } = props;
    const theme = useMemo(() => extendTheme(themeProp, defaultTheme), [themeProp]);
    return (React.createElement(SystemProvider, { theme: theme, prefix: "--tango" },
        React.createElement(ConfigProvider, { locale: zhCN },
            React.createElement(TangoEngineProvider, { value: { engine, config } },
                React.createElement(DesignerProvider, { value: { sandboxQuery, remoteServices } }, children)))));
}
