import React from 'react';
import { Designer, IWorkspace } from '@music163/tango-core';
import { DndQuery } from '.';
import { SelectModeType } from '../types';
interface UseDndProps {
    workspace: IWorkspace;
    designer: Designer;
    /**
     * 沙箱内的 DOM 查询操作
     */
    sandboxQuery: DndQuery;
    /**
     * 选择模式
     * - point 点选
     * - area 框选
     */
    selectMode?: SelectModeType;
    /**
     * 沙箱视图变化时的回调
     * @param data
     */
    onViewChange?: (data: any) => void;
}
export declare function useDnd({ sandboxQuery, designer, workspace, selectMode, onViewChange, }: UseDndProps): {
    onClick: (e: React.MouseEvent) => void;
    onMouseDown?: undefined;
    onDragStart: (e: React.DragEvent) => void;
    onDragEnter: (e: React.DragEvent<HTMLElement>) => void;
    onDragOver: (e: React.DragEvent<HTMLElement>) => void;
    onDrop: (e: React.DragEvent) => void;
    onDragEnd: () => void;
    onScroll: () => void;
    onKeyDown: (e: React.KeyboardEvent) => void;
    onTango: (e: CustomEvent) => void;
} | {
    onMouseDown: (e: React.MouseEvent) => void;
    onClick?: undefined;
    onDragStart: (e: React.DragEvent) => void;
    onDragEnter: (e: React.DragEvent<HTMLElement>) => void;
    onDragOver: (e: React.DragEvent<HTMLElement>) => void;
    onDrop: (e: React.DragEvent) => void;
    onDragEnd: () => void;
    onScroll: () => void;
    onKeyDown: (e: React.KeyboardEvent) => void;
    onTango: (e: CustomEvent) => void;
};
export {};
