import { Engine, SimulatorNameType } from './models';
import { IWorkspace } from './models/interfaces';
interface ICreateEngineOptions {
    /**
     * 自定义工作区
     */
    workspace?: IWorkspace;
    /**
     * 默认的模拟器模式
     */
    defaultSimulatorMode?: SimulatorNameType;
    /**
     * 默认激活的侧边栏
     */
    defaultActiveSidebarPanel?: string;
}
/**
 * Designer 实例化工厂函数
 * @param options
 * @returns
 */
export declare function createEngine({ workspace, defaultSimulatorMode, defaultActiveSidebarPanel, }: ICreateEngineOptions): Engine;
export {};
