import { Designer, Engine } from './models';
/**
 * Designer 实例化工厂函数
 * @param options
 * @returns
 */
export function createEngine({ workspace, defaultSimulatorMode = 'desktop', defaultActiveSidebarPanel = '', }) {
    const engine = new Engine({
        workspace,
        designer: new Designer({
            workspace,
            simulator: defaultSimulatorMode,
            activeSidebarPanel: defaultActiveSidebarPanel,
        }),
    });
    return engine;
}
