import React from 'react';
import { File } from './file';
import { ModuleList } from './module-list';
export class Directory extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            open: true,
        };
        this.toggleOpen = () => {
            this.setState((state) => ({ open: !state.open }));
        };
    }
    render() {
        const { prefixedPath, files, selectFile, activePath, depth } = this.props;
        return (React.createElement("div", { key: prefixedPath },
            React.createElement(File, { depth: depth, isDirOpen: this.state.open, onClick: this.toggleOpen, path: prefixedPath + '/' }),
            this.state.open ? (React.createElement(ModuleList, { activePath: activePath, depth: depth, files: files, prefixedPath: prefixedPath, selectFile: selectFile })) : null));
    }
}
