function hasKey(obj, key) {
    return Object.prototype.hasOwnProperty.call(obj, key);
}
function isSimpleObject(obj) {
    return (typeof obj === 'object' &&
        obj !== null &&
        !Array.isArray(obj) &&
        !(obj instanceof Date) &&
        !(obj instanceof RegExp));
}
export function mergeObjects(obj1, obj2) {
    if (!obj1) {
        return obj2;
    }
    if (!obj2) {
        return obj1;
    }
    const result = {};
    for (const key in obj1) {
        if (hasKey(obj1, key)) {
            if (isSimpleObject(obj1[key]) && isSimpleObject(obj2[key])) {
                result[key] = mergeObjects(obj1[key], obj2[key]);
            }
            else {
                result[key] = obj1[key];
            }
        }
    }
    for (const key in obj2) {
        if (hasKey(obj2, key)) {
            if (isSimpleObject(obj2[key]) && !hasKey(result, key)) {
                result[key] = mergeObjects({}, obj2[key]);
            }
            else if (!hasKey(result, key)) {
                result[key] = obj2[key];
            }
        }
    }
    return result;
}
