/**
 * condition 为 false 的时候打印 msg
 * @param condition
 * @param msg
 */
export function assert(condition, msg) {
    console.assert(condition, msg);
}
export function isString(str) {
    return typeof str === 'string';
}
export function isFunction(fn) {
    return typeof fn === 'function';
}
export function isNumber(num) {
    return typeof num === 'number';
}
export function isBoolean(obj) {
    return typeof obj === 'boolean';
}
export function isObject(obj) {
    return typeof obj === 'object' && !Array.isArray(obj) && obj !== null;
}
export function isPlainObject(obj) {
    return Object.prototype.toString.call(obj) === '[object Object]';
}
export function isPromise(obj) {
    return obj && obj.then && isFunction(obj.then);
}
/**
 * 判断值是否是 null 或 undefined
 * @param val
 * @returns true if val is null or undefined
 */
export function isNil(val) {
    return val == null;
}
/**
 * 是否是状态变量的 path
 * @param key
 * @returns
 */
export function isStoreVariablePath(key) {
    return key === 'pageStore' || /^stores\.[a-zA-Z0-9]+\.\w+$/.test(key);
}
/**
 * 是否是服务变量的 path
 * @param key
 * @returns
 */
export function isServiceVariablePath(key) {
    return /^services\.[a-zA-Z0-9]+/.test(key);
}
/**
 * 是否在 Tango 设计模式
 */
export function isInTangoDesignMode() {
    return !!window.__TANGO_DESIGNER__;
}
