/**
 * 合并 target 和 source 对象，source 对象的优先级更高，如存在重名，覆盖 target 中的 key
 * @param target target object
 * @param source source object
 * @return new merged object, target will not be modified
 */
export declare function merge(target: object, source: object): {};
/**
 * 从目标上下文中根据 keyPath 获取对应的值
 * @param context the object to query
 * @param keyPath the path of the property to get
 * @returns
 */
export declare function getValue(context: any, keyPath: string): any;
/**
 * Sets the value at path of object. If a portion of path doesn't exist, it's created. Arrays are created for missing index properties while objects are created for all other missing properties
 * @param context
 * @param keyPath
 * @param value
 * @returns
 */
export declare function setValue(context: any, keyPath: string, value: any): any;
/**
 * 浅拷贝目标对象，并清除对象上的 undefined value
 * @param obj
 */
export declare function clone(obj: any, withUndefined?: boolean): any;
export declare function omit(obj: any, keys: string[]): any;
export declare function pick(obj: any, keys: string[]): {};
