/**
 * 导入列表解析为导入声明对象
 * @param names
 * @param nameMap
 * @returns
 */
export function namesToImportDeclarations(names, nameMap) {
    const map = {};
    names.forEach((name) => {
        const mod = nameMap[name];
        if (mod) {
            updateMod(map, mod.source, name, mod.isDefault, !map[mod.source]);
        }
    });
    return Object.keys(map).map((sourcePath) => (Object.assign({ sourcePath }, map[sourcePath])));
}
function updateMod(map, fromPackage, specifier, isDefault = false, shouldInit = true) {
    if (shouldInit) {
        map[fromPackage] = {};
    }
    if (isDefault) {
        map[fromPackage].defaultSpecifier = specifier;
    }
    else if (map[fromPackage].specifiers) {
        map[fromPackage].specifiers.push(specifier);
    }
    else {
        map[fromPackage].specifiers = [specifier];
    }
}
