import * as t from '@babel/types';
import { IComponentProp, IComponentPrototype, Dict } from '@music163/tango-helpers';
import type { IImportDeclarationPayload, IImportSpecifierData } from '../types';
export declare function prototype2importDeclarationData(prototype: IComponentPrototype, relativeFilepath?: string): {
    source: string;
    specifiers: IImportSpecifierData[];
};
/**
 * 根据组件的 prototype 生成 ImportDeclarationPayload
 * @deprecated
 */
export declare function getImportDeclarationPayloadByPrototype(prototype: IComponentPrototype, relativeFilepath?: string): IImportDeclarationPayload;
/**
 * 基于 key-value 生成 prop={value} 字符串
 * @example { name: 'foo', initValue: false } >> name={false}
 * @example { name: 'foo', initValue: 1 } >> name={1}
 * @example { name: 'foo', initValue: () => {} } >> name={()=>{}}
 * @example { name: 'foo', initValue: { foo: 'bar' } } >> name={{ foo: 'bar' }}
 * @example { name: 'foo', initValue: [{ foo: 'bar' }] } >> name={[{ foo: 'bar' }]}
 * @example { name: 'foo', initValue: 'bar' } >> name="bar"
 * @example { name: 'foo', initValue: '{() => {}}' } >> name={()=>{}}
 * @example { name: 'foo', initValue: '{{() => {}}}' } >> name={() => {}}
 * @example { name: 'foo', initValue: '{bar}' } >> name={bar}
 * @returns
 */
export declare function propDataToKeyValueString(item: IComponentProp, generateValue?: (...args: any[]) => string): string;
/**
 * Button prototype -> <Button>hello</Button>
 *
 * @param prototype
 * @param extraProps
 */
export declare function prototype2code(prototype: IComponentPrototype, extraProps?: Dict): string;
/**
 * 基于 prototype 信息生成 t.JSXElement
 * @example ButtonPrototype -> <Button>hello</Button> -> t.JSXElement
 *
 * @param prototype 组件的配置信息
 * @param props 额外的属性集
 */
export declare function prototype2jsxElement(prototype: IComponentPrototype, props?: Dict): t.JSXElement;
