import i18n from 'i18next';
import LanguageDetector from 'i18next-browser-languagedetector';
import Backend from 'i18next-http-backend';
import { getWorkspace } from './global';
const __workspace__ = getWorkspace();
const options = {
    order: ['cookie', 'localStorage', 'sessionStorage', 'navigator', 'htmlTag', 'path', 'subdomain'],
    lookupLocalStorage: 'lng',
};
if (!__workspace__) {
    i18n
        // i18next-http-backend
        // loads translations from your server
        // https://github.com/i18next/i18next-http-backend
        .use(Backend);
}
// detect user language
// learn more: https://github.com/i18next/i18next-browser-languageDetector
i18n
    .use(LanguageDetector)
    // init i18next
    // for all options read: https://www.i18next.com/overview/configuration-options
    .init({
    debug: true,
    fallbackLng: 'zh-CN',
    detection: options,
    interpolation: {
        escapeValue: false, // not needed for react as it escapes by default
    },
    backend: {
        overrideMimeType: true,
        crossDomain: true,
    },
});
export default i18n;
