import React from 'react';
import { ReactJsonViewProps } from 'react-json-view';
export type JsonViewProps = Omit<ReactJsonViewProps, 'onSelect'> & {
    /**
     * 允许复制
     */
    enableCopy?: boolean;
    /**
     * 点击复制按钮的回调
     * @param valuePath value 的路径
     * @param data { src, namespace, name }
     * @returns
     */
    onCopy?: (valuePath: string, data: any) => string;
};
export declare function JsonView({ enableCopy, onCopy, ...rest }: JsonViewProps): React.JSX.Element;
