import { __rest } from "tslib";
import React from 'react';
import ReactJsonView from 'react-json-view';
export function JsonView(_a) {
    var { enableCopy, onCopy } = _a, rest = __rest(_a, ["enableCopy", "onCopy"]);
    return (React.createElement(ReactJsonView, Object.assign({ name: false, iconStyle: "square", quotesOnKeys: false, displayDataTypes: false, enableClipboard: enableCopy
            ? (data) => {
                const valuePath = getJsonValuePath(data.namespace);
                const ret = onCopy === null || onCopy === void 0 ? void 0 : onCopy(valuePath, data);
                navigator.clipboard.writeText(ret || valuePath);
            }
            : false }, rest)));
}
const numPattern = /^\d+$/;
function getJsonValuePath(namespace) {
    if (!Array.isArray(namespace)) {
        return;
    }
    if (namespace[0] === false) {
        namespace = namespace.slice(1);
    }
    return [...namespace].reduce((prev, cur) => {
        if (numPattern.test(cur)) {
            prev = `${prev}[${cur}]`;
        }
        else {
            prev = prev ? [prev, cur].join('?.') : cur;
        }
        return prev;
    }, '');
}
