import { action, computed, makeObservable, observable } from 'mobx';
export var DropMethod;
(function (DropMethod) {
    DropMethod["ReplaceNode"] = "replaceNode";
    DropMethod["InsertBefore"] = "insertBefore";
    DropMethod["InsertAfter"] = "insertAfter";
    DropMethod["InsertChild"] = "insertChild";
    DropMethod["InsertFirstChild"] = "insertFirstChild";
})(DropMethod || (DropMethod = {}));
/**
 * 放置目标类
 */
export class DropTarget {
    get node() {
        return this.workspace.getNode(this.data.id, this.data.filename);
    }
    /**
     * 获取对应的 prototype
     */
    get prototype() {
        var _a, _b;
        return ((_a = this.data) === null || _a === void 0 ? void 0 : _a.name) ? this.workspace.getPrototype((_b = this.data) === null || _b === void 0 ? void 0 : _b.name) : null;
    }
    get id() {
        var _a;
        return (_a = this.data) === null || _a === void 0 ? void 0 : _a.id;
    }
    get bounding() {
        var _a;
        return (_a = this.data) === null || _a === void 0 ? void 0 : _a.bounding;
    }
    get display() {
        var _a;
        return (_a = this.data) === null || _a === void 0 ? void 0 : _a.display;
    }
    constructor(workspace) {
        this.workspace = workspace;
        this.method = DropMethod.InsertAfter;
        this.data = null;
        makeObservable(this, {
            method: observable,
            data: observable,
            set: action,
            clear: action,
            node: computed,
        });
    }
    set(data, method) {
        this.data = data;
        this.method = method;
    }
    /**
     * 重置
     */
    clear() {
        this.data = null;
    }
    /**
     * 获取对应的 node
     * @deprecated
     */
    getNode() {
        return this.node;
    }
}
