import { cloneJSXElement, getJSXElementAttributes } from '../helpers';
/**
 * 视图节点类
 */
export class TangoNode {
    get loc() {
        var _a;
        return (_a = this.rawNode) === null || _a === void 0 ? void 0 : _a.loc;
    }
    constructor(props) {
        this.file = props.file;
        this.id = props.id;
        this.component = props.component;
        this.rawNode = props.rawNode;
        this.props = getJSXElementAttributes(cloneJSXElement(props.rawNode));
    }
    /**
     * 返回克隆后的 ast 节点
     * @param overrideProps 额外设置给克隆节点的属性
     * @returns
     */
    cloneRawNode(overrideProps) {
        return cloneJSXElement(this.rawNode, overrideProps);
    }
    /**
     * 清空节点的指向，交给 GC 去回收
     */
    destroy() {
        this.file = null;
    }
}
