import { ISelectedItemData, MousePoint } from '@music163/tango-helpers';
import { IViewFile, IWorkspace } from './interfaces';
type StartDataType = {
    point: MousePoint;
    element: HTMLElement;
};
export declare class SelectSource {
    /**
     * 选中元素列表
     */
    _items: ISelectedItemData[];
    /**
     * 用户选择的起点
     */
    _start: StartDataType;
    private readonly workspace;
    get start(): StartDataType;
    get first(): ISelectedItemData;
    get firstNode(): import("./interfaces").IViewNode;
    get size(): number;
    /**
     * 选中的结点数据 NodeData
     */
    get selected(): ISelectedItemData[];
    /**
     * 是否选中了结点
     */
    get isSelected(): boolean;
    /**
     * 选中结点位于的文件
     */
    get file(): IViewFile;
    /**
     * 选中的结点 Nodes
     */
    get nodes(): import("./interfaces").IViewNode[];
    constructor(workspace: IWorkspace);
    add(): void;
    remove(): void;
    select(items: ISelectedItemData | ISelectedItemData[]): void;
    setStart(data: StartDataType): void;
    clear(): void;
}
export {};
