import { IFileConfig, IStorePropertyData } from '../types';
import { IWorkspace } from './interfaces';
import { TangoModule } from './module';
/**
 * 入口配置模块
 */
export declare class TangoStoreEntryModule extends TangoModule {
    _stores: string[];
    get stores(): string[];
    constructor(workspace: IWorkspace, props: IFileConfig);
    _analysisAst(): void;
    /**
     * 新建模型
     * @param name
     */
    addStore(name: string): this;
    /**
     * 删除模型
     * @param name
     */
    removeStore(name: string): this;
}
/**
 * 状态模型模块
 */
export declare class TangoStoreModule extends TangoModule {
    /**
     * 模块名
     */
    name: string;
    namespace: string;
    states: IStorePropertyData[];
    actions: IStorePropertyData[];
    constructor(workspace: IWorkspace, props: IFileConfig);
    /**
     * 添加状态属性
     * @param stateName
     * @param initValue
     */
    addState(stateName: string, initValue: string): this;
    /**
     * 移除状态
     */
    removeState(stateName: string): this;
    /**
     * 更新状态代码
     * @param stateName 状态名
     * @param code 代码
     */
    updateState(stateName: string, code: string): this;
    _analysisAst(): void;
}
