import React from 'react';
import { HTMLCoralProps } from 'coral-system';
export interface PanelProps extends Omit<HTMLCoralProps<'div'>, 'title'> {
    /**
     * 面板标题
     */
    title?: React.ReactNode;
    /**
     * 小标题
     */
    subTitle?: React.ReactNode;
    /**
     * 标题栏附加节点
     */
    extra?: React.ReactNode;
    /**
     * 面板外观
     */
    shape?: 'solid' | 'light';
    headerProps?: HTMLCoralProps<'div'>;
    bodyProps?: HTMLCoralProps<'div'>;
}
export declare function Panel({ shape, title, subTitle: subTitleProp, extra, headerProps: headerPropsProp, bodyProps: bodyPropsProp, children, className, ...rest }: PanelProps): React.JSX.Element;
