import { __rest } from "tslib";
import React, { useMemo } from 'react';
import cx from 'classnames';
import { css, Box, Text } from 'coral-system';
import { merge } from '@music163/tango-helpers';
const headerStyle = css `
  user-select: none;
  display: flex;
  justify-content: space-between;
  align-items: center;
`;
export function Panel(_a) {
    var { shape = 'light', title, subTitle: subTitleProp, extra, headerProps: headerPropsProp, bodyProps: bodyPropsProp, children, className } = _a, rest = __rest(_a, ["shape", "title", "subTitle", "extra", "headerProps", "bodyProps", "children", "className"]);
    const systemProps = useMemo(() => {
        let rootProps;
        let headerProps;
        let bodyProps;
        if (shape === 'solid') {
            rootProps = {
                border: 'solid',
                borderColor: 'line.normal',
            };
            headerProps = {
                borderBottom: 'solid',
                borderBottomColor: 'line.normal',
                p: 'm',
                lineHeight: '24px',
            };
            bodyProps = {
                p: 'm',
            };
        }
        return {
            rootProps,
            headerProps: merge(headerProps, headerPropsProp),
            bodyProps: merge(bodyProps, bodyPropsProp),
        };
    }, [shape, headerPropsProp, bodyPropsProp]);
    const subTitle = typeof subTitleProp === 'string' && subTitleProp ? (React.createElement(Text, { ml: "m", fontSize: "note" }, subTitleProp)) : (subTitleProp);
    const showHeader = !!(title || subTitle || extra);
    return (React.createElement(Box, Object.assign({ display: "flex", flexDirection: "column", overflow: "auto", bg: "white" }, systemProps.rootProps, { className: cx('Panel', className) }, rest),
        showHeader && (React.createElement(Box, Object.assign({ flex: "0", px: "m", py: "s" }, systemProps.headerProps, { css: headerStyle, className: "PanelHeader" }),
            React.createElement(Box, null,
                React.createElement(Text, { color: "text.title", fontWeight: "500" }, title),
                subTitle && React.createElement(Text, { ml: "s" }, subTitle)),
            extra)),
        React.createElement(Box, Object.assign({ flex: "1", overflowY: "auto" }, systemProps.bodyProps, { className: "PanelBody" }), children)));
}
