import React from 'react';
import { RouteConfig } from 'react-router-config';
type IRouteConfig = Omit<RouteConfig, 'path'> & {
    path?: string;
};
export interface RunAppConfig {
    /**
     * 启动项配置
     */
    boot: {
        mountElement: HTMLElement;
        qiankun: false | {
            appName: string;
        };
    };
    /**
     * 单个页面应用的根组件，适合不需要前端路由的情况
     */
    singleEntry?: React.ComponentType;
    /**
     * 多页应用路由配置, router.config 的快捷写法
     */
    routes: IRouteConfig[];
    /**
     * 路由配置
     */
    router?: {
        config: IRouteConfig[];
        type?: 'browser' | 'hash';
        layout: React.FC;
    };
    /**
     * 根组件的父容器设置，传入的组件将一次作为应用根节点的父级组件
     */
    providers?: AppContainerProps['providers'];
}
export declare function runApp(config: RunAppConfig): {};
interface AppContainerProps {
    providers?: React.ReactElement[];
    children: React.ReactNode;
}
export {};
