import { __rest } from "tslib";
import React from 'react';
import { Text } from 'coral-system';
import { Input } from 'antd';
import { SearchOutlined } from '@ant-design/icons';
export function Search(_a) {
    var { placeholder = '请输入关键词', onChange, width, escapeValue = true, style: styleProp = {} } = _a, rest = __rest(_a, ["placeholder", "onChange", "width", "escapeValue", "style"]);
    const style = Object.assign({ width }, styleProp);
    return (React.createElement(Input, Object.assign({ placeholder: placeholder, onChange: (e) => {
            let next = e.target.value;
            if (escapeValue) {
                next = next.replaceAll('\\', '\\\\');
            }
            onChange === null || onChange === void 0 ? void 0 : onChange(next);
        }, suffix: React.createElement(Text, { color: "text.placeholder" },
            React.createElement(SearchOutlined, null)), allowClear: true, style: style }, rest)));
}
