import React from 'react';
import { Select } from 'antd';
import { ListSetter } from './list-setter';
const defaultNewOptionValue = {
    key: '1',
    label: '按钮',
};
const shapes = [
    { label: '普通按钮', value: 'button' },
    { label: '文本按钮', value: 'text' },
];
const buttonTypes = [
    { label: '主要', value: 'primary' },
    { label: '次要', value: 'secondary' },
    { label: '普通', value: 'normal' },
];
const types = [
    { label: '普通动作', value: 'action' },
    { label: '确认提示', value: 'confirm' },
];
const optionFormFields = [
    { label: 'key', name: 'key', required: true },
    { label: '文本', name: 'label', required: true },
    { label: '外观', name: 'shape', component: React.createElement(Select, { placeholder: "\u8BF7\u9009\u62E9", options: shapes }) },
    {
        label: '按钮类型',
        name: 'buttonType',
        component: React.createElement(Select, { placeholder: "\u8BF7\u9009\u62E9", options: buttonTypes }),
    },
    { label: '类型', name: 'actionType', component: React.createElement(Select, { placeholder: "\u8BF7\u9009\u62E9", options: types }) },
    { label: '确认气泡内容', name: 'confirmContent' },
];
const getKey = (item) => item.key;
const renderItem = (item) => item.label;
/**
 * 列表项设置器
 */
export function ActionListSetter(props) {
    return (React.createElement(ListSetter, Object.assign({ getListItemKey: getKey, renderItem: renderItem, listItemFormFields: optionFormFields, newItemDefaultValues: defaultNewOptionValue }, props)));
}
