import { __rest } from "tslib";
import React, { useCallback } from 'react';
import { Radio, Tooltip } from 'antd';
import { IconFont } from '@music163/tango-ui';
export function ChoiceSetter(_a) {
    var { options, onChange } = _a, props = __rest(_a, ["options", "onChange"]);
    const renderIcon = useCallback((icon) => {
        if (!icon) {
            return null;
        }
        if (icon.startsWith('icon-')) {
            return React.createElement(IconFont, { type: icon });
        }
        return null;
    }, []);
    return (React.createElement(Radio.Group, Object.assign({ optionType: "button", buttonStyle: "solid", onChange: (e) => {
            onChange && onChange(e.target.value);
        } }, props), options.map((item) => (React.createElement(RadioButton, { tip: item.tip, key: item.value, value: item.value },
        renderIcon(item.icon),
        item.label)))));
}
function RadioButton(_a) {
    var { tip } = _a, rest = __rest(_a, ["tip"]);
    let ret = React.createElement(Radio.Button, Object.assign({}, rest));
    if (tip) {
        ret = React.createElement(Tooltip, { title: tip }, ret);
    }
    return ret;
}
