import React from 'react';
import { Switch } from 'antd';
import { Box } from 'coral-system';
import { FieldStringOutlined } from '@ant-design/icons';
import { ListSetter } from './list-setter';
const defaultNewOptionValue = {
    // key: 'c1',
    // dataIndex: 'option',
    title: 'Column',
    // width: '200px',
};
const optionFormFields = [
    { label: 'key', name: 'key', required: true },
    { label: 'dataIndex', name: 'dataIndex', required: true },
    { label: '列标题', name: 'title', required: true },
    { label: '列宽', name: 'width' },
    { label: '锁列', name: 'fixed', valuePropName: 'checked', component: React.createElement(Switch, null) },
];
const renderSetterItem = (item) => {
    return (React.createElement(React.Fragment, null,
        React.createElement(FieldStringOutlined, null),
        React.createElement(Box, { display: "inline-block", ml: "m" }, item.title)));
};
/**
 * 表格列设置器
 */
export function ColumnSetter(props) {
    return (React.createElement(ListSetter, Object.assign({ getListItemKey: (item) => item.key || item.dataIndex, addBtnText: "\u6DFB\u52A0\u65B0\u5217", listItemFormFields: optionFormFields, newItemDefaultValues: defaultNewOptionValue, renderItem: renderSetterItem }, props)));
}
