import { __rest } from "tslib";
import React from 'react';
import moment from 'moment';
import { DatePicker, TimePicker } from 'antd';
function toMoment(value, format) {
    let ret;
    if (moment.isMoment(value)) {
        ret = value;
    }
    else if (typeof value === 'string' && format) {
        ret = moment(value, format);
    }
    else {
        ret = moment();
    }
    if (ret && ret.isValid()) {
        return ret;
    }
    return;
}
const style = {
    width: '100%',
};
export function DateSetter(_a) {
    var { value, onChange, format = 'YYYY-MM-DD' } = _a, rest = __rest(_a, ["value", "onChange", "format"]);
    return (React.createElement(DatePicker, Object.assign({}, rest, { format: format, style: style, value: value ? toMoment(value, format) : undefined, onChange: (val, str) => {
            onChange && onChange(str);
        } })));
}
function toMoments(value, format) {
    if (Array.isArray(value)) {
        return value.map((item) => toMoment(item, format));
    }
    return [];
}
export function DateRangeSetter(_a) {
    var { value, onChange, format = 'YYYY-MM-DD' } = _a, rest = __rest(_a, ["value", "onChange", "format"]);
    return (React.createElement(DatePicker.RangePicker, Object.assign({}, rest, { style: style, format: format, value: toMoments(value, format), onChange: (val, str) => {
            onChange && onChange(str);
        } })));
}
export function TimeSetter(_a) {
    var { value, onChange, format = 'HH:mm:ss' } = _a, rest = __rest(_a, ["value", "onChange", "format"]);
    return (React.createElement(TimePicker, Object.assign({}, rest, { format: format, style: style, value: toMoment(value, format), onChange: (val, str) => {
            onChange && onChange(str);
        } })));
}
export function TimeRangeSetter(_a) {
    var { value, onChange, format = 'HH:mm:ss' } = _a, rest = __rest(_a, ["value", "onChange", "format"]);
    return (React.createElement(TimePicker.RangePicker, Object.assign({}, rest, { style: style, format: format, value: toMoments(value, format), onChange: (val, str) => {
            onChange && onChange(str);
        } })));
}
