import React from 'react';
import { IVariableTreeNode } from '@music163/tango-helpers';
import { FormItemComponentProps } from '@music163/tango-setting-form';
export declare const expressionValueValidate: (value: string) => string;
export declare const jsonValueValidate: (value: string) => string;
export interface ExpressionSetterProps extends FormItemComponentProps<string> {
    modalTitle?: string;
    modalTip?: string;
    autoCompleteOptions?: string[];
    allowClear?: boolean;
    showOptionsDropDown?: boolean;
}
export declare function ExpressionSetter(props: ExpressionSetterProps): React.JSX.Element;
export interface ExpressionModalProps {
    title?: string;
    subTitle?: string;
    placeholder?: string;
    visible?: boolean;
    defaultValue?: string;
    value?: string;
    onCancel?: () => void;
    onOk?: (value: string) => void;
    dataSource?: IVariableTreeNode[];
    autoCompleteOptions?: string[];
    /**
     * 新建 store 的模板代码
     */
    newStoreTemplate?: string;
}
export declare function ExpressionModal({ title, subTitle, placeholder, visible, onCancel, onOk, defaultValue, value, dataSource, autoCompleteOptions, newStoreTemplate, }: ExpressionModalProps): React.JSX.Element;
