import React, { useState } from 'react';
import { Box } from 'coral-system';
import { SingleMonacoEditor } from '@music163/tango-ui';
/**
 * JSON Setter
 */
export function JSONSetter({ value: valueProp, onChange }) {
    const [value, setValue] = useState(valueProp || '');
    return (React.createElement(Box, { height: "120px", border: "solid", borderColor: "line.normal", borderRadius: "s" },
        React.createElement(SingleMonacoEditor, { defaultValue: value, onChange: (newValue) => {
                setValue(newValue);
            }, onBlur: (newValue) => {
                if (newValue !== value) {
                    onChange(newValue);
                }
            }, language: "json", options: {
                lineNumbers: 'off',
                minimap: {
                    enabled: false,
                },
            } })));
}
