import React, { useEffect, useState } from 'react';
import { Box } from 'coral-system';
import { Input, Radio } from 'antd';
import { isValidUrl } from '@music163/tango-helpers';
import { useWorkspaceData } from '@music163/tango-context';
import { PickerSetter } from './picker-setter';
export function RouterSetter(props) {
    const [type, setType] = useState(() => {
        return isValidUrl(props.value) ? 'input' : 'select';
    });
    const [input, setInput] = useState(props.value);
    const { routeOptions } = useWorkspaceData();
    const displayType = props.type || 'both';
    useEffect(() => {
        displayType === 'router' ? setType('select') : setType('input');
    }, [displayType]);
    return (React.createElement(Box, null,
        React.createElement(Box, { mb: "m" }, ['both', 'router'].includes(displayType) && (React.createElement(Radio.Group, { value: type, optionType: "button", buttonStyle: "solid", onChange: (e) => setType(e.target.value) },
            React.createElement(Radio, { value: "select" }, "\u9009\u62E9\u8DEF\u7531"),
            React.createElement(Radio, { value: "input" }, "\u81EA\u5B9A\u4E49\u8F93\u5165")))),
        type === 'select' && (React.createElement(PickerSetter, Object.assign({ placeholder: "\u8BF7\u9009\u62E9\u672C\u5730\u8DEF\u7531", options: routeOptions }, props))),
        type === 'input' && (React.createElement(Input, Object.assign({ placeholder: `请输入任意${{ link: '链接', router: '路由', both: '' }[displayType]}地址` }, props, { value: input, onChange: (e) => setInput(e.target.value), onBlur: () => props === null || props === void 0 ? void 0 : props.onChange(input) })))));
}
