import React from 'react';
import { PartialRecord } from '@music163/tango-helpers';
type MenuKeyType = 'common' | 'atom' | 'snippet' | 'bizComp' | 'localComp';
type MenuValueType = Array<{
    title: string;
    items: string[];
}>;
export type MenuDataType = PartialRecord<MenuKeyType, MenuValueType>;
export interface ComponentsPanelProps {
    /**
     * 菜单数据
     */
    menuData: MenuDataType;
    /**
     * 展示业务组件分类
     */
    showBizComps?: boolean;
    /**
     * 动态加载物料 loading，避免未加载完成用户点击空列表
     */
    loading?: boolean;
    /**
     * 设置业务组件调用名
     * @param name
     * @returns
     */
    getBizCompName?: (name: string) => string;
}
export declare function useFlatMenuData<T>(menuData: T): {
    title: string;
    items: string[];
}[];
export declare const ComponentsPanel: (({ menuData, showBizComps, getBizCompName, loading, }: ComponentsPanelProps) => React.JSX.Element) & {
    displayName: string;
};
export {};
