import { __rest } from "tslib";
import React from 'react';
import { observer, useWorkspace, useWorkspaceData } from '@music163/tango-context';
import { Box } from 'coral-system';
import { VariableTree } from '../../components';
import { useSandboxQuery } from '../../context';
// 移除掉不必要的属性
export function shapeServiceValues(val) {
    const shapeValues = Object.assign({}, val);
    delete shapeValues.type;
    return shapeValues;
}
const DataSourceView = observer(() => {
    const sandbox = useSandboxQuery();
    const workspace = useWorkspace();
    const { serviceVariables } = useWorkspaceData();
    const serviceModules = Object.keys(workspace.serviceModules).map((key) => ({
        label: key === 'index' ? '默认模块' : key,
        value: key,
    }));
    return (React.createElement(Box, { className: "ServiceFunctionList", p: "m" },
        React.createElement(VariableTree, { dataSource: serviceVariables, appContext: sandbox === null || sandbox === void 0 ? void 0 : sandbox.window['tango'], serviceModules: serviceModules, onRemoveService: (variableKey) => {
                workspace.removeServiceFunction(variableKey);
            }, onAddService: (data) => {
                const _a = shapeServiceValues(data), { name, moduleName } = _a, payload = __rest(_a, ["name", "moduleName"]);
                workspace.addServiceFunction(name, payload, moduleName);
            }, onUpdateService: (data) => {
                const _a = shapeServiceValues(data), { name, moduleName } = _a, payload = __rest(_a, ["name", "moduleName"]);
                workspace.updateServiceFunction(name, payload, moduleName);
            }, getServiceData: (serviceKey) => {
                const data = workspace.getServiceFunction(serviceKey);
                return Object.assign({ name: data.name, moduleName: data.moduleName, method: 'get' }, data.config);
            } })));
});
export default DataSourceView;
