import React from 'react';
import { HTMLCoralProps } from 'coral-system';
import { ReactComponentProps } from '@music163/tango-helpers';
export interface SidebarProps extends ReactComponentProps {
    /**
     * 面板宽度
     */
    panelWidth?: number;
    /**
     * 底部附加内容
     */
    footer?: React.ReactNode;
}
export interface SidebarPanelItemProps extends Omit<SidebarPanelBarItemProps, 'isActive'>, HTMLCoralProps<'div'> {
    /**
     * 面板唯一标识符
     */
    key?: string;
    /**
     * 面板标题
     * @deprecated
     */
    title?: string;
    /**
     * 文档地址
     * @deprecated
     */
    doc?: string;
    /**
     * 是否为浮动面板
     */
    isFloat?: boolean;
    /**
     * 面板宽度
     */
    width?: number;
    /**
     * 如果 key 匹配到内置组件的话，传递给子节点的属性
     */
    widgetProps?: object;
}
declare function BaseSidebarPanel({ panelWidth: defaultPanelWidth, footer, children }: SidebarProps): React.JSX.Element;
declare namespace BaseSidebarPanel {
    var Item: ({ key, title, doc, isFloat, width, widgetProps, }: SidebarPanelItemProps) => React.JSX.Element;
}
export declare const Sidebar: typeof BaseSidebarPanel & {
    displayName: string;
};
interface SidebarPanelBarItemProps {
    /**
     * 是否选中
     */
    isActive?: boolean;
    /**
     * 侧边栏图标
     */
    icon?: React.ReactNode;
    /**
     * 侧边栏图标说明，推荐使用 2 个字
     */
    label?: string;
    /**
     * 是否展示徽标
     */
    showBadge?: false | {
        /**
         * 是否显示小圆点
         */
        dot?: boolean;
        /**
         * 展示的数字
         */
        count?: number;
    };
}
export {};
