import React from 'react';
import { Button } from 'antd';
import { FileAddOutlined } from '@ant-design/icons';
import { useBoolean } from '@music163/tango-helpers';
import { Panel } from '@music163/tango-ui';
import { observer, useWorkspace, useWorkspaceData } from '@music163/tango-context';
import { VariableTree } from '../components';
import { CODE_TEMPLATES } from '../helpers';
import { AddStoreForm } from '../components/variable-tree/add-store';
export const VariablePanel = observer(({ newStoreTemplate = CODE_TEMPLATES.newStoreTemplate }) => {
    const [isAdd, { on, off }] = useBoolean();
    const workspace = useWorkspace();
    const { storeVariables } = useWorkspaceData();
    const storeNames = storeVariables.map((item) => item.title);
    return (React.createElement(Panel, { className: "ModelView", height: "100%", title: "\u89C6\u56FE\u6A21\u578B\u4E0E\u53D8\u91CF\u7BA1\u7406", extra: React.createElement(Button, { size: "small", type: "primary", icon: React.createElement(FileAddOutlined, null), onClick: on }, "\u65B0\u5EFA\u6A21\u578B"), bodyProps: { p: 'm' } }, isAdd ? (React.createElement(AddStoreForm, { storeNames: storeNames, onCancel: off, onSubmit: (values) => {
            workspace.addStoreFile(values.name, newStoreTemplate);
            off();
        } })) : (React.createElement(VariableTree, { defaultValueDetailMode: "define", dataSource: storeVariables, onAddStoreVariable: (storeName, data) => {
            workspace.addStoreState(storeName, data.name, data.initialValue);
        }, onRemoveStoreVariable: (variableKey) => {
            workspace.removeStoreVariable(variableKey);
        }, onUpdateStoreVariable: (variableKey, code) => {
            workspace.updateStoreVariable(variableKey, code);
        } }))));
});
