import React from 'react';
import { Box, css } from 'coral-system';
import { Breadcrumb } from 'antd';
import { observer, useWorkspace, useDesigner } from '@music163/tango-context';
const itemWrapperStyle = css `
  user-select: none;

  &:hover {
    color: var(--tango-colors-brand);
  }
`;
const ItemWrapper = (props) => {
    return React.createElement(Box, Object.assign({ display: "inline-block", css: itemWrapperStyle }, props));
};
export const BottomBar = observer(() => {
    var _a, _b;
    const workspace = useWorkspace();
    const designer = useDesigner();
    if (workspace.selectSource.size !== 1) {
        return null;
    }
    const parents = ((_b = (_a = workspace.selectSource) === null || _a === void 0 ? void 0 : _a.first) === null || _b === void 0 ? void 0 : _b.parents) || [];
    const reversedParents = [...parents].reverse();
    const length = parents.length;
    return (React.createElement(Box, { className: "BottomBar", display: designer.isPreview ? 'none' : 'block', flex: "0", px: "l", bg: "background.normal", borderTop: "solid", borderTopColor: "line.normal" },
        React.createElement(Breadcrumb, null,
            reversedParents.map((parent, index) => (React.createElement(Breadcrumb.Item, { key: parent.id, onClick: () => {
                    workspace.selectSource.select(Object.assign(Object.assign({}, parent), { parents: parents.slice(length - index) }));
                } },
                React.createElement(ItemWrapper, null, parent.name)))),
            React.createElement(Breadcrumb.Item, { key: workspace.selectSource.first.id },
                React.createElement(ItemWrapper, null, workspace.selectSource.first.name)))));
});
