import { __rest } from "tslib";
import React from 'react';
import styled from 'styled-components';
import cx from 'classnames';
import { Tabs as AntTabs } from 'antd';
const StyledTabs = styled(AntTabs) `
  .ant-tabs-nav {
    padding-left: 12px;
    padding-right: 12px;
    margin: 0;
  }

  &.sticky .ant-tabs-nav {
    position: sticky;
    top: ${(props) => props.$stickyOffset};
    z-index: 2;
    background: #fff;
  }

  &.ant-tabs-centered .ant-tabs-nav {
    margin: 0;
  }
`;
export function Tabs(_a) {
    var { centered, isTabBarSticky = false, tabBarStickyOffset = 0, className } = _a, rest = __rest(_a, ["centered", "isTabBarSticky", "tabBarStickyOffset", "className"]);
    const classNames = cx(className, { sticky: isTabBarSticky });
    return (React.createElement(StyledTabs, Object.assign({ size: "small", tabBarGutter: 24, centered: centered, className: classNames, "$stickyOffset": tabBarStickyOffset }, rest)));
}
Tabs.TabPane = AntTabs.TabPane;
