import { __rest } from "tslib";
import React from 'react';
import { Box } from 'coral-system';
import { Tag } from 'antd';
import { useControllableState, warning } from '@music163/tango-helpers';
export function TagSelect(_a) {
    var { value: valueProp, defaultValue = [], onChange, options, mode = 'multiple' } = _a, rest = __rest(_a, ["value", "defaultValue", "onChange", "options", "mode"]);
    const [value, setValue] = useControllableState({
        value: valueProp,
        defaultValue,
        onChange,
    });
    if (mode === 'single' && value.length > 1) {
        warning(false, '单选模式下 value 只能有一个值！');
    }
    return (React.createElement(Box, Object.assign({ className: "TangoTagSelect" }, rest), options.map((option) => (React.createElement(Tag.CheckableTag, { className: option.disabled ? 'disabled' : undefined, key: option.value, checked: value.includes(option.value), onChange: (checked) => {
            if (mode === 'multiple') {
                if (checked) {
                    setValue([...value, option.value]);
                }
                else {
                    setValue(value.filter((item) => item !== option.value));
                }
            }
            else {
                checked ? setValue([option.value]) : setValue([]);
            }
        } }, option.label)))));
}
