import React from 'react';
import { HTMLCoralProps } from 'coral-system';
import { DropDownProps, MenuProps, TooltipProps } from 'antd';
export interface ToggleButtonProps extends Omit<HTMLCoralProps<'button'>, 'type'> {
    size?: 's' | 'm' | 'l' | 'xl';
    shape?: 'outline' | 'ghost' | 'text';
    type?: 'normal' | 'primary';
    selected?: boolean;
    disabled?: boolean;
    icon?: React.ReactNode;
    /**
     * 提示文案
     * @deprecated 使用 tooltip 代替
     */
    tip?: string;
    /**
     * 提示文案
     */
    tooltip?: string;
    /**
     * 提示文案的位置
     */
    tooltipPlacement?: TooltipProps['placement'];
    /**
     * 下拉菜单
     */
    items?: MenuProps['items'];
    /**
     * 自定义下拉弹层
     */
    overlay?: DropDownProps['overlay'];
    /**
     * 下拉弹层的样式
     */
    overlayStyle?: DropDownProps['overlayStyle'];
    /**
     * 点击菜单项的回调
     */
    onItemClick?: MenuProps['onClick'];
    /**
     * 下拉菜单的属性
     */
    dropdownProps?: DropDownProps;
}
/**
 * TODO: 使用 Action 重构
 */
export declare function ToggleButton(props: ToggleButtonProps): React.JSX.Element;
