import React from 'react';
import { Box } from 'coral-system';
import { ToggleButton, RedoOutlined, UndoOutlined } from '@music163/tango-ui';
import { observer, useWorkspace } from '@music163/tango-context';
export const HistoryTool = observer(() => {
    const workspace = useWorkspace();
    return (React.createElement(Box, { display: "flex", columnGap: "m" },
        React.createElement(ToggleButton, { shape: "ghost", disabled: !workspace.history.couldBack || workspace.history.index === 0, tooltip: "\u64A4\u9500", onClick: () => {
                workspace.history.back();
                workspace.selectSource.clear();
            } },
            React.createElement(UndoOutlined, null)),
        React.createElement(ToggleButton, { shape: "ghost", disabled: !workspace.history.couldForward, tooltip: "\u91CD\u505A", onClick: () => {
                workspace.history.forward();
                workspace.selectSource.clear();
            } },
            React.createElement(RedoOutlined, null))));
});
