/**
 * 文件类型枚举
 */
export var FileType;
(function (FileType) {
    // js 文件
    FileType["Module"] = "module";
    FileType["StoreEntryModule"] = "storeEntryModule";
    FileType["RouteModule"] = "routeModule";
    FileType["ServiceModule"] = "serviceModule";
    FileType["StoreModule"] = "storeModule";
    // 组件配置文件
    FileType["ComponentPrototypeModule"] = "componentPrototypeModule";
    // 组件运行调试入口文件，一般为 `/app.js`
    FileType["ComponentDemoEntryModule"] = "componentDemoEntryModule";
    /**
     * 本地组件目录的入口文件
     */
    FileType["ComponentsEntryModule"] = "componentsEntryModule";
    /**
     * @deprecated 已废弃
     */
    FileType["BlockEntryModule"] = "blockEntryModule";
    // jsx 类型视图文件
    FileType["JsxViewModule"] = "jsxViewModule";
    // json 类型视图文件
    FileType["JsonViewModule"] = "jsonViewModule";
    // 非 js 文件
    FileType["PackageJson"] = "packageJson";
    FileType["TangoConfigJson"] = "tangoConfigJson";
    FileType["AppJson"] = "appJson";
    FileType["File"] = "file";
    FileType["Json"] = "json";
    FileType["Less"] = "less";
    FileType["Scss"] = "scss";
})(FileType || (FileType = {}));
