import React from 'react';
import { Box } from 'coral-system';
import { observer, useDesigner } from '@music163/tango-context';
export const WorkspaceView = observer((props) => {
    const { mode = 'design', children } = props;
    const designer = useDesigner();
    const display = mode !== designer.activeView ? 'none' : 'block';
    // 云音乐移动端模式小屏幕适配，可能会溢出屏幕
    const overflow = designer.simulator.name === 'phone' ? 'auto' : designer.isPreview ? 'auto' : 'hidden';
    return (React.createElement(Box, { className: `ViewPanel ${mode}`, display: designer.activeView === 'dual' ? 'block' : display, flex: "1", overflow: overflow, position: "relative" }, children));
});
