"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var field_mapping_1 = tslib_1.__importDefault(require("./field-mapping"));
var FieldTypeComponent = function (props) {
    var type = props.type, agents = props.agents, transProps = tslib_1.__rest(props, ["type", "agents"]);
    var Component = (0, react_1.useMemo)(function () { return field_mapping_1.default[type]; }, [type]);
    if (Component && type) {
        if (type === 'staff') {
            return (react_1.default.createElement(Component, tslib_1.__assign({}, transProps, { agents: agents })));
        }
        else if (type === 'datetime') {
            var is_standard = (props || {}).is_standard;
            return (react_1.default.createElement(Component, tslib_1.__assign({}, transProps, { needTransfer: is_standard })));
        }
        else if (type === 'file') {
            var _a = props || {}, file_suffix = _a.file_suffix, file_size_limit = _a.file_size_limit, file_field_size_limit = _a.file_field_size_limit, file_count_limit = _a.file_count_limit;
            return (react_1.default.createElement(Component, tslib_1.__assign({}, transProps, { marking: 'web.custom_field.file', singleLimit: file_size_limit, totalLimit: file_field_size_limit, uploadProps: { accept: file_suffix, maxCount: file_count_limit } })));
        }
        return (react_1.default.createElement(Component, tslib_1.__assign({}, props)));
    }
    else {
        return null;
    }
};
exports.default = FieldTypeComponent;
