"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
// @ts-nocheck
var react_1 = tslib_1.__importStar(require("react"));
var viewerjs_1 = tslib_1.__importDefault(require("viewerjs"));
// import { downLoadFile } from '@/service';
var utils_1 = require("@udesk-webapp/utils");
var locale_1 = require("@udesk-webapp/locale");
var file_icon_1 = tslib_1.__importDefault(require("../file-icon"));
var common_1 = require("../../utils/common");
var ImageAttachment = function (_a) {
    var url = _a.url, file_name = _a.file_name, onPreviewImage = _a.onPreviewImage, downloadFile = _a.downloadFile, id = _a.id, imgIndex = _a.imgIndex, formatMessage = _a.formatMessage;
    var type = (file_name === null || file_name === void 0 ? void 0 : file_name.split('.').pop()) || '';
    return (react_1.default.createElement("div", null,
        react_1.default.createElement(file_icon_1.default, { type: type }),
        react_1.default.createElement("span", null, file_name),
        react_1.default.createElement("img", { src: url, style: { display: 'none' }, alt: file_name }),
        react_1.default.createElement("a", { className: "mgl-10", role: "button", "data-ignore-switch-editing": "1", onClick: function (e) {
                e.stopPropagation();
                onPreviewImage(imgIndex);
            } }, formatMessage('labels.preview')),
        react_1.default.createElement("a", { href: url, className: "mgl-5", "data-ignore-switch-editing": "1", target: "_blank", download: file_name, onClick: function (e) {
                e.stopPropagation();
                downloadFile(id);
            } }, formatMessage('labels.download'))));
};
var DocumentLikeAttachment = function (_a) {
    var url = _a.url, file_name = _a.file_name, onPreview = _a.onPreview, downloadFile = _a.downloadFile, id = _a.id, formatMessage = _a.formatMessage;
    var type = (file_name === null || file_name === void 0 ? void 0 : file_name.split('.').pop()) || '';
    return (react_1.default.createElement("div", null,
        react_1.default.createElement(file_icon_1.default, { type: type }),
        react_1.default.createElement("span", null, file_name),
        onPreview ? (react_1.default.createElement("a", { className: "mgl-10", role: "button", "data-ignore-switch-editing": "1", onClick: function (e) {
                e.stopPropagation();
                onPreview({ url: url, file_name: file_name });
            } }, formatMessage('labels.preview'))) : null,
        react_1.default.createElement("a", { href: url, className: "mgl-5", "data-ignore-switch-editing": "1", target: "_blank", download: file_name, onClick: function (e) {
                e.stopPropagation();
                downloadFile(id);
            } }, formatMessage('labels.download'))));
};
var CommonAttachment = function (_a) {
    var url = _a.url, file_name = _a.file_name;
    var type = (file_name === null || file_name === void 0 ? void 0 : file_name.split('.').pop()) || '';
    return (react_1.default.createElement("a", { className: "link", href: url, "data-ignore-switch-editing": "1", target: "_blank" },
        react_1.default.createElement(file_icon_1.default, { type: type }),
        file_name));
};
var AttachmentList = function (_a) {
    var attachments = _a.attachments, previewUrl = _a.previewUrl, udeskVersion = _a.udeskVersion, ticketId = _a.ticketId, downLoadLogEnable = _a.downLoadLogEnable;
    var formatMessage = (0, locale_1.useTranslation)().t; // 多语言
    var ref = (0, react_1.useRef)();
    var viewer = (0, react_1.useRef)();
    (0, react_1.useLayoutEffect)(function () {
        if (!ref.current) {
            return;
        }
        viewer.current = new viewerjs_1.default(ref.current);
        return function () {
            var _a;
            (_a = viewer.current) === null || _a === void 0 ? void 0 : _a.destroy();
        };
    }, []);
    (0, react_1.useEffect)(function () {
        var _a;
        (_a = viewer.current) === null || _a === void 0 ? void 0 : _a.update();
    }, [attachments]);
    var downloadFile = function (id) {
        if (!downLoadLogEnable)
            return;
        // downLoadFile({
        //     ticket_attachment_download_log: {
        //         attachment_id: id,
        //         ticket_id: ticketId,
        //     },
        // });
        (0, utils_1.ajax)().postJSON('/cs/ts/api/ticket_attachment_download_logs', {
            ticket_attachment_download_log: {
                attachment_id: id,
                ticket_id: ticketId,
            }
        }).then(function (res) {
        }).catch(function (e) {
        });
    };
    var onPreview = function (_a) {
        var url = _a.url;
        if (url) {
            var u = (0, common_1.getPreviewUrl)(url, {
                previewUrl: previewUrl
            });
            window.open(u, '_blank');
        }
    };
    var imgIndex = 0;
    var imgAttachment = [], docAttachment = [], comAttachment = [];
    (attachments || []).forEach(function (i, idx) {
        if (/\.(jpg|png|gif|jpeg)$/.test(i.file_name)) {
            i.imgIndex = imgIndex++;
            imgAttachment.push(react_1.default.createElement(ImageAttachment, tslib_1.__assign({}, i, { onPreviewImage: function (idx) {
                    var _a;
                    (_a = viewer.current) === null || _a === void 0 ? void 0 : _a.view(idx);
                }, downloadFile: downloadFile, key: idx, formatMessage: formatMessage })));
        }
        else if (udeskVersion === 'pro' &&
            /.(doc|docx|odt|rtf|wps|ppt|pptx|odp|dp|xls|xlsx|ods|csv|et|pdf)$/.test(i.file_name)) {
            docAttachment.push(react_1.default.createElement(DocumentLikeAttachment, tslib_1.__assign({}, i, { onPreview: onPreview, downloadFile: downloadFile, key: idx, formatMessage: formatMessage })));
        }
        else {
            comAttachment.push(react_1.default.createElement(CommonAttachment, tslib_1.__assign({}, i, { key: idx })));
        }
    });
    return (react_1.default.createElement("div", null,
        react_1.default.createElement("div", { ref: ref }, imgAttachment),
        docAttachment,
        comAttachment));
};
exports.default = AttachmentList;
