"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
// @ts-nocheck
var react_1 = tslib_1.__importStar(require("react"));
var rich_editor_1 = tslib_1.__importDefault(require("@udesk-webapp/rich-editor"));
require("./index.module.scss");
var copy_1 = tslib_1.__importDefault(require("../../copy"));
var content_view_1 = tslib_1.__importDefault(require("../content-view"));
var ContentEditComponent = react_1.default.forwardRef(function (props, ref) {
    var disabled = props.disabled, value = props.value, onChange = props.onChange, onEditorPostRender = props.onEditorPostRender, _a = props.backgroundColor, backgroundColor = _a === void 0 ? '' : _a, _b = props.showUploadImg, showUploadImg = _b === void 0 ? true : _b, copyProps = props.copyProps, readOnly = props.readOnly, translate = props.translate, _c = props.statusbar, statusbar = _c === void 0 ? true : _c;
    var _d = (0, react_1.useState)(value || ''), content = _d[0], setContent = _d[1];
    var richEditorRef = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(function () {
        setContent(value || '');
    }, [value]);
    var onEditorChange = function (content) {
        setContent(content);
        onChange === null || onChange === void 0 ? void 0 : onChange(content);
    };
    // 保留子组件插入文本的能力
    (0, react_1.useImperativeHandle)(ref, function () { return ({
        insertContent: function (content) {
            if (!(richEditorRef === null || richEditorRef === void 0 ? void 0 : richEditorRef.current)) {
                return;
            }
            var insertContent = (richEditorRef === null || richEditorRef === void 0 ? void 0 : richEditorRef.current).insertContent;
            insertContent === null || insertContent === void 0 ? void 0 : insertContent(content);
        },
    }); });
    var copyText = (0, react_1.useMemo)(function () {
        return content.replace(new RegExp('<[^>]+>', 'gi'), '');
    }, [content]);
    return (readOnly ?
        react_1.default.createElement(content_view_1.default, tslib_1.__assign({}, props, { copyProps: copyProps, content: content }))
        :
            react_1.default.createElement(copy_1.default, tslib_1.__assign({}, copyProps, { text: copyText }),
                react_1.default.createElement("div", { className: "contentEdit-wrap" },
                    react_1.default.createElement("div", { className: "contentEdit-content" },
                        react_1.default.createElement(rich_editor_1.default, { marking: "web.ts.create_ticket", autoresize_min_height: 130, autoresize_max_height: 200, statusbar: statusbar, paste_data_images: true, readonly: disabled, value: content, showImg: showUploadImg, 
                            // defaultValue={''}
                            backgroundColor: backgroundColor, onChange: onEditorChange, postRender: onEditorPostRender, translate: translate, ref: richEditorRef })))));
});
exports.default = ContentEditComponent;
