"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var icons_1 = require("@ant-design/icons");
var utils_1 = require("@udesk-webapp/utils");
var copy_1 = tslib_1.__importDefault(require("../../copy"));
var react_viewer_1 = tslib_1.__importDefault(require("react-viewer"));
require("./index.module.scss");
var locale_1 = require("@udesk-webapp/locale");
function isHtml(text) {
    return /<[^>]+>/g.test(text);
}
function safeHtml(text) {
    var div = document.createElement('div');
    div.innerHTML = text;
    return (div.innerHTML || '').replace(/class\s*=\s*['"]([\w\s-])+['"]/gi, '');
}
function safeContent(text) {
    if (text && /\r\n|\n/.test(text)) {
        text = text.replace(/\r\n|\n/g, '<br>');
    }
    if (isHtml(text)) {
        return safeHtml(text);
    }
    return text;
}
var RichTextView = function (props, ref) {
    var content = props.content, _a = props.isDefaultOpen, isDefaultOpen = _a === void 0 ? false : _a, _b = props.defaultHeight, defaultHeight = _b === void 0 ? 72 : _b, copyProps = props.copyProps, _c = props.platform, platform = _c === void 0 ? '' : _c, xssWhiteList = props.xssWhiteList;
    var formatMessage = (0, locale_1.useTranslation)().t; // 多语言
    var isRichTextEmpty = !content;
    var richTextContentDetailDom = null;
    var _d = (0, react_1.useState)(false), open = _d[0], setOpen = _d[1];
    var _e = (0, react_1.useState)(false), buttonsVisible = _e[0], setButtonsVisible = _e[1];
    var _f = (0, react_1.useState)(false), visible = _f[0], setVisible = _f[1];
    var _g = (0, react_1.useState)([]), viewerImages = _g[0], setViewerImages = _g[1];
    var defaultHeightStyle = (0, react_1.useMemo)(function () {
        if (!isDefaultOpen && !open) {
            return {
                maxHeight: "".concat(defaultHeight, "px"),
                height: 'auto',
            };
        }
        return {
            height: 'auto',
        };
    }, [isDefaultOpen, open, defaultHeight]);
    var onViewerClose = (0, react_1.useCallback)(function () {
        setVisible(false);
    }, []);
    var copyText = (0, react_1.useMemo)(function () {
        return content.replace(new RegExp('<[^>]+>', 'gi'), '');
    }, [content]);
    var onShrink = (0, react_1.useCallback)(function (e) {
        e.stopPropagation();
        setOpen(false);
    }, [setOpen]);
    var onUnfold = (0, react_1.useCallback)(function (e) {
        e.stopPropagation();
        setOpen(true);
    }, [setOpen]);
    var showViewer = (0, react_1.useCallback)(function (url) {
        setViewerImages([
            {
                src: url,
                alt: '',
            },
        ]);
        setVisible(true);
    }, []);
    var resizeViewHeight = function () {
        if (richTextContentDetailDom) {
            var offsetHeight = richTextContentDetailDom === null || richTextContentDetailDom === void 0 ? void 0 : richTextContentDetailDom.offsetHeight;
            var hasImg = /<img/.test(content); // 判断图片 图片加载需要时间 如果有图片直接显示‘展开’
            if ((offsetHeight > defaultHeight || hasImg) && !isDefaultOpen) {
                setButtonsVisible(true);
            }
            var images_1 = richTextContentDetailDom === null || richTextContentDetailDom === void 0 ? void 0 : richTextContentDetailDom.querySelectorAll('img');
            images_1 &&
                images_1.forEach(function (image, index) {
                    image.addEventListener('click', function (event) {
                        var imgs = [];
                        for (var i = index; i <= images_1.length; i++) {
                            var img = images_1[i];
                            if (img === null || img === void 0 ? void 0 : img.src) {
                                imgs.push({
                                    src: img.src,
                                    alt: img === null || img === void 0 ? void 0 : img.title,
                                });
                            }
                        }
                        for (var i = 0; i < index; i++) {
                            var img = images_1[i];
                            if (img === null || img === void 0 ? void 0 : img.src) {
                                imgs.push({
                                    src: img.src,
                                    alt: img === null || img === void 0 ? void 0 : img.title,
                                });
                            }
                        }
                        setViewerImages(imgs);
                        setVisible(true);
                    });
                });
        }
    };
    (0, react_1.useEffect)(function () {
        resizeViewHeight();
    }, [content]);
    var safeHtmlContent = function (content, xssWhiteList) {
        if (platform === 'email') {
            return (0, utils_1.replaceScriptCode)(safeContent(content));
        }
        return (0, utils_1.xssByRichEditorWhiteList)(content, {
            whiteList: xssWhiteList
        });
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(copy_1.default, tslib_1.__assign({}, copyProps, { text: copyText }),
            react_1.default.createElement("div", { className: "ticketBasicField-richTextView" },
                react_1.default.createElement("div", { style: defaultHeightStyle, className: "richTextView-content" }, isRichTextEmpty ?
                    react_1.default.createElement("span", { className: "richTextView-content-empty" }, "- -")
                    : react_1.default.createElement("div", { ref: function (ref) { return (richTextContentDetailDom = ref); }, className: "richTextView-content-wrapper" },
                        react_1.default.createElement("div", { className: "richTextView-container", dangerouslySetInnerHTML: {
                                __html: safeHtmlContent(content, xssWhiteList),
                            } }))),
                buttonsVisible &&
                    react_1.default.createElement("div", { className: "richTextView-buttons" }, open ?
                        react_1.default.createElement("a", { href: "javascript:;", onClick: onShrink, className: "spread-button m-r-sm" },
                            react_1.default.createElement("span", null, formatMessage('labels.packUp')),
                            react_1.default.createElement(icons_1.UpOutlined, null))
                        : react_1.default.createElement("a", { href: "javascript:;", onClick: onUnfold, className: "spread-button m-r-sm" },
                            react_1.default.createElement("span", null, formatMessage('labels.packDown')),
                            react_1.default.createElement(icons_1.DownOutlined, null))))),
        react_1.default.createElement(react_viewer_1.default, { zIndex: 19999, visible: visible, onClose: onViewerClose, images: viewerImages })));
};
exports.default = RichTextView;
