"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PositionEnum = void 0;
var tslib_1 = require("tslib");
// @ts-nocheck
var react_1 = tslib_1.__importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var react_copy_to_clipboard_1 = tslib_1.__importDefault(require("react-copy-to-clipboard"));
require("./index.module.scss");
var locale_1 = require("@udesk-webapp/locale");
var PositionEnum;
(function (PositionEnum) {
    PositionEnum["Top"] = "top";
    PositionEnum["Left"] = "left";
    PositionEnum["Right"] = "right";
    PositionEnum["Bottom"] = "bottom";
    PositionEnum["TopLeft"] = "topLeft";
    PositionEnum["TopRight"] = "topRight";
    PositionEnum["BottomLeft"] = "bottomLeft";
    PositionEnum["BottomRight"] = "bottomRight";
    PositionEnum["LeftTop"] = "leftTop";
    PositionEnum["LeftBottom"] = "leftBottom";
    PositionEnum["RightTop"] = "rightTop";
    PositionEnum["RightBottom"] = "rightBottom";
})(PositionEnum = exports.PositionEnum || (exports.PositionEnum = {}));
var CopyText = function (props) {
    // 默认显示在右上角，不能默认显示在容器外面，因为外层容器上设置了overflow:hidden，这样复制按钮就显示不出来了。
    // 而设置overflow:hidden的原因是为了内容过长时，显示省略号...
    var icon = props.icon, text = props.text, _a = props.left, left = _a === void 0 ? '' : _a, _b = props.right, right = _b === void 0 ? '' : _b, _c = props.top, top = _c === void 0 ? '' : _c, _d = props.bottom, bottom = _d === void 0 ? '' : _d, _e = props.switchFlag, switchFlag = _e === void 0 ? true : _e, _f = props.btnSize, btnSize = _f === void 0 ? 'small' : _f, _g = props.type, type = _g === void 0 ? 'default' : _g, _h = props.buttonText, buttonText = _h === void 0 ? '' : _h, _j = props.placement, placement = _j === void 0 ? PositionEnum.TopRight : _j, className = props.className, style = props.style;
    var formatMessage = (0, locale_1.useTranslation)().t; // 多语言
    var buttonStyle = {
        left: left,
        right: right,
        top: top,
        bottom: bottom,
    };
    var _k = (0, react_1.useState)(buttonStyle), copyStyle = _k[0], setCopyStyle = _k[1];
    var showButton = (0, react_1.useCallback)(function () {
        setCopyStyle(tslib_1.__assign(tslib_1.__assign({}, copyStyle), { visibility: text === '' || text === null || text === undefined ? 'hidden' : 'visible' }));
    }, [copyStyle, text]);
    var hideButton = (0, react_1.useCallback)(function () {
        setCopyStyle(tslib_1.__assign(tslib_1.__assign({}, copyStyle), { visibility: 'hidden' }));
    }, [copyStyle]);
    var copyText = function (_text, result) {
        if (result) {
            udesk_ui_1.message.info(formatMessage('tips.success.copy'));
        }
        else {
            udesk_ui_1.message.error(formatMessage('tips.fail.copy'));
        }
    };
    var handleClick = (0, react_1.useCallback)(function (event) {
        event.stopPropagation();
    }, []);
    return switchFlag ? (react_1.default.createElement("div", { onMouseEnter: showButton, onMouseLeave: hideButton, className: className ? "".concat(className, " copy-container") : 'copy-container', style: style },
        react_1.default.createElement(react_copy_to_clipboard_1.default, { text: text, onCopy: copyText },
            react_1.default.createElement(udesk_ui_1.Button, { className: "copy-button copy-position-".concat(placement), size: btnSize, style: copyStyle, onClick: handleClick, type: type, icon: icon }, buttonText || formatMessage('labels.copy'))),
        props.children)) : (react_1.default.createElement(react_1.default.Fragment, null, props.children));
};
exports.default = CopyText;
