"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var dayjs_1 = tslib_1.__importDefault(require("dayjs"));
require("dayjs/locale/zh-cn");
var en_US_1 = tslib_1.__importDefault(require("antd/es/date-picker/locale/en_US"));
var zh_CN_1 = tslib_1.__importDefault(require("antd/es/date-picker/locale/zh_CN"));
var copy_1 = tslib_1.__importDefault(require("../copy"));
var react_dom_1 = tslib_1.__importDefault(require("react-dom"));
var utils_1 = require("@udesk-webapp/utils");
var YYYY_MM_DD = 'YYYY-MM-DD';
var YYYY_M_D = 'YYYY-M-D';
var YYYY_MM_DD_HH_MM = 'YYYY-MM-DD HH:mm';
var YYYY_MM_DD_HH_MM_SS = 'YYYY-MM-DD HH:mm:ss';
var YYYY_M_D_HH_MM = 'YYYY-M-D HH:mm';
var YYYY_M_D_HH_MM_SS = 'YYYY-M-D HH:mm:ss';
// 日期类 注意格式和多语言
var FormDatePicker = function (props) {
    var onChange = props.onChange, onValueBlur = props.onValueBlur, id = props.id, value = props.value, _a = props.showTime, showTime = _a === void 0 ? false : _a, _b = props.language, language = _b === void 0 ? 'zh-CN' : _b, copyProps = props.copyProps, format = props.format, _c = props.blurToSave, blurToSave = _c === void 0 ? true : _c, _d = props.needTransfer, needTransfer = _d === void 0 ? false : _d, restProps = tslib_1.__rest(props, ["onChange", "onValueBlur", "id", "value", "showTime", "language", "copyProps", "format", "blurToSave", "needTransfer"]);
    var _e = (0, react_1.useState)(value || null), dateValue = _e[0], setDateValue = _e[1];
    // 这里format为数组兼容复制YYYY_MM_DD_HH_MM_SS等其他时间格式后可以保存（antd默认转换为数组第一个）
    // 注意format为数组，showtime需要为 { format: 'HH:mm' }。为true antd会报错
    var antdFormat = format ? format : (showTime ? [YYYY_MM_DD_HH_MM, YYYY_MM_DD_HH_MM_SS, YYYY_M_D_HH_MM, YYYY_M_D_HH_MM_SS] : [YYYY_MM_DD, YYYY_M_D, YYYY_MM_DD_HH_MM, YYYY_MM_DD_HH_MM_SS, YYYY_M_D_HH_MM, YYYY_M_D_HH_MM_SS]);
    // const dateFormat = typeof antdFormat === 'string' ? antdFormat : antdFormat[0];
    var dateRef = (0, react_1.useRef)(null);
    var isDateChange = (0, react_1.useRef)(false); // 解决配置了失焦保存时，点击此刻无效的问题。
    (0, react_1.useEffect)(function () {
        if (value && showTime && needTransfer) {
            // 服务器时间转本地时间
            // @ts-ignore
            setDateValue((0, utils_1.time2Locale)(value, format));
        }
        else {
            setDateValue(value || null);
        }
    }, [value, showTime, needTransfer, format]);
    var handleOnchange = (0, react_1.useCallback)(function (date, dateString) {
        // const newString = date?.format(dateFormat) || dateString;
        setDateValue(dateString);
        if (dateString && showTime && needTransfer) {
            // 本地时间转服务器时间
            // @ts-ignore
            onChange === null || onChange === void 0 ? void 0 : onChange((0, utils_1.time2Service)(dateString, format));
        }
        else {
            onChange === null || onChange === void 0 ? void 0 : onChange(dateString);
        }
        // 清除触发失去焦点
        if (!dateString && id) {
            onValueBlur === null || onValueBlur === void 0 ? void 0 : onValueBlur(id, '');
        }
        // 值为空时不变更，可能是删除按钮，不会触发OpenChange
        isDateChange.current = !!dateString;
    }, [id, onChange, onValueBlur, needTransfer, showTime, format]);
    var handleOnOpenChange = (0, react_1.useCallback)(function (open) {
        var _a;
        if (!open && dateRef.current) {
            var dateDom = react_dom_1.default.findDOMNode(dateRef.current);
            var dateInputDom = dateDom ? (_a = dateDom === null || dateDom === void 0 ? void 0 : dateDom.getElementsByTagName('input')) === null || _a === void 0 ? void 0 : _a[0] : null;
            var inputValue = (dateInputDom === null || dateInputDom === void 0 ? void 0 : dateInputDom.value) || "";
            // 验证input元素中value有值，判断是否与当前值相等,且是个有效时间
            // dayjs校验或者正则
            if (inputValue && dateValue !== inputValue && !isDateChange.current && (0, dayjs_1.default)(inputValue).isValid()) {
                setDateValue(inputValue);
                if (needTransfer && showTime) {
                    // @ts-ignore
                    onChange === null || onChange === void 0 ? void 0 : onChange((0, utils_1.time2Service)(inputValue, format));
                }
                else {
                    onChange === null || onChange === void 0 ? void 0 : onChange(inputValue);
                }
            }
            isDateChange.current = false;
        }
    }, [dateValue, onChange, needTransfer, showTime, format]);
    return (react_1.default.createElement(copy_1.default, tslib_1.__assign({}, copyProps, { text: dateValue }),
        react_1.default.createElement(udesk_ui_1.DatePicker, tslib_1.__assign({ getPopupContainer: function (triggerNode) { return triggerNode; }, ref: dateRef, style: { width: '100%' } }, restProps, { onChange: handleOnchange, 
            // 这里兼容失焦保存
            onOpenChange: blurToSave ? handleOnOpenChange : undefined, showTime: showTime ? { format: 'HH:mm' } : false, format: antdFormat, 
            // @ts-ignore
            value: dateValue ? (0, dayjs_1.default)(dateValue) : null, locale: language === 'zh-CN' ? zh_CN_1.default : en_US_1.default, onBlur: function () {
                var onValueBlur = props.onValueBlur, _a = props.id, id = _a === void 0 ? '' : _a;
                if (dateValue && needTransfer && showTime) {
                    // @ts-ignore
                    onValueBlur === null || onValueBlur === void 0 ? void 0 : onValueBlur(id, (0, utils_1.time2Service)(dateValue, format));
                }
                else {
                    onValueBlur === null || onValueBlur === void 0 ? void 0 : onValueBlur(id, dateValue);
                }
            }, 
            // WARN:下面这个antd看着没有这个api,在onchange先实现
            onClear: function () {
                // 这里模拟Blur事件用于字段推送
                var onValueBlur = props.onValueBlur, _a = props.id, id = _a === void 0 ? '' : _a;
                onValueBlur === null || onValueBlur === void 0 ? void 0 : onValueBlur(id, '');
            } }))));
};
exports.default = FormDatePicker;
