"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importDefault(require("react"));
var icon_1 = require("@udesk-webapp/icon");
var IMAGE_TYPE = ['gif', 'jpeg', 'jpg', 'png', 'gif', 'bmp', 'psd', 'tig'];
var WORD_TYPE = ['doc', 'docx'];
var PDF_TYPE = ['pdf'];
var PPT_TYPE = ['ppt', 'pptx'];
var TXT_TYPE = ['txt'];
var EXCEL_TYPE = ['xls', 'xlsx'];
var AUDIO_TYPE = ['mp3', 'amr', 'flac', 'ape', 'wma', 'wav', 'aac', 'm4a', 'au', 'ram', 'mmf', 'aif'];
var VIDEO_TYPE = ['mp4', 'mkv', 'avi', 'swf', 'wmv', 'rmvb', 'mov', 'mpg', 'webm', 'ogg'];
var ZIP_TYPE = ['rar', 'zip', '7z', 'gz', 'arj', 'z'];
var FormFileIcon = function (props) {
    var type = props.type;
    if (IMAGE_TYPE.indexOf(type) > -1) {
        return (react_1.default.createElement(icon_1.ImageFileIcon, null));
    }
    else if (WORD_TYPE.indexOf(type) > -1) {
        return (react_1.default.createElement(icon_1.WordFileIcon, null));
    }
    else if (PDF_TYPE.indexOf(type) > -1) {
        return (react_1.default.createElement(icon_1.PdfFileIcon, null));
    }
    else if (PPT_TYPE.indexOf(type) > -1) {
        return (react_1.default.createElement(icon_1.PptFileIcon, null));
    }
    else if (TXT_TYPE.indexOf(type) > -1) {
        return (react_1.default.createElement(icon_1.TxtFileIcon, null));
    }
    else if (EXCEL_TYPE.indexOf(type) > -1) {
        return react_1.default.createElement(icon_1.ExcelFileIcon, null);
    }
    else if (AUDIO_TYPE.indexOf(type) > -1) {
        return (react_1.default.createElement(icon_1.AudioFileIcon, null));
    }
    else if (VIDEO_TYPE.indexOf(type) > -1) {
        return (react_1.default.createElement(icon_1.VideoFileIcon, null));
    }
    else if (ZIP_TYPE.indexOf(type) > -1) {
        return (react_1.default.createElement(icon_1.ZipFileIcon, null));
    }
    return (react_1.default.createElement(icon_1.UnknowFileIcon, null));
};
exports.default = FormFileIcon;
