"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
// @ts-nocheck
var react_1 = tslib_1.__importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
require("./index.module.scss");
var copy_1 = tslib_1.__importDefault(require("../copy"));
var locale_1 = require("@udesk-webapp/locale");
// 自定义字段 范围值（大于、小于）
var FormRange = function (props) {
    var _a = props.id, id = _a === void 0 ? '' : _a, value = props.value, _b = props.suffix, suffix = _b === void 0 ? '' : _b, copyProps = props.copyProps, onChange = props.onChange, onValueBlur = props.onValueBlur;
    var t = (0, locale_1.useTranslation)().t;
    var _c = (0, react_1.useMemo)(function () {
        if (value && value.length) {
            return [value[0] || '', value[1] || ''];
        }
        return ['', ''];
    }, [value]), startNumber = _c[0], endNumber = _c[1];
    var onValueChange = function (type, v) {
        var changeValue = [startNumber, endNumber];
        changeValue[type === 'min' ? 0 : 1] = v;
        onChange === null || onChange === void 0 ? void 0 : onChange(changeValue);
    };
    var onInputBlur = function (type) {
        var changeValue = [startNumber, endNumber];
        if (startNumber && endNumber && parseInt(startNumber) > parseInt(endNumber)) {
            changeValue[type === 'min' ? 0 : 1] = '';
            onChange === null || onChange === void 0 ? void 0 : onChange(changeValue);
        }
        onValueBlur === null || onValueBlur === void 0 ? void 0 : onValueBlur(id, [startNumber, endNumber]);
    };
    return (react_1.default.createElement(copy_1.default, tslib_1.__assign({}, copyProps, { text: "".concat(startNumber, ",").concat(endNumber) }),
        react_1.default.createElement("div", { className: "form-range-group-wrapper" },
            react_1.default.createElement(udesk_ui_1.Input.Group, { compact: true },
                react_1.default.createElement(udesk_ui_1.InputNumber, { controls: false, min: '0', onBlur: function () { return onInputBlur('min'); }, onChange: function (e) { return onValueChange('min', e); }, placeholder: t('labels.minValue'), precision: 0, stringMode: true, style: { width: "calc(".concat(suffix ? '40%' : '50%', " - 15px)"), textAlign: 'center' }, value: startNumber }),
                react_1.default.createElement(udesk_ui_1.Input, { className: "form-range-input-split", style: {
                        width: 30,
                        pointerEvents: 'none',
                    }, placeholder: "~", disabled: true }),
                react_1.default.createElement(udesk_ui_1.InputNumber, { controls: false, addonAfter: suffix, className: "form-range-input-right", min: '0', onBlur: function () { return onInputBlur('max'); }, onChange: function (e) { return onValueChange('max', e); }, placeholder: t('labels.maxValue'), precision: 0, stringMode: true, style: { width: "calc(".concat(suffix ? '60%' : '50%', " - 15px)"), textAlign: 'center' }, value: endNumber })))));
};
exports.default = FormRange;
