"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
// @ts-nocheck
var react_1 = tslib_1.__importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var moment_1 = tslib_1.__importDefault(require("moment"));
var copy_1 = tslib_1.__importDefault(require("../copy"));
var en_US_1 = tslib_1.__importDefault(require("antd/es/date-picker/locale/en_US"));
var zh_CN_1 = tslib_1.__importDefault(require("antd/es/date-picker/locale/zh_CN"));
var locale_1 = require("@udesk-webapp/locale");
var utils_1 = require("@udesk-webapp/utils");
var RangePicker = udesk_ui_1.DatePicker.RangePicker;
var YYYY_MM_DD = 'YYYY-MM-DD';
var YYYY_MM_DD_HH_MM = 'YYYY-MM-DD HH:mm';
var YYYY_MM_DD_HH_MM_SS = 'YYYY-MM-DD HH:mm:ss';
// 日期类 注意格式和多语言
var FormRangePicker = function (props) {
    var onChange = props.onChange, value = props.value, _a = props.language, language = _a === void 0 ? 'zh-CN' : _a, _b = props.showTime, showTime = _b === void 0 ? false : _b, copyProps = props.copyProps, format = props.format, ranges = props.ranges, needTransfer = props.needTransfer, restProps = tslib_1.__rest(props, ["onChange", "value", "language", "showTime", "copyProps", "format", "ranges", "needTransfer"]);
    var formatMessage = (0, locale_1.useTranslation)().t; // 多语言
    var dateFormat = format || (showTime ? YYYY_MM_DD_HH_MM_SS : YYYY_MM_DD);
    var normalRanges = (0, react_1.useMemo)(function () {
        var _a;
        return ranges ? ranges : (_a = {},
            _a[formatMessage('components.ranges.today')] = [(0, moment_1.default)().startOf('day'),
                (0, moment_1.default)().endOf('day')],
            _a[formatMessage('components.ranges.yesterday')] = [(0, moment_1.default)().subtract(1, 'days').startOf('day'),
                (0, moment_1.default)().subtract(1, 'days').endOf('day')],
            _a[formatMessage('components.ranges.recently_seven_day')] = [(0, moment_1.default)().subtract(6, 'days').startOf('day'),
                (0, moment_1.default)().endOf('day')],
            _a[formatMessage('components.ranges.recently_thirty_day')] = [(0, moment_1.default)().subtract(29, 'days').startOf('day'),
                (0, moment_1.default)().endOf('day')],
            _a[formatMessage('components.ranges.this_month')] = [(0, moment_1.default)().startOf('month').startOf('day'),
                (0, moment_1.default)().endOf('month').endOf('day')],
            _a[formatMessage('components.ranges.last_month')] = [(0, moment_1.default)().subtract(1, 'month')
                    .startOf('month')
                    .startOf('day'),
                (0, moment_1.default)().subtract(1, 'month').endOf('month')
                    .endOf('day')],
            _a[formatMessage('components.ranges.this_year')] = [(0, moment_1.default)().startOf('year').startOf('day'),
                (0, moment_1.default)().endOf('year').endOf('day')],
            _a[formatMessage('components.ranges.last_year')] = [(0, moment_1.default)().subtract(1, 'year').startOf('year')
                    .startOf('day'),
                (0, moment_1.default)().subtract(1, 'year').endOf('year')
                    .endOf('day')],
            _a[formatMessage('components.ranges.recently_year')] = [(0, moment_1.default)().subtract(1, 'year'), (0, moment_1.default)()],
            _a);
    }, [ranges]);
    var _c = (0, react_1.useMemo)(function () {
        if (value && value.length && showTime && needTransfer) {
            // 服务器时间转本地时间
            // @ts-ignore
            return [(0, utils_1.time2Locale)(value[0], dateFormat) || '', (0, utils_1.time2Locale)(value[1], dateFormat) || ''];
        }
        if (value && value.length) {
            return [value[0] || '', value[1] || ''];
        }
        return ['', ''];
    }, [value, showTime, needTransfer, dateFormat]), startTime = _c[0], endTime = _c[1];
    var handleOnchange = function (dates, dateStrings) {
        if (dateStrings && dateStrings.length && showTime && needTransfer) {
            // 服务器时间转本地时间
            onChange === null || onChange === void 0 ? void 0 : onChange([(0, utils_1.time2Service)(dateStrings[0], dateFormat) || '', (0, utils_1.time2Service)(dateStrings[1], dateFormat) || '']);
        }
        else {
            onChange === null || onChange === void 0 ? void 0 : onChange(dateStrings);
        }
    };
    return (react_1.default.createElement(copy_1.default, tslib_1.__assign({}, copyProps, { text: "".concat(startTime, ",").concat(endTime) }),
        react_1.default.createElement(RangePicker, tslib_1.__assign({ style: { width: '100%' }, getPopupContainer: function (triggerNode) { return triggerNode; } }, restProps, { ranges: normalRanges, showTime: showTime, format: dateFormat, locale: language === 'zh-CN' ? zh_CN_1.default : en_US_1.default, onChange: handleOnchange, value: startTime === "" || endTime === "" ? null :
                [(0, moment_1.default)(startTime, dateFormat), (0, moment_1.default)(endTime, dateFormat)], onBlur: function () {
                var onValueBlur = props.onValueBlur, _a = props.id, id = _a === void 0 ? '' : _a;
                if (showTime && needTransfer) {
                    // 服务器时间转本地时间
                    // @ts-ignore
                    return [(0, utils_1.time2Service)(startTime, dateFormat) || '', (0, utils_1.time2Service)(endTime, dateFormat) || ''];
                }
                else {
                    onValueBlur === null || onValueBlur === void 0 ? void 0 : onValueBlur(id, [startTime, endTime]);
                }
            } }))));
};
exports.default = FormRangePicker;
