"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var format_1 = require("../../utils/format");
require("./index.module.scss");
var copy_1 = tslib_1.__importDefault(require("../copy"));
/**
 * 经典级联组件
 */
var FormMultipleSelect = react_1.default.memo(function (props) {
    var copyProps = props.copyProps, options = props.options, showSearch = props.showSearch, allowClear = props.allowClear, readOnly = props.readOnly, disabled = props.disabled, classNames = props.classNames, fullSelect = props.fullSelect, fieldNames = props.fieldNames, onChange = props.onChange, valueProps = props.value, placeholder = props.placeholder, _a = props.inALine, inALine = _a === void 0 ? true : _a, restProps = tslib_1.__rest(props, ["copyProps", "options", "showSearch", "allowClear", "readOnly", "disabled", "classNames", "fullSelect", "fieldNames", "onChange", "value", "placeholder", "inALine"]);
    var _b = (0, react_1.useState)([]), valueList = _b[0], setValueList = _b[1];
    var changeValue = (0, react_1.useRef)([]);
    var multipleSelectRef = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(function () {
        setValueList(function () {
            if (typeof valueProps === 'string') {
                return valueProps ? valueProps.split(',') : [];
            }
            return valueProps || [];
        });
    }, [valueProps]);
    var _c = (0, react_1.useMemo)(function () {
        var _a = fieldNames || {}, _b = _a.label, label = _b === void 0 ? 'label' : _b, _c = _a.value, value = _c === void 0 ? 'value' : _c, _d = _a.children, children = _d === void 0 ? 'children' : _d, _e = _a.is_hide, is_hide = _e === void 0 ? 'is_hide' : _e;
        return (0, format_1.getFormatOptions)(options, { label: label, value: value, children: children, is_hide: is_hide });
    }, [options, fieldNames]), formatOptions = _c[0], formatNoHideOptions = _c[1];
    var valueObj = (0, react_1.useMemo)(function () {
        return (valueList || []).reduce(function (prev, current, index) {
            var _options = !index ? formatOptions : (prev[index - 1] || {}).children || [];
            var keyOption = _options.find(function (item) { return current === item.value; });
            keyOption && prev.push(keyOption);
            return prev;
        }, []);
    }, [formatOptions, valueList]);
    var optionsList = (0, react_1.useMemo)(function () {
        var newList = [];
        if (valueObj && valueObj.length > 0) {
            var valueNoHideObj = valueObj.reduce(function (prev, current, index) {
                var _options = index === 0 ? formatNoHideOptions : prev[index - 1];
                var keyOption = _options.find(function (item) { return current.value === item.value; });
                if (keyOption && keyOption.children) {
                    prev.push(keyOption.children);
                }
                else if (index !== valueObj.length - 1) {
                    prev.push([]);
                }
                return prev;
            }, []);
            newList = tslib_1.__spreadArray([formatNoHideOptions], valueNoHideObj, true);
        }
        else {
            newList.push(formatNoHideOptions);
        }
        return newList;
    }, [formatNoHideOptions, valueObj]);
    var showValueText = (0, react_1.useMemo)(function () {
        if (!valueObj.length) {
            return '- -';
        }
        return valueObj
            .map(function (item) {
            return (item === null || item === void 0 ? void 0 : item.label) || '- -';
        })
            .join(' / ');
    }, [valueObj]);
    var calcClassnames = (0, react_1.useMemo)(function () {
        if (inALine) {
            return 'form-multipleSelect-wrapper';
        }
        else {
            return 'form-multipleSelect-wrapper form-multipleSelect-wrapper-block';
        }
    }, [inALine]);
    if (readOnly) {
        return (react_1.default.createElement(copy_1.default, tslib_1.__assign({}, copyProps, { text: showValueText }),
            react_1.default.createElement("span", { className: "".concat(classNames) }, showValueText),
            ";"));
    }
    var onValueChange = (0, react_1.useCallback)(function (_value, _option, _index) {
        var _a;
        var valueAry = valueList.slice(0, _index);
        var valueObjAry = valueObj.slice(0, _index);
        if (_value) {
            valueAry.push(_value);
            valueObjAry.push(_option);
        }
        else if (valueAry.length) {
            valueAry.push('');
            valueObjAry.push({});
        }
        if (((_a = _option === null || _option === void 0 ? void 0 : _option.children) === null || _a === void 0 ? void 0 : _a.length) && fullSelect) {
            valueAry.push('');
        }
        changeValue.current = valueAry;
        onChange(valueAry, valueObjAry);
    }, [onChange, valueList]);
    var filterOption = (0, react_1.useCallback)(function (input, option) {
        var _a, _b;
        return ((_b = (_a = option === null || option === void 0 ? void 0 : option.label) === null || _a === void 0 ? void 0 : _a.toLowerCase()) === null || _b === void 0 ? void 0 : _b.indexOf(input === null || input === void 0 ? void 0 : input.toLowerCase())) >= 0;
    }, []);
    var onItemBlur = function (index) {
        // 避免多次推送，开启最末级必填后最末级触发blur
        if (fullSelect && changeValue.current[changeValue.current.length - 1] === '') {
            return;
        }
        var onValueBlur = props.onValueBlur, _a = props.id, id = _a === void 0 ? '' : _a;
        onValueBlur === null || onValueBlur === void 0 ? void 0 : onValueBlur(id, changeValue.current);
    };
    var onItemClear = function (index) {
        if (fullSelect && index !== 0) {
            return;
        }
        var onValueBlur = props.onValueBlur, _a = props.id, id = _a === void 0 ? '' : _a;
        onValueBlur === null || onValueBlur === void 0 ? void 0 : onValueBlur(id, (changeValue.current || []).slice(0, index));
    };
    return (react_1.default.createElement(copy_1.default, tslib_1.__assign({}, copyProps, { text: showValueText }),
        react_1.default.createElement("div", { className: calcClassnames, ref: multipleSelectRef }, optionsList.map(function (options, index) {
            return (react_1.default.createElement("div", { className: "form-multipleSelect-item", style: {
                    marginRight: optionsList.length > 1 && index !== optionsList.length - 1
                        ? '5px'
                        : '',
                }, key: index },
                react_1.default.createElement(udesk_ui_1.Select, tslib_1.__assign({ getPopupContainer: function () { return multipleSelectRef.current || document.body; }, dropdownMatchSelectWidth: (options === null || options === void 0 ? void 0 : options.length) > 300 ? true : false }, restProps, { disabled: disabled, value: valueObj[index], placeholder: placeholder, allowClear: allowClear, showSearch: showSearch, options: options, filterOption: filterOption, onChange: function (value, options) {
                        return onValueChange(value, options, index);
                    }, onBlur: function () { return onItemBlur(index); }, onClear: function () { return onItemClear(index); } }))));
        }))));
});
FormMultipleSelect.defaultProps = {
    classNames: '',
    disabled: false,
    readOnly: false,
    showSearch: true,
    allowClear: true,
    placeholder: '',
    fullSelect: false,
    options: [],
    value: [],
    onChange: function () { },
};
exports.default = FormMultipleSelect;
