"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var copy_1 = tslib_1.__importDefault(require("../copy"));
var utils_1 = require("@udesk-webapp/utils");
// 自定义字段 文本/或者通用性质的带icon点击事件/或者纯文本的系统字段（主题等）
var FormText = function (props) {
    var _a = props.allowClear, allowClear = _a === void 0 ? true : _a, _b = props.autoToggleSensitiveValue, autoToggleSensitiveValue = _b === void 0 ? false : _b, value = props.value, copyProps = props.copyProps, addonAfterRender = props.addonAfterRender, sensitiveMarkPlaceholder = props.sensitive_mark_placeholder, sensitiveMarkPosition = props.sensitive_mark_position, sensitiveMarkSize = props.sensitive_mark_size, sensitiveMode = props.sensitive_mode, _c = props.addonAfterClick, addonAfterClick = _c === void 0 ? function () { } : _c, onFocus = props.onFocus, restProps = tslib_1.__rest(props, ["allowClear", "autoToggleSensitiveValue", "value", "copyProps", "addonAfterRender", "sensitive_mark_placeholder", "sensitive_mark_position", "sensitive_mark_size", "sensitive_mode", "addonAfterClick", "onFocus"]);
    // 设置展示值
    var _d = (0, react_1.useState)(value), showValue = _d[0], setShowValue = _d[1];
    // 判断是否获取焦点
    var _e = (0, react_1.useState)(false), focusing = _e[0], setFocusing = _e[1];
    // const focusRef=useRef(false);
    // 内部值
    var localeValueRef = (0, react_1.useRef)(value);
    (0, react_1.useEffect)(function () {
        localeValueRef.current = value;
        setShowValue(value);
        // 自动转换脱敏状态
        if (autoToggleSensitiveValue && !focusing) {
            var sensitiveValue = (0, utils_1.sensitiveField)({
                sensitive_mark_placeholder: sensitiveMarkPlaceholder,
                sensitive_mark_position: sensitiveMarkPosition,
                sensitive_mark_size: sensitiveMarkSize,
                sensitive_mode: sensitiveMode, // 脱敏模式，0不脱敏，1全脱敏，2部分脱敏
            })(value);
            setShowValue(sensitiveValue);
        }
    }, [value, autoToggleSensitiveValue, sensitiveMarkPlaceholder, sensitiveMarkPosition, sensitiveMarkSize, sensitiveMode, focusing]);
    var onValueChange = function (e) {
        var _a;
        var targetValue = e.target.value;
        setShowValue(targetValue);
        (_a = props === null || props === void 0 ? void 0 : props.onChange) === null || _a === void 0 ? void 0 : _a.call(props, targetValue);
    };
    var focus = (0, react_1.useCallback)(function () {
        setFocusing(true);
        setShowValue(value);
        onFocus === null || onFocus === void 0 ? void 0 : onFocus(value);
    }, [onFocus, value]);
    return (react_1.default.createElement(copy_1.default, tslib_1.__assign({}, copyProps, { text: showValue }),
        react_1.default.createElement(udesk_ui_1.Input, tslib_1.__assign({ addonAfter: !!addonAfterRender ? (react_1.default.createElement("span", { onClick: function () { return addonAfterClick === null || addonAfterClick === void 0 ? void 0 : addonAfterClick(localeValueRef.current); } }, addonAfterRender)) : null }, restProps, { allowClear: allowClear, value: showValue, onChange: function (data) { return onValueChange(data); }, onBlur: function (e) {
                // const targetValue = e.target.value;
                var onValueBlur = props.onValueBlur, _a = props.id, id = _a === void 0 ? '' : _a;
                setFocusing(false);
                onValueBlur === null || onValueBlur === void 0 ? void 0 : onValueBlur(id, value);
            }, onFocus: focus }))));
};
exports.default = FormText;
