"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var lodash_es_1 = require("lodash-es");
var SHOW_PARENT = udesk_ui_1.TreeSelect.SHOW_PARENT, SHOW_CHILD = udesk_ui_1.TreeSelect.SHOW_CHILD;
var getData = function (data, val) {
    var arr = data;
    arr.map(function (i) {
        i.value = val + ',' + i.value;
        if (i.children) {
            getData(i.children, i.value);
        }
    });
    return arr;
};
// 树形结构 多选
var FormTreeSelect = function (props) {
    var valueProps = props.value, onChange = props.onChange, treeData = props.treeData, strategy = props.strategy, _a = props.maxTagCount, maxTagCount = _a === void 0 ? 1 : _a, _b = props.labelInValue, labelInValue = _b === void 0 ? true : _b, formatTreeDataValue = props.formatTreeDataValue, readOnly = props.readOnly, _c = props.treeCheckable, treeCheckable = _c === void 0 ? true : _c, _d = props.treeNodeFilterProp, treeNodeFilterProp = _d === void 0 ? 'title' : _d, restProps = tslib_1.__rest(props, ["value", "onChange", "treeData", "strategy", "maxTagCount", "labelInValue", "formatTreeDataValue", "readOnly", "treeCheckable", "treeNodeFilterProp"]);
    var _e = (0, react_1.useState)(valueProps || undefined), curValue = _e[0], setCurValue = _e[1];
    var onValueChange = function (newValue) {
        setCurValue(newValue);
        onChange === null || onChange === void 0 ? void 0 : onChange(newValue);
    };
    var newTreeData = (0, react_1.useMemo)(function () {
        if (formatTreeDataValue) {
            var arr = (0, lodash_es_1.cloneDeep)(treeData);
            arr.map(function (item) {
                if (item === null || item === void 0 ? void 0 : item.children) {
                    item.children = getData(item === null || item === void 0 ? void 0 : item.children, item.value);
                }
            });
            return arr;
        }
        return treeData;
    }, [formatTreeDataValue, treeData]);
    if (readOnly) {
        return null;
    }
    return (react_1.default.createElement(udesk_ui_1.TreeSelect, tslib_1.__assign({ getPopupContainer: function (triggerNode) { return triggerNode; } }, restProps, { maxTagCount: maxTagCount, treeData: newTreeData, labelInValue: labelInValue, value: curValue, onChange: onValueChange, treeCheckable: treeCheckable, treeNodeFilterProp: treeNodeFilterProp, showCheckedStrategy: strategy === 'parent' ? SHOW_PARENT : SHOW_CHILD, style: {
            width: '100%',
        } })));
};
exports.default = FormTreeSelect;
