module.exports = getProductVersion;

function getProductVersion() {
    /* Sample data
    {
        sha: '718b42687d49d9b5028969556af159eca8727a51',
        abbreviatedSha: '718b42687d',
        branch: 'feature_CASE_911',
        tag: null,
        committer: '李凤宝 <lifengbao@udesk.cn>',
        committerDate: '2017-10-18T09:38:29.000Z',
        author: '李凤宝 <lifengbao@udesk.cn>',
        authorDate: '2017-10-18T09:38:29.000Z',
        commitMessage: 'Some commit message',
        root: '/home/user/Documents/udesk_ember_cli' 
    }
    */
    let gitInfo = require('git-repo-info')();
    let today = new Date();
    let year = today.getFullYear() % 100;
    let month = today.getMonth() + 1;
    let day = today.getDate();
    return `${year}.${month}.${day}.${gitInfo.abbreviatedSha}`;
}
