// 这样的TS语法，prettier还不支持，会导致整个文件不可格式化，所以单独提出来。
// 等prettier支持了，再合并回去

/**
 * 仅保留已知的（即显式声明的）属性，禁止动态索引。
 *
 * @summary 有时我们会在某个Type中添加动态索引以支持任意自定义属性，
 * 参考 @link https://www.typescriptlang.org/docs/handbook/2/mapped-types.html
 * 但由于动态索引的存在，如果我们没有办法重写Type的某个属性，当我们尝试使用Omit排除
 * 掉某个属性后，你会发现你排除了所有属性！
 * 可以使用这个工具类从Type中提取出所有显式声明的属性，然后再进行后续其它处理就可以了。
 */
declare type KnownProps<T> = {
    [K in keyof T as string extends K ? never : number extends K ? never : K]: T[K];
};
