/**
 * 把某个类型的所有字段变成 Required 的，同时把所有二级属性也变成 Required 的。
 * 与 `Required<T>` 类型类似，但深度更深。
 */
declare type DeepRequired<T> = {
    [key in keyof T]-?: T[key] extends (infer T)[] | undefined
        ? NonNullable<Required<T>[]>
        : NonNullable<Required<T[key]>>;
};
