"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.withTranslation = exports.useTranslation = void 0;
var tslib_1 = require("tslib");
var i18next_1 = tslib_1.__importDefault(require("i18next"));
var i18next_browser_languagedetector_1 = tslib_1.__importDefault(require("i18next-browser-languagedetector"));
var react_i18next_1 = require("react-i18next");
Object.defineProperty(exports, "withTranslation", { enumerable: true, get: function () { return react_i18next_1.withTranslation; } });
var en_1 = tslib_1.__importDefault(require("./en"));
var zh_1 = tslib_1.__importDefault(require("./zh"));
var ja_JP_1 = tslib_1.__importDefault(require("./ja-JP"));
var ar_EG_1 = tslib_1.__importDefault(require("./ar-EG"));
var ru_RU_1 = tslib_1.__importDefault(require("./ru-RU"));
var th_TH_1 = tslib_1.__importDefault(require("./th-TH"));
var tr_TR_1 = tslib_1.__importDefault(require("./tr-TR"));
var vi_VN_1 = tslib_1.__importDefault(require("./vi-VN"));
var fr_1 = tslib_1.__importDefault(require("./fr"));
var es_ES_1 = tslib_1.__importDefault(require("./es-ES"));
var pt_PT_1 = tslib_1.__importDefault(require("./pt-PT"));
var zh_HK_1 = tslib_1.__importDefault(require("./zh-HK"));
var zh_TW_1 = tslib_1.__importDefault(require("./zh-TW"));
var de_1 = tslib_1.__importDefault(require("./de"));
var id_ID_1 = tslib_1.__importDefault(require("./id-ID"));
var el_GR_1 = tslib_1.__importDefault(require("./el-GR"));
var it_IT_1 = tslib_1.__importDefault(require("./it-IT"));
var ko_KR_1 = tslib_1.__importDefault(require("./ko-KR"));
var ms_1 = tslib_1.__importDefault(require("./ms"));
var newI18n = i18next_1.default.createInstance();
newI18n.use(i18next_browser_languagedetector_1.default)
    .use(react_i18next_1.initReactI18next) // bind react-i18next to the instance
    .init({
    fallbackLng: 'zh',
    resources: {
        'en-US': {
            translation: en_1.default,
        },
        'zh-CN': {
            translation: zh_1.default,
        },
        'zh-HK': {
            translation: zh_HK_1.default,
        },
        'zh-TW': {
            translation: zh_TW_1.default,
        },
        'ja-JP': {
            translation: ja_JP_1.default,
        },
        'ar-EG': {
            translation: ar_EG_1.default,
        },
        'ru-RU': {
            translation: ru_RU_1.default,
        },
        'th-TH': {
            translation: th_TH_1.default,
        },
        'tr-TR': {
            translation: tr_TR_1.default,
        },
        'vi-VN': {
            translation: vi_VN_1.default,
        },
        'fr': {
            translation: fr_1.default,
        },
        'pt-PT': {
            translation: pt_PT_1.default,
        },
        'es-ES': {
            translation: es_ES_1.default,
        },
        'de': {
            translation: de_1.default,
        },
        'id-ID': {
            translation: id_ID_1.default,
        },
        'el-GR': {
            translation: el_GR_1.default,
        },
        'it-IT': {
            translation: it_IT_1.default,
        },
        'ko-KR': {
            translation: ko_KR_1.default
        },
        ms: {
            translation: ms_1.default,
        }
    },
    interpolation: {
        escapeValue: false // not needed for react!!
    }
});
exports.default = newI18n;
var useTranslation = function (ns, options) {
    return (0, react_i18next_1.useTranslation)(ns, tslib_1.__assign({ i18n: newI18n }, options));
};
exports.useTranslation = useTranslation;
