"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.FontSize = void 0;
exports.createIconfont = createIconfont;

var _react = _interopRequireWildcard(require("react"));

var _icons = require("@ant-design/icons");

var _classnames = _interopRequireDefault(require("classnames"));

var _configProvider = _interopRequireDefault(require("../config-provider"));

var _excluded = ["iconSize", "size"],
    _excluded2 = ["iconSize", "type", "size", "rotate", "spin", "style", "className"];

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }

function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }

function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

/**
 * 字体尺寸，兼容AntDesign的 `SizeType` 类型
 *
 * @exports
 * @enum {string}
 */
var FontSize;

(function (FontSize) {
  /** 超小 */
  FontSize["xSmall"] = "x-small";
  /** 小 */

  FontSize["small"] = "small";
  /** 正常(默认值) */

  FontSize["middle"] = "middle";
  /** 大 */

  FontSize["large"] = "large";
  /** 超大 */

  FontSize["xLarge"] = "x-large";
  /** 超大(二级) */

  FontSize["xxLarge"] = "xx-large";
})(FontSize || (exports.FontSize = FontSize = {}));

var loadedUrlCache = {};

function createIconfont(options) {
  var scriptUrl = options.scriptUrl,
      cssUrl = options.cssUrl,
      _options$iconPrefix = options.iconPrefix,
      iconPrefix = _options$iconPrefix === void 0 ? '' : _options$iconPrefix,
      _options$fontFamily = options.fontFamily,
      fontFamily = _options$fontFamily === void 0 ? 'iconfont' : _options$fontFamily,
      extraCommonProps = options.extraCommonProps,
      defaultProps = options.defaultProps;
  var Component;

  if (scriptUrl) {
    // 生成一个Iconfont组件
    var AntdIconFont = (0, _icons.createFromIconfontCN)({
      scriptUrl: scriptUrl // scriptUrl: '//at.alicdn.com/t/font_2202737_xnfbgjrxasa.js',

    });

    Component = function Component(props) {
      var _props$className;

      var iconSize = props.iconSize,
          size = props.size,
          antdProps = _objectWithoutProperties(props, _excluded);

      var context = (0, _react.useContext)(_configProvider["default"].ConfigContext);

      if (!size) {
        size = convertToSize(iconSize);
      }

      return /*#__PURE__*/_react["default"].createElement(AntdIconFont, _objectSpread(_objectSpread(_objectSpread({}, antdProps), extraCommonProps), {}, {
        className: (0, _classnames["default"])(_defineProperty(_defineProperty(_defineProperty(_defineProperty({}, context.getPrefixCls('iconfont'), true), iconPrefix + props.type, !!props.type), convertToClassName(size), true), (_props$className = props.className) !== null && _props$className !== void 0 ? _props$className : '', !!props.className)),
        type: "".concat(iconPrefix + (props.type || ''))
      }));
    };
  } else if (cssUrl) {
    // 生成一个Iconfont组件

    /**
     * DOM API required.
     * Make sure in browser environment.
     * By calling the factory method it creates a <link/> that loads css files into the document head.
     */
    if (typeof document !== 'undefined' && typeof window !== 'undefined' && typeof document.createElement === 'function') {
      createCssLinkElements(cssUrl);
    }

    Component = function Component(props) {
      var iconSize = props.iconSize,
          type = props.type,
          size = props.size,
          rotate = props.rotate,
          spin = props.spin,
          style = props.style,
          className = props.className,
          antdProps = _objectWithoutProperties(props, _excluded2);

      var context = (0, _react.useContext)(_configProvider["default"].ConfigContext);

      if (!size) {
        size = convertToSize(iconSize);
      }

      var inlineStyle = _objectSpread(_objectSpread({}, style), rotate ? {
        msTransform: "rotate(".concat(rotate, "deg)"),
        transform: "rotate(".concat(rotate, "deg)")
      } : {});

      return /*#__PURE__*/_react["default"].createElement("i", _objectSpread(_objectSpread(_objectSpread({}, antdProps), extraCommonProps), {}, {
        className: (0, _classnames["default"])(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty({}, context.getPrefixCls('iconfont'), true), fontFamily, true), iconPrefix + type, !!type), context.getPrefixCls('iconfont-spin'), spin), convertToClassName(size), true), className !== null && className !== void 0 ? className : '', !!className)),
        style: Object.keys(inlineStyle).length > 0 ? inlineStyle : undefined
      }), props.children);
    };
  } else {
    throw new Error("必须设置'scriptUrl'或'cssUrl'两个属性之一");
  }

  Component.displayName = 'IconFont';
  Component.defaultProps = _objectSpread({}, defaultProps);
  var Iconfont = Component;
  Iconfont.FontSize = {
    xSmall: FontSize.xSmall,
    small: FontSize.small,
    middle: FontSize.middle,
    large: FontSize.large,
    xLarge: FontSize.xLarge,
    xxLarge: FontSize.xxLarge
  };
  return Iconfont;
}

function convertToSize(iconSize) {
  var size;

  if (iconSize) {
    switch (iconSize) {
      case 'xs':
        size = FontSize.xSmall;
        break;

      case 'sm':
        size = FontSize.small;
        break;

      case 'lg':
        size = FontSize.large;
        break;

      case 'xl':
        size = FontSize.xLarge;
        break;

      case 'md':
      default:
        size = FontSize.middle;
        break;
    }
  } else {
    size = FontSize.middle;
  }

  return size;
}
/**
 * 在页面中注入css样式文件
 *
 * @param {(string | string[])} cssLinkUrls 一个或多个css文件url
 */


function createCssLinkElements(cssLinkUrls) {
  if (typeof cssLinkUrls === 'string') {
    cssLinkUrls = [cssLinkUrls];
  }

  var _loop = function _loop() {
    var url = cssLinkUrls[i];

    try {
      // 把相对路径转换成绝对路径，例如/a/b/c.css，或者//www.udesk.cn/a.css
      url = new URL(url, window.location.href).href;
    } catch (_unused) {}

    if (!loadedUrlCache[url]) {
      loadedUrlCache[url] = 1;
    }

    var allLinks = Array.from(document.getElementsByTagName('link'));

    if (url && !allLinks.some(function (link) {
      return link.href === url;
    })) {
      appendCssElement(url);
    }
  };

  for (var i = 0; i < cssLinkUrls.length; i++) {
    _loop();
  }
}
/**
 * 直接注入css文件，如果失败了每隔一秒重试一次，最多5次
 *
 * @param {string} url
 * @returns
 */


function appendCssElement(url) {
  loadedUrlCache[url]++;

  if (loadedUrlCache[url] > 5) {
    return;
  }

  var link = document.createElement('link');
  link.rel = 'stylesheet';
  link.href = url;

  var retry = function retry() {
    var existing = Array.from(document.getElementsByTagName('link')).find(function (e) {
      return e.href === url;
    });

    if (existing) {
      document.head.removeChild(existing);
    }

    setTimeout(function () {
      appendCssElement(url);
    }, 1000);
  };

  link.onerror = function () {
    retry();
  };

  link.onabort = function () {
    retry();
  };

  document.head.appendChild(link);
}

function convertToClassName(size) {
  var sizeString = size === null || size === void 0 ? void 0 : size.toString();

  if (sizeString) {
    return sizeString.replace(/([A-Z])/g, function (substring) {
      return '-' + substring.toLowerCase();
    });
  }

  return '';
}
//# sourceMappingURL=index.js.map
