import React, { ComponentProps } from 'react';
import { Select } from 'udesk-ui';
import './index.module.scss';
declare type OptionType = {
    value?: string | number;
    label?: string;
    is_hide?: boolean | undefined;
    children?: OptionType[] | undefined;
};
declare type PropsInterface = {
    disabled?: boolean;
    readOnly?: boolean;
    showSearch?: boolean;
    allowClear?: boolean;
    fullSelect?: boolean;
    classNames?: string;
    placeholder?: string;
    options: OptionType[];
    value: string | string[] | number[];
    fieldNames?: {
        label?: string;
        value?: string;
        children?: string;
        is_hide?: string;
    };
    switchFlag?: boolean;
    onChange: (value: string[], options?: any[]) => void;
} & Omit<ComponentProps<typeof Select>, 'onChange' | 'value'>;
/**
 * 经典级联组件
 */
declare const MultipleSelectField: React.FC<PropsInterface>;
export default MultipleSelectField;
