import React, { ComponentProps } from 'react';
import { Modal } from 'udesk-ui';
import { ModeType, TicketSignatureConfigResponse, VerifySignature } from './types';
export declare enum VerifySignatureAndSaveTicketEnums {
    NeedSignature = "needSignature",
    VerifySignatureAndSaveTicket = "verifySignatureAndSaveTicket"
}
export declare type TicketSignatureInterface = Omit<ComponentProps<typeof Modal>, 'visible' | 'onOk' | 'onCancel'> & {
    isVisible: boolean;
    ticketSignature: TicketSignatureConfigResponse;
    onClose?: () => void;
    onVerifySignatureAndSaveTicket?: (saveStep: ModeType, params: VerifySignature) => void;
    onVertifyFail?: (error: any) => void;
};
export declare const initalTicketSignature: {
    id: undefined;
    name: string;
    category_content: string;
    category_enabled: boolean;
    category_required: boolean;
    description_enabled: boolean;
    description_required: boolean;
    signature_require_user_email: boolean;
};
declare const TicketSignature: React.FC<TicketSignatureInterface>;
export default TicketSignature;
