import React, { ComponentProps } from 'react';
import { Input } from 'udesk-ui';
import FieldErrAndExplain from '@udesk-webapp/custom-field-error-explain';
import CopyComponent from '@udesk-webapp/copy-content';
import { useValid } from '@udesk-webapp/custom-field-input-base';
export declare type ILinkField = Omit<ComponentProps<typeof FieldErrAndExplain>, 'errMsg'> & Omit<ComponentProps<typeof Input>, 'onBlur' | 'onChange' | 'value' | 'suffix'> & Pick<ComponentProps<typeof CopyComponent>, 'switchFlag'> & {
    trigger: 'onChange' | 'onBlur';
    value?: string;
    type: 'text' | 'textarea' | 'link' | 'number' | 'numeric' | 'date' | 'datetime' | 'time' | 'location' | 'calculate' | 'radio' | 'droplist' | 'droplistMulti' | 'cascade' | 'checkbox';
    remark?: string;
    isRequired?: boolean;
    disabled?: boolean;
    customValidPromise?: Parameters<typeof useValid>[0]['customValidPromise'];
    convertPropsFn?: any;
    isFormItem: boolean;
    onChange?: (data: any) => void;
    onBlur?: (data: any) => void;
    onValueChangedByBlur?: (data: any) => void;
    onValueChanged?: (data: any) => void;
};
declare const Link: React.FC<ILinkField>;
export default Link;
