import React, { ComponentProps } from 'react';
import { Input } from 'udesk-ui';
import FieldErrAndExplain from '@udesk-webapp/custom-field-error-explain';
declare type IFieldBase = {
    label?: string;
    id: string;
    trigger: 'onChange' | 'onBlur';
    value?: string;
    remark?: string;
    explain?: string;
    explainShow?: boolean;
    isRequired?: boolean;
    disabled?: boolean;
    customValidPromise?: (value: string) => Promise<any>;
    convertPropsFn?: any;
    isFormItem?: boolean;
    onChange?: (data: any) => void;
    onBlur?: (data: any) => void;
};
declare type ITextareaField = Omit<ComponentProps<typeof Input.TextArea>, 'rows' | 'value' | 'onChange' | 'onBlur'> & Omit<ComponentProps<typeof FieldErrAndExplain>, 'errMsg'> & IFieldBase & {
    onValueChangedByBlur?: (data: any) => void;
    onValueChanged?: (data: any) => void;
    rowsLine?: number;
    switchFlag?: boolean;
};
declare const AreaText: React.FC<ITextareaField>;
export default AreaText;
