import React, { ComponentProps } from 'react';
import Form from 'udesk-ui/es/form';
import GetFieldComponet from './field-type-component';
import { IFieldItem, IAgent } from '@udesk-webapp/utils';
declare type FormItemProps = ComponentProps<typeof Form.Item>;
export type { IFieldItem };
export declare type CustomFieldItemProps = {
    fieldItem: IFieldItem;
    isFormItem: boolean;
    switchFlag?: boolean;
    notUseDefault?: boolean;
    labelCol?: FormItemProps['labelCol'];
    wrapperCol?: FormItemProps['wrapperCol'];
    agents?: IAgent[];
    onChange?: (value: any, fieldItem: IFieldItem) => void;
    onBlur?: (value: any, fieldItem: IFieldItem) => void;
    onValueChange?: (value: any, fieldItem: IFieldItem) => void;
};
declare const CustomFieldItem: React.FC<CustomFieldItemProps>;
export default CustomFieldItem;
export { GetFieldComponet };
export declare const fieldComponentMapping: {
    calculate: any;
    cascade: any;
    cascader: any;
    chained_droplist: any;
    checkbox: any;
    droplistMulti: any;
    droplist: any;
    radio_droplist: any;
    date: any;
    datetime: any;
    link: any;
    location: any;
    number: any;
    numeric: any;
    radio: any;
    tag_tree: any;
    textarea: any;
    area_text: any;
    time: any;
    text: any;
    staff: React.FC<{
        disabled?: Boolean | undefined;
        agents: {
            label: string;
            nick_name: string;
            value: number;
            id: number;
        }[];
        valueMode: import("@udesk-webapp/agent-select").modeEnums;
        readOnly?: boolean | undefined;
        value: string;
        placeholder?: string | undefined;
        onChange?: ((value: string, options: object[]) => void) | undefined;
    } & Omit<any, "mode" | "onChange" | "value"> & {
        children?: React.ReactNode;
    }>;
    file: React.NamedExoticComponent<{
        value: any;
        onChange?: ((value: {
            id: string | number;
            file_name: string;
            url: string;
        }[]) => void) | undefined;
        singleLimit?: number | undefined;
        totalLimit?: number | undefined;
        marking?: string | undefined;
        buttonText?: string | undefined;
        buttonProps?: any;
        buttonRender?: any;
        tipRender?: any;
        uploadProps?: any;
        sourceChannel?: string | undefined;
        uploadType?: "img" | "file" | undefined;
        previewUrl?: string | undefined;
        udeskVersion?: string | undefined;
        tooltipPlacement?: string | undefined;
        weirdMode?: boolean | undefined;
        singleFileOutOfSizeFun?: ((fileName: string, singleSizeLimit: number) => boolean) | undefined;
        totalFileOutOfSizeFun?: ((currentTotalSize: number, totalSizeLimit: number) => boolean) | undefined;
        hoveTip?: boolean | undefined;
    }>;
};
