/// <reference types="react" />
import { ColumnProps } from 'udesk-ui/es/table';
import { CustomField, ITicket, IAgent } from '@udesk-webapp/utils';
import TicketTable from './associated-ticket-form';
import TicketFilter from './ticket-filters/index';
import TicketFilterCondition, { DataSourcesInterface } from './ticket-filters/ticket-filter-condition';
export { TicketFilter, TicketFilterCondition, TicketTable };
interface MetaInterface {
    total_records?: number;
    current_page?: number;
}
interface ResultInterface {
    meta: MetaInterface;
    tickets: ITicket[];
}
interface onRowTypes {
    (record: ITicket): {
        onClick: () => {};
        onDoubleClick: () => {};
        onContextMenu: () => {};
        onMouseEnter: () => {};
        onMouseLeave: () => {};
    };
}
interface listsParamsAllConditionsTypes {
    field_name?: string;
    operation?: string;
    value?: string;
}
interface listsParamsTypes {
    all_conditions?: Array<listsParamsAllConditionsTypes>;
    any_conditions?: Array<string>;
    column?: string;
    filter_id?: string;
    group_name?: string;
    order?: string;
    page: number;
    page_size: number;
    query?: string;
    sort_by?: Array<Array<string>>;
}
interface TicketColumnInterface {
    fieldMode?: string;
}
interface TicketDetailTypes {
    isInitDatas?: boolean;
    disabledLists?: Array<number>;
    onRow?: onRowTypes;
    onRowSelectionChange?: Function;
    dataSources?: DataSourcesInterface;
    ticketCustomFields?: any;
    ticketSystemFields?: any;
    selectedRowKeys?: number[];
    useCustomFieldRequset?: boolean;
    useTicketListRequset?: boolean;
    agents: IAgent[];
    customFields?: CustomField[];
    columns?: (TicketColumnInterface & ColumnProps<ITicket>)[];
    scrollConfig: {
        scrollToFirstRowOnChange: boolean;
        x: string | number;
        y: string | number;
    };
    getTicketsList?: (params: listsParamsTypes) => ResultInterface;
}
declare const TicketDetail: (props: TicketDetailTypes) => JSX.Element;
export default TicketDetail;
