import React, { ComponentProps } from 'react';
import { Cascader } from 'udesk-ui';
declare type OptionType = {
    value?: string | number;
    label?: string;
    is_hide?: boolean | undefined;
    children?: OptionType[] | undefined;
};
declare type PropsInterface = Omit<ComponentProps<typeof Cascader>, 'value'> & {
    options: OptionType[];
    value: string | string[] | number[];
    fieldNames: {
        label?: string;
        value?: string;
        children?: string;
        is_hide?: string;
    };
    readOnly?: boolean;
    disabled?: boolean;
    fullSelect?: boolean;
    classNames?: string;
    switchFlag?: boolean;
    onChange: (value: string | any[]) => void;
};
/**
 * 快速级联组件
 * ** 注意此处需要支持antd@4.17.0 **
 */
declare const CascaderField: React.FC<PropsInterface>;
export default CascaderField;
