import React, { ComponentProps } from 'react';
import { Input } from 'udesk-ui';
import FieldErrAndExplain from '@udesk-webapp/custom-field-error-explain';
import CopyComponent from '@udesk-webapp/copy-content';
import { useValid } from '@udesk-webapp/custom-field-input-base';
export declare type ILocation = Omit<ComponentProps<typeof Input.TextArea>, 'onChange' | 'onBlur' | 'rows'> & Omit<ComponentProps<typeof FieldErrAndExplain>, 'errMsg'> & Pick<ComponentProps<typeof CopyComponent>, 'switchFlag'> & {
    label?: string;
    id: string;
    trigger: 'onChange' | 'onBlur';
    value?: string;
    type: 'text' | 'textarea' | 'link' | 'number' | 'numeric' | 'date' | 'datetime' | 'time' | 'location' | 'calculate' | 'radio' | 'droplist' | 'droplistMulti' | 'cascade' | 'checkbox';
    remark?: string;
    isRequired?: boolean;
    disabled?: boolean;
    customValidPromise?: Parameters<typeof useValid>[0]['customValidPromise'];
    convertPropsFn?: any;
    onChange?: (data: any) => void;
    onBlur?: (data: any) => void;
    defaultValue?: string;
    placeholder?: string;
    maxLength?: number;
    rowsLine?: number;
    onValueChangedByBlur?: (data: any) => void;
    onValueChanged?: (data: any) => void;
};
declare const Location: React.FC<ILocation>;
export default Location;
