import { __assign, __rest } from "tslib";
// 多选框组件
import React, { useCallback, useEffect, useMemo, useState } from 'react';
import { Checkbox } from 'udesk-ui';
import cssObj from './index.module.scss';
var FiledCheckbox = function (_a) {
    var onChange = _a.onChange, _b = _a.options, options = _b === void 0 ? [] : _b, sortType = _a.sort_type, notUseDefault = _a.notUseDefault, value = _a.value, hiddenLabelPath = _a.hiddenLabelPath, props = __rest(_a, ["onChange", "options", "sort_type", "notUseDefault", "value", "hiddenLabelPath"]);
    // 选择的选项值
    var _c = useState([]), checkedList = _c[0], setCheckedList = _c[1];
    var showOptions = useMemo(function () {
        if (!options) {
            return [];
        }
        var currentValue = value;
        if (typeof currentValue === 'string') {
            currentValue = currentValue.split(',');
        }
        else if (typeof currentValue === 'number') {
            currentValue = [currentValue];
        }
        return options.filter(function (option) {
            if (!option) {
                return false;
            }
            var isHide = hiddenLabelPath && option[hiddenLabelPath];
            var isSelected = currentValue != null && currentValue.includes(option.value);
            return !isHide || isSelected;
        });
    }, [hiddenLabelPath, options, value]);
    // 监听道选项改变 处理数据   取出其中默认选项  复制给Radio.Group的value  主要是外部新建字段  改变默认选项时触发  改变展示效果
    useEffect(function () {
        if (value) {
            // value  类型 是[] 或 string
            if (typeof (value) === 'string') {
                // 将value转数组  存值
                setCheckedList(value.split(','));
            }
            else {
                setCheckedList(value);
            }
        }
        else {
            if (!notUseDefault) {
                setCheckedList(options === null || options === void 0 ? void 0 : options.filter(function (item) { return item.default; }).map(function (item) { return item.value; }));
            }
        }
    }, [notUseDefault, options, value]);
    // 选择改变时触发
    var checkOnChange = useCallback(function (_checkedList) {
        setCheckedList(_checkedList);
        if (onChange)
            onChange(_checkedList.join(','));
    }, [onChange]);
    var checkGroupChildren = useMemo(function () { return (React.createElement(Checkbox.Group, __assign({ value: checkedList, onChange: checkOnChange }, props), showOptions.map(function (item) { return (React.createElement(Checkbox, { key: item.value, value: item.value },
        React.createElement("span", { className: "".concat(cssObj['select-item'], " ").concat(item.color ? cssObj['select-item-hascolor'] : ''), style: { background: item.color ? item.color : '' } },
            item.icon ?
                React.createElement("img", { alt: '', src: item.icon, className: cssObj['setting-img'] }) : '',
            item.title))); }))); }, [checkOnChange, checkedList, options, props, sortType]);
    return (React.createElement("div", { className: cssObj['select-wrapper'] }, checkGroupChildren));
};
FiledCheckbox.defaultProps = {
    sort_type: 'x',
    notUseDefault: true,
    options: [],
    hiddenLabelPath: 'is_hide'
};
export default FiledCheckbox;
