import { __assign, __rest } from "tslib";
// TODO 未来工单迁react时,工单签名组件需要复用
import React, { useCallback, useMemo, useState, useEffect } from 'react';
import { useTranslation } from '@udesk-webapp/locale';
import { Form, Input, Modal, Select, Button } from 'udesk-ui';
export var VerifySignatureAndSaveTicketEnums;
(function (VerifySignatureAndSaveTicketEnums) {
    VerifySignatureAndSaveTicketEnums["NeedSignature"] = "needSignature";
    VerifySignatureAndSaveTicketEnums["VerifySignatureAndSaveTicket"] = "verifySignatureAndSaveTicket";
})(VerifySignatureAndSaveTicketEnums || (VerifySignatureAndSaveTicketEnums = {}));
var layout = {
    labelCol: { span: 8 },
    wrapperCol: { span: 10 },
};
export var initalTicketSignature = {
    id: undefined,
    name: '',
    category_content: '',
    category_enabled: false,
    category_required: false,
    description_enabled: false,
    description_required: false,
    signature_require_user_email: false,
};
// 倒计时组件
var CountDown = function (_a) {
    var disabledSubmitBtn = _a.disabledSubmitBtn, setDisabledSubmitBtn = _a.setDisabledSubmitBtn, form = _a.form, t = _a.t;
    var _b = useState(120), count = _b[0], setCount = _b[1];
    var isCounting = useMemo(function () { return count > 0 && !disabledSubmitBtn; }, [count, disabledSubmitBtn]);
    var handleRestTimer = function () {
        setCount(120);
        setDisabledSubmitBtn(false);
        form.resetFields();
    };
    useEffect(function () {
        if (isCounting) {
            var timerId_1 = window.setTimeout(function () {
                setCount(count - 1);
            }, 1000);
            return function () {
                window.clearTimeout(timerId_1);
            };
        }
        else {
            setDisabledSubmitBtn(true);
        }
    }, [count, isCounting]);
    return React.createElement(React.Fragment, null,
        isCounting ? React.createElement("span", null,
            count,
            "s") : t('expired'),
        React.createElement(Button, { type: "text", size: 'small', disabled: isCounting, onClick: handleRestTimer }, t('reset')));
};
var TicketSignature = function (_a) {
    var isVisible = _a.isVisible, ticketSignature = _a.ticketSignature, onVerifySignatureAndSaveTicket = _a.onVerifySignatureAndSaveTicket, onVertifyFail = _a.onVertifyFail, onClose = _a.onClose, props = __rest(_a, ["isVisible", "ticketSignature", "onVerifySignatureAndSaveTicket", "onVertifyFail", "onClose"]);
    var t = useTranslation()[0];
    var form = Form.useForm()[0];
    var _b = useState(false), disabledSubmitBtn = _b[0], setDisabledSubmitBtn = _b[1];
    var _c = useState(false), loading = _c[0], setLoading = _c[1];
    var ticket_signature_id = ticketSignature.id, name = ticketSignature.name, _d = ticketSignature.category_content, category_content = _d === void 0 ? '' : _d, category_enabled = ticketSignature.category_enabled, category_required = ticketSignature.category_required, description_enabled = ticketSignature.description_enabled, description_required = ticketSignature.description_required, signature_require_user_email = ticketSignature.signature_require_user_email;
    var selectOptions = useMemo(function () { return category_content.split(',').map(function (item) { return ({ value: item }); }); }, [category_content]);
    var handleTicketSignature = useCallback(function () {
        form
            .validateFields()
            .then(function (values) {
            setLoading(true);
            var email = values.email, password = values.password, category_names = values.category_names, description = values.description;
            var params = {
                ticket_signature_user: {
                    email: email,
                    password: password,
                },
                ticket_signature_record: {
                    category_names: (category_names || []).join(','),
                    description: description,
                    ticket_signature_id: ticket_signature_id,
                }
            };
            if (typeof onVerifySignatureAndSaveTicket === 'function') {
                onVerifySignatureAndSaveTicket(VerifySignatureAndSaveTicketEnums.VerifySignatureAndSaveTicket, params);
                handleCancelTicketSignature();
            }
        }).catch(function (error) {
            if (typeof onVertifyFail === 'function') {
                onVertifyFail(error);
            }
        });
    }, [ticket_signature_id]);
    var handleCancelTicketSignature = useCallback(function () {
        form.resetFields();
        if (typeof onClose === 'function') {
            onClose();
        }
    }, [onClose]);
    useEffect(function () {
        if (!isVisible) {
            setDisabledSubmitBtn(false);
            setLoading(false);
        }
    }, [isVisible]);
    return (React.createElement(Modal, __assign({ title: t('signatrueTitle'), visible: isVisible, destroyOnClose: true, onOk: handleTicketSignature, onCancel: handleCancelTicketSignature, footer: [
            React.createElement(Button, { key: "cancel", onClick: handleCancelTicketSignature }, t('cancel')),
            React.createElement(Button, { key: "confirm", type: "primary", loading: loading, disabled: disabledSubmitBtn, onClick: handleTicketSignature }, t('confirm')),
        ] }, props),
        React.createElement(Form, __assign({ form: form }, layout, { initialValues: {
                name: name
            }, autoComplete: "chrome-off" }),
            React.createElement(Form.Item, { name: 'name', label: t('name'), required: true },
                React.createElement(Input, { readOnly: true })),
            signature_require_user_email ? React.createElement(Form.Item, { name: 'email', label: t('account'), rules: [
                    { required: true, message: t('page.im.ticket.emptyAccountError') },
                    { whitespace: true },
                    { type: 'email', message: t('page.im.ticket.formatAccountError') }
                ] },
                React.createElement(Input, null)) : '',
            React.createElement(Form.Item, { name: 'password', label: t('password'), rules: [
                    { required: true, message: t('page.im.ticket.emptyPasswordError') },
                    { whitespace: true },
                ] },
                React.createElement(Input.Password, null)),
            category_enabled ? React.createElement(Form.Item, { name: 'category_names', label: t('type'), required: category_required, rules: [
                    {
                        validator: function (rule, value) {
                            if (category_required && (value === undefined || !(value || []).length)) {
                                return Promise.reject(t('page.im.ticket.emptyTypeError'));
                            }
                            return Promise.resolve();
                        }
                    }
                ] },
                React.createElement(Select, { mode: 'multiple', showArrow: true, options: selectOptions })) : '',
            description_enabled ? React.createElement(Form.Item, { name: 'description', label: t('description'), rules: [
                    {
                        required: description_required,
                        message: t('page.im.ticket.emptyDescriptionError')
                    },
                    {
                        whitespace: true,
                    }
                ] },
                React.createElement(Input, null)) : '',
            React.createElement(Form.Item, { name: 'timer', label: t('signatrueAging') },
                React.createElement(CountDown, { disabledSubmitBtn: disabledSubmitBtn, setDisabledSubmitBtn: setDisabledSubmitBtn, form: form, t: t })))));
};
export default TicketSignature;
