"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _path() {
  const data = _interopRequireWildcard(require("path"));
  _path = function _path() {
    return data;
  };
  return data;
}
function _fs() {
  const data = _interopRequireDefault(require("fs"));
  _fs = function _fs() {
    return data;
  };
  return data;
}
function _micromatch() {
  const data = _interopRequireDefault(require("micromatch"));
  _micromatch = function _micromatch() {
    return data;
  };
  return data;
}
function _stringifyObject() {
  const data = _interopRequireDefault(require("stringify-object"));
  _stringifyObject = function _stringifyObject() {
    return data;
  };
  return data;
}
function _camelcase() {
  const data = _interopRequireDefault(require("camelcase"));
  _camelcase = function _camelcase() {
    return data;
  };
  return data;
}
function _nanoid() {
  const data = require("nanoid");
  _nanoid = function _nanoid() {
    return data;
  };
  return data;
}
function _chalk() {
  const data = _interopRequireDefault(require("chalk"));
  _chalk = function _chalk() {
    return data;
  };
  return data;
}
function _umi() {
  const data = require("umi");
  _umi = function _umi() {
    return data;
  };
  return data;
}
var _const = require("./const");
var _manifest = require("./plugins/manifest");
var _version = require("./plugins/version");
function _utils() {
  const data = require("@umijs/utils");
  _utils = function _utils() {
    return data;
  };
  return data;
}
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
const PLUGIN_TMP_DIR_NAME = _const.PluginTmpDirName; // plugin-udesk-sdk 插件创建临时文件的专有文件夹
const defaultSdkName = 'main';
const defaultMultipleModeOutputDir = 'dist';
const defaultWebpackEntryName = 'umi';
const defaultOutputFilename = 'index';
const defaultMountElementId = 'root';
const defaultManifestFilename = 'manifest.json';
const subConfigKey = key => `${key}-sdk`;
var Env = /*#__PURE__*/function (Env) {
  Env["dev"] = "development";
  Env["prod"] = "production";
  return Env;
}(Env || {});
const PluginDefaultConfig = {
  defaultSdk: defaultSdkName,
  outputFilename: defaultOutputFilename,
  version: '1.0.1',
  printSdkName: true,
  manifestHash: false
};
var _default = api => {
  var _api$args$_;
  /**
   *  Plugin config的类型声明，用户在添加umi config时会提供智能提示和类型校验
   * */
  // 主config
  api.describe({
    key: _const.MainConfigKey,
    config: {
      schema(joi) {
        return joi.object({
          defaultSdk: [joi.string()],
          outputFilename: [joi.string()],
          version: [joi.string()],
          multipleModeOutputDir: [joi.string(), joi.allow(null), joi.allow('')],
          printSdkName: [joi.boolean()],
          manifestHash: [joi.boolean()],
          [_const.SdkOptionsConfigKey]: joi.object().unknown()
        }).unknown();
      },
      default: PluginDefaultConfig
    }
  });
  // sdkOptions 设置，可以设置不同sdk的defaultOptions
  // api.describe({
  //     key: SdkOptionsConfigKey,
  //     config: {
  //         schema(joi) {
  //             return joi.object();
  //         },
  //     },
  // });

  // 临时目录绝对路径
  const umiTmpDir = api.paths.absTmpPath;
  // src 目录绝对路径，需注意 src 目录是可选的，如果没有 src 目录，absSrcPath 等同于 cwd
  const srcDir = api.paths.absSrcPath;
  // sdk配置文件所在路径
  const sdkConfigDir = (0, _utils().winPath)((0, _path().join)(srcDir, _const.ConfigFilesDirName));

  /**
   *  加载 Plugin 的config
   * */
  let basePluginConfig = _objectSpread(_objectSpread({}, PluginDefaultConfig), api.userConfig[_const.MainConfigKey]);
  let subPluginConfigs = {};
  Object.keys(basePluginConfig).filter(k => k.endsWith('-sdk')).forEach(k => {
    subPluginConfigs[k] = basePluginConfig[k];
    delete basePluginConfig[k];
  });
  // sdkoptions 基础配置
  let baseSdkOptions = _objectSpread({}, basePluginConfig[_const.SdkOptionsConfigKey]);
  delete basePluginConfig[_const.SdkOptionsConfigKey];
  let subSdkOptions = {};
  Object.keys(baseSdkOptions).filter(k => k.endsWith('-sdk')).forEach(k => {
    // 为所有的sdk配置增加通用基础配置
    subSdkOptions[k] = baseSdkOptions[k];
    delete baseSdkOptions[k];
  });

  /**
   * 判断是否是正在build 或者 dev，除了这两种情况，umi还支持很多其他的命令，如：
   * mfsu, build, config, dev, generate, g, help, plugin, version, webpack, dva
   * 后来把 webpack 也算进来了，因为在生成webpack配置，也可以算作是build
   * */
  let isCompilingLike = process.argv.some(a => a === 'dev' || a === 'build' || a === 'webpack');
  let startupSdkName = basePluginConfig.defaultSdk;
  /** 是否启动所有sdk，即不指定任何sdk */
  let multipleMode = !((_api$args$_ = api.args._) === null || _api$args$_ === void 0 ? void 0 : _api$args$_.length); // 参数为空或者长度为0

  if (isCompilingLike) {
    var _api$args$_2;
    // 提取正在编译的sdk
    if (api.args.sdk) {
      // 编译时手动传递了sdk参数，例如：umi build --sdk main
      startupSdkName = api.args.sdk;
    } else if (((_api$args$_2 = api.args._) === null || _api$args$_2 === void 0 ? void 0 : _api$args$_2.length) > 0) {
      // 或者使用sub command，例如：umi build main 或 yarn start my-sdk
      startupSdkName = api.args._[0];
    }
    // 打印sdk名称
    if (basePluginConfig.printSdkName) {
      api.logger.log(`Building for sdk of '${startupSdkName}'...`);
    }
  }

  // 继续设置 plugConfig ，支持每个sdk设置自己单独的配置
  let pluginConfig = _objectSpread(_objectSpread({}, basePluginConfig), subPluginConfigs[subConfigKey(startupSdkName)]);

  /**
   * 读取 SDK config files 的配置
   */
  let configFiles = getConfigFiles({
    dir: sdkConfigDir,
    api,
    defaultSdk: pluginConfig.defaultSdk
  });
  const multipleModeOutputDir = pluginConfig.multipleModeOutputDir != null ? pluginConfig.multipleModeOutputDir : defaultMultipleModeOutputDir;
  if (configFiles.some(c => c.filename === multipleModeOutputDir)) {
    throw new Error(`${_chalk().default.yellow(multipleModeOutputDir)} 是系统保留名称，不能作为sdk的配置文件，请更换另外一个名称`);
  }
  if (!configFiles.some(c => c.filename === startupSdkName)) {
    throw new Error(`Umi插件 ${_chalk().default.yellow(_const.PluginTmpDirName)} 要求必须提供相关sdk的配置文件。
当前编译的sdk为 ${_chalk().default.greenBright(startupSdkName)}，请创建 ${_chalk().default.underline(`src/sdk/${startupSdkName}.json`)} 配置文件`);
  }
  let sdkConfigsWithoutRoutes = configFiles.map(c => {
    return loadConfig(c, {
      api,
      systemRoutes: [],
      includeRoutes: false,
      sdkConfigDir
    });
  });
  let startupConfigWithoutRoute = sdkConfigsWithoutRoutes.find(c => c.filename === startupSdkName);

  // 修改 htmlChunks，以修改index.html中输出的scripts
  // 把entry中的所有入口文件都自动带上
  api.register({
    key: 'modifyHTMLChunks',
    fn(memo) {
      return _asyncToGenerator(function* () {
        // 排除掉umi，然后增加sdk entries
        return [...memo.filter(s => s !== defaultWebpackEntryName), ...(multipleMode ? configFiles.map(c => c.filename) : [pluginConfig.outputFilename])];
      })();
    }
  });
  // 禁用 layout 插件，实现纯净模式
  if (startupConfigWithoutRoute.disableLayout) {
    api.skipPlugins(['@umijs/plugin-layout']);
    /**
     * 禁用layout插件后，umi把对应的RuntimePluginKey给禁用了，
     * 但业务项目里还是会从 app.ts 中导出 layout 配置，因为在主应用时还需要启用layout。
     * 此时 umi 的就会报错，提示 layout PluginKey不可识别。
     * 由于layout配置是模块级别的导出，没有办法有时导出，有时又不到处，
     * 因此一个hacky的办法是，我们把 layout 的key 再给恢复了，避免umi报错，
     * 反正layout插件都禁用了，导出了配置也不会起作用
     */
    api.addRuntimePluginKey(() => 'layout');
  }
  let pluginState = {
    multipleMode,
    startupSdkName,
    startupConfig: startupConfigWithoutRoute,
    sdkConfigs: sdkConfigsWithoutRoutes
  };
  // 注册一个主hook，主要给第三方插件在编译时用的，额外把当前配置文件内容也放进去了，有可能用到
  api.register({
    key: _const.MainConfigKey,
    fn() {
      // 引用了sdk插件，就默认是全局微前端架构，所有应用都以sdk的模式运行。
      // 除非，不引用sdk插件，恢复成app模式
      return pluginState;
    }
  });

  // 增加运行时配置
  api.addRuntimePlugin(() => (0, _utils().winPath)((0, _path().join)(umiTmpDir, PLUGIN_TMP_DIR_NAME, 'runtime.tsx')));

  // 在runtime文件中调用，可以获取客户端的运行时配置，在app.ts中export即可
  api.addRuntimePluginKey(() => [_const.GetConfigFilePluginKey, _const.PluginConfigPluginKey, _const.PluginStatePluginKey, _const.GetRootContextPluginKey, _const.GetDefaultSdkOptionsPluginKey]);
  // 添加到 umi 模块的导出
  api.addUmiExports(() => [{
    exportAll: true,
    source: `../${PLUGIN_TMP_DIR_NAME}/exports`
  }]);

  // 修改最终配置
  api.modifyConfig(memo => {
    // 输出在sdk各自的目录下
    if (memo.outputPath) {
      memo.outputPath += `/${multipleMode ? multipleModeOutputDir : startupSdkName}`;
    }

    // 强制打开 runtimeHistory，以便在渲染sdk之前设置history的options，主要是设置 basename
    if (!memo.runtimeHistory) {
      memo.runtimeHistory = {};
    }
    // if (startupConfigWithoutRoute.mode === Mode.sdk) {
    //     // sdk模式时先禁用dynamicImport，因为目前只支持app模式的按需加载
    //     // 因为babel编译时，会把publicPath写死编译到js中去，暂时没有办法在运行时进行指定。
    //     // 如果要在编译时确定publicPath的话，就需要根据不同的环境编译不同的版本了，这不是理想的方案
    //     memo.dynamicImport = false;
    // }

    //@ts-ignore
    if (pluginConfig.base) {
      //@ts-ignore
      memo.base = pluginConfig.base;
    }
    //@ts-ignore
    if (pluginConfig.publicPath) {
      //@ts-ignore
      memo.publicPath = pluginConfig.publicPath;
    }
    return memo;
  });
  // 修改bundle配置
  api.modifyBundleConfig( /*#__PURE__*/function () {
    var _ref = _asyncToGenerator(function* (memo, {
      env,
      type,
      bundler,
      mfsu
    }) {
      var _api$config$mfsu;
      if (typeof memo.entry === 'function') {
        memo.entry = yield memo.entry();
      }
      console.log('mfsu', mfsu);
      memo.entry = buildEntry({
        multipleMode,
        configFiles: sdkConfigsWithoutRoutes,
        startupSdkName,
        outputFileName: pluginConfig.outputFilename,
        umiTmpDir,
        mfsu: env === Env.prod ? !!((_api$config$mfsu = api.config.mfsu) === null || _api$config$mfsu === void 0 ? void 0 : _api$config$mfsu[env]) : !!api.config.mfsu
      });
      console.log('入口：', memo.entry);
      return memo;
    });
    return function (_x, _x2) {
      return _ref.apply(this, arguments);
    };
  }());

  // 注册manifest插件
  api.modifyBundleConfig((bundleConfig, {
    env,
    mfsu,
    type,
    bundler: {
      id
    }
  }) => {
    const enableWriteToDisk = api.config.devServer && api.config.devServer.writeToDisk;
    if ((env === Env.prod || enableWriteToDisk) && !mfsu && id === 'webpack' &&
    // avoid ssr bundler build override index.html
    type === _umi().BundlerConfigType.csr) {
      var _bundleConfig$plugins;
      (_bundleConfig$plugins = bundleConfig.plugins) === null || _bundleConfig$plugins === void 0 ? void 0 : _bundleConfig$plugins.push(new _manifest.ManifestWebpackPlugin({
        api,
        multipleMode,
        startupSdkName,
        sdkConfigs: sdkConfigsWithoutRoutes,
        pluginConfig,
        defaultManifestFilename
      }), new _version.SdkVersionWebpackPlugin({
        api,
        pluginConfig
      }));
    }
    return bundleConfig;
  });
  api.chainWebpack((webpackConfig, {
    webpack,
    type,
    createCSSRule,
    mfsu
  }) => {
    // 当启动模式是sdk模式时，启用NormalModuleReplacementPlugin插件，去掉antd的全局样式
    // 其它情况都是启动一个app，不需要去掉全局样式，而是要包含antd的全局样式

    if (!pluginState.multipleMode && startupConfigWithoutRoute.mode === _const.Mode.sdk) {
      webpackConfig.plugin('replaceModule').use(new webpack.NormalModuleReplacementPlugin(/\/style(\/index(\.less)?)?$/, opt => {
        if (opt.context.match(/antd\/(es|lib)\/[\w|-]+?\/style$/) && opt.request === '../../style/index.less') {
          // 把引用 antd/es/styles/index.less 替换为 udesk-ui 的定制版，去掉了 global.less
          opt.request = require.resolve('udesk-ui/es/style/index.less');
        }
      }));
    }
    return webpackConfig;
  });

  // 是否需要注册一些command，进行定制化编译，或者代码生成？

  // todo: 每个sdk除了有defaultOptions的配置，还要允许有独立的umi config。
  // todo: 在编一阶段调用modifyConfig来覆盖当前编译配置。但如何从配置中把umi的配置精确分离出来？
  // todo: 创建一个新包，udesk-umi/umi-loader/umi-preset，只允许引这个，用这个包控制umi版本
  // todo: 使用qiankun的架构？
  // todo: 如何禁用layout？可以使用disablePlugins api，在非main sdk时禁用掉
  // todo: 更新文档
  // todo: 给插件config增加类型提示
  // todo: api.modifyBundleConfigs，说明可以支持多个webpack的配置，也就是说可以一次性把所有sdk打包了？
  // todo: 支持 dynmaic import路由
  // todo: SDKOptionsContext不能传递下去
  // todo: 在regenerate时，子路由会重复叠加
  // todo: 配置文件改成ts格式
  // todo: 允许自定义入口位置，这样就可以从entry继承，自定义一些东西
  // todo: 在config中增加一个runtime.ts，在entry中可以调用方法，把sdk config和plugin state传递过去，这样就支持运行时构造sdkoptions了
  // todo: 编译时判断是否支持dynamicImport，然后支持组件的dynamic
  // todo: 动态根路由从sdkOptions中传入就可以了。把udeskSDK中的配置挪到SDK配置文件中。
  // todo: 把配置文件格式设置为ts，如果不能require ts文件，则可以事先编译成lib文件，再执行导入
  // todo: 生成添加manifest文件，一个主入口，多个vendor（并行，但主入口等全完成后才可执行），多个css。manifest添加版本号
  // todo: sdk loader增加选项，卸载时自动移除css？
  // todo: 自定义修改sdk的文件名，现在叫umi.js。如果替换掉umi
  // todo: 支持多个入口，一块编译所有的sdk
  // todo: 查看 modifyPublicPathStr 的api，以及 runtimePublicPath 的配置，包含解决sdk分包的线索？

  //todo: umi.js:465967 Warning: You are attempting to use a basename on a page whose URL path does not begin with the basename. Expected path "/site/test" to begin with "/wfsite"
  //umi.js:555409 Uncaught TypeError: this.routes is not a function

  //? 究竟应该一次性生成bundleConfig，然后批量编译所有sdk，还是应该一次一个一个的编译？按说第一种最好，但有以下一些问题需要解决：
  /**
   * 1. preset-built-in 插件里生成history，使用的api.config.base 来作为baseurl，一次编译不能有多个值？除非每个编译都有一份独立的api.config
   * 1.1 也就是说只要在以来其他插件生成的代码，就会存在单例问题
   * 2. 本插件在yarn build时，还是会用main来做主入口，其他sdk的入口文件能生成，但没法自动启动编译
   * 3.
   */

  /**
   * 生成一些常用的模板变量，方便在模板中直接使用。
   * 在替换环节还会做一些特殊处理，把所有绝对路径替换成相对路径，同时这些绝对路径还会保留，会在key前面增加 ABS_ 前缀，
   * */
  const placeholders = {
    CWD: (0, _utils().winPath)(api.paths.cwd),
    TMP_PATH: (0, _utils().winPath)(umiTmpDir),
    SRC_PATH: (0, _utils().winPath)(srcDir),
    PAGES_PATH: (0, _utils().winPath)(api.paths.absPagesPath),
    STARTUP_SDK_NAME: startupSdkName,
    PLUGIN_TMP_DIR_NAME,
    CONFIG_FILES_DIR_NAME: _const.ConfigFilesDirName,
    OUTPUT_SDK_ENTRIES_DIR_NAME: _const.OutputSdkEntriesDirName,
    PLUGIN_CONFIG_KEY: _const.MainConfigKey,
    DEFAULT_UMI_CHUNK: defaultWebpackEntryName
  };
  // 监听 sdk 目录
  api.addTmpGenerateWatcherPaths(() => [sdkConfigDir]);
  // 初次生成文件，以及监听目录变化后重新生成
  api.onGenerateFiles( /*#__PURE__*/_asyncToGenerator(function* () {
    // 重新加载配置文件。不要使用外面的configFiles，因为可能文件已发生了变化
    let configFiles = getConfigFiles({
      dir: sdkConfigDir,
      api,
      defaultSdk: pluginConfig.defaultSdk
    });

    // 拷贝运行时文件，注意依赖顺序
    // todo: 有些可以挪到独立的包中，ts版的web-toolkits
    // !注意在模板文件中的 import 指令不可以使用 @、@@ 这种指令，必须使用相对路径或绝对路径
    writeFromTemplateFile('./const.ts', {
      api,
      placeholders
    });
    writeFromTemplateFile('./types.d.ts', {
      api,
      placeholders
    });
    writeFromTemplateFile('./.templates/exports.ts', {
      api,
      placeholders
      // 导出所有入口，会导致每个sdk都包含其他的sdk内容，导致包变大
      // format: content => {
      //     // 把每个entry导出到umi命名空间下
      //     let entries = configFiles.map(c => {
      //         let exportName = `${camelCase(c.filename, {
      //             pascalCase: true,
      //         })}SDKEntryBase`;
      //         return `export { default as ${exportName} } from './${OutputSdkEntriesDirName}/${c.filename}';`;
      //     });
      //     content = placeholder(
      //         content,
      //         'EXPORT_ENTRIES',
      //         entries.join(EOL).replace(/;$/, '')
      //     );
      //     return content;
      // },
    });

    writeFromTemplateFile('./.templates/umi-sdk-base.ts', {
      api,
      placeholders
    });
    writeFromTemplateFile('./.templates/root-component.tsx', {
      api,
      placeholders
    });
    writeFromTemplateFile('./.templates/dummy.ts', {
      api,
      placeholders
    });
    writeFromTemplateFile('./.templates/hooks.ts', {
      api,
      placeholders,
      format: content => {
        content = placeholder(content, 'DEFAULT_ROUTER_BASE', api.config.base || '/');
        return content;
      }
    });
    writeFromTemplateFile('./.templates/runtime.tsx', {
      api,
      placeholders
    });
    // copy runtime-types
    const runtimeTypesFile = `${PLUGIN_TMP_DIR_NAME}/runtime-types.ts`;
    if (_fs().default.existsSync((0, _path().join)(sdkConfigDir, 'types.ts'))) {
      // prettier-ignore
      writeFromTemplateFile('./.templates/runtime-types-custom.ts', {
        out: runtimeTypesFile,
        api,
        placeholders
      });
    } else {
      writeFromTemplateFile('./.templates/runtime-types.ts', {
        api,
        placeholders
      });
    }

    // 加载 sdk-runtime，先尝试加载业务项目内的文件，如果不存在的话，加载插件内默认的
    let sdkRuntimePath = `${srcDir}/sdk-runtime`;
    let sdkRuntime = loadModule(sdkRuntimePath);
    if (sdkRuntime.data) {
      // 校验文件的合法性
      let friendlyName = `~/src/${(0, _path().basename)(sdkRuntime.filename)}`;
      if (sdkRuntime.data.getSdkOptions) {
        if (typeof sdkRuntime.data.getSdkOptions !== 'function') {
          throw new Error(`${friendlyName} 中导出的 'getSdkOptions' 必须是一个方法！`);
        }
      }
    }
    // 把 sdk-runtime 拷贝到临时目录中，在运行时使用
    if (sdkRuntime.filename) {
      writeFromTemplateFile(sdkRuntime.filename, {
        api,
        placeholders
      });
    } else {
      // 如果业务项目没有，则拷贝默认的
      writeFromTemplateFile('./.templates/sdk-runtime.tsx', {
        api,
        placeholders
      });
    }

    /**
     * 解析Config配置，把配置的路由模糊匹配规则解析成真正的路由，
     * 同时把component路径解析成require指令
     */
    let systemRoutes = yield api.getRoutes();
    let sdkConfigs = loadConfigs(configFiles, {
      api,
      systemRoutes,
      sdkConfigDir
    });

    /**
     * 至此，路由配置已经解析的很标准了，可以安全使用。
     * name、path都已经有值，routes 也是umi中正式的路由对象了，不存在字符串形式了
     */
    // 生成真正的sdk entry和options类文件
    sdkConfigs.forEach(config => {
      let configFilename = getFilename(config);
      let optionFilename = `${configFilename}-options`;
      let rendererFilename = `${configFilename}-renderer`;
      let isComponentSDK = !!config.componentsMapping;
      // let isRouteSDK=config.routes;
      // 输出sdk-options文件
      writeFromTemplateFile(`./.templates/${_const.OutputSdkEntriesDirName}/sdk-options.ts`, {
        api,
        placeholders,
        out: `${PLUGIN_TMP_DIR_NAME}/${_const.OutputSdkEntriesDirName}/${optionFilename}.ts`,
        format(content) {
          // 深拷贝一下，因为在下一步中替换component会直接修改配置对象
          let clonedConfig = _objectSpread(_objectSpread({}, config), {}, {
            routes: []
          });
          // 把 route.component 是组件的路径，需要替换成 require 指令，得到的是组件导出的类
          if (config.routes) {
            clonedConfig.routes = requireComponent(config.routes, {
              configPath: config.path,
              api
            });
            // 组件SDK
          } else if (config.componentsMapping) {
            clonedConfig.routes = requireComponent(convertToRoute(config.componentsMapping), {
              configPath: config.path,
              api
            });
          }
          let configContent = placeholder(stringify(clonedConfig, 4, {
            singleQuotes: false
          }), null, '$1');
          if (api.config.dynamicImport && api.config.dynamicImport.loading) {
            content = placeholder(content, 'LOADING_COMPONENT', `import LoadingComponent from '${api.config.dynamicImport.loading}';`);
          }
          // 写入SDK配置文件的内容
          return placeholder(content, 'RUNTIME_SDK_CONFIG', configContent);
        }
      });

      // 输出sdk-class文件
      writeFromTemplateFile(`./.templates/${_const.OutputSdkEntriesDirName}/sdk-class.ts`, {
        api,
        placeholders,
        out: `${PLUGIN_TMP_DIR_NAME}/${_const.OutputSdkEntriesDirName}/${configFilename}-class.ts`,
        format(content) {
          // 替换 options，包含sdk的路由表
          content = placeholder(content, 'ENTRY_OPTIONS_FILE', (0, _utils().winPath)(optionFilename));
          content = placeholder(content, 'ENTRY_RENDERER_FILE', (0, _utils().winPath)(rendererFilename));
          content = placeholder(content, 'ENTRY_RENDERER_MODE', isComponentSDK ? `'${_const.Mode.component}'` : `${undefined}` // 这里如果还需要区分是app还是sdk，继续判断
          );

          // 替换 sdkOptions 的默认值，用户显式在config中配置的才会写入进去
          let compilerDefaultOptions = _objectSpread(_objectSpread({}, baseSdkOptions), subSdkOptions[subConfigKey(configFilename)]);
          content = placeholder(content, 'COMPILER_SDK_DEFAULT_OPTIONS', `${stringify(compilerDefaultOptions, 4)}`);

          // 替换 PLUGIN_CONFIG ，可以传递给 config/sdk-runtime.ts 模块，让前端根据插件的配置和状态做一些决策
          let subPluginConfig = _objectSpread(_objectSpread({}, basePluginConfig), subPluginConfigs[subConfigKey(configFilename)]);
          content = placeholder(content, 'PLUGIN_CONFIG', `${stringify(subPluginConfig, 4)}`);

          // 替换 PLUGIN_STATE ，可以传递给 config/sdk-runtime.ts 模块，让前端根据插件的配置和状态做一些决策
          content = placeholder(content, 'PLUGIN_STATE', `${stringify(pluginState, 4)}`);

          // 替换 CONFIG_FILENAME ，入口文件的文件名
          content = placeholder(content, 'CONFIG_FILENAME', `${(0, _utils().winPath)(config.filename)}`);
          return content;
        }
      });

      // 输出 sdk-startup 文件
      writeFromTemplateFile(`./.templates/${_const.OutputSdkEntriesDirName}/sdk-startup.tsx`, {
        api,
        placeholders,
        out: `${PLUGIN_TMP_DIR_NAME}/${_const.OutputSdkEntriesDirName}/${configFilename}-startup.tsx`,
        format(content) {
          // 替换 options，包含sdk的路由表
          content = placeholder(content, 'ENTRY_PATH', (0, _utils().winPath)(config.entryPath.replace(/\.\w+$/, '')));

          // 替换 isCurrentSdk 的标记，如果是，则自动初始化sdk，并渲染
          content = placeholder(content, 'AUTO_RUN', config.autoRun ? 'true' : 'false');
          content = placeholder(content, 'SDK_OPTIONS', jsonStrigify(config['options.sdkOptions']));
          // 替换 UNIQUE_ID
          content = placeholder(content, 'UNIQUE_ID', config.uniqueId);
          // 引进组件形式SDK
          let componentSDKPath = config === null || config === void 0 ? void 0 : config.componentEntryPath;
          if (componentSDKPath) {
            content = placeholder(content, 'IMPORT_COMPONENT_SDK', `import componentSdk from "${(0, _utils().winPath)(componentSDKPath === null || componentSDKPath === void 0 ? void 0 : componentSDKPath.replace(/\.\w+$/, ''))}"`);
            content = placeholder(content, 'EXPORT_COMPONENT_SDK', `export { componentSdk };`);
            content = placeholder(content, 'COMPONENT_SDK_CLASS', `componentSdk`);
          } else {
            content = placeholder(content, 'IMPORT_COMPONENT_SDK', ``);
            content = placeholder(content, 'COMPONENT_SDK_CLASS', `false`);
          }

          // 替换 rootElementId，sdk渲染到这个容器里
          content = placeholder(content, 'UMI_ROOT_ELEMENT_ID', api.config.mountElementId || defaultMountElementId);
          return content;
        }
      });

      // 输出 mf-patch 文件
      writeFromTemplateFile(`./.templates/${_const.OutputSdkEntriesDirName}/mf-patch.ts`, {
        api,
        placeholders,
        out: `${PLUGIN_TMP_DIR_NAME}/${_const.OutputSdkEntriesDirName}/${configFilename}-mf-patch.ts`,
        format(content) {
          // 替换 UNIQUE_ID
          content = placeholder(content, 'UNIQUE_ID', config.uniqueId);
          return content;
        }
      });
    });
  }));
};
exports.default = _default;
function getFilename(config) {
  let filePath = '';
  if (typeof config === 'string') {
    filePath = config;
  } else {
    filePath = config.filename || config.path;
  }
  return (0, _path().basename)(filePath).replace((0, _path().extname)(filePath), '');
}
function loadConfigs(configFiles, {
  api,
  systemRoutes,
  // includeRoutes = true,
  sdkConfigDir
}) {
  return configFiles.map(file => {
    let includeRoutes = file.includeRoutes;
    // 删掉includeRoutes
    delete file.includeRoutes;
    return loadConfig(file, {
      api,
      systemRoutes,
      includeRoutes: includeRoutes == undefined ? true : includeRoutes,
      sdkConfigDir
    });
  });
}
function loadConfig(descriptor, {
  api,
  systemRoutes,
  includeRoutes = true,
  sdkConfigDir
}) {
  let descriptorFileContent = require(descriptor.path);
  // 如果descriptor有routes和componentsMapping配置，则删除配置文件中的相同属性
  let cloneDescriptorFileContent = _objectSpread({}, descriptorFileContent);
  if ((descriptor === null || descriptor === void 0 ? void 0 : descriptor.routes) || (descriptor === null || descriptor === void 0 ? void 0 : descriptor.componentsMapping)) {
    delete cloneDescriptorFileContent.routes;
    delete cloneDescriptorFileContent.componentsMapping;
  }
  let config = _objectSpread(_objectSpread({}, descriptor), cloneDescriptorFileContent);
  config.path = descriptor.path;
  if (!config.name) {
    // 自动生成SDK Class的名称
    // 可以自己指定，或者根据文件名自动生成，
    // 生成规则是：文件名变成Pascal格式 + SdkClass后缀
    config.name = (0, _camelcase().default)(getFilename(config) + '-sdk-class', {
      pascalCase: true
    });
  }
  if (config.mode == null) {
    if (config.isMain) {
      config.mode = _const.Mode.app;
    } else {
      config.mode = _const.Mode.sdk;
    }
  }
  if (config.disableLayout == null) {
    if (api.env === Env.dev) {
      // 开发模式下自动启用layout
      config.disableLayout = false;
    } else if (api.env === Env.prod) {
      // 生产模式下自动禁用layout，但应用模式下除外
      config.disableLayout = config.mode === _const.Mode.sdk;
    }
  }
  if (config.autoRun == null) {
    if (api.env === Env.dev) {
      // 开发模式下自动运行方便测试
      config.autoRun = true;
    } else if (api.env === Env.prod) {
      // 生产模式下，禁止自动运行，除非是app模式
      config.autoRun = config.mode === _const.Mode.app;
    }
  }
  config.uniqueId = (0, _nanoid().nanoid)();
  let entryPath = '';
  if (config.entry) {
    entryPath = (0, _path().resolve)(api.paths.cwd, config.entry);
  } else {
    // 用户自定义入口，支持ts、tsx、js、jsx类型
    let userEntryFile = ['ts', 'tsx', 'js', 'jsx'].map(ext => (0, _path().join)(sdkConfigDir, `${config.filename}.${ext}`)).find(s => _fs().default.existsSync(s));
    entryPath = userEntryFile || (0, _path().join)(api.paths.absTmpPath, PLUGIN_TMP_DIR_NAME, _const.OutputSdkEntriesDirName, `${descriptor.filename}-class.ts`);
    // config里面的这两个属性已经重新生成，使用descriptorFileContent代替
    if (descriptorFileContent.routes && descriptorFileContent.componentsMapping && descriptor.filename.indexOf('--component') === -1) {
      let componentEntryPath = '';
      componentEntryPath = userEntryFile || (0, _path().join)(api.paths.absTmpPath, PLUGIN_TMP_DIR_NAME, _const.OutputSdkEntriesDirName, `${descriptor.filename}--component-class.ts`);
      // 同时包含路由和组件的sdk
      config.componentEntryPath = (0, _utils().winPath)(componentEntryPath);
    }
  }
  config.entryPath = (0, _utils().winPath)(entryPath);
  config.optionsName = `${descriptor.filename}-options.ts`;
  config.optionsPath = (0, _utils().winPath)((0, _path().join)(api.paths.absTmpPath, _const.PluginTmpDirName, _const.OutputSdkEntriesDirName, `${descriptor.filename}-options.ts`));
  config.rendererName = `${descriptor.filename}-renderer.ts`;
  config.rendererPath = (0, _utils().winPath)((0, _path().join)(api.paths.absTmpPath, `${descriptor.filename}-renderer.ts`));
  config.startupName = `${descriptor.filename}-startup.tsx`;
  config.startupPath = (0, _utils().winPath)((0, _path().join)(api.paths.absTmpPath, _const.PluginTmpDirName, _const.OutputSdkEntriesDirName, `${descriptor.filename}-startup.tsx`));
  if (includeRoutes && config.routes) {
    // 处理路由
    let configPatterns = normalizeRoutes(config.routes);
    let routePatterns = configPatterns.filter(r => r.path);
    let stringPatterns = configPatterns.filter(r => typeof r === 'string');
    let globPatterns = configPatterns.filter(r => r.patterns).map(r => r).filter(glob => {
      // 验证 glob.root 必须存在
      let root = findRoute(glob.root, {
        systemRoutes
      });
      if (root) {
        return true;
      } else {
        api.logger.warn(`Glob根路由 '${glob.root}' 在路由表中不存在，这条规则被自动忽略。配置文件: ${config.path} `);
        return false;
      }
    });

    // 从系统路由表中提取匹配的路由
    let tree = cloneTree(systemRoutes, (route, {
      parentNodes
    }) => {
      let newRoute = _objectSpread({}, route);
      if (!newRoute.path) {
        return;
      }
      // 只要任何一个patter匹配即可
      let isMatched = stringPatterns.some(pattern => _micromatch().default.isMatch(newRoute.path, pattern));
      if (isMatched) {
        // 把匹配节点标记一下
        newRoute.isMatched = true;
        // 同时把所有父节点都标记一下
        parentNodes.forEach(node => {
          node.isMatched = true;
        });
      }
      return newRoute;
    });
    removeMismatched(tree);
    config.routes = tree;

    // 再追加使用 globaPattern 提取出来的路由，直接提取到根路由下
    globPatterns.forEach(glob => {
      let root = findRoute(glob.root, {
        systemRoutes
      });
      if (root) {
        let rootPath = root.path || '';
        let newRoot = cloneTree([root], (route, {
          parentNodes
        }) => {
          let newRoute = _objectSpread({}, route);
          // 只要任何一个patter匹配即可
          let isMatched = glob.patterns.some(pattern => _micromatch().default.isMatch(newRoute.path, rootPath + (pattern.startsWith('/') ? '' : '/') + pattern));
          if (isMatched) {
            // 把匹配节点标记一下
            newRoute.isMatched = true;
            // 把根节点也标记一下
            parentNodes.forEach(node => {
              node.isMatched = true;
            });
            // 如果不包含根节点，则把根节点的路径清除掉，把子路由直接提取到根路由上
            if (!glob.includeRoot) {
              newRoute.path = newRoute.path.replace(rootPath, '');
            }
          }
          return newRoute;
        });
        removeMismatched(newRoot);
        // console.log(...newRoot);
        // 如果包含父节点，则把父节点（附带匹配到的子路由）附加到根路由上
        // 否则，只把匹配到的子路由附加到根路由上
        if (glob.includeRoot) {
          config.routes.push(...newRoot);
        } else {
          newRoot.forEach(route => {
            config.routes.push(...(route.routes || []));
          });
        }
      }
    });

    // 添加手动声明的routes
    config.routes.push(...routePatterns.map(config => _objectSpread({}, config)));
    /*
    不自动附加子路由。既然父路由都是自己声明的，那下面的子路由也需要自己声明。
    routePatterns.forEach(routeConfig => {
    let newRoute: ResolvedRoute = { ...routeConfig, routes: [] };
    let childRoutes: RoutePattern[] = [];
    if (routeConfig.routes) {
        childRoutes = [...routeConfig.routes];
    }
    let matchRoute = findRoute(newRoute.path, { systemRoutes });
    if (!newRoute.component && !matchRoute) {
        throw new Error(
            `SDK配置错误！路由 '${routeConfig.path}' 没有设置 component，而此path在路由表中又不存在，会导致空白页面，请设置 component 的值。配置文件: ${config.path} `
        );
    }
    if (
        !matchRoute &&
        routeConfig.routes &&
        routeConfig.routes.some(r => typeof r === 'string')
    ) {
        api.logger.warn(
            `由于路由 '${routeConfig.path}' 在路由表中不存在，所以routes子路由中的字符串规则被自动忽略。配置文件: ${config.path} `
        );
    }
    newRoute.routes = pickRouteNodes(childRoutes, matchRoute, {
        systemRoutes,
        api,
        config,
    });
    config.routes.push(newRoute);
    });
    */

    // 删除 isMatched 临时标记
    traverseTreeReverse(config.routes, route => {
      delete route.isMatched;
      return true;
    });
  }
  return config;
}
function normalizeRoutes(routes, parentName = '') {
  let newRoutes = [];
  routes.forEach(route => {
    if (route) {
      if (typeof route === 'string') {
        // 字符串表达式
        newRoutes.push(route);
      } else if (typeof route === 'object') {
        if (route.root || route.patterns) {
          // Glob对象
          route = route;
          route.root = route.root || '';
          route.patterns = route.patterns || [];
          newRoutes.push(route);
        } else {
          // 路由对象
          route = route;
          if (!route.path) {
            throw new Error(`SDK配置文件路由的path不能为空，请检查 ${parentName}/""`);
          }
          newRoutes.push(route);
        }
      }
    }
  });
  for (let i = newRoutes.length - 1; i >= 0; i--) {
    let route = newRoutes[i];
    if (typeof route === 'string') {
      if (parentName) {
        routes[i] = `${parentName}/${route}`;
      }
    } else if (route.patterns) {
      route = route;
      if (!route.root) {
        // 如果root为空，只能兼容成父节点的path，
        // 由于root本来就是全局性的，与父节点也无关，所以这么处理也说的过去
        route.root = parentName;
        continue;
      }
      if (parentName) {
        route.root = `${parentName}/${route.root}`;
      }
    } else if (route.path) {
      route = route;
      if (parentName) {
        route.path = `${parentName}/${route.path}`;
      }
      if (route.routes) {
        route.routes = normalizeRoutes(route.routes, route.path);
      }
    }
  }
  return newRoutes;
}
function writeFromTemplateFile(src, {
  api,
  placeholders,
  out,
  format
}) {
  let srcFilename = _path().default.isAbsolute(src) ? src : (0, _path().join)(__dirname, '../src', src);
  let outPath = out || (_path().default.isAbsolute(src) ? (0, _path().join)(PLUGIN_TMP_DIR_NAME, (0, _path().basename)(src)) : (0, _path().join)(PLUGIN_TMP_DIR_NAME, src.replace('.templates/', '')));
  let content = _fs().default.readFileSync(srcFilename).toString();

  // 替换placeholder的path，变成相对路径
  let relativePlaceholders = relativePaths(placeholders, (0, _path().join)(api.paths.absTmpPath, outPath));
  // 替换通用占位符
  Object.entries(relativePlaceholders).forEach(([key, value]) => {
    content = placeholder(content, key, value);
  });
  if (format) {
    content = format(content);
  }
  api.writeTmpFile({
    path: outPath,
    content
  });
}

/** 把 placeholders 中的绝对路径替换成相对路径，同时还保留原值，保存在 ABS_ 前缀的新字段下 */
function relativePaths(placeholders, basePath) {
  let newPlaceholders = _objectSpread({}, placeholders);
  Object.entries(newPlaceholders).forEach(([key, value]) => {
    if (_path().default.isAbsolute(value)) {
      newPlaceholders[`ABS_${key}`] = (0, _utils().winPath)(value);
      newPlaceholders[key] = (0, _utils().winPath)((0, _path().relative)(_path().default.dirname(basePath), value));
    }
  });
  return newPlaceholders;
}
function getConfigFiles({
  dir,
  api,
  defaultSdk
}) {
  let configFiles = [];
  if (_fs().default.existsSync(dir) && _fs().default.statSync(dir).isDirectory) {
    const regExp = /\.(json)/i;
    let files = _fs().default.readdirSync(dir).map(p => (0, _path().join)(dir, p)).filter(p => p.match(regExp));
    files.forEach(p => {
      let config = null;
      try {
        config = require(p);
      } catch (error) {
        api.logger.error(`加载sdk配置文件 ${p} 失败`);
        throw error;
      }
      let filename = getFilename(p);
      if (config.routes && config.componentsMapping) {
        configFiles.push({
          path: (0, _utils().winPath)(p),
          includeRoutes: false,
          // 为了不走路由，临时添加
          componentsMapping: config.componentsMapping,
          // 路由附带组件的配置文件，组件的文件名称通过增加--component来区分
          filename: `${filename}--component`,
          isMain: false
        });
        configFiles.push({
          path: (0, _utils().winPath)(p),
          filename,
          routes: config.routes,
          isMain: filename === defaultSdk
        });
      } else if (config.routes) {
        configFiles.push({
          path: (0, _utils().winPath)(p),
          filename,
          isMain: filename === defaultSdk
        });
      } else if (config.componentsMapping) {
        configFiles.push({
          path: (0, _utils().winPath)(p),
          includeRoutes: false,
          // 为了不走路由，临时添加
          filename,
          isMain: false
        });
      } else {
        throw new Error(`sdk配置文件 ${p} 格式不正确`);
      }
    });
  }

  // 如果没有主sdk，则自动创建一个默认的
  if (!configFiles.some(c => c.filename === defaultSdk)) {
    configFiles.push({
      path: (0, _path().join)(__dirname, '../src', './.templates/main.json'),
      filename: (0, _utils().winPath)(defaultSdk),
      isMain: true
    });
  }
  return configFiles;
}
function buildEntry({
  multipleMode,
  configFiles,
  startupSdkName,
  outputFileName,
  umiTmpDir,
  mfsu
}) {
  let entry = {};
  if (multipleMode) {
    configFiles.forEach(c => {
      let mfsuPatchPath = _path().default.join(umiTmpDir, _const.PluginTmpDirName, _const.OutputSdkEntriesDirName, `${c.filename}-mf-patch.ts`);
      entry[c.filename] = [mfsu ? mfsuPatchPath : undefined, c.startupPath].filter(Boolean);
    });
  } else {
    var _configFiles$find;
    let mfsuPatchPath = _path().default.join(umiTmpDir, _const.PluginTmpDirName, _const.OutputSdkEntriesDirName, `${startupSdkName}-mf-patch.ts`);
    // 取startupSdkName的配置，key使用outputFileName
    entry[outputFileName] = [mfsu ? mfsuPatchPath : undefined, (_configFiles$find = configFiles.find(c => c.filename === startupSdkName)) === null || _configFiles$find === void 0 ? void 0 : _configFiles$find.startupPath].filter(Boolean);
  }
  return _objectSpread({
    /**
     * 为什么不是删除掉umi的默认入口？目前发现有两处障碍：
     * 1. 在生成html时(preset-built-in/plugins/commands/htmlUtils.ts)会默认使用 umi 的入口，如果我们删除掉，会导致生成html时在chunks中找不到而报错
     * 2. 在调用 umi webpack 命令打印webpack配置时（preset-built-in/plugins/commands/webpack/webpack.ts），会默认根据entry=umi来查找webpack的config
     * 没怎么测试过，暂时还没发现其它的障碍
     * 对于第一处可以解决，可以注册 modifyHTMLChunks 的hook，来修改掉默认的htmlChunks，把umi去掉即可避免生成html时再去查找umi的chunk。
     * 对于第二处理论上也能解决，需要修改源文件，换一个其他的用来识别umi默认config的标识(如果存在的话)
     * 但是如果对umi的编译方式改变过多的话，是否会导致别的错误就不好说了，暂时不动。目前发现mfsu开启后启动出错。
     */
    [defaultWebpackEntryName]: _path().default.join(umiTmpDir, _const.PluginTmpDirName, 'dummy.ts')
  }, entry);
}

// function pickRouteNodes(
//     configRoutes: RootRoutes,
//     parentMatch: IRoute | undefined,
//     { systemRoutes, api, config }: { systemRoutes: IRoute[]; api: IApi; config: RuntimeSdkConfig }
// ): ResolvedRoute[] {}

function matchChildRoutesByString(parentMatch, pattern) {
  let tree = cloneTree(parentMatch.routes, route => {
    let newRoute = _objectSpread({}, route);
    newRoute.isMatched = _micromatch().default.isMatch(newRoute.path, pattern);
    return newRoute;
  });
  removeMismatched(tree);
  return tree;
}
function findRoute(path, {
  systemRoutes
}) {
  let matchedRoute = undefined;
  traverseTreeReverse(systemRoutes, route => {
    if (route.path === path) {
      matchedRoute = _objectSpread(_objectSpread({}, route), {}, {
        routes: [...(route.routes || [])]
      });
      return false;
    } else {
      return true;
    }
  });
  return matchedRoute;
}
function cloneTree(routes, action, newTree = [], parentNodes = []) {
  routes.forEach(route => {
    let newRoute = action(route, {
      newTree,
      parentNodes
    });
    newTree.push(newRoute);
    if (route.routes) {
      newRoute.routes = [];
      cloneTree(route.routes, action, newRoute.routes, [...parentNodes, newRoute]);
    }
  });
  return newTree;
}
function traverseTreeReverse(routes, action) {
  for (let i = routes.length - 1; i >= 0; i--) {
    let route = routes[i];
    if (!route) {
      continue;
    }
    if (!action(route, routes, i)) {
      continue;
    }
    if (route.routes) {
      traverseTreeReverse(route.routes, action);
    }
  }
}
function removeMismatched(tree) {
  traverseTreeReverse(tree, (route, routes, index) => {
    if (route.isMatched) {
      // 匹配到了，就保留这个节点，不必深入查找了
      return false;
    } else {
      // 如果没匹配到，可能某个子节点有匹配，需要查找子节点
      if (route.routes) {
        // 检查子节点是否有选中的
        let hasMatchedChildren = false;
        traverseTreeReverse(route.routes, subRoute => {
          if (subRoute.isMatched) {
            hasMatchedChildren = true;
            return false;
          } else {
            return true;
          }
        });
        if (hasMatchedChildren) {
          // 有子节点被匹配的话，保留此节点，但继续深度遍历
          return true;
        } else {
          // 否则移除此节点，不必深入遍历
          routes.splice(index, 1);
          return false;
        }
      } else {
        // 没有匹配到，还没有子节点的，直接移除
        routes.splice(index, 1);
        return false;
      }
    }
  });
}

/** 替换路由的component字段，把路径名替换成 require 指令 */
function requireComponent(routes, options) {
  let runtimeRoutes = [];
  routes.filter(route => route).forEach(route => {
    let componentContent = `%require('${route.component}').default%`;
    if (options.api.config.dynamicImport) {
      let webpackChunkName = options.api.utils.routeToChunkName({
        route,
        cwd: options.api.paths.cwd
      });
      let loading = '';
      if (options.api.config.dynamicImport.loading) {
        loading = `, loading: LoadingComponent`;
      }
      componentContent = `%dynamic({ loader: () => import(/* webpackChunkName: '${webpackChunkName}' */'${route.component}')${loading}})%`;
    }
    let newRoute = _objectSpread(_objectSpread({}, route), {}, {
      component: componentContent
    });
    runtimeRoutes.push(newRoute);
    if (route.routes) {
      newRoute.routes = requireComponent(route.routes, options);
    }
  });
  return runtimeRoutes;
}
function placeholder(content, placeholder, value) {
  /**
   * 有两种模板占位符(___是占位符变量)：
   * 1. "%___%"
   * 2. //"%___%"
   * 为什么采用这样的占位符规则？
   * 最初想的是使用 %___% 这样的规则，也更好理解一些。但这样的内容直接出现在 js 文件里的话，不是合法的语法，
   * 既让编译器报错，同时也没有办法格式化代码。所以，我们把规则变体了一下，变成一个“字符串”形式，这样在大部分
   * 场景下都是正常的js代码了，不算很简洁优雅，但很实用。
   * 第二种占位符是在第一种基础上衍生出来的，因为有时我们需要一整行都是一个占位符，但是 prettier 会进行格式化，
   * "%___%"  =>  ('%___%');
   * 会在外层套上括号，变成一个表达式。所以我们在前面增加了两个 // ，变成一种注释，prettier就不会自动格式化了。
   */
  const reg = /(?:\/\/\s*)?["']%(.+?)%["']/g;
  if (placeholder) {
    return content.replace(reg, (substr, group1) => {
      if (placeholder instanceof RegExp) {
        return substr.replace(placeholder, value);
      } else {
        if (group1 === placeholder) {
          return value;
        } else {
          return substr;
        }
      }
    });
  } else {
    // 替换所有
    return content.replace(reg, value);
  }
}
function loadModule(moduleName) {
  let extensions = ['ts', 'tsx', 'js', 'jsx'];
  for (var _i = 0, _extensions = extensions; _i < _extensions.length; _i++) {
    const ext = _extensions[_i];
    let filename = `${moduleName}.${ext}`;
    if (_fs().default.existsSync(filename)) {
      return {
        filename,
        data: require(filename)
      };
    }
  }
  return {
    filename: undefined,
    data: undefined
  };
}
function stringify(data, indent = 4, options) {
  let content = (0, _stringifyObject().default)(data, _objectSpread(_objectSpread({}, options), {}, {
    indent: spaceIndent(indent)
  }));
  if (typeof data === 'object' && indent > 4 && content.substr(-1, 1) === '}') {
    // 如果是缩进大于一级以上的话，最后一个大括号没有正常缩进
    content = content.replace(/(.+?)\}$/, `$1${spaceIndent(indent - 4)}}`);
  }
  return content;
}
function spaceIndent(count = 4) {
  return ''.padStart(count, ' ');
}

//#region Api debug info
/* 
    [api]
    
    id: '@umijs/plugin-access',
    key: 'access',
    cwd: '/Users/shijistar/Documents/udesk_wechat_helper_web',
    env: 'development',

    paths: {
      cwd: '/Users/shijistar/Documents/udesk_wechat_helper_web',
      absNodeModulesPath: '/Users/shijistar/Documents/udesk_wechat_helper_web/node_modules',
      absOutputPath: '/Users/shijistar/Documents/udesk_wechat_helper_web/dist',
      absSrcPath: '/Users/shijistar/Documents/udesk_wechat_helper_web/src',
      absPagesPath: '/Users/shijistar/Documents/udesk_wechat_helper_web/src/pages',
      absTmpPath: '/Users/shijistar/Documents/udesk_wechat_helper_web/src/.umi'
    },

    service: Service {
        _events: [Object: null prototype] {},
        _eventsCount: 0,
        _maxListeners: undefined,
        skipPluginIds: Set {},
        stage: 9,
        commands: {
        build: [Object],
        config: [Object],
        dev: [Object],
        generate: [Object],
        g: 'generate',
        help: [Object],
        plugin: [Object],
        version: [Object],
        webpack: [Object],
        dva: [Object]
        },
    }

    configInstance: Config {
      cwd: '/Users/shijistar/Documents/udesk_wechat_helper_web',
      service: [Circular],
      localConfig: true,
      configFile: 'config/config.ts'
    },

    plugins: {
      '@umijs/preset-built-in': [Object],
      './node_modules/@@/registerMethods': [Object],
      './node_modules/@@/routes': [Object],
      './node_modules/@@/generateFiles/core/history': [Object],
      './node_modules/@@/generateFiles/core/plugin': [Object],
      './node_modules/@@/generateFiles/core/polyfill': [Object],
      './node_modules/@@/generateFiles/core/routes': [Object],
      './node_modules/@@/generateFiles/core/umiExports': [Object],
      './node_modules/@@/generateFiles/core/configTypes': [Object],
      './node_modules/@@/generateFiles/umi': [Object],
      './node_modules/@@/features/alias': [Object],
      './node_modules/@@/features/analyze': [Object],
      './node_modules/@@/features/autoprefixer': [Object],
      './node_modules/@@/features/base': [Object],
      './node_modules/@@/features/chainWebpack': [Object],
      './node_modules/@@/features/chunks': [Object],
      './node_modules/@@/features/cssLoader': [Object],
      './node_modules/@@/features/cssModulesTypescriptLoader': [Object],
      './node_modules/@@/features/cssnano': [Object],
      './node_modules/@@/features/copy': [Object],
      './node_modules/@@/features/define': [Object],
      './node_modules/@@/features/devScripts': [Object],
      './node_modules/@@/features/devServer': [Object],
      './node_modules/@@/features/devtool': [Object],
      './node_modules/@@/features/dynamicImport': [Object],
      './node_modules/@@/features/exportStatic': [Object],
      './node_modules/@@/features/externals': [Object],
      './node_modules/@@/features/extraBabelIncludes': [Object],
      './node_modules/@@/features/extraBabelPlugins': [Object],
      './node_modules/@@/features/extraBabelPresets': [Object],
      './node_modules/@@/features/extraPostCSSPlugins': [Object],
      './node_modules/@@/features/forkTSChecker': [Object],
      './node_modules/@@/features/fastRefresh': [Object],
      './node_modules/@@/features/globalCSS': [Object],
      './node_modules/@@/features/globalJS': [Object],
      './node_modules/@@/features/hash': [Object],
      './node_modules/@@/features/ignoreMomentLocale': [Object],
      './node_modules/@@/features/inlineLimit': [Object],
      './node_modules/@@/features/lessLoader': [Object],
      './node_modules/@@/features/manifest': [Object],
      './node_modules/@@/features/mountElementId': [Object],
      './node_modules/@@/features/mpa': [Object],
      './node_modules/@@/features/nodeModulesTransform': [Object],
      './node_modules/@@/features/outputPath': [Object],
      './node_modules/@@/features/plugins': [Object],
      './node_modules/@@/features/postcssLoader': [Object],
      './node_modules/@@/features/presets': [Object],
      './node_modules/@@/features/proxy': [Object],
      './node_modules/@@/features/publicPath': [Object],
      './node_modules/@@/features/runtimePublicPath': [Object],
      './node_modules/@@/features/ssr/ssr': [Object],
      './node_modules/@@/features/singular': [Object],
      './node_modules/@@/features/styleLoader': [Object],
      './node_modules/@@/features/targets': [Object],
      './node_modules/@@/features/terserOptions': [Object],
      './node_modules/@@/features/theme': [Object],
      './node_modules/@@/features/umiInfo': [Object],
      './node_modules/@@/features/runtimeHistory': [Object],
      './node_modules/@@/features/html/favicon': [Object],
      './node_modules/@@/features/html/headScripts': [Object],
      './node_modules/@@/features/html/links': [Object],
      './node_modules/@@/features/html/metas': [Object],
      './node_modules/@@/features/html/scripts': [Object],
      './node_modules/@@/features/html/styles': [Object],
      './node_modules/@@/features/html/title': [Object],
      './node_modules/@@/commands/build/build': [Object],
      './node_modules/@@/commands/build/applyHtmlWebpackPlugin': [Object],
      './node_modules/@@/commands/config/config': [Object],
      './node_modules/@@/commands/dev/dev': [Object],
      './node_modules/@@/commands/dev/devCompileDone/devCompileDone': [Object],
      './node_modules/@@/commands/dev/mock/mock': [Object],
      './node_modules/@@/commands/generate/generate': [Object],
      './node_modules/@@/commands/help/help': [Object],
      './node_modules/@@/commands/plugin/plugin': [Object],
      './node_modules/@@/commands/version/version': [Object],
      './node_modules/@@/commands/webpack/webpack': [Object],
      './node_modules/umi/lib/plugins/umiAlias': [Object],
      '@umijs/plugin-access': [Object],
      '@umijs/plugin-antd': [Object],
      '@umijs/plugin-crossorigin': [Object],
      '@umijs/plugin-dva': [Object],
      '@umijs/plugin-helmet': [Object],
      '@umijs/plugin-initial-state': [Object],
      '@umijs/plugin-layout': [Object],
      '@umijs/plugin-locale': [Object],
      '@umijs/plugin-model': [Object],
      '@umijs/plugin-request': [Object],
      '@umijs/plugin-sass': [Object]
    },

    hooks: {
      onGenerateFiles: [Array],
      addUmiExports: [Array],
      addPolyfillImports: [Array],
      chainWebpack: [Array],
      addDepInfo: [Array],
      addBeforeMiddewares: [Array],
      addHTMLHeadScripts: [Array],
      addEntryImportsAhead: [Array],
      modifyConfig: [Array],
      onPatchRoute: [Array],
      onPatchRoutes: [Array],
      modifyExportRouteMap: [Array],
      modifyProdHTMLContent: [Array],
      onBuildComplete: [Array],
      modifyBabelOpts: [Array],
      addEntryCodeAhead: [Array],
      modifyRendererPath: [Array],
      modifyDefaultConfig: [Array],
      modifyHTML: [Array],
      onStart: [Array],
      modifyBundleConfigs: [Array],
      modifyHTMLChunks: [Array],
      modifyDevHTMLContent: [Array],
      addRuntimePluginKey: [Array],
      addEntryCode: [Array],
      addHTMLLinks: [Array],
      addHTMLMetas: [Array],
      addHTMLScripts: [Array],
      addHTMLStyles: [Array],
      modifyBundleConfig: [Array],
      onDevCompileDone: [Array],
      addRuntimePlugin: [Array],
      addTmpGenerateWatcherPaths: [Array],
      modifyBabelPresetOpts: [Array],
      addProjectFirstLibraries: [Array],
      addExtraModels: [Array],
      modifyRoutes: [Array]
    },

    hooksByPluginId: {
      './node_modules/@@/generateFiles/core/history': [Array],
      './node_modules/@@/generateFiles/core/plugin': [Array],
      './node_modules/@@/generateFiles/core/polyfill': [Array],
      './node_modules/@@/generateFiles/core/routes': [Array],
      './node_modules/@@/generateFiles/core/umiExports': [Array],
      './node_modules/@@/generateFiles/core/configTypes': [Array],
      './node_modules/@@/generateFiles/umi': [Array],
      './node_modules/@@/features/alias': [Array],
      './node_modules/@@/features/analyze': [Array],
      './node_modules/@@/features/devScripts': [Array],
      './node_modules/@@/features/exportStatic': [Array],
      './node_modules/@@/features/forkTSChecker': [Array],
      './node_modules/@@/features/fastRefresh': [Array],
      './node_modules/@@/features/globalCSS': [Array],
      './node_modules/@@/features/globalJS': [Array],
      './node_modules/@@/features/mpa': [Array],
      './node_modules/@@/features/ssr/ssr': [Array],
      './node_modules/@@/features/umiInfo': [Array],
      './node_modules/@@/features/html/favicon': [Array],
      './node_modules/@@/features/html/headScripts': [Array],
      './node_modules/@@/features/html/links': [Array],
      './node_modules/@@/features/html/metas': [Array],
      './node_modules/@@/features/html/scripts': [Array],
      './node_modules/@@/features/html/styles': [Array],
      './node_modules/@@/features/html/title': [Array],
      './node_modules/@@/commands/build/applyHtmlWebpackPlugin': [Array],
      './node_modules/@@/commands/dev/dev': [Array],
      './node_modules/@@/commands/dev/devCompileDone/devCompileDone': [Array],
      './node_modules/@@/commands/dev/mock/mock': [Array],
      './node_modules/umi/lib/plugins/umiAlias': [Array],
      '@umijs/plugin-access': [Array],
      '@umijs/plugin-antd': [Array],
      '@umijs/plugin-dva': [Array],
      '@umijs/plugin-helmet': [Array],
      '@umijs/plugin-initial-state': [Array],
      '@umijs/plugin-layout': [Array],
      '@umijs/plugin-locale': [Array],
      '@umijs/plugin-model': [Array],
      '@umijs/plugin-request': [Array],
      '@umijs/plugin-sass': [Array]
    },
    
    */
//#endregion

// function createImports(componentsMapping) {
//     if (Array.isArray(componentsMapping) && componentsMapping.length) {
//         let importArray = componentsMapping.map(component => {
//             let componentPath = component.path;
//             if (componentPath.startsWith('@')) {
//                 // TODO 这里兼容下@@写法
//                 componentPath = componentPath.replace(/^@/, '../../..');
//             }
//             return `import ${component.name} from '${componentPath}';`;
//         });
//         return importArray.join('');
//     } else {
//         return '';
//     }
// }
// function createVarDefine(componentsMapping) {
//     if (Array.isArray(componentsMapping) && componentsMapping.length) {
//         let compnentNameArray = componentsMapping.map(component => component.name);
//         return `{${compnentNameArray.join(',')}}`;
//     } else {
//         return '';
//     }
// }

function convertToRoute(componentsMapping) {
  if (!componentsMapping) {
    return [];
  }
  return componentsMapping.map(component => {
    return {
      path: '---',
      component: component.path,
      name: component.name
    };
  });
}
function jsonStrigify(options) {
  if (!options) {
    return '{}';
  }
  return JSON.stringify(options, function (key, value) {
    if (typeof value === 'function') {
      return value + '';
    }
    return value;
  });
}