"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fieldComponentMapping = exports.GetFieldComponet = void 0;
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var QuestionCircleOutlined_1 = tslib_1.__importDefault(require("@ant-design/icons/QuestionCircleOutlined"));
var tooltip_1 = tslib_1.__importDefault(require("udesk-ui/es/tooltip"));
var form_1 = tslib_1.__importDefault(require("udesk-ui/es/form"));
var classnames_1 = tslib_1.__importDefault(require("classnames"));
var field_type_component_1 = tslib_1.__importDefault(require("./field-type-component"));
exports.GetFieldComponet = field_type_component_1.default;
var field_mapping_1 = tslib_1.__importDefault(require("./field-mapping"));
var index_module_scss_1 = tslib_1.__importDefault(require("./index.module.scss"));
// TODO 提成enums
var valueChangeFieldTypes = ['link', 'location', 'number', 'numeric', 'textarea', 'text'];
var CustomFieldItem = function (_a) {
    var fieldItem = _a.fieldItem, isFormItem = _a.isFormItem, agents = _a.agents, _b = _a.switchFlag, switchFlag = _b === void 0 ? false : _b, labelCol = _a.labelCol, wrapperCol = _a.wrapperCol, onValueChange = _a.onValueChange, props = tslib_1.__rest(_a, ["fieldItem", "isFormItem", "agents", "switchFlag", "labelCol", "wrapperCol", "onValueChange"]);
    var showLabel = fieldItem.showLabel, itemLabelCol = fieldItem.labelCol, itemWrapperCol = fieldItem.wrapperCol, _c = fieldItem.mode, mode = _c === void 0 ? 'edit' : _c, itemClassName = fieldItem.itemClassName;
    var _d = (0, react_1.useState)(fieldItem.value), oldValue = _d[0], setOldValue = _d[1]; // 存储历史数据,用来判断onblur时值是否变化
    var fromLabel = function () { return (showLabel ?
        (react_1.default.createElement("div", { className: (0, classnames_1.default)('item-label', index_module_scss_1.default['item-label']) },
            fieldItem.isRequired && react_1.default.createElement("span", { style: { color: 'red' } }, "*"),
            react_1.default.createElement("span", { style: { marginRight: '5px' } },
                fieldItem.label,
                fieldItem.colon ? ':' : '',
                react_1.default.createElement("span", { className: "sub-title", dangerouslySetInnerHTML: { __html: fieldItem.subTitle || '' } })),
            fieldItem.layout !== 'horizontal' && fieldItem.tooltipShow && fieldItem.tooltip && (react_1.default.createElement(tooltip_1.default, { title: fieldItem.tooltip },
                react_1.default.createElement(QuestionCircleOutlined_1.default, null))))) : ''); };
    (0, react_1.useEffect)(function () {
        setOldValue(fieldItem.value);
    }, [fieldItem.value]);
    var onValueChanged = (0, react_1.useCallback)(function (value, field) {
        if (props && typeof onValueChange === 'function') {
            onValueChange(value, fieldItem);
        }
    }, [onValueChange]);
    var onChange = (0, react_1.useCallback)(function (value) {
        if (props && typeof props.onChange === 'function') {
            props.onChange(value, fieldItem);
        }
        if (!valueChangeFieldTypes.includes(fieldItem.type)) {
            onValueChanged(value, fieldItem);
        }
    }, [fieldItem]);
    var onBlur = (0, react_1.useCallback)(function (value) {
        if (props && typeof props.onBlur === 'function') {
            props.onBlur(value, fieldItem);
        }
        if (valueChangeFieldTypes.includes(fieldItem.type)) {
            if (value !== oldValue) {
                setOldValue(value);
                onValueChanged(value, fieldItem);
            }
        }
    }, [fieldItem, oldValue]);
    return (react_1.default.createElement(react_1.default.Fragment, null, field_mapping_1.default[fieldItem.type] ?
        isFormItem ? (react_1.default.createElement(form_1.default.Item, tslib_1.__assign({}, props, { className: itemClassName, label: fromLabel(), labelCol: itemLabelCol || labelCol, wrapperCol: itemWrapperCol || wrapperCol, name: fieldItem.id, colon: false, trigger: fieldItem.trigger || 'onChange', rules: typeof fieldItem.customValidFn === 'function' ? [
                {
                    validator: fieldItem.customValidFn
                }
            ] : undefined }), react_1.default.createElement(field_type_component_1.default, tslib_1.__assign({ onChange: onChange, onBlur: onBlur, switchFlag: switchFlag, agents: agents }, fieldItem, { isFormItem: isFormItem, notUseDefault: props.notUseDefault, mode: mode })))) : (react_1.default.createElement("div", { className: "".concat(itemClassName, " ").concat(fieldItem.layout === 'horizontal' ? index_module_scss_1.default['field-item-horizontal'] : index_module_scss_1.default['field-item']) },
            fromLabel(),
            react_1.default.createElement("div", { className: index_module_scss_1.default['item-content'] }, react_1.default.createElement(field_type_component_1.default, tslib_1.__assign({ onChange: onChange, onBlur: onBlur, switchFlag: switchFlag, agents: agents }, fieldItem, { isFormItem: false, mode: mode })))))
        : null));
};
exports.default = CustomFieldItem;
exports.fieldComponentMapping = field_mapping_1.default;
