import { __assign, __rest } from "tslib";
import React, { useEffect, useMemo, useState } from 'react';
import i18n, { useTranslation } from '@udesk-webapp/locale';
import { ajax, PATH_BASE } from '@udesk-webapp/utils';
import { TicketContext } from '@udesk-webapp/ticket-signature/es/utilities';
import CreateTicket from '@udesk-webapp/create-ticket';
import CreateCustomer from '@udesk-webapp/create-customer';
import CreateOrg from '@udesk-webapp/create-org';
// use out lang,TODO add lang api
// import i18n from './i18n';
import style from './index.module.scss';
// eslint-disable-next-line no-shadow
var PageTypeEnums;
(function (PageTypeEnums) {
    PageTypeEnums["Ticket"] = "ticket";
    PageTypeEnums["Customer"] = "customer";
    PageTypeEnums["Organization"] = "organization";
})(PageTypeEnums || (PageTypeEnums = {}));
var langHas = {
    'en-us': 'en',
    'zh-cn': 'zh'
};
function CreateTicketIndex(_a) {
    var _b, _c, _d, _e;
    var onCreateSuccess = _a.onCreateSuccess, agents = _a.agents, props = __rest(_a, ["onCreateSuccess", "agents"]);
    var _f = useState([]), agent = _f[0], setAgent = _f[1];
    useEffect(function () {
        i18n === null || i18n === void 0 ? void 0 : i18n.changeLanguage(props.lang ? (langHas[props.lang] || langHas['zh-cn']) : langHas['zh-cn']);
    }, []);
    useEffect(function () {
        ajax().getJSON("".concat(PATH_BASE, "/user_groups/list_with_agents_status")).then(function (res) {
            var options = res.user_groups.map(function (item) { return ({
                label: res.ticket_setting_is_open ? "".concat(item.name, "  (").concat(res.ticket_setting_online_title, " ").concat(item.agents_availability_count, "/").concat(item.agents_count, ")") : item.name,
                value: item.id,
                agents_availability_count: item.agents_availability_count,
                agents_count: item.agents_count,
                children: item.agents.map(function (_item) { return ({
                    label: res.ticket_setting_is_open ? "".concat(_item.nick_name, "  (").concat(_item.availability ? res.ticket_setting_online_title : res.ticket_setting_offline_title, ")") : _item.nick_name,
                    value: _item.id,
                    availability: _item.availability
                }); })
            }); });
            setAgent(options);
        });
    }, []);
    var t = useTranslation().t;
    var _g = useState('ticket'), pageType = _g[0], setPageType = _g[1]; // 页面类型  用于切换界面   ticket 新建工单  customer 新建客户 org 新建公司
    var _h = useState(''), agentGroup = _h[0], setAgentGroup = _h[1]; // 负责组   新增用户中的负责组 组件中改变 负责组选择  改变该值  在 负责人组件中 使用
    var _j = useState({
        value: (_b = props === null || props === void 0 ? void 0 : props.chat) === null || _b === void 0 ? void 0 : _b.customer_id,
        label: (_c = props === null || props === void 0 ? void 0 : props.chat) === null || _c === void 0 ? void 0 : _c.nick_name
    }), customer = _j[0], setCustomer = _j[1];
    var _k = useState({}), organization = _k[0], setOrganization = _k[1];
    // 根据pagetype不一样 改变头部标题
    var header;
    if (pageType === PageTypeEnums.Ticket) {
        header = t('page.im.ticket.createTicket');
    }
    else if (pageType === PageTypeEnums.Customer) {
        header = t('page.im.ticket.createCustomer');
    }
    else {
        header = t('page.im.ticket.createOrg');
    }
    var contextContent = useMemo(function () { return ({
        changePageType: function (type) { return setPageType(type); },
        agentGroup: agentGroup,
        changeAgentGroup: function (type) { return setAgentGroup(type); },
        customer: customer,
        changeCustomer: function (newCustomer) {
            var _a, _b;
            // TODO:因为create_ticket被销毁,无法调用内部方法
            // 在这里操作storage不合适
            // 临时这样处理,后面用ts_react项目的新建工单替换后,改组件可删除
            var updateValue = newCustomer ? {
                customer_id: __assign({}, newCustomer)
            } : {};
            var stashKey = "".concat((_a = props.currentUser) === null || _a === void 0 ? void 0 : _a.id, "-ticket-form-stash-at-email-im-message-").concat((_b = props.chat) === null || _b === void 0 ? void 0 : _b.im_sub_session_id);
            updateCreateTicketStorage(stashKey, updateValue);
            setCustomer(newCustomer);
        },
        organization: organization,
        changeOrganization: function (object) { return setOrganization(object); },
        agent: agent
    }); }, [agent, agentGroup, customer, organization, (_d = props.chat) === null || _d === void 0 ? void 0 : _d.im_sub_session_id, (_e = props.currentUser) === null || _e === void 0 ? void 0 : _e.id]);
    var content = useMemo(function () {
        switch (pageType) {
            case 'ticket':
                return React.createElement(CreateTicket, __assign({ setShowTicket: props.setShowTicket, onSaveSuccess: onCreateSuccess, customer: customer }, props));
            case 'customer':
                return React.createElement(CreateCustomer, __assign({ agents: agents }, props));
            default:
                return React.createElement(CreateOrg, __assign({}, props));
        }
    }, [pageType, props]);
    return (React.createElement("div", { className: style['ticket-wrapper'] },
        React.createElement("div", { className: style['ticket-header'] }, header),
        React.createElement(TicketContext.Provider, { value: contextContent }, content)));
}
function updateCreateTicketStorage(stashKey, updateValue) {
    var localStorageData = localStorage.getItem(stashKey);
    localStorageData && (localStorageData = JSON.parse(localStorageData));
    if (localStorageData === null || localStorageData === void 0 ? void 0 : localStorageData.createTicketFormData) {
        localStorageData.createTicketFormData = __assign(__assign({}, localStorageData === null || localStorageData === void 0 ? void 0 : localStorageData.createTicketFormData), updateValue);
        localStorage.setItem(stashKey, JSON.stringify(localStorageData));
    }
}
export default CreateTicketIndex;
