"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _react = _interopRequireWildcard(require("react"));

var _filter = _interopRequireDefault(require("lodash-es/filter"));

var _forEach = _interopRequireDefault(require("lodash-es/forEach"));

var _isEmpty = _interopRequireDefault(require("lodash-es/isEmpty"));

var _map = _interopRequireDefault(require("lodash-es/map"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var labelStyle = {
  display: 'inline-block',
  padding: '0 15px',
  width: '165px',
  whiteSpace: 'nowrap',
  textOverflow: 'ellipsis',
  overflow: 'hidden'
};
/**
 * @property {array<object>} columns - 将要显示的内容
 * @property {number} cols - 内容显示为几列
 */

var ColumnControl = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(ColumnControl, _Component);

  function ColumnControl(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {
      keyword: ''
    };
    return _this;
  }
  /**
   * 恢复默认
   * @returns {null|*}
   */


  var _proto = ColumnControl.prototype;

  _proto.renderRecoverDefault = function renderRecoverDefault() {
    var _this$props = this.props,
        showRecoverDefault = _this$props.showRecoverDefault,
        classNameOfRecoverDefaultWrapper = _this$props.classNameOfRecoverDefaultWrapper,
        styleOfRecoverDefaultWrapper = _this$props.styleOfRecoverDefaultWrapper,
        onRecoverDefaultClick = _this$props.onRecoverDefaultClick,
        t = _this$props.t;

    if (showRecoverDefault) {
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: classNameOfRecoverDefaultWrapper,
        style: styleOfRecoverDefaultWrapper
      }, /*#__PURE__*/_react["default"].createElement("a", {
        href: "javascript:",
        className: "link",
        onClick: onRecoverDefaultClick
      }, t('label.recover_default')));
    }

    return null;
  };

  /**
   * 搜索框
   * @returns {null|*}
   */
  _proto.renderSearch = function renderSearch() {
    var _this2 = this;

    var keyword = this.state.keyword;
    var _this$props2 = this.props,
        showSearch = _this$props2.showSearch,
        classNameOfSearchInputWrapper = _this$props2.classNameOfSearchInputWrapper,
        styleOfSearchInputWrapper = _this$props2.styleOfSearchInputWrapper,
        classNameOfSearchInput = _this$props2.classNameOfSearchInput,
        styleOfSearchInput = _this$props2.styleOfSearchInput,
        searchPlaceholder = _this$props2.searchPlaceholder,
        classNameOfSearchInputIcon = _this$props2.classNameOfSearchInputIcon,
        styleOfSearchInputIcon = _this$props2.styleOfSearchInputIcon;

    if (showSearch) {
      return /*#__PURE__*/_react["default"].createElement("div", {
        className: classNameOfSearchInputWrapper,
        style: styleOfSearchInputWrapper
      }, /*#__PURE__*/_react["default"].createElement("input", {
        className: classNameOfSearchInput,
        style: styleOfSearchInput,
        value: keyword,
        onChange: function onChange(e) {
          return _this2.setState({
            keyword: e.target.value
          });
        },
        placeholder: searchPlaceholder
      }), /*#__PURE__*/_react["default"].createElement("span", {
        className: classNameOfSearchInputIcon,
        style: styleOfSearchInputIcon
      }));
    }

    return null;
  };

  _proto.render = function render() {
    var _this3 = this;

    var categories = this.determineCategories();
    var _this$props3 = this.props,
        columns = _this$props3.columns,
        _this$props3$cols = _this$props3.cols,
        cols = _this$props3$cols === void 0 ? 1 : _this$props3$cols,
        style = _this$props3.style,
        className = _this$props3.className,
        _this$props3$t = _this$props3.t,
        t = _this$props3$t === void 0 ? function (v) {
      return v;
    } : _this$props3$t,
        classNameOfColumnsWrapper = _this$props3.classNameOfColumnsWrapper,
        styleOfColumnsWrapper = _this$props3.styleOfColumnsWrapper;

    if (!style) {
      style = {};
    }

    if (!style.boxSizing) {
      style.boxSizing = 'content-box';
    }

    if (!style.width) {
      style.width = cols * 165 + "px";
    }

    return /*#__PURE__*/_react["default"].createElement("div", {
      style: style,
      className: className
    }, this.renderSearch(), this.renderRecoverDefault(), /*#__PURE__*/_react["default"].createElement("div", {
      className: classNameOfColumnsWrapper,
      style: styleOfColumnsWrapper
    }, (0, _isEmpty["default"])(categories) ? this.renderColumns(columns, cols) : (0, _map["default"])(categories, function (category) {
      return /*#__PURE__*/_react["default"].createElement("div", {
        key: category
      }, /*#__PURE__*/_react["default"].createElement("h5", null, t(category)), _this3.renderColumns((0, _filter["default"])(columns, ['category', category]), cols));
    })));
  }
  /**
   * @param {array} columns
   * @param {number} cols
   */
  ;

  _proto.renderColumns = function renderColumns(columns, cols) {
    var _this4 = this;

    var _this$props$t = this.props.t,
        t = _this$props$t === void 0 ? function (v) {
      return v;
    } : _this$props$t;
    var keyword = this.state.keyword;
    return /*#__PURE__*/_react["default"].createElement("div", null, (0, _map["default"])(columns, function (item) {
      var title;

      if (!item.name) {
        title = t(item.id);
      } else if (typeof item.name === 'string') {
        title = item.name;
      }

      if (keyword && title.indexOf(keyword) === -1) {
        return null;
      }

      return /*#__PURE__*/_react["default"].createElement("label", {
        key: item.id,
        style: labelStyle,
        title: title
      }, /*#__PURE__*/_react["default"].createElement("input", {
        type: "checkbox",
        checked: item.display,
        style: {
          marginRight: '5px'
        },
        onChange: function onChange(e) {
          return _this4._onChange(item, e);
        }
      }), item.name || t(item.id));
    }));
  };

  _proto.determineCategories = function determineCategories() {
    var categories = [];
    (0, _forEach["default"])(this.props.columns, function (item) {
      if (item.category && categories.indexOf(item.category) === -1) {
        categories.push(item.category);
      }
    });
    return categories;
  };

  _proto._onChange = function _onChange(column, e) {
    this.props.onChange(column, e.target.checked);
  };

  return ColumnControl;
}(_react.Component); //@formatter:off


exports["default"] = ColumnControl;
ColumnControl.propTypes = {
  /**
   * 哪些列将受到控制
   * category属性请使用国际化key值
   * @example
   * [
   *  {id:'name', display:true, category:'label.person'},
   *  {id:'age',  display:true, category:'label.person'}
   * ]
   */
  columns: _propTypes["default"].arrayOf(_propTypes["default"].shape({
    id: _propTypes["default"].string.isRequired,
    display: _propTypes["default"].bool,
    category: _propTypes["default"].string,
    name: _propTypes["default"].oneOfType([_propTypes["default"].string, _propTypes["default"].node])
  })).isRequired,
  //显示为几列
  cols: _propTypes["default"].number,
  style: _propTypes["default"].object,
  className: _propTypes["default"].string,
  onChange: _propTypes["default"].func,
  t: _propTypes["default"].func,
  showSearch: _propTypes["default"].bool,
  classNameOfSearchInput: _propTypes["default"].string,
  classNameOfSearchInputWrapper: _propTypes["default"].string,
  classNameOfSearchInputIcon: _propTypes["default"].string,
  classNameOfRecoverDefaultWrapper: _propTypes["default"].string,
  classNameOfColumnsWrapper: _propTypes["default"].string,
  showRecoverDefault: _propTypes["default"].bool,
  onRecoverDefaultClick: _propTypes["default"].func,
  styleOfSearchInput: _propTypes["default"].object,
  styleOfSearchInputWrapper: _propTypes["default"].object,
  styleOfSearchInputIcon: _propTypes["default"].object,
  styleOfRecoverDefaultWrapper: _propTypes["default"].object,
  styleOfColumnsWrapper: _propTypes["default"].object,
  searchPlaceholder: _propTypes["default"].string
}; //@formatter:on

ColumnControl.defaultProps = {
  classNameOfSearchInput: 'form-control input-sm',
  classNameOfSearchInputWrapper: 'form-group has-feedback',
  classNameOfSearchInputIcon: 'icon icon-search form-control-feedback text-muted',
  classNameOfRecoverDefaultWrapper: 'recover-default-wrapper',
  classNameOfColumnsWrapper: 'columns-wrapper',
  className: '',
  styleOfSearchInput: {},
  styleOfSearchInputWrapper: {},
  styleOfSearchInputIcon: {},
  styleOfRecoverDefaultWrapper: {
    padding: '0 15px 10px'
  },
  styleOfColumnsWrapper: {
    height: '270px',
    overflowY: 'auto'
  },
  searchPlaceholder: null
};