"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports["default"] = void 0;

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _react = _interopRequireWildcard(require("react"));

var _reactPopper = require("react-popper");

var _columnControl = _interopRequireDefault(require("@udesk-webapp/column-control"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _assign = _interopRequireDefault(require("lodash-es/assign"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var ColumnControlPopover = /*#__PURE__*/function (_Component) {
  (0, _inheritsLoose2["default"])(ColumnControlPopover, _Component);

  function ColumnControlPopover(props) {
    var _this;

    _this = _Component.call(this, props) || this;
    _this.state = {
      isOpen: false
    };
    _this._ref = /*#__PURE__*/_react["default"].createRef();
    _this._doNotClosePopover = false;
    return _this;
  }

  var _proto = ColumnControlPopover.prototype;

  _proto.render = function render() {
    var _this2 = this;

    var managerClassNames = ['dropdown'];

    if (this.state.isOpen) {
      managerClassNames.push('open');
    }

    var _this$props = this.props,
        columns = _this$props.columns,
        _this$props$cols = _this$props.cols,
        cols = _this$props$cols === void 0 ? 1 : _this$props$cols,
        t = _this$props.t,
        onChange = _this$props.onChange,
        _this$props$className = _this$props.className,
        className = _this$props$className === void 0 ? '' : _this$props$className,
        showSearch = _this$props.showSearch,
        classNameOfSearchInput = _this$props.classNameOfSearchInput,
        classNameOfSearchInputWrapper = _this$props.classNameOfSearchInputWrapper,
        classNameOfSearchInputIcon = _this$props.classNameOfSearchInputIcon,
        classNameOfRecoverDefaultWrapper = _this$props.classNameOfRecoverDefaultWrapper,
        classNameOfColumnsWrapper = _this$props.classNameOfColumnsWrapper,
        showRecoverDefault = _this$props.showRecoverDefault,
        onRecoverDefaultClick = _this$props.onRecoverDefaultClick,
        styleOfColumnsWrapper = _this$props.styleOfColumnsWrapper,
        searchPlaceholder = _this$props.searchPlaceholder;
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: managerClassNames.join(' ') + ' ' + className,
      ref: this._ref
    }, /*#__PURE__*/_react["default"].createElement(_reactPopper.Manager, null, /*#__PURE__*/_react["default"].createElement(_reactPopper.Reference, null, function (_ref) {
      var ref = _ref.ref;
      return (
        /*#__PURE__*/
        //@formatter:off
        _react["default"].createElement("button", {
          type: "button",
          className: "btn btn-default",
          ref: ref,
          onClick: function onClick() {
            return _this2._toggle();
          }
        }, t('label.column'), " ", /*#__PURE__*/_react["default"].createElement("i", {
          className: "icon icon-caret-down"
        })) //@formatter:on

      );
    }), this.state.isOpen && /*#__PURE__*/_react["default"].createElement(_reactPopper.Popper, {
      placement: "bottom-end"
    }, function (_ref2) {
      var ref = _ref2.ref,
          style = _ref2.style,
          placement = _ref2.placement;
      return /*#__PURE__*/_react["default"].createElement("div", {
        ref: ref,
        style: (0, _assign["default"])({
          zIndex: 1000000
        }, style),
        "data-placement": placement
      }, /*#__PURE__*/_react["default"].createElement(_columnControl["default"], {
        style: {
          backgroundColor: '#fff',
          border: '1px solid #e1e1e1',
          width: cols * 165 + 20
        },
        columns: columns,
        cols: cols,
        onChange: onChange,
        t: t,
        showSearch: showSearch,
        classNameOfSearchInput: classNameOfSearchInput,
        classNameOfSearchInputWrapper: classNameOfSearchInputWrapper,
        classNameOfSearchInputIcon: classNameOfSearchInputIcon,
        classNameOfRecoverDefaultWrapper: classNameOfRecoverDefaultWrapper,
        classNameOfColumnsWrapper: classNameOfColumnsWrapper,
        showRecoverDefault: showRecoverDefault,
        onRecoverDefaultClick: onRecoverDefaultClick,
        styleOfColumnsWrapper: styleOfColumnsWrapper,
        searchPlaceholder: searchPlaceholder
      }));
    })));
  };

  _proto.componentDidMount = function componentDidMount() {
    var _this3 = this;

    this._ref.current.addEventListener('click', function () {
      _this3._doNotClosePopover = true;
    });

    document.addEventListener('click', this._bodyEvent = function () {
      if (_this3._doNotClosePopover) {
        _this3._doNotClosePopover = false;
        return;
      }

      _this3._close();
    });
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    document.removeEventListener('click', this._bodyEvent);
  };

  _proto._close = function _close() {
    if (this.state.isOpen) {
      var onClose = this.props.onClose;
      onClose && onClose();
      this.setState({
        isOpen: false
      });
    }
  };

  _proto._open = function _open() {
    var onOpen = this.props.onOpen;
    onOpen && onOpen();
    this.setState({
      isOpen: true
    });
  };

  _proto._toggle = function _toggle() {
    if (this.state.isOpen) {
      this._close();
    } else {
      this._open();
    }
  };

  return ColumnControlPopover;
}(_react.Component);

ColumnControlPopover.propTypes = {
  columns: _propTypes["default"].array,
  cols: _propTypes["default"].number,
  onChange: _propTypes["default"].func,
  className: _propTypes["default"].string,
  t: _propTypes["default"].func,
  showSearch: _propTypes["default"].bool,
  classNameOfSearchInput: _propTypes["default"].string,
  classNameOfSearchInputWrapper: _propTypes["default"].string,
  classNameOfSearchInputIcon: _propTypes["default"].string,
  classNameOfRecoverDefaultWrapper: _propTypes["default"].string,
  classNameOfColumnsWrapper: _propTypes["default"].string,
  showRecoverDefault: _propTypes["default"].bool,
  onRecoverDefaultClick: _propTypes["default"].func,
  styleOfColumnsWrapper: _propTypes["default"].object,
  onOpen: _propTypes["default"].func,
  onClose: _propTypes["default"].func,
  searchPlaceholder: _propTypes["default"].string
};
var _default = ColumnControlPopover;
exports["default"] = _default;