"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
// @ts-nocheck
var react_1 = tslib_1.__importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var icons_1 = require("@ant-design/icons");
var pro_form_1 = require("@ant-design/pro-form");
var locale_1 = require("@udesk-webapp/locale");
var ant_local_plugin_1 = tslib_1.__importDefault(require("./ant-local-plugin"));
var custom_form_components_1 = require("@udesk-webapp/custom-form-components");
require("./index.module.scss");
var pro_provider_1 = tslib_1.__importDefault(require("@ant-design/pro-provider"));
var utils_1 = require("@udesk-webapp/utils");
var LAYOUT_TYPE_HORIZONTAL = 'horizontal';
var LAYOUT_TYPE_VERTICAL = 'vertical';
var LAYOUT_TYPE_INLINE = 'inline';
var InputType;
(function (InputType) {
    InputType["Content"] = "content";
    InputType["FormCascader"] = "formCascader";
    InputType["FormCheckbox"] = "formCheckbox";
    InputType["FormDatePicker"] = "formDatePicker";
    InputType["FormLocation"] = "formLocation";
    InputType["FormMultipleSelect"] = "formMultipleSelect";
    InputType["FormNumber"] = "formNumber";
    InputType["FormRadio"] = "formRadio";
    InputType["FormRange"] = "formRange";
    InputType["FormRangePicker"] = "formRangePicker";
    InputType["FormSelect"] = "formSelect";
    InputType["FormSelectInput"] = "formSelectInput";
    InputType["FormText"] = "formText";
    InputType["FormLink"] = "formLink";
    InputType["FormTextArea"] = "formTextArea";
    InputType["FormTimePicker"] = "formTimePicker";
    InputType["FormTreeSelect"] = "formTreeSelect";
    InputType["Upload"] = "upload";
})(InputType || (InputType = {}));
var CustomForm = react_1.default.memo(function (props) {
    var columns = props.columns, _a = props.valueTypes, valueTypes = _a === void 0 ? {} : _a, _b = props.layoutType, layoutType = _b === void 0 ? 'Form' : _b, _c = props.formLayout, formLayout = _c === void 0 ? LAYOUT_TYPE_VERTICAL : _c, _d = props.hiddenResetButton, hiddenResetButton = _d === void 0 ? false : _d, _e = props.hiddenSubmitButton, hiddenSubmitButton = _e === void 0 ? false : _e, modalProps = props.modalProps, _f = props.submitBtnText, submitBtnText = _f === void 0 ? '' : _f, _g = props.cancelBtnText, cancelBtnText = _g === void 0 ? '' : _g, _h = props.language, language = _h === void 0 ? '' : _h, loading = props.loading, _j = props.isModalScroll, isModalScroll = _j === void 0 ? false : _j, submitBtnType = props.submitBtnType, zIndex = props.zIndex, _k = props.maskClosable, maskClosable = _k === void 0 ? false : _k, destroyOnClose = props.destroyOnClose, visible = props.visible, afterSubmitter = props.afterSubmitter, beforeSubmitter = props.beforeSubmitter, onCancel = props.onCancel, onValuesChange = props.onValuesChange, onValuesBlur = props.onValuesBlur, submitterRender = props.submitterRender, collapseRender = props.collapseRender, restProps = tslib_1.__rest(props, ["columns", "valueTypes", "layoutType", "formLayout", "hiddenResetButton", "hiddenSubmitButton", "modalProps", "submitBtnText", "cancelBtnText", "language", "loading", "isModalScroll", "submitBtnType", "zIndex", "maskClosable", "destroyOnClose", "visible", "afterSubmitter", "beforeSubmitter", "onCancel", "onValuesChange", "onValuesBlur", "submitterRender", "collapseRender"]);
    var values = (0, react_1.useContext)(pro_provider_1.default);
    var _l = (0, locale_1.useTranslation)(), formatMessage = _l.t, i18n = _l.i18n; // 多语言
    (0, react_1.useEffect)(function () {
        // 尝试给antD pro 插入缺失的多语言
        (0, ant_local_plugin_1.default)(language);
        i18n.changeLanguage(language);
    }, [language]);
    var getFormItem = (0, react_1.useCallback)(function (text, props, type) {
        var itemDom = react_1.default.createElement("div", null);
        var _a = props.fieldProps, fieldProps = _a === void 0 ? {} : _a;
        var _b = fieldProps.copyProps, copyProps = _b === void 0 ? {} : _b;
        if (layoutType === 'LightFilter' || layoutType === 'QueryFilter') {
            copyProps.switchFlag = false;
        }
        switch (type) {
            case InputType.FormText:
                itemDom = react_1.default.createElement(custom_form_components_1.FormText, tslib_1.__assign({ onValueBlur: onValuesBlur }, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps }));
                break;
            case InputType.FormLink:
                itemDom = react_1.default.createElement(custom_form_components_1.FormLink, tslib_1.__assign({ onValueBlur: onValuesBlur }, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps }));
                break;
            case InputType.FormTextArea:
                itemDom = react_1.default.createElement(custom_form_components_1.FormTextArea, tslib_1.__assign({ onValueBlur: onValuesBlur }, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps }));
                break;
            case InputType.FormNumber:
                itemDom = react_1.default.createElement(custom_form_components_1.FormNumber, tslib_1.__assign({ onValueBlur: onValuesBlur }, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps }));
                break;
            case InputType.FormSelect:
                itemDom = react_1.default.createElement(custom_form_components_1.FormSelect, tslib_1.__assign({ onValueBlur: onValuesBlur }, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps }));
                break;
            case InputType.FormSelectInput:
                itemDom = react_1.default.createElement(custom_form_components_1.FormSelectInput, tslib_1.__assign({ onValueBlur: onValuesBlur }, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps }));
                break;
            case InputType.FormMultipleSelect:
                itemDom = react_1.default.createElement(custom_form_components_1.FormMultipleSelect, tslib_1.__assign({ onValueBlur: onValuesBlur }, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps }));
                break;
            case InputType.FormCascader:
                itemDom = react_1.default.createElement(custom_form_components_1.FormCascader, tslib_1.__assign({ onValueBlur: onValuesBlur }, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps }));
                break;
            case InputType.FormLocation:
                itemDom = react_1.default.createElement(custom_form_components_1.FormLocation, tslib_1.__assign({ onValueBlur: onValuesBlur }, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps }));
                break;
            case InputType.FormCheckbox:
                itemDom = react_1.default.createElement(custom_form_components_1.FormCheckbox, tslib_1.__assign({ onValueBlur: onValuesBlur }, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps }));
                break;
            case InputType.FormRadio:
                itemDom = react_1.default.createElement(custom_form_components_1.FormRadio, tslib_1.__assign({ onValueBlur: onValuesBlur }, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps }));
                break;
            case InputType.FormRange:
                itemDom = react_1.default.createElement(custom_form_components_1.FormRange, tslib_1.__assign({ onValueBlur: onValuesBlur }, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps }));
                break;
            case InputType.FormRangePicker:
                itemDom = react_1.default.createElement(custom_form_components_1.FormRangePicker, tslib_1.__assign({ onValueBlur: onValuesBlur }, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps, language: language }));
                break;
            case InputType.FormDatePicker:
                itemDom = react_1.default.createElement(custom_form_components_1.FormDatePicker, tslib_1.__assign({ onValueBlur: onValuesBlur }, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps, language: language }));
                break;
            case InputType.FormTimePicker:
                itemDom = react_1.default.createElement(custom_form_components_1.FormTimePicker, tslib_1.__assign({ onValueBlur: onValuesBlur }, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps, language: language }));
                break;
            case InputType.FormTreeSelect:
                itemDom = react_1.default.createElement(custom_form_components_1.FormTreeSelect, tslib_1.__assign({ onValueBlur: onValuesBlur }, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps }));
                break;
            default:
                break;
        }
        return itemDom;
    }, [onValuesBlur]);
    var getItem = (0, react_1.useCallback)(function (text, props, type) {
        var _a, _b, _c;
        var _d = props.fieldProps, fieldProps = _d === void 0 ? {} : _d;
        var _e = fieldProps.copyProps, copyProps = _e === void 0 ? {} : _e;
        if (!copyProps.placement) {
            copyProps.placement = custom_form_components_1.PositionEnum.TopLeft;
        }
        var itemDom = react_1.default.createElement("div", null);
        switch (type) {
            case InputType.FormSelect:
                itemDom = react_1.default.createElement(custom_form_components_1.FormSelect, tslib_1.__assign({}, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps, readOnly: true }));
                break;
            case InputType.FormSelectInput:
                itemDom = react_1.default.createElement(custom_form_components_1.FormSelectInput, tslib_1.__assign({}, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps, readOnly: true }));
                break;
            case InputType.FormMultipleSelect:
                itemDom = react_1.default.createElement(custom_form_components_1.FormMultipleSelect, tslib_1.__assign({}, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps, readOnly: true }));
                break;
            case InputType.FormCascader:
                itemDom = react_1.default.createElement(custom_form_components_1.FormCascader, tslib_1.__assign({}, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps, readOnly: true }));
                break;
            case InputType.FormTreeSelect:
                itemDom = react_1.default.createElement(custom_form_components_1.FormTreeSelect, tslib_1.__assign({}, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps, readOnly: true }));
                break;
            case InputType.FormCheckbox:
                itemDom = react_1.default.createElement(custom_form_components_1.FormCheckbox, tslib_1.__assign({}, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps, readOnly: true }));
                break;
            case InputType.FormRadio:
                itemDom = react_1.default.createElement(custom_form_components_1.FormRadio, tslib_1.__assign({}, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps, readOnly: true }));
                break;
            case InputType.FormTextArea:
                /**
                 * readonlyRenderComponent
                 * 目前只有工单详情多行文本只读模式，依然渲染textArea,其他地方依然是 <span>{text}</span>
                 */
                if (((_a = props === null || props === void 0 ? void 0 : props.fieldProps) === null || _a === void 0 ? void 0 : _a.readonlyRenderComponent) && !!text) {
                    itemDom = (react_1.default.createElement(custom_form_components_1.FormTextArea, tslib_1.__assign({}, props === null || props === void 0 ? void 0 : props.fieldProps, { copyProps: copyProps, readOnly: true })));
                }
                else {
                    itemDom = (react_1.default.createElement("span", null, text));
                }
                break;
            case InputType.FormDatePicker:
                var showText = text;
                if (!!text && ((_b = props === null || props === void 0 ? void 0 : props.fieldProps) === null || _b === void 0 ? void 0 : _b.needTransfer) && ((_c = props === null || props === void 0 ? void 0 : props.fieldProps) === null || _c === void 0 ? void 0 : _c.showTime)) {
                    showText = (0, utils_1.time2Locale)(text);
                }
                itemDom = (react_1.default.createElement(custom_form_components_1.CopyText, tslib_1.__assign({}, copyProps, { text: showText }),
                    react_1.default.createElement("span", null, showText)));
                break;
            default:
                itemDom = (react_1.default.createElement(custom_form_components_1.CopyText, tslib_1.__assign({}, copyProps, { text: text }), [InputType.FormLink].indexOf(type) !== -1 && text ?
                    react_1.default.createElement("a", { href: text, target: "_blank" }, text)
                    : react_1.default.createElement("span", null, text)));
                break;
        }
        return itemDom;
    }, []);
    var onFinishFailed = function (_a) {
        var _b;
        var errorFields = _a.errorFields;
        udesk_ui_1.message.error(((_b = errorFields[0]) === null || _b === void 0 ? void 0 : _b.errors[0]) || '');
    };
    var valueTypeMap = (0, react_1.useMemo)(function () {
        var _a;
        // 自定义的复杂组件需要单加
        var types = (_a = {},
            _a[InputType.Content] = {
                render: function (text, props) {
                    var fieldProps = (props === null || props === void 0 ? void 0 : props.fieldProps) || {};
                    var _a = fieldProps.copyProps, copyProps = _a === void 0 ? {} : _a;
                    if (!copyProps.placement) {
                        copyProps.placement = custom_form_components_1.PositionEnum.TopLeft;
                    }
                    return react_1.default.createElement(custom_form_components_1.Content, tslib_1.__assign({}, fieldProps, { copyProps: copyProps, readOnly: true }));
                    // return <ContentView {...fieldProps} copyProps={copyProps} content={text} />
                },
                renderFormItem: function (text, props) {
                    var fieldProps = (props === null || props === void 0 ? void 0 : props.fieldProps) || {};
                    var _a = fieldProps.copyProps, copyProps = _a === void 0 ? {} : _a;
                    return react_1.default.createElement(custom_form_components_1.Content, tslib_1.__assign({}, fieldProps, { copyProps: copyProps }));
                },
            },
            _a[InputType.Upload] = {
                render: function (attachments, props) {
                    var fieldProps = (props === null || props === void 0 ? void 0 : props.fieldProps) || {};
                    return react_1.default.createElement(custom_form_components_1.AttachmentListView, tslib_1.__assign({}, fieldProps, { attachments: attachments }));
                },
                renderFormItem: function (text, props) {
                    var fieldProps = (props === null || props === void 0 ? void 0 : props.fieldProps) || {};
                    return react_1.default.createElement(custom_form_components_1.Upload, tslib_1.__assign({}, fieldProps));
                },
            },
            _a);
        // 通用的组件统一返回
        [
            InputType.FormCascader,
            InputType.FormCheckbox,
            InputType.FormDatePicker,
            InputType.FormLink,
            InputType.FormLocation,
            InputType.FormMultipleSelect,
            InputType.FormNumber,
            InputType.FormRadio,
            InputType.FormRange,
            InputType.FormRangePicker,
            InputType.FormSelect,
            InputType.FormSelectInput,
            InputType.FormText,
            InputType.FormTextArea,
            InputType.FormTimePicker,
            InputType.FormTreeSelect,
        ].forEach(function (inputType) {
            var itemConfig = {
                render: function (text, props) {
                    return getItem(text, props, inputType);
                },
                renderFormItem: function (text, props) {
                    return getFormItem(text, props, inputType);
                },
            };
            types[inputType] = itemConfig;
        });
        types = tslib_1.__assign(tslib_1.__assign({}, types), valueTypes);
        return types;
    }, [columns, valueTypes, getFormItem, getItem]);
    return (react_1.default.createElement(pro_provider_1.default.Provider, { value: tslib_1.__assign(tslib_1.__assign({}, values), { valueTypeMap: valueTypeMap }) },
        react_1.default.createElement(pro_form_1.BetaSchemaForm, tslib_1.__assign({}, restProps, { grid: layoutType !== 'LightFilter' && layoutType !== 'QueryFilter', layout: formLayout, layoutType: layoutType, 
            // labelCol={{ span: 4 }} // horizontal 下使用
            // wrapperCol={{ span: 14 }} // horizontal 下使用
            visible: visible, language: language, modalProps: tslib_1.__assign({ bodyStyle: isModalScroll ? { overflowY: 'scroll', height: 600 } : {}, width: 1000, zIndex: zIndex, destroyOnClose: destroyOnClose, maskClosable: maskClosable, modalRender: function (modal) { return (react_1.default.createElement(react_1.default.Fragment, null,
                    modal,
                    loading && isModalScroll ? (react_1.default.createElement(udesk_ui_1.Spin, { spinning: loading, wrapperClassName: "customForm-model-spin-wrapper" },
                        react_1.default.createElement("div", { className: "customForm-model-spin-content" }))) : null)); } }, (modalProps || {})), submitTimeout: 10000, submitter: {
                render: function (props, doms) {
                    if (typeof submitterRender === 'function') {
                        return submitterRender(props);
                    }
                    else if (layoutType === 'LightFilter' || layoutType === 'QueryFilter') {
                        return tslib_1.__spreadArray([], doms, true);
                    }
                    else {
                        var btnDoms = [];
                        beforeSubmitter && btnDoms.push(beforeSubmitter(props));
                        if (!hiddenSubmitButton) {
                            btnDoms.push(react_1.default.createElement(udesk_ui_1.Button, { loading: loading, type: "primary", key: "submit", onClick: function () { var _a, _b; return (_b = (_a = props.form) === null || _a === void 0 ? void 0 : _a.submit) === null || _b === void 0 ? void 0 : _b.call(_a); } }, submitBtnText || formatMessage(submitBtnType == 'save' ? 'save' : 'submit')));
                        }
                        if (!hiddenResetButton) {
                            btnDoms.push(react_1.default.createElement(udesk_ui_1.Button, { key: "rest", onClick: function () {
                                    var _a;
                                    if (layoutType !== "ModalForm") {
                                        (_a = props.form) === null || _a === void 0 ? void 0 : _a.resetFields();
                                    }
                                    ;
                                    onCancel === null || onCancel === void 0 ? void 0 : onCancel();
                                } }, cancelBtnText || formatMessage('cancel')));
                        }
                        afterSubmitter && btnDoms.push(afterSubmitter(props));
                        return (react_1.default.createElement("div", { className: 'custom-form-footerToolbar' },
                            react_1.default.createElement(udesk_ui_1.Space, { wrap: true }, btnDoms)));
                    }
                },
            }, columns: columns, collapseRender: function (collapsed, doms) {
                if (typeof collapseRender === 'function') {
                    return collapseRender(collapsed, doms);
                }
                else {
                    return (collapsed ? react_1.default.createElement("span", { style: { color: '#00b38b' } },
                        formatMessage('labels.packDown'),
                        " ",
                        react_1.default.createElement(icons_1.DownOutlined, null)) : react_1.default.createElement("span", { style: { color: '#00b38b' } },
                        formatMessage('labels.packUp'),
                        " ",
                        react_1.default.createElement(icons_1.UpOutlined, null)));
                }
            }, onFinishFailed: onFinishFailed, onValuesChange: onValuesChange }))));
});
exports.default = CustomForm;
