import { __assign, __rest } from "tslib";
import React, { useCallback, useEffect, useState } from 'react';
import { Input } from 'udesk-ui';
import { TiaoZhuan } from '@udesk-webapp/icon';
import { CloseCircleFilled } from '@ant-design/icons';
import FieldErrAndExplain from '@udesk-webapp/custom-field-error-explain';
import CopyComponent from '@udesk-webapp/copy-content';
import { useValid } from '@udesk-webapp/custom-field-input-base';
import cssObj from './index.module.scss';
var Link = function (_a) {
    var isFormItem = _a.isFormItem, explainShow = _a.explainShow, explain = _a.explain, onBlur = _a.onBlur, onChange = _a.onChange, switchFlag = _a.switchFlag, trigger = _a.trigger, customValidPromise = _a.customValidPromise, propValue = _a.value, props = __rest(_a, ["isFormItem", "explainShow", "explain", "onBlur", "onChange", "switchFlag", "trigger", "customValidPromise", "value"]);
    var _b = useState(''), errMsg = _b[0], setErrMsg = _b[1];
    // 输入的值
    var _c = useState(props.defaultValue || ''), value = _c[0], setValue = _c[1];
    // 是否显示跳转按钮
    var _d = useState(false), showIcon = _d[0], setShowIcon = _d[1];
    var handleValid = useValid({
        customValidPromise: customValidPromise,
        onSuccess: function () {
            var changeFunction = onBlur;
            if (typeof changeFunction === 'function') {
                changeFunction(value);
            }
        },
        onError: function (error) {
            var err = error && error.message;
            setErrMsg(err);
        },
    });
    useEffect(function () {
        setValue(propValue || '');
        setShowIcon(!!propValue);
    }, [propValue]);
    // props.value变化即触发
    //   输入值变化时  手动双向绑定  进行检验
    var handleOnchange = useCallback(function (e) {
        // 解决ember传值过来时,由于异步渲染引起的光标抖动问题,后面可以考虑下其他解决方案
        // 或者传入数据处由react处理后可以考虑去除此代码,以保证数据流向清晰
        setValue(e.target.value);
        if (typeof onChange === 'function') {
            onChange(e.target.value);
        }
    }, [onChange]);
    var handleValidValue = useCallback(function (e) {
        var v = e.target.value;
        handleValid({
            value: v,
            changeFunction: onBlur,
            isFormItem: isFormItem
        });
    }, [isFormItem, onBlur]);
    // 点击输入框右侧图标  打开输入的链接页面
    var openWindow = useCallback(function () {
        window.open(value, '_blank');
    }, [value]);
    // 清空输入框
    var clear = useCallback(function () {
        setValue('');
        if (trigger === 'onChange') {
            onChange === null || onChange === void 0 ? void 0 : onChange('');
        }
        else if (trigger === 'onBlur') {
            onBlur === null || onBlur === void 0 ? void 0 : onBlur('');
        }
    }, [onBlur, onChange, trigger]);
    var handleSuffix = (React.createElement("div", { className: cssObj['icon-group-wrapper'] },
        React.createElement("span", { className: cssObj['redict-icon'], onClick: openWindow },
            React.createElement(TiaoZhuan, null)),
        React.createElement("span", { className: cssObj['clear-icon'], onClick: clear },
            React.createElement(CloseCircleFilled, null))));
    return (React.createElement(FieldErrAndExplain, { isFormItem: isFormItem, explainShow: explainShow, explain: explain, errMsg: errMsg },
        React.createElement(CopyComponent, { text: value, switchFlag: switchFlag },
            React.createElement(Input, __assign({ onBlur: handleValidValue, value: value, onChange: handleOnchange, suffix: showIcon ? handleSuffix : '' }, props)))));
};
Link.defaultProps = {
    style: {}
};
export default Link;
