import { __assign, __rest } from "tslib";
// 搜索公司
import React, { useCallback, useContext, useEffect, useState } from 'react';
import { Select } from 'udesk-ui';
import { ajax } from '@udesk-webapp/utils';
import { TicketContext } from '@udesk-webapp/ticket-signature/es/utilities';
var Option = Select.Option;
var AgentUserField = function (_a) {
    var onChange = _a.onChange, propValue = _a.value, props = __rest(_a, ["onChange", "value"]);
    var agentGroup = useContext(TicketContext).agentGroup;
    var _b = useState(), value = _b[0], setValue = _b[1]; // 选择的选项
    var _c = useState([]), data = _c[0], setData = _c[1];
    useEffect(function () {
        // 负责组只要改变  负责人就置空  重新选择
        setValue({ value: '', label: '' });
        if (!agentGroup) {
            // 如果选负责组是空选项   负责人数据置空
            setData([]);
        }
        else {
            // 请求负责人数据
            ajax().getJSON("/cs/ts/api/user_groups/".concat(agentGroup)).then(function (res) {
                var list = res.user_group.users.map(function (item) { return ({
                    value: item.id,
                    label: item.nick_name,
                }); });
                // 前边加空选项
                list.unshift({
                    value: '',
                    label: '--'
                });
                setData(list);
            });
        }
    }, [agentGroup]);
    // 选项变化时回调
    var handleChange = useCallback(function (changeValue) {
        setValue(changeValue);
        if (typeof onChange === 'function') {
            onChange(changeValue ? changeValue.value : '');
        }
    }, [onChange]);
    // 筛选规则
    var handleFilter = useCallback(function (inputValue, option) {
        if (option.children.includes(inputValue))
            return true;
        return false;
    }, []);
    return (React.createElement(Select, __assign({ value: value, onChange: handleChange, filterOption: handleFilter }, props), data.map(function (d) { return (React.createElement(Option, { key: d.value, value: d.value }, d.label)); })));
};
AgentUserField.defaultProps = {
    showSearch: true,
    showArrow: true,
    labelInValue: true,
    style: { width: '100%' },
    getPopupContainer: function (triggerNode) { return triggerNode; }
};
export default AgentUserField;
