"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.forEachTree = void 0;
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var tree_select_1 = tslib_1.__importDefault(require("antd/es/tree-select"));
var tag_1 = tslib_1.__importDefault(require("antd/es/tag"));
require("antd/es/tree-select/style/index.less");
require("antd/es/select/style/index.less");
require("antd/es/tag/style/index.less");
require("antd/es/empty/style/index.less");
var get_1 = tslib_1.__importDefault(require("lodash-es/get"));
function forEachTree(treeData, callback, options) {
    if (treeData === void 0) { treeData = []; }
    var _a = (options || {}).nodeChildrenPath, nodeChildrenPath = _a === void 0 ? 'subs' : _a;
    treeData === null || treeData === void 0 ? void 0 : treeData.forEach(function (i) {
        callback(i);
        forEachTree(get_1.default(i, nodeChildrenPath), callback, options);
    });
}
exports.forEachTree = forEachTree;
function buildTreeData(selectOptions, parentCheckable, parentKey) {
    if (!selectOptions) {
        return [];
    }
    return selectOptions.map(function (i) {
        var title = i.title;
        var isLeaf = false;
        if (i.node_type === 'leaf') {
            isLeaf = true;
        }
        else if (!i.node_type && (!i.subs || i.subs.length === 0)) {
            isLeaf = true;
        }
        if (isLeaf) {
            title = react_1.default.createElement(tag_1.default, { color: i.color || '#00B38B' },
                i.icon_url ?
                    react_1.default.createElement("img", { src: i.icon_url, alt: '', style: { width: "1em", height: "1em", marginRight: '3px' } }) : null,
                i.title);
        }
        return {
            title: title,
            value: i.value,
            checkable: parentCheckable ? true : isLeaf,
            disableCheckbox: parentCheckable ? false : !isLeaf,
            children: buildTreeData(i.subs, parentCheckable),
            titleText: i.title
        };
    });
}
var tagRender = function (props) {
    var label = props.label, closable = props.closable, onClose = props.onClose;
    return react_1.cloneElement(label, { closable: closable, onClose: onClose });
};
var TagTree = function (_a) {
    var value = _a.value, formData = _a.formData, onChange = _a.onChange, size = _a.size, disabled = _a.disabled;
    // const treeNodes = useMemo(() => renderTreeNode(formData.select_options, formData.parent_checkable), [formData.parent_checkable, formData.select_options]);
    var treeData = react_1.useMemo(function () { return buildTreeData(formData.select_options, formData.parent_checkable); }, [formData.parent_checkable, formData.select_options]);
    var ref = react_1.useRef(null);
    var getPopupContainer = react_1.useCallback(function () { return ref.current || document.body; }, []);
    var disableStatus = typeof disabled === 'function' ? disabled() : disabled;
    var valueAry = react_1.useMemo(function () {
        if (typeof value === 'string') {
            return value.split(',');
        }
        else if (value) {
            return value;
        }
        else {
            return [];
        }
    }, [value]);
    var safeValueAry = react_1.useMemo(function () {
        if (valueAry.length === 0) {
            return [];
        }
        var result = [];
        forEachTree(formData.select_options, function (i) { return (valueAry === null || valueAry === void 0 ? void 0 : valueAry.includes(i.value)) && result.push(i.value); }, { nodeChildrenPath: 'subs' });
        return result;
    }, [formData.select_options, valueAry]);
    return (react_1.default.createElement("div", { ref: ref, style: { position: 'relative' } },
        react_1.default.createElement(tree_select_1.default, { showSearch: true, style: { width: '100%' }, value: safeValueAry, dropdownStyle: { maxHeight: 400, overflow: 'auto' }, placeholder: formData.input_tip, allowClear: true, treeCheckable: true, onChange: onChange, getPopupContainer: getPopupContainer, transitionName: '', treeDefaultExpandAll: formData.default_expand_all, multiple: true, tagRender: tagRender, treeData: treeData, size: size, disabled: disableStatus, treeNodeFilterProp: 'titleText' })));
};
exports.default = TagTree;
