import { __assign, __rest } from "tslib";
import React, { useEffect, useState } from 'react';
import { Select } from 'udesk-ui';
import CopyComponent from '@udesk-webapp/copy-content';
import cssObj from './index.module.scss';
var Option = Select.Option;
var FiledDroplistRadio = function (_a) {
    var _b;
    var switchFlag = _a.switchFlag, options = _a.options, onChange = _a.onChange, value = _a.value, props = __rest(_a, ["switchFlag", "options", "onChange", "value"]);
    // 选择的选项值
    var _c = useState(), selectValue = _c[0], setSelectValue = _c[1];
    // 监听道选项改变 处理数据   取出其中默认选项  复制给Radio.Group的value  主要是外部新建字段  改变默认选项时触发  改变展示效果
    useEffect(function () {
        // 如果有传value  说明在formitem里   优先使用value
        if (value) {
            // value  类型 是[] 或 string
            if (typeof (value) === 'string') {
                // 将value转数组  存值
                setSelectValue((value + '').split(','));
            }
        }
        else {
            var valueList_1 = [];
            options === null || options === void 0 ? void 0 : options.forEach(function (item) {
                if (item.default)
                    valueList_1.push(item.value);
            });
            setSelectValue(valueList_1);
        }
    }, [options, value]);
    useEffect(function () {
        setSelectValue(typeof value === 'string' ? value.split(',') : value);
    }, [value]);
    function selectOnChange(e) {
        setSelectValue(e);
        if (onChange)
            onChange(e.join(','));
    }
    return (React.createElement(CopyComponent, { text: (selectValue && selectValue.join(',')) || '', switchFlag: switchFlag },
        React.createElement(Select, __assign({ value: selectValue, onChange: selectOnChange }, props), (_b = options === null || options === void 0 ? void 0 : options.map(function (item) { return (React.createElement(Option, { key: item.value, value: item.value },
            React.createElement("span", { className: "".concat(cssObj['select-item'], " ").concat(item.color ? cssObj['select-item-hascolor'] : ''), style: {
                    background: item.color ? item.color : ''
                } },
                item.icon ?
                    React.createElement("img", { alt: '', src: item.icon, className: cssObj['setting-img'] }) : '',
                item.title))); })) !== null && _b !== void 0 ? _b : null)));
};
FiledDroplistRadio.defaultProps = {
    switchFlag: false,
    options: [],
    style: { width: '100%' },
    dropdownMatchSelectWidth: false,
    getPopupContainer: function (triggerNode) { return triggerNode; },
    mode: 'multiple'
};
export default FiledDroplistRadio;
