import { __assign, __rest } from "tslib";
import React, { useCallback, useEffect, useState } from 'react';
import { Input } from 'udesk-ui';
import { EnvironmentOutlined } from '@ant-design/icons';
import FieldErrAndExplain from '@udesk-webapp/custom-field-error-explain';
import CopyComponent from '@udesk-webapp/copy-content';
import { useValid } from '@udesk-webapp/custom-field-input-base';
import cssObj from './index.module.scss';
var TextArea = Input.TextArea;
var Location = function (_a) {
    var isFormItem = _a.isFormItem, onChange = _a.onChange, onBlur = _a.onBlur, customValidPromise = _a.customValidPromise, v = _a.value, explainShow = _a.explainShow, explain = _a.explain, switchFlag = _a.switchFlag, rowsLine = _a.rowsLine, props = __rest(_a, ["isFormItem", "onChange", "onBlur", "customValidPromise", "value", "explainShow", "explain", "switchFlag", "rowsLine"]);
    var _b = useState(v || ''), value = _b[0], setValue = _b[1]; // 输入的地址
    var _c = useState(false), showIcon = _c[0], setShowIcon = _c[1]; // 是否显示右上角地址图标  鼠标经过输入框时显示
    var _d = useState(''), errMsg = _d[0], setErrMsg = _d[1];
    var handleValid = useValid({
        customValidPromise: customValidPromise,
        onSuccess: function () {
            var changeFunction = props['onBlur'];
            if (typeof changeFunction === 'function') {
                changeFunction(value);
            }
        },
        onError: function (error) {
            var err = error && error.message;
            setErrMsg(err);
        },
    });
    useEffect(function () {
        setValue(v);
    }, [v]);
    // 点击定位图标  打开地图
    function openMap() {
        var url = "http://apis.map.qq.com/uri/v1/search?keyword=".concat(value || '', "&referer=custom_field");
        window.open(url, '_blank');
    }
    var handleOnchange = useCallback(function (e) {
        // 解决ember传值过来时,由于异步渲染引起的光标抖动问题,后面可以考虑下其他解决方案
        // 或者传入数据处由react处理后可以考虑去除此代码,以保证数据流向清晰
        setValue(e.target.value);
        if (typeof onChange === 'function') {
            onChange(e.target.value);
        }
    }, [onChange]);
    var handleValidValue = useCallback(function (e) {
        var value = e.target.value;
        handleValid({
            value: value,
            changeFunction: onBlur,
            isFormItem: isFormItem
        });
    }, [isFormItem, onBlur]);
    return (React.createElement(FieldErrAndExplain, { isFormItem: isFormItem, explainShow: explainShow, explain: explain, errMsg: errMsg },
        React.createElement("div", { className: "locationField-wrapper ".concat(cssObj['textarea-wrapper']), onMouseEnter: function () { return setShowIcon(true); }, onMouseLeave: function () { return setShowIcon(false); } },
            React.createElement(CopyComponent, { text: value, switchFlag: switchFlag },
                React.createElement(TextArea, __assign({ onBlur: handleValidValue, 
                    // 行数
                    rows: rowsLine, 
                    // 输入值
                    value: value, 
                    // 输入变化回调
                    onChange: handleOnchange }, props))),
            showIcon ? React.createElement("div", { className: cssObj['address-icon'], onClick: openMap },
                React.createElement(EnvironmentOutlined, null)) : '')));
};
Location.defaultProps = {
    className: cssObj['textarea-style']
};
export default Location;
