import { __rest, __spreadArray } from "tslib";
import React, { useCallback, useEffect, useState } from 'react';
import { Input } from 'udesk-ui';
import { useTranslation } from '@udesk-webapp/locale';
import FieldWarning from '@udesk-webapp/field-warning';
import { MinusOutlined, PlusOutlined } from '@ant-design/icons';
import style from './index.module.scss';
var EmailField = function (_a) {
    var value = _a.value, onChange = _a.onChange, props = __rest(_a, ["value", "onChange"]);
    // 多语言
    var t = useTranslation().t;
    var list = (value === null || value === void 0 ? void 0 : value.length) ? value : [''];
    var _b = useState(list), emailList = _b[0], setEmailList = _b[1];
    var _c = useState([]), errMessage = _c[0], SetErrMessage = _c[1];
    // 进来第一次生成对应邮箱数量的报错信息
    useEffect(function () {
        SetErrMessage(__spreadArray([], new Array(list.length), true));
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    // 新加邮箱时   改变外部form数据
    var addEmail = useCallback(function () {
        // props.onChange && props.onChange(emailList.concat('').join(','))
        setEmailList(function (v) { return v.concat(''); });
        SetErrMessage(function (v) { return v.concat(''); });
    }, []);
    // 删除   删除邮箱  删除报错信息
    var deleteEmail = useCallback(function (index) {
        setEmailList(function (v) { return __spreadArray(__spreadArray([], v.slice(0, index), true), v.slice(index + 1), true); });
        SetErrMessage(function (v) { return __spreadArray(__spreadArray([], v.slice(0, index), true), v.slice(index + 1), true); });
    }, []);
    // 输入值改变时  改变相对应的数据
    var emailInputChange = useCallback(function (e, index) {
        var inputValue = e.target.value;
        setEmailList(function (v) { return __spreadArray(__spreadArray(__spreadArray([], v.slice(0, index), true), [inputValue], false), v.slice(index + 1), true); });
    }, []);
    // 失焦触发  校验邮箱  更改外部form
    var emailOnBlur = useCallback(function (index) {
        var value = emailList[index];
        // if (value && !/^[A-Za-z0-9\u4e00-\u9fa5]+@[a-zA-Z0-9_-]+(\.[a-zA-Z0-9_-]+)+$/i.test(value)) {
        if (value && !/^([A-Za-z0-9_\-\.\u4e00-\u9fa5])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,8})$/i.test(value)) {
            SetErrMessage(function (v) { return __spreadArray(__spreadArray(__spreadArray([], v.slice(0, index), true), ['邮箱格式不正确'], false), v.slice(index + 1), true); });
        }
        else {
            SetErrMessage(function (v) { return __spreadArray(__spreadArray(__spreadArray([], v.slice(0, index), true), [''], false), v.slice(index + 1), true); });
        }
        if (typeof onChange === 'function') {
            onChange(emailList);
        }
    }, [emailList, onChange]);
    return (React.createElement(React.Fragment, null, emailList.map(function (item, index) { return (React.createElement("div", { key: index, className: style['email-item-wrapper'] },
        React.createElement("div", { className: style['email-item-box'] },
            React.createElement(Input, { style: { flex: 1 }, placeholder: props.placeholder, value: item, onChange: function (e) { return emailInputChange(e, index); }, onBlur: function () { return emailOnBlur(index); } }),
            !index ?
                React.createElement("div", { className: style['add-icon'], onClick: addEmail },
                    React.createElement(PlusOutlined, null),
                    React.createElement("div", null, t('add')))
                :
                    React.createElement("div", { className: style['add-icon'], onClick: function () { return deleteEmail(index); } },
                        React.createElement(MinusOutlined, null),
                        React.createElement("div", null, t('delete')))),
        React.createElement("div", { style: { marginTop: '5px' } },
            React.createElement(FieldWarning, { warningText: errMessage[index] })))); })));
};
export default EmailField;
