import { __assign, __rest } from "tslib";
import React, { useCallback, useEffect, useState } from 'react';
import { Input } from 'udesk-ui';
import FieldErrAndExplain from '@udesk-webapp/custom-field-error-explain';
import CopyComponent from '@udesk-webapp/copy-content';
import { useValid } from '@udesk-webapp/custom-field-input-base';
var Number = function (_a) {
    var isFormItem = _a.isFormItem, switchFlag = _a.switchFlag, customValidPromise = _a.customValidPromise, explainShow = _a.explainShow, explain = _a.explain, v = _a.value, onBlur = _a.onBlur, onChange = _a.onChange, addonSetting = _a.addonSetting, props = __rest(_a, ["isFormItem", "switchFlag", "customValidPromise", "explainShow", "explain", "value", "onBlur", "onChange", "addonSetting"]);
    var _b = useState(v), value = _b[0], setValue = _b[1];
    var _c = useState(''), errMsg = _c[0], setErrMsg = _c[1];
    var handleValid = useValid({
        customValidPromise: customValidPromise,
        onSuccess: function () {
            var changeFunction = onBlur;
            if (typeof changeFunction === 'function') {
                changeFunction(value);
            }
        },
        onError: function (error) {
            var err = error && error.message;
            setErrMsg(err);
        },
    });
    useEffect(function () {
        setValue(v || '');
    }, [v]);
    var isValid = useCallback(function (targetValue) {
        var reg = /^-?\d*$/;
        return reg.test(targetValue);
    }, []);
    var handleOnchange = useCallback(function (e) {
        var value = e.target.value;
        if (isValid(value)) {
            // 解决ember传值过来时,由于异步渲染引起的光标抖动问题,后面可以考虑下其他解决方案
            // 或者传入数据处由react处理后可以考虑去除此代码,以保证数据流向清晰
            setValue(value);
            if (typeof onChange === 'function') {
                onChange(value);
            }
        }
    }, [onChange]);
    var handleValidValue = useCallback(function (e) {
        var value = e.target.value;
        if (isValid(value)) {
            handleValid({
                value: value,
                changeFunction: onBlur,
                isFormItem: isFormItem
            });
        }
    }, [isFormItem, onBlur]);
    return (React.createElement(FieldErrAndExplain, { explainShow: explainShow, explain: explain, isFormItem: isFormItem, errMsg: errMsg },
        React.createElement(CopyComponent, { text: value, switchFlag: switchFlag },
            React.createElement(Input, __assign({ value: value, onBlur: handleValidValue, onChange: handleOnchange, addonBefore: addonSetting && addonSetting.addonBefore.checked && addonSetting.addonBefore.content, addonAfter: addonSetting && addonSetting.addonAfter.checked && addonSetting.addonAfter.content, prefix: addonSetting && addonSetting.prefix.checked && addonSetting.prefix.content, suffix: addonSetting && addonSetting.suffix.checked && addonSetting.suffix.content }, props)))));
};
Number.defaultProps = {
    isFormItem: true,
    style: {}
};
export default Number;
