import React from 'react';
import { Input as AntdInput, InputRef } from 'antd';
import type { InputProps as AntdInputProps, TextAreaProps as AntdTextAreaProps } from 'antd/es/input';
import type { TextAreaRef } from 'antd/es/input/TextArea';
interface InputProps extends AntdInputProps {
    /**
     * 最大可输入字符数
     */
    maxCount?: number;
    showCount?: boolean;
}
interface TextAreaProps extends AntdTextAreaProps {
    /**
     * 最大可输入字符数
     */
    maxCount?: number;
    showCount?: boolean;
}
export interface ExpandSuffixProps {
    /**
     * 是否显示字符数
     */
    showCount: boolean;
    /**
     * 最大可输入字符数（若传入则显示字符计数器后半段，不传则只显示当前字数）
     */
    maxCount?: number;
    /**
     * 当前字符数
     */
    valueLength: number;
    /**
     * Input组件传入的后缀
     */
    width?: number;
}
declare const TextArea: React.ForwardRefExoticComponent<TextAreaProps & React.RefAttributes<TextAreaRef>>;
declare const UInput: React.ForwardRefExoticComponent<InputProps & React.RefAttributes<InputRef>>;
export { InputProps };
export { TextAreaProps };
export type { GroupProps } from 'antd/es/input/Group';
export type { SearchProps } from 'antd/es/input/Search';
export type { PasswordProps } from 'antd/es/input/Password';
declare type UInputType = typeof UInput & Omit<typeof AntdInput, keyof React.ForwardRefExoticComponent<AntdInputProps> | 'TextArea'> & {
    TextArea: typeof TextArea;
};
declare const ExportInput: UInputType;
export default ExportInput;
