"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _space = _interopRequireDefault(require("antd/lib/space"));

var _input = _interopRequireDefault(require("antd/lib/input"));

var _react = _interopRequireWildcard(require("react"));

var _configProvider = _interopRequireDefault(require("../config-provider"));

var _core = require("../_utils/core");

var _classnames = _interopRequireDefault(require("classnames"));

var _lessVariables = require("../_utils/less-variables");

var _excluded = ["showCount", "maxCount", "onResize"],
    _excluded2 = ["showCount", "maxCount"];

function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }

function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }

function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }

var CurrentCount = function CurrentCount(_ref) {
  var maxCount = _ref.maxCount,
      valueLength = _ref.valueLength,
      showCount = _ref.showCount,
      width = _ref.width;
  var ctx = (0, _react.useContext)(_configProvider["default"].ConfigContext);
  var getPrefixCls = ctx.getPrefixCls;
  var valueLengthOver = typeof maxCount === 'number' && valueLength > maxCount;
  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, showCount && /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])(getPrefixCls('input-value-count'), _defineProperty({}, getPrefixCls('input-value-count-over'), valueLengthOver)),
    style: width ? {
      width: width - parseInt(_lessVariables.lessVariables['@padding-xss'], 10) - parseInt(_lessVariables.lessVariables['@scroll-bar-width'], 10)
    } : undefined
  }, "".concat(valueLength).concat(Boolean(maxCount) ? '/' + maxCount : '')));
};

var TextArea = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var ctx = (0, _react.useContext)(_configProvider["default"].ConfigContext);
  var getPrefixCls = ctx.getPrefixCls;

  var _props$showCount = props.showCount,
      showCount = _props$showCount === void 0 ? false : _props$showCount,
      maxCount = props.maxCount,
      propsOnResize = props.onResize,
      restProps = _objectWithoutProperties(props, _excluded);

  var propsOnChange = restProps.onChange;

  var _useState = (0, _react.useState)(0),
      _useState2 = _slicedToArray(_useState, 2),
      valueLength = _useState2[0],
      setValueLength = _useState2[1];

  var _useState3 = (0, _react.useState)(undefined),
      _useState4 = _slicedToArray(_useState3, 2),
      width = _useState4[0],
      setWidth = _useState4[1];

  var onChange = function onChange(e) {
    setValueLength(e.target.value.length);
    propsOnChange === null || propsOnChange === void 0 ? void 0 : propsOnChange(e);
  };

  if (!showCount) {
    return /*#__PURE__*/_react["default"].createElement(_input["default"].TextArea, _objectSpread(_objectSpread({}, restProps), {}, {
      ref: ref
    }));
  }

  var onResize = function onResize(_ref2) {
    var width = _ref2.width,
        height = _ref2.height;
    setWidth(width);
    propsOnResize === null || propsOnResize === void 0 ? void 0 : propsOnResize({
      width: width,
      height: height
    });
  };

  (0, _react.useEffect)(function () {
    setValueLength(function () {
      if (typeof props.value === 'string') {
        return props.value.length;
      } else {
        return 0;
      }
    });
  }, [props.value]);
  return /*#__PURE__*/_react["default"].createElement("div", {
    className: (0, _classnames["default"])(getPrefixCls('input-textarea'), getPrefixCls('input-textarea-show-count'))
  }, /*#__PURE__*/_react["default"].createElement(_input["default"].TextArea, _objectSpread(_objectSpread({}, restProps), {}, {
    onResize: onResize,
    showCount: false,
    onChange: onChange,
    ref: ref
  })), showCount && /*#__PURE__*/_react["default"].createElement(CurrentCount, {
    showCount: showCount,
    valueLength: valueLength,
    maxCount: maxCount,
    width: width
  }));
});
var UInput = /*#__PURE__*/(0, _react.forwardRef)(function (props, ref) {
  var _props$showCount2 = props.showCount,
      showCount = _props$showCount2 === void 0 ? false : _props$showCount2,
      maxCount = props.maxCount,
      restProps = _objectWithoutProperties(props, _excluded2);

  var suffix = restProps.suffix,
      propsOnChange = restProps.onChange;

  var _useState5 = (0, _react.useState)(0),
      _useState6 = _slicedToArray(_useState5, 2),
      valueLength = _useState6[0],
      setValueLength = _useState6[1];

  var onChange = function onChange(e) {
    setValueLength(e.target.value.length);
    propsOnChange === null || propsOnChange === void 0 ? void 0 : propsOnChange(e);
  };

  if (!showCount) {
    return /*#__PURE__*/_react["default"].createElement(_input["default"], _objectSpread(_objectSpread({}, restProps), {}, {
      ref: ref
    }));
  }

  (0, _react.useEffect)(function () {
    setValueLength(function () {
      if (typeof props.value === 'string') {
        return props.value.length;
      } else {
        return 0;
      }
    });
  }, [props.value]);
  return /*#__PURE__*/_react["default"].createElement(_input["default"], _objectSpread(_objectSpread({}, restProps), {}, {
    onChange: onChange,
    suffix: /*#__PURE__*/_react["default"].createElement(_space["default"], null, /*#__PURE__*/_react["default"].createElement(CurrentCount, {
      showCount: showCount,
      valueLength: valueLength,
      maxCount: maxCount
    }), suffix),
    ref: ref
  }));
});
var ExportInput = UInput; //拷贝静态属性

(0, _core.copyFromAntd)(ExportInput, _input["default"]); //重写TextArea组件映射

ExportInput.TextArea = TextArea;

var _default = exports["default"] = ExportInput;
//# sourceMappingURL=index.js.map
