import React from 'react';
import type { AssetResult } from '@udesk/sdk/lib/manifest-loader';
export interface PropsInterface {
    manifestUrl: string;
    options?: {
        [key: string]: any;
    };
    loadingComponent?: React.FC | React.ReactElement;
    showLoading?: boolean;
    autoRender?: boolean;
    container?: string | HTMLElement;
    errorCallback?: (error: any) => void;
    onLoad?: (assets: AssetResult[]) => void;
    onCreate?: (sdkInstance: any) => void;
    onDestroy?: (sdkInstance: any) => void;
}
/**
 * 路由SDK的manifest加载器,
 * manifestUrl为必传项
 * autoRender默认值为true,当改属性设置为false时,需要使用者
 * 在onLoad回调中处理manifest加载器返回的AssetResult
 *
 * @param {*} props
 */
declare const ManifestLoader: React.FC<PropsInterface>;
export default ManifestLoader;
