"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _manifestLoader = require("@udesk/sdk/lib/manifest-loader");

var _skeleton = _interopRequireDefault(require("../skeleton"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }

function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

/**
 * 路由SDK的manifest加载器,
 * manifestUrl为必传项
 * autoRender默认值为true,当改属性设置为false时,需要使用者
 * 在onLoad回调中处理manifest加载器返回的AssetResult
 *
 * @param {*} props
 */
var ManifestLoader = function ManifestLoader(props) {
  var _useState = (0, _react.useState)(false),
      _useState2 = _slicedToArray(_useState, 2),
      sdkloading = _useState2[0],
      setSdkLoading = _useState2[1];

  var containerRef = (0, _react.useRef)(null);
  var sdkInstanceRef = (0, _react.useRef)(null);
  var manifestUrl = props.manifestUrl,
      loadingComponent = props.loadingComponent,
      options = props.options,
      showLoading = props.showLoading,
      autoRender = props.autoRender,
      container = props.container,
      errorCallback = props.errorCallback,
      onLoad = props.onLoad,
      onCreate = props.onCreate,
      onDestroy = props.onDestroy;
  (0, _react.useEffect)(function () {
    if (!manifestUrl) {
      throw new TypeError('manifest-loader manifestUrl can not be empty!');
    }

    setSdkLoading(true);
    var manifestLoaderInstance = new _manifestLoader.ManifestLoader(manifestUrl, {});

    if (!manifestLoaderInstance) {
      setSdkLoading(false);
      throw new TypeError('Failed to instantiate Loader!');
    }

    var sdkInstance;
    manifestLoaderInstance === null || manifestLoaderInstance === void 0 ? void 0 : manifestLoaderInstance.assets().then(function () {
      var assets = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var entry = assets.find(function (a) {
        return a.isEntry;
      });
      setSdkLoading(false);

      if (typeof onLoad === 'function') {
        onLoad(assets);
      }

      if (!autoRender) {
        return;
      }

      if (entry !== null && entry !== void 0 && entry.SdkClass) {
        var sdkContainer = containerRef.current;
        sdkInstanceRef.current = sdkInstance = new entry.SdkClass(options);

        if (typeof onCreate === 'function') {
          onCreate(sdkInstance);
        }

        if (container) {
          if (typeof container === 'string') {
            sdkContainer = document.getElementById(container);
          } else {
            sdkContainer = container;
          }
        }

        sdkInstance.renderTo(sdkContainer).then(function () {
          if (sdkContainer) {
            sdkContainer.style.display = 'block';
          }
        });
      }
    })["catch"](function (error) {
      errorCallback && errorCallback(error);
    });
    return function () {
      if (typeof onDestroy === 'function') {
        onDestroy(sdkInstanceRef === null || sdkInstanceRef === void 0 ? void 0 : sdkInstanceRef.current);
      }

      if (autoRender) {
        var _sdkInstanceRef$curre;

        sdkInstanceRef === null || sdkInstanceRef === void 0 ? void 0 : (_sdkInstanceRef$curre = sdkInstanceRef.current) === null || _sdkInstanceRef$curre === void 0 ? void 0 : _sdkInstanceRef$curre.destroy();
      }
    };
  }, []);
  var getLoadingComponent = (0, _react.useMemo)(function () {
    if (loadingComponent) {
      return loadingComponent;
    } else {
      return /*#__PURE__*/_react["default"].createElement(_skeleton["default"], null);
    }
  }, [loadingComponent]);
  return sdkloading && showLoading ? /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, getLoadingComponent) : /*#__PURE__*/_react["default"].createElement("div", {
    ref: containerRef,
    className: "sdk-content",
    style: {
      display: 'none'
    }
  }, ' ');
};

ManifestLoader.defaultProps = {
  options: {},
  showLoading: true,
  autoRender: true
};

var _default = exports["default"] = ManifestLoader;
//# sourceMappingURL=route-manifest-loader.js.map
