import React, { ComponentProps } from 'react';
import { Select } from 'udesk-ui';
declare type OptionType = {
    value: string;
    label: string;
    is_hide?: boolean | undefined;
    subs?: OptionType[] | undefined;
};
declare type PropsInterface = {
    disabled?: Boolean;
    placeholder?: string;
    options: OptionType[];
    optionsMeta?: OptionType[];
    value: string | string[];
    onChange: (value: string[]) => void;
    switchFlag?: boolean;
    fullSelect?: boolean;
} & Omit<ComponentProps<typeof Select>, 'onChange' | 'value'>;
/**
 * 级联组件
 * @param props
 * @param props.value    选中的值
 * @param props.options  option数据
 */
declare const OldCascader: React.FC<PropsInterface>;
export default OldCascader;
