"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ManifestWebpackPlugin = void 0;
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _gitRepoInfo() {
  const data = _interopRequireDefault(require("git-repo-info"));
  _gitRepoInfo = function _gitRepoInfo() {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }
function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return typeof key === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (typeof input !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (typeof res !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _classPrivateFieldLooseBase(receiver, privateKey) { if (!Object.prototype.hasOwnProperty.call(receiver, privateKey)) { throw new TypeError("attempted to use private field on non-instance"); } return receiver; }
var id = 0;
function _classPrivateFieldLooseKey(name) { return "__private_" + id++ + "_" + name; }
var _api = /*#__PURE__*/_classPrivateFieldLooseKey("api");
var _multiMode = /*#__PURE__*/_classPrivateFieldLooseKey("multiMode");
var _startupSdkName = /*#__PURE__*/_classPrivateFieldLooseKey("startupSdkName");
var _sdkConfigs = /*#__PURE__*/_classPrivateFieldLooseKey("sdkConfigs");
var _pluginConfig = /*#__PURE__*/_classPrivateFieldLooseKey("pluginConfig");
var _defaultManifestFilename = /*#__PURE__*/_classPrivateFieldLooseKey("defaultManifestFilename");
class ManifestWebpackPlugin {
  constructor(options) {
    Object.defineProperty(this, _api, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _multiMode, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _startupSdkName, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _sdkConfigs, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _pluginConfig, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _defaultManifestFilename, {
      writable: true,
      value: void 0
    });
    _classPrivateFieldLooseBase(this, _api)[_api] = options.api;
    _classPrivateFieldLooseBase(this, _multiMode)[_multiMode] = options.multipleMode;
    _classPrivateFieldLooseBase(this, _startupSdkName)[_startupSdkName] = options.startupSdkName;
    _classPrivateFieldLooseBase(this, _pluginConfig)[_pluginConfig] = options.pluginConfig;
    _classPrivateFieldLooseBase(this, _sdkConfigs)[_sdkConfigs] = options.sdkConfigs;
    _classPrivateFieldLooseBase(this, _defaultManifestFilename)[_defaultManifestFilename] = options.defaultManifestFilename;
  }
  apply(compiler) {
    var _this = this;
    let startupConfig = _classPrivateFieldLooseBase(this, _sdkConfigs)[_sdkConfigs].find(c => c.filename === _classPrivateFieldLooseBase(this, _startupSdkName)[_startupSdkName]);
    const name = ManifestWebpackPlugin.name;
    compiler.hooks.emit.tapPromise(name, /*#__PURE__*/function () {
      var _ref = _asyncToGenerator(function* (compilation) {
        // 如果是多模式，则为每个sdk生成一个manifest。如果是单模式，则只为启动sdk生成manifest。
        let toWriteManifests = _classPrivateFieldLooseBase(_this, _sdkConfigs)[_sdkConfigs];
        if (!_classPrivateFieldLooseBase(_this, _multiMode)[_multiMode]) {
          toWriteManifests = [startupConfig];
        }
        toWriteManifests.forEach(config => {
          let manifest = generateManifest(compilation.chunks, {
            api: _classPrivateFieldLooseBase(_this, _api)[_api],
            multiMode: _classPrivateFieldLooseBase(_this, _multiMode)[_multiMode],
            sdkConfig: config,
            sdkConfigs: _classPrivateFieldLooseBase(_this, _sdkConfigs)[_sdkConfigs],
            outputFilename: _classPrivateFieldLooseBase(_this, _pluginConfig)[_pluginConfig].outputFilename
          });

          // 默认名称为manifest.json
          let assetName = _classPrivateFieldLooseBase(_this, _defaultManifestFilename)[_defaultManifestFilename];
          if (_classPrivateFieldLooseBase(_this, _multiMode)[_multiMode]) {
            // 如果是多模式，则为每个sdk生成一个manifest，名称为 {sdk}.manifest.json
            assetName = `${config.filename}.${_classPrivateFieldLooseBase(_this, _defaultManifestFilename)[_defaultManifestFilename]}`;
          }

          // todo: 使用合适的Source类型
          compilation.assets[assetName] = {
            source: () => JSON.stringify(manifest),
            size: () => JSON.stringify(manifest).length
          };
        });
        return true;
      });
      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
  }
}
exports.ManifestWebpackPlugin = ManifestWebpackPlugin;
function generateManifest(chunks, {
  api,
  multiMode,
  sdkConfig,
  sdkConfigs,
  outputFilename
}) {
  // 把当前编译sdk的assets生成一个manifest，这样sdk-loader只需要这一个入口了
  let manifest = new SdkManifest();

  // 添加venderScripts
  if (sdkConfig === null || sdkConfig === void 0 ? void 0 : sdkConfig.vendorScripts) {
    if (typeof (sdkConfig === null || sdkConfig === void 0 ? void 0 : sdkConfig.vendorScripts) === 'boolean') {
      [...(api.config.headScripts || []), ...(api.config.scripts || [])].filter(Boolean).forEach(script => {
        if (typeof script === 'string') {
          manifest.js.push(new JSItem({
            src: script
          }));
        } else {
          manifest.js.push(new JSItem(_objectSpread(_objectSpread({}, script), {}, {
            src: script.content ? undefined : script.src
          })));
        }
      });
    } else {
      sdkConfig === null || sdkConfig === void 0 ? void 0 : sdkConfig.vendorScripts.filter(Boolean).forEach(script => {
        if (typeof script === 'string') {
          manifest.js.push(new JSItem({
            src: script
          }));
        } else {
          manifest.js.push(new JSItem(_objectSpread(_objectSpread({}, script), {}, {
            src: script.content ? undefined : script.src
          })));
        }
      });
    }
  }
  if (sdkConfig === null || sdkConfig === void 0 ? void 0 : sdkConfig.vendorStyles) {
    if (typeof (sdkConfig === null || sdkConfig === void 0 ? void 0 : sdkConfig.vendorStyles) === 'boolean') {
      if (api.config.links) {
        api.config.links.filter(Boolean).forEach(link => {
          manifest.css.push(new CssItem(link));
        });
      }
      if (api.config.styles) {
        api.config.styles.filter(Boolean).forEach(style => {
          if (typeof style === 'string') {
            manifest.css.push(new CssItem({
              href: style
            }));
          } else {
            manifest.css.push(new CssItem(style));
          }
        });
      }
    } else {
      sdkConfig === null || sdkConfig === void 0 ? void 0 : sdkConfig.vendorStyles.filter(Boolean).forEach(style => {
        if (typeof style === 'string') {
          manifest.css.push(new CssItem({
            href: style
          }));
        } else {
          manifest.css.push(new CssItem(_objectSpread(_objectSpread({}, style), {}, {
            href: style.content ? undefined : style.href
          })));
        }
      });
    }
  }
  Array.from(chunks).filter(chunk => {
    if (multiMode) {
      // 多sdk模式下，每个sdk就是一个chunk
      return sdkConfigs.some(c => c.filename === chunk.name);
    } else {
      // 单sdk模式下，chunk name取pluginConfig中的outputFilename，默认为index
      return chunk.name === outputFilename || chunk.name || isEntryCss(chunk);
    }
  }).forEach(chunk => {
    let files = Array.from(chunk.files);
    if (files.length > 0) {
      manifest.js.push(...files
      // 以.js结尾
      .filter(f => f.endsWith('.js')).filter(filename => {
        if (multiMode) {
          // 多sdk模式下，查找 {sdk}.*.js 格式的js文件
          return filename.startsWith(`${sdkConfig.filename}.`);
        } else {
          // 单sdk模式下，查找 index.*.js 格式的js文件
          return filename.startsWith(`${outputFilename}.`);
        }
      }).map(filename => {
        if (chunk.name === outputFilename) {
          return new JSItem({
            src: filename,
            isEntry: true // 每个chunk都是入口
          });
        } else {
          return new JSItem({
            src: filename,
            isPreload: true
          });
        }
      }));
      manifest.css.push(...files
      // 以.css结尾
      .filter(f => f.endsWith('.css')).filter(filename => {
        if (multiMode) {
          // 多sdk模式下，查找 {sdk}.*.css 格式的js文件
          return filename.startsWith(`${sdkConfig.filename}.`);
        } else {
          // 单sdk模式下，查找 index.*.css 格式的js文件
          return filename.startsWith(`${outputFilename}.`) || outputFilename;
        }
      }).map(filename => new CssItem({
        href: filename
      })));
    }
  });
  manifest.release = new Release({
    version: getProductVersion()
  });

  // 保存manifest.json
  // if (
  //     (api.env === Env.dev && api.config.devServer && api.config.devServer.writeToDisk) ||
  //     api.env === Env.prod
  // ) {
  //     let content = JSON.stringify(manifest);
  //     let filename = join(outputPath, defaultManifestFilename);
  //     if (pluginConfig.manifestHash) {
  //         const shaObj = new jsSHA('SHA-1', 'TEXT', { encoding: 'UTF8' });
  //         shaObj.update(content);
  //         const hash = shaObj.getHash('HEX');
  //         let file = path.parse(defaultManifestFilename);
  //         filename = join(outputPath, `${file.name}-${hash}${file.ext}`);
  //     }
  //     fs.writeFileSync(filename, content);
  // }
  // console.log(stats?.compilation.chunks);
  return manifest;
}
function getProductVersion() {
  /* Sample data
  {
      sha: '718b42687d49d9b5028969556af159eca8727a51',
      abbreviatedSha: '718b42687d',
      branch: 'feature_CASE_911',
      tag: null,
      committer: '李凤宝 <lifengbao@udesk.cn>',
      committerDate: '2017-10-18T09:38:29.000Z',
      author: '李凤宝 <lifengbao@udesk.cn>',
      authorDate: '2017-10-18T09:38:29.000Z',
      commitMessage: 'Some commit message',
      root: '/home/user/Documents/udesk_ember_cli' 
  }
  */
  let gitInfo = (0, _gitRepoInfo().default)();
  let today = new Date();
  let year = today.getFullYear() % 100;
  let month = today.getMonth() + 1;
  let day = today.getDate();
  return `${year}.${month}.${day}.${today.getTime()}-${gitInfo.abbreviatedSha}`;
}
class SdkManifest {
  constructor() {
    this.js = [];
    this.css = [];
    this.version = '1.0';
    this.release = void 0;
  }
}
class JSItem {
  constructor(init) {
    this.isEntry = false;
    this.isPreload = false;
    this.destroyable = true;
    this.src = void 0;
    this.content = void 0;
    this.type = void 0;
    this.async = void 0;
    this.defer = void 0;
    this.crossOrigin = void 0;
    this.integrity = void 0;
    this.noModule = void 0;
    this.referrerPolicy = void 0;
    Object.assign(this, init);
  }
}
class CssItem {
  constructor(init) {
    this.destroyable = true;
    this.href = void 0;
    this.content = void 0;
    this.crossOrigin = void 0;
    this.disabled = void 0;
    this.integrity = void 0;
    this.media = void 0;
    this.referrerPolicy = void 0;
    this.rel = void 0;
    this.type = void 0;
    Object.assign(this, init);
  }
}
class Release {
  constructor(init) {
    this.version = '';
    Object.assign(this, init);
  }
}
function isEntryCss(chunk) {
  if (chunk.id && chunk.files) {
    return Array.from(chunk.files).every(fileName => {
      return /\.css/.test(fileName) && !/\.chunk\.css/.test(fileName);
    });
  } else {
    return false;
  }
}