"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SdkVersionWebpackPlugin = void 0;
function _react() {
  const data = _interopRequireDefault(require("react"));
  _react = function _react() {
    return data;
  };
  return data;
}
function _gitRepoInfo() {
  const data = _interopRequireDefault(require("git-repo-info"));
  _gitRepoInfo = function _gitRepoInfo() {
    return data;
  };
  return data;
}
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }
function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }
function _classPrivateFieldLooseBase(receiver, privateKey) { if (!Object.prototype.hasOwnProperty.call(receiver, privateKey)) { throw new TypeError("attempted to use private field on non-instance"); } return receiver; }
var id = 0;
function _classPrivateFieldLooseKey(name) { return "__private_" + id++ + "_" + name; }
var _api = /*#__PURE__*/_classPrivateFieldLooseKey("api");
var _pluginConfig = /*#__PURE__*/_classPrivateFieldLooseKey("pluginConfig");
class SdkVersionWebpackPlugin {
  constructor(options) {
    Object.defineProperty(this, _api, {
      writable: true,
      value: void 0
    });
    Object.defineProperty(this, _pluginConfig, {
      writable: true,
      value: void 0
    });
    _classPrivateFieldLooseBase(this, _api)[_api] = options.api;
    _classPrivateFieldLooseBase(this, _pluginConfig)[_pluginConfig] = options.pluginConfig;
  }
  apply(compiler) {
    var _this = this;
    const name = SdkVersionWebpackPlugin.name;
    compiler.hooks.emit.tapPromise(name, /*#__PURE__*/function () {
      var _ref = _asyncToGenerator(function* (compilation) {
        let sdkVersion = _classPrivateFieldLooseBase(_this, _pluginConfig)[_pluginConfig].version;
        compilation.assets['VERSION'] = {
          source: () => sdkVersion,
          size: () => sdkVersion.length
        };
        let releaseVersion = getProductVersion();
        compilation.assets['RELEASE-VERSION'] = {
          source: () => releaseVersion,
          size: () => releaseVersion.length
        };
        return true;
      });
      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
  }
}
exports.SdkVersionWebpackPlugin = SdkVersionWebpackPlugin;
function getProductVersion() {
  /* Sample data
  {
      sha: '718b42687d49d9b5028969556af159eca8727a51',
      abbreviatedSha: '718b42687d',
      branch: 'feature_CASE_911',
      tag: null,
      committer: '李凤宝 <lifengbao@udesk.cn>',
      committerDate: '2017-10-18T09:38:29.000Z',
      author: '李凤宝 <lifengbao@udesk.cn>',
      authorDate: '2017-10-18T09:38:29.000Z',
      commitMessage: 'Some commit message',
      root: '/home/user/Documents/udesk_ember_cli' 
  }
  */
  let gitInfo = (0, _gitRepoInfo().default)();
  let today = new Date();
  let year = today.getFullYear() % 100;
  let month = today.getMonth() + 1;
  let day = today.getDate();
  return `${year}.${month}.${day}.${today.getTime()}-${gitInfo.abbreviatedSha}`;
}