"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ruRUIntl = exports.msMYIntl = exports.jaJPIntl = exports.itITIntl = exports.esESIntl = exports.enUSIntl = exports["default"] = exports.createIntl = exports.IntlProvider = exports.IntlConsumer = void 0;
exports.useIntl = useIntl;
exports.zhTWIntl = exports.zhCNIntl = exports.viVNIntl = void 0;

var _react = _interopRequireWildcard(require("react"));

var _zh_CN = _interopRequireDefault(require("../../locale/zh_CN"));

var _en_US = _interopRequireDefault(require("../../locale/en_US"));

var _vi_VN = _interopRequireDefault(require("../../locale/vi_VN"));

var _it_IT = _interopRequireDefault(require("../../locale/it_IT"));

var _ja_JP = _interopRequireDefault(require("../../locale/ja_JP"));

var _es_ES = _interopRequireDefault(require("../../locale/es_ES"));

var _ru_RU = _interopRequireDefault(require("../../locale/ru_RU"));

var _ms_MY = _interopRequireDefault(require("../../locale/ms_MY"));

var _zh_TW = _interopRequireDefault(require("../../locale/zh_TW"));

var _util = require("../util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }

function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function get(source, path, defaultValue) {
  // a[3].b -> a.3.b
  var paths = path.replace(/\[(\d+)\]/g, '.$1').split('.');
  var result = source;
  var message = defaultValue; // eslint-disable-next-line no-restricted-syntax

  var _iterator = _createForOfIteratorHelper(paths),
      _step;

  try {
    for (_iterator.s(); !(_step = _iterator.n()).done;) {
      var p = _step.value;
      message = Object(result)[p];
      result = Object(result)[p];

      if (message === undefined) {
        return defaultValue;
      }
    }
  } catch (err) {
    _iterator.e(err);
  } finally {
    _iterator.f();
  }

  return message;
}
/**
 * 创建一个操作函数
 * @param locale
 * @param localeMap
 */


var createIntl = exports.createIntl = function createIntl(locale, localeMap) {
  return {
    getMessage: function getMessage(id, defaultMessage) {
      return get(localeMap, id, defaultMessage) || defaultMessage;
    },
    locale: locale
  };
};

var zhCNIntl = exports.zhCNIntl = createIntl('zh_CN', _zh_CN["default"]);
var enUSIntl = exports.enUSIntl = createIntl('en_US', _en_US["default"]);
var viVNIntl = exports.viVNIntl = createIntl('vi_VN', _vi_VN["default"]);
var itITIntl = exports.itITIntl = createIntl('it_IT', _it_IT["default"]);
var jaJPIntl = exports.jaJPIntl = createIntl('ja_JP', _ja_JP["default"]);
var esESIntl = exports.esESIntl = createIntl('es_ES', _es_ES["default"]);
var ruRUIntl = exports.ruRUIntl = createIntl('ru_RU', _ru_RU["default"]);
var msMYIntl = exports.msMYIntl = createIntl('ms_MY', _ms_MY["default"]);
var zhTWIntl = exports.zhTWIntl = createIntl('zh_TW', _zh_TW["default"]);
var intlMap = {
  'zh-CN': zhCNIntl,
  'en-US': enUSIntl,
  'vi-VN': viVNIntl,
  'it-IT': itITIntl,
  'js-JP': jaJPIntl,
  'es-ES': esESIntl,
  'ru-RU': ruRUIntl,
  'ms-MY': msMYIntl,
  'zh-TW': zhTWIntl
};

var IntlContext = /*#__PURE__*/_react["default"].createContext(intlMap[(0, _util.getLang)() || ''] || zhCNIntl);

var IntlConsumer = exports.IntlConsumer = IntlContext.Consumer,
    IntlProvider = exports.IntlProvider = IntlContext.Provider;

function useIntl() {
  var intl = (0, _react.useContext)(IntlContext);
  return intl;
}

var _default = exports["default"] = IntlContext;
//# sourceMappingURL=index.js.map
