import { __assign, __rest } from "tslib";
import React, { useCallback, useEffect, useState, useMemo } from 'react';
import { Select } from 'udesk-ui';
import CopyComponent from '@udesk-webapp/copy-content';
import cssObj from './index.module.scss';
var Option = Select.Option;
var Filed_droplistRadio = function (_a) {
    var _b;
    var notUseDefault = _a.notUseDefault, options = _a.options, onChange = _a.onChange, switchFlag = _a.switchFlag, value = _a.value, hiddenLabelPath = _a.hiddenLabelPath, optionValuePath = _a.optionValuePath, props = __rest(_a, ["notUseDefault", "options", "onChange", "switchFlag", "value", "hiddenLabelPath", "optionValuePath"]);
    // 选择的选项值
    var _c = useState(''), selectValue = _c[0], setSelectValue = _c[1];
    var _d = useState(''), copyText = _d[0], setCopyText = _d[1];
    var viewType = props.viewType;
    var showOptions = useMemo(function () {
        if (!Array.isArray(options)) {
            return [];
        }
        return options.filter(function (option) {
            var isHide = hiddenLabelPath && option[hiddenLabelPath];
            var isSelected = false;
            // 有没有值是数组形式待确认
            if (Array.isArray(value)) {
                isSelected = !!(optionValuePath && value.includes(option[optionValuePath]));
            }
            else {
                isSelected = !!(optionValuePath && option[optionValuePath] == value);
            }
            return !isHide || isSelected;
        });
    }, [options, hiddenLabelPath, value]);
    useEffect(function () {
        var value = Array.isArray(selectValue) ? selectValue.join(',') : selectValue;
        // 先清空copytext
        setCopyText('');
        options === null || options === void 0 ? void 0 : options.forEach(function (item) {
            if (optionValuePath && item[optionValuePath] === value) {
                setCopyText(item.title);
            }
        });
    }, [options, selectValue, optionValuePath]);
    // 监听道选项改变 处理数据   取出其中默认选项  复制给Radio.Group的value  主要是外部新建字段  改变默认选项时触发  改变展示效果
    useEffect(function () {
        // 如果有值传进来 优先使用传进来的值  否则从选项中找道默认选项
        if (value) {
            setSelectValue(value);
        }
        else {
            // 如果禁止使用默认值，直接不进行默认值处理
            if (notUseDefault)
                return;
            options === null || options === void 0 ? void 0 : options.forEach(function (item) {
                if (item.default) {
                    if (optionValuePath) {
                        setSelectValue(item[optionValuePath]);
                    }
                }
            });
        }
    }, [options, notUseDefault, value]);
    var selectOnChange = useCallback(function (e) {
        setSelectValue(e);
        if (onChange)
            onChange(e);
    }, [onChange]);
    // 多选默认值必须为空数组，特殊处理
    if (viewType === 1) {
        if (!selectValue) {
            selectValue = [];
        }
        if (selectValue && !Array.isArray(selectValue)) {
            selectValue = selectValue.split(',');
        }
    }
    return (React.createElement(CopyComponent, { text: copyText, switchFlag: switchFlag, noHidden: true },
        React.createElement(Select, __assign({ value: selectValue, onChange: selectOnChange, showSearch: options ? options.length > 8 : false, filterOption: function (input, option) { var _a, _b; return (_b = (_a = option === null || option === void 0 ? void 0 : option.label) === null || _a === void 0 ? void 0 : _a.toLowerCase()) === null || _b === void 0 ? void 0 : _b.includes(input.toLowerCase()); }, allowClear: true }, props, { mode: viewType === 1 ? 'multiple' : props.mode }), (_b = showOptions === null || showOptions === void 0 ? void 0 : showOptions.map(function (item) { return (React.createElement(Option, { key: optionValuePath && item[optionValuePath], value: optionValuePath && item[optionValuePath], label: item.title },
            React.createElement("span", { className: "".concat(cssObj['select-item'], " ").concat(item.color ? cssObj['select-item-hascolor'] : ''), style: {
                    background: item.color ? item.color : '',
                } },
                item.icon ? (React.createElement("img", { alt: '', src: item.icon, className: cssObj['setting-img'] })) : (''),
                item.title))); })) !== null && _b !== void 0 ? _b : null)));
};
Filed_droplistRadio.defaultProps = {
    hiddenLabelPath: 'is_hide',
    optionValuePath: 'value',
    switchFlag: false,
    dropdownMatchSelectWidth: true,
    notUseDefault: true,
    options: [],
    style: { width: '100%' },
    getPopupContainer: function (triggerNode) { return triggerNode; },
};
export default Filed_droplistRadio;
