"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _moment = _interopRequireDefault(require("moment"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var defaultRanges = [{
  name: '今日',
  key: 'TODAY',
  value: [(0, _moment["default"])().startOf('day'), (0, _moment["default"])().endOf('day')]
}, {
  name: '昨日',
  key: 'YESTODAY',
  value: [(0, _moment["default"])().subtract(1, 'days').startOf('day'), (0, _moment["default"])().subtract(1, 'days').endOf('day')]
}, {
  name: '当周',
  key: 'THIS_WEEK',
  value: [(0, _moment["default"])().subtract(Number((0, _moment["default"])().format('E')) - 1, 'days').startOf('day'), (0, _moment["default"])().add(7 - Number((0, _moment["default"])().format('E')), 'days').endOf('day')]
}, {
  name: '上周',
  key: 'LAST_WEEK',
  value: [(0, _moment["default"])().subtract(Number((0, _moment["default"])().format('E')) + 6, 'days').startOf('day'), (0, _moment["default"])().subtract(Number((0, _moment["default"])().format('E')), 'days').endOf('day')]
}, {
  name: '当月',
  key: 'THIS_MONTH',
  value: [(0, _moment["default"])().startOf('month').startOf('day'), (0, _moment["default"])().endOf('month').endOf('day')]
}, {
  name: '上月',
  key: 'LAST_MONTH',
  value: [(0, _moment["default"])().subtract(1, 'month').startOf('month').startOf('day'), (0, _moment["default"])().subtract(1, 'month').endOf('month').endOf('day')]
}, {
  name: '今年',
  key: 'THIS_YEAR',
  value: [(0, _moment["default"])().startOf('year').startOf('day'), (0, _moment["default"])().endOf('year').endOf('day')]
}, {
  name: '去年',
  key: 'LAST_YEAR',
  value: [(0, _moment["default"])().subtract(1, 'year').startOf('year').startOf('day'), (0, _moment["default"])().subtract(1, 'year').endOf('year').endOf('day')]
}, {
  name: '近7日',
  key: 'NEARLY_SEVENT_DAYS',
  value: [(0, _moment["default"])().subtract(6, 'days').startOf('day'), (0, _moment["default"])().endOf('day')]
}, {
  name: '过去7日',
  key: 'PAST_SEVEN_DAYS',
  value: [(0, _moment["default"])().subtract(7, 'days').startOf('day'), (0, _moment["default"])().subtract(1, 'days').endOf('day')]
}, {
  name: '近30日',
  key: 'NEARLY_THIRTY_DAYS',
  value: [(0, _moment["default"])().subtract(29, 'days').startOf('day'), (0, _moment["default"])().endOf('day')]
}, {
  name: '过去30日',
  key: 'PAST_THIRTY_DAYS',
  value: [(0, _moment["default"])().subtract(30, 'days').startOf('day'), (0, _moment["default"])().subtract(1, 'days').endOf('day')]
}, {
  name: '近90日',
  key: 'NEARLY_NINETY_DAYS',
  value: [(0, _moment["default"])().subtract(89, 'days').startOf('day'), (0, _moment["default"])().endOf('day')]
}, {
  name: '过去90日',
  key: 'PAST_NINETY_DAYS',
  value: [(0, _moment["default"])().subtract(90, 'days').startOf('day'), (0, _moment["default"])().subtract(1, 'days').endOf('day')]
}];

var _default = exports["default"] = defaultRanges;