"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _configProvider = _interopRequireDefault(require("../config-provider"));

var _config = require("./config");

var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));

var _immutable = require("immutable");

var _moment = _interopRequireDefault(require("moment"));

var _enums = _interopRequireDefault(require("./enums"));

var _datePicker = _interopRequireDefault(require("../date-picker"));

var _button = _interopRequireDefault(require("../button"));

var _tabs = _interopRequireDefault(require("../tabs"));

var _space = _interopRequireDefault(require("../space"));

var _excluded = ["dateRanges", "dateRangesNameField", "dateRangesKeyField", "dateRangesValueField", "dateType", "staticDateOpen", "dynamicDateOpen", "value", "format", "open", "onOpenChange"];

var _this = void 0;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache(e) { if ("function" != typeof WeakMap) return null; var r = new WeakMap(), t = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(e) { return e ? t : r; })(e); }

function _interopRequireWildcard(e, r) { if (!r && e && e.__esModule) return e; if (null === e || "object" != _typeof(e) && "function" != typeof e) return { "default": e }; var t = _getRequireWildcardCache(r); if (t && t.has(e)) return t.get(e); var n = { __proto__: null }, a = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var u in e) if ("default" !== u && {}.hasOwnProperty.call(e, u)) { var i = a ? Object.getOwnPropertyDescriptor(e, u) : null; i && (i.get || i.set) ? Object.defineProperty(n, u, i) : n[u] = e[u]; } return n["default"] = e, t && t.set(e, n), n; }

function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }

function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }

function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toPropertyKey(t) { var i = _toPrimitive(t, "string"); return "symbol" == _typeof(i) ? i : i + ""; }

function _toPrimitive(t, r) { if ("object" != _typeof(t) || !t) return t; var e = t[Symbol.toPrimitive]; if (void 0 !== e) { var i = e.call(t, r || "default"); if ("object" != _typeof(i)) return i; throw new TypeError("@@toPrimitive must return a primitive value."); } return ("string" === r ? String : Number)(t); }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }

function _iterableToArrayLimit(r, l) { var t = null == r ? null : "undefined" != typeof Symbol && r[Symbol.iterator] || r["@@iterator"]; if (null != t) { var e, n, i, u, a = [], f = !0, o = !1; try { if (i = (t = t.call(r)).next, 0 === l) { if (Object(t) !== t) return; f = !1; } else for (; !(f = (e = i.call(t)).done) && (a.push(e.value), a.length !== l); f = !0); } catch (r) { o = !0, n = r; } finally { try { if (!f && null != t["return"] && (u = t["return"](), Object(u) !== u)) return; } finally { if (o) throw n; } } return a; } }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

var RangePicker = _datePicker["default"].RangePicker;
var TabPane = _tabs["default"].TabPane;
var smartTimeType = _enums["default"].smartTimeType,
    dateChangeOrigin = _enums["default"].dateChangeOrigin;
var DATE_FORMATE = 'YYYY/MM/DD'; // value日期格式：
// 静态日期：dates:[moment.MomentInput, moment.MomentInput], dateStrings: [YYYY/MM/DD, YYYY/MM/DD]
// 动态日期：
//  【快捷选择日期】- dates: [-7,-1], dateStrings: '过去7日-过去1日';
//  【自定义日期】 - dates: [-5,10], dateStrings: '过去5日-未来10日';

var defaultProps = {
  dateRanges: _config.defaultSmartRange,
  dateRangesNameField: 'name',
  dateRangesKeyField: 'key',
  dateRangesValueField: 'value',
  dateType: 'STATIC',
  value: [],
  staticDateOpen: true,
  dynamicDateOpen: true,
  onChange: function onChange() {},
  format: DATE_FORMATE,
  open: undefined,
  onOpenChange: function onOpenChange() {}
};

var SmartRangePicker = function SmartRangePicker(props) {
  var dateRanges = props.dateRanges,
      dateRangesNameField = props.dateRangesNameField,
      dateRangesKeyField = props.dateRangesKeyField,
      dateRangesValueField = props.dateRangesValueField,
      dateType = props.dateType,
      staticDateOpen = props.staticDateOpen,
      dynamicDateOpen = props.dynamicDateOpen,
      value = props.value,
      format = props.format,
      open = props.open,
      onOpenChange = props.onOpenChange,
      otherProps = _objectWithoutProperties(props, _excluded);

  var configContext = (0, _react.useContext)(_configProvider["default"].ConfigContext);
  var smartPickerWrapperRef = (0, _react.useRef)(null);
  var smartPickerPanelRef = (0, _react.useRef)(null);
  var isChanging = (0, _react.useRef)(false); // 可选日期类型状态初始化

  var filterCustomDateType = function filterCustomDateType(staticDateOpen, dynamicDateOpen, smartTimeType) {
    var cloneCustomTimeType = (0, _cloneDeep["default"])(smartTimeType);

    if (staticDateOpen === false) {
      if (cloneCustomTimeType[smartTimeType['STATIC'].key]) {
        cloneCustomTimeType[smartTimeType['STATIC'].key]['disabled'] = true;
      }
    }

    if (dynamicDateOpen === false) {
      if (cloneCustomTimeType[smartTimeType['DYNAMIC'].key]) {
        cloneCustomTimeType[smartTimeType['DYNAMIC'].key]['disabled'] = true;
      }
    }

    return cloneCustomTimeType;
  };
  /**
   * 自定义日期格式化方法
   * @param {number} day 日期
   */


  var formatCustomValueObj = function formatCustomValueObj(day) {
    if (!Number.isNaN(Number(day))) {
      return (0, _moment["default"])().add(Number(day), 'day');
    } else {
      return null;
    }
  };
  /**
   * 日期分类格式化
   * @param {moment} value 待格式化日期
   * @param {string} dateType 日期类型
   */


  var _formatDateValue = (0, _react.useCallback)(function (value, dateType) {
    // 根据日期类型，格式化日期返回值，同时生成日期字符
    switch (dateType) {
      case smartTimeType['DYNAMIC'].key:
        {
          if (typeof value === 'string') {
            // 快捷日期['key']
            if (Array.isArray(dateRanges) && dateRanges.length) {
              var rang = dateRanges.find(function (item) {
                return item[dateRangesKeyField] === value;
              });

              if (rang) {
                return rang[dateRangesValueField];
              }
            }
          } else if (Array.isArray(value) && value.length) {
            // 自定义日期
            var _value = _slicedToArray(value, 2),
                _value$ = _value[0],
                customDateA = _value$ === void 0 ? null : _value$,
                _value$2 = _value[1],
                customDateB = _value$2 === void 0 ? null : _value$2;

            var values = [];
            if (customDateA != null && customDateA !== '') values[0] = formatCustomValueObj(customDateA);
            if (customDateB != null && customDateB !== '') values[1] = formatCustomValueObj(customDateB);
            return values;
          }

          break;
        }

      case smartTimeType['STATIC'].key:
      default:
        {
          if (Array.isArray(value) && value.length) {
            return value.filter(function (item) {
              return item != null && item !== '';
            });
          }

          break;
        }
    }
  }, [dateRanges, dateRangesKeyField, dateRangesValueField]);
  /**
   * 时间类型选初始化方法
   * @param {string} propsDateType 日期类型
   */


  var initDateTypeActiveKey = function initDateTypeActiveKey(propsDateType) {
    // 如果传了，则使用传入的；如果没有传，则使用可用的第一个；如果没有可用，则报错
    var filterCustomDateTypes = filterCustomDateType(staticDateOpen, dynamicDateOpen, smartTimeType);
    var availableCustomDateType = Object.values(filterCustomDateTypes).filter(function (item) {
      return !item.disabled;
    });

    if (propsDateType && availableCustomDateType.some(function (item) {
      return item.key === propsDateType;
    })) {
      return propsDateType;
    } else {
      return availableCustomDateType[0].key;
    }
  }; // 初始化日期类型


  var _useState = (0, _react.useState)(function () {
    return initDateTypeActiveKey((dateType + '').toLocaleUpperCase());
  }),
      _useState2 = _slicedToArray(_useState, 2),
      dateTypeActiveKey = _useState2[0],
      setDateTypeActiveKey = _useState2[1]; // props
  // 初始化日期类型枚举集


  var customDateType = (0, _react.useMemo)(function () {
    return filterCustomDateType(staticDateOpen, dynamicDateOpen, smartTimeType);
  }, [dynamicDateOpen, staticDateOpen]);
  /**
   * 动态日期数据生成函数
   * @param {moment} compareDate  对比日期
   * @param {moment} referenceDate 基准日期
   * @param {string} outputType 输出类型[string/number]
   */

  var _handleDynamicDateCreate = (0, _react.useCallback)(function (compareDate, referenceDate, outputType) {
    // 对比日期校验
    if (!(0, _moment["default"])(compareDate).isValid() || !(0, _moment["default"])(referenceDate).isValid()) {
      return null;
    }

    switch (outputType) {
      case 'string':
        // 过去;
        if ((0, _moment["default"])(compareDate).isBefore(referenceDate, 'd')) {
          return "\u8FC7\u53BB".concat(Math.abs((0, _moment["default"])((0, _moment["default"])(compareDate).format(props.format)).diff((0, _moment["default"])(referenceDate).format(props.format), 'd')), "\u65E5");
        } // 今日


        if ((0, _moment["default"])(compareDate).isSame(referenceDate, 'd')) return "\u4ECA\u65E5"; // 未来

        if ((0, _moment["default"])(compareDate).isAfter(referenceDate, 'd')) {
          return "\u672A\u6765".concat((0, _moment["default"])((0, _moment["default"])(compareDate).format(props.format)).diff((0, _moment["default"])((0, _moment["default"])(referenceDate).format(props.format)), 'd'), "\u65E5");
        }

        break;

      case 'number':
      default:
        // 过去
        if ((0, _moment["default"])(compareDate).isBefore(referenceDate, 'd')) {
          return (0, _moment["default"])((0, _moment["default"])(compareDate).format(props.format)).diff((0, _moment["default"])((0, _moment["default"])(referenceDate).format(props.format)), 'd');
        } // 今日


        if ((0, _moment["default"])(compareDate).isSame(referenceDate, 'd')) {
          return 0;
        } // 未来


        if ((0, _moment["default"])(compareDate).isAfter(referenceDate, 'd')) {
          return (0, _moment["default"])((0, _moment["default"])(compareDate).format(props.format)).diff((0, _moment["default"])((0, _moment["default"])(referenceDate).format(props.format)), 'd');
        }

        break;
    }
  }, [props.format]);
  /**
   * 动态日期计算
   * @param {moment} paramDate 对比日期
   * @param {moment} referenceDate 基准日期
   * @param {string} createType 生成类型[string:动态日期字符串；default: array]
   */


  var _calculateDynamicDate = (0, _react.useCallback)(function (paramDate, referenceDate, createType) {
    // 默认基准日期
    var cloneReferenceDate = (0, _moment["default"])().format(props.format); // 默认生成类型

    var cloneCreateType = 'number'; // 覆盖基准日期

    if (referenceDate && (0, _moment["default"])(referenceDate).isValid()) {
      cloneReferenceDate = (0, _immutable.Map)(referenceDate).toJS();
    } // 覆盖生成类型


    if (createType && createType !== 'number') {
      cloneCreateType = createType;
    }

    return _handleDynamicDateCreate(paramDate, cloneReferenceDate, cloneCreateType);
  }, [_handleDynamicDateCreate, props.format]);
  /**
   * 日期返回值格式化
   * @param {moment} handleValue 待处理日期范围值数组
   * @param {string[]} handleValueString 待处理日期范围字符串数组
   * @param {object} handleRangeData 待处理当前选择的预设快捷对象
   * @param {string} changeOriginFrom 日期选择来源（快捷预设or日期面板）
   */


  var handleDateValueFormat = (0, _react.useCallback)(function (handleValue, handleRangeData, changeOriginFrom) {
    var format = props.format;
    var dates = [];
    var dateStrings = ['', ''];
    var rangeDatas = handleRangeData;
    var originFromDatas = changeOriginFrom ? changeOriginFrom : dateChangeOrigin['PANEL'].key; // 静态类型

    if (dateTypeActiveKey === smartTimeType['STATIC'].key) {
      dates = Array.isArray(handleValue) ? (0, _immutable.List)(handleValue).toJS() : [];
      dateStrings = Array.isArray(handleValue) ? (0, _immutable.List)(handleValue.map(function (item) {
        return (0, _moment["default"])(item).format(format);
      })).toJS() : ['', ''];
    } // 动态类型


    if (dateTypeActiveKey === smartTimeType['DYNAMIC'].key) {
      // 对日期做动态转化
      var dateArr = Array.isArray(handleValue) ? handleValue.map(function (item) {
        return _calculateDynamicDate(item, null, 'number');
      }) : null;
      var dateStr = Array.isArray(handleValue) ? handleValue.map(function (item) {
        return _calculateDynamicDate(item, null, 'string');
      }) : '';
      dates = dateArr; //[-2,5]

      dateStrings = Array.isArray(dateStr) ? dateStr.join('-') : dateStr; //dateStrings为自定义动态日期字符串，例如：'过去x日-未来x日'
    }

    return {
      dates: dates,
      dateStrings: dateStrings,
      rangeDatas: rangeDatas,
      originFromDatas: originFromDatas
    };
  }, [_calculateDynamicDate, dateTypeActiveKey, props]);
  /**
   * 创建日期信息对象
   * @param {moment} dateValue 待处理日期范围值数组
   * @param {string[]} selectRange 待处理日期范围字符串数组
   * @param {object} changeOrigin 待处理当前选择的预设快捷对象
   * @param {string} dateTypeActiveKey 当前日期类型
   */

  var _useState3 = (0, _react.useState)(dateChangeOrigin['PANEL'].key),
      _useState4 = _slicedToArray(_useState3, 2),
      changeOrigin = _useState4[0],
      setChangeOrigin = _useState4[1];

  var createComfirmObjStore = function createComfirmObjStore(_ref) {
    var dateValue = _ref.dateValue,
        selectRange = _ref.selectRange,
        changeOrigin = _ref.changeOrigin,
        dateTypeActiveKey = _ref.dateTypeActiveKey;
    var format = props.format;

    if (dateValue) {
      var _handleDateValueForma = handleDateValueFormat(dateValue, selectRange, changeOrigin),
          dates = _handleDateValueForma.dates,
          dateStrings = _handleDateValueForma.dateStrings,
          rangeDatas = _handleDateValueForma.rangeDatas,
          originFromDatas = _handleDateValueForma.originFromDatas;

      return {
        // 按类格式化日期对象
        date: dates,
        dateString: dateStrings,
        // moment日期对象
        momentDate: dateValue,
        momentDateString: Array.isArray(dateValue) && dateValue.length ? dateValue.map(function (item) {
          return (0, _moment["default"])(item).format(format);
        }) : ['', ''],
        // 其他参数
        dateType: dateTypeActiveKey,
        rangSelect: rangeDatas,
        dateOperateOrigin: originFromDatas
      };
    } else {
      return null;
    }
  }; // 初始化value存储值


  var _useState5 = (0, _react.useState)(function () {
    return createComfirmObjStore({
      dateValue: _formatDateValue(value, (dateType + '').toLocaleUpperCase()),
      selectRange: null,
      changeOrigin: dateChangeOrigin['PANEL'].key,
      dateTypeActiveKey: (dateType + '').toLocaleUpperCase()
    });
  }),
      _useState6 = _slicedToArray(_useState5, 2),
      comfirmObjStore = _useState6[0],
      setComfirmObjStore = _useState6[1]; // 日期面板显示状态初始化


  var _useState7 = (0, _react.useState)(),
      _useState8 = _slicedToArray(_useState7, 2),
      panelVisible = _useState8[0],
      setPanelVisible = _useState8[1];

  (0, _react.useEffect)(function () {
    setPanelVisible(!!open);
  }, [open]); // 监听value变化更新dateValue

  var _useState9 = (0, _react.useState)(function () {
    return _formatDateValue(value, (dateType + '').toLocaleUpperCase());
  }),
      _useState10 = _slicedToArray(_useState9, 2),
      dateValue = _useState10[0],
      setDateValue = _useState10[1];

  (0, _react.useEffect)(function () {
    setDateValue(_formatDateValue(value, (dateType + '').toLocaleUpperCase()));
  }, [_formatDateValue, value, dateType]); // 比较两日期值是否相同

  var _isSameDate = (0, _react.useCallback)(function (momentRangeA, momentRangeB) {
    if (momentRangeA && momentRangeB && Array.isArray(momentRangeA) && Array.isArray(momentRangeB)) {
      var isSame = momentRangeA.map(function (item) {
        return (0, _moment["default"])(item).format(props.format);
      }).join('-') === momentRangeB.map(function (item) {
        return (0, _moment["default"])(item).format(props.format);
      }).join('-');
      return isSame;
    }

    return false;
  }, [props.format]); // 格式化预设日期选项列表，增加高亮属性


  var _formatDateRangeList = (0, _react.useCallback)(function (dateValue, rangeList) {
    var newList = [];

    if (Array.isArray(rangeList) && rangeList.length) {
      newList = rangeList.map(function (item) {
        return _objectSpread(_objectSpread({}, item), {}, {
          _isSmartRangeActiveLight: _isSameDate(dateValue, item[props.dateRangesValueField])
        });
      });
    }

    return newList;
  }, [_isSameDate, props.dateRangesValueField]); // 监听dateValue值改变，更新dateRangeList


  var dateRangeList = (0, _react.useMemo)(function () {
    return _formatDateRangeList(dateValue, dateRanges);
  }, [_formatDateRangeList, dateRanges, dateValue]); // 动态生成选择日期的字符串

  var tabExtraContent = (0, _react.useMemo)(function () {
    var dateStringArr = '';
    var format = props.format;

    if (Array.isArray(dateValue) && dateValue.every(function (item) {
      return !!item && (0, _moment["default"])(item).isValid();
    })) {
      switch ((dateTypeActiveKey + '').toLocaleUpperCase()) {
        case smartTimeType['STATIC'].key:
          {
            dateStringArr = dateValue.map(function (item) {
              return (0, _moment["default"])(item).format(format);
            }).join('-');
            break;
          }

        case smartTimeType['DYNAMIC'].key:
          {
            dateStringArr = "".concat(dateValue.map(function (item) {
              return _calculateDynamicDate(item, null, 'string');
            }).join('-'), " | ").concat(dateValue.map(function (item) {
              return (0, _moment["default"])(item).format(format);
            }).join('-'));
            break;
          }

        default:
          return '';
      }
    }

    return /*#__PURE__*/_react["default"].createElement("span", {
      style: {
        color: 'rgba(0,0,0,0.45)'
      }
    }, dateStringArr);
  }, [_calculateDynamicDate, dateTypeActiveKey, dateValue, props]);
  /**
   * 时间类型选择
   * @param {string} activeKey 当前活跃tabKey
   */

  var onTimeTypeChange = function onTimeTypeChange(activeKey) {
    setDateTypeActiveKey(activeKey);
  }; // 重置初始值


  var resetDateValue = function resetDateValue() {
    // 如果存在上一次确定选择的日期值，则返显上一次确定选择的日期值；否则返显value值
    if (comfirmObjStore) {
      var comfirmDateType = comfirmObjStore.dateType,
          rangSelect = comfirmObjStore.rangSelect,
          dateOperateOrigin = comfirmObjStore.dateOperateOrigin,
          momentDate = comfirmObjStore.momentDate;
      setCurrentRang(rangSelect);
      setChangeOrigin(dateOperateOrigin);
      setDateTypeActiveKey(comfirmDateType);
      setTimeout(function () {
        setDateValue(momentDate);
      }, 0);
    } else {
      setDateValue(dateValue);
    }
  }; // 清空日期


  var clearDateValue = function clearDateValue() {
    setDateValue([]);
    setCurrentRang(null);
    setChangeOrigin(dateChangeOrigin['PANEL'].key);
    setDateTypeActiveKey(smartTimeType['STATIC'].key);
    setComfirmObjStore(null);
  };
  /**
   * 日期修改
   * @param {moment} date 修改后的日期数据
   * @param {object} rangeData 选择的快捷预设对象
   * @param {string} dateOrigin 日期修改操作来源
   */
  // const [isChanging, setIsChanging] = useState(false);


  var _onDateChange = function _onDateChange(date, dateString, info) {
    var rangeData = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
    var dateOrigin = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : dateChangeOrigin['PANEL'].key;
    isChanging.current = true;

    if (date != null) {
      // 更新日期数据
      setDateValue(date); // 更新rangeData

      setCurrentRang(rangeData); // 更新操作来源

      setChangeOrigin(dateOrigin);
    } else {
      isChanging.current = false; // 清空日期值

      clearDateValue();
    }
  }; // 取消


  var onCancelClick = function onCancelClick(e) {
    isChanging.current = false;
    e.stopPropagation(); // 重置dateValue

    resetDateValue();
    setPanelVisible(false);
  }; // 确定


  var _useState11 = (0, _react.useState)(null),
      _useState12 = _slicedToArray(_useState11, 2),
      currentRange = _useState12[0],
      setCurrentRang = _useState12[1];

  var onOkClick = function onOkClick() {
    isChanging.current = false;
    var currentComfirmObjStore = createComfirmObjStore({
      dateValue: dateValue,
      selectRange: currentRange,
      changeOrigin: changeOrigin,
      dateTypeActiveKey: dateTypeActiveKey
    });
    setComfirmObjStore(currentComfirmObjStore);
    var onChange = props.onChange;

    if (typeof onChange === 'function') {
      onChange(currentComfirmObjStore);
    }

    setPanelVisible(false);
  };

  var isCanOk = (0, _react.useMemo)(function () {
    if (Array.isArray(dateValue) && dateValue.filter(function (item) {
      return item != null && item !== '';
    }).length === 2) {
      return true;
    }

    return false;
  }, [dateValue]); // 增加页脚确认取消按钮

  var createExtraFooter = function createExtraFooter(mode) {
    return /*#__PURE__*/_react["default"].createElement("div", {
      className: "smart-date-picker-panel-default-footer"
    }, /*#__PURE__*/_react["default"].createElement(_space["default"], null, /*#__PURE__*/_react["default"].createElement(_button["default"], {
      type: "default",
      size: "small",
      onClick: onCancelClick
    }, "\u53D6\u6D88"), /*#__PURE__*/_react["default"].createElement(_button["default"], {
      type: "primary",
      size: "small",
      onClick: onOkClick,
      disabled: !isCanOk
    }, "\u786E\u5B9A")));
  }; // 面板展开控制


  var onOpenChanged = function onOpenChanged(visible) {
    if (isChanging.current) {
      isChanging.current = false;
    } else {
      setPanelVisible(visible);

      if (typeof onOpenChange === 'function') {
        onOpenChange(visible);
      }
    }
  };
  /**
   * 初始化自定义日期面板
   * @param {reactNode} panelNode 原始日期面板dom
   */


  var initBasePanel = function initBasePanel(panelNode) {
    var format = props.format;
    return /*#__PURE__*/_react["default"].createElement("main", {
      className: "base-render-panel",
      ref: smartPickerPanelRef
    }, /*#__PURE__*/_react["default"].createElement("aside", {
      className: "smart-date-choose-wrapper"
    }, /*#__PURE__*/_react["default"].createElement("h4", {
      className: "choose-title"
    }, "\u5FEB\u901F\u9009\u62E9"), /*#__PURE__*/_react["default"].createElement("ul", null, Array.isArray(dateRangeList) && dateRangeList.map(function (item) {
      return /*#__PURE__*/_react["default"].createElement("li", {
        key: item[dateRangesKeyField]
      }, /*#__PURE__*/_react["default"].createElement(_button["default"], {
        type: "link",
        className: "fast-date-btn ".concat(item['_isSmartRangeActiveLight'] ? 'active' : ''),
        onClick: _onDateChange.bind(_this, item[dateRangesValueField], item[dateRangesValueField].map(function (i) {
          return (0, _moment["default"])(i).format(format);
        }), {}, item, dateChangeOrigin['RANGE'].key)
      }, item[dateRangesNameField]));
    }))), /*#__PURE__*/_react["default"].createElement("section", {
      className: "smart-date-panel-wrapper"
    }, /*#__PURE__*/_react["default"].createElement("header", {
      className: "extra-header"
    }, /*#__PURE__*/_react["default"].createElement(_tabs["default"], {
      activeKey: dateTypeActiveKey,
      onChange: onTimeTypeChange,
      size: "middle",
      tabBarExtraContent: tabExtraContent
    }, Object.prototype.toString.call(customDateType) === '[object Object]' && Object.values(customDateType).length > 0 && Object.values(customDateType).map(function (item) {
      return /*#__PURE__*/_react["default"].createElement(TabPane, {
        tab: item.name,
        key: item.key,
        disabled: item.disabled
      });
    }))), /*#__PURE__*/_react["default"].createElement("section", {
      className: "panel-node-wrapper"
    }, panelNode)));
  };

  return /*#__PURE__*/_react["default"].createElement("div", {
    className: configContext.getPrefixCls('smart-date-picker'),
    ref: smartPickerWrapperRef
  }, /*#__PURE__*/_react["default"].createElement(RangePicker, _objectSpread(_objectSpread({}, otherProps), {}, {
    className: configContext.getPrefixCls('smart-date-range-picker-component'),
    dropdownClassName: configContext.getPrefixCls('smart-date-range-picker-dropdown-wrapper'),
    panelRender: function panelRender(panelNode) {
      return initBasePanel(panelNode);
    },
    onChange: function onChange() {
      return false;
    },
    onCalendarChange: _onDateChange,
    renderExtraFooter: function renderExtraFooter(mode) {
      return createExtraFooter(mode);
    },
    open: panelVisible,
    onOpenChange: onOpenChanged,
    locale: "zh_CN",
    format: props.dateFormat,
    value: dateValue
  })));
};

SmartRangePicker.defaultProps = defaultProps;

var _default = exports["default"] = SmartRangePicker;
//# sourceMappingURL=index.js.map
