import React from 'react';
import { CustomField } from '@udesk-webapp/utils';
import { FIlterCondition as ConditionInterface } from '@udesk-webapp/utils';
import { DataSourcesInterface } from './ticket-filter-condition';
export * from './ticket-filter-condition-utils';
export interface ParamsInterface {
    allConditions?: ConditionInterface[];
    anyConditions?: ConditionInterface[];
    filterId?: string;
}
export interface FilterInterface {
    value?: string | number;
    label: string;
    title?: string;
    allConditions?: ConditionInterface[];
    anyConditions?: ConditionInterface[];
}
interface PropsInterface {
    filterUrl?: string;
    filters?: FilterInterface[];
    getFilters?: () => Promise<FilterInterface[]>;
    allConditions?: ConditionInterface[];
    anyConditions?: ConditionInterface[];
    filterText?: string;
    filterField?: string;
    showFilter?: boolean;
    useFormatCondition?: boolean;
    showCondition?: boolean;
    dataSources?: DataSourcesInterface;
    ticketCustomFields?: any;
    ticketCountField?: string;
    filterLists?: FilterInterface[];
    filterMaxNumber?: number;
    systemFields?: Partial<CustomField>[];
    onSearch?: (params: ParamsInterface) => void;
    onCancelSearch?: () => void;
    onFilterChang?: (params: ParamsInterface) => void;
    filterClassName?: string;
    removalIconClass?: string;
    addIconClass?: string;
    addIconText?: string;
}
declare const TicketFilters: React.FC<PropsInterface>;
export default TicketFilters;
