import React from 'react';
import { FIlterCondition as ConditionInterface } from '@udesk-webapp/utils';
import { DataSourcesInterface } from './ticket-filter-condition';
interface ParamsInterface {
    allConditions?: ConditionInterface[];
    anyConditions?: ConditionInterface[];
    filterId?: string;
}
interface FilterInterface {
    value?: string;
    allConditions: ConditionInterface[];
    anyConditions: ConditionInterface[];
}
interface PropsInterface {
    filterUrl?: string;
    filters?: FilterInterface[];
    getFilters?: () => Promise<FilterInterface[]>;
    allConditions?: ConditionInterface[];
    anyConditions?: ConditionInterface[];
    filterText?: string;
    filterField?: string;
    showFilter?: boolean;
    showCondition?: boolean;
    dataSources?: DataSourcesInterface;
    ticketCustomFields?: any;
    ticketCountField?: string;
    onSearch?: (params: ParamsInterface) => void;
    onCancelSearch?: () => void;
    onFilterChang?: (filterId: number, allConditions: ConditionInterface[], anyConditions: ConditionInterface[]) => void;
}
declare const TicketFilters: React.FC<PropsInterface>;
export default TicketFilters;
