import { FIlterCondition as ConditionInterface } from '@udesk-webapp/utils';
export { formatCondition, createCustomerName, unFormatCondition };
/**
 * 这个方法为业务方提供转换conditions内部的客户和公司的数据格式，也可以业务方通过自己的方法转换好后，传递进来
 *
 * @param {(ConditionInterface[] | undefined)} originalConditions 需要转换的conditions
 * @param {*} conditionFieldField condition的字段属性名
 * @param {*} conditionValueField condition的value属性名
 * @return {*} promise 因为有查询方法，所有返回promise
 */
declare function formatCondition(originalConditions: ConditionInterface[] | undefined, conditionFieldField: any, conditionValueField: any): Promise<unknown>;
declare function createCustomerName(customer: any): string;
/**
 *  将conditions内的客户和公司转换回id的形式，业务方如果有需要可以调用
 * 不更改conditions引用，直接更改的conditions
 * 更改conditions引用会导致整个组件重新渲染，性能低
 *
 * @param {(ConditionInterface[] | undefined)} originalConditions
 * @param {*} conditionFieldField
 * @param {*} conditionValueField
 * @return {*}
 */
declare const unFormatCondition: (originalConditions: ConditionInterface[] | undefined, conditionFieldField: any, conditionValueField: any, copy?: boolean) => ConditionInterface[] | undefined;
