import React from 'react';
import { CustomField, SelectOption } from '@udesk-webapp/utils';
interface ConditionInterface {
}
interface fieldInterface {
    name: string;
    text: string;
    inputType: string;
    contentType: string;
    operators: string[];
    dataSource?: SelectOption[] | undefined | null;
    attributes?: {
        [key: string]: any;
    };
}
export interface DataSourcesInterface {
    priority?: {
        key: string;
        id: number;
        name?: string;
    }[];
    status?: {
        key: string;
        id: number;
        name?: string;
    }[];
    platforms?: {
        key: string;
        id: number;
        name?: string;
    }[];
    satisfaction?: {
        key: string;
        id: number;
        name?: string;
    }[];
    templates?: {
        key: string;
        id: number;
        name?: string;
    }[];
    tags?: {
        key: string;
        id: number;
        name?: string;
    }[];
    forwardEmail?: {
        key: string;
        id: number;
        name?: string;
    }[];
    agents?: any[];
}
interface PropsInterface {
    conditions?: ConditionInterface[];
    showConditionNumber?: boolean;
    autoChooseFirstField?: boolean;
    showConditionHeaders?: boolean;
    showConditionHeadersWhenEmpty?: boolean;
    conditionFieldColumnHeader?: boolean;
    conditionOperatorColumnHeader?: boolean;
    conditionValueColumnHeader?: boolean;
    allowEmptyConditions?: boolean;
    fieldsConfig?: fieldInterface[] | undefined;
    customFields?: CustomField[];
    systemFields?: Partial<CustomField>[];
    customerSystemFields?: Partial<CustomField>[];
    onConditionChanged?: (conditions: ConditionInterface) => void;
    dataSources?: DataSourcesInterface;
    className?: string;
}
declare const TicketFilterCondition: React.FC<PropsInterface>;
export default TicketFilterCondition;
