import React from 'react';
import { CustomField, SelectOption, FIlterCondition as ConditionInterface } from '@udesk-webapp/utils';
export * from '../ticket-filter-condition-utils';
export interface FieldInterface {
    name?: string;
    text?: string;
    inputType?: string;
    contentType?: string;
    operators: string[];
    dataSource?: SelectOption[] | undefined | null;
    attributes?: {
        [key: string]: any;
    };
}
export interface DataSourcesInterface {
    priority?: {
        key: string;
        id: number;
        name?: string;
    }[];
    status?: {
        key: string;
        id: number;
        name?: string;
    }[];
    platforms?: {
        key: string;
        id: number;
        name?: string;
    }[];
    satisfaction?: {
        key: string;
        id: number;
        name?: string;
    }[];
    templates?: {
        key: string;
        id: number;
        name?: string;
    }[];
    tags?: {
        key: string;
        id: number;
        name?: string;
    }[];
    forwardEmail?: {
        key: string;
        id: number;
        name?: string;
    }[];
    agents?: any[];
}
interface PropsInterface {
    conditions?: ConditionInterface[];
    conditionFieldField?: string;
    conditionOperatorField?: string;
    conditionValueField?: string;
    showConditionNumber?: boolean;
    autoChooseFirstField?: boolean;
    showConditionHeaders?: boolean;
    showConditionHeadersWhenEmpty?: boolean;
    conditionFieldColumnHeader?: boolean;
    conditionOperatorColumnHeader?: boolean;
    conditionValueColumnHeader?: boolean;
    allowEmptyConditions?: boolean;
    fieldsConfig?: FieldInterface[] | undefined;
    customFields?: CustomField[];
    systemFields?: Partial<CustomField>[];
    customerSystemFields?: Partial<CustomField>[];
    onConditionChanged?: (conditions: ConditionInterface[] | undefined) => void;
    dataSources?: DataSourcesInterface;
    className?: string;
    removalIconClass?: string;
    addIconClass?: string;
    addIconText?: string;
}
declare const TicketFilterCondition: React.FC<PropsInterface>;
export default TicketFilterCondition;
