"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.translateOptions = exports.originalMap = exports.originalOptions = void 0;
var tslib_1 = require("tslib");
var i18n_1 = tslib_1.__importDefault(require("../i18n"));
exports.originalOptions = [
    {
        value: 'zh-cn',
        label: i18n_1.default.t('language.chinese'),
    },
    {
        value: 'auto',
        label: 'Auto',
    },
];
var originalMap;
(function (originalMap) {
    originalMap["ZhCn"] = "zh-cn";
    originalMap["EnUs"] = "en-us";
    originalMap["Auto"] = "auto";
})(originalMap = exports.originalMap || (exports.originalMap = {}));
exports.translateOptions = [
    { label: i18n_1.default.t('language.zh-cn'), value: 'zh-cn' },
    { label: i18n_1.default.t('language.zh-tw'), value: 'zh-tw' },
    { label: i18n_1.default.t('language.en-us'), value: 'en-us' },
    { label: i18n_1.default.t('language.fr'), value: 'fr' },
    { label: i18n_1.default.t('language.de'), value: 'de' },
    { label: i18n_1.default.t('language.fil'), value: 'fil' },
    { label: i18n_1.default.t('language.ja'), value: 'ja' },
    { label: i18n_1.default.t('language.it'), value: 'it' },
    { label: i18n_1.default.t('language.ru'), value: 'ru' },
    { label: i18n_1.default.t('language.ko'), value: 'ko' },
    { label: i18n_1.default.t('language.vi'), value: 'vi' },
    { label: i18n_1.default.t('language.af'), value: 'af' },
    { label: i18n_1.default.t('language.sq'), value: 'sq' },
    { label: i18n_1.default.t('language.am'), value: 'am' },
    { label: i18n_1.default.t('language.ar'), value: 'ar' },
    { label: i18n_1.default.t('language.hy'), value: 'hy' },
    { label: i18n_1.default.t('language.as'), value: 'as' },
    { label: i18n_1.default.t('language.ay'), value: 'ay' },
    { label: i18n_1.default.t('language.az'), value: 'az' },
    { label: i18n_1.default.t('language.bm'), value: 'bm' },
    { label: i18n_1.default.t('language.eu'), value: 'eu' },
    { label: i18n_1.default.t('language.be'), value: 'be' },
    { label: i18n_1.default.t('language.bn'), value: 'bn' },
    { label: i18n_1.default.t('language.bho'), value: 'bho' },
    { label: i18n_1.default.t('language.bs'), value: 'bs' },
    { label: i18n_1.default.t('language.bg'), value: 'bg' },
    { label: i18n_1.default.t('language.ca'), value: 'ca' },
    { label: i18n_1.default.t('language.ceb'), value: 'ceb' },
    { label: i18n_1.default.t('language.co'), value: 'co' },
    { label: i18n_1.default.t('language.hr'), value: 'hr' },
    { label: i18n_1.default.t('language.cs'), value: 'cs' },
    { label: i18n_1.default.t('language.da'), value: 'da' },
    { label: i18n_1.default.t('language.dv'), value: 'dv' },
    { label: i18n_1.default.t('language.doi'), value: 'doi' },
    { label: i18n_1.default.t('language.nl'), value: 'nl' },
    { label: i18n_1.default.t('language.eo'), value: 'eo' },
    { label: i18n_1.default.t('language.et'), value: 'et' },
    { label: i18n_1.default.t('language.ee'), value: 'ee' },
    { label: i18n_1.default.t('language.fi'), value: 'fi' },
    { label: i18n_1.default.t('language.fy'), value: 'fy' },
    { label: i18n_1.default.t('language.gl'), value: 'gl' },
    { label: i18n_1.default.t('language.ka'), value: 'ka' },
    { label: i18n_1.default.t('language.el'), value: 'el' },
    { label: i18n_1.default.t('language.gn'), value: 'gn' },
    { label: i18n_1.default.t('language.gu'), value: 'gu' },
    { label: i18n_1.default.t('language.ht'), value: 'ht' },
    { label: i18n_1.default.t('language.ha'), value: 'ha' },
    { label: i18n_1.default.t('language.haw'), value: 'haw' },
    { label: i18n_1.default.t('language.he'), value: 'he' },
    { label: i18n_1.default.t('language.hi'), value: 'hi' },
    { label: i18n_1.default.t('language.hmn'), value: 'hmn' },
    { label: i18n_1.default.t('language.hu'), value: 'hu' },
    { label: i18n_1.default.t('language.is'), value: 'is' },
    { label: i18n_1.default.t('language.ig'), value: 'ig' },
    { label: i18n_1.default.t('language.ilo'), value: 'ilo' },
    { label: i18n_1.default.t('language.id'), value: 'id' },
    { label: i18n_1.default.t('language.ga'), value: 'ga' },
    { label: i18n_1.default.t('language.jv'), value: 'jv' },
    { label: i18n_1.default.t('language.kn'), value: 'kn' },
    { label: i18n_1.default.t('language.kk'), value: 'kk' },
    { label: i18n_1.default.t('language.km'), value: 'km' },
    { label: i18n_1.default.t('language.rw'), value: 'rw' },
    { label: i18n_1.default.t('language.gom'), value: 'gom' },
    { label: i18n_1.default.t('language.kri'), value: 'kri' },
    { label: i18n_1.default.t('language.ku'), value: 'ku' },
    { label: i18n_1.default.t('language.ckb'), value: 'ckb' },
    { label: i18n_1.default.t('language.ky'), value: 'ky' },
    { label: i18n_1.default.t('language.lo'), value: 'lo' },
    { label: i18n_1.default.t('language.la'), value: 'la' },
    { label: i18n_1.default.t('language.lv'), value: 'lv' },
    { label: i18n_1.default.t('language.ln'), value: 'ln' },
    { label: i18n_1.default.t('language.lt'), value: 'lt' },
    { label: i18n_1.default.t('language.lg'), value: 'lg' },
    { label: i18n_1.default.t('language.lb'), value: 'lb' },
    { label: i18n_1.default.t('language.mk'), value: 'mk' },
    { label: i18n_1.default.t('language.mai'), value: 'mai' },
    { label: i18n_1.default.t('language.mg'), value: 'mg' },
    { label: i18n_1.default.t('language.ms'), value: 'ms' },
    { label: i18n_1.default.t('language.ml'), value: 'ml' },
    { label: i18n_1.default.t('language.mt'), value: 'mt' },
    { label: i18n_1.default.t('language.mi'), value: 'mi' },
    { label: i18n_1.default.t('language.mr'), value: 'mr' },
    { label: i18n_1.default.t('language.mni-Mtei'), value: 'mni-Mtei' },
    { label: i18n_1.default.t('language.mni-lus'), value: 'lus' },
    { label: i18n_1.default.t('language.mn'), value: 'mn' },
    { label: i18n_1.default.t('language.my'), value: 'my' },
    { label: i18n_1.default.t('language.ne'), value: 'ne' },
    { label: i18n_1.default.t('language.no'), value: 'no' },
    { label: i18n_1.default.t('language.ny'), value: 'ny' },
    { label: i18n_1.default.t('language.or'), value: 'or' },
    { label: i18n_1.default.t('language.om'), value: 'om' },
    { label: i18n_1.default.t('language.ps'), value: 'ps' },
    { label: i18n_1.default.t('language.fa'), value: 'fa' },
    { label: i18n_1.default.t('language.pl'), value: 'pl' },
    { label: i18n_1.default.t('language.pt'), value: 'pt' },
    { label: i18n_1.default.t('language.pa'), value: 'pa' },
    { label: i18n_1.default.t('language.qu'), value: 'qu' },
    { label: i18n_1.default.t('language.ro'), value: 'ro' },
    { label: i18n_1.default.t('language.sm'), value: 'sm' },
    { label: i18n_1.default.t('language.sa'), value: 'sa' },
    { label: i18n_1.default.t('language.gd'), value: 'gd' },
    { label: i18n_1.default.t('language.nso'), value: 'nso' },
    { label: i18n_1.default.t('language.sr'), value: 'sr' },
    { label: i18n_1.default.t('language.st'), value: 'st' },
    { label: i18n_1.default.t('language.sn'), value: 'sn' },
    { label: i18n_1.default.t('language.sd'), value: 'sd' },
    { label: i18n_1.default.t('language.si'), value: 'si' },
    { label: i18n_1.default.t('language.sk'), value: 'sk' },
    { label: i18n_1.default.t('language.sl'), value: 'sl' },
    { label: i18n_1.default.t('language.so'), value: 'so' },
    { label: i18n_1.default.t('language.es'), value: 'es' },
    { label: i18n_1.default.t('language.su'), value: 'su' },
    { label: i18n_1.default.t('language.sw'), value: 'sw' },
    { label: i18n_1.default.t('language.sv'), value: 'sv' },
    { label: i18n_1.default.t('language.tl'), value: 'tl' },
    { label: i18n_1.default.t('language.tg'), value: 'tg' },
    { label: i18n_1.default.t('language.ta'), value: 'ta' },
    { label: i18n_1.default.t('language.tt'), value: 'tt' },
    { label: i18n_1.default.t('language.te'), value: 'te' },
    { label: i18n_1.default.t('language.th'), value: 'th' },
    { label: i18n_1.default.t('language.ti'), value: 'ti' },
    { label: i18n_1.default.t('language.ts'), value: 'ts' },
    { label: i18n_1.default.t('language.tr'), value: 'tr' },
    { label: i18n_1.default.t('language.tk'), value: 'tk' },
    { label: i18n_1.default.t('language.ak'), value: 'ak' },
    { label: i18n_1.default.t('language.uk'), value: 'uk' },
    { label: i18n_1.default.t('language.ur'), value: 'ur' },
    { label: i18n_1.default.t('language.ug'), value: 'ug' },
    { label: i18n_1.default.t('language.uz'), value: 'uz' },
    { label: i18n_1.default.t('language.cy'), value: 'cy' },
    { label: i18n_1.default.t('language.xh'), value: 'xh' },
    { label: i18n_1.default.t('language.yi'), value: 'yi' },
    { label: i18n_1.default.t('language.yo'), value: 'yo' },
    { label: i18n_1.default.t('language.zu'), value: 'zu' }
];
