/**
 * sdk-manifest version 1.0
 */
export declare class SdkManifest {
    js: JSItem[];
    css: CssItem[];
    version: string;
    release?: Release;
}
export declare class JSItem implements IScript {
    constructor(init?: Partial<JSItem>);
    isEntry: boolean;
    isPreload?: boolean;
    destroyable: boolean;
    src?: string;
    content?: string;
    type?: string;
    async?: boolean;
    defer?: boolean;
    crossOrigin?: string | null;
    integrity?: string;
    noModule?: boolean;
    referrerPolicy?: string;
}
export declare class CssItem implements ICss {
    constructor(init?: Partial<CssItem>);
    destroyable: boolean;
    href?: string;
    content?: string;
    crossOrigin?: string | null;
    disabled?: boolean;
    integrity?: string;
    media?: string;
    referrerPolicy?: string;
    rel?: string;
    type?: string;
}
export declare class Release {
    constructor(init?: Partial<Release>);
    version: string;
}
export interface IScript extends Partial<HTMLScriptElement> {
    content?: string;
    destroyable?: boolean;
}
export interface ICss extends Partial<HTMLLinkElement> {
    content?: string;
    destroyable?: boolean;
}
