"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var tslib_1 = require("tslib");
var react_1 = tslib_1.__importStar(require("react"));
var udesk_ui_1 = require("udesk-ui");
var react_i18next_1 = require("react-i18next");
var upload_box_1 = tslib_1.__importDefault(require("@udesk-webapp/upload-box"));
var index_module_less_1 = tslib_1.__importDefault(require("./index.module.less"));
var CheckOutlined_1 = tslib_1.__importDefault(require("@ant-design/icons/CheckOutlined"));
var CloseCircleFilled_1 = tslib_1.__importDefault(require("@ant-design/icons/CloseCircleFilled"));
function UploadModal(_a) {
    var marking = _a.marking, props = tslib_1.__rest(_a, ["marking"]);
    var uploadRef = (0, react_1.useRef)();
    // 上传的图片列表
    var _b = (0, react_1.useState)([]), imageFiles = _b[0], setImageFiles = _b[1];
    var _c = (0, react_1.useState)([]), selectedImages = _c[0], setSelectedImages = _c[1];
    //多语言配置
    var t = (0, react_i18next_1.useTranslation)().t;
    // 点击插入  筛选出被选择的图片   将选择的图片 插入富文本编辑
    function handleOk() {
        // props.addImg(imgList.filter(item => item.isSelect));
        if (selectedImages) {
            props.addImg(selectedImages === null || selectedImages === void 0 ? void 0 : selectedImages.filter(function (i) { return i.url; }).map(function (i) { return ({ src: i.url, isSelect: true }); }));
            // 插入后清空
            uploadRef.current.deleteAll();
            setSelectedImages([]);
            setImageFiles([]);
        }
    }
    // 点击取消 关闭弹窗
    function handleCancel() {
        props.close();
    }
    // 删除图片
    function deleteImg(e, index) {
        e.stopPropagation();
        var delItem = imageFiles[index];
        setImageFiles(function (v) {
            if (!v) {
                return v;
            }
            var result = tslib_1.__spreadArray([], v, true);
            result.splice(index, 1);
            return result;
        });
        //同时删除antdUpload中的数据，
        imageFiles && uploadRef.current.deleteItem(delItem);
        // 删除select
        setSelectedImages(function (v) {
            if (v === void 0) { v = []; }
            if (v.includes(delItem)) {
                return v.filter(function (i) { return i !== delItem; });
            }
            else {
                return v;
            }
        });
    }
    // 选择图片  显示右下角对勾
    function selectImg(imageFile) {
        setSelectedImages(function (v) {
            if (v === void 0) { v = []; }
            if (v.includes(imageFile)) {
                return v.filter(function (i) { return i !== imageFile; });
            }
            else {
                return tslib_1.__spreadArray(tslib_1.__spreadArray([], v, true), [imageFile], false);
            }
        });
    }
    var onChange = (0, react_1.useCallback)(function (fileList) {
        setImageFiles(fileList);
        setSelectedImages(fileList);
    }, []);
    // 弹窗页脚
    var footer = (0, react_1.useMemo)(function () {
        return (react_1.default.createElement("div", { className: index_module_less_1.default['modal-btn'] },
            react_1.default.createElement(upload_box_1.default, tslib_1.__assign({ className: index_module_less_1.default['upload-btn'] }, props, { value: imageFiles, marking: marking || 'web.ts.ticket_reply', onChange: onChange, noAttachment: false, showUploadList: false, accept: 'image/jpeg,image/jpg,image/png', ref: uploadRef }),
                react_1.default.createElement(udesk_ui_1.Button, null, t('uploader.uploadImg'))),
            react_1.default.createElement(udesk_ui_1.Button, { key: 'back', onClick: handleCancel }, t('cancel')),
            react_1.default.createElement(udesk_ui_1.Button, { key: 'submit', type: 'primary', onClick: handleOk }, t('uploader.insertImg'))));
    }, [imageFiles, selectedImages]);
    return (react_1.default.createElement("div", null,
        react_1.default.createElement(udesk_ui_1.Modal, { visible: props.show, title: t('uploader.uploadImg'), onOk: handleOk, onCancel: handleCancel, footer: footer, width: 600, zIndex: 9999 },
            react_1.default.createElement("div", { className: index_module_less_1.default['modal-content'] },
                react_1.default.createElement(udesk_ui_1.Row, { gutter: [16, 24] }, imageFiles === null || imageFiles === void 0 ? void 0 : imageFiles.map(function (item, index) {
                    return (react_1.default.createElement(udesk_ui_1.Col, { span: 8, key: item.url },
                        react_1.default.createElement("div", { className: index_module_less_1.default['img-wrapper'], onClick: function () { return selectImg(item); } },
                            react_1.default.createElement("img", { src: item.url, alt: item.url }),
                            react_1.default.createElement("div", { className: index_module_less_1.default['delete-icon'], onClick: function (e) { return deleteImg(e, index); } },
                                react_1.default.createElement(CloseCircleFilled_1.default, null)),
                            (selectedImages === null || selectedImages === void 0 ? void 0 : selectedImages.includes(item)) && (react_1.default.createElement("div", { className: index_module_less_1.default['select-icon'] },
                                react_1.default.createElement(CheckOutlined_1.default, null))))));
                }))))));
}
exports.default = UploadModal;
