/**
 * @description 生成级联列表 和 去掉隐藏选项的列表
 */
import { __assign } from "tslib";
export function getFormatOptions(options, fieldNames) {
    var result = [];
    var resultWithNoHide = [];
    options.forEach(function (item) {
        var newItem = {
            label: item[fieldNames.label],
            value: item[fieldNames.value],
            is_hide: item[fieldNames.is_hide],
        };
        var newItemWithNoHide = !newItem.is_hide ? __assign({}, newItem) : null;
        var itemChildren = item[fieldNames.children];
        if (Array.isArray(itemChildren) && itemChildren.length) {
            var newChildren = getFormatOptions(itemChildren, fieldNames);
            if (newChildren[0] && newChildren[0].length) {
                newItem['children'] = newChildren[0];
            }
            if (newItemWithNoHide && newChildren[1] && newChildren[1].length) {
                newItemWithNoHide['children'] = newChildren[1];
            }
        }
        result.push(newItem);
        newItemWithNoHide && resultWithNoHide.push(newItemWithNoHide);
    });
    return [result, resultWithNoHide];
}
