import { __awaiter, __generator } from "tslib";
import React from 'react';
import { ajax, PATH_BASE } from '@udesk-webapp/utils';
import { VerifySignatureAndSaveTicketEnums } from '.';
export var TicketContext = React.createContext({});
export var getSignatureConfig = function (_a) {
    var _b = _a.mode, mode = _b === void 0 ? VerifySignatureAndSaveTicketEnums.NeedSignature : _b, ticket = _a.ticket, ticket_id = _a.ticket_id, _c = _a.examine_type, examine_type = _c === void 0 ? 'create' : _c;
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0: return [4 /*yield*/, new Promise(function (resolve, reject) {
                        if (mode === VerifySignatureAndSaveTicketEnums.VerifySignatureAndSaveTicket) {
                            resolve({
                                signature_required: false,
                            });
                        }
                        else {
                            ajax().postJSON("".concat(PATH_BASE, "/ticket_signatures/examine"), {
                                examine_type: examine_type,
                                ticket_id: examine_type === 'update' ? ticket_id : undefined,
                                ticket: ticket,
                            })
                                .then(function (res) {
                                if (res.code === 1000) {
                                    resolve(res);
                                }
                                else {
                                    reject(res);
                                }
                            })
                                .catch(function (error) {
                                //获取签名配置失败，提示错误，不继续保存工单。
                                reject(error);
                            });
                        }
                    })];
                case 1: return [2 /*return*/, _d.sent()];
            }
        });
    });
};
