"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPreviewUrl = exports.stringToHex = void 0;
function stringToHex(str) {
    var hexResult = [];
    for (var i = 0, len = str.length; i < len; i++) {
        var hex = str.charCodeAt(i).toString(16);
        hexResult.push(hex);
    }
    return hexResult.join('');
}
exports.stringToHex = stringToHex;
function getPreviewUrl(url, options) {
    if (!url) {
        return '';
    }
    var _a = options || {}, _b = _a.needEncode, needEncode = _b === void 0 ? false : _b, previewUrl = _a.previewUrl;
    if (needEncode) {
        url = encodeURIComponent(decodeURIComponent(url));
        url = url.replace(/%2F/g, '/');
    }
    var hexUrl;
    try {
        hexUrl = stringToHex(url);
    }
    catch (e) {
        console.error('preview-url-helper', e);
        return url;
    }
    return "".concat(previewUrl, "/wopi/files/").concat(hexUrl, "/documents");
}
exports.getPreviewUrl = getPreviewUrl;
