"use strict";
/**
 * @description 生成级联列表 和 去掉隐藏选项的列表
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.markOptionUsedByValue = exports.getFormatOptions = void 0;
var tslib_1 = require("tslib");
function getFormatOptions(options, fieldNames) {
    var result = [];
    var resultWithNoHide = [];
    (options || []).forEach(function (item) {
        var newItem = {
            label: item[fieldNames.label],
            value: item[fieldNames.value],
            is_hide: item[fieldNames.is_hide],
        };
        var newItemWithNoHide = !newItem.is_hide ? tslib_1.__assign({}, newItem) : null;
        var itemChildren = (fieldNames === null || fieldNames === void 0 ? void 0 : fieldNames.children) ? item[fieldNames.children] : [];
        if (Array.isArray(itemChildren) && itemChildren.length) {
            var newChildren = getFormatOptions(itemChildren, fieldNames);
            if (newChildren[0] && newChildren[0].length) {
                newItem['children'] = newChildren[0];
            }
            if (newItemWithNoHide && newChildren[1] && newChildren[1].length) {
                newItemWithNoHide['children'] = newChildren[1];
            }
        }
        result.push(newItem);
        newItemWithNoHide && resultWithNoHide.push(newItemWithNoHide);
    });
    return [result, resultWithNoHide];
}
exports.getFormatOptions = getFormatOptions;
function markOptionUsedByValue(options, _value) {
    if (options === void 0) { options = []; }
    var values;
    if (!Array.isArray(_value)) {
        if (typeof _value === 'string' && _value.length > 0) {
            values = _value.split(',');
        }
        else {
            values = _value ? ["".concat(_value)] : [];
        }
    }
    else {
        values = _value || [];
    }
    return options.map(function (item) {
        if (item && values.includes(item.value)) {
            // item.isUsed = true;
            return tslib_1.__assign(tslib_1.__assign({}, item), { isUsed: true });
        }
        return item;
    });
}
exports.markOptionUsedByValue = markOptionUsedByValue;
