declare type StoragePolicy = "qiniu" | "ali" | "huawei_cloud_obs" | "minio";
declare type Marking = "web.mg.rich_editor_copy";
interface AliParams {
    "Cache-Control"?: string;
}
export declare function uploadFile(file: File, options: Parameters<typeof fetchFileUploadPolicy>[1] & {
    aliParams?: AliParams;
    saveAttachment?: boolean;
}): Promise<{
    src: string;
    attachment_id?: number;
    attachment_mark?: string;
}>;
export declare function fetchFileUploadPolicy(file: File, option: {
    marking: Marking;
    key?: string;
    access_token?: string;
    user_id?: number;
}): Promise<{
    key: string;
    accessid: string;
    bucket: string;
    dir: string;
    expire: number;
    host: string;
    policy: string;
    signature: string;
    storage_policy: StoragePolicy;
    signed_url?: string | undefined;
    file_path?: string | undefined;
    "x-oss-object-acl": string;
}>;
export {};
