import { src, dest } from 'gulp';
import rename from 'gulp-rename';
import console = require('console');
var flatten = require('gulp-flatten');

export interface CopyCreatorOptions {
  from: string[];
  toDir: string;
}

export interface CopyFlatOptions {
  from: string[];
  toDir: string,
  filename: (option: { name: string, dirname: string }) => string;
}

export const copy = ({ from, toDir }: CopyCreatorOptions) =>
  function CopyFiles() {
    return src(from).pipe(dest(toDir));
  };

export const copyFlat = ({ from, toDir, filename }: CopyFlatOptions) =>
  function CopyFiles() {
    return src(from)
      .pipe(
        rename((file) => {
          let dirname = '';
          if (file.dirname) {
            dirname = file.dirname;
          }
          if (file.basename) {
            file.basename = filename({ name: file.basename, dirname });
          }
        })
      )
      .pipe(flatten())
      .pipe(dest(toDir));
  };
