export interface AbstractNode {
  tag: string;
  attrs: {
    [key: string]: string;
  };
  children?: AbstractNode[];
}

export interface IconDefinition {
  name: string; // kebab-case-style
  theme: ThemeType;
  icon:
  | ((primaryColor: string, secondaryColor: string) => AbstractNode)
  | AbstractNode;
  caption: string;
  category: string;
}

// export type ThemeType = 'filled' | 'outlined' | 'twotone';
// export type ThemeTypeUpperCase = 'Filled' | 'Outlined' | 'TwoTone';

export type ThemeType = 'filled' | 'outlined';
export type ThemeTypeUpperCase = 'Filled' | 'Outlined';

