import pkg     from './package.json';
import babel   from 'rollup-plugin-babel';
import resolve from 'rollup-plugin-node-resolve';

const babelOptions = () => {
    return {
        babelrc : false,
        presets : [['@babel/preset-env', {modules : false}], '@babel/preset-react']
    };
};
export default [{
    input    : 'src/index.js',
    plugins  : [resolve(), babel(babelOptions())],
    external : [
        'lodash-es', 'react', 'prop-types', 'react-dom', '@udesk-webapp/column-control', 'react-popper'
    ],
    output   : [
        {
            file   : pkg.module,
            format : 'es'
        }
    ]
}];