import pkg     from './package.json';
import babel   from 'rollup-plugin-babel';
import resolve from 'rollup-plugin-node-resolve';

const babelOptions = () => {
    return {
        babelrc : false,
        presets : [['@babel/preset-env', {modules : false}], '@babel/preset-react'],
        plugins : [
            '@babel/plugin-syntax-dynamic-import',
            '@babel/plugin-syntax-import-meta',
            '@babel/plugin-proposal-class-properties',
            '@babel/plugin-proposal-json-strings',
            [
                '@babel/plugin-proposal-decorators',
                {
                    'legacy' : true
                }
            ],
            '@babel/plugin-proposal-function-sent',
            '@babel/plugin-proposal-export-namespace-from',
            '@babel/plugin-proposal-numeric-separator',
            '@babel/plugin-proposal-throw-expressions',
            '@babel/plugin-proposal-export-default-from',
            '@babel/plugin-proposal-logical-assignment-operators',
            '@babel/plugin-proposal-optional-chaining',
            [
                '@babel/plugin-proposal-pipeline-operator',
                {
                    'proposal' : 'minimal'
                }
            ],
            '@babel/plugin-proposal-nullish-coalescing-operator',
            '@babel/plugin-proposal-do-expressions',
            '@babel/plugin-proposal-function-bind'
        ]
    };
};
export default [{
    input    : 'src/index.js',
    plugins  : [resolve(), babel(babelOptions())],
    external : [
        'lodash-es', 'react', 'prop-types', 'react-dom'
    ],
    output   : [
        {
            file   : pkg.module,
            format : 'es'
        }
    ]
}];