//@ts-ignore
import entryClass from '"%ENTRY_PATH%"';
// prettier-ignore
'%IMPORT_COMPONENT_SDK%';
/**
 * SDK的启动器
 * 包含把入口Class传递到document.currentScript，以及运行当前sdk（app模式）
 */

// 把当前 SDKClass 传递给 script 标签
// 但要判断一下是否有bindToCurrentScript方法，也就是UmiSdkClass的基类。
// 如果用户自定义了入口类，而且没有从UmiSdkClass继承的话，可能没有这个方法。
if (entryClass.bindToCurrentScript) {
    let currentScript = window.document["'%UNIQUE_ID%'"] || document.currentScript!;
    delete window.document["'%UNIQUE_ID%'"];
    // 同步设置 currentScript.sdkClass 向外传递 entryClass
    entryClass.bindToCurrentScript(entryClass, currentScript);
    // 存在组件SDK配置
    if ('%COMPONENT_SDK_CLASS%') {
        // @ts-ignore：占位符
        '%COMPONENT_SDK_CLASS%'.bindToCurrentScript(
            '%COMPONENT_SDK_CLASS%',
            currentScript,
            'componentSdkClass'
        );
        // 向外异步方式传递 entryClass
        if (typeof currentScript.onSdkLoaded === 'function') {
            // @ts-ignore：占位符
            currentScript.onSdkLoaded({
                sdkClass: entryClass,
                '%COMPONENT_SDK_CLASS%': '%COMPONENT_SDK_CLASS%',
            });
        }
    } else {
        // 向外异步方式传递 entryClass
        if (typeof currentScript.onSdkLoaded === 'function') {
            // @ts-ignore：占位符
            currentScript.onSdkLoaded({ sdkClass: entryClass });
        }
    }
}

if ('%AUTO_RUN%') {
    // 自动运行，默认情况下开发模式运行时默认都会自动运行，不过每个 sdk 可以独立设置
    const sdk = new entryClass('%SDK_OPTIONS%');
    sdk.renderTo(document.getElementById('"%UMI_ROOT_ELEMENT_ID%"'));
}

export default entryClass;
// prettier-ignore
'%EXPORT_COMPONENT_SDK%';
