// @ts-nocheck
import React, { useState, useEffect } from 'react';

const CheckList = (props: any) => {
    const { columns,  value } = props;
    const [localValue, setLocalValue] = useState(value);

    const handleCheckChange = (checked, column) => {
        const newVlue = [...localValue];
        const index = newVlue.indexOf(column.id);
        if (checked && index < 0) {
            newVlue.push(column.id);
        }

        if (!checked && index > -1) {
            newVlue.splice(index, 1);
        }
        setLocalValue(newVlue);
        props?.onChange?.(newVlue);
    };

    useEffect(() => {
        setLocalValue(value);
    }, [value]);

    return (
        <div className='control-content custom-scroller'>
            {
                columns.map((column) => {
                    return (
                        <label className='list-item'>
                            <input 
                                className='item-check' 
                                type="checkbox" 
                                checked={localValue.indexOf(column.id) > -1} 
                                onChange={(e)=> {
                                    handleCheckChange(e.target.checked, column);
                                }}
                            />
                            <span className="item-text" title={column.name}>{column.name}</span>
                        </label>
                    )
                })
            }
        </div>
    );
};

export default CheckList;
