import React, { Component, Fragment } from 'react';
import PropTypes                      from 'prop-types';
import find                           from 'lodash-es/find';

class Control extends Component {
    render() {
        let {value, prefix, getOptionLabel, getOptionValue, isOpen, placeholder, options} = this.props;
        return (
            <Fragment>
                <span>{prefix}{' '}
                    {
                        value ?
                        getOptionLabel(find(options, i => getOptionValue(i) === value)) :
                        placeholder
                    }
                </span>
                <div style={{marginRight : 0}}>
                    <i className={'icon icon-caret-' + (isOpen ? 'up' : 'down')}/>
                </div>
            </Fragment>
        );
    }
}

Control.propTypes = {
    value          : PropTypes.any,
    prefix         : PropTypes.string,
    getOptionLabel : PropTypes.func,
    getOptionValue : PropTypes.func,
    isOpen         : PropTypes.bool,
    placeholder    : PropTypes.string,
    t              : PropTypes.func,
    options        : PropTypes.array
};
Control.defaultProps = {};

export default Control;
