/*
 * @Author: your name
 * @Date: 2020-09-02 13:50:08
 * @LastEditTime: 2021-10-30 18:24:15
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath: /udesk_webapp_cc/Users/amyliang/Documents/udesk_webapp_public/packages/multi-select/src/Control.js
 */
import React, { Component, Fragment } from 'react';
import find from 'lodash-es/find';
import isEmpty from 'lodash-es/isEmpty';
import PropTypes from 'prop-types';

class Control extends Component {
    render() {
        let { value, prefix, getOptionLabel, getOptionValue, isOpen, placeholder, t, options, showAllOption } = this.props;
        return (
            <Fragment>
                <span>{prefix} {do {
                    if (!isEmpty(value)) {
                        if (value.length === 1) {
                        getOptionLabel(find(options, i => getOptionValue(i) === value[0]));
                        } else if(showAllOption && value.includes('all')){
                        (value.length - 1) + t('filter.choice.unit');          
                        }else{
                        value.length + t('filter.choice.unit');
                        }
                    } else {
                        placeholder;
                    }
                }}</span>
                <div style={{ marginRight: 0 }}>
                    <i className={'icon icon-caret-' + (isOpen ? 'up' : 'down')} />
                </div>
            </Fragment>
        );
    }
}

Control.propTypes = {
    value: PropTypes.array,
    prefix: PropTypes.string,
    getOptionLabel: PropTypes.func,
    getOptionValue: PropTypes.func,
    isOpen: PropTypes.bool,
    placeholder: PropTypes.string,
    t: PropTypes.func,
    options: PropTypes.array
};
Control.defaultProps = {};

export default Control;
