import React, { Component, createRef } from 'react';

class IndeterminateCheckbox extends Component {
    _ref = createRef();

    componentDidMount() {
        if (this.props.indeterminate === true) {
            this._setIndeterminate(true);
        }
    }

    componentDidUpdate(previousProps) {
        if (previousProps.indeterminate !== this.props.indeterminate) {
            this._setIndeterminate(this.props.indeterminate);
        }
    }

    _setIndeterminate(indeterminate) {
        const node = this._ref.current;
        node.indeterminate = indeterminate;
    }

    render() {
        //eslint-disable-next-line no-unused-vars
        const {indeterminate, type, ...props} = this.props;
        return <input type="checkbox" {...props} ref={this._ref}/>;
    }
}

export default IndeterminateCheckbox;
