/*
 * @Author: your name
 * @Date: 2020-09-02 13:50:08
 * @LastEditTime: 2021-10-30 16:47:12
 * @LastEditors: Please set LastEditors
 * @Description: In User Settings Edit
 * @FilePath: /udesk_webapp_cc/Users/amyliang/Documents/udesk_webapp_public/packages/multi-select/src/Options.js
 */
import React, { Component, Fragment } from 'react';
import PropTypes from 'prop-types';
import filter from 'lodash-es/filter';
import includes from 'lodash-es/includes';
import map from 'lodash-es/map';

class Options extends Component {
    render() {
        let { options, getOptionLabel = v => JSON.stringify(v), getOptionValue = v => v, value = [] } = this.props;
        return (
            <Fragment>
                {map(options, (i, index) => (
                    <li key={index}>
                        <label>
                            <input value={getOptionValue(i)} type='checkbox'
                                checked={includes(value, getOptionValue(i))}
                                onChange={(e) => this.onChange(i, e.target.checked)} />
                            {getOptionLabel(i)}
                        </label>
                    </li>
                ))}
            </Fragment>
        );
    }

    /**
     * 当选项被点击时触发
     * @param {any} option - 选项
     * @param {boolean} isChecked - 选中状态
     */
    onChange(option, isChecked) {
        let { value = [], getOptionValue = v => v } = this.props;
        if (isChecked) {
            this.props.onChange([...value, getOptionValue(option)]);
        } else {
            this.props.onChange(filter(value, i => i !== getOptionValue(option)));
        }
    }
}

Options.propTypes = {
    options: PropTypes.arrayOf(PropTypes.any),
    getOptionLabel: PropTypes.func,
    getOptionValue: PropTypes.func,
    value: PropTypes.arrayOf(PropTypes.any),
    onChange: PropTypes.func
};

export default Options;
