import React, { Component, Fragment } from 'react';
import PropTypes                      from 'prop-types';
import map                            from 'lodash-es/map';

class Options extends Component {
    static defaultProps = {
        getOptionValue : v => v,
        getOptionLabel : v => JSON.stringify(v),
        options        : []
    };

    render() {
        let {options, getOptionLabel} = this.props;
        return (
            <Fragment>
                {map(options, (i, index) => (
                    <li key={index} onClick={() => this._onSelect(i)}>
                        {getOptionLabel(i)}
                    </li>
                ))}
            </Fragment>
        );
    }

    _onSelect(option) {
        let {getOptionValue, onChange} = this.props;

        onChange(getOptionValue(option), option);
    }
}

Options.propTypes = {
    options        : PropTypes.arrayOf(PropTypes.any),
    getOptionLabel : PropTypes.func,
    getOptionValue : PropTypes.func,
    value          : PropTypes.any,
    onChange       : PropTypes.func
};

export default Options;
