import React from 'react';
import ReactDom from 'react-dom';
// import PropTypes from 'prop-types';

// Import dependencies as global libraries. See them in package.json `script-loader` section.
// https://sebastianblade.com/how-to-import-unmodular-library-like-zepto/
//TODO:  All dependencies should be removed in the future!
import 'jquery';
import 'bootstrap/dist/js/bootstrap';
import 'bootstrap/dist/css/bootstrap.css';
import 'moment';
import 'moment/locale/zh-cn';
import 'daterangepicker';
import 'daterangepicker/daterangepicker.css';
import 'bootstrap-duration-picker/dist/bootstrap-duration-picker-debug';
import 'bootstrap-duration-picker/dist/bootstrap-duration-picker.css';

// 客服使用 date-time-picker
import 'eonasdan-bootstrap-datetimepicker';
import 'eonasdan-bootstrap-datetimepicker/build/css/bootstrap-datetimepicker.css';
// KM 系使用 date-time-picker
// import 'bootstrap-datetime-picker';
// import 'bootstrap-datetime-picker/js/locales/bootstrap-datetimepicker.zh-CN';
// import 'bootstrap-datetime-picker/bootstrap-datetimepicker.css';

import Udesk from './udesk';

// 不要一次性引入全部插件！而是在各个组件/模块中按需引入！否则万一某个组件忘了引用插件，在demo中发现不了！
// 只能在这里引用那些“全局”插件。
import '../udesk-plugin-installers/ui/notify/iziToast';

import initializers from './initializers';
import { init as initModels } from './models';
import './styles/layout.css';
import PagesComponent from './pages';

Udesk.init();
Udesk.on("onModelPromiseCatched", (error) => {
    //eslint-disable-next-line
    console.error(error);
});
initializers.run();
initModels();

//Expose global Udesk for easier debugging.
// #if process.env.ENABLE_DEBUG_INFO === 'true'
window.Udesk = Udesk;
window.React = React;
window.ReactDom = ReactDom;
// #endif

function renderPages() {
    ReactDom.render((<PagesComponent />), document.getElementById('root'));
}

// if (process.env.NODE_ENV !== 'production' && module.hot) {
//     module.hot.accept('./pages', renderPages);
// }

renderPages();