export default {
    demo: {
        pages: {
            notFound: {
                noRoute: "哎呀，当前页面没有匹配到任何路由！请检查一下url是否正确？"
            }
        },
        customFilters: {
            name: "custom-filters (自定义过滤器)",
            title: "自定义过滤器",
            description:
                `自定义过滤器是一个用来构建自定义查询条件的组件，现已被广泛应用于各业务系统之中。每一行表示一个查询条件，分为<code>字段</code>、<code>操作符</code>、和<code>值</code>，分别各占一列。
                组件的首要设计目标就是强大的扩展性，值列所使用的组件都是动态配置的，并且会根据字段的类型以及操作符的不同组合，配置不同的输入组件，需要符合<code>custom-filter-inputs/input-base-class</code>的规范，都可以配置为自定义过滤器的输入组件。
                甚至字段列、操作符列都可以使用自定义组件。组件基本用法是传入两个基本属性：<code>fields</code>和<code>fieldValueSettings</code>，具体配置文件格式参见<code>components/custom-filters/demo/config/fields.js</code>和<code>components.js</code>。`,
            basicSample: "基本示例",
            config: {
                fields: {
                    name: "公司名称",
                    contactsName: "联系人",
                    followStatus: "跟进状态",
                    mobile: "手机",
                    telephone: "固定电话",
                    email: "邮件",
                    province: "省份",
                    address: "详细地址",
                    masterUserId: "销售线索所有人",
                    leadsHighSeaReceiveTime: "领取时间",
                    leadsHighSeaReturnCount: "退回次数",
                    leadsHighSeaId: "所属公海",
                    createUserId: "创建人",
                    lastMasterUserId: "最后所有人",
                    officeId: "负责组",
                    notFollowDays: "未跟进天数",
                    highSeaStatus: "公海状态",
                    updateUserId: "最近修改人",
                    expireTime: "到期时间",
                    updateTime: "最近修改时间",
                    createTime: "创建时间",
                    recentActivityRecordTime: "最新活动记录时间",
                    remark: "备注",
                    tags: "标签"
                },
                components: {
                    currentUser: "当前用户"
                },
                enums: {
                    fieldOperators: {
                        is: "等于",
                        not: "不等于",
                        contains: "包含",
                        notContains: "不包含",
                        containsAny: "包含任意",
                        notContainsAny: "不包含任意",
                        containsAll: "包含所有",
                        notContainsAll: "不包含所有",
                        isNull: "为空",
                        isNotNull: "不为空",
                        greaterThan: "大于",
                        greaterThanEq: "大于等于",
                        lessThan: "小于",
                        lessThanEq: "小于等于",
                        between: "介于",
                        notBetween: "不介于",
                        relative: "等于",
                        set: "设置为",
                        belongs: "属于",
                        notBelongs: "不属于",
                        today: "今天",
                        yesterday: "昨天",
                        tomorrow: "明天",
                        next_seven_day: "今后七天",
                        last_seven_day: "最近七天",
                        this_week: "本周",
                        next_week: "下周",
                        last_week: "上周",
                        this_month: "本月",
                        next_month: "下月",
                        last_month: "上月",
                        this_year: "今年",
                        next_year: "明年",
                        last_year: "去年",
                        exact_match: "精确匹配",
                        add_value: "新增值",
                        remove_value: "删除值",
                        set_null: "置空",
                    }
                }
            }
        },
        customFilterInputs: {
            name: "custom-filter-inputs (自定义过滤器输入控件)",
            description: "配合自定义过滤器使用的不同类型的组件",
        },
        reactTable: {
            name: "react-table (表格组件)",
            title: "表格组件",
            description: "",
            columns: {
                name: "客户名称",
                mobile: "手机",
                telephone: "固定电话",
                email: "邮件",
                classification: "客户级别",
                location: "省、市、区",
                address: "详细地址",
                businessCategoryId: "客户类型",
                masterUserId: "客户所有人",
                officeId: "负责组",
                customerHighSeaId: "所属公海",
                highSeaStatus: "公海状态",
                customerHighSeaReceiveTime: "领取时间",
                expireTime: "到期时间",
                customerHighSeaReturnCount: "退回次数",
                createUserId: "创建人",
                createTime: "创建时间",
                recentActivityRecordTime: "最新活动记录时间",
                locked: "锁定状态",
                updateUserId: "最近修改人",
                updateTime: "最近修改时间",
                notFollowDays: "未跟进天数",
                lastMasterUserId: "最后所有人",
                remark: "备注",
                tags: "标签"
            },
            enums: {
                businessTypes: {
                    contacts: "联系人",
                    customer: "客户",
                    leads: "线索",
                    niche: "商机",
                    product: "产品",
                    task: "任务",
                },
                classifications: {
                    B: "B级-有一定意向，需求和价格还需要引导",
                    C: "C级-产品对客户有帮助，先了解一下"
                },
                customerBusinessCategories: {
                    Default: "默认业务类型",
                    Shanghai: "上海业务类型"
                },
                highSeaStatus: {
                    not_receive: "未领取",
                    already_receive: "已领取",
                    already_transformed: "已转化",
                    create_by_oneself: "自建",
                    signed: "已签约",
                    freezed: "已冻结",
                    canceled: "已废弃"
                },
                lockStatus: {
                    unlocked: "未锁定",
                    locked: "已锁定"
                }
            }
        },
        bootstrapDurationPicker: {
            name: "bootstrap-duration-picker (时长选择器)",
            description: "",
        },
        autoComplete: {
            name: "auto-complete (自动完成)",
            description: "自动完成，支持单值和多值模式，单值和多值的情况下value值为对象或者对象数组",
        },
        checkBox: {
            name: "check-box (复选框)",
            description: `复选框提供基本的复选功能，同时也支持true/false的value值`
        },
        radioBtn: {
            name: "radio-btn (单选框)",
            description: `单元框提供基本的单选功能`
        },
        DateRangePicker: {
            name: "date-range-picker（range时间选择）",
            description: `提供range时间段选择`
        },
        reactPager: {
            name: "react-pager（分页）",
            description: `提供分页功能`
        },
        reactSelect: {
            name: "react-select（下拉）",
            description: `提供最基础的下拉功能`
        },
        bubbleLoader: {
            name: "bubble-loader（加载中动画）",
            description: `根据react-css-loaders封装的加载中动画`
        },
        reactModal: {
            name: "react-modal（弹框）",
            description: `提供可自定义上中下区域的弹框组件`,
            open: "打开弹窗"
        },
        reactTinymce: {
            name: "react-tinymce（富文本编辑）",
            description: `提供富文本编辑器`
        },
        reactEcharts: {
            name: "react-echarts（图表）",
            description: `提供不同类型的echarts图表`
        },
        reactTool: {
            name: "react-tool（提示）",
            description: `提供tool提示`
        },
        dragTable: {
            name: "drag-table（排序表格）",
            description: `提供能够排序的表格`
        },
        newVersion: {
            name: "new-version (发版提示)",
            description: "提供一个简单的发版提示组件",
            messageText: "很高兴的通知您，我们网站刚刚发布了新版本！为了保证您的正常使用，我们需要您立即保存当前的工作，点击按钮重新加载新版本",
            clickButtonText: "重新加载"
        },
        imageViewer: {
            name: "image-viewer (图片查看)",
            description: "图片预览组件，以相册的形式预览某个容器下的所有图片。更多demo效果，请查看：<a href='https://fengyuanchen.github.io/viewerjs/' target='_blank'>https://fengyuanchen.github.io/viewerjs/</a>",
            imageDescription: "这是一张图片"
        },
        customUiGrid: {
            name: "customUiGrid(栅格自定义UI（一维）)",
            description: "提供一个栅格自定义UI",
        },
        jeTimePicker: {
            name: "jeTimePicker(时分选择组件)",
            description: "提供一个时分选择组件",
        },
        aceEditor: {
            name: "ace-editor(代码编辑器)",
            description: "代码编辑器",
        },
        ReactAntdCheckboxGroup: {
            name: "antd-checkbox-group(checkbox组)",
            description: "checkbox组",
        },
        drawerModal: {
            name: "drawerModal(弹框抽屉)",
            description: "在边侧出现抽屉",
        },
        reactTransversalSelect: {
            name: "ReactTransversalSelect(横向带排序选择)",
            description: "横向带排序选择",
        },
        reactPowerSelect: {
            name: "reactPowerSelect(带搜索的下拉选择组件)",
            description: "带搜索的下拉选择组件，基本功能等同于ember power-select",
        },
        reactGaodeMap: {
            name: "reactGaodeMap(高德地图组件)",
            description: "基于高德地图Api封装组件",
        }
    },
};