import { createAction } from '@reduxjs/toolkit';

const addUser = createAction("addUser");
const modifyUserName = createAction("modifyUserName");
const saveUser = createAction("saveUser");
const deleteUsers = createAction("deleteUsers");
const loadUsers = createAction("loadUsers");
const loadUsersAsync = () => (dispatch, getState) => {
    setTimeout(() => {
        dispatch(loadUsers([
            {
                id: 1,
                name: "张三",
                role: 1,
                avatar: "https://ss0.bdstatic.com/70cFvHSh_Q1YnxGkpoWK1HF6hhy/it/u=1204422664,373745882&fm=26&gp=0.jpg",
                createDate: new Date(2020, 0, 1).toISOString(),
                updateDate: new Date(2020, 0, 1).toISOString(),
            }, {
                id: 2,
                name: "李四",
                role: 2,
                avatar: "https://ss0.bdstatic.com/70cFvHSh_Q1YnxGkpoWK1HF6hhy/it/u=1764219719,2359539133&fm=26&gp=0.jpg",
                createDate: new Date(2020, 0, 1, 8).toISOString(),
                updateDate: new Date(2020, 0, 1).toISOString(),
            }, {
                id: 3,
                name: "王五",
                role: 3,
                avatar: "https://timgsa.baidu.com/timg?image&quality=80&size=b9999_10000&sec=1578062622857&di=19a96caffcfd198db06485096f3655b3&imgtype=0&src=http%3A%2F%2Fimage.biaobaiju.com%2Fuploads%2F20181108%2F20%2F1541679918-sylFZadhMm.jpeg",
                createDate: new Date(2020, 0, 1).toISOString(),
                updateDate: new Date(2020, 0, 1).toISOString(),
            }
        ]));
    }, 1000);
};
const searchUser = createAction("searchUser");
const searchUserLatest = createAction("searchUserLatest");
const searchUserLeading = createAction("searchUserLeading");

export {
    addUser,
    modifyUserName,
    saveUser,
    deleteUsers,
    loadUsers,
    loadUsersAsync,
    searchUser,
    searchUserLatest,
    searchUserLeading,
};