import { loadUsers, addUser, modifyUserName, saveUser, deleteUsers } from './action';

export default {
    [loadUsers]: (state, action, meta) => ({ ...state, users: [...action.payload] }),
    [addUser]: (state, action, meta) => ({ ...state, users: [...state.users, action.payload] }),
    [modifyUserName]: (state, action, meta) => {
        let index = state.users.findIndex(u => u.id === action.payload.id);
        if (index !== -1) {
            let user = state.users[index];
            return {
                ...state,
                users: [
                    ...state.users.slice(0, index),
                    { ...user, name: action.payload.name },
                    ...state.users.slice(index + 1)]
            };
        }
        else {
            return state;
        }
    },
    [saveUser]: (state, action, meta) => {
        let index = state.users.findIndex(u => u.id === action.payload.id);
        if (index !== -1) {
            state.users[index] = action.payload;
        }
    },
    [deleteUsers]: (state, action, meta) => ({
        ...state,
        users: state.users.filter(u => !action.payload.includes(u.id))
    }),
    searchUserSuccess: (state, action, meta) => ({
        ...state,
        ...action.payload,
        searchTimes: state.searchTimes + 1,
        searchError: undefined,
        timestamp: Date.now(),
    }),
    searchUserError: (state, action, meta) => ({
        ...state,
        ...action.payload,
        searchTimes: state.searchTimes + 1,
        searchedUsers: undefined,
        timestamp: Date.now(),
    })
};