import { searchUser, searchUserLatest, searchUserLeading } from './action';
export default {
    takeEvery: {
        [searchUser]({ actions }) {
            return {
                saga: this.searchUserPromise,
                successAction: "searchUserSuccess",
                errorAction: "searchUserError"
            };
        }
    },
    takeLatest: {
        [searchUserLatest]({ actions }) {
            return {
                saga: this.searchUserPromise,
                successAction: "searchUserSuccess",
                errorAction: "searchUserError"
            };
        }
    },
    takeLeading: {
        [searchUserLeading]({ actions }) {
            return {
                saga: this.searchUserPromise,
                successAction: "searchUserSuccess",
                errorAction: "searchUserError"
            };
        }
    },
    searchUserPromise(action, { state }) {
        return new Promise((resolve, reject) => {
            setTimeout(() => {
                if ((state.searchTimes + 1) % 10 === 0) {
                    reject({
                        searchName: action.payload.name,
                        searchError: "搜索太多次啦~~~",
                    });
                }
                else {
                    resolve({
                        searchName: action.payload.name,
                        searchedUsers: state.users.filter(u => u.name.includes(action.payload.name || "")),
                    });
                }
            }, 1000);
        });
    }
};