import React from 'react';
import Udesk from '../../udesk';
import DemoLocalesLocales from '../../locales';

//Component demo pages
import CustomFiltersDemo from '../../../components/custom-filters/demo';
import CustomFilterInputDemo from "../../../components/custom-filter-inputs/demo";
import ReactTableDemo from "../../../components/react-table/demo";
import BootstrapDurationPickerDemo from "../../../components/bootstrap-duration-picker/demo";
import AutoCompleteDemo from "../../../components/auto-complete/demo";
import CheckBoxDemo from "../../../components/check-box/demo";
import RadioBtnDemo from "../../../components/radio-btn/demo";
import DateRangePickerDemo from "../../../components/date-range-picker/demo";
import ReactPagerDemo from "../../../components/react-pager/demo";
import ReactSelectDemo from "../../../components/react-select/demo";
import BubbleLoaderDemo from "../../../components/bubble-loader/demo";
import ReactModalDemo from "../../../components/react-modal/demo";
import ReactTinymceDemo from "../../../components/react-tinymce/demo";
import ReactEchartsDemo from "../../../components/react-echarts/demo";
import ReactToolDemo from "../../../components/react-field-tool/demo";
import DragTableDemo from "../../../components/drag-table/demo";
import NewVersionDemo from "../../../components/new-version/demo";
import ImageViewerDemo from "../../../components/image-viewer/demo";
import CustomUiGridDemo from "../../../components/custom-ui/grid/demo";
import JeTimePickerDemo from "../../../components/je-time-picker/demo";
import AceEditorDemo from "../../../components/ace-editor/demo";
import DrawerModalDemo from "../../../components/drawer-modal/demo";
import ReactAntdCheckboxGroup from "../../../components/react-antd-checkbox-group/demo";
import ReactTransversalSelectDemo from "../../../components/react-transversal-select/demo";
import ReactPowerSelectDemo from "../../../components/react-power-select/demo";

import ReactGaodeMapDemo from "../../../components/gaode-map/demo";


const DEMOS = [
    {
        id: "CustomFiltersDemo",
        name: DemoLocalesLocales.current.demo.customFilters.name,
        title: DemoLocalesLocales.current.demo.customFilters.title,
        description: DemoLocalesLocales.current.demo.customFilters.description,
        content: CustomFiltersDemo
    },
    {
        id: "CustomFilterInputDemo",
        name: DemoLocalesLocales.current.demo.customFilterInputs.name,
        title: DemoLocalesLocales.current.demo.customFilterInputs.title,
        description: DemoLocalesLocales.current.demo.customFilterInputs.description,
        content: CustomFilterInputDemo
    },
    {
        id: "ReactTableDemo",
        name: DemoLocalesLocales.current.demo.reactTable.name,
        title: DemoLocalesLocales.current.demo.reactTable.title,
        description: DemoLocalesLocales.current.demo.reactTable.description,
        content: ReactTableDemo
    },
    {
        id: "BootstrapDurationPickerDemo",
        name: DemoLocalesLocales.current.demo.bootstrapDurationPicker.name,
        title: DemoLocalesLocales.current.demo.bootstrapDurationPicker.title,
        description: DemoLocalesLocales.current.demo.bootstrapDurationPicker.description,
        content: BootstrapDurationPickerDemo
    },
    {
        id: "AutoCompleteDemo",
        name: DemoLocalesLocales.current.demo.autoComplete.name,
        title: DemoLocalesLocales.current.demo.autoComplete.title,
        description: DemoLocalesLocales.current.demo.autoComplete.description,
        content: AutoCompleteDemo
    },
    {
        id: "CheckBoxDemo",
        name: DemoLocalesLocales.current.demo.checkBox.name,
        title: DemoLocalesLocales.current.demo.checkBox.title,
        description: DemoLocalesLocales.current.demo.checkBox.description,
        content: CheckBoxDemo
    },
    {
        id: "RadioBtnDemo",
        name: DemoLocalesLocales.current.demo.radioBtn.name,
        title: DemoLocalesLocales.current.demo.radioBtn.title,
        description: DemoLocalesLocales.current.demo.radioBtn.description,
        content: RadioBtnDemo
    },
    {
        id: "DateRangePickerDemo",
        name: DemoLocalesLocales.current.demo.DateRangePicker.name,
        title: DemoLocalesLocales.current.demo.DateRangePicker.title,
        description: DemoLocalesLocales.current.demo.DateRangePicker.description,
        content: DateRangePickerDemo
    },
    {
        id: "ReactPagerDemo",
        name: DemoLocalesLocales.current.demo.reactPager.name,
        title: DemoLocalesLocales.current.demo.reactPager.title,
        description: DemoLocalesLocales.current.demo.reactPager.description,
        content: ReactPagerDemo
    },
    {
        id: "ReactSelectDemo",
        name: DemoLocalesLocales.current.demo.reactSelect.name,
        title: DemoLocalesLocales.current.demo.reactSelect.title,
        description: DemoLocalesLocales.current.demo.reactSelect.description,
        content: ReactSelectDemo
    },
    {
        id: "BubbleLoaderDemo",
        name: DemoLocalesLocales.current.demo.bubbleLoader.name,
        title: DemoLocalesLocales.current.demo.bubbleLoader.title,
        description: DemoLocalesLocales.current.demo.bubbleLoader.description,
        content: BubbleLoaderDemo
    },
    {
        id: "ReactModalDemo",
        name: DemoLocalesLocales.current.demo.reactModal.name,
        title: DemoLocalesLocales.current.demo.reactModal.title,
        description: DemoLocalesLocales.current.demo.reactModal.description,
        content: ReactModalDemo
    },
    {
        id: "ReactTinymceDemo",
        name: DemoLocalesLocales.current.demo.reactTinymce.name,
        title: DemoLocalesLocales.current.demo.reactTinymce.title,
        description: DemoLocalesLocales.current.demo.reactTinymce.description,
        content: ReactTinymceDemo
    },
    {
        id: "ReactEchartsDemo",
        name: DemoLocalesLocales.current.demo.reactEcharts.name,
        title: DemoLocalesLocales.current.demo.reactEcharts.title,
        description: DemoLocalesLocales.current.demo.reactEcharts.description,
        content: ReactEchartsDemo
    },
    {
        id: "ReactToolDemo",
        name: DemoLocalesLocales.current.demo.reactTool.name,
        title: DemoLocalesLocales.current.demo.reactTool.title,
        description: DemoLocalesLocales.current.demo.reactTool.description,
        content: ReactToolDemo
    },
    {
        id: "DragTableDemo",
        name: DemoLocalesLocales.current.demo.dragTable.name,
        title: DemoLocalesLocales.current.demo.dragTable.title,
        description: DemoLocalesLocales.current.demo.dragTable.description,
        content: DragTableDemo
    },
    {
        id: "NewVersionDemo",
        name: DemoLocalesLocales.get("demo.newVersion.name"),
        title: DemoLocalesLocales.get("demo.newVersion.title"),
        description: DemoLocalesLocales.get("demo.newVersion.description"),
        content: NewVersionDemo
    },
    {
        id: "ImageViewerDemo",
        name: DemoLocalesLocales.get("demo.imageViewer.name"),
        title: DemoLocalesLocales.get("demo.imageViewer.title"),
        description: DemoLocalesLocales.get("demo.imageViewer.description"),
        content: ImageViewerDemo
    },
    {
        id: "CustomUiGridDemo",
        name: DemoLocalesLocales.get("demo.customUiGrid.name"),
        title: DemoLocalesLocales.get("demo.customUiGrid.title"),
        description: DemoLocalesLocales.get("demo.customUiGrid.description"),
        content: CustomUiGridDemo
    },
    {
        id: "AceEditorDemo",
        name: DemoLocalesLocales.get("demo.aceEditor.name"),
        title: DemoLocalesLocales.get("demo.aceEditor.title"),
        description: DemoLocalesLocales.get("demo.aceEditor.description"),
        content: AceEditorDemo
    },
    {
        id: "DrawerModalDemo",
        name: DemoLocalesLocales.get("demo.drawerModal.name"),
        title: DemoLocalesLocales.get("demo.drawerModal.title"),
        description: DemoLocalesLocales.get("demo.drawerModal.description"),
        content: DrawerModalDemo
    },
    {
        id: "ReactAntdCheckboxGroup",
        name: DemoLocalesLocales.get("demo.ReactAntdCheckboxGroup.name"),
        title: DemoLocalesLocales.get("demo.ReactAntdCheckboxGroup.title"),
        description: DemoLocalesLocales.get("demo.ReactAntdCheckboxGroup.description"),
        content: ReactAntdCheckboxGroup
    },
    {
        id: "JeTimePickerDemo",
        name: DemoLocalesLocales.get("demo.jeTimePicker.name"),
        title: DemoLocalesLocales.get("demo.jeTimePicker.title"),
        description: DemoLocalesLocales.get("demo.jeTimePicker.description"),
        content: JeTimePickerDemo
    },
    {
        id: "ReactTransversalSelect",
        name: DemoLocalesLocales.get("demo.reactTransversalSelect.name"),
        title: DemoLocalesLocales.get("demo.reactTransversalSelect.title"),
        description: DemoLocalesLocales.get("demo.reactTransversalSelect.description"),
        content: ReactTransversalSelectDemo
    },
    {
        id: "reactPowerSelectDemo",
        name: DemoLocalesLocales.get("demo.reactPowerSelect.name"),
        title: DemoLocalesLocales.get("demo.reactPowerSelect.title"),
        description: DemoLocalesLocales.get("demo.reactPowerSelect.description"),
        content: ReactPowerSelectDemo
    },
    {
        id: "reactGaodeMapDemo",
        name: DemoLocalesLocales.get("demo.reactGaodeMap.name"),
        title: DemoLocalesLocales.get("demo.reactGaodeMap.title"),
        description: DemoLocalesLocales.get("demo.reactGaodeMap.description"),
        content: ReactGaodeMapDemo
    },
];

Udesk.react.context.defaults.options.localesManager = DemoLocalesLocales;

class UdeskReactDemo extends React.Component {
    constructor(props) {
        super(props);
        let hash = window.location.hash.replace("#", "");
        let matchedDemo = DEMOS.find(d => d.id === hash) || DEMOS[0];
        this.state.currentDemo = matchedDemo;
    }
    state = {
        currentDemo: null,
        context: Udesk.react.context.defaults,
    }
    privates = {
        demos: DEMOS
    }

    componentDidMount() {
        this.state.context.on("changed", (context) => {
            this.setState({
                context: context
            });
        });
    }

    actions = {
        switchDemo(demo) {
            this.setState({
                currentDemo: demo
            });
        },
        changeLanguage(e) {
            let language = e.target.value;
            this.state.context.updateProps({
                language: language
            });
        }
    }
}

UdeskReactDemo.propTypes = {
};

UdeskReactDemo.defaultProps = {
};

export default UdeskReactDemo;