import React from 'react';
import Udesk from '../../udesk';
import UdeskDemoComponent from './component';

export default class UdeskDemoTemplate extends UdeskDemoComponent {
    render() {
        let {
            // props,
            state,
            privates,
            // privates: { computes },
            actions
        } = this;
        let RunningDemo = state.currentDemo.content;
        return (
            <React.StrictMode>
                <Udesk.react.context.UdeskProvider value={state.context}>
                    <div className="demo-page">
                        {/* 
                            bootstrap v4
                            <nav className="navbar navbar-expand-md navbar-dark bg-dark">
                                <div className="navbar-brand">Udesk-React</div>
                                <div className="collapse navbar-collapse" id="navbarsExampleDefault">
                                    <ul className="navbar-nav mr-auto">
                                        <li className="nav-item dropdown">
                                            <a className="nav-link dropdown-toggle" href="#demos" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">{this.state.currentDemo.name}</a>
                                            <div className="dropdown-menu" aria-labelledby="dropdown01">
                                                {
                                                    privates.demos.map(demo =>
                                                        <a className="dropdown-item" key={demo.id} href={"#" + demo.id} onClick={actions.switchDemo.params(demo)} dangerouslySetInnerHTML={{ __html: Udesk.utils.web.safeHtml(demo.name.replace(/ /g, "&nbsp;")) }}></a>
                                                    )
                                                }
                                            </div>
                                        </li>
                                    </ul>
                                </div>
                            </nav> 
                        */}
                        {/* Bootstrap v3 */}
                        <nav className="navbar navbar-inverse navbar-fixed-top">
                            <div className="container">
                                <div className="navbar-header">
                                    <div className="navbar-brand">Udesk-React</div>
                                </div>
                                <div id="navbar" className="navbar-collapse collapse">
                                    <ul className="nav navbar-nav">
                                        <li className="dropdown">
                                            <a href="#demos" className="dropdown-toggle" data-toggle="dropdown" role="button" aria-haspopup="true" aria-expanded="false">{this.state.currentDemo.name} <span className="caret"></span></a>
                                            <ul className="dropdown-menu">
                                                {
                                                    privates.demos.map(demo =>
                                                        <li key={demo.id}>
                                                            <a className="" href={"#" + demo.id} onClick={actions.switchDemo.params(demo)} dangerouslySetInnerHTML={{ __html: Udesk.utils.web.safeHtml(demo.name.replace(/ /g, "&nbsp;")) }}></a>
                                                        </li>
                                                    )
                                                }
                                                {/* 
                                                    <li role="separator" className="divider"></li>
                                                    <li className="dropdown-header">Nav header</li> 
                                                */}
                                            </ul>
                                        </li>
                                    </ul>
                                    <form className="navbar-form navbar-right">
                                        <div className="form-group">
                                            <label className="control-label language-dropdown-label">Language</label>
                                            <select className="form-control language-dropdown" defaultValue={state.language} onChange={actions.changeLanguage}>
                                                <option value="ZH-CN">简体中文</option>
                                                <option value="EN-US">English (United States)</option>
                                            </select>
                                        </div>
                                        {/* 
                                            <div className="form-group">
                                                <input type="text" placeholder="Email" className="form-control" />
                                            </div>
                                            <div className="form-group">
                                                <input type="password" placeholder="Password" className="form-control" />
                                            </div>
                                            <button type="submit" className="btn btn-success">Sign in</button> 
                                        */}
                                    </form>
                                </div>
                            </div>
                        </nav>
                        <div role="main" className="container demo-page-body">
                            <If condition={state.currentDemo.description}>
                                <div className="jumbotron">
                                    <h2 className="component-name">{(state.currentDemo.title || state.currentDemo.name).replace(/^\s*/, "")}</h2>
                                    <p className="component-description" dangerouslySetInnerHTML={{ __html: Udesk.utils.web.safeHtml(state.currentDemo.description) }}></p>
                                </div>
                            </If>
                            <div className="demo-page-content">
                                <If condition={state.currentDemo}>
                                    <RunningDemo />
                                </If>
                            </div>
                        </div>
                    </div>
                </Udesk.react.context.UdeskProvider>
            </React.StrictMode>
        );
    }
}
