import React from 'react';
import {
    Route,
    Switch,
    Redirect,
    withRouter
} from 'react-router-dom';
import UserListComponent from './user-list';
import UserDetailComponent from './user-detail';

export default class UdeskDemoTemplate extends React.Component {
    render() {
        let UserListComponentWithRouter = withRouter(UserListComponent);
        let UserDetailComponentWithRouter = withRouter(UserDetailComponent);
        return (
            <Switch>
                <Redirect exact from="/redux" to="/redux/user-list" />
                <Route path="/redux/user-list">
                    <UserListComponentWithRouter />
                </Route>
                <Route path="/redux/user-detail/:id" children={({ match }) =>
                    <Choose>
                        <When condition={match.params.id === "1"}>
                            <UserDetailComponentWithRouter />
                        </When>
                        <When condition={match.params.id === "2"}>
                            <UserDetailComponentWithRouter reduxKey={match.params.id} keepReduxState={true} />
                        </When>
                        <Otherwise>
                            <UserDetailComponentWithRouter reduxKey={match.params.id} />
                        </Otherwise>
                    </Choose>
                }>
                </Route>
                <Redirect exact strict to="/404" />
            </Switch>
        );
    }
}
