import React from 'react';
// import Udesk from '../../../udesk';

class UserDetailComponent extends React.Component {
    state = {
        user: null,
        userNotFound: false,
        isLastIndex: false,
        isFirstIndex: false
    }

    componentDidMount() {
        this.props.setCurrentUserId(parseInt(this.props.match.params.id, 10));
        if (!this.props.users) {
            this.props.loadUsersAsync();
        }
        else {
            this.actions.findUser();
        }
        if (!this.props.roles) {
            this.props.getRolesAsync();
        }
    }
    componentDidUpdate() {
        if (!this.state.user && !this.state.userNotFound && this.props.users) {
            this.actions.findUser();
        }
    }

    actions = {
        goBack() {
            this.props.history.push("/redux/user-list");
        },
        gotoPreviousUser() {
            // eslint-disable-next-line eqeqeq
            let matchIndex = this.props.users.findIndex(u => u.id == this.props.match.params.id);
            if (matchIndex === -1 || matchIndex === 0) {
                this.setState({
                    isFirstIndex: true
                });
            }
            else {
                let previousUserId = this.props.users[matchIndex - 1].id;
                this.props.history.push(`/redux/user-detail/${previousUserId}`);
            }
        },
        gotoNextUser() {
            // eslint-disable-next-line eqeqeq
            let matchIndex = this.props.users.findIndex(u => u.id == this.props.match.params.id);
            if (matchIndex === -1 || matchIndex === this.props.users.length - 1) {
                this.setState({
                    isLastIndex: true
                });
            }
            else {
                let nextUserId = this.props.users[matchIndex + 1].id;
                this.props.history.push(`/redux/user-detail/${nextUserId}`);
            }
        },
        changeName(e) {
            this.props.modifyUserName({
                id: this.state.user.id,
                name: e.target.value
            });
        },
        save() {
            this.props.saveUser(this.state.user);
            this.actions.goBack();
        },
        deleteUser() {
            this.props.deleteUsers([this.state.user.id]);
            this.props.setCurrentUserId();
            this.actions.goBack();
        },
        onRoleChanged(e) {
            this.setState({
                user: {
                    ...this.state.user,
                    role: parseInt(e.target.value, 10)
                }
            });
        },
        findUser() {
            // eslint-disable-next-line eqeqeq
            let matchedUser = this.props.users.find(u => u.id == this.props.match.params.id);
            if (matchedUser) {
                this.setState({
                    user: matchedUser
                });
            }
            else {
                this.setState({
                    userNotFound: true
                });
            }
        }
    }
}

UserDetailComponent.propTypes = {
};

UserDetailComponent.defaultProps = {
};

export default UserDetailComponent;