import React from 'react';
import UserDetailRoute from './route';
import './style.css';

export default class UserDetailTemplate extends UserDetailRoute {
    render() {
        let {
            props,
            // state,
            // privates,
            // actions
        } = this;
        return (
            <div className="page page-layout page-user-detail">
                <div className="page-record">
                    <If condition={this.state.userNotFound}>
                        <h3>用户不存在！</h3>
                    </If>
                    <If condition={!this.state.userNotFound}>
                        <If condition={this.state.user}>
                            <h1 className="page-header clearfix">用户信息 {props.reduxKey}</h1>
                            <section className="user-toolbar">
                                <button onClick={this.actions.goBack} >&lt;&lt;返回</button>
                                <button onClick={this.actions.gotoPreviousUser} disabled={this.state.isFirstIndex}>上一个</button>
                                <button onClick={this.actions.gotoNextUser} disabled={this.state.isLastIndex}>下一个</button>
                                <button onClick={this.actions.save}>保存</button>
                                <button onClick={this.actions.deleteUser}>删除</button>
                            </section>
                            <hr />
                            <br />
                            <fieldset>
                                <ul className="user-form">
                                    <li className="form-row">
                                        <div className="field-caption">姓名:</div>
                                        <div className="field-control">
                                            <input type="text" defaultValue={this.state.user.name} onChange={this.actions.changeName}></input> (实时修改)
                                        </div>
                                    </li>
                                    <li className="form-row">
                                        <div className="field-caption">头像: </div>
                                        <div className="field-control">
                                            <img src={this.state.user.avatar} alt={`${this.state.user.name}的头像`} height="50" />
                                        </div>
                                    </li>
                                    <If condition={this.props.roles}>
                                        <li className="form-row">
                                            <div className="field-caption">角色:</div>
                                            <div className="field-control">
                                                <select onChange={this.actions.onRoleChanged}>
                                                    <For each="role" of={this.props.roles}>
                                                        <option key={role.id} selected={role.id === this.state.user.role} value={role.id}>{role.name}</option>
                                                    </For>
                                                </select>
                                            </div>
                                        </li>
                                    </If>
                                    <li className="form-row">
                                        <div className="field-caption">创建时间:</div>
                                        <div className="field-control">{this.state.user.createDate}</div>
                                    </li>
                                    <li className="form-row">
                                        <div className="field-caption">更新时间:</div>
                                        <div className="field-control">{this.state.user.updateDate}</div>
                                    </li>
                                </ul>
                            </fieldset>
                        </If>
                        <If condition={!this.state.user}>
                            <h3>数据加载中...</h3>
                        </If>
                    </If>
                </div>
            </div >
        );
    }
}
