import React from 'react';
import UserListRoute from './route';
import ReactAntdTable from '../../../../components/react-antd-table';
import './style.css';

export default class UserListTemplate extends UserListRoute {
    render() {
        return (
            <div className="page page-layout page-user-list">
                <div className="page-record">
                    <h1 className="page-header clearfix">用户列表</h1>
                    <div className="user-search">
                        {/* <h3>搜索</h3> */}
                        <div>
                            <section>
                                <p>
                                    姓名: <input type="text" defaultValue={this.state.searchName} onChange={(e) => { this.setState({ searchName: e.target.value }); }} />
                                </p>
                            </section>
                            <section>
                                <button onClick={this.actions.search}>搜索</button>
                                &nbsp;&nbsp;
                                <button onClick={this.actions.debounceSearch}>防抖搜索</button>
                                &nbsp;&nbsp;
                                <button onClick={this.actions.throttlingSearch}>节流搜索</button>
                                &nbsp;&nbsp;
                                <If condition={this.props.searchTimes > 0}>
                                    <React.Fragment>搜索次数：{this.props.searchTimes}</React.Fragment>
                                </If>
                            </section>
                        </div>
                    </div>
                    <hr />
                    <section className="user-toolbar">
                        <button onClick={this.actions.addUser}>添加新用户</button>
                        &nbsp;&nbsp;
                        <button onClick={this.actions.removeUsers}>删除</button>
                        {/* &nbsp;&nbsp;
                        <button onClick={this.actions.throttlingSearch}>节流搜索</button> */}
                    </section>
                    <br />
                    <div className="search-result">
                        <With hasError={!!this.props.searchError}>
                            <If condition={hasError}>
                                <h3>出错啦！</h3>
                                <p>{this.props.searchError}</p>
                            </If>
                            <If condition={!hasError}>
                                <ReactAntdTable
                                    loading={!this.props.users}
                                    columns={this.state.columns}
                                    dataSource={this.props.searchedUsers || this.props.users}
                                    size="middle"
                                    onSelectChanged={this.actions.onSelectChanged}
                                    onRowClick={this.actions.onRowClick}
                                    onColumnsVisibleChanged={this.actions.onColumnsVisibleChanged}
                                    showColumnSetting
                                    bordered
                                    resizable
                                    columnDragable
                                    showCheckboxColumn
                                    showTitle
                                    title={this.props.searchedUsers ? "搜索结果" : "全部用户"}
                                />
                            </If>
                        </With>
                    </div>
                </div>
            </div>
        );
    }
}
