import React from 'react';
import { Provider } from 'react-redux';
import {
    BrowserRouter as Router,
    Route,
    Redirect,
    Switch,
} from 'react-router-dom';
import Udesk from '../udesk';
import store from "../../udesk/react/redux/store";
import PagesComponent from './component';
import NotFoundComponent from './not-found';
import UdeskDemoComponent from './demo';
import ReduxDemoComponent from './redux-demo';
// import routing from '../../udesk/ui/routing';

export default class UdeskDemoTemplate extends PagesComponent {
    render() {
        return (
            <React.StrictMode>
                <Provider store={store}>
                    <Udesk.react.context.UdeskProvider value={this.state.context}>
                        <Router>
                            <Switch>
                                <Redirect exact from="/" to="/demo" />
                                <Route path="/">
                                    <Switch>
                                        <Route path="/demo">
                                            <UdeskDemoComponent />
                                        </Route>
                                        <Route path="/redux">
                                            <ReduxDemoComponent />
                                        </Route>
                                        <Route path="/404">
                                            <NotFoundComponent />
                                        </Route>
                                        <Redirect exact strict to="/404" />
                                    </Switch>
                                </Route>
                            </Switch>
                        </Router>
                    </Udesk.react.context.UdeskProvider>
                </Provider>
            </React.StrictMode>
        );
    }
}
