/** @jsx jsx */
import {jsx} from '@emotion/react';
import {Component} from 'react';

type Props = {
    content: string[],
    value: string,
    activeClassName: string,
    onChange: (v: string) => void,
    className?: string,
    t?: (v: string) => string
}

type State = {}

class Categories extends Component<Props, State> {
    render() {
        let {
            content,
            activeClassName = 'active',
            value,
            className = '',
            t = (v) => v
        } = this.props;
        return (
            <ul className={className}>
                {content.map((i, idx) => <li className={i === value ? activeClassName : ''}
                                             key={idx}
                                             onClick={(e) => this._onClick(e, i)}>{t(i)}</li>)}
            </ul>
        );
    }

    _onClick = (e, category: string) => {
        let {
            onChange
        } = this.props;

        if (typeof onChange === 'function') {
            onChange(category);
        }
    };
}

export default Categories;
