import React, {ComponentProps, useCallback, useEffect, useState} from 'react';
import { Cascader } from 'udesk-ui';
import CopyComponent from '../../../copy';

/**
 * 级联组件
 * @param props
 */
const NewCascader: React.FC<any> = (props) => {
    console.log('newCascader', props);
    const [value, setValue] = useState<any>(undefined);
    const { options } = props;
    useEffect(() => {
        // const values = (props.value || []).reduce((initValues: any, currentValue: any, index: number) => {
        //     let options: any;
        //     if (!index) {
        //         options = props.options;
        //     } else {
        //         options = (initValues[index - 1] || {}).options;
        //     }

        //     const keyOption = options.find((option: any) => {
        //         return currentValue === option.value
        //     });

        //     initValues.push({
        //         key: keyOption.label,
        //         options: keyOption.children || keyOption.subs || []
        //     });

        //     return initValues;
        // }, []).map((item: any) => item.key);

        // setValue(values)
        let value = props.value;
        if (value && typeof value === 'string') {
            value = props.value.split(',');
        }
        setValue(value);
    }, [props.value]);

    const handleChange: ComponentProps<typeof Cascader>['onChange'] = useCallback(
        (value) => {
            setValue(value);
            props.onChange && props.onChange(value.length ? value : '');
        },
        [props]
    );

    const formatValue = useCallback(
        (value) => {
            const data = (value || [])
                .reduce((initValues: any, currentValue: any, index: number) => {
                    let _options: any;
                    if (!index) {
                        _options = options;
                    } else {
                        _options = (initValues[index - 1] || {}).options || [];
                    }

                    const keyOption =
                        _options.find((option: any) => {
                            return currentValue === option.value;
                        }) || {};

                    initValues.push({
                        key: keyOption.label,
                        options: keyOption.children || keyOption.subs || [],
                    });

                    return initValues;
                }, [])
                .filter((_t: any) => _t.key)
                .map((item: any) => item.key)
                .join('/');

            return data;
        },
        [options]
    );

    return (
        <CopyComponent text={formatValue(value)} switchFlag={props.switchFlag}>
            <Cascader
                options={props.options}
                value={value}
                onChange={handleChange}
                placeholder="请选择"
                changeOnSelect
                showSearch
                disabled={props.disabled}
            />
        </CopyComponent>
    );
};

export default NewCascader;
