//多选框组件
import React, { useCallback, useEffect, useMemo, useRef, useState } from 'react';
import { Checkbox } from 'udesk-ui';
import cssObj from './index.module.scss'

const CheckboxGroup = Checkbox.Group;

function Filed_checkbox(props: any) {
    const {onChange, options = [], sort_type = 'x'} = props
    //选择的选项值
    const [checkedList, setCheckedList] = useState<any[]>([])
    // 换行排列样式
    const yStyle = useRef({
        display: 'block',
        height: '30px',
        lineHeight: '30px',
        marginLeft: '0'
    })
    // 连续排列样式
    const xStyle = useRef({
        display: 'inline-block'
    })
    // 监听道选项改变 处理数据   取出其中默认选项  复制给Radio.Group的value  主要是外部新建字段  改变默认选项时触发  改变展示效果
    useEffect(() => {
        if (props.value) {
            //value  类型 是[] 或 string
            if (typeof (props.value) === 'string') {
                // 将value转数组  存值
                setCheckedList(props.value.split(','))
            } else {
                setCheckedList(props.value)
            }
        } else {
            setCheckedList(options.filter((item: any) => item.default).map((item: any) => item.value))
        }
    }, [props.value])

    // useEffect(() => {
    //     setCheckedList(props.value)
    // }, [props.value])

    // 选择改变时触发
    const checkOnChange = useCallback((checkedList: any[]) => {
        setCheckedList(checkedList)
        if (onChange) onChange(checkedList.join(','))
    }, [onChange])

    const checkGroupChildren = useMemo(() => {
        return (
            <CheckboxGroup
                value={checkedList}
                onChange={checkOnChange}
                disabled={props.disabled}
            >
                {options.map((item: any) => {
                    return (
                        <Checkbox key={item.value} value={item.value}
                                  style={sort_type === 'y' ? yStyle.current : xStyle.current}>
                        <span
                            className={`${cssObj['select-item']} ${item.color ? cssObj['select-item-hascolor'] : ''}`}
                            style={{
                                background: item.color ? item.color : ''
                            }}
                        >
                            {item.icon ?
                                <img alt='' src={item.icon} className={cssObj['setting-img']}/> : ''}{item.title}
                        </span>
                        </Checkbox>
                    )
                })}
            </CheckboxGroup>
        )
    }, [checkOnChange, checkedList, options, props.disabled, sort_type])
    return (
        <div className={cssObj['select-wrapper']}>
            {checkGroupChildren}
        </div>
    );
}

export default Filed_checkbox;
