import React, { useEffect, useState } from 'react';
import { Select } from 'udesk-ui';
import cssObj from './index.module.scss';
import CopyComponent from '../../copy';

const { Option } = Select;

function Filed_droplistRadio(props: any) {
    const { onChange, options = [], switchFlag = false } = props;
    //选择的选项值
    const [selectValue, setSelectValue] = useState<string[]>();
    // 监听道选项改变 处理数据   取出其中默认选项  复制给Radio.Group的value  主要是外部新建字段  改变默认选项时触发  改变展示效果
    useEffect(() => {
        //如果有传value  说明在formitem里   优先使用value
        if (props.value) {
            //value  类型 是[] 或 string
            if (typeof props.value === 'string') {
                // 将value转数组  存值
                setSelectValue(props.value.split(','));
            }
        } else {
            let valueList: string[] = [];
            options.forEach((item: any) => {
                if (item.default) valueList.push(item.value);
            });
            setSelectValue(valueList);
        }
    }, [options, props.value]);

    useEffect(() => {
        setSelectValue(typeof props.value === 'string' ? props.value.split(',') : props.value);
    }, [props.value]);

    function selectOnChange(e: string[]) {
        setSelectValue(e);
        if (onChange) onChange(e.join(','));
    }

    return (
        <CopyComponent text={(selectValue && selectValue.join(',')) || ''} switchFlag={switchFlag}>
            <Select
                value={selectValue}
                onChange={selectOnChange}
                style={{ width: '100%' }}
                mode="multiple"
                getPopupContainer={(triggerNode) => triggerNode}
                disabled={props.disabled}
            >
                {options.map((item: any) => {
                    return (
                        <Option key={item.value} value={item.value}>
                            <span
                                className={`${cssObj['select-item']} ${
                                    item.color ? cssObj['select-item-hascolor'] : ''
                                }`}
                                style={{
                                    background: item.color ? item.color : '',
                                }}
                            >
                                {item.icon ? <img alt="" src={item.icon} className={cssObj['setting-img']} /> : ''}
                                {item.title}
                            </span>
                        </Option>
                    );
                })}
            </Select>
        </CopyComponent>
    );
}

export default Filed_droplistRadio;
