import React from 'react';

interface FieldCommonProps extends IAnyField {
    children?: React.ReactNode
    errMsg: string
}

const FieldCommon: React.FC<FieldCommonProps> = (props) => {
    return (
        <React.Fragment>
            {props.children}
            {
                props.errMsg && !props.isFormItem && (
                    <div className='err-text' style={{color: '#ff5e5b'}}>{props.errMsg}</div>
                )
            }
            {
                props.explain && props.explainShow && (
                    <div className='explain-rich' style={{
                        maxHeight: '200px',
                        overflow: 'auto',
                        color: 'rgba(0, 0, 0, 0.45)',
                        paddingLeft: '5px'
                    }} dangerouslySetInnerHTML={{__html: props.explain}}></div>
                )
            }
        </React.Fragment>
    );
}

export default FieldCommon;
