import React, { useMemo } from 'react';

function CustomSelect(props: any) {
    let {allowClear = true} = props
    const options = useMemo(() => {
        let options = props.options
        if (allowClear) {
            options.unshift({
                title: "--",
                value: ""
            })
        }
        return options
    }, [allowClear, props.options])
    const children = useMemo(() => {
        return React.Children.map(props.children, child => (
            React.cloneElement(child, {
                ...props,
                options
            })
        ))
    }, [options, props])
    return (
        <>
            {children}
        </>
    );
}

export default CustomSelect;
