import React from 'react';
import Udesk from '../../udesk/index';
import CheckBox from './index';

const CHECK_BOX_OPTIONS = [{
    id: 1,
    name: "test1",
    disabled: true,
    description: "(test description)"
}, {
    id: 2,
    name: "test2"
}];

const SINGLE_CHECK_BOX_OPTIONS = [{
    id: 1,
    name: "test"
}];

class CheckBoxDemo extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            value: [1],
            singleValue: true
        };
    }

    actions = {
        onChanged(value) {
            this.setState({
                value
            });
        },

        onSingleValueChanged(singleValue) {
            this.setState({
                singleValue
            });
        }
    }

    render() {
        let {
            value,
            singleValue
        } = this.state;
        return (
            <div>
                <h4>checkbox</h4>
                <CheckBox value={value} options={CHECK_BOX_OPTIONS} onChanged={this.actions.onChanged} />
                <h4>single checkbox</h4>
                <CheckBox value={singleValue} singleCheckBox={true} options={SINGLE_CHECK_BOX_OPTIONS} onChanged={this.actions.onSingleValueChanged} />
            </div>
        );
    }
}

CheckBoxDemo.propTypes = {
};

CheckBoxDemo.defaultProps = {
};

export default Udesk.react.udeskify(CheckBoxDemo);