import React, { useState } from 'react';
import { SketchPicker } from 'react-color';
import { Button } from 'udesk-ui'
import cssObj from './colorPicker.module.scss'

interface Props {
    color: string,
    closePicker: () => void,
    confirmPicker: (color: string) => void
}

const Index: React.FC<Props> = (props) => {
    const [color, setColor] = useState<string>(props.color)

    function handleChangeComplete(value: any) {
        setColor(value.hex)
    }

    return (
        <div className={cssObj['color-picker-wrapper']}>
            <SketchPicker
                color={color}
                onChangeComplete={handleChangeComplete}
            />
            <div className={cssObj['btn-list']}>
                <Button onClick={props.closePicker}>取消</Button>
                <Button onClick={() => props.confirmPicker(color)}>确定</Button>
            </div>
        </div>
    );
}

export default Index;
