import React, { useState } from 'react';
import { SketchPicker } from 'react-color';
import { Button } from 'udesk-ui'
import cssObj from './colorPicker.module.scss'

function ColorPicker(props: any) {
    const [color, setColor] = useState<string>(props.color)

    function handleChangeComplete(value: any) {
        setColor(value.hex)
    }

    return (
        <div className={cssObj['color-picker-wrapper']}>
            <SketchPicker
                color={color}
                onChangeComplete={handleChangeComplete}
            />
            <div className={cssObj['btn-list']}>
                <Button onClick={() => props.confirmPicler('')}>清空</Button>
                <Button onClick={() => props.confirmPicler(color)}>确定</Button>
            </div>
        </div>
    );
}

export default ColorPicker;
