import React from 'react';
import CustomFieldItem from './field-item'

interface CustomFieldContainerProps {
    fields: any
    isFormItem?: boolean,
    switchFlag?: boolean,
    notUseDefault?:boolean
}

const CustomFieldContainer: React.FC<CustomFieldContainerProps> = ({ fields, isFormItem = true, ...props }) => {
    return <React.Fragment>
        {
            fields.length > 0 && (
                fields.map((fieldItem: IFieldItem) => {
                    return <CustomFieldItem key={fieldItem.field.id} {...props} fieldItem={fieldItem} isFormItem={isFormItem} />
                })
            )
        }
    </React.Fragment>
};

export default CustomFieldContainer;
