import React from 'react';
import DataSourceBaseClass from './data-source-base-class';
import CheckboxComponent from "../check-box/index";
import Udesk from '../../udesk/index';

class Checkbox extends DataSourceBaseClass {
    actions = {
        _validate() {
            return true;
        },
        _onInputValueChanged(internalValue) {
            this.actions._onChanged(internalValue);
        }
    }

    static get emberName() {
        return 'udesk/custom-field-inputs/check-box';
    }

    render() {
        let {
            privates: { computes },
        } = this;

        let {
            internalValue,
            mergedAttributes
        } = computes;
        let {
            disabled,
            dataSource,
            dataSourceValueFeild,
            dataSourceNameField,
            DefaultValueField,
            DefaultNameField,
        } = this.props;
        let valueField = DefaultValueField;
        if (mergedAttributes[dataSourceValueFeild] != null) {
            valueField = mergedAttributes[dataSourceValueFeild];
        }
        let nameField = DefaultNameField;
        if (mergedAttributes[dataSourceNameField] != null) {
            nameField = mergedAttributes[dataSourceNameField];
        }

        return (
            <CheckboxComponent value={internalValue} classNames={mergedAttributes.classNames} disabled={disabled} options={dataSource} valueField={valueField} nameField={nameField} onChanged={this.actions._onInputValueChanged} />
        );
    }
}

export default Udesk.react.udeskify(Checkbox);