import React, { Component } from 'react';
// import PropTypes from 'prop-types';
import TextBox from './text-box';
import Textarea from "./text-area";
import IntegerNumber from "./integer-number";
import FloatNumber from "./float-number";
import SimplePhone from "./simple-phone";
import TextPercent from "./text-percent";
import DatePicker from "./date-picker";
import DateTimePicker from "./date-time-picker";
import DateRangePicker from "./date-range-picker";
import DurationPicker from "./duration-picker";
import Checkbox from "./check-box";
import ReactSelect from "./react-select";
import ReactMultiSelect from "./react-multi-select";
import DropDown from "./drop-down";
import AutoComplete from "./auto-complete";
import ReactPowerSelect from "./react-power-select";
import ReactPowerMultiSelect from './react-power-multi-select';
import TimePicker from "./time-picker";

import "./style/index.css";

const dataSource = [{
    id: 1,
    name: "test1"
}, {
    id: 2,
    name: "test2"
}];

export default class CustomFilterInputDemo extends Component {
    constructor(props) {
        super(props);
        this.state = {
            textBoxValue: "",
            textAreaValue: "",
            integerNumberValue: "",
            floatNumberValue: "",
            simplePhoneValue: "",
            textPercentValue: "",
            datePickerValue: "",
            dateRangePickerValue: "",
            durationPickerValue: "",
            checkboxValue: null,
            reactSelectValue: 1,
            reactMultiSelectValue: [1],
            dropDownValue: 1,
            autoCompleteValue: null,
            reactPowerSelectValue: 1,
            reactPowerMultiSelectValue: [1],
            timePickerValue: null
        };
        this.changeTextBoxValue = this.changeTextBoxValue.bind(this);
        this.changeAreaBoxValue = this.changeAreaBoxValue.bind(this);
        this.changeIntegerNumberValue = this.changeIntegerNumberValue.bind(this);
        this.changeFloatNumberValue = this.changeFloatNumberValue.bind(this);
        this.changeSimplePhoneValue = this.changeSimplePhoneValue.bind(this);
        this.changeTextPercentValue = this.changeTextPercentValue.bind(this);
        this.changeDatePickerValue = this.changeDatePickerValue.bind(this);
        this.changeDateTimePickerValue = this.changeDateTimePickerValue.bind(this);
        this.changeDateRangePickerValue = this.changeDateRangePickerValue.bind(this);
        this.changeDurationPickerPickerValue = this.changeDurationPickerPickerValue.bind(this);
        this.changeCheckboxValue = this.changeCheckboxValue.bind(this);
        this.changeReactSelectValue = this.changeReactSelectValue.bind(this);
        this.changeReactMultiSelectValue = this.changeReactMultiSelectValue.bind(this);
        this.changeMultiDropdownValue = this.changeMultiDropdownValue.bind(this);
        this.changeAutoCompleteValue = this.changeAutoCompleteValue.bind(this);
        this.changeReactPowerSelectValue = this.changeReactPowerSelectValue.bind(this);
        this.changeReactPowerMultiSelectValue = this.changeReactPowerMultiSelectValue.bind(this);
        this.changeTimePickerValue = this.changeTimePickerValue.bind(this);

        this.autoCompleteAttributes = {
            loadOptions() {
                return new Promise((resolve, reject) => {
                    resolve([{
                        id: 1,
                        name: "test1"
                    }, {
                        id: 2,
                        name: "test2"
                    }]);
                });
            }
        };
    }

    changeTextBoxValue(value) {
        this.setState({
            textBoxValue: value
        });
    }

    changeAreaBoxValue(value) {
        this.setState({
            textAreaValue: value
        });
    }

    changeIntegerNumberValue(value) {
        this.setState({
            integerNumberValue: value
        });
    }

    changeFloatNumberValue(value) {
        this.setState({
            floatNumberValue: value
        });
    }

    changeSimplePhoneValue(value) {
        this.setState({
            simplePhoneValue: value
        });
    }

    changeTextPercentValue(value) {
        this.setState({
            textPercentValue: value
        });
    }

    changeDatePickerValue(value) {
        this.setState({
            datePickerValue: value
        });
    }

    changeDateTimePickerValue(value) {
        this.setState({
            dateTimePickerValue: value
        });
    }

    changeDateRangePickerValue(value) {
        this.setState({
            dateRangePickerValue: value
        });
    }

    changeDurationPickerPickerValue(value) {
        this.setState({
            durationPickerValue: value
        });
    }

    changeCheckboxValue(value) {
        this.setState({
            checkboxValue: value
        });
    }

    changeReactSelectValue(value) {
        this.setState({
            reactSelectValue: value
        });
    }

    changeReactMultiSelectValue(value) {
        this.setState({
            reactSelectMultiValue: value
        });
    }

    changeMultiDropdownValue(value) {
        this.setState({
            dropDownValue: value
        });
    }

    changeAutoCompleteValue(value) {
        this.setState({
            autoCompleteValue: value
        });
    }
    changeReactPowerSelectValue(value) {
        this.setState({
            reactPowerSelectValue: value
        });
    }
    changeReactPowerMultiSelectValue(value) {
        this.setState({
            reactPowerMultiSelectValue: value
        });
    }
    changeTimePickerValue(value) { 
        this.setState({
            timePickerValue: value
        });
    }
    render() {
        return (
            <div>
                <h4>text-box</h4>
                <TextBox value={this.state.textBoxValue} onChanged={this.changeTextBoxValue} />
                <h4>text-area</h4>
                <Textarea value={this.state.textAreaValue} onChanged={this.changeAreaBoxValue} />
                <h4>integer-number</h4>
                <IntegerNumber value={this.state.integerNumberValue} onChanged={this.changeIntegerNumberValue} />
                <h4>float-number</h4>
                <FloatNumber value={this.state.floatNumberValue} onChanged={this.changeFloatNumberValue} />
                <h4>simple-phone</h4>
                <SimplePhone value={this.state.simplePhoneValue} onChanged={this.changeSimplePhoneValue} />
                <h4>text-percent</h4>
                <TextPercent value={this.state.textPercentValue} onChanged={this.changeTextPercentValue} />
                <h4>date-picker</h4>
                <DatePicker value={this.state.datePickerValue} onChanged={this.changeDatePickerValue} />
                <h4>date-time-picker</h4>
                <DateTimePicker value={this.state.dateTimePickerValue} onChanged={this.changeDateTimePickerValue} />
                <h4>date-range-picker</h4>
                <DateRangePicker value={this.state.dateRangePickerValue} onChanged={this.changeDateRangePickerValue} />
                <h4>duration-picker</h4>
                <DurationPicker value={this.state.durationPickerValue} onChanged={this.changeDurationPickerPickerValue} />
                <h4>check-box</h4>
                <Checkbox value={this.state.checkboxValue} dataSource={dataSource} onChanged={this.changeCheckboxValue} />
                <h4>react-select</h4>
                <ReactSelect value={this.state.reactSelectValue} dataSource={dataSource} onChanged={this.changeReactSelectValue} />
                <h4>react-multi-select</h4>
                <ReactMultiSelect value={this.state.reactMultiSelectValue} dataSource={dataSource} onChanged={this.changeReactMultiSelectValue} />
                <h4>drop-down</h4>
                <DropDown value={this.state.dropDownValue} dataSource={dataSource} onChanged={this.changeMultiDropdownValue} />
                <h4>auto-complete</h4>
                <AutoComplete value={this.state.autoCompleteValue} attributes={this.autoCompleteAttributes} onChanged={this.changeAutoCompleteValue} />
                <h4>Single power select</h4>
                <ReactPowerSelect value={this.state.reactPowerSelectValue} dataSource={dataSource} onChanged={this.changeReactPowerSelectValue} />
                <h4>react-power-multi-select</h4>
                <ReactPowerMultiSelect value={this.state.reactPowerMultiSelectValue} dataSource={dataSource} onChanged={this.changeReactPowerMultiSelectValue} />
                <h4>time-picker</h4>
                <TimePicker value={this.state.timePickerValue} onChanged={this.changeTimePickerValue} />
            </div>
        );
    }
}
