import React from 'react';
import DataSourceBaseClass from './data-source-base-class';
import DropDrownComponent from "../react-select/index";
import Udesk from '../../udesk/index';

class DropDrown extends DataSourceBaseClass {
    actions = {
        _validate() {
            return true;
        },
        _getInternalValueFromValue(value) {
            let internalValue = super._getInternalValueFromValue(value);
            if (internalValue == null) {
                return "";
            }
            return internalValue;
        },
        _onInputValueChanged(internalValue) {
            this.actions._onChanged(internalValue);
        }
    }

    static get emberName() {
        return 'udesk/custom-field-inputs/drop-down';
    }
    
    render() {
        let {
            privates: { computes },
        } = this;

        let {
            internalValue,
            mergedAttributes
        } = computes;
        let {
            disabled,
            dataSource,
            dataSourceValueFeild,
            dataSourceNameField,
            DefaultValueField,
            DefaultNameField,
        } = this.props;
        let valueField = DefaultValueField;
        if (mergedAttributes[dataSourceValueFeild] != null) {
            valueField = mergedAttributes[dataSourceValueFeild];
        }
        let nameField = DefaultNameField;
        if (mergedAttributes[dataSourceNameField] != null) {
            nameField = mergedAttributes[dataSourceNameField];
        }

        return (
            <DropDrownComponent value={internalValue} classNames={mergedAttributes.classNames} disabled={disabled} dataScource={dataSource} valueField={valueField} nameField={nameField} onChanged={this.actions._onInputValueChanged} />
        );
    }
}

export default Udesk.react.udeskify(DropDrown);