import React from 'react';
import InputBaseClass from './input-base-class';
import BootstrapDurationPicker from "../bootstrap-duration-picker/index";
import Udesk from '../../udesk/index';

class DurationPicker extends InputBaseClass {
    actions = {
        _validate() {
            return true;
        },

        _onInputValueChanged(internalValue) {
            this.actions._onChanged(internalValue);
        }
    }

    static get emberName() {
        return 'udesk/custom-field-inputs/duration-picker';
    }
    
    render() {
        let {
            privates: { computes },
        } = this;

        let {
            internalValue,
            mergedAttributes
        } = computes;
        let {
            disabled
        } = this.props;

        // mergedAttributes的属性统统传入了下级组件
        return (
            <BootstrapDurationPicker value={internalValue} {...mergedAttributes} disabled={disabled} onChanged={this.actions._onInputValueChanged} />
        );
    }
}

export default Udesk.react.udeskify(DurationPicker);