import React from 'react';
import DataSourceBaseClass from './data-source-base-class';
import ReactPowerSelectComponent from "../react-power-select";
import Udesk from '../../udesk/index';

class ReactPowerMultiSelect extends DataSourceBaseClass {
    actions = {
        _validate() {
            return true;
        },
        _getInternalValueFromValue(value) {
            let internalValue = super._getInternalValueFromValue(value);
            if (internalValue == null) {
                return "";
            }
            return internalValue;
        },
        _onInputValueChanged(internalValue) {
            this.actions._onChanged(internalValue);
        }
    }

    static get emberName() {
        return 'udesk/custom-field-inputs/power-select';
    }
    
    render() {
        let {
            privates: { computes },
        } = this;

        let {
            internalValue,
            mergedAttributes
        } = computes;


        let {
            disabled,
            dataSource,
            dataSourceValueFeild,
            dataSourceNameField,
            DefaultValueField,
            DefaultNameField,
        } = this.props;
        let valueField = DefaultValueField;
        if (mergedAttributes[dataSourceValueFeild] != null) {
            valueField = mergedAttributes[dataSourceValueFeild];
        }
        let nameField = DefaultNameField;
        if (mergedAttributes[dataSourceNameField] != null) {
            nameField = mergedAttributes[dataSourceNameField];
        }

        return (
            <ReactPowerSelectComponent value={internalValue} classNames={mergedAttributes.classNames} disabled={disabled} dataSource={dataSource} valueField={valueField} nameField={nameField} placeholder={mergedAttributes.placeholder} customStyle={mergedAttributes.customStyle} noOptionsMessage={mergedAttributes.noOptionsMessage} onChanged={this.actions._onInputValueChanged} isMulti/>
        );
    }
}

export default Udesk.react.udeskify(ReactPowerMultiSelect);