import React from 'react';
import DataSourceBaseClass from './data-source-base-class';
import ReactSelectComponent from "react-select";
import Udesk from '../../udesk/index';

class ReactSelect extends DataSourceBaseClass {
    actions = {
        _validate() {
            return true;
        },

        _onInputValueChanged(option) {
            if (typeof option === "object") {
                let {
                    mergedAttributes
                } = this.state;
                let {
                    dataSourceValueFeild,
                    DefaultValueField
                } = this.props;
                let valueField = DefaultValueField;
                if (mergedAttributes[dataSourceValueFeild] != null) {
                    valueField = mergedAttributes[dataSourceValueFeild];
                }
                this.actions._onChanged(option[valueField]);
            }
        }
    }

    static get emberName() {
        return '';
    }
    
    render() {
        let {
            privates: { computes },
        } = this;

        let {
            internalValue,
            mergedAttributes
        } = computes;
        let {
            disabled,
            dataSource,
            dataSourceValueFeild,
            dataSourceNameField,
            DefaultValueField,
            DefaultNameField,
        } = this.props;
        let valueField = DefaultValueField;
        if (mergedAttributes[dataSourceValueFeild] != null) {
            valueField = mergedAttributes[dataSourceValueFeild];
        }
        let nameField = DefaultNameField;
        if (mergedAttributes[dataSourceNameField] != null) {
            nameField = mergedAttributes[dataSourceNameField];
        }

        let getOptionLabel = (option) => {
            return option[nameField];
        };

        let getOptionValue = (option) => {
            return option[valueField];
        };
        if (!(dataSource instanceof Array)) {
            dataSource = [];
        }

        let targetOption = dataSource.find((option) => {
            if (typeof option !== "object") {
                return false;
            }
            return option[valueField] === internalValue;
        });
        if (targetOption == null) { 
            targetOption = "";
        }

        return (
            <ReactSelectComponent value={targetOption} containerClassNames={mergedAttributes.classNames} isSearchable={mergedAttributes.isSearchable} isClearable={mergedAttributes.isClearable} disabled={disabled} options={dataSource} placeholder={mergedAttributes.placeholder} getOptionLabel={getOptionLabel} getOptionValue={getOptionValue} onChange={this.actions._onInputValueChanged} />
        );
    }
}

export default Udesk.react.udeskify(ReactSelect);