import React from 'react';
import InputBaseClass from './input-base-class';
import JeTimePicker from "../je-time-picker";
import Udesk from '../../udesk/index';

class TimePicker extends InputBaseClass {
    actions = {
        _validate() {
            return true;
        },

        _onInputValueChanged(internalValue) {
            this.actions._onChanged(internalValue);
        }
    }

    static get emberName() {
        return 'udesk/custom-field-inputs/time-picker';
    }

    render() {
        let {
            privates: { computes },
        } = this;

        let {
            internalValue,
            mergedAttributes
        } = computes;
        let {
            disabled
        } = this.props;
        return (
            <JeTimePicker
                value={internalValue}
                disabled={disabled}
                format={mergedAttributes.format || Udesk.config.date.momentTimeFormat}
                serverFormat={mergedAttributes.serverFormat || Udesk.config.date.momentTimeFormat}
                classNames={mergedAttributes.classNames}
                minuteStep={1}
                onChanged={this.actions._onInputValueChanged}
            />
        );
    }
}

export default Udesk.react.udeskify(TimePicker);