import Udesk from '../../../../udesk';
import { inputTypes, fieldOperators } from './enums';

export default {
    convertInputType,
    convertOperators
};

function convertInputType(value) {
    return enumConverter(value, inputTypes);
}

function convertOperators(value) {
    return enumArrayConverter(value, fieldOperators);
}

function enumConverter(value, enumType) {
    if (value instanceof Udesk.enums.EnumItemClass) {
        return value;
    } else {
        let enumItem = enumType[value] || enumType.get(value);
        return enumItem;
    }
}

function enumArrayConverter(value, enumType) {
    if (value == null) {
        return value;
    }
    let newArray = [];
    for (let item of value) {
        newArray.push(enumConverter(item, enumType));
    }
    return newArray;
}
