import Udesk from '../../../../udesk';
import DemoLocales from "../../../../app/locales";

export let inputTypes = new Udesk.enums.EnumClass([
    { id: "text", key: "text" },
    { id: "textArea", key: "textArea" },
    { id: "dropDown", key: "dropDown" },
    { id: "datePicker", key: "datePicker" },
    { id: "time", key: "time" },
    { id: "dateTimePicker", key: "dateTimePicker" },
    { id: "dateRange", key: "dateRange" },
    { id: "integerNumber", key: "integerNumber" },
    { id: "floatNumber", key: "floatNumber" },
    { id: "powerSelectMultiple", key: "powerSelectMultiple" },
    { id: "powerSelect", key: "powerSelect" },
    { id: "autoComplete", key: "autoComplete" },
    { id: "checkBox", key: "checkBox" },
    { id: "cascadeDropDown", key: "cascadeDropDown" },
    { id: "simplePhone", key: "simplePhone" },
    { id: "currentUser", key: "currentUser" },
    { id: "currentOffice", key: "currentOffice" },
]);

export let fieldOperators = new Udesk.enums.EnumClass([
    /*jshint camelcase:false*/
    { id: "is", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.is"), key: "is" },
    { id: "not", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.not"), key: "not" },
    { id: "contains", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.contains"), key: "contains" },
    { id: "not_contains", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.notContains"), key: "not_contains" },
    { id: "contains_any", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.containsAny"), key: "contains_any" },
    { id: "not_contains_any", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.notContainsAny"), key: "not_contains_any" },
    { id: "contains_all", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.containsAll"), key: "contains_all" },
    { id: "not_contains_all", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.notContainsAll"), key: "not_contains_all" },
    { id: "is_null", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.isNull"), key: "is_null" },
    { id: "is_not_null", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.isNotNull"), key: "is_not_null" },
    { id: "greater_than", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.greaterThan"), key: "greater_than" },
    { id: "greater_than_eq", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.greaterThanEq"), key: "greater_than_eq" },
    { id: "less_than", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.lessThan"), key: "less_than" },
    { id: "less_than_eq", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.lessThanEq"), key: "less_than_eq" },
    { id: "between", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.between"), key: "between" },
    { id: "not_between", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.notBetween"), key: "not_between" },
    { id: "relative", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.relative"), key: "relative" },
    { id: "set", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.set"), key: "set" },
    { id: "belongs", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.belongs"), key: "belongs" },
    { id: "not_belongs", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.notBelongs"), key: "not_belongs" },
    { id: "today", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.today"), key: "today" },
    { id: "yesterday", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.yesterday"), key: "yesterday" },
    { id: "tomorrow", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.tomorrow"), key: "tomorrow" },
    { id: "next_seven_day", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.next_seven_day"), key: "next_seven_day" },
    { id: "last_seven_day", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.last_seven_day"), key: "last_seven_day" },
    { id: "this_week", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.this_week"), key: "this_week" },
    { id: "next_week", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.next_week"), key: "next_week" },
    { id: "last_week", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.last_week"), key: "last_week" },
    { id: "this_month", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.this_month"), key: "this_month" },
    { id: "next_month", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.next_month"), key: "next_month" },
    { id: "last_month", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.last_month"), key: "last_month" },
    { id: "this_year", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.this_year"), key: "this_year" },
    { id: "next_year", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.next_year"), key: "next_year" },
    { id: "last_year", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.last_year"), key: "last_year" },
    { id: "exact_match", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.exact_match"), key: "exact_match" },
    { id: "add_value", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.add_value"), key: "add_value" },
    { id: "remove_value", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.remove_value"), key: "remove_value" },
    { id: "set_null", name: () => DemoLocales.get("demo.customFilters.config.enums.fieldOperators.set_null"), key: "set_null" },
]);