import React from 'react';
// import PropTypes from 'prop-types';
import CustomFiltersDemoComponent from "./component";
import DemoLocalesLocales from '../../../app/locales';
import CustomFilters from '..';

export default class CustomFiltersDemoTemplate extends CustomFiltersDemoComponent {
    render() {
        let {
            actions
        }
            = this;
        return (
            <div className="custom-filters-demo">
                <div className="page-header">
                    <h3>{DemoLocalesLocales.current.demo.customFilters.basicSample}</h3>
                </div>
                <div className="sample-content">
                    <CustomFilters
                        conditions={this.privates.conditions}
                        fields={this.privates.fields}
                        fieldValueSettings={this.privates.componentSettings}
                        onChanged={actions.conditionsChanged} />
                    {/* onChanged={this.privates.conditionsMutator} /> */}
                </div>
                <div className="conditions-result">
                    <ul className="conditions-list">
                        <For each="condition" index="index" of={this.privates.conditions}>
                            <With field={this.privates.fields.find(f => f.name === condition.field)}>
                                <With operator={field.operators.find(o => o.id === condition.operator)}>
                                    <li key={[field.name, operator.id, index].join("-")} className="condition-content">
                                        <span className="condition-field">{field.text}</span>
                                        <span className="condition-operator">{operator.name}</span>
                                        <span className="condition-value">{JSON.stringify(condition.value).replace(/^"?([^"]*)"?$/, "$1")}</span>
                                    </li>
                                </With>
                            </With>
                        </For>
                    </ul>
                </div>
            </div>
        );
    }
}