function findWidgets(widgets, matcher) {
    var matchedWidget = [];
    traverseWidgets(widgets, (widget) => {
        if (matcher(widget)) {
            matchedWidget.push(widget);
        }
    });
    return matchedWidget;
}

function traverseWidgets(root, callback) {
    for (var widget of root) {
        let result = callback(widget);
        if (result != null && result === false) {
            break;
        }
        if (widget.instance.widgets && (widget.instance.widgets instanceof Array && widget.instance.widgets.length > 0)) {
            traverseWidgets(widget.instance.widgets, callback);
        }
    }
}

export {
    findWidgets,
    traverseWidgets
};