import React from 'react';

export default class WidgetDragClass extends React.Component {

    init() {
        this._widgetDragStart = widgetDragStart.bind(this);
        this._widgetDrapEnd = widgetDrapEnd.bind(this);
    }
    componentDidMount() {
        let targetElement = this.getDragHandler();
        if (targetElement != null) {
            targetElement.addEventListener("dragstart", this._widgetDragStart, false);
            targetElement.addEventListener("drapend", this._widgetDrapEnd, false);
        }
    }
    componentWillUnmount() {
        let targetElement = this.getDragHandler();
        if (targetElement != null) {
            targetElement.removeEventListener("dragstart", this._widgetDragStart);
            targetElement.removeEventListener("drapend", this._widgetDrapEnd);
        }
    }
    getDragHandler() {
        throw new Error(`Please return a compoenet parent element.`);
    }

    getDragWidgetType(element) {
        if (element) {
            return element.attributes["data-widget-type"].value;
        }
        return null;
    }
    getDataTransferName() {
        return "widgetDescriptor";
    }
    getDropDataTransferWidgetTypeField() {
        return "widgetType";
    }
    getDraggable() {
        return true;
    }
}

function widgetDragStart(e) {
    e.stopPropagation();
    let widgetType = this.getDragWidgetType(e.target);
    if (this.getDraggable(widgetType)) {
        if (widgetType != null && widgetType !== "") {
            let dropDataTransferWidgetTypeField = this.getDropDataTransferWidgetTypeField();
            if (dropDataTransferWidgetTypeField != null && dropDataTransferWidgetTypeField !== "") {
                let data = {
                    [dropDataTransferWidgetTypeField]: widgetType,
                };
                let dataTransferName = this.getDataTransferName();
                if (dataTransferName !== null && dataTransferName !== "") {
                    e.dataTransfer.clearData(dataTransferName);
                    e.dataTransfer.setData(dataTransferName, JSON.stringify(data));
                }
            }
        }
    }
    return true;
}
function widgetDrapEnd() {
    return false;
}