import WidgetBaseClass from "./widget-base";
import Udesk from '../../../udesk/index';

export default class WidgetDropClass extends WidgetBaseClass { 
    init() { 
        this._widgetDrapOver = widgetDrapOver.bind(this);
        this._widgetDrop = widgetDrop.bind(this);
        this._widgetDrapEnter = widgetDrapEnter.bind(this);
    }
    componentDidMount() {
        let mode = this.props.mode;
        if (mode === Udesk.enums.udeskReactCustomUiGridModeEnums.design.id) {
            let targetElement = this.getDragHandler();
            if (targetElement != null) {
                targetElement.addEventListener("dragover", this._widgetDrapOver, false);
                targetElement.addEventListener("drop", this._widgetDrop, false);
                targetElement.addEventListener("dropenter", this._widgetDrapEnter, false);
            }
        }
    }
    componentWillUnmount() {
        let mode = this.props.mode;
        if (mode === Udesk.enums.udeskReactCustomUiGridModeEnums.design.id) {
            let targetElement = this.getDragHandler();
            if (targetElement != null) {
                targetElement.removeEventListener("dragover", this._widgetDrapOver);
                targetElement.removeEventListener("drop", this._widgetDrop);
                targetElement.removeEventListener("dropenter", this._widgetDrapEnter);
            }
        }
    }
    getDragHandler() {
        throw new Error(`Please return a compoenet parent element.`);
    }
    isAllowableDrop() { 
        return true;
    }
}

function widgetDrapOver(e) {
    e.preventDefault();
    return false;
}
function widgetDrop(e) {
    if (e.stopPropagation) {
        e.stopPropagation();
    }
    let {
        dropDataTransferDataField,
        dropDataTransferWidgetTypeField,
        widget,
        addWidget
    } = this.props;
    let str = e.dataTransfer.getData(dropDataTransferDataField);
    let dataTransferData = null;
    if (typeof str === 'string') {
        try {
            dataTransferData = JSON.parse(str);
        } catch (e) {
            return;
        }
    }
    let dropWidgetType = dataTransferData[dropDataTransferWidgetTypeField];
    if (dropWidgetType != null && dropWidgetType !== "") {
        let isAllowableDrop = this.isAllowableDrop(dropWidgetType);
        if (isAllowableDrop) {
            if (addWidget != null) {
                addWidget({
                    id: widget.instance.id,
                    descriptors: [{
                        type: dropWidgetType
                    }]
                });
            }
        }
    }
}
function widgetDrapEnter(e) {
    
}