import React from 'react';
import Udesk from '../../../udesk/index';
import WidgetDragClass from "./widget-drag-class";
import PropTypes from 'prop-types';

class WidgetTypeDragWrapper extends WidgetDragClass {
    static propTypes = {
        mode: PropTypes.string,
        widgetType: PropTypes.string,
        getDraggable: PropTypes.func,
        getDraggableContext: PropTypes.object,
    }
    static defaultProps = {
        mode: "design",
        widgetType: null,
        getDraggable: null,
        getDraggableContext: null,
    }

    privates = {
        element: null
    }

    getDragHandler() {
        return this.privates.element;
    }
    getDraggable(widgetType) {
        if (typeof this.props.getDraggable === "function") {
            return this.props.getDraggable.call(this.props.getDraggableContext, widgetType);
        } else {
            return true;
        }
    }

    actions = {
        _receiveWrapperDom(dom) {
            this.privates.element = dom;
        }
    }

    render() {
        let {
            widgetType,
        } = this.props;
        return (
            <div className="custom-ui-grid-widget-item" draggable="true" data-widget-type={`${widgetType}`} ref={this.actions._receiveWrapperDom}>
                {this.props.children}
            </div>
        );
    }
}

export default Udesk.react.udeskify(WidgetTypeDragWrapper);