import React from 'react';
import PropTypes from 'prop-types';

class DrawerModalComponent extends React.Component {
    //#region
    static defaultProps = {
        classNames: "",
        isVisible: false,
        containerWidth: "30%",
        backdropClose: true,//点击空白处是否关闭
        onClosed: null
    }
    static propTypes = {
        classNames: PropTypes.string,
        isVisible: PropTypes.bool,
        onClosed: PropTypes.func
    }
    //#endregion
    privates = {
        isVisible: false,
        drawerModalInstance: null,
        modalKey: `drawer-modal-${new Date().getTime()}`
    }
    componentDidMount() {
        let {
            modalKey
        } = this.privates;
        let that = this;
        $(document).off(`click.${modalKey}`).on(`click.${modalKey}`, (e) => {
            let drawerModalInstance = this.privates.drawerModalInstance;
            if (drawerModalInstance) {
                if (!that.isDestroyed && that.props.isVisible) {
                    let {
                        backdropClose
                    } = that.props;
                    let children = $(drawerModalInstance).find(e.target);
                    if (children && children.length > 0) {
                        return;
                    } else if (!backdropClose && drawerModalInstance === e.target) {
                        return;
                    } else {
                        that.actions.closeDrawerModal(e);
                    }
                }
            }
        });
    }
    componentWillUnmount() {
        let {
            modalKey
        } = this.privates;
        $(document).off(`click.${modalKey}`);
        this.privates.drawerModalInstance = null;
    }
    actions = {
        closeDrawerModal(e) {
            if (e && e.stopPropagation) {
                e.stopPropagation();
            }
            this.trigger("onClosed", e);
        }
    }
}

export default DrawerModalComponent;
