import React from 'react';
import ClassNames from 'classnames';
import DrawerModalComponent from './component';

class DrawerModalTemplate extends DrawerModalComponent {
    render() {
        let {
            isVisible,
            classNames,
            containerWidth
        } = this.props;

        let containerStyle = {
            width: getContainerWith(containerWidth)
        };

        return (
            <div className={ClassNames("drawer-modal", { [`${classNames}`]: classNames })} >
                <If condition={isVisible}>
                    <div className={ClassNames("drawer-modal-wrap", { "show": isVisible })} ref={(instance) => this.privates.drawerModalInstance = instance}>
                        <div className={ClassNames("drawer-modal-container")} style={containerStyle}>
                            {this.props.children}
                        </div>
                    </div>
                </If >
            </div>
        );
    }
}

function getContainerWith(width) {
    if (width) {
        if (width.indexOf("%") > -1) {
            return width;
        } else if (width.indexOf("px") > -1) {
            return width;
        } else {
            let widthNumber = Number(width);
            if (isNaN(widthNumber)) {
                return "30%";
            } else {
                return widthNumber + "px";
            }
        }
    } else if (width === 0) {
        return 0;
    } else {
        return "30%";
    }
}



export default DrawerModalTemplate;
