import React, { useMemo } from "react";
import { Dropdown } from "udesk-ui";
import { Menu } from "./menu";

const Trigger: React.FC<any> = React.forwardRef((props, ref) => {
    return (
        <div ref={ref} {...props}>
            {props.children}
        </div>
    );
});

const DropDownClass: React.FC<any> = (props) => {
    let {
        children,
        trigger = ["click"],
        text = "",
        ...others
    } = props;

    const showChild = (children: any, child: any) => React.Children.toArray(children).filter((c: any) => c.type === child)[0];

    let menu = useMemo(() => showChild(children, Menu), [children]);

    let triggerElement = useMemo(() => {
        let child = showChild(children, Trigger);
        if (child) {
            return child;
        } else {
            return (<span>{text}</span>)
        }
    }, [children, text]);

    return (
        <Dropdown overlay={menu} trigger={trigger} {...others}>
            {triggerElement}
        </Dropdown>
    );
}

export default DropDownClass;
export {
    Menu,
    Trigger
};
