import React from "react";
import ClassNames from 'classnames';
import ImageCropperComponent from "./component";

export default class ImageCropperTemplate extends ImageCropperComponent {
    render() {
        let {
            actions,
            locales,
            props,
            privates
        } = this;
        return (
            <div className="udesk-image-cropper">
                <div
                    className={ClassNames("image-cropper-container", { "image-cropper-container-display-none": !props.showCropper })}
                    ref={this.ownContainer}
                >
                    <div className="container">
                        <div className="row-container">
                            <div className="image-cropper-box">
                                <img ref={this.imageCropper} src={props.imageContent} alt={locales.components.imageCropper.imageAlt} className="image-cropper" />
                            </div>
                            <If condition={props.showPreviewContainer}>
                                <div className="perview-container-box">
                                    <div className="perview-container">
                                        <div className={`${props.previewClass} ${props.previewClass}-${privates.previewClassKey}`}></div>
                                    </div>
                                    <div>{locales.components.imageCropper.previewText}</div>
                                </div>
                            </If>
                            <If condition={props.showResultContainer}>
                                <div className="result-container-box">
                                    <div className="result-container">
                                        <div className={`${props.resultClass}`}></div>
                                    </div>
                                    <div>{locales.components.imageCropper.resultText}</div>
                                </div>
                            </If>
                        </div>
                        <button type="button" className="btn btn-primary" onClick={actions.crop}>
                            {locales.components.imageCropper.actionText}
                        </button>
                    </div>
                </div>
            </div>
        );
    }
}
