import React from "react";
import ImageUploadComponent from "./component";
import ClassNames from 'classnames';
import ReactModal from "../react-modal";
import ImageCropper from "../image-cropper";

export default class ImageUploadTemplate extends ImageUploadComponent {
    render() {
        let { actions, props, state, privates } = this;
        return (
            <div className="udesk-react-component-image-upload">
                <div className="image-upload-div" ref={this.privates.ownContainer}>
                    <div className="pull-left">
                        <a href="javascript:void(0);"
                            className={ClassNames("action-btn image-upload-p-a", { disabled: props.disabled })} >
                            {privates.computes._buttonText}
                            <input
                                type="file"
                                name="imageFile"
                                className={ClassNames("action-btn image-upload-p-a-input", { disabled: props.disabled })}
                                disabled={props.disabled}
                                accept={props.acceptFileTypes}
                            />
                        </a>
                        <div className="upload-tip">{privates.computes._uploadTips}</div>
                    </div>
                </div>
                <div className={ClassNames({ "image-upload-cropper-display-none": !state.showCropper })} >
                    <Choose>
                        <When condition={props.alertCopperModal}>
                            <ReactModal visible={state.imageContent} footer={null}>
                                <ImageCropper
                                    filename={state.filename}
                                    imageContent={state.imageContent}
                                    onChanged={actions.getCroppedCanvas}
                                    aspectRatio={privates.computes._cropperOptions.aspectRatio}
                                    crop={privates.computes._cropperOptions.crop}
                                    viewMode={privates.computes._cropperOptions.viewMode}
                                    dragMode={privates.computes._cropperOptions.dragMode}
                                    responsive={privates.computes._cropperOptions.responsive}
                                    center={privates.computes._cropperOptions.center}
                                    checkCrossOrigin={
                                        privates.computes._cropperOptions.checkCrossOrigin
                                    }
                                    toggleDragModeOnDblclick={
                                        privates.computes._cropperOptions.toggleDragModeOnDblclick
                                    }
                                    background={privates.computes._cropperOptions.background}
                                    modal={privates.computes._cropperOptions.modal}
                                    guides={privates.computes._cropperOptions.guides}
                                    highlight={privates.computes._cropperOptions.highlight}
                                    autoCrop={privates.computes._cropperOptions.autoCrop}
                                    autoCropArea={privates.computes._cropperOptions.autoCropArea}
                                    dragDrop={privates.computes._cropperOptions.dragDrop}
                                    movable={privates.computes._cropperOptions.movable}
                                    resizable={privates.computes._cropperOptions.resizable}
                                    zoomable={privates.computes._cropperOptions.zoomable}
                                    zoomOnWheel={privates.computes._cropperOptions.zoomOnWheel}
                                    zoomOnTouch={privates.computes._cropperOptions.zoomOnTouch}
                                    cropBoxMovable={
                                        privates.computes._cropperOptions.cropBoxMovable
                                    }
                                    cropBoxResizable={
                                        privates.computes._cropperOptions.cropBoxResizable
                                    }
                                    rotateable={privates.computes._cropperOptions.rotateable}
                                    minContainerWidth={
                                        privates.computes._cropperOptions.minContainerWidth
                                    }
                                    minContainerHeight={
                                        privates.computes._cropperOptions.minContainerHeight
                                    }
                                    minCanvasWidth={
                                        privates.computes._cropperOptions.minCanvasWidth
                                    }
                                    minCanvasHeight={
                                        privates.computes._cropperOptions.minCanvasHeight
                                    }
                                    minCropBoxWidth={
                                        privates.computes._cropperOptions.minCropBoxWidth
                                    }
                                    minCropBoxHeight={
                                        privates.computes._cropperOptions.minCropBoxHeight
                                    }
                                    build={privates.computes._cropperOptions.build}
                                    built={privates.computes._cropperOptions.built}
                                    dragStart={privates.computes._cropperOptions.dragStart}
                                    dragMove={privates.computes._cropperOptions.dragMove}
                                    dragEnd={privates.computes._cropperOptions.dragEnd}
                                    zoomin={privates.computes._cropperOptions.zoomin}
                                    zoomout={privates.computes._cropperOptions.zoomout}
                                    initAutoCrop={props.initAutoCrop}
                                    showCropper={props.showCropper}
                                    showPreviewContainer={props.showPreviewContainer}
                                    showResultContainer={props.showResultContainer}
                                />
                            </ReactModal>
                        </When>
                        <Otherwise>
                            <ImageCropper
                                filename={state.filename}
                                imageContent={state.imageContent}
                                onChanged={actions.getCroppedCanvas}
                                aspectRatio={privates.computes._cropperOptions.aspectRatio}
                                crop={privates.computes._cropperOptions.crop}
                                viewMode={privates.computes._cropperOptions.viewMode}
                                dragMode={privates.computes._cropperOptions.dragMode}
                                responsive={privates.computes._cropperOptions.responsive}
                                center={privates.computes._cropperOptions.center}
                                checkCrossOrigin={
                                    privates.computes._cropperOptions.checkCrossOrigin
                                }
                                toggleDragModeOnDblclick={
                                    privates.computes._cropperOptions.toggleDragModeOnDblclick
                                }
                                background={privates.computes._cropperOptions.background}
                                modal={privates.computes._cropperOptions.modal}
                                guides={privates.computes._cropperOptions.guides}
                                highlight={privates.computes._cropperOptions.highlight}
                                autoCrop={privates.computes._cropperOptions.autoCrop}
                                autoCropArea={privates.computes._cropperOptions.autoCropArea}
                                dragDrop={privates.computes._cropperOptions.dragDrop}
                                movable={privates.computes._cropperOptions.movable}
                                resizable={privates.computes._cropperOptions.resizable}
                                zoomable={privates.computes._cropperOptions.zoomable}
                                zoomOnWheel={privates.computes._cropperOptions.zoomOnWheel}
                                zoomOnTouch={privates.computes._cropperOptions.zoomOnTouch}
                                cropBoxMovable={
                                    privates.computes._cropperOptions.cropBoxMovable
                                }
                                cropBoxResizable={
                                    privates.computes._cropperOptions.cropBoxResizable
                                }
                                rotateable={privates.computes._cropperOptions.rotateable}
                                minContainerWidth={
                                    privates.computes._cropperOptions.minContainerWidth
                                }
                                minContainerHeight={
                                    privates.computes._cropperOptions.minContainerHeight
                                }
                                minCanvasWidth={
                                    privates.computes._cropperOptions.minCanvasWidth
                                }
                                minCanvasHeight={
                                    privates.computes._cropperOptions.minCanvasHeight
                                }
                                minCropBoxWidth={
                                    privates.computes._cropperOptions.minCropBoxWidth
                                }
                                minCropBoxHeight={
                                    privates.computes._cropperOptions.minCropBoxHeight
                                }
                                build={privates.computes._cropperOptions.build}
                                built={privates.computes._cropperOptions.built}
                                dragStart={privates.computes._cropperOptions.dragStart}
                                dragMove={privates.computes._cropperOptions.dragMove}
                                dragEnd={privates.computes._cropperOptions.dragEnd}
                                zoomin={privates.computes._cropperOptions.zoomin}
                                zoomout={privates.computes._cropperOptions.zoomout}
                                initAutoCrop={props.initAutoCrop}
                                showCropper={props.showCropper}
                            />
                        </Otherwise>
                    </Choose>
                </div>
            </div >
        );
    }
}
