import React from 'react';
import PropTypes from 'prop-types';

const DEFAULT_NAME_FIELD = "name";
const DEFAULT_VALUE_FIELD = "id";
const DEFAULT_DISABLED_FIELD = "disabled";

class ReactAntdCheckboxGroup extends React.Component {
    //#region defaultProps
    static defaultProps = {
        nameField: DEFAULT_NAME_FIELD,
        valueField: DEFAULT_VALUE_FIELD,
        disabledField: DEFAULT_DISABLED_FIELD,
        disabled: false,
        //此处不加默认值是为了组件受控与非受控控制，如果有合适方案更改这里
        // value: null,
        // defaultValue: [],
        options: [],
        name: null,
        onChange: null,
    }
    static propTypes = {
        nameField: PropTypes.string,
        valueField: PropTypes.string,
        disabledField: PropTypes.string,
        disabled: PropTypes.bool,
        value: PropTypes.array,
        defaultValue: PropTypes.array,
        options: PropTypes.array,
        name: PropTypes.string,
        onChange: PropTypes.func,
    }
    //#endregion

    privates = {
        options: []
    }

    parseProps({ props, prevProps, privates }) {
        let {
            nameField = DEFAULT_NAME_FIELD,
            valueField = DEFAULT_VALUE_FIELD,
            disabledField = DEFAULT_DISABLED_FIELD,
            options = [],
            value,
            defaultValue
        } = props;
        options = options.map(option => {
            return {
                disabled: option[disabledField],
                label: option[nameField],
                value: option[valueField],
            };
        });
        return {
            options: options,
            value,
            defaultValue
        };
    }

    actions = {
        onChange(...argus) {
            let {
                valueField
            } = this.props;
            let {
                options = []
            } = this.privates;
            let checkedOptions = options.filter(option => {
                if (argus) {
                    return argus.includes(option[valueField]);
                } else {
                    return false;
                }
            });
            this.trigger("onChange", ...argus, checkedOptions);
        }
    }
}

export default ReactAntdCheckboxGroup;