import React from 'react';
import PropTypes from 'prop-types';
import ClassNames from 'classnames';
import ReactAntdTable from 'udesk-react/src/components/react-antd-table';
import Udesk from '@Udesk';
import { Divider } from 'antd';

export default class NewTable extends React.Component {
    // #region defaultProps
    static defaultProps = {};
    // #endregion
    // #endregion

    // #region defaultProps
    privates = {};
    // #endregion

    // #region computes
    static computes = {
        props1: () => {},

        props2: ['props.props3', () => {}]
    };
    // #endregion

    // #region public function

    // #endregion

    // #region life cycle
    constructor(props) {
        super(props);
        this.state = { loading: true };
    }
    componentDidMount() {
        setTimeout(() => this.setState({ loading: false }), 1000);
    }
    componentWillUnmount() {}
    // #endregion

    // #region life cycle
    actions = {
        add() {
            let { history } = this.props;
            Udesk.ui.routing.transitionTo({
                history,
                routeName: 'configuration/user-setting/new'
            });
        },
        edit(item) {
            let { history } = this.props;
            Udesk.ui.routing.transitionTo({
                history,
                routeName: 'configuration/user-setting/edit',
                pathParams: {
                    id: item.id
                }
            });
        },
        view(item) {
            let { history } = this.props;
            Udesk.ui.routing.transitionTo({
                history,
                routeName: 'configuration/user-setting/detail',
                pathParams: {
                    id: item.id
                }
            });
        },
        forbidden() {
            Udesk.ui.alerts.warning({
                content: this.locales.labels.forbiddenContent,
                onOk: () => {}
            });
        },
        delete() {
            Udesk.ui.alerts.warning({
                content: this.locales.labels.deleteContent,
                onOk: () => {}
            });
        },
        onSearch() {}
    };

    render() {
        //#region 解构
        let { actions } = this;
        const columns = [
            {
                title: 'id',
                dataIndex: 'id',
                width: 50
            },
            {
                title: '客户名称',
                dataIndex: 'name',
                width: 150
            },
            {
                title: 'Age',
                dataIndex: 'age',
                width: 150
            },
            {
                title: 'Address',
                dataIndex: 'address',
                width: 150
            },
            {
                title: '岗位',
                dataIndex: 'post',
                searchMode: 'text',
                width: 150
            },
            {
                title: '角色',
                dataIndex: 'role',
                searchMode: 'enum',
                width: 150,
                filters: [{ text: '客户成功', value: 'London' }, { text: '其他', value: 'New York' }]
            },
            {
                dataIndex: 'action',
                title: '操作',
                key: 'action',
                width: 150,
                render: (text, record) => (
                    <span>
                        <a onClick={this.actions.view.params(record).preventDefault()}>{this.locales.labels.view} </a>
                        <Divider type="vertical" />
                        <a onClick={this.actions.edit.params(record).preventDefault()}>{this.locales.labels.edit} </a>
                        <Divider type="vertical" />
                        <a onClick={this.actions.delete.params(record).preventDefault()}>
                            {this.locales.labels.delete}
                        </a>{' '}
                        <Divider type="vertical" />
                        <a onClick={this.actions.forbidden.params(record).preventDefault()}>
                            {this.locales.labels.forbidden}
                        </a>
                    </span>
                )
            }
        ];

        const data = [];
        for (let i = 0; i < 46; i++) {
            data.push({
                id: i,
                name: `test name ${i}`,
                age: 32,
                post: '分公司行政',
                role: '客户成功',
                address: `London, Park Lane no. ${i}`
            });
        }
        //#endregion
        return (
            <div className="page page-layout page-user-setting-list">
                <div className="page-record">
                    <div className="page-header clearfix"></div>
                    <ReactAntdTable
                        loading={this.state.loading}
                        columns={columns}
                        dataSource={data}
                        pagination={{
                            showSizeChanger: true
                        }}
                        size="middle"
                        onChanged={this.actions.onSearch}
                        onPageChanged={this.actions.onSearch}
                        onShowSizeChanged={this.actions.onSearch}
                        showColumnSetting
                        bordered
                        resizable
                        columnDragable
                        showCheckboxColumn
                        showTitle
                        title={'测试'}
                    />
                </div>
            </div>
        );
    }
}
