const defaultColumn = {
    title: '',
    key: '',
    dataIndex: '',
    align: 'center',
    visible: true
};

const generateFullColumns = (updateColumns, localColumns) => {
    if (!Array.isArray(localColumns) || localColumns.length <= 0) {
        if (Array.isArray(updateColumns) && updateColumns.length > 0) {
            return updateColumns.map(item => Object.assign({}, defaultColumn, { ...item }));
        } else {
            return [];
        }
    }
    return updateColumns.map(item => {
        const filterLocalItem = localColumns.find(i => i.dataIndex === item.dataIndex) || {};
        return Object.assign({}, defaultColumn, filterLocalItem, { ...item });
    });
};

const generateFilterColumnsByFull = fullColumns => fullColumns.filter(item => item.visible);

export const getColumnKey = column => column.key || column.dataIndex;

export const generateColumns = (updateColumns, preLocalColumns) => {
    const localColumns = generateFullColumns(updateColumns, preLocalColumns);
    const filterColumns = generateFilterColumnsByFull(localColumns);

    return {
        filterColumns,
        localColumns
    };
};
