import Udesk from '../../../../udesk';
import DemoLocales from "../../../../app/locales";

export let businessTypes = new Udesk.enums.EnumClass([
    { "id": 1, "name": DemoLocales.get("demo.reactTable.enums.businessTypesleads."), "key": "leads" },
    { "id": 2, "name": DemoLocales.get("demo.reactTable.enums.businessTypescustomer."), "key": "customer" },
    { "id": 3, "name": DemoLocales.get("demo.reactTable.enums.businessTypesniche."), "key": "niche" },
    { "id": 4, "name": DemoLocales.get("demo.reactTable.enums.businessTypescontacts."), "key": "contacts" },
    { "id": 6, "name": DemoLocales.get("demo.reactTable.enums.businessTypesproduct."), "key": "product" },
    { "id": 5, "name": DemoLocales.get("demo.reactTable.enums.businessTypestask."), "key": "task" }
]);

export let classifications = new Udesk.enums.EnumClass([
    { "name": DemoLocales.get("demo.reactTable.enums.classifications.B"), "id": 2, "key": "B" },
    { "name": DemoLocales.get("demo.reactTable.enums.classifications.C"), "id": 3, "key": "C" }
]);

export let customerBusinessCategories = new Udesk.enums.EnumClass([
    { "id": 6, "name": DemoLocales.get("demo.reactTable.enums.customerBusinessCategories.Default"), key: "Default" },
    { "id": 26, "name": DemoLocales.get("demo.reactTable.enums.customerBusinessCategories.Shanghai"), key: "Shanghai" }
]);
export let highSeaStatus = new Udesk.enums.EnumClass([
    { "id": 1, "name": DemoLocales.get("demo.reactTable.enums.highSeaStatus.not_receive"), "key": "not_receive" },
    { "id": 2, "name": DemoLocales.get("demo.reactTable.enums.highSeaStatus.already_receive"), "key": "already_receive" },
    { "id": 3, "name": DemoLocales.get("demo.reactTable.enums.highSeaStatus.already_transformed"), "key": "already_transformed" },
    { "id": 4, "name": DemoLocales.get("demo.reactTable.enums.highSeaStatus.create_by_oneself"), "key": "create_by_oneself" },
    { "id": 5, "name": DemoLocales.get("demo.reactTable.enums.highSeaStatus.signed"), "key": "signed" },
    { "id": 6, "name": DemoLocales.get("demo.reactTable.enums.highSeaStatus.freezed"), "key": "freezed" },
    { "id": 7, "name": DemoLocales.get("demo.reactTable.enums.highSeaStatus.canceled"), "key": "canceled" }
]);
export let lockStatus = new Udesk.enums.EnumClass([
    { "id": 0, "key": "unlocked", "name": DemoLocales.get("demo.reactTable.enums.lockStatus.unlocked") },
    { "id": 1, "key": "locked", "name": DemoLocales.get("demo.reactTable.enums.lockStatus.locked") }
]);
// export let  = new Udesk.enums.EnumClass();

export default {
    businessTypes,
    classifications,
    customerBusinessCategories,
    highSeaStatus
};