import React from 'react';
import Udesk from '../../udesk/index';
import ReactTinymce from './index';

class ReactTinymceDemo extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            value: null,
        };
    }

    actions = {
        onEditorChange(value) {
            this.setState({
                value
            });
        },
    }

    render() {
        let {
            value,
        } = this.state;
        return (
            <div>
                <ReactTinymce
                    value={value}
                    tinymcePath={`/static/vendor/tinymce/tinymce.min.js`}
                    onEditorChange={this.actions.onEditorChange}
                    minHeihgt={142}
                    plugins={`advlist autolink lists charmap print preview anchor searchreplace visualblocks code fullscreen insertdatetime  contextmenu paste wordcount colorpicker textcolor image imagetools visualchars template codesample hr textpattern`}
                />
            </div>
        );
    }
}

ReactTinymceDemo.propTypes = {
};

ReactTinymceDemo.defaultProps = {
};

export default Udesk.react.udeskify(ReactTinymceDemo);