import React from 'react';
import ReactTransversalSelectComponent from "../component";
import ClassNames from 'classnames';
import { get } from "udesk-web-toolkits/src/udesk/utils/object";

export default class ReactTransversalSelectTemplacte extends ReactTransversalSelectComponent {

    render() {
        let {
            classNames,
            leftSelectHeaderText,
            rightSelectHeaderText,
            toLeftIconClass,
            toRightIconClass,
            sortUpIconClass,
            sortDownIconClass,
            nameField,
            sortable,
            extraCheckbox,
            extraCheckboxTitle,
            extraCheckboxField
        } = this.props;
        let {
            computes,
            leftActiveItem,
            rightActiveItem
        } = this.privates;
        return (
            <div className={ClassNames("react-transversal-select", { [`${classNames}`]: classNames })}>
                <div className="select-container left-container">
                    <div className="select-container-header left-continer-header">
                        <If condition={leftSelectHeaderText != null && leftSelectHeaderText !== ""}>
                            <p className="select-container-title">{leftSelectHeaderText}</p>
                        </If>
                    </div>
                    <div className="select-container-content left-continer-content">
                        <div className="data-source-list">
                            <For of={computes.leftDataSource} each="item" index="index">
                                <div key={`left-data-source-item-${index}`} className={ClassNames("data-source-item", { [`active`]: item === leftActiveItem })} onClick={this.actions.leftItemClick.params(item)}>
                                    {get(item, nameField)}
                                </div>
                            </For>
                        </div>
                    </div>
                </div>
                <div className="action-container">
                    <ul className="action-list">
                        <li className="action-item">
                            <a href="javascript:void(0);" className="toogle-action toogle-action-to-left" onClick={this.actions.toLeft}>
                                <i className={toLeftIconClass}></i>
                            </a>
                        </li>
                        <li className="action-item">
                            <a href="javascript:void(0);" className="toogle-action toogle-action-to-right" onClick={this.actions.toRight}>
                                <i className={toRightIconClass}>{ }</i>
                            </a>
                        </li>
                    </ul>
                </div>
                <div className="select-container right-container">
                    <div className="select-container-header right-continer-header">
                        <If condition={rightSelectHeaderText != null && rightSelectHeaderText !== ""}>
                            <p className="select-container-title">{rightSelectHeaderText}</p>
                        </If>
                        <If condition={extraCheckbox}>
                            <p className="extra-checkbox">{extraCheckboxTitle}</p>
                        </If>
                    </div>
                    <div className={ClassNames("select-container-content right-continer-content", { [`select-container-sortable`]: sortable })}>
                        <div className="content-header-sort">
                            <button type="button" className="btn white sort-btn" onClick={this.actions.sortUp}>
                                <i className={sortUpIconClass}></i>
                            </button>
                            <button type="button" className="btn white sort-btn" onClick={this.actions.sortDown}>
                                <i className={sortDownIconClass}></i>
                            </button>
                        </div>
                        <div className="data-source-list">
                            <For of={computes.rightDataSource} each="item" index="index">
                                <div key={`right-data-source-item-${index}`}
                                    className={ClassNames("data-source-item", { [`active`]: item === rightActiveItem })}
                                    onClick={this.actions.rightItemClick.params(item)}>
                                    <div className="result-item-name">{get(item, nameField)}</div>
                                    <If condition={extraCheckbox}>
                                        <div className="result-item-extra-checkbox">
                                            <input type="checkbox" checked={item[extraCheckboxField]} onClick={this.actions.extraCheckboxChanged.params(item, index)} />
                                        </div>
                                    </If>
                                </div>
                            </For>
                        </div>
                    </div>
                </div>
            </div>
        );
    }
}