import React from 'react';
import Component from "./base";
import ReactTreeIteration from './index';

export default class ReactTree extends Component {
    render() {
        let {
            props,
            privates,
            actions
        } = this;
        let {
            isChildTree,
            computes,
            treeStates,
            draggable,
            sortText,
            fullNodes
        } = privates;
        let {
            _className: className
        } = computes;
        let {
            treeActionsComponent: TreeActionsComponent,
            nodeComponent: NodeComponent,
            name,
            theme,
            enableTreeActions,
            enableSorting,
            treeActionsAttrs,
            treeAddIconClass,
            addIconClass,
            sortIconClass,
            confirmSortText,
            confirmSortIconClass,
            node,
            nodeNameField,
            isShowNodeNum,
            nodeNumField,
            nodeKeyField,
            checkable,
            clickable,
            showNodeDescriptorIcon,
            enableNodeActions,
            nodeTextComponent,
            nodeActionsComponent,
            expandedIconClass,
            collapsedIconClass,
            editIconClass,
            deleteIconClass,
            dragIconClass,
            isNodeMovable,
            enableSort,
            enableMove,
            componentClassName,
            onSorted,
            onSort,
            onSortingSaved,
            getNodeDescriptorIcon,
            getDropPositionClass,
            nodeCheckBoxComponent,
            selectionMode,
            selectedNodes,
            autoCheckUpStrategy,
            autoUncheckUpStrategy,
            getNodeBehaviors,
            childNodesField,
            isTreeModeData,
            nodeParentKeyField,
            recursivelyCollapse,
            onCollapsed,
            onNodeClicked,
            onActiveNodeChanged,
            onAdding,
            onAdded,
            onEditing,
            onEdited,
            onDeleting,
            onDeleted,
            onTreeAction,
            onNodeAction,
            onChecked,
            onUnchecked,
            enableHierarchyCascade
        } = props;
        let nodeClassName = !isChildTree ? "react-tree-main" : node.states.nodeClassName;
        return (
            <div className={className}>
                <If condition={!isChildTree}>
                    <If condition={name}>
                        <div className="node-heading">
                            <h4 className="tree-name">{name}</h4>
                            <If condition={enableTreeActions}>
                                <div className="tree-actions">
                                    <TreeActionsComponent enableSorting={enableSorting} enableAdding={(!treeStates.actions.add) || treeStates.actions.add.visible} runtimeAttrs={treeActionsAttrs} onTreeAction={actions.onTreeAction} draggable={draggable} onSort={actions.onSort} onSortingSaved={actions.onSortingSaved} treeAddIconClass={treeAddIconClass} sortText={sortText} sortIconClass={sortIconClass} confirmSortText={confirmSortText} confirmSortIconClass={confirmSortIconClass} />
                                </div>
                            </If>
                        </div>
                    </If>
                </If>
                <If condition={fullNodes.nodes}>
                    <div className={nodeClassName}>
                        <For each="node" index="index" of={fullNodes.nodes}>
                            <NodeComponent active={node.states.active} checked={node.states.checked} node={node} nameField={nodeNameField} isShowNodeNum={isShowNodeNum} numField={nodeNumField} keyField={nodeKeyField} checkable={checkable} clickable={clickable} showNodeDescriptorIcon={showNodeDescriptorIcon} enableActions={enableNodeActions} nodeTextComponent={nodeTextComponent} nodeActionsComponent={nodeActionsComponent} expandedIconClass={expandedIconClass} collapsedIconClass={collapsedIconClass} addIconClass={addIconClass} editIconClass={editIconClass} deleteIconClass={deleteIconClass} dragIconClass={dragIconClass} draggable={draggable} isNodeMovable={isNodeMovable} enableSort={enableSort} enableMove={enableMove} parentComponentClassName={componentClassName} onExpanded={actions.onNodeExpanded} onCollapsed={actions.onNodeCollapsed} onClicked={actions.onNodeClicked} onChecked={actions.onNodeChecked} onUnchecked={actions.onNodeUnchecked} onNodeAction={actions.onNodeAction} onSorted={onSorted} onSort={onSort} onSortingSaved={onSortingSaved} onDragStart={actions.onDragStart} onDrag={actions.onDrag} onDrop={actions.onDrop} onDragOvered={actions.onDragOvered} onDragEnter={actions.onDragEnter} onDragLeaved={actions.onDragLeaved} getNodeDescriptorIcon={getNodeDescriptorIcon} getDropPositionClass={getDropPositionClass} nodeCheckBoxComponent={nodeCheckBoxComponent} />
                            <If condition={node.states.expanded}>
                                <ReactTreeIteration isChildTree={true} isNormalizedTreeNodes={true} node={node} selectedNodes={selectedNodes} selectionMode={selectionMode} nodeComponent={NodeComponent} nodeActionsComponent={nodeActionsComponent} nodeTextComponent={nodeTextComponent} name={name} theme={theme} checkable={checkable} clickable={clickable} showNodeDescriptorIcon={showNodeDescriptorIcon} autoCheckUpStrategy={autoCheckUpStrategy} autoUncheckUpStrategy={autoUncheckUpStrategy} enableTreeActions={enableTreeActions} enableNodeActions={enableNodeActions} expandedIconClass={expandedIconClass} collapsedIconClass={collapsedIconClass} addIconClass={addIconClass} editIconClass={editIconClass} deleteIconClass={deleteIconClass} sortText={sortText} sortIconClass={sortIconClass} confirmSortText={confirmSortText} confirmSortIconClass={confirmSortIconClass} dragIconClass={dragIconClass} draggable={draggable} isNodeMovable={isNodeMovable} enableSort={enableSort} enableMove={enableMove} getNodeBehaviors={getNodeBehaviors} getNodeDescriptorIcon={getNodeDescriptorIcon} childNodesField={childNodesField} isTreeModeData={isTreeModeData} nodeKeyField={nodeKeyField} nodeParentKeyField={nodeParentKeyField} nodeNameField={nodeNameField} recursivelyCollapse={recursivelyCollapse} onExpanded={onCollapsed} onCollapsed={onCollapsed} onNodeClicked={onNodeClicked} onActiveNodeChanged={onActiveNodeChanged} onAdding={onAdding} onAdded={onAdded} onEditing={onEditing} onEdited={onEdited} onDeleting={onDeleting} onDeleted={onDeleted} onTreeAction={onTreeAction} onNodeAction={onNodeAction} onDragStart={actions.onDragStart} onDrag={actions.onDrag} onDrop={actions.onDrop} onDragOvered={actions.onDragOvered} onDragEnter={actions.onDragEnter} onDragLeaved={actions.onDragLeaved} onSorted={onSorted} onSort={onSort} onSortingSaved={onSortingSaved} onChecked={onChecked} onUnchecked={onUnchecked} onParentNodeChanged={actions.updateParent} enableHierarchyCascade={enableHierarchyCascade} getDropPositionClass={getDropPositionClass} nodeCheckBoxComponent={nodeCheckBoxComponent} isShowNodeNum={isShowNodeNum} numField={nodeNumField} />
                            </If>
                        </For>
                    </div>
                </If>
            </div>

        );
    }
}