import React from 'react';
import Locales from '../../../../../udesk/locales';
import DateRangePicker from '../../../../date-range-picker';
import SentimentAnalysisHeaderComponent from './component';
import ReactSelect from '../../../../react-select';
import Udesk from '../../../../../udesk';

export default class SentimentAnalysisHeaderTemplate extends SentimentAnalysisHeaderComponent {
    render() {
        let {
            language,
            title,
            showHeader,
            showSourceComponent
        } = this.props;
        let {
            locales,
            actions
        } = this;

        let {
            startDate,
            endDate,
            keyword,
            format,
            serverFormat,
            ranges,
            dateLimit,
            selectedSource
        } = this.privates;

        //设置3个月时间，由后端数据决定
        let minDate = moment().subtract(3, 'month').add(1, 'day');
        let maxDate = moment();

        return (
            <div className="sentiment-analysis-header">
                <If condition={showHeader}>
                    <div className="title">
                        {title}
                    </div>
                </If>
                <div className="actions">
                    <DateRangePicker classNames="actions-item form-control input-sm date-range-picker" start={startDate} end={endDate} format={format} serverFormat={serverFormat} applyAction={this.actions.onDateChanged} ranges={ranges} minDate={minDate} dateLimit={dateLimit} languageCode={language} />
                    <If condition={showSourceComponent}>
                        <ReactSelect classNames="source-type-content" dataScource={Udesk.enums.sourceTypes} value={selectedSource} onChanged={actions.onSelectedSource} hasNullSelect={false} />
                    </If>
                    <input type="text" className="actions-item form-control input-sm search-keyword" onChange={actions.onKeyWordChanged} placeholder={locales.labels.keyWord} value={keyword} />
                    <button className="btn btn-sm btn-success" onClick={actions.confirmSearch}>
                        {Locales.get("labels.OK", language)}
                    </button>
                </div>
            </div>
        );
    }
}