import React from 'react';
import Locales from '../../../../../udesk/locales';
import Udesk from '../../../../../udesk';
import SentimentAnalysisWordCloudComponent from './component';
import SentimentAnalysisHeader from '../sentiment-analysis-header';
import { ReportEcharts } from '../../../report-echarts';

export default class SentimentAnalysisWordCloudTemplate extends SentimentAnalysisWordCloudComponent {
    render() {
        let {
            sdkOptions,
            languageCode,
            urls,
            pageTitle,
            showHeader,
            showSourceComponent
        } = this.props;
        let {
            startDate,
            endDate,
            keyword,
            selectedSource,
            chartConfigOptions,
            wholeMoodChartConfigOptions,
            computes
        } = this.privates;

        return (
            <div className="pages-sentiment-analysis-word-cloud">
                <SentimentAnalysisHeader confirmSearch={this.actions.confirmSearch} startDate={startDate} endDate={endDate} keyword={keyword} title={pageTitle} showHeader={showHeader} showSourceComponent={showSourceComponent} selectedSource={selectedSource} />
                <div className="word-cloud">
                    <div className="word-cloud-item">
                        <ReportEcharts classNames="word-cloud-item" chartTitle={this.locales.components.report.pages.sentimentAnalysis.wordCloud.keywordCloud} chartType={Udesk.enums.echartTypes.wordCloud} chartDataUrl={urls.keywordWordCloudUrl} chartDataParams={computes.params} sdkOptions={sdkOptions} chartConfigOptions={chartConfigOptions} onSeriesClicked={this.actions.onSeriesClicked} />
                    </div>
                    <div className="word-cloud-item">
                        <ReportEcharts classNames="word-cloud-item" chartTitle={this.locales.components.report.pages.sentimentAnalysis.wordCloud.sensitiveWordsKeywordCloud} chartType={Udesk.enums.echartTypes.wordCloud} chartDataUrl={urls.sensitiveWordsWordCloudUrl} chartDataParams={computes.params} sdkOptions={sdkOptions} chartConfigOptions={chartConfigOptions} onSeriesClicked={this.actions.onSeriesClicked} />
                    </div>
                </div>
                <ReportEcharts classNames="whole-mood" chartTitle={this.locales.components.report.pages.sentimentAnalysis.wordCloud.wholeMood} chartType={Udesk.enums.echartTypes.pie} chartDataUrl={urls.wholeMoodUrl} chartDataParams={computes.params} sdkOptions={sdkOptions} chartConfigOptions={wholeMoodChartConfigOptions} showExtraPercentInLabels={true} />
            </div>
        );
    }
}