import React, {HTMLProps, useMemo} from "react";
import css from './style.module.scss';
import classNames from "classnames";

type Props = HTMLProps<HTMLSpanElement> & {
    content: string
}

const Highlight: React.FC<Props> = ({content, className, ...props}) => {
    let result = useMemo(() => {
        let _content = content.replace(/<(\/?)em>/g, '{-$1em-}');

        const div = window.document.createElement('div');
        div.innerText = _content;
        const divInnerHtml = div.innerHTML;

        return divInnerHtml.replace(/{-(\/?)em-}/g, '<$1em>');
    }, [content]);

    return <span className={classNames(css['highlight'], className)} {...props}
                 dangerouslySetInnerHTML={{__html: result}}/>;
}

export default Highlight;
