import { useMemo } from "react";

export const useSafeSpaceId = (spaceId: number | string) => {
    return useMemo(() => {
        const _spaceId = spaceId + '';
        if (_spaceId.indexOf(',') > -1) {
            return _spaceId.substring(0, _spaceId.indexOf(','));
        }
        return _spaceId;
    }, [spaceId]);
}
