interface RobotSettings {
    code: number;
    is_udesk_robot_open: boolean;
    is_auto_suggest_open: boolean;
    km_join_udesk_robots: {
        is_enabled: boolean;
        robot_ids: number[];
    };
    smart_assistance: {
        is_enabled: boolean;
        udesk_robot_id: number;
        scene_id: number;
        solution_enabled: boolean;
    };
    smart_assistance_auto_suggestion: {
        is_enabled: boolean;
        suggestion_count: number;
    };
    auth: {
        sign: string;
        email: string;
        timestamp: number;
        appID: string;
    };
}

interface Category {
    id: number;
    name: string;
    parentId: number;
    parentIds?: string;
    robotId?: number;
    num?: any;
    type?: number;
    classify?: number;
}

export interface RobotQuestion {
    id: number;
    robotId: number;
    categoryId: number;
    content: string;
    type: number;
    keyword: string;
    suggestType: number;
    availableTimeType: any;
    startTime: any;
    endTime: any;
    createTime: string;
    updateTime: string;
    needLearnCount: any;
    similarQuestion: any;
    answer: Answer;
    suggestList: any;
    channelList: any[];
    isButtonCopywriting: any;
    enableMultipleAnswers: number;
    tagAnswerList: any;
    flowJumpCount: any;
    wechatUrl: string;
}

interface Answer {
    id: number;
    content: string;
    type: number;
    msgbox: any;
}
