import React from "react";
import { Select } from "udesk-ui";
import style from "./style.module.scss";

const SelectClass: any = (props: any) => {
  let {
    options,
    children,
    valueFieldName = "id",
    nameFieldName = "name",
    ...others
  } = props;

  return (
    <Select className={style["select"]} {...others}>
      {children?.length &&
        React.Children.map(children, (child, index) => {
          return React.cloneElement(child, {
            index: index,
          });
        })}
      {!children?.length &&
        options?.length &&
        options.map((option: any) => {
          return (
            <Select.Option
              key={option[valueFieldName]}
              value={option[valueFieldName]}
            >
              {option[nameFieldName]}
            </Select.Option>
          );
        })}
    </Select>
  );
};
SelectClass.Option = Select.Option;
export default SelectClass;
