import React from 'react';
import { DatePicker, Row, Tooltip } from 'udesk-ui';

interface DateTimeFields {
    formData: {
        type: string,
        typeContent: string,
        help_tip_content: string, //tip提示内容
        help_tip_target: Array<string>,//客服 还是客户提示 还有内容是否为空
        input_tip: string,//输入提示 placeholder
        direct_tip_target: Array<string>,//直接提示 客服 还是客户提示 还有内容是否为空
        input_default: string,//输入框默认的值
        input_max: number,//最大长度
        // eslint-disable-next-line no-useless-escape
        input_regex?: string, //正则
        page_width: string,//页面宽度？
        sort_type?: string,//排序方式
        rows_line?: number,
        name: string,
        isRequired: boolean
    }
}

const CustomizeDateTimeComponent: React.FC<DateTimeFields> = (props) => {

    // eslint-disable-next-line react/prop-types
    const {formData} = props;
    // const [errMessage] = useState('');
    // const [errMsgShowFlag] = useState(false);

    // 失去焦点 校验是否提示
    const hanleValidateTime = (date: any, dateString: any) => {

    };
    return (
        <div className='box-shadow-bg'>
            <Row>
                {
                    formData.isRequired && <span style={{color: 'red'}}>*</span>
                }
                <span>{formData.name}</span>
                {
                    (formData.help_tip_content && formData.help_tip_content.length > 0) && (formData.help_tip_target && formData.help_tip_target.length > 0) &&

                    <Tooltip title={formData.help_tip_content}>
                        <i className='icon icon-caret-down'/>
                    </Tooltip>
                }
            </Row>
            <Row>
                <DatePicker showTime onChange={hanleValidateTime}/>
            </Row>
            <Row>
                {/* 初始没有校验提示 */}
                {/* {errMsgShowFlag && <span>{errMessage}</span>} */}
            </Row>

        </div>
    );
}

export default CustomizeDateTimeComponent;
