type ObjectPropertyPath = string | string[];

interface NodeProps<T> {
    value: T,
    onAdd: (option: T, parentKey: string) => void,
    nodeKey: string,
    onClick: onClickNode<T>,
    onChange: onChangeNode,
    onDelete: onDeleteNode,
    nodeTitlePath: ObjectPropertyPath
    nodeChildrenPath: ObjectPropertyPath
    nodeValuePath: ObjectPropertyPath
    allowAddChild?: (node: T) => boolean
    allowEditTitle?: (node: T) => boolean
    allowRemoveNode?: (node: T) => boolean
}

type onAddNode = (node: T, parentKey: string) => void
type onClickNode<T> = (branchKey: string, node: T) => void
type onChangeNode = (title: string, nodeKey: string) => void
type onDeleteNode = (nodeKey: string) => void

