import React from 'react';
import WaveAudioComponent from './component';

export default class WaveAudioTemplate extends WaveAudioComponent {
    render() {
        let {
            rates
        } = this.props;
        let {
            isShowPlayButton,
            isShowRateOptions,
            duration,
            currentTime,
            playbackRate,
            volume,
            isShowVolumeRange
        } = this.state;

        return (
            <div className="wave-audio-component" ref={this.privates.waveAudioRef}>
                <div className="wave-audio-container"></div>
                <div className="wave-audio-operation-panel">
                    <If condition={isShowPlayButton}>
                        <span className="wave-audio-button-box wave-audio-play-button" onClick={this.actions.play} title="play">
                            <i className="udesk-qc-iconfont icon-udesk-qc-icon--"></i>
                        </span>
                    </If>
                    <If condition={!isShowPlayButton}>
                        <span className="wave-audio-button-box wave-audio-pause-button" onClick={this.actions.pause} title="pause">
                            <i className="udesk-qc-iconfont icon-udesk-qc-icon--1"></i>
                        </span>
                    </If>
                    {/* <span className="wave-audio-button-box wave-audio-download-button pull-right">
                        <i className="udesk-qc-iconfont icon-udesk-qc-xiazai"></i>
                    </span> */}
                    <span className="wave-audio-time-box pull-right">
                        {currentTime} / {duration}
                    </span>
                    <span className="wave-audio-button-box wave-audio-rate-button pull-right">
                        <span className="wave-audio-rate-selected-option" onClick={this.actions.showRateOptions}>X {playbackRate}</span>
                        <If condition={isShowRateOptions}>
                            <ul className="wave-audio-rate-options">
                                <For each="rate" index="index" of={rates}>
                                    <li className="wave-audio-rate-option" key={index} onClick={this.actions.changePlaybackRate.params(rate)}>
                                        {rate}
                                    </li>
                                </For>
                            </ul>
                        </If>
                    </span>
                    <span className="wave-audio-button-box wave-audio-volumn-button pull-right">
                        <i className="udesk-qc-iconfont icon-udesk-qc-yinliang" onClick={this.actions.showVolumeRange}></i>
                        <If condition={isShowVolumeRange}>
                            <span className="wave-audio-volumn-input-box">
                                <input type="range" id="wave-audio-volume" min="0" max="1" step="0.1" value={volume} onChange={this.actions.changeVolume} />
                            </span>
                        </If>
                    </span>
                </div>
            </div>
        );
    }
}