Demo:

与`Udesk-ui`中的**ConfigProvider**传参保持一致即可

```tsx
/**
 * title: 基础使用
 * desc: 如果上面的组件丢失了样式，则表示`ConfigProvider`正常工作了，因为渲染后组件的 class 前缀会变为`prefixCls`传入的值，而不再是ant。目前支持中英文两种语言，默认为中文。
 */
import React from 'react';
import { ConfigProvider, ExportButton } from 'udesk_gm_ui';
// import zhCN from 'udesk_gm_ui/es/locale/zh_CN';
// import enUS from 'udesk_gm_ui/es/locale/en_US';

export default () => (
  <ConfigProvider
    // locale={zhCN}
    prefixCls="udesk-qa-ui">
    <ExportButton></ExportButton>
  </ConfigProvider>
);
```

渲染的真实 dom 为：

```html
<button type="button" class="udesk-qa-ui-btn udesk-qa-ui-btn-default"><span>导 出</span></button>
```
