import * as React from 'react';
// @ts-ignore
import Udesk from 'udesk-react/src/udesk';
// @ts-ignore
import CustomFilters from 'udesk-react/src/components/custom-filters/index';
import classNames from 'classnames';
import { usePrefixCls } from '../utils';
import './style/index';

Udesk.init();

type IndexProps = {
  onChange: (value: any) => void;
  value: any;
  showConditionNumber: boolean;
  conditionFieldColumnHeader: string;
  conditionOperatorColumnHeader: string;
  conditionValueColumnHeader: string;
  conditionFieldField: string;
  conditionValueField: string;
  fields: any[];
  fieldValueSettings: any[];
  conditions?: any[];
  fieldSelectorClass?: string;
  operatorSelectorClass?: string;
  conditionValueComponentAttrs?: any;
  prefixCls?: string;
  className?: string;
  theme?: string;
};

function Index(props: IndexProps) {
  const {
    onChange,
    value,
    showConditionNumber = false,
    conditionFieldColumnHeader = null,
    conditionOperatorColumnHeader = null,
    conditionValueColumnHeader = null,
    conditionFieldField = 'field',
    conditionValueField = 'value',
    fields = null,
    conditions = null,
    fieldValueSettings = null,
    fieldSelectorClass = 'form-control',
    operatorSelectorClass = 'form-control',
    conditionValueComponentAttrs = {},
    prefixCls: customizePrefixCls,
    className = '',
    theme = '',
  } = props;

  const [customFilterPrefixCls] = usePrefixCls('custom-filter', customizePrefixCls || '');
  const classes = classNames(customFilterPrefixCls, className);

  return (
    <>
      <CustomFilters
        theme={`${classes} ${theme}`}
        showConditionNumber={showConditionNumber}
        conditionFieldColumnHeader={conditionFieldColumnHeader}
        conditionOperatorColumnHeader={conditionOperatorColumnHeader}
        conditionValueColumnHeader={conditionValueColumnHeader}
        conditionFieldField={conditionFieldField}
        conditionValueField={conditionValueField}
        fields={fields}
        conditions={value}
        fieldValueSettings={fieldValueSettings}
        fieldSelectorClass={fieldSelectorClass}
        operatorSelectorClass={operatorSelectorClass}
        onChanged={onChange}
        conditionValueComponentAttrs={conditionValueComponentAttrs}
      />
    </>
  );
}

export default Index;
