## demo

Demo:

```tsx
/**
 * title: 基础使用
 * desc: 集成视频，图片，引用，标题，链接，列表，多选列表等，点击可以进行工具栏切换，鼠标选中还有加粗，斜线等内联样式可切换
 * background: 'rgb(240, 242, 245)'
 */
import React, { useContext, useState, useEffect, useRef } from 'react';
import { DocumentEditor } from 'udesk_gm_ui';
let dataOne = {
  blocks: [
    {
      id: 'PaLnx2OV0H',
      type: 'header',
      data: {
        text: 'Editor.js',
        level: 2,
      },
    },
    {
      id: 'yeEb5_X2CD',
      type: 'paragraph',
      data: {
        text: 'Hey. Meet the new Editor. On this page you can see it in action — try to edit this text.',
      },
    },
    {
      id: 'hyRnMGKf7g',
      type: 'header',
      data: {
        text: 'Key features',
        level: 3,
      },
    },
    {
      id: 'M8vXx_Y1Jk',
      type: 'list',
      data: {
        style: 'unordered',
        items: [
          'It is a block-styled editor',
          'It returns clean data output in JSON',
          'Designed to be extendable and pluggable with a simple API',
        ],
      },
    },
    {
      id: 'EQszj2NwCC',
      type: 'header',
      data: {
        text: 'What does it mean «block-styled editor»',
        level: 3,
      },
    },
    {
      id: 'V5ZhgAKnLf',
      type: 'paragraph',
      data: {
        text: 'Workspace in classic editors is made of a single contenteditable element, used to create different HTML markups. Editor.js <mark class="cdx-marker">workspace consists of separate Blocks: paragraphs, headings, images, lists, quotes, etc</mark>. Each of them is an independent contenteditable element (or more complex structure) provided by Plugin and united by Editor\'s Core.',
      },
    },
    {
      id: 'YkgjZw33zV',
      type: 'paragraph',
      data: {
        text: 'There are dozens of <a href="https://github.com/editor-js">ready-to-use Blocks</a> and the <a href="https://editorjs.io/creating-a-block-tool">simple API</a> for creation any Block you need. For example, you can implement Blocks for Tweets, Instagram posts, surveys and polls, CTA-buttons and even games.',
      },
    },
    {
      id: 'tXrDY7p9KO',
      type: 'header',
      data: {
        text: 'What does it mean clean data output',
        level: 3,
      },
    },
    {
      id: 'U0y9gXt_Vx',
      type: 'paragraph',
      data: {
        text: 'Classic WYSIWYG-editors produce raw HTML-markup with both content data and content appearance. On the contrary, Editor.js outputs JSON object with data of each Block. You can see an example below',
      },
    },
    {
      id: 'C4R_MEMJvb',
      type: 'paragraph',
      data: {
        text: 'Given data can be used as you want: render with HTML for <code class="inline-code">Web clients</code>, render natively for <code class="inline-code">mobile apps</code>, create markup for <code class="inline-code">Facebook Instant Articles</code> or <code class="inline-code">Google AMP</code>, generate an <code class="inline-code">audio version</code> and so on.',
      },
    },
    {
      id: '1ycsHqy8FD',
      type: 'paragraph',
      data: {
        text: 'Clean data is useful to sanitize, validate and process on the backend.',
      },
    },
    {
      id: '7EG9LTsg2p',
      type: 'delimiter',
      data: {},
    },
    {
      id: 'K7AjKWXnxO',
      type: 'paragraph',
      data: {
        text: "We have been working on this project more than three years. Several large media projects help us to test and debug the Editor, to make it's core more stable. At the same time we significantly improved the API. Now, it can be used to create any plugin for any task. Hope you enjoy. [表情]",
      },
    },
    {
      id: 't3aDTOTG1L',
      type: 'image',
      data: {
        file: {
          url: 'https://codex.so/public/app/img/external/codex2x.png',
        },
        caption: '',
        withBorder: false,
        stretched: false,
        withBackground: false,
      },
    },
  ],
};
const dataTwo = {
  blocks: [
    {
      id: 'PaLnx2OV0H',
      type: 'header',
      data: {
        text: 'Editor.js',
        level: 2,
      },
    },
    {
      id: 'yeEb5_X2CD',
      type: 'paragraph',
      data: {
        text: 'Hey. Meet the new Editor. On this page you can see it in action — try to edit this text.',
      },
    },
    {
      id: 'hyRnMGKf7g',
      type: 'header',
      data: {
        text: 'Key features',
        level: 3,
      },
    },
    {
      id: 'M8vXx_Y1Jk',
      type: 'list',
      data: {
        style: 'unordered',
        items: [
          'It is a block-styled editor',
          'It returns clean data output in JSON',
          'Designed to be extendable and pluggable with a simple API',
        ],
      },
    },
  ],
};
const dataThree = {
  blocks: [
    { id: '9IWFE_bRrw', type: 'header', data: { text: '方法一：', level: 1 } },
    {
      id: 'CGB03PMX47',
      type: 'list',
      data: {
        style: 'ordered',
        items: [
          'AAAAAAAAAAAAAAAAAAA',
          'BBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBBB',
          'CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC',
        ],
      },
    },
    {
      id: 'fj0cxIbzcY',
      type: 'checklist',
      data: {
        items: [
          { text: '是的', checked: false },
          { text: '不是', checked: true },
          { text: '全部是', checked: false },
        ],
      },
    },
    { id: 'h7IE1JqlVl', type: 'paragraph', data: { text: '点击跳转百度搜索' } },
    {
      id: 'Y8lwser-Iu',
      type: 'quote',
      data: { text: '云深不知处', caption: '王维', alignment: 'left' },
    },
    { id: 'rkK1mVPyJ9', type: 'delimiter', data: {} },
    {
      id: '_3eqPn3qw4',
      type: 'paragraph',
      data: { text: '阿三顶顶顶顶顶顶顶顶顶顶顶顶顶顶顶顶顶' },
    },
  ],
};
const Demo = () => {
  const ref = useRef<any>(null);
  const [defaultTitle, setDefaultTitle] = useState('');
  const [data, setDate] = useState({ blocks: [] });
  const upload = () => {
    console.log(111);
  };
  //   const getEditorResult = (jsonResult: any) => {
  //     console.log(222, jsonResult, '保存的数据，字符串');
  //   };
  const onSave = React.useCallback(async () => {
    const savedData = await (ref.current.current as any).save();
    console.log(savedData, '调用实例的方法获取的数据');
  }, []);

  const getInit = React.useCallback((editorCore) => {
    ref.current = editorCore;
  }, []);
  const getTitle = (title) => {
    console.log(title, '获取组件title');
    setDefaultTitle(title);
  };
  useEffect(() => {
    setDefaultTitle('回显的title');
    setDate(dataThree);
    // setTimeout(() => {
    //   setDate(dataOne);
    // }, 1500);
    // setTimeout(() => {
    //   setDate(dataTwo);
    // }, 3000);
    // setTimeout(() => {
    //   setDate(dataThree);
    // }, 5000);
  }, []);
  const styleConfig = {
    display: 'flex',
    justifyContent: 'content',
    marginBottom: 10,
    flexDirection: 'column',
    height: '100%',
    width: '100%',
    position: 'relative',
  };
  const styleHtml = {
    paddingLeft: 40,
    paddingRight: 40,
    background: '#fff',
    width: '100%',
  };
  const titleStyle = {
    marginLeft: '25%',
    width: '60%',
  };
  return (
    <React.Fragment>
      <button onClick={onSave} style={{ color: '#000' }}>
        保存
      </button>
      <DocumentEditor
        customImageUpload={upload}
        style={styleConfig}
        titleStyle={titleStyle}
        transformHtml={data}
        htmlPosition={styleHtml}
        //readOnlyFlag={true}
        getInit={getInit}
        getTitle={getTitle}
        defaultTitle={defaultTitle}
      />
    </React.Fragment>
  );
};
export default Demo;
```

## API

| 参数 | 说明 | 类型 | 默认值 | 版本 |
| --- | --- | --- | --- | --- |
| customImageUpload | 自定义上传图片的方法 | Function,返回值{file:{url:"....."}} | - |  |
| customVideoUpload | 自定义上传视频的方法 | Function,返回值{file:{url:"....."}} | - |  |
| getEditorResult | 自定义获取富文本编辑信息的方法 | Function,返回值 object，{title:标题} |  |
| transformHtml | 通过后端获取的 json 结构回显的数据 | 详情看 demo 用法 |  | 注意：当第一次使用或者后端接口返回数据为空时，需设置默认值 |
| htmlPosition | 解析出来的静态页面的块样式，如可以设置相对位置等 | 详情看 demo 用法 |  |
| style | 自定义编辑器的窗口大小和样式 | 详情看 demo 用法 |  |  |
| titleStyle | 自定义标题处于编辑器的窗口左右位置和宽度 | 详情看 demo 用法 |  |  |
| readOnlyFlag | 切换编辑器的只读开关 | 详情看 demo 用法 | false | 注意：只读开启时，不能设置保存 |
| getInit | 编辑器获取实例的方法 | 详情看 demo 用法 |  |  |
| getTitle | 编辑器获取 title 的方法 | 详情看 demo 用法 |  |  |
| defaultTitle | 编辑器设置默认方法 | 详情看 demo 用法 |  |  |
