let fs = require('fs');
let BASE_FILE_NAME = "iconfont";
let NEW_FILE_NAME = "udesk-react-iconfont";
let RENAME_EXTENSIONS = ['eot', 'svg', 'ttf', 'woff'];

for (let i = 0; i < RENAME_EXTENSIONS.length; i++) {
    let ext = RENAME_EXTENSIONS[i];
    let targetFile = `${NEW_FILE_NAME}.${ext}`;
    let sourceFile = `${BASE_FILE_NAME}.${ext}`;
    if (fs.existsSync(targetFile) && fs.existsSync(sourceFile)) {
        fs.unlinkSync(targetFile);
    }
}

for (let i = 0; i < RENAME_EXTENSIONS.length; i++) {
    let ext = RENAME_EXTENSIONS[i];
    let sourceFile = `${BASE_FILE_NAME}.${ext}`;
    if (fs.existsSync(sourceFile)) {
        fs.renameSync(`${BASE_FILE_NAME}.${ext}`, `${NEW_FILE_NAME}.${ext}`);
    }
}

let cssContent = fs.readFileSync(`${BASE_FILE_NAME}.css`, { encoding: 'utf8' });
let newContent = cssContent;
for (let i = 0; i < RENAME_EXTENSIONS.length; i++) {
    let ext = RENAME_EXTENSIONS[i];
    newContent = newContent.replace(new RegExp(`'${BASE_FILE_NAME}\\.${ext}`, "ig"), `'${NEW_FILE_NAME}.${ext}`);
}
fs.writeFileSync(`${BASE_FILE_NAME}.css`, newContent, { encoding: 'utf8' });
if (newContent === cssContent) {
    console.log(`${BASE_FILE_NAME}.css已经替换过了`);
} else {
    console.log(`${BASE_FILE_NAME}.css替换完成`);
}
