import React from 'react';
import includes from 'lodash-es/includes';
import isArray from 'lodash-es/isArray';
import { Col, Row } from 'udesk-ui';


const CustomFieldsShow: React.FC<any> = (props: any) => {
    const {customField, value} = props;
    const is_link = customField && customField['content_type'] === 'link';
    const labelStyle: React.CSSProperties = {
        color: 'rgba(0, 0, 0, 0.65)'
    }
    // function getLabel() {
    //     const { customField = {} } = props;
    //     let labelEl = '';
    //     if (customField.agent_permission === 1) {
    //         labelEl += <span className="red">*</span>;
    //     }
    //     return labelEl;
    // }

    function getValue() {
        const {customField, value} = props;
        if (!customField) return '';

        const {content_type: type, select_options: options} = customField;
        let reaultValue = '';
        let _value = value;
        let textArr: any = [];
        let result: any = [];
        let oArr: any = [];
        switch (type) {
            case 'droplist':
            case 'radio':
            case 'checkbox':
                if (!isArray(value)) {
                    _value = value.split(',');
                }
                (options || []).forEach((item: any) => {
                    if (includes(_value, item.value + '')) {
                        textArr.push(item.title);
                    }
                });
                reaultValue = textArr.join(',');
                break;
            case 'chained_droplist':
                if (!isArray(value)) {
                    _value = value.split(',');
                }
                oArr = options;
                _value.forEach((_v: any) => {
                    let ls,
                        oArrObj;

                    if (!oArr || !(oArrObj = oArr.find((item: any) => item.value === (_v + '')) || oArr.find((item: any) => item.value === parseInt(_v)))) {
                        return;
                    }

                    ls = oArrObj;
                    result.push(ls['title']);
                    oArr = ls['subs'];
                });
                reaultValue = result.join('/');
                break;
            case 'link':
                reaultValue = `<a href='${_value}' target="_blank">${_value}</a>`;
                break;
            default:
                reaultValue = _value;
                break;
        }
        return reaultValue;
    }

    return <div>
        {
            (props.customField && props.value) &&
            <Row>
                <Col span={6}>
                    <label style={labelStyle} title={props.title}>
                        {props.customField.agent_permission === 1 ? <span className="red">*</span> : ''}
                        {props.customField.title}
                    </label>
                </Col>
                <Col span={17} offset={1}>
                    <span title={props.title}
                          className={`item-content ${is_link ? 'item-content-link' : ''} word-break`}>
                        {
                            is_link ? (
                                <a href={value} target="_blank" rel="noopener noreferrer">{value}</a>
                            ) : (getValue())
                        }
                    </span>
                </Col>
            </Row>
        }
    </div>
}

export default CustomFieldsShow;
