import React, { useEffect, useState } from 'react';
import { Input } from 'udesk-ui';

const {TextArea} = Input;

interface IProps {
    value?: string;
    trigger: 'onChange' | 'onBlur';
    onChange?: (value: string) => void;
    onBlur?: (value: string) => void;
}

const DescField: React.FC<IProps> = (props) => {
    const [value, setValue] = useState(props.value || '')
    useEffect(() => {
        setValue(props.value || '')
    }, [props.value]);

    const handleChange = (e: React.ChangeEvent<HTMLTextAreaElement>) => {
        setValue(e.target.value);
    }

    const handleBlur = (e: React.ChangeEvent<HTMLTextAreaElement>) => {
        // props.onChange && props.onChange(e.target.value);
        if (props.value !== e.target.value) {
            let changeFunction = props[props.trigger]
            if (changeFunction) {
                changeFunction(value)
            }
        }
    }
    return (
        <>
            <TextArea
                value={value}
                onChange={handleChange}
                onBlur={handleBlur}
            />
        </>
    )

}
export default DescField;
