import React, { useEffect, useState } from "react";
import { Input } from "udesk-ui";
import CopyComponent from "../../../components/copy";

interface IProps {
  value?: string;
  trigger: "onChange" | "onBlur";
  onChange?: (value: string) => void;
  onBlur?: (value: string) => void;
}

const NameField: React.FC<IProps> = (props) => {
  const [value, setValue] = useState(props.value || "");
  useEffect(() => {
    setValue(props.value || "");
  }, [props.value]);

  const handleChange = (e: React.FocusEvent<HTMLInputElement>) => {
    setValue(e.target.value);
  };

  const handleBlur = (e: React.FocusEvent<HTMLInputElement>) => {
    // props.onChange && props.onChange(e.target.value);
    if (props.value !== e.target.value) {
      let changeFunction = props[props.trigger];
      if (changeFunction) {
        changeFunction(value);
      }
    }
  };
  return (
    <CopyComponent text={value} switchFlag={true}>
      <Input value={value} onChange={handleChange} onBlur={handleBlur} />
    </CopyComponent>
  );
};
export default NameField;
