import React, { useCallback, useEffect, useState } from "react";
import { Input } from "udesk-ui";
import CopyComponent from "../../../../components/copy";

interface DescOrNameProps {
  value?: string;
  trigger: "onChange" | "onBlur";
  onChange?: (value: string) => void;
  onBlur?: (value: string) => void;
  switchFlag?: boolean;
}

const DescOrName: React.FC<DescOrNameProps> = (props) => {
  const [value, setValue] = useState(props.value || "");
  useEffect(() => {
    setValue(props.value || "");
  }, [props.value]);

  const handleChange = useCallback((e: React.FocusEvent<HTMLInputElement>) => {
    setValue(e.target.value);
  }, []);
  // const handleChange = (e: React.FocusEvent<HTMLInputElement>) => {
  //     setValue(e.target.value);
  // }

  const handleBlur = useCallback(
    (e: React.FocusEvent<HTMLInputElement>) => {
      if (props.value !== e.target.value) {
        let changeFunction = props[props.trigger];
        if (changeFunction) {
          changeFunction(e.target.value);
        }
      }
    },
    [props.value]
  );

  // const handleBlur = (e: React.FocusEvent<HTMLInputElement>) => {
  //     if (props.value !== e.target.value) {
  //         let changeFunction = props[props.trigger]
  //         if (changeFunction) {
  //             changeFunction(value)
  //         }
  //     }
  // }
  return (
    <CopyComponent text={value} switchFlag={props.switchFlag}>
      <Input value={value} onChange={handleChange} onBlur={handleBlur} />
    </CopyComponent>
  );
};
export default DescOrName;
