import React from "react";
import { Form } from "udesk-ui";
import style from "./index.module.scss";
import { QiYeWeiXin, WeiBo, Weixin } from "../../../../components/icon/icon";

interface PlatformListProps {
  customer: Customer;
}

const PlatformList: React.FC<PlatformListProps> = ({ customer }) => {
  return (
    <React.Fragment>
      {/* 来源是是weixin */}
      {customer.weixins &&
        customer.weixins.length > 0 &&
        customer.weixins.map((item: any, index: number) => {
          return (
            <Form.Item
              key={index}
              className={style["platform-form-item"]}
              label={<div className={style["wx-icon"]} />}
            >
              <div className={style["customer-info-content"]}>
                {item.avatar && <img src={item.avatar} alt="avatar" />}
                <span>{item.nick_name}</span>
              </div>
            </Form.Item>
          );
        })}
      {/* 来源是 qywxes */}
      {customer.qywxes &&
        customer.qywxes.length > 0 &&
        customer.qywxes.map((item: any) => {
          return (
            <Form.Item
              className={style["platform-form-item"]}
              label={
                <QiYeWeiXin style={{ fontSize: "16px", color: "#1afa29" }} />
              }
            >
              <div className={style["customer-info-content"]}>
                {item.avatar && <img src={item.avatar} alt="avatar" />}
                <span>{item.nick_name}</span>
              </div>
            </Form.Item>
          );
        })}
      {/* 来源是 weibo */}
      {customer.weibos &&
        customer.weibos.length > 0 &&
        customer.weibos.map((item: any) => {
          return (
            <Form.Item
              className={style["platform-form-item"]}
              label={<WeiBo style={{ fontSize: "16px", color: "#1afa29" }} />}
            >
              <div className={style["customer-info-content"]}>
                {item.avatar && <img src={item.avatar} alt="avatar" />}
                <span>{item.nick_name}</span>
              </div>
            </Form.Item>
          );
        })}
      {/* 来源是 weixinminis */}
      {customer.weixin_minis &&
        customer.weixin_minis.length > 0 &&
        customer.weixin_minis.map((item: any, index: number) => {
          return (
            <Form.Item
              key={index}
              className={style["platform-form-item"]}
              label={<div className={style["wxmini-icon"]} />}
            >
              <div className={style["customer-info-content"]}>
                {item.avatar && <img src={item.avatar} alt="avatar" />}
                <span>{item.nick_name}</span>
              </div>
            </Form.Item>
          );
        })}
      {/* source_channel只显示头像? */}
      {customer.source_channel && customer.source_channel === "mcchat" && (
        <Form.Item
          className={style["platform-form-item"]}
          label={<Weixin style={{ fontSize: "16px", color: "#1afa29" }} />}
        >
          <div></div>
        </Form.Item>
      )}

      {/* 头像待确定 */}
      {customer.contact_im_channels &&
        customer.contact_im_channels.length > 0 &&
        customer.contact_im_channels.map((item: any) => {
          return (
            <Form.Item
              className={style["platform-form-item"]}
              label={<Weixin style={{ fontSize: "16px", color: "#1afa29" }} />}
            >
              <div className={style["customer-info-content"]}>
                {item.avatar && <img src={item.avatar} alt="avatar" />}
                <span>{item.nick_name}</span>
              </div>
            </Form.Item>
          );
        })}
    </React.Fragment>
  );
};

export default PlatformList;
