import React from 'react';
import { useTranslation } from "react-i18next";
import style from './index.module.scss'

interface ProductProps {
    product: any
}

const Improduct: React.FC<ProductProps> = (props) => {
    const {t} = useTranslation();
    const {product} = props;

    const needShow = product && (product.image || product.title || product.product_params);
    return (
        <React.Fragment>
            {
                needShow && (
                    <div className={style['product_page']}>
                        <h6 className={style['visit-info-title']}>{t('page.im.customerInfo.device.consultObj')}</h6>
                        <div className={`${style['media']} ${style['product-media']}`}>
                            {/* left 图片展示 */}
                            <div className={style['media-left']}>
                                {
                                    product.image &&
                                    <a href={product.url} rel="noopener noreferrer" target="_blank"><img alt={' '}
                                                                                                         src={product.image}/></a>
                                }
                            </div>
                            {/* 商品详情 */}
                            <div className={style['word-break']}>
                                {
                                    product.title &&
                                    <>
                                        {
                                            product.url &&
                                            <a href={product.url} rel="noopener noreferrer"
                                               target="_blank">{product.title}</a>
                                        }
                                        {
                                            !product.url &&
                                            <a href={product.url} rel="noopener noreferrer"
                                               target="_blank">{product.title}</a>
                                        }
                                    </>
                                }
                                <div className={style['details']}>
                                    {
                                        product.product_params && Object.keys(product.product_params).map((item: any, index: number) => {
                                            return (<div key={index}>{item}:{product.product_params[item]}</div>)
                                        })
                                    }
                                </div>
                            </div>
                        </div>
                    </div>
                )
            }
        </React.Fragment>
    );
}
export default Improduct;
