import React, { ComponentProps, Fragment } from "react";
import AccessInfo from "./access-info";
import Improduct from "./im-product";
import CustomerInfo from "./customer-info/index";
import style from "./index.module.scss";
import CustomerInfoDetail from "./customer-info/detail";
import { useSelector } from '../../store/store-hook';
import { RootState } from "../../store/root-reducer";

type ImCustomerProps = {
  chat: IMineChat;
  company: Company;
  imNewPlatforms: any;
  event: any;
} & ComponentProps<typeof CustomerInfo>;

const ImCustomer: React.FC<ImCustomerProps> = (props) => {
  const { chat, company } = props;
  const initData = useSelector((state: RootState) => state.initData);
  let customerRender = initData?.template?.customer?.render;
  let customerData:any = {};
  customerData.getConsumer = function(){
    return chat.customer;
  }
  return (
    <div className={style["customer-info"]}>
      {!!chat?.product && <Improduct product={chat.product} />}
      {!!chat?.accessInfo && !initData?.template?.customer?.customerInfo && (
        <AccessInfo
          accessInfo={chat.accessInfo}
          imNewPlatforms={props.imNewPlatforms || []}
        />
      )}
      {!!chat?.customer  && (
        <Fragment>

          {!initData?.template?.customer?.customerInfo && <CustomerInfoDetail
            customer={chat.customer}
            company={company}
            event={props.event}
            chat={chat}
          />}
          {
            !initData?.template?.customer?.oldCustomerTemplate  ? (
              <CustomerInfo
                {...props}
                showCount={props.showCount ? props.showCount : true}
              />
            ):customerRender && customerRender(customerData)
          }
          
        </Fragment>
      )}
    </div>
  );
};

export default ImCustomer;
