import React from "react";
import RepositoryWidget from "../../components/repository-widget";
import pick from "lodash-es/pick";
import { useSelector } from "../../store/store-hook";
import { RootState } from "../../store/root-reducer";

type Props = {
  company: Company;
  user: any;
  event: any;
  roleCan: IRoleCan;
  chat: IMineChat;
  kmrobot_url: string;
  previewUrl: string;
};
const ImKnowledge: React.FC<Props> = (props) => {
  const { company, user, event, roleCan, chat } = props;
  const { currentUser: agent, fields } = useSelector((state: RootState) =>
    pick(state, "currentUser", "fields")
  );
  return (
    <RepositoryWidget
      companyId={company.company_id!}
      email={user.email}
      selectionStateKey={`chat_${chat.im_sub_session_id}`}
      onUse={event?.onUse}
      onSend={event?.onSend}
      kmApiBase={props?.kmrobot_url}
      previewUrl={props?.previewUrl}
      allowSendQuestion={true}
      showRobotQuestionTab={true}
      showPublicScope={roleCan?.knowledge_view_public}
      subdomain={company.company_subdomain!}
      agent={agent}
      customer={chat.customer}
      customerCustomFields={fields.customerFieldsv2}
    />
  );
};

export default ImKnowledge;
