import React from 'react'
import { useDrop } from 'react-dnd'
import { DndItem } from './dnd-item'

interface DndContainerProps {
    list: any
    type: string,
    moveItem: (id: string, to: number) => void
    findItem: (id: string) => { index: number }
    checkedItem: (id: string) => void
}

/**
 * 平行视界model
 * @param param0
 */

export const DndContainer: React.FC<DndContainerProps> = ({list, type, moveItem, findItem, checkedItem}) => {
    const moveItemToContainer = (id: string, atIndex: number) => {
        moveItem(id, atIndex);
    }

    const findItemToContainer = (id: string) => {
        return findItem(id);
    }

    const checkedItemToContainer = (id: string) => {
        return checkedItem(id)
    }

    const [, drop] = useDrop({accept: type})
    return (
        <div ref={drop}>
            {list.map((card: any) => (
                <DndItem
                    key={card.id}
                    id={`${card.id}`}
                    text={card.text}
                    type={type}
                    checked={card.checked}
                    moveItemToContainer={moveItemToContainer}
                    findItemToContainer={findItemToContainer}
                    checkedItemToContainer={checkedItemToContainer}
                />
            ))}
        </div>
    )
}
