import React from "react";
import style from "./index.module.scss";
import { File } from "../../../components/icon/icon";

const FileType = (props: any) => {
  const { msgItem } = props;
  const canVideoExts = ["mp4", "mov", "MOV", "m4v", "M4V"];
  const contentObject =
    typeof msgItem.content === "string"
      ? JSON.parse(msgItem.content)
      : msgItem.content;
  return (
    <div className={style["new-message-contnet"]}>
      {canVideoExts.indexOf(contentObject.fileext) > -1 && (
        <video
          src={contentObject.data.content}
          style={{ maxWidth: "100%", maxHeight: "480px" }}
          controls={true}
        >
          视频地址：{contentObject.data.content}
        </video>
      )}
      {canVideoExts.indexOf(contentObject.fileext) === -1 && (
        <div className={style["new-file-type"]}>
          <div className={style["containersdsd"]}>
            <File />
          </div>
          <div>
            <a
              className={style["filename"]}
              href={contentObject.data.content}
              target="_blank"
              rel="noopener noreferrer"
              download={contentObject.filename}
            >
              {contentObject.filename || ""}
            </a>
            <div className={style["filesize"]}>
              <span>{contentObject.filesize || ""}</span>
              <a
                className={style["pull-right"]}
                href={contentObject.data.content}
                target="_blank"
                rel="noopener noreferrer"
                download={contentObject.filename}
              >
                下载
              </a>
            </div>
          </div>
        </div>
      )}
    </div>
  );
};
export default FileType;
