/* eslint-disable array-callback-return */
import React, { useCallback, useState } from 'react';
import style from './index.module.scss'
import { useTranslation } from 'react-i18next'
import { Modal } from 'udesk-ui'

function StructType(props: any) {
    const {msgItem} = props
    const {t} = useTranslation();
    const [showModal, setShowModal] = useState<boolean>(false)
    const [showPhone, setShowPhone] = useState<string>('')
    let item = typeof (msgItem.content) === 'string' ? JSON.parse(msgItem.content) : msgItem.content
    if (item.data) {
        item = item.data.content
    }
    const buttonTypes = {
        link: "link",
        phone: "phone"
    }
    const showTel = useCallback((phone: string) => {
        setShowModal(!showModal)
        setShowPhone(phone)
    }, [showModal])
    console.log('StructType',item)
    return (
        <div className={style['im-struct']}>
            <ul className={style['list-group']}>
                {item.img_url &&
                <li className={style["list-group-item"]}>
                    <img alt="" src={item.img_url} className={style["list-group-item-img"]}/>
                </li>
                }
                {(item.title || item.description) &&
                <li className={`${style['list-group-item']} ${style['text-left']}`}>
                    {item.title && <label>{item.title}</label>}
                    {item.description && <p className={style["text-muted"]}>{item.description}</p>}
                </li>
                }
                {item.buttons && item.buttons.map((item: any) => {
                    if (item) {
                        if (item.type === buttonTypes.link) {
                            return (
                                <li className={style["list-group-item"]}>
                                    <a href={item.value} target="_blank" rel="noopener noreferrer">{item.text}</a>
                                </li>
                            )
                        } else if (item.type === buttonTypes.phone) {
                            return (<li className={style["list-group-item"]}>
                                <a href={`tel:${item.value}`} onClick={() => showTel(item.value)}>{item.text}</a>
                            </li>)
                        }
                    }
                })}
            </ul>
            <Modal
                title={t('page.im.record.callNum')}
                visible={showModal}
            >
                <p>{t('page.im.record.pleaseCall')}:{showPhone}</p>
            </Modal>
        </div>
    );
}

export default StructType;
