//搜索公司
import React, { useCallback, useEffect, useState } from 'react';
import { Select } from 'udesk-ui'

const {Option} = Select;

function LanguageField(props: TicketField) {
    let list: SelectOptions[] = props.options || []
    const [value, setValue] = useState<string>(props.value as string)//选择的选项
    const data = (() => {
        return list.map(item => {
            return {
                value: item.value,
                label: item.title,
            }
        })
    })()//搜索到的数据
    useEffect(() => {
        setValue(props.value)
    }, [props.value])
    // 选项变化时回调
    const handleChange = useCallback((value: string) => {
        setValue(value)
        props.onChange && props.onChange(value)
    }, [props])
    //筛选规则
    const handleFilter = useCallback((inputValue, option) => {
        return option.children.includes(inputValue)
    }, [])
    return (
        <>
            {/* 带输入的下拉选择框 */}
            <Select
                showSearch//显示搜索
                showArrow={true}//显示下拉小箭头
                value={value}//选择的选项
                placeholder={props.placeholder}//占位符
                onChange={handleChange}//选中 option
                style={{width: '100%'}}
                filterOption={handleFilter}
                getPopupContainer={triggerNode => triggerNode}//菜单渲染父节点
            >
                {data.map(d => (
                    <Option key={d.value} value={d.value}>{d.label}</Option>
                ))}
            </Select>
        </>
    );
}

export default LanguageField;
