import React, { useCallback } from "react";
import { Button } from "udesk-ui";
import { useTranslation } from "react-i18next";
import UploadBox from "../../../../components/upload-box";
import { UploadOutlined } from "@ant-design/icons";
import { r } from "../../../../utils/index";

interface Props {
  value?: any[];
  onChange?: (value: any[]) => void;
}

function UploadFile(props: Props & any) {
  const { t } = useTranslation(); //多语言
  // const udeskWebappContext: any = useContext(UdeskContext);
  const onChange = useCallback(
    (fileList: any[]) => {
      console.log(fileList);
      props?.onChange?.(fileList);
    },
    [props?.onChange]
  );

  function createMarkup() {
    const tip = r(
      t("page.im.ticket.uploaderTip"),
      `<span style="color:#e80000" >${props.ticketTab.singleTicketAttachmentLimit}M</span>`,
      `<span style="color:#e80000" >${props.ticketTab.totalTicketAttachmentLimit}M</span>`
    );
    return { __html: tip };
  }

  return (
    <>
      <UploadBox
        {...props}
        marking="web.ts.ticket_reply"
        onChange={onChange}
        single={props.ticketTab.singleTicketAttachmentLimit * 1024 * 1024}
        total={props.ticketTab.totalTicketAttachmentLimit * 1024 * 1024}
        noAttachment={true}
      >
        <Button>
          <UploadOutlined />
          {t("page.im.ticket.uploadFile")}
        </Button>
      </UploadBox>
      <div
        style={{ color: "rgba(0, 0, 0, 0.45)", marginTop: "5px" }}
        dangerouslySetInnerHTML={createMarkup()}
      ></div>
    </>
  );
}

export default UploadFile;
