import React, { Component } from 'react';
import Pagination           from '@udesk/pagination';
import PropTypes            from 'prop-types';

class WebappPagination extends Component {
    constructor(props) {
        super(props);
    }

    render() {
        return <Pagination page={this.props.page} pageCount={this.props.pageCount}
                           recordCount={this.props.recordCount}
                           perPage={this.props.perPage}
                           onPageChange={this.props.onPageChange}
                           onPerPageChange={this.props.onPerPageChange}
                           className='ud-pagination clearfix'
                           pageCountClassName='pull-left'
                           pageHandlerClassName='pull-right'
                           pageBtnsClassName='pages'
                           jumpToClassName='go-page'
                           jumpToInputClassName='input-go form-control'
                           pageBtnsInnerClassName='pagination'
                           currentPageClassName='current'
                           perPageClassName='form-control'
                           maxPageBtnCount={this.props.maxPageBtnCount}
                           lang={this.props.lang}
        />;
    }
}

WebappPagination.propTypes = {
    page            : PropTypes.number.isRequired,
    pageCount       : PropTypes.number,
    recordCount     : PropTypes.number,
    perPage         : PropTypes.number,
    onPageChange    : PropTypes.func,
    onPerPageChange : PropTypes.func,
    maxPageBtnCount : PropTypes.number,
    lang            : PropTypes.string
};
export default WebappPagination;
