import React, { Component } from 'react';
import PropTypes            from 'prop-types';
import Control              from './Control';
import Dropdown             from './Dropdown';
import Popover              from '@udesk-webapp/popover';

class Index extends Component {
    constructor(props) {
        super(props);
    }

    render() {
        let {onChange = v => v, className, popContentStyle, style, ...props} = this.props;
        return (
            <Popover {...props} className={className} style={style} components={{
                Control,
                PopContent : ({closePopContent, ...props}) => {
                    return <Dropdown {...props} style={popContentStyle} onChange={(v) => {
                        onChange(v);
                        closePopContent();
                    }}/>;
                }
            }}/>
        );
    }
}

Index.propTypes = {
    t                : PropTypes.func,
    controlClassName : PropTypes.string
};

Index.defaultProps = {
    className       : 'select-with-search',
    popContentStyle : {minWidth : '200px', display : 'block', padding : '15px'}
};

export default Index;
