/** @jsx jsx */
import { css, jsx } from '@emotion/core';
import React        from 'react';
import UdeskTable   from './udeskTable';

let style = css`
    thead {
        &.dragging {
            user-select: none;
            & .drag-target-element .dnd-mask {
                display: block;
                z-index: -1;
            }
            & .dragging-element {
                display: block;
                position: fixed;
                opacity: 0.8;
                left: 0;
                box-sizing: border-box;
            }
        }
        &:not(.dragging) th,
        & .dragging-element {
            &:hover,
            &.dragging-element {
                color: #333;
                background: #EFEFEF;
                & .dnd-handler {
                    opacity: 1;
                    color: #333;
                }
            }
        }
        & th {
            position: relative;
            &.dnd {
                cursor: move;
            }
            .dnd-handler {
                opacity: 0;
                cursor: move;
                padding: 0 1px;
                position: absolute;
                left: 5px;
            }
            .dnd-mask {
                display: none;
                position: absolute;
                left: 0;
                top: 0;
                right: 0;
                bottom: 0;
                background-color: #fff;
                border: 1px dashed #00B38B;
            }
            &.sortable {
                .sort-btn-wrapped {
                    cursor: pointer;
                    position: absolute;
                    top: 5px;
                    display: inline-flex;
                    flex-direction: column;
                    margin-left: 5px;
                }
            }
        }
    }
`;
const UdeskTableWithStyle = function(props) {
    return <UdeskTable css={style} {...props}/>;
};

export const NoStyle = UdeskTable;
export default UdeskTableWithStyle;