import fs from 'fs';
import { IApi } from 'umi';
import yargs from 'yargs';
import shelljs from 'shelljs';
import prettier from 'prettier';

interface IPresetOpts {}

export default (api: IApi) => {
    api.describe({
        config: {
            schema(joi) {
                return joi.object({
                    // dark: joi.boolean(),
                });
            },
        },
    });
    api.addRuntimePluginKey(() => ['presetUdesk']);

    const opts: IPresetOpts = api.userConfig.presetUdesk;
    api.registerCommand({
        name: 'upgrade',
        alias: 'up',
        description: '一键升级umi插件集',
        details: '',
        fn: ({ args }: { args: yargs.Arguments }) => {
            shelljs.exec(`yarn add -D -E umi-preset-udesk`, { async: false });
            let appPackageJson = require('umi-plugin-preset-udesk/package.json');
            if (appPackageJson.app) {
                let appPackage = require('./package.json');
                fs.writeFileSync(
                    './package.json',
                    prettier.format(
                        JSON.stringify({ ...appPackage, ...appPackageJson.app }),
                        require('@udesk/prettier-config')
                    )
                );
            }
            // todo: 获取最新版 umi-plugin-preset-udesk
            // 升级最新版
            // 更新 package.json/app
        },
    });
};
