import React, { ComponentProps,useMemo } from 'react';
import {handleMessageData} from './util'
import ImLog from "@udesk-webapp/im-log";

interface Props {
    response:{
        agent_avatar?: string
        agent_id: number,
        agent_nick_name?: string,
        content: string
        created_at?: string,
        customer_id: number
        id: number
        inviter?:string | null
        log_type?:string
        message_display_status?: string
        message_id: string
        respone?:string
        send_status?: string
        sender?: string
        status?: string
        updated_at?: string
        [key:string]:any
    }
    dataType?:'robot',
    wechatSuffix?: boolean
}

const ImLogByResponse: React.FC<Props> = ({
    response,
    dataType,
    wechatSuffix
}) => {
    const msgArr = useMemo(() => {
        return handleMessageData(response, dataType, wechatSuffix)
    },[response])
    const emptyFn = () => null;
    const chat: ComponentProps<typeof ImLog>['chat'] = {
        belong: '',
        platform: 'web'
    };
    return (
        <>
            {msgArr.map((i: any,idx) =>
                <ImLog onReEdit={emptyFn}
                    key={i.id}
                    allowAddToCustomerInfo={false}
                    allowAddToRobotKM={false}
                    allowAddToKM={false}
                    allowRecall={false}
                    allowReedit={false}
                    msgdisplayStatus={false}
                    chat={chat}
                    web_message_display_status={false}
                    enabledSmartAssistance={false}
                    msg={i as any}
                    allowSearchImRecord={false}
                    allowVoiceToText={false}
                    wechatSuffix={wechatSuffix}
                />
            )}
        </>
    );
}

export default ImLogByResponse;


