import * as React from 'react';
import { ListItemWrap, ListItemLeft, ListItemRight } from './components/ItemWrap';
import { Checkbox } from 'udesk-ui';

interface ListItemProps {
  item: any;
  checkedList: any[];
  handleSingleCheck: (item: any) => void;
  itemDisable?: (item: any) => boolean;
  children: any;
}

const ListItem = (props: ListItemProps) => {
  const { item, checkedList, handleSingleCheck, itemDisable } = props;
  return (
    <ListItemWrap>
      <ListItemLeft>
        <Checkbox
          value={item.id}
          disabled={!!itemDisable?.(item)}
          checked={checkedList?.some((el: any) => el?.id === item?.id)}
          onChange={handleSingleCheck.bind(null, item)}
        />
      </ListItemLeft>
      <ListItemRight>
        {React.Children.map(props.children, (child) => {
          return React.cloneElement(child);
        })}
      </ListItemRight>
    </ListItemWrap>
  );
};

export default ListItem;
