const log = require('npmlog');
const { requireOptions } = require('./require-options');
const utils = require('./utils/option-utils');

// log.addLevel('success', 1, {
//     fg: 'green'
// })
function getOption() {
    return Object.assign(utils.formatOptions(requireOptions() || {}));
}
module.exports = {
    info(msg, prefix = '') {
        const options = getOption();

        if (options.showLog !== false) {
            log.info(prefix, msg);
        }
    },
    showInfo(msg, prefix = '') {
        log.info(prefix, msg);
    },
    debug(msg, prefix = '【debug】') {
        const options = getOption();

        if (options.showDebug) {
            log.info(prefix, msg);
        }
    },
    warn(msg, prefix = '') {
        const options = getOption();

        if (options.showLog !== false) {
            log.warn(prefix, msg);
        }
    },
    error(msg, prefix = '') {
        // if (options.showLog !== false) {
        log.error(prefix, msg);
        // }
    },
    success(msg, prefix = '') {
        const options = getOption();

        if (options.showLog !== false) {
            log.info(prefix, msg);
        }
    },
};
