const path = require('path');
const fs = require('fs');

let defaultOption = {};

function requireOptions(cusConfigPath) {
    const cwd = process.cwd();
    const optionPath = path.resolve(cwd, cusConfigPath || 'locales-tran.config.js');
    if (fs.existsSync(optionPath)) {
        const options = require(optionPath);
        // console.log('locales-tran.config: ', options);
        return { ...options, ...defaultOption };
    } else {
        return { ...defaultOption };
    }
}

function updateOption(options = {}) {
    defaultOption = { ...defaultOption, ...options };
}

// module.exports = requireOptions;
module.exports = {
    requireOptions,
    updateOption,
};
