import validators from '../../validators';
import converters from '../../converters';
// @ts-ignore
import CFITextBox from 'udesk-react/src/components/custom-filter-inputs/text-box';
// @ts-ignore
import DropDown from 'udesk-react/src/components/custom-filter-inputs/drop-down';
// @ts-ignore
import ReactPowerMultiSelect from 'udesk-react/src/components/custom-filter-inputs/react-power-multi-select';
// @ts-ignore
import AutoComplete from 'udesk-react/src/components/custom-filter-inputs/auto-complete';

function getComponentsConfigTable(locale: any) {
  return [
    {
      inputType: validators.validateInputTypes,
      operators: validators.validateOperators.bind(null, locale),
      component: validators.validateObject,
      attributes: validators.validateObject,
    },
    {
      inputType: converters.convertInputType,
      operators: converters.convertOperators.bind(null, locale),
      component: null,
      attributes: null,
    },
    {
      inputType: 'text',
      operators: [
        'equal',
        'notEqual',
        'contains',
        'not_contains',
        'any_equal',
        'any_not_equal',
        'contain_all',
        'not_contain_all',
      ],
      component: CFITextBox,
      attributes: {
        classNames: 'form-control',
      },
    },
    {
      inputType: 'text',
      operators: ['exist', 'not_exist'],
      component: null,
      attributes: {
        classNames: 'form-control',
      },
    },
    {
      inputType: 'dropDown',
      operators: ['equal', 'notEqual', 'contain_any', 'not_contain_any'],
      component: ReactPowerMultiSelect,
      attributes: {
        classNames: 'form-control km-customer-filter-multi-select',
      },
    },
    {
      inputType: 'dropDown',
      operators: ['belong', 'not_belong'],
      component: DropDown,
      attributes: {
        classNames: 'form-control km-customer-filter-select',
      },
    },
    {
      inputType: 'autoComplete',
      operators: ['belong', 'not_belong'],
      component: AutoComplete,
      attributes: {},
    },
    {
      inputType: 'emotionCategoryDropDown',
      operators: ['is', 'not'],
      component: DropDown,
      attributes: {
        classNames: 'form-control km-customer-filter-select',
      },
    },
  ];
}

export default getComponentsConfigTable;
