// @ts-ignore
import Udesk from 'udesk-react/src/udesk';
import { inputTypes, getFieldOperators } from '../../../constant';

const exportObj = {
  validateString,
  validateInputTypes,
  validateOperators,
  validateObject,
  validateFunction,
  validateFunctionNullable,
};

export default exportObj;

function validateString(value: any) {
  if (typeof value !== 'string') {
    return 'value must be string';
  }
  return true;
}

function validateInputTypes(value: any) {
  return validateEnum(value, inputTypes, 'inputTypes');
}

function validateOperators(locale: any, value: any) {
  return validateEnumArray(value, getFieldOperators(locale), 'fieldOperators');
}

function validateObject(value: any) {
  if (value != null && typeof value !== 'object') {
    return 'value must be POJO';
  }
  return true;
}

function validateFunction(value: any) {
  if (typeof value !== 'function') {
    return 'value must be function';
  }
  return true;
}

function validateFunctionNullable(value: any) {
  if (value != null && typeof value !== 'function') {
    return 'value must be function';
  }
  return true;
}

function validateEnum(value: any, enumType: any, enumTypeName: any) {
  if (
    !(value instanceof Udesk.enums.EnumItemClass) &&
    enumType[value] == null &&
    enumType.get(value) == null
  ) {
    return `value (${value}) must be enum type (${enumTypeName})`;
  }
  return true;
}

function validateEnumArray(value: any, enumType: any, enumTypeName: any) {
  if (!(value instanceof Array)) {
    return 'value must be array';
  }
  for (var item of value) {
    var result = validateEnum(item, enumType, enumTypeName);
    if (result !== true) {
      return result;
    }
  }
  return true;
}
