import * as React from 'react';
// @ts-ignore
import { CustomFilter } from 'udesk_gm_ui';
// @ts-ignore
import { useLocaleReceiver } from '../../../locale-provider/LocaleReceiver';
import { getNodeComponentSettings, getNodeFieldsConfig } from './fields';

interface customLogicFilterProps {
  value?: any;
  onChange?: (value: any) => void;
  blackList: any[];
  extraList: any[];
}

function CustomLogicFilter({
  value,
  onChange,
  blackList = [],
  extraList = [],
}: customLogicFilterProps) {
  const [contextLocale] = useLocaleReceiver('RulesConfig');

  const onFilterChange = (value: any[]) => {
    onChange?.(value || []);
  };
  return (
    <CustomFilter
      theme="bootstrap"
      showConditionNumber={true}
      conditionFieldColumnHeader={contextLocale.lang.field}
      conditionOperatorColumnHeader={contextLocale.lang.operator}
      conditionValueColumnHeader={contextLocale.lang.value}
      conditionFieldField="field"
      conditionValueField="value"
      // fields不能提取出来放到setState中，因为过滤器中间中使用的promise，初始值[]会影响后续值的更新
      // 配置左侧筛选项
      fields={
        getNodeFieldsConfig('trigger', 'manyAnswer', blackList, extraList, contextLocale) || []
      }
      // 配置右侧组件
      fieldValueSettings={getNodeComponentSettings('trigger', 'manyAnswer', contextLocale)}
      value={value}
      onChange={onFilterChange}
    />
  );
}

export default CustomLogicFilter;
