// @ts-ignore
import Udesk from 'udesk-react/src/udesk';

export const inputTypes = new Udesk.enums.EnumClass([
  { id: 'text', key: 'text' },
  { id: 'number', key: 'number' },
  { id: 'doubleText', key: 'doubleText' },
  { id: 'textArea', key: 'textArea' },
  { id: 'dropDown', key: 'dropDown' },
  { id: 'datePicker', key: 'datePicker' },
  { id: 'time', key: 'time' },
  { id: 'dateTimePicker', key: 'dateTimePicker' },
  { id: 'dateRange', key: 'dateRange' },
  { id: 'integerNumber', key: 'integerNumber' },
  { id: 'floatNumber', key: 'floatNumber' },
  { id: 'autoComplete', key: 'autoComplete' },
  { id: 'noValue', key: 'noValue' },
  { id: 'autoCompleteInput', key: 'autoCompleteInput' },
  { id: 'emotionCategoryDropDown', key: 'emotionCategoryDropDown' },
]);

export const getFieldOperators = (locale: any) => {
  const lang = locale.lang;
  let fieldOperators = new Udesk.enums.EnumClass([
    /*jshint camelcase:false*/
    { id: 'exist', name: () => lang.customFilters.fieldOperators.exist, key: 'exist' },
    { id: 'not_exist', name: () => lang.customFilters.fieldOperators.not_exist, key: 'not_exist' },
    { id: 'is', name: () => lang.customFilters.fieldOperators.is, key: 'is' },
    { id: 'not', name: () => lang.customFilters.fieldOperators.not, key: 'not' },
    { id: 'is', name: () => lang.customFilters.fieldOperators.equal, key: 'equal' },
    { id: 'is_express', name: () => lang.customFilters.fieldOperators.isExpress, key: 'isExpress' },
    { id: 'not', name: () => lang.customFilters.fieldOperators.notEqual, key: 'notEqual' },
    { id: 'any_equal', name: () => lang.customFilters.fieldOperators.any_equal, key: 'any_equal' },
    {
      id: 'any_not_equal',
      name: () => lang.customFilters.fieldOperators.any_not_equal,
      key: 'any_not_equal',
    },
    { id: 'any_match', name: () => lang.customFilters.fieldOperators.any_equal, key: 'any_match' },
    {
      id: 'none_match',
      name: () => lang.customFilters.fieldOperators.any_not_equal,
      key: 'none_match',
    },
    { id: 'contains', name: () => lang.customFilters.fieldOperators.contains, key: 'contains' },
    {
      id: 'not_contains',
      name: () => lang.customFilters.fieldOperators.notContains,
      key: 'not_contains',
    },
    {
      id: 'contains_any',
      name: () => lang.customFilters.fieldOperators.containsAny,
      key: 'contains_any',
    },
    {
      id: 'not_contains_any',
      name: () => lang.customFilters.fieldOperators.notContainsAny,
      key: 'not_contains_any',
    },
    {
      id: 'included_any',
      name: () => lang.customFilters.fieldOperators.containsAny,
      key: 'included_any',
    },
    {
      id: 'excluded_any',
      name: () => lang.customFilters.fieldOperators.notContainsAny,
      key: 'excluded_any',
    },
    {
      id: 'contains_all',
      name: () => lang.customFilters.fieldOperators.containsAll,
      key: 'contains_all',
    },
    {
      id: 'not_contains_all',
      name: () => lang.customFilters.fieldOperators.notContainsAll,
      key: 'not_contains_all',
    },
    {
      id: 'included_all',
      name: () => lang.customFilters.fieldOperators.containsAll,
      key: 'included_all',
    },
    {
      id: 'excluded_all',
      name: () => lang.customFilters.fieldOperators.notContainsAll,
      key: 'excluded_all',
    },
    { id: 'is_null', name: () => lang.customFilters.fieldOperators.isNull, key: 'is_null' },
    {
      id: 'is_not_null',
      name: () => lang.customFilters.fieldOperators.isNotNull,
      key: 'is_not_null',
    },
    {
      id: 'greater_than',
      name: () => lang.customFilters.fieldOperators.greaterThan,
      key: 'greater_than',
    },
    {
      id: 'greater_than_eq',
      name: () => lang.customFilters.fieldOperators.greaterThanEq,
      key: 'greater_than_eq',
    },
    { id: 'less_than', name: () => lang.customFilters.fieldOperators.lessThan, key: 'less_than' },
    {
      id: 'less_than_eq',
      name: () => lang.customFilters.fieldOperators.lessThanEq,
      key: 'less_than_eq',
    },
    { id: 'between', name: () => lang.customFilters.fieldOperators.between, key: 'between' },
    {
      id: 'not_between',
      name: () => lang.customFilters.fieldOperators.notBetween,
      key: 'not_between',
    },
    { id: 'relative', name: () => lang.customFilters.fieldOperators.relative, key: 'relative' },
    { id: 'set', name: () => lang.customFilters.fieldOperators.set, key: 'set' },
    {
      id: 'customBelong',
      name: () => lang.customFilters.fieldOperators.customBelong,
      key: 'customBelong',
    },
    {
      id: 'customNotBelong',
      name: () => lang.customFilters.fieldOperators.customNotBelong,
      key: 'customNotBelong',
    },
    { id: 'belongs', name: () => lang.customFilters.fieldOperators.belongs, key: 'belongs' },
    {
      id: 'not_belongs',
      name: () => lang.customFilters.fieldOperators.notBelongs,
      key: 'notBelongs',
    },
    {
      id: 'custom_belong',
      name: () => lang.customFilters.fieldOperators.belongs,
      key: 'custom_belong',
    },
    {
      id: 'custom_not_belong',
      name: () => lang.customFilters.fieldOperators.notBelongs,
      key: 'custom_not_belong',
    },
    { id: 'today', name: () => lang.customFilters.fieldOperators.today, key: 'today' },
    { id: 'yesterday', name: () => lang.customFilters.fieldOperators.yesterday, key: 'yesterday' },
    { id: 'tomorrow', name: () => lang.customFilters.fieldOperators.tomorrow, key: 'tomorrow' },
    {
      id: 'next_seven_day',
      name: () => lang.customFilters.fieldOperators.next_seven_day,
      key: 'next_seven_day',
    },
    {
      id: 'last_seven_day',
      name: () => lang.customFilters.fieldOperators.last_seven_day,
      key: 'last_seven_day',
    },
    { id: 'this_week', name: () => lang.customFilters.fieldOperators.this_week, key: 'this_week' },
    { id: 'next_week', name: () => lang.customFilters.fieldOperators.next_week, key: 'next_week' },
    { id: 'last_week', name: () => lang.customFilters.fieldOperators.last_week, key: 'last_week' },
    {
      id: 'this_month',
      name: () => lang.customFilters.fieldOperators.this_month,
      key: 'this_month',
    },
    {
      id: 'next_month',
      name: () => lang.customFilters.fieldOperators.next_month,
      key: 'next_month',
    },
    {
      id: 'last_month',
      name: () => lang.customFilters.fieldOperators.last_month,
      key: 'last_month',
    },
    { id: 'this_year', name: () => lang.customFilters.fieldOperators.this_year, key: 'this_year' },
    { id: 'next_year', name: () => lang.customFilters.fieldOperators.next_year, key: 'next_year' },
    { id: 'last_year', name: () => lang.customFilters.fieldOperators.last_year, key: 'last_year' },
    {
      id: 'exact_match',
      name: () => lang.customFilters.fieldOperators.exact_match,
      key: 'exact_match',
    },
    { id: 'add_value', name: () => lang.customFilters.fieldOperators.add_value, key: 'add_value' },
    {
      id: 'remove_value',
      name: () => lang.customFilters.fieldOperators.remove_value,
      key: 'remove_value',
    },
    { id: 'set_null', name: () => lang.customFilters.fieldOperators.set_null, key: 'set_null' },
    { id: 'is_any', name: () => lang.customFilters.fieldOperators.is_any, key: 'is_any' },
    { id: 'not_any', name: () => lang.customFilters.fieldOperators.not_any, key: 'not_any' },
    {
      id: 'containsSensitive',
      name: () => lang.customFilters.fieldOperators.containsSensitive,
      key: 'containsSensitive',
    },
    {
      id: 'contain_any',
      name: () => lang.customFilters.fieldOperators.contain_any,
      key: 'contain_any',
    },
    {
      id: 'not_contain_any',
      name: () => lang.customFilters.fieldOperators.not_contain_any,
      key: 'not_contain_any',
    },
    {
      id: 'contain_all',
      name: () => lang.customFilters.fieldOperators.contain_all,
      key: 'contain_all',
    },
    {
      id: 'not_contain_all',
      name: () => lang.customFilters.fieldOperators.not_contain_all,
      key: 'not_contain_all',
    },
    { id: 'belong', name: () => lang.customFilters.fieldOperators.belong, key: 'belong' },
    {
      id: 'not_belong',
      name: () => lang.customFilters.fieldOperators.not_belong,
      key: 'not_belong',
    },
  ]);
  return fieldOperators;
};

export const getConfigRuleTypes = (locale: any) => {
  const lang = locale.lang;
  let configRuleTypes = new Udesk.enums.EnumClass([
    {
      id: 'platform',
      key: 'platform',
      name: () => lang.configRuleTypes.platform,
    },
    {
      id: 'src',
      key: 'src',
      name: () => lang.configRuleTypes.src,
    },
    {
      id: 'srcUrl',
      key: 'srcUrl',
      name: () => lang.configRuleTypes.srcUrl,
    },
    {
      id: 'webPluginName',
      key: 'webPluginName',
      name: () => lang.configRuleTypes.webPluginName,
    },
    {
      id: 'loginUrl',
      key: 'loginUrl',
      name: () => lang.configRuleTypes.loginUrl,
    },
    {
      id: 'sessionUrl',
      key: 'sessionUrl',
      name: () => lang.configRuleTypes.sessionUrl,
    },
    {
      id: 'dialogueDesc',
      key: 'dialogueDesc',
      name: () => lang.configRuleTypes.dialogueDesc,
    },
    {
      id: 'tags',
      key: 'tags',
      name: () => lang.configRuleTypes.tags,
    },
    {
      id: 'currentTime',
      key: 'currentTime',
      name: () => lang.configRuleTypes.currentTime,
    },
    {
      id: 'orderReply',
      key: 'orderReply',
      name: () => lang.configRuleTypes.orderReply,
    },
    {
      id: 'keyword',
      key: 'keyword',
      name: () => lang.configRuleTypes.keyword,
    },
    {
      id: 'emotionCategory',
      key: 'emotionCategory',
      name: () => lang.configRuleTypes.emotionCategory,
    },
    {
      id: 'queryContent',
      key: 'queryContent',
      name: () => lang.configRuleTypes.queryContent,
    },
  ]);
  return configRuleTypes;
};

export const getManyAnswerEmotionCategory = (locale: any) => {
  const lang = locale.lang;
  let manyAnswerEmotionCategory = new Udesk.enums.EnumClass([
    {
      id: 'OPTIMISTIC',
      key: 'positive',
      name: () => lang.emotionCategory.positive,
    },
    {
      id: 'NEUTRAL',
      key: 'neutral',
      name: () => lang.emotionCategory.neutral,
    },
    {
      id: 'PESSIMISTIC',
      key: 'negative',
      name: () => lang.emotionCategory.negative,
    },
  ]);
  return manyAnswerEmotionCategory;
};

export const getJudgmentLogicTypes = (locale: any) => {
  const lang = locale.lang;

  let judgmentLogicTypes = new Udesk.enums.EnumClass([
    {
      id: 1,
      key: 'meetAll',
      name: () => lang.judgmentLogicTypes.meetAll,
    },
    {
      id: 2,
      key: 'meetAny',
      name: () => lang.judgmentLogicTypes.meetAny,
    },
    {
      id: 3,
      key: 'custom',
      name: () => lang.judgmentLogicTypes.custom,
    },
  ]);
  return judgmentLogicTypes;
};

export const getManyAnswerChannelTypes = (locale: any) => {
  const lang = locale.lang;
  let manyAnswerChannelTypes = new Udesk.enums.EnumClass([
    {
      id: 'testWindow',
      key: 'testWindow',
      name: () => lang.channelTypes.testWindow,
    },
    {
      id: 'web',
      key: 'web',
      name: () => lang.channelTypes.web,
    },
    {
      id: 'wechat,微信',
      key: 'WEChat',
      name: () => lang.channelTypes.WEChat,
    },
    {
      id: 'android',
      key: 'android',
      name: () => lang.channelTypes.android,
    },
    {
      id: 'ios',
      key: 'ios',
      name: () => lang.channelTypes.ios,
    },
    {
      id: 'weibo',
      key: 'weibo',
      name: () => lang.channelTypes.weibo,
    },
    {
      id: 'api',
      key: 'api',
      name: () => lang.channelTypes.api,
    },
    {
      id: 'mchat',
      key: 'mchat',
      name: () => lang.channelTypes.mchat,
    },
    {
      id: 'weixin_mini',
      key: 'WeChatSmallProgram',
      name: () => lang.channelTypes.WeChatSmallProgram,
    },
    {
      id: 'qywx',
      key: 'enterpriseWechat',
      name: () => lang.channelTypes.enterpriseWechat,
    },
    {
      id: 'baidu',
      key: 'baidu',
      name: () => lang.channelTypes.baidu,
    },
    {
      id: 'facebook',
      key: 'facebook',
      name: () => lang.channelTypes.facebook,
    },
    {
      id: 'line',
      key: 'line',
      name: () => lang.channelTypes.line,
    },
    {
      id: 'whats_app',
      key: 'whatsApp',
      name: () => lang.channelTypes.whatsApp,
    },
    {
      id: 'twitter',
      key: 'twitter',
      name: () => lang.channelTypes.twitter,
    },
    {
      id: 'tiktok',
      key: 'tiktok',
      name: () => lang.channelTypes.tiktok,
    },
    {
      id: 'weixin_kf',
      key: 'weChatService',
      name: () => lang.channelTypes.weChatService,
    },
    {
      id: 'meituan_waimai',
      key: 'meituan',
      name: () => lang.channelTypes.meituan,
    },
    {
      id: 'eleme_waimai',
      key: 'eleme',
      name: () => lang.channelTypes.eleme,
    },
  ]);
  return manyAnswerChannelTypes;
};

const exportObj = {
  inputTypes,
  getFieldOperators,
  getManyAnswerEmotionCategory,
  getJudgmentLogicTypes,
  getManyAnswerChannelTypes,
};

export default exportObj;
