## rules-config

#### Demo

```tsx
import React from 'react';
import { useRef, useState } from 'react';
import { RulesConfig } from 'udesk_gm_ui';

const defaultData = {
  name: 'w34t',
  tagValueLists: [
    {
      field: 'platform',
      operator: 'is',
      value: 'wechat,微信',
    },
    {
      field: 'srcUrl',
      operator: 'is',
      value: 'w4tw34tw',
    },
  ],
  judgmentLogic: 1,
  tag: '(1 and 2)',
};

export default () => {
  const ref = useRef();
  const [value, setValue] = useState(defaultData);

  const handleReset = () => {
    ref?.current?.reset();
  };
  const handleSubmit = () => {
    ref?.current?.submit();
  };

  const handleChange = (allValues, changedValues) => {
    console.log({ changedValues, allValues });
    setValue(allValues);
  };

  const handleFinish = (values) => {
    console.log({ values }, 'handleFinish');
    setValue(values);
  };

  return (
    <div style={{ background: '#fff', borderRadius: '4px', padding: 12 }}>
      <span
        style={{
          display: 'inline-block',
          padding: '6px 12px',
          cursor: 'pointer',
          background: '#1A6EFF',
          margin: '0 0 12px',
        }}
        onClick={handleReset}
      >
        reset button
      </span>
      <span
        style={{
          display: 'inline-block',
          padding: '6px 12px',
          cursor: 'pointer',
          background: '#1A6EFF',
          margin: '0 0 12px 12px',
        }}
        onClick={handleSubmit}
      >
        submit button
      </span>
      <RulesConfig
        ref={ref}
        value={value}
        onChange={handleChange}
        onFinish={handleFinish}
      ></RulesConfig>;
    </div>
  );
};
```

api

```ts
//组件默认key;
type defauleFormKeysType = {
  nameKey: string;
  tagValueListsKey: any[]; //详情见udesk-react中的数据格式
  judgmentLogicKey: string;
  tagKey: string;
};
const defauleFormKeys = {
  nameKey: 'name',
  tagValueListsKey: 'tagValueLists',
  judgmentLogicKey: 'judgmentLogic',
  tagKey: 'tag',
};
```

| 参数 | 说明 | 类型 | 默认值 | 版本 |
| --- | --- | --- | --- | --- |
| value | 选中项 | object:defauleFormKeysType | - |  |
| onChange | 返回选中项,未经过验证机制处理的数据 | function(allValue:defauleFormKeysType){} | - |  |
| onFinish | 返回 km 业务端数据需要的 | function(values:any){} |  |  |

## RulesConfigInstance

| 参数   | 说明         | 类型       | 默认值 | 版本 |
| ------ | ------------ | ---------- | ------ | ---- |
| reset  | 重置所有设置 | () => void | -      |      |
| submit | 触发验证     |            |        |      |
