import MultipleSyncFileLoaderBaseClass from "./multiple-sync-file-loader-base-service";

let _isFirstLoading = true;
let _isMapLoaded = false;
let _delayedCallbackes = [];

class GaodeMapLoaderClass extends MultipleSyncFileLoaderBaseClass {
    loadAsync(callback) {
        if (_isMapLoaded) {
            callback();
        } else {
            if (typeof callback === "function") {
                _delayedCallbackes.push(callback);
            }

            if (_isFirstLoading) {
                _isFirstLoading = true;
                let aAmapCustomUiScript = document.createElement("script");
                window.__amapInitializer__ = () => {
                    aAmapCustomUiScript.type = "text/javascript";
                    aAmapCustomUiScript.async = true;
                    aAmapCustomUiScript.src = "//webapi.amap.com/ui/1.0/main.js?v=1.0.11";
                    document.getElementsByTagName("head")[0].appendChild(aAmapCustomUiScript);
                    aAmapCustomUiScript.onload = function () {
                        loadedCallback();
                    };
                };

                let aAmapScript = document.createElement("script");
                aAmapScript.type = "text/javascript";
                aAmapScript.async = true;
                aAmapScript.src = "//webapi.amap.com/maps?v=1.4.2&key=b19547d82d0e5174c6727a627598c193&plugin=AMap.Autocomplete,AMap.GeoJSON,AMap.Polygon,AMap.MouseTool,AMap.PlaceSearch,AMap.Geocoder,AMap.Geolocation&callback=__amapInitializer__";

                document.getElementsByTagName("head")[0].appendChild(aAmapScript);
            }
        }
    }
}

export default new GaodeMapLoaderClass();

function loadedCallback() {
    for (let func of _delayedCallbackes) {
        func();
    }
    _delayedCallbackes = [];
}
