import MultipleSyncFileLoaderBaseClass from "./multiple-sync-file-loader-base-service";

let _loadedModules = new Map();

class GaodeModuleLoaderClass extends MultipleSyncFileLoaderBaseClass {
    loadAsync(moduleNames, callback) {
        if (window.AMapUI == null) {
            throw new Error(`Gaode Map must be loaded before loading its modules.`);
        }
        if (typeof callback !== "function") {
            throw new Error(`argument 'callback' must be a function.`);
        }
        if (!Array.isArray(moduleNames) || moduleNames.length === 0) {
            callback(null);
        }

        let mainModuleName = moduleNames[0];
        if (_loadedModules.has(mainModuleName)) {
            callback.apply(undefined, _loadedModules.get(mainModuleName));
        } else {
            window.AMapUI.load(moduleNames, function () {
                _loadedModules.set(mainModuleName, arguments);
                callback.apply(undefined, arguments);
            });
        }
    }

    destroy(moduleName) {
        _loadedModules.delete(moduleName);
    }
}

export default new GaodeModuleLoaderClass();

