import styled from 'styled-components';
import { TableWrapProps, ToolbarProps } from '../types';

export const Layout = styled.div`
  display: flex;
  flex-direction: column;
  height: 100%;
`;
export const FilterWrap = styled.div`
  margin-bottom: 12px;
`;
export const RowSelectionInfo = styled.div`
  span {
    color: rgba(44, 124, 246, 1);
  }
`;
export const TableWrap = styled.div<TableWrapProps>`
  padding: ${(props) => (typeof props.padding === 'number' ? props.padding + 'px' : props.padding)};
  background-color: #fff;
  flex: 1;
  overflow: hidden;
  display: flex;
  ${(props) => `.${props.prefixCls}-pagination`} {
    margin-bottom: 0;
  }
`;
export const ClassificationWrap = styled.div`
  display: flex;
  flex-direction: column;
  padding: 0 8px;
  margin-right: 16px;
  border-right: 1px solid rgba(0, 0, 0, 0.1);
  background-color: #fff;
  width: 320px;
  @media (max-width: 1440px) {
    width: 240px;
  }
  overflow-x: hidden;
`;

export const Toolbar = styled.div<ToolbarProps>`
  margin-bottom: 16px;
  /* justify-content: flex-end; */
  display: ${(props) => (props.visible ? 'flex' : 'none')};
  button {
    color: rgba(0, 0, 0, 0.65);
  }
  .${(props) => props.prefixCls}-btn-primary {
    color: #fff;
  }
  .${(props) => props.prefixCls}-btn-link {
    color: #1b6dff;
  }
`;
