/**
 * 客户自定义配置数据
 */

import { createSlice } from "@reduxjs/toolkit";
import merge from "lodash-es/merge";
import { AppThunk } from "../store";
import { csApiGetJSON } from "../../utils/csApi";

const { actions, reducer } = createSlice({
  name: "agentConfig",
  initialState: {} as IAgentConfig,
  reducers: {
    setAgentConfig(state, action) {
      return action.payload;
    },
    updateAgentConfig(state, action) {
      return merge(state, action.payload);
    },
  },
});

export const { setAgentConfig, updateAgentConfig } = actions;
export default reducer;
export const getAgentConfig = (): AppThunk => async (dispatch) => {
  try {
    csApiGetJSON("/cs/im/agent/im/agent_config")
    .then(res=>res.data)
    .then((response) => {
      dispatch(setAgentConfig(response.data));
    });
  } catch (err) {
    console.log("error");
  }
};
