import { createSlice } from '@reduxjs/toolkit';
import merge from 'lodash-es/merge';

const {actions, reducer} = createSlice({
    name: 'visitor',
    initialState: [] as IVisitor[],
    reducers: {
        addVisitor(state, action) {
            const chat = action.payload;
            const index = state.findIndex((item) => item.key === chat.key);
            if (index !== -1) {
                return [chat, ...state.slice(0, index), ...state.slice(index + 1)];
            } else {
                return [chat, ...state];
            }
        },
        deleteVisitor(state, action) {
            const customer = action.payload;
            const index = state.findIndex((item) => item.key === customer.key);
            if (index !== -1) {
                return [...state.slice(0, index), ...state.slice(index + 1)];
            } else {
                return state;
            }
        },
        updateVisitor(state, action) {
            const customer = action.payload;
            const index = state.findIndex((item) => item.key === customer.key);
            if (index !== -1) {
                merge(state[index], customer);
                return [...state];
            } else {
                return state;
            }
        }
    }
});

export const {addVisitor, deleteVisitor, updateVisitor} = actions;
export default reducer;
