import { combineReducers } from "@reduxjs/toolkit";

import agentConfigReducer from "./agent-config";
import fieldsReducer from "./fields";
import companyReducer from "./company";
import roleCanReducer from "./role-can";
import currentUserReducer from "./current-user";
import setNoteTemplateConfigReducer from "./note-templates";
import initDataReducer from "./init-data";
import agentsReducer from "./agents";
import groupsReducer from "./groups";
import imUrlsReducer from "./urls";
import platformReducer from "./platform";

export const rootReducer = combineReducers({
  agentConfig: agentConfigReducer,
  fields: fieldsReducer,
  company: companyReducer,
  roleCan: roleCanReducer,
  currentUser: currentUserReducer,
  noteTemplateConfig: setNoteTemplateConfigReducer,
  initData: initDataReducer,
  agents: agentsReducer,
  groups: groupsReducer,
  urls: imUrlsReducer,
  platforms: platformReducer,
});
export type RootState = ReturnType<typeof rootReducer>;
