import { css } from '@emotion/react';

export default css`
    .control-content{
        display: flex;
        padding: 15px;
        padding-bottom: 0;
        border-top: 1px solid #e1e1e1;
        border-bottom: 1px solid #e1e1e1;
        .left-panel,.right-panel {
            flex-direction: column;
        }
        .left-panel {
            .select-wrapper {
                position: relative;
                .select {
                    position: absolute;
                    top: 33px;
                }
            }
        }
        .right-panel {
            display: flex;
            width: 230px;
            .select-wrapper {
                flex-grow: 1;
                display: flex;
                .select {
                    flex-grow: 1;
                }
            }
        }
        .title {
            margin-bottom: 5px;
            .set-to-default {
                cursor: pointer;
                user-select: none;
                float: right;
            }
            > h4 {
                font-size: 14px;
                font-weight: normal;
                margin: 0;
                display: inline-block;
                margin-right: 15px;
            }
            &:after {
                content: '';
                display: block;
                clear: both;
            }
        }
        .select-wrapper {
            align-self: stretch;
            display: flex;
            flex-direction: column;
            align-items: stretch;
            min-width: 150px;
            .select{
                width: 100%;
                overflow: auto;
                font-size: 14px;
                border-color: #ccc;
                height: 200px;
                position: relative;
                outline: none;
                padding-top: 4px;
                padding-left: 8px;
                min-width: 150px;
            }
            .search-wrapper {
                position: relative;
                input {
                    width: 100%;
                    box-sizing: border-box;
                    font-size: 14px;
                    line-height: 24px;
                    padding: 0 16px 0 8px;
                    border: 1px solid #ccc;
                    border-bottom: none;
                }
                input:focus {
                    outline: none;
                }
                .search-icon {
                    position: absolute;
                    top: 8px;
                    right: 8px;
                }
            }
            .sort-btn-wrapper {
                border: 1px solid #ccc;
                border-bottom: 0;
                display: flex;
                padding: 0 10px;
                button {
                    font-size: 14px;
                    border: 0;
                    background-color: transparent;
                    color: #888;
                    height: 25px;
                    width: 25px;
                    padding: 0;
                    margin-right: 3px;
                }
            }
        }
        .mid-panel {
            padding: 0 10px;
            display: flex;
            flex-direction: column;
            align-items: center;
            justify-content: center;
            button {
                border: 0;
                background-color: transparent;
                font-size: 26px;
                margin: 10px 0;
            }
        }
        .category-tab{
            list-style-type: none;
            margin: 0;
            padding: 0;
            display: flex;
            border: 1px solid #ddd;
            border-bottom: none;
            li {
                flex: 1;
                padding: 5px 10px;
                font-size: 14px;
                cursor: pointer;
                border-color: transparent;
                border-width: 1px 1px 0;
                border-style: solid;
                white-space: nowrap;
                border-right: 1px solid #ddd !important;
                &.active {
                    background-color: transparent;
                    color: #00b38b;
                }
            }

            li:last-child {
                border-right: none;
            }
        }
    }
    .bottom-bar {
        text-align: right;
        padding: 12px 0;
        button {
            margin-right: 15px;
        }
    }
    .dnd-select {
        width: 100%;
        overflow: auto;
        font-size: 14px;
        height: 266px;
        position: relative;
        border: 1px solid #ccc;
        padding-left: 8px;

        dnd-item {
            padding-left: 4px;
        }

        .item.active {
            background: #ddd;
        }
    }

    .custom-scroller {
        ::-webkit-scrollbar {
            width: 7px;
            height: 7px;
        }
    
        ::-webkit-scrollbar-track {
            background-color: #f5f5f5;
            border-radius: 5px;
            -webkit-box-shadow: inset 0 0 3px rgba(0, 0, 0, 0.1);
        }
    
        ::-webkit-scrollbar-thumb {
            background-color: rgba(0, 0, 0, 0.2);
            border-radius: 5px;
        }
    
        ::-webkit-scrollbar-thumb:hover {
            background-color: rgba(0, 0, 0, 0.3);
            -webkit-box-shadow: unset;
        }
    }

    .control-header {
        padding: 12px;
        font-size: 14px;
        font-weight: bold;
    }
`;

export const popper = css`
    background-color: #fff;
    border: 1px solid #e1e1e1;
    box-shadow: rgb(0 0 0 / 5%) 1px 1px 1px 0px;
    text-align: left;
`;
