import i18next from '../i18n';

export const originalOptions = [
    {
        value: 'zh-cn',
        label: i18next.t('language.chinese'),
    },
    {
        value: 'auto',
        label: 'Auto',
    },
];

export enum originalMap {
    ZhCn = 'zh-cn',
    EnUs = 'en-us',
    Auto = 'auto'
}

export const translateOptions = [
    {label: i18next.t('language.zh-cn'), value:'zh-cn'},
    {label: i18next.t('language.zh-tw'), value:'zh-tw'},
    {label: i18next.t('language.en-us'), value:'en-us'},
    {label: i18next.t('language.fr'), value:'fr'},
    {label: i18next.t('language.de'), value:'de'},
    {label: i18next.t('language.fil'), value:'fil'},
    {label: i18next.t('language.ja'), value:'ja'},
    {label: i18next.t('language.it'), value:'it'},
    {label: i18next.t('language.ru'), value:'ru'},
    {label: i18next.t('language.ko'), value:'ko'},
    {label: i18next.t('language.vi'), value:'vi'},
    {label: i18next.t('language.af'), value:'af'},
    {label: i18next.t('language.sq'), value:'sq'},
    {label: i18next.t('language.am'), value:'am'},
    {label: i18next.t('language.ar'), value:'ar'},
    {label: i18next.t('language.hy'), value:'hy'},
    {label: i18next.t('language.as'), value:'as'},
    {label: i18next.t('language.ay'), value:'ay'},
    {label: i18next.t('language.az'), value:'az'},
    {label: i18next.t('language.bm'), value:'bm'},
    {label: i18next.t('language.eu'), value:'eu'},
    {label: i18next.t('language.be'), value:'be'},
    {label: i18next.t('language.bn'), value:'bn'},
    {label: i18next.t('language.bho'), value:'bho'},
    {label: i18next.t('language.bs'), value:'bs'},
    {label: i18next.t('language.bg'), value:'bg'},
    {label: i18next.t('language.ca'), value:'ca'},
    {label: i18next.t('language.ceb'), value:'ceb'},
    {label: i18next.t('language.co'), value:'co'},
    {label: i18next.t('language.hr'), value:'hr'},
    {label: i18next.t('language.cs'), value:'cs'},
    {label: i18next.t('language.da'), value:'da'},
    {label: i18next.t('language.dv'), value:'dv'},
    {label: i18next.t('language.doi'), value:'doi'},
    {label: i18next.t('language.nl'), value:'nl'},
    {label: i18next.t('language.eo'), value:'eo'},
    {label: i18next.t('language.et'), value:'et'},
    {label: i18next.t('language.ee'), value:'ee'},
    {label: i18next.t('language.fi'), value:'fi'},
    {label: i18next.t('language.fy'), value:'fy'},
    {label: i18next.t('language.gl'), value:'gl'},
    {label: i18next.t('language.ka'), value:'ka'},
    {label: i18next.t('language.el'), value:'el'},
    {label: i18next.t('language.gn'), value:'gn'},
    {label: i18next.t('language.gu'), value:'gu'},
    {label: i18next.t('language.ht'), value:'ht'},
    {label: i18next.t('language.ha'), value:'ha'},
    {label: i18next.t('language.haw'), value:'haw'},
    {label: i18next.t('language.he'), value:'he'},
    {label: i18next.t('language.hi'), value:'hi'},
    {label: i18next.t('language.hmn'), value:'hmn'},
    {label: i18next.t('language.hu'), value:'hu'},
    {label: i18next.t('language.is'), value:'is'},
    {label: i18next.t('language.ig'), value:'ig'},
    {label: i18next.t('language.ilo'), value:'ilo'},
    {label: i18next.t('language.id'), value:'id'},
    {label: i18next.t('language.ga'), value:'ga'},
    {label: i18next.t('language.jv'), value:'jv'},
    {label: i18next.t('language.kn'), value:'kn'},
    {label: i18next.t('language.kk'), value:'kk'},
    {label: i18next.t('language.km'), value:'km'},
    {label: i18next.t('language.rw'), value:'rw'},
    {label: i18next.t('language.gom'), value:'gom'},
    {label: i18next.t('language.kri'), value:'kri'},
    {label: i18next.t('language.ku'), value:'ku'},
    {label: i18next.t('language.ckb'), value:'ckb'},
    {label: i18next.t('language.ky'), value:'ky'},
    {label: i18next.t('language.lo'), value:'lo'},
    {label: i18next.t('language.la'), value:'la'},
    {label: i18next.t('language.lv'), value:'lv'},
    {label: i18next.t('language.ln'), value:'ln'},
    {label: i18next.t('language.lt'), value:'lt'},
    {label: i18next.t('language.lg'), value:'lg'},
    {label: i18next.t('language.lb'), value:'lb'},
    {label: i18next.t('language.mk'), value:'mk'},
    {label: i18next.t('language.mai'), value:'mai'},
    {label: i18next.t('language.mg'), value:'mg'},
    {label: i18next.t('language.ms'), value:'ms'},
    {label: i18next.t('language.ml'), value:'ml'},
    {label: i18next.t('language.mt'), value:'mt'},
    {label: i18next.t('language.mi'), value:'mi'},
    {label: i18next.t('language.mr'), value:'mr'},
    {label: i18next.t('language.mni-Mtei'), value:'mni-Mtei'},
    {label: i18next.t('language.mni-lus'), value:'lus'},
    {label: i18next.t('language.mn'), value:'mn'},
    {label: i18next.t('language.my'), value:'my'},
    {label: i18next.t('language.ne'), value:'ne'},
    {label: i18next.t('language.no'), value:'no'},
    {label: i18next.t('language.ny'), value:'ny'},
    {label: i18next.t('language.or'), value:'or'},
    {label: i18next.t('language.om'), value:'om'},
    {label: i18next.t('language.ps'), value:'ps'},
    {label: i18next.t('language.fa'), value:'fa'},
    {label: i18next.t('language.pl'), value:'pl'},
    {label: i18next.t('language.pt'), value:'pt'},
    {label: i18next.t('language.pa'), value:'pa'},
    {label: i18next.t('language.qu'), value:'qu'},
    {label: i18next.t('language.ro'), value:'ro'},
    {label: i18next.t('language.sm'), value:'sm'},
    {label: i18next.t('language.sa'), value:'sa'},
    {label: i18next.t('language.gd'), value:'gd'},
    {label: i18next.t('language.nso'), value:'nso'},
    {label: i18next.t('language.sr'), value:'sr'},
    {label: i18next.t('language.st'), value:'st'},
    {label: i18next.t('language.sn'), value:'sn'},
    {label: i18next.t('language.sd'), value:'sd'},
    {label: i18next.t('language.si'), value:'si'},
    {label: i18next.t('language.sk'), value:'sk'},
    {label: i18next.t('language.sl'), value:'sl'},
    {label: i18next.t('language.so'), value:'so'},
    {label: i18next.t('language.es'), value:'es'},
    {label: i18next.t('language.su'), value:'su'},
    {label: i18next.t('language.sw'), value:'sw'},
    {label: i18next.t('language.sv'), value:'sv'},
    {label: i18next.t('language.tl'), value:'tl'},
    {label: i18next.t('language.tg'), value:'tg'},
    {label: i18next.t('language.ta'), value:'ta'},
    {label: i18next.t('language.tt'), value:'tt'},
    {label: i18next.t('language.te'), value:'te'},
    {label: i18next.t('language.th'), value:'th'},
    {label: i18next.t('language.ti'), value:'ti'},
    {label: i18next.t('language.ts'), value:'ts'},
    {label: i18next.t('language.tr'), value:'tr'},
    {label: i18next.t('language.tk'), value:'tk'},
    {label: i18next.t('language.ak'), value:'ak'},
    {label: i18next.t('language.uk'), value:'uk'},
    {label: i18next.t('language.ur'), value:'ur'},
    {label: i18next.t('language.ug'), value:'ug'},
    {label: i18next.t('language.uz'), value:'uz'},
    {label: i18next.t('language.cy'), value:'cy'},
    {label: i18next.t('language.xh'), value:'xh'},
    {label: i18next.t('language.yi'), value:'yi'},
    {label: i18next.t('language.yo'), value:'yo'},
    {label: i18next.t('language.zu'), value:'zu'}
];