import styled from 'styled-components';

interface TreeMenuWrapProps {
  prefixCls: string;
  switcherIconPosition: 'left' | 'right';
  indentUnitWidth: number;
}

const TreeMenuWrap = styled.div<TreeMenuWrapProps>`
  display: flex;
  flex-direction: column;
  overflow-y: auto;
  height: 100%;
  ${(props) => `.${props.prefixCls}-tree-node-content-wrapper {
    overflow-x: hidden;
    display: flex;
  }`}
  .${(props) => props.prefixCls}-tree-title {
    flex: 1;
    overflow: hidden;
  }
  ${(props) => `.${props.prefixCls}-tree-node-selected {
    .icon-EllipsisOutlined {
      color: #fff;
    }
    .${props.prefixCls}-tree-title {
        .switcher-icon-right {
            color: #fff;
        }
    }
  }`}
  ${(props) => `.${props.prefixCls}-tree-indent-unit {
    width: ${props.indentUnitWidth}px;
  }`}
  ${(props) =>
    props.switcherIconPosition === 'right'
      ? `.${props.prefixCls}-tree-treenode {
            .switcher-icon-right {
                display: inline-block;
                text-align: center;
                width: 24px;
                color: rgba(0, 0, 0, 0.35);
                svg {
                    transition: transform 0.3s;
                }
            }
            .${props.prefixCls}-tree-switcher {
                display: none;
            }
            .${props.prefixCls}-tree-node-content-wrapper-close {
                .switcher-icon-right {
                    svg {
                        transform: rotate(-180deg);
                    }
                }
            }
        }`
      : ''}
`;

export { TreeMenuWrap };
