import { TreeMenuProps, TreeNode } from '../types';

export default function filterTreeDataByKeyword(
  data: TreeNode[] = [],
  keyword: string = '',
  fieldNames?: TreeMenuProps['fieldNames'],
): TreeNode[] {
  let res: TreeNode[] = [];
  const { title = 'title', children = 'children' } = fieldNames || {};

  data.forEach((element) => {
    if (element[title].indexOf(keyword) > -1) {
      let childrenValue = filterTreeDataByKeyword(element[children], keyword, fieldNames);
      element = { ...element, [children]: childrenValue.length ? childrenValue : undefined };
      res.push(element);
    } else {
      if (element[children] && element[children].length > 0) {
        let arr = filterTreeDataByKeyword(element[children], keyword, fieldNames);

        if (arr && arr.length > 0) {
          let obj = {
            ...element,
            [children]: arr,
          };
          res.push(obj);
        }
      }
    }
  });
  return res;
}

function includeKeyword(node: TreeNode, keyword: string) {
  return node.title.includes(keyword);
}
// function walker(data: TreeNode[] = [], stack: any[]) {
//     data.forEach(item => {
//         stack.push(item);
//     });
// }
