type IMessage = {
    // 必须的属性
    isRobot?: boolean                            //  是否机器人消息
    type: IMessageType                          //  消息类型: 例如 'message' | 'rich' | 'audio' | 'video' ...
    id: string                                  //  消息id
    content: any                                //  消息内容, 可能是string, 也有可能是 json, ?例如卡片消息? 结构化消息?
    data: MessageData                           //  对象
    sender_name: string                         //  消息发送人, 可能为客服昵称/客户姓名/系统登
    platform: IPlatform                         //  消息渠道
    date: string                                //  消息展示时间
    is_save: boolean                            //  消息是否已保存
    is_receive: boolean                         //  消息是接收还是发送
    im_sub_session_id: number                   //  消息所属的会话id
    auto: boolean                               //  是否是自动消息
    sender: 'agent' | 'customer'                //  消息发送方
    agent_id: number | 'robot'                  //  消息客服方id
    customer_id: number                         //  消息客户方id
    agent_nick_name: string                     //  消息客服方昵称
    user_nick_name: string                      //  消息客服方昵称
    created_at: string                          //  消息创建时间
    created_time: number                        //  消息创建时间(时间戳形式)
    updated_at: string | number                        //  消息更新时间

    session_key?: string                        //  消息的session_key
    status?: string                             //  消息状态? system
    agent_avatar?: string                       //  消息客服方的头像
    content_type?: string                       //  含义未知
    duration?: string                           //  type为audio时,语音时长
    for_survey?: string                         //  含义未知
    is_repeat?: boolean                         //  消息是否重复

    is_welcome?: boolean                        //  是否是欢迎语

    // file相关
    filename?: string                            //  file消息, 文件名
    filesize?: string                            //  file消息, 文件大小
    fileext?: string                             //  file消息, 文件后缀
    file_policy?: string                         //  file消息, 文件上传时策略
    filetype?: string                            //  file消息, 文件类型

    // 机器人消息
    faviconUrl?: string                          // 机器人消息: 链接消息, 链接的网站图标
    title?: string                               // 机器人消息: 链接消息,链接的网站title
    answerUrl?: string                           // 机器人消息:
    cardList?: string                            // 机器人消息: 卡片消息, 卡片列表

    // 超时次数标识
    timeout_freq?: number                        // 客户超时消息, 超时次数
    timeout_auto_msg?: boolean                   // 客服超时消息

    // 对话结束语
    msg_close?: boolean                          // 是否是对话结束语


    version?: any
    monitor?: any                               //  同事消息标识
    inviter?: any                               //  三方会话标识
    invitation?: string                         //  三方会话: 主会话/辅助会话 标识
    _invitation?: boolean
    internal?: boolean
    push_type?: string                          //  推广消息标识
    send_status?: IMessageStatus                //  消息发送状态, 'arrive' | 'off_sending' | 'fail' | 'off_arrive' | 'rollback'...
    respone?: string                          //  消息失败时,是否显示失败内容, 通常在 微信/小程序 等发送失败的提示,eg: 发送消息超过下限, 客户已取消关注
    message_display_status?: string | undefined           //  消息展示状态   ’hide‘
    recognition?: string                        //  audio消息的文本翻译结果
    font?: string                               //  客服消息字体
    log_type?: string                           //  同事协助时, 标识是内部备注还是发送给客户的消息
    active_guest?: boolean                      //  是否客服主动发起的会话
    read_status?: boolean                       //  消息已读未读状态
    translation?: { content: string, from: string } //  工作台AI文本f
    rollback_at?: string | Date                 //  消息撤回时间
    form_id?: any                               //  表单id
    isReceived?: boolean                        //  是否收到客户端的回执
    msg_id?: number | string
    loadingText?: boolean
    whether_transcode?: boolean                 // 是否H265转码
    open_robot_recommends?: boolean
    recv_type?: 'fail' | 'arrive'
    percentage?: number
    content_raw?: string                        //  机器人消息会携带这个属性
    randomFileName?: string
    is_wechat_fail?: boolean                     //  微信渠道失败消息
    hideMsg?: boolean                            //是否显示此条消息
    transactionId?: string                       //发送消息事务id，用于获取事务
    responseId?:number | string                   // 原id由于进行过处理，没有值时会被赋值成跟msgid一样，做用id排序时很麻烦，所以加个参数，用来存后端返回的id
}