import {
    AES,
    EncUtf8,
    EncBase64,
    EncHex,
    ModeECB,
    PadPkcs7
} from '../../../udesk/ref-npm-modules/plugins/utils.crypto.aes';
import { installPlugin, globalInstall } from '../../plugin-base';

const PLUGIN_PATH = "utils.crypto.aes";
const PLUGIN = {
    encrypt,
    decrypt,
    AesECBDecrypt
};

export default function install(udesk) {
    installPlugin(udesk, PLUGIN_PATH, PLUGIN);
}
globalInstall(PLUGIN_PATH, PLUGIN);

function encrypt(content, secretKey) {
    return AES.encrypt(content, secretKey).toString()
}

function decrypt(ciphertext, secretKey) {
    let bytes = AES.decrypt(ciphertext, secretKey);
    return bytes.toString(EncUtf8);
}

function AesECBDecrypt(ciphertext, sha1SecretKey) {
    let encryptedHexStr = EncHex.parse(ciphertext);   // 从二进制文本转成二进制
    let messageBase64 = EncBase64.stringify(encryptedHexStr);    // 转成base64
    let decrypt = AES.decrypt(
        messageBase64,
        EncUtf8.parse(sha1SecretKey),
        {
            mode: ModeECB,
            padding: PadPkcs7
        }
    );
    return decrypt.toString(EncUtf8).toString();
}