import {
    sha256
} from '../../../udesk/ref-npm-modules/plugins/utils.crypto.sha-256';
import {
    hash,
    hmacHash,
    ShaHasher,
    stringify
} from './sha-256-core';
import { installPlugin, globalInstall } from '../../plugin-base';

const PLUGIN_PATH = "utils.crypto.sha224";
const PLUGIN = {
    hash,
    getHasher: getSha224Hasher,
    hmac: {
        hash: hmacHash,
        getHasher: getSha224HmacHasher,
    }
};
export default function install(udesk) {
    installPlugin(udesk, PLUGIN_PATH, PLUGIN);
}
globalInstall(PLUGIN_PATH, PLUGIN);

function getSha224Hasher() {
    return new ShaHasher(sha256.sha224.create());
}

function getSha224HmacHasher(key) {
    key = stringify(key);
    return new ShaHasher(sha256.sha224.hmac.create(key));
}
