export default {
    labels: {
        time: 'time',
        download: 'download',
        pleaseSelect: 'pleaseSelect',
        OK: 'confirm',
        save: 'save',
        cancel: 'cancel',
        loadModelError: 'Loading module data failed, please wait a moment and try again',
        colon: ': ',
        weak: 'weak',
        strong: 'strong',
        relevance: 'relevance',
        all: 'All'
    },
    business: {
        getReportDataFailed: 'Failed to obtain chart data. Please check the network connection or try again later'
    },
    validation: {
        requiredFormat: "{0} cannot be empty",
        required: "This item cannot be empty",
        wrongFormat: "{0} format error",
        mustSelectFormat: "Must choose a valid {0}",
        wrongDateFormat: "The date format is incorrect! Please fill in the format yyyy-mm-dd",
        numberOnly: "Please enter a number",
        numberInRange: "Please enter a number between {0} and {1}",
        currency: "Please enter a valid amount",
    },
    components: {
        reactEcharts: {
            mapLoading: 'Map Loading...',
            customScatterPie: {
                weak: 'Weak',
                relevance: 'Relevance',
                strong: 'Strong'
            }
        },
        reactTable: {
            noSorting: 'Unsorted',
            sortAsc: 'From small to large',
            sortDesc: 'From large to small',
            chooseColumns: 'Show or hide the columns of the table',
            batchActionLeft: 'chosen',
            batchActionRight: 'records'
        },
        reactAntdForm: {
            numberOfWord: 'words',
            pleaseInput: 'please input',
            pleaseSelect: 'please select',
            pleaseFill: 'please fill',
            illegalCharacter: 'illegal characters',
            lessthan: 'less than',
            morethan: 'more than',
            formatError: 'format error'
        },
        reactAntdTable: {
            filterTitle: 'filter',
            filterConfirm: 'confirm',
            filterReset: 'reset',
            emptyText: 'empty',
            selectAll: 'select all',
            selectInvert: 'select invert',
            sortTitle: 'sort',
            requiredText: 'required',
            pleaseInput: 'please input',
            columnSetting: 'column setting',
            lookUp: 'lookup'
        },
        reactPager: {
            unitPrefix: 'Per page',
            unitPostfix: '',
            totalFormat: 'Total {0}',
            currentPageNumberFormat: 'Page {0}',
            totalPagesFormat: 'Total {0}',
            gotoSeparator: ' '
        },
        reportTable: {
            noReportData: 'No data'
        },
        reportEcharts: {
            noReportValue: 'The report has no data.',
            multipleIndicatorName: 'Multiple indicators',
            exceedSameIndustryTipsOne: '已超过',
            exceedSameIndustryTipsTwo: '的同行！',
        },
        customReactSlider: {
            prev: 'Prev',
            next: 'Next',
            close: 'Close'
        },
        reactTinymce: {
            isLoading: 'Loading ...'
        },
        dragList: {
            title: 'Category'
        },
        customFilters: {
            rangeFrom: '',
            rangeTo: 'to',
            validationSummary: 'Incorrect input, please see the detailed error below:',
            fieldsLoadingText: 'Loading, please wait...',
            fieldsLoadingErrorMsg: 'Fields failed to load, please try again later',
            valueLoadingText: 'Loading, please wait...',
            dataSourceLoadingErrorMsgFormat: 'Read data of {0} failed, please try again later',
            fieldNotExistsErrorMsg: 'Failed to switch fields, field "{0}" does not exist!',
            operatorNotExistsErrorMsg: 'The switch operator failed, the operator "{0}" does not exist!'
        },
        customFieldInputs: {
            validation: {},
            textBox: {
                invalidInputError: 'The text format of {0} is incorrect. Please correct it!',
                integerMaxLengthError: 'The maximum length of {0} is {1}'
            },
            textArea: {
                invalidInputError: 'The text format is incorrect, please correct it!',
                integerMaxLengthError: 'The maximum length of {0} is {1}'
            },
            datePicker: {
                invalidInputError: 'The format of the input is incorrect. Please select another one again!'
            },
            dateRange: {
                invalidInputError: 'The format of the input is incorrect. Please select another one again!'
            },
            dateTimePicker: {
                invalidInputError: 'The format of the input is incorrect. Please select another one again!'
            },
            integerNumber: {
                invalidInputError: 'The format of the input is incorrect. Please enter an integer!'
            },
            floatNumber: {
                invalidInputError: 'The format of the input is incorrect. Please enter an integer or decimal!',
                invalidPrecisionError: 'Please enter a decimal with a precision of {0}!'
            },
            textPrecent: {
                invalidInputError:
                    'The format of the input is incorrect. Please enter an integer or a percentage of the decimal!',
                invalidPrecisionError: 'Please enter a percentage with a precision of {0}!'
            },
            simplePhone: {
                invalidInputError: 'The phone format is incorrect, please correct it!',
                integerMaxLengthError: 'The maximum length of {0} is {1}'
            }
        },
        autoComplete: {
            noOptionsMessage: 'No options'
        },
        reactPowerSelect: {
            noOptionsMessage: 'No options'
        },
        figureGroupWidget: {
            belowAverage: 'Below average',
            aboveAverage: 'Above average'
        },
        dragTable: {
            drapHeaderInfo: 'Please drag the small icon to adjust the priority!',
            order: 'Order'
        },
        newVersion: {
            versionUpdateText:
                'Hello, this module has just released a new version, please save the current work, and then click the reload button to make the new version take effect as soon as possible.',
            reloadNewVersion: 'Reload'
        },
        customUi: {
            grid: {
                widgetRoot: {
                    noWidgetPlacholder: 'Drag components to this area'
                }
            }
        },
        report: {
            pages: {
                sentimentAnalysis: {
                    sentimentAnalysisHeader: {
                        title: 'Robot public opinion analysis'
                    },
                    wordCloud: {
                        keywordCloud: 'Keyword word cloud',
                        sensitiveWordsKeywordCloud: 'Sensitive word cloud',
                        wholeMood: 'Overall mood'
                    },
                    sentimentAnalysisDetail: {
                        popularWords: 'Hot words',
                        typicalQuestions: 'Typical question',
                        relevantKeywords: 'Associated keyword',
                        keywordTrends: 'Keyword trend',
                        emotionAnalysis: 'Emotional analysis',
                        getPopularWordsInformationFailed: 'Failed to get popular words'
                    }
                }
            },
            enums: {
                sourceTypes: {
                    agent: 'Agent message',
                    client: 'Client message'
                },
                chartDataView: {
                    toTable: "Click to switch to data table",
                    toChart: "Click to switch to data graphics",
                },
            }
        },
        jeTimePicker: {
            headerTitle: 'Choose time',
            hour: 'Hour',
            minute: 'Minute',
            second: 'Second',
            colon: ':',
            okButtonText: 'OK',
            clearButtonText: 'Clear',
            rangeTo: 'To'
        },
        reactTree: {
            sortText: 'Sort',
            applyLabel: 'Determine',
            sortError: "Sorting, can't {0} sort!"
        },
        loadingButton: {
            okButtonText: "Determine",
            loadingText: "Processing...",
        },
        imageCropper: {
            imageAlt: "Please select an image file",
            previewText: "Intercept Preview",
            resultText: "interception results",
            actionText: "Determine interception"
        },
        imageUpload: {
            buttonText: "upload",
            uploadTipsFormat: "Select a file size no larger than{0}",
            uploadTips: "Please select a document",
            uploadError: "The picture is too big, please recheck it!"
        },
    },
    enums: {
        echartTypes: {
            column: 'column',
            line: 'line',
            pie: 'pie',
            ring: 'ring',
            figure: 'figure',
            funnel: 'funnel',
            doubleAxises: 'doubleAxises',
            stackColumn: 'stackColumn',
            bar: 'bar',
            stackBar: 'stackBar',
            table: 'table',
            gauge: 'gauge',
            map: 'map',
            wordCloud: 'WordCloud',
            customScatterPie: 'Scatter',
            radar: 'radar',
            customStackBar: 'Custom StackBar',
            liquidFill: "Liquid fill",
        }
    },
    ui: {
        widgets: {
            bootstrapDateRangePicker: {
                applyLabel: 'confirm',
                emptyLabel: 'empty',
                cancelLabel: 'cancel',
                customRangeLabel: 'customize',
                fromLabel: 'from',
                toLabel: 'to',
                daysOfWeek: {
                    Sun: 'Sun',
                    Mon: 'Mon',
                    Tu: 'Tue',
                    We: 'Wen',
                    Th: 'Thr',
                    Fr: 'Fri',
                    Sa: 'Sat'
                },
                monthNames: {
                    Jan: 'Jan',
                    Feb: 'Feb',
                    Mar: 'Mar',
                    Apr: 'Apr',
                    May: 'May',
                    Jun: 'Jun',
                    Jul: 'Jul',
                    Aug: 'Aug',
                    Sep: 'Sep',
                    Oct: 'Oct',
                    Nov: 'Nov',
                    Dec: 'Dec'
                },
                ranges: {
                    today: 'today',
                    yesterday: 'yesterday',
                    thisWeek: 'thisWeek',
                    lastWeek: 'lastWeek',
                    thisMonth: 'thisMonth',
                    lastMonth: 'lastMonth',
                    lastThreeDay: 'lastThreeDay',
                    recentlySevenDay: 'recentlySevenDay',
                    recentlyFifteenDay: 'recentlyFifteenDay',
                    recentlyThirtyDay: 'recentlyThirtyDay',
                    recentlySixtyDay: 'recentlySixtyDay',
                    recentlyNinetyDay: 'recentlyNinetyDay',
                    thisYear: 'thisYear',
                    lastYear: 'lastYear',
                    recentlyYear: 'recentlyYear',
                    recentlyMonth: 'recently month',
                    recentlyTwoMonth: 'recently two month',
                    recentlyThreeMonth: 'recently three month'
                }
            },
            modalConfirm: {
                info: {
                    title: 'Information',
                    content: '',
                    okText: 'Confirm',
                    cancelText: 'Cancel'
                },
                warning: {
                    title: 'Note',
                    content: 'Note',
                    okText: 'Confirm',
                    cancelText: 'Cancel'
                },
                error: {
                    title: 'Error',
                    content: 'The operation failed...<br> Please try again later, or notify the Udesk administrator!',
                    okText: 'Confirm',
                    cancelText: 'Cancel'
                },
                success: {
                    title: 'Success',
                    content: 'Successful operation!',
                    okText: 'Confirm',
                    cancelText: 'Cancel'
                },
                confirm: {
                    title: 'Please confirm',
                    content: 'Are you sure you want to continue?',
                    okText: 'Confirm',
                    cancelText: 'Cancel'
                },
                deletion: {
                    title: 'Warning',
                    content:
                        'The content you selected will not be restored once deleted <br> Are you sure you want to delete?',
                    okText: 'Confirm',
                    cancelText: 'CCancel'
                }
            },
            bootstrapDurationPicker: {
                day: 'day',
                hour: 'hour',
                minute: 'minute',
                second: 'second',
                days: 'days',
                hours: 'hours',
                minutes: 'minutes',
                seconds: 'seconds'
            }
        }
    }
};
