export default {
    labels: {
        time: '時間',
        download: 'ダウンロード',
        pleaseSelect: '選択してください',
        OK: '決定する',
        save: '保存する',
        cancel: 'キャンセル',
        loadModelError: 'モジュールデータの読み込みに失敗しました。しばらく待ってからもう一度お試しください',
        colon: ': ',
        weak: '弱い',
        strong: '強い',
        relevance: '関係性',
        all: '全部'
    },
    business: {
        getReportDataFailed: 'チャートデータの取得に失敗しました。ネットワーク接続を確認するか、後でやり直してください'
    },
    validation: {
        requiredFormat: "{0} cannot be empty",
        required: "This item cannot be empty",
        wrongFormat: "{0} format error",
        mustSelectFormat: "Must choose a valid {0}",
        wrongDateFormat: "The date format is incorrect! Please fill in the format yyyy-mm-dd",
        numberOnly: "Please enter a number",
        numberInRange: "Please enter a number between {0} and {1}",
        currency: "Please enter a valid amount",
    },
    components: {
        reactEcharts: {
            mapLoading: '地図がロードされています...',
            customScatterPie: {
                weak: '弱い',
                relevance: '関連性',
                strong: '強い'
            }
        },
        reactTable: {
            noSorting: 'ソートされていない',
            sortAsc: '小から大へ',
            sortDesc: '大きいから小さい',
            chooseColumns: 'テーブルの列を表示または非表示にする',
            batchActionLeft: '選択された',
            batchActionRight: 'レコード'
        },
        reactAntdForm: {
            numberOfWord: '文字',
            pleaseInput: '入力してください',
            pleaseSelect: '選択してください',
            pleaseFill: '記入してください',
            illegalCharacter: '不正な文字',
            lessthan: '未満',
            morethan: '以上',
            formatError: 'フォーマットエラー'
        },
        reactAntdTable: {
            filterTitle: 'フィルタ',
            filterConfirm: 'を選択します',
            filterReset: 'リセット',
            emptyText: 'データがありません',
            selectAll: 'すべて選択',
            selectInvert: '選択を反古にする',
            sortTitle: '並べ替え',
            requiredText: '必要とする',
            pleaseInput: '入力してください',
            columnSetting: '列の設定',
            lookUp: '検索'
        },
        reactPager: {
            unitPrefix: 'ページごと',
            unitPostfix: '条',
            totalFormat: '合計{0}',
            currentPageNumberFormat: 'ページ{0}',
            totalPagesFormat: '合計{0}ページ',
            gotoSeparator: ' '
        },
        reportTable: {
            noReportData: 'データはまだありません'
        },
        reportEcharts: {
            noReportValue: 'データを表示しない',
            multipleIndicatorName: '複数のインジケータ',
            exceedSameIndustryTipsOne: '已超过',
            exceedSameIndustryTipsTwo: '的同行！',
        },
        customReactSlider: {
            prev: '前のページ',
            next: '次のページ',
            close: '閉じる'
        },
        reactTinymce: {
            isLoading: '読み込んでいます...'
        },
        dragList: {
            title: 'カテゴリ名'
        },
        customFilters: {
            rangeFrom: '',
            rangeTo: '〜する',
            validationSummary: '入力が正しくありません。下記の詳細なエラーをご覧ください：',
            fieldsLoadingText: '読み込んでいます、お待ちください...',
            fieldsLoadingErrorMsg: 'フィールドの読み込みに失敗しました。後でやり直してください',
            valueLoadingText: '読み込んでいます、お待ちください...',
            dataSourceLoadingErrorMsgFormat: '{0}の読み込みに失敗しました。後でやり直してください',
            fieldNotExistsErrorMsg: 'フィールドの切り替えに失敗しました"{0}"フィールドは存在しません！',
            operatorNotExistsErrorMsg: 'スイッチ演算子が失敗し、演算子"{0}"は存在しません！'
        },
        customFieldInputs: {
            validation: {},
            textBox: {
                invalidInputError: '{0}テキスト形式が間違っています。再入力してください！',
                integerMaxLengthError: '{0}の最大長は{1}です！'
            },
            textArea: {
                invalidInputError: 'テキスト形式が間違っています。再入力してください！',
                integerMaxLengthError: '{0}的最大长度为{1}！'
            },
            datePicker: {
                invalidInputError: '日付形式が正しくない、再選択してください！'
            },
            dateRange: {
                invalidInputError: '日付形式が正しくない、再選択してください！'
            },
            dateTimePicker: {
                invalidInputError: '日付形式が正しくない、再選択してください！'
            },
            integerNumber: {
                invalidInputError: '入力形式が間違っています。整数を入力してください！'
            },
            floatNumber: {
                invalidInputError: '入力形式が正しくありません。整数または小数を入力してください！',
                invalidPrecisionError: '{0}の精度で10進数を入力してください！'
            },
            textPrecent: {
                invalidInputError: '入力形式が正しくありません。小数点の整数または割合を入力してください！',
                invalidPrecisionError: '精度を{0}で入力してください！'
            },
            simplePhone: {
                invalidInputError: '電話の形式が間違っています。再入力してください！',
                integerMaxLengthError: '{0}の最大長は{1}です！'
            }
        },
        autoComplete: {
            noOptionsMessage: 'いいえ'
        },
        reactPowerSelect: {
            noOptionsMessage: 'いいえ'
        },
        figureGroupWidget: {
            belowAverage: '平均以下',
            aboveAverage: '平均以上'
        },
        dragTable: {
            drapHeaderInfo: '小さいアイコンをドラッグして優先度を調整してください！',
            order: '序列'
        },
        newVersion: {
            versionUpdateText:
                'こんにちは、このモジュールは新しいバージョンをリリースしました。あなたの現在の作品を保存してから、リロードボタンをクリックして新しいバージョンをできるだけ早く有効にしてください。',
            reloadNewVersion: 'リロード'
        },
        customUi: {
            grid: {
                widgetRoot: {
                    noWidgetPlacholder: '部品をここまで引き延ばす'
                }
            }
        },
        report: {
            pages: {
                sentimentAnalysis: {
                    sentimentAnalysisHeader: {
                        title: 'ロボット世論分析'
                    },
                    wordCloud: {
                        keywordCloud: 'キーワードワードクラウド',
                        sensitiveWordsKeywordCloud: '敏感な言葉の雲',
                        wholeMood: '全体的な気分'
                    },
                    sentimentAnalysisDetail: {
                        popularWords: '人気の言葉',
                        typicalQuestions: '典型的な質問',
                        relevantKeywords: '関連キーワード',
                        keywordTrends: 'キーワードの傾向',
                        emotionAnalysis: '感情分析',
                        getPopularWordsInformationFailed: '人気のある単語を取得できませんでした'
                    }
                }
            },
            enums: {
                sourceTypes: {
                    agent: 'カスタマーサービスメッセージ',
                    client: 'お客様からのメッセージ'
                },
                chartDataView: {
                    toTable: "Click to switch to data table",
                    toChart: "Click to switch to data graphics",
                },
            }
        },
        jeTimePicker: {
            headerTitle: '時間選択',
            hour: '時',
            minute: '分钟',
            second: '秒',
            colon: ':',
            okButtonText: '決定する',
            clearButtonText: '空です',
            rangeTo: 'に'
        },
        reactTree: {
            sortText: '排序',
            applyLabel: '确定',
            sortError: '排序中，不能{0}分类！'
        },
        loadingButton: {
            okButtonText: "確定",
            loadingText: "処理中...",
        },
        imageCropper: {
            imageAlt: "画像ファイルを選択してください",
            previewText: "インターセプトプレビュー",
            resultText: "迎撃結果",
            actionText: "迎撃を決定する"
        },
        imageUpload: {
            buttonText: "アップロード",
            uploadTipsFormat: "ファイルサイズは{0}",
            uploadTips: "資料を選択してください",
            uploadError: "写真が大きすぎるので、再確認をお願いします。"
        },
    },
    enums: {
        echartTypes: {
            column: 'ヒストグラム',
            line: '折れ線グラフ',
            pie: '円グラフ',
            ring: 'リングダイアグラム',
            figure: 'デジタルマップ',
            funnel: 'ファンネルチャート',
            doubleAxises: '二軸線図',
            stackColumn: '列積み重ね図',
            bar: '棒グラフ',
            stackBar: 'ストリップスタッキングダイアグラム',
            table: 'フォーム',
            gauge: 'ダッシュボード',
            map: '地図',
            wordCloud: '語雲',
            customScatterPie: '散策図',
            radar: 'レーダー図',
            customStackBar: 'Custom StackBar',
            liquidFill: "Liquid fill",
        }
    },
    ui: {
        widgets: {
            bootstrapDateRangePicker: {
                applyLabel: '決定する',
                emptyLabel: '空',
                cancelLabel: 'キャンセル',
                customRangeLabel: 'カスタム',
                fromLabel: '〜から',
                toLabel: '〜する',
                daysOfWeek: {
                    Sun: '日',
                    Mon: '一',
                    Tu: '二',
                    We: '三',
                    Th: '四',
                    Fr: '五',
                    Sa: '六'
                },
                monthNames: {
                    Jan: '一月',
                    Feb: '二月',
                    Mar: '三月',
                    Apr: '四月',
                    May: '五月',
                    Jun: '六月',
                    Jul: '七月',
                    Aug: '八月',
                    Sep: '九月',
                    Oct: '十月',
                    Nov: '十一月',
                    Dec: '十二月'
                },
                ranges: {
                    today: '今日',
                    yesterday: '昨日',
                    thisWeek: '今週',
                    lastWeek: '先週',
                    thisMonth: '今月',
                    lastMonth: '先月',
                    lastThreeDay: '過去3日間',
                    recentlySevenDay: '過去7日間',
                    recentlyFifteenDay: '過去15日間',
                    recentlyThirtyDay: '過去30日間',
                    recentlySixtyDay: '過去60日間',
                    recentlyNinetyDay: '過去90日間',
                    thisYear: '今年',
                    lastYear: '昨年',
                    recentlyYear: '昨年',
                    recentlyMonth: 'ここ1か月',
                    recentlyTwoMonth: 'ここ2か月',
                    recentlyThreeMonth: 'ここ3か月'
                }
            },
            modalConfirm: {
                info: {
                    title: 'プロンプト',
                    content: '',
                    okText: '決定する',
                    cancelText: 'キャンセル'
                },
                warning: {
                    title: '注意',
                    content: 'ご注意ください',
                    okText: '決定する',
                    cancelText: 'キャンセル'
                },
                error: {
                    title: 'エラー',
                    content:
                        '操作が失敗しました... <br>後でもう一度試してください、またはUdesk管理者に通知してください！',
                    okText: '決定する',
                    cancelText: 'キャンセル'
                },
                success: {
                    title: '成功',
                    content: '成功した操作！',
                    okText: '決定する',
                    cancelText: 'キャンセル'
                },
                confirm: {
                    title: '確認してください',
                    content: '続行してもよろしいですか？',
                    okText: '決定する',
                    cancelText: 'キャンセル'
                },
                deletion: {
                    title: '警告',
                    content:
                        '削除したコンテンツを選択すると、復元することはできません。<br>本当に削除してもよろしいですか？？',
                    okText: '決定する',
                    cancelText: 'キャンセル'
                }
            },
            bootstrapDurationPicker: {
                day: '日',
                hour: '時間',
                minute: '分',
                second: '二番目',
                days: '日',
                hours: '時間',
                minutes: '分',
                seconds: '二番目'
            }
        }
    }
};
