export default {
    labels: {
        time: '时间',
        download: '下载',
        pleaseSelect: '请选择',
        OK: '确定',
        save: '保存',
        cancel: '取消',
        loadModelError: '加载模块数据失败，请稍等再重试一次',
        colon: ': ',
        weak: '弱',
        strong: '强',
        relevance: '相关性',
        all: '全部'
    },
    business: {
        getReportDataFailed: "图表数据获取失败，请检查网络连接或稍后再试"
    },
    validation: {
        requiredFormat: "{0}不能为空",
        required: "此项不能为空",
        wrongFormat: "{0}格式错误",
        mustSelectFormat: "必须选择一个有效的{0}",
        wrongDateFormat: "日期格式不正确！请按照 yyyy-mm-dd 格式填写",
        numberOnly: "请输入一个数字",
        numberInRange: "请输入一个介于 {0} 和 {1} 之间的数字",
        currency: "请输入一个有效的金额",
    },
    components: {
        reactEcharts: {
            mapLoading: '地图正在加载中...',
            customScatterPie: {
                weak: '弱',
                relevance: '相关性',
                strong: '强'
            }
        },
        reactTable: {
            noSorting: '未排序',
            sortAsc: '由小到大',
            sortDesc: '由大到小',
            chooseColumns: '显示或隐藏表格的列',
            batchActionLeft: '已选择',
            batchActionRight: '条记录'
        },
        reactAntdForm: {
            numberOfWord: '个字',
            pleaseInput: '请输入',
            pleaseSelect: '请选择',
            pleaseFill: '请填写',
            illegalCharacter: '存在非法字符',
            lessthan: '少于',
            morethan: '超过',
            formatError: '格式错误'
        },
        reactAntdTable: {
            filterTitle: '筛选',
            filterConfirm: '确定',
            filterReset: '重置',
            emptyText: '暂无数据',
            selectAll: '全选',
            selectInvert: '反选',
            sortTitle: '排序',
            requiredText: '必填',
            pleaseInput: '请输入',
            columnSetting: '列设置',
            lookUp: '查找'
        },
        reactPager: {
            unitPrefix: '每页',
            unitPostfix: '条',
            totalFormat: '共{0}条',
            currentPageNumberFormat: '第{0}页',
            totalPagesFormat: '共{0}页',
            gotoSeparator: ' '
        },
        reportTable: {
            noReportData: '暂无数据'
        },
        reportEcharts: {
            noReportValue: '图表无数据',
            multipleIndicatorName: '多指标',
            exceedSameIndustryTipsOne: '已超过',
            exceedSameIndustryTipsTwo: '的同行！',
        },
        customReactSlider: {
            prev: '上一页',
            next: '下一页',
            close: '关闭'
        },
        reactTinymce: {
            isLoading: '正在加载中...'
        },
        dragList: {
            title: '分类名称'
        },
        customFilters: {
            rangeFrom: '',
            rangeTo: '至',
            validationSummary: '输入有误，请查看下面详细的错误内容：',
            fieldsLoadingText: '加载中，请稍候...',
            fieldsLoadingErrorMsg: '字段加载失败，请稍后重试',
            valueLoadingText: '加载中，请稍候...',
            dataSourceLoadingErrorMsgFormat: '读取{0}失败，请稍后重试',
            fieldNotExistsErrorMsg: '切换字段失败，字段 "{0}" 不存在！',
            operatorNotExistsErrorMsg: '切换操作符失败，操作符 "{0}" 不存在！'
        },
        customFieldInputs: {
            textBox: {
                invalidInputError: '{0}文本格式有误，请重新输入！',
                integerMaxLengthError: '{0}的最大长度为{1}！'
            },
            textArea: {
                invalidInputError: '文本格式有误，请重新输入！',
                integerMaxLengthError: '{0}的最大长度为{1}！'
            },
            datePicker: {
                invalidInputError: '日期格式有误，请重新选择！'
            },
            dateRange: {
                invalidInputError: '日期格式有误，请重新选择！'
            },
            dateTimePicker: {
                invalidInputError: '日期格式有误，请重新选择！'
            },
            integerNumber: {
                invalidInputError: '输入格式有误，请输入一个整数！'
            },
            floatNumber: {
                invalidInputError: '输入格式有误，请输入一个整数或者小数！',
                invalidPrecisionError: '请输入精准度为{0}的小数！'
            },
            textPrecent: {
                invalidInputError: '输入格式有误，请输入一个整数或者小数的百分比！',
                invalidPrecisionError: '请输入精准度为{0}的百分比！'
            },
            simplePhone: {
                invalidInputError: '电话格式有误，请重新输入！',
                integerMaxLengthError: '{0}的最大长度为{1}！'
            }
        },
        autoComplete: {
            noOptionsMessage: '暂无'
        },
        reactPowerSelect: {
            noOptionsMessage: '暂无'
        },
        figureGroupWidget: {
            belowAverage: '低于平均分',
            aboveAverage: '高于平均分'
        },
        dragTable: {
            drapHeaderInfo: '请拖动小图标调整优先级！',
            order: '排序'
        },
        newVersion: {
            versionUpdateText:
                '您好，这个模块刚刚发布了新版本，请您保存当前的工作，然后点击重新加载按钮，以让新版本尽快生效。',
            reloadNewVersion: '重新加载'
        },
        customUi: {
            grid: {
                widgetRoot: {
                    noWidgetPlacholder: '将组件拖至此区域'
                }
            }
        },
        report: {
            pages: {
                sentimentAnalysis: {
                    sentimentAnalysisHeader: {
                        title: '机器人舆情分析'
                    },
                    wordCloud: {
                        keywordCloud: '关键词词云',
                        sensitiveWordsKeywordCloud: '敏感词词云',
                        wholeMood: '整体情绪'
                    },
                    sentimentAnalysisDetail: {
                        popularWords: '热门词语',
                        typicalQuestions: '典型问句',
                        relevantKeywords: '关联关键词',
                        keywordTrends: '关键词趋势',
                        emotionAnalysis: '情绪分析',
                        getPopularWordsInformationFailed: '获取热门词语失败'
                    }
                }
            },
            enums: {
                sourceTypes: {
                    agent: '客服消息',
                    client: '客户消息'
                },
                chartDataView: {
                    toTable: "クリックしてデータテーブルに切り替えます",
                    toChart: "クリックしてデータグラフィックスに切り替えます",
                },
            }
        },
        jeTimePicker: {
            headerTitle: '时间选择',
            hour: '小时',
            minute: '分钟',
            second: '秒',
            colon: ':',
            okButtonText: '确定',
            clearButtonText: '清空',
            rangeTo: '至'
        },
        reactTree: {
            sortText: '排序',
            applyLabel: '确定',
            sortError: '排序中，不能{0}分类！'
        },
        loadingButton: {
            okButtonText: "确定",
            loadingText: "处理中...",
        },
        imageCropper: {
            imageAlt: "请选择图片文件",
            previewText: "截取预览",
            resultText: "截取结果",
            actionText: "确定截取"
        },
        imageUpload: {
            buttonText: "上传",
            uploadTipsFormat: "选择文件大小不超过{0}",
            uploadTips: "请选择文件",
            uploadError: "图片过大,请重新选取！"
        }
    },
    enums: {
        echartTypes: {
            column: '柱状图',
            line: '折线图',
            pie: '饼图',
            ring: '环图',
            figure: '数字图',
            funnel: '漏斗图',
            doubleAxises: '双轴图',
            stackColumn: '柱状堆叠图',
            bar: '条形图',
            stackBar: '条形堆叠图',
            table: '表格',
            gauge: '仪表盘',
            map: '地图',
            wordCloud: '词云',
            customScatterPie: '散点图',
            radar: '雷达图',
            customStackBar: '自定义条形堆叠图',
            liquidFill: "水球图",
        }
    },
    ui: {
        widgets: {
            bootstrapDateRangePicker: {
                applyLabel: '确定',
                emptyLabel: '清空',
                cancelLabel: '取消',
                customRangeLabel: '自定义',
                fromLabel: '从',
                toLabel: '到',
                daysOfWeek: {
                    Sun: '日',
                    Mon: '一',
                    Tu: '二',
                    We: '三',
                    Th: '四',
                    Fr: '五',
                    Sa: '六'
                },
                monthNames: {
                    Jan: '一月',
                    Feb: '二月',
                    Mar: '三月',
                    Apr: '四月',
                    May: '五月',
                    Jun: '六月',
                    Jul: '七月',
                    Aug: '八月',
                    Sep: '九月',
                    Oct: '十月',
                    Nov: '十一月',
                    Dec: '十二月'
                },
                ranges: {
                    today: '今天',
                    yesterday: '昨天',
                    thisWeek: '本周',
                    lastWeek: '上周',
                    thisMonth: '本月',
                    lastMonth: '上月',
                    lastThreeDay: '最近3天',
                    recentlySevenDay: '最近7天',
                    recentlyFifteenDay: '最近15天',
                    recentlyThirtyDay: '最近30天',
                    recentlySixtyDay: '最近60天',
                    recentlyNinetyDay: '最近90天',
                    thisYear: '今年',
                    lastYear: '去年',
                    recentlyYear: '最近一年',
                    recentlyMonth: '最近一个月',
                    recentlyTwoMonth: '最近两个月',
                    recentlyThreeMonth: '最近三个月'
                }
            },
            modalConfirm: {
                info: {
                    title: '提示',
                    content: '',
                    okText: '确定',
                    cancelText: '取消'
                },
                warning: {
                    title: '注意',
                    content: '请注意',
                    okText: '确定',
                    cancelText: '取消'
                },
                error: {
                    title: '错误',
                    content: '操作失败…<br>请稍后重试，或者通知Udesk管理员！',
                    okText: '确定',
                    cancelText: '取消'
                },
                success: {
                    title: '成功',
                    content: '操作成功！',
                    okText: '确定',
                    cancelText: '取消'
                },
                confirm: {
                    title: '请确认',
                    content: '您确定要继续吗?',
                    okText: '确定',
                    cancelText: '取消'
                },
                deletion: {
                    title: '警告',
                    content: '您选择的内容一旦删除将无法恢复<br>您确定要删除吗？',
                    okText: '确定',
                    cancelText: '取消'
                }
            },
            bootstrapDurationPicker: {
                day: '天',
                hour: '时',
                minute: '分',
                second: '秒',
                days: '天',
                hours: '时',
                minutes: '分',
                seconds: '秒'
            }
        }
    }
};
