import {csApiAxiosInstance, isSameOrigin} from '@udesk-webapp/utils';
import {getCsrfToken} from "./ajax";
import merge from 'lodash-es/merge';

interface IHeader {
    'X-CSRF-Token'?: string,
}

csApiAxiosInstance.interceptors.request.use((config) => {
    const _isSameOrigin = config.url ? isSameOrigin(config.url) : false;
    const headers: IHeader = {};

    const csrfToken = getCsrfToken();
    if (_isSameOrigin && csrfToken) {
        headers['X-CSRF-Token'] = csrfToken;
    }
    return merge({headers: headers}, config);
});

export {
    csApiRequest,
    csApiGetJSON,
    csApiPostJSON,
    csApiPutJSON,
    csApiDeleteJSON,
} from '@udesk-webapp/utils';
