import EventEmitter from "eventemitter3";

export class Eventable {
    private eventEmitter = new EventEmitter();

    public on(event: string, fn: (...args: any[]) => void, context?: any) {
        this.eventEmitter.on(event, fn, context ?? this);
    }

    public once(event: string, fn: (...args: any[]) => void, context?: any) {
        this.eventEmitter.once(event, fn, context ?? this);
    }

    public off(event: string, fn?: (...args: any[]) => void, context?: any, once?: boolean) {
        this.eventEmitter.off(event, fn, context ?? this, once);
    }

    public removeAllListeners(event?: string) {
        this.eventEmitter.removeAllListeners(event);
    }

    public fire(event: string, ...args: any[]) {
        this.eventEmitter.emit(event, ...args);
    }
}
