import { useContext } from 'react';
import ConfigProvider from '../../config-provider/index';

export default function usePrefixCls(
  componentSuffixCls: string,
  customizePrefixCls: string | undefined,
) {
  // @ts-ignore
  const { getPrefixCls } = useContext(ConfigProvider.ConfigContext);
  const componentCls = getPrefixCls(componentSuffixCls, customizePrefixCls);
  const prefixCls = getPrefixCls('', customizePrefixCls);
  return [componentCls, prefixCls];
}
