import { store } from "../store";
//TODO 工具类所有方法尽可能做成纯函数
export const ChatUtils = {
  /**
   * 获取业务记录模板是否含有必填字段
   * @param agent_note_template_id 会话设置过的业务记录模板,可能为空
   * return boolean
   */
  getNoteHasReqField: function (agent_note_template_id?: number) {
    const noteTemplateConfig = store.getState().noteTemplateConfig || {};
    const initData = store.getState().initData || {};
    const note_category: { [key: string]: string } = {
      im: "im",
      mpv: "video",
      call: "call",
    };
    const noteTemplates = noteTemplateConfig.noteTemplates || [];
    const imAgentNoteTemplatesSort =
      noteTemplateConfig.imAgentNoteTemplatesSort || [];

    let imNoteFields:any[] = [];
    const imNoteKey = note_category[initData.page]; //"im";

    if (agent_note_template_id) {
      imNoteFields =
        (
          noteTemplates.find(
            (note: INoteTemplate) => note?.id === agent_note_template_id
          ) || {}
        ).fields || [];
    } else {
      if (imAgentNoteTemplatesSort && imAgentNoteTemplatesSort.length > 0) {
        imNoteFields =
          (
            noteTemplates.find(
              (note: INoteTemplate) => note.id === imAgentNoteTemplatesSort[0]
            ) || {}
          ).fields || [];
      } else {
        imNoteFields =
          (
            noteTemplates.find(
              (note: INoteTemplate) => note.category === imNoteKey
            ) || {}
          ).fields || [];
      }
    }

    return imNoteFields.some((field: any) => field.is_required);
  },
};
