/**
 * 检查某条消息是否是事件 - 消息内容,im_log的消息内容本来是字符串，传入该方法时需要先JSON.parse
 */
export function imLogIsEvent(imLog: any/*, hash*/) {
    let content = getImLogContent(imLog);
    let contentType = content.type;
    //如果content.data包含timeout_freq、timeout_freq或timeout_auto_msg，那么imLog即是event又是message
    if (contentType === 'message' && ('timeout_freq' in content.data || 'msg_close' in content.data || 'timeout_auto_msg' in content.data)) {
        return true;
    }
    return !(['audio', 'file', 'image', 'location', 'message', 'rich', 'shortvideo', 'struct', 'video', 'product'].includes(contentType));//声明contains  /usr/share/code/resources/app/extensions/node_modules/typescript/lib/lib.es5.d.ts
}


export function imLogIsMessage(imLog: any/*, hash*/) {
    let content = getImLogContent(imLog);
    let contentType = content.type;
    return ['audio', 'file', 'image', 'location', 'message', 'rich', 'shortvideo', 'struct', 'video'].includes(contentType);
}


/**
 * 获取im log里的content对象，
 * im log的content属性是字符串，该字符串是一个json，可以转成object，
 * 如果转换失败则将content作为消息内容，type为message
 *
 */
function getImLogContent(imLog: any) {
    let content;
    try {
        content = JSON.parse(imLog.content);
    } catch (e) {
        content = {
            type: 'message',
            content: {data: {content: imLog.content}}
        };
    }

    return content;
}
