const path = require('path');

function formatOptions(originOptions) {
    const options = { ...originOptions };
    options.localesFilePath = [];
    options.targetLanguageMap = {};
    const { localesFilePath = [] } = originOptions;
    localesFilePath.forEach((p) => {
        if (typeof p === 'string') {
            options.localesFilePath.push(p);
            options.targetLanguageMap[path.basename(p)] = 'zh';
        } else {
            options.localesFilePath.push(p.outputPath);
            options.targetLanguageMap[path.basename(p.outputPath)] = p.targetLanguage || 'zh';
        }
    });
    return options;
}
module.exports = {
    formatOptions,
};
