import React from 'react';

const ExpandWithDefaultProps = <P extends object>(
  OriginalComponent: React.ComponentType<P>,
  defaultProps: Partial<P>,
) => {
  const NewComponent: React.FC<P> = (props) => {
    // @ts-ignore
    return <OriginalComponent {...defaultProps} {...props} />;
  };
  return NewComponent;
};

export default ExpandWithDefaultProps;
