ace.define("ace/mode/bi_compute_highlight_rules", function(require, exports, module) {
    "use strict";
    var oop = require("../lib/oop");
    var TextHighlightRules = require("./text_highlight_rules").TextHighlightRules;
    var DroolsHighlightRules = function() {
        var keywordMapper = this.createKeywordMapper({
            "keyword": "AVG|MAX|MIN|COUNT|ROUND|MEDIAN|DATEDIFF|case|when|then|else|end|SUM",
            // "string": "[.]"
        }, "identifier");
        this.$rules = {
            "start": [{
                token: keywordMapper,
                regex: "[a-zA-Z_$][a-zA-Z_$]*\\b",
            }, {
                token: "keyword",
                regex: "\\+|-|\\*|\\/"
            }, {
                token: "string",
                regex: "\\[([\\s\\S]*?)\\]"
            }],
        };
    };

    oop.inherits(DroolsHighlightRules, TextHighlightRules);
    exports.DroolsHighlightRules = DroolsHighlightRules;
});

ace.define("ace/mode/bi_compute", function(require, exports, module) {
    "use strict";
    var oop = require("../lib/oop");
    var TextMode = require("./text").Mode;
    var DroolsHighlightRules = require("./bi_compute_highlight_rules").DroolsHighlightRules;
    var DroolsMode = function() {
        this.HighlightRules = DroolsHighlightRules;
    };
    oop.inherits(DroolsMode, TextMode);
    (function() {
        this.$id = "ace/mode/bi_compute"
    }).call(DroolsMode.prototype),
        exports.Mode = DroolsMode;
});
