declare module '*.module.scss' {
    export default any;
}
declare module '*.module.css' {
    export default any;
}
declare module '*.png' {
    const src: string;
    export default src;
}

type Company = {
    cc_agent_helper?: CcAgentHelper;
    cc_whole_columns?: CcWholeColumns;
    cc_queue_columns?: CcQueueColumns;
    cc_agent_columns?: CcAgentColumns;
    im_whole_columns?: ImWholeColumns;
    im_agent_columns?: ImAgentColumns;
    agent_columns?: AgentColumns;
    agent_group_columns?: AgentGroupColumns;
    switch_anonym?: boolean;
    ticket_whole_columns?: TicketWholeColumns;
    ticket_agent_columns?: TicketAgentColumns;
    charged?: boolean;
    is_customer_owner_on?: boolean;
    call_voice_save_days?: number;
    is_auto_set_call_on?: boolean;
    is_auto_set_im_on?: boolean;
    is_auto_set_ticket_on?: boolean;
    callin_owner_first?: boolean;
    all_agent_quota?: number;
    call_agent_quota?: number;
    im_agent_quota?: number;
    ticket_agent_quota?: number;
    dial_agent_quota?: number;
    system_intergration?: boolean | null;
    paid?: boolean;
    platform_mpv_open?: boolean;
    is_sms_open?: boolean;
    company_id?: number;
    billing_app_id?: string | null;
    company_name?: string;
    company_subdomain?: string;
    company_code?: string;
    nav_logo_small?: string;
    nav_logo_normal?: string | null;
    sys_customer_logo?: string;
    sys_agent_logo?: string;
    cname?: any;
    bulletin?: string;
    is_newbie?: boolean;
    support_email?: string;
    forward_emails?: string[];
    expired?: boolean;
    is_broadcast_open?: boolean;
    target_available?: boolean;
    udesk_version?: string;
    agent_dashboard?: any;
    admin_dashboard?: any;
    is_bi_open?: boolean;
    close_reporting?: string;
    is_support_lang?: boolean;
    is_close_sla?: boolean;
    is_ad_task_open?: boolean;
    is_batch_sms_open?: boolean;
    monitor_reload_interval?: number;
    max_inspection_count?: number;
    open_tutorial?: boolean;
    volcano_monit?: VolcanoMonit;
    position_monit?: boolean;
    after_log_send_xmpp?: boolean;
    hidden_reply_histories?: boolean;
    channel_categories?: ChannelCategory[];
    real_time_translation?: boolean;
    category?: string;
    vcall?: boolean;
    remote_control?: boolean;
    is_edit_picture?: boolean;
    favicon?: string;
    show_paas_financial?: boolean;
    survey_option_labels?: SurveyOptionLabels;
    survey_options?: SurveyOption[];
    support_multi_organizations?: boolean;
    single_file_size_limit?: number;
    im_single_file_size_limit?: number;
    single_ticket_attachment_limit?: number;
    total_ticket_attachment_limit?: number;
    agent_note_must_fill?: boolean;
    behavior_trace?: boolean;
    customer_order?: boolean;
    customer_order_rule?: boolean;
    field_hooks_token_location?: string;
    old_message_interface_access?: boolean;
    web_message_display_status?: boolean;
    web_message_display_status_start_at?: any;
    image_recognize_text?: boolean;
    probe_config?: ProbeConfig;
};

interface TicketField {
    value?: any;
    onChange?: (value: any) => void;
    onBlur?: (value: any) => void;
    placeholder?: string;
    options?: any;
    remark?: string;
    trigger?: 'onChange' | 'onBlur';
}

interface CcWholeColumns {
    online_count: boolean;
    online_duration: boolean;
    online_avg_duration: boolean;
    call_duration: boolean;
    call_avg_duration: boolean;
    call_duration_rate: boolean;
    callin_count: boolean;
    callin_answered_count: boolean;
    callin_unanswered_count: boolean;
    callin_messaged_count: boolean;
    callin_hangup_count: boolean;
    callin_answered_rate: boolean;
    callin_satisfaction_count: boolean;
    callin_satisfaction_rate: boolean;
    callin_satisfied_count: boolean;
    callin_satisfied_rate: boolean;
    callin_dissatisfied_count: boolean;
    callin_dissatisfied_rate: boolean;
    callin_delayed_avg_duration: boolean;
    callin_call_duration: boolean;
    callin_call_avg_duration: boolean;
    callin_agent_hangup_count: boolean;
    callin_agent_hangup_rate: boolean;
    callin_customer_hangup_count: boolean;
    callin_customer_hangup_rate: boolean;
    callout_count: boolean;
    callout_answered_count: boolean;
    callout_unanswered_count: boolean;
    callout_answered_rate: boolean;
    callout_delayed_avg_duration: boolean;
    callout_call_duration: boolean;
    callout_call_avg_duration: boolean;
    callout_agent_hangup_count: boolean;
    callout_agent_hangup_rate: boolean;
    callout_customer_hangup_count: boolean;
    callout_customer_hangup_rate: boolean;
}

interface CcQueueColumns {
    queue_enter_count: boolean;
    callin_count: boolean;
    callin_answered_count: boolean;
    callin_unanswered_count: boolean;
    callin_messaged_count: boolean;
    callin_hangup_count: boolean;
    callin_answered_rate: boolean;
    callin_satisfaction_count: boolean;
    callin_satisfaction_rate: boolean;
    callin_satisfied_count: boolean;
    callin_satisfied_rate: boolean;
    callin_dissatisfied_count: boolean;
    callin_dissatisfied_rate: boolean;
    callin_delayed_avg_duration: boolean;
    callin_call_duration: boolean;
    callin_call_avg_duration: boolean;
    callin_agent_hangup_count: boolean;
    callin_agent_hangup_rate: boolean;
    callin_customer_hangup_count: boolean;
    callin_customer_hangup_rate: boolean;
}

interface CcAgentColumns {
    callin_count: boolean;
    callin_answered_count: boolean;
    callin_unanswered_count: boolean;
    callin_answered_rate: boolean;
    callin_satisfaction_count: boolean;
    callin_satisfaction_rate: boolean;
    callin_satisfied_count: boolean;
    callin_satisfied_rate: boolean;
    callin_dissatisfied_count: boolean;
    callin_dissatisfied_rate: boolean;
    callin_delayed_avg_duration: boolean;
    callin_call_duration: boolean;
    callin_call_avg_duration: boolean;
    callin_agent_hangup_count: boolean;
    callin_agent_hangup_rate: boolean;
    callin_customer_hangup_count: boolean;
    callin_customer_hangup_rate: boolean;
    callout_count: boolean;
    callout_answered_count: boolean;
    callout_unanswered_count: boolean;
    callout_answered_rate: boolean;
    callout_delayed_avg_duration: boolean;
    callout_call_duration: boolean;
    callout_call_avg_duration: boolean;
    callout_agent_hangup_count: boolean;
    callout_agent_hangup_rate: boolean;
    callout_customer_hangup_count: boolean;
    callout_customer_hangup_rate: boolean;
}

interface ImWholeColumns {
    customer_count: boolean;
    dialog_count: boolean;
    dialog_count_customer: boolean;
    dialog_count_agent: boolean;
    dialog_count_valid: boolean;
    customer_message_count: boolean;
    agent_message_count: boolean;
    message_count: boolean;
    message_count_avg: boolean;
    online_total: boolean;
    online_total_avg: boolean;
    busy_total: boolean;
    busy_total_avg: boolean;
    vote_count: boolean;
    vote_count_pct: boolean;
    option_0_count: boolean;
    option_0_count_pct: boolean;
    option_1_count: boolean;
    option_1_count_pct: boolean;
    option_2_count: boolean;
    option_2_count_pct: boolean;
    option_3_count: boolean;
    option_3_count_pct: boolean;
    option_4_count: boolean;
    option_4_count_pct: boolean;
}

interface ImAgentColumns {
    customer_count: boolean;
    dialog_count: boolean;
    dialog_count_customer: boolean;
    dialog_count_agent: boolean;
    dialog_count_valid: boolean;
    customer_message_count: boolean;
    agent_message_count: boolean;
    message_count: boolean;
    message_count_avg: boolean;
    online_total: boolean;
    online_total_pct: boolean;
    busy_total: boolean;
    busy_total_pct: boolean;
    offline_total: boolean;
    online_at: boolean;
    last_online_at: boolean;
    busy_total_avg: boolean;
    vote_count: boolean;
    vote_count_pct: boolean;
    option_0_count: boolean;
    option_0_count_pct: boolean;
    option_1_count: boolean;
    option_1_count_pct: boolean;
    option_2_count: boolean;
    option_2_count_pct: boolean;
    option_3_count: boolean;
    option_3_count_pct: boolean;
    option_4_count: boolean;
    option_4_count_pct: boolean;
}

interface AgentColumns {
    id: boolean;
    avatar: boolean;
    alias: boolean;
    email: boolean;
    cellphone: boolean;
    agent_role: boolean;
    agent_group: boolean;
    fixed_voip_id: boolean;
    fixed_voip_password: boolean;
}

interface AgentGroupColumns {
    id: boolean;
    name: boolean;
    agent_count: boolean;
    agents: boolean;
    created_at: boolean;
}

interface TicketWholeColumns {
    agent_count: boolean;
    ticket_count: boolean;
    ast_count: boolean;
    st_count: boolean;
    ct_count: boolean;
    ast: boolean;
    act: boolean;
}

interface TicketAgentColumns {
    ticket_count: boolean;
    st_count: boolean;
    ct_count: boolean;
    ast: boolean;
    act: boolean;
}

interface VolcanoMonit {
    panel: number;
    trend: number;
    agent: number;
}

interface ChannelCategory {
    channel_name: string;
    channel_url: string;
    imc_server: string;
    api_base_url?: any;
}

interface SurveyOptionLabels {
    vote_count: string;
    vote_count_pct: string;
    option_0_count: string;
    option_0_count_pct: string;
    option_1_count: string;
    option_1_count_pct: string;
    option_2_count: string;
    option_2_count_pct: string;
    option_3_count: string;
    option_3_count_pct: string;
    option_4_count: string;
    option_4_count_pct: string;
}

interface SurveyOption {
    id: number;
    text: string;
}

interface ProbeConfig {
    url: string;
    times: number;
    interval: number;
}

type AnyKey = {
    [key: string]: any;
};

type IRoleCan = {
    add_new_customer?: boolean;
    customer_import?: boolean;
    customer_show_group?: boolean;
    customer_show_all?: boolean;
    customer_show_personal?: boolean;
    customer_edit_group?: boolean;
    customer_edit_all?: boolean;
    customer_edit_personal?: boolean;
    add_new_tag?: boolean;
    customer_show_cellphone_all?: boolean;
    customer_show_cellphone_group?: boolean;
    customer_show_cellphone_personal?: boolean;
    set_customer_level?: boolean;
    customer_remove?: boolean;
    customer_merge?: boolean;
    callout_task_show_all?: boolean;
    callout_task_show_group?: boolean;
    callout_task_export?: boolean;
    callout_task_redispatch_customers?: boolean;
    customer_edit_passively?: boolean;
    tickets_import_all?: boolean;
    reply_to_customer?: boolean;
    callcenter_queues_monitor?: boolean;
    callcenter_groups_monitor?: boolean;
    callcenter_records_download?: boolean;
    callcenter_call_records_export?: boolean;
    callcenter_note_records_export?: boolean;
    callcenter_missed_callin_records_export?: boolean;
    callout_display_number_edit?: boolean;
    callout_task_customers_export?: boolean;
    callcenter_neaten_time_edit?: boolean;
    callout_neaten_time_edit?: boolean;
    group_neaten_time_edit?: boolean;
    ticket_overview?: boolean;
    ticket_import?: boolean;
    ticket_reports?: boolean;
    ticket_attachments?: boolean;
    ticket_custom_reports?: boolean;
    ticket_custom_reports_edit?: boolean;
    ticket_edit_all_ticket?: boolean;
    ticket_edit_group_ticket?: boolean;
    ticket_edit_agent_ticket?: boolean;
    ticket_edit_none_distribution?: boolean;
    callcenter_monitor?: boolean;
    callcenter_records?: boolean;
    callcenter_records_group?: boolean;
    callcenter_reports?: boolean;
    callcenter_reports_group?: boolean;
    callcenter_reports_user?: boolean;
    callcenter_reports_queue?: boolean;
    callcenter_reports_ivr?: boolean;
    export_cbi_callcenter_reports?: boolean;
    customer_custom_reports?: boolean;
    customer_custom_reports_edit?: boolean;
    call_custom_reports?: boolean;
    call_custom_reports_edit?: boolean;
    callcenter_callcheck?: boolean;
    callcenter_callcheck_group?: boolean;
    callcenter_cases?: boolean;
    im_online_all_monitor?: boolean;
    im_online_group_monitor?: boolean;
    work_log_monitor?: boolean;
    report_work_logs_export?: boolean;
    report_call_records_export?: boolean;
    report_call_quality_score_export?: boolean;
    report_call_case_group_export?: boolean;
    report_im_records_export?: boolean;
    report_im_quality_score_export?: boolean;
    report_im_case_group_export?: boolean;
    report_note_records_monitor_export?: boolean;
    report_knowledge_import?: boolean;
    report_knowledge_export?: boolean;
    knowledge_attachments?: boolean;
    knowledge_create_public?: boolean;
    knowledge_view_public?: boolean;
    knowledge_edit_public?: boolean;
    knowledge_delete_public?: boolean;
    knowledge_export_public?: boolean;
    knowledge_submit_public?: boolean;
    knowledge_review_public?: boolean;
    im_records?: boolean;
    im_session_group_only?: boolean;
    im_records_show_user?: boolean;
    im_workbench_show_all_im_records?: boolean;
    im_workbench_show_group_im_records?: boolean;
    im_workbench_show_user_im_records?: boolean;
    customer_center_show_all_im_records?: boolean;
    customer_center_show_group_im_records?: boolean;
    customer_center_show_user_im_records?: boolean;
    customer_center_show_all_video_records?: boolean;
    customer_center_show_group_video_records?: boolean;
    im_reports?: boolean;
    export_cbi_im_reports?: boolean;
    im_reports_group?: boolean;
    im_reports_user?: boolean;
    im_reports_queue?: boolean;
    im_reports_public_opinion?: boolean;
    im_reports_order?: boolean;
    im_visit_reports?: boolean;
    im_edit_reports?: boolean;
    im_custom_reports?: boolean;
    im_custom_reports_edit?: boolean;
    im_send_emoji?: boolean;
    agent_note_records?: boolean;
    crm_reports?: boolean;
    add_new_organization?: boolean;
    organization_export?: boolean;
    agent_notice_create?: boolean;
    im_guest?: boolean;
    im_guest_record?: boolean;
    im_guest_chat?: boolean;
    im_all_queue_monitor?: boolean;
    im_groups_queue_monitor?: boolean;
    im_all_colleague_monitor?: boolean;
    im_groups_colleague_monitor?: boolean;
    im_realtime_monitor?: boolean;
    im_dialogue_reception_control?: boolean;
    agent_monitor_all?: boolean;
    agent_monitor_group?: boolean;
    im_queue_assign?: boolean;
    im_allow_custom_size?: boolean;
    im_monit_custom_size?: boolean;
    ticket_time_reports?: boolean;
    ticket_time_reports_edit?: boolean;
    im_check_all?: boolean;
    im_check_group?: boolean;
    ticket_show_all?: boolean;
    ticket_show_group?: boolean;
    ticket_show_none_distribution?: boolean;
    im_cases?: boolean;
    set_robot?: boolean;
    defriend_customer?: boolean;
    customer_export?: boolean;
    short_message_records?: boolean;
    short_message_records_group?: boolean;
    short_message_records_personal?: boolean;
    ticket_relate?: boolean;
    sms_template_edit?: boolean;
    ad_task?: boolean;
    batch_sms?: boolean;
    platform_insight?: boolean;
    im_leave_all?: boolean;
    im_leave_group?: boolean;
    im_leave_colleague?: boolean;
    im_leave_self?: boolean;
    im_customer_contact?: boolean;
    remote_control?: boolean;
    im_chat_lock?: boolean;
    qc_task_new?: boolean;
    qc_task_view?: boolean;
    qc_task_manage?: boolean;
    alarm_all?: boolean;
    alarm_group?: boolean;
    alarm_edit?: boolean;
    position_monitor?: boolean;
    position_monitor_share?: boolean;
    im_customer_order?: boolean;
    im_add_to_robot_knowledge?: boolean;
    only_show_self_customer_feed?: boolean;
    only_show_group_customer_feed?: boolean;
    platform_mpv?: boolean;
    ticket_reports_new_all?: boolean;
    ticket_reports_new_group?: boolean;
    ticket_reports_new_agent?: boolean;
    ticket_reports_new_export?: boolean;
    personal_information_edit?: boolean;
    bulk_reply_tickets?: boolean;
    delete_organization?: boolean;
    video_record_show_all?: boolean;
    video_record_show_group?: boolean;
    ticket_edit_agent?: boolean;
    ticket_edit_agent_group?: boolean;
    ticket_edit_status?: boolean;
    ticket_edit_acceptor?: boolean;
    ticket_edit_priority?: boolean;
    ticket_delete?: boolean;
    ticket_tag_edit?: boolean;
    admin_custom_field?: boolean;
    admin_edit_personal_macro?: boolean;
    admin_edit_public_macro?: boolean;
    group_admin_user?: boolean;
    group_admin_company?: boolean;
    group_admin_agent_and_group?: boolean;
    helper_center_create_and_edit?: boolean;
    helper_center_other?: boolean;
    platform_im?: boolean;
    platform_call_center?: boolean;
    manage_position_monitor?: boolean;
    [key: string]: boolean;
};

type IUrls = {
    vistor_server: string;
};

type IUser = {
    agent_roles: AgentRole[]; // 客服角色
    aliase: string; // 昵称
    avatar?: string; // 客服头像
    cellphone: string; //客服电话
    csrf_token?: string; // csrftoken
    desc: string; // 客服描述
    email: string; // 客服邮箱
    id: number; // 客服id
    im_quick: boolean; // 客服是否开启快捷键
    isCall: boolean; // 是否有呼叫中心
    isDial: boolean; // ?
    isIM: boolean; // 是否有IM
    isMchatAdmin: boolean; // 是否多商户客服
    nick_name: string; // 客服昵称
    role: 'agent' | 'admin'; // 所属角色
    user_groups: UserGroup[]; // 所属客服组
};

type IAdmin = {
    // 系统管理员
    id: number;
    email: string;
    nick_name: string;
    cellphone: string;
    description: any;
    created_at: string;
    last_sign_in_at: string;
};

type IAgent = {
    id: number;
    email?: string;
    nick_name: string;
    agent_name_pinyin?: string;
    aliase?: string;
    cellphone?: any;
    availability?: boolean;
    description?: any;
    ticket_permission?: number;
    created_at?: string;
    availability_updated_at?: any;
    is_open_callcenter?: boolean;
    last_sign_in_at?: string;
    avatar?: any;
    agent_invalid?: boolean;
    fixed_voip_id?: string;
    fixed_voip_password?: string;
    user_groups?: UserGroup[];
    agent_roles?: AgentRole[];
    text?: string;
};

type UserGroup = {
    id: number;
    name: string;
};

type AgentRole = {
    id: number;
    name: string;
};

type IGroup = {
    id: number;
    name: string;
    description: string;
    created_at: string;
    ytxapp_queue_type: any;
    agents_count: number;
    customers_count: number;
};

type Template = {
    id: number;
    name: string;
    desc: string;
    category: string;
    ticket_template_id: number;
    is_default: boolean;
    call_type: string;
    agent_group_ids: any[];
    fields: Field;
};

type Tab = {
    name: string;
    text: string;
    active?: boolean;
    postMsgEnabled?: boolean;
    checked?: boolean;
};

type PlugTab = {
    name?: string;
    text?: string;
    active?: boolean;
    postMsgEnabled?: boolean;
    checked?: boolean;
};

type INoteTemplate = {
    agent_group_ids?: number[];
    call_type?: string;
    category?: string;
    desc?: string;
    fields?: any[];
    id?: number;
    is_default?: boolean;
    name?: string;
    ticket_template_id?: number;
};

type INoteTemplates = INoteTemplate[];

type AccessInfo = {
    version?: string;
    referrer?: string;
    accessUrl?: string;
    accessUrl_desc?: string;
    cur_url?: string;
    cur_url_desc?: string;
    channel?: any;
    searchType?: string;
    src_url?: string;
    keyword?: any;
    sysInfo?: string;
    bowserInfo?: string;
    resolution?: string;
    web_plugin_name?: any;
    web_plugin_id?: number;
    h5push?: boolean;
    user_agent?: string;
    platform?: string;
    is_web?: boolean;
    ip?: string;
    src?: string;
    is_sdk?: boolean;
    jid_resource?: string;
    day_sub_session_count?: number;
    queue_name?: string;
    session_key: string;
    menu_names?: string;
    cur_url_show?: string;
    accessUrl_show?: string;
    src_url_show?: string;
    session_code?: string;
    phoneModal?: string;
    phoneVersion?: string;
    netWorkStatus?: string;
    carrier?: string;
    scaleScreen?: string;
    need_day_sub_session_count?: any;
    networkStatus?: any;
    sdkName?: any;
    sdkType?: any;
};

type ChatAgent = {
    id: number;
    jid: string;
    nick: string;
};

type Customer = {
    invite_user_key?: string;
    merging?: boolean;
    last_session_24h?: any;
    id?: number;
    nick_name?: string;
    owner_id?: any;
    owner_group_id?: any;
    source_channel?: string;
    province?: string;
    city?: string;
    phone_service_provider?: any;
    isp?: string;
    last_contact_at?: any;
    first_contact_at?: any;
    contact_count?: number;
    last_contact_at_via_phone?: any;
    first_contact_at_via_phone?: any;
    contact_count_via_phone?: any;
    last_contact_at_via_im?: any;
    first_contact_at_via_im?: any;
    contact_count_via_im?: number;
    latest_device_info?: LatestDeviceInfo;
    is_blocked?: boolean;
    level?: string;
    created_at?: string;
    updated_at?: string;
    current_ticket_id?: any;
    from?: string;
    lang?: string;
    sdk_token?: any;
    web_token?: string;
    other_web_tokens?: any[];
    open_api_token?: any;
    avatar?: any;
    last_im_robot_session_id?: any;
    description?: string;
    email?: string;
    tags?: string;
    rich_tags?: any[];
    custom_fields?: AnyKey;
    follow_up_updated_at?: any;
    owner_name?: any;
    owner_group_name?: any;
    other_emails?: [number | null, string][];
    cellphones_attributes?: { id?: number; content: string; _destroy?: 1 }[]; ///spa1/customers/:id，这个接口新建修改客户的时候用的是这个 key 代表电话号码
    cellphones?: { id?: number; content: string; _destroy?: 1 }[];
    default_organization_id?: any;
    organizations?: any[];
    uid?: string;
    ticket_count?: number;
    video_records_count?: number;
    calls_count?: number;
    im_sessions_count?: number;
    im_sub_sessions_count?: number;
    weixin_nick_name?: any;
    weixin_avatar?: any;
    weixin_subscribe?: any;
    weixin_subscribe_time?: any;
    weixin_subscribe_from?: any;
    weixin_push?: any;
    weixin_openid?: any;
    unionid?: any;
    weixin_push_time?: any;
    weibo_nick_name?: any;
    weibo_avatar?: any;
    weibo_openid?: any;
    show_api_icon?: boolean;
    can_redirect?: boolean;
    can_merge?: boolean;
    customer_jid?: string;
    weixins?: any[];
    weibos?: any[];
    weixin_minis?: any[];
    qywxes?: any[];
    customer_token?: string;
    contact_im_channels?: any[];
};

type LatestDeviceInfo = {
    os: string;
    browser: string;
    resolution: string;
};

type Organization = {
    id?: number;
    name?: string;
    domains?: string;
    created_at?: string;
    org_email_suffix?: any;
    level?: string;
    custom_fields?: AnyKey;
    description?: string;
    customer_count?: number;
};

interface IColleagueNotice {
    agent_sensitive_word?: boolean;
    agent_sentiment_word?: boolean;
    customer_sensitive_word?: boolean;
    customer_sentiment_word?: boolean;
    desktop_notice?: boolean;
    response_timeout?: boolean;
    sessions_timeout?: boolean;
    survey?: boolean;
}

type IAgentConfig = {
    im_welcomes?: string;
    style?: AgentConfigStyle;
    chatSort?: string;
    visitInfoHide?: string;
    visitor_sort_type?: string;
    smart_assistance_enabled?: boolean;
    isTopImSubSessionIds?: string[];
    knowledge_config?: AgentConfigKnowledgeConfig;
    customImInputHeight?: string;
    visitor_sort_columns?: string;
    monitor_enables?: AgentConfigMonitorEnables;
    company?: AgentConfigCompany;
    agent_tab_config?: AgentTabConfig;
    colleague_notice?: IColleagueNotice;
    real_time_translation: {
        translate_to: any;
        enable?: boolean;
    };
};

type AgentConfigStyle = {
    fontSize: string;
    lineHeight: string;
    fontWeight: string;
    fontStyle: string;
    textDecoration: string;
    color: string;
};

type AgentConfigKnowledgeConfig = {
    expression_public: boolean;
    link_public: boolean;
    question_public: boolean;
    attachment_public: boolean;
    expression_personal: boolean;
    link_personal: boolean;
    question_personal: boolean;
    attachment_personal: boolean;
};

type AgentConfigMonitorEnables = {
    customer_sensitive_word: boolean;
    agent_sensitive_word: boolean;
    customer_sentiment_word: boolean;
    agent_sentiment_word: boolean;
    response_timeout: boolean;
    sessions_timeout: boolean;
    survey: boolean;
};

type AgentConfigCompany = {
    close_remind: boolean;
};
type AgentTabConfig = {
    parallel?: string;
    order?: string[];
    ticketCover?: string;
    visitCover?: string;
    recordCover?: string;
    sortDesc?: boolean;
};

type NewTab = {
    show?: boolean;
    zIndex?: number;
};

type IBelong = 'mine' | 'leave' | 'colleague' | 'queue';

type IChatBase = {
    customer_id: number; // 会话的客户id => 转化为 customer_id
    nick_name: string; // 会话的客户姓名
    avatar: any; // 会话的客户头像
    jid: string; // 会话的客户jid : ejabberd上客户的标识
    platform: string; // 会话的客户渠道
    status: 'online' | 'offline'; // 会话的状态, online|offline
    im_sub_session_id: number; // 会话的im_sub_session_id,唯一
    last_session_24h: boolean; // 会话是否超过24小时标识
    session_key: any; // 会话的session_key, 和 customer_id 标识唯一客户
    message: string; // 会话的最后一条消息, 需要显示在会话列表处
    note_complete: boolean; // 会话是否已经填写了所有的必填信息
    created_at: number; // 会话的创建时间
    updated_at: number; // 会话的更新时间
    lang: string; // 会话的语言
    agent_note_template_id: number; // 会话的业务记录模板id
    level: string; // 会话的客户是否是VIP
    belong: IBelong; // 会话所属: 'mine' | 'leave' | 'colleague' | 'queue'
    agent: any; // 会话身上缓存了当前客户的信息
    selected: boolean; // 会话是否被选中

    noteHasReqField?: boolean; // 会话是否有必填字段
    history?: boolean; // 会话的belong='mine'时, 区分是当前会话还是历史会话
    canSend?: boolean; // 会话是否可以通过xmpp直接发送消息, 目前sdk|web是true
    last_log_rollback?: boolean; // 会话的最后一条小时是否是测回的消息
    invitation?: string; // 会话的三方会话标识
    timeout_mark?: string; // 会话是否触发了首次响应超时
    lock?: boolean; // 会话是否锁定
    can_redirect?: boolean; // 会话是否可以转接
    customer_seq_num?: number; // 会话的客户消息顺序标识
    agent_seq_num?: number; // 会话的客服消息顺序标识
    last_replier?: string | null; // 会话的最后回复人, 客服|客户
    last_reply_time?: number | null; // 会话的最后回复时间
    jid_resource?: string; // 会话渠道是sdk时, 该参数标识sdk多端
    date: number; // 最新消息的时间用来排序
    wait_time: number; // 回话等待时间
    last_customer_resp_at: number; // 客户最新消息
    has_offline_msg?: boolean; // 会话是否有离线消息
    input_text?: string; // 会话框输入的内容
    seq_num?: number; //
    transFrom?: string; // 翻译语言
    agent_translated_text?: string; // 客服输入的翻译
    plugTab?: any; // 会话身上缓存的右侧信息区数据
    ask_transfer?: boolean; //
    _transfer?: boolean; //
    product?: {
        // 会话身上的咨询对象属性
        id: number;
        title?: string;
        url?: string;
        image?: string;
        product_params?: { detail: string };
        customer_id: number;
        created_at: string;
        updated_at: string;
        params: { key: string; val: string }[];
    };
    animated?: string; //会话置顶时的动画效果名称
    isTop?: boolean; //是否是置顶
    loadNote?: boolean;
    newMessage?: any; //xmpp连接后收到的最新一条客户消息
    inputConfig?: any; //输入框配置，显示字体设置和翻译
    _invitation?: boolean; //三方会话邀请方
};

type IMineChat = {
    customer?: any;
    organizations?: any[];
    accessInfo?: any;
    transfer?: boolean; //  会话是否已是转接状态
    customer_driving_close?: boolean; //  会话被客户关闭,但是没有进入历史的中间状态, closeing 状态

    unread?: number;
    isTop?: boolean;
    weixin_openid?: any;
    weibo_openid?: any;
    open_api_token?: any;
    message?: string;
    now?: any;
    rich_tags?: any[];
    version?: any;
    newMsg?: boolean;
    date?: string;
    messages?: any[];
    last_im_session_id?: number; // 上一条客服消息id
    last_im_robot_session_id?: number; // 上一条机器人消息id
    currentLogsCount?: number; // 当前页数
    leave?: boolean;
    colleague?: boolean; // 是否是同事  后期用belong
    innerRemark?: boolean;
    loadedMessages?: any;
    preMsg?: any; // 预知消息内容
    logsMsgs?: any[]; // 处理过分段的当前会话的消息
    logsMsgsCount?: number; // 会话消息的总页数
    isReadMsg?: boolean;
    nowTime?: number;
    lastTime?: number;
    online?: boolean;
    hasSurvey?: boolean; // 是否已经推送满意度
    message_board_id?: any;
    isDeletedCustomer?: boolean;
    jid_resource?: any;
    hasNoResClock?: boolean;
    tryReloadMsgs?: boolean; //
    close_click?: boolean; //
    keyword?: string; //
    useful_link?: string; //
    assignee?: any; //
    _agent_timeout_time?: Date | null;
    timeoutClockNeedClose?: boolean;
    isLoadMsg?: boolean; //是否加载过消息
    has_switch_agent_error_msg?: string;
    statusText?: string;
    statusValue?: ImWorkStatus;
    agent_id?: number;
    sensitive_words?: boolean;
    sentiment_words?: boolean;
    res_sess_timeout?: boolean;
    survey_notice?: boolean;
    push_survey?: boolean;
    loadingText?: boolean;
    sendingState?: 'Typing' | 'CancelTyping' | string;
    sendingTime?: number | null;
    hasAccessInfo?: boolean;
    selectedClz?: string;
    _invitation?: boolean;
    platform?: IPlatform;
    weixin_channel_id?: any; //TODO 弄清楚这个属性干嘛的
    qywx_channel_id?: any; //TODO 弄清楚这个属性干嘛的
    last_log_id?: number; //会话出现在左侧列表时，最后一条消息的id
    belongHistory: IBelong[]; //记录会话 belong 的历史，在某些 belong 里，会因为之前的 belong 导致行为有所不同
    contact_agent_id: number;
} & IChatBase;

type IPlatform =
    | 'web'
    | 'ios' //必然是 sdk
    | 'android' //必然是 sdk
    | 'wechat'
    | 'weibo'
    | 'qywx'
    | 'weixin_mini'
    | '微信'
    | 'api'
    | 'mchat'
    | 'baidubcp'
    | 'sdk'
    | 'line';
type IMessageStatus = 'arrive' | 'off_sending' | 'fail' | 'off_arrive' | 'rollback' | 'sending';
type IMessageType =
    | 'rich'
    | 'message'
    | 'info_transfer'
    | 'info'
    | 'survey'
    | 'close'
    | 'image'
    | 'file'
    | 'form_received'
    | 'form'
    | 'lock'
    | 'struct'
    | 'audio'
    | 'video'
    | 'location'
    | 'info_appoint'
    | 'active_guest'
    | 'start_session'
    | 'vcall'
    | 'product'
    | 'miniprogrampage';

interface IChat {
    // gtlSdkVersion?:(version:string) => string;
    __agent_timer_d?: number;
    _msgNoResTimer?: any;
    accessInfo?: {
        version: any;
        referrer?: string;
        accessUrl?: string;
        accessUrl_desc?: string;
        cur_url?: string;
        cur_url_desc?: string;
        channel?: string;
        searchType?: string;
        src_url?: string;
        keyword: any;
        sysInfo?: string;
        bowserInfo?: string;
        resolution?: string;
        web_plugin_name?: string;
        web_plugin_id?: number;
        h5push?: boolean;
        vistor?: {
            visitor_no: string;
            current_page: string;
            current_title: string;
            created_at?: string;
        };
        platform: string;
        is_web?: boolean;
        ip: string;
        src: string;
        is_sdk: boolean;
        jid_resource: string;
        day_sub_session_count: number;
        queue_name: string;
        session_key: string;
        menu_names: string;
        cur_url_show?: string;
        accessUrl_show?: string;
        src_url_show?: string;
        phoneModal?: string;
        phoneVersion?: string;
        appVersion?: string;
        appName?: string;
        scaleScreen?: string;
        networkStatus?: string;
        carrier?: string;
        is_android?: boolean;
        is_ios?: boolean;
        user_agent?: string;
        is_twitter?: boolean;
        is_wechat?: boolean;
        is_weibo?: boolean;
    };
    agent?: {
        id: number;
        jid?: string;
        nick?: string;
        status?: string;
        name?: string;
        avatar?: string;
        customers_count?: number;
    };
    agent_id?: number;
    agent_note_template_id?: any;
    agent_seq_num?: number;
    agentAvatar?: string;
    agentStatus?: string;
    agentStatusText?: string;
    avatar?: string;
    belong?: string;
    can_redirect?: boolean;
    canSend?: boolean;
    close_click?: boolean;
    closed_at?: string;
    colleague?: boolean;
    company_id?: number;
    contact_agent_id?: number;
    created_at?: any;
    currentLogsCount?: string;
    customer?: Customer;
    customer_driving_close?: boolean;
    customer_id?: number;
    customer_level?: string;
    customer_nick_name?: string;
    customer_seq_num?: number;
    customerInfoTab?: string;
    date?: number;
    description?: string;
    doLastTime?: string;
    email?: string;
    floatMsg?: string;
    has_switch_agent_error_msg?: string;
    hasAccessInfo?: boolean;
    hasNoResClock?: any;
    hasSurvey?: boolean;
    history?: boolean;
    id?: number;
    im_session_id?: number;
    im_sub_session_id?: number;
    innerRemark?: boolean;
    inputText?: string;
    invitation?: string;
    is_android?: boolean;
    is_facebook?: boolean;
    is_ios?: boolean;
    is_sdk?: boolean;
    is_twitter?: boolean;
    is_web?: boolean;
    is_wechat?: boolean;
    is_weibo?: boolean;
    isReadMsg?: boolean;
    isTop?: boolean;
    jid?: string;
    lang?: string;
    last_customer_resp_at?: number;
    last_im_robot_session_id?: any;
    last_im_session_id?: any;
    last_log_at?: string;
    last_log_id?: number;
    last_log_rollback?: boolean;
    last_replier?: string;
    last_reply_time?: string;
    last_session_24h?: boolean;
    leave?: boolean;
    level?: string;
    loadedMessages?: boolean;
    loadNote?: boolean;
    lock?: boolean;
    logsMsgs?: any[];
    logsMsgsCount?: string;
    message?: any;
    message_board_id?: number;
    messages?: any[];
    nick_name?: string;
    note_complete?: boolean;
    note_custom_field?: { custom_fields: { [key: string]: any }; content: any };
    noteHasReqField?: boolean;
    now?: string;
    old_recv_sn?: number;
    online?: boolean;
    online_status?: string;
    open_api_token?: any;
    organization?: string;
    organizations?: { id: number; name: string }[];
    platform?: string;
    plugTab?: {
        name: string;
        text: string;
        active: boolean;
        postMsgEnabled: boolean;
    };
    preMsg?: any;
    product?: {
        id: number;
        title?: string;
        url?: string;
        image?: string;
        product_params?: { detail: string };
        customer_id: number;
        created_at: string;
        updated_at: string;
        params: { key: string; val: string }[];
    };
    reLoadHisMsg?: boolean;
    sdkHasOfflineMsg?: boolean;
    selected?: boolean;
    selectedClz?: string;
    seq_num?: number;
    session_key?: string;
    sessions_timeout_at?: string;
    status?: string;
    statusText?: string;
    statusValue?: string;
    timeout_mark?: string; //用于重新打开页面，判断会话是否过期
    timeoutClockNeedClose?: boolean;
    title?: string;
    tryReloadMsgs?: boolean;
    unread?: number;
    updated_at?: any;
    user_id?: number;
    version?: any;
    wait_time?: number;
    weibo_openid?: any;
    weixin_openid?: any;
    roomId?: string;
}
type Fieldsv2 = {
    name?: string;
    im_show?: boolean;
    cc_show?: boolean;
    mpv_show?: boolean;
    id?: number;
    title?: string;
    field_owner?: string;
    comment?: string;
    customer_permission?: number;
    agent_permission?: number;
    options?: string[];
    select_options?: SelectOptions[];
    view_type?: number;
    full_select?: false;
    content_type: ContentType | TicketContentType;
    parent_checkable?: boolean;
    default_expand_all?: boolean;
    agent_permission?: number;
    comment?: null | string;
    customer_permission?: number;
    templates?: any;
    view_type?: number;
    is_unique?: boolean;
    is_relate_duplicate?: boolean;
    is_search?: boolean;
    field_id?: number;
    field_type: 'SelectField' | 'TextField';
    isRequired?: boolean;
    input_regex?: string;
    input_max?: number;
    help_tip_content?: string;
    help_tip_target?: string;
    input_default?: string;
    input_tip?: string; //placeholder
    rows_line?: number;
    sort_type?: string;
    input_row?: number;
    numberLimitSetting?: {
        intNumber: { checked: boolean; content: string };
        floatNumber: { checked: boolean; content: string };
    };
    addonSetting?: {
        addonBefore: { checked: boolean; content: string };
        addonAfter: { checked: boolean; content: string };
        prefix: { checked: boolean; content: string };
        suffix: { checked: boolean; content: string };
    };
    handleRule?: (rule: any, value: any) => Promise<void>;
    span?: number;
    is_required?: boolean;
};
type ModalType = 'question' | 'attachment' | 'useful_link' | 'robotQuestion';
type Modals = Record<ModalType, any> & { refreshKnowledge: number };
type ImContextProps = {
    page: string; // 使用页面标识"im" | "mpv"
    lang: string; // 语言参数
    isAdmin: boolean; // 是否是超级管理员
    imAgentNoteTemplatesSort: any[]; //  业务记录模板顺序
    customerFieldsAuthority: any; // 客户自定义字段权限
    ticketFieldsAbilities: any; // 自定义字段权限
    companyCategoryConfig: any;
    customerId;
    sessionKey;
    imSubSessionId;
    kmrobot_url: string;
    previewUrl: string;
    vistor_server: string;
    company: Company;
    roleCan: IRoleCan; // 角色权限列表
    user: IUser; // 当前客服
    admin: IAdmin;
    agents?: IAgent[]; // 客服组
    agentGroups: IGroup[]; //负责组
    pluginFilter?: string[];
    customerFieldsv2: Fieldsv2[];
    organizationFieldsv2: Field[];
    noteTemplates: Template[]; //  业务记录模板
    ticketTemplates: Template[]; //  工单模板
    tabPlugins: Tab[]; //  右侧tab标签
    tabsWidth: number; //  右侧tabs总宽度
    getTencentMap: (params: any) => { img_src: string; map_src: string }; //腾讯地图的方法
    companyConfig?: any;
    currentTab?: string;
    agentStatus?: any;
    accessInfo?: AccessInfo;
    agent?: ChatAgent;
    organizations?: Organization[];
    agentConfig: IAgentConfig;
    agentTabConfig?: AgentTabConfig;
    newVisit?: NewTab;
    newTicketReact?: NewTab;
    newRecord?: NewTab;
    plugTab?: PlugTab;
    event: any;
    ticketTab: TicketConfig;
    noteFields?: Field[];
    currentUser?: IUser;
    imNewPlatforms?: any;
    fieldHooks?: IFieldHook[];
    getCompanyCategoryConfig?: () => any;
    smsapp?: any;
    traceOpen?: boolean;
    apiHost?: string;
    chat: IChat;
    modals: Modals;
    sdk?: any;
    token?: any;
    spa1Path?: any;
    credentials?: any;
    template?: {
        record:any,
        customer?:{
            customerInfo?: boolean,
            oldCustomerTemplate: boolean,
            render?:any
        },
        business?:{
            oldBusinessTemplate: boolean,
            render?:any
        }
    };
};
type TicketConfig = {
    tableColumns: any[];
    customerFilters: { name: string; id: string }[];
};
type ContentType =
    | 'link'
    | 'radio'
    | 'datetime'
    | 'text'
    | 'date'
    | 'time'
    | 'checkbox'
    | 'radio_droplist'
    | 'droplistMulti'
    | 'numeric'
    | 'calculate'
    | 'cascade'
    | 'textarea'
    | 'number'
    | 'tag_tree'
    | 'location'
    | 'droplist';

type TicketContentType =
    | 'email'
    | 'org'
    | 'cellphone'
    | 'tag'
    | 'selectSearch'
    | 'agentGroups'
    | 'agent'
    | 'textHasPoint';

interface SelectOptions {
    value: string;
    title: string;
    default?: boolean;
    subs?: SelectOptions[];
    node_type?: 'branch' | 'leaf';
    icon?: string;
    color?: string;
}

interface AntdSelectOptions {
    value: number | string;
    label: string;
    color?: string;
    key?: string;
}

type Field = {
    parent_checkable?: boolean;
    default_expand_all?: boolean;
    agent_permission?: number;
    comment?: null | string;
    customer_permission?: number;
    name?: string;
    select_options?: SelectOptions[];
    templates?: any;
    view_type?: number;
    id?: number;
    title: string;
    field_owner?: 'Ticket';
    content_type: ContentType | TicketContentType;
    is_unique?: boolean;
    is_relate_duplicate?: boolean;
    is_search?: boolean;
    field_id?: number;
    field_type: 'SelectField' | 'TextField';
    isRequired?: boolean;
    input_regex?: string;
    input_max?: number;
    help_tip_content?: string;
    help_tip_target?: string;
    input_default?: string;
    input_tip?: string; //placeholder
    rows_line?: number;
    sort_type?: string;
    input_row?: number;
    numberLimitSetting?: {
        intNumber: { checked: boolean; content: string };
        floatNumber: { checked: boolean; content: string };
    };
    addonSetting?: {
        addonBefore: { checked: boolean; content: string };
        addonAfter: { checked: boolean; content: string };
        prefix: { checked: boolean; content: string };
        suffix: { checked: boolean; content: string };
    };
    handleRule?: (rule: any, value: any) => Promise<void>;
    span?: number;
    im_show?: boolean;
    is_required?: boolean;
};

type UploadImgList = {
    src: string;
    isSelect: boolean;
};

interface ObjectWithIndex extends object {
    [key: string]: any;
}

/** 自定义字段声明 **/

type IFieldBase = {
    label?: string; // 字段名
    id: string; // 字段id
    trigger: 'onChange' | 'onBlur'; // 同 From.item 的 trigger
    value?: string; // 字段值
    type:
        | 'text'
        | 'textarea'
        | 'link'
        | 'number'
        | 'numeric'
        | 'date'
        | 'datetime'
        | 'time'
        | 'location'
        | 'calculate'
        | 'radio'
        | 'droplist'
        | 'droplistMulti'
        | 'cascade'
        | 'checkbox'; // 字段类型
    remark?: string; // 字段描述(暂无用处)
    explain?: string; // 字段直接提示内容: 富文本string
    explainShow?: boolean; // 是否显示字段直接提示
    isRequired?: boolea; // 校验是否必填
    disabled?: boolean; // 是否可编辑
    customValidFn?: (rule: any, value: string) => Promise; // 自定义校验函数
    convertPropsFn?: any; // 自定义传参函数
    isFormItem?: boolean;
    onChange?: (data: any) => void;
    onBlur?: (data: any) => void;
    notUseDefault?: Boolean;
};

type ITextField = IFieldBase & {
    defaultValue?: string; // 字段默认值
    maxLength?: number; // 字段最大输入字符长度
    validReg?: string; // 字段正则验证
    placeholder?: string; // 字段占位符
    onValueChangedByBlur?: (data: any) => void; // 字段失焦时触发
    onValueChanged?: (config: any) => void; // 字段改变时触发
};

type ITextareaField = IFieldBase & {
    defaultValue?: string; // 字段默认值
    maxLength?: number; // 字段最大输入字符长度
    placeholder?: string; // 字段占位符
    onValueChangedByBlur?: (data: any) => void; // 字段失焦时触发
    onValueChanged?: (data: any) => void; // 字段改变时触发
    rowsLine?: number; //行数
    switchFlag?: boolean;
};

type ILinkField = IFieldBase & {
    defaultValue?: string; // 字段默认值
    regLink?: boolean; // 是否开启链接验证
    placeholder?: string; // 字段占位符
    onValueChangedByBlur?: (data: any) => void; // 字段失焦时触发
    onValueChanged?: (data: any) => void; // 字段改变时触发
    switchFlag?: boolean;
};
type ILocation = IFieldBase & {
    defaultValue?: string; // 字段默认值
    placeholder?: string; // 字段占位符
    maxLength?: number; // 字段最大输入字符长度
    rowsLine?: number; //行数
    onValueChangedByBlur?: (data: any) => void; // 字段失焦时触发
    onValueChanged?: (data: any) => void; // 字段改变时触发
    switchFlag?: boolean;
};

type IDate = IFieldBase & {
    value?: moment | null;
    switchFlag?: boolean;
};

type IDatetime = IDate & {};

type ITime = IDate & {};

type INumeric = IFieldBase & {
    defaultValue?: string; // 默认值
    placeholder?: string; // 字段占位符
    integerDigits?: number; // 整数位数
    decimalDigits?: number; //小数位数
    addonBefore?: string | ReactNode; // 外前缀
    addonAfter?: string | ReactNode; // 外后缀
    prefix?: string | ReactNode; // 内前缀
    suffix?: string | ReactNode; // 内后缀
    onValueChangedByBlur?: (data: any) => void; // 字段失焦时触发
    onValueChanged?: (data: any) => void; // 字段改变时触发
};

type INumber = INumeric & {};

type IOptions = {
    icon?: string; // 选项图标(链接地址)
    title: string; // 选项字段名
    bgColor?: string; // 选项背景色
    default?: boolean; // 是否默认选中
    value: string; //选项的值
};

type IDorplist = IFieldBase & {
    options?: IOptions[];
    onValueChanged?: (data: any) => void; // 字段改变时触发
};

type IDorplistMulti = IDorplist & {};
type IRadio = IDorplist & {
    options?: IOptions[];
    arrangement?: 'auto' | 'continuity' | 'wrap'; // 排列方式
    canCancel?: boolean;
};

type ICheckbox = IRadio & {};

type ICascadeOption = {
    label: string; // 级联字段名
    value: string; // 级联字段值
    disabled?: boolean; // 是否禁用
};

type ICascade = IFieldBase & {
    viewType?: number; // 1 老级联 2 新级联
    showType?: 'grade' | 'antd'; // grade 分级引导;  antd antd级联样式
    valueLimit?: 'any' | 'last'; // any 任意一级; last 最末级
    // children?: ICascadeOption[]
    onValueChanged?: (data: any) => void;
};

type IAnyField = ITextField &
    ITextareaField &
    ILinkField &
    IDate &
    IDatetime &
    ITime &
    IDorplist &
    IDorplistMulti &
    IRadio &
    ICheckbox &
    ICascade &
    INumber &
    INumeric;

type ISysField = {
    name: string;
    trigger: 'onChange' | 'onBlur';
    cc_show: boolean;
    im_show: boolean;
};
// 壳的声明
type IFieldItem = {
    layout?: 'horizontal' | 'vertical'; //布局  值: horizontal(水平) | vertical(垂直/默认)
    tooltip?: string; // 帮助提示
    tooltipShow?: boolean; // 是否显示帮助提示
    lines?: 'one' | 'multi'; // 跟随布局还是独占一行
    label: string; // 字段名
    isRequired?: boolean; // 是否必填
    Component?: React.Component | null;
    field: IAnyField;
};

/** 自定义字段声明 end **/

interface IFieldHook {
    id: number;
    name: string;
    field_owner: 'Customer' | 'Ticket';
    trigger_type: 'edit' | 'cc' | 'im';
    trigger_field?: string;
    target_fields: string[];
    active: boolean;
    key: string;
    url: string;
}

interface ITicket {
    id: number;
    agent_group_id: number;
    agent_group_name: string;
    agent_relation_emails: any[];
    agent_replied_at: any;
    all_tags: string;
    assignee_avatar: any;
    assignee_cellphone: any;
    assignee_email: any;
    assignee_id: any;
    assignee_name: any;
    attachments: any[];
    call_direction: string;
    closed_at: any;
    connected_status: string;
    content: string;
    content_type: string;
    created_at: string;
    creator_avatar: any;
    creator_id: number;
    creator_nick_name: string;
    custom_fields: { [customFieldName: string]: string | string[] };
    customer_cellphone: string;
    customer_custom_fields: { [customFieldName: string]: string | string[] };
    customer_description: string;
    customer_email: string;
    customer_id: number;
    customer_is_blocked: boolean;
    customer_lang: string;
    customer_level: string;
    customer_name: string;
    customer_owner_group_id: number;
    customer_owner_group_name: string;
    customer_owner_id: any;
    customer_owner_name: any;
    customer_relation_emails: any[];
    customer_replied_at: string;
    customer_rich_tags: any[];
    customer_telephone: string;
    field_num: string;
    first_assignee_cellphone: any;
    first_assignee_email: string;
    first_assignee_id: number;
    first_assignee_name: string;
    followers: any[];
    forward_email: any;
    historical_cc_agent: any[];
    historical_cc_customer: any[];
    historical_to_agent: any[];
    historical_to_customer: any[];
    im_platform: string;
    im_sub_session_id: number;
    last_closed_operator_name: any;
    last_reply_email: any;
    merchant_sid: any;
    next_ticket_id: any;
    platform_id: number;
    platform_name: string;
    platform_zh_name: string;
    previous_ticket_id: number;
    priority: string;
    priority_id: number;
    replied_at: string;
    replied_by: string;
    replier_id: number;
    replier_type: string;
    resolved_at: any;
    satisfaction: any;
    solved_deadline: any;
    solving_at: any;
    source: string;
    status: string;
    status_id: number;
    subject: string;
    survey_vote_desc: any;
    survey_vote_tags: any;
    tags: any[];
    template: { template_id: number; template_name: string };
    template_id: number;
    ticket_default_email: any;
    ticket_survey_add: boolean;
    timeout_ticket_id: any;
    timeout_ticket_num: any;
    timers: any[];
    updated_at: string;
    web_url: string;
}

interface SelectOption {
    title: string;
    value: string;
    default?: boolean;
    subs?: SelectOption[];
}

interface SelectField {
    id: number;
    title: string;
    name: string;
    field_owner: string;
    content_type: string;
    comment: string | null;
    customer_permission: number;
    agent_permission: number;
    select_options: SelectOption[];
    view_type: number;
}

interface TextField {
    id: number;
    title: string;
    name: string;
    field_owner: string;
    content_type: string;
    comment?: string;
    customer_permission: number;
    agent_permission: number;
    is_unique: boolean;
    is_relate_duplicate: boolean;
    is_search: boolean;
    calculate_result_type?: string;
}

type CustomField = TextField & SelectField;

// visitor 声明
type VisitorStatus =
    | 'online'
    | 'invite'
    | 'invited'
    | 'accepted'
    | 'chatting'
    | 'closed'
    | 'rejected'
    | 'offline'
    | 'force_chat'
    | 'force_chatting'
    | 'leaved'
    | 'transfer_agent';

interface IVisitor {
    status: VisitorStatus;
    [propName: string]: any;
}

type ImWorkStatus = 'busy' | 'online' | 'offline';
