export const sampleFiles = [
  {
    filename: '/tango.config.json',
    code: '{"packages":{"react":{"version":"16.14.0","library":"React","type":"dependency","resources":["https://kcs.t1.in.tryudesk.com/sandbox/unpkg/react@{{version}}/umd/react.development.js"]},"react-dom":{"version":"16.14.0","library":"ReactDOM","type":"dependency","resources":["https://kcs.t1.in.tryudesk.com/sandbox/unpkg/react-dom@{{version}}/umd/react-dom.development.js"]},"react-is":{"version":"16.13.1","library":"ReactIs","type":"dependency","resources":["https://kcs.t1.in.tryudesk.com/sandbox/unpkg/react-is@{{version}}/umd/react-is.production.min.js"]},"styled-components":{"version":"5.1.1","library":"styled","type":"dependency","resources":["https://kcs.t1.in.tryudesk.com/sandbox/unpkg/styled-components@{{version}}/dist/styled-components.min.js"]},"udesk-portal-boot":{"version":"0.2.1-delta4","library":"UdeskBoot","type":"baseDependency","resources":["https://kcs.t1.in.tryudesk.com/sandbox/unpkg-udesk/udesk-portal-boot@{{version}}/dist/boot.min.js"]},"@udesk/portal-components":{"version":"0.0.1","library":"TangoAntd","type":"baseDependency","resources":["https://kcs.t1.in.tryudesk.com/sandbox/unpkg-udesk/@udesk/portal-components@{{version}}/dist/index.js"],"designerResources":["https://kcs.t1.in.tryudesk.com/sandbox/unpkg-udesk/@udesk/portal-components@{{version}}/dist/designer.js"]},"classnames":{"version":"2.3.2","library":"classNames","type":"dependency","resources":["https://kcs.t1.in.tryudesk.com/sandbox/unpkg/classnames@{{version}}/dedupe.js"]}}}',
  },
  {
    filename: '/package.json',
    code: '{"name":"demo","private":true,"dependencies":{"react":"16.14.0","react-dom":"16.14.0","react-is":"16.13.1","styled-components":"5.1.1","udesk-portal-boot":"0.2.1-delta4","@udesk/portal-components":"0.0.1","classnames":"2.3.2"}}',
  },
  { filename: '/README.md' },
  {
    filename: '/src/_layout.js',
    code: "import React from 'react';\nimport Header from './components/header';\nimport Footer from './components/footer';\nimport { definePage } from 'udesk-portal-boot';\nimport { ConfigProvider, ContextDataProvider, When } from '@udesk/portal-components';\n\nclass Layout extends React.Component {\n\n    componentDidUpdate() {\n        let isKcsWeb = window.location.pathname.includes('/site/home');\n        if (udesk.stores.kpAuth.initData?.browserLogo && !isKcsWeb) {\n            // 设置网站图标的URL\n            this.setFavicon(udesk.stores.kpAuth.initData?.browserLogo);\n        }\n        if (udesk.stores.kpAuth.initData?.name && !isKcsWeb) {\n            document.title = udesk.stores.kpAuth.initData?.name;\n        }\n    }\n\n    setFavicon = (url) => {\n        var favicon = document.createElement('link');\n        favicon.rel = 'icon';\n        favicon.type = 'image/png';\n        favicon.href = url;\n        var head = document.querySelector('head');\n        head.appendChild(favicon);\n    }\n\n    render() {\n        return (\n            <ConfigProvider>\n                <ContextDataProvider>\n                    <When test={udesk.stores.kpAuth.initData}>\n                        <Header />\n                        {this.props.children}\n                        <Footer />\n                    </When>\n                </ContextDataProvider>\n            </ConfigProvider>\n        );\n    }\n}\n\nexport default definePage(Layout)\n",
  },
  {
    filename: '/src/index.js',
    code: "import { runApp } from 'udesk-portal-boot';\nimport routes from './routes';\nimport layout from './_layout';\nimport './styles/normalize.css';\nimport './styles/common.css';\n\nconst { bootstrap, mount, unmount } = runApp({\n    boot: {\n        mountElement: document.querySelector('#root'),\n        qiankun: true,\n    },\n\n    router: {\n        config: routes,\n        layout,\n    },\n});\n\nexport {\n    bootstrap, mount, unmount\n}\n",
  },
  {
    filename: '/src/routes.js',
    code: "import Index from './pages/index';\nimport Result from './pages/result'\nimport Detail from './pages/detail'\nimport NotFind from './pages/notFind'\n\nconst routes = [\n    {\n        path: '/portals/:secondaryType/:suffix',\n        exact: true,\n        component: Index,\n        routeName: 'home',\n    },\n    {\n        path: '/portals/:secondaryType/:suffix/result',\n        exact: true,\n        component: Result,\n        routeName: 'searchResult',\n    },\n    {\n        path: '/portals/:secondaryType/:suffix/detail',\n        exact: true,\n        component: Detail,\n        routeName: 'detail',\n    },\n    {\n        component: NotFind,\n        routeName: 'notFind',\n    },\n];\n\n\nexport default routes;\n",
  },
  {
    filename: '/src/components/footer.js',
    code: "import React from 'react';\n// eslint-disable-next-line import/no-unresolved\nimport { definePage } from 'udesk-portal-boot';\nimport '../styles/footer.css';\n\n\nclass Footer extends React.Component {\n\n    render() {\n        const initData = udesk.stores.kpAuth.initData || {};\n\n        return (\n            (!!initData?.companyName || !!initData?.recordNumber) &&\n            (\n                <footer>\n                    <div className='udesk-portal-page-footer'>\n                                <p>{ initData?.companyName || ''} </p>\n                                <p>{  initData?.recordNumber? '网站备案号：'+initData.recordNumber :''}</p>\n                    </div>\n                </footer>\n            )     \n        );\n    }\n}\n\nexport default definePage(Footer);\n",
  },
  {
    filename: '/src/components/header.js',
    code: "import React from 'react';\nimport { definePage } from 'udesk-portal-boot';\nimport '../styles/header.css';\nimport classNames from 'classnames';\n\nclass Header extends React.Component {\n\n    constructor(props) {\n        super(props);\n        this.state = {\n            logoutVisble: false,\n        };\n    }\n\n    onMoouseLogout = () => {\n        this.setState((state) => {\n            return {\n                logoutVisble: !state.logoutVisble,\n            }\n        })\n    }\n\n    handleLogout = () => {\n        udesk.stores.kpAuth.logout();\n    }\n\n    render() {\n        const initData = udesk.stores.kpAuth.initData || {};\n        const user = udesk.stores.kpAuth.user || {};\n\n        let {\n            logoutVisble\n        } = this.state;\n\n        const logoutUlClass = classNames('udesk-portal-page-header-login-ul', {\n            'udesk-portal-page-header-login-ul-active': logoutVisble,\n        });\n        const loginArrowClass = classNames('arrow-down', {\n            'active': logoutVisble,\n        });\n\n        if (window.__POWERED_BY_QIANKUN__) return null;\n\n        return (\n            <header className='udesk-portal-page-header'>\n                <div className='udesk-portal-page-header-logo'>\n                    <img src={initData?.logo || 'https://s4-km-pub-std.oss-cn-hangzhou.aliyuncs.com/img/logo_default.png'} alt='' />\n                    <p>{initData?.name || 'Logo'}</p>\n                </div>\n                {\n                    initData?.scene === 0 &&\n                    (\n                        <div className='udesk-portal-page-header-login'>\n                            <div className='udesk-portal-page-header-login-box' onMouseEnter={this.onMoouseLogout} onMouseLeave={this.onMoouseLogout}>\n                                <div className='udesk-portal-page-header-login-img' >\n                                    <img src={user?.headPortraitUrl || 'https://gw.alipayobjects.com/zos/antfincdn/XAosXuNZyF/BiazfanxmamNRoxxVxka.png'} alt='' />\n                                    <p>{user?.realname || ''}</p>\n                                    <div className={loginArrowClass}></div>\n                                </div>\n                                <ul className={logoutUlClass}>\n                                    <li onClick={this.handleLogout}>退出登录</li>\n                                </ul>\n                            </div>\n                        </div>\n                    )\n                }\n            </header>\n        );\n    }\n\n}\n\nexport default definePage(Header);\n",
  },
  {
    filename: '/src/pages/index.js',
    code: "import React from 'react';\n// eslint-disable-next-line import/no-unresolved\nimport { definePage } from 'udesk-portal-boot';\n// eslint-disable-next-line import/no-unresolved\nimport { Col, Cols, Page, Section, Search, ListCard, HomeDataProvider, Category, SearchTitle } from '@udesk/portal-components';\n\nclass App extends React.Component {\n    componentDidMount() {\n        console.log('componentDidMount', this.props);\n    }\n    render() {\n        return (\n            <HomeDataProvider>\n                <Page p='0 0 40px 0' bg=\"#FFF\">\n                    <Section bg=\"url(https://s4-km-pub-std.oss-cn-hangzhou.aliyuncs.com/img/bg.webp)\" p='148px 0 132px 0' contentMaxWidth='1040px'>\n                        <SearchTitle content=\"有什么可以帮助您的么？\" color='#fff' m='0 0 40px 0' textAlign='center' />\n                        <Search onSearch={() => { }}></Search>\n                    </Section>\n                    <Section bg=\"#FFF\" contentMaxWidth='1040px' title='热门内容' m='80px 0 80px 0'>\n                        <Cols m='24px -12px 0 -12px'>\n                            <Col span={8} m='0 0 24px 0'>\n                                <ListCard\n                                    getList={udesk.stores?.kpHomepage?.newKnowledges}\n                                    maxCount={3}\n                                    title='最新发布'\n                                    icon='https://s4-km-pub-std.oss-cn-hangzhou.aliyuncs.com/img/gride.png'\n                                    m='0 12px 0 12px'\n                                    bg='#fff'\n                                    color='#000'\n                                />\n                            </Col>\n                            <Col span={8} m='0 0 24px 0'>\n                                <ListCard\n                                    getList={udesk.stores?.kpHomepage?.notices}\n                                    maxCount={3}\n                                    title='公告'\n                                    icon='https://s4-km-pub-std.oss-cn-hangzhou.aliyuncs.com/img/common.png'\n                                    m='0 12px 0 12px'\n                                    bg='#fff'\n                                    color='#000'\n                                />\n                            </Col>\n                            <Col span={8} m='0 0 24px 0'>\n                                <ListCard\n                                    getList={udesk.stores?.kpHomepage?.recommendKnowledges}\n                                    maxCount={3}\n                                    title='推荐知识'\n                                    icon='https://s4-km-pub-std.oss-cn-hangzhou.aliyuncs.com/img/hot.png'\n                                    m='0 12px 0 12px'\n                                    bg='#fff'\n                                    color='#000'\n                                />\n                            </Col>\n                            <Col span={8}>\n                                <ListCard\n                                    getList={udesk.stores?.kpHomepage?.userRank}\n                                    maxCount={3}\n                                    title='积分排行'\n                                    icon='https://s4-km-pub-std.oss-cn-hangzhou.aliyuncs.com/img/rank.png'\n                                    m='0 12px 0 12px'\n                                    bg='#fff'\n                                    color='#000'\n                                />\n                            </Col>\n                            <Col span={8}>\n                                <ListCard\n                                    getList={udesk.stores?.kpHomepage?.recommendKnowledges}\n                                    maxCount={3}\n                                    title='新手指南'\n                                    icon='https://s4-km-pub-std.oss-cn-hangzhou.aliyuncs.com/img/new.png'\n                                    m='0 12px 0 12px'\n                                    bg='#fff'\n                                    color='#000'\n                                />\n                            </Col>\n                            <Col span={8}>\n                                <ListCard\n                                    getList={udesk.stores?.kpHomepage?.recommendKnowledges}\n                                    maxCount={3}\n                                    title='新手指南'\n                                    icon='https://s4-km-pub-std.oss-cn-hangzhou.aliyuncs.com/img/notify.png'\n                                    m='0 12px 0 12px'\n                                    bg='#fff'\n                                    color='#000'\n                                />\n                            </Col>\n                        </Cols>\n                    </Section>\n                    <Section bg=\"#FFF\" contentMaxWidth='1040px' title='知识空间' m='80px 0 40px 0'>\n                        <Category m='24px 0 0 0' />\n                    </Section>\n                </Page >\n            </HomeDataProvider>\n        );\n    }\n}\n\nexport default definePage(App);\n",
  },
  {
    filename: '/src/pages/notFind.js',
    code: "import React, { useState, useEffect } from 'react';\nimport { definePage } from 'udesk-portal-boot';\nimport { Col, Cols, Page, Section, Box, List } from '@udesk/portal-components';\nimport '../styles/notFind.less'\n\nfunction NotFind(props) {\n    const defaultErrorImg = 'https://s4-km-pub-std.oss-cn-hangzhou.aliyuncs.com/img/default-404.png';\n    const [errorImg, setErrorImg] = useState('')\n    const goHome = () => {\n        console.log(udesk.stores.kpAuth.initData.errorPage, props.history);\n        // window.location.replace(udesk.stores.kpAuth.initData.fullUrl)\n        // return\n        const targetUrl = udesk.stores.kpAuth.initData.fullUrl || '';\n        if (targetUrl) {\n            window.location.replace(targetUrl);\n        } else { \n            props.history.goBack();\n        }\n    }\n    useEffect(() => { \n        setErrorImg(udesk.stores.kpAuth.initData.errorPage || defaultErrorImg)\n    }, [udesk.stores.kpAuth.initData.errorPage])\n    return (\n        <Page style={{ background: '#fff', width: '100%' }}>\n            <Box className=\"header-blank\"></Box>\n            <Box className=\"not-find-container\">\n                <img src={errorImg} width=\"500px\" />\n                <Box className=\"not-find-content1\">\n                    PAGE NOT FOUND\n                </Box>\n                <Box className=\"not-find-content2\">\n                    抱歉您访问的页面不存在，请确定地址是否有误或者地址已被删除，您可以点击下方回到首页\n                </Box>\n                <Box className=\"not-find-return-btn\" onClick={goHome}>\n                    返回首页\n                </Box>\n            </Box>\n        </Page>\n    );\n}\n\nexport default definePage(NotFind);\n",
  },
  {
    filename: '/src/styles/common.css',
    code: 'section.td-section{\n    background-size: cover;\n    background-position: center;\n}\n.UDESK-PORTAL-PAGE {\n    min-height: calc(100vh - 81px);\n}\n\n::-webkit-scrollbar {\n    background-color: initial;\n}\n::-webkit-scrollbar {\n    width: 0.375rem!important;\n}\n::-webkit-scrollbar {\n    height: 0.375rem!important;\n}\n::-webkit-scrollbar-thumb {\n    background-color: rgb(222 222 222)!important;\n}\n::-webkit-scrollbar-thumb {\n    border-radius: 0.25rem!important;\n}\n::-webkit-scrollbar-track {\n    background-color: rgb(241 245 249)!important;\n}\n::-webkit-scrollbar-track {\n    border-radius: 0.25rem!important;\n}\n',
  },
  {
    filename: '/src/styles/footer.css',
    code: 'footer {\n    width: 100%;\n    border-top: 1px solid rgba(0, 0, 0, 0.15);\n    background: #FFF;\n    padding: 16px 0;\n}\n.udesk-portal-page-footer {\n    max-width: 1040px;\n    margin: 0 auto;\n}\n.udesk-portal-page-footer p {\n    color: rgba(0, 0, 0, 0.45);\n    font-size: 14px;\n    line-height: 24px;\n    text-align: center;\n    margin: 0;\n}\n',
  },
  {
    filename: '/src/styles/header.css',
    code: ".udesk-portal-page-header {\n  position: absolute;\n  left: 0;\n  right: 0;\n  padding: 18px 50px 10px;\n  display: flex;\n  justify-content: space-between;\n  align-items: center;\n}\n.udesk-portal-page-header-logo {\n  display: flex;\n  align-items: center;\n  padding-bottom: 8px;\n}\n.udesk-portal-page-header-logo img {\n  max-width: 80px;\n  max-height: 60px;\n}\n.udesk-portal-page-header-logo p {\n  color: #ffffff;\n  margin: 0 0 0 8px;\n}\n.udesk-portal-page-header-login {\n  color: #fff;\n}\n.udesk-portal-page-header-login-btn {\n  cursor: pointer;\n}\n.udesk-portal-page-header-login-box {\n  position: relative;\n  padding-bottom: 8px;\n}\n.udesk-portal-page-header-login-ul {\n  display: none;\n  position: absolute;\n  list-style: none;\n  padding: 0;\n  top: 48px;\n  left: 0px;\n  z-index: 1000;\n  margin: 0;\n  width: 114px;\n  background-color: #fff;\n  background-clip: padding-box;\n  border-radius: 2px;\n  outline: none;\n  box-shadow: 0 3px 6px -4px rgba(0, 0, 0, 0.12), 0 6px 16px 0 rgba(0, 0, 0, 0.08), 0 9px 28px 8px rgba(0, 0, 0, 0.05);\n}\n.udesk-portal-page-header-login-ul li {\n  text-align: center;\n  line-height: 38px;\n  height: 38px;\n  color: rgba(0, 0, 0, 0.85);\n  cursor: pointer;\n  transition: all 0.2s linear;\n}\n.udesk-portal-page-header-login-ul li::before {\n  content: '';\n  width: 0;\n  height: 0;\n  border-left: 5px solid transparent;\n  border-right: 5px solid transparent;\n  border-bottom: 6px solid #fff;\n  left: 54px;\n  top: -6px;\n  position: absolute;\n}\n.udesk-portal-page-header-login-ul li:hover {\n  background-color: #f5f5f5;\n  color: #2C7CF6;\n}\n.udesk-portal-page-header-login-ul-active {\n  display: block;\n}\n.udesk-portal-page-header-login-img {\n  display: flex;\n  align-items: center;\n}\n.udesk-portal-page-header-login-img img {\n  width: 40px;\n  height: 40px;\n  border-radius: 50%;\n}\n.udesk-portal-page-header-login-img p {\n  color: #ffffff;\n  margin: 0 8px;\n}\n.udesk-portal-page-header-login-img .arrow-down {\n  width: 0;\n  height: 0;\n  border-left: 5px solid transparent;\n  border-right: 5px solid transparent;\n  border-top: 6px solid #fff;\n  transition: transform 0.3s ease-in-out;\n}\n.udesk-portal-page-header-login-img .active {\n  transform: rotate(180deg);\n}\n",
  },
  {
    filename: '/src/styles/normalize.css',
    code: '/*! normalize.css v8.0.1 | MIT License | github.com/necolas/normalize.css */\n\n/* Document\n   ========================================================================== */\n\n/**\n * 1. Correct the line height in all browsers.\n * 2. Prevent adjustments of font size after orientation changes in iOS.\n */\n\nhtml {\n  line-height: 1.15; /* 1 */\n  -webkit-text-size-adjust: 100%; /* 2 */\n}\n\n/* Sections\n   ========================================================================== */\n\n/**\n * Remove the margin in all browsers.\n */\n\nbody {\n  margin: 0;\n}\n\n/**\n * Render the `main` element consistently in IE.\n */\n\nmain {\n  display: block;\n}\n\n/**\n * Correct the font size and margin on `h1` elements within `section` and\n * `article` contexts in Chrome, Firefox, and Safari.\n */\n\nh1 {\n  font-size: 2em;\n  margin: 0.67em 0;\n}\n\n/* Grouping content\n   ========================================================================== */\n\n/**\n * 1. Add the correct box sizing in Firefox.\n * 2. Show the overflow in Edge and IE.\n */\n\nhr {\n  box-sizing: content-box; /* 1 */\n  height: 0; /* 1 */\n  overflow: visible; /* 2 */\n}\n\n/**\n * 1. Correct the inheritance and scaling of font size in all browsers.\n * 2. Correct the odd `em` font sizing in all browsers.\n */\n\npre {\n  font-family: monospace, monospace; /* 1 */\n  font-size: 1em; /* 2 */\n}\n\n/* Text-level semantics\n   ========================================================================== */\n\n/**\n * Remove the gray background on active links in IE 10.\n */\n\na {\n  background-color: transparent;\n}\n\n/**\n * 1. Remove the bottom border in Chrome 57-\n * 2. Add the correct text decoration in Chrome, Edge, IE, Opera, and Safari.\n */\n\nabbr[title] {\n  border-bottom: none; /* 1 */\n  text-decoration: underline; /* 2 */\n  text-decoration: underline dotted; /* 2 */\n}\n\n/**\n * Add the correct font weight in Chrome, Edge, and Safari.\n */\n\nb,\nstrong {\n  font-weight: bolder;\n}\n\n/**\n * 1. Correct the inheritance and scaling of font size in all browsers.\n * 2. Correct the odd `em` font sizing in all browsers.\n */\n\ncode,\nkbd,\nsamp {\n  font-family: monospace, monospace; /* 1 */\n  font-size: 1em; /* 2 */\n}\n\n/**\n * Add the correct font size in all browsers.\n */\n\nsmall {\n  font-size: 80%;\n}\n\n/**\n * Prevent `sub` and `sup` elements from affecting the line height in\n * all browsers.\n */\n\nsub,\nsup {\n  font-size: 75%;\n  line-height: 0;\n  position: relative;\n  vertical-align: baseline;\n}\n\nsub {\n  bottom: -0.25em;\n}\n\nsup {\n  top: -0.5em;\n}\n\n/* Embedded content\n   ========================================================================== */\n\n/**\n * Remove the border on images inside links in IE 10.\n */\n\nimg {\n  border-style: none;\n}\n\n/* Forms\n   ========================================================================== */\n\n/**\n * 1. Change the font styles in all browsers.\n * 2. Remove the margin in Firefox and Safari.\n */\n\nbutton,\ninput,\noptgroup,\nselect,\ntextarea {\n  font-family: inherit; /* 1 */\n  font-size: 100%; /* 1 */\n  line-height: 1.15; /* 1 */\n  margin: 0; /* 2 */\n}\n\n/**\n * Show the overflow in IE.\n * 1. Show the overflow in Edge.\n */\n\nbutton,\ninput { /* 1 */\n  overflow: visible;\n}\n\n/**\n * Remove the inheritance of text transform in Edge, Firefox, and IE.\n * 1. Remove the inheritance of text transform in Firefox.\n */\n\nbutton,\nselect { /* 1 */\n  text-transform: none;\n}\n\n/**\n * Correct the inability to style clickable types in iOS and Safari.\n */\n\nbutton,\n[type="button"],\n[type="reset"],\n[type="submit"] {\n  -webkit-appearance: button;\n}\n\n/**\n * Remove the inner border and padding in Firefox.\n */\n\nbutton::-moz-focus-inner,\n[type="button"]::-moz-focus-inner,\n[type="reset"]::-moz-focus-inner,\n[type="submit"]::-moz-focus-inner {\n  border-style: none;\n  padding: 0;\n}\n\n/**\n * Restore the focus styles unset by the previous rule.\n */\n\nbutton:-moz-focusring,\n[type="button"]:-moz-focusring,\n[type="reset"]:-moz-focusring,\n[type="submit"]:-moz-focusring {\n  outline: 1px dotted ButtonText;\n}\n\n/**\n * Correct the padding in Firefox.\n */\n\nfieldset {\n  padding: 0.35em 0.75em 0.625em;\n}\n\n/**\n * 1. Correct the text wrapping in Edge and IE.\n * 2. Correct the color inheritance from `fieldset` elements in IE.\n * 3. Remove the padding so developers are not caught out when they zero out\n *    `fieldset` elements in all browsers.\n */\n\nlegend {\n  box-sizing: border-box; /* 1 */\n  color: inherit; /* 2 */\n  display: table; /* 1 */\n  max-width: 100%; /* 1 */\n  padding: 0; /* 3 */\n  white-space: normal; /* 1 */\n}\n\n/**\n * Add the correct vertical alignment in Chrome, Firefox, and Opera.\n */\n\nprogress {\n  vertical-align: baseline;\n}\n\n/**\n * Remove the default vertical scrollbar in IE 10+.\n */\n\ntextarea {\n  overflow: auto;\n}\n\n/**\n * 1. Add the correct box sizing in IE 10.\n * 2. Remove the padding in IE 10.\n */\n\n[type="checkbox"],\n[type="radio"] {\n  box-sizing: border-box; /* 1 */\n  padding: 0; /* 2 */\n}\n\n/**\n * Correct the cursor style of increment and decrement buttons in Chrome.\n */\n\n[type="number"]::-webkit-inner-spin-button,\n[type="number"]::-webkit-outer-spin-button {\n  height: auto;\n}\n\n/**\n * 1. Correct the odd appearance in Chrome and Safari.\n * 2. Correct the outline style in Safari.\n */\n\n[type="search"] {\n  -webkit-appearance: textfield; /* 1 */\n  outline-offset: -2px; /* 2 */\n}\n\n/**\n * Remove the inner padding in Chrome and Safari on macOS.\n */\n\n[type="search"]::-webkit-search-decoration {\n  -webkit-appearance: none;\n}\n\n/**\n * 1. Correct the inability to style clickable types in iOS and Safari.\n * 2. Change font properties to `inherit` in Safari.\n */\n\n::-webkit-file-upload-button {\n  -webkit-appearance: button; /* 1 */\n  font: inherit; /* 2 */\n}\n\n/* Interactive\n   ========================================================================== */\n\n/*\n * Add the correct display in Edge, IE 10+, and Firefox.\n */\n\ndetails {\n  display: block;\n}\n\n/*\n * Add the correct display in all browsers.\n */\n\nsummary {\n  display: list-item;\n}\n\n/* Misc\n   ========================================================================== */\n\n/**\n * Add the correct display in IE 10+.\n */\n\ntemplate {\n  display: none;\n}\n\n/**\n * Add the correct display in IE 10.\n */\n\n[hidden] {\n  display: none;\n}\n',
  },
  {
    filename: '/src/styles/notFind.less',
    code: ".header-blank {\n    width: 100%;\n    height: 88px;\n    // background-image: url('https://s4-km-pub-std.oss-cn-hangzhou.aliyuncs.com/img/bg.webp');\n}\n.not-find-container {\n    padding: 150px 0;\n    display: flex;\n    flex-direction: column;\n    // justify-content: center;\n    align-items: center;\n    font-family: PingFang SC;\n    .not-find-content1 {\n        color: #98909070;\n        font-size: 36px;\n        font-weight: 300;\n        line-height: 62px;\n    }\n    .not-find-content2 {\n        font-size: 14px;\n        line-height: 28px;\n        color: grey;\n    }\n    .not-find-return-btn {\n        color: #5e5656;\n        margin-top: 24px;\n        width: 240px;\n        height: 48px;\n        display: flex;\n        justify-content: center;\n        align-items: center;\n        border: 1px solid #ddd;\n        border-radius: 6px;\n        cursor: pointer;\n        &:hover {\n            border-color: #629AFF;\n        }\n    }\n}\n\n",
  },
  {
    filename: '/src/pages/detail/index.js',
    code: "import React from 'react';\nimport { definePage } from 'udesk-portal-boot';\nimport { Page, Box, KnowledgeDetailDataProvider, KnowledgeDetail, DocumentEditorPreview } from '@udesk/portal-components';\nimport './index.less'\n\nfunction KnowledgeDetailMain(props) {\n    // const [knowledgeType, setKnowledgeType] = useState('')\n    // useEffect(() => { \n    //     setKnowledgeType(udesk.stores?.knowledgeDetail?.knowledgeType)\n    // },[udesk.stores?.knowledgeDetail?.knowledgeType])\n    return (\n        <KnowledgeDetailDataProvider>\n            <Page className=\"knowledge-detail-main-page\" style={{ backgroundColor: '#fff', width: '100%' }}>\n                <Box className=\"header-blank\"></Box>\n\n                <Box className=\"knowledge-detail-page\" title=\"DetailPage\">\n                    <Box classname=\"main-page\">\n                        <Box className=\"knowledge-detail-content\">\n                            <Box className=\"knowledge-detail-content\">\n                                {udesk.stores?.knowledgeDetail?.knowledgeType === 'document' ? (\n                                    <div className='udesk-kcs-react-qa-detail'>\n                                        <DocumentEditorPreview />\n                                    </div>\n                                ) : (\n                                    <KnowledgeDetail />\n                                )}\n                            </Box>\n                        </Box>\n                    </Box>\n                </Box>\n            </Page>\n        </KnowledgeDetailDataProvider>\n    );\n}\n\nexport default definePage(KnowledgeDetailMain);\n",
  },
  {
    filename: '/src/pages/detail/index.less',
    code: ".knowledge-detail-main-page {\n    background-color: #fff;\n}\n.header-blank {\n    width: 100%;\n    height: 88px;\n    background-image: url('https://s4-km-pub-std.oss-cn-hangzhou.aliyuncs.com/img/bg.webp');\n}\n.knowledge-detail-page {\n    display: flex;\n    justify-content: center;\n    width: 100%;\n    font-family: PingFang SC;\n    background-color: #fff;\n}\n.main-content {\n    width: 1040px;\n}\n.knowledge-detail-title {\n    width: 100%;\n    .title-text {\n        color: #000;\n        font-size: 32px;\n        font-style: normal;\n        font-weight: 500;\n        line-height: 40px;\n    }\n    .title-base-info {\n        color: rgba(0, 0, 0, 0.45);\n        display: flex;\n        .title-base-info-text {\n            margin-right: 24px;\n            font-size: 14px;\n            font-style: normal;\n            font-weight: 400;\n            line-height: 22px;\n        }\n    }\n}\n.knowledge-detail-content {\n    width: 100%;\n    background-color: #fff;\n    overflow: scroll;\n    &::-webkit-scrollbar {\n        display: none;\n    }\n}\n",
  },
  {
    filename: '/src/pages/result/index.js',
    code: "import React from 'react';\nimport { definePage } from 'udesk-portal-boot';\nimport { Col, Cols, Page, Section, Box, DetailList, Search, SearchResultProvider, CategoryTree, BreadCrumbs, Title } from '@udesk/portal-components';\nimport './index.less'\n\nfunction ResultPage() {\n    return (\n        <SearchResultProvider>\n            <Page className=\"result-page\" title=\"PageTitle\" style={{ backgroundColor: '#fff'}}>\n                <Section\n                    className=\"result-search-container\"\n                    bg=\"url(https://s4-km-pub-std.oss-cn-hangzhou.aliyuncs.com/img/bg.webp)\"\n                    contentMaxWidth='1040px'\n                    p=\"104px 0px 0 0px\">\n                    <Search />\n                </Section>\n\n                <Section className=\"main-page\" p='40px 0 0 0'>\n                    <BreadCrumbs routerArr={[\n                        { type: 'search', name: '知识分类搜索', path: '' }\n                    ]} styles={{ background: '#fff', width: '1040px' }} />\n                    <Box className=\"box-width\">\n                        <Title fontSize='32px' fontWeight={500} lineHeight='40px' m='32px 0 32px 0'>\n                            { udesk.stores.searchResult.knowledgeBaseName || '结果'}\n                        </Title>\n                    </Box>\n                    <Cols className=\"box-width search-result-box\" >\n                        <Col className=\"result-category-box\" span={5}>\n                            <CategoryTree />\n                        </Col>\n                        <Col className=\"result-list-box\" span={18}>\n                            <Box>\n                                <Box className=\"result-content-list\">\n                                    <Col span={24}>\n                                        <DetailList cols={1} flow={'row'} bg=\"#fff\" />\n                                    </Col>\n                                </Box>\n                            </Box>\n                        </Col>\n                    </Cols>\n                </Section>\n            </Page>\n        </SearchResultProvider>\n    );\n}\n\nexport default definePage(ResultPage);\n",
  },
  {
    filename: '/src/pages/result/index.less',
    code: "// .result-page {\n//     background-color: aqua;\n// }\n// .my-section-title {\n//     color: blue;\n// }\n.result-search-box {\n    width: 1040px;\n    height: 120px;\n    background-color: rgb(65, 135, 209)!important;\n    display: flex;\n    justify-content: center;\n    align-items: center;\n    .search-input-container {\n        position: relative;\n        &::before {\n            display: block;\n            content: ' ';\n            position: absolute;\n            top: 20px;\n            left: 20px;\n            width: 24px;\n            height: 24px;\n            // background-image: url(../../statics/search.svg);\n            background-repeat: no-repeat;\n            background-size: cover;\n            z-index: 9;\n        }\n        .result-search-box-input {\n            position: relative;\n            max-width: 1040px;\n            min-width: 1040px;\n            font-size: 18px;\n            line-height: 26px;\n            height: 24px;\n            padding: 19px 19px 19px 60px;\n            border-radius: 4px;\n            border: 1px solid #fff;\n        }\n    }\n}\n.main-page {\n    display: flex;\n    flex-direction: column;\n    align-items: center;\n    background-color: #fff;\n    font-family: PingFang SC;\n    .search-result-box {\n        padding-top: 32px;\n        border-top: 1px solid #eee;\n        .result-category-box {\n            width: 200px;\n            margin-right: 20px;\n            \n        }\n    }\n}\n.box-width {\n    max-width: 1040px;\n    min-width: 1040px;\n}\n",
  },
];
