export const props = {
    page: 'im',
    lang: 'zh-cn',
    isAdmin: false,
    imAgentNoteTemplatesSort: [],
    customerFieldsAuthority: {},
    ticketFieldsAbilities: {},
    companyCategoryConfig: {},
    tabsWidth: 600,
    kmrobot_url: 'https://t2.km.tryudesk.com/api',
    previewUrl: 'https://preview-proxy.t2.udesk.cn/preview',
    vistor_server: 'basevistor.t2.tryudesk.com',
    company: {
        cc_agent_helper: null,
        cc_whole_columns: {
            online_count: true,
            online_duration: false,
            online_avg_duration: true,
            call_duration: false,
            call_avg_duration: true,
            call_duration_rate: false,
            callin_count: true,
            callin_answered_count: true,
            callin_unanswered_count: false,
            callin_messaged_count: false,
            callin_hangup_count: false,
            callin_answered_rate: false,
            callin_satisfaction_count: false,
            callin_satisfaction_rate: false,
            callin_satisfied_count: false,
            callin_satisfied_rate: false,
            callin_dissatisfied_count: false,
            callin_dissatisfied_rate: false,
            callin_delayed_avg_duration: false,
            callin_call_duration: false,
            callin_call_avg_duration: true,
            callin_agent_hangup_count: false,
            callin_agent_hangup_rate: false,
            callin_customer_hangup_count: false,
            callin_customer_hangup_rate: false,
            callout_count: true,
            callout_answered_count: true,
            callout_unanswered_count: false,
            callout_answered_rate: false,
            callout_delayed_avg_duration: false,
            callout_call_duration: false,
            callout_call_avg_duration: true,
            callout_agent_hangup_count: false,
            callout_agent_hangup_rate: false,
            callout_customer_hangup_count: false,
            callout_customer_hangup_rate: false,
        },
        cc_queue_columns: {
            queue_enter_count: true,
            callin_count: true,
            callin_answered_count: true,
            callin_unanswered_count: false,
            callin_messaged_count: false,
            callin_hangup_count: false,
            callin_answered_rate: true,
            callin_satisfaction_count: true,
            callin_satisfaction_rate: false,
            callin_satisfied_count: true,
            callin_satisfied_rate: false,
            callin_dissatisfied_count: false,
            callin_dissatisfied_rate: false,
            callin_delayed_avg_duration: false,
            callin_call_duration: false,
            callin_call_avg_duration: true,
            callin_agent_hangup_count: false,
            callin_agent_hangup_rate: false,
            callin_customer_hangup_count: false,
            callin_customer_hangup_rate: false,
        },
        cc_agent_columns: {
            callin_count: true,
            callin_answered_count: true,
            callin_unanswered_count: false,
            callin_answered_rate: false,
            callin_satisfaction_count: false,
            callin_satisfaction_rate: false,
            callin_satisfied_count: false,
            callin_satisfied_rate: false,
            callin_dissatisfied_count: false,
            callin_dissatisfied_rate: false,
            callin_delayed_avg_duration: false,
            callin_call_duration: false,
            callin_call_avg_duration: true,
            callin_agent_hangup_count: false,
            callin_agent_hangup_rate: false,
            callin_customer_hangup_count: false,
            callin_customer_hangup_rate: false,
            callout_count: true,
            callout_answered_count: true,
            callout_unanswered_count: false,
            callout_answered_rate: false,
            callout_delayed_avg_duration: false,
            callout_call_duration: false,
            callout_call_avg_duration: true,
            callout_agent_hangup_count: false,
            callout_agent_hangup_rate: false,
            callout_customer_hangup_count: false,
            callout_customer_hangup_rate: false,
        },
        im_whole_columns: {
            customer_count: true,
            dialog_count: true,
            dialog_count_customer: false,
            dialog_count_agent: false,
            dialog_count_valid: true,
            customer_message_count: false,
            agent_message_count: false,
            message_count: true,
            message_count_avg: true,
            online_total: true,
            online_total_avg: true,
            busy_total: true,
            busy_total_avg: false,
            vote_count: false,
            vote_count_pct: false,
            option_0_count: false,
            option_0_count_pct: false,
            option_1_count: false,
            option_1_count_pct: false,
            option_2_count: false,
            option_2_count_pct: false,
            option_3_count: false,
            option_3_count_pct: false,
            option_4_count: false,
            option_4_count_pct: false,
        },
        im_agent_columns: {
            customer_count: true,
            dialog_count: true,
            dialog_count_customer: false,
            dialog_count_agent: false,
            dialog_count_valid: true,
            customer_message_count: false,
            agent_message_count: false,
            message_count: true,
            message_count_avg: true,
            online_total: true,
            online_total_pct: false,
            busy_total: true,
            busy_total_pct: false,
            offline_total: false,
            online_at: false,
            last_online_at: false,
            busy_total_avg: false,
            vote_count: false,
            vote_count_pct: false,
            option_0_count: false,
            option_0_count_pct: false,
            option_1_count: false,
            option_1_count_pct: false,
            option_2_count: false,
            option_2_count_pct: false,
            option_3_count: false,
            option_3_count_pct: false,
            option_4_count: false,
            option_4_count_pct: false,
        },
        agent_columns: {
            id: true,
            avatar: true,
            alias: true,
            email: true,
            cellphone: true,
            agent_role: true,
            agent_group: true,
            fixed_voip_id: false,
            fixed_voip_password: false,
        },
        agent_group_columns: {
            id: true,
            name: true,
            agent_count: true,
            agents: false,
            created_at: true,
        },
        switch_anonym: false,
        ticket_whole_columns: {
            agent_count: true,
            ticket_count: true,
            ast_count: true,
            st_count: true,
            ct_count: true,
            ast: true,
            act: true,
        },
        ticket_agent_columns: {
            ticket_count: true,
            st_count: true,
            ct_count: true,
            ast: true,
            act: true,
        },
        charged: true,
        is_customer_owner_on: true,
        call_voice_save_days: 30,
        is_auto_set_call_on: true,
        is_auto_set_im_on: true,
        is_auto_set_ticket_on: true,
        callin_owner_first: true,
        all_agent_quota: 100,
        call_agent_quota: 0,
        im_agent_quota: 0,
        ticket_agent_quota: 0,
        dial_agent_quota: 0,
        system_intergration: true,
        paid: true,
        platform_mpv_open: true,
        is_sms_open: true,
        company_id: 1,
        billing_app_id: '6f0d305b-fca1-4056-65c4-63a7de9f47ec',
        company_name: '沃丰科技-研发-北京-04',
        company_subdomain: 'udesk-rd-bj-04',
        company_code: 'aajd',
        nav_logo_small:
            'https://pro-cs-freq.kefutoutiao.com/account_brower_icon/tid1/08102100011288432_1593590934498_87v9n.jpg',
        nav_logo_normal: null,
        sys_customer_logo: null,
        sys_agent_logo: null,
        cname: null,
        bulletin: '<p>管理员可在管理中心【账户设置】中，编辑公司公告显示内容。</p>',
        is_newbie: false,
        support_email: 'udesk-rd-bj-04@support.udesk.cn',
        forward_emails: [
            'reocar@p7support.udesk.cn',
            'reocar@p8support.udesk.cn',
            'udesk-rd-bj-04@support.udesk.cn',
            'reocar@p10support.udesk.cn',
            'reocar@p11support.udesk.cn',
            'reocar@p12support.udesk.cn',
            'reocar@p13support.udesk.cn',
            'reocar@p15support.udesk.cn',
            'reocar@p16support.udesk.cn',
            'reocar@p17support.udesk.cn',
            'reocar@p18support.udesk.cn',
            'reocar@p19support.udesk.cn',
            'reocar@p20support.udesk.cn',
            'reocar@p21support.udesk.cn',
            'reocar@p22support.udesk.cn',
            'reocar@p23support.udesk.cn',
            'reocar@p24support.udesk.cn',
            'reocar@p25support.udesk.cn',
            'reocar@p26support.udesk.cn',
            'reocar@p27support.udesk.cn',
            'reocar@p28support.udesk.cn',
            'reocar@p29support.udesk.cn',
            'reocar@p30support.udesk.cn',
            'reocar0326@presupport.udesk.cn',
            'udesk-rd-bj-04@support.udesk.cn',
        ],
        expired: false,
        is_broadcast_open: false,
        target_available: true,
        udesk_version: 'pro',
        agent_dashboard: null,
        admin_dashboard: null,
        is_bi_open: true,
        close_reporting: 'none_close',
        is_support_lang: false,
        is_close_sla: true,
        is_ad_task_open: false,
        is_batch_sms_open: false,
        monitor_reload_interval: 1,
        max_inspection_count: 2000,
        open_tutorial: true,
        volcano_monit: {
            panel: 3,
            trend: 3,
            agent: 3,
        },
        position_monit: false,
        after_log_send_xmpp: false,
        hidden_reply_histories: false,
        channel_categories: [
            {
                channel_name: 'baidu',
                channel_url: 'http://pro-cs-freq.oss-cn-hangzhou.aliyuncs.com/imc/headers/baidu.png',
                imc_server: 'https://baseimc-hz.udesk.cn',
            },
            {
                channel_name: 'whats_app',
                channel_url: 'http://pro-cs-freq.oss-cn-hangzhou.aliyuncs.com/imc/headers/Whatsapp.png',
                imc_server: 'https://baseimc-sg.udesk.cn',
            },
            {
                channel_name: 'facebook',
                channel_url: 'http://pro-cs-freq.oss-cn-hangzhou.aliyuncs.com/imc/headers/facebook.png',
                imc_server: 'https://baseimc-sg.udesk.cn',
            },
        ],
        real_time_translation: true,
        category: 'normal',
        vcall: true,
        remote_control: false,
        is_edit_picture: true,
        favicon:
            'https://pro-cs-freq.kefutoutiao.com/account_brower_icon/tid1/08102100011288432_1593590925692_7gcgm.jpg',
        show_paas_financial: true,
        paas_financial_since: '20200601',
        self_financial_before: '20200531',
        survey_option_labels: {
            vote_count: '满意度评价数',
            vote_count_pct: '满意度评价率',
            option_0_count: '超级超级满意3评价数',
            option_0_count_pct: '超级超级满意3评价率',
            option_1_count: '满意2评价数',
            option_1_count_pct: '满意2评价率',
            option_2_count: '一般2评价数',
            option_2_count_pct: '一般2评价率',
            option_3_count: '不满意评价数',
            option_3_count_pct: '不满意评价率',
            option_4_count: '非常不满意评价数',
            option_4_count_pct: '非常不满意评价率',
        },
        survey_options: [
            {
                id: 36,
                text: '超级超级满意3',
            },
            {
                id: 37,
                text: '满意2',
            },
            {
                id: 38,
                text: '一般2',
            },
            {
                id: 39,
                text: '不满意',
            },
        ],
        support_multi_organizations: null,
        single_file_size_limit: 15728640,
        im_single_file_size_limit: 52428800,
        single_ticket_attachment_limit: 52428800,
        total_ticket_attachment_limit: 52428800,
        agent_note_must_fill: false,
        behavior_trace: true,
        customer_order: true,
        customer_order_rule: false,
        field_hooks_token_location: 'body',
        old_message_interface_access: true,
        web_message_display_status: false,
        web_message_display_status_start_at: null,
        image_recognize_text: true,
        react_workbench: true,
        multi_agents_collaboration_enabled: false,
    },
    roleCan: {
        add_new_customer: true,
        customer_import: true,
        customer_show_group: true,
        customer_show_all: true,
        customer_show_personal: true,
        customer_edit_group: true,
        customer_edit_all: true,
        customer_edit_personal: true,
        add_new_tag: true,
        customer_show_cellphone_all: true,
        customer_show_cellphone_group: true,
        customer_show_cellphone_personal: true,
        set_customer_level: true,
        customer_remove: true,
        customer_merge: true,
        callout_task_show_all: false,
        callout_task_show_group: false,
        callout_task_export: true,
        callout_task_redispatch_customers: true,
        customer_edit_passively: true,
        tickets_import_all: true,
        reply_to_customer: true,
        callcenter_queues_monitor: true,
        callcenter_groups_monitor: true,
        callcenter_records_download: true,
        callcenter_call_records_export: true,
        callcenter_note_records_export: true,
        callcenter_missed_callin_records_export: true,
        callout_display_number_edit: true,
        callout_task_customers_export: true,
        callcenter_neaten_time_edit: true,
        callout_neaten_time_edit: true,
        group_neaten_time_edit: true,
        ticket_overview: true,
        ticket_import: true,
        ticket_reports: true,
        ticket_attachments: true,
        ticket_custom_reports: true,
        ticket_custom_reports_edit: true,
        ticket_edit_all_ticket: true,
        ticket_edit_group_ticket: true,
        ticket_edit_agent_ticket: true,
        ticket_edit_none_distribution: false,
        callcenter_monitor: true,
        callcenter_records: true,
        callcenter_records_group: true,
        callcenter_reports: true,
        callcenter_reports_group: true,
        callcenter_reports_user: true,
        callcenter_reports_queue: true,
        callcenter_reports_ivr: true,
        export_cbi_callcenter_reports: true,
        customer_custom_reports: true,
        customer_custom_reports_edit: true,
        call_custom_reports: true,
        call_custom_reports_edit: true,
        callcenter_callcheck: true,
        callcenter_callcheck_group: true,
        callcenter_cases: true,
        im_online_all_monitor: true,
        im_online_group_monitor: true,
        work_log_monitor: true,
        report_work_logs_export: true,
        report_call_records_export: true,
        report_call_quality_score_export: true,
        report_call_case_group_export: true,
        report_im_records_export: true,
        report_im_quality_score_export: true,
        report_im_case_group_export: true,
        report_note_records_monitor_export: true,
        report_knowledge_import: true,
        report_knowledge_export: true,
        knowledge_attachments: true,
        knowledge_create_public: true,
        knowledge_view_public: true,
        knowledge_edit_public: true,
        knowledge_delete_public: true,
        knowledge_export_public: true,
        knowledge_submit_public: true,
        knowledge_review_public: true,
        im_records: true,
        im_session_group_only: true,
        im_records_show_user: false,
        im_workbench_show_all_im_records: true,
        im_workbench_show_group_im_records: false,
        im_workbench_show_user_im_records: false,
        customer_center_show_all_im_records: true,
        customer_center_show_group_im_records: false,
        customer_center_show_user_im_records: false,
        customer_center_show_all_video_records: false,
        customer_center_show_group_video_records: true,
        im_reports: true,
        export_cbi_im_reports: true,
        im_reports_group: true,
        im_reports_user: true,
        im_reports_queue: true,
        im_reports_public_opinion: true,
        im_reports_order: true,
        im_visit_reports: true,
        im_edit_reports: true,
        im_custom_reports: true,
        im_custom_reports_edit: true,
        im_send_emoji: true,
        agent_note_records: true,
        crm_reports: true,
        crm_reports_new: true,
        add_new_organization: true,
        organization_export: true,
        agent_notice_create: true,
        im_guest: true,
        im_guest_record: true,
        im_guest_chat: true,
        im_all_queue_monitor: true,
        im_groups_queue_monitor: true,
        im_all_colleague_monitor: true,
        im_groups_colleague_monitor: true,
        im_realtime_monitor: true,
        im_dialogue_reception_control: true,
        agent_monitor_all: true,
        agent_monitor_group: true,
        im_queue_assign: true,
        im_allow_custom_size: true,
        im_monit_custom_size: true,
        ticket_time_reports: true,
        ticket_time_reports_edit: true,
        im_check_all: true,
        im_check_group: true,
        ticket_show_all: true,
        ticket_show_group: true,
        ticket_show_none_distribution: false,
        im_cases: true,
        set_robot: true,
        defriend_customer: true,
        customer_export: true,
        short_message_records: true,
        short_message_records_group: true,
        short_message_records_personal: true,
        ticket_relate: true,
        sms_template_edit: true,
        ad_task: false,
        batch_sms: false,
        platform_insight: true,
        im_leave_all: true,
        im_leave_group: true,
        im_leave_colleague: true,
        im_leave_self: true,
        im_customer_contact: true,
        remote_control: false,
        im_chat_lock: true,
        qc_task_new: true,
        qc_task_view: true,
        qc_task_manage: true,
        alarm_all: true,
        alarm_group: true,
        alarm_edit: true,
        position_monitor: true,
        position_monitor_share: true,
        im_customer_order: false,
        im_add_to_robot_knowledge: true,
        only_show_self_customer_feed: true,
        only_show_group_customer_feed: false,
        platform_mpv: true,
        ticket_reports_new_all: true,
        ticket_reports_new_group: false,
        ticket_reports_new_agent: false,
        ticket_reports_new_export: true,
        personal_information_edit: true,
        bulk_reply_tickets: true,
        delete_organization: true,
        video_record_show_all: true,
        video_record_show_group: true,
        new_personal_macro: true,
        new_public_macro: false,
        login_through_mobile: true,
        ticket_edit_agent: true,
        ticket_edit_agent_group: true,
        ticket_edit_status: true,
        ticket_edit_acceptor: true,
        ticket_edit_priority: true,
        ticket_delete: true,
        ticket_tag_edit: true,
        admin_custom_field: false,
        admin_edit_personal_macro: true,
        admin_edit_public_macro: true,
        group_admin_user: true,
        group_admin_company: true,
        group_admin_agent_and_group: false,
        helper_center_create_and_edit: true,
        helper_center_other: true,
        platform_im: true,
        platform_call_center: true,
        manage_position_monitor: false,
    },
    user: {
        id: 258301,
        csrf_token: 'lGq1Ep/pnRSApFNHU9/9TADPTVaHV01aSaR5xnoBl2c=',
        email: 'qihaihua@udesk.cn',
        nick_name: 'qihh',
        aliase: 'qihh',
        desc: null,
        cellphone: null,
        signature: null,
        role: 'agent',
        isIM: true,
        isAutoAssign: true,
        c_page_size: 10,
        ticketsColumns: {
            subject: true,
            user_nick_name: true,
            platform_zh_name: true,
            forward_email: false,
            assignee_nick_name: true,
            created_at: false,
            priority_zh_name: true,
            status_zh_name: true,
            combine_content: false,
            call_direction: false,
            connected_status: false,
            user_group_name: true,
            all_tags: false,
            follower_nick_names: false,
            last_replier_nick_name: false,
            replied_at: false,
            solved_deadline: false,
            agent_replied_at: false,
            customer_replied_at: false,
            user_cellphone: false,
            user_telephone: false,
            user_emain: false,
            assignee_email: false,
            assignee_cellphone: false,
            field_num: false,
            template_name: false,
            creator_nick_name: false,
        },
        notesColumns: {
            agent_name: true,
            customer_name: true,
            customer_cellphone: true,
            type: true,
            content: true,
        },
        customersColumns: {
            show_nick_name: true,
            show_email: true,
            show_cellphone: true,
            show_organization: true,
            show_description: false,
            show_owner: true,
            show_owner_group: false,
            show_created_at: false,
            show_updated_at: true,
            is_blocked: false,
            source_channel: false,
            province: false,
            city: false,
            phone_service_provider: false,
            isp: false,
            first_contact_at: false,
            last_contact_at: false,
            contact_count: false,
            first_contact_at_via_phone: false,
            last_contact_at_via_phone: false,
            contact_count_via_phone: false,
            first_contact_at_via_im: false,
            last_contact_at_via_im: false,
            contact_count_via_im: false,
            os: false,
            os_version: false,
            browser: false,
            phone_modal: false,
            show_follow_up_updated_at: false,
            resolution: false,
        },
        organizationColumns: {
            name: true,
            description: true,
            domains: true,
            created_at: true,
        },
        profile: 'all',
        token: 'igx3zBrz4eo24vb5zq75',
        popup_occasion: null,
        call_record_columns: {
            customer: {
                phone: true,
            },
            agent: {
                name: true,
            },
            queue: {
                desc: true,
            },
            call_log: {
                phone_address: true,
                call_type: true,
                seat_type_desc: true,
                result: true,
                sound_url: true,
                durationDesc: true,
                start_time: true,
                delayDesc: true,
                hangup_people: true,
            },
            note: {
                content: true,
                id: true,
            },
        },
        password_will_expired: false,
        password_will_expired_in: 0,
        user_groups: [
            {
                id: 188431,
                name: '齐海华',
            },
        ],
        agent_roles: [
            {
                id: 1,
                name: '客服 ',
            },
            {
                id: 250221,
                name: 'qihh',
            },
        ],
        visited_resources: {},
        im_quick: true,
        avatar: null,
        is_fresh: true,
        isAdmin: false,
        isAgent: true,
        is_open_call: false,
        isCall: false,
        isTicketAgent: false,
        displayCallOutJob: false,
        isMchatAdmin: false,
        isDial: false,
    },
    admin: {
        id: 1,
        email: 'admin@udesk.cn',
        nick_name: 'Alex',
        cellphone: '',
        description: null,
        created_at: '2014-10-14T03:46:58.000+08:00',
        last_sign_in_at: '2020-12-24T10:01:03.000+08:00',
    },
    agents: [
        {
            id: 2,
            email: 'agent@udesk.cn',
            nick_name: '紫薇',
            agent_name_pinyin: 'ziwei',
            aliase: 'bj04-紫薇',
            cellphone: '18627384937',
            availability: true,
            description: '',
            ticket_permission: 0,
            created_at: '2014-10-14T03:47:03.000+08:00',
            availability_updated_at: '2018-10-26T23:54:18.000+08:00',
            is_open_callcenter: true,
            last_sign_in_at: '2020-10-26T16:18:01.000+08:00',
            avatar: 'https://dn-udeskpub.qbox.me/FiDVe7ZX2ocfReCvlbkn8GfmKaMj',
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 27,
                    name: '售后组1',
                },
                {
                    id: 28,
                    name: '北京福瑞林肯中心',
                },
                {
                    id: 30,
                    name: '北京中庆林达林肯中心',
                },
                {
                    id: 118,
                    name: '测试客服组',
                },
                {
                    id: 1715,
                    name: '默认组',
                },
                {
                    id: 64491,
                    name: '紫薇组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 10335,
                    name: '管理员',
                },
            ],
            text: '紫薇',
        },
        {
            id: 3,
            email: 'agent2@udesk.cn',
            nick_name: '叶子',
            agent_name_pinyin: 'yezi',
            aliase: '叶子',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2014-10-14T03:47:03.000+08:00',
            availability_updated_at: '2017-10-13T23:42:38.000+08:00',
            is_open_callcenter: true,
            last_sign_in_at: '2020-09-28T13:34:17.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 118,
                    name: '测试客服组',
                },
                {
                    id: 1715,
                    name: '默认组',
                },
                {
                    id: 227841,
                    name: '云创',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 10335,
                    name: '管理员',
                },
            ],
            text: '叶子',
        },
        {
            id: 3055,
            email: 'zhanghao@sendmai.com',
            nick_name: '张昊',
            agent_name_pinyin: 'zhanghao',
            aliase: '张昊',
            cellphone: '13849512734',
            availability: false,
            description: '',
            ticket_permission: 0,
            created_at: '2015-02-12T15:39:49.000+08:00',
            availability_updated_at: '2015-04-26T20:00:00.000+08:00',
            is_open_callcenter: true,
            last_sign_in_at: null,
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 26,
                    name: '售前组3',
                },
                {
                    id: 27,
                    name: '售后组1',
                },
                {
                    id: 28,
                    name: '北京福瑞林肯中心',
                },
                {
                    id: 29,
                    name: '北京福瑞北苑林肯中心',
                },
                {
                    id: 30,
                    name: '北京中庆林达林肯中心',
                },
                {
                    id: 1715,
                    name: '默认组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 51127,
                    name: '查看全部工单',
                },
            ],
            text: '张昊',
        },
        {
            id: 3056,
            email: 'zhangyuning@sendmai.com',
            nick_name: '张玉宁',
            agent_name_pinyin: 'zhangyuning',
            aliase: '张玉宁',
            cellphone: '15321768954',
            availability: false,
            description: null,
            ticket_permission: 0,
            created_at: '2015-02-12T15:40:43.000+08:00',
            availability_updated_at: '2015-04-26T19:59:44.000+08:00',
            is_open_callcenter: true,
            last_sign_in_at: null,
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 26,
                    name: '售前组3',
                },
                {
                    id: 28,
                    name: '北京福瑞林肯中心',
                },
                {
                    id: 29,
                    name: '北京福瑞北苑林肯中心',
                },
                {
                    id: 1715,
                    name: '默认组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 51127,
                    name: '查看全部工单',
                },
            ],
            text: '张玉宁',
        },
        {
            id: 3057,
            email: 'yangning@sendmai.com',
            nick_name: '杨宁',
            agent_name_pinyin: 'yangning',
            aliase: '杨宁',
            cellphone: '18627364534',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2015-02-12T15:41:12.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: null,
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 1715,
                    name: '默认组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 51127,
                    name: '查看全部工单',
                },
            ],
            text: '杨宁',
        },
        {
            id: 4111,
            email: '515807701@qq.com',
            nick_name: '王明乐',
            agent_name_pinyin: 'wangmingle',
            aliase: '王明乐',
            cellphone: '',
            availability: true,
            description: '',
            ticket_permission: 2,
            created_at: '2015-04-26T19:30:47.000+08:00',
            availability_updated_at: '2015-04-26T20:00:42.000+08:00',
            is_open_callcenter: true,
            last_sign_in_at: '2018-03-02T14:24:00.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 70125,
                    name: 'Miller组',
                },
            ],
            agent_roles: [
                {
                    id: 136032,
                    name: 'IM客服测试',
                },
            ],
            text: '王明乐',
        },
        {
            id: 4821,
            email: 'aaa@daaa.com',
            nick_name: '钟黎明',
            agent_name_pinyin: 'zhongliming',
            aliase: '钟黎明',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2015-06-05T21:28:47.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: null,
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 1715,
                    name: '默认组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 51127,
                    name: '查看全部工单',
                },
            ],
            text: '钟黎明',
        },
        {
            id: 4958,
            email: '58437885@qq.com',
            nick_name: 'weiz',
            agent_name_pinyin: 'weiz',
            aliase: 'weiz',
            cellphone: '',
            availability: true,
            description: 'weizhao',
            ticket_permission: 0,
            created_at: '2015-06-15T15:14:14.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-09-19T16:14:59.000+08:00',
            avatar: '',
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 26,
                    name: '售前组3',
                },
                {
                    id: 1715,
                    name: '默认组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 51127,
                    name: '查看全部工单',
                },
            ],
            text: 'weiz',
        },
        {
            id: 5469,
            email: 'wangleiudesk_reocar@163.com',
            nick_name: '咖啡碱',
            agent_name_pinyin: 'kafeijian',
            aliase: '咖啡碱',
            cellphone: null,
            availability: true,
            description: 'he',
            ticket_permission: 0,
            created_at: '2015-07-09T11:38:23.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: null,
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 1715,
                    name: '默认组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 51127,
                    name: '查看全部工单',
                },
            ],
            text: '咖啡碱',
        },
        {
            id: 6259,
            email: 'wangl@reocar.udesk.cn',
            nick_name: '王雷',
            agent_name_pinyin: 'wanglei',
            aliase: '王雷',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2015-08-11T18:00:12.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2016-06-03T18:53:09.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 1715,
                    name: '默认组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 51127,
                    name: '查看全部工单',
                },
            ],
            text: '王雷',
        },
        {
            id: 7333,
            email: 'xiaolp2@udesk.cn',
            nick_name: '长风大侠',
            agent_name_pinyin: 'changfengdaxia',
            aliase: '长风大侠',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2015-09-30T10:34:44.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: null,
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 1715,
                    name: '默认组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 51127,
                    name: '查看全部工单',
                },
            ],
            text: '长风大侠',
        },
        {
            id: 7988,
            email: 'xiaoqiangudesk_reocar@163.com',
            nick_name: '吕小强',
            agent_name_pinyin: 'lvxiaoqiang',
            aliase: '吕小强',
            cellphone: null,
            availability: true,
            description: 'xiaoqiang',
            ticket_permission: 0,
            created_at: '2015-11-07T16:53:20.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: null,
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 1715,
                    name: '默认组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 51127,
                    name: '查看全部工单',
                },
            ],
            text: '吕小强',
        },
        {
            id: 9867,
            email: 'zhangl_reocar@udesk.cn',
            nick_name: 'zhangl',
            agent_name_pinyin: 'zhangl',
            aliase: 'zhangl',
            cellphone: '',
            availability: true,
            description: '',
            ticket_permission: 0,
            created_at: '2015-12-21T11:09:14.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: null,
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 118,
                    name: '测试客服组',
                },
                {
                    id: 1715,
                    name: '默认组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 51127,
                    name: '查看全部工单',
                },
            ],
            text: 'zhangl',
        },
        {
            id: 12712,
            email: 'xiaohl_reocar@udesk.cn',
            nick_name: 'xiaohl',
            agent_name_pinyin: 'xiaohl',
            aliase: 'xiaohl',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2016-02-16T17:31:49.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: null,
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 1715,
                    name: '默认组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 51127,
                    name: '查看全部工单',
                },
            ],
            text: 'xiaohl',
        },
        {
            id: 14653,
            email: '524495690@qq.com',
            nick_name: '啊啊',
            agent_name_pinyin: 'aa',
            aliase: '啊啊',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2016-03-16T11:11:45.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: null,
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 30,
                    name: '北京中庆林达林肯中心',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 51127,
                    name: '查看全部工单',
                },
            ],
            text: '啊啊',
        },
        {
            id: 33179,
            email: 'houjun@reocar0326.udesk.cn',
            nick_name: '侯军',
            agent_name_pinyin: 'houjun',
            aliase: '侯军',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2016-09-02T20:09:51.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2019-09-03T22:15:24.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 118,
                    name: '测试客服组',
                },
                {
                    id: 1715,
                    name: '默认组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 10335,
                    name: '管理员',
                },
                {
                    id: 51127,
                    name: '查看全部工单',
                },
            ],
            text: '侯军',
        },
        {
            id: 89811,
            email: 'king8@king8.com',
            nick_name: 'king',
            agent_name_pinyin: 'king',
            aliase: 'king',
            cellphone: '18810122237',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2018-07-30T19:08:14.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-08-07T16:47:27.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 83430,
                    name: 'king',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: 'king',
        },
        {
            id: 147391,
            email: 'mashuo_reocar@udesk.cn',
            nick_name: 'mashuo2',
            agent_name_pinyin: 'mashuo2',
            aliase: 'mashuo2',
            cellphone: '18611332147',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2019-06-21T22:27:05.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2019-07-05T21:11:52.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 1715,
                    name: '默认组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: 'mashuo2',
        },
        {
            id: 159261,
            email: 'zhangxs@reocar.udesk.cn',
            nick_name: '张雪松',
            agent_name_pinyin: 'zhangxuesong',
            aliase: '张雪松',
            cellphone: '13683658862',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2019-07-17T00:14:08.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-03-12T16:29:50.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 26,
                    name: '售前组3',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: '张雪松',
        },
        {
            id: 190731,
            email: 'zixinxintian@163.com',
            nick_name: 'wangzhenhua',
            agent_name_pinyin: 'wangzhenhua',
            aliase: 'wangzhenhua',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2019-09-20T23:34:36.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2019-09-20T23:35:00.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 127731,
                    name: '工单组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: 'wangzhenhua',
        },
        {
            id: 244871,
            email: 'sunzhimeng_rd_bj_04@udesk.cn',
            nick_name: 'sunzhimeng',
            agent_name_pinyin: 'sunzhimeng',
            aliase: 'sunzhimeng',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-03-05T10:08:19.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-04-29T11:21:11.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 127731,
                    name: '工单组',
                },
            ],
            agent_roles: [
                {
                    id: 51127,
                    name: '查看全部工单',
                },
            ],
            text: 'sunzhimeng',
        },
        {
            id: 245071,
            email: 'fanjw@udesk-rd-bj-04.udesk.cn',
            nick_name: 'Jevi',
            agent_name_pinyin: 'Jevi',
            aliase: 'Jevi',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-03-05T16:30:04.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-03-05T16:31:36.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 64491,
                    name: '紫薇组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 10335,
                    name: '管理员',
                },
            ],
            text: 'Jevi',
        },
        {
            id: 255871,
            email: 'chengzilong04@udesk.cn',
            nick_name: 'chengzilong',
            agent_name_pinyin: 'chengzilong',
            aliase: 'czl',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-03-30T15:18:01.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-12-24T11:03:00.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 189431,
                    name: '程子龙',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 10335,
                    name: '管理员',
                },
            ],
            text: 'chengzilong',
        },
        {
            id: 258001,
            email: 'zhangshuai_test@udesk.cn',
            nick_name: 'ZS-BJ04-01-NA',
            agent_name_pinyin: 'ZSBJ0401NA',
            aliase: 'zs-bj04-01-ni',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-04-02T10:28:31.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-09-21T11:33:47.000+08:00',
            avatar: 'https://pro-cs-freq.kefutoutiao.com/agent_header/tid1/th_1585794896704_mg5qg.jpg',
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 188231,
                    name: 'ZS坐席组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: 'ZS-BJ04-01-NA',
        },
        {
            id: 258011,
            email: '2082872126@qq.com',
            nick_name: 'ZS-BJ04-02-NA',
            agent_name_pinyin: 'ZSBJ0402NA',
            aliase: 'zs-bj04-02-ni',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-04-02T10:34:18.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-04-08T14:17:22.000+08:00',
            avatar:
                'https://pro-cs-freq.kefutoutiao.com/agent_header/tid1/企业微信截图_15754444072275_1585794921757_3cafh.png',
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 118,
                    name: '测试客服组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: 'ZS-BJ04-02-NA',
        },
        {
            id: 258031,
            email: 'hu1@udesk.cn',
            nick_name: 'hu1',
            agent_name_pinyin: 'hu1',
            aliase: 'hu1',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-04-02T10:42:30.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-05-12T10:13:20.000+08:00',
            avatar: 'https://pro-cs-freq.kefutoutiao.com/upload_image/tid1/udesk_init_key_bg_1585829647360_6t5hs.png',
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 188221,
                    name: '户振华',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: 'hu1',
        },
        {
            id: 258241,
            email: 'chenli_better@163.com',
            nick_name: 'chenli1',
            agent_name_pinyin: 'chenli',
            aliase: 'chenli',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-04-02T13:38:27.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-04-10T17:01:51.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 188441,
                    name: '陈历组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: 'chenli1',
        },
        {
            id: 258301,
            email: 'qihaihua@udesk.cn',
            nick_name: 'qihh',
            agent_name_pinyin: 'qihh',
            aliase: 'qihh',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-04-02T16:04:42.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-12-24T11:30:42.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 188431,
                    name: '齐海华',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 250221,
                    name: 'qihh',
                },
            ],
            text: 'qihh',
        },
        {
            id: 258471,
            email: 'yanxiaxue@udesk.cn',
            nick_name: '颜夏雪',
            agent_name_pinyin: 'yanxiaxue',
            aliase: '颜夏雪',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-04-03T16:39:19.000+08:00',
            availability_updated_at: '2020-04-09T11:54:26.000+08:00',
            is_open_callcenter: true,
            last_sign_in_at: '2020-04-13T09:36:45.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 186951,
                    name: '视频组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: '颜夏雪',
        },
        {
            id: 259201,
            email: 'wangwanda_test@udesk.cn',
            nick_name: 'wangwanda',
            agent_name_pinyin: 'wangwanda',
            aliase: 'wangwanda',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-04-07T13:46:52.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-04-14T13:41:56.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 189451,
                    name: 'wwd',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: 'wangwanda',
        },
        {
            id: 259241,
            email: 'panyu004@udesk.cn',
            nick_name: 'panyu',
            agent_name_pinyin: 'panyu',
            aliase: '123',
            cellphone: '13716779617',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-04-07T15:06:08.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-04-11T10:08:33.000+08:00',
            avatar: 'https://pro-cs-freq.kefutoutiao.com/upload_image/tid1/头像3_1586571272974_cpre9.jpg',
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 26,
                    name: '售前组3',
                },
                {
                    id: 189581,
                    name: '潘宇组',
                },
            ],
            agent_roles: [
                {
                    id: 10335,
                    name: '管理员',
                },
            ],
            text: 'panyu',
        },
        {
            id: 259671,
            email: 'caoyang1@udesk.cn',
            nick_name: '曹阳',
            agent_name_pinyin: 'caoyang',
            aliase: '曹阳',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-04-07T16:32:55.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-04-07T17:04:43.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 186951,
                    name: '视频组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: '曹阳',
        },
        {
            id: 262061,
            email: 'wangkai@udesk.com',
            nick_name: 'wangkai',
            agent_name_pinyin: 'xiaolongge',
            aliase: 'wangkai',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-04-13T12:08:26.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-05-08T18:18:49.000+08:00',
            avatar: 'https://pro-cs-freq.kefutoutiao.com/upload_image/tid1/WechatIMG23_1587385292573_gn98g.png',
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 186951,
                    name: '视频组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: 'wangkai',
        },
        {
            id: 262921,
            email: '1980147302@qq.com',
            nick_name: 'kk12333333333333333',
            agent_name_pinyin: 'kk',
            aliase: 'kk',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-04-14T20:05:24.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-11-05T16:35:31.000+08:00',
            avatar:
                'https://pro-cs-freq.kefutoutiao.com/agent_header/tid1/企业微信截图_15712823107043_1586865579988_33b9j.png',
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 210231,
                    name: 'kk',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: 'kk12333333333333333',
        },
        {
            id: 263891,
            email: 'wuqiang@udesk.com',
            nick_name: 'wuqiang',
            agent_name_pinyin: 'wuqiang',
            aliase: 'wuqiang',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 2,
            created_at: '2020-04-16T09:56:22.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-05-18T11:54:12.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 191511,
                    name: '商务销售体验组（勿删）',
                },
            ],
            agent_roles: [
                {
                    id: 251521,
                    name: '视频客服（体验-勿删）',
                },
            ],
            text: 'wuqiang',
        },
        {
            id: 264901,
            email: 'zhaoxiangyu@udesk.com',
            nick_name: 'zhaoxiangyu',
            agent_name_pinyin: 'zhaoxiangyu',
            aliase: 'zhaoxiangyu',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-04-17T15:14:10.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-07-10T09:54:54.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 1715,
                    name: '默认组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: 'zhaoxiangyu',
        },
        {
            id: 265161,
            email: 'spkftest1@udesk.cn',
            nick_name: 'spkftest1',
            agent_name_pinyin: 'spkftest1',
            aliase: 'spkftest1',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 2,
            created_at: '2020-04-20T09:55:42.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-07-30T14:03:59.000+08:00',
            avatar: 'https://pro-cs-freq.kefutoutiao.com/upload_image/tid1/WX20200420-101021_1587348643309_68kl8.png',
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 192621,
                    name: '视频客服test1',
                },
            ],
            agent_roles: [
                {
                    id: 251521,
                    name: '视频客服（体验-勿删）',
                },
            ],
            text: 'spkftest1',
        },
        {
            id: 265191,
            email: 'spkftest2@udesk.cn',
            nick_name: 'spkftest2',
            agent_name_pinyin: 'spkftest2',
            aliase: 'spkftest2',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 2,
            created_at: '2020-04-20T10:17:57.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-11-02T09:33:24.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 192631,
                    name: '视频客服test2',
                },
            ],
            agent_roles: [
                {
                    id: 251521,
                    name: '视频客服（体验-勿删）',
                },
            ],
            text: 'spkftest2',
        },
        {
            id: 265591,
            email: 'spkftest3@udesk.cn',
            nick_name: 'spkftest3',
            agent_name_pinyin: 'spkftest3',
            aliase: 'spkftest3',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 2,
            created_at: '2020-04-20T15:56:14.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-04-29T11:49:17.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 192871,
                    name: '视频客服test3',
                },
            ],
            agent_roles: [
                {
                    id: 251521,
                    name: '视频客服（体验-勿删）',
                },
            ],
            text: 'spkftest3',
        },
        {
            id: 267351,
            email: 'spkftest4@udesk.cn',
            nick_name: 'spkftest4',
            agent_name_pinyin: 'spkftest4',
            aliase: 'spkftest4',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 2,
            created_at: '2020-04-22T14:57:06.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-04-22T15:02:18.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 194481,
                    name: '视频客服test4',
                },
            ],
            agent_roles: [
                {
                    id: 251521,
                    name: '视频客服（体验-勿删）',
                },
            ],
            text: 'spkftest4',
        },
        {
            id: 271341,
            email: '982850253@qq.com',
            nick_name: '李宏卓',
            agent_name_pinyin: 'lihongzhuo',
            aliase: '李宏卓',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-04-30T10:25:50.000+08:00',
            availability_updated_at: '2020-05-06T14:24:14.000+08:00',
            is_open_callcenter: true,
            last_sign_in_at: '2020-06-05T11:28:49.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 198001,
                    name: '李宏卓组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: '李宏卓',
        },
        {
            id: 272131,
            email: 'qiaofuhui@udesk.com',
            nick_name: '乔福辉',
            agent_name_pinyin: 'qiaofuhui',
            aliase: '乔福辉',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-04-30T16:58:53.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-06-02T09:52:01.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 190741,
                    name: '乔福辉组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: '乔福辉',
        },
        {
            id: 274111,
            email: 'sunjing@udesk.com',
            nick_name: 'sun jing',
            agent_name_pinyin: 'sunjing',
            aliase: 'sun jing',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-05-09T14:31:17.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-09-02T10:32:43.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 199821,
                    name: '孙静组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: 'sun jing',
        },
        {
            id: 274141,
            email: 'zhangyi@test.udesk.cn',
            nick_name: '张奕',
            agent_name_pinyin: 'zhangyi',
            aliase: '张奕',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-05-09T17:25:46.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-12-04T10:11:17.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 199811,
                    name: '林肯组',
                },
                {
                    id: 267951,
                    name: '张奕组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 10335,
                    name: '管理员',
                },
                {
                    id: 248921,
                    name: '视频客服',
                },
            ],
            text: '张奕',
        },
        {
            id: 278411,
            email: 'yangqiang@udesk.com',
            nick_name: '杨强',
            agent_name_pinyin: 'yangqiang',
            aliase: '杨强',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-05-19T11:55:38.000+08:00',
            availability_updated_at: '2020-10-13T18:46:53.000+08:00',
            is_open_callcenter: true,
            last_sign_in_at: '2020-12-23T11:16:10.000+08:00',
            avatar: 'https://pro-cs-freq.kefutoutiao.com/upload_image/tid1/考勤证明照片_1604559738606_0uceg.jpeg',
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 202641,
                    name: '杨强组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: '杨强',
        },
        {
            id: 280561,
            email: 'liuqiang@udesk.com',
            nick_name: '刘强',
            agent_name_pinyin: 'liuqiang',
            aliase: '刘强',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-05-21T16:27:45.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-10-20T16:33:09.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 203501,
                    name: '刘强组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 262821,
                    name: '刘强测试',
                },
            ],
            text: '刘强',
        },
        {
            id: 281071,
            email: 'hudie@udesk.com',
            nick_name: '胡碟',
            agent_name_pinyin: 'hudie',
            aliase: '胡碟',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-05-22T17:56:40.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-05-22T18:04:46.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 203951,
                    name: '胡碟组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: '胡碟',
        },
        {
            id: 281081,
            email: 'lhz-bj-04@udesk.cn',
            nick_name: 'lhz',
            agent_name_pinyin: 'lhz',
            aliase: 'lhz',
            cellphone: '1902930',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-05-22T18:21:12.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-05-22T18:23:01.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 203961,
                    name: 'lhz',
                },
            ],
            agent_roles: [
                {
                    id: 260391,
                    name: 'lhz',
                },
            ],
            text: 'lhz',
        },
        {
            id: 281111,
            email: 'testn@udesk.com',
            nick_name: '张三',
            agent_name_pinyin: 'zhangsan',
            aliase: '张三',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-05-23T11:47:35.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: null,
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 203981,
                    name: 'TestGroup',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: '张三',
        },
        {
            id: 282081,
            email: 'zhangyu@udesk.com',
            nick_name: '张昱',
            agent_name_pinyin: 'zhangyu',
            aliase: '张昱',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-05-26T11:23:07.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-07-15T15:46:45.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 204821,
                    name: '张昱组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: '张昱',
        },
        {
            id: 288581,
            email: 'tengzijing@udesk.cn',
            nick_name: '滕子京',
            agent_name_pinyin: 'tengzijing',
            aliase: '京京',
            cellphone: '14555555555',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-06-04T16:48:13.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-12-21T14:46:20.000+08:00',
            avatar: 'https://pro-cs-freq.kefutoutiao.com/upload_image/tid1/Koala_1591964545440_pmvdo.jpg',
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 209111,
                    name: '京京组',
                },
                {
                    id: 210231,
                    name: 'kk',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: '滕子京',
        },
        {
            id: 288681,
            email: '1980147309@qq.com',
            nick_name: 'm',
            agent_name_pinyin: 'm',
            aliase: 'd',
            cellphone: '13131900266',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-06-04T20:11:21.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-06-04T20:14:55.000+08:00',
            avatar:
                'https://pro-cs-freq.kefutoutiao.com/agent_header/tid1/企业微信截图_15712823107043_1591272633805_tou6o.png',
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 210231,
                    name: 'kk',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: 'm',
        },
        {
            id: 308331,
            email: 'caozhihao@udesk.com',
            nick_name: 'caozhihao',
            agent_name_pinyin: 'caozhihao',
            aliase: 'caozhihao',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-07-06T15:38:47.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-07-28T18:27:31.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 223231,
                    name: '曹志豪组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: 'caozhihao',
        },
        {
            id: 310591,
            email: 'tianshuangwei@udesk.com',
            nick_name: 'tianshuangwei',
            agent_name_pinyin: 'tianshuangwei',
            aliase: 'tianshuangwei',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-07-08T14:34:40.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-07-28T17:10:27.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 224331,
                    name: '田霜维组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: 'tianshuangwei',
        },
        {
            id: 313701,
            email: 'zhudongliang@udesk.com',
            nick_name: 'zhudongliang',
            agent_name_pinyin: 'zhudongliang',
            aliase: 'zhudongliang',
            cellphone: '111',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-07-15T15:47:02.000+08:00',
            availability_updated_at: '2020-07-18T14:58:00.000+08:00',
            is_open_callcenter: true,
            last_sign_in_at: '2020-08-28T16:01:59.000+08:00',
            avatar: '',
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 227221,
                    name: '祝栋梁组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: 'zhudongliang',
        },
        {
            id: 314511,
            email: 'test2@udesk.com',
            nick_name: 'test2',
            agent_name_pinyin: 'test2',
            aliase: 'test2',
            cellphone: '1565',
            availability: false,
            description: null,
            ticket_permission: 0,
            created_at: '2020-07-17T09:23:24.000+08:00',
            availability_updated_at: '2020-07-17T09:35:10.000+08:00',
            is_open_callcenter: true,
            last_sign_in_at: '2020-07-30T15:08:07.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 227841,
                    name: '云创',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: 'test2',
        },
        {
            id: 318401,
            email: 'tengxiaojing@udesk.cn',
            nick_name: '滕晓静',
            agent_name_pinyin: 'tengxiaojing',
            aliase: '小静',
            cellphone: '13455555555',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-07-23T11:07:32.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-12-21T14:48:38.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 210231,
                    name: 'kk',
                },
                {
                    id: 230091,
                    name: '权限一组',
                },
            ],
            agent_roles: [
                {
                    id: 10335,
                    name: '管理员',
                },
            ],
            text: '滕晓静',
        },
        {
            id: 318741,
            email: 'songhp@bj-04.udesk.cn',
            nick_name: '宋',
            agent_name_pinyin: 'song',
            aliase: '海鹏',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-07-23T13:40:50.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-09-22T22:31:47.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 27,
                    name: '售后组1',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: '宋',
        },
        {
            id: 322791,
            email: 'xuqi@sknature.com',
            nick_name: 'Nicole',
            agent_name_pinyin: 'Nicole',
            aliase: 'Nicole',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 2,
            created_at: '2020-07-28T17:20:44.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: false,
            last_sign_in_at: null,
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 186951,
                    name: '视频组',
                },
            ],
            agent_roles: [
                {
                    id: 248921,
                    name: '视频客服',
                },
            ],
            text: 'Nicole',
        },
        {
            id: 323881,
            email: 'mengmeng@udesk.cn',
            nick_name: '梦梦',
            agent_name_pinyin: 'mengmeng',
            aliase: '梦梦',
            cellphone: '172322',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-07-30T10:11:05.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-08-03T09:26:13.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 232891,
                    name: '梦梦组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: '梦梦',
        },
        {
            id: 360221,
            email: 'yangqiang2@udesk.com',
            nick_name: 'Yangqiang2',
            agent_name_pinyin: 'Yangqiang',
            aliase: 'Hubery',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-09-22T16:08:55.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-09-22T16:29:29.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 268141,
                    name: '杨强组2',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: 'Yangqiang2',
        },
        {
            id: 363851,
            email: 'wangmingle@udesk.cn',
            nick_name: '王明乐',
            agent_name_pinyin: 'wangmingle',
            aliase: '王明乐',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-09-27T20:43:02.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-09-27T20:43:35.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 1715,
                    name: '默认组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
                {
                    id: 10335,
                    name: '管理员',
                },
            ],
            text: '王明乐',
        },
        {
            id: 374811,
            email: 'yansunbing@udesk.cn',
            nick_name: 'KUKA专家客服1011',
            agent_name_pinyin: 'yansunbing',
            aliase: 'yangsunbing',
            cellphone: '',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-10-28T10:23:49.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-12-23T14:20:52.000+08:00',
            avatar: '',
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 258981,
                    name: '库卡组',
                },
            ],
            agent_roles: [
                {
                    id: 1,
                    name: '客服 ',
                },
            ],
            text: 'KUKA专家客服1011',
        },
        {
            id: 375471,
            email: 'tengjingjing@udesk.cn',
            nick_name: '滕晶晶',
            agent_name_pinyin: 'tengjingjing',
            aliase: '小晶晶',
            cellphone: '14555555556',
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-10-29T14:05:08.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-10-29T14:05:13.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 230101,
                    name: '权限贰组',
                },
            ],
            agent_roles: [
                {
                    id: 10335,
                    name: '管理员',
                },
            ],
            text: '滕晶晶',
        },
        {
            id: 385221,
            email: 'zhaonana04@udesk.cn',
            nick_name: 'zhaonana04',
            agent_name_pinyin: 'zhaonana04',
            aliase: 'zhaonana04',
            cellphone: null,
            availability: true,
            description: null,
            ticket_permission: 0,
            created_at: '2020-11-23T13:52:47.000+08:00',
            availability_updated_at: null,
            is_open_callcenter: true,
            last_sign_in_at: '2020-11-23T13:53:35.000+08:00',
            avatar: null,
            agent_invalid: false,
            fixed_voip_id: null,
            fixed_voip_password: null,
            user_groups: [
                {
                    id: 265371,
                    name: 'zhaonana专用组',
                },
            ],
            agent_roles: [
                {
                    id: 10335,
                    name: '管理员',
                },
            ],
            text: 'zhaonana04',
        },
    ],
    agentGroups: [
        {
            id: 26,
            name: '售前组3',
            description: '售前服务',
            created_at: '2015-02-13T13:02:44.000+08:00',
            ytxapp_queue_type: 1000,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 27,
            name: '售后组1',
            description: '售后服务',
            created_at: '2015-02-13T13:02:55.000+08:00',
            ytxapp_queue_type: 1001,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 28,
            name: '北京福瑞林肯中心',
            description: '处理安卓系统相关问题',
            created_at: '2015-02-13T14:18:06.000+08:00',
            ytxapp_queue_type: 1002,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 29,
            name: '北京福瑞北苑林肯中心',
            description: '售后服务',
            created_at: '2015-02-13T18:12:47.000+08:00',
            ytxapp_queue_type: 1003,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 30,
            name: '北京中庆林达林肯中心',
            description: '为客户提供技术支持。',
            created_at: '2015-02-13T18:14:02.000+08:00',
            ytxapp_queue_type: 1004,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 118,
            name: '测试客服组',
            description: '',
            created_at: '2015-04-26T19:59:24.000+08:00',
            ytxapp_queue_type: 1005,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 1715,
            name: '默认组',
            description: '员工初始化时均属于该组。',
            created_at: '2015-12-30T22:08:41.000+08:00',
            ytxapp_queue_type: 1006,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 64491,
            name: '紫薇组',
            description: null,
            created_at: '2017-12-11T23:31:34.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 70125,
            name: 'Miller组',
            description: null,
            created_at: '2018-03-02T14:22:49.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 83430,
            name: 'king',
            description: null,
            created_at: '2018-07-30T19:06:27.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 127731,
            name: '工单组',
            description: null,
            created_at: '2019-07-05T21:10:37.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 186951,
            name: '视频组',
            description: null,
            created_at: '2020-03-30T15:16:59.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 188221,
            name: '户振华',
            description: null,
            created_at: '2020-04-02T10:40:02.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 188231,
            name: 'ZS坐席组',
            description: null,
            created_at: '2020-04-02T10:48:20.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 188411,
            name: '刘清鑫',
            description: null,
            created_at: '2020-04-02T15:09:53.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 188431,
            name: '齐海华',
            description: null,
            created_at: '2020-04-02T16:05:18.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 188441,
            name: '陈历组',
            description: null,
            created_at: '2020-04-02T16:19:02.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 189431,
            name: '程子龙',
            description: null,
            created_at: '2020-04-07T11:11:31.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 189451,
            name: 'wwd',
            description: null,
            created_at: '2020-04-07T13:47:13.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 189581,
            name: '潘宇组',
            description: null,
            created_at: '2020-04-07T15:15:59.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 190741,
            name: '乔福辉组',
            description: null,
            created_at: '2020-04-13T12:10:04.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 191511,
            name: '商务销售体验组（勿删）',
            description: null,
            created_at: '2020-04-16T09:54:33.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 192621,
            name: '视频客服test1',
            description: null,
            created_at: '2020-04-20T10:49:48.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 192631,
            name: '视频客服test2',
            description: null,
            created_at: '2020-04-20T10:51:13.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 192871,
            name: '视频客服test3',
            description: null,
            created_at: '2020-04-20T15:55:38.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 194481,
            name: '视频客服test4',
            description: null,
            created_at: '2020-04-22T14:56:03.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 198001,
            name: '李宏卓组',
            description: null,
            created_at: '2020-04-30T10:26:14.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 199811,
            name: '林肯组',
            description: null,
            created_at: '2020-05-11T15:39:12.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 199821,
            name: '孙静组',
            description: null,
            created_at: '2020-05-11T15:51:24.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 202641,
            name: '杨强组',
            description: null,
            created_at: '2020-05-19T11:54:41.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 203501,
            name: '刘强组',
            description: null,
            created_at: '2020-05-21T16:26:01.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 203951,
            name: '胡碟组',
            description: null,
            created_at: '2020-05-22T17:54:58.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 203961,
            name: 'lhz',
            description: null,
            created_at: '2020-05-22T18:21:22.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 203981,
            name: 'TestGroup',
            description: null,
            created_at: '2020-05-23T10:59:24.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 204821,
            name: '张昱组',
            description: null,
            created_at: '2020-05-26T11:22:23.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 209111,
            name: '京京组',
            description: null,
            created_at: '2020-06-04T16:42:27.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 210231,
            name: 'kk',
            description: null,
            created_at: '2020-06-08T17:01:03.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 223231,
            name: '曹志豪组',
            description: null,
            created_at: '2020-07-06T15:37:47.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 224331,
            name: '田霜维组',
            description: null,
            created_at: '2020-07-08T14:33:10.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 227221,
            name: '祝栋梁组',
            description: null,
            created_at: '2020-07-15T15:44:31.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 227841,
            name: '云创',
            description: null,
            created_at: '2020-07-16T18:03:51.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 230091,
            name: '权限一组',
            description: null,
            created_at: '2020-07-23T11:07:53.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 230101,
            name: '权限贰组',
            description: null,
            created_at: '2020-07-23T11:08:04.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 232891,
            name: '梦梦组',
            description: null,
            created_at: '2020-07-30T10:07:34.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 258981,
            name: '库卡组',
            description: null,
            created_at: '2020-10-28T10:22:47.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 265371,
            name: 'zhaonana专用组',
            description: null,
            created_at: '2020-11-23T13:53:06.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 267951,
            name: '张奕组',
            description: null,
            created_at: '2020-12-04T10:15:43.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
        {
            id: 268141,
            name: '杨强组2',
            description: null,
            created_at: '2020-12-05T14:57:16.000+08:00',
            ytxapp_queue_type: null,
            agents_count: 0,
            customers_count: 0,
        },
    ],
    customerFieldsv2: [
        {
            name: 'name',
            im_show: true,
            cc_show: true,
            mpv_show: false,
        },
        {
            name: 'cellphone',
            im_show: false,
            cc_show: true,
            mpv_show: false,
        },
        {
            name: 'TextField_2358',
            im_show: false,
            cc_show: true,
            mpv_show: true,
            id: 2358,
            title: '微信',
            field_owner: 'Customer',
            content_type: 'text',
            comment: null,
            customer_permission: 0,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'TextField_122871',
            im_show: true,
            cc_show: true,
            mpv_show: true,
            id: 122871,
            title: '已购产品',
            field_owner: 'Customer',
            content_type: 'text',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'SelectField_72411',
            im_show: true,
            cc_show: true,
            mpv_show: true,
            id: 72411,
            title: '客户地址',
            field_owner: 'Customer',
            content_type: 'chained_droplist',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            options: [
                ['北京市', [['海淀区', [['知春路']]]]],
                ['天津市', [['和平区']]],
            ],
            select_options: [
                {
                    title: '北京市',
                    value: '0',
                    subs: [
                        {
                            title: '海淀区',
                            value: '0',
                            subs: [
                                {
                                    title: '知春路',
                                    value: '0',
                                },
                            ],
                        },
                    ],
                },
                {
                    title: '天津市',
                    value: '1',
                    subs: [
                        {
                            title: '和平区',
                            value: '0',
                        },
                    ],
                },
            ],
            view_type: 0,
            full_select: false,
        },
        {
            name: 'email',
            im_show: false,
            cc_show: true,
            mpv_show: false,
        },
        {
            name: 'description',
            im_show: true,
            cc_show: false,
            mpv_show: false,
        },
        {
            name: 'tags',
            im_show: true,
            cc_show: true,
            mpv_show: false,
        },
        {
            name: 'organization',
            im_show: false,
            cc_show: true,
            mpv_show: false,
        },
        {
            name: 'TextField_120',
            im_show: true,
            cc_show: true,
            mpv_show: false,
            id: 120,
            title: '超链接字段1',
            field_owner: 'Customer',
            content_type: 'link',
            comment: '超链接字段1',
            customer_permission: 3,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'TextField_2356',
            im_show: false,
            cc_show: true,
            mpv_show: false,
            id: 2356,
            title: 'QQ',
            field_owner: 'Customer',
            content_type: 'text',
            comment: null,
            customer_permission: 0,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'TextField_2357',
            im_show: false,
            cc_show: true,
            mpv_show: false,
            id: 2357,
            title: '微博',
            field_owner: 'Customer',
            content_type: 'text',
            comment: null,
            customer_permission: 0,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'TextField_14234',
            im_show: false,
            cc_show: true,
            mpv_show: false,
            id: 14234,
            title: '多行文本',
            field_owner: 'Customer',
            content_type: 'area_text',
            comment: null,
            customer_permission: 3,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'SelectField_6894',
            im_show: false,
            cc_show: true,
            mpv_show: false,
            id: 6894,
            title: '单选',
            field_owner: 'Customer',
            content_type: 'radio',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            options: ['1', '2', '3'],
            select_options: [
                {
                    title: '1',
                    value: '0',
                },
                {
                    title: '2',
                    value: '1',
                },
                {
                    title: '3',
                    value: '2',
                },
            ],
            view_type: 0,
            full_select: false,
        },
        {
            name: 'SelectField_6895',
            im_show: false,
            cc_show: true,
            mpv_show: false,
            id: 6895,
            title: '多选',
            field_owner: 'Customer',
            content_type: 'checkbox',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            options: ['11', '22', '33', '88'],
            select_options: [
                {
                    title: '11',
                    value: '0',
                },
                {
                    title: '22',
                    value: '1',
                },
                {
                    title: '33',
                    value: '2',
                },
                {
                    title: '88',
                    value: '3',
                    default: true,
                },
            ],
            view_type: 0,
            full_select: false,
        },
        {
            name: 'SelectField_6896',
            im_show: false,
            cc_show: true,
            mpv_show: false,
            id: 6896,
            title: '下拉',
            field_owner: 'Customer',
            content_type: 'droplist',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            options: ['下拉1', '下拉2', '下拉3'],
            select_options: [
                {
                    title: '下拉1',
                    value: '0',
                },
                {
                    title: '下拉2',
                    value: '1',
                },
                {
                    title: '下拉3',
                    value: '2',
                },
            ],
            view_type: 0,
            full_select: false,
        },
        {
            name: 'TextField_14235',
            im_show: false,
            cc_show: true,
            mpv_show: false,
            id: 14235,
            title: '日期',
            field_owner: 'Customer',
            content_type: 'date',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'TextField_122191',
            im_show: false,
            cc_show: true,
            mpv_show: false,
            id: 122191,
            title: '时间',
            field_owner: 'Customer',
            content_type: 'time',
            comment: null,
            customer_permission: 3,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'TextField_122201',
            im_show: false,
            cc_show: true,
            mpv_show: false,
            id: 122201,
            title: '日期时间',
            field_owner: 'Customer',
            content_type: 'datetime',
            comment: null,
            customer_permission: 3,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'TextField_14236',
            im_show: false,
            cc_show: true,
            mpv_show: false,
            id: 14236,
            title: '正整数',
            field_owner: 'Customer',
            content_type: 'number',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'TextField_32505',
            im_show: false,
            cc_show: true,
            mpv_show: false,
            id: 32505,
            title: '用户附加',
            field_owner: 'Customer',
            content_type: 'area_text',
            comment: '',
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'TextField_32525',
            im_show: false,
            cc_show: true,
            mpv_show: false,
            id: 32525,
            title: '代表队',
            field_owner: 'Customer',
            content_type: 'text',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'TextField_122211',
            im_show: false,
            cc_show: true,
            mpv_show: false,
            id: 122211,
            title: '数值',
            field_owner: 'Customer',
            content_type: 'numeric',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'TextField_122221',
            im_show: false,
            cc_show: true,
            mpv_show: false,
            id: 122221,
            title: '计算字段',
            field_owner: 'Customer',
            content_type: 'calculate',
            comment: null,
            customer_permission: 1,
            agent_permission: 3,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
            calculate_result_type: 'numeric',
        },
        {
            name: 'SelectField_110241',
            im_show: true,
            cc_show: true,
            mpv_show: false,
            id: 110241,
            title: '意向车型',
            field_owner: 'Customer',
            content_type: 'droplist',
            comment: '',
            customer_permission: 2,
            agent_permission: 2,
            options: ['海马8s', '海马7s', '海马9s', '海马10s', '海马110s'],
            select_options: [
                {
                    title: '海马7s',
                    value: '2',
                },
                {
                    title: '海马8s',
                    value: '0',
                },
                {
                    title: '海马9s',
                    value: '3',
                },
                {
                    title: '海马10s',
                    value: '4',
                },
                {
                    title: '海马110s',
                    value: '5',
                },
            ],
            view_type: 0,
            full_select: false,
        },
        {
            name: 'TextField_183981',
            im_show: true,
            cc_show: true,
            mpv_show: false,
            id: 183981,
            title: '方便联系时间312',
            field_owner: 'Customer',
            content_type: 'datetime',
            comment: '',
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'SelectField_112951',
            im_show: true,
            cc_show: true,
            mpv_show: false,
            id: 112951,
            title: '社区网123',
            field_owner: 'Customer',
            content_type: 'droplist',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            options: ['12399', '32188', '热热热99', 're 777'],
            select_options: [
                {
                    title: '12399',
                    value: '0',
                },
                {
                    title: '32188',
                    value: '1',
                },
                {
                    title: '热热热99',
                    value: '2',
                },
                {
                    title: 're 777',
                    value: '3',
                },
            ],
            view_type: 0,
            full_select: false,
        },
        {
            name: 'TextField_188481',
            im_show: true,
            cc_show: true,
            mpv_show: false,
            id: 188481,
            title: '路由插件',
            field_owner: 'Customer',
            content_type: 'area_text',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'TextField_188491',
            im_show: true,
            cc_show: true,
            mpv_show: false,
            id: 188491,
            title: '咨询商品',
            field_owner: 'Customer',
            content_type: 'area_text',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'TextField_188501',
            im_show: true,
            cc_show: true,
            mpv_show: false,
            id: 188501,
            title: '路由11111',
            field_owner: 'Customer',
            content_type: 'text',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'TextField_188511',
            im_show: true,
            cc_show: true,
            mpv_show: false,
            id: 188511,
            title: '商品1111',
            field_owner: 'Customer',
            content_type: 'text',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'TextField_192331',
            im_show: false,
            cc_show: true,
            mpv_show: false,
            id: 192331,
            title: '1112',
            field_owner: 'Customer',
            content_type: 'text',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'TextField_192341',
            im_show: true,
            cc_show: true,
            mpv_show: false,
            id: 192341,
            title: '1113',
            field_owner: 'Customer',
            content_type: 'number',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
        },
        {
            name: 'SelectField_116271',
            im_show: true,
            cc_show: true,
            mpv_show: false,
            id: 116271,
            title: '1114',
            field_owner: 'Customer',
            content_type: 'radio',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            options: ['11', '12', '13'],
            select_options: [
                {
                    title: '11',
                    value: '0',
                },
                {
                    title: '12',
                    value: '1',
                },
                {
                    title: '13',
                    value: '2',
                },
            ],
            view_type: 0,
            full_select: false,
        },
    ],
    organizationFieldsv2: [
        {
            name: 'name',
            im_show: true,
            cc_show: true,
            mpv_show: null,
        },
        {
            name: 'description',
            im_show: false,
            cc_show: true,
            mpv_show: null,
        },
        {
            name: 'org_email_suffix',
            im_show: false,
            cc_show: true,
            mpv_show: null,
        },
        {
            name: 'domains',
            im_show: false,
            cc_show: true,
            mpv_show: null,
        },
        {
            id: 7972,
            title: '测试123',
            name: 'TextField_7972',
            field_owner: 'Organization',
            content_type: 'text',
            comment: '测试421',
            customer_permission: 2,
            agent_permission: 1,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
            im_show: false,
            cc_show: true,
            mpv_show: null,
        },
        {
            id: 32500,
            title: '注册时间123',
            name: 'TextField_32500',
            field_owner: 'Organization',
            content_type: 'time',
            comment: '公司注册时间',
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
            im_show: false,
            cc_show: true,
            mpv_show: null,
        },
        {
            id: 192351,
            title: '2221',
            name: 'TextField_192351',
            field_owner: 'Organization',
            content_type: 'text',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
            im_show: false,
            cc_show: true,
            mpv_show: true,
        },
        {
            id: 116261,
            title: '2222',
            name: 'SelectField_116261',
            field_owner: 'Organization',
            content_type: 'droplist',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            options: ['21', '22'],
            select_options: [
                {
                    title: '21',
                    value: '0',
                },
                {
                    title: '22',
                    value: '1',
                },
            ],
            view_type: 0,
            full_select: false,
            im_show: true,
            cc_show: true,
            mpv_show: true,
        },
    ],
    ticketTab: {
        singleTicketAttachmentLimit: 50,
        totalTicketAttachmentLimit: 50,
        ticketPriority: [
            {
                key: 'urgency',
                id: 1,
                name: '紧急',
            },
            {
                key: 'high',
                id: 2,
                name: '高',
            },
            {
                key: 'medium',
                id: 3,
                name: '标准',
            },
            {
                key: 'low',
                id: 4,
                name: '低',
            },
        ],
        ticketStatus: [
            {
                key: 'open',
                id: 1,
                name: '开启',
            },
            {
                key: 'solving',
                id: 4,
                name: '解决中',
            },
            {
                key: 'resolved',
                id: 2,
                name: '已解决',
            },
            {
                key: 'closed',
                id: 3,
                name: '已关闭',
            },
        ],
        langs_dict: [
            {
                id: '',
                text: '默认语言',
                lang_code: '',
            },
            {
                id: 'zh-cn',
                text: 'Chinese/简体中文',
                lang_code: 'zh-cn',
            },
            {
                id: 'en-us',
                text: 'English',
                lang_code: 'en-us',
            },
            {
                id: 'bn',
                text: 'Bengali/বাংলা ভাষা',
                lang_code: 'bn',
            },
            {
                id: 'de',
                text: 'German/Deutsch',
                lang_code: 'de',
            },
            {
                id: 'es',
                text: 'Spanisch/Español',
                lang_code: 'es',
            },
            {
                id: 'hi',
                text: 'Hindi/हिन्दी',
                lang_code: 'hi',
            },
            {
                id: 'id',
                text: 'Indonesian/Bahasa indonesia',
                lang_code: 'id',
            },
            {
                id: 'it',
                text: 'Italian/italiano',
                lang_code: 'it',
            },
            {
                id: 'ja',
                text: 'Japanese/日本語',
                lang_code: 'ja',
            },
            {
                id: 'ko',
                text: 'Korean/한국어',
                lang_code: 'ko',
            },
            {
                id: 'pt',
                text: 'Portuguese/Português',
                lang_code: 'pt',
            },
            {
                id: 'ru',
                text: 'Russian/русский',
                lang_code: 'ru',
            },
            {
                id: 'th',
                text: 'Thai/ไทย',
                lang_code: 'th',
            },
            {
                id: 'vi',
                text: 'Vietnamese/Người việt nam',
                lang_code: 'vi',
            },
            {
                id: 'zh-HK',
                text: 'HK Traditional Chinese/香港繁体',
                lang_code: 'zh-HK',
            },
            {
                id: 'el',
                text: 'Greek/Ελληνική γλώσσα',
                lang_code: 'el',
            },
            {
                id: 'tr',
                text: 'Turk/Türk dili',
                lang_code: 'tr',
            },
            {
                id: 'fr',
                text: 'French/Française',
                lang_code: 'fr',
            },
        ],
        tableColumns: [
            {
                value: 'nick_name',
                display: true,
            },
            {
                value: 'level',
            },
            {
                value: 'organizations',
                display: true,
            },
            {
                value: 'email',
                display: true,
            },
            {
                value: 'cellphone',
                display: true,
            },
            {
                value: 'tags',
            },
            {
                value: 'owner_name',
                display: true,
            },
            {
                value: 'owner_group_name',
                display: false,
            },
            {
                value: 'source_channel',
            },
            {
                value: 'province',
            },
            {
                value: 'city',
            },
            {
                value: 'phone_service_provider',
            },
            {
                value: 'isp',
            },
            {
                value: 'first_contact_at',
            },
            {
                value: 'last_contact_at',
            },
            {
                value: 'contact_count',
            },
            {
                value: 'first_contact_at_via_phone',
            },
            {
                value: 'last_contact_at_via_phone',
            },
            {
                value: 'contact_count_via_phone',
            },
            {
                value: 'first_contact_at_via_im',
            },
            {
                value: 'last_contact_at_via_im',
            },
            {
                value: 'contact_count_via_im',
            },
            {
                value: 'os',
            },
            {
                value: 'os_version',
            },
            {
                value: 'browser',
            },
            {
                value: 'phone_modal',
            },
            {
                value: 'resolution',
            },
            {
                value: 'created_at',
                display: false,
            },
            {
                value: 'updated_at',
                display: true,
            },
            {
                value: 'is_blocked',
            },
            {
                value: 'follow_up_updated_at',
                display: false,
            },
            {
                value: 'TextField_120',
                label: '超链接字段1',
            },
            {
                value: 'TextField_2356',
                label: 'QQ',
            },
            {
                value: 'TextField_2357',
                label: '微博',
            },
            {
                value: 'TextField_2358',
                label: '微信',
            },
            {
                value: 'TextField_14234',
                label: '多行文本',
            },
            {
                value: 'SelectField_6894',
                label: '单选',
            },
            {
                value: 'SelectField_6895',
                label: '多选',
            },
            {
                value: 'SelectField_6896',
                label: '下拉',
            },
            {
                value: 'TextField_14235',
                label: '日期',
            },
            {
                value: 'TextField_14236',
                label: '正整数',
            },
            {
                value: 'TextField_32505',
                label: '用户附加',
            },
            {
                value: 'TextField_32525',
                label: '代表队',
            },
            {
                value: 'TextField_122191',
                label: '时间',
            },
            {
                value: 'TextField_122201',
                label: '日期时间',
            },
            {
                value: 'TextField_122211',
                label: '数值',
            },
            {
                value: 'SelectField_72411',
                label: '客户地址',
            },
            {
                value: 'TextField_122221',
                label: '计算字段',
            },
            {
                value: 'TextField_122871',
                label: '已购产品',
            },
            {
                value: 'SelectField_110241',
                label: '意向车型',
            },
            {
                value: 'TextField_183981',
                label: '方便联系时间312',
            },
            {
                value: 'SelectField_112951',
                label: '社区网123',
            },
            {
                value: 'TextField_188481',
                label: '路由插件',
            },
            {
                value: 'TextField_188491',
                label: '咨询商品',
            },
            {
                value: 'TextField_188501',
                label: '路由11111',
            },
            {
                value: 'TextField_188511',
                label: '商品1111',
            },
            {
                value: 'TextField_192331',
                label: '1112',
            },
            {
                value: 'TextField_192341',
                label: '1113',
            },
            {
                value: 'SelectField_116271',
                label: '1114',
            },
        ],
        customerFilters: [
            {
                name: '所有客户',
                id: 45011,
                all_conditions: [],
                sort_by: [['created_at', 'desc']],
            },
        ],
    },
    ticketTemplates: [
        {
            id: 1,
            name: '默认',
            desc: '',
            default: true,
            use_scope_type: 'all_agents',
            fields: [
                {
                    id: 6,
                    title: '您的所属地区',
                    name: 'TextField_6',
                    field_owner: 'Ticket',
                    content_type: 'text',
                    comment: '省及市',
                    customer_permission: 0,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 6,
                    field_type: 'TextField',
                    is_required: false,
                },
                {
                    id: 1155,
                    title: '下拉列表',
                    name: 'SelectField_1155',
                    field_owner: 'Ticket',
                    content_type: 'droplist',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '1111',
                            value: '0',
                        },
                        {
                            title: '2222',
                            value: '1',
                        },
                        {
                            title: '3333',
                            value: '2',
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 1155,
                    field_type: 'SelectField',
                    is_required: false,
                },
                {
                    id: 1091,
                    title: 'ces',
                    name: 'SelectField_1091',
                    field_owner: 'Ticket',
                    content_type: 'droplist',
                    comment: '',
                    customer_permission: 2,
                    agent_permission: 1,
                    select_options: [
                        {
                            title: '11',
                            value: '0',
                        },
                        {
                            title: '22',
                            value: '1',
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 1091,
                    field_type: 'SelectField',
                    is_required: false,
                },
                {
                    id: 1205,
                    title: 'age',
                    name: 'TextField_1205',
                    field_owner: 'Ticket',
                    content_type: 'numeric',
                    comment: '',
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 1205,
                    field_type: 'TextField',
                    is_required: false,
                },
                {
                    id: 1206,
                    title: '客户姓名',
                    name: 'TextField_1206',
                    field_owner: 'Ticket',
                    content_type: 'text',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 1206,
                    field_type: 'TextField',
                    is_required: false,
                },
                {
                    id: 1214,
                    title: '预约时间',
                    name: 'TextField_1214',
                    field_owner: 'Ticket',
                    content_type: 'date',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 1214,
                    field_type: 'TextField',
                    is_required: false,
                },
                {
                    id: 1215,
                    title: '多行文本',
                    name: 'TextField_1215',
                    field_owner: 'Ticket',
                    content_type: 'area_text',
                    comment: '',
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 1215,
                    field_type: 'TextField',
                    is_required: false,
                },
                {
                    id: 1396,
                    title: '客服经理',
                    name: 'TextField_1396',
                    field_owner: 'Ticket',
                    content_type: 'text',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 1396,
                    field_type: 'TextField',
                    is_required: false,
                },
                {
                    id: 1397,
                    title: '时间',
                    name: 'TextField_1397',
                    field_owner: 'Ticket',
                    content_type: 'time',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 1397,
                    field_type: 'TextField',
                    is_required: false,
                },
                {
                    id: 22,
                    title: '您在哪里购买的该产品？',
                    name: 'TextField_22',
                    field_owner: 'Ticket',
                    content_type: 'text',
                    comment: '可填写区域，如省、市等',
                    customer_permission: 3,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 22,
                    field_type: 'TextField',
                    is_required: false,
                },
                {
                    id: 81,
                    title: '电话',
                    name: 'TextField_81',
                    field_owner: 'Ticket',
                    content_type: 'text',
                    comment: '',
                    customer_permission: 0,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 81,
                    field_type: 'TextField',
                    is_required: false,
                },
                {
                    id: 1195,
                    title: '年龄',
                    name: 'TextField_1195',
                    field_owner: 'Ticket',
                    content_type: 'numeric',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 1195,
                    field_type: 'TextField',
                    is_required: false,
                },
                {
                    id: 44,
                    title: '客户满意度',
                    name: 'SelectField_44',
                    field_owner: 'Ticket',
                    content_type: 'droplist',
                    comment: '',
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '满意',
                            value: '0',
                        },
                        {
                            title: '不满意',
                            value: '1',
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 44,
                    field_type: 'SelectField',
                    is_required: false,
                },
                {
                    id: 55,
                    title: '问题类型',
                    name: 'SelectField_55',
                    field_owner: 'Ticket',
                    content_type: 'droplist',
                    comment: '问题类型',
                    customer_permission: 3,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '程序崩溃',
                            value: '0',
                        },
                        {
                            title: '价格',
                            value: '1',
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 55,
                    field_type: 'SelectField',
                    is_required: false,
                },
                {
                    id: 93,
                    title: '工单字段测试',
                    name: 'SelectField_93',
                    field_owner: 'Ticket',
                    content_type: 'droplist',
                    comment: '测试',
                    customer_permission: 0,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '测试1',
                            value: '0',
                        },
                        {
                            title: '测试2',
                            value: '1',
                        },
                        {
                            title: '测试3',
                            value: '2',
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 93,
                    field_type: 'SelectField',
                    is_required: false,
                },
                {
                    id: 184,
                    title: '预约型号',
                    name: 'SelectField_184',
                    field_owner: 'Ticket',
                    content_type: 'radio',
                    comment: '单选框',
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: 'ICOM',
                            value: '0',
                        },
                        {
                            title: '博瑞',
                            value: '1',
                        },
                        {
                            title: '星越',
                            value: '2',
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 184,
                    field_type: 'SelectField',
                    is_required: false,
                },
                {
                    id: 183,
                    title: '复选框',
                    name: 'SelectField_183',
                    field_owner: 'Ticket',
                    content_type: 'checkbox',
                    comment: '复选框',
                    customer_permission: 0,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '一',
                            value: '0',
                        },
                        {
                            title: '二',
                            value: '1',
                        },
                        {
                            title: '三',
                            value: '2',
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 183,
                    field_type: 'SelectField',
                    is_required: false,
                },
                {
                    id: 4685,
                    title: '正整数',
                    name: 'TextField_4685',
                    field_owner: 'Ticket',
                    content_type: 'number',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 4685,
                    field_type: 'TextField',
                    is_required: false,
                },
            ],
            template_type: 'TicketTemplate',
        },
        {
            id: 16066,
            name: '工单',
            desc: '',
            default: false,
            use_scope_type: 'all_agents',
            fields: [
                {
                    id: 6,
                    title: '您的所属地区',
                    name: 'TextField_6',
                    field_owner: 'Ticket',
                    content_type: 'text',
                    comment: '省及市',
                    customer_permission: 0,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 6,
                    field_type: 'TextField',
                    is_required: false,
                },
                {
                    id: 4955,
                    title: '34',
                    name: 'TextField_4955',
                    field_owner: 'Ticket',
                    content_type: 'area_text',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 4955,
                    field_type: 'TextField',
                    is_required: false,
                },
            ],
            template_type: 'TicketTemplate',
        },
        {
            id: 50942,
            name: '用来看顺序的模块',
            desc: '没什么用',
            default: false,
            use_scope_type: 'all_agents',
            fields: [
                {
                    id: 1980,
                    title: '地理组合',
                    name: 'SelectField_1980',
                    field_owner: 'Ticket',
                    content_type: 'chained_droplist',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '北京市',
                            value: '0',
                            subs: [
                                {
                                    title: '海淀区',
                                    value: '0',
                                    subs: [
                                        {
                                            title: '知春路',
                                            value: '0',
                                        },
                                        {
                                            title: '海淀路',
                                            value: '1',
                                        },
                                    ],
                                },
                            ],
                        },
                        {
                            title: '天津市',
                            value: '1',
                            subs: [
                                {
                                    title: '和平区',
                                    value: '0',
                                },
                            ],
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 1980,
                    field_type: 'SelectField',
                    is_required: false,
                },
            ],
            template_type: 'TicketTemplate',
        },
        {
            id: 110981,
            name: '小龙测试-',
            desc: '小龙测试',
            default: false,
            use_scope_type: 'all_agents',
            fields: [
                {
                    id: 22,
                    title: '您在哪里购买的该产品？',
                    name: 'TextField_22',
                    field_owner: 'Ticket',
                    content_type: 'text',
                    comment: '可填写区域，如省、市等',
                    customer_permission: 3,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 22,
                    field_type: 'TextField',
                    is_required: false,
                },
                {
                    id: 81,
                    title: '电话',
                    name: 'TextField_81',
                    field_owner: 'Ticket',
                    content_type: 'text',
                    comment: '',
                    customer_permission: 0,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 81,
                    field_type: 'TextField',
                    is_required: true,
                },
                {
                    id: 1980,
                    title: '地理组合',
                    name: 'SelectField_1980',
                    field_owner: 'Ticket',
                    content_type: 'chained_droplist',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '北京市',
                            value: '0',
                            subs: [
                                {
                                    title: '海淀区',
                                    value: '0',
                                    subs: [
                                        {
                                            title: '知春路',
                                            value: '0',
                                        },
                                        {
                                            title: '海淀路',
                                            value: '1',
                                        },
                                    ],
                                },
                            ],
                        },
                        {
                            title: '天津市',
                            value: '1',
                            subs: [
                                {
                                    title: '和平区',
                                    value: '0',
                                },
                            ],
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 1980,
                    field_type: 'SelectField',
                    is_required: true,
                },
                {
                    id: 1214,
                    title: '预约时间',
                    name: 'TextField_1214',
                    field_owner: 'Ticket',
                    content_type: 'date',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 1214,
                    field_type: 'TextField',
                    is_required: true,
                },
                {
                    id: 184,
                    title: '预约型号',
                    name: 'SelectField_184',
                    field_owner: 'Ticket',
                    content_type: 'radio',
                    comment: '单选框',
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: 'ICOM',
                            value: '0',
                        },
                        {
                            title: '博瑞',
                            value: '1',
                        },
                        {
                            title: '星越',
                            value: '2',
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 184,
                    field_type: 'SelectField',
                    is_required: false,
                },
                {
                    id: 123711,
                    title: '请描述问题',
                    name: 'TextField_123711',
                    field_owner: 'Ticket',
                    content_type: 'area_text',
                    comment: '',
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: true,
                    field_id: 123711,
                    field_type: 'TextField',
                    is_required: false,
                },
            ],
            template_type: 'TicketTemplate',
        },
        {
            id: 112111,
            name: '预约试驾工单',
            desc: '',
            default: false,
            use_scope_type: 'all_agents',
            fields: [
                {
                    id: 184,
                    title: '预约型号',
                    name: 'SelectField_184',
                    field_owner: 'Ticket',
                    content_type: 'radio',
                    comment: '单选框',
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: 'ICOM',
                            value: '0',
                        },
                        {
                            title: '博瑞',
                            value: '1',
                        },
                        {
                            title: '星越',
                            value: '2',
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 184,
                    field_type: 'SelectField',
                    is_required: true,
                },
                {
                    id: 1214,
                    title: '预约时间',
                    name: 'TextField_1214',
                    field_owner: 'Ticket',
                    content_type: 'date',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 1214,
                    field_type: 'TextField',
                    is_required: true,
                },
                {
                    id: 1396,
                    title: '客服经理',
                    name: 'TextField_1396',
                    field_owner: 'Ticket',
                    content_type: 'text',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 1396,
                    field_type: 'TextField',
                    is_required: true,
                },
            ],
            template_type: 'TicketTemplate',
        },
    ],
    noteTemplates: [
        {
            id: 1,
            name: 'IM业务记录',
            desc: '应用于客服对IM对话内容进行整理记录',
            category: 'im',
            ticket_template_id: 55,
            is_default: true,
            call_type: '',
            agent_group_ids: [],
            fields: [
                {
                    name: 'TextField_82',
                    is_required: false,
                    id: 82,
                    title: '单行文本（业务记录同步工单）',
                    field_owner: 'Ticket',
                    content_type: 'text',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 82,
                    field_type: 'TextField',
                    forNoteIm: true,
                },
                {
                    name: 'TextField_83',
                    is_required: false,
                    id: 83,
                    title: '日期（业务记录同步工单）',
                    field_owner: 'Ticket',
                    content_type: 'date',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 83,
                    field_type: 'TextField',
                    forNoteIm: true,
                },
                {
                    name: 'TextField_84',
                    is_required: false,
                    id: 84,
                    title: '时间（业务记录同步工单）',
                    field_owner: 'Ticket',
                    content_type: 'time',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 84,
                    field_type: 'TextField',
                    forNoteIm: true,
                },
                {
                    name: 'TextField_85',
                    is_required: false,
                    id: 85,
                    title: '正整数（业务记录同步工单）',
                    field_owner: 'Ticket',
                    content_type: 'number',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 85,
                    field_type: 'TextField',
                    forNoteIm: true,
                },
                {
                    name: 'TextField_86',
                    is_required: false,
                    id: 86,
                    title: '多行文本（业务记录同步工单）',
                    field_owner: 'Ticket',
                    content_type: 'area_text',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 86,
                    field_type: 'TextField',
                    forNoteIm: true,
                },
                {
                    name: 'SelectField_65',
                    is_required: false,
                    id: 65,
                    title: '下拉列表（业务记录同步工单）',
                    field_owner: 'Ticket',
                    content_type: 'droplist',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: 'A',
                            value: '0',
                        },
                        {
                            title: 'B',
                            value: '1',
                        },
                        {
                            title: 'C',
                            value: '2',
                        },
                        {
                            title: 'D',
                            value: '3',
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 65,
                    field_type: 'SelectField',
                    forNoteIm: true,
                },
                {
                    name: 'SelectField_66',
                    is_required: false,
                    id: 66,
                    title: '级联（业务记录同步工单）',
                    field_owner: 'Ticket',
                    content_type: 'chained_droplist',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '北京市',
                            value: '0',
                            subs: [
                                {
                                    title: '海淀区',
                                    value: '0',
                                    subs: [
                                        {
                                            title: '知春路',
                                            value: '0',
                                        },
                                    ],
                                },
                            ],
                        },
                        {
                            title: '天津市',
                            value: '1',
                            subs: [
                                {
                                    title: '和平区',
                                    value: '0',
                                },
                            ],
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 66,
                    field_type: 'SelectField',
                    forNoteIm: true,
                },
                {
                    name: 'SelectField_67',
                    is_required: false,
                    id: 67,
                    title: '单选框（业务记录同步工单）',
                    field_owner: 'Ticket',
                    content_type: 'radio',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: 'A',
                            value: '0',
                        },
                        {
                            title: 'B',
                            value: '1',
                        },
                        {
                            title: 'C',
                            value: '2',
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 67,
                    field_type: 'SelectField',
                    forNoteIm: true,
                },
                {
                    name: 'SelectField_68',
                    is_required: false,
                    id: 68,
                    title: '复选框（业务记录同步工单）',
                    field_owner: 'Ticket',
                    content_type: 'checkbox',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: 'Q',
                            value: '0',
                        },
                        {
                            title: 'W',
                            value: '1',
                        },
                        {
                            title: 'E',
                            value: '2',
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 68,
                    field_type: 'SelectField',
                    forNoteIm: true,
                },
                {
                    name: 'SelectField_69',
                    is_required: false,
                    id: 69,
                    title: 'YL多级级联字段',
                    field_owner: 'Ticket',
                    content_type: 'chained_droplist',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '北京市',
                            value: '0',
                            subs: [
                                {
                                    title: '海淀区',
                                    value: '0',
                                    subs: [
                                        {
                                            title: '知春路',
                                            value: '0',
                                        },
                                    ],
                                },
                                {
                                    title: '西城区',
                                    value: '1',
                                    subs: [
                                        {
                                            title: '成铭大厦',
                                            value: '0',
                                            subs: [
                                                {
                                                    title: 'A座',
                                                    value: '0',
                                                },
                                                {
                                                    title: 'B座',
                                                    value: '1',
                                                },
                                                {
                                                    title: 'C座',
                                                    value: '2',
                                                    subs: [
                                                        {
                                                            title: '1205',
                                                            value: '0',
                                                        },
                                                        {
                                                            title: '1603',
                                                            value: '1',
                                                        },
                                                    ],
                                                },
                                            ],
                                        },
                                        {
                                            title: '半壁店街',
                                            value: '1',
                                        },
                                        {
                                            title: '西直门南小街',
                                            value: '2',
                                            subs: [
                                                {
                                                    title: '西城社保中心',
                                                    value: '0',
                                                    subs: [
                                                        {
                                                            title: '一层',
                                                            value: '0',
                                                        },
                                                        {
                                                            title: '二层',
                                                            value: '1',
                                                        },
                                                    ],
                                                },
                                            ],
                                        },
                                    ],
                                },
                            ],
                        },
                        {
                            title: '天津市',
                            value: '1',
                            subs: [
                                {
                                    title: '和平区',
                                    value: '0',
                                },
                            ],
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 69,
                    field_type: 'SelectField',
                    forNoteIm: true,
                },
            ],
        },
        {
            id: 3,
            name: 'test',
            desc: 'test',
            category: 'im',
            ticket_template_id: 1,
            is_default: false,
            call_type: '',
            agent_group_ids: [1],
            fields: [
                {
                    name: 'TextField_1',
                    is_required: true,
                    id: 1,
                    title: '单行文本（默认读写）',
                    field_owner: 'Ticket',
                    content_type: 'text',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 1,
                    field_type: 'TextField',
                    forNoteIm: true,
                    forNoteCall: true,
                },
                {
                    name: 'TextField_19',
                    is_required: false,
                    id: 19,
                    title: '时间（默认读写）',
                    field_owner: 'Ticket',
                    content_type: 'time',
                    comment: '时间',
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 19,
                    field_type: 'TextField',
                    forNoteIm: true,
                    forNoteCall: true,
                },
                {
                    name: 'SelectField_43',
                    is_required: true,
                    id: 43,
                    title: '测试下拉',
                    field_owner: 'Ticket',
                    content_type: 'droplist',
                    comment: '',
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '选项1',
                            value: '0',
                        },
                        {
                            title: '选项2',
                            value: '1',
                        },
                        {
                            title: '选项3',
                            value: '2',
                            default: true,
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 43,
                    field_type: 'SelectField',
                    forNoteIm: true,
                },
                {
                    name: 'SelectField_28',
                    is_required: false,
                    id: 28,
                    title: '自定义级联-sjl',
                    field_owner: 'Ticket',
                    content_type: 'chained_droplist',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '北京市',
                            value: '0',
                            subs: [
                                {
                                    title: '海淀区',
                                    value: '0',
                                    subs: [
                                        {
                                            title: '知春路',
                                            value: '0',
                                        },
                                    ],
                                },
                            ],
                        },
                        {
                            title: '天津市',
                            value: '1',
                            subs: [
                                {
                                    title: '和平区',
                                    value: '0',
                                },
                            ],
                        },
                    ],
                    view_type: 1,
                    full_select: false,
                    field_id: 28,
                    field_type: 'SelectField',
                    forNoteIm: true,
                },
                {
                    name: 'SelectField_52',
                    is_required: false,
                    id: 52,
                    title: '快速的级联样式',
                    field_owner: 'Ticket',
                    content_type: 'chained_droplist',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '北京市',
                            value: '0',
                            subs: [
                                {
                                    title: '海淀区',
                                    value: '0',
                                    subs: [
                                        {
                                            title: '知春路',
                                            value: '0',
                                        },
                                    ],
                                },
                            ],
                        },
                        {
                            title: '天津市',
                            value: '1',
                            subs: [
                                {
                                    title: '和平区',
                                    value: '0',
                                },
                            ],
                        },
                    ],
                    view_type: 1,
                    full_select: false,
                    field_id: 52,
                    field_type: 'SelectField',
                    forNoteIm: true,
                },
                {
                    name: 'SelectField_59',
                    is_required: false,
                    id: 59,
                    title: '测试下拉搜索',
                    field_owner: 'Ticket',
                    content_type: 'droplist',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '列表1',
                            value: '0',
                        },
                        {
                            title: '马里奥',
                            value: '1',
                        },
                        {
                            title: '上学',
                            value: '2',
                        },
                        {
                            title: '上课',
                            value: '3',
                        },
                        {
                            title: '上班',
                            value: '4',
                        },
                        {
                            title: '下拉列表6',
                            value: '5',
                        },
                        {
                            title: '下拉列表7',
                            value: '6',
                        },
                        {
                            title: '下拉列表8',
                            value: '7',
                        },
                        {
                            title: '下拉列表9',
                            value: '8',
                        },
                        {
                            title: '下拉列表10',
                            value: '9',
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 59,
                    field_type: 'SelectField',
                    forNoteIm: true,
                },
            ],
        },
        {
            id: 4,
            name: 'test',
            desc: 'testdesc',
            category: 'im',
            ticket_template_id: 2,
            is_default: false,
            call_type: '',
            agent_group_ids: [2, 3, 4],
            fields: [
                {
                    name: 'TextField_20',
                    is_required: true,
                    id: 20,
                    title: '日期时间（默认只读）',
                    field_owner: 'Ticket',
                    content_type: 'datetime',
                    comment: '日期时间',
                    customer_permission: 1,
                    agent_permission: 3,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 20,
                    field_type: 'TextField',
                    forNoteIm: true,
                    forNoteCall: true,
                },
                {
                    name: 'TextField_18',
                    is_required: true,
                    id: 18,
                    title: '日期（默认读写）',
                    field_owner: 'Ticket',
                    content_type: 'date',
                    comment: '日期',
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 18,
                    field_type: 'TextField',
                    forNoteIm: true,
                    forNoteCall: true,
                },
                {
                    name: 'SelectField_57',
                    is_required: false,
                    id: 57,
                    title: '只有一个选项的单选',
                    field_owner: 'Ticket',
                    content_type: 'radio',
                    comment: '只有一个选项的单选',
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '唯一选项',
                            value: '0',
                            default: true,
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 57,
                    field_type: 'SelectField',
                    forNoteIm: true,
                },
            ],
        },
        {
            id: 6,
            name: '一二三',
            desc: '',
            category: 'call',
            ticket_template_id: 1,
            is_default: false,
            call_type: 'in',
            agent_group_ids: [21],
            fields: [
                {
                    name: 'TextField_1',
                    is_required: false,
                    id: 1,
                    title: '单行文本（默认读写）',
                    field_owner: 'Ticket',
                    content_type: 'text',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 1,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_18',
                    is_required: false,
                    id: 18,
                    title: '日期（默认读写）',
                    field_owner: 'Ticket',
                    content_type: 'date',
                    comment: '日期',
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 18,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_19',
                    is_required: false,
                    id: 19,
                    title: '时间（默认读写）',
                    field_owner: 'Ticket',
                    content_type: 'time',
                    comment: '时间',
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 19,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_20',
                    is_required: false,
                    id: 20,
                    title: '日期时间（默认只读）',
                    field_owner: 'Ticket',
                    content_type: 'datetime',
                    comment: '日期时间',
                    customer_permission: 1,
                    agent_permission: 3,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 20,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_21',
                    is_required: false,
                    id: 21,
                    title: '正整数（默认只读）',
                    field_owner: 'Ticket',
                    content_type: 'number',
                    comment: '正整数',
                    customer_permission: 1,
                    agent_permission: 3,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 21,
                    field_type: 'TextField',
                    forNoteCall: true,
                    forNoteIm: true,
                },
                {
                    name: 'TextField_22',
                    is_required: false,
                    id: 22,
                    title: '数值（默认只读）',
                    field_owner: 'Ticket',
                    content_type: 'numeric',
                    comment: '数值',
                    customer_permission: 1,
                    agent_permission: 3,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 22,
                    field_type: 'TextField',
                    forNoteCall: true,
                    forNoteIm: true,
                },
            ],
        },
        {
            id: 7,
            name: '呼出',
            desc: '',
            category: 'call',
            ticket_template_id: 1,
            is_default: false,
            call_type: 'out',
            agent_group_ids: [20],
            fields: [
                {
                    name: 'TextField_1',
                    is_required: false,
                    id: 1,
                    title: '单行文本（默认读写）',
                    field_owner: 'Ticket',
                    content_type: 'text',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 1,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_18',
                    is_required: false,
                    id: 18,
                    title: '日期（默认读写）',
                    field_owner: 'Ticket',
                    content_type: 'date',
                    comment: '日期',
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 18,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_20',
                    is_required: false,
                    id: 20,
                    title: '日期时间（默认只读）',
                    field_owner: 'Ticket',
                    content_type: 'datetime',
                    comment: '日期时间',
                    customer_permission: 1,
                    agent_permission: 3,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 20,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_21',
                    is_required: false,
                    id: 21,
                    title: '正整数（默认只读）',
                    field_owner: 'Ticket',
                    content_type: 'number',
                    comment: '正整数',
                    customer_permission: 1,
                    agent_permission: 3,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 21,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_22',
                    is_required: false,
                    id: 22,
                    title: '数值（默认只读）',
                    field_owner: 'Ticket',
                    content_type: 'numeric',
                    comment: '数值',
                    customer_permission: 1,
                    agent_permission: 3,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 22,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_23',
                    is_required: false,
                    id: 23,
                    title: '链接（默认不可见）',
                    field_owner: 'Ticket',
                    content_type: 'link',
                    comment: '链接',
                    customer_permission: 2,
                    agent_permission: 4,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 23,
                    field_type: 'TextField',
                    forNoteCall: true,
                    forNoteIm: true,
                },
                {
                    name: 'TextField_24',
                    is_required: false,
                    id: 24,
                    title: '多行文本（默认只读）',
                    field_owner: 'Ticket',
                    content_type: 'area_text',
                    comment: '多行文本你会计就哦I哦家',
                    customer_permission: 1,
                    agent_permission: 3,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 24,
                    field_type: 'TextField',
                    forNoteCall: true,
                    forNoteIm: true,
                },
            ],
        },
        {
            id: 8,
            name: '孙',
            desc: '',
            category: 'im',
            ticket_template_id: 1,
            is_default: false,
            call_type: '',
            agent_group_ids: [37],
            fields: [
                {
                    name: 'TextField_19',
                    is_required: false,
                    id: 19,
                    title: '时间（默认读写）',
                    field_owner: 'Ticket',
                    content_type: 'time',
                    comment: '时间',
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 19,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_1',
                    is_required: false,
                    id: 1,
                    title: '单行文本（默认读写）',
                    field_owner: 'Ticket',
                    content_type: 'text',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 1,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_22',
                    is_required: false,
                    id: 22,
                    title: '数值（默认只读）',
                    field_owner: 'Ticket',
                    content_type: 'numeric',
                    comment: '数值',
                    customer_permission: 1,
                    agent_permission: 3,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 22,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_24',
                    is_required: false,
                    id: 24,
                    title: '多行文本（默认只读）',
                    field_owner: 'Ticket',
                    content_type: 'area_text',
                    comment: '多行文本你会计就哦I哦家',
                    customer_permission: 1,
                    agent_permission: 3,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 24,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_18',
                    is_required: false,
                    id: 18,
                    title: '日期（默认读写）',
                    field_owner: 'Ticket',
                    content_type: 'date',
                    comment: '日期',
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 18,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_20',
                    is_required: false,
                    id: 20,
                    title: '日期时间（默认只读）',
                    field_owner: 'Ticket',
                    content_type: 'datetime',
                    comment: '日期时间',
                    customer_permission: 1,
                    agent_permission: 3,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 20,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_23',
                    is_required: false,
                    id: 23,
                    title: '链接（默认不可见）',
                    field_owner: 'Ticket',
                    content_type: 'link',
                    comment: '链接',
                    customer_permission: 2,
                    agent_permission: 4,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 23,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_25',
                    is_required: false,
                    id: 25,
                    title: '地理位置（默认不可见）',
                    field_owner: 'Ticket',
                    content_type: 'location',
                    comment: '地理位置',
                    customer_permission: 2,
                    agent_permission: 4,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 25,
                    field_type: 'TextField',
                    forNoteIm: true,
                },
                {
                    name: 'TextField_50',
                    is_required: false,
                    id: 50,
                    title: '2',
                    field_owner: 'Ticket',
                    content_type: 'text',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 50,
                    field_type: 'TextField',
                    forNoteIm: true,
                },
                {
                    name: 'TextField_21',
                    is_required: false,
                    id: 21,
                    title: '正整数（默认只读）',
                    field_owner: 'Ticket',
                    content_type: 'number',
                    comment: '正整数',
                    customer_permission: 1,
                    agent_permission: 3,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 21,
                    field_type: 'TextField',
                },
                {
                    name: 'SelectField_43',
                    is_required: true,
                    id: 43,
                    title: '测试下拉',
                    field_owner: 'Ticket',
                    content_type: 'droplist',
                    comment: '',
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '选项1',
                            value: '0',
                        },
                        {
                            title: '选项2',
                            value: '1',
                        },
                        {
                            title: '选项3',
                            value: '2',
                            default: true,
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 43,
                    field_type: 'SelectField',
                },
                {
                    name: 'SelectField_28',
                    is_required: false,
                    id: 28,
                    title: '自定义级联-sjl',
                    field_owner: 'Ticket',
                    content_type: 'chained_droplist',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '北京市',
                            value: '0',
                            subs: [
                                {
                                    title: '海淀区',
                                    value: '0',
                                    subs: [
                                        {
                                            title: '知春路',
                                            value: '0',
                                        },
                                    ],
                                },
                            ],
                        },
                        {
                            title: '天津市',
                            value: '1',
                            subs: [
                                {
                                    title: '和平区',
                                    value: '0',
                                },
                            ],
                        },
                    ],
                    view_type: 1,
                    full_select: false,
                    field_id: 28,
                    field_type: 'SelectField',
                },
                {
                    name: 'SelectField_52',
                    is_required: false,
                    id: 52,
                    title: '快速的级联样式',
                    field_owner: 'Ticket',
                    content_type: 'chained_droplist',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '北京市',
                            value: '0',
                            subs: [
                                {
                                    title: '海淀区',
                                    value: '0',
                                    subs: [
                                        {
                                            title: '知春路',
                                            value: '0',
                                        },
                                    ],
                                },
                            ],
                        },
                        {
                            title: '天津市',
                            value: '1',
                            subs: [
                                {
                                    title: '和平区',
                                    value: '0',
                                },
                            ],
                        },
                    ],
                    view_type: 1,
                    full_select: false,
                    field_id: 52,
                    field_type: 'SelectField',
                },
            ],
        },
        {
            id: 10,
            name: '视频客服默认模板',
            desc: '系统默认视频客服业务记录模板',
            category: 'video',
            ticket_template_id: 1,
            is_default: true,
            call_type: null,
            agent_group_ids: [],
            fields: [],
        },
        {
            id: 15,
            name: 'test',
            desc: '',
            category: 'video',
            ticket_template_id: 6,
            is_default: false,
            call_type: '',
            agent_group_ids: [38],
            fields: [
                {
                    name: 'TextField_18',
                    is_required: false,
                    id: 18,
                    title: '日期（默认读写）',
                    field_owner: 'Ticket',
                    content_type: 'date',
                    comment: '日期',
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 18,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_19',
                    is_required: false,
                    id: 19,
                    title: '时间（默认读写）',
                    field_owner: 'Ticket',
                    content_type: 'time',
                    comment: '时间',
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 19,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_21',
                    is_required: false,
                    id: 21,
                    title: '正整数（默认只读）',
                    field_owner: 'Ticket',
                    content_type: 'number',
                    comment: '正整数',
                    customer_permission: 1,
                    agent_permission: 3,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 21,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_22',
                    is_required: false,
                    id: 22,
                    title: '数值（默认只读）',
                    field_owner: 'Ticket',
                    content_type: 'numeric',
                    comment: '数值',
                    customer_permission: 1,
                    agent_permission: 3,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 22,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_23',
                    is_required: false,
                    id: 23,
                    title: '链接（默认不可见）',
                    field_owner: 'Ticket',
                    content_type: 'link',
                    comment: '链接',
                    customer_permission: 2,
                    agent_permission: 4,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 23,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_24',
                    is_required: false,
                    id: 24,
                    title: '多行文本（默认只读）',
                    field_owner: 'Ticket',
                    content_type: 'area_text',
                    comment: '多行文本你会计就哦I哦家',
                    customer_permission: 1,
                    agent_permission: 3,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 24,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_25',
                    is_required: false,
                    id: 25,
                    title: '地理位置（默认不可见）',
                    field_owner: 'Ticket',
                    content_type: 'location',
                    comment: '地理位置',
                    customer_permission: 2,
                    agent_permission: 4,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 25,
                    field_type: 'TextField',
                },
            ],
        },
        {
            id: 19,
            name: 'wwd',
            desc: '',
            category: 'im',
            ticket_template_id: 1,
            is_default: false,
            call_type: '',
            agent_group_ids: [9],
            fields: [
                {
                    name: 'SelectField_64',
                    is_required: false,
                    id: 64,
                    title: 'wwd级联',
                    field_owner: 'Ticket',
                    content_type: 'chained_droplist',
                    comment: '',
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '北京市',
                            value: '0',
                            subs: [
                                {
                                    title: '海淀区',
                                    value: '0',
                                    subs: [
                                        {
                                            title: '知春路',
                                            value: '0',
                                        },
                                    ],
                                },
                                {
                                    title: '111',
                                    value: '1',
                                },
                                {
                                    title: '112',
                                    value: '2',
                                },
                                {
                                    title: '113',
                                    value: '3',
                                },
                                {
                                    title: '114',
                                    value: '4',
                                },
                                {
                                    title: '115',
                                    value: '5',
                                },
                                {
                                    title: '116',
                                    value: '6',
                                },
                                {
                                    title: '117',
                                    value: '7',
                                },
                                {
                                    title: '118',
                                    value: '8',
                                },
                                {
                                    title: '119',
                                    value: '9',
                                },
                                {
                                    title: '121',
                                    value: '10',
                                },
                                {
                                    title: '122',
                                    value: '11',
                                },
                                {
                                    title: '123',
                                    value: '12',
                                },
                                {
                                    title: '124',
                                    value: '13',
                                },
                                {
                                    title: '125',
                                    value: '14',
                                },
                                {
                                    title: '126',
                                    value: '15',
                                },
                                {
                                    title: '127',
                                    value: '16',
                                },
                                {
                                    title: '128',
                                    value: '17',
                                },
                                {
                                    title: '129',
                                    value: '18',
                                },
                                {
                                    title: '130',
                                    value: '19',
                                },
                                {
                                    title: '131',
                                    value: '20',
                                },
                                {
                                    title: '132',
                                    value: '21',
                                },
                                {
                                    title: '133',
                                    value: '22',
                                },
                                {
                                    title: '134',
                                    value: '23',
                                },
                                {
                                    title: '135',
                                    value: '24',
                                },
                                {
                                    title: '136',
                                    value: '25',
                                },
                                {
                                    title: '137',
                                    value: '26',
                                },
                                {
                                    title: '138',
                                    value: '27',
                                },
                                {
                                    title: '139',
                                    value: '28',
                                },
                                {
                                    title: '140',
                                    value: '29',
                                },
                                {
                                    title: '141',
                                    value: '30',
                                },
                                {
                                    title: '142',
                                    value: '31',
                                },
                                {
                                    title: '143',
                                    value: '32',
                                },
                                {
                                    title: '144',
                                    value: '33',
                                },
                                {
                                    title: '145',
                                    value: '34',
                                },
                                {
                                    title: '146',
                                    value: '35',
                                },
                                {
                                    title: '147',
                                    value: '36',
                                },
                                {
                                    title: '148',
                                    value: '37',
                                },
                                {
                                    title: '149',
                                    value: '38',
                                },
                                {
                                    title: '150',
                                    value: '39',
                                },
                                {
                                    title: '151',
                                    value: '40',
                                },
                                {
                                    title: '152',
                                    value: '41',
                                },
                                {
                                    title: '153',
                                    value: '42',
                                },
                                {
                                    title: '154',
                                    value: '43',
                                },
                                {
                                    title: '155',
                                    value: '44',
                                },
                                {
                                    title: '156',
                                    value: '45',
                                },
                                {
                                    title: '157',
                                    value: '46',
                                },
                                {
                                    title: '158',
                                    value: '47',
                                },
                                {
                                    title: '159',
                                    value: '48',
                                },
                                {
                                    title: '160',
                                    value: '49',
                                },
                                {
                                    title: '161',
                                    value: '50',
                                },
                            ],
                        },
                        {
                            title: '天津市',
                            value: '1',
                            subs: [
                                {
                                    title: '和平区',
                                    value: '0',
                                },
                            ],
                        },
                    ],
                    view_type: 1,
                    full_select: false,
                    field_id: 64,
                    field_type: 'SelectField',
                    forNoteIm: true,
                },
                {
                    name: 'TextField_59',
                    is_required: false,
                    id: 59,
                    title: 'wwd 可见 ',
                    field_owner: 'Ticket',
                    content_type: 'link',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 59,
                    field_type: 'TextField',
                    forNoteIm: true,
                },
                {
                    name: 'SelectField_39',
                    is_required: false,
                    id: 39,
                    title: 'wwd单选',
                    field_owner: 'Ticket',
                    content_type: 'radio',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '完全二无群二',
                            value: '0',
                        },
                        {
                            title: '好的',
                            value: '1',
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 39,
                    field_type: 'SelectField',
                    forNoteIm: true,
                },
                {
                    name: 'TextField_19',
                    is_required: false,
                    id: 19,
                    title: '时间（默认读写）',
                    field_owner: 'Ticket',
                    content_type: 'time',
                    comment: '时间',
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 19,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_18',
                    is_required: true,
                    id: 18,
                    title: '日期（默认读写）',
                    field_owner: 'Ticket',
                    content_type: 'date',
                    comment: '日期',
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 18,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_22',
                    is_required: true,
                    id: 22,
                    title: '数值（默认只读）',
                    field_owner: 'Ticket',
                    content_type: 'numeric',
                    comment: '数值',
                    customer_permission: 1,
                    agent_permission: 3,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 22,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_24',
                    is_required: true,
                    id: 24,
                    title: '多行文本（默认只读）',
                    field_owner: 'Ticket',
                    content_type: 'area_text',
                    comment: '多行文本你会计就哦I哦家',
                    customer_permission: 1,
                    agent_permission: 3,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 24,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_76',
                    is_required: true,
                    id: 76,
                    title: '测试多行',
                    field_owner: 'Ticket',
                    content_type: 'area_text',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 76,
                    field_type: 'TextField',
                    forNoteIm: true,
                },
                {
                    name: 'SelectField_43',
                    is_required: false,
                    id: 43,
                    title: '测试下拉',
                    field_owner: 'Ticket',
                    content_type: 'droplist',
                    comment: '',
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '选项1',
                            value: '0',
                        },
                        {
                            title: '选项2',
                            value: '1',
                        },
                        {
                            title: '选项3',
                            value: '2',
                            default: true,
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 43,
                    field_type: 'SelectField',
                },
                {
                    name: 'SelectField_27',
                    is_required: false,
                    id: 27,
                    title: '自定义下拉列表-sjl有默认值',
                    field_owner: 'Ticket',
                    content_type: 'droplist',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '下拉1',
                            value: '0',
                            default: true,
                        },
                        {
                            title: '下拉2',
                            value: '1',
                        },
                        {
                            title: '下拉3',
                            value: '2',
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 27,
                    field_type: 'SelectField',
                    forNoteIm: true,
                },
                {
                    name: 'SelectField_28',
                    is_required: false,
                    id: 28,
                    title: '自定义级联-sjl',
                    field_owner: 'Ticket',
                    content_type: 'chained_droplist',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '北京市',
                            value: '0',
                            subs: [
                                {
                                    title: '海淀区',
                                    value: '0',
                                    subs: [
                                        {
                                            title: '知春路',
                                            value: '0',
                                        },
                                    ],
                                },
                            ],
                        },
                        {
                            title: '天津市',
                            value: '1',
                            subs: [
                                {
                                    title: '和平区',
                                    value: '0',
                                },
                            ],
                        },
                    ],
                    view_type: 1,
                    full_select: false,
                    field_id: 28,
                    field_type: 'SelectField',
                },
            ],
        },
        {
            id: 20,
            name: 'IM即时通讯工作台客服业务记录转客服工单模板操作权限测试',
            desc: '',
            category: 'im',
            ticket_template_id: 1,
            is_default: false,
            call_type: '',
            agent_group_ids: [36, 53],
            fields: [
                {
                    name: 'SelectField_46',
                    is_required: false,
                    id: 46,
                    title: '测试多选读写有默认值',
                    field_owner: 'Ticket',
                    content_type: 'checkbox',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '1',
                            value: '0',
                        },
                        {
                            title: '特殊2',
                            value: '1',
                            default: true,
                        },
                        {
                            title: '特殊3',
                            value: '2',
                            default: true,
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 46,
                    field_type: 'SelectField',
                    forNoteIm: true,
                },
                {
                    name: 'TextField_24',
                    is_required: false,
                    id: 24,
                    title: '多行文本（默认只读）',
                    field_owner: 'Ticket',
                    content_type: 'area_text',
                    comment: '多行文本你会计就哦I哦家',
                    customer_permission: 1,
                    agent_permission: 3,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 24,
                    field_type: 'TextField',
                },
            ],
        },
        {
            id: 21,
            name: '业务记录转工单模板权限',
            desc: '',
            category: 'call',
            ticket_template_id: 17,
            is_default: false,
            call_type: 'out',
            agent_group_ids: [21],
            fields: [],
        },
        {
            id: 22,
            name: '业务记录转工单模板权限全部',
            desc: '',
            category: 'call',
            ticket_template_id: 12,
            is_default: false,
            call_type: 'out',
            agent_group_ids: [22],
            fields: [],
        },
        {
            id: 23,
            name: '视频客服业务记录转工单模板权限',
            desc: '',
            category: 'video',
            ticket_template_id: 16,
            is_default: false,
            call_type: '',
            agent_group_ids: [6],
            fields: [],
        },
        {
            id: 24,
            name: '测试业务记录模板',
            desc: '从',
            category: 'im',
            ticket_template_id: 1,
            is_default: false,
            call_type: '',
            agent_group_ids: [55, 56],
            fields: [
                {
                    name: 'TextField_1',
                    is_required: true,
                    id: 1,
                    title: '单行文本（默认读写）',
                    field_owner: 'Ticket',
                    content_type: 'text',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 1,
                    field_type: 'TextField',
                },
                {
                    name: 'TextField_21',
                    is_required: true,
                    id: 21,
                    title: '正整数（默认只读）',
                    field_owner: 'Ticket',
                    content_type: 'number',
                    comment: '正整数',
                    customer_permission: 1,
                    agent_permission: 3,
                    is_unique: false,
                    is_relate_duplicate: false,
                    is_search: false,
                    field_id: 21,
                    field_type: 'TextField',
                },
                {
                    name: 'SelectField_39',
                    is_required: false,
                    id: 39,
                    title: 'wwd单选',
                    field_owner: 'Ticket',
                    content_type: 'radio',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '完全二无群二',
                            value: '0',
                        },
                        {
                            title: '好的',
                            value: '1',
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 39,
                    field_type: 'SelectField',
                },
            ],
        },
        {
            id: 37,
            name: '业务记录权限-孙',
            desc: '',
            category: 'im',
            ticket_template_id: 6,
            is_default: false,
            call_type: '',
            agent_group_ids: [6],
            fields: [
                {
                    name: 'SelectField_27',
                    is_required: false,
                    id: 27,
                    title: '自定义下拉列表-sjl有默认值',
                    field_owner: 'Ticket',
                    content_type: 'droplist',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '下拉1',
                            value: '0',
                            default: true,
                        },
                        {
                            title: '下拉2',
                            value: '1',
                        },
                        {
                            title: '下拉3',
                            value: '2',
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 27,
                    field_type: 'SelectField',
                },
                {
                    name: 'SelectField_28',
                    is_required: false,
                    id: 28,
                    title: '自定义级联-sjl',
                    field_owner: 'Ticket',
                    content_type: 'chained_droplist',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '北京市',
                            value: '0',
                            subs: [
                                {
                                    title: '海淀区',
                                    value: '0',
                                    subs: [
                                        {
                                            title: '知春路',
                                            value: '0',
                                        },
                                    ],
                                },
                            ],
                        },
                        {
                            title: '天津市',
                            value: '1',
                            subs: [
                                {
                                    title: '和平区',
                                    value: '0',
                                },
                            ],
                        },
                    ],
                    view_type: 1,
                    full_select: false,
                    field_id: 28,
                    field_type: 'SelectField',
                },
                {
                    name: 'SelectField_44',
                    is_required: false,
                    id: 44,
                    title: '测试级联只读',
                    field_owner: 'Ticket',
                    content_type: 'chained_droplist',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 3,
                    select_options: [
                        {
                            title: '北京市',
                            value: '0',
                            subs: [
                                {
                                    title: '海淀区',
                                    value: '0',
                                    subs: [
                                        {
                                            title: '知春路',
                                            value: '0',
                                        },
                                    ],
                                },
                            ],
                        },
                        {
                            title: '天津市',
                            value: '1',
                            subs: [
                                {
                                    title: '和平区',
                                    value: '0',
                                },
                            ],
                        },
                    ],
                    view_type: 0,
                    full_select: true,
                    field_id: 44,
                    field_type: 'SelectField',
                    forNoteIm: true,
                },
                {
                    name: 'SelectField_45',
                    is_required: false,
                    id: 45,
                    title: '取向',
                    field_owner: 'Ticket',
                    content_type: 'radio',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '男',
                            value: '0',
                            default: true,
                        },
                        {
                            title: '女',
                            value: '1',
                        },
                        {
                            title: '男女',
                            value: '2',
                        },
                        {
                            title: '不喜欢人类',
                            value: '3',
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 45,
                    field_type: 'SelectField',
                    forNoteIm: true,
                },
                {
                    name: 'SelectField_46',
                    is_required: false,
                    id: 46,
                    title: '测试多选读写有默认值',
                    field_owner: 'Ticket',
                    content_type: 'checkbox',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '1',
                            value: '0',
                        },
                        {
                            title: '特殊2',
                            value: '1',
                            default: true,
                        },
                        {
                            title: '特殊3',
                            value: '2',
                            default: true,
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 46,
                    field_type: 'SelectField',
                },
                {
                    name: 'SelectField_47',
                    is_required: false,
                    id: 47,
                    title: '最末级级联',
                    field_owner: 'Ticket',
                    content_type: 'chained_droplist',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '北京市',
                            value: '0',
                            subs: [
                                {
                                    title: '海淀区',
                                    value: '0',
                                    subs: [
                                        {
                                            title: '知春路',
                                            value: '0',
                                        },
                                    ],
                                },
                            ],
                        },
                        {
                            title: '天津市',
                            value: '1',
                            subs: [
                                {
                                    title: '和平区',
                                    value: '0',
                                },
                            ],
                        },
                    ],
                    view_type: 0,
                    full_select: true,
                    field_id: 47,
                    field_type: 'SelectField',
                    forNoteIm: true,
                },
                {
                    name: 'SelectField_52',
                    is_required: true,
                    id: 52,
                    title: '快速的级联样式',
                    field_owner: 'Ticket',
                    content_type: 'chained_droplist',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '北京市',
                            value: '0',
                            subs: [
                                {
                                    title: '海淀区',
                                    value: '0',
                                    subs: [
                                        {
                                            title: '知春路',
                                            value: '0',
                                        },
                                    ],
                                },
                            ],
                        },
                        {
                            title: '天津市',
                            value: '1',
                            subs: [
                                {
                                    title: '和平区',
                                    value: '0',
                                },
                            ],
                        },
                    ],
                    view_type: 1,
                    full_select: false,
                    field_id: 52,
                    field_type: 'SelectField',
                },
                {
                    name: 'SelectField_53',
                    is_required: false,
                    id: 53,
                    title: '单选有默认值',
                    field_owner: 'Ticket',
                    content_type: 'radio',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '1',
                            value: '0',
                        },
                        {
                            title: '默认的',
                            value: '1',
                            default: true,
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 53,
                    field_type: 'SelectField',
                    forNoteIm: true,
                },
                {
                    name: 'SelectField_54',
                    is_required: false,
                    id: 54,
                    title: '复选有默认值',
                    field_owner: 'Ticket',
                    content_type: 'checkbox',
                    comment: null,
                    customer_permission: 2,
                    agent_permission: 2,
                    select_options: [
                        {
                            title: '方法',
                            value: '0',
                        },
                        {
                            title: '默认的',
                            value: '1',
                            default: true,
                        },
                        {
                            title: '默认的2',
                            value: '2',
                            default: true,
                        },
                        {
                            title: '人人',
                            value: '3',
                        },
                    ],
                    view_type: 0,
                    full_select: false,
                    field_id: 54,
                    field_type: 'SelectField',
                    forNoteIm: true,
                },
            ],
        },
    ],

    urls: {
        isHttps: false,
        base: 'http://localhost:3001',
        hc: '/hc',
        apiBase: '/spa1',
        staticPath: 'http://localhost:3001/entry',
        cliStaticPath: 'http://localhost:3001',
        cliCmpsPath: 'http://localhost:3001/static_cmps',
        login: '/users/sign_in',
        uploader_srv: 'https://upload.qiniup.com',
        qnPub: 'https://dn-udeskpub.qbox.me',
        qnIm: 'https://dn-udeskim.qbox.me',
        vcallTokenUrl: '//app.vcall.udeskb3.com/vcall/v1/token',
        vistor_server: 'basevistor.udesk.cn:6001',
        previewUrl: 'https://preview-proxy.udesk.cn/preview',
    },
    platforms: [
        {
            id: 'web',
            text: 'web',
        },
        {
            id: 'api',
            text: 'api',
        },
        {
            id: 'android',
            text: 'android',
        },
        {
            id: 'ios',
            text: 'ios',
        },
        {
            id: '微信',
            text: '微信',
        },
        {
            id: 'weixin_mini',
            text: '小程序',
        },
        {
            id: 'weibo',
            text: '微博',
        },
        {
            id: 'qywx',
            text: '企业微信',
        },
        {
            id: 'baidu',
            text: '百度',
            channel_url: 'http://pro-cs-freq.oss-cn-hangzhou.aliyuncs.com/imc/headers/baidu.png',
        },
        {
            id: 'whats_app',
            text: 'whats_app',
            channel_url: 'http://pro-cs-freq.oss-cn-hangzhou.aliyuncs.com/imc/headers/Whatsapp.png',
        },
        {
            id: 'facebook',
            text: 'facebook',
            channel_url: 'http://pro-cs-freq.oss-cn-hangzhou.aliyuncs.com/imc/headers/facebook.png',
        },
    ],
    customFieldsAuthority: {
        code: 1000,
        ticket_fields_abilities: {
            1: {
                TextField_6: {
                    new: 'editable',
                    edit: 'editable',
                },
                SelectField_1155: {
                    new: 'editable',
                    edit: 'editable',
                },
                SelectField_1091: {
                    new: 'must_fill_in',
                    edit: 'must_fill_in',
                },
                TextField_1205: {
                    new: 'editable',
                    edit: 'editable',
                },
                TextField_1206: {
                    new: 'editable',
                    edit: 'editable',
                },
                TextField_1214: {
                    new: 'editable',
                    edit: 'editable',
                },
                TextField_1215: {
                    new: 'editable',
                    edit: 'editable',
                },
                TextField_1396: {
                    new: 'editable',
                    edit: 'editable',
                },
                TextField_1397: {
                    new: 'editable',
                    edit: 'editable',
                },
                TextField_22: {
                    new: 'editable',
                    edit: 'editable',
                },
                TextField_81: {
                    new: 'editable',
                    edit: 'editable',
                },
                TextField_1195: {
                    new: 'editable',
                    edit: 'editable',
                },
                SelectField_44: {
                    new: 'editable',
                    edit: 'editable',
                },
                SelectField_55: {
                    new: 'editable',
                    edit: 'editable',
                },
                SelectField_93: {
                    new: 'editable',
                    edit: 'editable',
                },
                SelectField_184: {
                    new: 'editable',
                    edit: 'editable',
                },
                SelectField_183: {
                    new: 'editable',
                    edit: 'editable',
                },
                TextField_4685: {
                    new: 'editable',
                    edit: 'editable',
                },
            },
            16066: {
                TextField_6: {
                    new: 'editable',
                    edit: 'editable',
                },
                TextField_4955: {
                    new: 'editable',
                    edit: 'editable',
                },
            },
            50942: {
                SelectField_1980: {
                    new: 'editable',
                    edit: 'editable',
                },
            },
            110981: {
                TextField_22: {
                    new: 'editable',
                    edit: 'editable',
                },
                TextField_81: {
                    new: 'must_fill_in',
                    edit: 'must_fill_in',
                },
                SelectField_1980: {
                    new: 'must_fill_in',
                    edit: 'must_fill_in',
                },
                TextField_1214: {
                    new: 'must_fill_in',
                    edit: 'must_fill_in',
                },
                SelectField_184: {
                    new: 'editable',
                    edit: 'editable',
                },
                TextField_123711: {
                    new: 'editable',
                    edit: 'editable',
                },
            },
            112111: {
                SelectField_184: {
                    new: 'must_fill_in',
                    edit: 'must_fill_in',
                },
                TextField_1214: {
                    new: 'must_fill_in',
                    edit: 'must_fill_in',
                },
                TextField_1396: {
                    new: 'must_fill_in',
                    edit: 'must_fill_in',
                },
            },
            show: {
                TextField_6: 'editable',
                TextField_4685: 'editable',
                TextField_4954: 'editable',
                TextField_4955: 'editable',
                TextField_65621: 'editable',
                TextField_123711: 'editable',
                TextField_130601: 'editable',
                TextField_133181: 'editable',
                TextField_197661: 'editable',
                SelectField_1980: 'editable',
                SelectField_3336: 'editable',
                SelectField_6831: 'editable',
                SelectField_7260: 'editable',
                SelectField_37621: 'editable',
                SelectField_1155: 'editable',
                SelectField_1091: 'must_fill_in',
                TextField_1205: 'editable',
                TextField_1206: 'editable',
                TextField_1214: 'editable',
                TextField_1215: 'editable',
                TextField_1315: 'editable',
                TextField_1396: 'editable',
                TextField_1397: 'editable',
                TextField_22: 'editable',
                TextField_81: 'editable',
                TextField_1195: 'editable',
                SelectField_7: 'editable',
                SelectField_44: 'editable',
                SelectField_55: 'editable',
                SelectField_93: 'editable',
                SelectField_184: 'editable',
                SelectField_183: 'editable',
            },
        },
        customer_fields_abilities: {
            TextField_120: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            TextField_2356: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            TextField_2357: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            TextField_2358: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            TextField_14234: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            SelectField_6894: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            SelectField_6895: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            SelectField_6896: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            TextField_14235: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            TextField_14236: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            TextField_32505: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            TextField_32525: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            TextField_122191: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            TextField_122201: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            TextField_122211: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            SelectField_72411: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            TextField_122221: {
                new: 'readable',
                edit: 'readable',
                show: 'readable',
            },
            TextField_122871: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            SelectField_110241: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            TextField_183981: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            SelectField_112951: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            TextField_188481: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            TextField_188491: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            TextField_188501: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            TextField_188511: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            TextField_192331: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            TextField_192341: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
            SelectField_116271: {
                new: 'editable',
                edit: 'editable',
                show: 'editable',
            },
        },
    },
    imNewPlatforms: [
        {
            channel_name: 'baidu',
            channel_url: 'http://pro-cs-freq.oss-cn-hangzhou.aliyuncs.com/imc/headers/baidu.png',
            imc_server: 'https://baseimc-hz.udesk.cn',
        },
        {
            channel_name: 'whats_app',
            channel_url: 'http://pro-cs-freq.oss-cn-hangzhou.aliyuncs.com/imc/headers/Whatsapp.png',
            imc_server: 'https://baseimc-sg.udesk.cn',
        },
        {
            channel_name: 'facebook',
            channel_url: 'http://pro-cs-freq.oss-cn-hangzhou.aliyuncs.com/imc/headers/facebook.png',
            imc_server: 'https://baseimc-sg.udesk.cn',
        },
    ],
    ImNote: {
        templates: [
            {
                id: 1,
                name: 'IM业务记录',
                desc: '应用于客服对IM对话内容进行整理记录',
                category: 'im',
                ticket_template_id: 1,
                is_default: true,
                call_type: '',
                agent_group_ids: [],
                fields: [
                    {
                        name: 'TextField_6',
                        is_required: false,
                        id: 6,
                        title: '您的所属地区',
                        field_owner: 'Ticket',
                        content_type: 'text',
                        comment: '省及市',
                        customer_permission: 0,
                        agent_permission: 2,
                        is_unique: false,
                        is_relate_duplicate: false,
                        is_search: false,
                        field_id: 6,
                        field_type: 'TextField',
                        forNoteIm: true,
                        forNoteCall: true,
                    },
                    {
                        name: 'SelectField_1155',
                        is_required: false,
                        id: 1155,
                        title: '下拉列表',
                        field_owner: 'Ticket',
                        content_type: 'droplist',
                        comment: null,
                        customer_permission: 2,
                        agent_permission: 2,
                        select_options: [
                            {
                                title: '1111',
                                value: '0',
                            },
                            {
                                title: '2222',
                                value: '1',
                            },
                            {
                                title: '3333',
                                value: '2',
                            },
                        ],
                        view_type: 0,
                        full_select: false,
                        field_id: 1155,
                        field_type: 'SelectField',
                        forNoteIm: true,
                        forNoteCall: true,
                    },
                    {
                        name: 'SelectField_1091',
                        is_required: true,
                        id: 1091,
                        title: 'ces',
                        field_owner: 'Ticket',
                        content_type: 'droplist',
                        comment: '',
                        customer_permission: 2,
                        agent_permission: 1,
                        select_options: [
                            {
                                title: '11',
                                value: '0',
                            },
                            {
                                title: '22',
                                value: '1',
                            },
                        ],
                        view_type: 0,
                        full_select: false,
                        field_id: 1091,
                        field_type: 'SelectField',
                        forNoteIm: true,
                        forNoteCall: true,
                    },
                    {
                        name: 'TextField_1205',
                        is_required: false,
                        id: 1205,
                        title: 'age',
                        field_owner: 'Ticket',
                        content_type: 'numeric',
                        comment: '',
                        customer_permission: 2,
                        agent_permission: 2,
                        is_unique: false,
                        is_relate_duplicate: false,
                        is_search: false,
                        field_id: 1205,
                        field_type: 'TextField',
                        forNoteIm: true,
                        forNoteCall: true,
                    },
                    {
                        name: 'TextField_1206',
                        is_required: false,
                        id: 1206,
                        title: '客户姓名',
                        field_owner: 'Ticket',
                        content_type: 'text',
                        comment: null,
                        customer_permission: 2,
                        agent_permission: 2,
                        is_unique: false,
                        is_relate_duplicate: false,
                        is_search: false,
                        field_id: 1206,
                        field_type: 'TextField',
                        forNoteIm: true,
                        forNoteCall: true,
                    },
                    {
                        name: 'TextField_1214',
                        is_required: false,
                        id: 1214,
                        title: '预约时间',
                        field_owner: 'Ticket',
                        content_type: 'date',
                        comment: null,
                        customer_permission: 2,
                        agent_permission: 2,
                        is_unique: false,
                        is_relate_duplicate: false,
                        is_search: false,
                        field_id: 1214,
                        field_type: 'TextField',
                        forNoteIm: true,
                        forNoteCall: true,
                    },
                    {
                        name: 'TextField_1215',
                        is_required: false,
                        id: 1215,
                        title: '多行文本',
                        field_owner: 'Ticket',
                        content_type: 'area_text',
                        comment: '',
                        customer_permission: 2,
                        agent_permission: 2,
                        is_unique: false,
                        is_relate_duplicate: false,
                        is_search: false,
                        field_id: 1215,
                        field_type: 'TextField',
                        forNoteIm: true,
                        forNoteCall: true,
                    },
                    {
                        name: 'TextField_1315',
                        is_required: false,
                        id: 1315,
                        title: '测试排序按啊啊啊啊',
                        field_owner: 'Ticket',
                        content_type: 'text',
                        comment: null,
                        customer_permission: 2,
                        agent_permission: 2,
                        is_unique: false,
                        is_relate_duplicate: false,
                        is_search: false,
                        field_id: 1315,
                        field_type: 'TextField',
                        forNoteIm: true,
                        forNoteCall: true,
                    },
                    {
                        name: 'TextField_1396',
                        is_required: false,
                        id: 1396,
                        title: '客服经理',
                        field_owner: 'Ticket',
                        content_type: 'text',
                        comment: null,
                        customer_permission: 2,
                        agent_permission: 2,
                        is_unique: false,
                        is_relate_duplicate: false,
                        is_search: false,
                        field_id: 1396,
                        field_type: 'TextField',
                        forNoteIm: true,
                        forNoteCall: true,
                    },
                    {
                        name: 'TextField_1397',
                        is_required: false,
                        id: 1397,
                        title: '时间',
                        field_owner: 'Ticket',
                        content_type: 'time',
                        comment: null,
                        customer_permission: 2,
                        agent_permission: 2,
                        is_unique: false,
                        is_relate_duplicate: false,
                        is_search: false,
                        field_id: 1397,
                        field_type: 'TextField',
                        forNoteIm: true,
                        forNoteCall: true,
                    },
                    {
                        name: 'TextField_22',
                        is_required: false,
                        id: 22,
                        title: '您在哪里购买的该产品？',
                        field_owner: 'Ticket',
                        content_type: 'text',
                        comment: '可填写区域，如省、市等',
                        customer_permission: 3,
                        agent_permission: 2,
                        is_unique: false,
                        is_relate_duplicate: false,
                        is_search: false,
                        field_id: 22,
                        field_type: 'TextField',
                        forNoteIm: true,
                        forNoteCall: true,
                    },
                    {
                        name: 'TextField_81',
                        is_required: false,
                        id: 81,
                        title: '电话',
                        field_owner: 'Ticket',
                        content_type: 'text',
                        comment: '',
                        customer_permission: 0,
                        agent_permission: 2,
                        is_unique: false,
                        is_relate_duplicate: false,
                        is_search: false,
                        field_id: 81,
                        field_type: 'TextField',
                        forNoteIm: true,
                        forNoteCall: true,
                    },
                    {
                        name: 'TextField_1195',
                        is_required: false,
                        id: 1195,
                        title: '年龄',
                        field_owner: 'Ticket',
                        content_type: 'numeric',
                        comment: null,
                        customer_permission: 2,
                        agent_permission: 2,
                        is_unique: false,
                        is_relate_duplicate: false,
                        is_search: false,
                        field_id: 1195,
                        field_type: 'TextField',
                        forNoteIm: true,
                        forNoteCall: true,
                    },
                    {
                        name: 'SelectField_7',
                        is_required: false,
                        id: 7,
                        title: '所属哪个部门',
                        field_owner: 'Ticket',
                        content_type: 'droplist',
                        comment: '技术部',
                        customer_permission: 0,
                        agent_permission: 2,
                        select_options: [
                            {
                                title: '测试部',
                                value: '0',
                            },
                            {
                                title: '销售部',
                                value: '1',
                            },
                            {
                                title: ' 运营部',
                                value: '2',
                            },
                        ],
                        view_type: 0,
                        full_select: false,
                        field_id: 7,
                        field_type: 'SelectField',
                        forNoteIm: true,
                        forNoteCall: true,
                    },
                    {
                        name: 'SelectField_55',
                        is_required: false,
                        id: 55,
                        title: '问题类型',
                        field_owner: 'Ticket',
                        content_type: 'droplist',
                        comment: '问题类型',
                        customer_permission: 3,
                        agent_permission: 2,
                        select_options: [
                            {
                                title: '程序崩溃',
                                value: '0',
                            },
                            {
                                title: '价格',
                                value: '1',
                            },
                        ],
                        view_type: 0,
                        full_select: false,
                        field_id: 55,
                        field_type: 'SelectField',
                        forNoteIm: true,
                        forNoteCall: true,
                    },
                    {
                        name: 'SelectField_93',
                        is_required: false,
                        id: 93,
                        title: '工单字段测试',
                        field_owner: 'Ticket',
                        content_type: 'droplist',
                        comment: '测试',
                        customer_permission: 0,
                        agent_permission: 2,
                        select_options: [
                            {
                                title: '测试1',
                                value: '0',
                            },
                            {
                                title: '测试2',
                                value: '1',
                            },
                            {
                                title: '测试3',
                                value: '2',
                            },
                        ],
                        view_type: 0,
                        full_select: false,
                        field_id: 93,
                        field_type: 'SelectField',
                        forNoteIm: true,
                        forNoteCall: true,
                    },
                    {
                        name: 'SelectField_184',
                        is_required: false,
                        id: 184,
                        title: '预约型号',
                        field_owner: 'Ticket',
                        content_type: 'radio',
                        comment: '单选框',
                        customer_permission: 2,
                        agent_permission: 2,
                        select_options: [
                            {
                                title: 'ICOM',
                                value: '0',
                            },
                            {
                                title: '博瑞',
                                value: '1',
                            },
                            {
                                title: '星越',
                                value: '2',
                            },
                        ],
                        view_type: 0,
                        full_select: false,
                        field_id: 184,
                        field_type: 'SelectField',
                        forNoteIm: true,
                        forNoteCall: true,
                    },
                    {
                        name: 'SelectField_183',
                        is_required: false,
                        id: 183,
                        title: '复选框',
                        field_owner: 'Ticket',
                        content_type: 'checkbox',
                        comment: '复选框',
                        customer_permission: 0,
                        agent_permission: 2,
                        select_options: [
                            {
                                title: '一',
                                value: '0',
                            },
                            {
                                title: '二',
                                value: '1',
                            },
                            {
                                title: '三',
                                value: '2',
                            },
                        ],
                        view_type: 0,
                        full_select: false,
                        field_id: 183,
                        field_type: 'SelectField',
                        forNoteIm: true,
                    },
                    {
                        name: 'TextField_4685',
                        is_required: false,
                        id: 4685,
                        title: '正整数',
                        field_owner: 'Ticket',
                        content_type: 'number',
                        comment: null,
                        customer_permission: 2,
                        agent_permission: 2,
                        is_unique: false,
                        is_relate_duplicate: false,
                        is_search: false,
                        field_id: 4685,
                        field_type: 'TextField',
                        forNoteIm: true,
                        forNoteCall: true,
                    },
                    {
                        name: 'TextField_4955',
                        is_required: false,
                        id: 4955,
                        title: '34',
                        field_owner: 'Ticket',
                        content_type: 'area_text',
                        comment: null,
                        customer_permission: 2,
                        agent_permission: 2,
                        is_unique: false,
                        is_relate_duplicate: false,
                        is_search: false,
                        field_id: 4955,
                        field_type: 'TextField',
                        forNoteIm: true,
                    },
                    {
                        name: 'SelectField_1980',
                        is_required: false,
                        id: 1980,
                        title: '地理组合',
                        field_owner: 'Ticket',
                        content_type: 'chained_droplist',
                        comment: null,
                        customer_permission: 2,
                        agent_permission: 2,
                        select_options: [
                            {
                                title: '北京市',
                                value: '0',
                                subs: [
                                    {
                                        title: '海淀区',
                                        value: '0',
                                        subs: [
                                            {
                                                title: '知春路',
                                                value: '0',
                                            },
                                            {
                                                title: '海淀路',
                                                value: '1',
                                            },
                                        ],
                                    },
                                ],
                            },
                            {
                                title: '天津市',
                                value: '1',
                                subs: [
                                    {
                                        title: '和平区',
                                        value: '0',
                                    },
                                ],
                            },
                        ],
                        view_type: 0,
                        full_select: false,
                        field_id: 1980,
                        field_type: 'SelectField',
                        forNoteIm: true,
                    },
                    {
                        name: 'TextField_197661',
                        is_required: false,
                        id: 197661,
                        title: 'test1_测试业务记录筛选器',
                        field_owner: 'Ticket',
                        content_type: 'text',
                        comment: '业务记录筛选器测试',
                        customer_permission: 2,
                        agent_permission: 2,
                        is_unique: false,
                        is_relate_duplicate: false,
                        is_search: true,
                        field_id: 197661,
                        field_type: 'TextField',
                        forNoteIm: true,
                    },
                ],
            },
            {
                id: 190551,
                name: '维修模板',
                desc: '客户维修记录',
                category: 'im',
                ticket_template_id: 1,
                is_default: false,
                call_type: '',
                agent_group_ids: [190741],
                fields: [
                    {
                        name: 'TextField_4954',
                        is_required: false,
                        id: 4954,
                        title: '产品分类',
                        field_owner: 'Ticket',
                        content_type: 'area_text',
                        comment: null,
                        customer_permission: 2,
                        agent_permission: 2,
                        is_unique: false,
                        is_relate_duplicate: false,
                        is_search: false,
                        field_id: 4954,
                        field_type: 'TextField',
                        forNoteIm: true,
                    },
                    {
                        name: 'SelectField_6831',
                        is_required: false,
                        id: 6831,
                        title: '故障类型',
                        field_owner: 'Ticket',
                        content_type: 'droplist',
                        comment: null,
                        customer_permission: 2,
                        agent_permission: 2,
                        select_options: [
                            {
                                title: '无法启动',
                                value: '0',
                            },
                            {
                                title: '水太热',
                                value: '1',
                            },
                            {
                                title: '频繁断电',
                                value: '2',
                            },
                        ],
                        view_type: 0,
                        full_select: false,
                        field_id: 6831,
                        field_type: 'SelectField',
                        forNoteIm: true,
                    },
                    {
                        name: 'TextField_123711',
                        is_required: false,
                        id: 123711,
                        title: '请描述问题',
                        field_owner: 'Ticket',
                        content_type: 'area_text',
                        comment: '',
                        customer_permission: 2,
                        agent_permission: 2,
                        is_unique: false,
                        is_relate_duplicate: false,
                        is_search: true,
                        field_id: 123711,
                        field_type: 'TextField',
                        forNoteIm: true,
                    },
                    {
                        name: 'TextField_1214',
                        is_required: false,
                        id: 1214,
                        title: '预约时间',
                        field_owner: 'Ticket',
                        content_type: 'date',
                        comment: null,
                        customer_permission: 2,
                        agent_permission: 2,
                        is_unique: false,
                        is_relate_duplicate: false,
                        is_search: false,
                        field_id: 1214,
                        field_type: 'TextField',
                    },
                ],
            },
        ],
    },
    smsapp: {
        signature: '【test】',
        marketing_signature: null,
        flash_sms_signature: null,
        is_open: true,
        brand: 'ali',
    },
    agent: {
        id: 3,
        jid: 'agent_3_1_hailiang@imdev.udeskmonkey.com',
        nick: '昵称Jerry',
    },
    customerId: 1779,
    sessionKey: '',
    imSubSessionId: 2813,
    customer: {
        invite_user_key: 'ebba60d0-264a-49c8-a1ce-fd80c94cca71',
        merging: null,
        last_session_24h: false,
        id: 1779,
        nick_name: '匿名用户',
        owner_id: 3,
        owner_group_id: 1,
        source_channel: 'web_im',
        province: null,
        city: null,
        phone_service_provider: null,
        isp: null,
        last_contact_at: null,
        first_contact_at: null,
        contact_count: null,
        last_contact_at_via_phone: null,
        first_contact_at_via_phone: null,
        contact_count_via_phone: null,
        last_contact_at_via_im: null,
        first_contact_at_via_im: null,
        contact_count_via_im: null,
        latest_device_info: {},
        is_blocked: false,
        level: 'normal',
        created_at: '2020-05-12T20:24:40.000+08:00',
        updated_at: '2020-06-07T23:50:40.000+08:00',
        current_ticket_id: null,
        from: null,
        lang: 'zh-cn',
        sdk_token: null,
        web_token: '73eb129d-50b2-41a9-a066-895e924d4ab6',
        other_web_tokens: [],
        open_api_token: null,
        avatar: null,
        last_im_robot_session_id: null,
        description: 'IM用户:ip()',
        email: '',
        tags: '',
        rich_tags: [],
        custom_fields: {},
        follow_up_updated_at: null,
        owner_name: 'Jerry',
        owner_group_name: '默认组',
        other_emails: [],
        cellphones: [],
        default_organization_id: 12,
        organizations: [12],
        uid: '6f3',
        ticket_count: 26,
        calls_count: 0,
        im_sessions_count: 1,
        im_sub_sessions_count: 1,
        weixin_nick_name: null,
        weixin_avatar: null,
        weixin_subscribe: null,
        weixin_subscribe_time: null,
        weixin_subscribe_from: null,
        weixin_push: null,
        weixin_openid: null,
        unionid: null,
        weixin_push_time: null,
        weibo_nick_name: null,
        weibo_avatar: null,
        weibo_openid: null,
        show_api_icon: false,
        can_redirect: true,
        can_merge: false,
        customer_jid: 'customer_1779_1_hailiang@imdev.udeskmonkey.com',
        weixins: [],
        weibos: [],
        weixin_minis: [],
        qywxes: [],
        contact_im_channels: [],
        description_ip: '',
    },
    organizations: [
        {
            id: 12,
            name: 'reocar',
        },
    ],
    agentConfig: {
        agent_tab_config: {
            parallel: '',
            order: ['-1', '-2', '-3', '-4', '1', '2', 'im-log-records'],
            ticketCover: 'all',
            visitCover: 'all',
            recordCover: 'all',
            sortDesc: false,
        },
        style: {
            fontSize: '13px',
            lineHeight: '1.4',
            fontWeight: 'normal',
            fontStyle: 'normal',
            textDecoration: 'none',
            color: '#974806',
        },
        im_welcomes: '',
        customImInputHeight: '170',
        chatSort: 'customer_new_msg',
        isFoldInfo: 'false',
        visiteInfoFold: 'true',
        visitor_sort_columns:
            'visitor_no,keyword,looking,operation,device,ask_num,invite_num,residence_time,session_num,vist_num,desc,name,source,vist_page_num,source_url',
        visitor_sort_type: 'create_time',
        isTopImSubSessionIds: '',
        visitInfoHide: 'false',
        colleague_notice: {
            survey: true,
            sessions_timeout: true,
            response_timeout: true,
            customer_sensitive_word: true,
            agent_sensitive_word: true,
            customer_sentiment_word: true,
            agent_sentiment_word: true,
            desktop_notice: true,
            sentiment_words: true,
            sensitive_words: true,
        },
        sentiment_words: true,
        sensitive_words: true,
        response_timeout: false,
        sessions_timeout: false,
        survey: true,
        desktop_notice: true,
        monitor_enables: {
            customer_sensitive_word: true,
            agent_sensitive_word: true,
            customer_sentiment_word: true,
            agent_sentiment_word: true,
            response_timeout: true,
            sessions_timeout: true,
            survey: true,
        },
        company: {
            close_remind: true,
        },
    },
    agentTabConfig: {
        parallel: '',
        order: ['-1', '-2', '-3', '-4', '1', '2'],
        ticketCover: 'all',
        visitCover: 'all',
        recordCover: 'all',
        sortDesc: false,
    },
    newVisit: {},
    newTicketReact: {
        show: true,
    },
    newRecord: {
        show: false,
    },
    event: {
        updateChat: function (config) {
            console.log(`Event invoked! name: '${config.name}'. args:`, ...arguments);
        },
        updateChatCustomer: function (config) {
            console.log(`Event invoked! name:updateChatCustomer '${config.name}'. args:`, ...arguments);
        },

        updateTab: function (agentTabConfig = {}) {
            console.log(`Event invoked! name:updateTab '${agentTabConfig.name}'. args:`, ...arguments);
        },
        closeTicket: function (item) {
            console.log(`Event invoked! name:closeTicket '${item.name}'. args:`, ...arguments);
        },
        showDetail: function (item) {
            console.log(`Event invoked! name: showDetail'${item.name}'. args:`, ...arguments);
        },
        catchContactAgentId: function (item) {
            console.log(`Event invoked! name:catchContactAgentId '${item.name}'. args:`, ...arguments);
        },
        transitionToRoute: function (item, id) {
            console.log(`Event invoked! name: transitionToRoute'${item.name}'. args:`, ...arguments);
        },
        onMakeCall: function (item, id) {
            console.log(`Event invoked! name:onMakeCall '${item.name}'. args:`, ...arguments);
        },
        openSms: function (item, id) {
            console.log(`Event invoked! name:openSms '${item.name}'. args:`, ...arguments);
        },
        createEmailTicket: function (item, id) {
            console.log(`Event invoked! name:createEmailTicket '${item.name}'. args:`, ...arguments);
        },

        onKnowledgeUseClick: function (type, data) {
            console.log(`Event invoked! name:onKnowledgeUseClick '${type}'. args:`, ...arguments);
        },

        onKnowledgeSendClick: function (type, data) {
            console.log(`Event invoked! name:onKnowledgeSendClick '${type}'. args:`, ...arguments);
        },

        sendMsg: function (type, data) {
            console.log(`Event invoked! name:sendMsg '${type}'. args:`, ...arguments);
        },
    },
    chat: {
        nick_name: '北京朝阳BGP多线(1598853757)',
        description: 'IM用户:ip(119.57.115.195)',
        email: '119.57.115.195_1598853757_1@temp.com',
        id: 974,
        level: 'normal',
        organization: null,
        jid: 'customer_974_1_udeskt2@t2.ejabberd.tryudesk.com',
        status: 'offline',
        platform: 'web',
        im_sub_session_id: 2912,
        session_key: '',
        last_customer_resp_at: 1607672254851,
        message: {},
        last_log_at: null,
        last_session_24h: true,
        updated_at: 1607672254581,
        created_at: 1601191408000,
        last_log_id: null,
        rich_tags: [
            { id: 2, name: '支付宝延迟到账', color: '1' },
            { id: 3, name: '问问', color: '1' },
            { id: 4, name: '天行健', color: '1' },
        ],
        note_complete: false,
        agent_note_template_id: 4,
        belong: 'mine',
        history: true,
        date: 1601191408000,
        customer_id: 974,
        agent: {
            id: 95,
            csrf_token: 'FB95Sf6qtlpK/nN/las9p+xqUgjnu4fF6w5fdJmdmuE=',
            user_id: 11,
            avatar: null,
            room_jid: '',
            nick: 'qihaihua',
            type: 'user',
            chatting: false,
            im_server: 'http://t2.ejabberd.tryudesk.com/http-bind/',
            im_ws_server: 'wss://t2.ejabberd.tryudesk.com/websocket',
            im_ws: 'ws://t2.ejabberd.tryudesk.com/websocket',
            im_wss: 'wss://t2.ejabberd.tryudesk.com/websocket',
            has_pre_form: false,
            show_pre_form: null,
            show_pre_session: null,
            im_group: {},
            im_ws_available: true,
            access_token: 'dfe379d7-a057-418f-9605-7df546e6a385',
            last_im_session_id: 0,
            offline: {},
            text_sensitivity_api: null,
            queueing: null,
            username: 'agent_11_1_udeskt2@t2.ejabberd.tryudesk.com',
            password: 'e5e6e1f201f5df03b39b454d37d2987d',
        },
        avatar: null,
        lang: 'zh-cn',
        canSend: true,
        invitation: '',
        isTop: false,
        lock: false,
        wait_time: 0,
        messages: [],
        noteHasReqField: true,
        input_text: '',
        currentLogsCount: 0,
        customer_driving_close: false,
        online: false,
        belongHistory: [],
        selected: true,
        unread: 0,
        inputConfig: { showFontFlag: false, showTranslation: false },
        accessInfo: {
            version: '1',
            referrer: '',
            accessUrl: 'null',
            accessUrl_desc: '',
            cur_url: 'https://demo.t2.tryudesk.com/im_client/?web_plugin_id=22&agent_id=68',
            cur_url_desc: '',
            channel: null,
            searchType: '直接访问',
            src_url: 'null',
            keyword: null,
            sysInfo: 'Win10',
            bowserInfo: 'Chrome78',
            resolution: '1920*1080',
            web_plugin_name: '赵娜娜',
            web_plugin_id: 22,
            h5push: false,
            user_agent:
                'Mozilla/5.0 (Windows NT 10.0; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/78.0.3904.108 Safari/537.36',
            platform: 'web',
            is_web: true,
            ip: '119.57.115.195',
            src: '直接访问',
            is_sdk: false,
            jid_resource: '',
            day_sub_session_count: 6,
            queue_name: 'qihaihua',
            session_key: '',
            menu_names: '',
            cur_url_show: 'https://demo.t2.tryudesk.com/im_client/?web_plugin_id=22&agent_id=68',
            accessUrl_show: 'null',
            src_url_show: 'null',
        },
        hasAccessInfo: true,
        is_web: true,
        customer: {
            invite_user_key: '',
            merging: null,
            last_session_24h: true,
            id: 974,
            nick_name: '北京朝阳BGP多线(1598853757)33z',
            owner_id: 11,
            owner_group_id: 8,
            source_channel: 'web_im',
            province: '北京',
            city: '朝阳',
            phone_service_provider: null,
            isp: '电信&联通',
            last_contact_at: null,
            first_contact_at: null,
            contact_count: 0,
            last_contact_at_via_phone: null,
            first_contact_at_via_phone: null,
            contact_count_via_phone: null,
            last_contact_at_via_im: null,
            first_contact_at_via_im: null,
            contact_count_via_im: 0,
            latest_device_info: {
                os: 'Win10',
                browser: 'Chrome78',
                resolution: '1920*1080',
            },
            is_blocked: false,
            level: 'normal',
            created_at: '2020-08-31T14:02:37.000+08:00',
            updated_at: '2020-08-31T14:03:53.000+08:00',
            current_ticket_id: null,
            from: '北京朝阳BGP多线',
            lang: 'zh-cn',
            sdk_token: null,
            web_token: '99951fbf-66f4-4dd8-84ec-2da548f097ae',
            other_web_tokens: [],
            open_api_token: null,
            avatar: null,
            last_im_session_id: 2732,
            last_im_robot_session_id: null,
            description: 'IM用户:ip(119.57.115.195)',
            email: '',
            tags: '支付宝延迟到账,问问,天行健',
            rich_tags: [
                { id: 2, name: '支付宝延迟到账', color: '1' },
                { id: 3, name: '问问', color: '1' },
                { id: 4, name: '天行健', color: '1' },
            ],
            custom_fields: {
                SelectField_1: ['0'],
                SelectField_3: ['0'],
                SelectField_13: ['0'],
                SelectField_16: ['0'],
                SelectField_17: ['0', '1', '2'],
                SelectField_25: ['0'],
            },
            follow_up_updated_at: null,
            owner_name: 'qihaihua',
            owner_group_name: '齐海华',
            other_emails: [],
            cellphones: [],
            default_organization_id: null,
            organizations: [],
            uid: '3ce',
            ticket_count: 0,
            calls_count: 0,
            im_sessions_count: 7,
            im_sub_sessions_count: 7,
            video_records_count: 0,
            weixin_nick_name: null,
            weixin_avatar: null,
            weixin_subscribe: null,
            weixin_subscribe_time: null,
            weixin_subscribe_from: null,
            weixin_push: null,
            weixin_openid: null,
            unionid: null,
            weixin_push_time: null,
            weibo_nick_name: null,
            weibo_avatar: null,
            weibo_openid: null,
            show_api_icon: false,
            can_redirect: true,
            can_merge: false,
            customer_jid: 'customer_974_1_udeskt2@t2.ejabberd.tryudesk.com',
            weixins: [],
            weibos: [],
            weixin_minis: [],
            qywxes: [],
            contact_im_channels: [],
            description_ip: '119.57.115.195',
        },
        organizations: [],
        title: '北京朝阳BGP多线(1598853757)11',
        can_redirect: true,
        product: {
            id: 329,
            title: null,
            url: null,
            image: null,
            product_params: null,
            customer_id: 974,
            created_at: '2020-08-31T14:03:53.000+08:00',
            updated_at: '2020-08-31T14:03:53.000+08:00',
            params: [],
        },
        isLoadMsg: true,
    },

    noteFields: [
        {
            id: 6,
            title: '您的所属地区',
            name: 'TextField_6',
            field_owner: 'Ticket',
            content_type: 'text',
            comment: '省及市',
            customer_permission: 0,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    id: 2,
                    name: '默认业务记录',
                    desc: '当不设置任何业务记录时，显示默认业务记录',
                    category: 'call',
                    ticket_template_id: 16066,
                    is_default: true,
                    call_type: null,
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '',
                    id: 1,
                    name: '默认',
                    template_type: 'TicketTemplate',
                    default: true,
                },
                {
                    desc: '',
                    id: 16066,
                    name: '工单',
                    template_type: 'TicketTemplate',
                    default: false,
                },
            ],
            field_id: 6,
            field_type: 'TextField',
        },
        {
            id: 4685,
            title: '正整数',
            name: 'TextField_4685',
            field_owner: 'Ticket',
            content_type: 'number',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    id: 2,
                    name: '默认业务记录',
                    desc: '当不设置任何业务记录时，显示默认业务记录',
                    category: 'call',
                    ticket_template_id: 16066,
                    is_default: true,
                    call_type: null,
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '',
                    id: 1,
                    name: '默认',
                    template_type: 'TicketTemplate',
                    default: true,
                },
            ],
            field_id: 4685,
            field_type: 'TextField',
        },
        {
            id: 4954,
            title: '产品分类',
            name: 'TextField_4954',
            field_owner: 'Ticket',
            content_type: 'area_text',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
            templates: [
                {
                    id: 190551,
                    name: '维修模板',
                    desc: '客户维修记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: false,
                    call_type: '',
                    agent_group_ids: [190741],
                    template_type: 'AgentNoteTemplate',
                },
            ],
            field_id: 4954,
            field_type: 'TextField',
        },
        {
            id: 4955,
            title: '34',
            name: 'TextField_4955',
            field_owner: 'Ticket',
            content_type: 'area_text',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '',
                    id: 16066,
                    name: '工单',
                    template_type: 'TicketTemplate',
                    default: false,
                },
            ],
            field_id: 4955,
            field_type: 'TextField',
        },
        {
            id: 123711,
            title: '请描述问题',
            name: 'TextField_123711',
            field_owner: 'Ticket',
            content_type: 'area_text',
            comment: '',
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: true,
            templates: [
                {
                    id: 190551,
                    name: '维修模板',
                    desc: '客户维修记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: false,
                    call_type: '',
                    agent_group_ids: [190741],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '小龙测试',
                    id: 110981,
                    name: '小龙测试-',
                    template_type: 'TicketTemplate',
                    default: false,
                },
            ],
            field_id: 123711,
            field_type: 'TextField',
        },
        {
            id: 197661,
            title: 'test1_测试业务记录筛选器',
            name: 'TextField_197661',
            field_owner: 'Ticket',
            content_type: 'text',
            comment: '业务记录筛选器测试',
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: true,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
            ],
            field_id: 197661,
            field_type: 'TextField',
        },
        {
            id: 1980,
            title: '地理组合',
            name: 'SelectField_1980',
            field_owner: 'Ticket',
            content_type: 'chained_droplist',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            select_options: [
                {
                    title: '北京市',
                    value: '0',
                    subs: [
                        {
                            title: '海淀区',
                            value: '0',
                            subs: [
                                {
                                    title: '知春路',
                                    value: '0',
                                },
                                {
                                    title: '海淀路',
                                    value: '1',
                                },
                            ],
                        },
                    ],
                },
                {
                    title: '天津市',
                    value: '1',
                    subs: [
                        {
                            title: '和平区',
                            value: '0',
                        },
                    ],
                },
            ],
            view_type: 0,
            full_select: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '没什么用',
                    id: 50942,
                    name: '用来看顺序的模块',
                    template_type: 'TicketTemplate',
                    default: false,
                },
                {
                    desc: '小龙测试',
                    id: 110981,
                    name: '小龙测试-',
                    template_type: 'TicketTemplate',
                    default: false,
                },
            ],
            field_id: 1980,
            field_type: 'SelectField',
        },
        {
            id: 6831,
            title: '故障类型',
            name: 'SelectField_6831',
            field_owner: 'Ticket',
            content_type: 'droplist',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            select_options: [
                {
                    title: '无法启动',
                    value: '0',
                },
                {
                    title: '水太热',
                    value: '1',
                },
                {
                    title: '频繁断电',
                    value: '2',
                },
            ],
            view_type: 0,
            full_select: false,
            templates: [
                {
                    id: 190551,
                    name: '维修模板',
                    desc: '客户维修记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: false,
                    call_type: '',
                    agent_group_ids: [190741],
                    template_type: 'AgentNoteTemplate',
                },
            ],
            field_id: 6831,
            field_type: 'SelectField',
        },
        {
            id: 1155,
            title: '下拉列表',
            name: 'SelectField_1155',
            field_owner: 'Ticket',
            content_type: 'droplist',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            select_options: [
                {
                    title: '1111',
                    value: '0',
                },
                {
                    title: '2222',
                    value: '1',
                },
                {
                    title: '3333',
                    value: '2',
                },
            ],
            view_type: 0,
            full_select: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    id: 2,
                    name: '默认业务记录',
                    desc: '当不设置任何业务记录时，显示默认业务记录',
                    category: 'call',
                    ticket_template_id: 16066,
                    is_default: true,
                    call_type: null,
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '',
                    id: 1,
                    name: '默认',
                    template_type: 'TicketTemplate',
                    default: true,
                },
            ],
            field_id: 1155,
            field_type: 'SelectField',
        },
        {
            id: 1091,
            title: 'ces',
            name: 'SelectField_1091',
            field_owner: 'Ticket',
            content_type: 'droplist',
            comment: '',
            customer_permission: 2,
            agent_permission: 1,
            select_options: [
                {
                    title: '11',
                    value: '0',
                },
                {
                    title: '22',
                    value: '1',
                },
            ],
            view_type: 0,
            full_select: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    id: 2,
                    name: '默认业务记录',
                    desc: '当不设置任何业务记录时，显示默认业务记录',
                    category: 'call',
                    ticket_template_id: 16066,
                    is_default: true,
                    call_type: null,
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '',
                    id: 1,
                    name: '默认',
                    template_type: 'TicketTemplate',
                    default: true,
                },
            ],
            field_id: 1091,
            field_type: 'SelectField',
        },
        {
            id: 1205,
            title: 'age',
            name: 'TextField_1205',
            field_owner: 'Ticket',
            content_type: 'numeric',
            comment: '',
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    id: 2,
                    name: '默认业务记录',
                    desc: '当不设置任何业务记录时，显示默认业务记录',
                    category: 'call',
                    ticket_template_id: 16066,
                    is_default: true,
                    call_type: null,
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '',
                    id: 1,
                    name: '默认',
                    template_type: 'TicketTemplate',
                    default: true,
                },
            ],
            field_id: 1205,
            field_type: 'TextField',
        },
        {
            id: 1206,
            title: '客户姓名',
            name: 'TextField_1206',
            field_owner: 'Ticket',
            content_type: 'text',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    id: 2,
                    name: '默认业务记录',
                    desc: '当不设置任何业务记录时，显示默认业务记录',
                    category: 'call',
                    ticket_template_id: 16066,
                    is_default: true,
                    call_type: null,
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '',
                    id: 1,
                    name: '默认',
                    template_type: 'TicketTemplate',
                    default: true,
                },
            ],
            field_id: 1206,
            field_type: 'TextField',
        },
        {
            id: 1214,
            title: '预约时间',
            name: 'TextField_1214',
            field_owner: 'Ticket',
            content_type: 'date',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    id: 2,
                    name: '默认业务记录',
                    desc: '当不设置任何业务记录时，显示默认业务记录',
                    category: 'call',
                    ticket_template_id: 16066,
                    is_default: true,
                    call_type: null,
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    id: 190551,
                    name: '维修模板',
                    desc: '客户维修记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: false,
                    call_type: '',
                    agent_group_ids: [190741],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '',
                    id: 1,
                    name: '默认',
                    template_type: 'TicketTemplate',
                    default: true,
                },
                {
                    desc: '小龙测试',
                    id: 110981,
                    name: '小龙测试-',
                    template_type: 'TicketTemplate',
                    default: false,
                },
                {
                    desc: '',
                    id: 112111,
                    name: '预约试驾工单',
                    template_type: 'TicketTemplate',
                    default: false,
                },
            ],
            field_id: 1214,
            field_type: 'TextField',
        },
        {
            id: 1215,
            title: '多行文本',
            name: 'TextField_1215',
            field_owner: 'Ticket',
            content_type: 'area_text',
            comment: '',
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    id: 2,
                    name: '默认业务记录',
                    desc: '当不设置任何业务记录时，显示默认业务记录',
                    category: 'call',
                    ticket_template_id: 16066,
                    is_default: true,
                    call_type: null,
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '',
                    id: 1,
                    name: '默认',
                    template_type: 'TicketTemplate',
                    default: true,
                },
            ],
            field_id: 1215,
            field_type: 'TextField',
        },
        {
            id: 1315,
            title: '测试排序按啊啊啊啊',
            name: 'TextField_1315',
            field_owner: 'Ticket',
            content_type: 'text',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    id: 2,
                    name: '默认业务记录',
                    desc: '当不设置任何业务记录时，显示默认业务记录',
                    category: 'call',
                    ticket_template_id: 16066,
                    is_default: true,
                    call_type: null,
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
            ],
            field_id: 1315,
            field_type: 'TextField',
        },
        {
            id: 1396,
            title: '客服经理',
            name: 'TextField_1396',
            field_owner: 'Ticket',
            content_type: 'text',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    id: 2,
                    name: '默认业务记录',
                    desc: '当不设置任何业务记录时，显示默认业务记录',
                    category: 'call',
                    ticket_template_id: 16066,
                    is_default: true,
                    call_type: null,
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '',
                    id: 1,
                    name: '默认',
                    template_type: 'TicketTemplate',
                    default: true,
                },
                {
                    desc: '',
                    id: 112111,
                    name: '预约试驾工单',
                    template_type: 'TicketTemplate',
                    default: false,
                },
            ],
            field_id: 1396,
            field_type: 'TextField',
        },
        {
            id: 1397,
            title: '时间',
            name: 'TextField_1397',
            field_owner: 'Ticket',
            content_type: 'time',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    id: 2,
                    name: '默认业务记录',
                    desc: '当不设置任何业务记录时，显示默认业务记录',
                    category: 'call',
                    ticket_template_id: 16066,
                    is_default: true,
                    call_type: null,
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '',
                    id: 1,
                    name: '默认',
                    template_type: 'TicketTemplate',
                    default: true,
                },
            ],
            field_id: 1397,
            field_type: 'TextField',
        },
        {
            id: 22,
            title: '您在哪里购买的该产品？',
            name: 'TextField_22',
            field_owner: 'Ticket',
            content_type: 'text',
            comment: '可填写区域，如省、市等',
            customer_permission: 3,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    id: 2,
                    name: '默认业务记录',
                    desc: '当不设置任何业务记录时，显示默认业务记录',
                    category: 'call',
                    ticket_template_id: 16066,
                    is_default: true,
                    call_type: null,
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '',
                    id: 1,
                    name: '默认',
                    template_type: 'TicketTemplate',
                    default: true,
                },
                {
                    desc: '小龙测试',
                    id: 110981,
                    name: '小龙测试-',
                    template_type: 'TicketTemplate',
                    default: false,
                },
            ],
            field_id: 22,
            field_type: 'TextField',
        },
        {
            id: 81,
            title: '电话',
            name: 'TextField_81',
            field_owner: 'Ticket',
            content_type: 'text',
            comment: '',
            customer_permission: 0,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    id: 2,
                    name: '默认业务记录',
                    desc: '当不设置任何业务记录时，显示默认业务记录',
                    category: 'call',
                    ticket_template_id: 16066,
                    is_default: true,
                    call_type: null,
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '',
                    id: 1,
                    name: '默认',
                    template_type: 'TicketTemplate',
                    default: true,
                },
                {
                    desc: '小龙测试',
                    id: 110981,
                    name: '小龙测试-',
                    template_type: 'TicketTemplate',
                    default: false,
                },
            ],
            field_id: 81,
            field_type: 'TextField',
        },
        {
            id: 1195,
            title: '年龄',
            name: 'TextField_1195',
            field_owner: 'Ticket',
            content_type: 'numeric',
            comment: null,
            customer_permission: 2,
            agent_permission: 2,
            is_unique: false,
            is_relate_duplicate: false,
            is_search: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    id: 2,
                    name: '默认业务记录',
                    desc: '当不设置任何业务记录时，显示默认业务记录',
                    category: 'call',
                    ticket_template_id: 16066,
                    is_default: true,
                    call_type: null,
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '',
                    id: 1,
                    name: '默认',
                    template_type: 'TicketTemplate',
                    default: true,
                },
            ],
            field_id: 1195,
            field_type: 'TextField',
        },
        {
            id: 7,
            title: '所属哪个部门',
            name: 'SelectField_7',
            field_owner: 'Ticket',
            content_type: 'droplist',
            comment: '技术部',
            customer_permission: 0,
            agent_permission: 2,
            select_options: [
                {
                    title: '测试部',
                    value: '0',
                },
                {
                    title: '销售部',
                    value: '1',
                },
                {
                    title: ' 运营部',
                    value: '2',
                },
            ],
            view_type: 0,
            full_select: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    id: 2,
                    name: '默认业务记录',
                    desc: '当不设置任何业务记录时，显示默认业务记录',
                    category: 'call',
                    ticket_template_id: 16066,
                    is_default: true,
                    call_type: null,
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
            ],
            field_id: 7,
            field_type: 'SelectField',
        },
        {
            id: 44,
            title: '客户满意度',
            name: 'SelectField_44',
            field_owner: 'Ticket',
            content_type: 'droplist',
            comment: '',
            customer_permission: 2,
            agent_permission: 2,
            select_options: [
                {
                    title: '满意',
                    value: '0',
                },
                {
                    title: '不满意',
                    value: '1',
                },
            ],
            view_type: 0,
            full_select: false,
            templates: [
                {
                    id: 2,
                    name: '默认业务记录',
                    desc: '当不设置任何业务记录时，显示默认业务记录',
                    category: 'call',
                    ticket_template_id: 16066,
                    is_default: true,
                    call_type: null,
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '',
                    id: 1,
                    name: '默认',
                    template_type: 'TicketTemplate',
                    default: true,
                },
            ],
            field_id: 44,
            field_type: 'SelectField',
        },
        {
            id: 55,
            title: '问题类型',
            name: 'SelectField_55',
            field_owner: 'Ticket',
            content_type: 'droplist',
            comment: '问题类型',
            customer_permission: 3,
            agent_permission: 2,
            select_options: [
                {
                    title: '程序崩溃',
                    value: '0',
                },
                {
                    title: '价格',
                    value: '1',
                },
            ],
            view_type: 0,
            full_select: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    id: 2,
                    name: '默认业务记录',
                    desc: '当不设置任何业务记录时，显示默认业务记录',
                    category: 'call',
                    ticket_template_id: 16066,
                    is_default: true,
                    call_type: null,
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '',
                    id: 1,
                    name: '默认',
                    template_type: 'TicketTemplate',
                    default: true,
                },
            ],
            field_id: 55,
            field_type: 'SelectField',
        },
        {
            id: 93,
            title: '工单字段测试',
            name: 'SelectField_93',
            field_owner: 'Ticket',
            content_type: 'droplist',
            comment: '测试',
            customer_permission: 0,
            agent_permission: 2,
            select_options: [
                {
                    title: '测试1',
                    value: '0',
                },
                {
                    title: '测试2',
                    value: '1',
                },
                {
                    title: '测试3',
                    value: '2',
                },
            ],
            view_type: 0,
            full_select: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    id: 2,
                    name: '默认业务记录',
                    desc: '当不设置任何业务记录时，显示默认业务记录',
                    category: 'call',
                    ticket_template_id: 16066,
                    is_default: true,
                    call_type: null,
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '',
                    id: 1,
                    name: '默认',
                    template_type: 'TicketTemplate',
                    default: true,
                },
            ],
            field_id: 93,
            field_type: 'SelectField',
        },
        {
            id: 184,
            title: '预约型号',
            name: 'SelectField_184',
            field_owner: 'Ticket',
            content_type: 'radio',
            comment: '单选框',
            customer_permission: 2,
            agent_permission: 2,
            select_options: [
                {
                    title: 'ICOM',
                    value: '0',
                },
                {
                    title: '博瑞',
                    value: '1',
                },
                {
                    title: '星越',
                    value: '2',
                },
            ],
            view_type: 0,
            full_select: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    id: 2,
                    name: '默认业务记录',
                    desc: '当不设置任何业务记录时，显示默认业务记录',
                    category: 'call',
                    ticket_template_id: 16066,
                    is_default: true,
                    call_type: null,
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '',
                    id: 1,
                    name: '默认',
                    template_type: 'TicketTemplate',
                    default: true,
                },
                {
                    desc: '小龙测试',
                    id: 110981,
                    name: '小龙测试-',
                    template_type: 'TicketTemplate',
                    default: false,
                },
                {
                    desc: '',
                    id: 112111,
                    name: '预约试驾工单',
                    template_type: 'TicketTemplate',
                    default: false,
                },
            ],
            field_id: 184,
            field_type: 'SelectField',
        },
        {
            id: 183,
            title: '复选框',
            name: 'SelectField_183',
            field_owner: 'Ticket',
            content_type: 'checkbox',
            comment: '复选框',
            customer_permission: 0,
            agent_permission: 2,
            select_options: [
                {
                    title: '一',
                    value: '0',
                },
                {
                    title: '二',
                    value: '1',
                },
                {
                    title: '三',
                    value: '2',
                },
            ],
            view_type: 0,
            full_select: false,
            templates: [
                {
                    id: 1,
                    name: 'IM业务记录',
                    desc: '应用于客服对IM对话内容进行整理记录',
                    category: 'im',
                    ticket_template_id: 1,
                    is_default: true,
                    call_type: '',
                    agent_group_ids: [],
                    template_type: 'AgentNoteTemplate',
                },
                {
                    desc: '',
                    id: 1,
                    name: '默认',
                    template_type: 'TicketTemplate',
                    default: true,
                },
            ],
            field_id: 183,
            field_type: 'SelectField',
        },
    ],

    translate: [
        {
            name: '英文',
            lang_code: 'en-us',
        },
        {
            name: '简体中文',
            lang_code: 'zh-cn',
        },
        {
            name: '繁体中文',
            lang_code: 'zh-HK',
        },
        {
            name: '俄语',
            lang_code: 'ru',
        },
        {
            name: '葡萄牙语',
            lang_code: 'pt',
        },
        {
            name: '西班牙语',
            lang_code: 'es',
        },
        {
            name: '法语',
            lang_code: 'fr',
        },
        {
            name: '土耳其语',
            lang_code: 'tr',
        },
        {
            name: '阿拉伯语',
            lang_code: 'ar',
        },
        {
            name: '意大利语',
            lang_code: 'it',
        },
        {
            name: '泰语',
            lang_code: 'th',
        },
        {
            name: '越南语',
            lang_code: 'vi',
        },
        {
            name: '印尼语',
            lang_code: 'id',
        },
        {
            name: '日语',
            lang_code: 'ja',
        },
        {
            name: '韩语',
            lang_code: 'ko',
        },
    ],
    modals: {
        refreshKnowledge: 0,
    },
    getTencentMap: (params) => {
        let imgUrl = 'http://apis.map.qq.com/ws/staticmap/v2/',
            mapUrl = 'http://apis.map.qq.com/uri/v1/marker',
            key = 'NFFBZ-QGA3P-66OD5-LDYQH-GHTEV-CWBUV';
        try {
            let locationData = params.split(';') || ['0', '0', '', ''];
            let local = locationData[0] + ',' + locationData[1];
            let zoom = locationData[2] || 16;
            let localName = locationData[3] || '位置';
            return {
                img_src:
                    imgUrl + '?key=' + key + '&size=200*150&center=' + local + '&zoom=' + zoom + '&markers=' + local,
                map_src: mapUrl + '?marker=coord:' + local + ';title:位置信息;addr:' + localName,
            };
        } catch (e) {
            return {};
        }
    },
};
